#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 3618
#define LARGE_STATE_COUNT 1004
#define SYMBOL_COUNT 341
#define ALIAS_COUNT 4
#define TOKEN_COUNT 153
#define EXTERNAL_TOKEN_COUNT 10
#define FIELD_COUNT 31
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 279

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  anon_sym_macro_rules_BANG = 3,
  anon_sym_LPAREN = 4,
  anon_sym_RPAREN = 5,
  anon_sym_LBRACK = 6,
  anon_sym_RBRACK = 7,
  anon_sym_LBRACE = 8,
  anon_sym_RBRACE = 9,
  anon_sym_EQ_GT = 10,
  anon_sym_COLON = 11,
  anon_sym_DOLLAR = 12,
  aux_sym_token_repetition_pattern_token1 = 13,
  anon_sym_PLUS = 14,
  anon_sym_STAR = 15,
  anon_sym_QMARK = 16,
  anon_sym_block = 17,
  anon_sym_expr = 18,
  anon_sym_ident = 19,
  anon_sym_item = 20,
  anon_sym_lifetime = 21,
  anon_sym_literal = 22,
  anon_sym_meta = 23,
  anon_sym_pat = 24,
  anon_sym_path = 25,
  anon_sym_stmt = 26,
  anon_sym_tt = 27,
  anon_sym_ty = 28,
  anon_sym_vis = 29,
  anon_sym_u8 = 30,
  anon_sym_i8 = 31,
  anon_sym_u16 = 32,
  anon_sym_i16 = 33,
  anon_sym_u32 = 34,
  anon_sym_i32 = 35,
  anon_sym_u64 = 36,
  anon_sym_i64 = 37,
  anon_sym_u128 = 38,
  anon_sym_i128 = 39,
  anon_sym_isize = 40,
  anon_sym_usize = 41,
  anon_sym_f32 = 42,
  anon_sym_f64 = 43,
  anon_sym_bool = 44,
  anon_sym_str = 45,
  anon_sym_char = 46,
  anon_sym_DASH = 47,
  anon_sym_SLASH = 48,
  anon_sym_PERCENT = 49,
  anon_sym_CARET = 50,
  anon_sym_BANG = 51,
  anon_sym_AMP = 52,
  anon_sym_PIPE = 53,
  anon_sym_AMP_AMP = 54,
  anon_sym_PIPE_PIPE = 55,
  anon_sym_LT_LT = 56,
  anon_sym_GT_GT = 57,
  anon_sym_PLUS_EQ = 58,
  anon_sym_DASH_EQ = 59,
  anon_sym_STAR_EQ = 60,
  anon_sym_SLASH_EQ = 61,
  anon_sym_PERCENT_EQ = 62,
  anon_sym_CARET_EQ = 63,
  anon_sym_AMP_EQ = 64,
  anon_sym_PIPE_EQ = 65,
  anon_sym_LT_LT_EQ = 66,
  anon_sym_GT_GT_EQ = 67,
  anon_sym_EQ = 68,
  anon_sym_EQ_EQ = 69,
  anon_sym_BANG_EQ = 70,
  anon_sym_GT = 71,
  anon_sym_LT = 72,
  anon_sym_GT_EQ = 73,
  anon_sym_LT_EQ = 74,
  anon_sym_AT = 75,
  anon_sym__ = 76,
  anon_sym_DOT = 77,
  anon_sym_DOT_DOT = 78,
  anon_sym_DOT_DOT_DOT = 79,
  anon_sym_DOT_DOT_EQ = 80,
  anon_sym_COMMA = 81,
  anon_sym_COLON_COLON = 82,
  anon_sym_DASH_GT = 83,
  anon_sym_POUND = 84,
  anon_sym_SQUOTE = 85,
  anon_sym_as = 86,
  anon_sym_async = 87,
  anon_sym_await = 88,
  anon_sym_break = 89,
  anon_sym_const = 90,
  anon_sym_continue = 91,
  anon_sym_default = 92,
  anon_sym_enum = 93,
  anon_sym_fn = 94,
  anon_sym_for = 95,
  anon_sym_if = 96,
  anon_sym_impl = 97,
  anon_sym_let = 98,
  anon_sym_loop = 99,
  anon_sym_match = 100,
  anon_sym_mod = 101,
  anon_sym_pub = 102,
  anon_sym_return = 103,
  anon_sym_static = 104,
  anon_sym_struct = 105,
  anon_sym_trait = 106,
  anon_sym_type = 107,
  anon_sym_union = 108,
  anon_sym_unsafe = 109,
  anon_sym_use = 110,
  anon_sym_where = 111,
  anon_sym_while = 112,
  anon_sym_extern = 113,
  anon_sym_ref = 114,
  anon_sym_else = 115,
  anon_sym_in = 116,
  anon_sym_LT2 = 117,
  anon_sym_dyn = 118,
  sym_mutable_specifier = 119,
  anon_sym_yield = 120,
  anon_sym_move = 121,
  anon_sym_try = 122,
  sym_integer_literal = 123,
  aux_sym_string_literal_token1 = 124,
  anon_sym_DQUOTE = 125,
  sym_char_literal = 126,
  sym_escape_sequence = 127,
  anon_sym_true = 128,
  anon_sym_false = 129,
  anon_sym_SLASH_SLASH = 130,
  aux_sym_line_comment_token1 = 131,
  aux_sym_line_comment_token2 = 132,
  aux_sym_line_comment_token3 = 133,
  sym__inner_line_doc_comment_marker = 134,
  sym__outer_line_doc_comment_marker = 135,
  anon_sym_SLASH_STAR = 136,
  anon_sym_STAR_SLASH = 137,
  sym_shebang = 138,
  sym_self = 139,
  sym_super = 140,
  sym_crate = 141,
  sym_metavariable = 142,
  sym_string_content = 143,
  sym__raw_string_literal_start = 144,
  sym_raw_string_literal_content = 145,
  sym__raw_string_literal_end = 146,
  sym_float_literal = 147,
  sym__outer_block_doc_comment_marker = 148,
  sym__inner_block_doc_comment_marker = 149,
  sym__block_comment_content = 150,
  sym__line_doc_content = 151,
  sym__error_sentinel = 152,
  sym_source_file = 153,
  sym__statement = 154,
  sym_empty_statement = 155,
  sym_expression_statement = 156,
  sym_macro_definition = 157,
  sym_macro_rule = 158,
  sym__token_pattern = 159,
  sym_token_tree_pattern = 160,
  sym_token_binding_pattern = 161,
  sym_token_repetition_pattern = 162,
  sym_fragment_specifier = 163,
  sym_token_tree = 164,
  sym_token_repetition = 165,
  sym_attribute_item = 166,
  sym_inner_attribute_item = 167,
  sym_attribute = 168,
  sym_mod_item = 169,
  sym_foreign_mod_item = 170,
  sym_declaration_list = 171,
  sym_struct_item = 172,
  sym_union_item = 173,
  sym_enum_item = 174,
  sym_enum_variant_list = 175,
  sym_enum_variant = 176,
  sym_field_declaration_list = 177,
  sym_field_declaration = 178,
  sym_ordered_field_declaration_list = 179,
  sym_extern_crate_declaration = 180,
  sym_const_item = 181,
  sym_static_item = 182,
  sym_type_item = 183,
  sym_function_item = 184,
  sym_function_signature_item = 185,
  sym_function_modifiers = 186,
  sym_where_clause = 187,
  sym_where_predicate = 188,
  sym_impl_item = 189,
  sym_trait_item = 190,
  sym_associated_type = 191,
  sym_trait_bounds = 192,
  sym_higher_ranked_trait_bound = 193,
  sym_removed_trait_bound = 194,
  sym_type_parameters = 195,
  sym_const_parameter = 196,
  sym_constrained_type_parameter = 197,
  sym_optional_type_parameter = 198,
  sym_let_declaration = 199,
  sym_use_declaration = 200,
  sym__use_clause = 201,
  sym_scoped_use_list = 202,
  sym_use_list = 203,
  sym_use_as_clause = 204,
  sym_use_wildcard = 205,
  sym_parameters = 206,
  sym_self_parameter = 207,
  sym_variadic_parameter = 208,
  sym_parameter = 209,
  sym_extern_modifier = 210,
  sym_visibility_modifier = 211,
  sym__type = 212,
  sym_bracketed_type = 213,
  sym_qualified_type = 214,
  sym_lifetime = 215,
  sym_array_type = 216,
  sym_for_lifetimes = 217,
  sym_function_type = 218,
  sym_tuple_type = 219,
  sym_unit_type = 220,
  sym_generic_function = 221,
  sym_generic_type = 222,
  sym_generic_type_with_turbofish = 223,
  sym_bounded_type = 224,
  sym_type_arguments = 225,
  sym_type_binding = 226,
  sym_reference_type = 227,
  sym_pointer_type = 228,
  sym_never_type = 229,
  sym_abstract_type = 230,
  sym_dynamic_type = 231,
  sym__expression_except_range = 232,
  sym__expression = 233,
  sym_macro_invocation = 234,
  sym_delim_token_tree = 235,
  sym__delim_tokens = 236,
  sym__non_delim_token = 237,
  sym_scoped_identifier = 238,
  sym_scoped_type_identifier_in_expression_position = 239,
  sym_scoped_type_identifier = 240,
  sym_range_expression = 241,
  sym_unary_expression = 242,
  sym_try_expression = 243,
  sym_reference_expression = 244,
  sym_binary_expression = 245,
  sym_assignment_expression = 246,
  sym_compound_assignment_expr = 247,
  sym_type_cast_expression = 248,
  sym_return_expression = 249,
  sym_yield_expression = 250,
  sym_call_expression = 251,
  sym_arguments = 252,
  sym_array_expression = 253,
  sym_parenthesized_expression = 254,
  sym_tuple_expression = 255,
  sym_unit_expression = 256,
  sym_struct_expression = 257,
  sym_field_initializer_list = 258,
  sym_shorthand_field_initializer = 259,
  sym_field_initializer = 260,
  sym_base_field_initializer = 261,
  sym_if_expression = 262,
  sym_let_condition = 263,
  sym__let_chain = 264,
  sym__condition = 265,
  sym_else_clause = 266,
  sym_match_expression = 267,
  sym_match_block = 268,
  sym_match_arm = 269,
  sym_last_match_arm = 270,
  sym_match_pattern = 271,
  sym_while_expression = 272,
  sym_loop_expression = 273,
  sym_for_expression = 274,
  sym_const_block = 275,
  sym_closure_expression = 276,
  sym_closure_parameters = 277,
  sym_label = 278,
  sym_break_expression = 279,
  sym_continue_expression = 280,
  sym_index_expression = 281,
  sym_await_expression = 282,
  sym_field_expression = 283,
  sym_unsafe_block = 284,
  sym_async_block = 285,
  sym_try_block = 286,
  sym_block = 287,
  sym__pattern = 288,
  sym_tuple_pattern = 289,
  sym_slice_pattern = 290,
  sym_tuple_struct_pattern = 291,
  sym_struct_pattern = 292,
  sym_field_pattern = 293,
  sym_remaining_field_pattern = 294,
  sym_mut_pattern = 295,
  sym_range_pattern = 296,
  sym_ref_pattern = 297,
  sym_captured_pattern = 298,
  sym_reference_pattern = 299,
  sym_or_pattern = 300,
  sym__literal = 301,
  sym__literal_pattern = 302,
  sym_negative_literal = 303,
  sym_string_literal = 304,
  sym_raw_string_literal = 305,
  sym_boolean_literal = 306,
  sym_line_comment = 307,
  sym__line_doc_comment_marker = 308,
  sym_block_comment = 309,
  sym__block_doc_comment_marker = 310,
  aux_sym_source_file_repeat1 = 311,
  aux_sym_macro_definition_repeat1 = 312,
  aux_sym_token_tree_pattern_repeat1 = 313,
  aux_sym_token_tree_repeat1 = 314,
  aux_sym__non_special_token_repeat1 = 315,
  aux_sym_declaration_list_repeat1 = 316,
  aux_sym_enum_variant_list_repeat1 = 317,
  aux_sym_enum_variant_list_repeat2 = 318,
  aux_sym_field_declaration_list_repeat1 = 319,
  aux_sym_ordered_field_declaration_list_repeat1 = 320,
  aux_sym_function_modifiers_repeat1 = 321,
  aux_sym_where_clause_repeat1 = 322,
  aux_sym_trait_bounds_repeat1 = 323,
  aux_sym_type_parameters_repeat1 = 324,
  aux_sym_use_list_repeat1 = 325,
  aux_sym_parameters_repeat1 = 326,
  aux_sym_for_lifetimes_repeat1 = 327,
  aux_sym_tuple_type_repeat1 = 328,
  aux_sym_type_arguments_repeat1 = 329,
  aux_sym_delim_token_tree_repeat1 = 330,
  aux_sym_arguments_repeat1 = 331,
  aux_sym_tuple_expression_repeat1 = 332,
  aux_sym_field_initializer_list_repeat1 = 333,
  aux_sym_match_block_repeat1 = 334,
  aux_sym_match_arm_repeat1 = 335,
  aux_sym_closure_parameters_repeat1 = 336,
  aux_sym_tuple_pattern_repeat1 = 337,
  aux_sym_slice_pattern_repeat1 = 338,
  aux_sym_struct_pattern_repeat1 = 339,
  aux_sym_string_literal_repeat1 = 340,
  alias_sym_field_identifier = 341,
  alias_sym_let_chain = 342,
  alias_sym_shorthand_field_identifier = 343,
  alias_sym_type_identifier = 344,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_macro_rules_BANG] = "macro_rules!",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_COLON] = ":",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_token_repetition_pattern_token1] = "token_repetition_pattern_token1",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "\?",
  [anon_sym_block] = "block",
  [anon_sym_expr] = "expr",
  [anon_sym_ident] = "ident",
  [anon_sym_item] = "item",
  [anon_sym_lifetime] = "lifetime",
  [anon_sym_literal] = "literal",
  [anon_sym_meta] = "meta",
  [anon_sym_pat] = "pat",
  [anon_sym_path] = "path",
  [anon_sym_stmt] = "stmt",
  [anon_sym_tt] = "tt",
  [anon_sym_ty] = "ty",
  [anon_sym_vis] = "vis",
  [anon_sym_u8] = "primitive_type",
  [anon_sym_i8] = "primitive_type",
  [anon_sym_u16] = "primitive_type",
  [anon_sym_i16] = "primitive_type",
  [anon_sym_u32] = "primitive_type",
  [anon_sym_i32] = "primitive_type",
  [anon_sym_u64] = "primitive_type",
  [anon_sym_i64] = "primitive_type",
  [anon_sym_u128] = "primitive_type",
  [anon_sym_i128] = "primitive_type",
  [anon_sym_isize] = "primitive_type",
  [anon_sym_usize] = "primitive_type",
  [anon_sym_f32] = "primitive_type",
  [anon_sym_f64] = "primitive_type",
  [anon_sym_bool] = "primitive_type",
  [anon_sym_str] = "primitive_type",
  [anon_sym_char] = "primitive_type",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_CARET] = "^",
  [anon_sym_BANG] = "!",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_EQ] = "=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_LT] = "<",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_AT] = "@",
  [anon_sym__] = "_",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_DOT_DOT_EQ] = "..=",
  [anon_sym_COMMA] = ",",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_POUND] = "#",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_as] = "as",
  [anon_sym_async] = "async",
  [anon_sym_await] = "await",
  [anon_sym_break] = "break",
  [anon_sym_const] = "const",
  [anon_sym_continue] = "continue",
  [anon_sym_default] = "default",
  [anon_sym_enum] = "enum",
  [anon_sym_fn] = "fn",
  [anon_sym_for] = "for",
  [anon_sym_if] = "if",
  [anon_sym_impl] = "impl",
  [anon_sym_let] = "let",
  [anon_sym_loop] = "loop",
  [anon_sym_match] = "match",
  [anon_sym_mod] = "mod",
  [anon_sym_pub] = "pub",
  [anon_sym_return] = "return",
  [anon_sym_static] = "static",
  [anon_sym_struct] = "struct",
  [anon_sym_trait] = "trait",
  [anon_sym_type] = "type",
  [anon_sym_union] = "union",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_use] = "use",
  [anon_sym_where] = "where",
  [anon_sym_while] = "while",
  [anon_sym_extern] = "extern",
  [anon_sym_ref] = "ref",
  [anon_sym_else] = "else",
  [anon_sym_in] = "in",
  [anon_sym_LT2] = "<",
  [anon_sym_dyn] = "dyn",
  [sym_mutable_specifier] = "mutable_specifier",
  [anon_sym_yield] = "yield",
  [anon_sym_move] = "move",
  [anon_sym_try] = "try",
  [sym_integer_literal] = "integer_literal",
  [aux_sym_string_literal_token1] = "\"",
  [anon_sym_DQUOTE] = "\"",
  [sym_char_literal] = "char_literal",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_SLASH_SLASH] = "//",
  [aux_sym_line_comment_token1] = "line_comment_token1",
  [aux_sym_line_comment_token2] = "line_comment_token2",
  [aux_sym_line_comment_token3] = "line_comment_token3",
  [sym__inner_line_doc_comment_marker] = "inner_doc_comment_marker",
  [sym__outer_line_doc_comment_marker] = "outer_doc_comment_marker",
  [anon_sym_SLASH_STAR] = "/*",
  [anon_sym_STAR_SLASH] = "*/",
  [sym_shebang] = "shebang",
  [sym_self] = "self",
  [sym_super] = "super",
  [sym_crate] = "crate",
  [sym_metavariable] = "metavariable",
  [sym_string_content] = "string_content",
  [sym__raw_string_literal_start] = "_raw_string_literal_start",
  [sym_raw_string_literal_content] = "string_content",
  [sym__raw_string_literal_end] = "_raw_string_literal_end",
  [sym_float_literal] = "float_literal",
  [sym__outer_block_doc_comment_marker] = "outer_doc_comment_marker",
  [sym__inner_block_doc_comment_marker] = "inner_doc_comment_marker",
  [sym__block_comment_content] = "_block_comment_content",
  [sym__line_doc_content] = "doc_comment",
  [sym__error_sentinel] = "_error_sentinel",
  [sym_source_file] = "source_file",
  [sym__statement] = "_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_macro_definition] = "macro_definition",
  [sym_macro_rule] = "macro_rule",
  [sym__token_pattern] = "_token_pattern",
  [sym_token_tree_pattern] = "token_tree_pattern",
  [sym_token_binding_pattern] = "token_binding_pattern",
  [sym_token_repetition_pattern] = "token_repetition_pattern",
  [sym_fragment_specifier] = "fragment_specifier",
  [sym_token_tree] = "token_tree",
  [sym_token_repetition] = "token_repetition",
  [sym_attribute_item] = "attribute_item",
  [sym_inner_attribute_item] = "inner_attribute_item",
  [sym_attribute] = "attribute",
  [sym_mod_item] = "mod_item",
  [sym_foreign_mod_item] = "foreign_mod_item",
  [sym_declaration_list] = "declaration_list",
  [sym_struct_item] = "struct_item",
  [sym_union_item] = "union_item",
  [sym_enum_item] = "enum_item",
  [sym_enum_variant_list] = "enum_variant_list",
  [sym_enum_variant] = "enum_variant",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_ordered_field_declaration_list] = "ordered_field_declaration_list",
  [sym_extern_crate_declaration] = "extern_crate_declaration",
  [sym_const_item] = "const_item",
  [sym_static_item] = "static_item",
  [sym_type_item] = "type_item",
  [sym_function_item] = "function_item",
  [sym_function_signature_item] = "function_signature_item",
  [sym_function_modifiers] = "function_modifiers",
  [sym_where_clause] = "where_clause",
  [sym_where_predicate] = "where_predicate",
  [sym_impl_item] = "impl_item",
  [sym_trait_item] = "trait_item",
  [sym_associated_type] = "associated_type",
  [sym_trait_bounds] = "trait_bounds",
  [sym_higher_ranked_trait_bound] = "higher_ranked_trait_bound",
  [sym_removed_trait_bound] = "removed_trait_bound",
  [sym_type_parameters] = "type_parameters",
  [sym_const_parameter] = "const_parameter",
  [sym_constrained_type_parameter] = "constrained_type_parameter",
  [sym_optional_type_parameter] = "optional_type_parameter",
  [sym_let_declaration] = "let_declaration",
  [sym_use_declaration] = "use_declaration",
  [sym__use_clause] = "_use_clause",
  [sym_scoped_use_list] = "scoped_use_list",
  [sym_use_list] = "use_list",
  [sym_use_as_clause] = "use_as_clause",
  [sym_use_wildcard] = "use_wildcard",
  [sym_parameters] = "parameters",
  [sym_self_parameter] = "self_parameter",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym_parameter] = "parameter",
  [sym_extern_modifier] = "extern_modifier",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym__type] = "_type",
  [sym_bracketed_type] = "bracketed_type",
  [sym_qualified_type] = "qualified_type",
  [sym_lifetime] = "lifetime",
  [sym_array_type] = "array_type",
  [sym_for_lifetimes] = "for_lifetimes",
  [sym_function_type] = "function_type",
  [sym_tuple_type] = "tuple_type",
  [sym_unit_type] = "unit_type",
  [sym_generic_function] = "generic_function",
  [sym_generic_type] = "generic_type",
  [sym_generic_type_with_turbofish] = "generic_type_with_turbofish",
  [sym_bounded_type] = "bounded_type",
  [sym_type_arguments] = "type_arguments",
  [sym_type_binding] = "type_binding",
  [sym_reference_type] = "reference_type",
  [sym_pointer_type] = "pointer_type",
  [sym_never_type] = "never_type",
  [sym_abstract_type] = "abstract_type",
  [sym_dynamic_type] = "dynamic_type",
  [sym__expression_except_range] = "_expression_except_range",
  [sym__expression] = "_expression",
  [sym_macro_invocation] = "macro_invocation",
  [sym_delim_token_tree] = "token_tree",
  [sym__delim_tokens] = "_delim_tokens",
  [sym__non_delim_token] = "_non_delim_token",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_scoped_type_identifier_in_expression_position] = "scoped_type_identifier",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_range_expression] = "range_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_try_expression] = "try_expression",
  [sym_reference_expression] = "reference_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_compound_assignment_expr] = "compound_assignment_expr",
  [sym_type_cast_expression] = "type_cast_expression",
  [sym_return_expression] = "return_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_call_expression] = "call_expression",
  [sym_arguments] = "arguments",
  [sym_array_expression] = "array_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_unit_expression] = "unit_expression",
  [sym_struct_expression] = "struct_expression",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_shorthand_field_initializer] = "shorthand_field_initializer",
  [sym_field_initializer] = "field_initializer",
  [sym_base_field_initializer] = "base_field_initializer",
  [sym_if_expression] = "if_expression",
  [sym_let_condition] = "let_condition",
  [sym__let_chain] = "_let_chain",
  [sym__condition] = "_condition",
  [sym_else_clause] = "else_clause",
  [sym_match_expression] = "match_expression",
  [sym_match_block] = "match_block",
  [sym_match_arm] = "match_arm",
  [sym_last_match_arm] = "match_arm",
  [sym_match_pattern] = "match_pattern",
  [sym_while_expression] = "while_expression",
  [sym_loop_expression] = "loop_expression",
  [sym_for_expression] = "for_expression",
  [sym_const_block] = "const_block",
  [sym_closure_expression] = "closure_expression",
  [sym_closure_parameters] = "closure_parameters",
  [sym_label] = "label",
  [sym_break_expression] = "break_expression",
  [sym_continue_expression] = "continue_expression",
  [sym_index_expression] = "index_expression",
  [sym_await_expression] = "await_expression",
  [sym_field_expression] = "field_expression",
  [sym_unsafe_block] = "unsafe_block",
  [sym_async_block] = "async_block",
  [sym_try_block] = "try_block",
  [sym_block] = "block",
  [sym__pattern] = "_pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_slice_pattern] = "slice_pattern",
  [sym_tuple_struct_pattern] = "tuple_struct_pattern",
  [sym_struct_pattern] = "struct_pattern",
  [sym_field_pattern] = "field_pattern",
  [sym_remaining_field_pattern] = "remaining_field_pattern",
  [sym_mut_pattern] = "mut_pattern",
  [sym_range_pattern] = "range_pattern",
  [sym_ref_pattern] = "ref_pattern",
  [sym_captured_pattern] = "captured_pattern",
  [sym_reference_pattern] = "reference_pattern",
  [sym_or_pattern] = "or_pattern",
  [sym__literal] = "_literal",
  [sym__literal_pattern] = "_literal_pattern",
  [sym_negative_literal] = "negative_literal",
  [sym_string_literal] = "string_literal",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_boolean_literal] = "boolean_literal",
  [sym_line_comment] = "line_comment",
  [sym__line_doc_comment_marker] = "_line_doc_comment_marker",
  [sym_block_comment] = "block_comment",
  [sym__block_doc_comment_marker] = "_block_doc_comment_marker",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_macro_definition_repeat1] = "macro_definition_repeat1",
  [aux_sym_token_tree_pattern_repeat1] = "token_tree_pattern_repeat1",
  [aux_sym_token_tree_repeat1] = "token_tree_repeat1",
  [aux_sym__non_special_token_repeat1] = "_non_special_token_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_enum_variant_list_repeat1] = "enum_variant_list_repeat1",
  [aux_sym_enum_variant_list_repeat2] = "enum_variant_list_repeat2",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_ordered_field_declaration_list_repeat1] = "ordered_field_declaration_list_repeat1",
  [aux_sym_function_modifiers_repeat1] = "function_modifiers_repeat1",
  [aux_sym_where_clause_repeat1] = "where_clause_repeat1",
  [aux_sym_trait_bounds_repeat1] = "trait_bounds_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_use_list_repeat1] = "use_list_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_for_lifetimes_repeat1] = "for_lifetimes_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_delim_token_tree_repeat1] = "delim_token_tree_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_match_block_repeat1] = "match_block_repeat1",
  [aux_sym_match_arm_repeat1] = "match_arm_repeat1",
  [aux_sym_closure_parameters_repeat1] = "closure_parameters_repeat1",
  [aux_sym_tuple_pattern_repeat1] = "tuple_pattern_repeat1",
  [aux_sym_slice_pattern_repeat1] = "slice_pattern_repeat1",
  [aux_sym_struct_pattern_repeat1] = "struct_pattern_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_let_chain] = "let_chain",
  [alias_sym_shorthand_field_identifier] = "shorthand_field_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_macro_rules_BANG] = anon_sym_macro_rules_BANG,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [aux_sym_token_repetition_pattern_token1] = aux_sym_token_repetition_pattern_token1,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_block] = anon_sym_block,
  [anon_sym_expr] = anon_sym_expr,
  [anon_sym_ident] = anon_sym_ident,
  [anon_sym_item] = anon_sym_item,
  [anon_sym_lifetime] = anon_sym_lifetime,
  [anon_sym_literal] = anon_sym_literal,
  [anon_sym_meta] = anon_sym_meta,
  [anon_sym_pat] = anon_sym_pat,
  [anon_sym_path] = anon_sym_path,
  [anon_sym_stmt] = anon_sym_stmt,
  [anon_sym_tt] = anon_sym_tt,
  [anon_sym_ty] = anon_sym_ty,
  [anon_sym_vis] = anon_sym_vis,
  [anon_sym_u8] = anon_sym_u8,
  [anon_sym_i8] = anon_sym_u8,
  [anon_sym_u16] = anon_sym_u8,
  [anon_sym_i16] = anon_sym_u8,
  [anon_sym_u32] = anon_sym_u8,
  [anon_sym_i32] = anon_sym_u8,
  [anon_sym_u64] = anon_sym_u8,
  [anon_sym_i64] = anon_sym_u8,
  [anon_sym_u128] = anon_sym_u8,
  [anon_sym_i128] = anon_sym_u8,
  [anon_sym_isize] = anon_sym_u8,
  [anon_sym_usize] = anon_sym_u8,
  [anon_sym_f32] = anon_sym_u8,
  [anon_sym_f64] = anon_sym_u8,
  [anon_sym_bool] = anon_sym_u8,
  [anon_sym_str] = anon_sym_u8,
  [anon_sym_char] = anon_sym_u8,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym__] = anon_sym__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_DOT_DOT_EQ] = anon_sym_DOT_DOT_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_impl] = anon_sym_impl,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_loop] = anon_sym_loop,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_pub] = anon_sym_pub,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_trait] = anon_sym_trait,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_unsafe] = anon_sym_unsafe,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_LT2] = anon_sym_LT,
  [anon_sym_dyn] = anon_sym_dyn,
  [sym_mutable_specifier] = sym_mutable_specifier,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_move] = anon_sym_move,
  [anon_sym_try] = anon_sym_try,
  [sym_integer_literal] = sym_integer_literal,
  [aux_sym_string_literal_token1] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [sym_char_literal] = sym_char_literal,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [aux_sym_line_comment_token1] = aux_sym_line_comment_token1,
  [aux_sym_line_comment_token2] = aux_sym_line_comment_token2,
  [aux_sym_line_comment_token3] = aux_sym_line_comment_token3,
  [sym__inner_line_doc_comment_marker] = sym__inner_block_doc_comment_marker,
  [sym__outer_line_doc_comment_marker] = sym__outer_block_doc_comment_marker,
  [anon_sym_SLASH_STAR] = anon_sym_SLASH_STAR,
  [anon_sym_STAR_SLASH] = anon_sym_STAR_SLASH,
  [sym_shebang] = sym_shebang,
  [sym_self] = sym_self,
  [sym_super] = sym_super,
  [sym_crate] = sym_crate,
  [sym_metavariable] = sym_metavariable,
  [sym_string_content] = sym_string_content,
  [sym__raw_string_literal_start] = sym__raw_string_literal_start,
  [sym_raw_string_literal_content] = sym_string_content,
  [sym__raw_string_literal_end] = sym__raw_string_literal_end,
  [sym_float_literal] = sym_float_literal,
  [sym__outer_block_doc_comment_marker] = sym__outer_block_doc_comment_marker,
  [sym__inner_block_doc_comment_marker] = sym__inner_block_doc_comment_marker,
  [sym__block_comment_content] = sym__block_comment_content,
  [sym__line_doc_content] = sym__line_doc_content,
  [sym__error_sentinel] = sym__error_sentinel,
  [sym_source_file] = sym_source_file,
  [sym__statement] = sym__statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_macro_definition] = sym_macro_definition,
  [sym_macro_rule] = sym_macro_rule,
  [sym__token_pattern] = sym__token_pattern,
  [sym_token_tree_pattern] = sym_token_tree_pattern,
  [sym_token_binding_pattern] = sym_token_binding_pattern,
  [sym_token_repetition_pattern] = sym_token_repetition_pattern,
  [sym_fragment_specifier] = sym_fragment_specifier,
  [sym_token_tree] = sym_token_tree,
  [sym_token_repetition] = sym_token_repetition,
  [sym_attribute_item] = sym_attribute_item,
  [sym_inner_attribute_item] = sym_inner_attribute_item,
  [sym_attribute] = sym_attribute,
  [sym_mod_item] = sym_mod_item,
  [sym_foreign_mod_item] = sym_foreign_mod_item,
  [sym_declaration_list] = sym_declaration_list,
  [sym_struct_item] = sym_struct_item,
  [sym_union_item] = sym_union_item,
  [sym_enum_item] = sym_enum_item,
  [sym_enum_variant_list] = sym_enum_variant_list,
  [sym_enum_variant] = sym_enum_variant,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym_field_declaration] = sym_field_declaration,
  [sym_ordered_field_declaration_list] = sym_ordered_field_declaration_list,
  [sym_extern_crate_declaration] = sym_extern_crate_declaration,
  [sym_const_item] = sym_const_item,
  [sym_static_item] = sym_static_item,
  [sym_type_item] = sym_type_item,
  [sym_function_item] = sym_function_item,
  [sym_function_signature_item] = sym_function_signature_item,
  [sym_function_modifiers] = sym_function_modifiers,
  [sym_where_clause] = sym_where_clause,
  [sym_where_predicate] = sym_where_predicate,
  [sym_impl_item] = sym_impl_item,
  [sym_trait_item] = sym_trait_item,
  [sym_associated_type] = sym_associated_type,
  [sym_trait_bounds] = sym_trait_bounds,
  [sym_higher_ranked_trait_bound] = sym_higher_ranked_trait_bound,
  [sym_removed_trait_bound] = sym_removed_trait_bound,
  [sym_type_parameters] = sym_type_parameters,
  [sym_const_parameter] = sym_const_parameter,
  [sym_constrained_type_parameter] = sym_constrained_type_parameter,
  [sym_optional_type_parameter] = sym_optional_type_parameter,
  [sym_let_declaration] = sym_let_declaration,
  [sym_use_declaration] = sym_use_declaration,
  [sym__use_clause] = sym__use_clause,
  [sym_scoped_use_list] = sym_scoped_use_list,
  [sym_use_list] = sym_use_list,
  [sym_use_as_clause] = sym_use_as_clause,
  [sym_use_wildcard] = sym_use_wildcard,
  [sym_parameters] = sym_parameters,
  [sym_self_parameter] = sym_self_parameter,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym_parameter] = sym_parameter,
  [sym_extern_modifier] = sym_extern_modifier,
  [sym_visibility_modifier] = sym_visibility_modifier,
  [sym__type] = sym__type,
  [sym_bracketed_type] = sym_bracketed_type,
  [sym_qualified_type] = sym_qualified_type,
  [sym_lifetime] = sym_lifetime,
  [sym_array_type] = sym_array_type,
  [sym_for_lifetimes] = sym_for_lifetimes,
  [sym_function_type] = sym_function_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_unit_type] = sym_unit_type,
  [sym_generic_function] = sym_generic_function,
  [sym_generic_type] = sym_generic_type,
  [sym_generic_type_with_turbofish] = sym_generic_type_with_turbofish,
  [sym_bounded_type] = sym_bounded_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_type_binding] = sym_type_binding,
  [sym_reference_type] = sym_reference_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym_never_type] = sym_never_type,
  [sym_abstract_type] = sym_abstract_type,
  [sym_dynamic_type] = sym_dynamic_type,
  [sym__expression_except_range] = sym__expression_except_range,
  [sym__expression] = sym__expression,
  [sym_macro_invocation] = sym_macro_invocation,
  [sym_delim_token_tree] = sym_token_tree,
  [sym__delim_tokens] = sym__delim_tokens,
  [sym__non_delim_token] = sym__non_delim_token,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_scoped_type_identifier_in_expression_position] = sym_scoped_type_identifier,
  [sym_scoped_type_identifier] = sym_scoped_type_identifier,
  [sym_range_expression] = sym_range_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_try_expression] = sym_try_expression,
  [sym_reference_expression] = sym_reference_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_compound_assignment_expr] = sym_compound_assignment_expr,
  [sym_type_cast_expression] = sym_type_cast_expression,
  [sym_return_expression] = sym_return_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_arguments] = sym_arguments,
  [sym_array_expression] = sym_array_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_unit_expression] = sym_unit_expression,
  [sym_struct_expression] = sym_struct_expression,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_shorthand_field_initializer] = sym_shorthand_field_initializer,
  [sym_field_initializer] = sym_field_initializer,
  [sym_base_field_initializer] = sym_base_field_initializer,
  [sym_if_expression] = sym_if_expression,
  [sym_let_condition] = sym_let_condition,
  [sym__let_chain] = sym__let_chain,
  [sym__condition] = sym__condition,
  [sym_else_clause] = sym_else_clause,
  [sym_match_expression] = sym_match_expression,
  [sym_match_block] = sym_match_block,
  [sym_match_arm] = sym_match_arm,
  [sym_last_match_arm] = sym_match_arm,
  [sym_match_pattern] = sym_match_pattern,
  [sym_while_expression] = sym_while_expression,
  [sym_loop_expression] = sym_loop_expression,
  [sym_for_expression] = sym_for_expression,
  [sym_const_block] = sym_const_block,
  [sym_closure_expression] = sym_closure_expression,
  [sym_closure_parameters] = sym_closure_parameters,
  [sym_label] = sym_label,
  [sym_break_expression] = sym_break_expression,
  [sym_continue_expression] = sym_continue_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_field_expression] = sym_field_expression,
  [sym_unsafe_block] = sym_unsafe_block,
  [sym_async_block] = sym_async_block,
  [sym_try_block] = sym_try_block,
  [sym_block] = sym_block,
  [sym__pattern] = sym__pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_slice_pattern] = sym_slice_pattern,
  [sym_tuple_struct_pattern] = sym_tuple_struct_pattern,
  [sym_struct_pattern] = sym_struct_pattern,
  [sym_field_pattern] = sym_field_pattern,
  [sym_remaining_field_pattern] = sym_remaining_field_pattern,
  [sym_mut_pattern] = sym_mut_pattern,
  [sym_range_pattern] = sym_range_pattern,
  [sym_ref_pattern] = sym_ref_pattern,
  [sym_captured_pattern] = sym_captured_pattern,
  [sym_reference_pattern] = sym_reference_pattern,
  [sym_or_pattern] = sym_or_pattern,
  [sym__literal] = sym__literal,
  [sym__literal_pattern] = sym__literal_pattern,
  [sym_negative_literal] = sym_negative_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_line_comment] = sym_line_comment,
  [sym__line_doc_comment_marker] = sym__line_doc_comment_marker,
  [sym_block_comment] = sym_block_comment,
  [sym__block_doc_comment_marker] = sym__block_doc_comment_marker,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_macro_definition_repeat1] = aux_sym_macro_definition_repeat1,
  [aux_sym_token_tree_pattern_repeat1] = aux_sym_token_tree_pattern_repeat1,
  [aux_sym_token_tree_repeat1] = aux_sym_token_tree_repeat1,
  [aux_sym__non_special_token_repeat1] = aux_sym__non_special_token_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_enum_variant_list_repeat1] = aux_sym_enum_variant_list_repeat1,
  [aux_sym_enum_variant_list_repeat2] = aux_sym_enum_variant_list_repeat2,
  [aux_sym_field_declaration_list_repeat1] = aux_sym_field_declaration_list_repeat1,
  [aux_sym_ordered_field_declaration_list_repeat1] = aux_sym_ordered_field_declaration_list_repeat1,
  [aux_sym_function_modifiers_repeat1] = aux_sym_function_modifiers_repeat1,
  [aux_sym_where_clause_repeat1] = aux_sym_where_clause_repeat1,
  [aux_sym_trait_bounds_repeat1] = aux_sym_trait_bounds_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_use_list_repeat1] = aux_sym_use_list_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_for_lifetimes_repeat1] = aux_sym_for_lifetimes_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_delim_token_tree_repeat1] = aux_sym_delim_token_tree_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_match_block_repeat1] = aux_sym_match_block_repeat1,
  [aux_sym_match_arm_repeat1] = aux_sym_match_arm_repeat1,
  [aux_sym_closure_parameters_repeat1] = aux_sym_closure_parameters_repeat1,
  [aux_sym_tuple_pattern_repeat1] = aux_sym_tuple_pattern_repeat1,
  [aux_sym_slice_pattern_repeat1] = aux_sym_slice_pattern_repeat1,
  [aux_sym_struct_pattern_repeat1] = aux_sym_struct_pattern_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_let_chain] = alias_sym_let_chain,
  [alias_sym_shorthand_field_identifier] = alias_sym_shorthand_field_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_macro_rules_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_token_repetition_pattern_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_block] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_expr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ident] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_item] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lifetime] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_literal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_meta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_path] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stmt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ty] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vis] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i8] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u16] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i16] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u128] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i128] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_isize] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_usize] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_f32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_f64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_str] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_impl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_loop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trait] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dyn] = {
    .visible = true,
    .named = false,
  },
  [sym_mutable_specifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_move] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_line_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_line_comment_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_line_comment_token3] = {
    .visible = false,
    .named = false,
  },
  [sym__inner_line_doc_comment_marker] = {
    .visible = true,
    .named = true,
  },
  [sym__outer_line_doc_comment_marker] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SLASH_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_shebang] = {
    .visible = true,
    .named = true,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_crate] = {
    .visible = true,
    .named = true,
  },
  [sym_metavariable] = {
    .visible = true,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym__raw_string_literal_start] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string_literal_content] = {
    .visible = true,
    .named = true,
  },
  [sym__raw_string_literal_end] = {
    .visible = false,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__outer_block_doc_comment_marker] = {
    .visible = true,
    .named = true,
  },
  [sym__inner_block_doc_comment_marker] = {
    .visible = true,
    .named = true,
  },
  [sym__block_comment_content] = {
    .visible = false,
    .named = true,
  },
  [sym__line_doc_content] = {
    .visible = true,
    .named = true,
  },
  [sym__error_sentinel] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_rule] = {
    .visible = true,
    .named = true,
  },
  [sym__token_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_token_tree_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_token_binding_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_token_repetition_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_fragment_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_token_tree] = {
    .visible = true,
    .named = true,
  },
  [sym_token_repetition] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_inner_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_foreign_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_item] = {
    .visible = true,
    .named = true,
  },
  [sym_union_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant_list] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ordered_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_crate_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_item] = {
    .visible = true,
    .named = true,
  },
  [sym_static_item] = {
    .visible = true,
    .named = true,
  },
  [sym_type_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_where_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_impl_item] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_item] = {
    .visible = true,
    .named = true,
  },
  [sym_associated_type] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_bounds] = {
    .visible = true,
    .named = true,
  },
  [sym_higher_ranked_trait_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_removed_trait_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_const_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_let_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__use_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_as_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_use_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_self_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_bracketed_type] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_lifetime] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_for_lifetimes] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type_with_turbofish] = {
    .visible = true,
    .named = true,
  },
  [sym_bounded_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_type_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_never_type] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_type] = {
    .visible = true,
    .named = true,
  },
  [sym_dynamic_type] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_except_range] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_macro_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_delim_token_tree] = {
    .visible = true,
    .named = true,
  },
  [sym__delim_tokens] = {
    .visible = false,
    .named = true,
  },
  [sym__non_delim_token] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier_in_expression_position] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_try_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_assignment_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_type_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_return_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_shorthand_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_base_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_let_condition] = {
    .visible = true,
    .named = true,
  },
  [sym__let_chain] = {
    .visible = false,
    .named = true,
  },
  [sym__condition] = {
    .visible = false,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_last_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_match_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_while_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_const_block] = {
    .visible = true,
    .named = true,
  },
  [sym_closure_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_closure_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym_break_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unsafe_block] = {
    .visible = true,
    .named = true,
  },
  [sym_async_block] = {
    .visible = true,
    .named = true,
  },
  [sym_try_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_remaining_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_mut_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_range_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_captured_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_or_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__literal_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_negative_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__line_doc_comment_marker] = {
    .visible = false,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__block_doc_comment_marker] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__non_special_token_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ordered_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_where_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_trait_bounds_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_lifetimes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_delim_token_tree_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_arm_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_closure_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_slice_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_let_chain] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_bounds = 6,
  field_condition = 7,
  field_consequence = 8,
  field_default_type = 9,
  field_doc = 10,
  field_element = 11,
  field_field = 12,
  field_function = 13,
  field_inner = 14,
  field_left = 15,
  field_length = 16,
  field_list = 17,
  field_macro = 18,
  field_name = 19,
  field_operator = 20,
  field_outer = 21,
  field_parameters = 22,
  field_path = 23,
  field_pattern = 24,
  field_return_type = 25,
  field_right = 26,
  field_trait = 27,
  field_type = 28,
  field_type_arguments = 29,
  field_type_parameters = 30,
  field_value = 31,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_bounds] = "bounds",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_default_type] = "default_type",
  [field_doc] = "doc",
  [field_element] = "element",
  [field_field] = "field",
  [field_function] = "function",
  [field_inner] = "inner",
  [field_left] = "left",
  [field_length] = "length",
  [field_list] = "list",
  [field_macro] = "macro",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_outer] = "outer",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_trait] = "trait",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [6] = {.index = 3, .length = 1},
  [7] = {.index = 3, .length = 1},
  [8] = {.index = 4, .length = 1},
  [10] = {.index = 5, .length = 2},
  [11] = {.index = 5, .length = 2},
  [12] = {.index = 7, .length = 2},
  [13] = {.index = 9, .length = 2},
  [14] = {.index = 11, .length = 3},
  [15] = {.index = 14, .length = 2},
  [16] = {.index = 16, .length = 2},
  [17] = {.index = 16, .length = 2},
  [18] = {.index = 18, .length = 1},
  [19] = {.index = 19, .length = 2},
  [20] = {.index = 19, .length = 2},
  [21] = {.index = 19, .length = 2},
  [22] = {.index = 21, .length = 1},
  [23] = {.index = 22, .length = 1},
  [24] = {.index = 23, .length = 1},
  [25] = {.index = 23, .length = 1},
  [26] = {.index = 24, .length = 2},
  [27] = {.index = 24, .length = 2},
  [28] = {.index = 26, .length = 1},
  [29] = {.index = 27, .length = 2},
  [30] = {.index = 29, .length = 2},
  [31] = {.index = 31, .length = 2},
  [32] = {.index = 33, .length = 1},
  [33] = {.index = 34, .length = 2},
  [34] = {.index = 27, .length = 2},
  [35] = {.index = 36, .length = 2},
  [36] = {.index = 38, .length = 1},
  [37] = {.index = 39, .length = 1},
  [38] = {.index = 40, .length = 2},
  [39] = {.index = 26, .length = 1},
  [40] = {.index = 16, .length = 2},
  [41] = {.index = 16, .length = 2},
  [42] = {.index = 42, .length = 2},
  [43] = {.index = 44, .length = 2},
  [44] = {.index = 46, .length = 1},
  [45] = {.index = 16, .length = 2},
  [46] = {.index = 16, .length = 2},
  [47] = {.index = 47, .length = 3},
  [48] = {.index = 50, .length = 2},
  [49] = {.index = 52, .length = 2},
  [50] = {.index = 52, .length = 2},
  [51] = {.index = 54, .length = 2},
  [52] = {.index = 44, .length = 2},
  [53] = {.index = 11, .length = 3},
  [54] = {.index = 3, .length = 1},
  [56] = {.index = 56, .length = 1},
  [57] = {.index = 56, .length = 1},
  [58] = {.index = 57, .length = 1},
  [60] = {.index = 58, .length = 2},
  [61] = {.index = 56, .length = 1},
  [62] = {.index = 60, .length = 1},
  [63] = {.index = 61, .length = 1},
  [64] = {.index = 62, .length = 1},
  [65] = {.index = 63, .length = 2},
  [66] = {.index = 65, .length = 2},
  [67] = {.index = 65, .length = 2},
  [68] = {.index = 67, .length = 1},
  [69] = {.index = 67, .length = 1},
  [70] = {.index = 57, .length = 1},
  [71] = {.index = 68, .length = 2},
  [72] = {.index = 70, .length = 3},
  [73] = {.index = 73, .length = 2},
  [74] = {.index = 75, .length = 3},
  [75] = {.index = 78, .length = 3},
  [77] = {.index = 81, .length = 2},
  [78] = {.index = 81, .length = 2},
  [79] = {.index = 83, .length = 2},
  [80] = {.index = 85, .length = 3},
  [81] = {.index = 88, .length = 2},
  [82] = {.index = 90, .length = 1},
  [83] = {.index = 91, .length = 2},
  [84] = {.index = 93, .length = 2},
  [85] = {.index = 95, .length = 3},
  [86] = {.index = 98, .length = 2},
  [87] = {.index = 100, .length = 2},
  [88] = {.index = 102, .length = 2},
  [89] = {.index = 104, .length = 2},
  [90] = {.index = 106, .length = 2},
  [91] = {.index = 104, .length = 2},
  [92] = {.index = 106, .length = 2},
  [93] = {.index = 108, .length = 1},
  [94] = {.index = 102, .length = 2},
  [95] = {.index = 108, .length = 1},
  [96] = {.index = 109, .length = 1},
  [97] = {.index = 110, .length = 3},
  [98] = {.index = 113, .length = 1},
  [99] = {.index = 114, .length = 1},
  [100] = {.index = 115, .length = 2},
  [101] = {.index = 3, .length = 1},
  [102] = {.index = 117, .length = 1},
  [103] = {.index = 118, .length = 2},
  [104] = {.index = 120, .length = 1},
  [105] = {.index = 120, .length = 1},
  [106] = {.index = 121, .length = 3},
  [107] = {.index = 124, .length = 1},
  [108] = {.index = 121, .length = 3},
  [109] = {.index = 18, .length = 1},
  [110] = {.index = 125, .length = 2},
  [111] = {.index = 127, .length = 3},
  [112] = {.index = 130, .length = 3},
  [113] = {.index = 133, .length = 4},
  [114] = {.index = 137, .length = 3},
  [115] = {.index = 140, .length = 3},
  [116] = {.index = 143, .length = 2},
  [117] = {.index = 145, .length = 2},
  [118] = {.index = 145, .length = 2},
  [120] = {.index = 147, .length = 2},
  [121] = {.index = 149, .length = 3},
  [122] = {.index = 152, .length = 3},
  [123] = {.index = 147, .length = 2},
  [124] = {.index = 149, .length = 3},
  [125] = {.index = 155, .length = 2},
  [127] = {.index = 157, .length = 3},
  [128] = {.index = 160, .length = 3},
  [129] = {.index = 163, .length = 4},
  [130] = {.index = 125, .length = 2},
  [131] = {.index = 167, .length = 3},
  [132] = {.index = 170, .length = 2},
  [133] = {.index = 172, .length = 3},
  [134] = {.index = 175, .length = 2},
  [135] = {.index = 177, .length = 2},
  [136] = {.index = 179, .length = 3},
  [137] = {.index = 182, .length = 3},
  [138] = {.index = 185, .length = 2},
  [139] = {.index = 185, .length = 2},
  [140] = {.index = 187, .length = 2},
  [141] = {.index = 189, .length = 3},
  [142] = {.index = 192, .length = 2},
  [143] = {.index = 194, .length = 2},
  [144] = {.index = 196, .length = 1},
  [145] = {.index = 197, .length = 2},
  [146] = {.index = 199, .length = 1},
  [147] = {.index = 200, .length = 2},
  [148] = {.index = 108, .length = 1},
  [149] = {.index = 202, .length = 2},
  [150] = {.index = 204, .length = 2},
  [151] = {.index = 206, .length = 1},
  [152] = {.index = 207, .length = 2},
  [153] = {.index = 209, .length = 3},
  [154] = {.index = 209, .length = 3},
  [155] = {.index = 212, .length = 2},
  [156] = {.index = 214, .length = 4},
  [157] = {.index = 218, .length = 3},
  [158] = {.index = 221, .length = 4},
  [159] = {.index = 225, .length = 2},
  [160] = {.index = 227, .length = 3},
  [161] = {.index = 225, .length = 2},
  [162] = {.index = 227, .length = 3},
  [163] = {.index = 230, .length = 3},
  [164] = {.index = 233, .length = 3},
  [165] = {.index = 236, .length = 4},
  [166] = {.index = 233, .length = 3},
  [167] = {.index = 236, .length = 4},
  [168] = {.index = 230, .length = 3},
  [169] = {.index = 240, .length = 2},
  [170] = {.index = 242, .length = 2},
  [171] = {.index = 244, .length = 2},
  [172] = {.index = 246, .length = 2},
  [173] = {.index = 248, .length = 1},
  [174] = {.index = 249, .length = 2},
  [175] = {.index = 251, .length = 3},
  [176] = {.index = 254, .length = 2},
  [177] = {.index = 256, .length = 2},
  [178] = {.index = 200, .length = 2},
  [179] = {.index = 258, .length = 4},
  [180] = {.index = 262, .length = 3},
  [181] = {.index = 265, .length = 3},
  [182] = {.index = 268, .length = 3},
  [183] = {.index = 271, .length = 3},
  [184] = {.index = 274, .length = 4},
  [185] = {.index = 278, .length = 2},
  [186] = {.index = 280, .length = 2},
  [187] = {.index = 280, .length = 2},
  [188] = {.index = 282, .length = 3},
  [189] = {.index = 285, .length = 4},
  [190] = {.index = 289, .length = 3},
  [191] = {.index = 249, .length = 2},
  [192] = {.index = 292, .length = 2},
  [193] = {.index = 294, .length = 3},
  [194] = {.index = 297, .length = 3},
  [195] = {.index = 300, .length = 2},
  [196] = {.index = 302, .length = 3},
  [197] = {.index = 200, .length = 2},
  [198] = {.index = 305, .length = 3},
  [199] = {.index = 308, .length = 2},
  [200] = {.index = 310, .length = 2},
  [201] = {.index = 312, .length = 3},
  [202] = {.index = 315, .length = 3},
  [203] = {.index = 318, .length = 2},
  [204] = {.index = 320, .length = 4},
  [205] = {.index = 324, .length = 5},
  [206] = {.index = 329, .length = 4},
  [207] = {.index = 333, .length = 3},
  [208] = {.index = 333, .length = 3},
  [209] = {.index = 336, .length = 3},
  [210] = {.index = 339, .length = 4},
  [211] = {.index = 336, .length = 3},
  [212] = {.index = 339, .length = 4},
  [213] = {.index = 343, .length = 4},
  [214] = {.index = 343, .length = 4},
  [215] = {.index = 347, .length = 3},
  [216] = {.index = 350, .length = 3},
  [217] = {.index = 353, .length = 3},
  [218] = {.index = 356, .length = 2},
  [219] = {.index = 358, .length = 2},
  [220] = {.index = 125, .length = 2},
  [221] = {.index = 360, .length = 2},
  [222] = {.index = 362, .length = 3},
  [223] = {.index = 360, .length = 2},
  [224] = {.index = 362, .length = 3},
  [225] = {.index = 365, .length = 3},
  [226] = {.index = 368, .length = 4},
  [227] = {.index = 365, .length = 3},
  [228] = {.index = 368, .length = 4},
  [229] = {.index = 372, .length = 4},
  [230] = {.index = 376, .length = 4},
  [231] = {.index = 380, .length = 3},
  [232] = {.index = 383, .length = 4},
  [233] = {.index = 387, .length = 3},
  [234] = {.index = 390, .length = 3},
  [235] = {.index = 393, .length = 3},
  [236] = {.index = 396, .length = 4},
  [237] = {.index = 400, .length = 2},
  [238] = {.index = 402, .length = 3},
  [239] = {.index = 405, .length = 4},
  [240] = {.index = 409, .length = 3},
  [241] = {.index = 412, .length = 3},
  [242] = {.index = 415, .length = 2},
  [243] = {.index = 417, .length = 3},
  [244] = {.index = 420, .length = 5},
  [245] = {.index = 425, .length = 4},
  [246] = {.index = 425, .length = 4},
  [247] = {.index = 429, .length = 3},
  [248] = {.index = 432, .length = 3},
  [249] = {.index = 435, .length = 3},
  [250] = {.index = 438, .length = 3},
  [251] = {.index = 441, .length = 2},
  [252] = {.index = 443, .length = 3},
  [253] = {.index = 443, .length = 3},
  [254] = {.index = 446, .length = 3},
  [255] = {.index = 449, .length = 4},
  [256] = {.index = 446, .length = 3},
  [257] = {.index = 449, .length = 4},
  [258] = {.index = 453, .length = 4},
  [259] = {.index = 453, .length = 4},
  [260] = {.index = 457, .length = 4},
  [261] = {.index = 461, .length = 5},
  [262] = {.index = 466, .length = 4},
  [263] = {.index = 470, .length = 2},
  [264] = {.index = 472, .length = 4},
  [265] = {.index = 476, .length = 4},
  [266] = {.index = 480, .length = 3},
  [267] = {.index = 483, .length = 4},
  [268] = {.index = 487, .length = 4},
  [269] = {.index = 491, .length = 3},
  [270] = {.index = 494, .length = 4},
  [271] = {.index = 494, .length = 4},
  [272] = {.index = 498, .length = 5},
  [273] = {.index = 503, .length = 4},
  [274] = {.index = 507, .length = 5},
  [275] = {.index = 512, .length = 4},
  [276] = {.index = 516, .length = 4},
  [277] = {.index = 520, .length = 3},
  [278] = {.index = 523, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_inner, 0},
  [1] =
    {field_outer, 0},
  [2] =
    {field_value, 1},
  [3] =
    {field_name, 1},
  [4] =
    {field_body, 1},
  [5] =
    {field_body, 1},
    {field_name, 0},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_body, 1},
    {field_parameters, 0},
  [11] =
    {field_doc, 2},
    {field_inner, 1, .inherited = true},
    {field_outer, 1, .inherited = true},
  [14] =
    {field_inner, 1, .inherited = true},
    {field_outer, 1, .inherited = true},
  [16] =
    {field_name, 2},
    {field_path, 0},
  [18] =
    {field_value, 2},
  [19] =
    {field_type, 0},
    {field_type_arguments, 1},
  [21] =
    {field_type, 1},
  [22] =
    {field_parameters, 1},
  [23] =
    {field_trait, 1},
  [24] =
    {field_parameters, 1},
    {field_trait, 0},
  [26] =
    {field_macro, 0},
  [27] =
    {field_body, 2},
    {field_name, 1},
  [29] =
    {field_condition, 1},
    {field_consequence, 2},
  [31] =
    {field_body, 2},
    {field_type, 1},
  [33] =
    {field_pattern, 1},
  [34] =
    {field_body, 2},
    {field_value, 1},
  [36] =
    {field_body, 2},
    {field_parameters, 1},
  [38] =
    {field_list, 1},
  [39] =
    {field_argument, 1},
  [40] =
    {field_body, 2},
    {field_condition, 1},
  [42] =
    {field_function, 0},
    {field_type_arguments, 2},
  [44] =
    {field_type, 0},
    {field_type_arguments, 2},
  [46] =
    {field_body, 2},
  [47] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [50] =
    {field_left, 0},
    {field_right, 2},
  [52] =
    {field_field, 2},
    {field_value, 0},
  [54] =
    {field_type, 2},
    {field_value, 0},
  [56] =
    {field_type, 0},
  [57] =
    {field_name, 0},
  [58] =
    {field_pattern, 0},
    {field_type, 2},
  [60] =
    {field_element, 1},
  [61] =
    {field_type, 2},
  [62] =
    {field_parameters, 2},
  [63] =
    {field_alias, 2},
    {field_type, 0},
  [65] =
    {field_parameters, 2},
    {field_trait, 1},
  [67] =
    {field_arguments, 1},
  [68] =
    {field_body, 3},
    {field_name, 1},
  [70] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [73] =
    {field_name, 1},
    {field_parameters, 2},
  [75] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [78] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [81] =
    {field_bounds, 1},
    {field_left, 0},
  [83] =
    {field_type, 2},
    {field_type_parameters, 1},
  [85] =
    {field_body, 3},
    {field_type, 2},
    {field_type_parameters, 1},
  [88] =
    {field_body, 3},
    {field_type, 1},
  [90] =
    {field_pattern, 2},
  [91] =
    {field_body, 3},
    {field_parameters, 2},
  [93] =
    {field_name, 1},
    {field_type_parameters, 2},
  [95] =
    {field_body, 3},
    {field_bounds, 2},
    {field_name, 1},
  [98] =
    {field_bounds, 2},
    {field_name, 1},
  [100] =
    {field_body, 3},
    {field_type, 2},
  [102] =
    {field_body, 3},
    {field_name, 2},
  [104] =
    {field_list, 2},
    {field_path, 0},
  [106] =
    {field_alias, 2},
    {field_path, 0},
  [108] =
    {field_name, 2},
  [109] =
    {field_argument, 2},
  [110] =
    {field_body, 3},
    {field_parameters, 0},
    {field_return_type, 2},
  [113] =
    {field_body, 3},
  [114] =
    {field_length, 3},
  [115] =
    {field_pattern, 1},
    {field_type, 3},
  [117] =
    {field_type, 3},
  [118] =
    {field_parameters, 1},
    {field_return_type, 3},
  [120] =
    {field_trait, 3},
  [121] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_trait, 0},
  [124] =
    {field_parameters, 3},
  [125] =
    {field_name, 1},
    {field_type, 3},
  [127] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [130] =
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [133] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [137] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [140] =
    {field_body, 4},
    {field_pattern, 1},
    {field_value, 3},
  [143] =
    {field_pattern, 1},
    {field_value, 3},
  [145] =
    {field_default_type, 2},
    {field_name, 0},
  [147] =
    {field_trait, 1},
    {field_type, 3},
  [149] =
    {field_body, 4},
    {field_trait, 1},
    {field_type, 3},
  [152] =
    {field_body, 4},
    {field_type, 2},
    {field_type_parameters, 1},
  [155] =
    {field_alternative, 3},
    {field_pattern, 1},
  [157] =
    {field_body, 4},
    {field_parameters, 1},
    {field_return_type, 3},
  [160] =
    {field_body, 4},
    {field_bounds, 2},
    {field_name, 1},
  [163] =
    {field_body, 4},
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [167] =
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [170] =
    {field_type, 3},
    {field_type_parameters, 2},
  [172] =
    {field_body, 4},
    {field_type, 3},
    {field_type_parameters, 2},
  [175] =
    {field_body, 4},
    {field_type, 2},
  [177] =
    {field_body, 4},
    {field_name, 2},
  [179] =
    {field_body, 4},
    {field_bounds, 3},
    {field_name, 2},
  [182] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [185] =
    {field_field, 0},
    {field_value, 2},
  [187] =
    {field_name, 2},
    {field_parameters, 3},
  [189] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [192] =
    {field_name, 2},
    {field_type_parameters, 3},
  [194] =
    {field_body, 4},
    {field_name, 3},
  [196] =
    {field_name, 3},
  [197] =
    {field_body, 4},
    {field_condition, 3},
  [199] =
    {field_length, 4},
  [200] =
    {field_name, 0},
    {field_type, 2},
  [202] =
    {field_name, 0},
    {field_pattern, 2},
  [204] =
    {field_element, 1},
    {field_length, 3},
  [206] =
    {field_pattern, 0},
  [207] =
    {field_parameters, 2},
    {field_return_type, 4},
  [209] =
    {field_parameters, 2},
    {field_return_type, 4},
    {field_trait, 1},
  [212] =
    {field_name, 0},
    {field_value, 2},
  [214] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [218] =
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [221] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [225] =
    {field_trait, 2},
    {field_type, 4},
  [227] =
    {field_body, 5},
    {field_trait, 2},
    {field_type, 4},
  [230] =
    {field_body, 5},
    {field_trait, 1},
    {field_type, 3},
  [233] =
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [236] =
    {field_body, 5},
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [240] =
    {field_pattern, 2},
    {field_type, 4},
  [242] =
    {field_pattern, 2},
    {field_value, 4},
  [244] =
    {field_alternative, 4},
    {field_pattern, 2},
  [246] =
    {field_pattern, 0},
    {field_value, 2},
  [248] =
    {field_condition, 2},
  [249] =
    {field_name, 2},
    {field_type, 4},
  [251] =
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4},
  [254] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [256] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [258] =
    {field_body, 5},
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [262] =
    {field_name, 1},
    {field_type, 4},
    {field_type_parameters, 2},
  [265] =
    {field_body, 5},
    {field_type, 3},
    {field_type_parameters, 2},
  [268] =
    {field_body, 5},
    {field_bounds, 3},
    {field_name, 2},
  [271] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [274] =
    {field_body, 5},
    {field_bounds, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [278] =
    {field_alias, 4},
    {field_name, 2},
  [280] =
    {field_field, 1},
    {field_value, 3},
  [282] =
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [285] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [289] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [292] =
    {field_body, 5},
    {field_name, 3},
  [294] =
    {field_body, 5},
    {field_bounds, 4},
    {field_name, 3},
  [297] =
    {field_body, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [300] =
    {field_name, 3},
    {field_parameters, 4},
  [302] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4},
  [305] =
    {field_name, 0},
    {field_type, 3},
    {field_type_arguments, 1},
  [308] =
    {field_name, 1},
    {field_pattern, 3},
  [310] =
    {field_parameters, 3},
    {field_return_type, 5},
  [312] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 5},
  [315] =
    {field_body, 1},
    {field_name, 0},
    {field_value, 3},
  [318] =
    {field_name, 1},
    {field_value, 3},
  [320] =
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [324] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [329] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [333] =
    {field_body, 6},
    {field_trait, 2},
    {field_type, 4},
  [336] =
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 1},
  [339] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 1},
  [343] =
    {field_body, 6},
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [347] =
    {field_pattern, 1},
    {field_type, 3},
    {field_value, 5},
  [350] =
    {field_alternative, 5},
    {field_pattern, 1},
    {field_type, 3},
  [353] =
    {field_alternative, 5},
    {field_pattern, 1},
    {field_value, 3},
  [356] =
    {field_name, 3},
    {field_type, 5},
  [358] =
    {field_type, 2},
    {field_type, 3, .inherited = true},
  [360] =
    {field_trait, 3},
    {field_type, 5},
  [362] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
  [365] =
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [368] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [372] =
    {field_body, 6},
    {field_bounds, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [376] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [380] =
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [383] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [387] =
    {field_name, 2},
    {field_type, 5},
    {field_type_parameters, 3},
  [390] =
    {field_body, 6},
    {field_bounds, 4},
    {field_name, 3},
  [393] =
    {field_body, 6},
    {field_name, 3},
    {field_type_parameters, 4},
  [396] =
    {field_body, 6},
    {field_bounds, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [400] =
    {field_alias, 5},
    {field_name, 3},
  [402] =
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [405] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [409] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 4},
  [412] =
    {field_body, 6},
    {field_pattern, 3},
    {field_value, 5},
  [415] =
    {field_name, 2},
    {field_pattern, 4},
  [417] =
    {field_body, 2},
    {field_name, 1},
    {field_value, 4},
  [420] =
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [425] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 1},
  [429] =
    {field_pattern, 2},
    {field_type, 4},
    {field_value, 6},
  [432] =
    {field_alternative, 6},
    {field_pattern, 2},
    {field_type, 4},
  [435] =
    {field_alternative, 6},
    {field_pattern, 2},
    {field_value, 4},
  [438] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 6},
  [441] =
    {field_type, 3},
    {field_type, 4, .inherited = true},
  [443] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
  [446] =
    {field_trait, 4},
    {field_type, 6},
    {field_type_parameters, 2},
  [449] =
    {field_body, 7},
    {field_trait, 4},
    {field_type, 6},
    {field_type_parameters, 2},
  [453] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [457] =
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [461] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [466] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [470] =
    {field_name, 4},
    {field_type, 6},
  [472] =
    {field_body, 7},
    {field_bounds, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [476] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [480] =
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [483] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [487] =
    {field_alternative, 7},
    {field_pattern, 1},
    {field_type, 3},
    {field_value, 5},
  [491] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 7},
  [494] =
    {field_body, 8},
    {field_trait, 4},
    {field_type, 6},
    {field_type_parameters, 2},
  [498] =
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [503] =
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
  [507] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
  [512] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [516] =
    {field_alternative, 8},
    {field_pattern, 2},
    {field_type, 4},
    {field_value, 6},
  [520] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 8},
  [523] =
    {field_body, 9},
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [5] = {
    [0] = alias_sym_type_identifier,
  },
  [7] = {
    [1] = alias_sym_type_identifier,
  },
  [9] = {
    [0] = alias_sym_let_chain,
  },
  [10] = {
    [0] = alias_sym_type_identifier,
  },
  [16] = {
    [0] = sym_identifier,
  },
  [17] = {
    [0] = sym_identifier,
    [2] = alias_sym_type_identifier,
  },
  [19] = {
    [0] = sym_identifier,
  },
  [20] = {
    [0] = alias_sym_type_identifier,
  },
  [24] = {
    [1] = alias_sym_type_identifier,
  },
  [26] = {
    [0] = alias_sym_type_identifier,
  },
  [28] = {
    [0] = sym_identifier,
  },
  [29] = {
    [1] = alias_sym_type_identifier,
  },
  [41] = {
    [2] = alias_sym_type_identifier,
  },
  [43] = {
    [0] = alias_sym_type_identifier,
  },
  [45] = {
    [0] = sym_generic_type,
  },
  [46] = {
    [0] = sym_generic_type,
    [2] = alias_sym_type_identifier,
  },
  [50] = {
    [2] = alias_sym_field_identifier,
  },
  [53] = {
    [2] = sym__line_doc_content,
  },
  [54] = {
    [1] = sym_identifier,
  },
  [55] = {
    [0] = sym_identifier,
    [2] = sym_identifier,
  },
  [57] = {
    [0] = alias_sym_type_identifier,
  },
  [58] = {
    [0] = alias_sym_shorthand_field_identifier,
  },
  [59] = {
    [2] = sym_identifier,
  },
  [61] = {
    [0] = sym_generic_type,
  },
  [66] = {
    [1] = alias_sym_type_identifier,
  },
  [68] = {
    [0] = sym_identifier,
  },
  [71] = {
    [1] = alias_sym_type_identifier,
  },
  [72] = {
    [1] = alias_sym_type_identifier,
  },
  [76] = {
    [1] = alias_sym_type_identifier,
  },
  [77] = {
    [0] = alias_sym_type_identifier,
  },
  [84] = {
    [1] = alias_sym_type_identifier,
  },
  [85] = {
    [1] = alias_sym_type_identifier,
  },
  [86] = {
    [1] = alias_sym_type_identifier,
  },
  [88] = {
    [2] = alias_sym_type_identifier,
  },
  [89] = {
    [0] = sym_identifier,
  },
  [90] = {
    [0] = sym_identifier,
  },
  [95] = {
    [2] = alias_sym_type_identifier,
  },
  [101] = {
    [1] = alias_sym_shorthand_field_identifier,
  },
  [104] = {
    [3] = alias_sym_type_identifier,
  },
  [106] = {
    [0] = alias_sym_type_identifier,
  },
  [109] = {
    [0] = sym_identifier,
  },
  [111] = {
    [1] = alias_sym_type_identifier,
  },
  [117] = {
    [0] = alias_sym_type_identifier,
  },
  [119] = {
    [2] = alias_sym_type_identifier,
  },
  [120] = {
    [1] = alias_sym_type_identifier,
  },
  [121] = {
    [1] = alias_sym_type_identifier,
  },
  [126] = {
    [3] = sym_identifier,
  },
  [128] = {
    [1] = alias_sym_type_identifier,
  },
  [129] = {
    [1] = alias_sym_type_identifier,
  },
  [130] = {
    [1] = alias_sym_type_identifier,
  },
  [131] = {
    [1] = alias_sym_type_identifier,
  },
  [135] = {
    [2] = alias_sym_type_identifier,
  },
  [136] = {
    [2] = alias_sym_type_identifier,
  },
  [137] = {
    [2] = alias_sym_type_identifier,
  },
  [139] = {
    [0] = alias_sym_field_identifier,
  },
  [142] = {
    [2] = alias_sym_type_identifier,
  },
  [143] = {
    [3] = alias_sym_type_identifier,
  },
  [147] = {
    [0] = alias_sym_type_identifier,
  },
  [148] = {
    [2] = alias_sym_shorthand_field_identifier,
  },
  [149] = {
    [0] = alias_sym_field_identifier,
  },
  [153] = {
    [1] = alias_sym_type_identifier,
  },
  [159] = {
    [2] = alias_sym_type_identifier,
  },
  [160] = {
    [2] = alias_sym_type_identifier,
  },
  [163] = {
    [1] = alias_sym_type_identifier,
  },
  [164] = {
    [2] = alias_sym_type_identifier,
  },
  [165] = {
    [2] = alias_sym_type_identifier,
  },
  [178] = {
    [0] = alias_sym_field_identifier,
  },
  [179] = {
    [1] = alias_sym_type_identifier,
  },
  [180] = {
    [1] = alias_sym_type_identifier,
  },
  [182] = {
    [2] = alias_sym_type_identifier,
  },
  [183] = {
    [2] = alias_sym_type_identifier,
  },
  [184] = {
    [2] = alias_sym_type_identifier,
  },
  [187] = {
    [1] = alias_sym_field_identifier,
  },
  [191] = {
    [2] = alias_sym_type_identifier,
  },
  [192] = {
    [3] = alias_sym_type_identifier,
  },
  [193] = {
    [3] = alias_sym_type_identifier,
  },
  [194] = {
    [3] = alias_sym_type_identifier,
  },
  [198] = {
    [0] = alias_sym_type_identifier,
  },
  [199] = {
    [1] = alias_sym_field_identifier,
  },
  [207] = {
    [2] = alias_sym_type_identifier,
  },
  [209] = {
    [3] = alias_sym_type_identifier,
  },
  [210] = {
    [3] = alias_sym_type_identifier,
  },
  [213] = {
    [2] = alias_sym_type_identifier,
  },
  [220] = {
    [1] = alias_sym_field_identifier,
  },
  [221] = {
    [3] = alias_sym_type_identifier,
  },
  [222] = {
    [3] = alias_sym_type_identifier,
  },
  [225] = {
    [3] = alias_sym_type_identifier,
  },
  [226] = {
    [3] = alias_sym_type_identifier,
  },
  [229] = {
    [2] = alias_sym_type_identifier,
  },
  [233] = {
    [2] = alias_sym_type_identifier,
  },
  [234] = {
    [3] = alias_sym_type_identifier,
  },
  [235] = {
    [3] = alias_sym_type_identifier,
  },
  [236] = {
    [3] = alias_sym_type_identifier,
  },
  [242] = {
    [2] = alias_sym_field_identifier,
  },
  [245] = {
    [3] = alias_sym_type_identifier,
  },
  [252] = {
    [3] = alias_sym_type_identifier,
  },
  [254] = {
    [4] = alias_sym_type_identifier,
  },
  [255] = {
    [4] = alias_sym_type_identifier,
  },
  [258] = {
    [3] = alias_sym_type_identifier,
  },
  [264] = {
    [3] = alias_sym_type_identifier,
  },
  [270] = {
    [4] = alias_sym_type_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_generic_type_with_turbofish, 2,
    sym_generic_type_with_turbofish,
    sym_generic_type,
  sym__let_chain, 2,
    sym__let_chain,
    alias_sym_let_chain,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 2,
  [7] = 3,
  [8] = 3,
  [9] = 4,
  [10] = 2,
  [11] = 4,
  [12] = 12,
  [13] = 3,
  [14] = 2,
  [15] = 12,
  [16] = 2,
  [17] = 12,
  [18] = 12,
  [19] = 19,
  [20] = 20,
  [21] = 4,
  [22] = 2,
  [23] = 23,
  [24] = 20,
  [25] = 4,
  [26] = 4,
  [27] = 3,
  [28] = 12,
  [29] = 2,
  [30] = 3,
  [31] = 3,
  [32] = 12,
  [33] = 4,
  [34] = 12,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 37,
  [40] = 40,
  [41] = 38,
  [42] = 42,
  [43] = 35,
  [44] = 40,
  [45] = 38,
  [46] = 37,
  [47] = 38,
  [48] = 35,
  [49] = 37,
  [50] = 36,
  [51] = 42,
  [52] = 35,
  [53] = 42,
  [54] = 40,
  [55] = 36,
  [56] = 40,
  [57] = 37,
  [58] = 37,
  [59] = 38,
  [60] = 37,
  [61] = 38,
  [62] = 38,
  [63] = 38,
  [64] = 37,
  [65] = 36,
  [66] = 42,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 72,
  [76] = 71,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 70,
  [81] = 74,
  [82] = 69,
  [83] = 78,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 86,
  [91] = 91,
  [92] = 85,
  [93] = 93,
  [94] = 89,
  [95] = 88,
  [96] = 91,
  [97] = 85,
  [98] = 98,
  [99] = 91,
  [100] = 100,
  [101] = 86,
  [102] = 88,
  [103] = 88,
  [104] = 85,
  [105] = 105,
  [106] = 105,
  [107] = 85,
  [108] = 100,
  [109] = 109,
  [110] = 110,
  [111] = 105,
  [112] = 112,
  [113] = 84,
  [114] = 98,
  [115] = 86,
  [116] = 91,
  [117] = 93,
  [118] = 88,
  [119] = 86,
  [120] = 112,
  [121] = 91,
  [122] = 100,
  [123] = 85,
  [124] = 86,
  [125] = 100,
  [126] = 105,
  [127] = 87,
  [128] = 105,
  [129] = 88,
  [130] = 100,
  [131] = 100,
  [132] = 105,
  [133] = 91,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 137,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 140,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 136,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 160,
  [166] = 138,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 170,
  [172] = 169,
  [173] = 173,
  [174] = 157,
  [175] = 145,
  [176] = 176,
  [177] = 177,
  [178] = 176,
  [179] = 177,
  [180] = 180,
  [181] = 170,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 150,
  [188] = 188,
  [189] = 188,
  [190] = 190,
  [191] = 182,
  [192] = 192,
  [193] = 147,
  [194] = 173,
  [195] = 182,
  [196] = 196,
  [197] = 197,
  [198] = 196,
  [199] = 164,
  [200] = 170,
  [201] = 155,
  [202] = 176,
  [203] = 184,
  [204] = 204,
  [205] = 182,
  [206] = 190,
  [207] = 186,
  [208] = 176,
  [209] = 209,
  [210] = 210,
  [211] = 210,
  [212] = 212,
  [213] = 209,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 216,
  [219] = 219,
  [220] = 216,
  [221] = 219,
  [222] = 216,
  [223] = 223,
  [224] = 224,
  [225] = 217,
  [226] = 223,
  [227] = 227,
  [228] = 227,
  [229] = 224,
  [230] = 230,
  [231] = 219,
  [232] = 219,
  [233] = 233,
  [234] = 224,
  [235] = 235,
  [236] = 233,
  [237] = 230,
  [238] = 219,
  [239] = 216,
  [240] = 224,
  [241] = 224,
  [242] = 215,
  [243] = 243,
  [244] = 243,
  [245] = 245,
  [246] = 243,
  [247] = 243,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 259,
  [271] = 271,
  [272] = 272,
  [273] = 260,
  [274] = 274,
  [275] = 275,
  [276] = 253,
  [277] = 277,
  [278] = 278,
  [279] = 253,
  [280] = 275,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 286,
  [289] = 261,
  [290] = 262,
  [291] = 291,
  [292] = 264,
  [293] = 265,
  [294] = 294,
  [295] = 255,
  [296] = 266,
  [297] = 297,
  [298] = 267,
  [299] = 275,
  [300] = 284,
  [301] = 257,
  [302] = 302,
  [303] = 248,
  [304] = 268,
  [305] = 305,
  [306] = 282,
  [307] = 285,
  [308] = 308,
  [309] = 268,
  [310] = 310,
  [311] = 261,
  [312] = 269,
  [313] = 313,
  [314] = 271,
  [315] = 253,
  [316] = 285,
  [317] = 272,
  [318] = 262,
  [319] = 308,
  [320] = 275,
  [321] = 264,
  [322] = 255,
  [323] = 323,
  [324] = 257,
  [325] = 275,
  [326] = 326,
  [327] = 277,
  [328] = 278,
  [329] = 297,
  [330] = 265,
  [331] = 266,
  [332] = 294,
  [333] = 310,
  [334] = 310,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 267,
  [340] = 310,
  [341] = 287,
  [342] = 305,
  [343] = 261,
  [344] = 275,
  [345] = 345,
  [346] = 275,
  [347] = 262,
  [348] = 264,
  [349] = 265,
  [350] = 257,
  [351] = 266,
  [352] = 267,
  [353] = 353,
  [354] = 268,
  [355] = 345,
  [356] = 283,
  [357] = 269,
  [358] = 259,
  [359] = 271,
  [360] = 360,
  [361] = 258,
  [362] = 272,
  [363] = 255,
  [364] = 275,
  [365] = 272,
  [366] = 271,
  [367] = 259,
  [368] = 269,
  [369] = 285,
  [370] = 282,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 185,
  [380] = 380,
  [381] = 381,
  [382] = 375,
  [383] = 372,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 180,
  [388] = 375,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 372,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 392,
  [402] = 402,
  [403] = 400,
  [404] = 404,
  [405] = 402,
  [406] = 404,
  [407] = 404,
  [408] = 400,
  [409] = 402,
  [410] = 410,
  [411] = 411,
  [412] = 411,
  [413] = 411,
  [414] = 414,
  [415] = 415,
  [416] = 415,
  [417] = 415,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 419,
  [422] = 422,
  [423] = 422,
  [424] = 424,
  [425] = 419,
  [426] = 420,
  [427] = 420,
  [428] = 424,
  [429] = 429,
  [430] = 429,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 433,
  [436] = 433,
  [437] = 434,
  [438] = 438,
  [439] = 434,
  [440] = 438,
  [441] = 438,
  [442] = 442,
  [443] = 443,
  [444] = 443,
  [445] = 443,
  [446] = 245,
  [447] = 249,
  [448] = 326,
  [449] = 353,
  [450] = 335,
  [451] = 360,
  [452] = 389,
  [453] = 453,
  [454] = 398,
  [455] = 385,
  [456] = 456,
  [457] = 371,
  [458] = 376,
  [459] = 397,
  [460] = 377,
  [461] = 386,
  [462] = 381,
  [463] = 463,
  [464] = 393,
  [465] = 391,
  [466] = 453,
  [467] = 373,
  [468] = 453,
  [469] = 399,
  [470] = 380,
  [471] = 394,
  [472] = 395,
  [473] = 453,
  [474] = 378,
  [475] = 475,
  [476] = 475,
  [477] = 475,
  [478] = 475,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 353,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 360,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 531,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 335,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 249,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 668,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 326,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 754,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 756,
  [761] = 758,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 772,
  [776] = 773,
  [777] = 777,
  [778] = 777,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 781,
  [787] = 787,
  [788] = 784,
  [789] = 785,
  [790] = 790,
  [791] = 787,
  [792] = 790,
  [793] = 793,
  [794] = 794,
  [795] = 780,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 800,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 801,
  [812] = 812,
  [813] = 801,
  [814] = 812,
  [815] = 800,
  [816] = 816,
  [817] = 796,
  [818] = 797,
  [819] = 808,
  [820] = 806,
  [821] = 801,
  [822] = 798,
  [823] = 823,
  [824] = 800,
  [825] = 803,
  [826] = 816,
  [827] = 802,
  [828] = 805,
  [829] = 829,
  [830] = 830,
  [831] = 829,
  [832] = 829,
  [833] = 829,
  [834] = 834,
  [835] = 835,
  [836] = 835,
  [837] = 837,
  [838] = 838,
  [839] = 839,
  [840] = 838,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 839,
  [847] = 835,
  [848] = 843,
  [849] = 843,
  [850] = 850,
  [851] = 851,
  [852] = 842,
  [853] = 843,
  [854] = 854,
  [855] = 834,
  [856] = 839,
  [857] = 842,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 872,
  [873] = 873,
  [874] = 874,
  [875] = 875,
  [876] = 876,
  [877] = 877,
  [878] = 878,
  [879] = 879,
  [880] = 877,
  [881] = 867,
  [882] = 882,
  [883] = 883,
  [884] = 862,
  [885] = 873,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 886,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 872,
  [901] = 901,
  [902] = 866,
  [903] = 889,
  [904] = 904,
  [905] = 879,
  [906] = 906,
  [907] = 883,
  [908] = 888,
  [909] = 874,
  [910] = 910,
  [911] = 865,
  [912] = 859,
  [913] = 906,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 866,
  [918] = 918,
  [919] = 919,
  [920] = 920,
  [921] = 871,
  [922] = 922,
  [923] = 923,
  [924] = 878,
  [925] = 925,
  [926] = 926,
  [927] = 886,
  [928] = 928,
  [929] = 915,
  [930] = 930,
  [931] = 920,
  [932] = 932,
  [933] = 928,
  [934] = 934,
  [935] = 935,
  [936] = 932,
  [937] = 915,
  [938] = 938,
  [939] = 876,
  [940] = 904,
  [941] = 923,
  [942] = 875,
  [943] = 943,
  [944] = 944,
  [945] = 890,
  [946] = 860,
  [947] = 947,
  [948] = 948,
  [949] = 910,
  [950] = 894,
  [951] = 916,
  [952] = 952,
  [953] = 868,
  [954] = 893,
  [955] = 952,
  [956] = 898,
  [957] = 918,
  [958] = 859,
  [959] = 863,
  [960] = 960,
  [961] = 896,
  [962] = 962,
  [963] = 899,
  [964] = 898,
  [965] = 965,
  [966] = 897,
  [967] = 896,
  [968] = 968,
  [969] = 706,
  [970] = 869,
  [971] = 882,
  [972] = 919,
  [973] = 875,
  [974] = 887,
  [975] = 915,
  [976] = 976,
  [977] = 920,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 859,
  [982] = 901,
  [983] = 930,
  [984] = 920,
  [985] = 858,
  [986] = 864,
  [987] = 947,
  [988] = 899,
  [989] = 892,
  [990] = 948,
  [991] = 882,
  [992] = 926,
  [993] = 895,
  [994] = 925,
  [995] = 898,
  [996] = 923,
  [997] = 893,
  [998] = 894,
  [999] = 904,
  [1000] = 922,
  [1001] = 897,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 706,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 326,
  [1016] = 335,
  [1017] = 1017,
  [1018] = 1018,
  [1019] = 360,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 180,
  [1023] = 1023,
  [1024] = 374,
  [1025] = 185,
  [1026] = 1026,
  [1027] = 249,
  [1028] = 1028,
  [1029] = 353,
  [1030] = 1030,
  [1031] = 390,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 569,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 497,
  [1039] = 620,
  [1040] = 619,
  [1041] = 1041,
  [1042] = 1042,
  [1043] = 626,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 1048,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 245,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1008,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 1002,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 429,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1080,
  [1081] = 1071,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1080,
  [1089] = 1071,
  [1090] = 1080,
  [1091] = 722,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 537,
  [1095] = 623,
  [1096] = 490,
  [1097] = 386,
  [1098] = 335,
  [1099] = 675,
  [1100] = 685,
  [1101] = 687,
  [1102] = 753,
  [1103] = 744,
  [1104] = 742,
  [1105] = 741,
  [1106] = 1106,
  [1107] = 735,
  [1108] = 730,
  [1109] = 729,
  [1110] = 725,
  [1111] = 723,
  [1112] = 718,
  [1113] = 701,
  [1114] = 684,
  [1115] = 683,
  [1116] = 682,
  [1117] = 676,
  [1118] = 664,
  [1119] = 658,
  [1120] = 656,
  [1121] = 647,
  [1122] = 646,
  [1123] = 644,
  [1124] = 479,
  [1125] = 617,
  [1126] = 1126,
  [1127] = 611,
  [1128] = 1128,
  [1129] = 602,
  [1130] = 594,
  [1131] = 1131,
  [1132] = 589,
  [1133] = 564,
  [1134] = 572,
  [1135] = 632,
  [1136] = 1136,
  [1137] = 394,
  [1138] = 1138,
  [1139] = 551,
  [1140] = 545,
  [1141] = 533,
  [1142] = 521,
  [1143] = 519,
  [1144] = 1144,
  [1145] = 515,
  [1146] = 509,
  [1147] = 496,
  [1148] = 495,
  [1149] = 1149,
  [1150] = 484,
  [1151] = 376,
  [1152] = 378,
  [1153] = 748,
  [1154] = 752,
  [1155] = 528,
  [1156] = 499,
  [1157] = 489,
  [1158] = 512,
  [1159] = 624,
  [1160] = 180,
  [1161] = 747,
  [1162] = 483,
  [1163] = 485,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 724,
  [1177] = 721,
  [1178] = 486,
  [1179] = 704,
  [1180] = 702,
  [1181] = 628,
  [1182] = 686,
  [1183] = 371,
  [1184] = 669,
  [1185] = 681,
  [1186] = 639,
  [1187] = 690,
  [1188] = 706,
  [1189] = 691,
  [1190] = 699,
  [1191] = 703,
  [1192] = 713,
  [1193] = 638,
  [1194] = 726,
  [1195] = 749,
  [1196] = 750,
  [1197] = 650,
  [1198] = 480,
  [1199] = 751,
  [1200] = 1200,
  [1201] = 649,
  [1202] = 643,
  [1203] = 641,
  [1204] = 627,
  [1205] = 625,
  [1206] = 607,
  [1207] = 593,
  [1208] = 566,
  [1209] = 728,
  [1210] = 565,
  [1211] = 540,
  [1212] = 539,
  [1213] = 536,
  [1214] = 164,
  [1215] = 507,
  [1216] = 395,
  [1217] = 570,
  [1218] = 575,
  [1219] = 579,
  [1220] = 1220,
  [1221] = 601,
  [1222] = 606,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 698,
  [1226] = 697,
  [1227] = 393,
  [1228] = 738,
  [1229] = 506,
  [1230] = 743,
  [1231] = 740,
  [1232] = 737,
  [1233] = 736,
  [1234] = 719,
  [1235] = 185,
  [1236] = 696,
  [1237] = 1237,
  [1238] = 693,
  [1239] = 598,
  [1240] = 488,
  [1241] = 692,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 155,
  [1247] = 678,
  [1248] = 677,
  [1249] = 1249,
  [1250] = 674,
  [1251] = 733,
  [1252] = 1252,
  [1253] = 491,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 673,
  [1259] = 671,
  [1260] = 670,
  [1261] = 663,
  [1262] = 662,
  [1263] = 661,
  [1264] = 652,
  [1265] = 651,
  [1266] = 1266,
  [1267] = 380,
  [1268] = 542,
  [1269] = 616,
  [1270] = 1270,
  [1271] = 615,
  [1272] = 614,
  [1273] = 613,
  [1274] = 612,
  [1275] = 597,
  [1276] = 523,
  [1277] = 1277,
  [1278] = 596,
  [1279] = 326,
  [1280] = 588,
  [1281] = 1281,
  [1282] = 580,
  [1283] = 493,
  [1284] = 543,
  [1285] = 524,
  [1286] = 494,
  [1287] = 637,
  [1288] = 525,
  [1289] = 526,
  [1290] = 522,
  [1291] = 1291,
  [1292] = 374,
  [1293] = 381,
  [1294] = 498,
  [1295] = 503,
  [1296] = 487,
  [1297] = 482,
  [1298] = 603,
  [1299] = 583,
  [1300] = 734,
  [1301] = 517,
  [1302] = 513,
  [1303] = 389,
  [1304] = 520,
  [1305] = 511,
  [1306] = 510,
  [1307] = 1307,
  [1308] = 595,
  [1309] = 492,
  [1310] = 501,
  [1311] = 390,
  [1312] = 398,
  [1313] = 592,
  [1314] = 1314,
  [1315] = 502,
  [1316] = 1316,
  [1317] = 481,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 527,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 500,
  [1328] = 1009,
  [1329] = 591,
  [1330] = 590,
  [1331] = 534,
  [1332] = 584,
  [1333] = 582,
  [1334] = 608,
  [1335] = 504,
  [1336] = 610,
  [1337] = 1010,
  [1338] = 581,
  [1339] = 635,
  [1340] = 648,
  [1341] = 578,
  [1342] = 505,
  [1343] = 746,
  [1344] = 249,
  [1345] = 745,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 739,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 732,
  [1354] = 1354,
  [1355] = 727,
  [1356] = 720,
  [1357] = 1357,
  [1358] = 717,
  [1359] = 708,
  [1360] = 716,
  [1361] = 710,
  [1362] = 715,
  [1363] = 714,
  [1364] = 712,
  [1365] = 377,
  [1366] = 711,
  [1367] = 705,
  [1368] = 700,
  [1369] = 695,
  [1370] = 391,
  [1371] = 694,
  [1372] = 385,
  [1373] = 689,
  [1374] = 688,
  [1375] = 680,
  [1376] = 679,
  [1377] = 672,
  [1378] = 667,
  [1379] = 399,
  [1380] = 397,
  [1381] = 1381,
  [1382] = 666,
  [1383] = 1383,
  [1384] = 665,
  [1385] = 660,
  [1386] = 508,
  [1387] = 1387,
  [1388] = 659,
  [1389] = 1389,
  [1390] = 577,
  [1391] = 657,
  [1392] = 1392,
  [1393] = 567,
  [1394] = 563,
  [1395] = 532,
  [1396] = 654,
  [1397] = 562,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 653,
  [1401] = 561,
  [1402] = 560,
  [1403] = 559,
  [1404] = 353,
  [1405] = 642,
  [1406] = 516,
  [1407] = 514,
  [1408] = 518,
  [1409] = 1409,
  [1410] = 150,
  [1411] = 535,
  [1412] = 1412,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 636,
  [1417] = 1417,
  [1418] = 630,
  [1419] = 634,
  [1420] = 633,
  [1421] = 558,
  [1422] = 1422,
  [1423] = 538,
  [1424] = 631,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 622,
  [1428] = 618,
  [1429] = 604,
  [1430] = 557,
  [1431] = 541,
  [1432] = 600,
  [1433] = 1433,
  [1434] = 1434,
  [1435] = 544,
  [1436] = 145,
  [1437] = 1437,
  [1438] = 599,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 546,
  [1442] = 587,
  [1443] = 586,
  [1444] = 547,
  [1445] = 556,
  [1446] = 555,
  [1447] = 1447,
  [1448] = 553,
  [1449] = 1449,
  [1450] = 147,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 585,
  [1454] = 574,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 548,
  [1458] = 573,
  [1459] = 549,
  [1460] = 571,
  [1461] = 1461,
  [1462] = 360,
  [1463] = 530,
  [1464] = 373,
  [1465] = 529,
  [1466] = 568,
  [1467] = 552,
  [1468] = 550,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 706,
  [1472] = 1472,
  [1473] = 485,
  [1474] = 1474,
  [1475] = 1475,
  [1476] = 1476,
  [1477] = 1477,
  [1478] = 1478,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1003,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1491,
  [1492] = 1492,
  [1493] = 1493,
  [1494] = 1494,
  [1495] = 1495,
  [1496] = 1495,
  [1497] = 1497,
  [1498] = 1498,
  [1499] = 1499,
  [1500] = 1500,
  [1501] = 1037,
  [1502] = 1502,
  [1503] = 1503,
  [1504] = 1495,
  [1505] = 1011,
  [1506] = 1037,
  [1507] = 1013,
  [1508] = 1012,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1510,
  [1512] = 1014,
  [1513] = 1513,
  [1514] = 1513,
  [1515] = 1037,
  [1516] = 1075,
  [1517] = 1517,
  [1518] = 1028,
  [1519] = 1349,
  [1520] = 1520,
  [1521] = 1018,
  [1522] = 1085,
  [1523] = 1017,
  [1524] = 1023,
  [1525] = 1079,
  [1526] = 1526,
  [1527] = 1030,
  [1528] = 1528,
  [1529] = 1082,
  [1530] = 1026,
  [1531] = 1020,
  [1532] = 1021,
  [1533] = 1533,
  [1534] = 1461,
  [1535] = 1082,
  [1536] = 1085,
  [1537] = 1461,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1079,
  [1541] = 1075,
  [1542] = 1542,
  [1543] = 1083,
  [1544] = 1035,
  [1545] = 1545,
  [1546] = 1542,
  [1547] = 1414,
  [1548] = 1033,
  [1549] = 1437,
  [1550] = 1052,
  [1551] = 1049,
  [1552] = 1048,
  [1553] = 1553,
  [1554] = 1545,
  [1555] = 1542,
  [1556] = 1542,
  [1557] = 1349,
  [1558] = 1461,
  [1559] = 1048,
  [1560] = 1032,
  [1561] = 1561,
  [1562] = 1437,
  [1563] = 1553,
  [1564] = 1477,
  [1565] = 1561,
  [1566] = 1472,
  [1567] = 1561,
  [1568] = 1077,
  [1569] = 1561,
  [1570] = 1036,
  [1571] = 1414,
  [1572] = 245,
  [1573] = 1503,
  [1574] = 1574,
  [1575] = 1047,
  [1576] = 1051,
  [1577] = 353,
  [1578] = 249,
  [1579] = 1078,
  [1580] = 326,
  [1581] = 1050,
  [1582] = 335,
  [1583] = 1084,
  [1584] = 360,
  [1585] = 1057,
  [1586] = 1046,
  [1587] = 1482,
  [1588] = 1087,
  [1589] = 1086,
  [1590] = 1490,
  [1591] = 1489,
  [1592] = 1488,
  [1593] = 1593,
  [1594] = 1498,
  [1595] = 1487,
  [1596] = 1486,
  [1597] = 1485,
  [1598] = 1484,
  [1599] = 1493,
  [1600] = 1500,
  [1601] = 1072,
  [1602] = 1073,
  [1603] = 1603,
  [1604] = 1074,
  [1605] = 1499,
  [1606] = 1067,
  [1607] = 1066,
  [1608] = 1492,
  [1609] = 1494,
  [1610] = 1491,
  [1611] = 1068,
  [1612] = 1612,
  [1613] = 1502,
  [1614] = 1497,
  [1615] = 1064,
  [1616] = 1063,
  [1617] = 1483,
  [1618] = 1574,
  [1619] = 1060,
  [1620] = 1059,
  [1621] = 1061,
  [1622] = 1593,
  [1623] = 1623,
  [1624] = 1612,
  [1625] = 1054,
  [1626] = 1053,
  [1627] = 1056,
  [1628] = 1628,
  [1629] = 1628,
  [1630] = 1612,
  [1631] = 1472,
  [1632] = 1055,
  [1633] = 1477,
  [1634] = 1062,
  [1635] = 1070,
  [1636] = 371,
  [1637] = 1173,
  [1638] = 390,
  [1639] = 1498,
  [1640] = 1640,
  [1641] = 1243,
  [1642] = 1642,
  [1643] = 1643,
  [1644] = 1644,
  [1645] = 1452,
  [1646] = 1646,
  [1647] = 1647,
  [1648] = 1648,
  [1649] = 1642,
  [1650] = 1487,
  [1651] = 1651,
  [1652] = 1451,
  [1653] = 1643,
  [1654] = 1486,
  [1655] = 1485,
  [1656] = 1656,
  [1657] = 1499,
  [1658] = 1291,
  [1659] = 1323,
  [1660] = 398,
  [1661] = 1651,
  [1662] = 1244,
  [1663] = 1170,
  [1664] = 1484,
  [1665] = 1434,
  [1666] = 1666,
  [1667] = 389,
  [1668] = 1499,
  [1669] = 381,
  [1670] = 1483,
  [1671] = 150,
  [1672] = 374,
  [1673] = 1256,
  [1674] = 1648,
  [1675] = 1675,
  [1676] = 1493,
  [1677] = 1500,
  [1678] = 1500,
  [1679] = 1502,
  [1680] = 1257,
  [1681] = 1656,
  [1682] = 1642,
  [1683] = 1491,
  [1684] = 1644,
  [1685] = 1409,
  [1686] = 1643,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1689,
  [1690] = 1643,
  [1691] = 1642,
  [1692] = 1692,
  [1693] = 1493,
  [1694] = 1484,
  [1695] = 1307,
  [1696] = 1696,
  [1697] = 1200,
  [1698] = 1319,
  [1699] = 1485,
  [1700] = 1347,
  [1701] = 1164,
  [1702] = 1486,
  [1703] = 1350,
  [1704] = 1352,
  [1705] = 1167,
  [1706] = 1354,
  [1707] = 1499,
  [1708] = 1357,
  [1709] = 1175,
  [1710] = 1643,
  [1711] = 1646,
  [1712] = 1712,
  [1713] = 1713,
  [1714] = 1646,
  [1715] = 1487,
  [1716] = 1169,
  [1717] = 1717,
  [1718] = 185,
  [1719] = 1498,
  [1720] = 1646,
  [1721] = 1503,
  [1722] = 1488,
  [1723] = 1489,
  [1724] = 1642,
  [1725] = 180,
  [1726] = 1351,
  [1727] = 1494,
  [1728] = 1492,
  [1729] = 1126,
  [1730] = 1128,
  [1731] = 1131,
  [1732] = 1491,
  [1733] = 1733,
  [1734] = 1136,
  [1735] = 1413,
  [1736] = 1138,
  [1737] = 1494,
  [1738] = 1738,
  [1739] = 429,
  [1740] = 1502,
  [1741] = 1144,
  [1742] = 1255,
  [1743] = 1497,
  [1744] = 1644,
  [1745] = 1254,
  [1746] = 1455,
  [1747] = 1717,
  [1748] = 1392,
  [1749] = 1469,
  [1750] = 1470,
  [1751] = 393,
  [1752] = 395,
  [1753] = 1249,
  [1754] = 1656,
  [1755] = 1503,
  [1756] = 1642,
  [1757] = 1482,
  [1758] = 1644,
  [1759] = 1398,
  [1760] = 1760,
  [1761] = 1412,
  [1762] = 1762,
  [1763] = 1318,
  [1764] = 1490,
  [1765] = 1449,
  [1766] = 1488,
  [1767] = 1439,
  [1768] = 1106,
  [1769] = 1433,
  [1770] = 1174,
  [1771] = 1426,
  [1772] = 1322,
  [1773] = 1646,
  [1774] = 1643,
  [1775] = 1425,
  [1776] = 1172,
  [1777] = 1777,
  [1778] = 1778,
  [1779] = 1171,
  [1780] = 1166,
  [1781] = 378,
  [1782] = 1149,
  [1783] = 1399,
  [1784] = 394,
  [1785] = 386,
  [1786] = 1497,
  [1787] = 380,
  [1788] = 373,
  [1789] = 1778,
  [1790] = 1415,
  [1791] = 1237,
  [1792] = 397,
  [1793] = 1656,
  [1794] = 1794,
  [1795] = 1483,
  [1796] = 1242,
  [1797] = 1008,
  [1798] = 164,
  [1799] = 1492,
  [1800] = 155,
  [1801] = 399,
  [1802] = 385,
  [1803] = 1168,
  [1804] = 1503,
  [1805] = 1794,
  [1806] = 376,
  [1807] = 1760,
  [1808] = 147,
  [1809] = 1324,
  [1810] = 1422,
  [1811] = 1165,
  [1812] = 1483,
  [1813] = 145,
  [1814] = 1489,
  [1815] = 1644,
  [1816] = 1220,
  [1817] = 1325,
  [1818] = 1490,
  [1819] = 1093,
  [1820] = 1223,
  [1821] = 391,
  [1822] = 1644,
  [1823] = 1252,
  [1824] = 1646,
  [1825] = 1277,
  [1826] = 1688,
  [1827] = 1762,
  [1828] = 1389,
  [1829] = 1417,
  [1830] = 1644,
  [1831] = 1387,
  [1832] = 1224,
  [1833] = 1643,
  [1834] = 1646,
  [1835] = 1835,
  [1836] = 1447,
  [1837] = 1642,
  [1838] = 1440,
  [1839] = 377,
  [1840] = 1840,
  [1841] = 1482,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 1844,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1738,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1853,
  [1854] = 1852,
  [1855] = 1855,
  [1856] = 1849,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1687,
  [1860] = 1860,
  [1861] = 1851,
  [1862] = 1862,
  [1863] = 1846,
  [1864] = 1843,
  [1865] = 1855,
  [1866] = 1866,
  [1867] = 1867,
  [1868] = 1857,
  [1869] = 1860,
  [1870] = 1696,
  [1871] = 1862,
  [1872] = 1866,
  [1873] = 1866,
  [1874] = 1845,
  [1875] = 1875,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 1877,
  [1879] = 1876,
  [1880] = 1880,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1882,
  [1884] = 1884,
  [1885] = 1885,
  [1886] = 1885,
  [1887] = 1881,
  [1888] = 1884,
  [1889] = 1889,
  [1890] = 1890,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 1893,
  [1894] = 1893,
  [1895] = 1892,
  [1896] = 1892,
  [1897] = 1893,
  [1898] = 1892,
  [1899] = 1892,
  [1900] = 1900,
  [1901] = 1900,
  [1902] = 147,
  [1903] = 150,
  [1904] = 1011,
  [1905] = 1018,
  [1906] = 1014,
  [1907] = 1013,
  [1908] = 1023,
  [1909] = 1017,
  [1910] = 1910,
  [1911] = 1012,
  [1912] = 1028,
  [1913] = 1018,
  [1914] = 1020,
  [1915] = 1021,
  [1916] = 1026,
  [1917] = 1030,
  [1918] = 1017,
  [1919] = 1023,
  [1920] = 1028,
  [1921] = 1032,
  [1922] = 1035,
  [1923] = 1052,
  [1924] = 1049,
  [1925] = 1057,
  [1926] = 1077,
  [1927] = 1033,
  [1928] = 1083,
  [1929] = 1036,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1931,
  [1933] = 1068,
  [1934] = 1067,
  [1935] = 1066,
  [1936] = 1936,
  [1937] = 180,
  [1938] = 1936,
  [1939] = 1060,
  [1940] = 1940,
  [1941] = 1063,
  [1942] = 185,
  [1943] = 374,
  [1944] = 1061,
  [1945] = 1940,
  [1946] = 1056,
  [1947] = 1046,
  [1948] = 1059,
  [1949] = 1072,
  [1950] = 1520,
  [1951] = 1073,
  [1952] = 1051,
  [1953] = 1055,
  [1954] = 1054,
  [1955] = 1078,
  [1956] = 1047,
  [1957] = 1050,
  [1958] = 390,
  [1959] = 1053,
  [1960] = 1084,
  [1961] = 1940,
  [1962] = 1074,
  [1963] = 1064,
  [1964] = 1964,
  [1965] = 1165,
  [1966] = 1318,
  [1967] = 1168,
  [1968] = 1169,
  [1969] = 1969,
  [1970] = 1171,
  [1971] = 1323,
  [1972] = 1322,
  [1973] = 1254,
  [1974] = 1936,
  [1975] = 1093,
  [1976] = 1389,
  [1977] = 1538,
  [1978] = 1978,
  [1979] = 1166,
  [1980] = 1149,
  [1981] = 1244,
  [1982] = 1539,
  [1983] = 1172,
  [1984] = 1325,
  [1985] = 1170,
  [1986] = 1324,
  [1987] = 1175,
  [1988] = 1257,
  [1989] = 1174,
  [1990] = 1256,
  [1991] = 1167,
  [1992] = 1528,
  [1993] = 1409,
  [1994] = 1387,
  [1995] = 1255,
  [1996] = 1243,
  [1997] = 145,
  [1998] = 1998,
  [1999] = 1999,
  [2000] = 2000,
  [2001] = 155,
  [2002] = 1023,
  [2003] = 1018,
  [2004] = 1018,
  [2005] = 1018,
  [2006] = 1017,
  [2007] = 2007,
  [2008] = 2008,
  [2009] = 1023,
  [2010] = 1028,
  [2011] = 1017,
  [2012] = 1910,
  [2013] = 1023,
  [2014] = 1028,
  [2015] = 1028,
  [2016] = 1017,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 2019,
  [2020] = 2019,
  [2021] = 2021,
  [2022] = 2018,
  [2023] = 2021,
  [2024] = 2024,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 2027,
  [2028] = 2027,
  [2029] = 2029,
  [2030] = 2026,
  [2031] = 2024,
  [2032] = 2032,
  [2033] = 2025,
  [2034] = 2034,
  [2035] = 2035,
  [2036] = 1023,
  [2037] = 249,
  [2038] = 1028,
  [2039] = 2039,
  [2040] = 2040,
  [2041] = 2041,
  [2042] = 2042,
  [2043] = 353,
  [2044] = 2044,
  [2045] = 2045,
  [2046] = 2040,
  [2047] = 326,
  [2048] = 335,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 2052,
  [2053] = 2053,
  [2054] = 2035,
  [2055] = 2055,
  [2056] = 2056,
  [2057] = 1930,
  [2058] = 2042,
  [2059] = 2059,
  [2060] = 360,
  [2061] = 2039,
  [2062] = 2059,
  [2063] = 1018,
  [2064] = 2064,
  [2065] = 2065,
  [2066] = 2066,
  [2067] = 1017,
  [2068] = 2068,
  [2069] = 2041,
  [2070] = 2051,
  [2071] = 2071,
  [2072] = 2072,
  [2073] = 2052,
  [2074] = 2074,
  [2075] = 2064,
  [2076] = 2076,
  [2077] = 2077,
  [2078] = 2078,
  [2079] = 2079,
  [2080] = 2080,
  [2081] = 2081,
  [2082] = 2081,
  [2083] = 2083,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 2086,
  [2087] = 2087,
  [2088] = 2088,
  [2089] = 2089,
  [2090] = 2090,
  [2091] = 2091,
  [2092] = 2092,
  [2093] = 2078,
  [2094] = 2094,
  [2095] = 2095,
  [2096] = 2096,
  [2097] = 2097,
  [2098] = 2098,
  [2099] = 2099,
  [2100] = 2100,
  [2101] = 2101,
  [2102] = 2102,
  [2103] = 2103,
  [2104] = 2104,
  [2105] = 399,
  [2106] = 2106,
  [2107] = 2107,
  [2108] = 2108,
  [2109] = 2109,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2077,
  [2114] = 2114,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 2117,
  [2118] = 1930,
  [2119] = 2119,
  [2120] = 2120,
  [2121] = 2121,
  [2122] = 2106,
  [2123] = 2078,
  [2124] = 1930,
  [2125] = 2076,
  [2126] = 1964,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 2133,
  [2134] = 2134,
  [2135] = 2135,
  [2136] = 1964,
  [2137] = 1964,
  [2138] = 2138,
  [2139] = 2139,
  [2140] = 2140,
  [2141] = 2132,
  [2142] = 2139,
  [2143] = 2135,
  [2144] = 2144,
  [2145] = 2145,
  [2146] = 2129,
  [2147] = 2147,
  [2148] = 2130,
  [2149] = 2149,
  [2150] = 2129,
  [2151] = 2144,
  [2152] = 1930,
  [2153] = 2138,
  [2154] = 2147,
  [2155] = 2149,
  [2156] = 1033,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 2144,
  [2160] = 2145,
  [2161] = 2161,
  [2162] = 2162,
  [2163] = 2140,
  [2164] = 2161,
  [2165] = 1035,
  [2166] = 2166,
  [2167] = 1032,
  [2168] = 2168,
  [2169] = 2169,
  [2170] = 2170,
  [2171] = 1036,
  [2172] = 2157,
  [2173] = 2158,
  [2174] = 2170,
  [2175] = 2162,
  [2176] = 2176,
  [2177] = 2177,
  [2178] = 2178,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 2180,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 2178,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 2188,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2191,
  [2192] = 2192,
  [2193] = 2177,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2179,
  [2198] = 2189,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 1964,
  [2202] = 2202,
  [2203] = 2203,
  [2204] = 2204,
  [2205] = 2182,
  [2206] = 2199,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2196,
  [2210] = 2176,
  [2211] = 2211,
  [2212] = 2207,
  [2213] = 2200,
  [2214] = 2214,
  [2215] = 2187,
  [2216] = 2192,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2211,
  [2221] = 2221,
  [2222] = 2202,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2191,
  [2227] = 2227,
  [2228] = 2184,
  [2229] = 2217,
  [2230] = 2195,
  [2231] = 2186,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2232,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2242,
  [2252] = 2252,
  [2253] = 2249,
  [2254] = 2254,
  [2255] = 2000,
  [2256] = 2256,
  [2257] = 2247,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2233,
  [2261] = 2261,
  [2262] = 2237,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2265,
  [2269] = 2261,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2263,
  [2274] = 2270,
  [2275] = 2264,
  [2276] = 2276,
  [2277] = 2236,
  [2278] = 2250,
  [2279] = 2243,
  [2280] = 2272,
  [2281] = 2267,
  [2282] = 2252,
  [2283] = 2254,
  [2284] = 2266,
  [2285] = 2242,
  [2286] = 2276,
  [2287] = 2238,
  [2288] = 2271,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2296,
  [2302] = 2302,
  [2303] = 2293,
  [2304] = 2291,
  [2305] = 2305,
  [2306] = 2294,
  [2307] = 2295,
  [2308] = 2308,
  [2309] = 2017,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2310,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2297,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2308,
  [2321] = 2316,
  [2322] = 2322,
  [2323] = 2315,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2298,
  [2333] = 2333,
  [2334] = 2299,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2331,
  [2339] = 2319,
  [2340] = 2331,
  [2341] = 2325,
  [2342] = 2342,
  [2343] = 2289,
  [2344] = 2302,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2324,
  [2348] = 2337,
  [2349] = 2349,
  [2350] = 155,
  [2351] = 2351,
  [2352] = 2311,
  [2353] = 2305,
  [2354] = 2342,
  [2355] = 2318,
  [2356] = 2356,
  [2357] = 147,
  [2358] = 2308,
  [2359] = 2008,
  [2360] = 2322,
  [2361] = 2316,
  [2362] = 2007,
  [2363] = 2300,
  [2364] = 145,
  [2365] = 2292,
  [2366] = 2315,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 2349,
  [2370] = 2346,
  [2371] = 150,
  [2372] = 2372,
  [2373] = 2336,
  [2374] = 2372,
  [2375] = 2375,
  [2376] = 2376,
  [2377] = 2290,
  [2378] = 2375,
  [2379] = 2329,
  [2380] = 2342,
  [2381] = 2342,
  [2382] = 2356,
  [2383] = 2328,
  [2384] = 2327,
  [2385] = 2333,
  [2386] = 2376,
  [2387] = 2326,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 2390,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2394,
  [2395] = 2395,
  [2396] = 2396,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2400,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 2390,
  [2405] = 2405,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2407,
  [2417] = 2417,
  [2418] = 2418,
  [2419] = 2419,
  [2420] = 2420,
  [2421] = 2393,
  [2422] = 2422,
  [2423] = 2393,
  [2424] = 2424,
  [2425] = 2422,
  [2426] = 2401,
  [2427] = 2427,
  [2428] = 2428,
  [2429] = 2429,
  [2430] = 2400,
  [2431] = 2406,
  [2432] = 2412,
  [2433] = 2417,
  [2434] = 2434,
  [2435] = 2396,
  [2436] = 2417,
  [2437] = 2401,
  [2438] = 2438,
  [2439] = 2439,
  [2440] = 2440,
  [2441] = 2441,
  [2442] = 2442,
  [2443] = 2441,
  [2444] = 2389,
  [2445] = 2428,
  [2446] = 2446,
  [2447] = 2447,
  [2448] = 1092,
  [2449] = 2449,
  [2450] = 1316,
  [2451] = 2429,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 2454,
  [2455] = 1314,
  [2456] = 2417,
  [2457] = 2457,
  [2458] = 2458,
  [2459] = 2459,
  [2460] = 2391,
  [2461] = 2461,
  [2462] = 1381,
  [2463] = 2415,
  [2464] = 1346,
  [2465] = 2465,
  [2466] = 2419,
  [2467] = 2467,
  [2468] = 2458,
  [2469] = 1266,
  [2470] = 2470,
  [2471] = 2389,
  [2472] = 2400,
  [2473] = 2473,
  [2474] = 2419,
  [2475] = 1245,
  [2476] = 1008,
  [2477] = 2477,
  [2478] = 2422,
  [2479] = 2479,
  [2480] = 2480,
  [2481] = 1321,
  [2482] = 2410,
  [2483] = 2399,
  [2484] = 2484,
  [2485] = 2442,
  [2486] = 2403,
  [2487] = 2424,
  [2488] = 1326,
  [2489] = 2467,
  [2490] = 2490,
  [2491] = 2473,
  [2492] = 2447,
  [2493] = 1270,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2504,
  [2505] = 2505,
  [2506] = 2506,
  [2507] = 2507,
  [2508] = 2508,
  [2509] = 2509,
  [2510] = 2510,
  [2511] = 2511,
  [2512] = 2512,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2516,
  [2517] = 2517,
  [2518] = 2511,
  [2519] = 2504,
  [2520] = 2496,
  [2521] = 2521,
  [2522] = 2522,
  [2523] = 2523,
  [2524] = 2524,
  [2525] = 2509,
  [2526] = 2526,
  [2527] = 151,
  [2528] = 2528,
  [2529] = 2529,
  [2530] = 2530,
  [2531] = 2515,
  [2532] = 2532,
  [2533] = 2533,
  [2534] = 2534,
  [2535] = 2535,
  [2536] = 2536,
  [2537] = 2537,
  [2538] = 2538,
  [2539] = 2539,
  [2540] = 2540,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2543,
  [2544] = 2544,
  [2545] = 2545,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2548,
  [2549] = 2549,
  [2550] = 2550,
  [2551] = 2494,
  [2552] = 2534,
  [2553] = 2553,
  [2554] = 162,
  [2555] = 2555,
  [2556] = 2556,
  [2557] = 2557,
  [2558] = 2558,
  [2559] = 2559,
  [2560] = 2560,
  [2561] = 2504,
  [2562] = 2562,
  [2563] = 2524,
  [2564] = 2564,
  [2565] = 2565,
  [2566] = 2566,
  [2567] = 2567,
  [2568] = 2568,
  [2569] = 2569,
  [2570] = 2570,
  [2571] = 2571,
  [2572] = 2528,
  [2573] = 2573,
  [2574] = 2574,
  [2575] = 2575,
  [2576] = 2576,
  [2577] = 2577,
  [2578] = 2578,
  [2579] = 2579,
  [2580] = 2512,
  [2581] = 2581,
  [2582] = 2510,
  [2583] = 2583,
  [2584] = 2584,
  [2585] = 2544,
  [2586] = 2584,
  [2587] = 2548,
  [2588] = 2549,
  [2589] = 2589,
  [2590] = 2499,
  [2591] = 2498,
  [2592] = 2497,
  [2593] = 2593,
  [2594] = 2594,
  [2595] = 2595,
  [2596] = 2506,
  [2597] = 2597,
  [2598] = 2499,
  [2599] = 2510,
  [2600] = 2498,
  [2601] = 2497,
  [2602] = 2511,
  [2603] = 2505,
  [2604] = 2496,
  [2605] = 2513,
  [2606] = 2523,
  [2607] = 2506,
  [2608] = 2529,
  [2609] = 2500,
  [2610] = 2578,
  [2611] = 2509,
  [2612] = 2612,
  [2613] = 2514,
  [2614] = 2557,
  [2615] = 2512,
  [2616] = 2500,
  [2617] = 2506,
  [2618] = 2543,
  [2619] = 2530,
  [2620] = 2503,
  [2621] = 2583,
  [2622] = 2535,
  [2623] = 2502,
  [2624] = 2583,
  [2625] = 2537,
  [2626] = 2593,
  [2627] = 2523,
  [2628] = 2065,
  [2629] = 2557,
  [2630] = 2515,
  [2631] = 2562,
  [2632] = 2508,
  [2633] = 2576,
  [2634] = 2511,
  [2635] = 2066,
  [2636] = 2504,
  [2637] = 2541,
  [2638] = 2521,
  [2639] = 2522,
  [2640] = 2496,
  [2641] = 2641,
  [2642] = 2537,
  [2643] = 2068,
  [2644] = 2512,
  [2645] = 2071,
  [2646] = 2583,
  [2647] = 2593,
  [2648] = 2497,
  [2649] = 2074,
  [2650] = 2545,
  [2651] = 2550,
  [2652] = 2523,
  [2653] = 2497,
  [2654] = 2509,
  [2655] = 2655,
  [2656] = 2530,
  [2657] = 2532,
  [2658] = 2506,
  [2659] = 2535,
  [2660] = 2044,
  [2661] = 2564,
  [2662] = 2504,
  [2663] = 2045,
  [2664] = 2509,
  [2665] = 2056,
  [2666] = 2533,
  [2667] = 2530,
  [2668] = 2498,
  [2669] = 2568,
  [2670] = 2535,
  [2671] = 2537,
  [2672] = 2567,
  [2673] = 2673,
  [2674] = 2571,
  [2675] = 2675,
  [2676] = 2595,
  [2677] = 2612,
  [2678] = 2678,
  [2679] = 2679,
  [2680] = 2680,
  [2681] = 2678,
  [2682] = 2562,
  [2683] = 2683,
  [2684] = 2679,
  [2685] = 2535,
  [2686] = 2497,
  [2687] = 2687,
  [2688] = 2612,
  [2689] = 2683,
  [2690] = 2537,
  [2691] = 2595,
  [2692] = 2541,
  [2693] = 2693,
  [2694] = 2694,
  [2695] = 2509,
  [2696] = 2535,
  [2697] = 2537,
  [2698] = 2698,
  [2699] = 2535,
  [2700] = 2559,
  [2701] = 2516,
  [2702] = 2537,
  [2703] = 2593,
  [2704] = 2533,
  [2705] = 2535,
  [2706] = 2549,
  [2707] = 2537,
  [2708] = 2535,
  [2709] = 2537,
  [2710] = 2535,
  [2711] = 2537,
  [2712] = 2557,
  [2713] = 2693,
  [2714] = 2581,
  [2715] = 2535,
  [2716] = 2716,
  [2717] = 2537,
  [2718] = 2555,
  [2719] = 2535,
  [2720] = 2537,
  [2721] = 2721,
  [2722] = 2566,
  [2723] = 2495,
  [2724] = 2501,
  [2725] = 2575,
  [2726] = 2583,
  [2727] = 2507,
  [2728] = 2532,
  [2729] = 2499,
  [2730] = 2530,
  [2731] = 2731,
  [2732] = 2732,
  [2733] = 2107,
  [2734] = 2734,
  [2735] = 2735,
  [2736] = 2079,
  [2737] = 2080,
  [2738] = 2738,
  [2739] = 2099,
  [2740] = 2114,
  [2741] = 2741,
  [2742] = 2108,
  [2743] = 2743,
  [2744] = 2744,
  [2745] = 2745,
  [2746] = 2746,
  [2747] = 2100,
  [2748] = 2748,
  [2749] = 2095,
  [2750] = 2750,
  [2751] = 2751,
  [2752] = 2752,
  [2753] = 2091,
  [2754] = 2089,
  [2755] = 2755,
  [2756] = 2756,
  [2757] = 2757,
  [2758] = 2109,
  [2759] = 2101,
  [2760] = 2096,
  [2761] = 2087,
  [2762] = 2086,
  [2763] = 2083,
  [2764] = 2734,
  [2765] = 2085,
  [2766] = 2090,
  [2767] = 2767,
  [2768] = 2768,
  [2769] = 2769,
  [2770] = 2770,
  [2771] = 2771,
  [2772] = 2771,
  [2773] = 2769,
  [2774] = 2092,
  [2775] = 2094,
  [2776] = 2776,
  [2777] = 2098,
  [2778] = 2778,
  [2779] = 2121,
  [2780] = 2757,
  [2781] = 2781,
  [2782] = 2782,
  [2783] = 2103,
  [2784] = 2784,
  [2785] = 2104,
  [2786] = 2786,
  [2787] = 2787,
  [2788] = 2768,
  [2789] = 2088,
  [2790] = 2790,
  [2791] = 2750,
  [2792] = 2084,
  [2793] = 2097,
  [2794] = 2794,
  [2795] = 2115,
  [2796] = 2116,
  [2797] = 2797,
  [2798] = 164,
  [2799] = 2799,
  [2800] = 2800,
  [2801] = 2801,
  [2802] = 2802,
  [2803] = 2803,
  [2804] = 2120,
  [2805] = 2805,
  [2806] = 2117,
  [2807] = 2807,
  [2808] = 2112,
  [2809] = 2809,
  [2810] = 2784,
  [2811] = 2111,
  [2812] = 2786,
  [2813] = 2813,
  [2814] = 2814,
  [2815] = 2815,
  [2816] = 2816,
  [2817] = 2817,
  [2818] = 2818,
  [2819] = 2819,
  [2820] = 2820,
  [2821] = 2821,
  [2822] = 2822,
  [2823] = 2823,
  [2824] = 2824,
  [2825] = 2825,
  [2826] = 2826,
  [2827] = 2827,
  [2828] = 2828,
  [2829] = 2829,
  [2830] = 2830,
  [2831] = 2831,
  [2832] = 2832,
  [2833] = 2833,
  [2834] = 2834,
  [2835] = 2835,
  [2836] = 2836,
  [2837] = 2837,
  [2838] = 2838,
  [2839] = 2110,
  [2840] = 2840,
  [2841] = 2840,
  [2842] = 2842,
  [2843] = 2843,
  [2844] = 2844,
  [2845] = 2845,
  [2846] = 2846,
  [2847] = 2847,
  [2848] = 2102,
  [2849] = 2849,
  [2850] = 2850,
  [2851] = 2851,
  [2852] = 2852,
  [2853] = 2853,
  [2854] = 2854,
  [2855] = 2855,
  [2856] = 2856,
  [2857] = 2857,
  [2858] = 2858,
  [2859] = 2809,
  [2860] = 2860,
  [2861] = 2861,
  [2862] = 2790,
  [2863] = 2787,
  [2864] = 2864,
  [2865] = 2865,
  [2866] = 2866,
  [2867] = 2770,
  [2868] = 2735,
  [2869] = 2869,
  [2870] = 2870,
  [2871] = 2871,
  [2872] = 2872,
  [2873] = 2873,
  [2874] = 2874,
  [2875] = 2875,
  [2876] = 2876,
  [2877] = 2877,
  [2878] = 2878,
  [2879] = 2879,
  [2880] = 2880,
  [2881] = 2881,
  [2882] = 2882,
  [2883] = 2883,
  [2884] = 2884,
  [2885] = 2885,
  [2886] = 2886,
  [2887] = 2887,
  [2888] = 2888,
  [2889] = 2807,
  [2890] = 2890,
  [2891] = 2891,
  [2892] = 2892,
  [2893] = 2893,
  [2894] = 2894,
  [2895] = 2752,
  [2896] = 2794,
  [2897] = 2797,
  [2898] = 2744,
  [2899] = 2899,
  [2900] = 2900,
  [2901] = 2817,
  [2902] = 2902,
  [2903] = 2770,
  [2904] = 2904,
  [2905] = 2905,
  [2906] = 2906,
  [2907] = 2907,
  [2908] = 2794,
  [2909] = 2800,
  [2910] = 2910,
  [2911] = 2911,
  [2912] = 2912,
  [2913] = 2913,
  [2914] = 2914,
  [2915] = 2915,
  [2916] = 2916,
  [2917] = 2917,
  [2918] = 2805,
  [2919] = 2919,
  [2920] = 2782,
  [2921] = 2921,
  [2922] = 2767,
  [2923] = 2767,
  [2924] = 2924,
  [2925] = 2925,
  [2926] = 2738,
  [2927] = 2732,
  [2928] = 2928,
  [2929] = 2928,
  [2930] = 2930,
  [2931] = 2794,
  [2932] = 2932,
  [2933] = 2924,
  [2934] = 2921,
  [2935] = 2878,
  [2936] = 2919,
  [2937] = 2937,
  [2938] = 2893,
  [2939] = 2916,
  [2940] = 2915,
  [2941] = 2941,
  [2942] = 2907,
  [2943] = 2902,
  [2944] = 2914,
  [2945] = 2904,
  [2946] = 2899,
  [2947] = 2814,
  [2948] = 2948,
  [2949] = 2949,
  [2950] = 2816,
  [2951] = 2951,
  [2952] = 2818,
  [2953] = 2953,
  [2954] = 2900,
  [2955] = 2955,
  [2956] = 2886,
  [2957] = 399,
  [2958] = 2885,
  [2959] = 2959,
  [2960] = 2960,
  [2961] = 2906,
  [2962] = 2822,
  [2963] = 2741,
  [2964] = 2893,
  [2965] = 2965,
  [2966] = 2755,
  [2967] = 2905,
  [2968] = 2968,
  [2969] = 2750,
  [2970] = 2970,
  [2971] = 2786,
  [2972] = 2878,
  [2973] = 2751,
  [2974] = 2974,
  [2975] = 2872,
  [2976] = 2902,
  [2977] = 2899,
  [2978] = 2871,
  [2979] = 2870,
  [2980] = 2746,
  [2981] = 2981,
  [2982] = 2982,
  [2983] = 2894,
  [2984] = 2861,
  [2985] = 2860,
  [2986] = 2892,
  [2987] = 2890,
  [2988] = 2988,
  [2989] = 2858,
  [2990] = 2767,
  [2991] = 2832,
  [2992] = 2847,
  [2993] = 2888,
  [2994] = 2885,
  [2995] = 2782,
  [2996] = 2996,
  [2997] = 2835,
  [2998] = 2998,
  [2999] = 2881,
  [3000] = 2886,
  [3001] = 2743,
  [3002] = 2865,
  [3003] = 2837,
  [3004] = 2748,
  [3005] = 2794,
  [3006] = 2857,
  [3007] = 2930,
  [3008] = 3008,
  [3009] = 2853,
  [3010] = 3010,
  [3011] = 3011,
  [3012] = 2813,
  [3013] = 2815,
  [3014] = 3014,
  [3015] = 3015,
  [3016] = 3016,
  [3017] = 2845,
  [3018] = 3018,
  [3019] = 2838,
  [3020] = 2836,
  [3021] = 3021,
  [3022] = 2824,
  [3023] = 3023,
  [3024] = 2745,
  [3025] = 2731,
  [3026] = 2828,
  [3027] = 2827,
  [3028] = 3028,
  [3029] = 3029,
  [3030] = 2826,
  [3031] = 2825,
  [3032] = 3032,
  [3033] = 3033,
  [3034] = 3034,
  [3035] = 3035,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 3038,
  [3039] = 3039,
  [3040] = 3040,
  [3041] = 3041,
  [3042] = 3042,
  [3043] = 3043,
  [3044] = 3044,
  [3045] = 3045,
  [3046] = 3046,
  [3047] = 3047,
  [3048] = 3048,
  [3049] = 3049,
  [3050] = 3050,
  [3051] = 3035,
  [3052] = 3052,
  [3053] = 3047,
  [3054] = 3036,
  [3055] = 3048,
  [3056] = 3056,
  [3057] = 3057,
  [3058] = 3040,
  [3059] = 3059,
  [3060] = 3060,
  [3061] = 3061,
  [3062] = 3062,
  [3063] = 3063,
  [3064] = 3064,
  [3065] = 3065,
  [3066] = 3066,
  [3067] = 3067,
  [3068] = 3068,
  [3069] = 3047,
  [3070] = 3070,
  [3071] = 3043,
  [3072] = 1166,
  [3073] = 3047,
  [3074] = 3074,
  [3075] = 3075,
  [3076] = 3038,
  [3077] = 3034,
  [3078] = 3078,
  [3079] = 3079,
  [3080] = 3080,
  [3081] = 3081,
  [3082] = 3033,
  [3083] = 3083,
  [3084] = 3084,
  [3085] = 3085,
  [3086] = 3086,
  [3087] = 3087,
  [3088] = 3088,
  [3089] = 3089,
  [3090] = 3045,
  [3091] = 3091,
  [3092] = 3092,
  [3093] = 3093,
  [3094] = 3094,
  [3095] = 3095,
  [3096] = 3096,
  [3097] = 3050,
  [3098] = 3098,
  [3099] = 3099,
  [3100] = 3100,
  [3101] = 3101,
  [3102] = 3102,
  [3103] = 3057,
  [3104] = 3048,
  [3105] = 3085,
  [3106] = 3106,
  [3107] = 3042,
  [3108] = 3040,
  [3109] = 3109,
  [3110] = 3110,
  [3111] = 3110,
  [3112] = 3112,
  [3113] = 3109,
  [3114] = 3112,
  [3115] = 3115,
  [3116] = 3116,
  [3117] = 3117,
  [3118] = 3060,
  [3119] = 3060,
  [3120] = 3120,
  [3121] = 3121,
  [3122] = 3122,
  [3123] = 3123,
  [3124] = 3065,
  [3125] = 3125,
  [3126] = 3126,
  [3127] = 3127,
  [3128] = 3128,
  [3129] = 3101,
  [3130] = 3130,
  [3131] = 3131,
  [3132] = 3132,
  [3133] = 3112,
  [3134] = 3050,
  [3135] = 3089,
  [3136] = 3099,
  [3137] = 3080,
  [3138] = 3050,
  [3139] = 3132,
  [3140] = 3140,
  [3141] = 1172,
  [3142] = 3088,
  [3143] = 3143,
  [3144] = 3067,
  [3145] = 3078,
  [3146] = 3146,
  [3147] = 3084,
  [3148] = 3148,
  [3149] = 3149,
  [3150] = 3150,
  [3151] = 3100,
  [3152] = 3152,
  [3153] = 3068,
  [3154] = 3154,
  [3155] = 3155,
  [3156] = 3156,
  [3157] = 3155,
  [3158] = 3158,
  [3159] = 3159,
  [3160] = 3160,
  [3161] = 3161,
  [3162] = 3085,
  [3163] = 3070,
  [3164] = 3050,
  [3165] = 3165,
  [3166] = 3074,
  [3167] = 3094,
  [3168] = 3057,
  [3169] = 1254,
  [3170] = 1255,
  [3171] = 3093,
  [3172] = 3172,
  [3173] = 3092,
  [3174] = 3174,
  [3175] = 3175,
  [3176] = 3068,
  [3177] = 3037,
  [3178] = 3091,
  [3179] = 3179,
  [3180] = 3117,
  [3181] = 3083,
  [3182] = 3086,
  [3183] = 3175,
  [3184] = 3081,
  [3185] = 3052,
  [3186] = 3093,
  [3187] = 3110,
  [3188] = 3050,
  [3189] = 3062,
  [3190] = 3099,
  [3191] = 3101,
  [3192] = 3192,
  [3193] = 3131,
  [3194] = 3122,
  [3195] = 3109,
  [3196] = 3120,
  [3197] = 3048,
  [3198] = 3128,
  [3199] = 3199,
  [3200] = 3160,
  [3201] = 3201,
  [3202] = 3202,
  [3203] = 3116,
  [3204] = 3199,
  [3205] = 3205,
  [3206] = 3086,
  [3207] = 3207,
  [3208] = 3208,
  [3209] = 3156,
  [3210] = 3059,
  [3211] = 3101,
  [3212] = 3165,
  [3213] = 3213,
  [3214] = 3057,
  [3215] = 3215,
  [3216] = 3216,
  [3217] = 3049,
  [3218] = 3036,
  [3219] = 3099,
  [3220] = 3220,
  [3221] = 3068,
  [3222] = 3152,
  [3223] = 3086,
  [3224] = 3224,
  [3225] = 3225,
  [3226] = 3057,
  [3227] = 3050,
  [3228] = 3149,
  [3229] = 3099,
  [3230] = 3101,
  [3231] = 3148,
  [3232] = 3046,
  [3233] = 3158,
  [3234] = 3123,
  [3235] = 3159,
  [3236] = 3102,
  [3237] = 2831,
  [3238] = 3050,
  [3239] = 3044,
  [3240] = 3086,
  [3241] = 3241,
  [3242] = 3063,
  [3243] = 3041,
  [3244] = 3143,
  [3245] = 3064,
  [3246] = 3128,
  [3247] = 1323,
  [3248] = 3068,
  [3249] = 3249,
  [3250] = 3039,
  [3251] = 3050,
  [3252] = 3112,
  [3253] = 3099,
  [3254] = 3101,
  [3255] = 3050,
  [3256] = 3256,
  [3257] = 2830,
  [3258] = 3179,
  [3259] = 3259,
  [3260] = 3260,
  [3261] = 3079,
  [3262] = 3262,
  [3263] = 3074,
  [3264] = 3056,
  [3265] = 3061,
  [3266] = 3131,
  [3267] = 3070,
  [3268] = 3092,
  [3269] = 3068,
  [3270] = 3161,
  [3271] = 3050,
  [3272] = 3088,
  [3273] = 3099,
  [3274] = 3101,
  [3275] = 3070,
  [3276] = 3132,
  [3277] = 3277,
  [3278] = 3112,
  [3279] = 3094,
  [3280] = 3068,
  [3281] = 3050,
  [3282] = 3282,
  [3283] = 3099,
  [3284] = 3101,
  [3285] = 3285,
  [3286] = 3068,
  [3287] = 3095,
  [3288] = 3099,
  [3289] = 3101,
  [3290] = 3068,
  [3291] = 3146,
  [3292] = 3099,
  [3293] = 3101,
  [3294] = 3087,
  [3295] = 3068,
  [3296] = 3099,
  [3297] = 3101,
  [3298] = 3068,
  [3299] = 3220,
  [3300] = 3099,
  [3301] = 3101,
  [3302] = 3093,
  [3303] = 3067,
  [3304] = 3304,
  [3305] = 3305,
  [3306] = 3216,
  [3307] = 3150,
  [3308] = 3066,
  [3309] = 3068,
  [3310] = 3096,
  [3311] = 3311,
  [3312] = 3312,
  [3313] = 3313,
  [3314] = 3314,
  [3315] = 3315,
  [3316] = 3316,
  [3317] = 3317,
  [3318] = 3318,
  [3319] = 3319,
  [3320] = 3320,
  [3321] = 3321,
  [3322] = 3322,
  [3323] = 3323,
  [3324] = 3313,
  [3325] = 3325,
  [3326] = 3326,
  [3327] = 3327,
  [3328] = 3328,
  [3329] = 3329,
  [3330] = 3330,
  [3331] = 3331,
  [3332] = 3332,
  [3333] = 3333,
  [3334] = 3334,
  [3335] = 3335,
  [3336] = 3336,
  [3337] = 3337,
  [3338] = 3338,
  [3339] = 3339,
  [3340] = 3313,
  [3341] = 3341,
  [3342] = 3342,
  [3343] = 3343,
  [3344] = 3344,
  [3345] = 3345,
  [3346] = 3346,
  [3347] = 3347,
  [3348] = 3348,
  [3349] = 3349,
  [3350] = 3347,
  [3351] = 3322,
  [3352] = 3320,
  [3353] = 3318,
  [3354] = 3330,
  [3355] = 3355,
  [3356] = 3356,
  [3357] = 3349,
  [3358] = 3358,
  [3359] = 3359,
  [3360] = 3360,
  [3361] = 3361,
  [3362] = 3362,
  [3363] = 3363,
  [3364] = 3364,
  [3365] = 3365,
  [3366] = 3366,
  [3367] = 3367,
  [3368] = 3368,
  [3369] = 3369,
  [3370] = 3370,
  [3371] = 3371,
  [3372] = 3372,
  [3373] = 3373,
  [3374] = 3374,
  [3375] = 3375,
  [3376] = 3348,
  [3377] = 3377,
  [3378] = 3378,
  [3379] = 3379,
  [3380] = 3380,
  [3381] = 3381,
  [3382] = 3382,
  [3383] = 3383,
  [3384] = 3384,
  [3385] = 3385,
  [3386] = 142,
  [3387] = 3375,
  [3388] = 3388,
  [3389] = 3332,
  [3390] = 3359,
  [3391] = 3391,
  [3392] = 3392,
  [3393] = 3393,
  [3394] = 3394,
  [3395] = 3395,
  [3396] = 3375,
  [3397] = 3397,
  [3398] = 3398,
  [3399] = 3362,
  [3400] = 3400,
  [3401] = 3334,
  [3402] = 3402,
  [3403] = 3403,
  [3404] = 3404,
  [3405] = 3405,
  [3406] = 3406,
  [3407] = 3407,
  [3408] = 3367,
  [3409] = 3409,
  [3410] = 3410,
  [3411] = 3369,
  [3412] = 3406,
  [3413] = 3413,
  [3414] = 3414,
  [3415] = 3415,
  [3416] = 3364,
  [3417] = 3417,
  [3418] = 3388,
  [3419] = 3419,
  [3420] = 3339,
  [3421] = 3421,
  [3422] = 3362,
  [3423] = 3355,
  [3424] = 3424,
  [3425] = 3343,
  [3426] = 3426,
  [3427] = 3427,
  [3428] = 3428,
  [3429] = 3312,
  [3430] = 3430,
  [3431] = 3344,
  [3432] = 3337,
  [3433] = 3370,
  [3434] = 3427,
  [3435] = 3435,
  [3436] = 3345,
  [3437] = 3375,
  [3438] = 3426,
  [3439] = 3439,
  [3440] = 3394,
  [3441] = 3344,
  [3442] = 3442,
  [3443] = 3419,
  [3444] = 3444,
  [3445] = 3445,
  [3446] = 3446,
  [3447] = 3410,
  [3448] = 3448,
  [3449] = 3335,
  [3450] = 3331,
  [3451] = 3366,
  [3452] = 3395,
  [3453] = 3405,
  [3454] = 3388,
  [3455] = 3455,
  [3456] = 3362,
  [3457] = 3457,
  [3458] = 3458,
  [3459] = 3392,
  [3460] = 3373,
  [3461] = 3372,
  [3462] = 3365,
  [3463] = 3463,
  [3464] = 3383,
  [3465] = 3465,
  [3466] = 3385,
  [3467] = 3406,
  [3468] = 3377,
  [3469] = 3321,
  [3470] = 3323,
  [3471] = 3471,
  [3472] = 3419,
  [3473] = 3458,
  [3474] = 3331,
  [3475] = 3415,
  [3476] = 3398,
  [3477] = 3477,
  [3478] = 3337,
  [3479] = 3375,
  [3480] = 3339,
  [3481] = 3458,
  [3482] = 3482,
  [3483] = 3349,
  [3484] = 3406,
  [3485] = 3485,
  [3486] = 3367,
  [3487] = 3487,
  [3488] = 3369,
  [3489] = 3370,
  [3490] = 3444,
  [3491] = 3372,
  [3492] = 3402,
  [3493] = 3493,
  [3494] = 3494,
  [3495] = 3495,
  [3496] = 3477,
  [3497] = 3497,
  [3498] = 3394,
  [3499] = 3499,
  [3500] = 3313,
  [3501] = 3501,
  [3502] = 3502,
  [3503] = 3335,
  [3504] = 3323,
  [3505] = 3505,
  [3506] = 3506,
  [3507] = 3331,
  [3508] = 3508,
  [3509] = 3509,
  [3510] = 3339,
  [3511] = 3367,
  [3512] = 3333,
  [3513] = 3369,
  [3514] = 3372,
  [3515] = 3323,
  [3516] = 3516,
  [3517] = 3517,
  [3518] = 3518,
  [3519] = 3313,
  [3520] = 3331,
  [3521] = 3388,
  [3522] = 3339,
  [3523] = 3321,
  [3524] = 3372,
  [3525] = 3313,
  [3526] = 3331,
  [3527] = 3339,
  [3528] = 3372,
  [3529] = 3331,
  [3530] = 3339,
  [3531] = 3372,
  [3532] = 3331,
  [3533] = 3331,
  [3534] = 3331,
  [3535] = 3331,
  [3536] = 3331,
  [3537] = 3338,
  [3538] = 3538,
  [3539] = 3539,
  [3540] = 3361,
  [3541] = 3502,
  [3542] = 3471,
  [3543] = 3446,
  [3544] = 3417,
  [3545] = 3414,
  [3546] = 3413,
  [3547] = 3547,
  [3548] = 3404,
  [3549] = 3549,
  [3550] = 3439,
  [3551] = 3381,
  [3552] = 3398,
  [3553] = 3388,
  [3554] = 3316,
  [3555] = 3555,
  [3556] = 3400,
  [3557] = 3327,
  [3558] = 3315,
  [3559] = 3329,
  [3560] = 3560,
  [3561] = 3561,
  [3562] = 3314,
  [3563] = 3505,
  [3564] = 3564,
  [3565] = 3397,
  [3566] = 3561,
  [3567] = 3325,
  [3568] = 3501,
  [3569] = 3391,
  [3570] = 3336,
  [3571] = 3508,
  [3572] = 3360,
  [3573] = 3355,
  [3574] = 3574,
  [3575] = 3575,
  [3576] = 3487,
  [3577] = 161,
  [3578] = 3578,
  [3579] = 3344,
  [3580] = 3371,
  [3581] = 3574,
  [3582] = 3578,
  [3583] = 3393,
  [3584] = 3375,
  [3585] = 3502,
  [3586] = 3471,
  [3587] = 3417,
  [3588] = 3414,
  [3589] = 3358,
  [3590] = 3394,
  [3591] = 3502,
  [3592] = 3414,
  [3593] = 3378,
  [3594] = 3594,
  [3595] = 3414,
  [3596] = 3414,
  [3597] = 3414,
  [3598] = 3465,
  [3599] = 3517,
  [3600] = 3455,
  [3601] = 3421,
  [3602] = 3384,
  [3603] = 3382,
  [3604] = 3560,
  [3605] = 3317,
  [3606] = 3328,
  [3607] = 3607,
  [3608] = 3564,
  [3609] = 3326,
  [3610] = 3374,
  [3611] = 3611,
  [3612] = 3612,
  [3613] = 3613,
  [3614] = 3614,
  [3615] = 3615,
  [3616] = 3616,
  [3617] = 3617,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa},
  {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54},
  {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f},
  {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa},
  {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25},
  {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6},
  {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e},
  {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9},
  {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb},
  {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef},
  {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1},
  {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06},
  {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3},
  {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28},
  {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d},
  {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf},
  {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d},
  {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d},
  {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
  {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808},
  {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5},
  {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27},
  {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af},
  {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4},
  {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d},
  {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339},
  {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5},
  {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a},
  {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f},
  {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32},
  {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40},
  {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89},
  {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e},
  {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77},
  {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7},
  {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b150, 0x1b152}, {0x1b164, 0x1b167},
  {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f},
  {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a},
  {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5},
  {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788},
  {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad},
  {0x1e2c0, 0x1e2eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b},
  {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39},
  {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54},
  {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a},
  {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9},
  {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
};

static TSCharacterRange sym_identifier_character_set_3[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x300, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481},
  {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf}, {0x5c1, 0x5c2},
  {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dc},
  {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd},
  {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963}, {0x966, 0x96f},
  {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9c4},
  {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe},
  {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39},
  {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75},
  {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xac5},
  {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03}, {0xb05, 0xb0c},
  {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48}, {0xb4b, 0xb4d},
  {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90},
  {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbbe, 0xbc2},
  {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28},
  {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc63},
  {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbc, 0xcc4},
  {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf2}, {0xd00, 0xd0c},
  {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f}, {0xd7a, 0xd7f},
  {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdcf, 0xdd4},
  {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59}, {0xe81, 0xe82},
  {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xec8, 0xecd},
  {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37}, {0xf39, 0xf39},
  {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049}, {0x1050, 0x109d},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258},
  {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5},
  {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715}, {0x171f, 0x1734},
  {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd}, {0x17e0, 0x17e9},
  {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b}, {0x1930, 0x193b},
  {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c},
  {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59}, {0x1b6b, 0x1b73},
  {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2},
  {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x203f, 0x2040}, {0x2054, 0x2054}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115},
  {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e},
  {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f},
  {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6},
  {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x3099, 0x309a},
  {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf},
  {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1}, {0xa717, 0xa71f},
  {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c}, {0xa840, 0xa873},
  {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c}, {0xa980, 0xa9c0},
  {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2}, {0xaadb, 0xaadd},
  {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a},
  {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d},
  {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41},
  {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f},
  {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff66, 0xffbe}, {0xffc2, 0xffc7},
  {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d},
  {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0}, {0x10300, 0x1031f},
  {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104a0, 0x104a9},
  {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595},
  {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785},
  {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855},
  {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf},
  {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c},
  {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48},
  {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c},
  {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075}, {0x1107f, 0x110ba},
  {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173}, {0x11176, 0x11176},
  {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x1123e}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303}, {0x11305, 0x1130c},
  {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348}, {0x1134b, 0x1134d},
  {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459}, {0x1145e, 0x11461},
  {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640}, {0x11644, 0x11644},
  {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746}, {0x11800, 0x1183a},
  {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938}, {0x1193b, 0x11943},
  {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47}, {0x11a50, 0x11a99},
  {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7},
  {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47}, {0x11d50, 0x11d59},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6}, {0x11fb0, 0x11fb0},
  {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e},
  {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59},
  {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4},
  {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122},
  {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e},
  {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244},
  {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb},
  {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544},
  {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734},
  {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36},
  {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1e000, 0x1e006}, {0x1e008, 0x1e018},
  {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae},
  {0x1e2c0, 0x1e2f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b},
  {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37},
  {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52},
  {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64},
  {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3},
  {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(70);
      ADVANCE_MAP(
        '!', 169,
        '"', 155,
        '#', 141,
        '$', 83,
        '%', 97,
        '&', 102,
        '\'', 143,
        '(', 73,
        ')', 74,
        '*', 90,
        '+', 88,
        ',', 137,
        '-', 94,
        '.', 131,
        '/', 170,
        '0', 149,
        ':', 81,
        ';', 71,
        '<', 144,
        '=', 121,
        '>', 125,
        '?', 91,
        '@', 130,
        '[', 75,
        '\\', 45,
        ']', 76,
        '^', 98,
        'b', 176,
        'c', 177,
        'm', 180,
        'r', 178,
        '{', 77,
        '|', 104,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(66);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '!', 100,
        '"', 154,
        '#', 140,
        '$', 83,
        '%', 97,
        '&', 102,
        '\'', 143,
        '(', 73,
        ')', 74,
        '*', 90,
        '+', 88,
        ',', 137,
        '-', 94,
        '.', 131,
        '/', 96,
        '0', 149,
        ':', 81,
        ';', 71,
        '<', 127,
        '=', 121,
        '>', 125,
        '?', 91,
        '@', 130,
        '[', 75,
        ']', 76,
        '^', 98,
        'b', 176,
        'c', 177,
        'r', 178,
        '{', 77,
        '|', 104,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '!', 100,
        '"', 154,
        '#', 140,
        '$', 64,
        '%', 97,
        '&', 102,
        '\'', 143,
        '(', 73,
        ')', 74,
        '*', 90,
        '+', 88,
        ',', 137,
        '-', 93,
        '.', 131,
        '/', 96,
        '0', 149,
        ':', 81,
        ';', 71,
        '<', 127,
        '=', 120,
        '>', 125,
        '?', 91,
        '[', 75,
        ']', 76,
        '^', 98,
        'b', 176,
        'c', 177,
        'r', 178,
        '{', 77,
        '|', 104,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 100,
        '"', 154,
        '#', 140,
        '$', 82,
        '%', 97,
        '&', 102,
        '\'', 143,
        '(', 73,
        ')', 74,
        '*', 90,
        '+', 88,
        ',', 137,
        '-', 94,
        '.', 131,
        '/', 96,
        '0', 149,
        ':', 81,
        ';', 71,
        '<', 127,
        '=', 121,
        '>', 125,
        '?', 91,
        '@', 130,
        '[', 75,
        ']', 76,
        '^', 98,
        'b', 176,
        'c', 177,
        'r', 178,
        '{', 77,
        '|', 104,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 100,
        '"', 154,
        '$', 64,
        '%', 97,
        '&', 102,
        '\'', 143,
        '(', 73,
        '*', 90,
        '+', 88,
        '-', 93,
        '.', 131,
        '/', 96,
        '0', 149,
        ':', 81,
        '<', 127,
        '=', 121,
        '>', 125,
        '?', 91,
        '[', 75,
        '^', 98,
        'b', 176,
        'c', 177,
        'r', 178,
        '{', 77,
        '|', 104,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 100,
        '%', 97,
        '&', 102,
        '\'', 142,
        '(', 73,
        ')', 74,
        '*', 90,
        '+', 88,
        ',', 137,
        '-', 93,
        '.', 131,
        '/', 96,
        ':', 81,
        ';', 71,
        '<', 144,
        '=', 120,
        '>', 125,
        '?', 91,
        '[', 75,
        ']', 76,
        '^', 98,
        'r', 178,
        '{', 77,
        '|', 104,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 100,
        '%', 97,
        '&', 102,
        '\'', 142,
        '(', 73,
        ')', 74,
        '*', 90,
        '+', 88,
        ',', 137,
        '-', 93,
        '.', 131,
        '/', 96,
        ':', 39,
        ';', 71,
        '<', 127,
        '=', 120,
        '>', 125,
        '?', 91,
        '[', 75,
        ']', 76,
        '^', 98,
        'r', 178,
        '{', 77,
        '|', 104,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 100,
        '%', 97,
        '&', 102,
        '\'', 142,
        '(', 73,
        '*', 90,
        '+', 88,
        '-', 93,
        '.', 131,
        '/', 96,
        ':', 39,
        '<', 127,
        '=', 121,
        '>', 125,
        '?', 91,
        '[', 75,
        '^', 98,
        'r', 178,
        '{', 77,
        '|', 104,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 100,
        '%', 97,
        '&', 102,
        '(', 73,
        '*', 90,
        '+', 88,
        '-', 93,
        '.', 131,
        '/', 96,
        ':', 39,
        '<', 144,
        '=', 121,
        '>', 125,
        '?', 91,
        '[', 75,
        '^', 98,
        'r', 178,
        '|', 104,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 99,
        '"', 155,
        '#', 140,
        '$', 64,
        '&', 23,
        '\'', 142,
        '(', 73,
        ')', 74,
        '*', 32,
        '+', 87,
        ',', 137,
        '.', 29,
        '/', 27,
        ':', 81,
        ';', 71,
        '<', 126,
        '=', 42,
        '>', 124,
        '\\', 45,
        ']', 76,
        'm', 180,
        'r', 178,
        '{', 77,
        '|', 103,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '!', 99,
        '"', 154,
        '#', 140,
        '$', 64,
        '&', 101,
        '\'', 143,
        '(', 73,
        ')', 74,
        '*', 89,
        ',', 137,
        '-', 92,
        '.', 30,
        '/', 27,
        '0', 149,
        ':', 81,
        ';', 71,
        '<', 126,
        '=', 119,
        '>', 124,
        '?', 91,
        '[', 75,
        ']', 76,
        'b', 176,
        'c', 177,
        'r', 178,
        '{', 77,
        '|', 103,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '!', 99,
        '"', 154,
        '#', 140,
        '$', 64,
        '&', 101,
        '\'', 143,
        '(', 73,
        ')', 74,
        '*', 89,
        ',', 137,
        '-', 92,
        '.', 31,
        '/', 27,
        '0', 149,
        ':', 39,
        '<', 126,
        '=', 42,
        '?', 91,
        '[', 75,
        'b', 176,
        'c', 177,
        'r', 178,
        '|', 103,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '!', 99,
        '"', 154,
        '$', 64,
        '&', 101,
        '\'', 143,
        '(', 73,
        '*', 89,
        '+', 87,
        ',', 137,
        '-', 95,
        '.', 30,
        '/', 27,
        '0', 149,
        ':', 39,
        ';', 71,
        '<', 126,
        '[', 75,
        ']', 76,
        'b', 176,
        'c', 177,
        'r', 178,
        '{', 77,
        '|', 103,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(12);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '!', 99,
        '#', 140,
        '$', 64,
        '&', 101,
        '\'', 142,
        '(', 73,
        ')', 74,
        '*', 89,
        '+', 87,
        ',', 137,
        '-', 41,
        '.', 29,
        '/', 27,
        '0', 149,
        ':', 81,
        ';', 71,
        '<', 126,
        '=', 119,
        '>', 124,
        '?', 91,
        '[', 75,
        ']', 76,
        'r', 178,
        '{', 77,
        '|', 103,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(13);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '!', 99,
        '#', 140,
        '$', 64,
        '&', 23,
        '\'', 142,
        '(', 73,
        ')', 74,
        '*', 32,
        '+', 87,
        ',', 137,
        '.', 29,
        '/', 27,
        ':', 81,
        ';', 71,
        '<', 126,
        '=', 42,
        '>', 124,
        ']', 76,
        'm', 180,
        'r', 178,
        '{', 77,
        '|', 103,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '!', 99,
        '\'', 142,
        '(', 73,
        ')', 74,
        '+', 87,
        ',', 137,
        '.', 29,
        '/', 27,
        ':', 81,
        ';', 71,
        '<', 144,
        '=', 119,
        '>', 124,
        '@', 130,
        ']', 76,
        'r', 178,
        '{', 77,
        '|', 103,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '!', 99,
        '(', 73,
        '.', 29,
        '/', 27,
        ':', 39,
        '<', 144,
        '=', 42,
        '@', 130,
        'r', 178,
        '{', 77,
        '|', 103,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(16);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '!', 40,
        '%', 97,
        '&', 102,
        '\'', 142,
        '(', 73,
        ')', 74,
        '*', 90,
        '+', 88,
        ',', 137,
        '-', 94,
        '.', 131,
        '/', 96,
        ':', 80,
        ';', 71,
        '<', 127,
        '=', 120,
        '>', 125,
        '?', 91,
        '[', 75,
        ']', 76,
        '^', 98,
        'r', 178,
        '{', 77,
        '|', 104,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(17);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '!', 40,
        '%', 97,
        '&', 102,
        '\'', 142,
        '(', 73,
        ')', 74,
        '*', 90,
        '+', 88,
        ',', 137,
        '-', 93,
        '.', 131,
        '/', 96,
        ':', 80,
        ';', 71,
        '<', 127,
        '=', 120,
        '>', 125,
        '?', 91,
        '[', 75,
        ']', 76,
        '^', 98,
        'r', 178,
        '{', 77,
        '|', 104,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '!', 40,
        '%', 97,
        '&', 102,
        '(', 73,
        '*', 90,
        '+', 88,
        '-', 94,
        '.', 131,
        '/', 96,
        '<', 127,
        '=', 121,
        '>', 125,
        '?', 91,
        '[', 75,
        '^', 98,
        'r', 178,
        '|', 104,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == 'b' ||
          lookahead == 'c') ADVANCE(177);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(20);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        '#', 140,
        '$', 64,
        ',', 137,
        '/', 27,
        ':', 39,
        ';', 71,
        '<', 126,
        '=', 119,
        'm', 180,
        'r', 178,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '#', 140,
        ',', 137,
        '.', 30,
        '/', 27,
        '0', 149,
        ':', 80,
        ';', 71,
        '<', 126,
        '=', 119,
        'r', 178,
        '{', 77,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 23:
      if (lookahead == '&') ADVANCE(105);
      END_STATE();
    case 24:
      if (lookahead == '\'') ADVANCE(156);
      END_STATE();
    case 25:
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '\\') ADVANCE(46);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 26:
      ADVANCE_MAP(
        '\'', 142,
        '(', 73,
        ')', 74,
        '*', 89,
        '+', 87,
        ',', 137,
        '-', 41,
        '.', 29,
        '/', 27,
        ':', 80,
        ';', 71,
        '<', 144,
        '=', 119,
        '>', 124,
        ']', 76,
        'r', 178,
        '{', 77,
        '|', 103,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 27:
      if (lookahead == '*') ADVANCE(172);
      if (lookahead == '/') ADVANCE(158);
      END_STATE();
    case 28:
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '?') ADVANCE(91);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(85);
      if (lookahead != 0) ADVANCE(86);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(134);
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(132);
      END_STATE();
    case 31:
      if (lookahead == '.') ADVANCE(133);
      END_STATE();
    case 32:
      if (lookahead == '/') ADVANCE(174);
      END_STATE();
    case 33:
      if (lookahead == '1') ADVANCE(35);
      if (lookahead == '3') ADVANCE(34);
      if (lookahead == '6') ADVANCE(37);
      if (lookahead == '8') ADVANCE(145);
      if (lookahead == 's') ADVANCE(44);
      END_STATE();
    case 34:
      if (lookahead == '2') ADVANCE(145);
      END_STATE();
    case 35:
      if (lookahead == '2') ADVANCE(38);
      if (lookahead == '6') ADVANCE(145);
      END_STATE();
    case 36:
      if (lookahead == '3') ADVANCE(34);
      if (lookahead == '6') ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == '4') ADVANCE(145);
      END_STATE();
    case 38:
      if (lookahead == '8') ADVANCE(145);
      END_STATE();
    case 39:
      if (lookahead == ':') ADVANCE(138);
      END_STATE();
    case 40:
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 41:
      if (lookahead == '>') ADVANCE(139);
      END_STATE();
    case 42:
      if (lookahead == '>') ADVANCE(79);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(47);
      END_STATE();
    case 45:
      if (lookahead == 'u') ADVANCE(48);
      if (lookahead == 'x') ADVANCE(60);
      if (lookahead != 0) ADVANCE(157);
      END_STATE();
    case 46:
      if (lookahead == 'u') ADVANCE(49);
      if (lookahead == 'x') ADVANCE(61);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 47:
      if (lookahead == 'z') ADVANCE(43);
      END_STATE();
    case 48:
      if (lookahead == '{') ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 49:
      if (lookahead == '{') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 50:
      if (lookahead == '}') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 51:
      if (lookahead == '}') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 52:
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(150);
      END_STATE();
    case 53:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(53);
      if (lookahead != 0 &&
          lookahead != '[') ADVANCE(190);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(151);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(157);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(153);
      END_STATE();
    case 64:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 65:
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 66:
      if (eof) ADVANCE(70);
      ADVANCE_MAP(
        '!', 100,
        '"', 154,
        '#', 141,
        '$', 83,
        '%', 97,
        '&', 102,
        '\'', 143,
        '(', 73,
        ')', 74,
        '*', 90,
        '+', 88,
        ',', 137,
        '-', 94,
        '.', 131,
        '/', 96,
        '0', 149,
        ':', 81,
        ';', 71,
        '<', 144,
        '=', 121,
        '>', 125,
        '?', 91,
        '@', 130,
        '[', 75,
        ']', 76,
        '^', 98,
        'b', 176,
        'c', 177,
        'm', 180,
        'r', 178,
        '{', 77,
        '|', 104,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(66);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 67:
      if (eof) ADVANCE(70);
      ADVANCE_MAP(
        '!', 100,
        '"', 154,
        '#', 140,
        '$', 64,
        '%', 97,
        '&', 102,
        '\'', 143,
        '(', 73,
        '*', 90,
        '+', 88,
        '-', 93,
        '.', 131,
        '/', 96,
        '0', 149,
        ':', 39,
        ';', 71,
        '<', 127,
        '=', 120,
        '>', 125,
        '?', 91,
        '[', 75,
        '^', 98,
        'b', 176,
        'c', 177,
        'm', 180,
        'r', 178,
        '{', 77,
        '|', 104,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 68:
      if (eof) ADVANCE(70);
      ADVANCE_MAP(
        '!', 99,
        '"', 154,
        '#', 141,
        '$', 64,
        '&', 101,
        '\'', 143,
        '(', 73,
        ')', 74,
        '*', 89,
        '+', 87,
        ',', 137,
        '-', 92,
        '.', 30,
        '/', 27,
        '0', 149,
        ':', 81,
        ';', 71,
        '<', 126,
        '=', 119,
        '>', 124,
        '?', 91,
        '[', 75,
        ']', 76,
        'b', 176,
        'c', 177,
        'm', 180,
        'r', 178,
        '{', 77,
        '|', 103,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 69:
      if (eof) ADVANCE(70);
      ADVANCE_MAP(
        '!', 99,
        '"', 154,
        '#', 140,
        '$', 64,
        '&', 101,
        '\'', 143,
        '(', 73,
        '*', 89,
        '-', 92,
        '.', 30,
        '/', 27,
        '0', 149,
        ':', 39,
        ';', 71,
        '<', 126,
        '=', 42,
        '[', 75,
        'b', 176,
        'c', 177,
        'm', 180,
        'r', 178,
        '{', 77,
        '|', 103,
        '}', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(189);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_macro_rules_BANG);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(138);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead == '*') ADVANCE(172);
      if (lookahead == '/') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(86);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead == '/') ADVANCE(84);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(86);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(110);
      if (lookahead == '>') ADVANCE(139);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(139);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(172);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(105);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(116);
      if (lookahead == '|') ADVANCE(106);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(79);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(128);
      if (lookahead == '>') ADVANCE(108);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(107);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(134);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(135);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(135);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '!') ADVANCE(53);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '\\') ADVANCE(46);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_LT2);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_integer_literal);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '2') ADVANCE(153);
      if (lookahead == 'f') ADVANCE(147);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(153);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '3') ADVANCE(146);
      if (lookahead == '6') ADVANCE(148);
      if (lookahead == 'f') ADVANCE(147);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(153);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '4') ADVANCE(153);
      if (lookahead == 'f') ADVANCE(147);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(153);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'b') ADVANCE(52);
      if (lookahead == 'f') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'o') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(152);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(147);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_char_literal);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(86);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(164);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead == '*') ADVANCE(173);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(164);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(163);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(164);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(164);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead == '!') ADVANCE(169);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(167);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(168);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '/') ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(168);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead == '/') ADVANCE(166);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(167);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(168);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(168);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym__inner_line_doc_comment_marker);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym__outer_line_doc_comment_marker);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym__outer_line_doc_comment_marker);
      if (lookahead == '/') ADVANCE(161);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(164);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_STAR_SLASH);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\'') ADVANCE(25);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(154);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '#') ADVANCE(65);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(186);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(181);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(185);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(187);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(182);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(179);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(184);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(188);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(175);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(183);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_identifier);
      if (set_contains(sym_identifier_character_set_3, 763, lookahead)) ADVANCE(189);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_shebang);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '[') ADVANCE(190);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_metavariable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        '_', 1,
        'a', 2,
        'b', 3,
        'c', 4,
        'd', 5,
        'e', 6,
        'f', 7,
        'i', 8,
        'l', 9,
        'm', 10,
        'p', 11,
        'r', 12,
        's', 13,
        't', 14,
        'u', 15,
        'v', 16,
        'w', 17,
        'y', 18,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2:
      if (lookahead == 's') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(21);
      if (lookahead == 'o') ADVANCE(22);
      if (lookahead == 'r') ADVANCE(23);
      END_STATE();
    case 4:
      if (lookahead == 'h') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(25);
      if (lookahead == 'r') ADVANCE(26);
      END_STATE();
    case 5:
      if (lookahead == 'e') ADVANCE(27);
      if (lookahead == 'y') ADVANCE(28);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'n') ADVANCE(30);
      if (lookahead == 'x') ADVANCE(31);
      END_STATE();
    case 7:
      if (lookahead == '3') ADVANCE(32);
      if (lookahead == '6') ADVANCE(33);
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '1', 37,
        '3', 38,
        '6', 39,
        '8', 40,
        'd', 41,
        'f', 42,
        'm', 43,
        'n', 44,
        's', 45,
        't', 46,
      );
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      if (lookahead == 'i') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'o') ADVANCE(52);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == 't') ADVANCE(61);
      if (lookahead == 'y') ADVANCE(62);
      END_STATE();
    case 15:
      if (lookahead == '1') ADVANCE(63);
      if (lookahead == '3') ADVANCE(64);
      if (lookahead == '6') ADVANCE(65);
      if (lookahead == '8') ADVANCE(66);
      if (lookahead == 'n') ADVANCE(67);
      if (lookahead == 's') ADVANCE(68);
      END_STATE();
    case 16:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(70);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(72);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 21:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(77);
      END_STATE();
    case 25:
      if (lookahead == 'n') ADVANCE(78);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(79);
      END_STATE();
    case 27:
      if (lookahead == 'f') ADVANCE(80);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(82);
      END_STATE();
    case 30:
      if (lookahead == 'u') ADVANCE(83);
      END_STATE();
    case 31:
      if (lookahead == 'p') ADVANCE(84);
      if (lookahead == 't') ADVANCE(85);
      END_STATE();
    case 32:
      if (lookahead == '2') ADVANCE(86);
      END_STATE();
    case 33:
      if (lookahead == '4') ADVANCE(87);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(88);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 36:
      if (lookahead == 'r') ADVANCE(89);
      END_STATE();
    case 37:
      if (lookahead == '2') ADVANCE(90);
      if (lookahead == '6') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == '2') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == '4') ADVANCE(93);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_i8);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 43:
      if (lookahead == 'p') ADVANCE(95);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 45:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 47:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 48:
      if (lookahead == 'f') ADVANCE(99);
      if (lookahead == 't') ADVANCE(100);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(101);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(104);
      if (lookahead == 'v') ADVANCE(105);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(108);
      END_STATE();
    case 56:
      if (lookahead == 'f') ADVANCE(109);
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(111);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(112);
      if (lookahead == 'm') ADVANCE(113);
      if (lookahead == 'r') ADVANCE(114);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(115);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(116);
      if (lookahead == 'u') ADVANCE(117);
      if (lookahead == 'y') ADVANCE(118);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_tt);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_ty);
      if (lookahead == 'p') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == '2') ADVANCE(120);
      if (lookahead == '6') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == '2') ADVANCE(122);
      END_STATE();
    case 65:
      if (lookahead == '4') ADVANCE(123);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_u8);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(124);
      if (lookahead == 's') ADVANCE(125);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(126);
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 's') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(129);
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(134);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(135);
      END_STATE();
    case 76:
      if (lookahead == 'a') ADVANCE(136);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 78:
      if (lookahead == 's') ADVANCE(138);
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 79:
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_dyn);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(142);
      END_STATE();
    case 83:
      if (lookahead == 'm') ADVANCE(143);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(144);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_f32);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_f64);
      END_STATE();
    case 88:
      if (lookahead == 's') ADVANCE(146);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 90:
      if (lookahead == '8') ADVANCE(147);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_i16);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_i32);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_i64);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(149);
      END_STATE();
    case 96:
      if (lookahead == 'z') ADVANCE(150);
      END_STATE();
    case 97:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 101:
      if (lookahead == 'p') ADVANCE(154);
      END_STATE();
    case 102:
      if (lookahead == 'c') ADVANCE(155);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(156);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_mod);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_mutable_specifier);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_pat);
      if (lookahead == 'h') ADVANCE(158);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_pub);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 110:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 111:
      if (lookahead == 'f') ADVANCE(160);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 113:
      if (lookahead == 't') ADVANCE(162);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_str);
      if (lookahead == 'u') ADVANCE(163);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 116:
      if (lookahead == 'i') ADVANCE(165);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(166);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 120:
      if (lookahead == '8') ADVANCE(168);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_u16);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_u32);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_u64);
      END_STATE();
    case 124:
      if (lookahead == 'o') ADVANCE(169);
      END_STATE();
    case 125:
      if (lookahead == 'a') ADVANCE(170);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 127:
      if (lookahead == 'z') ADVANCE(171);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_vis);
      END_STATE();
    case 129:
      if (lookahead == 'r') ADVANCE(172);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(173);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(174);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(175);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 134:
      if (lookahead == 'k') ADVANCE(177);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 136:
      if (lookahead == 'k') ADVANCE(178);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_char);
      END_STATE();
    case 138:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 139:
      if (lookahead == 'i') ADVANCE(180);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 141:
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_expr);
      END_STATE();
    case 145:
      if (lookahead == 'r') ADVANCE(183);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_i128);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_impl);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_item);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(187);
      END_STATE();
    case 153:
      if (lookahead == 'r') ADVANCE(188);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_loop);
      END_STATE();
    case 155:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_meta);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_move);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_path);
      END_STATE();
    case 159:
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 161:
      if (lookahead == 'i') ADVANCE(191);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_stmt);
      END_STATE();
    case 163:
      if (lookahead == 'c') ADVANCE(192);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 165:
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_u128);
      END_STATE();
    case 169:
      if (lookahead == 'n') ADVANCE(195);
      END_STATE();
    case 170:
      if (lookahead == 'f') ADVANCE(196);
      END_STATE();
    case 171:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 172:
      if (lookahead == 'e') ADVANCE(198);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 174:
      if (lookahead == 'd') ADVANCE(200);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_block);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 180:
      if (lookahead == 'n') ADVANCE(201);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_crate);
      END_STATE();
    case 182:
      if (lookahead == 'l') ADVANCE(202);
      END_STATE();
    case 183:
      if (lookahead == 'n') ADVANCE(203);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_ident);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_isize);
      END_STATE();
    case 187:
      if (lookahead == 'i') ADVANCE(204);
      END_STATE();
    case 188:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 190:
      if (lookahead == 'n') ADVANCE(206);
      END_STATE();
    case 191:
      if (lookahead == 'c') ADVANCE(207);
      END_STATE();
    case 192:
      if (lookahead == 't') ADVANCE(208);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_trait);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_usize);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 201:
      if (lookahead == 'u') ADVANCE(210);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 204:
      if (lookahead == 'm') ADVANCE(212);
      END_STATE();
    case 205:
      if (lookahead == 'l') ADVANCE(213);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_literal);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_lifetime);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 68, .external_lex_state = 2},
  [2] = {.lex_state = 69, .external_lex_state = 2},
  [3] = {.lex_state = 69, .external_lex_state = 2},
  [4] = {.lex_state = 69, .external_lex_state = 2},
  [5] = {.lex_state = 69, .external_lex_state = 2},
  [6] = {.lex_state = 69, .external_lex_state = 2},
  [7] = {.lex_state = 69, .external_lex_state = 2},
  [8] = {.lex_state = 69, .external_lex_state = 2},
  [9] = {.lex_state = 69, .external_lex_state = 2},
  [10] = {.lex_state = 69, .external_lex_state = 2},
  [11] = {.lex_state = 69, .external_lex_state = 2},
  [12] = {.lex_state = 69, .external_lex_state = 2},
  [13] = {.lex_state = 69, .external_lex_state = 2},
  [14] = {.lex_state = 69, .external_lex_state = 2},
  [15] = {.lex_state = 69, .external_lex_state = 2},
  [16] = {.lex_state = 69, .external_lex_state = 2},
  [17] = {.lex_state = 69, .external_lex_state = 2},
  [18] = {.lex_state = 69, .external_lex_state = 2},
  [19] = {.lex_state = 69, .external_lex_state = 2},
  [20] = {.lex_state = 69, .external_lex_state = 2},
  [21] = {.lex_state = 69, .external_lex_state = 2},
  [22] = {.lex_state = 69, .external_lex_state = 2},
  [23] = {.lex_state = 69, .external_lex_state = 2},
  [24] = {.lex_state = 69, .external_lex_state = 2},
  [25] = {.lex_state = 69, .external_lex_state = 2},
  [26] = {.lex_state = 69, .external_lex_state = 2},
  [27] = {.lex_state = 69, .external_lex_state = 2},
  [28] = {.lex_state = 69, .external_lex_state = 2},
  [29] = {.lex_state = 69, .external_lex_state = 2},
  [30] = {.lex_state = 69, .external_lex_state = 2},
  [31] = {.lex_state = 69, .external_lex_state = 2},
  [32] = {.lex_state = 69, .external_lex_state = 2},
  [33] = {.lex_state = 69, .external_lex_state = 2},
  [34] = {.lex_state = 69, .external_lex_state = 2},
  [35] = {.lex_state = 2, .external_lex_state = 2},
  [36] = {.lex_state = 2, .external_lex_state = 2},
  [37] = {.lex_state = 2, .external_lex_state = 2},
  [38] = {.lex_state = 2, .external_lex_state = 2},
  [39] = {.lex_state = 2, .external_lex_state = 2},
  [40] = {.lex_state = 2, .external_lex_state = 2},
  [41] = {.lex_state = 2, .external_lex_state = 2},
  [42] = {.lex_state = 2, .external_lex_state = 2},
  [43] = {.lex_state = 4, .external_lex_state = 2},
  [44] = {.lex_state = 4, .external_lex_state = 2},
  [45] = {.lex_state = 4, .external_lex_state = 2},
  [46] = {.lex_state = 4, .external_lex_state = 2},
  [47] = {.lex_state = 4, .external_lex_state = 2},
  [48] = {.lex_state = 2, .external_lex_state = 2},
  [49] = {.lex_state = 4, .external_lex_state = 2},
  [50] = {.lex_state = 4, .external_lex_state = 2},
  [51] = {.lex_state = 4, .external_lex_state = 2},
  [52] = {.lex_state = 2, .external_lex_state = 2},
  [53] = {.lex_state = 2, .external_lex_state = 2},
  [54] = {.lex_state = 2, .external_lex_state = 2},
  [55] = {.lex_state = 2, .external_lex_state = 2},
  [56] = {.lex_state = 2, .external_lex_state = 2},
  [57] = {.lex_state = 2, .external_lex_state = 2},
  [58] = {.lex_state = 2, .external_lex_state = 2},
  [59] = {.lex_state = 2, .external_lex_state = 2},
  [60] = {.lex_state = 2, .external_lex_state = 2},
  [61] = {.lex_state = 2, .external_lex_state = 2},
  [62] = {.lex_state = 2, .external_lex_state = 2},
  [63] = {.lex_state = 2, .external_lex_state = 2},
  [64] = {.lex_state = 2, .external_lex_state = 2},
  [65] = {.lex_state = 2, .external_lex_state = 2},
  [66] = {.lex_state = 2, .external_lex_state = 2},
  [67] = {.lex_state = 1, .external_lex_state = 2},
  [68] = {.lex_state = 1, .external_lex_state = 2},
  [69] = {.lex_state = 1, .external_lex_state = 2},
  [70] = {.lex_state = 1, .external_lex_state = 2},
  [71] = {.lex_state = 1, .external_lex_state = 2},
  [72] = {.lex_state = 1, .external_lex_state = 2},
  [73] = {.lex_state = 1, .external_lex_state = 2},
  [74] = {.lex_state = 1, .external_lex_state = 2},
  [75] = {.lex_state = 1, .external_lex_state = 2},
  [76] = {.lex_state = 1, .external_lex_state = 2},
  [77] = {.lex_state = 3, .external_lex_state = 2},
  [78] = {.lex_state = 1, .external_lex_state = 2},
  [79] = {.lex_state = 1, .external_lex_state = 2},
  [80] = {.lex_state = 1, .external_lex_state = 2},
  [81] = {.lex_state = 1, .external_lex_state = 2},
  [82] = {.lex_state = 1, .external_lex_state = 2},
  [83] = {.lex_state = 1, .external_lex_state = 2},
  [84] = {.lex_state = 1, .external_lex_state = 2},
  [85] = {.lex_state = 3, .external_lex_state = 2},
  [86] = {.lex_state = 3, .external_lex_state = 2},
  [87] = {.lex_state = 1, .external_lex_state = 2},
  [88] = {.lex_state = 3, .external_lex_state = 2},
  [89] = {.lex_state = 1, .external_lex_state = 2},
  [90] = {.lex_state = 3, .external_lex_state = 2},
  [91] = {.lex_state = 3, .external_lex_state = 2},
  [92] = {.lex_state = 3, .external_lex_state = 2},
  [93] = {.lex_state = 1, .external_lex_state = 2},
  [94] = {.lex_state = 1, .external_lex_state = 2},
  [95] = {.lex_state = 3, .external_lex_state = 2},
  [96] = {.lex_state = 3, .external_lex_state = 2},
  [97] = {.lex_state = 3, .external_lex_state = 2},
  [98] = {.lex_state = 1, .external_lex_state = 2},
  [99] = {.lex_state = 3, .external_lex_state = 2},
  [100] = {.lex_state = 3, .external_lex_state = 2},
  [101] = {.lex_state = 3, .external_lex_state = 2},
  [102] = {.lex_state = 3, .external_lex_state = 2},
  [103] = {.lex_state = 3, .external_lex_state = 2},
  [104] = {.lex_state = 3, .external_lex_state = 2},
  [105] = {.lex_state = 3, .external_lex_state = 2},
  [106] = {.lex_state = 3, .external_lex_state = 2},
  [107] = {.lex_state = 3, .external_lex_state = 2},
  [108] = {.lex_state = 3, .external_lex_state = 2},
  [109] = {.lex_state = 1, .external_lex_state = 2},
  [110] = {.lex_state = 1, .external_lex_state = 2},
  [111] = {.lex_state = 3, .external_lex_state = 2},
  [112] = {.lex_state = 1, .external_lex_state = 2},
  [113] = {.lex_state = 1, .external_lex_state = 2},
  [114] = {.lex_state = 1, .external_lex_state = 2},
  [115] = {.lex_state = 3, .external_lex_state = 2},
  [116] = {.lex_state = 3, .external_lex_state = 2},
  [117] = {.lex_state = 1, .external_lex_state = 2},
  [118] = {.lex_state = 3, .external_lex_state = 2},
  [119] = {.lex_state = 3, .external_lex_state = 2},
  [120] = {.lex_state = 1, .external_lex_state = 2},
  [121] = {.lex_state = 3, .external_lex_state = 2},
  [122] = {.lex_state = 3, .external_lex_state = 2},
  [123] = {.lex_state = 3, .external_lex_state = 2},
  [124] = {.lex_state = 3, .external_lex_state = 2},
  [125] = {.lex_state = 3, .external_lex_state = 2},
  [126] = {.lex_state = 3, .external_lex_state = 2},
  [127] = {.lex_state = 1, .external_lex_state = 2},
  [128] = {.lex_state = 3, .external_lex_state = 2},
  [129] = {.lex_state = 3, .external_lex_state = 2},
  [130] = {.lex_state = 3, .external_lex_state = 2},
  [131] = {.lex_state = 3, .external_lex_state = 2},
  [132] = {.lex_state = 3, .external_lex_state = 2},
  [133] = {.lex_state = 3, .external_lex_state = 2},
  [134] = {.lex_state = 1, .external_lex_state = 2},
  [135] = {.lex_state = 1, .external_lex_state = 2},
  [136] = {.lex_state = 1, .external_lex_state = 2},
  [137] = {.lex_state = 10, .external_lex_state = 2},
  [138] = {.lex_state = 10, .external_lex_state = 2},
  [139] = {.lex_state = 1, .external_lex_state = 2},
  [140] = {.lex_state = 10, .external_lex_state = 2},
  [141] = {.lex_state = 10, .external_lex_state = 2},
  [142] = {.lex_state = 1, .external_lex_state = 2},
  [143] = {.lex_state = 1, .external_lex_state = 2},
  [144] = {.lex_state = 1, .external_lex_state = 2},
  [145] = {.lex_state = 1, .external_lex_state = 2},
  [146] = {.lex_state = 1, .external_lex_state = 2},
  [147] = {.lex_state = 1, .external_lex_state = 2},
  [148] = {.lex_state = 1, .external_lex_state = 2},
  [149] = {.lex_state = 10, .external_lex_state = 2},
  [150] = {.lex_state = 1, .external_lex_state = 2},
  [151] = {.lex_state = 1, .external_lex_state = 2},
  [152] = {.lex_state = 1, .external_lex_state = 2},
  [153] = {.lex_state = 1, .external_lex_state = 2},
  [154] = {.lex_state = 3, .external_lex_state = 2},
  [155] = {.lex_state = 1, .external_lex_state = 2},
  [156] = {.lex_state = 3, .external_lex_state = 2},
  [157] = {.lex_state = 1, .external_lex_state = 2},
  [158] = {.lex_state = 1, .external_lex_state = 2},
  [159] = {.lex_state = 1, .external_lex_state = 2},
  [160] = {.lex_state = 10, .external_lex_state = 2},
  [161] = {.lex_state = 1, .external_lex_state = 2},
  [162] = {.lex_state = 1, .external_lex_state = 2},
  [163] = {.lex_state = 1, .external_lex_state = 2},
  [164] = {.lex_state = 1, .external_lex_state = 2},
  [165] = {.lex_state = 10, .external_lex_state = 2},
  [166] = {.lex_state = 10, .external_lex_state = 2},
  [167] = {.lex_state = 1, .external_lex_state = 2},
  [168] = {.lex_state = 1, .external_lex_state = 2},
  [169] = {.lex_state = 10, .external_lex_state = 2},
  [170] = {.lex_state = 10, .external_lex_state = 2},
  [171] = {.lex_state = 10, .external_lex_state = 2},
  [172] = {.lex_state = 10, .external_lex_state = 2},
  [173] = {.lex_state = 10, .external_lex_state = 2},
  [174] = {.lex_state = 3, .external_lex_state = 2},
  [175] = {.lex_state = 3, .external_lex_state = 2},
  [176] = {.lex_state = 10, .external_lex_state = 2},
  [177] = {.lex_state = 10, .external_lex_state = 2},
  [178] = {.lex_state = 10, .external_lex_state = 2},
  [179] = {.lex_state = 10, .external_lex_state = 2},
  [180] = {.lex_state = 3, .external_lex_state = 2},
  [181] = {.lex_state = 10, .external_lex_state = 2},
  [182] = {.lex_state = 10, .external_lex_state = 2},
  [183] = {.lex_state = 3, .external_lex_state = 2},
  [184] = {.lex_state = 10, .external_lex_state = 2},
  [185] = {.lex_state = 3, .external_lex_state = 2},
  [186] = {.lex_state = 10, .external_lex_state = 2},
  [187] = {.lex_state = 3, .external_lex_state = 2},
  [188] = {.lex_state = 10, .external_lex_state = 2},
  [189] = {.lex_state = 10, .external_lex_state = 2},
  [190] = {.lex_state = 10, .external_lex_state = 2},
  [191] = {.lex_state = 10, .external_lex_state = 2},
  [192] = {.lex_state = 10, .external_lex_state = 2},
  [193] = {.lex_state = 3, .external_lex_state = 2},
  [194] = {.lex_state = 10, .external_lex_state = 2},
  [195] = {.lex_state = 10, .external_lex_state = 2},
  [196] = {.lex_state = 10, .external_lex_state = 2},
  [197] = {.lex_state = 3, .external_lex_state = 2},
  [198] = {.lex_state = 10, .external_lex_state = 2},
  [199] = {.lex_state = 3, .external_lex_state = 2},
  [200] = {.lex_state = 10, .external_lex_state = 2},
  [201] = {.lex_state = 3, .external_lex_state = 2},
  [202] = {.lex_state = 10, .external_lex_state = 2},
  [203] = {.lex_state = 10, .external_lex_state = 2},
  [204] = {.lex_state = 3, .external_lex_state = 2},
  [205] = {.lex_state = 10, .external_lex_state = 2},
  [206] = {.lex_state = 10, .external_lex_state = 2},
  [207] = {.lex_state = 10, .external_lex_state = 2},
  [208] = {.lex_state = 10, .external_lex_state = 2},
  [209] = {.lex_state = 10, .external_lex_state = 2},
  [210] = {.lex_state = 10, .external_lex_state = 2},
  [211] = {.lex_state = 10, .external_lex_state = 2},
  [212] = {.lex_state = 10, .external_lex_state = 2},
  [213] = {.lex_state = 10, .external_lex_state = 2},
  [214] = {.lex_state = 10, .external_lex_state = 2},
  [215] = {.lex_state = 10, .external_lex_state = 2},
  [216] = {.lex_state = 12, .external_lex_state = 2},
  [217] = {.lex_state = 10, .external_lex_state = 2},
  [218] = {.lex_state = 12, .external_lex_state = 2},
  [219] = {.lex_state = 12, .external_lex_state = 2},
  [220] = {.lex_state = 12, .external_lex_state = 2},
  [221] = {.lex_state = 12, .external_lex_state = 2},
  [222] = {.lex_state = 12, .external_lex_state = 2},
  [223] = {.lex_state = 10, .external_lex_state = 2},
  [224] = {.lex_state = 12, .external_lex_state = 2},
  [225] = {.lex_state = 10, .external_lex_state = 2},
  [226] = {.lex_state = 10, .external_lex_state = 2},
  [227] = {.lex_state = 10, .external_lex_state = 2},
  [228] = {.lex_state = 10, .external_lex_state = 2},
  [229] = {.lex_state = 12, .external_lex_state = 2},
  [230] = {.lex_state = 10, .external_lex_state = 2},
  [231] = {.lex_state = 12, .external_lex_state = 2},
  [232] = {.lex_state = 12, .external_lex_state = 2},
  [233] = {.lex_state = 10, .external_lex_state = 2},
  [234] = {.lex_state = 12, .external_lex_state = 2},
  [235] = {.lex_state = 10, .external_lex_state = 2},
  [236] = {.lex_state = 10, .external_lex_state = 2},
  [237] = {.lex_state = 10, .external_lex_state = 2},
  [238] = {.lex_state = 12, .external_lex_state = 2},
  [239] = {.lex_state = 12, .external_lex_state = 2},
  [240] = {.lex_state = 12, .external_lex_state = 2},
  [241] = {.lex_state = 12, .external_lex_state = 2},
  [242] = {.lex_state = 10, .external_lex_state = 2},
  [243] = {.lex_state = 10, .external_lex_state = 2},
  [244] = {.lex_state = 10, .external_lex_state = 2},
  [245] = {.lex_state = 67, .external_lex_state = 2},
  [246] = {.lex_state = 10, .external_lex_state = 2},
  [247] = {.lex_state = 10, .external_lex_state = 2},
  [248] = {.lex_state = 10, .external_lex_state = 2},
  [249] = {.lex_state = 67, .external_lex_state = 2},
  [250] = {.lex_state = 10, .external_lex_state = 2},
  [251] = {.lex_state = 10, .external_lex_state = 2},
  [252] = {.lex_state = 10, .external_lex_state = 2},
  [253] = {.lex_state = 10, .external_lex_state = 2},
  [254] = {.lex_state = 10, .external_lex_state = 2},
  [255] = {.lex_state = 10, .external_lex_state = 2},
  [256] = {.lex_state = 10, .external_lex_state = 2},
  [257] = {.lex_state = 10, .external_lex_state = 2},
  [258] = {.lex_state = 10, .external_lex_state = 2},
  [259] = {.lex_state = 10, .external_lex_state = 2},
  [260] = {.lex_state = 10, .external_lex_state = 2},
  [261] = {.lex_state = 10, .external_lex_state = 2},
  [262] = {.lex_state = 10, .external_lex_state = 2},
  [263] = {.lex_state = 10, .external_lex_state = 2},
  [264] = {.lex_state = 10, .external_lex_state = 2},
  [265] = {.lex_state = 10, .external_lex_state = 2},
  [266] = {.lex_state = 10, .external_lex_state = 2},
  [267] = {.lex_state = 10, .external_lex_state = 2},
  [268] = {.lex_state = 10, .external_lex_state = 2},
  [269] = {.lex_state = 10, .external_lex_state = 2},
  [270] = {.lex_state = 10, .external_lex_state = 2},
  [271] = {.lex_state = 10, .external_lex_state = 2},
  [272] = {.lex_state = 10, .external_lex_state = 2},
  [273] = {.lex_state = 10, .external_lex_state = 2},
  [274] = {.lex_state = 10, .external_lex_state = 2},
  [275] = {.lex_state = 10, .external_lex_state = 2},
  [276] = {.lex_state = 10, .external_lex_state = 2},
  [277] = {.lex_state = 10, .external_lex_state = 2},
  [278] = {.lex_state = 10, .external_lex_state = 2},
  [279] = {.lex_state = 10, .external_lex_state = 2},
  [280] = {.lex_state = 10, .external_lex_state = 2},
  [281] = {.lex_state = 10, .external_lex_state = 2},
  [282] = {.lex_state = 10, .external_lex_state = 2},
  [283] = {.lex_state = 10, .external_lex_state = 2},
  [284] = {.lex_state = 10, .external_lex_state = 2},
  [285] = {.lex_state = 10, .external_lex_state = 2},
  [286] = {.lex_state = 10, .external_lex_state = 2},
  [287] = {.lex_state = 10, .external_lex_state = 2},
  [288] = {.lex_state = 10, .external_lex_state = 2},
  [289] = {.lex_state = 10, .external_lex_state = 2},
  [290] = {.lex_state = 10, .external_lex_state = 2},
  [291] = {.lex_state = 10, .external_lex_state = 2},
  [292] = {.lex_state = 10, .external_lex_state = 2},
  [293] = {.lex_state = 10, .external_lex_state = 2},
  [294] = {.lex_state = 10, .external_lex_state = 2},
  [295] = {.lex_state = 10, .external_lex_state = 2},
  [296] = {.lex_state = 10, .external_lex_state = 2},
  [297] = {.lex_state = 10, .external_lex_state = 2},
  [298] = {.lex_state = 10, .external_lex_state = 2},
  [299] = {.lex_state = 10, .external_lex_state = 2},
  [300] = {.lex_state = 10, .external_lex_state = 2},
  [301] = {.lex_state = 10, .external_lex_state = 2},
  [302] = {.lex_state = 10, .external_lex_state = 2},
  [303] = {.lex_state = 10, .external_lex_state = 2},
  [304] = {.lex_state = 10, .external_lex_state = 2},
  [305] = {.lex_state = 10, .external_lex_state = 2},
  [306] = {.lex_state = 10, .external_lex_state = 2},
  [307] = {.lex_state = 10, .external_lex_state = 2},
  [308] = {.lex_state = 10, .external_lex_state = 2},
  [309] = {.lex_state = 10, .external_lex_state = 2},
  [310] = {.lex_state = 10, .external_lex_state = 2},
  [311] = {.lex_state = 10, .external_lex_state = 2},
  [312] = {.lex_state = 10, .external_lex_state = 2},
  [313] = {.lex_state = 10, .external_lex_state = 2},
  [314] = {.lex_state = 10, .external_lex_state = 2},
  [315] = {.lex_state = 10, .external_lex_state = 2},
  [316] = {.lex_state = 10, .external_lex_state = 2},
  [317] = {.lex_state = 10, .external_lex_state = 2},
  [318] = {.lex_state = 10, .external_lex_state = 2},
  [319] = {.lex_state = 10, .external_lex_state = 2},
  [320] = {.lex_state = 10, .external_lex_state = 2},
  [321] = {.lex_state = 10, .external_lex_state = 2},
  [322] = {.lex_state = 10, .external_lex_state = 2},
  [323] = {.lex_state = 10, .external_lex_state = 2},
  [324] = {.lex_state = 10, .external_lex_state = 2},
  [325] = {.lex_state = 10, .external_lex_state = 2},
  [326] = {.lex_state = 67, .external_lex_state = 2},
  [327] = {.lex_state = 10, .external_lex_state = 2},
  [328] = {.lex_state = 10, .external_lex_state = 2},
  [329] = {.lex_state = 10, .external_lex_state = 2},
  [330] = {.lex_state = 10, .external_lex_state = 2},
  [331] = {.lex_state = 10, .external_lex_state = 2},
  [332] = {.lex_state = 10, .external_lex_state = 2},
  [333] = {.lex_state = 10, .external_lex_state = 2},
  [334] = {.lex_state = 10, .external_lex_state = 2},
  [335] = {.lex_state = 67, .external_lex_state = 2},
  [336] = {.lex_state = 10, .external_lex_state = 2},
  [337] = {.lex_state = 10, .external_lex_state = 2},
  [338] = {.lex_state = 10, .external_lex_state = 2},
  [339] = {.lex_state = 10, .external_lex_state = 2},
  [340] = {.lex_state = 10, .external_lex_state = 2},
  [341] = {.lex_state = 10, .external_lex_state = 2},
  [342] = {.lex_state = 10, .external_lex_state = 2},
  [343] = {.lex_state = 10, .external_lex_state = 2},
  [344] = {.lex_state = 10, .external_lex_state = 2},
  [345] = {.lex_state = 10, .external_lex_state = 2},
  [346] = {.lex_state = 10, .external_lex_state = 2},
  [347] = {.lex_state = 10, .external_lex_state = 2},
  [348] = {.lex_state = 10, .external_lex_state = 2},
  [349] = {.lex_state = 10, .external_lex_state = 2},
  [350] = {.lex_state = 10, .external_lex_state = 2},
  [351] = {.lex_state = 10, .external_lex_state = 2},
  [352] = {.lex_state = 10, .external_lex_state = 2},
  [353] = {.lex_state = 67, .external_lex_state = 2},
  [354] = {.lex_state = 10, .external_lex_state = 2},
  [355] = {.lex_state = 10, .external_lex_state = 2},
  [356] = {.lex_state = 10, .external_lex_state = 2},
  [357] = {.lex_state = 10, .external_lex_state = 2},
  [358] = {.lex_state = 10, .external_lex_state = 2},
  [359] = {.lex_state = 10, .external_lex_state = 2},
  [360] = {.lex_state = 67, .external_lex_state = 2},
  [361] = {.lex_state = 10, .external_lex_state = 2},
  [362] = {.lex_state = 10, .external_lex_state = 2},
  [363] = {.lex_state = 10, .external_lex_state = 2},
  [364] = {.lex_state = 10, .external_lex_state = 2},
  [365] = {.lex_state = 10, .external_lex_state = 2},
  [366] = {.lex_state = 10, .external_lex_state = 2},
  [367] = {.lex_state = 10, .external_lex_state = 2},
  [368] = {.lex_state = 10, .external_lex_state = 2},
  [369] = {.lex_state = 10, .external_lex_state = 2},
  [370] = {.lex_state = 10, .external_lex_state = 2},
  [371] = {.lex_state = 67, .external_lex_state = 2},
  [372] = {.lex_state = 11, .external_lex_state = 2},
  [373] = {.lex_state = 67, .external_lex_state = 2},
  [374] = {.lex_state = 67, .external_lex_state = 2},
  [375] = {.lex_state = 11, .external_lex_state = 2},
  [376] = {.lex_state = 67, .external_lex_state = 2},
  [377] = {.lex_state = 67, .external_lex_state = 2},
  [378] = {.lex_state = 67, .external_lex_state = 2},
  [379] = {.lex_state = 67, .external_lex_state = 2},
  [380] = {.lex_state = 67, .external_lex_state = 2},
  [381] = {.lex_state = 67, .external_lex_state = 2},
  [382] = {.lex_state = 11, .external_lex_state = 2},
  [383] = {.lex_state = 11, .external_lex_state = 2},
  [384] = {.lex_state = 67, .external_lex_state = 2},
  [385] = {.lex_state = 67, .external_lex_state = 2},
  [386] = {.lex_state = 67, .external_lex_state = 2},
  [387] = {.lex_state = 67, .external_lex_state = 2},
  [388] = {.lex_state = 11, .external_lex_state = 2},
  [389] = {.lex_state = 67, .external_lex_state = 2},
  [390] = {.lex_state = 67, .external_lex_state = 2},
  [391] = {.lex_state = 67, .external_lex_state = 2},
  [392] = {.lex_state = 67, .external_lex_state = 2},
  [393] = {.lex_state = 67, .external_lex_state = 2},
  [394] = {.lex_state = 67, .external_lex_state = 2},
  [395] = {.lex_state = 67, .external_lex_state = 2},
  [396] = {.lex_state = 11, .external_lex_state = 2},
  [397] = {.lex_state = 67, .external_lex_state = 2},
  [398] = {.lex_state = 67, .external_lex_state = 2},
  [399] = {.lex_state = 67, .external_lex_state = 2},
  [400] = {.lex_state = 11, .external_lex_state = 2},
  [401] = {.lex_state = 67, .external_lex_state = 2},
  [402] = {.lex_state = 11, .external_lex_state = 2},
  [403] = {.lex_state = 11, .external_lex_state = 2},
  [404] = {.lex_state = 11, .external_lex_state = 2},
  [405] = {.lex_state = 11, .external_lex_state = 2},
  [406] = {.lex_state = 11, .external_lex_state = 2},
  [407] = {.lex_state = 11, .external_lex_state = 2},
  [408] = {.lex_state = 11, .external_lex_state = 2},
  [409] = {.lex_state = 11, .external_lex_state = 2},
  [410] = {.lex_state = 11, .external_lex_state = 2},
  [411] = {.lex_state = 10, .external_lex_state = 2},
  [412] = {.lex_state = 10, .external_lex_state = 2},
  [413] = {.lex_state = 10, .external_lex_state = 2},
  [414] = {.lex_state = 11, .external_lex_state = 2},
  [415] = {.lex_state = 11, .external_lex_state = 2},
  [416] = {.lex_state = 11, .external_lex_state = 2},
  [417] = {.lex_state = 11, .external_lex_state = 2},
  [418] = {.lex_state = 10, .external_lex_state = 2},
  [419] = {.lex_state = 10, .external_lex_state = 2},
  [420] = {.lex_state = 10, .external_lex_state = 2},
  [421] = {.lex_state = 10, .external_lex_state = 2},
  [422] = {.lex_state = 10, .external_lex_state = 2},
  [423] = {.lex_state = 10, .external_lex_state = 2},
  [424] = {.lex_state = 10, .external_lex_state = 2},
  [425] = {.lex_state = 10, .external_lex_state = 2},
  [426] = {.lex_state = 10, .external_lex_state = 2},
  [427] = {.lex_state = 10, .external_lex_state = 2},
  [428] = {.lex_state = 10, .external_lex_state = 2},
  [429] = {.lex_state = 2, .external_lex_state = 2},
  [430] = {.lex_state = 4, .external_lex_state = 2},
  [431] = {.lex_state = 12, .external_lex_state = 2},
  [432] = {.lex_state = 12, .external_lex_state = 2},
  [433] = {.lex_state = 10, .external_lex_state = 2},
  [434] = {.lex_state = 10, .external_lex_state = 2},
  [435] = {.lex_state = 10, .external_lex_state = 2},
  [436] = {.lex_state = 10, .external_lex_state = 2},
  [437] = {.lex_state = 10, .external_lex_state = 2},
  [438] = {.lex_state = 10, .external_lex_state = 2},
  [439] = {.lex_state = 10, .external_lex_state = 2},
  [440] = {.lex_state = 10, .external_lex_state = 2},
  [441] = {.lex_state = 10, .external_lex_state = 2},
  [442] = {.lex_state = 10, .external_lex_state = 2},
  [443] = {.lex_state = 10, .external_lex_state = 2},
  [444] = {.lex_state = 10, .external_lex_state = 2},
  [445] = {.lex_state = 10, .external_lex_state = 2},
  [446] = {.lex_state = 2, .external_lex_state = 2},
  [447] = {.lex_state = 2, .external_lex_state = 2},
  [448] = {.lex_state = 2, .external_lex_state = 2},
  [449] = {.lex_state = 2, .external_lex_state = 2},
  [450] = {.lex_state = 2, .external_lex_state = 2},
  [451] = {.lex_state = 2, .external_lex_state = 2},
  [452] = {.lex_state = 2, .external_lex_state = 2},
  [453] = {.lex_state = 10, .external_lex_state = 2},
  [454] = {.lex_state = 2, .external_lex_state = 2},
  [455] = {.lex_state = 2, .external_lex_state = 2},
  [456] = {.lex_state = 2, .external_lex_state = 2},
  [457] = {.lex_state = 2, .external_lex_state = 2},
  [458] = {.lex_state = 2, .external_lex_state = 2},
  [459] = {.lex_state = 2, .external_lex_state = 2},
  [460] = {.lex_state = 2, .external_lex_state = 2},
  [461] = {.lex_state = 2, .external_lex_state = 2},
  [462] = {.lex_state = 2, .external_lex_state = 2},
  [463] = {.lex_state = 2, .external_lex_state = 2},
  [464] = {.lex_state = 2, .external_lex_state = 2},
  [465] = {.lex_state = 2, .external_lex_state = 2},
  [466] = {.lex_state = 10, .external_lex_state = 2},
  [467] = {.lex_state = 2, .external_lex_state = 2},
  [468] = {.lex_state = 10, .external_lex_state = 2},
  [469] = {.lex_state = 2, .external_lex_state = 2},
  [470] = {.lex_state = 2, .external_lex_state = 2},
  [471] = {.lex_state = 2, .external_lex_state = 2},
  [472] = {.lex_state = 2, .external_lex_state = 2},
  [473] = {.lex_state = 10, .external_lex_state = 2},
  [474] = {.lex_state = 2, .external_lex_state = 2},
  [475] = {.lex_state = 10, .external_lex_state = 2},
  [476] = {.lex_state = 10, .external_lex_state = 2},
  [477] = {.lex_state = 10, .external_lex_state = 2},
  [478] = {.lex_state = 10, .external_lex_state = 2},
  [479] = {.lex_state = 69, .external_lex_state = 2},
  [480] = {.lex_state = 69, .external_lex_state = 2},
  [481] = {.lex_state = 69, .external_lex_state = 2},
  [482] = {.lex_state = 69, .external_lex_state = 2},
  [483] = {.lex_state = 69, .external_lex_state = 2},
  [484] = {.lex_state = 69, .external_lex_state = 2},
  [485] = {.lex_state = 69, .external_lex_state = 2},
  [486] = {.lex_state = 69, .external_lex_state = 2},
  [487] = {.lex_state = 69, .external_lex_state = 2},
  [488] = {.lex_state = 69, .external_lex_state = 2},
  [489] = {.lex_state = 69, .external_lex_state = 2},
  [490] = {.lex_state = 69, .external_lex_state = 2},
  [491] = {.lex_state = 69, .external_lex_state = 2},
  [492] = {.lex_state = 69, .external_lex_state = 2},
  [493] = {.lex_state = 69, .external_lex_state = 2},
  [494] = {.lex_state = 69, .external_lex_state = 2},
  [495] = {.lex_state = 69, .external_lex_state = 2},
  [496] = {.lex_state = 69, .external_lex_state = 2},
  [497] = {.lex_state = 69, .external_lex_state = 2},
  [498] = {.lex_state = 69, .external_lex_state = 2},
  [499] = {.lex_state = 69, .external_lex_state = 2},
  [500] = {.lex_state = 69, .external_lex_state = 2},
  [501] = {.lex_state = 69, .external_lex_state = 2},
  [502] = {.lex_state = 69, .external_lex_state = 2},
  [503] = {.lex_state = 69, .external_lex_state = 2},
  [504] = {.lex_state = 69, .external_lex_state = 2},
  [505] = {.lex_state = 69, .external_lex_state = 2},
  [506] = {.lex_state = 69, .external_lex_state = 2},
  [507] = {.lex_state = 69, .external_lex_state = 2},
  [508] = {.lex_state = 69, .external_lex_state = 2},
  [509] = {.lex_state = 69, .external_lex_state = 2},
  [510] = {.lex_state = 69, .external_lex_state = 2},
  [511] = {.lex_state = 69, .external_lex_state = 2},
  [512] = {.lex_state = 69, .external_lex_state = 2},
  [513] = {.lex_state = 69, .external_lex_state = 2},
  [514] = {.lex_state = 69, .external_lex_state = 2},
  [515] = {.lex_state = 69, .external_lex_state = 2},
  [516] = {.lex_state = 69, .external_lex_state = 2},
  [517] = {.lex_state = 69, .external_lex_state = 2},
  [518] = {.lex_state = 69, .external_lex_state = 2},
  [519] = {.lex_state = 69, .external_lex_state = 2},
  [520] = {.lex_state = 69, .external_lex_state = 2},
  [521] = {.lex_state = 69, .external_lex_state = 2},
  [522] = {.lex_state = 69, .external_lex_state = 2},
  [523] = {.lex_state = 69, .external_lex_state = 2},
  [524] = {.lex_state = 69, .external_lex_state = 2},
  [525] = {.lex_state = 69, .external_lex_state = 2},
  [526] = {.lex_state = 69, .external_lex_state = 2},
  [527] = {.lex_state = 69, .external_lex_state = 2},
  [528] = {.lex_state = 69, .external_lex_state = 2},
  [529] = {.lex_state = 69, .external_lex_state = 2},
  [530] = {.lex_state = 69, .external_lex_state = 2},
  [531] = {.lex_state = 9},
  [532] = {.lex_state = 69, .external_lex_state = 2},
  [533] = {.lex_state = 69, .external_lex_state = 2},
  [534] = {.lex_state = 69, .external_lex_state = 2},
  [535] = {.lex_state = 69, .external_lex_state = 2},
  [536] = {.lex_state = 69, .external_lex_state = 2},
  [537] = {.lex_state = 69, .external_lex_state = 2},
  [538] = {.lex_state = 69, .external_lex_state = 2},
  [539] = {.lex_state = 69, .external_lex_state = 2},
  [540] = {.lex_state = 69, .external_lex_state = 2},
  [541] = {.lex_state = 69, .external_lex_state = 2},
  [542] = {.lex_state = 69, .external_lex_state = 2},
  [543] = {.lex_state = 69, .external_lex_state = 2},
  [544] = {.lex_state = 69, .external_lex_state = 2},
  [545] = {.lex_state = 69, .external_lex_state = 2},
  [546] = {.lex_state = 69, .external_lex_state = 2},
  [547] = {.lex_state = 69, .external_lex_state = 2},
  [548] = {.lex_state = 69, .external_lex_state = 2},
  [549] = {.lex_state = 69, .external_lex_state = 2},
  [550] = {.lex_state = 69, .external_lex_state = 2},
  [551] = {.lex_state = 69, .external_lex_state = 2},
  [552] = {.lex_state = 69, .external_lex_state = 2},
  [553] = {.lex_state = 69, .external_lex_state = 2},
  [554] = {.lex_state = 10, .external_lex_state = 2},
  [555] = {.lex_state = 69, .external_lex_state = 2},
  [556] = {.lex_state = 69, .external_lex_state = 2},
  [557] = {.lex_state = 69, .external_lex_state = 2},
  [558] = {.lex_state = 69, .external_lex_state = 2},
  [559] = {.lex_state = 69, .external_lex_state = 2},
  [560] = {.lex_state = 69, .external_lex_state = 2},
  [561] = {.lex_state = 69, .external_lex_state = 2},
  [562] = {.lex_state = 69, .external_lex_state = 2},
  [563] = {.lex_state = 69, .external_lex_state = 2},
  [564] = {.lex_state = 69, .external_lex_state = 2},
  [565] = {.lex_state = 69, .external_lex_state = 2},
  [566] = {.lex_state = 69, .external_lex_state = 2},
  [567] = {.lex_state = 69, .external_lex_state = 2},
  [568] = {.lex_state = 69, .external_lex_state = 2},
  [569] = {.lex_state = 69, .external_lex_state = 2},
  [570] = {.lex_state = 69, .external_lex_state = 2},
  [571] = {.lex_state = 69, .external_lex_state = 2},
  [572] = {.lex_state = 69, .external_lex_state = 2},
  [573] = {.lex_state = 69, .external_lex_state = 2},
  [574] = {.lex_state = 69, .external_lex_state = 2},
  [575] = {.lex_state = 69, .external_lex_state = 2},
  [576] = {.lex_state = 69, .external_lex_state = 2},
  [577] = {.lex_state = 69, .external_lex_state = 2},
  [578] = {.lex_state = 69, .external_lex_state = 2},
  [579] = {.lex_state = 69, .external_lex_state = 2},
  [580] = {.lex_state = 69, .external_lex_state = 2},
  [581] = {.lex_state = 69, .external_lex_state = 2},
  [582] = {.lex_state = 69, .external_lex_state = 2},
  [583] = {.lex_state = 69, .external_lex_state = 2},
  [584] = {.lex_state = 69, .external_lex_state = 2},
  [585] = {.lex_state = 69, .external_lex_state = 2},
  [586] = {.lex_state = 69, .external_lex_state = 2},
  [587] = {.lex_state = 69, .external_lex_state = 2},
  [588] = {.lex_state = 69, .external_lex_state = 2},
  [589] = {.lex_state = 69, .external_lex_state = 2},
  [590] = {.lex_state = 69, .external_lex_state = 2},
  [591] = {.lex_state = 69, .external_lex_state = 2},
  [592] = {.lex_state = 69, .external_lex_state = 2},
  [593] = {.lex_state = 69, .external_lex_state = 2},
  [594] = {.lex_state = 69, .external_lex_state = 2},
  [595] = {.lex_state = 69, .external_lex_state = 2},
  [596] = {.lex_state = 69, .external_lex_state = 2},
  [597] = {.lex_state = 69, .external_lex_state = 2},
  [598] = {.lex_state = 69, .external_lex_state = 2},
  [599] = {.lex_state = 69, .external_lex_state = 2},
  [600] = {.lex_state = 69, .external_lex_state = 2},
  [601] = {.lex_state = 69, .external_lex_state = 2},
  [602] = {.lex_state = 69, .external_lex_state = 2},
  [603] = {.lex_state = 69, .external_lex_state = 2},
  [604] = {.lex_state = 69, .external_lex_state = 2},
  [605] = {.lex_state = 69, .external_lex_state = 2},
  [606] = {.lex_state = 69, .external_lex_state = 2},
  [607] = {.lex_state = 69, .external_lex_state = 2},
  [608] = {.lex_state = 69, .external_lex_state = 2},
  [609] = {.lex_state = 69, .external_lex_state = 2},
  [610] = {.lex_state = 69, .external_lex_state = 2},
  [611] = {.lex_state = 69, .external_lex_state = 2},
  [612] = {.lex_state = 69, .external_lex_state = 2},
  [613] = {.lex_state = 69, .external_lex_state = 2},
  [614] = {.lex_state = 69, .external_lex_state = 2},
  [615] = {.lex_state = 69, .external_lex_state = 2},
  [616] = {.lex_state = 69, .external_lex_state = 2},
  [617] = {.lex_state = 69, .external_lex_state = 2},
  [618] = {.lex_state = 69, .external_lex_state = 2},
  [619] = {.lex_state = 69, .external_lex_state = 2},
  [620] = {.lex_state = 69, .external_lex_state = 2},
  [621] = {.lex_state = 69, .external_lex_state = 2},
  [622] = {.lex_state = 69, .external_lex_state = 2},
  [623] = {.lex_state = 69, .external_lex_state = 2},
  [624] = {.lex_state = 69, .external_lex_state = 2},
  [625] = {.lex_state = 69, .external_lex_state = 2},
  [626] = {.lex_state = 69, .external_lex_state = 2},
  [627] = {.lex_state = 69, .external_lex_state = 2},
  [628] = {.lex_state = 69, .external_lex_state = 2},
  [629] = {.lex_state = 9},
  [630] = {.lex_state = 69, .external_lex_state = 2},
  [631] = {.lex_state = 69, .external_lex_state = 2},
  [632] = {.lex_state = 69, .external_lex_state = 2},
  [633] = {.lex_state = 69, .external_lex_state = 2},
  [634] = {.lex_state = 69, .external_lex_state = 2},
  [635] = {.lex_state = 69, .external_lex_state = 2},
  [636] = {.lex_state = 69, .external_lex_state = 2},
  [637] = {.lex_state = 69, .external_lex_state = 2},
  [638] = {.lex_state = 69, .external_lex_state = 2},
  [639] = {.lex_state = 69, .external_lex_state = 2},
  [640] = {.lex_state = 69, .external_lex_state = 2},
  [641] = {.lex_state = 69, .external_lex_state = 2},
  [642] = {.lex_state = 69, .external_lex_state = 2},
  [643] = {.lex_state = 69, .external_lex_state = 2},
  [644] = {.lex_state = 69, .external_lex_state = 2},
  [645] = {.lex_state = 69, .external_lex_state = 2},
  [646] = {.lex_state = 69, .external_lex_state = 2},
  [647] = {.lex_state = 69, .external_lex_state = 2},
  [648] = {.lex_state = 69, .external_lex_state = 2},
  [649] = {.lex_state = 69, .external_lex_state = 2},
  [650] = {.lex_state = 69, .external_lex_state = 2},
  [651] = {.lex_state = 69, .external_lex_state = 2},
  [652] = {.lex_state = 69, .external_lex_state = 2},
  [653] = {.lex_state = 69, .external_lex_state = 2},
  [654] = {.lex_state = 69, .external_lex_state = 2},
  [655] = {.lex_state = 69, .external_lex_state = 2},
  [656] = {.lex_state = 69, .external_lex_state = 2},
  [657] = {.lex_state = 69, .external_lex_state = 2},
  [658] = {.lex_state = 69, .external_lex_state = 2},
  [659] = {.lex_state = 69, .external_lex_state = 2},
  [660] = {.lex_state = 69, .external_lex_state = 2},
  [661] = {.lex_state = 69, .external_lex_state = 2},
  [662] = {.lex_state = 69, .external_lex_state = 2},
  [663] = {.lex_state = 69, .external_lex_state = 2},
  [664] = {.lex_state = 69, .external_lex_state = 2},
  [665] = {.lex_state = 69, .external_lex_state = 2},
  [666] = {.lex_state = 69, .external_lex_state = 2},
  [667] = {.lex_state = 69, .external_lex_state = 2},
  [668] = {.lex_state = 9},
  [669] = {.lex_state = 69, .external_lex_state = 2},
  [670] = {.lex_state = 69, .external_lex_state = 2},
  [671] = {.lex_state = 69, .external_lex_state = 2},
  [672] = {.lex_state = 69, .external_lex_state = 2},
  [673] = {.lex_state = 69, .external_lex_state = 2},
  [674] = {.lex_state = 69, .external_lex_state = 2},
  [675] = {.lex_state = 69, .external_lex_state = 2},
  [676] = {.lex_state = 69, .external_lex_state = 2},
  [677] = {.lex_state = 69, .external_lex_state = 2},
  [678] = {.lex_state = 69, .external_lex_state = 2},
  [679] = {.lex_state = 69, .external_lex_state = 2},
  [680] = {.lex_state = 69, .external_lex_state = 2},
  [681] = {.lex_state = 69, .external_lex_state = 2},
  [682] = {.lex_state = 69, .external_lex_state = 2},
  [683] = {.lex_state = 69, .external_lex_state = 2},
  [684] = {.lex_state = 69, .external_lex_state = 2},
  [685] = {.lex_state = 69, .external_lex_state = 2},
  [686] = {.lex_state = 69, .external_lex_state = 2},
  [687] = {.lex_state = 69, .external_lex_state = 2},
  [688] = {.lex_state = 69, .external_lex_state = 2},
  [689] = {.lex_state = 69, .external_lex_state = 2},
  [690] = {.lex_state = 69, .external_lex_state = 2},
  [691] = {.lex_state = 69, .external_lex_state = 2},
  [692] = {.lex_state = 69, .external_lex_state = 2},
  [693] = {.lex_state = 69, .external_lex_state = 2},
  [694] = {.lex_state = 69, .external_lex_state = 2},
  [695] = {.lex_state = 69, .external_lex_state = 2},
  [696] = {.lex_state = 69, .external_lex_state = 2},
  [697] = {.lex_state = 69, .external_lex_state = 2},
  [698] = {.lex_state = 69, .external_lex_state = 2},
  [699] = {.lex_state = 69, .external_lex_state = 2},
  [700] = {.lex_state = 69, .external_lex_state = 2},
  [701] = {.lex_state = 69, .external_lex_state = 2},
  [702] = {.lex_state = 69, .external_lex_state = 2},
  [703] = {.lex_state = 69, .external_lex_state = 2},
  [704] = {.lex_state = 69, .external_lex_state = 2},
  [705] = {.lex_state = 69, .external_lex_state = 2},
  [706] = {.lex_state = 69, .external_lex_state = 2},
  [707] = {.lex_state = 9},
  [708] = {.lex_state = 69, .external_lex_state = 2},
  [709] = {.lex_state = 9},
  [710] = {.lex_state = 69, .external_lex_state = 2},
  [711] = {.lex_state = 69, .external_lex_state = 2},
  [712] = {.lex_state = 69, .external_lex_state = 2},
  [713] = {.lex_state = 69, .external_lex_state = 2},
  [714] = {.lex_state = 69, .external_lex_state = 2},
  [715] = {.lex_state = 69, .external_lex_state = 2},
  [716] = {.lex_state = 69, .external_lex_state = 2},
  [717] = {.lex_state = 69, .external_lex_state = 2},
  [718] = {.lex_state = 69, .external_lex_state = 2},
  [719] = {.lex_state = 69, .external_lex_state = 2},
  [720] = {.lex_state = 69, .external_lex_state = 2},
  [721] = {.lex_state = 69, .external_lex_state = 2},
  [722] = {.lex_state = 69, .external_lex_state = 2},
  [723] = {.lex_state = 69, .external_lex_state = 2},
  [724] = {.lex_state = 69, .external_lex_state = 2},
  [725] = {.lex_state = 69, .external_lex_state = 2},
  [726] = {.lex_state = 69, .external_lex_state = 2},
  [727] = {.lex_state = 69, .external_lex_state = 2},
  [728] = {.lex_state = 69, .external_lex_state = 2},
  [729] = {.lex_state = 69, .external_lex_state = 2},
  [730] = {.lex_state = 69, .external_lex_state = 2},
  [731] = {.lex_state = 69, .external_lex_state = 2},
  [732] = {.lex_state = 69, .external_lex_state = 2},
  [733] = {.lex_state = 69, .external_lex_state = 2},
  [734] = {.lex_state = 69, .external_lex_state = 2},
  [735] = {.lex_state = 69, .external_lex_state = 2},
  [736] = {.lex_state = 69, .external_lex_state = 2},
  [737] = {.lex_state = 69, .external_lex_state = 2},
  [738] = {.lex_state = 69, .external_lex_state = 2},
  [739] = {.lex_state = 69, .external_lex_state = 2},
  [740] = {.lex_state = 69, .external_lex_state = 2},
  [741] = {.lex_state = 69, .external_lex_state = 2},
  [742] = {.lex_state = 69, .external_lex_state = 2},
  [743] = {.lex_state = 69, .external_lex_state = 2},
  [744] = {.lex_state = 69, .external_lex_state = 2},
  [745] = {.lex_state = 69, .external_lex_state = 2},
  [746] = {.lex_state = 69, .external_lex_state = 2},
  [747] = {.lex_state = 69, .external_lex_state = 2},
  [748] = {.lex_state = 69, .external_lex_state = 2},
  [749] = {.lex_state = 69, .external_lex_state = 2},
  [750] = {.lex_state = 69, .external_lex_state = 2},
  [751] = {.lex_state = 69, .external_lex_state = 2},
  [752] = {.lex_state = 69, .external_lex_state = 2},
  [753] = {.lex_state = 69, .external_lex_state = 2},
  [754] = {.lex_state = 10, .external_lex_state = 2},
  [755] = {.lex_state = 10, .external_lex_state = 2},
  [756] = {.lex_state = 10, .external_lex_state = 2},
  [757] = {.lex_state = 10, .external_lex_state = 2},
  [758] = {.lex_state = 10, .external_lex_state = 2},
  [759] = {.lex_state = 10, .external_lex_state = 2},
  [760] = {.lex_state = 10, .external_lex_state = 2},
  [761] = {.lex_state = 10, .external_lex_state = 2},
  [762] = {.lex_state = 10, .external_lex_state = 2},
  [763] = {.lex_state = 13},
  [764] = {.lex_state = 13},
  [765] = {.lex_state = 13},
  [766] = {.lex_state = 13},
  [767] = {.lex_state = 13},
  [768] = {.lex_state = 13},
  [769] = {.lex_state = 13},
  [770] = {.lex_state = 13},
  [771] = {.lex_state = 13},
  [772] = {.lex_state = 10, .external_lex_state = 2},
  [773] = {.lex_state = 10, .external_lex_state = 2},
  [774] = {.lex_state = 13},
  [775] = {.lex_state = 10, .external_lex_state = 2},
  [776] = {.lex_state = 10, .external_lex_state = 2},
  [777] = {.lex_state = 10, .external_lex_state = 2},
  [778] = {.lex_state = 10, .external_lex_state = 2},
  [779] = {.lex_state = 13},
  [780] = {.lex_state = 10, .external_lex_state = 2},
  [781] = {.lex_state = 10, .external_lex_state = 2},
  [782] = {.lex_state = 10, .external_lex_state = 2},
  [783] = {.lex_state = 10, .external_lex_state = 2},
  [784] = {.lex_state = 10, .external_lex_state = 2},
  [785] = {.lex_state = 10, .external_lex_state = 2},
  [786] = {.lex_state = 10, .external_lex_state = 2},
  [787] = {.lex_state = 10, .external_lex_state = 2},
  [788] = {.lex_state = 10, .external_lex_state = 2},
  [789] = {.lex_state = 10, .external_lex_state = 2},
  [790] = {.lex_state = 10, .external_lex_state = 2},
  [791] = {.lex_state = 10, .external_lex_state = 2},
  [792] = {.lex_state = 10, .external_lex_state = 2},
  [793] = {.lex_state = 10, .external_lex_state = 2},
  [794] = {.lex_state = 11, .external_lex_state = 2},
  [795] = {.lex_state = 10, .external_lex_state = 2},
  [796] = {.lex_state = 10, .external_lex_state = 2},
  [797] = {.lex_state = 10, .external_lex_state = 2},
  [798] = {.lex_state = 10, .external_lex_state = 2},
  [799] = {.lex_state = 10, .external_lex_state = 2},
  [800] = {.lex_state = 10, .external_lex_state = 2},
  [801] = {.lex_state = 10, .external_lex_state = 2},
  [802] = {.lex_state = 10, .external_lex_state = 2},
  [803] = {.lex_state = 10, .external_lex_state = 2},
  [804] = {.lex_state = 10, .external_lex_state = 2},
  [805] = {.lex_state = 10, .external_lex_state = 2},
  [806] = {.lex_state = 10, .external_lex_state = 2},
  [807] = {.lex_state = 10, .external_lex_state = 2},
  [808] = {.lex_state = 10, .external_lex_state = 2},
  [809] = {.lex_state = 10, .external_lex_state = 2},
  [810] = {.lex_state = 10, .external_lex_state = 2},
  [811] = {.lex_state = 10, .external_lex_state = 2},
  [812] = {.lex_state = 10, .external_lex_state = 2},
  [813] = {.lex_state = 10, .external_lex_state = 2},
  [814] = {.lex_state = 10, .external_lex_state = 2},
  [815] = {.lex_state = 10, .external_lex_state = 2},
  [816] = {.lex_state = 10, .external_lex_state = 2},
  [817] = {.lex_state = 10, .external_lex_state = 2},
  [818] = {.lex_state = 10, .external_lex_state = 2},
  [819] = {.lex_state = 10, .external_lex_state = 2},
  [820] = {.lex_state = 10, .external_lex_state = 2},
  [821] = {.lex_state = 10, .external_lex_state = 2},
  [822] = {.lex_state = 10, .external_lex_state = 2},
  [823] = {.lex_state = 10, .external_lex_state = 2},
  [824] = {.lex_state = 10, .external_lex_state = 2},
  [825] = {.lex_state = 10, .external_lex_state = 2},
  [826] = {.lex_state = 10, .external_lex_state = 2},
  [827] = {.lex_state = 10, .external_lex_state = 2},
  [828] = {.lex_state = 10, .external_lex_state = 2},
  [829] = {.lex_state = 13},
  [830] = {.lex_state = 13},
  [831] = {.lex_state = 13},
  [832] = {.lex_state = 13},
  [833] = {.lex_state = 13},
  [834] = {.lex_state = 13},
  [835] = {.lex_state = 13},
  [836] = {.lex_state = 13},
  [837] = {.lex_state = 13},
  [838] = {.lex_state = 13},
  [839] = {.lex_state = 13},
  [840] = {.lex_state = 13},
  [841] = {.lex_state = 13},
  [842] = {.lex_state = 13},
  [843] = {.lex_state = 13},
  [844] = {.lex_state = 13},
  [845] = {.lex_state = 13},
  [846] = {.lex_state = 13},
  [847] = {.lex_state = 13},
  [848] = {.lex_state = 13},
  [849] = {.lex_state = 13},
  [850] = {.lex_state = 13},
  [851] = {.lex_state = 13},
  [852] = {.lex_state = 13},
  [853] = {.lex_state = 13},
  [854] = {.lex_state = 13},
  [855] = {.lex_state = 13},
  [856] = {.lex_state = 13},
  [857] = {.lex_state = 13},
  [858] = {.lex_state = 13},
  [859] = {.lex_state = 13},
  [860] = {.lex_state = 13},
  [861] = {.lex_state = 13},
  [862] = {.lex_state = 13},
  [863] = {.lex_state = 13},
  [864] = {.lex_state = 13},
  [865] = {.lex_state = 13},
  [866] = {.lex_state = 13},
  [867] = {.lex_state = 13},
  [868] = {.lex_state = 13},
  [869] = {.lex_state = 13},
  [870] = {.lex_state = 13},
  [871] = {.lex_state = 13},
  [872] = {.lex_state = 13},
  [873] = {.lex_state = 13},
  [874] = {.lex_state = 13},
  [875] = {.lex_state = 13},
  [876] = {.lex_state = 13},
  [877] = {.lex_state = 13},
  [878] = {.lex_state = 13},
  [879] = {.lex_state = 13},
  [880] = {.lex_state = 13},
  [881] = {.lex_state = 13},
  [882] = {.lex_state = 13},
  [883] = {.lex_state = 13},
  [884] = {.lex_state = 13},
  [885] = {.lex_state = 13},
  [886] = {.lex_state = 13},
  [887] = {.lex_state = 13},
  [888] = {.lex_state = 13},
  [889] = {.lex_state = 13},
  [890] = {.lex_state = 13},
  [891] = {.lex_state = 13},
  [892] = {.lex_state = 13},
  [893] = {.lex_state = 13},
  [894] = {.lex_state = 13},
  [895] = {.lex_state = 13},
  [896] = {.lex_state = 13},
  [897] = {.lex_state = 13},
  [898] = {.lex_state = 13},
  [899] = {.lex_state = 13},
  [900] = {.lex_state = 13},
  [901] = {.lex_state = 13},
  [902] = {.lex_state = 13},
  [903] = {.lex_state = 13},
  [904] = {.lex_state = 13},
  [905] = {.lex_state = 13},
  [906] = {.lex_state = 13},
  [907] = {.lex_state = 13},
  [908] = {.lex_state = 13},
  [909] = {.lex_state = 13},
  [910] = {.lex_state = 13},
  [911] = {.lex_state = 13},
  [912] = {.lex_state = 13},
  [913] = {.lex_state = 13},
  [914] = {.lex_state = 13},
  [915] = {.lex_state = 13},
  [916] = {.lex_state = 13},
  [917] = {.lex_state = 13},
  [918] = {.lex_state = 13},
  [919] = {.lex_state = 13},
  [920] = {.lex_state = 13},
  [921] = {.lex_state = 13},
  [922] = {.lex_state = 13},
  [923] = {.lex_state = 13},
  [924] = {.lex_state = 13},
  [925] = {.lex_state = 13},
  [926] = {.lex_state = 13},
  [927] = {.lex_state = 13},
  [928] = {.lex_state = 13},
  [929] = {.lex_state = 13},
  [930] = {.lex_state = 13},
  [931] = {.lex_state = 13},
  [932] = {.lex_state = 13},
  [933] = {.lex_state = 13},
  [934] = {.lex_state = 13},
  [935] = {.lex_state = 13},
  [936] = {.lex_state = 13},
  [937] = {.lex_state = 13},
  [938] = {.lex_state = 13},
  [939] = {.lex_state = 13},
  [940] = {.lex_state = 13},
  [941] = {.lex_state = 13},
  [942] = {.lex_state = 13},
  [943] = {.lex_state = 13},
  [944] = {.lex_state = 13},
  [945] = {.lex_state = 13},
  [946] = {.lex_state = 13},
  [947] = {.lex_state = 13},
  [948] = {.lex_state = 13},
  [949] = {.lex_state = 13},
  [950] = {.lex_state = 13},
  [951] = {.lex_state = 13},
  [952] = {.lex_state = 13},
  [953] = {.lex_state = 13},
  [954] = {.lex_state = 13},
  [955] = {.lex_state = 13},
  [956] = {.lex_state = 13},
  [957] = {.lex_state = 13},
  [958] = {.lex_state = 13},
  [959] = {.lex_state = 13},
  [960] = {.lex_state = 13},
  [961] = {.lex_state = 13},
  [962] = {.lex_state = 13},
  [963] = {.lex_state = 13},
  [964] = {.lex_state = 13},
  [965] = {.lex_state = 13},
  [966] = {.lex_state = 13},
  [967] = {.lex_state = 13},
  [968] = {.lex_state = 13},
  [969] = {.lex_state = 10, .external_lex_state = 2},
  [970] = {.lex_state = 13},
  [971] = {.lex_state = 13},
  [972] = {.lex_state = 13},
  [973] = {.lex_state = 13},
  [974] = {.lex_state = 13},
  [975] = {.lex_state = 13},
  [976] = {.lex_state = 13},
  [977] = {.lex_state = 13},
  [978] = {.lex_state = 13},
  [979] = {.lex_state = 13},
  [980] = {.lex_state = 13},
  [981] = {.lex_state = 13},
  [982] = {.lex_state = 13},
  [983] = {.lex_state = 13},
  [984] = {.lex_state = 13},
  [985] = {.lex_state = 13},
  [986] = {.lex_state = 13},
  [987] = {.lex_state = 13},
  [988] = {.lex_state = 13},
  [989] = {.lex_state = 13},
  [990] = {.lex_state = 13},
  [991] = {.lex_state = 13},
  [992] = {.lex_state = 13},
  [993] = {.lex_state = 13},
  [994] = {.lex_state = 13},
  [995] = {.lex_state = 13},
  [996] = {.lex_state = 13},
  [997] = {.lex_state = 13},
  [998] = {.lex_state = 13},
  [999] = {.lex_state = 13},
  [1000] = {.lex_state = 13},
  [1001] = {.lex_state = 13},
  [1002] = {.lex_state = 10, .external_lex_state = 2},
  [1003] = {.lex_state = 10, .external_lex_state = 2},
  [1004] = {.lex_state = 12, .external_lex_state = 2},
  [1005] = {.lex_state = 12, .external_lex_state = 2},
  [1006] = {.lex_state = 10, .external_lex_state = 2},
  [1007] = {.lex_state = 11, .external_lex_state = 2},
  [1008] = {.lex_state = 13},
  [1009] = {.lex_state = 10, .external_lex_state = 2},
  [1010] = {.lex_state = 10, .external_lex_state = 2},
  [1011] = {.lex_state = 5},
  [1012] = {.lex_state = 5},
  [1013] = {.lex_state = 5},
  [1014] = {.lex_state = 5},
  [1015] = {.lex_state = 9},
  [1016] = {.lex_state = 9},
  [1017] = {.lex_state = 5},
  [1018] = {.lex_state = 5},
  [1019] = {.lex_state = 9},
  [1020] = {.lex_state = 5},
  [1021] = {.lex_state = 5},
  [1022] = {.lex_state = 9},
  [1023] = {.lex_state = 5},
  [1024] = {.lex_state = 9},
  [1025] = {.lex_state = 9},
  [1026] = {.lex_state = 5},
  [1027] = {.lex_state = 9},
  [1028] = {.lex_state = 5},
  [1029] = {.lex_state = 9},
  [1030] = {.lex_state = 5},
  [1031] = {.lex_state = 9},
  [1032] = {.lex_state = 6},
  [1033] = {.lex_state = 6},
  [1034] = {.lex_state = 21},
  [1035] = {.lex_state = 6},
  [1036] = {.lex_state = 6},
  [1037] = {.lex_state = 6},
  [1038] = {.lex_state = 21},
  [1039] = {.lex_state = 21},
  [1040] = {.lex_state = 21},
  [1041] = {.lex_state = 6},
  [1042] = {.lex_state = 10, .external_lex_state = 2},
  [1043] = {.lex_state = 21},
  [1044] = {.lex_state = 13},
  [1045] = {.lex_state = 13},
  [1046] = {.lex_state = 17},
  [1047] = {.lex_state = 17},
  [1048] = {.lex_state = 6},
  [1049] = {.lex_state = 6},
  [1050] = {.lex_state = 6},
  [1051] = {.lex_state = 17},
  [1052] = {.lex_state = 6},
  [1053] = {.lex_state = 17},
  [1054] = {.lex_state = 17},
  [1055] = {.lex_state = 17},
  [1056] = {.lex_state = 17},
  [1057] = {.lex_state = 5},
  [1058] = {.lex_state = 6},
  [1059] = {.lex_state = 17},
  [1060] = {.lex_state = 17},
  [1061] = {.lex_state = 6},
  [1062] = {.lex_state = 6},
  [1063] = {.lex_state = 6},
  [1064] = {.lex_state = 17},
  [1065] = {.lex_state = 18},
  [1066] = {.lex_state = 6},
  [1067] = {.lex_state = 6},
  [1068] = {.lex_state = 6},
  [1069] = {.lex_state = 13},
  [1070] = {.lex_state = 6},
  [1071] = {.lex_state = 13},
  [1072] = {.lex_state = 6},
  [1073] = {.lex_state = 6},
  [1074] = {.lex_state = 6},
  [1075] = {.lex_state = 6},
  [1076] = {.lex_state = 18},
  [1077] = {.lex_state = 6},
  [1078] = {.lex_state = 17},
  [1079] = {.lex_state = 6},
  [1080] = {.lex_state = 13},
  [1081] = {.lex_state = 13},
  [1082] = {.lex_state = 6},
  [1083] = {.lex_state = 6},
  [1084] = {.lex_state = 17},
  [1085] = {.lex_state = 6},
  [1086] = {.lex_state = 6},
  [1087] = {.lex_state = 6},
  [1088] = {.lex_state = 13},
  [1089] = {.lex_state = 13},
  [1090] = {.lex_state = 13},
  [1091] = {.lex_state = 9},
  [1092] = {.lex_state = 13},
  [1093] = {.lex_state = 6},
  [1094] = {.lex_state = 9},
  [1095] = {.lex_state = 9},
  [1096] = {.lex_state = 9},
  [1097] = {.lex_state = 6},
  [1098] = {.lex_state = 6},
  [1099] = {.lex_state = 9},
  [1100] = {.lex_state = 9},
  [1101] = {.lex_state = 9},
  [1102] = {.lex_state = 9},
  [1103] = {.lex_state = 9},
  [1104] = {.lex_state = 9},
  [1105] = {.lex_state = 9},
  [1106] = {.lex_state = 6},
  [1107] = {.lex_state = 9},
  [1108] = {.lex_state = 9},
  [1109] = {.lex_state = 9},
  [1110] = {.lex_state = 9},
  [1111] = {.lex_state = 9},
  [1112] = {.lex_state = 9},
  [1113] = {.lex_state = 9},
  [1114] = {.lex_state = 9},
  [1115] = {.lex_state = 9},
  [1116] = {.lex_state = 9},
  [1117] = {.lex_state = 9},
  [1118] = {.lex_state = 9},
  [1119] = {.lex_state = 9},
  [1120] = {.lex_state = 9},
  [1121] = {.lex_state = 9},
  [1122] = {.lex_state = 9},
  [1123] = {.lex_state = 9},
  [1124] = {.lex_state = 9},
  [1125] = {.lex_state = 9},
  [1126] = {.lex_state = 6},
  [1127] = {.lex_state = 9},
  [1128] = {.lex_state = 6},
  [1129] = {.lex_state = 9},
  [1130] = {.lex_state = 9},
  [1131] = {.lex_state = 6},
  [1132] = {.lex_state = 9},
  [1133] = {.lex_state = 9},
  [1134] = {.lex_state = 9},
  [1135] = {.lex_state = 9},
  [1136] = {.lex_state = 6},
  [1137] = {.lex_state = 6},
  [1138] = {.lex_state = 6},
  [1139] = {.lex_state = 9},
  [1140] = {.lex_state = 9},
  [1141] = {.lex_state = 9},
  [1142] = {.lex_state = 9},
  [1143] = {.lex_state = 9},
  [1144] = {.lex_state = 6},
  [1145] = {.lex_state = 9},
  [1146] = {.lex_state = 9},
  [1147] = {.lex_state = 9},
  [1148] = {.lex_state = 9},
  [1149] = {.lex_state = 6},
  [1150] = {.lex_state = 9},
  [1151] = {.lex_state = 6},
  [1152] = {.lex_state = 6},
  [1153] = {.lex_state = 9},
  [1154] = {.lex_state = 9},
  [1155] = {.lex_state = 9},
  [1156] = {.lex_state = 9},
  [1157] = {.lex_state = 9},
  [1158] = {.lex_state = 9},
  [1159] = {.lex_state = 9},
  [1160] = {.lex_state = 6},
  [1161] = {.lex_state = 9},
  [1162] = {.lex_state = 9},
  [1163] = {.lex_state = 9},
  [1164] = {.lex_state = 6},
  [1165] = {.lex_state = 6},
  [1166] = {.lex_state = 6},
  [1167] = {.lex_state = 6},
  [1168] = {.lex_state = 6},
  [1169] = {.lex_state = 6},
  [1170] = {.lex_state = 6},
  [1171] = {.lex_state = 6},
  [1172] = {.lex_state = 6},
  [1173] = {.lex_state = 6},
  [1174] = {.lex_state = 6},
  [1175] = {.lex_state = 6},
  [1176] = {.lex_state = 9},
  [1177] = {.lex_state = 9},
  [1178] = {.lex_state = 9},
  [1179] = {.lex_state = 9},
  [1180] = {.lex_state = 9},
  [1181] = {.lex_state = 9},
  [1182] = {.lex_state = 9},
  [1183] = {.lex_state = 6},
  [1184] = {.lex_state = 9},
  [1185] = {.lex_state = 9},
  [1186] = {.lex_state = 9},
  [1187] = {.lex_state = 9},
  [1188] = {.lex_state = 9},
  [1189] = {.lex_state = 9},
  [1190] = {.lex_state = 9},
  [1191] = {.lex_state = 9},
  [1192] = {.lex_state = 9},
  [1193] = {.lex_state = 9},
  [1194] = {.lex_state = 9},
  [1195] = {.lex_state = 9},
  [1196] = {.lex_state = 9},
  [1197] = {.lex_state = 9},
  [1198] = {.lex_state = 9},
  [1199] = {.lex_state = 9},
  [1200] = {.lex_state = 6},
  [1201] = {.lex_state = 9},
  [1202] = {.lex_state = 9},
  [1203] = {.lex_state = 9},
  [1204] = {.lex_state = 9},
  [1205] = {.lex_state = 9},
  [1206] = {.lex_state = 9},
  [1207] = {.lex_state = 9},
  [1208] = {.lex_state = 9},
  [1209] = {.lex_state = 9},
  [1210] = {.lex_state = 9},
  [1211] = {.lex_state = 9},
  [1212] = {.lex_state = 9},
  [1213] = {.lex_state = 9},
  [1214] = {.lex_state = 6},
  [1215] = {.lex_state = 9},
  [1216] = {.lex_state = 6},
  [1217] = {.lex_state = 9},
  [1218] = {.lex_state = 9},
  [1219] = {.lex_state = 9},
  [1220] = {.lex_state = 6},
  [1221] = {.lex_state = 9},
  [1222] = {.lex_state = 9},
  [1223] = {.lex_state = 6},
  [1224] = {.lex_state = 6},
  [1225] = {.lex_state = 9},
  [1226] = {.lex_state = 9},
  [1227] = {.lex_state = 6},
  [1228] = {.lex_state = 9},
  [1229] = {.lex_state = 9},
  [1230] = {.lex_state = 9},
  [1231] = {.lex_state = 9},
  [1232] = {.lex_state = 9},
  [1233] = {.lex_state = 9},
  [1234] = {.lex_state = 9},
  [1235] = {.lex_state = 6},
  [1236] = {.lex_state = 9},
  [1237] = {.lex_state = 6},
  [1238] = {.lex_state = 9},
  [1239] = {.lex_state = 9},
  [1240] = {.lex_state = 9},
  [1241] = {.lex_state = 9},
  [1242] = {.lex_state = 6},
  [1243] = {.lex_state = 6},
  [1244] = {.lex_state = 6},
  [1245] = {.lex_state = 13},
  [1246] = {.lex_state = 6},
  [1247] = {.lex_state = 9},
  [1248] = {.lex_state = 9},
  [1249] = {.lex_state = 6},
  [1250] = {.lex_state = 9},
  [1251] = {.lex_state = 9},
  [1252] = {.lex_state = 6},
  [1253] = {.lex_state = 9},
  [1254] = {.lex_state = 6},
  [1255] = {.lex_state = 6},
  [1256] = {.lex_state = 6},
  [1257] = {.lex_state = 6},
  [1258] = {.lex_state = 9},
  [1259] = {.lex_state = 9},
  [1260] = {.lex_state = 9},
  [1261] = {.lex_state = 9},
  [1262] = {.lex_state = 9},
  [1263] = {.lex_state = 9},
  [1264] = {.lex_state = 9},
  [1265] = {.lex_state = 9},
  [1266] = {.lex_state = 13},
  [1267] = {.lex_state = 6},
  [1268] = {.lex_state = 9},
  [1269] = {.lex_state = 9},
  [1270] = {.lex_state = 13},
  [1271] = {.lex_state = 9},
  [1272] = {.lex_state = 9},
  [1273] = {.lex_state = 9},
  [1274] = {.lex_state = 9},
  [1275] = {.lex_state = 9},
  [1276] = {.lex_state = 9},
  [1277] = {.lex_state = 6},
  [1278] = {.lex_state = 9},
  [1279] = {.lex_state = 6},
  [1280] = {.lex_state = 9},
  [1281] = {.lex_state = 10, .external_lex_state = 2},
  [1282] = {.lex_state = 9},
  [1283] = {.lex_state = 9},
  [1284] = {.lex_state = 9},
  [1285] = {.lex_state = 9},
  [1286] = {.lex_state = 9},
  [1287] = {.lex_state = 9},
  [1288] = {.lex_state = 9},
  [1289] = {.lex_state = 9},
  [1290] = {.lex_state = 9},
  [1291] = {.lex_state = 6},
  [1292] = {.lex_state = 6},
  [1293] = {.lex_state = 6},
  [1294] = {.lex_state = 9},
  [1295] = {.lex_state = 9},
  [1296] = {.lex_state = 9},
  [1297] = {.lex_state = 9},
  [1298] = {.lex_state = 9},
  [1299] = {.lex_state = 9},
  [1300] = {.lex_state = 9},
  [1301] = {.lex_state = 9},
  [1302] = {.lex_state = 9},
  [1303] = {.lex_state = 6},
  [1304] = {.lex_state = 9},
  [1305] = {.lex_state = 9},
  [1306] = {.lex_state = 9},
  [1307] = {.lex_state = 6},
  [1308] = {.lex_state = 9},
  [1309] = {.lex_state = 9},
  [1310] = {.lex_state = 9},
  [1311] = {.lex_state = 6},
  [1312] = {.lex_state = 6},
  [1313] = {.lex_state = 9},
  [1314] = {.lex_state = 13},
  [1315] = {.lex_state = 9},
  [1316] = {.lex_state = 13},
  [1317] = {.lex_state = 9},
  [1318] = {.lex_state = 6},
  [1319] = {.lex_state = 6},
  [1320] = {.lex_state = 9},
  [1321] = {.lex_state = 13},
  [1322] = {.lex_state = 6},
  [1323] = {.lex_state = 6},
  [1324] = {.lex_state = 6},
  [1325] = {.lex_state = 6},
  [1326] = {.lex_state = 13},
  [1327] = {.lex_state = 9},
  [1328] = {.lex_state = 11, .external_lex_state = 2},
  [1329] = {.lex_state = 9},
  [1330] = {.lex_state = 9},
  [1331] = {.lex_state = 9},
  [1332] = {.lex_state = 9},
  [1333] = {.lex_state = 9},
  [1334] = {.lex_state = 9},
  [1335] = {.lex_state = 9},
  [1336] = {.lex_state = 9},
  [1337] = {.lex_state = 11, .external_lex_state = 2},
  [1338] = {.lex_state = 9},
  [1339] = {.lex_state = 9},
  [1340] = {.lex_state = 9},
  [1341] = {.lex_state = 9},
  [1342] = {.lex_state = 9},
  [1343] = {.lex_state = 9},
  [1344] = {.lex_state = 6},
  [1345] = {.lex_state = 9},
  [1346] = {.lex_state = 13},
  [1347] = {.lex_state = 6},
  [1348] = {.lex_state = 9},
  [1349] = {.lex_state = 6},
  [1350] = {.lex_state = 6},
  [1351] = {.lex_state = 6},
  [1352] = {.lex_state = 6},
  [1353] = {.lex_state = 9},
  [1354] = {.lex_state = 6},
  [1355] = {.lex_state = 9},
  [1356] = {.lex_state = 9},
  [1357] = {.lex_state = 6},
  [1358] = {.lex_state = 9},
  [1359] = {.lex_state = 9},
  [1360] = {.lex_state = 9},
  [1361] = {.lex_state = 9},
  [1362] = {.lex_state = 9},
  [1363] = {.lex_state = 9},
  [1364] = {.lex_state = 9},
  [1365] = {.lex_state = 6},
  [1366] = {.lex_state = 9},
  [1367] = {.lex_state = 9},
  [1368] = {.lex_state = 9},
  [1369] = {.lex_state = 9},
  [1370] = {.lex_state = 6},
  [1371] = {.lex_state = 9},
  [1372] = {.lex_state = 6},
  [1373] = {.lex_state = 9},
  [1374] = {.lex_state = 9},
  [1375] = {.lex_state = 9},
  [1376] = {.lex_state = 9},
  [1377] = {.lex_state = 9},
  [1378] = {.lex_state = 9},
  [1379] = {.lex_state = 6},
  [1380] = {.lex_state = 6},
  [1381] = {.lex_state = 13},
  [1382] = {.lex_state = 9},
  [1383] = {.lex_state = 10, .external_lex_state = 2},
  [1384] = {.lex_state = 9},
  [1385] = {.lex_state = 9},
  [1386] = {.lex_state = 9},
  [1387] = {.lex_state = 6},
  [1388] = {.lex_state = 9},
  [1389] = {.lex_state = 6},
  [1390] = {.lex_state = 9},
  [1391] = {.lex_state = 9},
  [1392] = {.lex_state = 6},
  [1393] = {.lex_state = 9},
  [1394] = {.lex_state = 9},
  [1395] = {.lex_state = 9},
  [1396] = {.lex_state = 9},
  [1397] = {.lex_state = 9},
  [1398] = {.lex_state = 6},
  [1399] = {.lex_state = 6},
  [1400] = {.lex_state = 9},
  [1401] = {.lex_state = 9},
  [1402] = {.lex_state = 9},
  [1403] = {.lex_state = 9},
  [1404] = {.lex_state = 6},
  [1405] = {.lex_state = 9},
  [1406] = {.lex_state = 9},
  [1407] = {.lex_state = 9},
  [1408] = {.lex_state = 9},
  [1409] = {.lex_state = 6},
  [1410] = {.lex_state = 6},
  [1411] = {.lex_state = 9},
  [1412] = {.lex_state = 6},
  [1413] = {.lex_state = 6},
  [1414] = {.lex_state = 6},
  [1415] = {.lex_state = 6},
  [1416] = {.lex_state = 9},
  [1417] = {.lex_state = 6},
  [1418] = {.lex_state = 9},
  [1419] = {.lex_state = 9},
  [1420] = {.lex_state = 9},
  [1421] = {.lex_state = 9},
  [1422] = {.lex_state = 6},
  [1423] = {.lex_state = 9},
  [1424] = {.lex_state = 9},
  [1425] = {.lex_state = 6},
  [1426] = {.lex_state = 6},
  [1427] = {.lex_state = 9},
  [1428] = {.lex_state = 9},
  [1429] = {.lex_state = 9},
  [1430] = {.lex_state = 9},
  [1431] = {.lex_state = 9},
  [1432] = {.lex_state = 9},
  [1433] = {.lex_state = 6},
  [1434] = {.lex_state = 6},
  [1435] = {.lex_state = 9},
  [1436] = {.lex_state = 6},
  [1437] = {.lex_state = 6},
  [1438] = {.lex_state = 9},
  [1439] = {.lex_state = 6},
  [1440] = {.lex_state = 6},
  [1441] = {.lex_state = 9},
  [1442] = {.lex_state = 9},
  [1443] = {.lex_state = 9},
  [1444] = {.lex_state = 9},
  [1445] = {.lex_state = 9},
  [1446] = {.lex_state = 9},
  [1447] = {.lex_state = 6},
  [1448] = {.lex_state = 9},
  [1449] = {.lex_state = 6},
  [1450] = {.lex_state = 6},
  [1451] = {.lex_state = 6},
  [1452] = {.lex_state = 6},
  [1453] = {.lex_state = 9},
  [1454] = {.lex_state = 9},
  [1455] = {.lex_state = 6},
  [1456] = {.lex_state = 9},
  [1457] = {.lex_state = 9},
  [1458] = {.lex_state = 9},
  [1459] = {.lex_state = 9},
  [1460] = {.lex_state = 9},
  [1461] = {.lex_state = 6},
  [1462] = {.lex_state = 6},
  [1463] = {.lex_state = 9},
  [1464] = {.lex_state = 6},
  [1465] = {.lex_state = 9},
  [1466] = {.lex_state = 9},
  [1467] = {.lex_state = 9},
  [1468] = {.lex_state = 9},
  [1469] = {.lex_state = 6},
  [1470] = {.lex_state = 6},
  [1471] = {.lex_state = 13},
  [1472] = {.lex_state = 6},
  [1473] = {.lex_state = 10, .external_lex_state = 2},
  [1474] = {.lex_state = 13},
  [1475] = {.lex_state = 10, .external_lex_state = 2},
  [1476] = {.lex_state = 10, .external_lex_state = 2},
  [1477] = {.lex_state = 6},
  [1478] = {.lex_state = 10, .external_lex_state = 2},
  [1479] = {.lex_state = 13},
  [1480] = {.lex_state = 10, .external_lex_state = 2},
  [1481] = {.lex_state = 13},
  [1482] = {.lex_state = 6},
  [1483] = {.lex_state = 6},
  [1484] = {.lex_state = 6},
  [1485] = {.lex_state = 6},
  [1486] = {.lex_state = 6},
  [1487] = {.lex_state = 6},
  [1488] = {.lex_state = 6},
  [1489] = {.lex_state = 6},
  [1490] = {.lex_state = 6},
  [1491] = {.lex_state = 6},
  [1492] = {.lex_state = 6},
  [1493] = {.lex_state = 6},
  [1494] = {.lex_state = 6},
  [1495] = {.lex_state = 13},
  [1496] = {.lex_state = 13},
  [1497] = {.lex_state = 6},
  [1498] = {.lex_state = 6},
  [1499] = {.lex_state = 6},
  [1500] = {.lex_state = 6},
  [1501] = {.lex_state = 6},
  [1502] = {.lex_state = 6},
  [1503] = {.lex_state = 6},
  [1504] = {.lex_state = 13},
  [1505] = {.lex_state = 8},
  [1506] = {.lex_state = 7},
  [1507] = {.lex_state = 8},
  [1508] = {.lex_state = 8},
  [1509] = {.lex_state = 6},
  [1510] = {.lex_state = 10, .external_lex_state = 2},
  [1511] = {.lex_state = 10, .external_lex_state = 2},
  [1512] = {.lex_state = 8},
  [1513] = {.lex_state = 10, .external_lex_state = 2},
  [1514] = {.lex_state = 10, .external_lex_state = 2},
  [1515] = {.lex_state = 6},
  [1516] = {.lex_state = 7},
  [1517] = {.lex_state = 13},
  [1518] = {.lex_state = 8},
  [1519] = {.lex_state = 6},
  [1520] = {.lex_state = 13},
  [1521] = {.lex_state = 8},
  [1522] = {.lex_state = 6},
  [1523] = {.lex_state = 8},
  [1524] = {.lex_state = 8},
  [1525] = {.lex_state = 7},
  [1526] = {.lex_state = 13},
  [1527] = {.lex_state = 8},
  [1528] = {.lex_state = 13},
  [1529] = {.lex_state = 6},
  [1530] = {.lex_state = 8},
  [1531] = {.lex_state = 8},
  [1532] = {.lex_state = 8},
  [1533] = {.lex_state = 13},
  [1534] = {.lex_state = 6},
  [1535] = {.lex_state = 7},
  [1536] = {.lex_state = 7},
  [1537] = {.lex_state = 6},
  [1538] = {.lex_state = 13},
  [1539] = {.lex_state = 13},
  [1540] = {.lex_state = 6},
  [1541] = {.lex_state = 6},
  [1542] = {.lex_state = 6},
  [1543] = {.lex_state = 7},
  [1544] = {.lex_state = 7},
  [1545] = {.lex_state = 6},
  [1546] = {.lex_state = 6},
  [1547] = {.lex_state = 6},
  [1548] = {.lex_state = 7},
  [1549] = {.lex_state = 6},
  [1550] = {.lex_state = 7},
  [1551] = {.lex_state = 7},
  [1552] = {.lex_state = 7},
  [1553] = {.lex_state = 6},
  [1554] = {.lex_state = 6},
  [1555] = {.lex_state = 6},
  [1556] = {.lex_state = 6},
  [1557] = {.lex_state = 7},
  [1558] = {.lex_state = 7},
  [1559] = {.lex_state = 6},
  [1560] = {.lex_state = 7},
  [1561] = {.lex_state = 6},
  [1562] = {.lex_state = 7},
  [1563] = {.lex_state = 6},
  [1564] = {.lex_state = 6},
  [1565] = {.lex_state = 6},
  [1566] = {.lex_state = 6},
  [1567] = {.lex_state = 6},
  [1568] = {.lex_state = 7},
  [1569] = {.lex_state = 6},
  [1570] = {.lex_state = 7},
  [1571] = {.lex_state = 7},
  [1572] = {.lex_state = 7},
  [1573] = {.lex_state = 6},
  [1574] = {.lex_state = 6},
  [1575] = {.lex_state = 19},
  [1576] = {.lex_state = 19},
  [1577] = {.lex_state = 7},
  [1578] = {.lex_state = 7},
  [1579] = {.lex_state = 19},
  [1580] = {.lex_state = 7},
  [1581] = {.lex_state = 7},
  [1582] = {.lex_state = 7},
  [1583] = {.lex_state = 19},
  [1584] = {.lex_state = 7},
  [1585] = {.lex_state = 8},
  [1586] = {.lex_state = 19},
  [1587] = {.lex_state = 6},
  [1588] = {.lex_state = 7},
  [1589] = {.lex_state = 7},
  [1590] = {.lex_state = 6},
  [1591] = {.lex_state = 6},
  [1592] = {.lex_state = 6},
  [1593] = {.lex_state = 6},
  [1594] = {.lex_state = 6},
  [1595] = {.lex_state = 6},
  [1596] = {.lex_state = 6},
  [1597] = {.lex_state = 6},
  [1598] = {.lex_state = 6},
  [1599] = {.lex_state = 6},
  [1600] = {.lex_state = 6},
  [1601] = {.lex_state = 7},
  [1602] = {.lex_state = 7},
  [1603] = {.lex_state = 6},
  [1604] = {.lex_state = 7},
  [1605] = {.lex_state = 6},
  [1606] = {.lex_state = 7},
  [1607] = {.lex_state = 7},
  [1608] = {.lex_state = 6},
  [1609] = {.lex_state = 6},
  [1610] = {.lex_state = 6},
  [1611] = {.lex_state = 7},
  [1612] = {.lex_state = 13},
  [1613] = {.lex_state = 6},
  [1614] = {.lex_state = 6},
  [1615] = {.lex_state = 19},
  [1616] = {.lex_state = 7},
  [1617] = {.lex_state = 6},
  [1618] = {.lex_state = 6},
  [1619] = {.lex_state = 19},
  [1620] = {.lex_state = 19},
  [1621] = {.lex_state = 7},
  [1622] = {.lex_state = 6},
  [1623] = {.lex_state = 6},
  [1624] = {.lex_state = 13},
  [1625] = {.lex_state = 19},
  [1626] = {.lex_state = 19},
  [1627] = {.lex_state = 19},
  [1628] = {.lex_state = 6},
  [1629] = {.lex_state = 6},
  [1630] = {.lex_state = 13},
  [1631] = {.lex_state = 7},
  [1632] = {.lex_state = 19},
  [1633] = {.lex_state = 7},
  [1634] = {.lex_state = 7},
  [1635] = {.lex_state = 7},
  [1636] = {.lex_state = 7},
  [1637] = {.lex_state = 7},
  [1638] = {.lex_state = 7},
  [1639] = {.lex_state = 6},
  [1640] = {.lex_state = 6},
  [1641] = {.lex_state = 7},
  [1642] = {.lex_state = 6},
  [1643] = {.lex_state = 6},
  [1644] = {.lex_state = 6},
  [1645] = {.lex_state = 7},
  [1646] = {.lex_state = 6},
  [1647] = {.lex_state = 6},
  [1648] = {.lex_state = 6},
  [1649] = {.lex_state = 6},
  [1650] = {.lex_state = 6},
  [1651] = {.lex_state = 6},
  [1652] = {.lex_state = 7},
  [1653] = {.lex_state = 6},
  [1654] = {.lex_state = 6},
  [1655] = {.lex_state = 6},
  [1656] = {.lex_state = 6},
  [1657] = {.lex_state = 7},
  [1658] = {.lex_state = 7},
  [1659] = {.lex_state = 7},
  [1660] = {.lex_state = 7},
  [1661] = {.lex_state = 6},
  [1662] = {.lex_state = 7},
  [1663] = {.lex_state = 7},
  [1664] = {.lex_state = 6},
  [1665] = {.lex_state = 7},
  [1666] = {.lex_state = 6},
  [1667] = {.lex_state = 7},
  [1668] = {.lex_state = 6},
  [1669] = {.lex_state = 7},
  [1670] = {.lex_state = 6},
  [1671] = {.lex_state = 7},
  [1672] = {.lex_state = 7},
  [1673] = {.lex_state = 7},
  [1674] = {.lex_state = 6},
  [1675] = {.lex_state = 13},
  [1676] = {.lex_state = 6},
  [1677] = {.lex_state = 7},
  [1678] = {.lex_state = 6},
  [1679] = {.lex_state = 6},
  [1680] = {.lex_state = 7},
  [1681] = {.lex_state = 6},
  [1682] = {.lex_state = 6},
  [1683] = {.lex_state = 6},
  [1684] = {.lex_state = 6},
  [1685] = {.lex_state = 7},
  [1686] = {.lex_state = 6},
  [1687] = {.lex_state = 6},
  [1688] = {.lex_state = 6},
  [1689] = {.lex_state = 6},
  [1690] = {.lex_state = 6},
  [1691] = {.lex_state = 6},
  [1692] = {.lex_state = 6},
  [1693] = {.lex_state = 7},
  [1694] = {.lex_state = 7},
  [1695] = {.lex_state = 7},
  [1696] = {.lex_state = 6},
  [1697] = {.lex_state = 7},
  [1698] = {.lex_state = 7},
  [1699] = {.lex_state = 7},
  [1700] = {.lex_state = 7},
  [1701] = {.lex_state = 7},
  [1702] = {.lex_state = 7},
  [1703] = {.lex_state = 7},
  [1704] = {.lex_state = 7},
  [1705] = {.lex_state = 7},
  [1706] = {.lex_state = 7},
  [1707] = {.lex_state = 6},
  [1708] = {.lex_state = 7},
  [1709] = {.lex_state = 7},
  [1710] = {.lex_state = 6},
  [1711] = {.lex_state = 6},
  [1712] = {.lex_state = 6},
  [1713] = {.lex_state = 6},
  [1714] = {.lex_state = 6},
  [1715] = {.lex_state = 7},
  [1716] = {.lex_state = 7},
  [1717] = {.lex_state = 6},
  [1718] = {.lex_state = 7},
  [1719] = {.lex_state = 7},
  [1720] = {.lex_state = 6},
  [1721] = {.lex_state = 7},
  [1722] = {.lex_state = 7},
  [1723] = {.lex_state = 7},
  [1724] = {.lex_state = 6},
  [1725] = {.lex_state = 7},
  [1726] = {.lex_state = 7},
  [1727] = {.lex_state = 7},
  [1728] = {.lex_state = 6},
  [1729] = {.lex_state = 7},
  [1730] = {.lex_state = 7},
  [1731] = {.lex_state = 7},
  [1732] = {.lex_state = 7},
  [1733] = {.lex_state = 6},
  [1734] = {.lex_state = 7},
  [1735] = {.lex_state = 7},
  [1736] = {.lex_state = 7},
  [1737] = {.lex_state = 6},
  [1738] = {.lex_state = 6},
  [1739] = {.lex_state = 7},
  [1740] = {.lex_state = 7},
  [1741] = {.lex_state = 7},
  [1742] = {.lex_state = 7},
  [1743] = {.lex_state = 7},
  [1744] = {.lex_state = 6},
  [1745] = {.lex_state = 7},
  [1746] = {.lex_state = 7},
  [1747] = {.lex_state = 6},
  [1748] = {.lex_state = 7},
  [1749] = {.lex_state = 7},
  [1750] = {.lex_state = 7},
  [1751] = {.lex_state = 7},
  [1752] = {.lex_state = 7},
  [1753] = {.lex_state = 7},
  [1754] = {.lex_state = 6},
  [1755] = {.lex_state = 6},
  [1756] = {.lex_state = 6},
  [1757] = {.lex_state = 7},
  [1758] = {.lex_state = 6},
  [1759] = {.lex_state = 7},
  [1760] = {.lex_state = 6},
  [1761] = {.lex_state = 7},
  [1762] = {.lex_state = 6},
  [1763] = {.lex_state = 7},
  [1764] = {.lex_state = 7},
  [1765] = {.lex_state = 7},
  [1766] = {.lex_state = 6},
  [1767] = {.lex_state = 7},
  [1768] = {.lex_state = 7},
  [1769] = {.lex_state = 7},
  [1770] = {.lex_state = 7},
  [1771] = {.lex_state = 7},
  [1772] = {.lex_state = 7},
  [1773] = {.lex_state = 6},
  [1774] = {.lex_state = 6},
  [1775] = {.lex_state = 7},
  [1776] = {.lex_state = 7},
  [1777] = {.lex_state = 6},
  [1778] = {.lex_state = 6},
  [1779] = {.lex_state = 7},
  [1780] = {.lex_state = 7},
  [1781] = {.lex_state = 7},
  [1782] = {.lex_state = 7},
  [1783] = {.lex_state = 7},
  [1784] = {.lex_state = 7},
  [1785] = {.lex_state = 7},
  [1786] = {.lex_state = 6},
  [1787] = {.lex_state = 7},
  [1788] = {.lex_state = 7},
  [1789] = {.lex_state = 6},
  [1790] = {.lex_state = 7},
  [1791] = {.lex_state = 7},
  [1792] = {.lex_state = 7},
  [1793] = {.lex_state = 6},
  [1794] = {.lex_state = 6},
  [1795] = {.lex_state = 6},
  [1796] = {.lex_state = 7},
  [1797] = {.lex_state = 7},
  [1798] = {.lex_state = 7},
  [1799] = {.lex_state = 7},
  [1800] = {.lex_state = 7},
  [1801] = {.lex_state = 7},
  [1802] = {.lex_state = 7},
  [1803] = {.lex_state = 7},
  [1804] = {.lex_state = 6},
  [1805] = {.lex_state = 6},
  [1806] = {.lex_state = 7},
  [1807] = {.lex_state = 6},
  [1808] = {.lex_state = 7},
  [1809] = {.lex_state = 7},
  [1810] = {.lex_state = 7},
  [1811] = {.lex_state = 7},
  [1812] = {.lex_state = 7},
  [1813] = {.lex_state = 7},
  [1814] = {.lex_state = 6},
  [1815] = {.lex_state = 6},
  [1816] = {.lex_state = 7},
  [1817] = {.lex_state = 7},
  [1818] = {.lex_state = 6},
  [1819] = {.lex_state = 7},
  [1820] = {.lex_state = 7},
  [1821] = {.lex_state = 7},
  [1822] = {.lex_state = 6},
  [1823] = {.lex_state = 7},
  [1824] = {.lex_state = 6},
  [1825] = {.lex_state = 7},
  [1826] = {.lex_state = 6},
  [1827] = {.lex_state = 6},
  [1828] = {.lex_state = 7},
  [1829] = {.lex_state = 7},
  [1830] = {.lex_state = 6},
  [1831] = {.lex_state = 7},
  [1832] = {.lex_state = 7},
  [1833] = {.lex_state = 6},
  [1834] = {.lex_state = 6},
  [1835] = {.lex_state = 6},
  [1836] = {.lex_state = 7},
  [1837] = {.lex_state = 6},
  [1838] = {.lex_state = 7},
  [1839] = {.lex_state = 7},
  [1840] = {.lex_state = 6},
  [1841] = {.lex_state = 6},
  [1842] = {.lex_state = 6},
  [1843] = {.lex_state = 6},
  [1844] = {.lex_state = 6},
  [1845] = {.lex_state = 6},
  [1846] = {.lex_state = 6},
  [1847] = {.lex_state = 7},
  [1848] = {.lex_state = 6},
  [1849] = {.lex_state = 6},
  [1850] = {.lex_state = 6},
  [1851] = {.lex_state = 6},
  [1852] = {.lex_state = 6},
  [1853] = {.lex_state = 6},
  [1854] = {.lex_state = 6},
  [1855] = {.lex_state = 6},
  [1856] = {.lex_state = 6},
  [1857] = {.lex_state = 6},
  [1858] = {.lex_state = 13},
  [1859] = {.lex_state = 7},
  [1860] = {.lex_state = 6},
  [1861] = {.lex_state = 6},
  [1862] = {.lex_state = 6},
  [1863] = {.lex_state = 6},
  [1864] = {.lex_state = 6},
  [1865] = {.lex_state = 6},
  [1866] = {.lex_state = 6},
  [1867] = {.lex_state = 13},
  [1868] = {.lex_state = 6},
  [1869] = {.lex_state = 6},
  [1870] = {.lex_state = 7},
  [1871] = {.lex_state = 6},
  [1872] = {.lex_state = 6},
  [1873] = {.lex_state = 6},
  [1874] = {.lex_state = 6},
  [1875] = {.lex_state = 6},
  [1876] = {.lex_state = 13},
  [1877] = {.lex_state = 13},
  [1878] = {.lex_state = 13},
  [1879] = {.lex_state = 13},
  [1880] = {.lex_state = 13},
  [1881] = {.lex_state = 13},
  [1882] = {.lex_state = 13},
  [1883] = {.lex_state = 13},
  [1884] = {.lex_state = 13},
  [1885] = {.lex_state = 13},
  [1886] = {.lex_state = 13},
  [1887] = {.lex_state = 13},
  [1888] = {.lex_state = 13},
  [1889] = {.lex_state = 13},
  [1890] = {.lex_state = 13},
  [1891] = {.lex_state = 13},
  [1892] = {.lex_state = 13},
  [1893] = {.lex_state = 13},
  [1894] = {.lex_state = 13},
  [1895] = {.lex_state = 13},
  [1896] = {.lex_state = 13},
  [1897] = {.lex_state = 13},
  [1898] = {.lex_state = 13},
  [1899] = {.lex_state = 13},
  [1900] = {.lex_state = 13},
  [1901] = {.lex_state = 13},
  [1902] = {.lex_state = 26},
  [1903] = {.lex_state = 26},
  [1904] = {.lex_state = 15},
  [1905] = {.lex_state = 15},
  [1906] = {.lex_state = 15},
  [1907] = {.lex_state = 15},
  [1908] = {.lex_state = 15},
  [1909] = {.lex_state = 15},
  [1910] = {.lex_state = 15},
  [1911] = {.lex_state = 15},
  [1912] = {.lex_state = 15},
  [1913] = {.lex_state = 15},
  [1914] = {.lex_state = 26},
  [1915] = {.lex_state = 26},
  [1916] = {.lex_state = 26},
  [1917] = {.lex_state = 26},
  [1918] = {.lex_state = 15},
  [1919] = {.lex_state = 15},
  [1920] = {.lex_state = 15},
  [1921] = {.lex_state = 13},
  [1922] = {.lex_state = 13},
  [1923] = {.lex_state = 13},
  [1924] = {.lex_state = 13},
  [1925] = {.lex_state = 26},
  [1926] = {.lex_state = 13},
  [1927] = {.lex_state = 13},
  [1928] = {.lex_state = 13},
  [1929] = {.lex_state = 13},
  [1930] = {.lex_state = 15},
  [1931] = {.lex_state = 13},
  [1932] = {.lex_state = 13},
  [1933] = {.lex_state = 13},
  [1934] = {.lex_state = 13},
  [1935] = {.lex_state = 13},
  [1936] = {.lex_state = 15},
  [1937] = {.lex_state = 26},
  [1938] = {.lex_state = 15},
  [1939] = {.lex_state = 26},
  [1940] = {.lex_state = 15},
  [1941] = {.lex_state = 13},
  [1942] = {.lex_state = 26},
  [1943] = {.lex_state = 26},
  [1944] = {.lex_state = 13},
  [1945] = {.lex_state = 15},
  [1946] = {.lex_state = 26},
  [1947] = {.lex_state = 26},
  [1948] = {.lex_state = 26},
  [1949] = {.lex_state = 13},
  [1950] = {.lex_state = 13},
  [1951] = {.lex_state = 13},
  [1952] = {.lex_state = 26},
  [1953] = {.lex_state = 26},
  [1954] = {.lex_state = 26},
  [1955] = {.lex_state = 26},
  [1956] = {.lex_state = 26},
  [1957] = {.lex_state = 13},
  [1958] = {.lex_state = 26},
  [1959] = {.lex_state = 26},
  [1960] = {.lex_state = 26},
  [1961] = {.lex_state = 15},
  [1962] = {.lex_state = 13},
  [1963] = {.lex_state = 26},
  [1964] = {.lex_state = 13},
  [1965] = {.lex_state = 26},
  [1966] = {.lex_state = 26},
  [1967] = {.lex_state = 26},
  [1968] = {.lex_state = 26},
  [1969] = {.lex_state = 13},
  [1970] = {.lex_state = 26},
  [1971] = {.lex_state = 26},
  [1972] = {.lex_state = 26},
  [1973] = {.lex_state = 26},
  [1974] = {.lex_state = 15},
  [1975] = {.lex_state = 26},
  [1976] = {.lex_state = 26},
  [1977] = {.lex_state = 13},
  [1978] = {.lex_state = 13},
  [1979] = {.lex_state = 26},
  [1980] = {.lex_state = 26},
  [1981] = {.lex_state = 26},
  [1982] = {.lex_state = 13},
  [1983] = {.lex_state = 26},
  [1984] = {.lex_state = 26},
  [1985] = {.lex_state = 26},
  [1986] = {.lex_state = 26},
  [1987] = {.lex_state = 26},
  [1988] = {.lex_state = 26},
  [1989] = {.lex_state = 26},
  [1990] = {.lex_state = 26},
  [1991] = {.lex_state = 26},
  [1992] = {.lex_state = 13},
  [1993] = {.lex_state = 26},
  [1994] = {.lex_state = 26},
  [1995] = {.lex_state = 26},
  [1996] = {.lex_state = 26},
  [1997] = {.lex_state = 26},
  [1998] = {.lex_state = 15},
  [1999] = {.lex_state = 13},
  [2000] = {.lex_state = 13},
  [2001] = {.lex_state = 26},
  [2002] = {.lex_state = 15},
  [2003] = {.lex_state = 15},
  [2004] = {.lex_state = 15},
  [2005] = {.lex_state = 15},
  [2006] = {.lex_state = 15},
  [2007] = {.lex_state = 26},
  [2008] = {.lex_state = 26},
  [2009] = {.lex_state = 15},
  [2010] = {.lex_state = 15},
  [2011] = {.lex_state = 15},
  [2012] = {.lex_state = 16},
  [2013] = {.lex_state = 15},
  [2014] = {.lex_state = 15},
  [2015] = {.lex_state = 15},
  [2016] = {.lex_state = 15},
  [2017] = {.lex_state = 26},
  [2018] = {.lex_state = 13},
  [2019] = {.lex_state = 13},
  [2020] = {.lex_state = 13},
  [2021] = {.lex_state = 13},
  [2022] = {.lex_state = 13},
  [2023] = {.lex_state = 13},
  [2024] = {.lex_state = 13},
  [2025] = {.lex_state = 13},
  [2026] = {.lex_state = 13},
  [2027] = {.lex_state = 13},
  [2028] = {.lex_state = 13},
  [2029] = {.lex_state = 13},
  [2030] = {.lex_state = 13},
  [2031] = {.lex_state = 13},
  [2032] = {.lex_state = 13},
  [2033] = {.lex_state = 13},
  [2034] = {.lex_state = 13},
  [2035] = {.lex_state = 22},
  [2036] = {.lex_state = 16},
  [2037] = {.lex_state = 26},
  [2038] = {.lex_state = 16},
  [2039] = {.lex_state = 15},
  [2040] = {.lex_state = 20},
  [2041] = {.lex_state = 20},
  [2042] = {.lex_state = 15},
  [2043] = {.lex_state = 26},
  [2044] = {.lex_state = 13},
  [2045] = {.lex_state = 13},
  [2046] = {.lex_state = 20},
  [2047] = {.lex_state = 26},
  [2048] = {.lex_state = 26},
  [2049] = {.lex_state = 13},
  [2050] = {.lex_state = 13},
  [2051] = {.lex_state = 13},
  [2052] = {.lex_state = 13},
  [2053] = {.lex_state = 13},
  [2054] = {.lex_state = 22},
  [2055] = {.lex_state = 13},
  [2056] = {.lex_state = 13},
  [2057] = {.lex_state = 15},
  [2058] = {.lex_state = 15},
  [2059] = {.lex_state = 15},
  [2060] = {.lex_state = 26},
  [2061] = {.lex_state = 15},
  [2062] = {.lex_state = 15},
  [2063] = {.lex_state = 16},
  [2064] = {.lex_state = 15},
  [2065] = {.lex_state = 13},
  [2066] = {.lex_state = 13},
  [2067] = {.lex_state = 16},
  [2068] = {.lex_state = 13},
  [2069] = {.lex_state = 20},
  [2070] = {.lex_state = 13},
  [2071] = {.lex_state = 13},
  [2072] = {.lex_state = 15},
  [2073] = {.lex_state = 13},
  [2074] = {.lex_state = 13},
  [2075] = {.lex_state = 15},
  [2076] = {.lex_state = 13},
  [2077] = {.lex_state = 22},
  [2078] = {.lex_state = 15},
  [2079] = {.lex_state = 26},
  [2080] = {.lex_state = 26},
  [2081] = {.lex_state = 13},
  [2082] = {.lex_state = 13},
  [2083] = {.lex_state = 26},
  [2084] = {.lex_state = 26},
  [2085] = {.lex_state = 26},
  [2086] = {.lex_state = 26},
  [2087] = {.lex_state = 26},
  [2088] = {.lex_state = 26},
  [2089] = {.lex_state = 26},
  [2090] = {.lex_state = 26},
  [2091] = {.lex_state = 26},
  [2092] = {.lex_state = 26},
  [2093] = {.lex_state = 15},
  [2094] = {.lex_state = 26},
  [2095] = {.lex_state = 26},
  [2096] = {.lex_state = 26},
  [2097] = {.lex_state = 26},
  [2098] = {.lex_state = 26},
  [2099] = {.lex_state = 26},
  [2100] = {.lex_state = 26},
  [2101] = {.lex_state = 26},
  [2102] = {.lex_state = 26},
  [2103] = {.lex_state = 26},
  [2104] = {.lex_state = 26},
  [2105] = {.lex_state = 26},
  [2106] = {.lex_state = 22},
  [2107] = {.lex_state = 26},
  [2108] = {.lex_state = 26},
  [2109] = {.lex_state = 26},
  [2110] = {.lex_state = 26},
  [2111] = {.lex_state = 26},
  [2112] = {.lex_state = 26},
  [2113] = {.lex_state = 22},
  [2114] = {.lex_state = 26},
  [2115] = {.lex_state = 26},
  [2116] = {.lex_state = 26},
  [2117] = {.lex_state = 26},
  [2118] = {.lex_state = 16},
  [2119] = {.lex_state = 13},
  [2120] = {.lex_state = 26},
  [2121] = {.lex_state = 26},
  [2122] = {.lex_state = 22},
  [2123] = {.lex_state = 15},
  [2124] = {.lex_state = 15},
  [2125] = {.lex_state = 13},
  [2126] = {.lex_state = 9},
  [2127] = {.lex_state = 26},
  [2128] = {.lex_state = 22},
  [2129] = {.lex_state = 9},
  [2130] = {.lex_state = 13},
  [2131] = {.lex_state = 13},
  [2132] = {.lex_state = 13},
  [2133] = {.lex_state = 68},
  [2134] = {.lex_state = 13},
  [2135] = {.lex_state = 13},
  [2136] = {.lex_state = 16},
  [2137] = {.lex_state = 9},
  [2138] = {.lex_state = 13},
  [2139] = {.lex_state = 13},
  [2140] = {.lex_state = 13},
  [2141] = {.lex_state = 13},
  [2142] = {.lex_state = 13},
  [2143] = {.lex_state = 13},
  [2144] = {.lex_state = 5},
  [2145] = {.lex_state = 13},
  [2146] = {.lex_state = 9},
  [2147] = {.lex_state = 26},
  [2148] = {.lex_state = 13},
  [2149] = {.lex_state = 26},
  [2150] = {.lex_state = 9},
  [2151] = {.lex_state = 5},
  [2152] = {.lex_state = 15},
  [2153] = {.lex_state = 13},
  [2154] = {.lex_state = 26},
  [2155] = {.lex_state = 26},
  [2156] = {.lex_state = 16},
  [2157] = {.lex_state = 13},
  [2158] = {.lex_state = 26},
  [2159] = {.lex_state = 5},
  [2160] = {.lex_state = 13},
  [2161] = {.lex_state = 13},
  [2162] = {.lex_state = 26},
  [2163] = {.lex_state = 13},
  [2164] = {.lex_state = 13},
  [2165] = {.lex_state = 16},
  [2166] = {.lex_state = 13},
  [2167] = {.lex_state = 16},
  [2168] = {.lex_state = 13},
  [2169] = {.lex_state = 13},
  [2170] = {.lex_state = 13},
  [2171] = {.lex_state = 16},
  [2172] = {.lex_state = 13},
  [2173] = {.lex_state = 26},
  [2174] = {.lex_state = 13},
  [2175] = {.lex_state = 26},
  [2176] = {.lex_state = 13},
  [2177] = {.lex_state = 22},
  [2178] = {.lex_state = 22},
  [2179] = {.lex_state = 13},
  [2180] = {.lex_state = 13},
  [2181] = {.lex_state = 13},
  [2182] = {.lex_state = 13},
  [2183] = {.lex_state = 13},
  [2184] = {.lex_state = 13},
  [2185] = {.lex_state = 22},
  [2186] = {.lex_state = 13},
  [2187] = {.lex_state = 13},
  [2188] = {.lex_state = 13},
  [2189] = {.lex_state = 13},
  [2190] = {.lex_state = 13},
  [2191] = {.lex_state = 13},
  [2192] = {.lex_state = 22},
  [2193] = {.lex_state = 22},
  [2194] = {.lex_state = 20},
  [2195] = {.lex_state = 13},
  [2196] = {.lex_state = 13},
  [2197] = {.lex_state = 13},
  [2198] = {.lex_state = 13},
  [2199] = {.lex_state = 22},
  [2200] = {.lex_state = 13},
  [2201] = {.lex_state = 9},
  [2202] = {.lex_state = 22},
  [2203] = {.lex_state = 13},
  [2204] = {.lex_state = 13},
  [2205] = {.lex_state = 13},
  [2206] = {.lex_state = 22},
  [2207] = {.lex_state = 13},
  [2208] = {.lex_state = 13},
  [2209] = {.lex_state = 13},
  [2210] = {.lex_state = 13},
  [2211] = {.lex_state = 22},
  [2212] = {.lex_state = 13},
  [2213] = {.lex_state = 13},
  [2214] = {.lex_state = 13},
  [2215] = {.lex_state = 13},
  [2216] = {.lex_state = 22},
  [2217] = {.lex_state = 13},
  [2218] = {.lex_state = 13},
  [2219] = {.lex_state = 13},
  [2220] = {.lex_state = 22},
  [2221] = {.lex_state = 13},
  [2222] = {.lex_state = 22},
  [2223] = {.lex_state = 13},
  [2224] = {.lex_state = 13},
  [2225] = {.lex_state = 13},
  [2226] = {.lex_state = 13},
  [2227] = {.lex_state = 13},
  [2228] = {.lex_state = 13},
  [2229] = {.lex_state = 13},
  [2230] = {.lex_state = 13},
  [2231] = {.lex_state = 13},
  [2232] = {.lex_state = 68},
  [2233] = {.lex_state = 22},
  [2234] = {.lex_state = 68},
  [2235] = {.lex_state = 68},
  [2236] = {.lex_state = 13},
  [2237] = {.lex_state = 68},
  [2238] = {.lex_state = 68},
  [2239] = {.lex_state = 68},
  [2240] = {.lex_state = 68},
  [2241] = {.lex_state = 26},
  [2242] = {.lex_state = 9},
  [2243] = {.lex_state = 68},
  [2244] = {.lex_state = 13},
  [2245] = {.lex_state = 68},
  [2246] = {.lex_state = 68},
  [2247] = {.lex_state = 22},
  [2248] = {.lex_state = 2},
  [2249] = {.lex_state = 22},
  [2250] = {.lex_state = 68},
  [2251] = {.lex_state = 9},
  [2252] = {.lex_state = 2},
  [2253] = {.lex_state = 22},
  [2254] = {.lex_state = 68},
  [2255] = {.lex_state = 16},
  [2256] = {.lex_state = 68},
  [2257] = {.lex_state = 22},
  [2258] = {.lex_state = 13},
  [2259] = {.lex_state = 26},
  [2260] = {.lex_state = 22},
  [2261] = {.lex_state = 68},
  [2262] = {.lex_state = 68},
  [2263] = {.lex_state = 68},
  [2264] = {.lex_state = 13},
  [2265] = {.lex_state = 68},
  [2266] = {.lex_state = 22},
  [2267] = {.lex_state = 68},
  [2268] = {.lex_state = 68},
  [2269] = {.lex_state = 68},
  [2270] = {.lex_state = 68},
  [2271] = {.lex_state = 13},
  [2272] = {.lex_state = 68},
  [2273] = {.lex_state = 68},
  [2274] = {.lex_state = 68},
  [2275] = {.lex_state = 13},
  [2276] = {.lex_state = 13},
  [2277] = {.lex_state = 13},
  [2278] = {.lex_state = 68},
  [2279] = {.lex_state = 68},
  [2280] = {.lex_state = 68},
  [2281] = {.lex_state = 68},
  [2282] = {.lex_state = 2},
  [2283] = {.lex_state = 68},
  [2284] = {.lex_state = 22},
  [2285] = {.lex_state = 9},
  [2286] = {.lex_state = 13},
  [2287] = {.lex_state = 68},
  [2288] = {.lex_state = 13},
  [2289] = {.lex_state = 26},
  [2290] = {.lex_state = 13},
  [2291] = {.lex_state = 13},
  [2292] = {.lex_state = 13},
  [2293] = {.lex_state = 13},
  [2294] = {.lex_state = 26},
  [2295] = {.lex_state = 17},
  [2296] = {.lex_state = 13},
  [2297] = {.lex_state = 13},
  [2298] = {.lex_state = 13},
  [2299] = {.lex_state = 13},
  [2300] = {.lex_state = 13},
  [2301] = {.lex_state = 13},
  [2302] = {.lex_state = 13},
  [2303] = {.lex_state = 13},
  [2304] = {.lex_state = 13},
  [2305] = {.lex_state = 13},
  [2306] = {.lex_state = 26},
  [2307] = {.lex_state = 17},
  [2308] = {.lex_state = 26},
  [2309] = {.lex_state = 16},
  [2310] = {.lex_state = 13},
  [2311] = {.lex_state = 13},
  [2312] = {.lex_state = 13},
  [2313] = {.lex_state = 68},
  [2314] = {.lex_state = 13},
  [2315] = {.lex_state = 26},
  [2316] = {.lex_state = 26},
  [2317] = {.lex_state = 13},
  [2318] = {.lex_state = 13},
  [2319] = {.lex_state = 13},
  [2320] = {.lex_state = 26},
  [2321] = {.lex_state = 26},
  [2322] = {.lex_state = 2},
  [2323] = {.lex_state = 26},
  [2324] = {.lex_state = 2},
  [2325] = {.lex_state = 13},
  [2326] = {.lex_state = 13},
  [2327] = {.lex_state = 13},
  [2328] = {.lex_state = 13},
  [2329] = {.lex_state = 13},
  [2330] = {.lex_state = 68},
  [2331] = {.lex_state = 26},
  [2332] = {.lex_state = 13},
  [2333] = {.lex_state = 26},
  [2334] = {.lex_state = 13},
  [2335] = {.lex_state = 22},
  [2336] = {.lex_state = 17},
  [2337] = {.lex_state = 13},
  [2338] = {.lex_state = 26},
  [2339] = {.lex_state = 13},
  [2340] = {.lex_state = 12},
  [2341] = {.lex_state = 13},
  [2342] = {.lex_state = 13},
  [2343] = {.lex_state = 26},
  [2344] = {.lex_state = 13},
  [2345] = {.lex_state = 26},
  [2346] = {.lex_state = 13},
  [2347] = {.lex_state = 2},
  [2348] = {.lex_state = 13},
  [2349] = {.lex_state = 13},
  [2350] = {.lex_state = 16},
  [2351] = {.lex_state = 13},
  [2352] = {.lex_state = 13},
  [2353] = {.lex_state = 13},
  [2354] = {.lex_state = 13},
  [2355] = {.lex_state = 13},
  [2356] = {.lex_state = 17},
  [2357] = {.lex_state = 16},
  [2358] = {.lex_state = 12},
  [2359] = {.lex_state = 16},
  [2360] = {.lex_state = 2},
  [2361] = {.lex_state = 26},
  [2362] = {.lex_state = 16},
  [2363] = {.lex_state = 13},
  [2364] = {.lex_state = 16},
  [2365] = {.lex_state = 13},
  [2366] = {.lex_state = 26},
  [2367] = {.lex_state = 13},
  [2368] = {.lex_state = 26},
  [2369] = {.lex_state = 13},
  [2370] = {.lex_state = 13},
  [2371] = {.lex_state = 16},
  [2372] = {.lex_state = 13},
  [2373] = {.lex_state = 17},
  [2374] = {.lex_state = 13},
  [2375] = {.lex_state = 13},
  [2376] = {.lex_state = 13},
  [2377] = {.lex_state = 13},
  [2378] = {.lex_state = 13},
  [2379] = {.lex_state = 13},
  [2380] = {.lex_state = 13},
  [2381] = {.lex_state = 13},
  [2382] = {.lex_state = 17},
  [2383] = {.lex_state = 13},
  [2384] = {.lex_state = 13},
  [2385] = {.lex_state = 26},
  [2386] = {.lex_state = 13},
  [2387] = {.lex_state = 13},
  [2388] = {.lex_state = 5},
  [2389] = {.lex_state = 5},
  [2390] = {.lex_state = 9},
  [2391] = {.lex_state = 9},
  [2392] = {.lex_state = 13},
  [2393] = {.lex_state = 26},
  [2394] = {.lex_state = 13},
  [2395] = {.lex_state = 9},
  [2396] = {.lex_state = 9},
  [2397] = {.lex_state = 13},
  [2398] = {.lex_state = 13},
  [2399] = {.lex_state = 9},
  [2400] = {.lex_state = 68},
  [2401] = {.lex_state = 68},
  [2402] = {.lex_state = 26},
  [2403] = {.lex_state = 9},
  [2404] = {.lex_state = 9},
  [2405] = {.lex_state = 13},
  [2406] = {.lex_state = 9},
  [2407] = {.lex_state = 9},
  [2408] = {.lex_state = 9},
  [2409] = {.lex_state = 13},
  [2410] = {.lex_state = 9},
  [2411] = {.lex_state = 13},
  [2412] = {.lex_state = 26},
  [2413] = {.lex_state = 2},
  [2414] = {.lex_state = 2},
  [2415] = {.lex_state = 9},
  [2416] = {.lex_state = 9},
  [2417] = {.lex_state = 26},
  [2418] = {.lex_state = 9, .external_lex_state = 3},
  [2419] = {.lex_state = 26},
  [2420] = {.lex_state = 13},
  [2421] = {.lex_state = 26},
  [2422] = {.lex_state = 13},
  [2423] = {.lex_state = 26},
  [2424] = {.lex_state = 9},
  [2425] = {.lex_state = 13},
  [2426] = {.lex_state = 26},
  [2427] = {.lex_state = 165},
  [2428] = {.lex_state = 26},
  [2429] = {.lex_state = 9},
  [2430] = {.lex_state = 26},
  [2431] = {.lex_state = 9},
  [2432] = {.lex_state = 26},
  [2433] = {.lex_state = 26},
  [2434] = {.lex_state = 13},
  [2435] = {.lex_state = 9},
  [2436] = {.lex_state = 26},
  [2437] = {.lex_state = 26},
  [2438] = {.lex_state = 13},
  [2439] = {.lex_state = 13},
  [2440] = {.lex_state = 13},
  [2441] = {.lex_state = 26},
  [2442] = {.lex_state = 9},
  [2443] = {.lex_state = 26},
  [2444] = {.lex_state = 5},
  [2445] = {.lex_state = 26},
  [2446] = {.lex_state = 13},
  [2447] = {.lex_state = 26},
  [2448] = {.lex_state = 26},
  [2449] = {.lex_state = 13},
  [2450] = {.lex_state = 26},
  [2451] = {.lex_state = 9},
  [2452] = {.lex_state = 13},
  [2453] = {.lex_state = 13},
  [2454] = {.lex_state = 13},
  [2455] = {.lex_state = 26},
  [2456] = {.lex_state = 26},
  [2457] = {.lex_state = 26},
  [2458] = {.lex_state = 9},
  [2459] = {.lex_state = 26},
  [2460] = {.lex_state = 9},
  [2461] = {.lex_state = 26},
  [2462] = {.lex_state = 26},
  [2463] = {.lex_state = 9},
  [2464] = {.lex_state = 26},
  [2465] = {.lex_state = 13},
  [2466] = {.lex_state = 26},
  [2467] = {.lex_state = 9},
  [2468] = {.lex_state = 9},
  [2469] = {.lex_state = 26},
  [2470] = {.lex_state = 26},
  [2471] = {.lex_state = 5},
  [2472] = {.lex_state = 26},
  [2473] = {.lex_state = 9},
  [2474] = {.lex_state = 26},
  [2475] = {.lex_state = 26},
  [2476] = {.lex_state = 26},
  [2477] = {.lex_state = 13},
  [2478] = {.lex_state = 13},
  [2479] = {.lex_state = 13},
  [2480] = {.lex_state = 13},
  [2481] = {.lex_state = 26},
  [2482] = {.lex_state = 9},
  [2483] = {.lex_state = 9},
  [2484] = {.lex_state = 9},
  [2485] = {.lex_state = 9},
  [2486] = {.lex_state = 9},
  [2487] = {.lex_state = 9},
  [2488] = {.lex_state = 26},
  [2489] = {.lex_state = 9},
  [2490] = {.lex_state = 26},
  [2491] = {.lex_state = 9},
  [2492] = {.lex_state = 26},
  [2493] = {.lex_state = 26},
  [2494] = {.lex_state = 9},
  [2495] = {.lex_state = 5},
  [2496] = {.lex_state = 9},
  [2497] = {.lex_state = 9, .external_lex_state = 4},
  [2498] = {.lex_state = 9},
  [2499] = {.lex_state = 9},
  [2500] = {.lex_state = 9},
  [2501] = {.lex_state = 13},
  [2502] = {.lex_state = 13},
  [2503] = {.lex_state = 13},
  [2504] = {.lex_state = 68},
  [2505] = {.lex_state = 68},
  [2506] = {.lex_state = 9},
  [2507] = {.lex_state = 13},
  [2508] = {.lex_state = 13},
  [2509] = {.lex_state = 9, .external_lex_state = 4},
  [2510] = {.lex_state = 68},
  [2511] = {.lex_state = 9},
  [2512] = {.lex_state = 9},
  [2513] = {.lex_state = 9},
  [2514] = {.lex_state = 68},
  [2515] = {.lex_state = 15},
  [2516] = {.lex_state = 5},
  [2517] = {.lex_state = 68},
  [2518] = {.lex_state = 9},
  [2519] = {.lex_state = 68},
  [2520] = {.lex_state = 9},
  [2521] = {.lex_state = 13},
  [2522] = {.lex_state = 13},
  [2523] = {.lex_state = 9},
  [2524] = {.lex_state = 13},
  [2525] = {.lex_state = 9, .external_lex_state = 4},
  [2526] = {.lex_state = 28},
  [2527] = {.lex_state = 68},
  [2528] = {.lex_state = 13},
  [2529] = {.lex_state = 9},
  [2530] = {.lex_state = 68},
  [2531] = {.lex_state = 15},
  [2532] = {.lex_state = 5},
  [2533] = {.lex_state = 5},
  [2534] = {.lex_state = 9},
  [2535] = {.lex_state = 5},
  [2536] = {.lex_state = 68},
  [2537] = {.lex_state = 5},
  [2538] = {.lex_state = 68},
  [2539] = {.lex_state = 68},
  [2540] = {.lex_state = 26},
  [2541] = {.lex_state = 68},
  [2542] = {.lex_state = 68},
  [2543] = {.lex_state = 68},
  [2544] = {.lex_state = 9},
  [2545] = {.lex_state = 13},
  [2546] = {.lex_state = 9, .external_lex_state = 4},
  [2547] = {.lex_state = 26},
  [2548] = {.lex_state = 9},
  [2549] = {.lex_state = 5},
  [2550] = {.lex_state = 13},
  [2551] = {.lex_state = 9},
  [2552] = {.lex_state = 9},
  [2553] = {.lex_state = 26},
  [2554] = {.lex_state = 68},
  [2555] = {.lex_state = 68},
  [2556] = {.lex_state = 26},
  [2557] = {.lex_state = 9},
  [2558] = {.lex_state = 28},
  [2559] = {.lex_state = 5},
  [2560] = {.lex_state = 26},
  [2561] = {.lex_state = 68},
  [2562] = {.lex_state = 68},
  [2563] = {.lex_state = 13},
  [2564] = {.lex_state = 68},
  [2565] = {.lex_state = 9},
  [2566] = {.lex_state = 9},
  [2567] = {.lex_state = 13},
  [2568] = {.lex_state = 13},
  [2569] = {.lex_state = 9},
  [2570] = {.lex_state = 13},
  [2571] = {.lex_state = 5},
  [2572] = {.lex_state = 13},
  [2573] = {.lex_state = 9},
  [2574] = {.lex_state = 26},
  [2575] = {.lex_state = 9},
  [2576] = {.lex_state = 13},
  [2577] = {.lex_state = 26},
  [2578] = {.lex_state = 13},
  [2579] = {.lex_state = 28},
  [2580] = {.lex_state = 9},
  [2581] = {.lex_state = 13},
  [2582] = {.lex_state = 68},
  [2583] = {.lex_state = 2},
  [2584] = {.lex_state = 13},
  [2585] = {.lex_state = 9},
  [2586] = {.lex_state = 13},
  [2587] = {.lex_state = 9},
  [2588] = {.lex_state = 5},
  [2589] = {.lex_state = 68},
  [2590] = {.lex_state = 9},
  [2591] = {.lex_state = 9},
  [2592] = {.lex_state = 9, .external_lex_state = 4},
  [2593] = {.lex_state = 13},
  [2594] = {.lex_state = 68},
  [2595] = {.lex_state = 5},
  [2596] = {.lex_state = 9},
  [2597] = {.lex_state = 28},
  [2598] = {.lex_state = 9},
  [2599] = {.lex_state = 68},
  [2600] = {.lex_state = 9},
  [2601] = {.lex_state = 9, .external_lex_state = 4},
  [2602] = {.lex_state = 9},
  [2603] = {.lex_state = 68},
  [2604] = {.lex_state = 9},
  [2605] = {.lex_state = 9},
  [2606] = {.lex_state = 9},
  [2607] = {.lex_state = 9},
  [2608] = {.lex_state = 9},
  [2609] = {.lex_state = 9},
  [2610] = {.lex_state = 13},
  [2611] = {.lex_state = 9, .external_lex_state = 4},
  [2612] = {.lex_state = 5},
  [2613] = {.lex_state = 68},
  [2614] = {.lex_state = 9},
  [2615] = {.lex_state = 9},
  [2616] = {.lex_state = 9},
  [2617] = {.lex_state = 9},
  [2618] = {.lex_state = 68},
  [2619] = {.lex_state = 68},
  [2620] = {.lex_state = 13},
  [2621] = {.lex_state = 2},
  [2622] = {.lex_state = 5},
  [2623] = {.lex_state = 13},
  [2624] = {.lex_state = 2},
  [2625] = {.lex_state = 5},
  [2626] = {.lex_state = 13},
  [2627] = {.lex_state = 9},
  [2628] = {.lex_state = 16},
  [2629] = {.lex_state = 9},
  [2630] = {.lex_state = 15},
  [2631] = {.lex_state = 68},
  [2632] = {.lex_state = 13},
  [2633] = {.lex_state = 13},
  [2634] = {.lex_state = 9},
  [2635] = {.lex_state = 16},
  [2636] = {.lex_state = 68},
  [2637] = {.lex_state = 68},
  [2638] = {.lex_state = 13},
  [2639] = {.lex_state = 13},
  [2640] = {.lex_state = 9},
  [2641] = {.lex_state = 68},
  [2642] = {.lex_state = 5},
  [2643] = {.lex_state = 16},
  [2644] = {.lex_state = 9},
  [2645] = {.lex_state = 16},
  [2646] = {.lex_state = 2},
  [2647] = {.lex_state = 13},
  [2648] = {.lex_state = 9, .external_lex_state = 4},
  [2649] = {.lex_state = 16},
  [2650] = {.lex_state = 13},
  [2651] = {.lex_state = 13},
  [2652] = {.lex_state = 9},
  [2653] = {.lex_state = 9, .external_lex_state = 4},
  [2654] = {.lex_state = 9, .external_lex_state = 4},
  [2655] = {.lex_state = 26},
  [2656] = {.lex_state = 68},
  [2657] = {.lex_state = 5},
  [2658] = {.lex_state = 9},
  [2659] = {.lex_state = 5},
  [2660] = {.lex_state = 16},
  [2661] = {.lex_state = 68},
  [2662] = {.lex_state = 68},
  [2663] = {.lex_state = 16},
  [2664] = {.lex_state = 9, .external_lex_state = 4},
  [2665] = {.lex_state = 16},
  [2666] = {.lex_state = 5},
  [2667] = {.lex_state = 68},
  [2668] = {.lex_state = 9},
  [2669] = {.lex_state = 13},
  [2670] = {.lex_state = 5},
  [2671] = {.lex_state = 5},
  [2672] = {.lex_state = 13},
  [2673] = {.lex_state = 26},
  [2674] = {.lex_state = 5},
  [2675] = {.lex_state = 68},
  [2676] = {.lex_state = 5},
  [2677] = {.lex_state = 5},
  [2678] = {.lex_state = 68},
  [2679] = {.lex_state = 68},
  [2680] = {.lex_state = 68},
  [2681] = {.lex_state = 68},
  [2682] = {.lex_state = 68},
  [2683] = {.lex_state = 68},
  [2684] = {.lex_state = 68},
  [2685] = {.lex_state = 5},
  [2686] = {.lex_state = 9, .external_lex_state = 4},
  [2687] = {.lex_state = 26},
  [2688] = {.lex_state = 5},
  [2689] = {.lex_state = 68},
  [2690] = {.lex_state = 5},
  [2691] = {.lex_state = 5},
  [2692] = {.lex_state = 68},
  [2693] = {.lex_state = 68},
  [2694] = {.lex_state = 26},
  [2695] = {.lex_state = 9, .external_lex_state = 4},
  [2696] = {.lex_state = 5},
  [2697] = {.lex_state = 5},
  [2698] = {.lex_state = 26},
  [2699] = {.lex_state = 5},
  [2700] = {.lex_state = 5},
  [2701] = {.lex_state = 5},
  [2702] = {.lex_state = 5},
  [2703] = {.lex_state = 13},
  [2704] = {.lex_state = 5},
  [2705] = {.lex_state = 5},
  [2706] = {.lex_state = 5},
  [2707] = {.lex_state = 5},
  [2708] = {.lex_state = 5},
  [2709] = {.lex_state = 5},
  [2710] = {.lex_state = 5},
  [2711] = {.lex_state = 5},
  [2712] = {.lex_state = 9},
  [2713] = {.lex_state = 68},
  [2714] = {.lex_state = 13},
  [2715] = {.lex_state = 5},
  [2716] = {.lex_state = 9},
  [2717] = {.lex_state = 5},
  [2718] = {.lex_state = 68},
  [2719] = {.lex_state = 5},
  [2720] = {.lex_state = 5},
  [2721] = {.lex_state = 26},
  [2722] = {.lex_state = 9},
  [2723] = {.lex_state = 5},
  [2724] = {.lex_state = 13},
  [2725] = {.lex_state = 9},
  [2726] = {.lex_state = 2},
  [2727] = {.lex_state = 13},
  [2728] = {.lex_state = 5},
  [2729] = {.lex_state = 9},
  [2730] = {.lex_state = 68},
  [2731] = {.lex_state = 68},
  [2732] = {.lex_state = 68},
  [2733] = {.lex_state = 16},
  [2734] = {.lex_state = 13},
  [2735] = {.lex_state = 13},
  [2736] = {.lex_state = 16},
  [2737] = {.lex_state = 16},
  [2738] = {.lex_state = 5},
  [2739] = {.lex_state = 16},
  [2740] = {.lex_state = 16},
  [2741] = {.lex_state = 68},
  [2742] = {.lex_state = 16},
  [2743] = {.lex_state = 13},
  [2744] = {.lex_state = 68},
  [2745] = {.lex_state = 5},
  [2746] = {.lex_state = 68},
  [2747] = {.lex_state = 16},
  [2748] = {.lex_state = 5},
  [2749] = {.lex_state = 16},
  [2750] = {.lex_state = 68},
  [2751] = {.lex_state = 68},
  [2752] = {.lex_state = 68},
  [2753] = {.lex_state = 16},
  [2754] = {.lex_state = 16},
  [2755] = {.lex_state = 5},
  [2756] = {.lex_state = 17},
  [2757] = {.lex_state = 68},
  [2758] = {.lex_state = 16},
  [2759] = {.lex_state = 16},
  [2760] = {.lex_state = 16},
  [2761] = {.lex_state = 16},
  [2762] = {.lex_state = 16},
  [2763] = {.lex_state = 16},
  [2764] = {.lex_state = 13},
  [2765] = {.lex_state = 16},
  [2766] = {.lex_state = 16},
  [2767] = {.lex_state = 5},
  [2768] = {.lex_state = 68},
  [2769] = {.lex_state = 68},
  [2770] = {.lex_state = 68},
  [2771] = {.lex_state = 68},
  [2772] = {.lex_state = 68},
  [2773] = {.lex_state = 68},
  [2774] = {.lex_state = 16},
  [2775] = {.lex_state = 16},
  [2776] = {.lex_state = 26},
  [2777] = {.lex_state = 16},
  [2778] = {.lex_state = 68},
  [2779] = {.lex_state = 16},
  [2780] = {.lex_state = 68},
  [2781] = {.lex_state = 68},
  [2782] = {.lex_state = 68},
  [2783] = {.lex_state = 16},
  [2784] = {.lex_state = 68},
  [2785] = {.lex_state = 16},
  [2786] = {.lex_state = 68},
  [2787] = {.lex_state = 68},
  [2788] = {.lex_state = 68},
  [2789] = {.lex_state = 16},
  [2790] = {.lex_state = 68},
  [2791] = {.lex_state = 68},
  [2792] = {.lex_state = 16},
  [2793] = {.lex_state = 16},
  [2794] = {.lex_state = 13},
  [2795] = {.lex_state = 16},
  [2796] = {.lex_state = 16},
  [2797] = {.lex_state = 68},
  [2798] = {.lex_state = 26},
  [2799] = {.lex_state = 68},
  [2800] = {.lex_state = 68},
  [2801] = {.lex_state = 68},
  [2802] = {.lex_state = 68},
  [2803] = {.lex_state = 68},
  [2804] = {.lex_state = 16},
  [2805] = {.lex_state = 68},
  [2806] = {.lex_state = 16},
  [2807] = {.lex_state = 68},
  [2808] = {.lex_state = 16},
  [2809] = {.lex_state = 5},
  [2810] = {.lex_state = 68},
  [2811] = {.lex_state = 16},
  [2812] = {.lex_state = 68},
  [2813] = {.lex_state = 68},
  [2814] = {.lex_state = 68},
  [2815] = {.lex_state = 68},
  [2816] = {.lex_state = 68},
  [2817] = {.lex_state = 13},
  [2818] = {.lex_state = 68},
  [2819] = {.lex_state = 68},
  [2820] = {.lex_state = 68},
  [2821] = {.lex_state = 68},
  [2822] = {.lex_state = 68},
  [2823] = {.lex_state = 13},
  [2824] = {.lex_state = 68},
  [2825] = {.lex_state = 68},
  [2826] = {.lex_state = 68},
  [2827] = {.lex_state = 68},
  [2828] = {.lex_state = 68},
  [2829] = {.lex_state = 68},
  [2830] = {.lex_state = 9},
  [2831] = {.lex_state = 9},
  [2832] = {.lex_state = 68},
  [2833] = {.lex_state = 68},
  [2834] = {.lex_state = 68},
  [2835] = {.lex_state = 68},
  [2836] = {.lex_state = 68},
  [2837] = {.lex_state = 13},
  [2838] = {.lex_state = 68},
  [2839] = {.lex_state = 16},
  [2840] = {.lex_state = 68},
  [2841] = {.lex_state = 68},
  [2842] = {.lex_state = 68},
  [2843] = {.lex_state = 68},
  [2844] = {.lex_state = 68},
  [2845] = {.lex_state = 13},
  [2846] = {.lex_state = 68},
  [2847] = {.lex_state = 68},
  [2848] = {.lex_state = 16},
  [2849] = {.lex_state = 68},
  [2850] = {.lex_state = 68},
  [2851] = {.lex_state = 68},
  [2852] = {.lex_state = 13},
  [2853] = {.lex_state = 68},
  [2854] = {.lex_state = 68},
  [2855] = {.lex_state = 68},
  [2856] = {.lex_state = 9, .external_lex_state = 4},
  [2857] = {.lex_state = 13},
  [2858] = {.lex_state = 68},
  [2859] = {.lex_state = 5},
  [2860] = {.lex_state = 68},
  [2861] = {.lex_state = 68},
  [2862] = {.lex_state = 68},
  [2863] = {.lex_state = 68},
  [2864] = {.lex_state = 68},
  [2865] = {.lex_state = 68},
  [2866] = {.lex_state = 68},
  [2867] = {.lex_state = 68},
  [2868] = {.lex_state = 13},
  [2869] = {.lex_state = 68},
  [2870] = {.lex_state = 68},
  [2871] = {.lex_state = 68},
  [2872] = {.lex_state = 68},
  [2873] = {.lex_state = 68},
  [2874] = {.lex_state = 68},
  [2875] = {.lex_state = 68},
  [2876] = {.lex_state = 9},
  [2877] = {.lex_state = 68},
  [2878] = {.lex_state = 68},
  [2879] = {.lex_state = 68},
  [2880] = {.lex_state = 68},
  [2881] = {.lex_state = 68},
  [2882] = {.lex_state = 68},
  [2883] = {.lex_state = 68},
  [2884] = {.lex_state = 68},
  [2885] = {.lex_state = 68},
  [2886] = {.lex_state = 68},
  [2887] = {.lex_state = 17},
  [2888] = {.lex_state = 68},
  [2889] = {.lex_state = 68},
  [2890] = {.lex_state = 68},
  [2891] = {.lex_state = 68},
  [2892] = {.lex_state = 68},
  [2893] = {.lex_state = 68},
  [2894] = {.lex_state = 68},
  [2895] = {.lex_state = 68},
  [2896] = {.lex_state = 13},
  [2897] = {.lex_state = 68},
  [2898] = {.lex_state = 68},
  [2899] = {.lex_state = 68},
  [2900] = {.lex_state = 68},
  [2901] = {.lex_state = 13},
  [2902] = {.lex_state = 68},
  [2903] = {.lex_state = 68},
  [2904] = {.lex_state = 13},
  [2905] = {.lex_state = 68},
  [2906] = {.lex_state = 68},
  [2907] = {.lex_state = 68},
  [2908] = {.lex_state = 13},
  [2909] = {.lex_state = 68},
  [2910] = {.lex_state = 68},
  [2911] = {.lex_state = 68},
  [2912] = {.lex_state = 68},
  [2913] = {.lex_state = 68},
  [2914] = {.lex_state = 68},
  [2915] = {.lex_state = 68},
  [2916] = {.lex_state = 68},
  [2917] = {.lex_state = 68},
  [2918] = {.lex_state = 68},
  [2919] = {.lex_state = 68},
  [2920] = {.lex_state = 68},
  [2921] = {.lex_state = 68},
  [2922] = {.lex_state = 5},
  [2923] = {.lex_state = 5},
  [2924] = {.lex_state = 68},
  [2925] = {.lex_state = 68},
  [2926] = {.lex_state = 5},
  [2927] = {.lex_state = 68},
  [2928] = {.lex_state = 68},
  [2929] = {.lex_state = 68},
  [2930] = {.lex_state = 13},
  [2931] = {.lex_state = 13},
  [2932] = {.lex_state = 68},
  [2933] = {.lex_state = 68},
  [2934] = {.lex_state = 68},
  [2935] = {.lex_state = 68},
  [2936] = {.lex_state = 68},
  [2937] = {.lex_state = 68},
  [2938] = {.lex_state = 68},
  [2939] = {.lex_state = 68},
  [2940] = {.lex_state = 68},
  [2941] = {.lex_state = 68},
  [2942] = {.lex_state = 68},
  [2943] = {.lex_state = 68},
  [2944] = {.lex_state = 68},
  [2945] = {.lex_state = 13},
  [2946] = {.lex_state = 68},
  [2947] = {.lex_state = 68},
  [2948] = {.lex_state = 68},
  [2949] = {.lex_state = 68},
  [2950] = {.lex_state = 68},
  [2951] = {.lex_state = 68},
  [2952] = {.lex_state = 68},
  [2953] = {.lex_state = 13},
  [2954] = {.lex_state = 68},
  [2955] = {.lex_state = 13},
  [2956] = {.lex_state = 68},
  [2957] = {.lex_state = 16},
  [2958] = {.lex_state = 68},
  [2959] = {.lex_state = 68},
  [2960] = {.lex_state = 68},
  [2961] = {.lex_state = 68},
  [2962] = {.lex_state = 68},
  [2963] = {.lex_state = 68},
  [2964] = {.lex_state = 68},
  [2965] = {.lex_state = 17},
  [2966] = {.lex_state = 5},
  [2967] = {.lex_state = 68},
  [2968] = {.lex_state = 68},
  [2969] = {.lex_state = 68},
  [2970] = {.lex_state = 9},
  [2971] = {.lex_state = 68},
  [2972] = {.lex_state = 68},
  [2973] = {.lex_state = 68},
  [2974] = {.lex_state = 16},
  [2975] = {.lex_state = 68},
  [2976] = {.lex_state = 68},
  [2977] = {.lex_state = 68},
  [2978] = {.lex_state = 68},
  [2979] = {.lex_state = 68},
  [2980] = {.lex_state = 68},
  [2981] = {.lex_state = 68},
  [2982] = {.lex_state = 68},
  [2983] = {.lex_state = 68},
  [2984] = {.lex_state = 68},
  [2985] = {.lex_state = 68},
  [2986] = {.lex_state = 68},
  [2987] = {.lex_state = 68},
  [2988] = {.lex_state = 17},
  [2989] = {.lex_state = 68},
  [2990] = {.lex_state = 5},
  [2991] = {.lex_state = 68},
  [2992] = {.lex_state = 68},
  [2993] = {.lex_state = 68},
  [2994] = {.lex_state = 68},
  [2995] = {.lex_state = 68},
  [2996] = {.lex_state = 68},
  [2997] = {.lex_state = 68},
  [2998] = {.lex_state = 68},
  [2999] = {.lex_state = 68},
  [3000] = {.lex_state = 68},
  [3001] = {.lex_state = 13},
  [3002] = {.lex_state = 68},
  [3003] = {.lex_state = 13},
  [3004] = {.lex_state = 5},
  [3005] = {.lex_state = 13},
  [3006] = {.lex_state = 13},
  [3007] = {.lex_state = 13},
  [3008] = {.lex_state = 17},
  [3009] = {.lex_state = 68},
  [3010] = {.lex_state = 68},
  [3011] = {.lex_state = 68},
  [3012] = {.lex_state = 68},
  [3013] = {.lex_state = 68},
  [3014] = {.lex_state = 68},
  [3015] = {.lex_state = 68},
  [3016] = {.lex_state = 68},
  [3017] = {.lex_state = 13},
  [3018] = {.lex_state = 68},
  [3019] = {.lex_state = 68},
  [3020] = {.lex_state = 68},
  [3021] = {.lex_state = 68},
  [3022] = {.lex_state = 68},
  [3023] = {.lex_state = 68},
  [3024] = {.lex_state = 5},
  [3025] = {.lex_state = 68},
  [3026] = {.lex_state = 68},
  [3027] = {.lex_state = 68},
  [3028] = {.lex_state = 68},
  [3029] = {.lex_state = 68},
  [3030] = {.lex_state = 68},
  [3031] = {.lex_state = 68},
  [3032] = {.lex_state = 68},
  [3033] = {.lex_state = 68},
  [3034] = {.lex_state = 68},
  [3035] = {.lex_state = 68},
  [3036] = {.lex_state = 13},
  [3037] = {.lex_state = 68},
  [3038] = {.lex_state = 13},
  [3039] = {.lex_state = 68},
  [3040] = {.lex_state = 68},
  [3041] = {.lex_state = 13},
  [3042] = {.lex_state = 13},
  [3043] = {.lex_state = 68},
  [3044] = {.lex_state = 13},
  [3045] = {.lex_state = 68},
  [3046] = {.lex_state = 68},
  [3047] = {.lex_state = 13},
  [3048] = {.lex_state = 13},
  [3049] = {.lex_state = 68},
  [3050] = {.lex_state = 13},
  [3051] = {.lex_state = 68},
  [3052] = {.lex_state = 68},
  [3053] = {.lex_state = 13},
  [3054] = {.lex_state = 13},
  [3055] = {.lex_state = 13},
  [3056] = {.lex_state = 68},
  [3057] = {.lex_state = 68},
  [3058] = {.lex_state = 68},
  [3059] = {.lex_state = 68},
  [3060] = {.lex_state = 13},
  [3061] = {.lex_state = 68},
  [3062] = {.lex_state = 13},
  [3063] = {.lex_state = 68},
  [3064] = {.lex_state = 68},
  [3065] = {.lex_state = 13},
  [3066] = {.lex_state = 13},
  [3067] = {.lex_state = 13},
  [3068] = {.lex_state = 13},
  [3069] = {.lex_state = 13},
  [3070] = {.lex_state = 13},
  [3071] = {.lex_state = 68},
  [3072] = {.lex_state = 26},
  [3073] = {.lex_state = 13},
  [3074] = {.lex_state = 68},
  [3075] = {.lex_state = 13},
  [3076] = {.lex_state = 13},
  [3077] = {.lex_state = 68},
  [3078] = {.lex_state = 13},
  [3079] = {.lex_state = 13},
  [3080] = {.lex_state = 68},
  [3081] = {.lex_state = 68},
  [3082] = {.lex_state = 68},
  [3083] = {.lex_state = 68},
  [3084] = {.lex_state = 68},
  [3085] = {.lex_state = 13},
  [3086] = {.lex_state = 68},
  [3087] = {.lex_state = 68},
  [3088] = {.lex_state = 13},
  [3089] = {.lex_state = 13},
  [3090] = {.lex_state = 68},
  [3091] = {.lex_state = 68},
  [3092] = {.lex_state = 13},
  [3093] = {.lex_state = 13},
  [3094] = {.lex_state = 13},
  [3095] = {.lex_state = 68},
  [3096] = {.lex_state = 13},
  [3097] = {.lex_state = 13},
  [3098] = {.lex_state = 68},
  [3099] = {.lex_state = 13},
  [3100] = {.lex_state = 68},
  [3101] = {.lex_state = 13},
  [3102] = {.lex_state = 68},
  [3103] = {.lex_state = 68},
  [3104] = {.lex_state = 13},
  [3105] = {.lex_state = 13},
  [3106] = {.lex_state = 68},
  [3107] = {.lex_state = 13},
  [3108] = {.lex_state = 68},
  [3109] = {.lex_state = 68},
  [3110] = {.lex_state = 68},
  [3111] = {.lex_state = 68},
  [3112] = {.lex_state = 68},
  [3113] = {.lex_state = 68},
  [3114] = {.lex_state = 68},
  [3115] = {.lex_state = 68},
  [3116] = {.lex_state = 68},
  [3117] = {.lex_state = 68},
  [3118] = {.lex_state = 13},
  [3119] = {.lex_state = 13},
  [3120] = {.lex_state = 68},
  [3121] = {.lex_state = 68},
  [3122] = {.lex_state = 68},
  [3123] = {.lex_state = 68},
  [3124] = {.lex_state = 13},
  [3125] = {.lex_state = 9, .external_lex_state = 5},
  [3126] = {.lex_state = 68},
  [3127] = {.lex_state = 9, .external_lex_state = 5},
  [3128] = {.lex_state = 68},
  [3129] = {.lex_state = 13},
  [3130] = {.lex_state = 9, .external_lex_state = 5},
  [3131] = {.lex_state = 68},
  [3132] = {.lex_state = 68},
  [3133] = {.lex_state = 68},
  [3134] = {.lex_state = 13},
  [3135] = {.lex_state = 13},
  [3136] = {.lex_state = 13},
  [3137] = {.lex_state = 68},
  [3138] = {.lex_state = 13},
  [3139] = {.lex_state = 68},
  [3140] = {.lex_state = 68},
  [3141] = {.lex_state = 26},
  [3142] = {.lex_state = 13},
  [3143] = {.lex_state = 68},
  [3144] = {.lex_state = 13},
  [3145] = {.lex_state = 13},
  [3146] = {.lex_state = 68},
  [3147] = {.lex_state = 68},
  [3148] = {.lex_state = 68},
  [3149] = {.lex_state = 68},
  [3150] = {.lex_state = 68, .external_lex_state = 6},
  [3151] = {.lex_state = 68},
  [3152] = {.lex_state = 68},
  [3153] = {.lex_state = 13},
  [3154] = {.lex_state = 68},
  [3155] = {.lex_state = 68},
  [3156] = {.lex_state = 68},
  [3157] = {.lex_state = 68},
  [3158] = {.lex_state = 68},
  [3159] = {.lex_state = 68},
  [3160] = {.lex_state = 68},
  [3161] = {.lex_state = 5},
  [3162] = {.lex_state = 13},
  [3163] = {.lex_state = 13},
  [3164] = {.lex_state = 13},
  [3165] = {.lex_state = 68},
  [3166] = {.lex_state = 68},
  [3167] = {.lex_state = 13},
  [3168] = {.lex_state = 68},
  [3169] = {.lex_state = 26},
  [3170] = {.lex_state = 26},
  [3171] = {.lex_state = 13},
  [3172] = {.lex_state = 17},
  [3173] = {.lex_state = 13},
  [3174] = {.lex_state = 68},
  [3175] = {.lex_state = 68},
  [3176] = {.lex_state = 13},
  [3177] = {.lex_state = 68},
  [3178] = {.lex_state = 68},
  [3179] = {.lex_state = 68},
  [3180] = {.lex_state = 68},
  [3181] = {.lex_state = 68},
  [3182] = {.lex_state = 68},
  [3183] = {.lex_state = 68},
  [3184] = {.lex_state = 68},
  [3185] = {.lex_state = 68},
  [3186] = {.lex_state = 13},
  [3187] = {.lex_state = 68},
  [3188] = {.lex_state = 13},
  [3189] = {.lex_state = 13},
  [3190] = {.lex_state = 13},
  [3191] = {.lex_state = 13},
  [3192] = {.lex_state = 68},
  [3193] = {.lex_state = 68},
  [3194] = {.lex_state = 68},
  [3195] = {.lex_state = 68},
  [3196] = {.lex_state = 68},
  [3197] = {.lex_state = 13},
  [3198] = {.lex_state = 68},
  [3199] = {.lex_state = 68},
  [3200] = {.lex_state = 68},
  [3201] = {.lex_state = 68},
  [3202] = {.lex_state = 9},
  [3203] = {.lex_state = 68},
  [3204] = {.lex_state = 68},
  [3205] = {.lex_state = 68},
  [3206] = {.lex_state = 68},
  [3207] = {.lex_state = 68},
  [3208] = {.lex_state = 68},
  [3209] = {.lex_state = 68},
  [3210] = {.lex_state = 68},
  [3211] = {.lex_state = 13},
  [3212] = {.lex_state = 68},
  [3213] = {.lex_state = 68},
  [3214] = {.lex_state = 68},
  [3215] = {.lex_state = 68},
  [3216] = {.lex_state = 68},
  [3217] = {.lex_state = 68},
  [3218] = {.lex_state = 13},
  [3219] = {.lex_state = 13},
  [3220] = {.lex_state = 68},
  [3221] = {.lex_state = 13},
  [3222] = {.lex_state = 68},
  [3223] = {.lex_state = 68},
  [3224] = {.lex_state = 68},
  [3225] = {.lex_state = 68},
  [3226] = {.lex_state = 68},
  [3227] = {.lex_state = 13},
  [3228] = {.lex_state = 68},
  [3229] = {.lex_state = 13},
  [3230] = {.lex_state = 13},
  [3231] = {.lex_state = 68},
  [3232] = {.lex_state = 68},
  [3233] = {.lex_state = 68},
  [3234] = {.lex_state = 68},
  [3235] = {.lex_state = 68},
  [3236] = {.lex_state = 68},
  [3237] = {.lex_state = 4},
  [3238] = {.lex_state = 13},
  [3239] = {.lex_state = 13},
  [3240] = {.lex_state = 68},
  [3241] = {.lex_state = 68},
  [3242] = {.lex_state = 68},
  [3243] = {.lex_state = 13},
  [3244] = {.lex_state = 68},
  [3245] = {.lex_state = 68},
  [3246] = {.lex_state = 68},
  [3247] = {.lex_state = 26},
  [3248] = {.lex_state = 13},
  [3249] = {.lex_state = 68},
  [3250] = {.lex_state = 68},
  [3251] = {.lex_state = 13},
  [3252] = {.lex_state = 68},
  [3253] = {.lex_state = 13},
  [3254] = {.lex_state = 13},
  [3255] = {.lex_state = 13},
  [3256] = {.lex_state = 9},
  [3257] = {.lex_state = 4},
  [3258] = {.lex_state = 68},
  [3259] = {.lex_state = 68},
  [3260] = {.lex_state = 68},
  [3261] = {.lex_state = 13},
  [3262] = {.lex_state = 68},
  [3263] = {.lex_state = 68},
  [3264] = {.lex_state = 68},
  [3265] = {.lex_state = 68},
  [3266] = {.lex_state = 68},
  [3267] = {.lex_state = 13},
  [3268] = {.lex_state = 13},
  [3269] = {.lex_state = 13},
  [3270] = {.lex_state = 5},
  [3271] = {.lex_state = 13},
  [3272] = {.lex_state = 13},
  [3273] = {.lex_state = 13},
  [3274] = {.lex_state = 13},
  [3275] = {.lex_state = 13},
  [3276] = {.lex_state = 68},
  [3277] = {.lex_state = 68},
  [3278] = {.lex_state = 68},
  [3279] = {.lex_state = 13},
  [3280] = {.lex_state = 13},
  [3281] = {.lex_state = 13},
  [3282] = {.lex_state = 68},
  [3283] = {.lex_state = 13},
  [3284] = {.lex_state = 13},
  [3285] = {.lex_state = 68},
  [3286] = {.lex_state = 13},
  [3287] = {.lex_state = 68},
  [3288] = {.lex_state = 13},
  [3289] = {.lex_state = 13},
  [3290] = {.lex_state = 13},
  [3291] = {.lex_state = 68},
  [3292] = {.lex_state = 13},
  [3293] = {.lex_state = 13},
  [3294] = {.lex_state = 68},
  [3295] = {.lex_state = 13},
  [3296] = {.lex_state = 13},
  [3297] = {.lex_state = 13},
  [3298] = {.lex_state = 13},
  [3299] = {.lex_state = 68},
  [3300] = {.lex_state = 13},
  [3301] = {.lex_state = 13},
  [3302] = {.lex_state = 13},
  [3303] = {.lex_state = 13},
  [3304] = {.lex_state = 68},
  [3305] = {.lex_state = 68},
  [3306] = {.lex_state = 68},
  [3307] = {.lex_state = 68, .external_lex_state = 6},
  [3308] = {.lex_state = 13},
  [3309] = {.lex_state = 13},
  [3310] = {.lex_state = 13},
  [3311] = {.lex_state = 26},
  [3312] = {.lex_state = 68},
  [3313] = {.lex_state = 68, .external_lex_state = 7},
  [3314] = {.lex_state = 13},
  [3315] = {.lex_state = 13},
  [3316] = {.lex_state = 13},
  [3317] = {.lex_state = 13},
  [3318] = {.lex_state = 13},
  [3319] = {.lex_state = 69},
  [3320] = {.lex_state = 13},
  [3321] = {.lex_state = 68},
  [3322] = {.lex_state = 13},
  [3323] = {.lex_state = 68},
  [3324] = {.lex_state = 68, .external_lex_state = 7},
  [3325] = {.lex_state = 68},
  [3326] = {.lex_state = 13},
  [3327] = {.lex_state = 68},
  [3328] = {.lex_state = 13},
  [3329] = {.lex_state = 68},
  [3330] = {.lex_state = 13},
  [3331] = {.lex_state = 68},
  [3332] = {.lex_state = 13},
  [3333] = {.lex_state = 68},
  [3334] = {.lex_state = 68},
  [3335] = {.lex_state = 68},
  [3336] = {.lex_state = 68},
  [3337] = {.lex_state = 13},
  [3338] = {.lex_state = 68},
  [3339] = {.lex_state = 68},
  [3340] = {.lex_state = 68, .external_lex_state = 7},
  [3341] = {.lex_state = 69},
  [3342] = {.lex_state = 69},
  [3343] = {.lex_state = 68},
  [3344] = {.lex_state = 13},
  [3345] = {.lex_state = 68},
  [3346] = {.lex_state = 9},
  [3347] = {.lex_state = 13},
  [3348] = {.lex_state = 13},
  [3349] = {.lex_state = 68},
  [3350] = {.lex_state = 13},
  [3351] = {.lex_state = 13},
  [3352] = {.lex_state = 13},
  [3353] = {.lex_state = 13},
  [3354] = {.lex_state = 13},
  [3355] = {.lex_state = 68},
  [3356] = {.lex_state = 13},
  [3357] = {.lex_state = 68},
  [3358] = {.lex_state = 13},
  [3359] = {.lex_state = 13},
  [3360] = {.lex_state = 68},
  [3361] = {.lex_state = 68},
  [3362] = {.lex_state = 68},
  [3363] = {.lex_state = 68},
  [3364] = {.lex_state = 68},
  [3365] = {.lex_state = 68},
  [3366] = {.lex_state = 68},
  [3367] = {.lex_state = 68},
  [3368] = {.lex_state = 68},
  [3369] = {.lex_state = 68},
  [3370] = {.lex_state = 13},
  [3371] = {.lex_state = 68},
  [3372] = {.lex_state = 68},
  [3373] = {.lex_state = 68},
  [3374] = {.lex_state = 68},
  [3375] = {.lex_state = 68, .external_lex_state = 8},
  [3376] = {.lex_state = 13},
  [3377] = {.lex_state = 68},
  [3378] = {.lex_state = 68},
  [3379] = {.lex_state = 68},
  [3380] = {.lex_state = 68},
  [3381] = {.lex_state = 17},
  [3382] = {.lex_state = 68},
  [3383] = {.lex_state = 68},
  [3384] = {.lex_state = 13},
  [3385] = {.lex_state = 68},
  [3386] = {.lex_state = 69},
  [3387] = {.lex_state = 68, .external_lex_state = 8},
  [3388] = {.lex_state = 68},
  [3389] = {.lex_state = 13},
  [3390] = {.lex_state = 13},
  [3391] = {.lex_state = 68},
  [3392] = {.lex_state = 68},
  [3393] = {.lex_state = 17},
  [3394] = {.lex_state = 13},
  [3395] = {.lex_state = 68},
  [3396] = {.lex_state = 68, .external_lex_state = 8},
  [3397] = {.lex_state = 17},
  [3398] = {.lex_state = 13},
  [3399] = {.lex_state = 68},
  [3400] = {.lex_state = 68},
  [3401] = {.lex_state = 68},
  [3402] = {.lex_state = 68},
  [3403] = {.lex_state = 69},
  [3404] = {.lex_state = 68},
  [3405] = {.lex_state = 68},
  [3406] = {.lex_state = 68},
  [3407] = {.lex_state = 13},
  [3408] = {.lex_state = 68},
  [3409] = {.lex_state = 13},
  [3410] = {.lex_state = 68},
  [3411] = {.lex_state = 68},
  [3412] = {.lex_state = 68},
  [3413] = {.lex_state = 17},
  [3414] = {.lex_state = 17},
  [3415] = {.lex_state = 68},
  [3416] = {.lex_state = 68},
  [3417] = {.lex_state = 68},
  [3418] = {.lex_state = 68},
  [3419] = {.lex_state = 68},
  [3420] = {.lex_state = 68},
  [3421] = {.lex_state = 13},
  [3422] = {.lex_state = 68},
  [3423] = {.lex_state = 68},
  [3424] = {.lex_state = 68},
  [3425] = {.lex_state = 68},
  [3426] = {.lex_state = 68},
  [3427] = {.lex_state = 68},
  [3428] = {.lex_state = 68},
  [3429] = {.lex_state = 68},
  [3430] = {.lex_state = 17},
  [3431] = {.lex_state = 13},
  [3432] = {.lex_state = 13},
  [3433] = {.lex_state = 13},
  [3434] = {.lex_state = 68},
  [3435] = {.lex_state = 68},
  [3436] = {.lex_state = 68},
  [3437] = {.lex_state = 68, .external_lex_state = 8},
  [3438] = {.lex_state = 68},
  [3439] = {.lex_state = 68},
  [3440] = {.lex_state = 13},
  [3441] = {.lex_state = 13},
  [3442] = {.lex_state = 69},
  [3443] = {.lex_state = 68},
  [3444] = {.lex_state = 68},
  [3445] = {.lex_state = 9},
  [3446] = {.lex_state = 13},
  [3447] = {.lex_state = 68},
  [3448] = {.lex_state = 68},
  [3449] = {.lex_state = 68},
  [3450] = {.lex_state = 68},
  [3451] = {.lex_state = 68},
  [3452] = {.lex_state = 68},
  [3453] = {.lex_state = 68},
  [3454] = {.lex_state = 68},
  [3455] = {.lex_state = 68},
  [3456] = {.lex_state = 68},
  [3457] = {.lex_state = 17},
  [3458] = {.lex_state = 68},
  [3459] = {.lex_state = 68},
  [3460] = {.lex_state = 68},
  [3461] = {.lex_state = 68},
  [3462] = {.lex_state = 68},
  [3463] = {.lex_state = 68},
  [3464] = {.lex_state = 68},
  [3465] = {.lex_state = 13},
  [3466] = {.lex_state = 68},
  [3467] = {.lex_state = 68},
  [3468] = {.lex_state = 68},
  [3469] = {.lex_state = 68},
  [3470] = {.lex_state = 68},
  [3471] = {.lex_state = 68},
  [3472] = {.lex_state = 68},
  [3473] = {.lex_state = 68},
  [3474] = {.lex_state = 68},
  [3475] = {.lex_state = 68},
  [3476] = {.lex_state = 13},
  [3477] = {.lex_state = 68},
  [3478] = {.lex_state = 13},
  [3479] = {.lex_state = 68, .external_lex_state = 8},
  [3480] = {.lex_state = 68},
  [3481] = {.lex_state = 68},
  [3482] = {.lex_state = 17},
  [3483] = {.lex_state = 68},
  [3484] = {.lex_state = 68},
  [3485] = {.lex_state = 68},
  [3486] = {.lex_state = 68},
  [3487] = {.lex_state = 68},
  [3488] = {.lex_state = 68},
  [3489] = {.lex_state = 13},
  [3490] = {.lex_state = 68},
  [3491] = {.lex_state = 68},
  [3492] = {.lex_state = 68},
  [3493] = {.lex_state = 69},
  [3494] = {.lex_state = 68, .external_lex_state = 9},
  [3495] = {.lex_state = 68, .external_lex_state = 9},
  [3496] = {.lex_state = 68},
  [3497] = {.lex_state = 68, .external_lex_state = 9},
  [3498] = {.lex_state = 13},
  [3499] = {.lex_state = 163},
  [3500] = {.lex_state = 68, .external_lex_state = 7},
  [3501] = {.lex_state = 68},
  [3502] = {.lex_state = 17},
  [3503] = {.lex_state = 68},
  [3504] = {.lex_state = 68},
  [3505] = {.lex_state = 68},
  [3506] = {.lex_state = 13},
  [3507] = {.lex_state = 68},
  [3508] = {.lex_state = 17},
  [3509] = {.lex_state = 13},
  [3510] = {.lex_state = 68},
  [3511] = {.lex_state = 68},
  [3512] = {.lex_state = 68},
  [3513] = {.lex_state = 68},
  [3514] = {.lex_state = 68},
  [3515] = {.lex_state = 68},
  [3516] = {.lex_state = 13},
  [3517] = {.lex_state = 13},
  [3518] = {.lex_state = 68},
  [3519] = {.lex_state = 68, .external_lex_state = 7},
  [3520] = {.lex_state = 68},
  [3521] = {.lex_state = 68},
  [3522] = {.lex_state = 68},
  [3523] = {.lex_state = 68},
  [3524] = {.lex_state = 68},
  [3525] = {.lex_state = 68, .external_lex_state = 7},
  [3526] = {.lex_state = 68},
  [3527] = {.lex_state = 68},
  [3528] = {.lex_state = 68},
  [3529] = {.lex_state = 68},
  [3530] = {.lex_state = 68},
  [3531] = {.lex_state = 68},
  [3532] = {.lex_state = 68},
  [3533] = {.lex_state = 68},
  [3534] = {.lex_state = 68},
  [3535] = {.lex_state = 68},
  [3536] = {.lex_state = 68},
  [3537] = {.lex_state = 68},
  [3538] = {.lex_state = 13},
  [3539] = {.lex_state = 13},
  [3540] = {.lex_state = 68},
  [3541] = {.lex_state = 17},
  [3542] = {.lex_state = 68},
  [3543] = {.lex_state = 13},
  [3544] = {.lex_state = 68},
  [3545] = {.lex_state = 17},
  [3546] = {.lex_state = 17},
  [3547] = {.lex_state = 68},
  [3548] = {.lex_state = 68},
  [3549] = {.lex_state = 17},
  [3550] = {.lex_state = 68},
  [3551] = {.lex_state = 17},
  [3552] = {.lex_state = 13},
  [3553] = {.lex_state = 68},
  [3554] = {.lex_state = 13},
  [3555] = {.lex_state = 13},
  [3556] = {.lex_state = 68},
  [3557] = {.lex_state = 68},
  [3558] = {.lex_state = 13},
  [3559] = {.lex_state = 68},
  [3560] = {.lex_state = 68},
  [3561] = {.lex_state = 17},
  [3562] = {.lex_state = 13},
  [3563] = {.lex_state = 68},
  [3564] = {.lex_state = 13},
  [3565] = {.lex_state = 17},
  [3566] = {.lex_state = 17},
  [3567] = {.lex_state = 68},
  [3568] = {.lex_state = 68},
  [3569] = {.lex_state = 68},
  [3570] = {.lex_state = 68},
  [3571] = {.lex_state = 17},
  [3572] = {.lex_state = 68},
  [3573] = {.lex_state = 68},
  [3574] = {.lex_state = 68},
  [3575] = {.lex_state = 68},
  [3576] = {.lex_state = 68},
  [3577] = {.lex_state = 69},
  [3578] = {.lex_state = 68},
  [3579] = {.lex_state = 13},
  [3580] = {.lex_state = 68},
  [3581] = {.lex_state = 68},
  [3582] = {.lex_state = 68},
  [3583] = {.lex_state = 17},
  [3584] = {.lex_state = 68, .external_lex_state = 8},
  [3585] = {.lex_state = 17},
  [3586] = {.lex_state = 68},
  [3587] = {.lex_state = 68},
  [3588] = {.lex_state = 17},
  [3589] = {.lex_state = 13},
  [3590] = {.lex_state = 13},
  [3591] = {.lex_state = 17},
  [3592] = {.lex_state = 17},
  [3593] = {.lex_state = 68},
  [3594] = {.lex_state = 17},
  [3595] = {.lex_state = 17},
  [3596] = {.lex_state = 17},
  [3597] = {.lex_state = 17},
  [3598] = {.lex_state = 13},
  [3599] = {.lex_state = 13},
  [3600] = {.lex_state = 68},
  [3601] = {.lex_state = 13},
  [3602] = {.lex_state = 13},
  [3603] = {.lex_state = 68},
  [3604] = {.lex_state = 68},
  [3605] = {.lex_state = 13},
  [3606] = {.lex_state = 13},
  [3607] = {.lex_state = 13},
  [3608] = {.lex_state = 13},
  [3609] = {.lex_state = 13},
  [3610] = {.lex_state = 68},
  [3611] = {(TSStateId)(-1)},
  [3612] = {(TSStateId)(-1)},
  [3613] = {(TSStateId)(-1)},
  [3614] = {(TSStateId)(-1)},
  [3615] = {(TSStateId)(-1)},
  [3616] = {(TSStateId)(-1)},
  [3617] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_line_comment] = STATE(0),
    [sym_block_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_macro_rules_BANG] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_block] = ACTIONS(1),
    [anon_sym_expr] = ACTIONS(1),
    [anon_sym_ident] = ACTIONS(1),
    [anon_sym_item] = ACTIONS(1),
    [anon_sym_lifetime] = ACTIONS(1),
    [anon_sym_literal] = ACTIONS(1),
    [anon_sym_meta] = ACTIONS(1),
    [anon_sym_pat] = ACTIONS(1),
    [anon_sym_path] = ACTIONS(1),
    [anon_sym_stmt] = ACTIONS(1),
    [anon_sym_tt] = ACTIONS(1),
    [anon_sym_ty] = ACTIONS(1),
    [anon_sym_vis] = ACTIONS(1),
    [anon_sym_u8] = ACTIONS(1),
    [anon_sym_i8] = ACTIONS(1),
    [anon_sym_u16] = ACTIONS(1),
    [anon_sym_i16] = ACTIONS(1),
    [anon_sym_u32] = ACTIONS(1),
    [anon_sym_i32] = ACTIONS(1),
    [anon_sym_u64] = ACTIONS(1),
    [anon_sym_i64] = ACTIONS(1),
    [anon_sym_u128] = ACTIONS(1),
    [anon_sym_i128] = ACTIONS(1),
    [anon_sym_isize] = ACTIONS(1),
    [anon_sym_usize] = ACTIONS(1),
    [anon_sym_f32] = ACTIONS(1),
    [anon_sym_f64] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_str] = ACTIONS(1),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_impl] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_loop] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_pub] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_trait] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_LT2] = ACTIONS(1),
    [anon_sym_dyn] = ACTIONS(1),
    [sym_mutable_specifier] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_move] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [sym_integer_literal] = ACTIONS(1),
    [aux_sym_string_literal_token1] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_char_literal] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [sym__inner_line_doc_comment_marker] = ACTIONS(1),
    [sym__outer_line_doc_comment_marker] = ACTIONS(1),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [sym_shebang] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_crate] = ACTIONS(1),
    [sym_metavariable] = ACTIONS(1),
    [sym_string_content] = ACTIONS(1),
    [sym__raw_string_literal_start] = ACTIONS(1),
    [sym_raw_string_literal_content] = ACTIONS(1),
    [sym__raw_string_literal_end] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym__outer_block_doc_comment_marker] = ACTIONS(1),
    [sym__inner_block_doc_comment_marker] = ACTIONS(1),
    [sym__block_comment_content] = ACTIONS(1),
    [sym__line_doc_content] = ACTIONS(1),
    [sym__error_sentinel] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(3518),
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1848),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(1),
    [sym_block_comment] = STATE(1),
    [aux_sym_source_file_repeat1] = STATE(5),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(35),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_shebang] = ACTIONS(105),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [2] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1822),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(2),
    [sym_block_comment] = STATE(2),
    [aux_sym_source_file_repeat1] = STATE(32),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [3] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1643),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(3),
    [sym_block_comment] = STATE(3),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(121),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [4] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1724),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(4),
    [sym_block_comment] = STATE(4),
    [aux_sym_source_file_repeat1] = STATE(31),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [5] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1848),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(5),
    [sym_block_comment] = STATE(5),
    [aux_sym_source_file_repeat1] = STATE(20),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [ts_builtin_sym_end] = ACTIONS(125),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [6] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1684),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(6),
    [sym_block_comment] = STATE(6),
    [aux_sym_source_file_repeat1] = STATE(15),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(127),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [7] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1690),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(7),
    [sym_block_comment] = STATE(7),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [8] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1710),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(8),
    [sym_block_comment] = STATE(8),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [9] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1837),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(9),
    [sym_block_comment] = STATE(9),
    [aux_sym_source_file_repeat1] = STATE(27),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [10] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1758),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(10),
    [sym_block_comment] = STATE(10),
    [aux_sym_source_file_repeat1] = STATE(12),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [11] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1649),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(11),
    [sym_block_comment] = STATE(11),
    [aux_sym_source_file_repeat1] = STATE(13),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [12] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1720),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(12),
    [sym_block_comment] = STATE(12),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [13] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1653),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(13),
    [sym_block_comment] = STATE(13),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(141),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [14] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1815),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(14),
    [sym_block_comment] = STATE(14),
    [aux_sym_source_file_repeat1] = STATE(17),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(143),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [15] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1714),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(15),
    [sym_block_comment] = STATE(15),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(145),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [16] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1744),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(16),
    [sym_block_comment] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(28),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [17] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1834),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(17),
    [sym_block_comment] = STATE(17),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [18] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1646),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(18),
    [sym_block_comment] = STATE(18),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [19] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1848),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(19),
    [sym_block_comment] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(20),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [ts_builtin_sym_end] = ACTIONS(153),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [20] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1848),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(20),
    [sym_block_comment] = STATE(20),
    [aux_sym_source_file_repeat1] = STATE(20),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [ts_builtin_sym_end] = ACTIONS(155),
    [sym_identifier] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(160),
    [anon_sym_macro_rules_BANG] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_STAR] = ACTIONS(175),
    [anon_sym_u8] = ACTIONS(178),
    [anon_sym_i8] = ACTIONS(178),
    [anon_sym_u16] = ACTIONS(178),
    [anon_sym_i16] = ACTIONS(178),
    [anon_sym_u32] = ACTIONS(178),
    [anon_sym_i32] = ACTIONS(178),
    [anon_sym_u64] = ACTIONS(178),
    [anon_sym_i64] = ACTIONS(178),
    [anon_sym_u128] = ACTIONS(178),
    [anon_sym_i128] = ACTIONS(178),
    [anon_sym_isize] = ACTIONS(178),
    [anon_sym_usize] = ACTIONS(178),
    [anon_sym_f32] = ACTIONS(178),
    [anon_sym_f64] = ACTIONS(178),
    [anon_sym_bool] = ACTIONS(178),
    [anon_sym_str] = ACTIONS(178),
    [anon_sym_char] = ACTIONS(178),
    [anon_sym_DASH] = ACTIONS(175),
    [anon_sym_BANG] = ACTIONS(175),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_PIPE] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(190),
    [anon_sym_COLON_COLON] = ACTIONS(193),
    [anon_sym_POUND] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_async] = ACTIONS(202),
    [anon_sym_break] = ACTIONS(205),
    [anon_sym_const] = ACTIONS(208),
    [anon_sym_continue] = ACTIONS(211),
    [anon_sym_default] = ACTIONS(214),
    [anon_sym_enum] = ACTIONS(217),
    [anon_sym_fn] = ACTIONS(220),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_impl] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(232),
    [anon_sym_loop] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(238),
    [anon_sym_mod] = ACTIONS(241),
    [anon_sym_pub] = ACTIONS(244),
    [anon_sym_return] = ACTIONS(247),
    [anon_sym_static] = ACTIONS(250),
    [anon_sym_struct] = ACTIONS(253),
    [anon_sym_trait] = ACTIONS(256),
    [anon_sym_type] = ACTIONS(259),
    [anon_sym_union] = ACTIONS(262),
    [anon_sym_unsafe] = ACTIONS(265),
    [anon_sym_use] = ACTIONS(268),
    [anon_sym_while] = ACTIONS(271),
    [anon_sym_extern] = ACTIONS(274),
    [anon_sym_yield] = ACTIONS(277),
    [anon_sym_move] = ACTIONS(280),
    [anon_sym_try] = ACTIONS(283),
    [sym_integer_literal] = ACTIONS(286),
    [aux_sym_string_literal_token1] = ACTIONS(289),
    [sym_char_literal] = ACTIONS(286),
    [anon_sym_true] = ACTIONS(292),
    [anon_sym_false] = ACTIONS(292),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(295),
    [sym_super] = ACTIONS(298),
    [sym_crate] = ACTIONS(301),
    [sym_metavariable] = ACTIONS(304),
    [sym__raw_string_literal_start] = ACTIONS(307),
    [sym_float_literal] = ACTIONS(286),
  },
  [21] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1756),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(21),
    [sym_block_comment] = STATE(21),
    [aux_sym_source_file_repeat1] = STATE(8),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(310),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [22] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1644),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(22),
    [sym_block_comment] = STATE(22),
    [aux_sym_source_file_repeat1] = STATE(18),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(312),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [23] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1848),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(23),
    [sym_block_comment] = STATE(23),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [ts_builtin_sym_end] = ACTIONS(125),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [24] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1848),
    [sym_macro_invocation] = STATE(401),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(24),
    [sym_block_comment] = STATE(24),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(160),
    [anon_sym_macro_rules_BANG] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(175),
    [anon_sym_u8] = ACTIONS(178),
    [anon_sym_i8] = ACTIONS(178),
    [anon_sym_u16] = ACTIONS(178),
    [anon_sym_i16] = ACTIONS(178),
    [anon_sym_u32] = ACTIONS(178),
    [anon_sym_i32] = ACTIONS(178),
    [anon_sym_u64] = ACTIONS(178),
    [anon_sym_i64] = ACTIONS(178),
    [anon_sym_u128] = ACTIONS(178),
    [anon_sym_i128] = ACTIONS(178),
    [anon_sym_isize] = ACTIONS(178),
    [anon_sym_usize] = ACTIONS(178),
    [anon_sym_f32] = ACTIONS(178),
    [anon_sym_f64] = ACTIONS(178),
    [anon_sym_bool] = ACTIONS(178),
    [anon_sym_str] = ACTIONS(178),
    [anon_sym_char] = ACTIONS(178),
    [anon_sym_DASH] = ACTIONS(175),
    [anon_sym_BANG] = ACTIONS(175),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_PIPE] = ACTIONS(184),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(190),
    [anon_sym_COLON_COLON] = ACTIONS(193),
    [anon_sym_POUND] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_async] = ACTIONS(202),
    [anon_sym_break] = ACTIONS(205),
    [anon_sym_const] = ACTIONS(208),
    [anon_sym_continue] = ACTIONS(211),
    [anon_sym_default] = ACTIONS(214),
    [anon_sym_enum] = ACTIONS(217),
    [anon_sym_fn] = ACTIONS(220),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_impl] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(232),
    [anon_sym_loop] = ACTIONS(235),
    [anon_sym_match] = ACTIONS(238),
    [anon_sym_mod] = ACTIONS(241),
    [anon_sym_pub] = ACTIONS(244),
    [anon_sym_return] = ACTIONS(247),
    [anon_sym_static] = ACTIONS(250),
    [anon_sym_struct] = ACTIONS(253),
    [anon_sym_trait] = ACTIONS(256),
    [anon_sym_type] = ACTIONS(259),
    [anon_sym_union] = ACTIONS(262),
    [anon_sym_unsafe] = ACTIONS(265),
    [anon_sym_use] = ACTIONS(268),
    [anon_sym_while] = ACTIONS(271),
    [anon_sym_extern] = ACTIONS(274),
    [anon_sym_yield] = ACTIONS(277),
    [anon_sym_move] = ACTIONS(280),
    [anon_sym_try] = ACTIONS(283),
    [sym_integer_literal] = ACTIONS(286),
    [aux_sym_string_literal_token1] = ACTIONS(289),
    [sym_char_literal] = ACTIONS(286),
    [anon_sym_true] = ACTIONS(292),
    [anon_sym_false] = ACTIONS(292),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(295),
    [sym_super] = ACTIONS(298),
    [sym_crate] = ACTIONS(301),
    [sym_metavariable] = ACTIONS(304),
    [sym__raw_string_literal_start] = ACTIONS(307),
    [sym_float_literal] = ACTIONS(286),
  },
  [25] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1682),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(25),
    [sym_block_comment] = STATE(25),
    [aux_sym_source_file_repeat1] = STATE(7),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(314),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [26] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1642),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(26),
    [sym_block_comment] = STATE(26),
    [aux_sym_source_file_repeat1] = STATE(3),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(316),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [27] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1833),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(27),
    [sym_block_comment] = STATE(27),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(318),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [28] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1711),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(28),
    [sym_block_comment] = STATE(28),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(320),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [29] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1830),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(29),
    [sym_block_comment] = STATE(29),
    [aux_sym_source_file_repeat1] = STATE(34),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(322),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [30] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1686),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(30),
    [sym_block_comment] = STATE(30),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(324),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [31] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1774),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(31),
    [sym_block_comment] = STATE(31),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(326),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [32] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1773),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(32),
    [sym_block_comment] = STATE(32),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(328),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [33] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1691),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(33),
    [sym_block_comment] = STATE(33),
    [aux_sym_source_file_repeat1] = STATE(30),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(330),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [34] = {
    [sym__statement] = STATE(605),
    [sym_empty_statement] = STATE(609),
    [sym_expression_statement] = STATE(609),
    [sym_macro_definition] = STATE(609),
    [sym_attribute_item] = STATE(609),
    [sym_inner_attribute_item] = STATE(609),
    [sym_mod_item] = STATE(609),
    [sym_foreign_mod_item] = STATE(609),
    [sym_struct_item] = STATE(609),
    [sym_union_item] = STATE(609),
    [sym_enum_item] = STATE(609),
    [sym_extern_crate_declaration] = STATE(609),
    [sym_const_item] = STATE(609),
    [sym_static_item] = STATE(609),
    [sym_type_item] = STATE(609),
    [sym_function_item] = STATE(609),
    [sym_function_signature_item] = STATE(609),
    [sym_function_modifiers] = STATE(3517),
    [sym_impl_item] = STATE(609),
    [sym_trait_item] = STATE(609),
    [sym_associated_type] = STATE(609),
    [sym_let_declaration] = STATE(609),
    [sym_use_declaration] = STATE(609),
    [sym_extern_modifier] = STATE(2142),
    [sym_visibility_modifier] = STATE(1931),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1824),
    [sym_macro_invocation] = STATE(392),
    [sym_scoped_identifier] = STATE(1534),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(384),
    [sym_match_expression] = STATE(384),
    [sym_while_expression] = STATE(384),
    [sym_loop_expression] = STATE(384),
    [sym_for_expression] = STATE(384),
    [sym_const_block] = STATE(384),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3502),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(384),
    [sym_async_block] = STATE(384),
    [sym_try_block] = STATE(384),
    [sym_block] = STATE(384),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(34),
    [sym_block_comment] = STATE(34),
    [aux_sym_source_file_repeat1] = STATE(24),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(332),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [35] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1492),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(35),
    [sym_block_comment] = STATE(35),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(336),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_RPAREN] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_RBRACK] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(336),
    [anon_sym_COLON] = ACTIONS(340),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PERCENT] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(336),
    [anon_sym_PIPE_PIPE] = ACTIONS(336),
    [anon_sym_LT_LT] = ACTIONS(342),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [anon_sym_DASH_EQ] = ACTIONS(336),
    [anon_sym_STAR_EQ] = ACTIONS(336),
    [anon_sym_SLASH_EQ] = ACTIONS(336),
    [anon_sym_PERCENT_EQ] = ACTIONS(336),
    [anon_sym_CARET_EQ] = ACTIONS(336),
    [anon_sym_AMP_EQ] = ACTIONS(336),
    [anon_sym_PIPE_EQ] = ACTIONS(336),
    [anon_sym_LT_LT_EQ] = ACTIONS(336),
    [anon_sym_GT_GT_EQ] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(342),
    [anon_sym_EQ_EQ] = ACTIONS(336),
    [anon_sym_BANG_EQ] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(336),
    [anon_sym_LT_EQ] = ACTIONS(336),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(336),
    [anon_sym_COMMA] = ACTIONS(336),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(342),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(342),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [36] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1491),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(35),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(36),
    [sym_block_comment] = STATE(36),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym_LPAREN] = ACTIONS(368),
    [anon_sym_RPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_RBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(372),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(370),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [37] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1494),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(37),
    [sym_block_comment] = STATE(37),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(374),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_RBRACK] = ACTIONS(374),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(374),
    [anon_sym_PLUS] = ACTIONS(376),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_QMARK] = ACTIONS(374),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(376),
    [anon_sym_SLASH] = ACTIONS(376),
    [anon_sym_PERCENT] = ACTIONS(376),
    [anon_sym_CARET] = ACTIONS(376),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_AMP_AMP] = ACTIONS(374),
    [anon_sym_PIPE_PIPE] = ACTIONS(374),
    [anon_sym_LT_LT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(376),
    [anon_sym_PLUS_EQ] = ACTIONS(374),
    [anon_sym_DASH_EQ] = ACTIONS(374),
    [anon_sym_STAR_EQ] = ACTIONS(374),
    [anon_sym_SLASH_EQ] = ACTIONS(374),
    [anon_sym_PERCENT_EQ] = ACTIONS(374),
    [anon_sym_CARET_EQ] = ACTIONS(374),
    [anon_sym_AMP_EQ] = ACTIONS(374),
    [anon_sym_PIPE_EQ] = ACTIONS(374),
    [anon_sym_LT_LT_EQ] = ACTIONS(374),
    [anon_sym_GT_GT_EQ] = ACTIONS(374),
    [anon_sym_EQ] = ACTIONS(376),
    [anon_sym_EQ_EQ] = ACTIONS(374),
    [anon_sym_BANG_EQ] = ACTIONS(374),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(374),
    [anon_sym_LT_EQ] = ACTIONS(374),
    [anon_sym_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(374),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(376),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(376),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [38] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1482),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(38),
    [sym_block_comment] = STATE(38),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(378),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(378),
    [anon_sym_RBRACK] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_STAR] = ACTIONS(380),
    [anon_sym_QMARK] = ACTIONS(378),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_SLASH] = ACTIONS(380),
    [anon_sym_PERCENT] = ACTIONS(380),
    [anon_sym_CARET] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(380),
    [anon_sym_PIPE] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(378),
    [anon_sym_PIPE_PIPE] = ACTIONS(378),
    [anon_sym_LT_LT] = ACTIONS(380),
    [anon_sym_GT_GT] = ACTIONS(380),
    [anon_sym_PLUS_EQ] = ACTIONS(378),
    [anon_sym_DASH_EQ] = ACTIONS(378),
    [anon_sym_STAR_EQ] = ACTIONS(378),
    [anon_sym_SLASH_EQ] = ACTIONS(378),
    [anon_sym_PERCENT_EQ] = ACTIONS(378),
    [anon_sym_CARET_EQ] = ACTIONS(378),
    [anon_sym_AMP_EQ] = ACTIONS(378),
    [anon_sym_PIPE_EQ] = ACTIONS(378),
    [anon_sym_LT_LT_EQ] = ACTIONS(378),
    [anon_sym_GT_GT_EQ] = ACTIONS(378),
    [anon_sym_EQ] = ACTIONS(380),
    [anon_sym_EQ_EQ] = ACTIONS(378),
    [anon_sym_BANG_EQ] = ACTIONS(378),
    [anon_sym_GT] = ACTIONS(380),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(378),
    [anon_sym_LT_EQ] = ACTIONS(378),
    [anon_sym_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(378),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(378),
    [anon_sym_COMMA] = ACTIONS(378),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(380),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(380),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [39] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1494),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(39),
    [sym_block_comment] = STATE(39),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_RPAREN] = ACTIONS(374),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_RBRACK] = ACTIONS(374),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(374),
    [anon_sym_PLUS] = ACTIONS(376),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_QMARK] = ACTIONS(374),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(376),
    [anon_sym_SLASH] = ACTIONS(376),
    [anon_sym_PERCENT] = ACTIONS(376),
    [anon_sym_CARET] = ACTIONS(376),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_AMP_AMP] = ACTIONS(374),
    [anon_sym_PIPE_PIPE] = ACTIONS(374),
    [anon_sym_LT_LT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(376),
    [anon_sym_PLUS_EQ] = ACTIONS(374),
    [anon_sym_DASH_EQ] = ACTIONS(374),
    [anon_sym_STAR_EQ] = ACTIONS(374),
    [anon_sym_SLASH_EQ] = ACTIONS(374),
    [anon_sym_PERCENT_EQ] = ACTIONS(374),
    [anon_sym_CARET_EQ] = ACTIONS(374),
    [anon_sym_AMP_EQ] = ACTIONS(374),
    [anon_sym_PIPE_EQ] = ACTIONS(374),
    [anon_sym_LT_LT_EQ] = ACTIONS(374),
    [anon_sym_GT_GT_EQ] = ACTIONS(374),
    [anon_sym_EQ] = ACTIONS(376),
    [anon_sym_EQ_EQ] = ACTIONS(374),
    [anon_sym_BANG_EQ] = ACTIONS(374),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(374),
    [anon_sym_LT_EQ] = ACTIONS(374),
    [anon_sym_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(374),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(376),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(376),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [40] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1502),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(40),
    [sym_block_comment] = STATE(40),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(382),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(382),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(382),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(382),
    [anon_sym_PLUS] = ACTIONS(384),
    [anon_sym_STAR] = ACTIONS(344),
    [anon_sym_QMARK] = ACTIONS(382),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_SLASH] = ACTIONS(384),
    [anon_sym_PERCENT] = ACTIONS(384),
    [anon_sym_CARET] = ACTIONS(384),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(386),
    [anon_sym_PIPE] = ACTIONS(388),
    [anon_sym_AMP_AMP] = ACTIONS(382),
    [anon_sym_PIPE_PIPE] = ACTIONS(382),
    [anon_sym_LT_LT] = ACTIONS(384),
    [anon_sym_GT_GT] = ACTIONS(384),
    [anon_sym_PLUS_EQ] = ACTIONS(382),
    [anon_sym_DASH_EQ] = ACTIONS(382),
    [anon_sym_STAR_EQ] = ACTIONS(382),
    [anon_sym_SLASH_EQ] = ACTIONS(382),
    [anon_sym_PERCENT_EQ] = ACTIONS(382),
    [anon_sym_CARET_EQ] = ACTIONS(382),
    [anon_sym_AMP_EQ] = ACTIONS(382),
    [anon_sym_PIPE_EQ] = ACTIONS(382),
    [anon_sym_LT_LT_EQ] = ACTIONS(382),
    [anon_sym_GT_GT_EQ] = ACTIONS(382),
    [anon_sym_EQ] = ACTIONS(384),
    [anon_sym_EQ_EQ] = ACTIONS(382),
    [anon_sym_BANG_EQ] = ACTIONS(382),
    [anon_sym_GT] = ACTIONS(384),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(382),
    [anon_sym_LT_EQ] = ACTIONS(382),
    [anon_sym_DOT] = ACTIONS(384),
    [anon_sym_DOT_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(382),
    [anon_sym_COMMA] = ACTIONS(382),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(384),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(384),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [41] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1482),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(41),
    [sym_block_comment] = STATE(41),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(378),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_RPAREN] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(378),
    [anon_sym_RBRACK] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_STAR] = ACTIONS(380),
    [anon_sym_QMARK] = ACTIONS(378),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_SLASH] = ACTIONS(380),
    [anon_sym_PERCENT] = ACTIONS(380),
    [anon_sym_CARET] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(380),
    [anon_sym_PIPE] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(378),
    [anon_sym_PIPE_PIPE] = ACTIONS(378),
    [anon_sym_LT_LT] = ACTIONS(380),
    [anon_sym_GT_GT] = ACTIONS(380),
    [anon_sym_PLUS_EQ] = ACTIONS(378),
    [anon_sym_DASH_EQ] = ACTIONS(378),
    [anon_sym_STAR_EQ] = ACTIONS(378),
    [anon_sym_SLASH_EQ] = ACTIONS(378),
    [anon_sym_PERCENT_EQ] = ACTIONS(378),
    [anon_sym_CARET_EQ] = ACTIONS(378),
    [anon_sym_AMP_EQ] = ACTIONS(378),
    [anon_sym_PIPE_EQ] = ACTIONS(378),
    [anon_sym_LT_LT_EQ] = ACTIONS(378),
    [anon_sym_GT_GT_EQ] = ACTIONS(378),
    [anon_sym_EQ] = ACTIONS(380),
    [anon_sym_EQ_EQ] = ACTIONS(378),
    [anon_sym_BANG_EQ] = ACTIONS(378),
    [anon_sym_GT] = ACTIONS(380),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(378),
    [anon_sym_LT_EQ] = ACTIONS(378),
    [anon_sym_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(378),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(378),
    [anon_sym_COMMA] = ACTIONS(378),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(380),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(380),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [42] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1497),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(42),
    [sym_block_comment] = STATE(42),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(344),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(386),
    [anon_sym_PIPE] = ACTIONS(388),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(396),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [43] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1799),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(43),
    [sym_block_comment] = STATE(43),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(336),
    [anon_sym_COLON] = ACTIONS(402),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PERCENT] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(336),
    [anon_sym_PIPE_PIPE] = ACTIONS(336),
    [anon_sym_LT_LT] = ACTIONS(342),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [anon_sym_DASH_EQ] = ACTIONS(336),
    [anon_sym_STAR_EQ] = ACTIONS(336),
    [anon_sym_SLASH_EQ] = ACTIONS(336),
    [anon_sym_PERCENT_EQ] = ACTIONS(336),
    [anon_sym_CARET_EQ] = ACTIONS(336),
    [anon_sym_AMP_EQ] = ACTIONS(336),
    [anon_sym_PIPE_EQ] = ACTIONS(336),
    [anon_sym_LT_LT_EQ] = ACTIONS(336),
    [anon_sym_GT_GT_EQ] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(342),
    [anon_sym_EQ_EQ] = ACTIONS(336),
    [anon_sym_BANG_EQ] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(336),
    [anon_sym_LT_EQ] = ACTIONS(336),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(336),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(342),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [44] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1740),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(44),
    [sym_block_comment] = STATE(44),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(382),
    [anon_sym_PLUS] = ACTIONS(384),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_QMARK] = ACTIONS(382),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_SLASH] = ACTIONS(384),
    [anon_sym_PERCENT] = ACTIONS(384),
    [anon_sym_CARET] = ACTIONS(384),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(388),
    [anon_sym_AMP_AMP] = ACTIONS(382),
    [anon_sym_PIPE_PIPE] = ACTIONS(382),
    [anon_sym_LT_LT] = ACTIONS(384),
    [anon_sym_GT_GT] = ACTIONS(384),
    [anon_sym_PLUS_EQ] = ACTIONS(382),
    [anon_sym_DASH_EQ] = ACTIONS(382),
    [anon_sym_STAR_EQ] = ACTIONS(382),
    [anon_sym_SLASH_EQ] = ACTIONS(382),
    [anon_sym_PERCENT_EQ] = ACTIONS(382),
    [anon_sym_CARET_EQ] = ACTIONS(382),
    [anon_sym_AMP_EQ] = ACTIONS(382),
    [anon_sym_PIPE_EQ] = ACTIONS(382),
    [anon_sym_LT_LT_EQ] = ACTIONS(382),
    [anon_sym_GT_GT_EQ] = ACTIONS(382),
    [anon_sym_EQ] = ACTIONS(384),
    [anon_sym_EQ_EQ] = ACTIONS(382),
    [anon_sym_BANG_EQ] = ACTIONS(382),
    [anon_sym_GT] = ACTIONS(384),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(382),
    [anon_sym_LT_EQ] = ACTIONS(382),
    [anon_sym_DOT] = ACTIONS(384),
    [anon_sym_DOT_DOT] = ACTIONS(462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(382),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(384),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [45] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1757),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(45),
    [sym_block_comment] = STATE(45),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_STAR] = ACTIONS(380),
    [anon_sym_QMARK] = ACTIONS(378),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_SLASH] = ACTIONS(380),
    [anon_sym_PERCENT] = ACTIONS(380),
    [anon_sym_CARET] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(380),
    [anon_sym_PIPE] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(378),
    [anon_sym_PIPE_PIPE] = ACTIONS(378),
    [anon_sym_LT_LT] = ACTIONS(380),
    [anon_sym_GT_GT] = ACTIONS(380),
    [anon_sym_PLUS_EQ] = ACTIONS(378),
    [anon_sym_DASH_EQ] = ACTIONS(378),
    [anon_sym_STAR_EQ] = ACTIONS(378),
    [anon_sym_SLASH_EQ] = ACTIONS(378),
    [anon_sym_PERCENT_EQ] = ACTIONS(378),
    [anon_sym_CARET_EQ] = ACTIONS(378),
    [anon_sym_AMP_EQ] = ACTIONS(378),
    [anon_sym_PIPE_EQ] = ACTIONS(378),
    [anon_sym_LT_LT_EQ] = ACTIONS(378),
    [anon_sym_GT_GT_EQ] = ACTIONS(378),
    [anon_sym_EQ] = ACTIONS(380),
    [anon_sym_EQ_EQ] = ACTIONS(378),
    [anon_sym_BANG_EQ] = ACTIONS(378),
    [anon_sym_GT] = ACTIONS(380),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(378),
    [anon_sym_LT_EQ] = ACTIONS(378),
    [anon_sym_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(378),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(378),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(380),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [46] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1727),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(46),
    [sym_block_comment] = STATE(46),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(374),
    [anon_sym_PLUS] = ACTIONS(376),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_QMARK] = ACTIONS(374),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(376),
    [anon_sym_SLASH] = ACTIONS(376),
    [anon_sym_PERCENT] = ACTIONS(376),
    [anon_sym_CARET] = ACTIONS(376),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_AMP_AMP] = ACTIONS(374),
    [anon_sym_PIPE_PIPE] = ACTIONS(374),
    [anon_sym_LT_LT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(376),
    [anon_sym_PLUS_EQ] = ACTIONS(374),
    [anon_sym_DASH_EQ] = ACTIONS(374),
    [anon_sym_STAR_EQ] = ACTIONS(374),
    [anon_sym_SLASH_EQ] = ACTIONS(374),
    [anon_sym_PERCENT_EQ] = ACTIONS(374),
    [anon_sym_CARET_EQ] = ACTIONS(374),
    [anon_sym_AMP_EQ] = ACTIONS(374),
    [anon_sym_PIPE_EQ] = ACTIONS(374),
    [anon_sym_LT_LT_EQ] = ACTIONS(374),
    [anon_sym_GT_GT_EQ] = ACTIONS(374),
    [anon_sym_EQ] = ACTIONS(376),
    [anon_sym_EQ_EQ] = ACTIONS(374),
    [anon_sym_BANG_EQ] = ACTIONS(374),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(374),
    [anon_sym_LT_EQ] = ACTIONS(374),
    [anon_sym_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(374),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(376),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [47] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1757),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(47),
    [sym_block_comment] = STATE(47),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_STAR] = ACTIONS(380),
    [anon_sym_QMARK] = ACTIONS(378),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_SLASH] = ACTIONS(380),
    [anon_sym_PERCENT] = ACTIONS(380),
    [anon_sym_CARET] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(380),
    [anon_sym_PIPE] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(378),
    [anon_sym_PIPE_PIPE] = ACTIONS(378),
    [anon_sym_LT_LT] = ACTIONS(380),
    [anon_sym_GT_GT] = ACTIONS(380),
    [anon_sym_PLUS_EQ] = ACTIONS(378),
    [anon_sym_DASH_EQ] = ACTIONS(378),
    [anon_sym_STAR_EQ] = ACTIONS(378),
    [anon_sym_SLASH_EQ] = ACTIONS(378),
    [anon_sym_PERCENT_EQ] = ACTIONS(378),
    [anon_sym_CARET_EQ] = ACTIONS(378),
    [anon_sym_AMP_EQ] = ACTIONS(378),
    [anon_sym_PIPE_EQ] = ACTIONS(378),
    [anon_sym_LT_LT_EQ] = ACTIONS(378),
    [anon_sym_GT_GT_EQ] = ACTIONS(378),
    [anon_sym_EQ] = ACTIONS(380),
    [anon_sym_EQ_EQ] = ACTIONS(378),
    [anon_sym_BANG_EQ] = ACTIONS(378),
    [anon_sym_GT] = ACTIONS(380),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(378),
    [anon_sym_LT_EQ] = ACTIONS(378),
    [anon_sym_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(378),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(378),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(380),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [48] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1728),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(48),
    [sym_block_comment] = STATE(48),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_COLON] = ACTIONS(340),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PERCENT] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(336),
    [anon_sym_PIPE_PIPE] = ACTIONS(336),
    [anon_sym_LT_LT] = ACTIONS(342),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [anon_sym_DASH_EQ] = ACTIONS(336),
    [anon_sym_STAR_EQ] = ACTIONS(336),
    [anon_sym_SLASH_EQ] = ACTIONS(336),
    [anon_sym_PERCENT_EQ] = ACTIONS(336),
    [anon_sym_CARET_EQ] = ACTIONS(336),
    [anon_sym_AMP_EQ] = ACTIONS(336),
    [anon_sym_PIPE_EQ] = ACTIONS(336),
    [anon_sym_LT_LT_EQ] = ACTIONS(336),
    [anon_sym_GT_GT_EQ] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(342),
    [anon_sym_EQ_EQ] = ACTIONS(336),
    [anon_sym_BANG_EQ] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(336),
    [anon_sym_LT_EQ] = ACTIONS(336),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(336),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(342),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [49] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1727),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(49),
    [sym_block_comment] = STATE(49),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(374),
    [anon_sym_PLUS] = ACTIONS(376),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_QMARK] = ACTIONS(374),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(376),
    [anon_sym_SLASH] = ACTIONS(376),
    [anon_sym_PERCENT] = ACTIONS(376),
    [anon_sym_CARET] = ACTIONS(376),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_AMP_AMP] = ACTIONS(374),
    [anon_sym_PIPE_PIPE] = ACTIONS(374),
    [anon_sym_LT_LT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(376),
    [anon_sym_PLUS_EQ] = ACTIONS(374),
    [anon_sym_DASH_EQ] = ACTIONS(374),
    [anon_sym_STAR_EQ] = ACTIONS(374),
    [anon_sym_SLASH_EQ] = ACTIONS(374),
    [anon_sym_PERCENT_EQ] = ACTIONS(374),
    [anon_sym_CARET_EQ] = ACTIONS(374),
    [anon_sym_AMP_EQ] = ACTIONS(374),
    [anon_sym_PIPE_EQ] = ACTIONS(374),
    [anon_sym_LT_LT_EQ] = ACTIONS(374),
    [anon_sym_GT_GT_EQ] = ACTIONS(374),
    [anon_sym_EQ] = ACTIONS(376),
    [anon_sym_EQ_EQ] = ACTIONS(374),
    [anon_sym_BANG_EQ] = ACTIONS(374),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(374),
    [anon_sym_LT_EQ] = ACTIONS(374),
    [anon_sym_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(374),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(376),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [50] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1732),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(43),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(50),
    [sym_block_comment] = STATE(50),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(490),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [51] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1743),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(51),
    [sym_block_comment] = STATE(51),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_PIPE] = ACTIONS(388),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [52] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1608),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(52),
    [sym_block_comment] = STATE(52),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_COLON] = ACTIONS(340),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PERCENT] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(336),
    [anon_sym_PIPE_PIPE] = ACTIONS(336),
    [anon_sym_LT_LT] = ACTIONS(342),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [anon_sym_DASH_EQ] = ACTIONS(336),
    [anon_sym_STAR_EQ] = ACTIONS(336),
    [anon_sym_SLASH_EQ] = ACTIONS(336),
    [anon_sym_PERCENT_EQ] = ACTIONS(336),
    [anon_sym_CARET_EQ] = ACTIONS(336),
    [anon_sym_AMP_EQ] = ACTIONS(336),
    [anon_sym_PIPE_EQ] = ACTIONS(336),
    [anon_sym_LT_LT_EQ] = ACTIONS(336),
    [anon_sym_GT_GT_EQ] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(342),
    [anon_sym_EQ_EQ] = ACTIONS(336),
    [anon_sym_BANG_EQ] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(336),
    [anon_sym_LT_EQ] = ACTIONS(336),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(336),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(342),
    [anon_sym_as] = ACTIONS(342),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [53] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1786),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(53),
    [sym_block_comment] = STATE(53),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(468),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(506),
    [anon_sym_PIPE] = ACTIONS(388),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [54] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1679),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(54),
    [sym_block_comment] = STATE(54),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_PLUS] = ACTIONS(384),
    [anon_sym_STAR] = ACTIONS(468),
    [anon_sym_QMARK] = ACTIONS(382),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_SLASH] = ACTIONS(384),
    [anon_sym_PERCENT] = ACTIONS(384),
    [anon_sym_CARET] = ACTIONS(384),
    [anon_sym_BANG] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(506),
    [anon_sym_PIPE] = ACTIONS(388),
    [anon_sym_AMP_AMP] = ACTIONS(382),
    [anon_sym_PIPE_PIPE] = ACTIONS(382),
    [anon_sym_LT_LT] = ACTIONS(384),
    [anon_sym_GT_GT] = ACTIONS(384),
    [anon_sym_PLUS_EQ] = ACTIONS(382),
    [anon_sym_DASH_EQ] = ACTIONS(382),
    [anon_sym_STAR_EQ] = ACTIONS(382),
    [anon_sym_SLASH_EQ] = ACTIONS(382),
    [anon_sym_PERCENT_EQ] = ACTIONS(382),
    [anon_sym_CARET_EQ] = ACTIONS(382),
    [anon_sym_AMP_EQ] = ACTIONS(382),
    [anon_sym_PIPE_EQ] = ACTIONS(382),
    [anon_sym_LT_LT_EQ] = ACTIONS(382),
    [anon_sym_GT_GT_EQ] = ACTIONS(382),
    [anon_sym_EQ] = ACTIONS(384),
    [anon_sym_EQ_EQ] = ACTIONS(382),
    [anon_sym_BANG_EQ] = ACTIONS(382),
    [anon_sym_GT] = ACTIONS(384),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(382),
    [anon_sym_LT_EQ] = ACTIONS(382),
    [anon_sym_DOT] = ACTIONS(384),
    [anon_sym_DOT_DOT] = ACTIONS(508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(382),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(384),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [55] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1610),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(52),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(55),
    [sym_block_comment] = STATE(55),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(370),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [56] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1613),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(56),
    [sym_block_comment] = STATE(56),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_PLUS] = ACTIONS(384),
    [anon_sym_STAR] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(382),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_SLASH] = ACTIONS(384),
    [anon_sym_PERCENT] = ACTIONS(384),
    [anon_sym_CARET] = ACTIONS(384),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(388),
    [anon_sym_AMP_AMP] = ACTIONS(382),
    [anon_sym_PIPE_PIPE] = ACTIONS(382),
    [anon_sym_LT_LT] = ACTIONS(384),
    [anon_sym_GT_GT] = ACTIONS(384),
    [anon_sym_PLUS_EQ] = ACTIONS(382),
    [anon_sym_DASH_EQ] = ACTIONS(382),
    [anon_sym_STAR_EQ] = ACTIONS(382),
    [anon_sym_SLASH_EQ] = ACTIONS(382),
    [anon_sym_PERCENT_EQ] = ACTIONS(382),
    [anon_sym_CARET_EQ] = ACTIONS(382),
    [anon_sym_AMP_EQ] = ACTIONS(382),
    [anon_sym_PIPE_EQ] = ACTIONS(382),
    [anon_sym_LT_LT_EQ] = ACTIONS(382),
    [anon_sym_GT_GT_EQ] = ACTIONS(382),
    [anon_sym_EQ] = ACTIONS(384),
    [anon_sym_EQ_EQ] = ACTIONS(382),
    [anon_sym_BANG_EQ] = ACTIONS(382),
    [anon_sym_GT] = ACTIONS(384),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(382),
    [anon_sym_LT_EQ] = ACTIONS(382),
    [anon_sym_DOT] = ACTIONS(384),
    [anon_sym_DOT_DOT] = ACTIONS(512),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(382),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(384),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [57] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1737),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(57),
    [sym_block_comment] = STATE(57),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_LBRACE] = ACTIONS(374),
    [anon_sym_PLUS] = ACTIONS(376),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_QMARK] = ACTIONS(374),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(376),
    [anon_sym_SLASH] = ACTIONS(376),
    [anon_sym_PERCENT] = ACTIONS(376),
    [anon_sym_CARET] = ACTIONS(376),
    [anon_sym_BANG] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_AMP_AMP] = ACTIONS(374),
    [anon_sym_PIPE_PIPE] = ACTIONS(374),
    [anon_sym_LT_LT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(376),
    [anon_sym_PLUS_EQ] = ACTIONS(374),
    [anon_sym_DASH_EQ] = ACTIONS(374),
    [anon_sym_STAR_EQ] = ACTIONS(374),
    [anon_sym_SLASH_EQ] = ACTIONS(374),
    [anon_sym_PERCENT_EQ] = ACTIONS(374),
    [anon_sym_CARET_EQ] = ACTIONS(374),
    [anon_sym_AMP_EQ] = ACTIONS(374),
    [anon_sym_PIPE_EQ] = ACTIONS(374),
    [anon_sym_LT_LT_EQ] = ACTIONS(374),
    [anon_sym_GT_GT_EQ] = ACTIONS(374),
    [anon_sym_EQ] = ACTIONS(376),
    [anon_sym_EQ_EQ] = ACTIONS(374),
    [anon_sym_BANG_EQ] = ACTIONS(374),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(374),
    [anon_sym_LT_EQ] = ACTIONS(374),
    [anon_sym_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(374),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(376),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [58] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1737),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(58),
    [sym_block_comment] = STATE(58),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_LBRACE] = ACTIONS(374),
    [anon_sym_PLUS] = ACTIONS(376),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_QMARK] = ACTIONS(374),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(376),
    [anon_sym_SLASH] = ACTIONS(376),
    [anon_sym_PERCENT] = ACTIONS(376),
    [anon_sym_CARET] = ACTIONS(376),
    [anon_sym_BANG] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_AMP_AMP] = ACTIONS(374),
    [anon_sym_PIPE_PIPE] = ACTIONS(374),
    [anon_sym_LT_LT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(376),
    [anon_sym_PLUS_EQ] = ACTIONS(374),
    [anon_sym_DASH_EQ] = ACTIONS(374),
    [anon_sym_STAR_EQ] = ACTIONS(374),
    [anon_sym_SLASH_EQ] = ACTIONS(374),
    [anon_sym_PERCENT_EQ] = ACTIONS(374),
    [anon_sym_CARET_EQ] = ACTIONS(374),
    [anon_sym_AMP_EQ] = ACTIONS(374),
    [anon_sym_PIPE_EQ] = ACTIONS(374),
    [anon_sym_LT_LT_EQ] = ACTIONS(374),
    [anon_sym_GT_GT_EQ] = ACTIONS(374),
    [anon_sym_EQ] = ACTIONS(376),
    [anon_sym_EQ_EQ] = ACTIONS(374),
    [anon_sym_BANG_EQ] = ACTIONS(374),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(374),
    [anon_sym_LT_EQ] = ACTIONS(374),
    [anon_sym_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(374),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(376),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [59] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1841),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(59),
    [sym_block_comment] = STATE(59),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_STAR] = ACTIONS(380),
    [anon_sym_QMARK] = ACTIONS(378),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_SLASH] = ACTIONS(380),
    [anon_sym_PERCENT] = ACTIONS(380),
    [anon_sym_CARET] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(380),
    [anon_sym_PIPE] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(378),
    [anon_sym_PIPE_PIPE] = ACTIONS(378),
    [anon_sym_LT_LT] = ACTIONS(380),
    [anon_sym_GT_GT] = ACTIONS(380),
    [anon_sym_PLUS_EQ] = ACTIONS(378),
    [anon_sym_DASH_EQ] = ACTIONS(378),
    [anon_sym_STAR_EQ] = ACTIONS(378),
    [anon_sym_SLASH_EQ] = ACTIONS(378),
    [anon_sym_PERCENT_EQ] = ACTIONS(378),
    [anon_sym_CARET_EQ] = ACTIONS(378),
    [anon_sym_AMP_EQ] = ACTIONS(378),
    [anon_sym_PIPE_EQ] = ACTIONS(378),
    [anon_sym_LT_LT_EQ] = ACTIONS(378),
    [anon_sym_GT_GT_EQ] = ACTIONS(378),
    [anon_sym_EQ] = ACTIONS(380),
    [anon_sym_EQ_EQ] = ACTIONS(378),
    [anon_sym_BANG_EQ] = ACTIONS(378),
    [anon_sym_GT] = ACTIONS(380),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(378),
    [anon_sym_LT_EQ] = ACTIONS(378),
    [anon_sym_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(378),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(378),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(380),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [60] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1609),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(60),
    [sym_block_comment] = STATE(60),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_LBRACE] = ACTIONS(374),
    [anon_sym_PLUS] = ACTIONS(376),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_QMARK] = ACTIONS(374),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(376),
    [anon_sym_SLASH] = ACTIONS(376),
    [anon_sym_PERCENT] = ACTIONS(376),
    [anon_sym_CARET] = ACTIONS(376),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_AMP_AMP] = ACTIONS(374),
    [anon_sym_PIPE_PIPE] = ACTIONS(374),
    [anon_sym_LT_LT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(376),
    [anon_sym_PLUS_EQ] = ACTIONS(374),
    [anon_sym_DASH_EQ] = ACTIONS(374),
    [anon_sym_STAR_EQ] = ACTIONS(374),
    [anon_sym_SLASH_EQ] = ACTIONS(374),
    [anon_sym_PERCENT_EQ] = ACTIONS(374),
    [anon_sym_CARET_EQ] = ACTIONS(374),
    [anon_sym_AMP_EQ] = ACTIONS(374),
    [anon_sym_PIPE_EQ] = ACTIONS(374),
    [anon_sym_LT_LT_EQ] = ACTIONS(374),
    [anon_sym_GT_GT_EQ] = ACTIONS(374),
    [anon_sym_EQ] = ACTIONS(376),
    [anon_sym_EQ_EQ] = ACTIONS(374),
    [anon_sym_BANG_EQ] = ACTIONS(374),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(374),
    [anon_sym_LT_EQ] = ACTIONS(374),
    [anon_sym_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(374),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(376),
    [anon_sym_as] = ACTIONS(376),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [61] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1841),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(61),
    [sym_block_comment] = STATE(61),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_STAR] = ACTIONS(380),
    [anon_sym_QMARK] = ACTIONS(378),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_SLASH] = ACTIONS(380),
    [anon_sym_PERCENT] = ACTIONS(380),
    [anon_sym_CARET] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(380),
    [anon_sym_PIPE] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(378),
    [anon_sym_PIPE_PIPE] = ACTIONS(378),
    [anon_sym_LT_LT] = ACTIONS(380),
    [anon_sym_GT_GT] = ACTIONS(380),
    [anon_sym_PLUS_EQ] = ACTIONS(378),
    [anon_sym_DASH_EQ] = ACTIONS(378),
    [anon_sym_STAR_EQ] = ACTIONS(378),
    [anon_sym_SLASH_EQ] = ACTIONS(378),
    [anon_sym_PERCENT_EQ] = ACTIONS(378),
    [anon_sym_CARET_EQ] = ACTIONS(378),
    [anon_sym_AMP_EQ] = ACTIONS(378),
    [anon_sym_PIPE_EQ] = ACTIONS(378),
    [anon_sym_LT_LT_EQ] = ACTIONS(378),
    [anon_sym_GT_GT_EQ] = ACTIONS(378),
    [anon_sym_EQ] = ACTIONS(380),
    [anon_sym_EQ_EQ] = ACTIONS(378),
    [anon_sym_BANG_EQ] = ACTIONS(378),
    [anon_sym_GT] = ACTIONS(380),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(378),
    [anon_sym_LT_EQ] = ACTIONS(378),
    [anon_sym_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(378),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(378),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(380),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [62] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1587),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(62),
    [sym_block_comment] = STATE(62),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_STAR] = ACTIONS(380),
    [anon_sym_QMARK] = ACTIONS(378),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_SLASH] = ACTIONS(380),
    [anon_sym_PERCENT] = ACTIONS(380),
    [anon_sym_CARET] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(380),
    [anon_sym_PIPE] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(378),
    [anon_sym_PIPE_PIPE] = ACTIONS(378),
    [anon_sym_LT_LT] = ACTIONS(380),
    [anon_sym_GT_GT] = ACTIONS(380),
    [anon_sym_PLUS_EQ] = ACTIONS(378),
    [anon_sym_DASH_EQ] = ACTIONS(378),
    [anon_sym_STAR_EQ] = ACTIONS(378),
    [anon_sym_SLASH_EQ] = ACTIONS(378),
    [anon_sym_PERCENT_EQ] = ACTIONS(378),
    [anon_sym_CARET_EQ] = ACTIONS(378),
    [anon_sym_AMP_EQ] = ACTIONS(378),
    [anon_sym_PIPE_EQ] = ACTIONS(378),
    [anon_sym_LT_LT_EQ] = ACTIONS(378),
    [anon_sym_GT_GT_EQ] = ACTIONS(378),
    [anon_sym_EQ] = ACTIONS(380),
    [anon_sym_EQ_EQ] = ACTIONS(378),
    [anon_sym_BANG_EQ] = ACTIONS(378),
    [anon_sym_GT] = ACTIONS(380),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(378),
    [anon_sym_LT_EQ] = ACTIONS(378),
    [anon_sym_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(378),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(378),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(380),
    [anon_sym_as] = ACTIONS(380),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [63] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1587),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(63),
    [sym_block_comment] = STATE(63),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(378),
    [anon_sym_PLUS] = ACTIONS(380),
    [anon_sym_STAR] = ACTIONS(380),
    [anon_sym_QMARK] = ACTIONS(378),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(380),
    [anon_sym_SLASH] = ACTIONS(380),
    [anon_sym_PERCENT] = ACTIONS(380),
    [anon_sym_CARET] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(380),
    [anon_sym_PIPE] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(378),
    [anon_sym_PIPE_PIPE] = ACTIONS(378),
    [anon_sym_LT_LT] = ACTIONS(380),
    [anon_sym_GT_GT] = ACTIONS(380),
    [anon_sym_PLUS_EQ] = ACTIONS(378),
    [anon_sym_DASH_EQ] = ACTIONS(378),
    [anon_sym_STAR_EQ] = ACTIONS(378),
    [anon_sym_SLASH_EQ] = ACTIONS(378),
    [anon_sym_PERCENT_EQ] = ACTIONS(378),
    [anon_sym_CARET_EQ] = ACTIONS(378),
    [anon_sym_AMP_EQ] = ACTIONS(378),
    [anon_sym_PIPE_EQ] = ACTIONS(378),
    [anon_sym_LT_LT_EQ] = ACTIONS(378),
    [anon_sym_GT_GT_EQ] = ACTIONS(378),
    [anon_sym_EQ] = ACTIONS(380),
    [anon_sym_EQ_EQ] = ACTIONS(378),
    [anon_sym_BANG_EQ] = ACTIONS(378),
    [anon_sym_GT] = ACTIONS(380),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(378),
    [anon_sym_LT_EQ] = ACTIONS(378),
    [anon_sym_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT] = ACTIONS(380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(378),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(378),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(380),
    [anon_sym_as] = ACTIONS(380),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [64] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1609),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(64),
    [sym_block_comment] = STATE(64),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_LBRACE] = ACTIONS(374),
    [anon_sym_PLUS] = ACTIONS(376),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_QMARK] = ACTIONS(374),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(376),
    [anon_sym_SLASH] = ACTIONS(376),
    [anon_sym_PERCENT] = ACTIONS(376),
    [anon_sym_CARET] = ACTIONS(376),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_AMP_AMP] = ACTIONS(374),
    [anon_sym_PIPE_PIPE] = ACTIONS(374),
    [anon_sym_LT_LT] = ACTIONS(376),
    [anon_sym_GT_GT] = ACTIONS(376),
    [anon_sym_PLUS_EQ] = ACTIONS(374),
    [anon_sym_DASH_EQ] = ACTIONS(374),
    [anon_sym_STAR_EQ] = ACTIONS(374),
    [anon_sym_SLASH_EQ] = ACTIONS(374),
    [anon_sym_PERCENT_EQ] = ACTIONS(374),
    [anon_sym_CARET_EQ] = ACTIONS(374),
    [anon_sym_AMP_EQ] = ACTIONS(374),
    [anon_sym_PIPE_EQ] = ACTIONS(374),
    [anon_sym_LT_LT_EQ] = ACTIONS(374),
    [anon_sym_GT_GT_EQ] = ACTIONS(374),
    [anon_sym_EQ] = ACTIONS(376),
    [anon_sym_EQ_EQ] = ACTIONS(374),
    [anon_sym_BANG_EQ] = ACTIONS(374),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(374),
    [anon_sym_LT_EQ] = ACTIONS(374),
    [anon_sym_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(374),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(376),
    [anon_sym_as] = ACTIONS(376),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [65] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1683),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(48),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(65),
    [sym_block_comment] = STATE(65),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(372),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [66] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1614),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(66),
    [sym_block_comment] = STATE(66),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(388),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(512),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [67] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(67),
    [sym_block_comment] = STATE(67),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(514),
    [anon_sym_SEMI] = ACTIONS(517),
    [anon_sym_LPAREN] = ACTIONS(520),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(534),
    [anon_sym_PLUS] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(531),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_u8] = ACTIONS(514),
    [anon_sym_i8] = ACTIONS(514),
    [anon_sym_u16] = ACTIONS(514),
    [anon_sym_i16] = ACTIONS(514),
    [anon_sym_u32] = ACTIONS(514),
    [anon_sym_i32] = ACTIONS(514),
    [anon_sym_u64] = ACTIONS(514),
    [anon_sym_i64] = ACTIONS(514),
    [anon_sym_u128] = ACTIONS(514),
    [anon_sym_i128] = ACTIONS(514),
    [anon_sym_isize] = ACTIONS(514),
    [anon_sym_usize] = ACTIONS(514),
    [anon_sym_f32] = ACTIONS(514),
    [anon_sym_f64] = ACTIONS(514),
    [anon_sym_bool] = ACTIONS(514),
    [anon_sym_str] = ACTIONS(514),
    [anon_sym_char] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(531),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_PERCENT] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_AMP] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_PIPE_PIPE] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(531),
    [anon_sym_GT_GT] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(517),
    [anon_sym_DASH_EQ] = ACTIONS(517),
    [anon_sym_STAR_EQ] = ACTIONS(517),
    [anon_sym_SLASH_EQ] = ACTIONS(517),
    [anon_sym_PERCENT_EQ] = ACTIONS(517),
    [anon_sym_CARET_EQ] = ACTIONS(517),
    [anon_sym_AMP_EQ] = ACTIONS(517),
    [anon_sym_PIPE_EQ] = ACTIONS(517),
    [anon_sym_LT_LT_EQ] = ACTIONS(517),
    [anon_sym_GT_GT_EQ] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(531),
    [anon_sym_GT_EQ] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(517),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym__] = ACTIONS(531),
    [anon_sym_DOT] = ACTIONS(531),
    [anon_sym_DOT_DOT] = ACTIONS(531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(517),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(517),
    [anon_sym_DASH_GT] = ACTIONS(517),
    [anon_sym_POUND] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(514),
    [anon_sym_as] = ACTIONS(514),
    [anon_sym_async] = ACTIONS(514),
    [anon_sym_await] = ACTIONS(514),
    [anon_sym_break] = ACTIONS(514),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_continue] = ACTIONS(514),
    [anon_sym_default] = ACTIONS(514),
    [anon_sym_enum] = ACTIONS(514),
    [anon_sym_fn] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(514),
    [anon_sym_if] = ACTIONS(514),
    [anon_sym_impl] = ACTIONS(514),
    [anon_sym_let] = ACTIONS(514),
    [anon_sym_loop] = ACTIONS(514),
    [anon_sym_match] = ACTIONS(514),
    [anon_sym_mod] = ACTIONS(514),
    [anon_sym_pub] = ACTIONS(514),
    [anon_sym_return] = ACTIONS(514),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_struct] = ACTIONS(514),
    [anon_sym_trait] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(514),
    [anon_sym_union] = ACTIONS(514),
    [anon_sym_unsafe] = ACTIONS(514),
    [anon_sym_use] = ACTIONS(514),
    [anon_sym_where] = ACTIONS(514),
    [anon_sym_while] = ACTIONS(514),
    [sym_mutable_specifier] = ACTIONS(514),
    [sym_integer_literal] = ACTIONS(537),
    [aux_sym_string_literal_token1] = ACTIONS(540),
    [sym_char_literal] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(543),
    [anon_sym_false] = ACTIONS(543),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(514),
    [sym_super] = ACTIONS(514),
    [sym_crate] = ACTIONS(514),
    [sym_metavariable] = ACTIONS(546),
    [sym__raw_string_literal_start] = ACTIONS(549),
    [sym_float_literal] = ACTIONS(537),
  },
  [68] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(68),
    [sym_block_comment] = STATE(68),
    [aux_sym_token_tree_repeat1] = STATE(68),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(555),
    [anon_sym_LPAREN] = ACTIONS(558),
    [anon_sym_RPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_RBRACK] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(555),
    [anon_sym_COLON] = ACTIONS(569),
    [anon_sym_DOLLAR] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(569),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(569),
    [anon_sym_GT_GT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(555),
    [anon_sym_DASH_EQ] = ACTIONS(555),
    [anon_sym_STAR_EQ] = ACTIONS(555),
    [anon_sym_SLASH_EQ] = ACTIONS(555),
    [anon_sym_PERCENT_EQ] = ACTIONS(555),
    [anon_sym_CARET_EQ] = ACTIONS(555),
    [anon_sym_AMP_EQ] = ACTIONS(555),
    [anon_sym_PIPE_EQ] = ACTIONS(555),
    [anon_sym_LT_LT_EQ] = ACTIONS(555),
    [anon_sym_GT_GT_EQ] = ACTIONS(555),
    [anon_sym_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ] = ACTIONS(555),
    [anon_sym_BANG_EQ] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(569),
    [anon_sym_GT_EQ] = ACTIONS(555),
    [anon_sym_LT_EQ] = ACTIONS(555),
    [anon_sym_AT] = ACTIONS(555),
    [anon_sym__] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(555),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(555),
    [anon_sym_COLON_COLON] = ACTIONS(555),
    [anon_sym_DASH_GT] = ACTIONS(555),
    [anon_sym_POUND] = ACTIONS(555),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(575),
    [aux_sym_string_literal_token1] = ACTIONS(578),
    [sym_char_literal] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(581),
    [anon_sym_false] = ACTIONS(581),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(584),
    [sym__raw_string_literal_start] = ACTIONS(587),
    [sym_float_literal] = ACTIONS(575),
  },
  [69] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(69),
    [sym_block_comment] = STATE(69),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_RBRACE] = ACTIONS(600),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [70] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(70),
    [sym_block_comment] = STATE(70),
    [aux_sym_token_tree_pattern_repeat1] = STATE(74),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_RPAREN] = ACTIONS(616),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [71] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(71),
    [sym_block_comment] = STATE(71),
    [aux_sym_token_tree_pattern_repeat1] = STATE(78),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_RBRACK] = ACTIONS(616),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [72] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(72),
    [sym_block_comment] = STATE(72),
    [aux_sym_token_tree_pattern_repeat1] = STATE(82),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_RBRACE] = ACTIONS(616),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [73] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(73),
    [sym_block_comment] = STATE(73),
    [aux_sym_token_tree_pattern_repeat1] = STATE(79),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_RPAREN] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [74] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(74),
    [sym_block_comment] = STATE(74),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_RPAREN] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [75] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(75),
    [sym_block_comment] = STATE(75),
    [aux_sym_token_tree_pattern_repeat1] = STATE(69),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_RBRACE] = ACTIONS(622),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [76] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(76),
    [sym_block_comment] = STATE(76),
    [aux_sym_token_tree_pattern_repeat1] = STATE(83),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_RBRACK] = ACTIONS(622),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [77] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(77),
    [sym_block_comment] = STATE(77),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(624),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_RPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(633),
    [anon_sym_LBRACE] = ACTIONS(638),
    [anon_sym_RBRACE] = ACTIONS(633),
    [anon_sym_EQ_GT] = ACTIONS(627),
    [anon_sym_COLON] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_u8] = ACTIONS(624),
    [anon_sym_i8] = ACTIONS(624),
    [anon_sym_u16] = ACTIONS(624),
    [anon_sym_i16] = ACTIONS(624),
    [anon_sym_u32] = ACTIONS(624),
    [anon_sym_i32] = ACTIONS(624),
    [anon_sym_u64] = ACTIONS(624),
    [anon_sym_i64] = ACTIONS(624),
    [anon_sym_u128] = ACTIONS(624),
    [anon_sym_i128] = ACTIONS(624),
    [anon_sym_isize] = ACTIONS(624),
    [anon_sym_usize] = ACTIONS(624),
    [anon_sym_f32] = ACTIONS(624),
    [anon_sym_f64] = ACTIONS(624),
    [anon_sym_bool] = ACTIONS(624),
    [anon_sym_str] = ACTIONS(624),
    [anon_sym_char] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_PERCENT] = ACTIONS(641),
    [anon_sym_CARET] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(641),
    [anon_sym_GT_GT] = ACTIONS(641),
    [anon_sym_PLUS_EQ] = ACTIONS(627),
    [anon_sym_DASH_EQ] = ACTIONS(627),
    [anon_sym_STAR_EQ] = ACTIONS(627),
    [anon_sym_SLASH_EQ] = ACTIONS(627),
    [anon_sym_PERCENT_EQ] = ACTIONS(627),
    [anon_sym_CARET_EQ] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(627),
    [anon_sym_PIPE_EQ] = ACTIONS(627),
    [anon_sym_LT_LT_EQ] = ACTIONS(627),
    [anon_sym_GT_GT_EQ] = ACTIONS(627),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_BANG_EQ] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(627),
    [anon_sym_LT_EQ] = ACTIONS(627),
    [anon_sym_AT] = ACTIONS(627),
    [anon_sym__] = ACTIONS(641),
    [anon_sym_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(627),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(627),
    [anon_sym_COMMA] = ACTIONS(627),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_DASH_GT] = ACTIONS(627),
    [anon_sym_POUND] = ACTIONS(627),
    [anon_sym_SQUOTE] = ACTIONS(624),
    [anon_sym_as] = ACTIONS(624),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_await] = ACTIONS(624),
    [anon_sym_break] = ACTIONS(624),
    [anon_sym_const] = ACTIONS(624),
    [anon_sym_continue] = ACTIONS(624),
    [anon_sym_default] = ACTIONS(624),
    [anon_sym_enum] = ACTIONS(624),
    [anon_sym_fn] = ACTIONS(624),
    [anon_sym_for] = ACTIONS(624),
    [anon_sym_if] = ACTIONS(624),
    [anon_sym_impl] = ACTIONS(624),
    [anon_sym_let] = ACTIONS(624),
    [anon_sym_loop] = ACTIONS(624),
    [anon_sym_match] = ACTIONS(624),
    [anon_sym_mod] = ACTIONS(624),
    [anon_sym_pub] = ACTIONS(624),
    [anon_sym_return] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(624),
    [anon_sym_struct] = ACTIONS(624),
    [anon_sym_trait] = ACTIONS(624),
    [anon_sym_type] = ACTIONS(624),
    [anon_sym_union] = ACTIONS(624),
    [anon_sym_unsafe] = ACTIONS(624),
    [anon_sym_use] = ACTIONS(624),
    [anon_sym_where] = ACTIONS(624),
    [anon_sym_while] = ACTIONS(624),
    [sym_mutable_specifier] = ACTIONS(624),
    [sym_integer_literal] = ACTIONS(647),
    [aux_sym_string_literal_token1] = ACTIONS(650),
    [sym_char_literal] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(624),
    [sym_super] = ACTIONS(624),
    [sym_crate] = ACTIONS(624),
    [sym__raw_string_literal_start] = ACTIONS(656),
    [sym_float_literal] = ACTIONS(647),
  },
  [78] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(78),
    [sym_block_comment] = STATE(78),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_RBRACK] = ACTIONS(620),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [79] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(79),
    [sym_block_comment] = STATE(79),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_RPAREN] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [80] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(80),
    [sym_block_comment] = STATE(80),
    [aux_sym_token_tree_pattern_repeat1] = STATE(81),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_RPAREN] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [81] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(81),
    [sym_block_comment] = STATE(81),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_RPAREN] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [82] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(82),
    [sym_block_comment] = STATE(82),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_RBRACE] = ACTIONS(620),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [83] = {
    [sym__token_pattern] = STATE(153),
    [sym_token_tree_pattern] = STATE(143),
    [sym_token_binding_pattern] = STATE(143),
    [sym_token_repetition_pattern] = STATE(143),
    [sym__literal] = STATE(143),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(83),
    [sym_block_comment] = STATE(83),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_RBRACK] = ACTIONS(600),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(590),
    [anon_sym_i8] = ACTIONS(590),
    [anon_sym_u16] = ACTIONS(590),
    [anon_sym_i16] = ACTIONS(590),
    [anon_sym_u32] = ACTIONS(590),
    [anon_sym_i32] = ACTIONS(590),
    [anon_sym_u64] = ACTIONS(590),
    [anon_sym_i64] = ACTIONS(590),
    [anon_sym_u128] = ACTIONS(590),
    [anon_sym_i128] = ACTIONS(590),
    [anon_sym_isize] = ACTIONS(590),
    [anon_sym_usize] = ACTIONS(590),
    [anon_sym_f32] = ACTIONS(590),
    [anon_sym_f64] = ACTIONS(590),
    [anon_sym_bool] = ACTIONS(590),
    [anon_sym_str] = ACTIONS(590),
    [anon_sym_char] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(590),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_break] = ACTIONS(590),
    [anon_sym_const] = ACTIONS(590),
    [anon_sym_continue] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(590),
    [anon_sym_enum] = ACTIONS(590),
    [anon_sym_fn] = ACTIONS(590),
    [anon_sym_for] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_impl] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(590),
    [anon_sym_mod] = ACTIONS(590),
    [anon_sym_pub] = ACTIONS(590),
    [anon_sym_return] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_struct] = ACTIONS(590),
    [anon_sym_trait] = ACTIONS(590),
    [anon_sym_type] = ACTIONS(590),
    [anon_sym_union] = ACTIONS(590),
    [anon_sym_unsafe] = ACTIONS(590),
    [anon_sym_use] = ACTIONS(590),
    [anon_sym_where] = ACTIONS(590),
    [anon_sym_while] = ACTIONS(590),
    [sym_mutable_specifier] = ACTIONS(590),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(590),
    [sym_super] = ACTIONS(590),
    [sym_crate] = ACTIONS(590),
    [sym_metavariable] = ACTIONS(612),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [84] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(84),
    [sym_block_comment] = STATE(84),
    [aux_sym_token_tree_repeat1] = STATE(127),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [85] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(85),
    [sym_block_comment] = STATE(85),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [86] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(86),
    [sym_block_comment] = STATE(86),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(131),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [87] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(87),
    [sym_block_comment] = STATE(87),
    [aux_sym_token_tree_repeat1] = STATE(68),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_RBRACK] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [88] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(88),
    [sym_block_comment] = STATE(88),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(128),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [89] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(89),
    [sym_block_comment] = STATE(89),
    [aux_sym_token_tree_repeat1] = STATE(68),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(701),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [90] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(90),
    [sym_block_comment] = STATE(90),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(100),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(703),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [91] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(91),
    [sym_block_comment] = STATE(91),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(85),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [92] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(92),
    [sym_block_comment] = STATE(92),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(705),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [93] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(93),
    [sym_block_comment] = STATE(93),
    [aux_sym_token_tree_repeat1] = STATE(68),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_RBRACE] = ACTIONS(707),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [94] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(94),
    [sym_block_comment] = STATE(94),
    [aux_sym_token_tree_repeat1] = STATE(68),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(707),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [95] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(95),
    [sym_block_comment] = STATE(95),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(106),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(703),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [96] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(96),
    [sym_block_comment] = STATE(96),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(107),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [97] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(97),
    [sym_block_comment] = STATE(97),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [98] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(98),
    [sym_block_comment] = STATE(98),
    [aux_sym_token_tree_repeat1] = STATE(94),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [99] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(99),
    [sym_block_comment] = STATE(99),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(92),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(711),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [100] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(100),
    [sym_block_comment] = STATE(100),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [101] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(101),
    [sym_block_comment] = STATE(101),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(122),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [102] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(102),
    [sym_block_comment] = STATE(102),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(111),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [103] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(103),
    [sym_block_comment] = STATE(103),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [104] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(104),
    [sym_block_comment] = STATE(104),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(717),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [105] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(105),
    [sym_block_comment] = STATE(105),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(717),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [106] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(106),
    [sym_block_comment] = STATE(106),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [107] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(107),
    [sym_block_comment] = STATE(107),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [108] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(108),
    [sym_block_comment] = STATE(108),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [109] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(109),
    [sym_block_comment] = STATE(109),
    [aux_sym_token_tree_repeat1] = STATE(68),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [110] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(110),
    [sym_block_comment] = STATE(110),
    [aux_sym_token_tree_repeat1] = STATE(109),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [111] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(111),
    [sym_block_comment] = STATE(111),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [112] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(112),
    [sym_block_comment] = STATE(112),
    [aux_sym_token_tree_repeat1] = STATE(117),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [113] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(113),
    [sym_block_comment] = STATE(113),
    [aux_sym_token_tree_repeat1] = STATE(87),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_RBRACK] = ACTIONS(723),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [114] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(114),
    [sym_block_comment] = STATE(114),
    [aux_sym_token_tree_repeat1] = STATE(89),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [115] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(115),
    [sym_block_comment] = STATE(115),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(125),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [116] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(116),
    [sym_block_comment] = STATE(116),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(104),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [117] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(117),
    [sym_block_comment] = STATE(117),
    [aux_sym_token_tree_repeat1] = STATE(68),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [118] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(118),
    [sym_block_comment] = STATE(118),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(105),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [119] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(119),
    [sym_block_comment] = STATE(119),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(108),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [120] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(120),
    [sym_block_comment] = STATE(120),
    [aux_sym_token_tree_repeat1] = STATE(93),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [121] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(121),
    [sym_block_comment] = STATE(121),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(715),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [122] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(122),
    [sym_block_comment] = STATE(122),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [123] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(123),
    [sym_block_comment] = STATE(123),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(727),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [124] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(124),
    [sym_block_comment] = STATE(124),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(130),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [125] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(125),
    [sym_block_comment] = STATE(125),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(705),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [126] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(126),
    [sym_block_comment] = STATE(126),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(727),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [127] = {
    [sym_token_tree] = STATE(163),
    [sym_token_repetition] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(164),
    [sym_raw_string_literal] = STATE(164),
    [sym_boolean_literal] = STATE(164),
    [sym_line_comment] = STATE(127),
    [sym_block_comment] = STATE(127),
    [aux_sym_token_tree_repeat1] = STATE(68),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_RBRACK] = ACTIONS(707),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(606),
    [aux_sym_string_literal_token1] = ACTIONS(608),
    [sym_char_literal] = ACTIONS(606),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym_metavariable] = ACTIONS(673),
    [sym__raw_string_literal_start] = ACTIONS(614),
    [sym_float_literal] = ACTIONS(606),
  },
  [128] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(128),
    [sym_block_comment] = STATE(128),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [129] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(129),
    [sym_block_comment] = STATE(129),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(126),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(729),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [130] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(130),
    [sym_block_comment] = STATE(130),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [131] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(131),
    [sym_block_comment] = STATE(131),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [132] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(132),
    [sym_block_comment] = STATE(132),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [133] = {
    [sym_delim_token_tree] = STATE(204),
    [sym__delim_tokens] = STATE(197),
    [sym__non_delim_token] = STATE(204),
    [sym__literal] = STATE(183),
    [sym_string_literal] = STATE(199),
    [sym_raw_string_literal] = STATE(199),
    [sym_boolean_literal] = STATE(199),
    [sym_line_comment] = STATE(133),
    [sym_block_comment] = STATE(133),
    [aux_sym__non_special_token_repeat1] = STATE(154),
    [aux_sym_delim_token_tree_repeat1] = STATE(123),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(729),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(675),
    [anon_sym_i8] = ACTIONS(675),
    [anon_sym_u16] = ACTIONS(675),
    [anon_sym_i16] = ACTIONS(675),
    [anon_sym_u32] = ACTIONS(675),
    [anon_sym_i32] = ACTIONS(675),
    [anon_sym_u64] = ACTIONS(675),
    [anon_sym_i64] = ACTIONS(675),
    [anon_sym_u128] = ACTIONS(675),
    [anon_sym_i128] = ACTIONS(675),
    [anon_sym_isize] = ACTIONS(675),
    [anon_sym_usize] = ACTIONS(675),
    [anon_sym_f32] = ACTIONS(675),
    [anon_sym_f64] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_str] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(675),
    [anon_sym_as] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_fn] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_impl] = ACTIONS(675),
    [anon_sym_let] = ACTIONS(675),
    [anon_sym_loop] = ACTIONS(675),
    [anon_sym_match] = ACTIONS(675),
    [anon_sym_mod] = ACTIONS(675),
    [anon_sym_pub] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_trait] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [anon_sym_unsafe] = ACTIONS(675),
    [anon_sym_use] = ACTIONS(675),
    [anon_sym_where] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [sym_mutable_specifier] = ACTIONS(675),
    [sym_integer_literal] = ACTIONS(691),
    [aux_sym_string_literal_token1] = ACTIONS(693),
    [sym_char_literal] = ACTIONS(691),
    [anon_sym_true] = ACTIONS(695),
    [anon_sym_false] = ACTIONS(695),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_crate] = ACTIONS(675),
    [sym__raw_string_literal_start] = ACTIONS(697),
    [sym_float_literal] = ACTIONS(691),
  },
  [134] = {
    [sym_line_comment] = STATE(134),
    [sym_block_comment] = STATE(134),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(731),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(731),
    [anon_sym_i8] = ACTIONS(731),
    [anon_sym_u16] = ACTIONS(731),
    [anon_sym_i16] = ACTIONS(731),
    [anon_sym_u32] = ACTIONS(731),
    [anon_sym_i32] = ACTIONS(731),
    [anon_sym_u64] = ACTIONS(731),
    [anon_sym_i64] = ACTIONS(731),
    [anon_sym_u128] = ACTIONS(731),
    [anon_sym_i128] = ACTIONS(731),
    [anon_sym_isize] = ACTIONS(731),
    [anon_sym_usize] = ACTIONS(731),
    [anon_sym_f32] = ACTIONS(731),
    [anon_sym_f64] = ACTIONS(731),
    [anon_sym_bool] = ACTIONS(731),
    [anon_sym_str] = ACTIONS(731),
    [anon_sym_char] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_await] = ACTIONS(731),
    [anon_sym_break] = ACTIONS(731),
    [anon_sym_const] = ACTIONS(731),
    [anon_sym_continue] = ACTIONS(731),
    [anon_sym_default] = ACTIONS(731),
    [anon_sym_enum] = ACTIONS(731),
    [anon_sym_fn] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_impl] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(731),
    [anon_sym_loop] = ACTIONS(731),
    [anon_sym_match] = ACTIONS(731),
    [anon_sym_mod] = ACTIONS(731),
    [anon_sym_pub] = ACTIONS(731),
    [anon_sym_return] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_struct] = ACTIONS(731),
    [anon_sym_trait] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_union] = ACTIONS(731),
    [anon_sym_unsafe] = ACTIONS(731),
    [anon_sym_use] = ACTIONS(731),
    [anon_sym_where] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [sym_mutable_specifier] = ACTIONS(731),
    [sym_integer_literal] = ACTIONS(733),
    [aux_sym_string_literal_token1] = ACTIONS(733),
    [sym_char_literal] = ACTIONS(733),
    [anon_sym_true] = ACTIONS(731),
    [anon_sym_false] = ACTIONS(731),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(731),
    [sym_super] = ACTIONS(731),
    [sym_crate] = ACTIONS(731),
    [sym_metavariable] = ACTIONS(733),
    [sym__raw_string_literal_start] = ACTIONS(733),
    [sym_float_literal] = ACTIONS(733),
  },
  [135] = {
    [sym_line_comment] = STATE(135),
    [sym_block_comment] = STATE(135),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_RBRACK] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_EQ_GT] = ACTIONS(592),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(735),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(602),
    [anon_sym_QMARK] = ACTIONS(592),
    [anon_sym_u8] = ACTIONS(735),
    [anon_sym_i8] = ACTIONS(735),
    [anon_sym_u16] = ACTIONS(735),
    [anon_sym_i16] = ACTIONS(735),
    [anon_sym_u32] = ACTIONS(735),
    [anon_sym_i32] = ACTIONS(735),
    [anon_sym_u64] = ACTIONS(735),
    [anon_sym_i64] = ACTIONS(735),
    [anon_sym_u128] = ACTIONS(735),
    [anon_sym_i128] = ACTIONS(735),
    [anon_sym_isize] = ACTIONS(735),
    [anon_sym_usize] = ACTIONS(735),
    [anon_sym_f32] = ACTIONS(735),
    [anon_sym_f64] = ACTIONS(735),
    [anon_sym_bool] = ACTIONS(735),
    [anon_sym_str] = ACTIONS(735),
    [anon_sym_char] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(602),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP_AMP] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(592),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(592),
    [anon_sym_DASH_EQ] = ACTIONS(592),
    [anon_sym_STAR_EQ] = ACTIONS(592),
    [anon_sym_SLASH_EQ] = ACTIONS(592),
    [anon_sym_PERCENT_EQ] = ACTIONS(592),
    [anon_sym_CARET_EQ] = ACTIONS(592),
    [anon_sym_AMP_EQ] = ACTIONS(592),
    [anon_sym_PIPE_EQ] = ACTIONS(592),
    [anon_sym_LT_LT_EQ] = ACTIONS(592),
    [anon_sym_GT_GT_EQ] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(592),
    [anon_sym_BANG_EQ] = ACTIONS(592),
    [anon_sym_GT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(592),
    [anon_sym_LT_EQ] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym__] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(592),
    [anon_sym_COMMA] = ACTIONS(592),
    [anon_sym_COLON_COLON] = ACTIONS(592),
    [anon_sym_DASH_GT] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(592),
    [anon_sym_SQUOTE] = ACTIONS(735),
    [anon_sym_as] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(735),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_break] = ACTIONS(735),
    [anon_sym_const] = ACTIONS(735),
    [anon_sym_continue] = ACTIONS(735),
    [anon_sym_default] = ACTIONS(735),
    [anon_sym_enum] = ACTIONS(735),
    [anon_sym_fn] = ACTIONS(735),
    [anon_sym_for] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_impl] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(735),
    [anon_sym_loop] = ACTIONS(735),
    [anon_sym_match] = ACTIONS(735),
    [anon_sym_mod] = ACTIONS(735),
    [anon_sym_pub] = ACTIONS(735),
    [anon_sym_return] = ACTIONS(735),
    [anon_sym_static] = ACTIONS(735),
    [anon_sym_struct] = ACTIONS(735),
    [anon_sym_trait] = ACTIONS(735),
    [anon_sym_type] = ACTIONS(735),
    [anon_sym_union] = ACTIONS(735),
    [anon_sym_unsafe] = ACTIONS(735),
    [anon_sym_use] = ACTIONS(735),
    [anon_sym_where] = ACTIONS(735),
    [anon_sym_while] = ACTIONS(735),
    [sym_mutable_specifier] = ACTIONS(735),
    [sym_integer_literal] = ACTIONS(737),
    [aux_sym_string_literal_token1] = ACTIONS(737),
    [sym_char_literal] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(735),
    [anon_sym_false] = ACTIONS(735),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(735),
    [sym_super] = ACTIONS(735),
    [sym_crate] = ACTIONS(735),
    [sym_metavariable] = ACTIONS(737),
    [sym__raw_string_literal_start] = ACTIONS(737),
    [sym_float_literal] = ACTIONS(737),
  },
  [136] = {
    [sym_line_comment] = STATE(136),
    [sym_block_comment] = STATE(136),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(739),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_LPAREN] = ACTIONS(744),
    [anon_sym_RPAREN] = ACTIONS(744),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_RBRACK] = ACTIONS(744),
    [anon_sym_LBRACE] = ACTIONS(744),
    [anon_sym_RBRACE] = ACTIONS(744),
    [anon_sym_EQ_GT] = ACTIONS(741),
    [anon_sym_COLON] = ACTIONS(746),
    [anon_sym_DOLLAR] = ACTIONS(739),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(739),
    [anon_sym_i8] = ACTIONS(739),
    [anon_sym_u16] = ACTIONS(739),
    [anon_sym_i16] = ACTIONS(739),
    [anon_sym_u32] = ACTIONS(739),
    [anon_sym_i32] = ACTIONS(739),
    [anon_sym_u64] = ACTIONS(739),
    [anon_sym_i64] = ACTIONS(739),
    [anon_sym_u128] = ACTIONS(739),
    [anon_sym_i128] = ACTIONS(739),
    [anon_sym_isize] = ACTIONS(739),
    [anon_sym_usize] = ACTIONS(739),
    [anon_sym_f32] = ACTIONS(739),
    [anon_sym_f64] = ACTIONS(739),
    [anon_sym_bool] = ACTIONS(739),
    [anon_sym_str] = ACTIONS(739),
    [anon_sym_char] = ACTIONS(739),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(746),
    [anon_sym_PERCENT] = ACTIONS(746),
    [anon_sym_CARET] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_AMP] = ACTIONS(746),
    [anon_sym_PIPE] = ACTIONS(746),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_LT_LT] = ACTIONS(746),
    [anon_sym_GT_GT] = ACTIONS(746),
    [anon_sym_PLUS_EQ] = ACTIONS(741),
    [anon_sym_DASH_EQ] = ACTIONS(741),
    [anon_sym_STAR_EQ] = ACTIONS(741),
    [anon_sym_SLASH_EQ] = ACTIONS(741),
    [anon_sym_PERCENT_EQ] = ACTIONS(741),
    [anon_sym_CARET_EQ] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(741),
    [anon_sym_LT_LT_EQ] = ACTIONS(741),
    [anon_sym_GT_GT_EQ] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(746),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_BANG_EQ] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(746),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(741),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(741),
    [anon_sym__] = ACTIONS(746),
    [anon_sym_DOT] = ACTIONS(746),
    [anon_sym_DOT_DOT] = ACTIONS(746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(741),
    [anon_sym_COMMA] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(741),
    [anon_sym_DASH_GT] = ACTIONS(741),
    [anon_sym_POUND] = ACTIONS(741),
    [anon_sym_SQUOTE] = ACTIONS(739),
    [anon_sym_as] = ACTIONS(739),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_await] = ACTIONS(739),
    [anon_sym_break] = ACTIONS(739),
    [anon_sym_const] = ACTIONS(739),
    [anon_sym_continue] = ACTIONS(739),
    [anon_sym_default] = ACTIONS(739),
    [anon_sym_enum] = ACTIONS(739),
    [anon_sym_fn] = ACTIONS(739),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_if] = ACTIONS(739),
    [anon_sym_impl] = ACTIONS(739),
    [anon_sym_let] = ACTIONS(739),
    [anon_sym_loop] = ACTIONS(739),
    [anon_sym_match] = ACTIONS(739),
    [anon_sym_mod] = ACTIONS(739),
    [anon_sym_pub] = ACTIONS(739),
    [anon_sym_return] = ACTIONS(739),
    [anon_sym_static] = ACTIONS(739),
    [anon_sym_struct] = ACTIONS(739),
    [anon_sym_trait] = ACTIONS(739),
    [anon_sym_type] = ACTIONS(739),
    [anon_sym_union] = ACTIONS(739),
    [anon_sym_unsafe] = ACTIONS(739),
    [anon_sym_use] = ACTIONS(739),
    [anon_sym_where] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(739),
    [sym_mutable_specifier] = ACTIONS(739),
    [sym_integer_literal] = ACTIONS(744),
    [aux_sym_string_literal_token1] = ACTIONS(744),
    [sym_char_literal] = ACTIONS(744),
    [anon_sym_true] = ACTIONS(739),
    [anon_sym_false] = ACTIONS(739),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_crate] = ACTIONS(739),
    [sym_metavariable] = ACTIONS(744),
    [sym__raw_string_literal_start] = ACTIONS(744),
    [sym_float_literal] = ACTIONS(744),
  },
  [137] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1618),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(137),
    [sym_block_comment] = STATE(137),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [138] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1545),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(138),
    [sym_block_comment] = STATE(138),
    [aux_sym_enum_variant_list_repeat1] = STATE(140),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(755),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(757),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [139] = {
    [sym_line_comment] = STATE(139),
    [sym_block_comment] = STATE(139),
    [sym_identifier] = ACTIONS(759),
    [anon_sym_SEMI] = ACTIONS(761),
    [anon_sym_LPAREN] = ACTIONS(761),
    [anon_sym_RPAREN] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(761),
    [anon_sym_LBRACE] = ACTIONS(761),
    [anon_sym_RBRACE] = ACTIONS(761),
    [anon_sym_EQ_GT] = ACTIONS(761),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(759),
    [anon_sym_PLUS] = ACTIONS(759),
    [anon_sym_STAR] = ACTIONS(759),
    [anon_sym_QMARK] = ACTIONS(761),
    [anon_sym_u8] = ACTIONS(759),
    [anon_sym_i8] = ACTIONS(759),
    [anon_sym_u16] = ACTIONS(759),
    [anon_sym_i16] = ACTIONS(759),
    [anon_sym_u32] = ACTIONS(759),
    [anon_sym_i32] = ACTIONS(759),
    [anon_sym_u64] = ACTIONS(759),
    [anon_sym_i64] = ACTIONS(759),
    [anon_sym_u128] = ACTIONS(759),
    [anon_sym_i128] = ACTIONS(759),
    [anon_sym_isize] = ACTIONS(759),
    [anon_sym_usize] = ACTIONS(759),
    [anon_sym_f32] = ACTIONS(759),
    [anon_sym_f64] = ACTIONS(759),
    [anon_sym_bool] = ACTIONS(759),
    [anon_sym_str] = ACTIONS(759),
    [anon_sym_char] = ACTIONS(759),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_SLASH] = ACTIONS(759),
    [anon_sym_PERCENT] = ACTIONS(759),
    [anon_sym_CARET] = ACTIONS(759),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(759),
    [anon_sym_PIPE] = ACTIONS(759),
    [anon_sym_AMP_AMP] = ACTIONS(761),
    [anon_sym_PIPE_PIPE] = ACTIONS(761),
    [anon_sym_LT_LT] = ACTIONS(759),
    [anon_sym_GT_GT] = ACTIONS(759),
    [anon_sym_PLUS_EQ] = ACTIONS(761),
    [anon_sym_DASH_EQ] = ACTIONS(761),
    [anon_sym_STAR_EQ] = ACTIONS(761),
    [anon_sym_SLASH_EQ] = ACTIONS(761),
    [anon_sym_PERCENT_EQ] = ACTIONS(761),
    [anon_sym_CARET_EQ] = ACTIONS(761),
    [anon_sym_AMP_EQ] = ACTIONS(761),
    [anon_sym_PIPE_EQ] = ACTIONS(761),
    [anon_sym_LT_LT_EQ] = ACTIONS(761),
    [anon_sym_GT_GT_EQ] = ACTIONS(761),
    [anon_sym_EQ] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(761),
    [anon_sym_BANG_EQ] = ACTIONS(761),
    [anon_sym_GT] = ACTIONS(759),
    [anon_sym_LT] = ACTIONS(759),
    [anon_sym_GT_EQ] = ACTIONS(761),
    [anon_sym_LT_EQ] = ACTIONS(761),
    [anon_sym_AT] = ACTIONS(761),
    [anon_sym__] = ACTIONS(759),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DOT_DOT] = ACTIONS(759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(761),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(761),
    [anon_sym_COMMA] = ACTIONS(761),
    [anon_sym_COLON_COLON] = ACTIONS(761),
    [anon_sym_DASH_GT] = ACTIONS(761),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_as] = ACTIONS(759),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_break] = ACTIONS(759),
    [anon_sym_const] = ACTIONS(759),
    [anon_sym_continue] = ACTIONS(759),
    [anon_sym_default] = ACTIONS(759),
    [anon_sym_enum] = ACTIONS(759),
    [anon_sym_fn] = ACTIONS(759),
    [anon_sym_for] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(759),
    [anon_sym_impl] = ACTIONS(759),
    [anon_sym_let] = ACTIONS(759),
    [anon_sym_loop] = ACTIONS(759),
    [anon_sym_match] = ACTIONS(759),
    [anon_sym_mod] = ACTIONS(759),
    [anon_sym_pub] = ACTIONS(759),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_struct] = ACTIONS(759),
    [anon_sym_trait] = ACTIONS(759),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_union] = ACTIONS(759),
    [anon_sym_unsafe] = ACTIONS(759),
    [anon_sym_use] = ACTIONS(759),
    [anon_sym_where] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(759),
    [sym_mutable_specifier] = ACTIONS(759),
    [sym_integer_literal] = ACTIONS(761),
    [aux_sym_string_literal_token1] = ACTIONS(761),
    [sym_char_literal] = ACTIONS(761),
    [anon_sym_true] = ACTIONS(759),
    [anon_sym_false] = ACTIONS(759),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(759),
    [sym_super] = ACTIONS(759),
    [sym_crate] = ACTIONS(759),
    [sym_metavariable] = ACTIONS(761),
    [sym__raw_string_literal_start] = ACTIONS(761),
    [sym_float_literal] = ACTIONS(761),
  },
  [140] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1553),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(140),
    [sym_block_comment] = STATE(140),
    [aux_sym_enum_variant_list_repeat1] = STATE(160),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [141] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1574),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(141),
    [sym_block_comment] = STATE(141),
    [aux_sym_enum_variant_list_repeat1] = STATE(209),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [142] = {
    [sym_line_comment] = STATE(142),
    [sym_block_comment] = STATE(142),
    [sym_identifier] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(773),
    [anon_sym_RPAREN] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_RBRACK] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_RBRACE] = ACTIONS(773),
    [anon_sym_EQ_GT] = ACTIONS(773),
    [anon_sym_COLON] = ACTIONS(771),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_u8] = ACTIONS(771),
    [anon_sym_i8] = ACTIONS(771),
    [anon_sym_u16] = ACTIONS(771),
    [anon_sym_i16] = ACTIONS(771),
    [anon_sym_u32] = ACTIONS(771),
    [anon_sym_i32] = ACTIONS(771),
    [anon_sym_u64] = ACTIONS(771),
    [anon_sym_i64] = ACTIONS(771),
    [anon_sym_u128] = ACTIONS(771),
    [anon_sym_i128] = ACTIONS(771),
    [anon_sym_isize] = ACTIONS(771),
    [anon_sym_usize] = ACTIONS(771),
    [anon_sym_f32] = ACTIONS(771),
    [anon_sym_f64] = ACTIONS(771),
    [anon_sym_bool] = ACTIONS(771),
    [anon_sym_str] = ACTIONS(771),
    [anon_sym_char] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_BANG] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym__] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(773),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(773),
    [anon_sym_DASH_GT] = ACTIONS(773),
    [anon_sym_POUND] = ACTIONS(773),
    [anon_sym_SQUOTE] = ACTIONS(771),
    [anon_sym_as] = ACTIONS(771),
    [anon_sym_async] = ACTIONS(771),
    [anon_sym_await] = ACTIONS(771),
    [anon_sym_break] = ACTIONS(771),
    [anon_sym_const] = ACTIONS(771),
    [anon_sym_continue] = ACTIONS(771),
    [anon_sym_default] = ACTIONS(771),
    [anon_sym_enum] = ACTIONS(771),
    [anon_sym_fn] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_impl] = ACTIONS(771),
    [anon_sym_let] = ACTIONS(771),
    [anon_sym_loop] = ACTIONS(771),
    [anon_sym_match] = ACTIONS(771),
    [anon_sym_mod] = ACTIONS(771),
    [anon_sym_pub] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(771),
    [anon_sym_static] = ACTIONS(771),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_trait] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(771),
    [anon_sym_union] = ACTIONS(771),
    [anon_sym_unsafe] = ACTIONS(771),
    [anon_sym_use] = ACTIONS(771),
    [anon_sym_where] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [sym_mutable_specifier] = ACTIONS(771),
    [sym_integer_literal] = ACTIONS(773),
    [aux_sym_string_literal_token1] = ACTIONS(773),
    [sym_char_literal] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(771),
    [anon_sym_false] = ACTIONS(771),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(771),
    [sym_super] = ACTIONS(771),
    [sym_crate] = ACTIONS(771),
    [sym_metavariable] = ACTIONS(773),
    [sym__raw_string_literal_start] = ACTIONS(773),
    [sym_float_literal] = ACTIONS(773),
  },
  [143] = {
    [sym_line_comment] = STATE(143),
    [sym_block_comment] = STATE(143),
    [sym_identifier] = ACTIONS(731),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(731),
    [anon_sym_i8] = ACTIONS(731),
    [anon_sym_u16] = ACTIONS(731),
    [anon_sym_i16] = ACTIONS(731),
    [anon_sym_u32] = ACTIONS(731),
    [anon_sym_i32] = ACTIONS(731),
    [anon_sym_u64] = ACTIONS(731),
    [anon_sym_i64] = ACTIONS(731),
    [anon_sym_u128] = ACTIONS(731),
    [anon_sym_i128] = ACTIONS(731),
    [anon_sym_isize] = ACTIONS(731),
    [anon_sym_usize] = ACTIONS(731),
    [anon_sym_f32] = ACTIONS(731),
    [anon_sym_f64] = ACTIONS(731),
    [anon_sym_bool] = ACTIONS(731),
    [anon_sym_str] = ACTIONS(731),
    [anon_sym_char] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_AT] = ACTIONS(733),
    [anon_sym__] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(731),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_DASH_GT] = ACTIONS(733),
    [anon_sym_POUND] = ACTIONS(733),
    [anon_sym_SQUOTE] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_await] = ACTIONS(731),
    [anon_sym_break] = ACTIONS(731),
    [anon_sym_const] = ACTIONS(731),
    [anon_sym_continue] = ACTIONS(731),
    [anon_sym_default] = ACTIONS(731),
    [anon_sym_enum] = ACTIONS(731),
    [anon_sym_fn] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_impl] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(731),
    [anon_sym_loop] = ACTIONS(731),
    [anon_sym_match] = ACTIONS(731),
    [anon_sym_mod] = ACTIONS(731),
    [anon_sym_pub] = ACTIONS(731),
    [anon_sym_return] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_struct] = ACTIONS(731),
    [anon_sym_trait] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_union] = ACTIONS(731),
    [anon_sym_unsafe] = ACTIONS(731),
    [anon_sym_use] = ACTIONS(731),
    [anon_sym_where] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [sym_mutable_specifier] = ACTIONS(731),
    [sym_integer_literal] = ACTIONS(733),
    [aux_sym_string_literal_token1] = ACTIONS(733),
    [sym_char_literal] = ACTIONS(733),
    [anon_sym_true] = ACTIONS(731),
    [anon_sym_false] = ACTIONS(731),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(731),
    [sym_super] = ACTIONS(731),
    [sym_crate] = ACTIONS(731),
    [sym_metavariable] = ACTIONS(733),
    [sym__raw_string_literal_start] = ACTIONS(733),
    [sym_float_literal] = ACTIONS(733),
  },
  [144] = {
    [sym_line_comment] = STATE(144),
    [sym_block_comment] = STATE(144),
    [sym_identifier] = ACTIONS(731),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(775),
    [anon_sym_DOLLAR] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(731),
    [anon_sym_i8] = ACTIONS(731),
    [anon_sym_u16] = ACTIONS(731),
    [anon_sym_i16] = ACTIONS(731),
    [anon_sym_u32] = ACTIONS(731),
    [anon_sym_i32] = ACTIONS(731),
    [anon_sym_u64] = ACTIONS(731),
    [anon_sym_i64] = ACTIONS(731),
    [anon_sym_u128] = ACTIONS(731),
    [anon_sym_i128] = ACTIONS(731),
    [anon_sym_isize] = ACTIONS(731),
    [anon_sym_usize] = ACTIONS(731),
    [anon_sym_f32] = ACTIONS(731),
    [anon_sym_f64] = ACTIONS(731),
    [anon_sym_bool] = ACTIONS(731),
    [anon_sym_str] = ACTIONS(731),
    [anon_sym_char] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_AT] = ACTIONS(733),
    [anon_sym__] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(731),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_DASH_GT] = ACTIONS(733),
    [anon_sym_POUND] = ACTIONS(733),
    [anon_sym_SQUOTE] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_await] = ACTIONS(731),
    [anon_sym_break] = ACTIONS(731),
    [anon_sym_const] = ACTIONS(731),
    [anon_sym_continue] = ACTIONS(731),
    [anon_sym_default] = ACTIONS(731),
    [anon_sym_enum] = ACTIONS(731),
    [anon_sym_fn] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_impl] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(731),
    [anon_sym_loop] = ACTIONS(731),
    [anon_sym_match] = ACTIONS(731),
    [anon_sym_mod] = ACTIONS(731),
    [anon_sym_pub] = ACTIONS(731),
    [anon_sym_return] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_struct] = ACTIONS(731),
    [anon_sym_trait] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_union] = ACTIONS(731),
    [anon_sym_unsafe] = ACTIONS(731),
    [anon_sym_use] = ACTIONS(731),
    [anon_sym_where] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [sym_mutable_specifier] = ACTIONS(731),
    [sym_integer_literal] = ACTIONS(733),
    [aux_sym_string_literal_token1] = ACTIONS(733),
    [sym_char_literal] = ACTIONS(733),
    [anon_sym_true] = ACTIONS(731),
    [anon_sym_false] = ACTIONS(731),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(731),
    [sym_super] = ACTIONS(731),
    [sym_crate] = ACTIONS(731),
    [sym_metavariable] = ACTIONS(733),
    [sym__raw_string_literal_start] = ACTIONS(733),
    [sym_float_literal] = ACTIONS(733),
  },
  [145] = {
    [sym_line_comment] = STATE(145),
    [sym_block_comment] = STATE(145),
    [sym_identifier] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(779),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(779),
    [anon_sym_RBRACE] = ACTIONS(779),
    [anon_sym_EQ_GT] = ACTIONS(779),
    [anon_sym_COLON] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(779),
    [anon_sym_u8] = ACTIONS(777),
    [anon_sym_i8] = ACTIONS(777),
    [anon_sym_u16] = ACTIONS(777),
    [anon_sym_i16] = ACTIONS(777),
    [anon_sym_u32] = ACTIONS(777),
    [anon_sym_i32] = ACTIONS(777),
    [anon_sym_u64] = ACTIONS(777),
    [anon_sym_i64] = ACTIONS(777),
    [anon_sym_u128] = ACTIONS(777),
    [anon_sym_i128] = ACTIONS(777),
    [anon_sym_isize] = ACTIONS(777),
    [anon_sym_usize] = ACTIONS(777),
    [anon_sym_f32] = ACTIONS(777),
    [anon_sym_f64] = ACTIONS(777),
    [anon_sym_bool] = ACTIONS(777),
    [anon_sym_str] = ACTIONS(777),
    [anon_sym_char] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(779),
    [anon_sym_DASH_EQ] = ACTIONS(779),
    [anon_sym_STAR_EQ] = ACTIONS(779),
    [anon_sym_SLASH_EQ] = ACTIONS(779),
    [anon_sym_PERCENT_EQ] = ACTIONS(779),
    [anon_sym_CARET_EQ] = ACTIONS(779),
    [anon_sym_AMP_EQ] = ACTIONS(779),
    [anon_sym_PIPE_EQ] = ACTIONS(779),
    [anon_sym_LT_LT_EQ] = ACTIONS(779),
    [anon_sym_GT_GT_EQ] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(779),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(779),
    [anon_sym_LT_EQ] = ACTIONS(779),
    [anon_sym_AT] = ACTIONS(779),
    [anon_sym__] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(777),
    [anon_sym_DOT_DOT] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(779),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(779),
    [anon_sym_COMMA] = ACTIONS(779),
    [anon_sym_COLON_COLON] = ACTIONS(779),
    [anon_sym_DASH_GT] = ACTIONS(779),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_SQUOTE] = ACTIONS(777),
    [anon_sym_as] = ACTIONS(777),
    [anon_sym_async] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_break] = ACTIONS(777),
    [anon_sym_const] = ACTIONS(777),
    [anon_sym_continue] = ACTIONS(777),
    [anon_sym_default] = ACTIONS(777),
    [anon_sym_enum] = ACTIONS(777),
    [anon_sym_fn] = ACTIONS(777),
    [anon_sym_for] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_impl] = ACTIONS(777),
    [anon_sym_let] = ACTIONS(777),
    [anon_sym_loop] = ACTIONS(777),
    [anon_sym_match] = ACTIONS(777),
    [anon_sym_mod] = ACTIONS(777),
    [anon_sym_pub] = ACTIONS(777),
    [anon_sym_return] = ACTIONS(777),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_struct] = ACTIONS(777),
    [anon_sym_trait] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_union] = ACTIONS(777),
    [anon_sym_unsafe] = ACTIONS(777),
    [anon_sym_use] = ACTIONS(777),
    [anon_sym_where] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym_mutable_specifier] = ACTIONS(777),
    [sym_integer_literal] = ACTIONS(779),
    [aux_sym_string_literal_token1] = ACTIONS(779),
    [sym_char_literal] = ACTIONS(779),
    [anon_sym_true] = ACTIONS(777),
    [anon_sym_false] = ACTIONS(777),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(777),
    [sym_super] = ACTIONS(777),
    [sym_crate] = ACTIONS(777),
    [sym_metavariable] = ACTIONS(779),
    [sym__raw_string_literal_start] = ACTIONS(779),
    [sym_float_literal] = ACTIONS(779),
  },
  [146] = {
    [sym_line_comment] = STATE(146),
    [sym_block_comment] = STATE(146),
    [sym_identifier] = ACTIONS(781),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_RBRACK] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_EQ_GT] = ACTIONS(783),
    [anon_sym_COLON] = ACTIONS(781),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(781),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_u8] = ACTIONS(781),
    [anon_sym_i8] = ACTIONS(781),
    [anon_sym_u16] = ACTIONS(781),
    [anon_sym_i16] = ACTIONS(781),
    [anon_sym_u32] = ACTIONS(781),
    [anon_sym_i32] = ACTIONS(781),
    [anon_sym_u64] = ACTIONS(781),
    [anon_sym_i64] = ACTIONS(781),
    [anon_sym_u128] = ACTIONS(781),
    [anon_sym_i128] = ACTIONS(781),
    [anon_sym_isize] = ACTIONS(781),
    [anon_sym_usize] = ACTIONS(781),
    [anon_sym_f32] = ACTIONS(781),
    [anon_sym_f64] = ACTIONS(781),
    [anon_sym_bool] = ACTIONS(781),
    [anon_sym_str] = ACTIONS(781),
    [anon_sym_char] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_SLASH] = ACTIONS(781),
    [anon_sym_PERCENT] = ACTIONS(781),
    [anon_sym_CARET] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AMP] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(781),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym__] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(781),
    [anon_sym_DOT_DOT] = ACTIONS(781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_COLON_COLON] = ACTIONS(783),
    [anon_sym_DASH_GT] = ACTIONS(783),
    [anon_sym_POUND] = ACTIONS(783),
    [anon_sym_SQUOTE] = ACTIONS(781),
    [anon_sym_as] = ACTIONS(781),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(781),
    [anon_sym_break] = ACTIONS(781),
    [anon_sym_const] = ACTIONS(781),
    [anon_sym_continue] = ACTIONS(781),
    [anon_sym_default] = ACTIONS(781),
    [anon_sym_enum] = ACTIONS(781),
    [anon_sym_fn] = ACTIONS(781),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_if] = ACTIONS(781),
    [anon_sym_impl] = ACTIONS(781),
    [anon_sym_let] = ACTIONS(781),
    [anon_sym_loop] = ACTIONS(781),
    [anon_sym_match] = ACTIONS(781),
    [anon_sym_mod] = ACTIONS(781),
    [anon_sym_pub] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_struct] = ACTIONS(781),
    [anon_sym_trait] = ACTIONS(781),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_union] = ACTIONS(781),
    [anon_sym_unsafe] = ACTIONS(781),
    [anon_sym_use] = ACTIONS(781),
    [anon_sym_where] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(781),
    [sym_mutable_specifier] = ACTIONS(781),
    [sym_integer_literal] = ACTIONS(783),
    [aux_sym_string_literal_token1] = ACTIONS(783),
    [sym_char_literal] = ACTIONS(783),
    [anon_sym_true] = ACTIONS(781),
    [anon_sym_false] = ACTIONS(781),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(781),
    [sym_super] = ACTIONS(781),
    [sym_crate] = ACTIONS(781),
    [sym_metavariable] = ACTIONS(783),
    [sym__raw_string_literal_start] = ACTIONS(783),
    [sym_float_literal] = ACTIONS(783),
  },
  [147] = {
    [sym_line_comment] = STATE(147),
    [sym_block_comment] = STATE(147),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_SEMI] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(787),
    [anon_sym_RPAREN] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(787),
    [anon_sym_RBRACK] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(787),
    [anon_sym_EQ_GT] = ACTIONS(787),
    [anon_sym_COLON] = ACTIONS(785),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_u8] = ACTIONS(785),
    [anon_sym_i8] = ACTIONS(785),
    [anon_sym_u16] = ACTIONS(785),
    [anon_sym_i16] = ACTIONS(785),
    [anon_sym_u32] = ACTIONS(785),
    [anon_sym_i32] = ACTIONS(785),
    [anon_sym_u64] = ACTIONS(785),
    [anon_sym_i64] = ACTIONS(785),
    [anon_sym_u128] = ACTIONS(785),
    [anon_sym_i128] = ACTIONS(785),
    [anon_sym_isize] = ACTIONS(785),
    [anon_sym_usize] = ACTIONS(785),
    [anon_sym_f32] = ACTIONS(785),
    [anon_sym_f64] = ACTIONS(785),
    [anon_sym_bool] = ACTIONS(785),
    [anon_sym_str] = ACTIONS(785),
    [anon_sym_char] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(785),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_PLUS_EQ] = ACTIONS(787),
    [anon_sym_DASH_EQ] = ACTIONS(787),
    [anon_sym_STAR_EQ] = ACTIONS(787),
    [anon_sym_SLASH_EQ] = ACTIONS(787),
    [anon_sym_PERCENT_EQ] = ACTIONS(787),
    [anon_sym_CARET_EQ] = ACTIONS(787),
    [anon_sym_AMP_EQ] = ACTIONS(787),
    [anon_sym_PIPE_EQ] = ACTIONS(787),
    [anon_sym_LT_LT_EQ] = ACTIONS(787),
    [anon_sym_GT_GT_EQ] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(787),
    [anon_sym_LT_EQ] = ACTIONS(787),
    [anon_sym_AT] = ACTIONS(787),
    [anon_sym__] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(787),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(787),
    [anon_sym_COMMA] = ACTIONS(787),
    [anon_sym_COLON_COLON] = ACTIONS(787),
    [anon_sym_DASH_GT] = ACTIONS(787),
    [anon_sym_POUND] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(785),
    [anon_sym_as] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_await] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_const] = ACTIONS(785),
    [anon_sym_continue] = ACTIONS(785),
    [anon_sym_default] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(785),
    [anon_sym_fn] = ACTIONS(785),
    [anon_sym_for] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(785),
    [anon_sym_impl] = ACTIONS(785),
    [anon_sym_let] = ACTIONS(785),
    [anon_sym_loop] = ACTIONS(785),
    [anon_sym_match] = ACTIONS(785),
    [anon_sym_mod] = ACTIONS(785),
    [anon_sym_pub] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(785),
    [anon_sym_static] = ACTIONS(785),
    [anon_sym_struct] = ACTIONS(785),
    [anon_sym_trait] = ACTIONS(785),
    [anon_sym_type] = ACTIONS(785),
    [anon_sym_union] = ACTIONS(785),
    [anon_sym_unsafe] = ACTIONS(785),
    [anon_sym_use] = ACTIONS(785),
    [anon_sym_where] = ACTIONS(785),
    [anon_sym_while] = ACTIONS(785),
    [sym_mutable_specifier] = ACTIONS(785),
    [sym_integer_literal] = ACTIONS(787),
    [aux_sym_string_literal_token1] = ACTIONS(787),
    [sym_char_literal] = ACTIONS(787),
    [anon_sym_true] = ACTIONS(785),
    [anon_sym_false] = ACTIONS(785),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(785),
    [sym_super] = ACTIONS(785),
    [sym_crate] = ACTIONS(785),
    [sym_metavariable] = ACTIONS(787),
    [sym__raw_string_literal_start] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(787),
  },
  [148] = {
    [sym_line_comment] = STATE(148),
    [sym_block_comment] = STATE(148),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(791),
    [anon_sym_RBRACK] = ACTIONS(791),
    [anon_sym_LBRACE] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_EQ_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(789),
    [anon_sym_DOLLAR] = ACTIONS(789),
    [anon_sym_PLUS] = ACTIONS(789),
    [anon_sym_STAR] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_u8] = ACTIONS(789),
    [anon_sym_i8] = ACTIONS(789),
    [anon_sym_u16] = ACTIONS(789),
    [anon_sym_i16] = ACTIONS(789),
    [anon_sym_u32] = ACTIONS(789),
    [anon_sym_i32] = ACTIONS(789),
    [anon_sym_u64] = ACTIONS(789),
    [anon_sym_i64] = ACTIONS(789),
    [anon_sym_u128] = ACTIONS(789),
    [anon_sym_i128] = ACTIONS(789),
    [anon_sym_isize] = ACTIONS(789),
    [anon_sym_usize] = ACTIONS(789),
    [anon_sym_f32] = ACTIONS(789),
    [anon_sym_f64] = ACTIONS(789),
    [anon_sym_bool] = ACTIONS(789),
    [anon_sym_str] = ACTIONS(789),
    [anon_sym_char] = ACTIONS(789),
    [anon_sym_DASH] = ACTIONS(789),
    [anon_sym_SLASH] = ACTIONS(789),
    [anon_sym_PERCENT] = ACTIONS(789),
    [anon_sym_CARET] = ACTIONS(789),
    [anon_sym_BANG] = ACTIONS(789),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(789),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_LT_LT] = ACTIONS(789),
    [anon_sym_GT_GT] = ACTIONS(789),
    [anon_sym_PLUS_EQ] = ACTIONS(791),
    [anon_sym_DASH_EQ] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(791),
    [anon_sym_SLASH_EQ] = ACTIONS(791),
    [anon_sym_PERCENT_EQ] = ACTIONS(791),
    [anon_sym_CARET_EQ] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(791),
    [anon_sym_PIPE_EQ] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ] = ACTIONS(789),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(789),
    [anon_sym_LT] = ACTIONS(789),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [anon_sym__] = ACTIONS(789),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_DOT_DOT] = ACTIONS(789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(791),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_COLON_COLON] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(791),
    [anon_sym_POUND] = ACTIONS(791),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [anon_sym_as] = ACTIONS(789),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_await] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(789),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_continue] = ACTIONS(789),
    [anon_sym_default] = ACTIONS(789),
    [anon_sym_enum] = ACTIONS(789),
    [anon_sym_fn] = ACTIONS(789),
    [anon_sym_for] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_impl] = ACTIONS(789),
    [anon_sym_let] = ACTIONS(789),
    [anon_sym_loop] = ACTIONS(789),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_mod] = ACTIONS(789),
    [anon_sym_pub] = ACTIONS(789),
    [anon_sym_return] = ACTIONS(789),
    [anon_sym_static] = ACTIONS(789),
    [anon_sym_struct] = ACTIONS(789),
    [anon_sym_trait] = ACTIONS(789),
    [anon_sym_type] = ACTIONS(789),
    [anon_sym_union] = ACTIONS(789),
    [anon_sym_unsafe] = ACTIONS(789),
    [anon_sym_use] = ACTIONS(789),
    [anon_sym_where] = ACTIONS(789),
    [anon_sym_while] = ACTIONS(789),
    [sym_mutable_specifier] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [aux_sym_string_literal_token1] = ACTIONS(791),
    [sym_char_literal] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(789),
    [anon_sym_false] = ACTIONS(789),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(789),
    [sym_super] = ACTIONS(789),
    [sym_crate] = ACTIONS(789),
    [sym_metavariable] = ACTIONS(791),
    [sym__raw_string_literal_start] = ACTIONS(791),
    [sym_float_literal] = ACTIONS(791),
  },
  [149] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1563),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(149),
    [sym_block_comment] = STATE(149),
    [aux_sym_enum_variant_list_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [150] = {
    [sym_line_comment] = STATE(150),
    [sym_block_comment] = STATE(150),
    [sym_identifier] = ACTIONS(797),
    [anon_sym_SEMI] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(799),
    [anon_sym_RBRACK] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(799),
    [anon_sym_COLON] = ACTIONS(797),
    [anon_sym_DOLLAR] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_u8] = ACTIONS(797),
    [anon_sym_i8] = ACTIONS(797),
    [anon_sym_u16] = ACTIONS(797),
    [anon_sym_i16] = ACTIONS(797),
    [anon_sym_u32] = ACTIONS(797),
    [anon_sym_i32] = ACTIONS(797),
    [anon_sym_u64] = ACTIONS(797),
    [anon_sym_i64] = ACTIONS(797),
    [anon_sym_u128] = ACTIONS(797),
    [anon_sym_i128] = ACTIONS(797),
    [anon_sym_isize] = ACTIONS(797),
    [anon_sym_usize] = ACTIONS(797),
    [anon_sym_f32] = ACTIONS(797),
    [anon_sym_f64] = ACTIONS(797),
    [anon_sym_bool] = ACTIONS(797),
    [anon_sym_str] = ACTIONS(797),
    [anon_sym_char] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(797),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(797),
    [anon_sym_BANG] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(797),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(799),
    [anon_sym_PIPE_PIPE] = ACTIONS(799),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_PLUS_EQ] = ACTIONS(799),
    [anon_sym_DASH_EQ] = ACTIONS(799),
    [anon_sym_STAR_EQ] = ACTIONS(799),
    [anon_sym_SLASH_EQ] = ACTIONS(799),
    [anon_sym_PERCENT_EQ] = ACTIONS(799),
    [anon_sym_CARET_EQ] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(799),
    [anon_sym_PIPE_EQ] = ACTIONS(799),
    [anon_sym_LT_LT_EQ] = ACTIONS(799),
    [anon_sym_GT_GT_EQ] = ACTIONS(799),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(799),
    [anon_sym_BANG_EQ] = ACTIONS(799),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT_EQ] = ACTIONS(799),
    [anon_sym_LT_EQ] = ACTIONS(799),
    [anon_sym_AT] = ACTIONS(799),
    [anon_sym__] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_DOT_DOT] = ACTIONS(797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(799),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(799),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(799),
    [anon_sym_POUND] = ACTIONS(799),
    [anon_sym_SQUOTE] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(797),
    [anon_sym_await] = ACTIONS(797),
    [anon_sym_break] = ACTIONS(797),
    [anon_sym_const] = ACTIONS(797),
    [anon_sym_continue] = ACTIONS(797),
    [anon_sym_default] = ACTIONS(797),
    [anon_sym_enum] = ACTIONS(797),
    [anon_sym_fn] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_if] = ACTIONS(797),
    [anon_sym_impl] = ACTIONS(797),
    [anon_sym_let] = ACTIONS(797),
    [anon_sym_loop] = ACTIONS(797),
    [anon_sym_match] = ACTIONS(797),
    [anon_sym_mod] = ACTIONS(797),
    [anon_sym_pub] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(797),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_struct] = ACTIONS(797),
    [anon_sym_trait] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_union] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(797),
    [anon_sym_use] = ACTIONS(797),
    [anon_sym_where] = ACTIONS(797),
    [anon_sym_while] = ACTIONS(797),
    [sym_mutable_specifier] = ACTIONS(797),
    [sym_integer_literal] = ACTIONS(799),
    [aux_sym_string_literal_token1] = ACTIONS(799),
    [sym_char_literal] = ACTIONS(799),
    [anon_sym_true] = ACTIONS(797),
    [anon_sym_false] = ACTIONS(797),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(797),
    [sym_super] = ACTIONS(797),
    [sym_crate] = ACTIONS(797),
    [sym_metavariable] = ACTIONS(799),
    [sym__raw_string_literal_start] = ACTIONS(799),
    [sym_float_literal] = ACTIONS(799),
  },
  [151] = {
    [sym_line_comment] = STATE(151),
    [sym_block_comment] = STATE(151),
    [sym_identifier] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(803),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(803),
    [anon_sym_RBRACK] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(803),
    [anon_sym_RBRACE] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(801),
    [anon_sym_DOLLAR] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_u8] = ACTIONS(801),
    [anon_sym_i8] = ACTIONS(801),
    [anon_sym_u16] = ACTIONS(801),
    [anon_sym_i16] = ACTIONS(801),
    [anon_sym_u32] = ACTIONS(801),
    [anon_sym_i32] = ACTIONS(801),
    [anon_sym_u64] = ACTIONS(801),
    [anon_sym_i64] = ACTIONS(801),
    [anon_sym_u128] = ACTIONS(801),
    [anon_sym_i128] = ACTIONS(801),
    [anon_sym_isize] = ACTIONS(801),
    [anon_sym_usize] = ACTIONS(801),
    [anon_sym_f32] = ACTIONS(801),
    [anon_sym_f64] = ACTIONS(801),
    [anon_sym_bool] = ACTIONS(801),
    [anon_sym_str] = ACTIONS(801),
    [anon_sym_char] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_SLASH] = ACTIONS(801),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ] = ACTIONS(801),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(801),
    [anon_sym_LT] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [anon_sym__] = ACTIONS(801),
    [anon_sym_DOT] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(803),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(803),
    [anon_sym_COMMA] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(803),
    [anon_sym_POUND] = ACTIONS(803),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_as] = ACTIONS(801),
    [anon_sym_async] = ACTIONS(801),
    [anon_sym_await] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(801),
    [anon_sym_const] = ACTIONS(801),
    [anon_sym_continue] = ACTIONS(801),
    [anon_sym_default] = ACTIONS(801),
    [anon_sym_enum] = ACTIONS(801),
    [anon_sym_fn] = ACTIONS(801),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_if] = ACTIONS(801),
    [anon_sym_impl] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_loop] = ACTIONS(801),
    [anon_sym_match] = ACTIONS(801),
    [anon_sym_mod] = ACTIONS(801),
    [anon_sym_pub] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(801),
    [anon_sym_struct] = ACTIONS(801),
    [anon_sym_trait] = ACTIONS(801),
    [anon_sym_type] = ACTIONS(801),
    [anon_sym_union] = ACTIONS(801),
    [anon_sym_unsafe] = ACTIONS(801),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_while] = ACTIONS(801),
    [sym_mutable_specifier] = ACTIONS(801),
    [sym_integer_literal] = ACTIONS(803),
    [aux_sym_string_literal_token1] = ACTIONS(803),
    [sym_char_literal] = ACTIONS(803),
    [anon_sym_true] = ACTIONS(801),
    [anon_sym_false] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(801),
    [sym_super] = ACTIONS(801),
    [sym_crate] = ACTIONS(801),
    [sym_metavariable] = ACTIONS(803),
    [sym__raw_string_literal_start] = ACTIONS(803),
    [sym_float_literal] = ACTIONS(803),
  },
  [152] = {
    [sym_line_comment] = STATE(152),
    [sym_block_comment] = STATE(152),
    [sym_identifier] = ACTIONS(805),
    [anon_sym_SEMI] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_RBRACK] = ACTIONS(807),
    [anon_sym_LBRACE] = ACTIONS(807),
    [anon_sym_RBRACE] = ACTIONS(807),
    [anon_sym_EQ_GT] = ACTIONS(807),
    [anon_sym_COLON] = ACTIONS(805),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_STAR] = ACTIONS(805),
    [anon_sym_QMARK] = ACTIONS(807),
    [anon_sym_u8] = ACTIONS(805),
    [anon_sym_i8] = ACTIONS(805),
    [anon_sym_u16] = ACTIONS(805),
    [anon_sym_i16] = ACTIONS(805),
    [anon_sym_u32] = ACTIONS(805),
    [anon_sym_i32] = ACTIONS(805),
    [anon_sym_u64] = ACTIONS(805),
    [anon_sym_i64] = ACTIONS(805),
    [anon_sym_u128] = ACTIONS(805),
    [anon_sym_i128] = ACTIONS(805),
    [anon_sym_isize] = ACTIONS(805),
    [anon_sym_usize] = ACTIONS(805),
    [anon_sym_f32] = ACTIONS(805),
    [anon_sym_f64] = ACTIONS(805),
    [anon_sym_bool] = ACTIONS(805),
    [anon_sym_str] = ACTIONS(805),
    [anon_sym_char] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(805),
    [anon_sym_PERCENT] = ACTIONS(805),
    [anon_sym_CARET] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_AMP] = ACTIONS(805),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_LT_LT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(807),
    [anon_sym_DASH_EQ] = ACTIONS(807),
    [anon_sym_STAR_EQ] = ACTIONS(807),
    [anon_sym_SLASH_EQ] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(807),
    [anon_sym_CARET_EQ] = ACTIONS(807),
    [anon_sym_AMP_EQ] = ACTIONS(807),
    [anon_sym_PIPE_EQ] = ACTIONS(807),
    [anon_sym_LT_LT_EQ] = ACTIONS(807),
    [anon_sym_GT_GT_EQ] = ACTIONS(807),
    [anon_sym_EQ] = ACTIONS(805),
    [anon_sym_EQ_EQ] = ACTIONS(807),
    [anon_sym_BANG_EQ] = ACTIONS(807),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_GT_EQ] = ACTIONS(807),
    [anon_sym_LT_EQ] = ACTIONS(807),
    [anon_sym_AT] = ACTIONS(807),
    [anon_sym__] = ACTIONS(805),
    [anon_sym_DOT] = ACTIONS(805),
    [anon_sym_DOT_DOT] = ACTIONS(805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(807),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(807),
    [anon_sym_COMMA] = ACTIONS(807),
    [anon_sym_COLON_COLON] = ACTIONS(807),
    [anon_sym_DASH_GT] = ACTIONS(807),
    [anon_sym_POUND] = ACTIONS(807),
    [anon_sym_SQUOTE] = ACTIONS(805),
    [anon_sym_as] = ACTIONS(805),
    [anon_sym_async] = ACTIONS(805),
    [anon_sym_await] = ACTIONS(805),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_const] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_default] = ACTIONS(805),
    [anon_sym_enum] = ACTIONS(805),
    [anon_sym_fn] = ACTIONS(805),
    [anon_sym_for] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(805),
    [anon_sym_impl] = ACTIONS(805),
    [anon_sym_let] = ACTIONS(805),
    [anon_sym_loop] = ACTIONS(805),
    [anon_sym_match] = ACTIONS(805),
    [anon_sym_mod] = ACTIONS(805),
    [anon_sym_pub] = ACTIONS(805),
    [anon_sym_return] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_struct] = ACTIONS(805),
    [anon_sym_trait] = ACTIONS(805),
    [anon_sym_type] = ACTIONS(805),
    [anon_sym_union] = ACTIONS(805),
    [anon_sym_unsafe] = ACTIONS(805),
    [anon_sym_use] = ACTIONS(805),
    [anon_sym_where] = ACTIONS(805),
    [anon_sym_while] = ACTIONS(805),
    [sym_mutable_specifier] = ACTIONS(805),
    [sym_integer_literal] = ACTIONS(807),
    [aux_sym_string_literal_token1] = ACTIONS(807),
    [sym_char_literal] = ACTIONS(807),
    [anon_sym_true] = ACTIONS(805),
    [anon_sym_false] = ACTIONS(805),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(805),
    [sym_crate] = ACTIONS(805),
    [sym_metavariable] = ACTIONS(807),
    [sym__raw_string_literal_start] = ACTIONS(807),
    [sym_float_literal] = ACTIONS(807),
  },
  [153] = {
    [sym_line_comment] = STATE(153),
    [sym_block_comment] = STATE(153),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_SEMI] = ACTIONS(811),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(811),
    [anon_sym_RBRACE] = ACTIONS(811),
    [anon_sym_EQ_GT] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(809),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(809),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_u8] = ACTIONS(809),
    [anon_sym_i8] = ACTIONS(809),
    [anon_sym_u16] = ACTIONS(809),
    [anon_sym_i16] = ACTIONS(809),
    [anon_sym_u32] = ACTIONS(809),
    [anon_sym_i32] = ACTIONS(809),
    [anon_sym_u64] = ACTIONS(809),
    [anon_sym_i64] = ACTIONS(809),
    [anon_sym_u128] = ACTIONS(809),
    [anon_sym_i128] = ACTIONS(809),
    [anon_sym_isize] = ACTIONS(809),
    [anon_sym_usize] = ACTIONS(809),
    [anon_sym_f32] = ACTIONS(809),
    [anon_sym_f64] = ACTIONS(809),
    [anon_sym_bool] = ACTIONS(809),
    [anon_sym_str] = ACTIONS(809),
    [anon_sym_char] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_SLASH] = ACTIONS(809),
    [anon_sym_PERCENT] = ACTIONS(809),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_AMP] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_LT_LT] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(809),
    [anon_sym_PLUS_EQ] = ACTIONS(811),
    [anon_sym_DASH_EQ] = ACTIONS(811),
    [anon_sym_STAR_EQ] = ACTIONS(811),
    [anon_sym_SLASH_EQ] = ACTIONS(811),
    [anon_sym_PERCENT_EQ] = ACTIONS(811),
    [anon_sym_CARET_EQ] = ACTIONS(811),
    [anon_sym_AMP_EQ] = ACTIONS(811),
    [anon_sym_PIPE_EQ] = ACTIONS(811),
    [anon_sym_LT_LT_EQ] = ACTIONS(811),
    [anon_sym_GT_GT_EQ] = ACTIONS(811),
    [anon_sym_EQ] = ACTIONS(809),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(809),
    [anon_sym_LT] = ACTIONS(809),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(811),
    [anon_sym__] = ACTIONS(809),
    [anon_sym_DOT] = ACTIONS(809),
    [anon_sym_DOT_DOT] = ACTIONS(809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(811),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(811),
    [anon_sym_COMMA] = ACTIONS(811),
    [anon_sym_COLON_COLON] = ACTIONS(811),
    [anon_sym_DASH_GT] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(811),
    [anon_sym_SQUOTE] = ACTIONS(809),
    [anon_sym_as] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_break] = ACTIONS(809),
    [anon_sym_const] = ACTIONS(809),
    [anon_sym_continue] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(809),
    [anon_sym_enum] = ACTIONS(809),
    [anon_sym_fn] = ACTIONS(809),
    [anon_sym_for] = ACTIONS(809),
    [anon_sym_if] = ACTIONS(809),
    [anon_sym_impl] = ACTIONS(809),
    [anon_sym_let] = ACTIONS(809),
    [anon_sym_loop] = ACTIONS(809),
    [anon_sym_match] = ACTIONS(809),
    [anon_sym_mod] = ACTIONS(809),
    [anon_sym_pub] = ACTIONS(809),
    [anon_sym_return] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_struct] = ACTIONS(809),
    [anon_sym_trait] = ACTIONS(809),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_union] = ACTIONS(809),
    [anon_sym_unsafe] = ACTIONS(809),
    [anon_sym_use] = ACTIONS(809),
    [anon_sym_where] = ACTIONS(809),
    [anon_sym_while] = ACTIONS(809),
    [sym_mutable_specifier] = ACTIONS(809),
    [sym_integer_literal] = ACTIONS(811),
    [aux_sym_string_literal_token1] = ACTIONS(811),
    [sym_char_literal] = ACTIONS(811),
    [anon_sym_true] = ACTIONS(809),
    [anon_sym_false] = ACTIONS(809),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(809),
    [sym_super] = ACTIONS(809),
    [sym_crate] = ACTIONS(809),
    [sym_metavariable] = ACTIONS(811),
    [sym__raw_string_literal_start] = ACTIONS(811),
    [sym_float_literal] = ACTIONS(811),
  },
  [154] = {
    [sym_line_comment] = STATE(154),
    [sym_block_comment] = STATE(154),
    [aux_sym__non_special_token_repeat1] = STATE(156),
    [sym_identifier] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(815),
    [anon_sym_RPAREN] = ACTIONS(815),
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_RBRACK] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_EQ_GT] = ACTIONS(677),
    [anon_sym_COLON] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_u8] = ACTIONS(813),
    [anon_sym_i8] = ACTIONS(813),
    [anon_sym_u16] = ACTIONS(813),
    [anon_sym_i16] = ACTIONS(813),
    [anon_sym_u32] = ACTIONS(813),
    [anon_sym_i32] = ACTIONS(813),
    [anon_sym_u64] = ACTIONS(813),
    [anon_sym_i64] = ACTIONS(813),
    [anon_sym_u128] = ACTIONS(813),
    [anon_sym_i128] = ACTIONS(813),
    [anon_sym_isize] = ACTIONS(813),
    [anon_sym_usize] = ACTIONS(813),
    [anon_sym_f32] = ACTIONS(813),
    [anon_sym_f64] = ACTIONS(813),
    [anon_sym_bool] = ACTIONS(813),
    [anon_sym_str] = ACTIONS(813),
    [anon_sym_char] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_DASH_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_CARET_EQ] = ACTIONS(677),
    [anon_sym_AMP_EQ] = ACTIONS(677),
    [anon_sym_PIPE_EQ] = ACTIONS(677),
    [anon_sym_LT_LT_EQ] = ACTIONS(677),
    [anon_sym_GT_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DASH_GT] = ACTIONS(677),
    [anon_sym_POUND] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(813),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_async] = ACTIONS(813),
    [anon_sym_await] = ACTIONS(813),
    [anon_sym_break] = ACTIONS(813),
    [anon_sym_const] = ACTIONS(813),
    [anon_sym_continue] = ACTIONS(813),
    [anon_sym_default] = ACTIONS(813),
    [anon_sym_enum] = ACTIONS(813),
    [anon_sym_fn] = ACTIONS(813),
    [anon_sym_for] = ACTIONS(813),
    [anon_sym_if] = ACTIONS(813),
    [anon_sym_impl] = ACTIONS(813),
    [anon_sym_let] = ACTIONS(813),
    [anon_sym_loop] = ACTIONS(813),
    [anon_sym_match] = ACTIONS(813),
    [anon_sym_mod] = ACTIONS(813),
    [anon_sym_pub] = ACTIONS(813),
    [anon_sym_return] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(813),
    [anon_sym_struct] = ACTIONS(813),
    [anon_sym_trait] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(813),
    [anon_sym_union] = ACTIONS(813),
    [anon_sym_unsafe] = ACTIONS(813),
    [anon_sym_use] = ACTIONS(813),
    [anon_sym_where] = ACTIONS(813),
    [anon_sym_while] = ACTIONS(813),
    [sym_mutable_specifier] = ACTIONS(813),
    [sym_integer_literal] = ACTIONS(815),
    [aux_sym_string_literal_token1] = ACTIONS(815),
    [sym_char_literal] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(813),
    [anon_sym_false] = ACTIONS(813),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(813),
    [sym_super] = ACTIONS(813),
    [sym_crate] = ACTIONS(813),
    [sym__raw_string_literal_start] = ACTIONS(815),
    [sym_float_literal] = ACTIONS(815),
  },
  [155] = {
    [sym_line_comment] = STATE(155),
    [sym_block_comment] = STATE(155),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(819),
    [anon_sym_LBRACK] = ACTIONS(819),
    [anon_sym_RBRACK] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(819),
    [anon_sym_EQ_GT] = ACTIONS(819),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(817),
    [anon_sym_STAR] = ACTIONS(817),
    [anon_sym_QMARK] = ACTIONS(819),
    [anon_sym_u8] = ACTIONS(817),
    [anon_sym_i8] = ACTIONS(817),
    [anon_sym_u16] = ACTIONS(817),
    [anon_sym_i16] = ACTIONS(817),
    [anon_sym_u32] = ACTIONS(817),
    [anon_sym_i32] = ACTIONS(817),
    [anon_sym_u64] = ACTIONS(817),
    [anon_sym_i64] = ACTIONS(817),
    [anon_sym_u128] = ACTIONS(817),
    [anon_sym_i128] = ACTIONS(817),
    [anon_sym_isize] = ACTIONS(817),
    [anon_sym_usize] = ACTIONS(817),
    [anon_sym_f32] = ACTIONS(817),
    [anon_sym_f64] = ACTIONS(817),
    [anon_sym_bool] = ACTIONS(817),
    [anon_sym_str] = ACTIONS(817),
    [anon_sym_char] = ACTIONS(817),
    [anon_sym_DASH] = ACTIONS(817),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_PERCENT] = ACTIONS(817),
    [anon_sym_CARET] = ACTIONS(817),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(819),
    [anon_sym_LT_LT] = ACTIONS(817),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_PLUS_EQ] = ACTIONS(819),
    [anon_sym_DASH_EQ] = ACTIONS(819),
    [anon_sym_STAR_EQ] = ACTIONS(819),
    [anon_sym_SLASH_EQ] = ACTIONS(819),
    [anon_sym_PERCENT_EQ] = ACTIONS(819),
    [anon_sym_CARET_EQ] = ACTIONS(819),
    [anon_sym_AMP_EQ] = ACTIONS(819),
    [anon_sym_PIPE_EQ] = ACTIONS(819),
    [anon_sym_LT_LT_EQ] = ACTIONS(819),
    [anon_sym_GT_GT_EQ] = ACTIONS(819),
    [anon_sym_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(819),
    [anon_sym_BANG_EQ] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(819),
    [anon_sym_LT_EQ] = ACTIONS(819),
    [anon_sym_AT] = ACTIONS(819),
    [anon_sym__] = ACTIONS(817),
    [anon_sym_DOT] = ACTIONS(817),
    [anon_sym_DOT_DOT] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(819),
    [anon_sym_COLON_COLON] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(819),
    [anon_sym_POUND] = ACTIONS(819),
    [anon_sym_SQUOTE] = ACTIONS(817),
    [anon_sym_as] = ACTIONS(817),
    [anon_sym_async] = ACTIONS(817),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_break] = ACTIONS(817),
    [anon_sym_const] = ACTIONS(817),
    [anon_sym_continue] = ACTIONS(817),
    [anon_sym_default] = ACTIONS(817),
    [anon_sym_enum] = ACTIONS(817),
    [anon_sym_fn] = ACTIONS(817),
    [anon_sym_for] = ACTIONS(817),
    [anon_sym_if] = ACTIONS(817),
    [anon_sym_impl] = ACTIONS(817),
    [anon_sym_let] = ACTIONS(817),
    [anon_sym_loop] = ACTIONS(817),
    [anon_sym_match] = ACTIONS(817),
    [anon_sym_mod] = ACTIONS(817),
    [anon_sym_pub] = ACTIONS(817),
    [anon_sym_return] = ACTIONS(817),
    [anon_sym_static] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(817),
    [anon_sym_trait] = ACTIONS(817),
    [anon_sym_type] = ACTIONS(817),
    [anon_sym_union] = ACTIONS(817),
    [anon_sym_unsafe] = ACTIONS(817),
    [anon_sym_use] = ACTIONS(817),
    [anon_sym_where] = ACTIONS(817),
    [anon_sym_while] = ACTIONS(817),
    [sym_mutable_specifier] = ACTIONS(817),
    [sym_integer_literal] = ACTIONS(819),
    [aux_sym_string_literal_token1] = ACTIONS(819),
    [sym_char_literal] = ACTIONS(819),
    [anon_sym_true] = ACTIONS(817),
    [anon_sym_false] = ACTIONS(817),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(817),
    [sym_super] = ACTIONS(817),
    [sym_crate] = ACTIONS(817),
    [sym_metavariable] = ACTIONS(819),
    [sym__raw_string_literal_start] = ACTIONS(819),
    [sym_float_literal] = ACTIONS(819),
  },
  [156] = {
    [sym_line_comment] = STATE(156),
    [sym_block_comment] = STATE(156),
    [aux_sym__non_special_token_repeat1] = STATE(156),
    [sym_identifier] = ACTIONS(739),
    [anon_sym_SEMI] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(744),
    [anon_sym_RPAREN] = ACTIONS(744),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_RBRACK] = ACTIONS(744),
    [anon_sym_LBRACE] = ACTIONS(744),
    [anon_sym_RBRACE] = ACTIONS(744),
    [anon_sym_EQ_GT] = ACTIONS(821),
    [anon_sym_COLON] = ACTIONS(824),
    [anon_sym_DOLLAR] = ACTIONS(744),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_STAR] = ACTIONS(824),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_u8] = ACTIONS(739),
    [anon_sym_i8] = ACTIONS(739),
    [anon_sym_u16] = ACTIONS(739),
    [anon_sym_i16] = ACTIONS(739),
    [anon_sym_u32] = ACTIONS(739),
    [anon_sym_i32] = ACTIONS(739),
    [anon_sym_u64] = ACTIONS(739),
    [anon_sym_i64] = ACTIONS(739),
    [anon_sym_u128] = ACTIONS(739),
    [anon_sym_i128] = ACTIONS(739),
    [anon_sym_isize] = ACTIONS(739),
    [anon_sym_usize] = ACTIONS(739),
    [anon_sym_f32] = ACTIONS(739),
    [anon_sym_f64] = ACTIONS(739),
    [anon_sym_bool] = ACTIONS(739),
    [anon_sym_str] = ACTIONS(739),
    [anon_sym_char] = ACTIONS(739),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_SLASH] = ACTIONS(824),
    [anon_sym_PERCENT] = ACTIONS(824),
    [anon_sym_CARET] = ACTIONS(824),
    [anon_sym_BANG] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(824),
    [anon_sym_PIPE] = ACTIONS(824),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(824),
    [anon_sym_GT_GT] = ACTIONS(824),
    [anon_sym_PLUS_EQ] = ACTIONS(821),
    [anon_sym_DASH_EQ] = ACTIONS(821),
    [anon_sym_STAR_EQ] = ACTIONS(821),
    [anon_sym_SLASH_EQ] = ACTIONS(821),
    [anon_sym_PERCENT_EQ] = ACTIONS(821),
    [anon_sym_CARET_EQ] = ACTIONS(821),
    [anon_sym_AMP_EQ] = ACTIONS(821),
    [anon_sym_PIPE_EQ] = ACTIONS(821),
    [anon_sym_LT_LT_EQ] = ACTIONS(821),
    [anon_sym_GT_GT_EQ] = ACTIONS(821),
    [anon_sym_EQ] = ACTIONS(824),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_GT] = ACTIONS(824),
    [anon_sym_LT] = ACTIONS(824),
    [anon_sym_GT_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(821),
    [anon_sym__] = ACTIONS(824),
    [anon_sym_DOT] = ACTIONS(824),
    [anon_sym_DOT_DOT] = ACTIONS(824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(821),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(821),
    [anon_sym_COLON_COLON] = ACTIONS(821),
    [anon_sym_DASH_GT] = ACTIONS(821),
    [anon_sym_POUND] = ACTIONS(821),
    [anon_sym_SQUOTE] = ACTIONS(739),
    [anon_sym_as] = ACTIONS(739),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_await] = ACTIONS(739),
    [anon_sym_break] = ACTIONS(739),
    [anon_sym_const] = ACTIONS(739),
    [anon_sym_continue] = ACTIONS(739),
    [anon_sym_default] = ACTIONS(739),
    [anon_sym_enum] = ACTIONS(739),
    [anon_sym_fn] = ACTIONS(739),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_if] = ACTIONS(739),
    [anon_sym_impl] = ACTIONS(739),
    [anon_sym_let] = ACTIONS(739),
    [anon_sym_loop] = ACTIONS(739),
    [anon_sym_match] = ACTIONS(739),
    [anon_sym_mod] = ACTIONS(739),
    [anon_sym_pub] = ACTIONS(739),
    [anon_sym_return] = ACTIONS(739),
    [anon_sym_static] = ACTIONS(739),
    [anon_sym_struct] = ACTIONS(739),
    [anon_sym_trait] = ACTIONS(739),
    [anon_sym_type] = ACTIONS(739),
    [anon_sym_union] = ACTIONS(739),
    [anon_sym_unsafe] = ACTIONS(739),
    [anon_sym_use] = ACTIONS(739),
    [anon_sym_where] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(739),
    [sym_mutable_specifier] = ACTIONS(739),
    [sym_integer_literal] = ACTIONS(744),
    [aux_sym_string_literal_token1] = ACTIONS(744),
    [sym_char_literal] = ACTIONS(744),
    [anon_sym_true] = ACTIONS(739),
    [anon_sym_false] = ACTIONS(739),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_crate] = ACTIONS(739),
    [sym__raw_string_literal_start] = ACTIONS(744),
    [sym_float_literal] = ACTIONS(744),
  },
  [157] = {
    [sym_line_comment] = STATE(157),
    [sym_block_comment] = STATE(157),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_SEMI] = ACTIONS(829),
    [anon_sym_LPAREN] = ACTIONS(829),
    [anon_sym_RPAREN] = ACTIONS(829),
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_RBRACK] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(829),
    [anon_sym_RBRACE] = ACTIONS(829),
    [anon_sym_EQ_GT] = ACTIONS(829),
    [anon_sym_COLON] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(827),
    [anon_sym_QMARK] = ACTIONS(829),
    [anon_sym_u8] = ACTIONS(827),
    [anon_sym_i8] = ACTIONS(827),
    [anon_sym_u16] = ACTIONS(827),
    [anon_sym_i16] = ACTIONS(827),
    [anon_sym_u32] = ACTIONS(827),
    [anon_sym_i32] = ACTIONS(827),
    [anon_sym_u64] = ACTIONS(827),
    [anon_sym_i64] = ACTIONS(827),
    [anon_sym_u128] = ACTIONS(827),
    [anon_sym_i128] = ACTIONS(827),
    [anon_sym_isize] = ACTIONS(827),
    [anon_sym_usize] = ACTIONS(827),
    [anon_sym_f32] = ACTIONS(827),
    [anon_sym_f64] = ACTIONS(827),
    [anon_sym_bool] = ACTIONS(827),
    [anon_sym_str] = ACTIONS(827),
    [anon_sym_char] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_SLASH] = ACTIONS(827),
    [anon_sym_PERCENT] = ACTIONS(827),
    [anon_sym_CARET] = ACTIONS(827),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_AMP] = ACTIONS(827),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_AMP_AMP] = ACTIONS(829),
    [anon_sym_PIPE_PIPE] = ACTIONS(829),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(827),
    [anon_sym_PLUS_EQ] = ACTIONS(829),
    [anon_sym_DASH_EQ] = ACTIONS(829),
    [anon_sym_STAR_EQ] = ACTIONS(829),
    [anon_sym_SLASH_EQ] = ACTIONS(829),
    [anon_sym_PERCENT_EQ] = ACTIONS(829),
    [anon_sym_CARET_EQ] = ACTIONS(829),
    [anon_sym_AMP_EQ] = ACTIONS(829),
    [anon_sym_PIPE_EQ] = ACTIONS(829),
    [anon_sym_LT_LT_EQ] = ACTIONS(829),
    [anon_sym_GT_GT_EQ] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(827),
    [anon_sym_EQ_EQ] = ACTIONS(829),
    [anon_sym_BANG_EQ] = ACTIONS(829),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT_EQ] = ACTIONS(829),
    [anon_sym_LT_EQ] = ACTIONS(829),
    [anon_sym_AT] = ACTIONS(829),
    [anon_sym__] = ACTIONS(827),
    [anon_sym_DOT] = ACTIONS(827),
    [anon_sym_DOT_DOT] = ACTIONS(827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(829),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(829),
    [anon_sym_COMMA] = ACTIONS(829),
    [anon_sym_COLON_COLON] = ACTIONS(829),
    [anon_sym_DASH_GT] = ACTIONS(829),
    [anon_sym_POUND] = ACTIONS(829),
    [anon_sym_SQUOTE] = ACTIONS(827),
    [anon_sym_as] = ACTIONS(827),
    [anon_sym_async] = ACTIONS(827),
    [anon_sym_await] = ACTIONS(827),
    [anon_sym_break] = ACTIONS(827),
    [anon_sym_const] = ACTIONS(827),
    [anon_sym_continue] = ACTIONS(827),
    [anon_sym_default] = ACTIONS(827),
    [anon_sym_enum] = ACTIONS(827),
    [anon_sym_fn] = ACTIONS(827),
    [anon_sym_for] = ACTIONS(827),
    [anon_sym_if] = ACTIONS(827),
    [anon_sym_impl] = ACTIONS(827),
    [anon_sym_let] = ACTIONS(827),
    [anon_sym_loop] = ACTIONS(827),
    [anon_sym_match] = ACTIONS(827),
    [anon_sym_mod] = ACTIONS(827),
    [anon_sym_pub] = ACTIONS(827),
    [anon_sym_return] = ACTIONS(827),
    [anon_sym_static] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(827),
    [anon_sym_trait] = ACTIONS(827),
    [anon_sym_type] = ACTIONS(827),
    [anon_sym_union] = ACTIONS(827),
    [anon_sym_unsafe] = ACTIONS(827),
    [anon_sym_use] = ACTIONS(827),
    [anon_sym_where] = ACTIONS(827),
    [anon_sym_while] = ACTIONS(827),
    [sym_mutable_specifier] = ACTIONS(827),
    [sym_integer_literal] = ACTIONS(829),
    [aux_sym_string_literal_token1] = ACTIONS(829),
    [sym_char_literal] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(827),
    [anon_sym_false] = ACTIONS(827),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(827),
    [sym_super] = ACTIONS(827),
    [sym_crate] = ACTIONS(827),
    [sym_metavariable] = ACTIONS(829),
    [sym__raw_string_literal_start] = ACTIONS(829),
    [sym_float_literal] = ACTIONS(829),
  },
  [158] = {
    [sym_line_comment] = STATE(158),
    [sym_block_comment] = STATE(158),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_SEMI] = ACTIONS(833),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(833),
    [anon_sym_RBRACK] = ACTIONS(833),
    [anon_sym_LBRACE] = ACTIONS(833),
    [anon_sym_RBRACE] = ACTIONS(833),
    [anon_sym_EQ_GT] = ACTIONS(833),
    [anon_sym_COLON] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_STAR] = ACTIONS(831),
    [anon_sym_QMARK] = ACTIONS(833),
    [anon_sym_u8] = ACTIONS(831),
    [anon_sym_i8] = ACTIONS(831),
    [anon_sym_u16] = ACTIONS(831),
    [anon_sym_i16] = ACTIONS(831),
    [anon_sym_u32] = ACTIONS(831),
    [anon_sym_i32] = ACTIONS(831),
    [anon_sym_u64] = ACTIONS(831),
    [anon_sym_i64] = ACTIONS(831),
    [anon_sym_u128] = ACTIONS(831),
    [anon_sym_i128] = ACTIONS(831),
    [anon_sym_isize] = ACTIONS(831),
    [anon_sym_usize] = ACTIONS(831),
    [anon_sym_f32] = ACTIONS(831),
    [anon_sym_f64] = ACTIONS(831),
    [anon_sym_bool] = ACTIONS(831),
    [anon_sym_str] = ACTIONS(831),
    [anon_sym_char] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_SLASH] = ACTIONS(831),
    [anon_sym_PERCENT] = ACTIONS(831),
    [anon_sym_CARET] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(833),
    [anon_sym_PIPE_PIPE] = ACTIONS(833),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_GT_GT] = ACTIONS(831),
    [anon_sym_PLUS_EQ] = ACTIONS(833),
    [anon_sym_DASH_EQ] = ACTIONS(833),
    [anon_sym_STAR_EQ] = ACTIONS(833),
    [anon_sym_SLASH_EQ] = ACTIONS(833),
    [anon_sym_PERCENT_EQ] = ACTIONS(833),
    [anon_sym_CARET_EQ] = ACTIONS(833),
    [anon_sym_AMP_EQ] = ACTIONS(833),
    [anon_sym_PIPE_EQ] = ACTIONS(833),
    [anon_sym_LT_LT_EQ] = ACTIONS(833),
    [anon_sym_GT_GT_EQ] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_GT] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(831),
    [anon_sym_GT_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(833),
    [anon_sym_AT] = ACTIONS(833),
    [anon_sym__] = ACTIONS(831),
    [anon_sym_DOT] = ACTIONS(831),
    [anon_sym_DOT_DOT] = ACTIONS(831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(833),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(833),
    [anon_sym_COLON_COLON] = ACTIONS(833),
    [anon_sym_DASH_GT] = ACTIONS(833),
    [anon_sym_POUND] = ACTIONS(833),
    [anon_sym_SQUOTE] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(831),
    [anon_sym_async] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(831),
    [anon_sym_break] = ACTIONS(831),
    [anon_sym_const] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_default] = ACTIONS(831),
    [anon_sym_enum] = ACTIONS(831),
    [anon_sym_fn] = ACTIONS(831),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(831),
    [anon_sym_impl] = ACTIONS(831),
    [anon_sym_let] = ACTIONS(831),
    [anon_sym_loop] = ACTIONS(831),
    [anon_sym_match] = ACTIONS(831),
    [anon_sym_mod] = ACTIONS(831),
    [anon_sym_pub] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_static] = ACTIONS(831),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_trait] = ACTIONS(831),
    [anon_sym_type] = ACTIONS(831),
    [anon_sym_union] = ACTIONS(831),
    [anon_sym_unsafe] = ACTIONS(831),
    [anon_sym_use] = ACTIONS(831),
    [anon_sym_where] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [sym_mutable_specifier] = ACTIONS(831),
    [sym_integer_literal] = ACTIONS(833),
    [aux_sym_string_literal_token1] = ACTIONS(833),
    [sym_char_literal] = ACTIONS(833),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(831),
    [sym_super] = ACTIONS(831),
    [sym_crate] = ACTIONS(831),
    [sym_metavariable] = ACTIONS(833),
    [sym__raw_string_literal_start] = ACTIONS(833),
    [sym_float_literal] = ACTIONS(833),
  },
  [159] = {
    [sym_line_comment] = STATE(159),
    [sym_block_comment] = STATE(159),
    [sym_identifier] = ACTIONS(835),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(837),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_RBRACK] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_EQ_GT] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(835),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_STAR] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_u8] = ACTIONS(835),
    [anon_sym_i8] = ACTIONS(835),
    [anon_sym_u16] = ACTIONS(835),
    [anon_sym_i16] = ACTIONS(835),
    [anon_sym_u32] = ACTIONS(835),
    [anon_sym_i32] = ACTIONS(835),
    [anon_sym_u64] = ACTIONS(835),
    [anon_sym_i64] = ACTIONS(835),
    [anon_sym_u128] = ACTIONS(835),
    [anon_sym_i128] = ACTIONS(835),
    [anon_sym_isize] = ACTIONS(835),
    [anon_sym_usize] = ACTIONS(835),
    [anon_sym_f32] = ACTIONS(835),
    [anon_sym_f64] = ACTIONS(835),
    [anon_sym_bool] = ACTIONS(835),
    [anon_sym_str] = ACTIONS(835),
    [anon_sym_char] = ACTIONS(835),
    [anon_sym_DASH] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(835),
    [anon_sym_PERCENT] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(835),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_AMP] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_AT] = ACTIONS(837),
    [anon_sym__] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(835),
    [anon_sym_DOT_DOT] = ACTIONS(835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(837),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(837),
    [anon_sym_SQUOTE] = ACTIONS(835),
    [anon_sym_as] = ACTIONS(835),
    [anon_sym_async] = ACTIONS(835),
    [anon_sym_await] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_const] = ACTIONS(835),
    [anon_sym_continue] = ACTIONS(835),
    [anon_sym_default] = ACTIONS(835),
    [anon_sym_enum] = ACTIONS(835),
    [anon_sym_fn] = ACTIONS(835),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_impl] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(835),
    [anon_sym_loop] = ACTIONS(835),
    [anon_sym_match] = ACTIONS(835),
    [anon_sym_mod] = ACTIONS(835),
    [anon_sym_pub] = ACTIONS(835),
    [anon_sym_return] = ACTIONS(835),
    [anon_sym_static] = ACTIONS(835),
    [anon_sym_struct] = ACTIONS(835),
    [anon_sym_trait] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(835),
    [anon_sym_union] = ACTIONS(835),
    [anon_sym_unsafe] = ACTIONS(835),
    [anon_sym_use] = ACTIONS(835),
    [anon_sym_where] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [sym_mutable_specifier] = ACTIONS(835),
    [sym_integer_literal] = ACTIONS(837),
    [aux_sym_string_literal_token1] = ACTIONS(837),
    [sym_char_literal] = ACTIONS(837),
    [anon_sym_true] = ACTIONS(835),
    [anon_sym_false] = ACTIONS(835),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(835),
    [sym_super] = ACTIONS(835),
    [sym_crate] = ACTIONS(835),
    [sym_metavariable] = ACTIONS(837),
    [sym__raw_string_literal_start] = ACTIONS(837),
    [sym_float_literal] = ACTIONS(837),
  },
  [160] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1593),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(160),
    [sym_block_comment] = STATE(160),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(842),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(850),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_u8] = ACTIONS(856),
    [anon_sym_i8] = ACTIONS(856),
    [anon_sym_u16] = ACTIONS(856),
    [anon_sym_i16] = ACTIONS(856),
    [anon_sym_u32] = ACTIONS(856),
    [anon_sym_i32] = ACTIONS(856),
    [anon_sym_u64] = ACTIONS(856),
    [anon_sym_i64] = ACTIONS(856),
    [anon_sym_u128] = ACTIONS(856),
    [anon_sym_i128] = ACTIONS(856),
    [anon_sym_isize] = ACTIONS(856),
    [anon_sym_usize] = ACTIONS(856),
    [anon_sym_f32] = ACTIONS(856),
    [anon_sym_f64] = ACTIONS(856),
    [anon_sym_bool] = ACTIONS(856),
    [anon_sym_str] = ACTIONS(856),
    [anon_sym_char] = ACTIONS(856),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(853),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(862),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_COLON_COLON] = ACTIONS(871),
    [anon_sym_POUND] = ACTIONS(874),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(880),
    [anon_sym_break] = ACTIONS(883),
    [anon_sym_const] = ACTIONS(886),
    [anon_sym_continue] = ACTIONS(889),
    [anon_sym_default] = ACTIONS(892),
    [anon_sym_for] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_loop] = ACTIONS(901),
    [anon_sym_match] = ACTIONS(904),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(892),
    [anon_sym_unsafe] = ACTIONS(913),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(919),
    [anon_sym_move] = ACTIONS(922),
    [anon_sym_try] = ACTIONS(925),
    [sym_integer_literal] = ACTIONS(928),
    [aux_sym_string_literal_token1] = ACTIONS(931),
    [sym_char_literal] = ACTIONS(928),
    [anon_sym_true] = ACTIONS(934),
    [anon_sym_false] = ACTIONS(934),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(937),
    [sym_super] = ACTIONS(940),
    [sym_crate] = ACTIONS(940),
    [sym_metavariable] = ACTIONS(943),
    [sym__raw_string_literal_start] = ACTIONS(946),
    [sym_float_literal] = ACTIONS(928),
  },
  [161] = {
    [sym_line_comment] = STATE(161),
    [sym_block_comment] = STATE(161),
    [sym_identifier] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(951),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_RBRACK] = ACTIONS(951),
    [anon_sym_LBRACE] = ACTIONS(951),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_EQ_GT] = ACTIONS(951),
    [anon_sym_COLON] = ACTIONS(949),
    [anon_sym_DOLLAR] = ACTIONS(949),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_STAR] = ACTIONS(949),
    [anon_sym_QMARK] = ACTIONS(951),
    [anon_sym_u8] = ACTIONS(949),
    [anon_sym_i8] = ACTIONS(949),
    [anon_sym_u16] = ACTIONS(949),
    [anon_sym_i16] = ACTIONS(949),
    [anon_sym_u32] = ACTIONS(949),
    [anon_sym_i32] = ACTIONS(949),
    [anon_sym_u64] = ACTIONS(949),
    [anon_sym_i64] = ACTIONS(949),
    [anon_sym_u128] = ACTIONS(949),
    [anon_sym_i128] = ACTIONS(949),
    [anon_sym_isize] = ACTIONS(949),
    [anon_sym_usize] = ACTIONS(949),
    [anon_sym_f32] = ACTIONS(949),
    [anon_sym_f64] = ACTIONS(949),
    [anon_sym_bool] = ACTIONS(949),
    [anon_sym_str] = ACTIONS(949),
    [anon_sym_char] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_SLASH] = ACTIONS(949),
    [anon_sym_PERCENT] = ACTIONS(949),
    [anon_sym_CARET] = ACTIONS(949),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(951),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_LT_LT] = ACTIONS(949),
    [anon_sym_GT_GT] = ACTIONS(949),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(949),
    [anon_sym_EQ_EQ] = ACTIONS(951),
    [anon_sym_BANG_EQ] = ACTIONS(951),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(951),
    [anon_sym_LT_EQ] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(951),
    [anon_sym__] = ACTIONS(949),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_DOT_DOT] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(951),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(951),
    [anon_sym_COMMA] = ACTIONS(951),
    [anon_sym_COLON_COLON] = ACTIONS(951),
    [anon_sym_DASH_GT] = ACTIONS(951),
    [anon_sym_POUND] = ACTIONS(951),
    [anon_sym_SQUOTE] = ACTIONS(949),
    [anon_sym_as] = ACTIONS(949),
    [anon_sym_async] = ACTIONS(949),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_const] = ACTIONS(949),
    [anon_sym_continue] = ACTIONS(949),
    [anon_sym_default] = ACTIONS(949),
    [anon_sym_enum] = ACTIONS(949),
    [anon_sym_fn] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(949),
    [anon_sym_impl] = ACTIONS(949),
    [anon_sym_let] = ACTIONS(949),
    [anon_sym_loop] = ACTIONS(949),
    [anon_sym_match] = ACTIONS(949),
    [anon_sym_mod] = ACTIONS(949),
    [anon_sym_pub] = ACTIONS(949),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_static] = ACTIONS(949),
    [anon_sym_struct] = ACTIONS(949),
    [anon_sym_trait] = ACTIONS(949),
    [anon_sym_type] = ACTIONS(949),
    [anon_sym_union] = ACTIONS(949),
    [anon_sym_unsafe] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(949),
    [anon_sym_where] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(949),
    [sym_mutable_specifier] = ACTIONS(949),
    [sym_integer_literal] = ACTIONS(951),
    [aux_sym_string_literal_token1] = ACTIONS(951),
    [sym_char_literal] = ACTIONS(951),
    [anon_sym_true] = ACTIONS(949),
    [anon_sym_false] = ACTIONS(949),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(949),
    [sym_super] = ACTIONS(949),
    [sym_crate] = ACTIONS(949),
    [sym_metavariable] = ACTIONS(951),
    [sym__raw_string_literal_start] = ACTIONS(951),
    [sym_float_literal] = ACTIONS(951),
  },
  [162] = {
    [sym_line_comment] = STATE(162),
    [sym_block_comment] = STATE(162),
    [sym_identifier] = ACTIONS(953),
    [anon_sym_SEMI] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(955),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_RBRACK] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_RBRACE] = ACTIONS(955),
    [anon_sym_EQ_GT] = ACTIONS(955),
    [anon_sym_COLON] = ACTIONS(953),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_STAR] = ACTIONS(953),
    [anon_sym_QMARK] = ACTIONS(955),
    [anon_sym_u8] = ACTIONS(953),
    [anon_sym_i8] = ACTIONS(953),
    [anon_sym_u16] = ACTIONS(953),
    [anon_sym_i16] = ACTIONS(953),
    [anon_sym_u32] = ACTIONS(953),
    [anon_sym_i32] = ACTIONS(953),
    [anon_sym_u64] = ACTIONS(953),
    [anon_sym_i64] = ACTIONS(953),
    [anon_sym_u128] = ACTIONS(953),
    [anon_sym_i128] = ACTIONS(953),
    [anon_sym_isize] = ACTIONS(953),
    [anon_sym_usize] = ACTIONS(953),
    [anon_sym_f32] = ACTIONS(953),
    [anon_sym_f64] = ACTIONS(953),
    [anon_sym_bool] = ACTIONS(953),
    [anon_sym_str] = ACTIONS(953),
    [anon_sym_char] = ACTIONS(953),
    [anon_sym_DASH] = ACTIONS(953),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_PERCENT] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_AMP_AMP] = ACTIONS(955),
    [anon_sym_PIPE_PIPE] = ACTIONS(955),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_PLUS_EQ] = ACTIONS(955),
    [anon_sym_DASH_EQ] = ACTIONS(955),
    [anon_sym_STAR_EQ] = ACTIONS(955),
    [anon_sym_SLASH_EQ] = ACTIONS(955),
    [anon_sym_PERCENT_EQ] = ACTIONS(955),
    [anon_sym_CARET_EQ] = ACTIONS(955),
    [anon_sym_AMP_EQ] = ACTIONS(955),
    [anon_sym_PIPE_EQ] = ACTIONS(955),
    [anon_sym_LT_LT_EQ] = ACTIONS(955),
    [anon_sym_GT_GT_EQ] = ACTIONS(955),
    [anon_sym_EQ] = ACTIONS(953),
    [anon_sym_EQ_EQ] = ACTIONS(955),
    [anon_sym_BANG_EQ] = ACTIONS(955),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT_EQ] = ACTIONS(955),
    [anon_sym_LT_EQ] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(955),
    [anon_sym__] = ACTIONS(953),
    [anon_sym_DOT] = ACTIONS(953),
    [anon_sym_DOT_DOT] = ACTIONS(953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(955),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(955),
    [anon_sym_COMMA] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(955),
    [anon_sym_DASH_GT] = ACTIONS(955),
    [anon_sym_POUND] = ACTIONS(955),
    [anon_sym_SQUOTE] = ACTIONS(953),
    [anon_sym_as] = ACTIONS(953),
    [anon_sym_async] = ACTIONS(953),
    [anon_sym_await] = ACTIONS(953),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(953),
    [anon_sym_continue] = ACTIONS(953),
    [anon_sym_default] = ACTIONS(953),
    [anon_sym_enum] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(953),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_impl] = ACTIONS(953),
    [anon_sym_let] = ACTIONS(953),
    [anon_sym_loop] = ACTIONS(953),
    [anon_sym_match] = ACTIONS(953),
    [anon_sym_mod] = ACTIONS(953),
    [anon_sym_pub] = ACTIONS(953),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_struct] = ACTIONS(953),
    [anon_sym_trait] = ACTIONS(953),
    [anon_sym_type] = ACTIONS(953),
    [anon_sym_union] = ACTIONS(953),
    [anon_sym_unsafe] = ACTIONS(953),
    [anon_sym_use] = ACTIONS(953),
    [anon_sym_where] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [sym_mutable_specifier] = ACTIONS(953),
    [sym_integer_literal] = ACTIONS(955),
    [aux_sym_string_literal_token1] = ACTIONS(955),
    [sym_char_literal] = ACTIONS(955),
    [anon_sym_true] = ACTIONS(953),
    [anon_sym_false] = ACTIONS(953),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(953),
    [sym_super] = ACTIONS(953),
    [sym_crate] = ACTIONS(953),
    [sym_metavariable] = ACTIONS(955),
    [sym__raw_string_literal_start] = ACTIONS(955),
    [sym_float_literal] = ACTIONS(955),
  },
  [163] = {
    [sym_line_comment] = STATE(163),
    [sym_block_comment] = STATE(163),
    [sym_identifier] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_RBRACK] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_EQ_GT] = ACTIONS(737),
    [anon_sym_COLON] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(735),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_STAR] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_u8] = ACTIONS(735),
    [anon_sym_i8] = ACTIONS(735),
    [anon_sym_u16] = ACTIONS(735),
    [anon_sym_i16] = ACTIONS(735),
    [anon_sym_u32] = ACTIONS(735),
    [anon_sym_i32] = ACTIONS(735),
    [anon_sym_u64] = ACTIONS(735),
    [anon_sym_i64] = ACTIONS(735),
    [anon_sym_u128] = ACTIONS(735),
    [anon_sym_i128] = ACTIONS(735),
    [anon_sym_isize] = ACTIONS(735),
    [anon_sym_usize] = ACTIONS(735),
    [anon_sym_f32] = ACTIONS(735),
    [anon_sym_f64] = ACTIONS(735),
    [anon_sym_bool] = ACTIONS(735),
    [anon_sym_str] = ACTIONS(735),
    [anon_sym_char] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(735),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(737),
    [anon_sym_DASH_EQ] = ACTIONS(737),
    [anon_sym_STAR_EQ] = ACTIONS(737),
    [anon_sym_SLASH_EQ] = ACTIONS(737),
    [anon_sym_PERCENT_EQ] = ACTIONS(737),
    [anon_sym_CARET_EQ] = ACTIONS(737),
    [anon_sym_AMP_EQ] = ACTIONS(737),
    [anon_sym_PIPE_EQ] = ACTIONS(737),
    [anon_sym_LT_LT_EQ] = ACTIONS(737),
    [anon_sym_GT_GT_EQ] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_BANG_EQ] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT_EQ] = ACTIONS(737),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_AT] = ACTIONS(737),
    [anon_sym__] = ACTIONS(735),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_DOT_DOT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(737),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_COLON_COLON] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(737),
    [anon_sym_POUND] = ACTIONS(737),
    [anon_sym_SQUOTE] = ACTIONS(735),
    [anon_sym_as] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(735),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_break] = ACTIONS(735),
    [anon_sym_const] = ACTIONS(735),
    [anon_sym_continue] = ACTIONS(735),
    [anon_sym_default] = ACTIONS(735),
    [anon_sym_enum] = ACTIONS(735),
    [anon_sym_fn] = ACTIONS(735),
    [anon_sym_for] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_impl] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(735),
    [anon_sym_loop] = ACTIONS(735),
    [anon_sym_match] = ACTIONS(735),
    [anon_sym_mod] = ACTIONS(735),
    [anon_sym_pub] = ACTIONS(735),
    [anon_sym_return] = ACTIONS(735),
    [anon_sym_static] = ACTIONS(735),
    [anon_sym_struct] = ACTIONS(735),
    [anon_sym_trait] = ACTIONS(735),
    [anon_sym_type] = ACTIONS(735),
    [anon_sym_union] = ACTIONS(735),
    [anon_sym_unsafe] = ACTIONS(735),
    [anon_sym_use] = ACTIONS(735),
    [anon_sym_where] = ACTIONS(735),
    [anon_sym_while] = ACTIONS(735),
    [sym_mutable_specifier] = ACTIONS(735),
    [sym_integer_literal] = ACTIONS(737),
    [aux_sym_string_literal_token1] = ACTIONS(737),
    [sym_char_literal] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(735),
    [anon_sym_false] = ACTIONS(735),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(735),
    [sym_super] = ACTIONS(735),
    [sym_crate] = ACTIONS(735),
    [sym_metavariable] = ACTIONS(737),
    [sym__raw_string_literal_start] = ACTIONS(737),
    [sym_float_literal] = ACTIONS(737),
  },
  [164] = {
    [sym_line_comment] = STATE(164),
    [sym_block_comment] = STATE(164),
    [sym_identifier] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_RBRACK] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_EQ_GT] = ACTIONS(959),
    [anon_sym_COLON] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_QMARK] = ACTIONS(959),
    [anon_sym_u8] = ACTIONS(957),
    [anon_sym_i8] = ACTIONS(957),
    [anon_sym_u16] = ACTIONS(957),
    [anon_sym_i16] = ACTIONS(957),
    [anon_sym_u32] = ACTIONS(957),
    [anon_sym_i32] = ACTIONS(957),
    [anon_sym_u64] = ACTIONS(957),
    [anon_sym_i64] = ACTIONS(957),
    [anon_sym_u128] = ACTIONS(957),
    [anon_sym_i128] = ACTIONS(957),
    [anon_sym_isize] = ACTIONS(957),
    [anon_sym_usize] = ACTIONS(957),
    [anon_sym_f32] = ACTIONS(957),
    [anon_sym_f64] = ACTIONS(957),
    [anon_sym_bool] = ACTIONS(957),
    [anon_sym_str] = ACTIONS(957),
    [anon_sym_char] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_SLASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(957),
    [anon_sym_PIPE] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(959),
    [anon_sym_PIPE_PIPE] = ACTIONS(959),
    [anon_sym_LT_LT] = ACTIONS(957),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_PLUS_EQ] = ACTIONS(959),
    [anon_sym_DASH_EQ] = ACTIONS(959),
    [anon_sym_STAR_EQ] = ACTIONS(959),
    [anon_sym_SLASH_EQ] = ACTIONS(959),
    [anon_sym_PERCENT_EQ] = ACTIONS(959),
    [anon_sym_CARET_EQ] = ACTIONS(959),
    [anon_sym_AMP_EQ] = ACTIONS(959),
    [anon_sym_PIPE_EQ] = ACTIONS(959),
    [anon_sym_LT_LT_EQ] = ACTIONS(959),
    [anon_sym_GT_GT_EQ] = ACTIONS(959),
    [anon_sym_EQ] = ACTIONS(957),
    [anon_sym_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(957),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym__] = ACTIONS(957),
    [anon_sym_DOT] = ACTIONS(957),
    [anon_sym_DOT_DOT] = ACTIONS(957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(959),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(959),
    [anon_sym_COMMA] = ACTIONS(959),
    [anon_sym_COLON_COLON] = ACTIONS(959),
    [anon_sym_DASH_GT] = ACTIONS(959),
    [anon_sym_POUND] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(957),
    [anon_sym_as] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_await] = ACTIONS(957),
    [anon_sym_break] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(957),
    [anon_sym_continue] = ACTIONS(957),
    [anon_sym_default] = ACTIONS(957),
    [anon_sym_enum] = ACTIONS(957),
    [anon_sym_fn] = ACTIONS(957),
    [anon_sym_for] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(957),
    [anon_sym_impl] = ACTIONS(957),
    [anon_sym_let] = ACTIONS(957),
    [anon_sym_loop] = ACTIONS(957),
    [anon_sym_match] = ACTIONS(957),
    [anon_sym_mod] = ACTIONS(957),
    [anon_sym_pub] = ACTIONS(957),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_static] = ACTIONS(957),
    [anon_sym_struct] = ACTIONS(957),
    [anon_sym_trait] = ACTIONS(957),
    [anon_sym_type] = ACTIONS(957),
    [anon_sym_union] = ACTIONS(957),
    [anon_sym_unsafe] = ACTIONS(957),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_where] = ACTIONS(957),
    [anon_sym_while] = ACTIONS(957),
    [sym_mutable_specifier] = ACTIONS(957),
    [sym_integer_literal] = ACTIONS(959),
    [aux_sym_string_literal_token1] = ACTIONS(959),
    [sym_char_literal] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(957),
    [anon_sym_false] = ACTIONS(957),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(957),
    [sym_super] = ACTIONS(957),
    [sym_crate] = ACTIONS(957),
    [sym_metavariable] = ACTIONS(959),
    [sym__raw_string_literal_start] = ACTIONS(959),
    [sym_float_literal] = ACTIONS(959),
  },
  [165] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1622),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(165),
    [sym_block_comment] = STATE(165),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(842),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(850),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_u8] = ACTIONS(856),
    [anon_sym_i8] = ACTIONS(856),
    [anon_sym_u16] = ACTIONS(856),
    [anon_sym_i16] = ACTIONS(856),
    [anon_sym_u32] = ACTIONS(856),
    [anon_sym_i32] = ACTIONS(856),
    [anon_sym_u64] = ACTIONS(856),
    [anon_sym_i64] = ACTIONS(856),
    [anon_sym_u128] = ACTIONS(856),
    [anon_sym_i128] = ACTIONS(856),
    [anon_sym_isize] = ACTIONS(856),
    [anon_sym_usize] = ACTIONS(856),
    [anon_sym_f32] = ACTIONS(856),
    [anon_sym_f64] = ACTIONS(856),
    [anon_sym_bool] = ACTIONS(856),
    [anon_sym_str] = ACTIONS(856),
    [anon_sym_char] = ACTIONS(856),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(853),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(862),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_COLON_COLON] = ACTIONS(871),
    [anon_sym_POUND] = ACTIONS(874),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(880),
    [anon_sym_break] = ACTIONS(883),
    [anon_sym_const] = ACTIONS(886),
    [anon_sym_continue] = ACTIONS(889),
    [anon_sym_default] = ACTIONS(892),
    [anon_sym_for] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_loop] = ACTIONS(901),
    [anon_sym_match] = ACTIONS(904),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(892),
    [anon_sym_unsafe] = ACTIONS(913),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(919),
    [anon_sym_move] = ACTIONS(922),
    [anon_sym_try] = ACTIONS(925),
    [sym_integer_literal] = ACTIONS(928),
    [aux_sym_string_literal_token1] = ACTIONS(931),
    [sym_char_literal] = ACTIONS(928),
    [anon_sym_true] = ACTIONS(934),
    [anon_sym_false] = ACTIONS(934),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(937),
    [sym_super] = ACTIONS(940),
    [sym_crate] = ACTIONS(940),
    [sym_metavariable] = ACTIONS(943),
    [sym__raw_string_literal_start] = ACTIONS(946),
    [sym_float_literal] = ACTIONS(928),
  },
  [166] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1554),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(166),
    [sym_block_comment] = STATE(166),
    [aux_sym_enum_variant_list_repeat1] = STATE(149),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(961),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(963),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [167] = {
    [sym_line_comment] = STATE(167),
    [sym_block_comment] = STATE(167),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(967),
    [anon_sym_RBRACK] = ACTIONS(967),
    [anon_sym_LBRACE] = ACTIONS(967),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_EQ_GT] = ACTIONS(967),
    [anon_sym_COLON] = ACTIONS(965),
    [anon_sym_DOLLAR] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(965),
    [anon_sym_STAR] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_u8] = ACTIONS(965),
    [anon_sym_i8] = ACTIONS(965),
    [anon_sym_u16] = ACTIONS(965),
    [anon_sym_i16] = ACTIONS(965),
    [anon_sym_u32] = ACTIONS(965),
    [anon_sym_i32] = ACTIONS(965),
    [anon_sym_u64] = ACTIONS(965),
    [anon_sym_i64] = ACTIONS(965),
    [anon_sym_u128] = ACTIONS(965),
    [anon_sym_i128] = ACTIONS(965),
    [anon_sym_isize] = ACTIONS(965),
    [anon_sym_usize] = ACTIONS(965),
    [anon_sym_f32] = ACTIONS(965),
    [anon_sym_f64] = ACTIONS(965),
    [anon_sym_bool] = ACTIONS(965),
    [anon_sym_str] = ACTIONS(965),
    [anon_sym_char] = ACTIONS(965),
    [anon_sym_DASH] = ACTIONS(965),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(967),
    [anon_sym_PIPE_PIPE] = ACTIONS(967),
    [anon_sym_LT_LT] = ACTIONS(965),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_PLUS_EQ] = ACTIONS(967),
    [anon_sym_DASH_EQ] = ACTIONS(967),
    [anon_sym_STAR_EQ] = ACTIONS(967),
    [anon_sym_SLASH_EQ] = ACTIONS(967),
    [anon_sym_PERCENT_EQ] = ACTIONS(967),
    [anon_sym_CARET_EQ] = ACTIONS(967),
    [anon_sym_AMP_EQ] = ACTIONS(967),
    [anon_sym_PIPE_EQ] = ACTIONS(967),
    [anon_sym_LT_LT_EQ] = ACTIONS(967),
    [anon_sym_GT_GT_EQ] = ACTIONS(967),
    [anon_sym_EQ] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(967),
    [anon_sym_BANG_EQ] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_GT_EQ] = ACTIONS(967),
    [anon_sym_LT_EQ] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(967),
    [anon_sym__] = ACTIONS(965),
    [anon_sym_DOT] = ACTIONS(965),
    [anon_sym_DOT_DOT] = ACTIONS(965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(967),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(967),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_COLON_COLON] = ACTIONS(967),
    [anon_sym_DASH_GT] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(967),
    [anon_sym_SQUOTE] = ACTIONS(965),
    [anon_sym_as] = ACTIONS(965),
    [anon_sym_async] = ACTIONS(965),
    [anon_sym_await] = ACTIONS(965),
    [anon_sym_break] = ACTIONS(965),
    [anon_sym_const] = ACTIONS(965),
    [anon_sym_continue] = ACTIONS(965),
    [anon_sym_default] = ACTIONS(965),
    [anon_sym_enum] = ACTIONS(965),
    [anon_sym_fn] = ACTIONS(965),
    [anon_sym_for] = ACTIONS(965),
    [anon_sym_if] = ACTIONS(965),
    [anon_sym_impl] = ACTIONS(965),
    [anon_sym_let] = ACTIONS(965),
    [anon_sym_loop] = ACTIONS(965),
    [anon_sym_match] = ACTIONS(965),
    [anon_sym_mod] = ACTIONS(965),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_return] = ACTIONS(965),
    [anon_sym_static] = ACTIONS(965),
    [anon_sym_struct] = ACTIONS(965),
    [anon_sym_trait] = ACTIONS(965),
    [anon_sym_type] = ACTIONS(965),
    [anon_sym_union] = ACTIONS(965),
    [anon_sym_unsafe] = ACTIONS(965),
    [anon_sym_use] = ACTIONS(965),
    [anon_sym_where] = ACTIONS(965),
    [anon_sym_while] = ACTIONS(965),
    [sym_mutable_specifier] = ACTIONS(965),
    [sym_integer_literal] = ACTIONS(967),
    [aux_sym_string_literal_token1] = ACTIONS(967),
    [sym_char_literal] = ACTIONS(967),
    [anon_sym_true] = ACTIONS(965),
    [anon_sym_false] = ACTIONS(965),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(965),
    [sym_super] = ACTIONS(965),
    [sym_crate] = ACTIONS(965),
    [sym_metavariable] = ACTIONS(967),
    [sym__raw_string_literal_start] = ACTIONS(967),
    [sym_float_literal] = ACTIONS(967),
  },
  [168] = {
    [sym_line_comment] = STATE(168),
    [sym_block_comment] = STATE(168),
    [sym_identifier] = ACTIONS(969),
    [anon_sym_SEMI] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(971),
    [anon_sym_RPAREN] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_RBRACK] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_EQ_GT] = ACTIONS(971),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_DOLLAR] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(969),
    [anon_sym_QMARK] = ACTIONS(971),
    [anon_sym_u8] = ACTIONS(969),
    [anon_sym_i8] = ACTIONS(969),
    [anon_sym_u16] = ACTIONS(969),
    [anon_sym_i16] = ACTIONS(969),
    [anon_sym_u32] = ACTIONS(969),
    [anon_sym_i32] = ACTIONS(969),
    [anon_sym_u64] = ACTIONS(969),
    [anon_sym_i64] = ACTIONS(969),
    [anon_sym_u128] = ACTIONS(969),
    [anon_sym_i128] = ACTIONS(969),
    [anon_sym_isize] = ACTIONS(969),
    [anon_sym_usize] = ACTIONS(969),
    [anon_sym_f32] = ACTIONS(969),
    [anon_sym_f64] = ACTIONS(969),
    [anon_sym_bool] = ACTIONS(969),
    [anon_sym_str] = ACTIONS(969),
    [anon_sym_char] = ACTIONS(969),
    [anon_sym_DASH] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(969),
    [anon_sym_PERCENT] = ACTIONS(969),
    [anon_sym_CARET] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(969),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(969),
    [anon_sym_PLUS_EQ] = ACTIONS(971),
    [anon_sym_DASH_EQ] = ACTIONS(971),
    [anon_sym_STAR_EQ] = ACTIONS(971),
    [anon_sym_SLASH_EQ] = ACTIONS(971),
    [anon_sym_PERCENT_EQ] = ACTIONS(971),
    [anon_sym_CARET_EQ] = ACTIONS(971),
    [anon_sym_AMP_EQ] = ACTIONS(971),
    [anon_sym_PIPE_EQ] = ACTIONS(971),
    [anon_sym_LT_LT_EQ] = ACTIONS(971),
    [anon_sym_GT_GT_EQ] = ACTIONS(971),
    [anon_sym_EQ] = ACTIONS(969),
    [anon_sym_EQ_EQ] = ACTIONS(971),
    [anon_sym_BANG_EQ] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_LT] = ACTIONS(969),
    [anon_sym_GT_EQ] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(971),
    [anon_sym__] = ACTIONS(969),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(971),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(971),
    [anon_sym_COMMA] = ACTIONS(971),
    [anon_sym_COLON_COLON] = ACTIONS(971),
    [anon_sym_DASH_GT] = ACTIONS(971),
    [anon_sym_POUND] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(969),
    [anon_sym_as] = ACTIONS(969),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_await] = ACTIONS(969),
    [anon_sym_break] = ACTIONS(969),
    [anon_sym_const] = ACTIONS(969),
    [anon_sym_continue] = ACTIONS(969),
    [anon_sym_default] = ACTIONS(969),
    [anon_sym_enum] = ACTIONS(969),
    [anon_sym_fn] = ACTIONS(969),
    [anon_sym_for] = ACTIONS(969),
    [anon_sym_if] = ACTIONS(969),
    [anon_sym_impl] = ACTIONS(969),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_loop] = ACTIONS(969),
    [anon_sym_match] = ACTIONS(969),
    [anon_sym_mod] = ACTIONS(969),
    [anon_sym_pub] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(969),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_struct] = ACTIONS(969),
    [anon_sym_trait] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_union] = ACTIONS(969),
    [anon_sym_unsafe] = ACTIONS(969),
    [anon_sym_use] = ACTIONS(969),
    [anon_sym_where] = ACTIONS(969),
    [anon_sym_while] = ACTIONS(969),
    [sym_mutable_specifier] = ACTIONS(969),
    [sym_integer_literal] = ACTIONS(971),
    [aux_sym_string_literal_token1] = ACTIONS(971),
    [sym_char_literal] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(969),
    [anon_sym_false] = ACTIONS(969),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(969),
    [sym_super] = ACTIONS(969),
    [sym_crate] = ACTIONS(969),
    [sym_metavariable] = ACTIONS(971),
    [sym__raw_string_literal_start] = ACTIONS(971),
    [sym_float_literal] = ACTIONS(971),
  },
  [169] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(169),
    [sym_block_comment] = STATE(169),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(973),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [170] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2830),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2523),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(170),
    [sym_block_comment] = STATE(170),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [171] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2830),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2627),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(171),
    [sym_block_comment] = STATE(171),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [172] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(172),
    [sym_block_comment] = STATE(172),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [173] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(173),
    [sym_block_comment] = STATE(173),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [174] = {
    [sym_line_comment] = STATE(174),
    [sym_block_comment] = STATE(174),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_SEMI] = ACTIONS(829),
    [anon_sym_LPAREN] = ACTIONS(829),
    [anon_sym_RPAREN] = ACTIONS(829),
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_RBRACK] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(829),
    [anon_sym_RBRACE] = ACTIONS(829),
    [anon_sym_EQ_GT] = ACTIONS(829),
    [anon_sym_COLON] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(827),
    [anon_sym_QMARK] = ACTIONS(829),
    [anon_sym_u8] = ACTIONS(827),
    [anon_sym_i8] = ACTIONS(827),
    [anon_sym_u16] = ACTIONS(827),
    [anon_sym_i16] = ACTIONS(827),
    [anon_sym_u32] = ACTIONS(827),
    [anon_sym_i32] = ACTIONS(827),
    [anon_sym_u64] = ACTIONS(827),
    [anon_sym_i64] = ACTIONS(827),
    [anon_sym_u128] = ACTIONS(827),
    [anon_sym_i128] = ACTIONS(827),
    [anon_sym_isize] = ACTIONS(827),
    [anon_sym_usize] = ACTIONS(827),
    [anon_sym_f32] = ACTIONS(827),
    [anon_sym_f64] = ACTIONS(827),
    [anon_sym_bool] = ACTIONS(827),
    [anon_sym_str] = ACTIONS(827),
    [anon_sym_char] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_SLASH] = ACTIONS(827),
    [anon_sym_PERCENT] = ACTIONS(827),
    [anon_sym_CARET] = ACTIONS(827),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_AMP] = ACTIONS(827),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_AMP_AMP] = ACTIONS(829),
    [anon_sym_PIPE_PIPE] = ACTIONS(829),
    [anon_sym_LT_LT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(827),
    [anon_sym_PLUS_EQ] = ACTIONS(829),
    [anon_sym_DASH_EQ] = ACTIONS(829),
    [anon_sym_STAR_EQ] = ACTIONS(829),
    [anon_sym_SLASH_EQ] = ACTIONS(829),
    [anon_sym_PERCENT_EQ] = ACTIONS(829),
    [anon_sym_CARET_EQ] = ACTIONS(829),
    [anon_sym_AMP_EQ] = ACTIONS(829),
    [anon_sym_PIPE_EQ] = ACTIONS(829),
    [anon_sym_LT_LT_EQ] = ACTIONS(829),
    [anon_sym_GT_GT_EQ] = ACTIONS(829),
    [anon_sym_EQ] = ACTIONS(827),
    [anon_sym_EQ_EQ] = ACTIONS(829),
    [anon_sym_BANG_EQ] = ACTIONS(829),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_GT_EQ] = ACTIONS(829),
    [anon_sym_LT_EQ] = ACTIONS(829),
    [anon_sym_AT] = ACTIONS(829),
    [anon_sym__] = ACTIONS(827),
    [anon_sym_DOT] = ACTIONS(827),
    [anon_sym_DOT_DOT] = ACTIONS(827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(829),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(829),
    [anon_sym_COMMA] = ACTIONS(829),
    [anon_sym_COLON_COLON] = ACTIONS(829),
    [anon_sym_DASH_GT] = ACTIONS(829),
    [anon_sym_POUND] = ACTIONS(829),
    [anon_sym_SQUOTE] = ACTIONS(827),
    [anon_sym_as] = ACTIONS(827),
    [anon_sym_async] = ACTIONS(827),
    [anon_sym_await] = ACTIONS(827),
    [anon_sym_break] = ACTIONS(827),
    [anon_sym_const] = ACTIONS(827),
    [anon_sym_continue] = ACTIONS(827),
    [anon_sym_default] = ACTIONS(827),
    [anon_sym_enum] = ACTIONS(827),
    [anon_sym_fn] = ACTIONS(827),
    [anon_sym_for] = ACTIONS(827),
    [anon_sym_if] = ACTIONS(827),
    [anon_sym_impl] = ACTIONS(827),
    [anon_sym_let] = ACTIONS(827),
    [anon_sym_loop] = ACTIONS(827),
    [anon_sym_match] = ACTIONS(827),
    [anon_sym_mod] = ACTIONS(827),
    [anon_sym_pub] = ACTIONS(827),
    [anon_sym_return] = ACTIONS(827),
    [anon_sym_static] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(827),
    [anon_sym_trait] = ACTIONS(827),
    [anon_sym_type] = ACTIONS(827),
    [anon_sym_union] = ACTIONS(827),
    [anon_sym_unsafe] = ACTIONS(827),
    [anon_sym_use] = ACTIONS(827),
    [anon_sym_where] = ACTIONS(827),
    [anon_sym_while] = ACTIONS(827),
    [sym_mutable_specifier] = ACTIONS(827),
    [sym_integer_literal] = ACTIONS(829),
    [aux_sym_string_literal_token1] = ACTIONS(829),
    [sym_char_literal] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(827),
    [anon_sym_false] = ACTIONS(827),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(827),
    [sym_super] = ACTIONS(827),
    [sym_crate] = ACTIONS(827),
    [sym__raw_string_literal_start] = ACTIONS(829),
    [sym_float_literal] = ACTIONS(829),
  },
  [175] = {
    [sym_line_comment] = STATE(175),
    [sym_block_comment] = STATE(175),
    [sym_identifier] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(779),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(779),
    [anon_sym_RBRACE] = ACTIONS(779),
    [anon_sym_EQ_GT] = ACTIONS(779),
    [anon_sym_COLON] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(779),
    [anon_sym_u8] = ACTIONS(777),
    [anon_sym_i8] = ACTIONS(777),
    [anon_sym_u16] = ACTIONS(777),
    [anon_sym_i16] = ACTIONS(777),
    [anon_sym_u32] = ACTIONS(777),
    [anon_sym_i32] = ACTIONS(777),
    [anon_sym_u64] = ACTIONS(777),
    [anon_sym_i64] = ACTIONS(777),
    [anon_sym_u128] = ACTIONS(777),
    [anon_sym_i128] = ACTIONS(777),
    [anon_sym_isize] = ACTIONS(777),
    [anon_sym_usize] = ACTIONS(777),
    [anon_sym_f32] = ACTIONS(777),
    [anon_sym_f64] = ACTIONS(777),
    [anon_sym_bool] = ACTIONS(777),
    [anon_sym_str] = ACTIONS(777),
    [anon_sym_char] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(779),
    [anon_sym_DASH_EQ] = ACTIONS(779),
    [anon_sym_STAR_EQ] = ACTIONS(779),
    [anon_sym_SLASH_EQ] = ACTIONS(779),
    [anon_sym_PERCENT_EQ] = ACTIONS(779),
    [anon_sym_CARET_EQ] = ACTIONS(779),
    [anon_sym_AMP_EQ] = ACTIONS(779),
    [anon_sym_PIPE_EQ] = ACTIONS(779),
    [anon_sym_LT_LT_EQ] = ACTIONS(779),
    [anon_sym_GT_GT_EQ] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(779),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(779),
    [anon_sym_LT_EQ] = ACTIONS(779),
    [anon_sym_AT] = ACTIONS(779),
    [anon_sym__] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(777),
    [anon_sym_DOT_DOT] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(779),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(779),
    [anon_sym_COMMA] = ACTIONS(779),
    [anon_sym_COLON_COLON] = ACTIONS(779),
    [anon_sym_DASH_GT] = ACTIONS(779),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_SQUOTE] = ACTIONS(777),
    [anon_sym_as] = ACTIONS(777),
    [anon_sym_async] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(777),
    [anon_sym_break] = ACTIONS(777),
    [anon_sym_const] = ACTIONS(777),
    [anon_sym_continue] = ACTIONS(777),
    [anon_sym_default] = ACTIONS(777),
    [anon_sym_enum] = ACTIONS(777),
    [anon_sym_fn] = ACTIONS(777),
    [anon_sym_for] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_impl] = ACTIONS(777),
    [anon_sym_let] = ACTIONS(777),
    [anon_sym_loop] = ACTIONS(777),
    [anon_sym_match] = ACTIONS(777),
    [anon_sym_mod] = ACTIONS(777),
    [anon_sym_pub] = ACTIONS(777),
    [anon_sym_return] = ACTIONS(777),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_struct] = ACTIONS(777),
    [anon_sym_trait] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_union] = ACTIONS(777),
    [anon_sym_unsafe] = ACTIONS(777),
    [anon_sym_use] = ACTIONS(777),
    [anon_sym_where] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym_mutable_specifier] = ACTIONS(777),
    [sym_integer_literal] = ACTIONS(779),
    [aux_sym_string_literal_token1] = ACTIONS(779),
    [sym_char_literal] = ACTIONS(779),
    [anon_sym_true] = ACTIONS(777),
    [anon_sym_false] = ACTIONS(777),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(777),
    [sym_super] = ACTIONS(777),
    [sym_crate] = ACTIONS(777),
    [sym__raw_string_literal_start] = ACTIONS(779),
    [sym_float_literal] = ACTIONS(779),
  },
  [176] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2830),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2640),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(176),
    [sym_block_comment] = STATE(176),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [177] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(177),
    [sym_block_comment] = STATE(177),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [178] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2830),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2496),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(178),
    [sym_block_comment] = STATE(178),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [179] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(179),
    [sym_block_comment] = STATE(179),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [180] = {
    [sym_line_comment] = STATE(180),
    [sym_block_comment] = STATE(180),
    [sym_identifier] = ACTIONS(991),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_RBRACK] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(991),
    [anon_sym_i8] = ACTIONS(991),
    [anon_sym_u16] = ACTIONS(991),
    [anon_sym_i16] = ACTIONS(991),
    [anon_sym_u32] = ACTIONS(991),
    [anon_sym_i32] = ACTIONS(991),
    [anon_sym_u64] = ACTIONS(991),
    [anon_sym_i64] = ACTIONS(991),
    [anon_sym_u128] = ACTIONS(991),
    [anon_sym_i128] = ACTIONS(991),
    [anon_sym_isize] = ACTIONS(991),
    [anon_sym_usize] = ACTIONS(991),
    [anon_sym_f32] = ACTIONS(991),
    [anon_sym_f64] = ACTIONS(991),
    [anon_sym_bool] = ACTIONS(991),
    [anon_sym_str] = ACTIONS(991),
    [anon_sym_char] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(991),
    [anon_sym_PERCENT] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(991),
    [anon_sym_GT_GT] = ACTIONS(991),
    [anon_sym_PLUS_EQ] = ACTIONS(993),
    [anon_sym_DASH_EQ] = ACTIONS(993),
    [anon_sym_STAR_EQ] = ACTIONS(993),
    [anon_sym_SLASH_EQ] = ACTIONS(993),
    [anon_sym_PERCENT_EQ] = ACTIONS(993),
    [anon_sym_CARET_EQ] = ACTIONS(993),
    [anon_sym_AMP_EQ] = ACTIONS(993),
    [anon_sym_PIPE_EQ] = ACTIONS(993),
    [anon_sym_LT_LT_EQ] = ACTIONS(993),
    [anon_sym_GT_GT_EQ] = ACTIONS(993),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_EQ_EQ] = ACTIONS(993),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_GT] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(993),
    [anon_sym__] = ACTIONS(991),
    [anon_sym_DOT] = ACTIONS(991),
    [anon_sym_DOT_DOT] = ACTIONS(991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_COLON_COLON] = ACTIONS(993),
    [anon_sym_DASH_GT] = ACTIONS(993),
    [anon_sym_POUND] = ACTIONS(993),
    [anon_sym_SQUOTE] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(991),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(991),
    [anon_sym_break] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_continue] = ACTIONS(991),
    [anon_sym_default] = ACTIONS(991),
    [anon_sym_enum] = ACTIONS(991),
    [anon_sym_fn] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_impl] = ACTIONS(991),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_loop] = ACTIONS(991),
    [anon_sym_match] = ACTIONS(991),
    [anon_sym_mod] = ACTIONS(991),
    [anon_sym_pub] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_struct] = ACTIONS(991),
    [anon_sym_trait] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_union] = ACTIONS(991),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_use] = ACTIONS(991),
    [anon_sym_where] = ACTIONS(991),
    [anon_sym_while] = ACTIONS(991),
    [sym_mutable_specifier] = ACTIONS(991),
    [sym_integer_literal] = ACTIONS(993),
    [aux_sym_string_literal_token1] = ACTIONS(993),
    [sym_char_literal] = ACTIONS(993),
    [anon_sym_true] = ACTIONS(991),
    [anon_sym_false] = ACTIONS(991),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(991),
    [sym_super] = ACTIONS(991),
    [sym_crate] = ACTIONS(991),
    [sym__raw_string_literal_start] = ACTIONS(993),
    [sym_float_literal] = ACTIONS(993),
  },
  [181] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2830),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2606),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(181),
    [sym_block_comment] = STATE(181),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [182] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2830),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2615),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(182),
    [sym_block_comment] = STATE(182),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [183] = {
    [sym_line_comment] = STATE(183),
    [sym_block_comment] = STATE(183),
    [sym_identifier] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(815),
    [anon_sym_RPAREN] = ACTIONS(815),
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_RBRACK] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_EQ_GT] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(813),
    [anon_sym_DOLLAR] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_u8] = ACTIONS(813),
    [anon_sym_i8] = ACTIONS(813),
    [anon_sym_u16] = ACTIONS(813),
    [anon_sym_i16] = ACTIONS(813),
    [anon_sym_u32] = ACTIONS(813),
    [anon_sym_i32] = ACTIONS(813),
    [anon_sym_u64] = ACTIONS(813),
    [anon_sym_i64] = ACTIONS(813),
    [anon_sym_u128] = ACTIONS(813),
    [anon_sym_i128] = ACTIONS(813),
    [anon_sym_isize] = ACTIONS(813),
    [anon_sym_usize] = ACTIONS(813),
    [anon_sym_f32] = ACTIONS(813),
    [anon_sym_f64] = ACTIONS(813),
    [anon_sym_bool] = ACTIONS(813),
    [anon_sym_str] = ACTIONS(813),
    [anon_sym_char] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_PLUS_EQ] = ACTIONS(815),
    [anon_sym_DASH_EQ] = ACTIONS(815),
    [anon_sym_STAR_EQ] = ACTIONS(815),
    [anon_sym_SLASH_EQ] = ACTIONS(815),
    [anon_sym_PERCENT_EQ] = ACTIONS(815),
    [anon_sym_CARET_EQ] = ACTIONS(815),
    [anon_sym_AMP_EQ] = ACTIONS(815),
    [anon_sym_PIPE_EQ] = ACTIONS(815),
    [anon_sym_LT_LT_EQ] = ACTIONS(815),
    [anon_sym_GT_GT_EQ] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_AT] = ACTIONS(815),
    [anon_sym__] = ACTIONS(813),
    [anon_sym_DOT] = ACTIONS(813),
    [anon_sym_DOT_DOT] = ACTIONS(813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(815),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_POUND] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(813),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_async] = ACTIONS(813),
    [anon_sym_await] = ACTIONS(813),
    [anon_sym_break] = ACTIONS(813),
    [anon_sym_const] = ACTIONS(813),
    [anon_sym_continue] = ACTIONS(813),
    [anon_sym_default] = ACTIONS(813),
    [anon_sym_enum] = ACTIONS(813),
    [anon_sym_fn] = ACTIONS(813),
    [anon_sym_for] = ACTIONS(813),
    [anon_sym_if] = ACTIONS(813),
    [anon_sym_impl] = ACTIONS(813),
    [anon_sym_let] = ACTIONS(813),
    [anon_sym_loop] = ACTIONS(813),
    [anon_sym_match] = ACTIONS(813),
    [anon_sym_mod] = ACTIONS(813),
    [anon_sym_pub] = ACTIONS(813),
    [anon_sym_return] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(813),
    [anon_sym_struct] = ACTIONS(813),
    [anon_sym_trait] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(813),
    [anon_sym_union] = ACTIONS(813),
    [anon_sym_unsafe] = ACTIONS(813),
    [anon_sym_use] = ACTIONS(813),
    [anon_sym_where] = ACTIONS(813),
    [anon_sym_while] = ACTIONS(813),
    [sym_mutable_specifier] = ACTIONS(813),
    [sym_integer_literal] = ACTIONS(815),
    [aux_sym_string_literal_token1] = ACTIONS(815),
    [sym_char_literal] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(813),
    [anon_sym_false] = ACTIONS(813),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(813),
    [sym_super] = ACTIONS(813),
    [sym_crate] = ACTIONS(813),
    [sym__raw_string_literal_start] = ACTIONS(815),
    [sym_float_literal] = ACTIONS(815),
  },
  [184] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(184),
    [sym_block_comment] = STATE(184),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [185] = {
    [sym_line_comment] = STATE(185),
    [sym_block_comment] = STATE(185),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_RBRACK] = ACTIONS(999),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_COLON] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(999),
    [anon_sym_u8] = ACTIONS(997),
    [anon_sym_i8] = ACTIONS(997),
    [anon_sym_u16] = ACTIONS(997),
    [anon_sym_i16] = ACTIONS(997),
    [anon_sym_u32] = ACTIONS(997),
    [anon_sym_i32] = ACTIONS(997),
    [anon_sym_u64] = ACTIONS(997),
    [anon_sym_i64] = ACTIONS(997),
    [anon_sym_u128] = ACTIONS(997),
    [anon_sym_i128] = ACTIONS(997),
    [anon_sym_isize] = ACTIONS(997),
    [anon_sym_usize] = ACTIONS(997),
    [anon_sym_f32] = ACTIONS(997),
    [anon_sym_f64] = ACTIONS(997),
    [anon_sym_bool] = ACTIONS(997),
    [anon_sym_str] = ACTIONS(997),
    [anon_sym_char] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(999),
    [anon_sym_DASH_EQ] = ACTIONS(999),
    [anon_sym_STAR_EQ] = ACTIONS(999),
    [anon_sym_SLASH_EQ] = ACTIONS(999),
    [anon_sym_PERCENT_EQ] = ACTIONS(999),
    [anon_sym_CARET_EQ] = ACTIONS(999),
    [anon_sym_AMP_EQ] = ACTIONS(999),
    [anon_sym_PIPE_EQ] = ACTIONS(999),
    [anon_sym_LT_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_GT_EQ] = ACTIONS(999),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_AT] = ACTIONS(999),
    [anon_sym__] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_COLON_COLON] = ACTIONS(999),
    [anon_sym_DASH_GT] = ACTIONS(999),
    [anon_sym_POUND] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(997),
    [anon_sym_async] = ACTIONS(997),
    [anon_sym_await] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_const] = ACTIONS(997),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_default] = ACTIONS(997),
    [anon_sym_enum] = ACTIONS(997),
    [anon_sym_fn] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_impl] = ACTIONS(997),
    [anon_sym_let] = ACTIONS(997),
    [anon_sym_loop] = ACTIONS(997),
    [anon_sym_match] = ACTIONS(997),
    [anon_sym_mod] = ACTIONS(997),
    [anon_sym_pub] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_static] = ACTIONS(997),
    [anon_sym_struct] = ACTIONS(997),
    [anon_sym_trait] = ACTIONS(997),
    [anon_sym_type] = ACTIONS(997),
    [anon_sym_union] = ACTIONS(997),
    [anon_sym_unsafe] = ACTIONS(997),
    [anon_sym_use] = ACTIONS(997),
    [anon_sym_where] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [sym_mutable_specifier] = ACTIONS(997),
    [sym_integer_literal] = ACTIONS(999),
    [aux_sym_string_literal_token1] = ACTIONS(999),
    [sym_char_literal] = ACTIONS(999),
    [anon_sym_true] = ACTIONS(997),
    [anon_sym_false] = ACTIONS(997),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(997),
    [sym_super] = ACTIONS(997),
    [sym_crate] = ACTIONS(997),
    [sym__raw_string_literal_start] = ACTIONS(999),
    [sym_float_literal] = ACTIONS(999),
  },
  [186] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(186),
    [sym_block_comment] = STATE(186),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [187] = {
    [sym_line_comment] = STATE(187),
    [sym_block_comment] = STATE(187),
    [sym_identifier] = ACTIONS(797),
    [anon_sym_SEMI] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(799),
    [anon_sym_RBRACK] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(799),
    [anon_sym_COLON] = ACTIONS(797),
    [anon_sym_DOLLAR] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_u8] = ACTIONS(797),
    [anon_sym_i8] = ACTIONS(797),
    [anon_sym_u16] = ACTIONS(797),
    [anon_sym_i16] = ACTIONS(797),
    [anon_sym_u32] = ACTIONS(797),
    [anon_sym_i32] = ACTIONS(797),
    [anon_sym_u64] = ACTIONS(797),
    [anon_sym_i64] = ACTIONS(797),
    [anon_sym_u128] = ACTIONS(797),
    [anon_sym_i128] = ACTIONS(797),
    [anon_sym_isize] = ACTIONS(797),
    [anon_sym_usize] = ACTIONS(797),
    [anon_sym_f32] = ACTIONS(797),
    [anon_sym_f64] = ACTIONS(797),
    [anon_sym_bool] = ACTIONS(797),
    [anon_sym_str] = ACTIONS(797),
    [anon_sym_char] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(797),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(797),
    [anon_sym_BANG] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(797),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(799),
    [anon_sym_PIPE_PIPE] = ACTIONS(799),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_PLUS_EQ] = ACTIONS(799),
    [anon_sym_DASH_EQ] = ACTIONS(799),
    [anon_sym_STAR_EQ] = ACTIONS(799),
    [anon_sym_SLASH_EQ] = ACTIONS(799),
    [anon_sym_PERCENT_EQ] = ACTIONS(799),
    [anon_sym_CARET_EQ] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(799),
    [anon_sym_PIPE_EQ] = ACTIONS(799),
    [anon_sym_LT_LT_EQ] = ACTIONS(799),
    [anon_sym_GT_GT_EQ] = ACTIONS(799),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(799),
    [anon_sym_BANG_EQ] = ACTIONS(799),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT_EQ] = ACTIONS(799),
    [anon_sym_LT_EQ] = ACTIONS(799),
    [anon_sym_AT] = ACTIONS(799),
    [anon_sym__] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_DOT_DOT] = ACTIONS(797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(799),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(799),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(799),
    [anon_sym_POUND] = ACTIONS(799),
    [anon_sym_SQUOTE] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(797),
    [anon_sym_await] = ACTIONS(797),
    [anon_sym_break] = ACTIONS(797),
    [anon_sym_const] = ACTIONS(797),
    [anon_sym_continue] = ACTIONS(797),
    [anon_sym_default] = ACTIONS(797),
    [anon_sym_enum] = ACTIONS(797),
    [anon_sym_fn] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_if] = ACTIONS(797),
    [anon_sym_impl] = ACTIONS(797),
    [anon_sym_let] = ACTIONS(797),
    [anon_sym_loop] = ACTIONS(797),
    [anon_sym_match] = ACTIONS(797),
    [anon_sym_mod] = ACTIONS(797),
    [anon_sym_pub] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(797),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_struct] = ACTIONS(797),
    [anon_sym_trait] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_union] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(797),
    [anon_sym_use] = ACTIONS(797),
    [anon_sym_where] = ACTIONS(797),
    [anon_sym_while] = ACTIONS(797),
    [sym_mutable_specifier] = ACTIONS(797),
    [sym_integer_literal] = ACTIONS(799),
    [aux_sym_string_literal_token1] = ACTIONS(799),
    [sym_char_literal] = ACTIONS(799),
    [anon_sym_true] = ACTIONS(797),
    [anon_sym_false] = ACTIONS(797),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(797),
    [sym_super] = ACTIONS(797),
    [sym_crate] = ACTIONS(797),
    [sym__raw_string_literal_start] = ACTIONS(799),
    [sym_float_literal] = ACTIONS(799),
  },
  [188] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(188),
    [sym_block_comment] = STATE(188),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [189] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(189),
    [sym_block_comment] = STATE(189),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [190] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1827),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(190),
    [sym_block_comment] = STATE(190),
    [aux_sym_enum_variant_list_repeat1] = STATE(210),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [191] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2830),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2644),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(191),
    [sym_block_comment] = STATE(191),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [192] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1859),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_let_condition] = STATE(3257),
    [sym__let_chain] = STATE(3237),
    [sym__condition] = STATE(3341),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(192),
    [sym_block_comment] = STATE(192),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_let] = ACTIONS(1015),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [193] = {
    [sym_line_comment] = STATE(193),
    [sym_block_comment] = STATE(193),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_SEMI] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(787),
    [anon_sym_RPAREN] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(787),
    [anon_sym_RBRACK] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(787),
    [anon_sym_EQ_GT] = ACTIONS(787),
    [anon_sym_COLON] = ACTIONS(785),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_u8] = ACTIONS(785),
    [anon_sym_i8] = ACTIONS(785),
    [anon_sym_u16] = ACTIONS(785),
    [anon_sym_i16] = ACTIONS(785),
    [anon_sym_u32] = ACTIONS(785),
    [anon_sym_i32] = ACTIONS(785),
    [anon_sym_u64] = ACTIONS(785),
    [anon_sym_i64] = ACTIONS(785),
    [anon_sym_u128] = ACTIONS(785),
    [anon_sym_i128] = ACTIONS(785),
    [anon_sym_isize] = ACTIONS(785),
    [anon_sym_usize] = ACTIONS(785),
    [anon_sym_f32] = ACTIONS(785),
    [anon_sym_f64] = ACTIONS(785),
    [anon_sym_bool] = ACTIONS(785),
    [anon_sym_str] = ACTIONS(785),
    [anon_sym_char] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(785),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_PLUS_EQ] = ACTIONS(787),
    [anon_sym_DASH_EQ] = ACTIONS(787),
    [anon_sym_STAR_EQ] = ACTIONS(787),
    [anon_sym_SLASH_EQ] = ACTIONS(787),
    [anon_sym_PERCENT_EQ] = ACTIONS(787),
    [anon_sym_CARET_EQ] = ACTIONS(787),
    [anon_sym_AMP_EQ] = ACTIONS(787),
    [anon_sym_PIPE_EQ] = ACTIONS(787),
    [anon_sym_LT_LT_EQ] = ACTIONS(787),
    [anon_sym_GT_GT_EQ] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(787),
    [anon_sym_LT_EQ] = ACTIONS(787),
    [anon_sym_AT] = ACTIONS(787),
    [anon_sym__] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(787),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(787),
    [anon_sym_COMMA] = ACTIONS(787),
    [anon_sym_COLON_COLON] = ACTIONS(787),
    [anon_sym_DASH_GT] = ACTIONS(787),
    [anon_sym_POUND] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(785),
    [anon_sym_as] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_await] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_const] = ACTIONS(785),
    [anon_sym_continue] = ACTIONS(785),
    [anon_sym_default] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(785),
    [anon_sym_fn] = ACTIONS(785),
    [anon_sym_for] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(785),
    [anon_sym_impl] = ACTIONS(785),
    [anon_sym_let] = ACTIONS(785),
    [anon_sym_loop] = ACTIONS(785),
    [anon_sym_match] = ACTIONS(785),
    [anon_sym_mod] = ACTIONS(785),
    [anon_sym_pub] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(785),
    [anon_sym_static] = ACTIONS(785),
    [anon_sym_struct] = ACTIONS(785),
    [anon_sym_trait] = ACTIONS(785),
    [anon_sym_type] = ACTIONS(785),
    [anon_sym_union] = ACTIONS(785),
    [anon_sym_unsafe] = ACTIONS(785),
    [anon_sym_use] = ACTIONS(785),
    [anon_sym_where] = ACTIONS(785),
    [anon_sym_while] = ACTIONS(785),
    [sym_mutable_specifier] = ACTIONS(785),
    [sym_integer_literal] = ACTIONS(787),
    [aux_sym_string_literal_token1] = ACTIONS(787),
    [sym_char_literal] = ACTIONS(787),
    [anon_sym_true] = ACTIONS(785),
    [anon_sym_false] = ACTIONS(785),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(785),
    [sym_super] = ACTIONS(785),
    [sym_crate] = ACTIONS(785),
    [sym__raw_string_literal_start] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(787),
  },
  [194] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(194),
    [sym_block_comment] = STATE(194),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1017),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [195] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2830),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2512),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(195),
    [sym_block_comment] = STATE(195),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [196] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(196),
    [sym_block_comment] = STATE(196),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1019),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [197] = {
    [sym_line_comment] = STATE(197),
    [sym_block_comment] = STATE(197),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(1023),
    [anon_sym_RBRACK] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_RBRACE] = ACTIONS(1023),
    [anon_sym_EQ_GT] = ACTIONS(1023),
    [anon_sym_COLON] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1023),
    [anon_sym_u8] = ACTIONS(1021),
    [anon_sym_i8] = ACTIONS(1021),
    [anon_sym_u16] = ACTIONS(1021),
    [anon_sym_i16] = ACTIONS(1021),
    [anon_sym_u32] = ACTIONS(1021),
    [anon_sym_i32] = ACTIONS(1021),
    [anon_sym_u64] = ACTIONS(1021),
    [anon_sym_i64] = ACTIONS(1021),
    [anon_sym_u128] = ACTIONS(1021),
    [anon_sym_i128] = ACTIONS(1021),
    [anon_sym_isize] = ACTIONS(1021),
    [anon_sym_usize] = ACTIONS(1021),
    [anon_sym_f32] = ACTIONS(1021),
    [anon_sym_f64] = ACTIONS(1021),
    [anon_sym_bool] = ACTIONS(1021),
    [anon_sym_str] = ACTIONS(1021),
    [anon_sym_char] = ACTIONS(1021),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(1021),
    [anon_sym_CARET] = ACTIONS(1021),
    [anon_sym_BANG] = ACTIONS(1021),
    [anon_sym_AMP] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1021),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_PLUS_EQ] = ACTIONS(1023),
    [anon_sym_DASH_EQ] = ACTIONS(1023),
    [anon_sym_STAR_EQ] = ACTIONS(1023),
    [anon_sym_SLASH_EQ] = ACTIONS(1023),
    [anon_sym_PERCENT_EQ] = ACTIONS(1023),
    [anon_sym_CARET_EQ] = ACTIONS(1023),
    [anon_sym_AMP_EQ] = ACTIONS(1023),
    [anon_sym_PIPE_EQ] = ACTIONS(1023),
    [anon_sym_LT_LT_EQ] = ACTIONS(1023),
    [anon_sym_GT_GT_EQ] = ACTIONS(1023),
    [anon_sym_EQ] = ACTIONS(1021),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT_EQ] = ACTIONS(1023),
    [anon_sym_LT_EQ] = ACTIONS(1023),
    [anon_sym_AT] = ACTIONS(1023),
    [anon_sym__] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(1021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1023),
    [anon_sym_COMMA] = ACTIONS(1023),
    [anon_sym_COLON_COLON] = ACTIONS(1023),
    [anon_sym_DASH_GT] = ACTIONS(1023),
    [anon_sym_POUND] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1021),
    [anon_sym_as] = ACTIONS(1021),
    [anon_sym_async] = ACTIONS(1021),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_break] = ACTIONS(1021),
    [anon_sym_const] = ACTIONS(1021),
    [anon_sym_continue] = ACTIONS(1021),
    [anon_sym_default] = ACTIONS(1021),
    [anon_sym_enum] = ACTIONS(1021),
    [anon_sym_fn] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1021),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_impl] = ACTIONS(1021),
    [anon_sym_let] = ACTIONS(1021),
    [anon_sym_loop] = ACTIONS(1021),
    [anon_sym_match] = ACTIONS(1021),
    [anon_sym_mod] = ACTIONS(1021),
    [anon_sym_pub] = ACTIONS(1021),
    [anon_sym_return] = ACTIONS(1021),
    [anon_sym_static] = ACTIONS(1021),
    [anon_sym_struct] = ACTIONS(1021),
    [anon_sym_trait] = ACTIONS(1021),
    [anon_sym_type] = ACTIONS(1021),
    [anon_sym_union] = ACTIONS(1021),
    [anon_sym_unsafe] = ACTIONS(1021),
    [anon_sym_use] = ACTIONS(1021),
    [anon_sym_where] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1021),
    [sym_mutable_specifier] = ACTIONS(1021),
    [sym_integer_literal] = ACTIONS(1023),
    [aux_sym_string_literal_token1] = ACTIONS(1023),
    [sym_char_literal] = ACTIONS(1023),
    [anon_sym_true] = ACTIONS(1021),
    [anon_sym_false] = ACTIONS(1021),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1021),
    [sym_super] = ACTIONS(1021),
    [sym_crate] = ACTIONS(1021),
    [sym__raw_string_literal_start] = ACTIONS(1023),
    [sym_float_literal] = ACTIONS(1023),
  },
  [198] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(198),
    [sym_block_comment] = STATE(198),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [199] = {
    [sym_line_comment] = STATE(199),
    [sym_block_comment] = STATE(199),
    [sym_identifier] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_RBRACK] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_EQ_GT] = ACTIONS(959),
    [anon_sym_COLON] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_QMARK] = ACTIONS(959),
    [anon_sym_u8] = ACTIONS(957),
    [anon_sym_i8] = ACTIONS(957),
    [anon_sym_u16] = ACTIONS(957),
    [anon_sym_i16] = ACTIONS(957),
    [anon_sym_u32] = ACTIONS(957),
    [anon_sym_i32] = ACTIONS(957),
    [anon_sym_u64] = ACTIONS(957),
    [anon_sym_i64] = ACTIONS(957),
    [anon_sym_u128] = ACTIONS(957),
    [anon_sym_i128] = ACTIONS(957),
    [anon_sym_isize] = ACTIONS(957),
    [anon_sym_usize] = ACTIONS(957),
    [anon_sym_f32] = ACTIONS(957),
    [anon_sym_f64] = ACTIONS(957),
    [anon_sym_bool] = ACTIONS(957),
    [anon_sym_str] = ACTIONS(957),
    [anon_sym_char] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_SLASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(957),
    [anon_sym_PIPE] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(959),
    [anon_sym_PIPE_PIPE] = ACTIONS(959),
    [anon_sym_LT_LT] = ACTIONS(957),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_PLUS_EQ] = ACTIONS(959),
    [anon_sym_DASH_EQ] = ACTIONS(959),
    [anon_sym_STAR_EQ] = ACTIONS(959),
    [anon_sym_SLASH_EQ] = ACTIONS(959),
    [anon_sym_PERCENT_EQ] = ACTIONS(959),
    [anon_sym_CARET_EQ] = ACTIONS(959),
    [anon_sym_AMP_EQ] = ACTIONS(959),
    [anon_sym_PIPE_EQ] = ACTIONS(959),
    [anon_sym_LT_LT_EQ] = ACTIONS(959),
    [anon_sym_GT_GT_EQ] = ACTIONS(959),
    [anon_sym_EQ] = ACTIONS(957),
    [anon_sym_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(957),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym__] = ACTIONS(957),
    [anon_sym_DOT] = ACTIONS(957),
    [anon_sym_DOT_DOT] = ACTIONS(957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(959),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(959),
    [anon_sym_COMMA] = ACTIONS(959),
    [anon_sym_COLON_COLON] = ACTIONS(959),
    [anon_sym_DASH_GT] = ACTIONS(959),
    [anon_sym_POUND] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(957),
    [anon_sym_as] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_await] = ACTIONS(957),
    [anon_sym_break] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(957),
    [anon_sym_continue] = ACTIONS(957),
    [anon_sym_default] = ACTIONS(957),
    [anon_sym_enum] = ACTIONS(957),
    [anon_sym_fn] = ACTIONS(957),
    [anon_sym_for] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(957),
    [anon_sym_impl] = ACTIONS(957),
    [anon_sym_let] = ACTIONS(957),
    [anon_sym_loop] = ACTIONS(957),
    [anon_sym_match] = ACTIONS(957),
    [anon_sym_mod] = ACTIONS(957),
    [anon_sym_pub] = ACTIONS(957),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_static] = ACTIONS(957),
    [anon_sym_struct] = ACTIONS(957),
    [anon_sym_trait] = ACTIONS(957),
    [anon_sym_type] = ACTIONS(957),
    [anon_sym_union] = ACTIONS(957),
    [anon_sym_unsafe] = ACTIONS(957),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_where] = ACTIONS(957),
    [anon_sym_while] = ACTIONS(957),
    [sym_mutable_specifier] = ACTIONS(957),
    [sym_integer_literal] = ACTIONS(959),
    [aux_sym_string_literal_token1] = ACTIONS(959),
    [sym_char_literal] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(957),
    [anon_sym_false] = ACTIONS(957),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(957),
    [sym_super] = ACTIONS(957),
    [sym_crate] = ACTIONS(957),
    [sym__raw_string_literal_start] = ACTIONS(959),
    [sym_float_literal] = ACTIONS(959),
  },
  [200] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2830),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2652),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(200),
    [sym_block_comment] = STATE(200),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [201] = {
    [sym_line_comment] = STATE(201),
    [sym_block_comment] = STATE(201),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(819),
    [anon_sym_LBRACK] = ACTIONS(819),
    [anon_sym_RBRACK] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(819),
    [anon_sym_EQ_GT] = ACTIONS(819),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(819),
    [anon_sym_PLUS] = ACTIONS(817),
    [anon_sym_STAR] = ACTIONS(817),
    [anon_sym_QMARK] = ACTIONS(819),
    [anon_sym_u8] = ACTIONS(817),
    [anon_sym_i8] = ACTIONS(817),
    [anon_sym_u16] = ACTIONS(817),
    [anon_sym_i16] = ACTIONS(817),
    [anon_sym_u32] = ACTIONS(817),
    [anon_sym_i32] = ACTIONS(817),
    [anon_sym_u64] = ACTIONS(817),
    [anon_sym_i64] = ACTIONS(817),
    [anon_sym_u128] = ACTIONS(817),
    [anon_sym_i128] = ACTIONS(817),
    [anon_sym_isize] = ACTIONS(817),
    [anon_sym_usize] = ACTIONS(817),
    [anon_sym_f32] = ACTIONS(817),
    [anon_sym_f64] = ACTIONS(817),
    [anon_sym_bool] = ACTIONS(817),
    [anon_sym_str] = ACTIONS(817),
    [anon_sym_char] = ACTIONS(817),
    [anon_sym_DASH] = ACTIONS(817),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_PERCENT] = ACTIONS(817),
    [anon_sym_CARET] = ACTIONS(817),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(817),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(819),
    [anon_sym_LT_LT] = ACTIONS(817),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_PLUS_EQ] = ACTIONS(819),
    [anon_sym_DASH_EQ] = ACTIONS(819),
    [anon_sym_STAR_EQ] = ACTIONS(819),
    [anon_sym_SLASH_EQ] = ACTIONS(819),
    [anon_sym_PERCENT_EQ] = ACTIONS(819),
    [anon_sym_CARET_EQ] = ACTIONS(819),
    [anon_sym_AMP_EQ] = ACTIONS(819),
    [anon_sym_PIPE_EQ] = ACTIONS(819),
    [anon_sym_LT_LT_EQ] = ACTIONS(819),
    [anon_sym_GT_GT_EQ] = ACTIONS(819),
    [anon_sym_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(819),
    [anon_sym_BANG_EQ] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(819),
    [anon_sym_LT_EQ] = ACTIONS(819),
    [anon_sym_AT] = ACTIONS(819),
    [anon_sym__] = ACTIONS(817),
    [anon_sym_DOT] = ACTIONS(817),
    [anon_sym_DOT_DOT] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(819),
    [anon_sym_COLON_COLON] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(819),
    [anon_sym_POUND] = ACTIONS(819),
    [anon_sym_SQUOTE] = ACTIONS(817),
    [anon_sym_as] = ACTIONS(817),
    [anon_sym_async] = ACTIONS(817),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_break] = ACTIONS(817),
    [anon_sym_const] = ACTIONS(817),
    [anon_sym_continue] = ACTIONS(817),
    [anon_sym_default] = ACTIONS(817),
    [anon_sym_enum] = ACTIONS(817),
    [anon_sym_fn] = ACTIONS(817),
    [anon_sym_for] = ACTIONS(817),
    [anon_sym_if] = ACTIONS(817),
    [anon_sym_impl] = ACTIONS(817),
    [anon_sym_let] = ACTIONS(817),
    [anon_sym_loop] = ACTIONS(817),
    [anon_sym_match] = ACTIONS(817),
    [anon_sym_mod] = ACTIONS(817),
    [anon_sym_pub] = ACTIONS(817),
    [anon_sym_return] = ACTIONS(817),
    [anon_sym_static] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(817),
    [anon_sym_trait] = ACTIONS(817),
    [anon_sym_type] = ACTIONS(817),
    [anon_sym_union] = ACTIONS(817),
    [anon_sym_unsafe] = ACTIONS(817),
    [anon_sym_use] = ACTIONS(817),
    [anon_sym_where] = ACTIONS(817),
    [anon_sym_while] = ACTIONS(817),
    [sym_mutable_specifier] = ACTIONS(817),
    [sym_integer_literal] = ACTIONS(819),
    [aux_sym_string_literal_token1] = ACTIONS(819),
    [sym_char_literal] = ACTIONS(819),
    [anon_sym_true] = ACTIONS(817),
    [anon_sym_false] = ACTIONS(817),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(817),
    [sym_super] = ACTIONS(817),
    [sym_crate] = ACTIONS(817),
    [sym__raw_string_literal_start] = ACTIONS(819),
    [sym_float_literal] = ACTIONS(819),
  },
  [202] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2830),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2520),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(202),
    [sym_block_comment] = STATE(202),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [203] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(203),
    [sym_block_comment] = STATE(203),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [204] = {
    [sym_line_comment] = STATE(204),
    [sym_block_comment] = STATE(204),
    [sym_identifier] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1031),
    [anon_sym_RPAREN] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1031),
    [anon_sym_RBRACK] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [anon_sym_EQ_GT] = ACTIONS(1031),
    [anon_sym_COLON] = ACTIONS(1029),
    [anon_sym_DOLLAR] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1031),
    [anon_sym_u8] = ACTIONS(1029),
    [anon_sym_i8] = ACTIONS(1029),
    [anon_sym_u16] = ACTIONS(1029),
    [anon_sym_i16] = ACTIONS(1029),
    [anon_sym_u32] = ACTIONS(1029),
    [anon_sym_i32] = ACTIONS(1029),
    [anon_sym_u64] = ACTIONS(1029),
    [anon_sym_i64] = ACTIONS(1029),
    [anon_sym_u128] = ACTIONS(1029),
    [anon_sym_i128] = ACTIONS(1029),
    [anon_sym_isize] = ACTIONS(1029),
    [anon_sym_usize] = ACTIONS(1029),
    [anon_sym_f32] = ACTIONS(1029),
    [anon_sym_f64] = ACTIONS(1029),
    [anon_sym_bool] = ACTIONS(1029),
    [anon_sym_str] = ACTIONS(1029),
    [anon_sym_char] = ACTIONS(1029),
    [anon_sym_DASH] = ACTIONS(1029),
    [anon_sym_SLASH] = ACTIONS(1029),
    [anon_sym_PERCENT] = ACTIONS(1029),
    [anon_sym_CARET] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_AMP] = ACTIONS(1029),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_AMP_AMP] = ACTIONS(1031),
    [anon_sym_PIPE_PIPE] = ACTIONS(1031),
    [anon_sym_LT_LT] = ACTIONS(1029),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1031),
    [anon_sym_DASH_EQ] = ACTIONS(1031),
    [anon_sym_STAR_EQ] = ACTIONS(1031),
    [anon_sym_SLASH_EQ] = ACTIONS(1031),
    [anon_sym_PERCENT_EQ] = ACTIONS(1031),
    [anon_sym_CARET_EQ] = ACTIONS(1031),
    [anon_sym_AMP_EQ] = ACTIONS(1031),
    [anon_sym_PIPE_EQ] = ACTIONS(1031),
    [anon_sym_LT_LT_EQ] = ACTIONS(1031),
    [anon_sym_GT_GT_EQ] = ACTIONS(1031),
    [anon_sym_EQ] = ACTIONS(1029),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_GT] = ACTIONS(1029),
    [anon_sym_LT] = ACTIONS(1029),
    [anon_sym_GT_EQ] = ACTIONS(1031),
    [anon_sym_LT_EQ] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1031),
    [anon_sym__] = ACTIONS(1029),
    [anon_sym_DOT] = ACTIONS(1029),
    [anon_sym_DOT_DOT] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1031),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1031),
    [anon_sym_COLON_COLON] = ACTIONS(1031),
    [anon_sym_DASH_GT] = ACTIONS(1031),
    [anon_sym_POUND] = ACTIONS(1031),
    [anon_sym_SQUOTE] = ACTIONS(1029),
    [anon_sym_as] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1029),
    [anon_sym_break] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1029),
    [anon_sym_continue] = ACTIONS(1029),
    [anon_sym_default] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(1029),
    [anon_sym_fn] = ACTIONS(1029),
    [anon_sym_for] = ACTIONS(1029),
    [anon_sym_if] = ACTIONS(1029),
    [anon_sym_impl] = ACTIONS(1029),
    [anon_sym_let] = ACTIONS(1029),
    [anon_sym_loop] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1029),
    [anon_sym_mod] = ACTIONS(1029),
    [anon_sym_pub] = ACTIONS(1029),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_static] = ACTIONS(1029),
    [anon_sym_struct] = ACTIONS(1029),
    [anon_sym_trait] = ACTIONS(1029),
    [anon_sym_type] = ACTIONS(1029),
    [anon_sym_union] = ACTIONS(1029),
    [anon_sym_unsafe] = ACTIONS(1029),
    [anon_sym_use] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(1029),
    [anon_sym_while] = ACTIONS(1029),
    [sym_mutable_specifier] = ACTIONS(1029),
    [sym_integer_literal] = ACTIONS(1031),
    [aux_sym_string_literal_token1] = ACTIONS(1031),
    [sym_char_literal] = ACTIONS(1031),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1029),
    [sym_super] = ACTIONS(1029),
    [sym_crate] = ACTIONS(1029),
    [sym__raw_string_literal_start] = ACTIONS(1031),
    [sym_float_literal] = ACTIONS(1031),
  },
  [205] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2830),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2580),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(205),
    [sym_block_comment] = STATE(205),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [206] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(206),
    [sym_block_comment] = STATE(206),
    [aux_sym_enum_variant_list_repeat1] = STATE(211),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1033),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [207] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(207),
    [sym_block_comment] = STATE(207),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1035),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [208] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1687),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2830),
    [sym__let_chain] = STATE(2831),
    [sym__condition] = STATE(2604),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(208),
    [sym_block_comment] = STATE(208),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [209] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1629),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(209),
    [sym_block_comment] = STATE(209),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [210] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1871),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(210),
    [sym_block_comment] = STATE(210),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [211] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1862),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(211),
    [sym_block_comment] = STATE(211),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [212] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(212),
    [sym_block_comment] = STATE(212),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [213] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1628),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(213),
    [sym_block_comment] = STATE(213),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [214] = {
    [sym_attribute_item] = STATE(1003),
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1603),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(214),
    [sym_block_comment] = STATE(214),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [215] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1702),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_let_condition] = STATE(2573),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(215),
    [sym_block_comment] = STATE(215),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_let] = ACTIONS(1015),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [216] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1605),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1277),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(216),
    [sym_block_comment] = STATE(216),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1039),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_DASH_GT] = ACTIONS(1043),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [217] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1826),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(217),
    [sym_block_comment] = STATE(217),
    [aux_sym_tuple_expression_repeat1] = STATE(236),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [218] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1657),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1825),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(218),
    [sym_block_comment] = STATE(218),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1047),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_DASH_GT] = ACTIONS(1049),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [219] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1503),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1237),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(219),
    [sym_block_comment] = STATE(219),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1051),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [220] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1499),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1277),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(220),
    [sym_block_comment] = STATE(220),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1039),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1043),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [221] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1804),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1237),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(221),
    [sym_block_comment] = STATE(221),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1051),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_DASH_GT] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [222] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1707),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1277),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(222),
    [sym_block_comment] = STATE(222),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1039),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_DASH_GT] = ACTIONS(1043),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [223] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1826),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(223),
    [sym_block_comment] = STATE(223),
    [aux_sym_tuple_expression_repeat1] = STATE(235),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [224] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1812),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1767),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(224),
    [sym_block_comment] = STATE(224),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1063),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_DASH_GT] = ACTIONS(1065),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [225] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1688),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(225),
    [sym_block_comment] = STATE(225),
    [aux_sym_tuple_expression_repeat1] = STATE(233),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [226] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1688),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(226),
    [sym_block_comment] = STATE(226),
    [aux_sym_tuple_expression_repeat1] = STATE(235),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [227] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1747),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(227),
    [sym_block_comment] = STATE(227),
    [aux_sym_tuple_expression_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [228] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1717),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(228),
    [sym_block_comment] = STATE(228),
    [aux_sym_tuple_expression_repeat1] = STATE(223),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [229] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1617),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1439),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(229),
    [sym_block_comment] = STATE(229),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_DASH_GT] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [230] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1738),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2573),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(230),
    [sym_block_comment] = STATE(230),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [231] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1755),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1237),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(231),
    [sym_block_comment] = STATE(231),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1051),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [232] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1721),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1791),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(232),
    [sym_block_comment] = STATE(232),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1077),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_DASH_GT] = ACTIONS(1079),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [233] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1760),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(233),
    [sym_block_comment] = STATE(233),
    [aux_sym_tuple_expression_repeat1] = STATE(235),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [234] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1483),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1439),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(234),
    [sym_block_comment] = STATE(234),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [235] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1844),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(235),
    [sym_block_comment] = STATE(235),
    [aux_sym_tuple_expression_repeat1] = STATE(235),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_u8] = ACTIONS(1100),
    [anon_sym_i8] = ACTIONS(1100),
    [anon_sym_u16] = ACTIONS(1100),
    [anon_sym_i16] = ACTIONS(1100),
    [anon_sym_u32] = ACTIONS(1100),
    [anon_sym_i32] = ACTIONS(1100),
    [anon_sym_u64] = ACTIONS(1100),
    [anon_sym_i64] = ACTIONS(1100),
    [anon_sym_u128] = ACTIONS(1100),
    [anon_sym_i128] = ACTIONS(1100),
    [anon_sym_isize] = ACTIONS(1100),
    [anon_sym_usize] = ACTIONS(1100),
    [anon_sym_f32] = ACTIONS(1100),
    [anon_sym_f64] = ACTIONS(1100),
    [anon_sym_bool] = ACTIONS(1100),
    [anon_sym_str] = ACTIONS(1100),
    [anon_sym_char] = ACTIONS(1100),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1106),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_DOT_DOT] = ACTIONS(1112),
    [anon_sym_COLON_COLON] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1118),
    [anon_sym_async] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(1124),
    [anon_sym_const] = ACTIONS(1127),
    [anon_sym_continue] = ACTIONS(1130),
    [anon_sym_default] = ACTIONS(1133),
    [anon_sym_for] = ACTIONS(1136),
    [anon_sym_if] = ACTIONS(1139),
    [anon_sym_loop] = ACTIONS(1142),
    [anon_sym_match] = ACTIONS(1145),
    [anon_sym_return] = ACTIONS(1148),
    [anon_sym_static] = ACTIONS(1151),
    [anon_sym_union] = ACTIONS(1133),
    [anon_sym_unsafe] = ACTIONS(1154),
    [anon_sym_while] = ACTIONS(1157),
    [anon_sym_yield] = ACTIONS(1160),
    [anon_sym_move] = ACTIONS(1163),
    [anon_sym_try] = ACTIONS(1166),
    [sym_integer_literal] = ACTIONS(1169),
    [aux_sym_string_literal_token1] = ACTIONS(1172),
    [sym_char_literal] = ACTIONS(1169),
    [anon_sym_true] = ACTIONS(1175),
    [anon_sym_false] = ACTIONS(1175),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1178),
    [sym_super] = ACTIONS(1181),
    [sym_crate] = ACTIONS(1181),
    [sym_metavariable] = ACTIONS(1184),
    [sym__raw_string_literal_start] = ACTIONS(1187),
    [sym_float_literal] = ACTIONS(1169),
  },
  [236] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1807),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(236),
    [sym_block_comment] = STATE(236),
    [aux_sym_tuple_expression_repeat1] = STATE(235),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1190),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [237] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1847),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_let_condition] = STATE(2573),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(237),
    [sym_block_comment] = STATE(237),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_let] = ACTIONS(1015),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [238] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1573),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1237),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(238),
    [sym_block_comment] = STATE(238),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1051),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_DASH_GT] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [239] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1668),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1277),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(239),
    [sym_block_comment] = STATE(239),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1039),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1043),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [240] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1795),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1439),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(240),
    [sym_block_comment] = STATE(240),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [241] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1670),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1439),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(241),
    [sym_block_comment] = STATE(241),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_DASH_GT] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [242] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1596),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_let_condition] = STATE(2573),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(242),
    [sym_block_comment] = STATE(242),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [243] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1357),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(243),
    [sym_block_comment] = STATE(243),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [sym_mutable_specifier] = ACTIONS(1192),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [244] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1357),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(244),
    [sym_block_comment] = STATE(244),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [sym_mutable_specifier] = ACTIONS(1194),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [245] = {
    [sym_else_clause] = STATE(393),
    [sym_line_comment] = STATE(245),
    [sym_block_comment] = STATE(245),
    [ts_builtin_sym_end] = ACTIONS(1196),
    [sym_identifier] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1196),
    [anon_sym_macro_rules_BANG] = ACTIONS(1196),
    [anon_sym_LPAREN] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(1196),
    [anon_sym_RBRACE] = ACTIONS(1196),
    [anon_sym_PLUS] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1196),
    [anon_sym_u8] = ACTIONS(1198),
    [anon_sym_i8] = ACTIONS(1198),
    [anon_sym_u16] = ACTIONS(1198),
    [anon_sym_i16] = ACTIONS(1198),
    [anon_sym_u32] = ACTIONS(1198),
    [anon_sym_i32] = ACTIONS(1198),
    [anon_sym_u64] = ACTIONS(1198),
    [anon_sym_i64] = ACTIONS(1198),
    [anon_sym_u128] = ACTIONS(1198),
    [anon_sym_i128] = ACTIONS(1198),
    [anon_sym_isize] = ACTIONS(1198),
    [anon_sym_usize] = ACTIONS(1198),
    [anon_sym_f32] = ACTIONS(1198),
    [anon_sym_f64] = ACTIONS(1198),
    [anon_sym_bool] = ACTIONS(1198),
    [anon_sym_str] = ACTIONS(1198),
    [anon_sym_char] = ACTIONS(1198),
    [anon_sym_DASH] = ACTIONS(1198),
    [anon_sym_SLASH] = ACTIONS(1198),
    [anon_sym_PERCENT] = ACTIONS(1198),
    [anon_sym_CARET] = ACTIONS(1198),
    [anon_sym_BANG] = ACTIONS(1198),
    [anon_sym_AMP] = ACTIONS(1198),
    [anon_sym_PIPE] = ACTIONS(1198),
    [anon_sym_AMP_AMP] = ACTIONS(1196),
    [anon_sym_PIPE_PIPE] = ACTIONS(1196),
    [anon_sym_LT_LT] = ACTIONS(1198),
    [anon_sym_GT_GT] = ACTIONS(1198),
    [anon_sym_PLUS_EQ] = ACTIONS(1196),
    [anon_sym_DASH_EQ] = ACTIONS(1196),
    [anon_sym_STAR_EQ] = ACTIONS(1196),
    [anon_sym_SLASH_EQ] = ACTIONS(1196),
    [anon_sym_PERCENT_EQ] = ACTIONS(1196),
    [anon_sym_CARET_EQ] = ACTIONS(1196),
    [anon_sym_AMP_EQ] = ACTIONS(1196),
    [anon_sym_PIPE_EQ] = ACTIONS(1196),
    [anon_sym_LT_LT_EQ] = ACTIONS(1196),
    [anon_sym_GT_GT_EQ] = ACTIONS(1196),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_EQ_EQ] = ACTIONS(1196),
    [anon_sym_BANG_EQ] = ACTIONS(1196),
    [anon_sym_GT] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_GT_EQ] = ACTIONS(1196),
    [anon_sym_LT_EQ] = ACTIONS(1196),
    [anon_sym_DOT] = ACTIONS(1198),
    [anon_sym_DOT_DOT] = ACTIONS(1198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1196),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1196),
    [anon_sym_COLON_COLON] = ACTIONS(1196),
    [anon_sym_POUND] = ACTIONS(1196),
    [anon_sym_SQUOTE] = ACTIONS(1198),
    [anon_sym_as] = ACTIONS(1198),
    [anon_sym_async] = ACTIONS(1198),
    [anon_sym_break] = ACTIONS(1198),
    [anon_sym_const] = ACTIONS(1198),
    [anon_sym_continue] = ACTIONS(1198),
    [anon_sym_default] = ACTIONS(1198),
    [anon_sym_enum] = ACTIONS(1198),
    [anon_sym_fn] = ACTIONS(1198),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_impl] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(1198),
    [anon_sym_loop] = ACTIONS(1198),
    [anon_sym_match] = ACTIONS(1198),
    [anon_sym_mod] = ACTIONS(1198),
    [anon_sym_pub] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(1198),
    [anon_sym_static] = ACTIONS(1198),
    [anon_sym_struct] = ACTIONS(1198),
    [anon_sym_trait] = ACTIONS(1198),
    [anon_sym_type] = ACTIONS(1198),
    [anon_sym_union] = ACTIONS(1198),
    [anon_sym_unsafe] = ACTIONS(1198),
    [anon_sym_use] = ACTIONS(1198),
    [anon_sym_while] = ACTIONS(1198),
    [anon_sym_extern] = ACTIONS(1198),
    [anon_sym_else] = ACTIONS(1200),
    [anon_sym_yield] = ACTIONS(1198),
    [anon_sym_move] = ACTIONS(1198),
    [anon_sym_try] = ACTIONS(1198),
    [sym_integer_literal] = ACTIONS(1196),
    [aux_sym_string_literal_token1] = ACTIONS(1196),
    [sym_char_literal] = ACTIONS(1196),
    [anon_sym_true] = ACTIONS(1198),
    [anon_sym_false] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1198),
    [sym_super] = ACTIONS(1198),
    [sym_crate] = ACTIONS(1198),
    [sym_metavariable] = ACTIONS(1196),
    [sym__raw_string_literal_start] = ACTIONS(1196),
    [sym_float_literal] = ACTIONS(1196),
  },
  [246] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1708),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(246),
    [sym_block_comment] = STATE(246),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [sym_mutable_specifier] = ACTIONS(1202),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [247] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1357),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(247),
    [sym_block_comment] = STATE(247),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [sym_mutable_specifier] = ACTIONS(1204),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [248] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1843),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(248),
    [sym_block_comment] = STATE(248),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [249] = {
    [sym_line_comment] = STATE(249),
    [sym_block_comment] = STATE(249),
    [ts_builtin_sym_end] = ACTIONS(1206),
    [sym_identifier] = ACTIONS(1208),
    [anon_sym_SEMI] = ACTIONS(1206),
    [anon_sym_macro_rules_BANG] = ACTIONS(1206),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_LBRACK] = ACTIONS(1206),
    [anon_sym_LBRACE] = ACTIONS(1206),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_PLUS] = ACTIONS(1208),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_QMARK] = ACTIONS(1206),
    [anon_sym_u8] = ACTIONS(1208),
    [anon_sym_i8] = ACTIONS(1208),
    [anon_sym_u16] = ACTIONS(1208),
    [anon_sym_i16] = ACTIONS(1208),
    [anon_sym_u32] = ACTIONS(1208),
    [anon_sym_i32] = ACTIONS(1208),
    [anon_sym_u64] = ACTIONS(1208),
    [anon_sym_i64] = ACTIONS(1208),
    [anon_sym_u128] = ACTIONS(1208),
    [anon_sym_i128] = ACTIONS(1208),
    [anon_sym_isize] = ACTIONS(1208),
    [anon_sym_usize] = ACTIONS(1208),
    [anon_sym_f32] = ACTIONS(1208),
    [anon_sym_f64] = ACTIONS(1208),
    [anon_sym_bool] = ACTIONS(1208),
    [anon_sym_str] = ACTIONS(1208),
    [anon_sym_char] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1208),
    [anon_sym_CARET] = ACTIONS(1208),
    [anon_sym_BANG] = ACTIONS(1208),
    [anon_sym_AMP] = ACTIONS(1208),
    [anon_sym_PIPE] = ACTIONS(1208),
    [anon_sym_AMP_AMP] = ACTIONS(1206),
    [anon_sym_PIPE_PIPE] = ACTIONS(1206),
    [anon_sym_LT_LT] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(1208),
    [anon_sym_PLUS_EQ] = ACTIONS(1206),
    [anon_sym_DASH_EQ] = ACTIONS(1206),
    [anon_sym_STAR_EQ] = ACTIONS(1206),
    [anon_sym_SLASH_EQ] = ACTIONS(1206),
    [anon_sym_PERCENT_EQ] = ACTIONS(1206),
    [anon_sym_CARET_EQ] = ACTIONS(1206),
    [anon_sym_AMP_EQ] = ACTIONS(1206),
    [anon_sym_PIPE_EQ] = ACTIONS(1206),
    [anon_sym_LT_LT_EQ] = ACTIONS(1206),
    [anon_sym_GT_GT_EQ] = ACTIONS(1206),
    [anon_sym_EQ] = ACTIONS(1208),
    [anon_sym_EQ_EQ] = ACTIONS(1206),
    [anon_sym_BANG_EQ] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1208),
    [anon_sym_LT] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(1206),
    [anon_sym_LT_EQ] = ACTIONS(1206),
    [anon_sym_DOT] = ACTIONS(1208),
    [anon_sym_DOT_DOT] = ACTIONS(1208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1206),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(1206),
    [anon_sym_POUND] = ACTIONS(1206),
    [anon_sym_SQUOTE] = ACTIONS(1208),
    [anon_sym_as] = ACTIONS(1208),
    [anon_sym_async] = ACTIONS(1208),
    [anon_sym_break] = ACTIONS(1208),
    [anon_sym_const] = ACTIONS(1208),
    [anon_sym_continue] = ACTIONS(1208),
    [anon_sym_default] = ACTIONS(1208),
    [anon_sym_enum] = ACTIONS(1208),
    [anon_sym_fn] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1208),
    [anon_sym_if] = ACTIONS(1208),
    [anon_sym_impl] = ACTIONS(1208),
    [anon_sym_let] = ACTIONS(1208),
    [anon_sym_loop] = ACTIONS(1208),
    [anon_sym_match] = ACTIONS(1208),
    [anon_sym_mod] = ACTIONS(1208),
    [anon_sym_pub] = ACTIONS(1208),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_static] = ACTIONS(1208),
    [anon_sym_struct] = ACTIONS(1208),
    [anon_sym_trait] = ACTIONS(1208),
    [anon_sym_type] = ACTIONS(1208),
    [anon_sym_union] = ACTIONS(1208),
    [anon_sym_unsafe] = ACTIONS(1208),
    [anon_sym_use] = ACTIONS(1208),
    [anon_sym_while] = ACTIONS(1208),
    [anon_sym_extern] = ACTIONS(1208),
    [anon_sym_else] = ACTIONS(1208),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_move] = ACTIONS(1208),
    [anon_sym_try] = ACTIONS(1208),
    [sym_integer_literal] = ACTIONS(1206),
    [aux_sym_string_literal_token1] = ACTIONS(1206),
    [sym_char_literal] = ACTIONS(1206),
    [anon_sym_true] = ACTIONS(1208),
    [anon_sym_false] = ACTIONS(1208),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1208),
    [sym_super] = ACTIONS(1208),
    [sym_crate] = ACTIONS(1208),
    [sym_metavariable] = ACTIONS(1206),
    [sym__raw_string_literal_start] = ACTIONS(1206),
    [sym_float_literal] = ACTIONS(1206),
  },
  [250] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1640),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(250),
    [sym_block_comment] = STATE(250),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [251] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1666),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(251),
    [sym_block_comment] = STATE(251),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [252] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1840),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(252),
    [sym_block_comment] = STATE(252),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [253] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1354),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(253),
    [sym_block_comment] = STATE(253),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [254] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1853),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(254),
    [sym_block_comment] = STATE(254),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [255] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1793),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(255),
    [sym_block_comment] = STATE(255),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [256] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1842),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(256),
    [sym_block_comment] = STATE(256),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [257] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1425),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(257),
    [sym_block_comment] = STATE(257),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [258] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1874),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(258),
    [sym_block_comment] = STATE(258),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [259] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1766),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(259),
    [sym_block_comment] = STATE(259),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [260] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1868),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(260),
    [sym_block_comment] = STATE(260),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [261] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1500),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(261),
    [sym_block_comment] = STATE(261),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [262] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1440),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(262),
    [sym_block_comment] = STATE(262),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [263] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(263),
    [sym_block_comment] = STATE(263),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [264] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1493),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(264),
    [sym_block_comment] = STATE(264),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [265] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1484),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(265),
    [sym_block_comment] = STATE(265),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [266] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1485),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(266),
    [sym_block_comment] = STATE(266),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [267] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1486),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(267),
    [sym_block_comment] = STATE(267),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [268] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1487),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(268),
    [sym_block_comment] = STATE(268),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [269] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1498),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(269),
    [sym_block_comment] = STATE(269),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [270] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1488),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(270),
    [sym_block_comment] = STATE(270),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [271] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1489),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(271),
    [sym_block_comment] = STATE(271),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [272] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1490),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(272),
    [sym_block_comment] = STATE(272),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [273] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1857),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(273),
    [sym_block_comment] = STATE(273),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [274] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1647),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(274),
    [sym_block_comment] = STATE(274),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [275] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1482),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(275),
    [sym_block_comment] = STATE(275),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [276] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1354),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(276),
    [sym_block_comment] = STATE(276),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [277] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1855),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(277),
    [sym_block_comment] = STATE(277),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [278] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1778),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(278),
    [sym_block_comment] = STATE(278),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [279] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1354),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(279),
    [sym_block_comment] = STATE(279),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [280] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1757),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(280),
    [sym_block_comment] = STATE(280),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [281] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1850),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(463),
    [sym_match_expression] = STATE(463),
    [sym_while_expression] = STATE(463),
    [sym_loop_expression] = STATE(463),
    [sym_for_expression] = STATE(463),
    [sym_const_block] = STATE(463),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3585),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(463),
    [sym_async_block] = STATE(463),
    [sym_try_block] = STATE(463),
    [sym_block] = STATE(463),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(281),
    [sym_block_comment] = STATE(281),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(1212),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1220),
    [anon_sym_loop] = ACTIONS(1222),
    [anon_sym_match] = ACTIONS(1224),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(1226),
    [anon_sym_while] = ACTIONS(1228),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(1230),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [282] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1873),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(282),
    [sym_block_comment] = STATE(282),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [283] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1851),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(283),
    [sym_block_comment] = STATE(283),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [284] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1696),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(284),
    [sym_block_comment] = STATE(284),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [285] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1556),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(285),
    [sym_block_comment] = STATE(285),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [286] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1674),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(286),
    [sym_block_comment] = STATE(286),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [287] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1805),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(287),
    [sym_block_comment] = STATE(287),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [288] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1648),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(288),
    [sym_block_comment] = STATE(288),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [289] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1678),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(289),
    [sym_block_comment] = STATE(289),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [290] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1440),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(290),
    [sym_block_comment] = STATE(290),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [291] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1777),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(463),
    [sym_match_expression] = STATE(463),
    [sym_while_expression] = STATE(463),
    [sym_loop_expression] = STATE(463),
    [sym_for_expression] = STATE(463),
    [sym_const_block] = STATE(463),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3585),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(463),
    [sym_async_block] = STATE(463),
    [sym_try_block] = STATE(463),
    [sym_block] = STATE(463),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(291),
    [sym_block_comment] = STATE(291),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(1212),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1220),
    [anon_sym_loop] = ACTIONS(1222),
    [anon_sym_match] = ACTIONS(1224),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(1226),
    [anon_sym_while] = ACTIONS(1228),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(1230),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [292] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1676),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(292),
    [sym_block_comment] = STATE(292),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [293] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1664),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(293),
    [sym_block_comment] = STATE(293),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [294] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1854),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(294),
    [sym_block_comment] = STATE(294),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [295] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1681),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(295),
    [sym_block_comment] = STATE(295),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [296] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1655),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(296),
    [sym_block_comment] = STATE(296),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [297] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1869),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(297),
    [sym_block_comment] = STATE(297),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [298] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1596),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(298),
    [sym_block_comment] = STATE(298),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [299] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1841),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(299),
    [sym_block_comment] = STATE(299),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [300] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1870),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(300),
    [sym_block_comment] = STATE(300),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [301] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1775),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(301),
    [sym_block_comment] = STATE(301),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [302] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1733),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(456),
    [sym_match_expression] = STATE(456),
    [sym_while_expression] = STATE(456),
    [sym_loop_expression] = STATE(456),
    [sym_for_expression] = STATE(456),
    [sym_const_block] = STATE(456),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3585),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(456),
    [sym_async_block] = STATE(456),
    [sym_try_block] = STATE(456),
    [sym_block] = STATE(456),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(302),
    [sym_block_comment] = STATE(302),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(1212),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1220),
    [anon_sym_loop] = ACTIONS(1222),
    [anon_sym_match] = ACTIONS(1224),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(1226),
    [anon_sym_while] = ACTIONS(1228),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(1230),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [303] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1864),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(303),
    [sym_block_comment] = STATE(303),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [304] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1650),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(304),
    [sym_block_comment] = STATE(304),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [305] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1856),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(305),
    [sym_block_comment] = STATE(305),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [306] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1872),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(306),
    [sym_block_comment] = STATE(306),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [307] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1546),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(307),
    [sym_block_comment] = STATE(307),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [308] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1661),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(308),
    [sym_block_comment] = STATE(308),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [309] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1715),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(309),
    [sym_block_comment] = STATE(309),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [310] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1567),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(310),
    [sym_block_comment] = STATE(310),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [311] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1677),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(311),
    [sym_block_comment] = STATE(311),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [312] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1639),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(312),
    [sym_block_comment] = STATE(312),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [313] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1713),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(313),
    [sym_block_comment] = STATE(313),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [314] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1814),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(314),
    [sym_block_comment] = STATE(314),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [315] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1706),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(315),
    [sym_block_comment] = STATE(315),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [316] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1542),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(316),
    [sym_block_comment] = STATE(316),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [317] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1818),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(317),
    [sym_block_comment] = STATE(317),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [318] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1838),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(318),
    [sym_block_comment] = STATE(318),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [319] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1651),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(319),
    [sym_block_comment] = STATE(319),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [320] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1587),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(320),
    [sym_block_comment] = STATE(320),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [321] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1693),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(321),
    [sym_block_comment] = STATE(321),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [322] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1754),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(322),
    [sym_block_comment] = STATE(322),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [323] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1875),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(456),
    [sym_match_expression] = STATE(456),
    [sym_while_expression] = STATE(456),
    [sym_loop_expression] = STATE(456),
    [sym_for_expression] = STATE(456),
    [sym_const_block] = STATE(456),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3585),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(456),
    [sym_async_block] = STATE(456),
    [sym_try_block] = STATE(456),
    [sym_block] = STATE(456),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(323),
    [sym_block_comment] = STATE(323),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(1212),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1220),
    [anon_sym_loop] = ACTIONS(1222),
    [anon_sym_match] = ACTIONS(1224),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(1226),
    [anon_sym_while] = ACTIONS(1228),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(1230),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [324] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1425),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(324),
    [sym_block_comment] = STATE(324),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [325] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1587),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(325),
    [sym_block_comment] = STATE(325),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [326] = {
    [sym_line_comment] = STATE(326),
    [sym_block_comment] = STATE(326),
    [ts_builtin_sym_end] = ACTIONS(1232),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_SEMI] = ACTIONS(1232),
    [anon_sym_macro_rules_BANG] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_LBRACE] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1234),
    [anon_sym_QMARK] = ACTIONS(1232),
    [anon_sym_u8] = ACTIONS(1234),
    [anon_sym_i8] = ACTIONS(1234),
    [anon_sym_u16] = ACTIONS(1234),
    [anon_sym_i16] = ACTIONS(1234),
    [anon_sym_u32] = ACTIONS(1234),
    [anon_sym_i32] = ACTIONS(1234),
    [anon_sym_u64] = ACTIONS(1234),
    [anon_sym_i64] = ACTIONS(1234),
    [anon_sym_u128] = ACTIONS(1234),
    [anon_sym_i128] = ACTIONS(1234),
    [anon_sym_isize] = ACTIONS(1234),
    [anon_sym_usize] = ACTIONS(1234),
    [anon_sym_f32] = ACTIONS(1234),
    [anon_sym_f64] = ACTIONS(1234),
    [anon_sym_bool] = ACTIONS(1234),
    [anon_sym_str] = ACTIONS(1234),
    [anon_sym_char] = ACTIONS(1234),
    [anon_sym_DASH] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(1234),
    [anon_sym_PERCENT] = ACTIONS(1234),
    [anon_sym_CARET] = ACTIONS(1234),
    [anon_sym_BANG] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1234),
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1232),
    [anon_sym_PIPE_PIPE] = ACTIONS(1232),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(1232),
    [anon_sym_DASH_EQ] = ACTIONS(1232),
    [anon_sym_STAR_EQ] = ACTIONS(1232),
    [anon_sym_SLASH_EQ] = ACTIONS(1232),
    [anon_sym_PERCENT_EQ] = ACTIONS(1232),
    [anon_sym_CARET_EQ] = ACTIONS(1232),
    [anon_sym_AMP_EQ] = ACTIONS(1232),
    [anon_sym_PIPE_EQ] = ACTIONS(1232),
    [anon_sym_LT_LT_EQ] = ACTIONS(1232),
    [anon_sym_GT_GT_EQ] = ACTIONS(1232),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_EQ_EQ] = ACTIONS(1232),
    [anon_sym_BANG_EQ] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_LT] = ACTIONS(1234),
    [anon_sym_GT_EQ] = ACTIONS(1232),
    [anon_sym_LT_EQ] = ACTIONS(1232),
    [anon_sym_DOT] = ACTIONS(1234),
    [anon_sym_DOT_DOT] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1232),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1232),
    [anon_sym_SQUOTE] = ACTIONS(1234),
    [anon_sym_as] = ACTIONS(1234),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_break] = ACTIONS(1234),
    [anon_sym_const] = ACTIONS(1234),
    [anon_sym_continue] = ACTIONS(1234),
    [anon_sym_default] = ACTIONS(1234),
    [anon_sym_enum] = ACTIONS(1234),
    [anon_sym_fn] = ACTIONS(1234),
    [anon_sym_for] = ACTIONS(1234),
    [anon_sym_if] = ACTIONS(1234),
    [anon_sym_impl] = ACTIONS(1234),
    [anon_sym_let] = ACTIONS(1234),
    [anon_sym_loop] = ACTIONS(1234),
    [anon_sym_match] = ACTIONS(1234),
    [anon_sym_mod] = ACTIONS(1234),
    [anon_sym_pub] = ACTIONS(1234),
    [anon_sym_return] = ACTIONS(1234),
    [anon_sym_static] = ACTIONS(1234),
    [anon_sym_struct] = ACTIONS(1234),
    [anon_sym_trait] = ACTIONS(1234),
    [anon_sym_type] = ACTIONS(1234),
    [anon_sym_union] = ACTIONS(1234),
    [anon_sym_unsafe] = ACTIONS(1234),
    [anon_sym_use] = ACTIONS(1234),
    [anon_sym_while] = ACTIONS(1234),
    [anon_sym_extern] = ACTIONS(1234),
    [anon_sym_else] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1234),
    [anon_sym_move] = ACTIONS(1234),
    [anon_sym_try] = ACTIONS(1234),
    [sym_integer_literal] = ACTIONS(1232),
    [aux_sym_string_literal_token1] = ACTIONS(1232),
    [sym_char_literal] = ACTIONS(1232),
    [anon_sym_true] = ACTIONS(1234),
    [anon_sym_false] = ACTIONS(1234),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1234),
    [sym_super] = ACTIONS(1234),
    [sym_crate] = ACTIONS(1234),
    [sym_metavariable] = ACTIONS(1232),
    [sym__raw_string_literal_start] = ACTIONS(1232),
    [sym_float_literal] = ACTIONS(1232),
  },
  [327] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1865),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(327),
    [sym_block_comment] = STATE(327),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [328] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1789),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(328),
    [sym_block_comment] = STATE(328),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [329] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1860),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(329),
    [sym_block_comment] = STATE(329),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [330] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1694),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(330),
    [sym_block_comment] = STATE(330),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [331] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1699),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(331),
    [sym_block_comment] = STATE(331),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [332] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1852),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(332),
    [sym_block_comment] = STATE(332),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [333] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1561),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(333),
    [sym_block_comment] = STATE(333),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [334] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1569),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(334),
    [sym_block_comment] = STATE(334),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [335] = {
    [sym_line_comment] = STATE(335),
    [sym_block_comment] = STATE(335),
    [ts_builtin_sym_end] = ACTIONS(1236),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_SEMI] = ACTIONS(1236),
    [anon_sym_macro_rules_BANG] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LBRACE] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_QMARK] = ACTIONS(1236),
    [anon_sym_u8] = ACTIONS(1238),
    [anon_sym_i8] = ACTIONS(1238),
    [anon_sym_u16] = ACTIONS(1238),
    [anon_sym_i16] = ACTIONS(1238),
    [anon_sym_u32] = ACTIONS(1238),
    [anon_sym_i32] = ACTIONS(1238),
    [anon_sym_u64] = ACTIONS(1238),
    [anon_sym_i64] = ACTIONS(1238),
    [anon_sym_u128] = ACTIONS(1238),
    [anon_sym_i128] = ACTIONS(1238),
    [anon_sym_isize] = ACTIONS(1238),
    [anon_sym_usize] = ACTIONS(1238),
    [anon_sym_f32] = ACTIONS(1238),
    [anon_sym_f64] = ACTIONS(1238),
    [anon_sym_bool] = ACTIONS(1238),
    [anon_sym_str] = ACTIONS(1238),
    [anon_sym_char] = ACTIONS(1238),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(1238),
    [anon_sym_PERCENT] = ACTIONS(1238),
    [anon_sym_CARET] = ACTIONS(1238),
    [anon_sym_BANG] = ACTIONS(1238),
    [anon_sym_AMP] = ACTIONS(1238),
    [anon_sym_PIPE] = ACTIONS(1238),
    [anon_sym_AMP_AMP] = ACTIONS(1236),
    [anon_sym_PIPE_PIPE] = ACTIONS(1236),
    [anon_sym_LT_LT] = ACTIONS(1238),
    [anon_sym_GT_GT] = ACTIONS(1238),
    [anon_sym_PLUS_EQ] = ACTIONS(1236),
    [anon_sym_DASH_EQ] = ACTIONS(1236),
    [anon_sym_STAR_EQ] = ACTIONS(1236),
    [anon_sym_SLASH_EQ] = ACTIONS(1236),
    [anon_sym_PERCENT_EQ] = ACTIONS(1236),
    [anon_sym_CARET_EQ] = ACTIONS(1236),
    [anon_sym_AMP_EQ] = ACTIONS(1236),
    [anon_sym_PIPE_EQ] = ACTIONS(1236),
    [anon_sym_LT_LT_EQ] = ACTIONS(1236),
    [anon_sym_GT_GT_EQ] = ACTIONS(1236),
    [anon_sym_EQ] = ACTIONS(1238),
    [anon_sym_EQ_EQ] = ACTIONS(1236),
    [anon_sym_BANG_EQ] = ACTIONS(1236),
    [anon_sym_GT] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT_EQ] = ACTIONS(1236),
    [anon_sym_LT_EQ] = ACTIONS(1236),
    [anon_sym_DOT] = ACTIONS(1238),
    [anon_sym_DOT_DOT] = ACTIONS(1238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1236),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1236),
    [anon_sym_COLON_COLON] = ACTIONS(1236),
    [anon_sym_POUND] = ACTIONS(1236),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_as] = ACTIONS(1238),
    [anon_sym_async] = ACTIONS(1238),
    [anon_sym_break] = ACTIONS(1238),
    [anon_sym_const] = ACTIONS(1238),
    [anon_sym_continue] = ACTIONS(1238),
    [anon_sym_default] = ACTIONS(1238),
    [anon_sym_enum] = ACTIONS(1238),
    [anon_sym_fn] = ACTIONS(1238),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_if] = ACTIONS(1238),
    [anon_sym_impl] = ACTIONS(1238),
    [anon_sym_let] = ACTIONS(1238),
    [anon_sym_loop] = ACTIONS(1238),
    [anon_sym_match] = ACTIONS(1238),
    [anon_sym_mod] = ACTIONS(1238),
    [anon_sym_pub] = ACTIONS(1238),
    [anon_sym_return] = ACTIONS(1238),
    [anon_sym_static] = ACTIONS(1238),
    [anon_sym_struct] = ACTIONS(1238),
    [anon_sym_trait] = ACTIONS(1238),
    [anon_sym_type] = ACTIONS(1238),
    [anon_sym_union] = ACTIONS(1238),
    [anon_sym_unsafe] = ACTIONS(1238),
    [anon_sym_use] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(1238),
    [anon_sym_else] = ACTIONS(1238),
    [anon_sym_yield] = ACTIONS(1238),
    [anon_sym_move] = ACTIONS(1238),
    [anon_sym_try] = ACTIONS(1238),
    [sym_integer_literal] = ACTIONS(1236),
    [aux_sym_string_literal_token1] = ACTIONS(1236),
    [sym_char_literal] = ACTIONS(1236),
    [anon_sym_true] = ACTIONS(1238),
    [anon_sym_false] = ACTIONS(1238),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1238),
    [sym_super] = ACTIONS(1238),
    [sym_crate] = ACTIONS(1238),
    [sym_metavariable] = ACTIONS(1236),
    [sym__raw_string_literal_start] = ACTIONS(1236),
    [sym_float_literal] = ACTIONS(1236),
  },
  [336] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1689),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(336),
    [sym_block_comment] = STATE(336),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [337] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1692),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(337),
    [sym_block_comment] = STATE(337),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [338] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1712),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(338),
    [sym_block_comment] = STATE(338),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [339] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1702),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(339),
    [sym_block_comment] = STATE(339),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [340] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1565),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(340),
    [sym_block_comment] = STATE(340),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [341] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1794),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(341),
    [sym_block_comment] = STATE(341),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [342] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1849),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(342),
    [sym_block_comment] = STATE(342),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [343] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1600),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(343),
    [sym_block_comment] = STATE(343),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [344] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1757),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(344),
    [sym_block_comment] = STATE(344),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [345] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1846),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(345),
    [sym_block_comment] = STATE(345),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [346] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1841),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(346),
    [sym_block_comment] = STATE(346),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [347] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1440),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(347),
    [sym_block_comment] = STATE(347),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [348] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1599),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(348),
    [sym_block_comment] = STATE(348),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [349] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1598),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(349),
    [sym_block_comment] = STATE(349),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [350] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1425),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(350),
    [sym_block_comment] = STATE(350),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [351] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1597),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(351),
    [sym_block_comment] = STATE(351),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [352] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1654),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(352),
    [sym_block_comment] = STATE(352),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1061),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [353] = {
    [sym_line_comment] = STATE(353),
    [sym_block_comment] = STATE(353),
    [ts_builtin_sym_end] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_SEMI] = ACTIONS(1240),
    [anon_sym_macro_rules_BANG] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_QMARK] = ACTIONS(1240),
    [anon_sym_u8] = ACTIONS(1242),
    [anon_sym_i8] = ACTIONS(1242),
    [anon_sym_u16] = ACTIONS(1242),
    [anon_sym_i16] = ACTIONS(1242),
    [anon_sym_u32] = ACTIONS(1242),
    [anon_sym_i32] = ACTIONS(1242),
    [anon_sym_u64] = ACTIONS(1242),
    [anon_sym_i64] = ACTIONS(1242),
    [anon_sym_u128] = ACTIONS(1242),
    [anon_sym_i128] = ACTIONS(1242),
    [anon_sym_isize] = ACTIONS(1242),
    [anon_sym_usize] = ACTIONS(1242),
    [anon_sym_f32] = ACTIONS(1242),
    [anon_sym_f64] = ACTIONS(1242),
    [anon_sym_bool] = ACTIONS(1242),
    [anon_sym_str] = ACTIONS(1242),
    [anon_sym_char] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_CARET] = ACTIONS(1242),
    [anon_sym_BANG] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1242),
    [anon_sym_PIPE] = ACTIONS(1242),
    [anon_sym_AMP_AMP] = ACTIONS(1240),
    [anon_sym_PIPE_PIPE] = ACTIONS(1240),
    [anon_sym_LT_LT] = ACTIONS(1242),
    [anon_sym_GT_GT] = ACTIONS(1242),
    [anon_sym_PLUS_EQ] = ACTIONS(1240),
    [anon_sym_DASH_EQ] = ACTIONS(1240),
    [anon_sym_STAR_EQ] = ACTIONS(1240),
    [anon_sym_SLASH_EQ] = ACTIONS(1240),
    [anon_sym_PERCENT_EQ] = ACTIONS(1240),
    [anon_sym_CARET_EQ] = ACTIONS(1240),
    [anon_sym_AMP_EQ] = ACTIONS(1240),
    [anon_sym_PIPE_EQ] = ACTIONS(1240),
    [anon_sym_LT_LT_EQ] = ACTIONS(1240),
    [anon_sym_GT_GT_EQ] = ACTIONS(1240),
    [anon_sym_EQ] = ACTIONS(1242),
    [anon_sym_EQ_EQ] = ACTIONS(1240),
    [anon_sym_BANG_EQ] = ACTIONS(1240),
    [anon_sym_GT] = ACTIONS(1242),
    [anon_sym_LT] = ACTIONS(1242),
    [anon_sym_GT_EQ] = ACTIONS(1240),
    [anon_sym_LT_EQ] = ACTIONS(1240),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_DOT_DOT] = ACTIONS(1242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1240),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1240),
    [anon_sym_COLON_COLON] = ACTIONS(1240),
    [anon_sym_POUND] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [anon_sym_as] = ACTIONS(1242),
    [anon_sym_async] = ACTIONS(1242),
    [anon_sym_break] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_continue] = ACTIONS(1242),
    [anon_sym_default] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1242),
    [anon_sym_fn] = ACTIONS(1242),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_impl] = ACTIONS(1242),
    [anon_sym_let] = ACTIONS(1242),
    [anon_sym_loop] = ACTIONS(1242),
    [anon_sym_match] = ACTIONS(1242),
    [anon_sym_mod] = ACTIONS(1242),
    [anon_sym_pub] = ACTIONS(1242),
    [anon_sym_return] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(1242),
    [anon_sym_struct] = ACTIONS(1242),
    [anon_sym_trait] = ACTIONS(1242),
    [anon_sym_type] = ACTIONS(1242),
    [anon_sym_union] = ACTIONS(1242),
    [anon_sym_unsafe] = ACTIONS(1242),
    [anon_sym_use] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(1242),
    [anon_sym_extern] = ACTIONS(1242),
    [anon_sym_else] = ACTIONS(1242),
    [anon_sym_yield] = ACTIONS(1242),
    [anon_sym_move] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1242),
    [sym_integer_literal] = ACTIONS(1240),
    [aux_sym_string_literal_token1] = ACTIONS(1240),
    [sym_char_literal] = ACTIONS(1240),
    [anon_sym_true] = ACTIONS(1242),
    [anon_sym_false] = ACTIONS(1242),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1242),
    [sym_super] = ACTIONS(1242),
    [sym_crate] = ACTIONS(1242),
    [sym_metavariable] = ACTIONS(1240),
    [sym__raw_string_literal_start] = ACTIONS(1240),
    [sym_float_literal] = ACTIONS(1240),
  },
  [354] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(354),
    [sym_block_comment] = STATE(354),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [355] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1863),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(355),
    [sym_block_comment] = STATE(355),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [356] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1861),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(356),
    [sym_block_comment] = STATE(356),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [357] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1594),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(357),
    [sym_block_comment] = STATE(357),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [358] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1592),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(358),
    [sym_block_comment] = STATE(358),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [359] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1591),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(359),
    [sym_block_comment] = STATE(359),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [360] = {
    [sym_line_comment] = STATE(360),
    [sym_block_comment] = STATE(360),
    [ts_builtin_sym_end] = ACTIONS(1244),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_SEMI] = ACTIONS(1244),
    [anon_sym_macro_rules_BANG] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_LBRACE] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_QMARK] = ACTIONS(1244),
    [anon_sym_u8] = ACTIONS(1246),
    [anon_sym_i8] = ACTIONS(1246),
    [anon_sym_u16] = ACTIONS(1246),
    [anon_sym_i16] = ACTIONS(1246),
    [anon_sym_u32] = ACTIONS(1246),
    [anon_sym_i32] = ACTIONS(1246),
    [anon_sym_u64] = ACTIONS(1246),
    [anon_sym_i64] = ACTIONS(1246),
    [anon_sym_u128] = ACTIONS(1246),
    [anon_sym_i128] = ACTIONS(1246),
    [anon_sym_isize] = ACTIONS(1246),
    [anon_sym_usize] = ACTIONS(1246),
    [anon_sym_f32] = ACTIONS(1246),
    [anon_sym_f64] = ACTIONS(1246),
    [anon_sym_bool] = ACTIONS(1246),
    [anon_sym_str] = ACTIONS(1246),
    [anon_sym_char] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_CARET] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1246),
    [anon_sym_AMP_AMP] = ACTIONS(1244),
    [anon_sym_PIPE_PIPE] = ACTIONS(1244),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_PLUS_EQ] = ACTIONS(1244),
    [anon_sym_DASH_EQ] = ACTIONS(1244),
    [anon_sym_STAR_EQ] = ACTIONS(1244),
    [anon_sym_SLASH_EQ] = ACTIONS(1244),
    [anon_sym_PERCENT_EQ] = ACTIONS(1244),
    [anon_sym_CARET_EQ] = ACTIONS(1244),
    [anon_sym_AMP_EQ] = ACTIONS(1244),
    [anon_sym_PIPE_EQ] = ACTIONS(1244),
    [anon_sym_LT_LT_EQ] = ACTIONS(1244),
    [anon_sym_GT_GT_EQ] = ACTIONS(1244),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_EQ_EQ] = ACTIONS(1244),
    [anon_sym_BANG_EQ] = ACTIONS(1244),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1244),
    [anon_sym_DOT] = ACTIONS(1246),
    [anon_sym_DOT_DOT] = ACTIONS(1246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1244),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1244),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [anon_sym_POUND] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_as] = ACTIONS(1246),
    [anon_sym_async] = ACTIONS(1246),
    [anon_sym_break] = ACTIONS(1246),
    [anon_sym_const] = ACTIONS(1246),
    [anon_sym_continue] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_enum] = ACTIONS(1246),
    [anon_sym_fn] = ACTIONS(1246),
    [anon_sym_for] = ACTIONS(1246),
    [anon_sym_if] = ACTIONS(1246),
    [anon_sym_impl] = ACTIONS(1246),
    [anon_sym_let] = ACTIONS(1246),
    [anon_sym_loop] = ACTIONS(1246),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_mod] = ACTIONS(1246),
    [anon_sym_pub] = ACTIONS(1246),
    [anon_sym_return] = ACTIONS(1246),
    [anon_sym_static] = ACTIONS(1246),
    [anon_sym_struct] = ACTIONS(1246),
    [anon_sym_trait] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1246),
    [anon_sym_union] = ACTIONS(1246),
    [anon_sym_unsafe] = ACTIONS(1246),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_while] = ACTIONS(1246),
    [anon_sym_extern] = ACTIONS(1246),
    [anon_sym_else] = ACTIONS(1246),
    [anon_sym_yield] = ACTIONS(1246),
    [anon_sym_move] = ACTIONS(1246),
    [anon_sym_try] = ACTIONS(1246),
    [sym_integer_literal] = ACTIONS(1244),
    [aux_sym_string_literal_token1] = ACTIONS(1244),
    [sym_char_literal] = ACTIONS(1244),
    [anon_sym_true] = ACTIONS(1246),
    [anon_sym_false] = ACTIONS(1246),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1246),
    [sym_super] = ACTIONS(1246),
    [sym_crate] = ACTIONS(1246),
    [sym_metavariable] = ACTIONS(1244),
    [sym__raw_string_literal_start] = ACTIONS(1244),
    [sym_float_literal] = ACTIONS(1244),
  },
  [361] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1845),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(361),
    [sym_block_comment] = STATE(361),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [362] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1590),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(362),
    [sym_block_comment] = STATE(362),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1041),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [363] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1656),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(363),
    [sym_block_comment] = STATE(363),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_move] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [364] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1482),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(364),
    [sym_block_comment] = STATE(364),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [365] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1764),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(365),
    [sym_block_comment] = STATE(365),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [366] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1723),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(366),
    [sym_block_comment] = STATE(366),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [367] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1722),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(367),
    [sym_block_comment] = STATE(367),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [368] = {
    [sym_bracketed_type] = STATE(3504),
    [sym_generic_function] = STATE(1695),
    [sym_generic_type_with_turbofish] = STATE(2903),
    [sym__expression_except_range] = STATE(1635),
    [sym__expression] = STATE(1719),
    [sym_macro_invocation] = STATE(1703),
    [sym_scoped_identifier] = STATE(1558),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3234),
    [sym_range_expression] = STATE(1698),
    [sym_unary_expression] = STATE(1695),
    [sym_try_expression] = STATE(1695),
    [sym_reference_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_compound_assignment_expr] = STATE(1695),
    [sym_type_cast_expression] = STATE(1695),
    [sym_return_expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_array_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_tuple_expression] = STATE(1695),
    [sym_unit_expression] = STATE(1695),
    [sym_struct_expression] = STATE(1695),
    [sym_if_expression] = STATE(1695),
    [sym_match_expression] = STATE(1695),
    [sym_while_expression] = STATE(1695),
    [sym_loop_expression] = STATE(1695),
    [sym_for_expression] = STATE(1695),
    [sym_const_block] = STATE(1695),
    [sym_closure_expression] = STATE(1695),
    [sym_closure_parameters] = STATE(224),
    [sym_label] = STATE(3591),
    [sym_break_expression] = STATE(1695),
    [sym_continue_expression] = STATE(1695),
    [sym_index_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_field_expression] = STATE(1634),
    [sym_unsafe_block] = STATE(1695),
    [sym_async_block] = STATE(1695),
    [sym_try_block] = STATE(1695),
    [sym_block] = STATE(1695),
    [sym__literal] = STATE(1695),
    [sym_string_literal] = STATE(1798),
    [sym_raw_string_literal] = STATE(1798),
    [sym_boolean_literal] = STATE(1798),
    [sym_line_comment] = STATE(368),
    [sym_block_comment] = STATE(368),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1037),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [369] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2867),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1555),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1537),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(229),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(369),
    [sym_block_comment] = STATE(369),
    [sym_identifier] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_u8] = ACTIONS(466),
    [anon_sym_i8] = ACTIONS(466),
    [anon_sym_u16] = ACTIONS(466),
    [anon_sym_i16] = ACTIONS(466),
    [anon_sym_u32] = ACTIONS(466),
    [anon_sym_i32] = ACTIONS(466),
    [anon_sym_u64] = ACTIONS(466),
    [anon_sym_i64] = ACTIONS(466),
    [anon_sym_u128] = ACTIONS(466),
    [anon_sym_i128] = ACTIONS(466),
    [anon_sym_isize] = ACTIONS(466),
    [anon_sym_usize] = ACTIONS(466),
    [anon_sym_f32] = ACTIONS(466),
    [anon_sym_f64] = ACTIONS(466),
    [anon_sym_bool] = ACTIONS(466),
    [anon_sym_str] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(979),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(484),
    [sym_super] = ACTIONS(486),
    [sym_crate] = ACTIONS(486),
    [sym_metavariable] = ACTIONS(488),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [370] = {
    [sym_bracketed_type] = STATE(3515),
    [sym_generic_function] = STATE(1307),
    [sym_generic_type_with_turbofish] = STATE(2770),
    [sym__expression_except_range] = STATE(1070),
    [sym__expression] = STATE(1866),
    [sym_macro_invocation] = STATE(1350),
    [sym_scoped_identifier] = STATE(1461),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3123),
    [sym_range_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1307),
    [sym_try_expression] = STATE(1307),
    [sym_reference_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_assignment_expression] = STATE(1307),
    [sym_compound_assignment_expr] = STATE(1307),
    [sym_type_cast_expression] = STATE(1307),
    [sym_return_expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_call_expression] = STATE(1307),
    [sym_array_expression] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple_expression] = STATE(1307),
    [sym_unit_expression] = STATE(1307),
    [sym_struct_expression] = STATE(1307),
    [sym_if_expression] = STATE(1307),
    [sym_match_expression] = STATE(1307),
    [sym_while_expression] = STATE(1307),
    [sym_loop_expression] = STATE(1307),
    [sym_for_expression] = STATE(1307),
    [sym_const_block] = STATE(1307),
    [sym_closure_expression] = STATE(1307),
    [sym_closure_parameters] = STATE(234),
    [sym_label] = STATE(3541),
    [sym_break_expression] = STATE(1307),
    [sym_continue_expression] = STATE(1307),
    [sym_index_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_field_expression] = STATE(1062),
    [sym_unsafe_block] = STATE(1307),
    [sym_async_block] = STATE(1307),
    [sym_try_block] = STATE(1307),
    [sym_block] = STATE(1307),
    [sym__literal] = STATE(1307),
    [sym_string_literal] = STATE(1214),
    [sym_raw_string_literal] = STATE(1214),
    [sym_boolean_literal] = STATE(1214),
    [sym_line_comment] = STATE(370),
    [sym_block_comment] = STATE(370),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [371] = {
    [sym_line_comment] = STATE(371),
    [sym_block_comment] = STATE(371),
    [ts_builtin_sym_end] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1250),
    [anon_sym_SEMI] = ACTIONS(1248),
    [anon_sym_macro_rules_BANG] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_QMARK] = ACTIONS(1248),
    [anon_sym_u8] = ACTIONS(1250),
    [anon_sym_i8] = ACTIONS(1250),
    [anon_sym_u16] = ACTIONS(1250),
    [anon_sym_i16] = ACTIONS(1250),
    [anon_sym_u32] = ACTIONS(1250),
    [anon_sym_i32] = ACTIONS(1250),
    [anon_sym_u64] = ACTIONS(1250),
    [anon_sym_i64] = ACTIONS(1250),
    [anon_sym_u128] = ACTIONS(1250),
    [anon_sym_i128] = ACTIONS(1250),
    [anon_sym_isize] = ACTIONS(1250),
    [anon_sym_usize] = ACTIONS(1250),
    [anon_sym_f32] = ACTIONS(1250),
    [anon_sym_f64] = ACTIONS(1250),
    [anon_sym_bool] = ACTIONS(1250),
    [anon_sym_str] = ACTIONS(1250),
    [anon_sym_char] = ACTIONS(1250),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_CARET] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_PIPE_PIPE] = ACTIONS(1248),
    [anon_sym_LT_LT] = ACTIONS(1250),
    [anon_sym_GT_GT] = ACTIONS(1250),
    [anon_sym_PLUS_EQ] = ACTIONS(1248),
    [anon_sym_DASH_EQ] = ACTIONS(1248),
    [anon_sym_STAR_EQ] = ACTIONS(1248),
    [anon_sym_SLASH_EQ] = ACTIONS(1248),
    [anon_sym_PERCENT_EQ] = ACTIONS(1248),
    [anon_sym_CARET_EQ] = ACTIONS(1248),
    [anon_sym_AMP_EQ] = ACTIONS(1248),
    [anon_sym_PIPE_EQ] = ACTIONS(1248),
    [anon_sym_LT_LT_EQ] = ACTIONS(1248),
    [anon_sym_GT_GT_EQ] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_EQ_EQ] = ACTIONS(1248),
    [anon_sym_BANG_EQ] = ACTIONS(1248),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_GT_EQ] = ACTIONS(1248),
    [anon_sym_LT_EQ] = ACTIONS(1248),
    [anon_sym_DOT] = ACTIONS(1250),
    [anon_sym_DOT_DOT] = ACTIONS(1250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1248),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1248),
    [anon_sym_COLON_COLON] = ACTIONS(1248),
    [anon_sym_POUND] = ACTIONS(1248),
    [anon_sym_SQUOTE] = ACTIONS(1250),
    [anon_sym_as] = ACTIONS(1250),
    [anon_sym_async] = ACTIONS(1250),
    [anon_sym_break] = ACTIONS(1250),
    [anon_sym_const] = ACTIONS(1250),
    [anon_sym_continue] = ACTIONS(1250),
    [anon_sym_default] = ACTIONS(1250),
    [anon_sym_enum] = ACTIONS(1250),
    [anon_sym_fn] = ACTIONS(1250),
    [anon_sym_for] = ACTIONS(1250),
    [anon_sym_if] = ACTIONS(1250),
    [anon_sym_impl] = ACTIONS(1250),
    [anon_sym_let] = ACTIONS(1250),
    [anon_sym_loop] = ACTIONS(1250),
    [anon_sym_match] = ACTIONS(1250),
    [anon_sym_mod] = ACTIONS(1250),
    [anon_sym_pub] = ACTIONS(1250),
    [anon_sym_return] = ACTIONS(1250),
    [anon_sym_static] = ACTIONS(1250),
    [anon_sym_struct] = ACTIONS(1250),
    [anon_sym_trait] = ACTIONS(1250),
    [anon_sym_type] = ACTIONS(1250),
    [anon_sym_union] = ACTIONS(1250),
    [anon_sym_unsafe] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1250),
    [anon_sym_while] = ACTIONS(1250),
    [anon_sym_extern] = ACTIONS(1250),
    [anon_sym_yield] = ACTIONS(1250),
    [anon_sym_move] = ACTIONS(1250),
    [anon_sym_try] = ACTIONS(1250),
    [sym_integer_literal] = ACTIONS(1248),
    [aux_sym_string_literal_token1] = ACTIONS(1248),
    [sym_char_literal] = ACTIONS(1248),
    [anon_sym_true] = ACTIONS(1250),
    [anon_sym_false] = ACTIONS(1250),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1250),
    [sym_super] = ACTIONS(1250),
    [sym_crate] = ACTIONS(1250),
    [sym_metavariable] = ACTIONS(1248),
    [sym__raw_string_literal_start] = ACTIONS(1248),
    [sym_float_literal] = ACTIONS(1248),
  },
  [372] = {
    [sym_attribute_item] = STATE(416),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(2750),
    [sym_variadic_parameter] = STATE(2750),
    [sym_parameter] = STATE(2750),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2631),
    [sym_bracketed_type] = STATE(3533),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3114),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2437),
    [sym_scoped_identifier] = STATE(2126),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2470),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(372),
    [sym_block_comment] = STATE(372),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_RPAREN] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1264),
    [anon_sym_i8] = ACTIONS(1264),
    [anon_sym_u16] = ACTIONS(1264),
    [anon_sym_i16] = ACTIONS(1264),
    [anon_sym_u32] = ACTIONS(1264),
    [anon_sym_i32] = ACTIONS(1264),
    [anon_sym_u64] = ACTIONS(1264),
    [anon_sym_i64] = ACTIONS(1264),
    [anon_sym_u128] = ACTIONS(1264),
    [anon_sym_i128] = ACTIONS(1264),
    [anon_sym_isize] = ACTIONS(1264),
    [anon_sym_usize] = ACTIONS(1264),
    [anon_sym_f32] = ACTIONS(1264),
    [anon_sym_f64] = ACTIONS(1264),
    [anon_sym_bool] = ACTIONS(1264),
    [anon_sym_str] = ACTIONS(1264),
    [anon_sym_char] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1270),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1274),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COMMA] = ACTIONS(1280),
    [anon_sym_COLON_COLON] = ACTIONS(1282),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1300),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1316),
    [sym_super] = ACTIONS(1318),
    [sym_crate] = ACTIONS(1318),
    [sym_metavariable] = ACTIONS(1320),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [373] = {
    [sym_line_comment] = STATE(373),
    [sym_block_comment] = STATE(373),
    [ts_builtin_sym_end] = ACTIONS(1324),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym_macro_rules_BANG] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_QMARK] = ACTIONS(1324),
    [anon_sym_u8] = ACTIONS(1326),
    [anon_sym_i8] = ACTIONS(1326),
    [anon_sym_u16] = ACTIONS(1326),
    [anon_sym_i16] = ACTIONS(1326),
    [anon_sym_u32] = ACTIONS(1326),
    [anon_sym_i32] = ACTIONS(1326),
    [anon_sym_u64] = ACTIONS(1326),
    [anon_sym_i64] = ACTIONS(1326),
    [anon_sym_u128] = ACTIONS(1326),
    [anon_sym_i128] = ACTIONS(1326),
    [anon_sym_isize] = ACTIONS(1326),
    [anon_sym_usize] = ACTIONS(1326),
    [anon_sym_f32] = ACTIONS(1326),
    [anon_sym_f64] = ACTIONS(1326),
    [anon_sym_bool] = ACTIONS(1326),
    [anon_sym_str] = ACTIONS(1326),
    [anon_sym_char] = ACTIONS(1326),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1326),
    [anon_sym_CARET] = ACTIONS(1326),
    [anon_sym_BANG] = ACTIONS(1326),
    [anon_sym_AMP] = ACTIONS(1326),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1326),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_PLUS_EQ] = ACTIONS(1324),
    [anon_sym_DASH_EQ] = ACTIONS(1324),
    [anon_sym_STAR_EQ] = ACTIONS(1324),
    [anon_sym_SLASH_EQ] = ACTIONS(1324),
    [anon_sym_PERCENT_EQ] = ACTIONS(1324),
    [anon_sym_CARET_EQ] = ACTIONS(1324),
    [anon_sym_AMP_EQ] = ACTIONS(1324),
    [anon_sym_PIPE_EQ] = ACTIONS(1324),
    [anon_sym_LT_LT_EQ] = ACTIONS(1324),
    [anon_sym_GT_GT_EQ] = ACTIONS(1324),
    [anon_sym_EQ] = ACTIONS(1326),
    [anon_sym_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG_EQ] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1326),
    [anon_sym_LT] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_DOT] = ACTIONS(1326),
    [anon_sym_DOT_DOT] = ACTIONS(1326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1324),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1324),
    [anon_sym_COLON_COLON] = ACTIONS(1324),
    [anon_sym_POUND] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1326),
    [anon_sym_as] = ACTIONS(1326),
    [anon_sym_async] = ACTIONS(1326),
    [anon_sym_break] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [anon_sym_continue] = ACTIONS(1326),
    [anon_sym_default] = ACTIONS(1326),
    [anon_sym_enum] = ACTIONS(1326),
    [anon_sym_fn] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_impl] = ACTIONS(1326),
    [anon_sym_let] = ACTIONS(1326),
    [anon_sym_loop] = ACTIONS(1326),
    [anon_sym_match] = ACTIONS(1326),
    [anon_sym_mod] = ACTIONS(1326),
    [anon_sym_pub] = ACTIONS(1326),
    [anon_sym_return] = ACTIONS(1326),
    [anon_sym_static] = ACTIONS(1326),
    [anon_sym_struct] = ACTIONS(1326),
    [anon_sym_trait] = ACTIONS(1326),
    [anon_sym_type] = ACTIONS(1326),
    [anon_sym_union] = ACTIONS(1326),
    [anon_sym_unsafe] = ACTIONS(1326),
    [anon_sym_use] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1326),
    [anon_sym_extern] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1326),
    [anon_sym_move] = ACTIONS(1326),
    [anon_sym_try] = ACTIONS(1326),
    [sym_integer_literal] = ACTIONS(1324),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1324),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1326),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1324),
    [sym__raw_string_literal_start] = ACTIONS(1324),
    [sym_float_literal] = ACTIONS(1324),
  },
  [374] = {
    [sym_line_comment] = STATE(374),
    [sym_block_comment] = STATE(374),
    [ts_builtin_sym_end] = ACTIONS(1328),
    [sym_identifier] = ACTIONS(1330),
    [anon_sym_SEMI] = ACTIONS(1328),
    [anon_sym_macro_rules_BANG] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(1328),
    [anon_sym_LBRACK] = ACTIONS(1328),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_RBRACE] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1330),
    [anon_sym_QMARK] = ACTIONS(1328),
    [anon_sym_u8] = ACTIONS(1330),
    [anon_sym_i8] = ACTIONS(1330),
    [anon_sym_u16] = ACTIONS(1330),
    [anon_sym_i16] = ACTIONS(1330),
    [anon_sym_u32] = ACTIONS(1330),
    [anon_sym_i32] = ACTIONS(1330),
    [anon_sym_u64] = ACTIONS(1330),
    [anon_sym_i64] = ACTIONS(1330),
    [anon_sym_u128] = ACTIONS(1330),
    [anon_sym_i128] = ACTIONS(1330),
    [anon_sym_isize] = ACTIONS(1330),
    [anon_sym_usize] = ACTIONS(1330),
    [anon_sym_f32] = ACTIONS(1330),
    [anon_sym_f64] = ACTIONS(1330),
    [anon_sym_bool] = ACTIONS(1330),
    [anon_sym_str] = ACTIONS(1330),
    [anon_sym_char] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1330),
    [anon_sym_PERCENT] = ACTIONS(1330),
    [anon_sym_CARET] = ACTIONS(1330),
    [anon_sym_BANG] = ACTIONS(1330),
    [anon_sym_AMP] = ACTIONS(1330),
    [anon_sym_PIPE] = ACTIONS(1330),
    [anon_sym_AMP_AMP] = ACTIONS(1328),
    [anon_sym_PIPE_PIPE] = ACTIONS(1328),
    [anon_sym_LT_LT] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1330),
    [anon_sym_PLUS_EQ] = ACTIONS(1328),
    [anon_sym_DASH_EQ] = ACTIONS(1328),
    [anon_sym_STAR_EQ] = ACTIONS(1328),
    [anon_sym_SLASH_EQ] = ACTIONS(1328),
    [anon_sym_PERCENT_EQ] = ACTIONS(1328),
    [anon_sym_CARET_EQ] = ACTIONS(1328),
    [anon_sym_AMP_EQ] = ACTIONS(1328),
    [anon_sym_PIPE_EQ] = ACTIONS(1328),
    [anon_sym_LT_LT_EQ] = ACTIONS(1328),
    [anon_sym_GT_GT_EQ] = ACTIONS(1328),
    [anon_sym_EQ] = ACTIONS(1330),
    [anon_sym_EQ_EQ] = ACTIONS(1328),
    [anon_sym_BANG_EQ] = ACTIONS(1328),
    [anon_sym_GT] = ACTIONS(1330),
    [anon_sym_LT] = ACTIONS(1330),
    [anon_sym_GT_EQ] = ACTIONS(1328),
    [anon_sym_LT_EQ] = ACTIONS(1328),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_DOT_DOT] = ACTIONS(1330),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1328),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1328),
    [anon_sym_COLON_COLON] = ACTIONS(1328),
    [anon_sym_POUND] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1330),
    [anon_sym_as] = ACTIONS(1330),
    [anon_sym_async] = ACTIONS(1330),
    [anon_sym_break] = ACTIONS(1330),
    [anon_sym_const] = ACTIONS(1330),
    [anon_sym_continue] = ACTIONS(1330),
    [anon_sym_default] = ACTIONS(1330),
    [anon_sym_enum] = ACTIONS(1330),
    [anon_sym_fn] = ACTIONS(1330),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_if] = ACTIONS(1330),
    [anon_sym_impl] = ACTIONS(1330),
    [anon_sym_let] = ACTIONS(1330),
    [anon_sym_loop] = ACTIONS(1330),
    [anon_sym_match] = ACTIONS(1330),
    [anon_sym_mod] = ACTIONS(1330),
    [anon_sym_pub] = ACTIONS(1330),
    [anon_sym_return] = ACTIONS(1330),
    [anon_sym_static] = ACTIONS(1330),
    [anon_sym_struct] = ACTIONS(1330),
    [anon_sym_trait] = ACTIONS(1330),
    [anon_sym_type] = ACTIONS(1330),
    [anon_sym_union] = ACTIONS(1330),
    [anon_sym_unsafe] = ACTIONS(1330),
    [anon_sym_use] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1330),
    [anon_sym_extern] = ACTIONS(1330),
    [anon_sym_yield] = ACTIONS(1330),
    [anon_sym_move] = ACTIONS(1330),
    [anon_sym_try] = ACTIONS(1330),
    [sym_integer_literal] = ACTIONS(1328),
    [aux_sym_string_literal_token1] = ACTIONS(1328),
    [sym_char_literal] = ACTIONS(1328),
    [anon_sym_true] = ACTIONS(1330),
    [anon_sym_false] = ACTIONS(1330),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1330),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1328),
    [sym__raw_string_literal_start] = ACTIONS(1328),
    [sym_float_literal] = ACTIONS(1328),
  },
  [375] = {
    [sym_attribute_item] = STATE(416),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(2750),
    [sym_variadic_parameter] = STATE(2750),
    [sym_parameter] = STATE(2750),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2631),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(375),
    [sym_block_comment] = STATE(375),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1342),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [376] = {
    [sym_line_comment] = STATE(376),
    [sym_block_comment] = STATE(376),
    [ts_builtin_sym_end] = ACTIONS(1358),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_SEMI] = ACTIONS(1358),
    [anon_sym_macro_rules_BANG] = ACTIONS(1358),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_RBRACE] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1360),
    [anon_sym_STAR] = ACTIONS(1360),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_u8] = ACTIONS(1360),
    [anon_sym_i8] = ACTIONS(1360),
    [anon_sym_u16] = ACTIONS(1360),
    [anon_sym_i16] = ACTIONS(1360),
    [anon_sym_u32] = ACTIONS(1360),
    [anon_sym_i32] = ACTIONS(1360),
    [anon_sym_u64] = ACTIONS(1360),
    [anon_sym_i64] = ACTIONS(1360),
    [anon_sym_u128] = ACTIONS(1360),
    [anon_sym_i128] = ACTIONS(1360),
    [anon_sym_isize] = ACTIONS(1360),
    [anon_sym_usize] = ACTIONS(1360),
    [anon_sym_f32] = ACTIONS(1360),
    [anon_sym_f64] = ACTIONS(1360),
    [anon_sym_bool] = ACTIONS(1360),
    [anon_sym_str] = ACTIONS(1360),
    [anon_sym_char] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1360),
    [anon_sym_SLASH] = ACTIONS(1360),
    [anon_sym_PERCENT] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1360),
    [anon_sym_PIPE] = ACTIONS(1360),
    [anon_sym_AMP_AMP] = ACTIONS(1358),
    [anon_sym_PIPE_PIPE] = ACTIONS(1358),
    [anon_sym_LT_LT] = ACTIONS(1360),
    [anon_sym_GT_GT] = ACTIONS(1360),
    [anon_sym_PLUS_EQ] = ACTIONS(1358),
    [anon_sym_DASH_EQ] = ACTIONS(1358),
    [anon_sym_STAR_EQ] = ACTIONS(1358),
    [anon_sym_SLASH_EQ] = ACTIONS(1358),
    [anon_sym_PERCENT_EQ] = ACTIONS(1358),
    [anon_sym_CARET_EQ] = ACTIONS(1358),
    [anon_sym_AMP_EQ] = ACTIONS(1358),
    [anon_sym_PIPE_EQ] = ACTIONS(1358),
    [anon_sym_LT_LT_EQ] = ACTIONS(1358),
    [anon_sym_GT_GT_EQ] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1360),
    [anon_sym_EQ_EQ] = ACTIONS(1358),
    [anon_sym_BANG_EQ] = ACTIONS(1358),
    [anon_sym_GT] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1360),
    [anon_sym_GT_EQ] = ACTIONS(1358),
    [anon_sym_LT_EQ] = ACTIONS(1358),
    [anon_sym_DOT] = ACTIONS(1360),
    [anon_sym_DOT_DOT] = ACTIONS(1360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1358),
    [anon_sym_COLON_COLON] = ACTIONS(1358),
    [anon_sym_POUND] = ACTIONS(1358),
    [anon_sym_SQUOTE] = ACTIONS(1360),
    [anon_sym_as] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_break] = ACTIONS(1360),
    [anon_sym_const] = ACTIONS(1360),
    [anon_sym_continue] = ACTIONS(1360),
    [anon_sym_default] = ACTIONS(1360),
    [anon_sym_enum] = ACTIONS(1360),
    [anon_sym_fn] = ACTIONS(1360),
    [anon_sym_for] = ACTIONS(1360),
    [anon_sym_if] = ACTIONS(1360),
    [anon_sym_impl] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1360),
    [anon_sym_loop] = ACTIONS(1360),
    [anon_sym_match] = ACTIONS(1360),
    [anon_sym_mod] = ACTIONS(1360),
    [anon_sym_pub] = ACTIONS(1360),
    [anon_sym_return] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_struct] = ACTIONS(1360),
    [anon_sym_trait] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_union] = ACTIONS(1360),
    [anon_sym_unsafe] = ACTIONS(1360),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_while] = ACTIONS(1360),
    [anon_sym_extern] = ACTIONS(1360),
    [anon_sym_yield] = ACTIONS(1360),
    [anon_sym_move] = ACTIONS(1360),
    [anon_sym_try] = ACTIONS(1360),
    [sym_integer_literal] = ACTIONS(1358),
    [aux_sym_string_literal_token1] = ACTIONS(1358),
    [sym_char_literal] = ACTIONS(1358),
    [anon_sym_true] = ACTIONS(1360),
    [anon_sym_false] = ACTIONS(1360),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1360),
    [sym_super] = ACTIONS(1360),
    [sym_crate] = ACTIONS(1360),
    [sym_metavariable] = ACTIONS(1358),
    [sym__raw_string_literal_start] = ACTIONS(1358),
    [sym_float_literal] = ACTIONS(1358),
  },
  [377] = {
    [sym_line_comment] = STATE(377),
    [sym_block_comment] = STATE(377),
    [ts_builtin_sym_end] = ACTIONS(1362),
    [sym_identifier] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1362),
    [anon_sym_macro_rules_BANG] = ACTIONS(1362),
    [anon_sym_LPAREN] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1362),
    [anon_sym_RBRACE] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_QMARK] = ACTIONS(1362),
    [anon_sym_u8] = ACTIONS(1364),
    [anon_sym_i8] = ACTIONS(1364),
    [anon_sym_u16] = ACTIONS(1364),
    [anon_sym_i16] = ACTIONS(1364),
    [anon_sym_u32] = ACTIONS(1364),
    [anon_sym_i32] = ACTIONS(1364),
    [anon_sym_u64] = ACTIONS(1364),
    [anon_sym_i64] = ACTIONS(1364),
    [anon_sym_u128] = ACTIONS(1364),
    [anon_sym_i128] = ACTIONS(1364),
    [anon_sym_isize] = ACTIONS(1364),
    [anon_sym_usize] = ACTIONS(1364),
    [anon_sym_f32] = ACTIONS(1364),
    [anon_sym_f64] = ACTIONS(1364),
    [anon_sym_bool] = ACTIONS(1364),
    [anon_sym_str] = ACTIONS(1364),
    [anon_sym_char] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_SLASH] = ACTIONS(1364),
    [anon_sym_PERCENT] = ACTIONS(1364),
    [anon_sym_CARET] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1362),
    [anon_sym_PIPE_PIPE] = ACTIONS(1362),
    [anon_sym_LT_LT] = ACTIONS(1364),
    [anon_sym_GT_GT] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1362),
    [anon_sym_DASH_EQ] = ACTIONS(1362),
    [anon_sym_STAR_EQ] = ACTIONS(1362),
    [anon_sym_SLASH_EQ] = ACTIONS(1362),
    [anon_sym_PERCENT_EQ] = ACTIONS(1362),
    [anon_sym_CARET_EQ] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1362),
    [anon_sym_PIPE_EQ] = ACTIONS(1362),
    [anon_sym_LT_LT_EQ] = ACTIONS(1362),
    [anon_sym_GT_GT_EQ] = ACTIONS(1362),
    [anon_sym_EQ] = ACTIONS(1364),
    [anon_sym_EQ_EQ] = ACTIONS(1362),
    [anon_sym_BANG_EQ] = ACTIONS(1362),
    [anon_sym_GT] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1362),
    [anon_sym_LT_EQ] = ACTIONS(1362),
    [anon_sym_DOT] = ACTIONS(1364),
    [anon_sym_DOT_DOT] = ACTIONS(1364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1362),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1362),
    [anon_sym_COLON_COLON] = ACTIONS(1362),
    [anon_sym_POUND] = ACTIONS(1362),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_as] = ACTIONS(1364),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_break] = ACTIONS(1364),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_continue] = ACTIONS(1364),
    [anon_sym_default] = ACTIONS(1364),
    [anon_sym_enum] = ACTIONS(1364),
    [anon_sym_fn] = ACTIONS(1364),
    [anon_sym_for] = ACTIONS(1364),
    [anon_sym_if] = ACTIONS(1364),
    [anon_sym_impl] = ACTIONS(1364),
    [anon_sym_let] = ACTIONS(1364),
    [anon_sym_loop] = ACTIONS(1364),
    [anon_sym_match] = ACTIONS(1364),
    [anon_sym_mod] = ACTIONS(1364),
    [anon_sym_pub] = ACTIONS(1364),
    [anon_sym_return] = ACTIONS(1364),
    [anon_sym_static] = ACTIONS(1364),
    [anon_sym_struct] = ACTIONS(1364),
    [anon_sym_trait] = ACTIONS(1364),
    [anon_sym_type] = ACTIONS(1364),
    [anon_sym_union] = ACTIONS(1364),
    [anon_sym_unsafe] = ACTIONS(1364),
    [anon_sym_use] = ACTIONS(1364),
    [anon_sym_while] = ACTIONS(1364),
    [anon_sym_extern] = ACTIONS(1364),
    [anon_sym_yield] = ACTIONS(1364),
    [anon_sym_move] = ACTIONS(1364),
    [anon_sym_try] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1362),
    [aux_sym_string_literal_token1] = ACTIONS(1362),
    [sym_char_literal] = ACTIONS(1362),
    [anon_sym_true] = ACTIONS(1364),
    [anon_sym_false] = ACTIONS(1364),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1364),
    [sym_super] = ACTIONS(1364),
    [sym_crate] = ACTIONS(1364),
    [sym_metavariable] = ACTIONS(1362),
    [sym__raw_string_literal_start] = ACTIONS(1362),
    [sym_float_literal] = ACTIONS(1362),
  },
  [378] = {
    [sym_line_comment] = STATE(378),
    [sym_block_comment] = STATE(378),
    [ts_builtin_sym_end] = ACTIONS(1366),
    [sym_identifier] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1366),
    [anon_sym_macro_rules_BANG] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1368),
    [anon_sym_STAR] = ACTIONS(1368),
    [anon_sym_QMARK] = ACTIONS(1366),
    [anon_sym_u8] = ACTIONS(1368),
    [anon_sym_i8] = ACTIONS(1368),
    [anon_sym_u16] = ACTIONS(1368),
    [anon_sym_i16] = ACTIONS(1368),
    [anon_sym_u32] = ACTIONS(1368),
    [anon_sym_i32] = ACTIONS(1368),
    [anon_sym_u64] = ACTIONS(1368),
    [anon_sym_i64] = ACTIONS(1368),
    [anon_sym_u128] = ACTIONS(1368),
    [anon_sym_i128] = ACTIONS(1368),
    [anon_sym_isize] = ACTIONS(1368),
    [anon_sym_usize] = ACTIONS(1368),
    [anon_sym_f32] = ACTIONS(1368),
    [anon_sym_f64] = ACTIONS(1368),
    [anon_sym_bool] = ACTIONS(1368),
    [anon_sym_str] = ACTIONS(1368),
    [anon_sym_char] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(1368),
    [anon_sym_PERCENT] = ACTIONS(1368),
    [anon_sym_CARET] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_AMP] = ACTIONS(1368),
    [anon_sym_PIPE] = ACTIONS(1368),
    [anon_sym_AMP_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1366),
    [anon_sym_LT_LT] = ACTIONS(1368),
    [anon_sym_GT_GT] = ACTIONS(1368),
    [anon_sym_PLUS_EQ] = ACTIONS(1366),
    [anon_sym_DASH_EQ] = ACTIONS(1366),
    [anon_sym_STAR_EQ] = ACTIONS(1366),
    [anon_sym_SLASH_EQ] = ACTIONS(1366),
    [anon_sym_PERCENT_EQ] = ACTIONS(1366),
    [anon_sym_CARET_EQ] = ACTIONS(1366),
    [anon_sym_AMP_EQ] = ACTIONS(1366),
    [anon_sym_PIPE_EQ] = ACTIONS(1366),
    [anon_sym_LT_LT_EQ] = ACTIONS(1366),
    [anon_sym_GT_GT_EQ] = ACTIONS(1366),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_EQ_EQ] = ACTIONS(1366),
    [anon_sym_BANG_EQ] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1368),
    [anon_sym_LT] = ACTIONS(1368),
    [anon_sym_GT_EQ] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1366),
    [anon_sym_DOT] = ACTIONS(1368),
    [anon_sym_DOT_DOT] = ACTIONS(1368),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1366),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1366),
    [anon_sym_COLON_COLON] = ACTIONS(1366),
    [anon_sym_POUND] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(1368),
    [anon_sym_async] = ACTIONS(1368),
    [anon_sym_break] = ACTIONS(1368),
    [anon_sym_const] = ACTIONS(1368),
    [anon_sym_continue] = ACTIONS(1368),
    [anon_sym_default] = ACTIONS(1368),
    [anon_sym_enum] = ACTIONS(1368),
    [anon_sym_fn] = ACTIONS(1368),
    [anon_sym_for] = ACTIONS(1368),
    [anon_sym_if] = ACTIONS(1368),
    [anon_sym_impl] = ACTIONS(1368),
    [anon_sym_let] = ACTIONS(1368),
    [anon_sym_loop] = ACTIONS(1368),
    [anon_sym_match] = ACTIONS(1368),
    [anon_sym_mod] = ACTIONS(1368),
    [anon_sym_pub] = ACTIONS(1368),
    [anon_sym_return] = ACTIONS(1368),
    [anon_sym_static] = ACTIONS(1368),
    [anon_sym_struct] = ACTIONS(1368),
    [anon_sym_trait] = ACTIONS(1368),
    [anon_sym_type] = ACTIONS(1368),
    [anon_sym_union] = ACTIONS(1368),
    [anon_sym_unsafe] = ACTIONS(1368),
    [anon_sym_use] = ACTIONS(1368),
    [anon_sym_while] = ACTIONS(1368),
    [anon_sym_extern] = ACTIONS(1368),
    [anon_sym_yield] = ACTIONS(1368),
    [anon_sym_move] = ACTIONS(1368),
    [anon_sym_try] = ACTIONS(1368),
    [sym_integer_literal] = ACTIONS(1366),
    [aux_sym_string_literal_token1] = ACTIONS(1366),
    [sym_char_literal] = ACTIONS(1366),
    [anon_sym_true] = ACTIONS(1368),
    [anon_sym_false] = ACTIONS(1368),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1368),
    [sym_super] = ACTIONS(1368),
    [sym_crate] = ACTIONS(1368),
    [sym_metavariable] = ACTIONS(1366),
    [sym__raw_string_literal_start] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
  },
  [379] = {
    [sym_line_comment] = STATE(379),
    [sym_block_comment] = STATE(379),
    [ts_builtin_sym_end] = ACTIONS(999),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_macro_rules_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(999),
    [anon_sym_u8] = ACTIONS(997),
    [anon_sym_i8] = ACTIONS(997),
    [anon_sym_u16] = ACTIONS(997),
    [anon_sym_i16] = ACTIONS(997),
    [anon_sym_u32] = ACTIONS(997),
    [anon_sym_i32] = ACTIONS(997),
    [anon_sym_u64] = ACTIONS(997),
    [anon_sym_i64] = ACTIONS(997),
    [anon_sym_u128] = ACTIONS(997),
    [anon_sym_i128] = ACTIONS(997),
    [anon_sym_isize] = ACTIONS(997),
    [anon_sym_usize] = ACTIONS(997),
    [anon_sym_f32] = ACTIONS(997),
    [anon_sym_f64] = ACTIONS(997),
    [anon_sym_bool] = ACTIONS(997),
    [anon_sym_str] = ACTIONS(997),
    [anon_sym_char] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(999),
    [anon_sym_DASH_EQ] = ACTIONS(999),
    [anon_sym_STAR_EQ] = ACTIONS(999),
    [anon_sym_SLASH_EQ] = ACTIONS(999),
    [anon_sym_PERCENT_EQ] = ACTIONS(999),
    [anon_sym_CARET_EQ] = ACTIONS(999),
    [anon_sym_AMP_EQ] = ACTIONS(999),
    [anon_sym_PIPE_EQ] = ACTIONS(999),
    [anon_sym_LT_LT_EQ] = ACTIONS(999),
    [anon_sym_GT_GT_EQ] = ACTIONS(999),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(999),
    [anon_sym_COLON_COLON] = ACTIONS(999),
    [anon_sym_POUND] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(997),
    [anon_sym_async] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_const] = ACTIONS(997),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_default] = ACTIONS(997),
    [anon_sym_enum] = ACTIONS(997),
    [anon_sym_fn] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_impl] = ACTIONS(997),
    [anon_sym_let] = ACTIONS(997),
    [anon_sym_loop] = ACTIONS(997),
    [anon_sym_match] = ACTIONS(997),
    [anon_sym_mod] = ACTIONS(997),
    [anon_sym_pub] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_static] = ACTIONS(997),
    [anon_sym_struct] = ACTIONS(997),
    [anon_sym_trait] = ACTIONS(997),
    [anon_sym_type] = ACTIONS(997),
    [anon_sym_union] = ACTIONS(997),
    [anon_sym_unsafe] = ACTIONS(997),
    [anon_sym_use] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_extern] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(997),
    [anon_sym_move] = ACTIONS(997),
    [anon_sym_try] = ACTIONS(997),
    [sym_integer_literal] = ACTIONS(999),
    [aux_sym_string_literal_token1] = ACTIONS(999),
    [sym_char_literal] = ACTIONS(999),
    [anon_sym_true] = ACTIONS(997),
    [anon_sym_false] = ACTIONS(997),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(997),
    [sym_super] = ACTIONS(997),
    [sym_crate] = ACTIONS(997),
    [sym_metavariable] = ACTIONS(999),
    [sym__raw_string_literal_start] = ACTIONS(999),
    [sym_float_literal] = ACTIONS(999),
  },
  [380] = {
    [sym_line_comment] = STATE(380),
    [sym_block_comment] = STATE(380),
    [ts_builtin_sym_end] = ACTIONS(1370),
    [sym_identifier] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_macro_rules_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_QMARK] = ACTIONS(1370),
    [anon_sym_u8] = ACTIONS(1372),
    [anon_sym_i8] = ACTIONS(1372),
    [anon_sym_u16] = ACTIONS(1372),
    [anon_sym_i16] = ACTIONS(1372),
    [anon_sym_u32] = ACTIONS(1372),
    [anon_sym_i32] = ACTIONS(1372),
    [anon_sym_u64] = ACTIONS(1372),
    [anon_sym_i64] = ACTIONS(1372),
    [anon_sym_u128] = ACTIONS(1372),
    [anon_sym_i128] = ACTIONS(1372),
    [anon_sym_isize] = ACTIONS(1372),
    [anon_sym_usize] = ACTIONS(1372),
    [anon_sym_f32] = ACTIONS(1372),
    [anon_sym_f64] = ACTIONS(1372),
    [anon_sym_bool] = ACTIONS(1372),
    [anon_sym_str] = ACTIONS(1372),
    [anon_sym_char] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_PIPE_PIPE] = ACTIONS(1370),
    [anon_sym_LT_LT] = ACTIONS(1372),
    [anon_sym_GT_GT] = ACTIONS(1372),
    [anon_sym_PLUS_EQ] = ACTIONS(1370),
    [anon_sym_DASH_EQ] = ACTIONS(1370),
    [anon_sym_STAR_EQ] = ACTIONS(1370),
    [anon_sym_SLASH_EQ] = ACTIONS(1370),
    [anon_sym_PERCENT_EQ] = ACTIONS(1370),
    [anon_sym_CARET_EQ] = ACTIONS(1370),
    [anon_sym_AMP_EQ] = ACTIONS(1370),
    [anon_sym_PIPE_EQ] = ACTIONS(1370),
    [anon_sym_LT_LT_EQ] = ACTIONS(1370),
    [anon_sym_GT_GT_EQ] = ACTIONS(1370),
    [anon_sym_EQ] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_DOT_DOT] = ACTIONS(1372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1370),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1370),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_POUND] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_as] = ACTIONS(1372),
    [anon_sym_async] = ACTIONS(1372),
    [anon_sym_break] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_continue] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
    [anon_sym_fn] = ACTIONS(1372),
    [anon_sym_for] = ACTIONS(1372),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_impl] = ACTIONS(1372),
    [anon_sym_let] = ACTIONS(1372),
    [anon_sym_loop] = ACTIONS(1372),
    [anon_sym_match] = ACTIONS(1372),
    [anon_sym_mod] = ACTIONS(1372),
    [anon_sym_pub] = ACTIONS(1372),
    [anon_sym_return] = ACTIONS(1372),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_struct] = ACTIONS(1372),
    [anon_sym_trait] = ACTIONS(1372),
    [anon_sym_type] = ACTIONS(1372),
    [anon_sym_union] = ACTIONS(1372),
    [anon_sym_unsafe] = ACTIONS(1372),
    [anon_sym_use] = ACTIONS(1372),
    [anon_sym_while] = ACTIONS(1372),
    [anon_sym_extern] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_move] = ACTIONS(1372),
    [anon_sym_try] = ACTIONS(1372),
    [sym_integer_literal] = ACTIONS(1370),
    [aux_sym_string_literal_token1] = ACTIONS(1370),
    [sym_char_literal] = ACTIONS(1370),
    [anon_sym_true] = ACTIONS(1372),
    [anon_sym_false] = ACTIONS(1372),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1372),
    [sym_super] = ACTIONS(1372),
    [sym_crate] = ACTIONS(1372),
    [sym_metavariable] = ACTIONS(1370),
    [sym__raw_string_literal_start] = ACTIONS(1370),
    [sym_float_literal] = ACTIONS(1370),
  },
  [381] = {
    [sym_line_comment] = STATE(381),
    [sym_block_comment] = STATE(381),
    [ts_builtin_sym_end] = ACTIONS(1374),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1374),
    [anon_sym_macro_rules_BANG] = ACTIONS(1374),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_LBRACE] = ACTIONS(1374),
    [anon_sym_RBRACE] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_QMARK] = ACTIONS(1374),
    [anon_sym_u8] = ACTIONS(1376),
    [anon_sym_i8] = ACTIONS(1376),
    [anon_sym_u16] = ACTIONS(1376),
    [anon_sym_i16] = ACTIONS(1376),
    [anon_sym_u32] = ACTIONS(1376),
    [anon_sym_i32] = ACTIONS(1376),
    [anon_sym_u64] = ACTIONS(1376),
    [anon_sym_i64] = ACTIONS(1376),
    [anon_sym_u128] = ACTIONS(1376),
    [anon_sym_i128] = ACTIONS(1376),
    [anon_sym_isize] = ACTIONS(1376),
    [anon_sym_usize] = ACTIONS(1376),
    [anon_sym_f32] = ACTIONS(1376),
    [anon_sym_f64] = ACTIONS(1376),
    [anon_sym_bool] = ACTIONS(1376),
    [anon_sym_str] = ACTIONS(1376),
    [anon_sym_char] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1376),
    [anon_sym_CARET] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_AMP] = ACTIONS(1376),
    [anon_sym_PIPE] = ACTIONS(1376),
    [anon_sym_AMP_AMP] = ACTIONS(1374),
    [anon_sym_PIPE_PIPE] = ACTIONS(1374),
    [anon_sym_LT_LT] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1376),
    [anon_sym_PLUS_EQ] = ACTIONS(1374),
    [anon_sym_DASH_EQ] = ACTIONS(1374),
    [anon_sym_STAR_EQ] = ACTIONS(1374),
    [anon_sym_SLASH_EQ] = ACTIONS(1374),
    [anon_sym_PERCENT_EQ] = ACTIONS(1374),
    [anon_sym_CARET_EQ] = ACTIONS(1374),
    [anon_sym_AMP_EQ] = ACTIONS(1374),
    [anon_sym_PIPE_EQ] = ACTIONS(1374),
    [anon_sym_LT_LT_EQ] = ACTIONS(1374),
    [anon_sym_GT_GT_EQ] = ACTIONS(1374),
    [anon_sym_EQ] = ACTIONS(1376),
    [anon_sym_EQ_EQ] = ACTIONS(1374),
    [anon_sym_BANG_EQ] = ACTIONS(1374),
    [anon_sym_GT] = ACTIONS(1376),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_GT_EQ] = ACTIONS(1374),
    [anon_sym_LT_EQ] = ACTIONS(1374),
    [anon_sym_DOT] = ACTIONS(1376),
    [anon_sym_DOT_DOT] = ACTIONS(1376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1374),
    [anon_sym_COLON_COLON] = ACTIONS(1374),
    [anon_sym_POUND] = ACTIONS(1374),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [anon_sym_as] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1376),
    [anon_sym_break] = ACTIONS(1376),
    [anon_sym_const] = ACTIONS(1376),
    [anon_sym_continue] = ACTIONS(1376),
    [anon_sym_default] = ACTIONS(1376),
    [anon_sym_enum] = ACTIONS(1376),
    [anon_sym_fn] = ACTIONS(1376),
    [anon_sym_for] = ACTIONS(1376),
    [anon_sym_if] = ACTIONS(1376),
    [anon_sym_impl] = ACTIONS(1376),
    [anon_sym_let] = ACTIONS(1376),
    [anon_sym_loop] = ACTIONS(1376),
    [anon_sym_match] = ACTIONS(1376),
    [anon_sym_mod] = ACTIONS(1376),
    [anon_sym_pub] = ACTIONS(1376),
    [anon_sym_return] = ACTIONS(1376),
    [anon_sym_static] = ACTIONS(1376),
    [anon_sym_struct] = ACTIONS(1376),
    [anon_sym_trait] = ACTIONS(1376),
    [anon_sym_type] = ACTIONS(1376),
    [anon_sym_union] = ACTIONS(1376),
    [anon_sym_unsafe] = ACTIONS(1376),
    [anon_sym_use] = ACTIONS(1376),
    [anon_sym_while] = ACTIONS(1376),
    [anon_sym_extern] = ACTIONS(1376),
    [anon_sym_yield] = ACTIONS(1376),
    [anon_sym_move] = ACTIONS(1376),
    [anon_sym_try] = ACTIONS(1376),
    [sym_integer_literal] = ACTIONS(1374),
    [aux_sym_string_literal_token1] = ACTIONS(1374),
    [sym_char_literal] = ACTIONS(1374),
    [anon_sym_true] = ACTIONS(1376),
    [anon_sym_false] = ACTIONS(1376),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1376),
    [sym_super] = ACTIONS(1376),
    [sym_crate] = ACTIONS(1376),
    [sym_metavariable] = ACTIONS(1374),
    [sym__raw_string_literal_start] = ACTIONS(1374),
    [sym_float_literal] = ACTIONS(1374),
  },
  [382] = {
    [sym_attribute_item] = STATE(417),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(2791),
    [sym_variadic_parameter] = STATE(2791),
    [sym_parameter] = STATE(2791),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2682),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(382),
    [sym_block_comment] = STATE(382),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1380),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COMMA] = ACTIONS(1382),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [383] = {
    [sym_attribute_item] = STATE(416),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(2750),
    [sym_variadic_parameter] = STATE(2750),
    [sym_parameter] = STATE(2750),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2631),
    [sym_bracketed_type] = STATE(3533),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3114),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2437),
    [sym_scoped_identifier] = STATE(2126),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2470),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(383),
    [sym_block_comment] = STATE(383),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1264),
    [anon_sym_i8] = ACTIONS(1264),
    [anon_sym_u16] = ACTIONS(1264),
    [anon_sym_i16] = ACTIONS(1264),
    [anon_sym_u32] = ACTIONS(1264),
    [anon_sym_i32] = ACTIONS(1264),
    [anon_sym_u64] = ACTIONS(1264),
    [anon_sym_i64] = ACTIONS(1264),
    [anon_sym_u128] = ACTIONS(1264),
    [anon_sym_i128] = ACTIONS(1264),
    [anon_sym_isize] = ACTIONS(1264),
    [anon_sym_usize] = ACTIONS(1264),
    [anon_sym_f32] = ACTIONS(1264),
    [anon_sym_f64] = ACTIONS(1264),
    [anon_sym_bool] = ACTIONS(1264),
    [anon_sym_str] = ACTIONS(1264),
    [anon_sym_char] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1270),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1274),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COMMA] = ACTIONS(1386),
    [anon_sym_COLON_COLON] = ACTIONS(1282),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1300),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1316),
    [sym_super] = ACTIONS(1318),
    [sym_crate] = ACTIONS(1318),
    [sym_metavariable] = ACTIONS(1320),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [384] = {
    [sym_line_comment] = STATE(384),
    [sym_block_comment] = STATE(384),
    [ts_builtin_sym_end] = ACTIONS(1388),
    [sym_identifier] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym_macro_rules_BANG] = ACTIONS(1388),
    [anon_sym_LPAREN] = ACTIONS(1388),
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1388),
    [anon_sym_RBRACE] = ACTIONS(1388),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_STAR] = ACTIONS(1390),
    [anon_sym_QMARK] = ACTIONS(1394),
    [anon_sym_u8] = ACTIONS(1390),
    [anon_sym_i8] = ACTIONS(1390),
    [anon_sym_u16] = ACTIONS(1390),
    [anon_sym_i16] = ACTIONS(1390),
    [anon_sym_u32] = ACTIONS(1390),
    [anon_sym_i32] = ACTIONS(1390),
    [anon_sym_u64] = ACTIONS(1390),
    [anon_sym_i64] = ACTIONS(1390),
    [anon_sym_u128] = ACTIONS(1390),
    [anon_sym_i128] = ACTIONS(1390),
    [anon_sym_isize] = ACTIONS(1390),
    [anon_sym_usize] = ACTIONS(1390),
    [anon_sym_f32] = ACTIONS(1390),
    [anon_sym_f64] = ACTIONS(1390),
    [anon_sym_bool] = ACTIONS(1390),
    [anon_sym_str] = ACTIONS(1390),
    [anon_sym_char] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP_AMP] = ACTIONS(1394),
    [anon_sym_PIPE_PIPE] = ACTIONS(1394),
    [anon_sym_LT_LT] = ACTIONS(1392),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1394),
    [anon_sym_DASH_EQ] = ACTIONS(1394),
    [anon_sym_STAR_EQ] = ACTIONS(1394),
    [anon_sym_SLASH_EQ] = ACTIONS(1394),
    [anon_sym_PERCENT_EQ] = ACTIONS(1394),
    [anon_sym_CARET_EQ] = ACTIONS(1394),
    [anon_sym_AMP_EQ] = ACTIONS(1394),
    [anon_sym_PIPE_EQ] = ACTIONS(1394),
    [anon_sym_LT_LT_EQ] = ACTIONS(1394),
    [anon_sym_GT_GT_EQ] = ACTIONS(1394),
    [anon_sym_EQ] = ACTIONS(1392),
    [anon_sym_EQ_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1394),
    [anon_sym_GT] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_GT_EQ] = ACTIONS(1394),
    [anon_sym_LT_EQ] = ACTIONS(1394),
    [anon_sym_DOT] = ACTIONS(1392),
    [anon_sym_DOT_DOT] = ACTIONS(1390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1394),
    [anon_sym_COLON_COLON] = ACTIONS(1388),
    [anon_sym_POUND] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1390),
    [anon_sym_as] = ACTIONS(1392),
    [anon_sym_async] = ACTIONS(1390),
    [anon_sym_break] = ACTIONS(1390),
    [anon_sym_const] = ACTIONS(1390),
    [anon_sym_continue] = ACTIONS(1390),
    [anon_sym_default] = ACTIONS(1390),
    [anon_sym_enum] = ACTIONS(1390),
    [anon_sym_fn] = ACTIONS(1390),
    [anon_sym_for] = ACTIONS(1390),
    [anon_sym_if] = ACTIONS(1390),
    [anon_sym_impl] = ACTIONS(1390),
    [anon_sym_let] = ACTIONS(1390),
    [anon_sym_loop] = ACTIONS(1390),
    [anon_sym_match] = ACTIONS(1390),
    [anon_sym_mod] = ACTIONS(1390),
    [anon_sym_pub] = ACTIONS(1390),
    [anon_sym_return] = ACTIONS(1390),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_struct] = ACTIONS(1390),
    [anon_sym_trait] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(1390),
    [anon_sym_union] = ACTIONS(1390),
    [anon_sym_unsafe] = ACTIONS(1390),
    [anon_sym_use] = ACTIONS(1390),
    [anon_sym_while] = ACTIONS(1390),
    [anon_sym_extern] = ACTIONS(1390),
    [anon_sym_yield] = ACTIONS(1390),
    [anon_sym_move] = ACTIONS(1390),
    [anon_sym_try] = ACTIONS(1390),
    [sym_integer_literal] = ACTIONS(1388),
    [aux_sym_string_literal_token1] = ACTIONS(1388),
    [sym_char_literal] = ACTIONS(1388),
    [anon_sym_true] = ACTIONS(1390),
    [anon_sym_false] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1390),
    [sym_super] = ACTIONS(1390),
    [sym_crate] = ACTIONS(1390),
    [sym_metavariable] = ACTIONS(1388),
    [sym__raw_string_literal_start] = ACTIONS(1388),
    [sym_float_literal] = ACTIONS(1388),
  },
  [385] = {
    [sym_line_comment] = STATE(385),
    [sym_block_comment] = STATE(385),
    [ts_builtin_sym_end] = ACTIONS(1396),
    [sym_identifier] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym_macro_rules_BANG] = ACTIONS(1396),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_LBRACK] = ACTIONS(1396),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1396),
    [anon_sym_u8] = ACTIONS(1398),
    [anon_sym_i8] = ACTIONS(1398),
    [anon_sym_u16] = ACTIONS(1398),
    [anon_sym_i16] = ACTIONS(1398),
    [anon_sym_u32] = ACTIONS(1398),
    [anon_sym_i32] = ACTIONS(1398),
    [anon_sym_u64] = ACTIONS(1398),
    [anon_sym_i64] = ACTIONS(1398),
    [anon_sym_u128] = ACTIONS(1398),
    [anon_sym_i128] = ACTIONS(1398),
    [anon_sym_isize] = ACTIONS(1398),
    [anon_sym_usize] = ACTIONS(1398),
    [anon_sym_f32] = ACTIONS(1398),
    [anon_sym_f64] = ACTIONS(1398),
    [anon_sym_bool] = ACTIONS(1398),
    [anon_sym_str] = ACTIONS(1398),
    [anon_sym_char] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_SLASH] = ACTIONS(1398),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_CARET] = ACTIONS(1398),
    [anon_sym_BANG] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1398),
    [anon_sym_PIPE] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1396),
    [anon_sym_PIPE_PIPE] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_PLUS_EQ] = ACTIONS(1396),
    [anon_sym_DASH_EQ] = ACTIONS(1396),
    [anon_sym_STAR_EQ] = ACTIONS(1396),
    [anon_sym_SLASH_EQ] = ACTIONS(1396),
    [anon_sym_PERCENT_EQ] = ACTIONS(1396),
    [anon_sym_CARET_EQ] = ACTIONS(1396),
    [anon_sym_AMP_EQ] = ACTIONS(1396),
    [anon_sym_PIPE_EQ] = ACTIONS(1396),
    [anon_sym_LT_LT_EQ] = ACTIONS(1396),
    [anon_sym_GT_GT_EQ] = ACTIONS(1396),
    [anon_sym_EQ] = ACTIONS(1398),
    [anon_sym_EQ_EQ] = ACTIONS(1396),
    [anon_sym_BANG_EQ] = ACTIONS(1396),
    [anon_sym_GT] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1398),
    [anon_sym_GT_EQ] = ACTIONS(1396),
    [anon_sym_LT_EQ] = ACTIONS(1396),
    [anon_sym_DOT] = ACTIONS(1398),
    [anon_sym_DOT_DOT] = ACTIONS(1398),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1396),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1396),
    [anon_sym_COLON_COLON] = ACTIONS(1396),
    [anon_sym_POUND] = ACTIONS(1396),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_as] = ACTIONS(1398),
    [anon_sym_async] = ACTIONS(1398),
    [anon_sym_break] = ACTIONS(1398),
    [anon_sym_const] = ACTIONS(1398),
    [anon_sym_continue] = ACTIONS(1398),
    [anon_sym_default] = ACTIONS(1398),
    [anon_sym_enum] = ACTIONS(1398),
    [anon_sym_fn] = ACTIONS(1398),
    [anon_sym_for] = ACTIONS(1398),
    [anon_sym_if] = ACTIONS(1398),
    [anon_sym_impl] = ACTIONS(1398),
    [anon_sym_let] = ACTIONS(1398),
    [anon_sym_loop] = ACTIONS(1398),
    [anon_sym_match] = ACTIONS(1398),
    [anon_sym_mod] = ACTIONS(1398),
    [anon_sym_pub] = ACTIONS(1398),
    [anon_sym_return] = ACTIONS(1398),
    [anon_sym_static] = ACTIONS(1398),
    [anon_sym_struct] = ACTIONS(1398),
    [anon_sym_trait] = ACTIONS(1398),
    [anon_sym_type] = ACTIONS(1398),
    [anon_sym_union] = ACTIONS(1398),
    [anon_sym_unsafe] = ACTIONS(1398),
    [anon_sym_use] = ACTIONS(1398),
    [anon_sym_while] = ACTIONS(1398),
    [anon_sym_extern] = ACTIONS(1398),
    [anon_sym_yield] = ACTIONS(1398),
    [anon_sym_move] = ACTIONS(1398),
    [anon_sym_try] = ACTIONS(1398),
    [sym_integer_literal] = ACTIONS(1396),
    [aux_sym_string_literal_token1] = ACTIONS(1396),
    [sym_char_literal] = ACTIONS(1396),
    [anon_sym_true] = ACTIONS(1398),
    [anon_sym_false] = ACTIONS(1398),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1398),
    [sym_super] = ACTIONS(1398),
    [sym_crate] = ACTIONS(1398),
    [sym_metavariable] = ACTIONS(1396),
    [sym__raw_string_literal_start] = ACTIONS(1396),
    [sym_float_literal] = ACTIONS(1396),
  },
  [386] = {
    [sym_line_comment] = STATE(386),
    [sym_block_comment] = STATE(386),
    [ts_builtin_sym_end] = ACTIONS(1400),
    [sym_identifier] = ACTIONS(1402),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_macro_rules_BANG] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_RBRACE] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1402),
    [anon_sym_QMARK] = ACTIONS(1400),
    [anon_sym_u8] = ACTIONS(1402),
    [anon_sym_i8] = ACTIONS(1402),
    [anon_sym_u16] = ACTIONS(1402),
    [anon_sym_i16] = ACTIONS(1402),
    [anon_sym_u32] = ACTIONS(1402),
    [anon_sym_i32] = ACTIONS(1402),
    [anon_sym_u64] = ACTIONS(1402),
    [anon_sym_i64] = ACTIONS(1402),
    [anon_sym_u128] = ACTIONS(1402),
    [anon_sym_i128] = ACTIONS(1402),
    [anon_sym_isize] = ACTIONS(1402),
    [anon_sym_usize] = ACTIONS(1402),
    [anon_sym_f32] = ACTIONS(1402),
    [anon_sym_f64] = ACTIONS(1402),
    [anon_sym_bool] = ACTIONS(1402),
    [anon_sym_str] = ACTIONS(1402),
    [anon_sym_char] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1402),
    [anon_sym_SLASH] = ACTIONS(1402),
    [anon_sym_PERCENT] = ACTIONS(1402),
    [anon_sym_CARET] = ACTIONS(1402),
    [anon_sym_BANG] = ACTIONS(1402),
    [anon_sym_AMP] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_PLUS_EQ] = ACTIONS(1400),
    [anon_sym_DASH_EQ] = ACTIONS(1400),
    [anon_sym_STAR_EQ] = ACTIONS(1400),
    [anon_sym_SLASH_EQ] = ACTIONS(1400),
    [anon_sym_PERCENT_EQ] = ACTIONS(1400),
    [anon_sym_CARET_EQ] = ACTIONS(1400),
    [anon_sym_AMP_EQ] = ACTIONS(1400),
    [anon_sym_PIPE_EQ] = ACTIONS(1400),
    [anon_sym_LT_LT_EQ] = ACTIONS(1400),
    [anon_sym_GT_GT_EQ] = ACTIONS(1400),
    [anon_sym_EQ] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT_EQ] = ACTIONS(1400),
    [anon_sym_LT_EQ] = ACTIONS(1400),
    [anon_sym_DOT] = ACTIONS(1402),
    [anon_sym_DOT_DOT] = ACTIONS(1402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1400),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1400),
    [anon_sym_COLON_COLON] = ACTIONS(1400),
    [anon_sym_POUND] = ACTIONS(1400),
    [anon_sym_SQUOTE] = ACTIONS(1402),
    [anon_sym_as] = ACTIONS(1402),
    [anon_sym_async] = ACTIONS(1402),
    [anon_sym_break] = ACTIONS(1402),
    [anon_sym_const] = ACTIONS(1402),
    [anon_sym_continue] = ACTIONS(1402),
    [anon_sym_default] = ACTIONS(1402),
    [anon_sym_enum] = ACTIONS(1402),
    [anon_sym_fn] = ACTIONS(1402),
    [anon_sym_for] = ACTIONS(1402),
    [anon_sym_if] = ACTIONS(1402),
    [anon_sym_impl] = ACTIONS(1402),
    [anon_sym_let] = ACTIONS(1402),
    [anon_sym_loop] = ACTIONS(1402),
    [anon_sym_match] = ACTIONS(1402),
    [anon_sym_mod] = ACTIONS(1402),
    [anon_sym_pub] = ACTIONS(1402),
    [anon_sym_return] = ACTIONS(1402),
    [anon_sym_static] = ACTIONS(1402),
    [anon_sym_struct] = ACTIONS(1402),
    [anon_sym_trait] = ACTIONS(1402),
    [anon_sym_type] = ACTIONS(1402),
    [anon_sym_union] = ACTIONS(1402),
    [anon_sym_unsafe] = ACTIONS(1402),
    [anon_sym_use] = ACTIONS(1402),
    [anon_sym_while] = ACTIONS(1402),
    [anon_sym_extern] = ACTIONS(1402),
    [anon_sym_yield] = ACTIONS(1402),
    [anon_sym_move] = ACTIONS(1402),
    [anon_sym_try] = ACTIONS(1402),
    [sym_integer_literal] = ACTIONS(1400),
    [aux_sym_string_literal_token1] = ACTIONS(1400),
    [sym_char_literal] = ACTIONS(1400),
    [anon_sym_true] = ACTIONS(1402),
    [anon_sym_false] = ACTIONS(1402),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1402),
    [sym_super] = ACTIONS(1402),
    [sym_crate] = ACTIONS(1402),
    [sym_metavariable] = ACTIONS(1400),
    [sym__raw_string_literal_start] = ACTIONS(1400),
    [sym_float_literal] = ACTIONS(1400),
  },
  [387] = {
    [sym_line_comment] = STATE(387),
    [sym_block_comment] = STATE(387),
    [ts_builtin_sym_end] = ACTIONS(993),
    [sym_identifier] = ACTIONS(991),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_macro_rules_BANG] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_u8] = ACTIONS(991),
    [anon_sym_i8] = ACTIONS(991),
    [anon_sym_u16] = ACTIONS(991),
    [anon_sym_i16] = ACTIONS(991),
    [anon_sym_u32] = ACTIONS(991),
    [anon_sym_i32] = ACTIONS(991),
    [anon_sym_u64] = ACTIONS(991),
    [anon_sym_i64] = ACTIONS(991),
    [anon_sym_u128] = ACTIONS(991),
    [anon_sym_i128] = ACTIONS(991),
    [anon_sym_isize] = ACTIONS(991),
    [anon_sym_usize] = ACTIONS(991),
    [anon_sym_f32] = ACTIONS(991),
    [anon_sym_f64] = ACTIONS(991),
    [anon_sym_bool] = ACTIONS(991),
    [anon_sym_str] = ACTIONS(991),
    [anon_sym_char] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(991),
    [anon_sym_PERCENT] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(991),
    [anon_sym_GT_GT] = ACTIONS(991),
    [anon_sym_PLUS_EQ] = ACTIONS(993),
    [anon_sym_DASH_EQ] = ACTIONS(993),
    [anon_sym_STAR_EQ] = ACTIONS(993),
    [anon_sym_SLASH_EQ] = ACTIONS(993),
    [anon_sym_PERCENT_EQ] = ACTIONS(993),
    [anon_sym_CARET_EQ] = ACTIONS(993),
    [anon_sym_AMP_EQ] = ACTIONS(993),
    [anon_sym_PIPE_EQ] = ACTIONS(993),
    [anon_sym_LT_LT_EQ] = ACTIONS(993),
    [anon_sym_GT_GT_EQ] = ACTIONS(993),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_EQ_EQ] = ACTIONS(993),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_GT] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(991),
    [anon_sym_DOT_DOT] = ACTIONS(991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(993),
    [anon_sym_COLON_COLON] = ACTIONS(993),
    [anon_sym_POUND] = ACTIONS(993),
    [anon_sym_SQUOTE] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(991),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_break] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_continue] = ACTIONS(991),
    [anon_sym_default] = ACTIONS(991),
    [anon_sym_enum] = ACTIONS(991),
    [anon_sym_fn] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_impl] = ACTIONS(991),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_loop] = ACTIONS(991),
    [anon_sym_match] = ACTIONS(991),
    [anon_sym_mod] = ACTIONS(991),
    [anon_sym_pub] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(991),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_struct] = ACTIONS(991),
    [anon_sym_trait] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_union] = ACTIONS(991),
    [anon_sym_unsafe] = ACTIONS(991),
    [anon_sym_use] = ACTIONS(991),
    [anon_sym_while] = ACTIONS(991),
    [anon_sym_extern] = ACTIONS(991),
    [anon_sym_yield] = ACTIONS(991),
    [anon_sym_move] = ACTIONS(991),
    [anon_sym_try] = ACTIONS(991),
    [sym_integer_literal] = ACTIONS(993),
    [aux_sym_string_literal_token1] = ACTIONS(993),
    [sym_char_literal] = ACTIONS(993),
    [anon_sym_true] = ACTIONS(991),
    [anon_sym_false] = ACTIONS(991),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(991),
    [sym_super] = ACTIONS(991),
    [sym_crate] = ACTIONS(991),
    [sym_metavariable] = ACTIONS(993),
    [sym__raw_string_literal_start] = ACTIONS(993),
    [sym_float_literal] = ACTIONS(993),
  },
  [388] = {
    [sym_attribute_item] = STATE(415),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(2969),
    [sym_variadic_parameter] = STATE(2969),
    [sym_parameter] = STATE(2969),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2562),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(388),
    [sym_block_comment] = STATE(388),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1404),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1406),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COMMA] = ACTIONS(1408),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [389] = {
    [sym_line_comment] = STATE(389),
    [sym_block_comment] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(1410),
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_SEMI] = ACTIONS(1410),
    [anon_sym_macro_rules_BANG] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(1410),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(1410),
    [anon_sym_RBRACE] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(1412),
    [anon_sym_STAR] = ACTIONS(1412),
    [anon_sym_QMARK] = ACTIONS(1410),
    [anon_sym_u8] = ACTIONS(1412),
    [anon_sym_i8] = ACTIONS(1412),
    [anon_sym_u16] = ACTIONS(1412),
    [anon_sym_i16] = ACTIONS(1412),
    [anon_sym_u32] = ACTIONS(1412),
    [anon_sym_i32] = ACTIONS(1412),
    [anon_sym_u64] = ACTIONS(1412),
    [anon_sym_i64] = ACTIONS(1412),
    [anon_sym_u128] = ACTIONS(1412),
    [anon_sym_i128] = ACTIONS(1412),
    [anon_sym_isize] = ACTIONS(1412),
    [anon_sym_usize] = ACTIONS(1412),
    [anon_sym_f32] = ACTIONS(1412),
    [anon_sym_f64] = ACTIONS(1412),
    [anon_sym_bool] = ACTIONS(1412),
    [anon_sym_str] = ACTIONS(1412),
    [anon_sym_char] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1412),
    [anon_sym_SLASH] = ACTIONS(1412),
    [anon_sym_PERCENT] = ACTIONS(1412),
    [anon_sym_CARET] = ACTIONS(1412),
    [anon_sym_BANG] = ACTIONS(1412),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_PIPE] = ACTIONS(1412),
    [anon_sym_AMP_AMP] = ACTIONS(1410),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_LT_LT] = ACTIONS(1412),
    [anon_sym_GT_GT] = ACTIONS(1412),
    [anon_sym_PLUS_EQ] = ACTIONS(1410),
    [anon_sym_DASH_EQ] = ACTIONS(1410),
    [anon_sym_STAR_EQ] = ACTIONS(1410),
    [anon_sym_SLASH_EQ] = ACTIONS(1410),
    [anon_sym_PERCENT_EQ] = ACTIONS(1410),
    [anon_sym_CARET_EQ] = ACTIONS(1410),
    [anon_sym_AMP_EQ] = ACTIONS(1410),
    [anon_sym_PIPE_EQ] = ACTIONS(1410),
    [anon_sym_LT_LT_EQ] = ACTIONS(1410),
    [anon_sym_GT_GT_EQ] = ACTIONS(1410),
    [anon_sym_EQ] = ACTIONS(1412),
    [anon_sym_EQ_EQ] = ACTIONS(1410),
    [anon_sym_BANG_EQ] = ACTIONS(1410),
    [anon_sym_GT] = ACTIONS(1412),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT_EQ] = ACTIONS(1410),
    [anon_sym_LT_EQ] = ACTIONS(1410),
    [anon_sym_DOT] = ACTIONS(1412),
    [anon_sym_DOT_DOT] = ACTIONS(1412),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1410),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1410),
    [anon_sym_COLON_COLON] = ACTIONS(1410),
    [anon_sym_POUND] = ACTIONS(1410),
    [anon_sym_SQUOTE] = ACTIONS(1412),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_async] = ACTIONS(1412),
    [anon_sym_break] = ACTIONS(1412),
    [anon_sym_const] = ACTIONS(1412),
    [anon_sym_continue] = ACTIONS(1412),
    [anon_sym_default] = ACTIONS(1412),
    [anon_sym_enum] = ACTIONS(1412),
    [anon_sym_fn] = ACTIONS(1412),
    [anon_sym_for] = ACTIONS(1412),
    [anon_sym_if] = ACTIONS(1412),
    [anon_sym_impl] = ACTIONS(1412),
    [anon_sym_let] = ACTIONS(1412),
    [anon_sym_loop] = ACTIONS(1412),
    [anon_sym_match] = ACTIONS(1412),
    [anon_sym_mod] = ACTIONS(1412),
    [anon_sym_pub] = ACTIONS(1412),
    [anon_sym_return] = ACTIONS(1412),
    [anon_sym_static] = ACTIONS(1412),
    [anon_sym_struct] = ACTIONS(1412),
    [anon_sym_trait] = ACTIONS(1412),
    [anon_sym_type] = ACTIONS(1412),
    [anon_sym_union] = ACTIONS(1412),
    [anon_sym_unsafe] = ACTIONS(1412),
    [anon_sym_use] = ACTIONS(1412),
    [anon_sym_while] = ACTIONS(1412),
    [anon_sym_extern] = ACTIONS(1412),
    [anon_sym_yield] = ACTIONS(1412),
    [anon_sym_move] = ACTIONS(1412),
    [anon_sym_try] = ACTIONS(1412),
    [sym_integer_literal] = ACTIONS(1410),
    [aux_sym_string_literal_token1] = ACTIONS(1410),
    [sym_char_literal] = ACTIONS(1410),
    [anon_sym_true] = ACTIONS(1412),
    [anon_sym_false] = ACTIONS(1412),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1412),
    [sym_super] = ACTIONS(1412),
    [sym_crate] = ACTIONS(1412),
    [sym_metavariable] = ACTIONS(1410),
    [sym__raw_string_literal_start] = ACTIONS(1410),
    [sym_float_literal] = ACTIONS(1410),
  },
  [390] = {
    [sym_line_comment] = STATE(390),
    [sym_block_comment] = STATE(390),
    [ts_builtin_sym_end] = ACTIONS(1414),
    [sym_identifier] = ACTIONS(1416),
    [anon_sym_SEMI] = ACTIONS(1414),
    [anon_sym_macro_rules_BANG] = ACTIONS(1414),
    [anon_sym_LPAREN] = ACTIONS(1414),
    [anon_sym_LBRACK] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1414),
    [anon_sym_RBRACE] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_QMARK] = ACTIONS(1414),
    [anon_sym_u8] = ACTIONS(1416),
    [anon_sym_i8] = ACTIONS(1416),
    [anon_sym_u16] = ACTIONS(1416),
    [anon_sym_i16] = ACTIONS(1416),
    [anon_sym_u32] = ACTIONS(1416),
    [anon_sym_i32] = ACTIONS(1416),
    [anon_sym_u64] = ACTIONS(1416),
    [anon_sym_i64] = ACTIONS(1416),
    [anon_sym_u128] = ACTIONS(1416),
    [anon_sym_i128] = ACTIONS(1416),
    [anon_sym_isize] = ACTIONS(1416),
    [anon_sym_usize] = ACTIONS(1416),
    [anon_sym_f32] = ACTIONS(1416),
    [anon_sym_f64] = ACTIONS(1416),
    [anon_sym_bool] = ACTIONS(1416),
    [anon_sym_str] = ACTIONS(1416),
    [anon_sym_char] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_SLASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(1416),
    [anon_sym_CARET] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_PIPE] = ACTIONS(1416),
    [anon_sym_AMP_AMP] = ACTIONS(1414),
    [anon_sym_PIPE_PIPE] = ACTIONS(1414),
    [anon_sym_LT_LT] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1416),
    [anon_sym_PLUS_EQ] = ACTIONS(1414),
    [anon_sym_DASH_EQ] = ACTIONS(1414),
    [anon_sym_STAR_EQ] = ACTIONS(1414),
    [anon_sym_SLASH_EQ] = ACTIONS(1414),
    [anon_sym_PERCENT_EQ] = ACTIONS(1414),
    [anon_sym_CARET_EQ] = ACTIONS(1414),
    [anon_sym_AMP_EQ] = ACTIONS(1414),
    [anon_sym_PIPE_EQ] = ACTIONS(1414),
    [anon_sym_LT_LT_EQ] = ACTIONS(1414),
    [anon_sym_GT_GT_EQ] = ACTIONS(1414),
    [anon_sym_EQ] = ACTIONS(1416),
    [anon_sym_EQ_EQ] = ACTIONS(1414),
    [anon_sym_BANG_EQ] = ACTIONS(1414),
    [anon_sym_GT] = ACTIONS(1416),
    [anon_sym_LT] = ACTIONS(1416),
    [anon_sym_GT_EQ] = ACTIONS(1414),
    [anon_sym_LT_EQ] = ACTIONS(1414),
    [anon_sym_DOT] = ACTIONS(1416),
    [anon_sym_DOT_DOT] = ACTIONS(1416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1414),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1414),
    [anon_sym_COLON_COLON] = ACTIONS(1414),
    [anon_sym_POUND] = ACTIONS(1414),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_as] = ACTIONS(1416),
    [anon_sym_async] = ACTIONS(1416),
    [anon_sym_break] = ACTIONS(1416),
    [anon_sym_const] = ACTIONS(1416),
    [anon_sym_continue] = ACTIONS(1416),
    [anon_sym_default] = ACTIONS(1416),
    [anon_sym_enum] = ACTIONS(1416),
    [anon_sym_fn] = ACTIONS(1416),
    [anon_sym_for] = ACTIONS(1416),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_impl] = ACTIONS(1416),
    [anon_sym_let] = ACTIONS(1416),
    [anon_sym_loop] = ACTIONS(1416),
    [anon_sym_match] = ACTIONS(1416),
    [anon_sym_mod] = ACTIONS(1416),
    [anon_sym_pub] = ACTIONS(1416),
    [anon_sym_return] = ACTIONS(1416),
    [anon_sym_static] = ACTIONS(1416),
    [anon_sym_struct] = ACTIONS(1416),
    [anon_sym_trait] = ACTIONS(1416),
    [anon_sym_type] = ACTIONS(1416),
    [anon_sym_union] = ACTIONS(1416),
    [anon_sym_unsafe] = ACTIONS(1416),
    [anon_sym_use] = ACTIONS(1416),
    [anon_sym_while] = ACTIONS(1416),
    [anon_sym_extern] = ACTIONS(1416),
    [anon_sym_yield] = ACTIONS(1416),
    [anon_sym_move] = ACTIONS(1416),
    [anon_sym_try] = ACTIONS(1416),
    [sym_integer_literal] = ACTIONS(1414),
    [aux_sym_string_literal_token1] = ACTIONS(1414),
    [sym_char_literal] = ACTIONS(1414),
    [anon_sym_true] = ACTIONS(1416),
    [anon_sym_false] = ACTIONS(1416),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1416),
    [sym_super] = ACTIONS(1416),
    [sym_crate] = ACTIONS(1416),
    [sym_metavariable] = ACTIONS(1414),
    [sym__raw_string_literal_start] = ACTIONS(1414),
    [sym_float_literal] = ACTIONS(1414),
  },
  [391] = {
    [sym_line_comment] = STATE(391),
    [sym_block_comment] = STATE(391),
    [ts_builtin_sym_end] = ACTIONS(1418),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_macro_rules_BANG] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_LBRACK] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1420),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_QMARK] = ACTIONS(1418),
    [anon_sym_u8] = ACTIONS(1420),
    [anon_sym_i8] = ACTIONS(1420),
    [anon_sym_u16] = ACTIONS(1420),
    [anon_sym_i16] = ACTIONS(1420),
    [anon_sym_u32] = ACTIONS(1420),
    [anon_sym_i32] = ACTIONS(1420),
    [anon_sym_u64] = ACTIONS(1420),
    [anon_sym_i64] = ACTIONS(1420),
    [anon_sym_u128] = ACTIONS(1420),
    [anon_sym_i128] = ACTIONS(1420),
    [anon_sym_isize] = ACTIONS(1420),
    [anon_sym_usize] = ACTIONS(1420),
    [anon_sym_f32] = ACTIONS(1420),
    [anon_sym_f64] = ACTIONS(1420),
    [anon_sym_bool] = ACTIONS(1420),
    [anon_sym_str] = ACTIONS(1420),
    [anon_sym_char] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_SLASH] = ACTIONS(1420),
    [anon_sym_PERCENT] = ACTIONS(1420),
    [anon_sym_CARET] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_PIPE] = ACTIONS(1420),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_PIPE_PIPE] = ACTIONS(1418),
    [anon_sym_LT_LT] = ACTIONS(1420),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_EQ] = ACTIONS(1418),
    [anon_sym_DASH_EQ] = ACTIONS(1418),
    [anon_sym_STAR_EQ] = ACTIONS(1418),
    [anon_sym_SLASH_EQ] = ACTIONS(1418),
    [anon_sym_PERCENT_EQ] = ACTIONS(1418),
    [anon_sym_CARET_EQ] = ACTIONS(1418),
    [anon_sym_AMP_EQ] = ACTIONS(1418),
    [anon_sym_PIPE_EQ] = ACTIONS(1418),
    [anon_sym_LT_LT_EQ] = ACTIONS(1418),
    [anon_sym_GT_GT_EQ] = ACTIONS(1418),
    [anon_sym_EQ] = ACTIONS(1420),
    [anon_sym_EQ_EQ] = ACTIONS(1418),
    [anon_sym_BANG_EQ] = ACTIONS(1418),
    [anon_sym_GT] = ACTIONS(1420),
    [anon_sym_LT] = ACTIONS(1420),
    [anon_sym_GT_EQ] = ACTIONS(1418),
    [anon_sym_LT_EQ] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(1420),
    [anon_sym_DOT_DOT] = ACTIONS(1420),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1418),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1418),
    [anon_sym_COLON_COLON] = ACTIONS(1418),
    [anon_sym_POUND] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_as] = ACTIONS(1420),
    [anon_sym_async] = ACTIONS(1420),
    [anon_sym_break] = ACTIONS(1420),
    [anon_sym_const] = ACTIONS(1420),
    [anon_sym_continue] = ACTIONS(1420),
    [anon_sym_default] = ACTIONS(1420),
    [anon_sym_enum] = ACTIONS(1420),
    [anon_sym_fn] = ACTIONS(1420),
    [anon_sym_for] = ACTIONS(1420),
    [anon_sym_if] = ACTIONS(1420),
    [anon_sym_impl] = ACTIONS(1420),
    [anon_sym_let] = ACTIONS(1420),
    [anon_sym_loop] = ACTIONS(1420),
    [anon_sym_match] = ACTIONS(1420),
    [anon_sym_mod] = ACTIONS(1420),
    [anon_sym_pub] = ACTIONS(1420),
    [anon_sym_return] = ACTIONS(1420),
    [anon_sym_static] = ACTIONS(1420),
    [anon_sym_struct] = ACTIONS(1420),
    [anon_sym_trait] = ACTIONS(1420),
    [anon_sym_type] = ACTIONS(1420),
    [anon_sym_union] = ACTIONS(1420),
    [anon_sym_unsafe] = ACTIONS(1420),
    [anon_sym_use] = ACTIONS(1420),
    [anon_sym_while] = ACTIONS(1420),
    [anon_sym_extern] = ACTIONS(1420),
    [anon_sym_yield] = ACTIONS(1420),
    [anon_sym_move] = ACTIONS(1420),
    [anon_sym_try] = ACTIONS(1420),
    [sym_integer_literal] = ACTIONS(1418),
    [aux_sym_string_literal_token1] = ACTIONS(1418),
    [sym_char_literal] = ACTIONS(1418),
    [anon_sym_true] = ACTIONS(1420),
    [anon_sym_false] = ACTIONS(1420),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1420),
    [sym_super] = ACTIONS(1420),
    [sym_crate] = ACTIONS(1420),
    [sym_metavariable] = ACTIONS(1418),
    [sym__raw_string_literal_start] = ACTIONS(1418),
    [sym_float_literal] = ACTIONS(1418),
  },
  [392] = {
    [sym_line_comment] = STATE(392),
    [sym_block_comment] = STATE(392),
    [ts_builtin_sym_end] = ACTIONS(1422),
    [sym_identifier] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1394),
    [anon_sym_macro_rules_BANG] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(1394),
    [anon_sym_LBRACK] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1422),
    [anon_sym_RBRACE] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_QMARK] = ACTIONS(1394),
    [anon_sym_u8] = ACTIONS(1424),
    [anon_sym_i8] = ACTIONS(1424),
    [anon_sym_u16] = ACTIONS(1424),
    [anon_sym_i16] = ACTIONS(1424),
    [anon_sym_u32] = ACTIONS(1424),
    [anon_sym_i32] = ACTIONS(1424),
    [anon_sym_u64] = ACTIONS(1424),
    [anon_sym_i64] = ACTIONS(1424),
    [anon_sym_u128] = ACTIONS(1424),
    [anon_sym_i128] = ACTIONS(1424),
    [anon_sym_isize] = ACTIONS(1424),
    [anon_sym_usize] = ACTIONS(1424),
    [anon_sym_f32] = ACTIONS(1424),
    [anon_sym_f64] = ACTIONS(1424),
    [anon_sym_bool] = ACTIONS(1424),
    [anon_sym_str] = ACTIONS(1424),
    [anon_sym_char] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_PIPE] = ACTIONS(1392),
    [anon_sym_AMP_AMP] = ACTIONS(1394),
    [anon_sym_PIPE_PIPE] = ACTIONS(1394),
    [anon_sym_LT_LT] = ACTIONS(1392),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1394),
    [anon_sym_DASH_EQ] = ACTIONS(1394),
    [anon_sym_STAR_EQ] = ACTIONS(1394),
    [anon_sym_SLASH_EQ] = ACTIONS(1394),
    [anon_sym_PERCENT_EQ] = ACTIONS(1394),
    [anon_sym_CARET_EQ] = ACTIONS(1394),
    [anon_sym_AMP_EQ] = ACTIONS(1394),
    [anon_sym_PIPE_EQ] = ACTIONS(1394),
    [anon_sym_LT_LT_EQ] = ACTIONS(1394),
    [anon_sym_GT_GT_EQ] = ACTIONS(1394),
    [anon_sym_EQ] = ACTIONS(1392),
    [anon_sym_EQ_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1394),
    [anon_sym_GT] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1392),
    [anon_sym_GT_EQ] = ACTIONS(1394),
    [anon_sym_LT_EQ] = ACTIONS(1394),
    [anon_sym_DOT] = ACTIONS(1392),
    [anon_sym_DOT_DOT] = ACTIONS(1392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1394),
    [anon_sym_COLON_COLON] = ACTIONS(1422),
    [anon_sym_POUND] = ACTIONS(1422),
    [anon_sym_SQUOTE] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1392),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_break] = ACTIONS(1424),
    [anon_sym_const] = ACTIONS(1424),
    [anon_sym_continue] = ACTIONS(1424),
    [anon_sym_default] = ACTIONS(1424),
    [anon_sym_enum] = ACTIONS(1424),
    [anon_sym_fn] = ACTIONS(1424),
    [anon_sym_for] = ACTIONS(1424),
    [anon_sym_if] = ACTIONS(1424),
    [anon_sym_impl] = ACTIONS(1424),
    [anon_sym_let] = ACTIONS(1424),
    [anon_sym_loop] = ACTIONS(1424),
    [anon_sym_match] = ACTIONS(1424),
    [anon_sym_mod] = ACTIONS(1424),
    [anon_sym_pub] = ACTIONS(1424),
    [anon_sym_return] = ACTIONS(1424),
    [anon_sym_static] = ACTIONS(1424),
    [anon_sym_struct] = ACTIONS(1424),
    [anon_sym_trait] = ACTIONS(1424),
    [anon_sym_type] = ACTIONS(1424),
    [anon_sym_union] = ACTIONS(1424),
    [anon_sym_unsafe] = ACTIONS(1424),
    [anon_sym_use] = ACTIONS(1424),
    [anon_sym_while] = ACTIONS(1424),
    [anon_sym_extern] = ACTIONS(1424),
    [anon_sym_yield] = ACTIONS(1424),
    [anon_sym_move] = ACTIONS(1424),
    [anon_sym_try] = ACTIONS(1424),
    [sym_integer_literal] = ACTIONS(1422),
    [aux_sym_string_literal_token1] = ACTIONS(1422),
    [sym_char_literal] = ACTIONS(1422),
    [anon_sym_true] = ACTIONS(1424),
    [anon_sym_false] = ACTIONS(1424),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1424),
    [sym_super] = ACTIONS(1424),
    [sym_crate] = ACTIONS(1424),
    [sym_metavariable] = ACTIONS(1422),
    [sym__raw_string_literal_start] = ACTIONS(1422),
    [sym_float_literal] = ACTIONS(1422),
  },
  [393] = {
    [sym_line_comment] = STATE(393),
    [sym_block_comment] = STATE(393),
    [ts_builtin_sym_end] = ACTIONS(1426),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1426),
    [anon_sym_macro_rules_BANG] = ACTIONS(1426),
    [anon_sym_LPAREN] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1426),
    [anon_sym_RBRACE] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_QMARK] = ACTIONS(1426),
    [anon_sym_u8] = ACTIONS(1428),
    [anon_sym_i8] = ACTIONS(1428),
    [anon_sym_u16] = ACTIONS(1428),
    [anon_sym_i16] = ACTIONS(1428),
    [anon_sym_u32] = ACTIONS(1428),
    [anon_sym_i32] = ACTIONS(1428),
    [anon_sym_u64] = ACTIONS(1428),
    [anon_sym_i64] = ACTIONS(1428),
    [anon_sym_u128] = ACTIONS(1428),
    [anon_sym_i128] = ACTIONS(1428),
    [anon_sym_isize] = ACTIONS(1428),
    [anon_sym_usize] = ACTIONS(1428),
    [anon_sym_f32] = ACTIONS(1428),
    [anon_sym_f64] = ACTIONS(1428),
    [anon_sym_bool] = ACTIONS(1428),
    [anon_sym_str] = ACTIONS(1428),
    [anon_sym_char] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1428),
    [anon_sym_PERCENT] = ACTIONS(1428),
    [anon_sym_CARET] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1426),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_LT_LT] = ACTIONS(1428),
    [anon_sym_GT_GT] = ACTIONS(1428),
    [anon_sym_PLUS_EQ] = ACTIONS(1426),
    [anon_sym_DASH_EQ] = ACTIONS(1426),
    [anon_sym_STAR_EQ] = ACTIONS(1426),
    [anon_sym_SLASH_EQ] = ACTIONS(1426),
    [anon_sym_PERCENT_EQ] = ACTIONS(1426),
    [anon_sym_CARET_EQ] = ACTIONS(1426),
    [anon_sym_AMP_EQ] = ACTIONS(1426),
    [anon_sym_PIPE_EQ] = ACTIONS(1426),
    [anon_sym_LT_LT_EQ] = ACTIONS(1426),
    [anon_sym_GT_GT_EQ] = ACTIONS(1426),
    [anon_sym_EQ] = ACTIONS(1428),
    [anon_sym_EQ_EQ] = ACTIONS(1426),
    [anon_sym_BANG_EQ] = ACTIONS(1426),
    [anon_sym_GT] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1428),
    [anon_sym_GT_EQ] = ACTIONS(1426),
    [anon_sym_LT_EQ] = ACTIONS(1426),
    [anon_sym_DOT] = ACTIONS(1428),
    [anon_sym_DOT_DOT] = ACTIONS(1428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1426),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(1426),
    [anon_sym_POUND] = ACTIONS(1426),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_async] = ACTIONS(1428),
    [anon_sym_break] = ACTIONS(1428),
    [anon_sym_const] = ACTIONS(1428),
    [anon_sym_continue] = ACTIONS(1428),
    [anon_sym_default] = ACTIONS(1428),
    [anon_sym_enum] = ACTIONS(1428),
    [anon_sym_fn] = ACTIONS(1428),
    [anon_sym_for] = ACTIONS(1428),
    [anon_sym_if] = ACTIONS(1428),
    [anon_sym_impl] = ACTIONS(1428),
    [anon_sym_let] = ACTIONS(1428),
    [anon_sym_loop] = ACTIONS(1428),
    [anon_sym_match] = ACTIONS(1428),
    [anon_sym_mod] = ACTIONS(1428),
    [anon_sym_pub] = ACTIONS(1428),
    [anon_sym_return] = ACTIONS(1428),
    [anon_sym_static] = ACTIONS(1428),
    [anon_sym_struct] = ACTIONS(1428),
    [anon_sym_trait] = ACTIONS(1428),
    [anon_sym_type] = ACTIONS(1428),
    [anon_sym_union] = ACTIONS(1428),
    [anon_sym_unsafe] = ACTIONS(1428),
    [anon_sym_use] = ACTIONS(1428),
    [anon_sym_while] = ACTIONS(1428),
    [anon_sym_extern] = ACTIONS(1428),
    [anon_sym_yield] = ACTIONS(1428),
    [anon_sym_move] = ACTIONS(1428),
    [anon_sym_try] = ACTIONS(1428),
    [sym_integer_literal] = ACTIONS(1426),
    [aux_sym_string_literal_token1] = ACTIONS(1426),
    [sym_char_literal] = ACTIONS(1426),
    [anon_sym_true] = ACTIONS(1428),
    [anon_sym_false] = ACTIONS(1428),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1428),
    [sym_super] = ACTIONS(1428),
    [sym_crate] = ACTIONS(1428),
    [sym_metavariable] = ACTIONS(1426),
    [sym__raw_string_literal_start] = ACTIONS(1426),
    [sym_float_literal] = ACTIONS(1426),
  },
  [394] = {
    [sym_line_comment] = STATE(394),
    [sym_block_comment] = STATE(394),
    [ts_builtin_sym_end] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_macro_rules_BANG] = ACTIONS(1430),
    [anon_sym_LPAREN] = ACTIONS(1430),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1430),
    [anon_sym_RBRACE] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1432),
    [anon_sym_STAR] = ACTIONS(1432),
    [anon_sym_QMARK] = ACTIONS(1430),
    [anon_sym_u8] = ACTIONS(1432),
    [anon_sym_i8] = ACTIONS(1432),
    [anon_sym_u16] = ACTIONS(1432),
    [anon_sym_i16] = ACTIONS(1432),
    [anon_sym_u32] = ACTIONS(1432),
    [anon_sym_i32] = ACTIONS(1432),
    [anon_sym_u64] = ACTIONS(1432),
    [anon_sym_i64] = ACTIONS(1432),
    [anon_sym_u128] = ACTIONS(1432),
    [anon_sym_i128] = ACTIONS(1432),
    [anon_sym_isize] = ACTIONS(1432),
    [anon_sym_usize] = ACTIONS(1432),
    [anon_sym_f32] = ACTIONS(1432),
    [anon_sym_f64] = ACTIONS(1432),
    [anon_sym_bool] = ACTIONS(1432),
    [anon_sym_str] = ACTIONS(1432),
    [anon_sym_char] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1432),
    [anon_sym_SLASH] = ACTIONS(1432),
    [anon_sym_PERCENT] = ACTIONS(1432),
    [anon_sym_CARET] = ACTIONS(1432),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_AMP] = ACTIONS(1432),
    [anon_sym_PIPE] = ACTIONS(1432),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [anon_sym_LT_LT] = ACTIONS(1432),
    [anon_sym_GT_GT] = ACTIONS(1432),
    [anon_sym_PLUS_EQ] = ACTIONS(1430),
    [anon_sym_DASH_EQ] = ACTIONS(1430),
    [anon_sym_STAR_EQ] = ACTIONS(1430),
    [anon_sym_SLASH_EQ] = ACTIONS(1430),
    [anon_sym_PERCENT_EQ] = ACTIONS(1430),
    [anon_sym_CARET_EQ] = ACTIONS(1430),
    [anon_sym_AMP_EQ] = ACTIONS(1430),
    [anon_sym_PIPE_EQ] = ACTIONS(1430),
    [anon_sym_LT_LT_EQ] = ACTIONS(1430),
    [anon_sym_GT_GT_EQ] = ACTIONS(1430),
    [anon_sym_EQ] = ACTIONS(1432),
    [anon_sym_EQ_EQ] = ACTIONS(1430),
    [anon_sym_BANG_EQ] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(1432),
    [anon_sym_GT_EQ] = ACTIONS(1430),
    [anon_sym_LT_EQ] = ACTIONS(1430),
    [anon_sym_DOT] = ACTIONS(1432),
    [anon_sym_DOT_DOT] = ACTIONS(1432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1430),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1430),
    [anon_sym_COLON_COLON] = ACTIONS(1430),
    [anon_sym_POUND] = ACTIONS(1430),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [anon_sym_as] = ACTIONS(1432),
    [anon_sym_async] = ACTIONS(1432),
    [anon_sym_break] = ACTIONS(1432),
    [anon_sym_const] = ACTIONS(1432),
    [anon_sym_continue] = ACTIONS(1432),
    [anon_sym_default] = ACTIONS(1432),
    [anon_sym_enum] = ACTIONS(1432),
    [anon_sym_fn] = ACTIONS(1432),
    [anon_sym_for] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1432),
    [anon_sym_impl] = ACTIONS(1432),
    [anon_sym_let] = ACTIONS(1432),
    [anon_sym_loop] = ACTIONS(1432),
    [anon_sym_match] = ACTIONS(1432),
    [anon_sym_mod] = ACTIONS(1432),
    [anon_sym_pub] = ACTIONS(1432),
    [anon_sym_return] = ACTIONS(1432),
    [anon_sym_static] = ACTIONS(1432),
    [anon_sym_struct] = ACTIONS(1432),
    [anon_sym_trait] = ACTIONS(1432),
    [anon_sym_type] = ACTIONS(1432),
    [anon_sym_union] = ACTIONS(1432),
    [anon_sym_unsafe] = ACTIONS(1432),
    [anon_sym_use] = ACTIONS(1432),
    [anon_sym_while] = ACTIONS(1432),
    [anon_sym_extern] = ACTIONS(1432),
    [anon_sym_yield] = ACTIONS(1432),
    [anon_sym_move] = ACTIONS(1432),
    [anon_sym_try] = ACTIONS(1432),
    [sym_integer_literal] = ACTIONS(1430),
    [aux_sym_string_literal_token1] = ACTIONS(1430),
    [sym_char_literal] = ACTIONS(1430),
    [anon_sym_true] = ACTIONS(1432),
    [anon_sym_false] = ACTIONS(1432),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1432),
    [sym_super] = ACTIONS(1432),
    [sym_crate] = ACTIONS(1432),
    [sym_metavariable] = ACTIONS(1430),
    [sym__raw_string_literal_start] = ACTIONS(1430),
    [sym_float_literal] = ACTIONS(1430),
  },
  [395] = {
    [sym_line_comment] = STATE(395),
    [sym_block_comment] = STATE(395),
    [ts_builtin_sym_end] = ACTIONS(1434),
    [sym_identifier] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_macro_rules_BANG] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_QMARK] = ACTIONS(1434),
    [anon_sym_u8] = ACTIONS(1436),
    [anon_sym_i8] = ACTIONS(1436),
    [anon_sym_u16] = ACTIONS(1436),
    [anon_sym_i16] = ACTIONS(1436),
    [anon_sym_u32] = ACTIONS(1436),
    [anon_sym_i32] = ACTIONS(1436),
    [anon_sym_u64] = ACTIONS(1436),
    [anon_sym_i64] = ACTIONS(1436),
    [anon_sym_u128] = ACTIONS(1436),
    [anon_sym_i128] = ACTIONS(1436),
    [anon_sym_isize] = ACTIONS(1436),
    [anon_sym_usize] = ACTIONS(1436),
    [anon_sym_f32] = ACTIONS(1436),
    [anon_sym_f64] = ACTIONS(1436),
    [anon_sym_bool] = ACTIONS(1436),
    [anon_sym_str] = ACTIONS(1436),
    [anon_sym_char] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_PLUS_EQ] = ACTIONS(1434),
    [anon_sym_DASH_EQ] = ACTIONS(1434),
    [anon_sym_STAR_EQ] = ACTIONS(1434),
    [anon_sym_SLASH_EQ] = ACTIONS(1434),
    [anon_sym_PERCENT_EQ] = ACTIONS(1434),
    [anon_sym_CARET_EQ] = ACTIONS(1434),
    [anon_sym_AMP_EQ] = ACTIONS(1434),
    [anon_sym_PIPE_EQ] = ACTIONS(1434),
    [anon_sym_LT_LT_EQ] = ACTIONS(1434),
    [anon_sym_GT_GT_EQ] = ACTIONS(1434),
    [anon_sym_EQ] = ACTIONS(1436),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_BANG_EQ] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_GT_EQ] = ACTIONS(1434),
    [anon_sym_LT_EQ] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(1436),
    [anon_sym_DOT_DOT] = ACTIONS(1436),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1434),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1434),
    [anon_sym_COLON_COLON] = ACTIONS(1434),
    [anon_sym_POUND] = ACTIONS(1434),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [anon_sym_as] = ACTIONS(1436),
    [anon_sym_async] = ACTIONS(1436),
    [anon_sym_break] = ACTIONS(1436),
    [anon_sym_const] = ACTIONS(1436),
    [anon_sym_continue] = ACTIONS(1436),
    [anon_sym_default] = ACTIONS(1436),
    [anon_sym_enum] = ACTIONS(1436),
    [anon_sym_fn] = ACTIONS(1436),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_if] = ACTIONS(1436),
    [anon_sym_impl] = ACTIONS(1436),
    [anon_sym_let] = ACTIONS(1436),
    [anon_sym_loop] = ACTIONS(1436),
    [anon_sym_match] = ACTIONS(1436),
    [anon_sym_mod] = ACTIONS(1436),
    [anon_sym_pub] = ACTIONS(1436),
    [anon_sym_return] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1436),
    [anon_sym_struct] = ACTIONS(1436),
    [anon_sym_trait] = ACTIONS(1436),
    [anon_sym_type] = ACTIONS(1436),
    [anon_sym_union] = ACTIONS(1436),
    [anon_sym_unsafe] = ACTIONS(1436),
    [anon_sym_use] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1436),
    [anon_sym_extern] = ACTIONS(1436),
    [anon_sym_yield] = ACTIONS(1436),
    [anon_sym_move] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1436),
    [sym_integer_literal] = ACTIONS(1434),
    [aux_sym_string_literal_token1] = ACTIONS(1434),
    [sym_char_literal] = ACTIONS(1434),
    [anon_sym_true] = ACTIONS(1436),
    [anon_sym_false] = ACTIONS(1436),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1436),
    [sym_super] = ACTIONS(1436),
    [sym_crate] = ACTIONS(1436),
    [sym_metavariable] = ACTIONS(1434),
    [sym__raw_string_literal_start] = ACTIONS(1434),
    [sym_float_literal] = ACTIONS(1434),
  },
  [396] = {
    [sym_attribute_item] = STATE(416),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(2750),
    [sym_variadic_parameter] = STATE(2750),
    [sym_parameter] = STATE(2750),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2631),
    [sym_bracketed_type] = STATE(3533),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3114),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2437),
    [sym_scoped_identifier] = STATE(2126),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2470),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(396),
    [sym_block_comment] = STATE(396),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_RPAREN] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1264),
    [anon_sym_i8] = ACTIONS(1264),
    [anon_sym_u16] = ACTIONS(1264),
    [anon_sym_i16] = ACTIONS(1264),
    [anon_sym_u32] = ACTIONS(1264),
    [anon_sym_i32] = ACTIONS(1264),
    [anon_sym_u64] = ACTIONS(1264),
    [anon_sym_i64] = ACTIONS(1264),
    [anon_sym_u128] = ACTIONS(1264),
    [anon_sym_i128] = ACTIONS(1264),
    [anon_sym_isize] = ACTIONS(1264),
    [anon_sym_usize] = ACTIONS(1264),
    [anon_sym_f32] = ACTIONS(1264),
    [anon_sym_f64] = ACTIONS(1264),
    [anon_sym_bool] = ACTIONS(1264),
    [anon_sym_str] = ACTIONS(1264),
    [anon_sym_char] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1270),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1274),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COMMA] = ACTIONS(1440),
    [anon_sym_COLON_COLON] = ACTIONS(1282),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1300),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1316),
    [sym_super] = ACTIONS(1318),
    [sym_crate] = ACTIONS(1318),
    [sym_metavariable] = ACTIONS(1320),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [397] = {
    [sym_line_comment] = STATE(397),
    [sym_block_comment] = STATE(397),
    [ts_builtin_sym_end] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_macro_rules_BANG] = ACTIONS(1442),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_u8] = ACTIONS(1444),
    [anon_sym_i8] = ACTIONS(1444),
    [anon_sym_u16] = ACTIONS(1444),
    [anon_sym_i16] = ACTIONS(1444),
    [anon_sym_u32] = ACTIONS(1444),
    [anon_sym_i32] = ACTIONS(1444),
    [anon_sym_u64] = ACTIONS(1444),
    [anon_sym_i64] = ACTIONS(1444),
    [anon_sym_u128] = ACTIONS(1444),
    [anon_sym_i128] = ACTIONS(1444),
    [anon_sym_isize] = ACTIONS(1444),
    [anon_sym_usize] = ACTIONS(1444),
    [anon_sym_f32] = ACTIONS(1444),
    [anon_sym_f64] = ACTIONS(1444),
    [anon_sym_bool] = ACTIONS(1444),
    [anon_sym_str] = ACTIONS(1444),
    [anon_sym_char] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1444),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
    [anon_sym_STAR_EQ] = ACTIONS(1442),
    [anon_sym_SLASH_EQ] = ACTIONS(1442),
    [anon_sym_PERCENT_EQ] = ACTIONS(1442),
    [anon_sym_CARET_EQ] = ACTIONS(1442),
    [anon_sym_AMP_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(1444),
    [anon_sym_DOT_DOT] = ACTIONS(1444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1442),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(1442),
    [anon_sym_POUND] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(1444),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_break] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_continue] = ACTIONS(1444),
    [anon_sym_default] = ACTIONS(1444),
    [anon_sym_enum] = ACTIONS(1444),
    [anon_sym_fn] = ACTIONS(1444),
    [anon_sym_for] = ACTIONS(1444),
    [anon_sym_if] = ACTIONS(1444),
    [anon_sym_impl] = ACTIONS(1444),
    [anon_sym_let] = ACTIONS(1444),
    [anon_sym_loop] = ACTIONS(1444),
    [anon_sym_match] = ACTIONS(1444),
    [anon_sym_mod] = ACTIONS(1444),
    [anon_sym_pub] = ACTIONS(1444),
    [anon_sym_return] = ACTIONS(1444),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_struct] = ACTIONS(1444),
    [anon_sym_trait] = ACTIONS(1444),
    [anon_sym_type] = ACTIONS(1444),
    [anon_sym_union] = ACTIONS(1444),
    [anon_sym_unsafe] = ACTIONS(1444),
    [anon_sym_use] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym_yield] = ACTIONS(1444),
    [anon_sym_move] = ACTIONS(1444),
    [anon_sym_try] = ACTIONS(1444),
    [sym_integer_literal] = ACTIONS(1442),
    [aux_sym_string_literal_token1] = ACTIONS(1442),
    [sym_char_literal] = ACTIONS(1442),
    [anon_sym_true] = ACTIONS(1444),
    [anon_sym_false] = ACTIONS(1444),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1444),
    [sym_super] = ACTIONS(1444),
    [sym_crate] = ACTIONS(1444),
    [sym_metavariable] = ACTIONS(1442),
    [sym__raw_string_literal_start] = ACTIONS(1442),
    [sym_float_literal] = ACTIONS(1442),
  },
  [398] = {
    [sym_line_comment] = STATE(398),
    [sym_block_comment] = STATE(398),
    [ts_builtin_sym_end] = ACTIONS(1446),
    [sym_identifier] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_macro_rules_BANG] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1446),
    [anon_sym_u8] = ACTIONS(1448),
    [anon_sym_i8] = ACTIONS(1448),
    [anon_sym_u16] = ACTIONS(1448),
    [anon_sym_i16] = ACTIONS(1448),
    [anon_sym_u32] = ACTIONS(1448),
    [anon_sym_i32] = ACTIONS(1448),
    [anon_sym_u64] = ACTIONS(1448),
    [anon_sym_i64] = ACTIONS(1448),
    [anon_sym_u128] = ACTIONS(1448),
    [anon_sym_i128] = ACTIONS(1448),
    [anon_sym_isize] = ACTIONS(1448),
    [anon_sym_usize] = ACTIONS(1448),
    [anon_sym_f32] = ACTIONS(1448),
    [anon_sym_f64] = ACTIONS(1448),
    [anon_sym_bool] = ACTIONS(1448),
    [anon_sym_str] = ACTIONS(1448),
    [anon_sym_char] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1448),
    [anon_sym_PLUS_EQ] = ACTIONS(1446),
    [anon_sym_DASH_EQ] = ACTIONS(1446),
    [anon_sym_STAR_EQ] = ACTIONS(1446),
    [anon_sym_SLASH_EQ] = ACTIONS(1446),
    [anon_sym_PERCENT_EQ] = ACTIONS(1446),
    [anon_sym_CARET_EQ] = ACTIONS(1446),
    [anon_sym_AMP_EQ] = ACTIONS(1446),
    [anon_sym_PIPE_EQ] = ACTIONS(1446),
    [anon_sym_LT_LT_EQ] = ACTIONS(1446),
    [anon_sym_GT_GT_EQ] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_EQ_EQ] = ACTIONS(1446),
    [anon_sym_BANG_EQ] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT_EQ] = ACTIONS(1446),
    [anon_sym_LT_EQ] = ACTIONS(1446),
    [anon_sym_DOT] = ACTIONS(1448),
    [anon_sym_DOT_DOT] = ACTIONS(1448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1446),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1446),
    [anon_sym_COLON_COLON] = ACTIONS(1446),
    [anon_sym_POUND] = ACTIONS(1446),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_as] = ACTIONS(1448),
    [anon_sym_async] = ACTIONS(1448),
    [anon_sym_break] = ACTIONS(1448),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_continue] = ACTIONS(1448),
    [anon_sym_default] = ACTIONS(1448),
    [anon_sym_enum] = ACTIONS(1448),
    [anon_sym_fn] = ACTIONS(1448),
    [anon_sym_for] = ACTIONS(1448),
    [anon_sym_if] = ACTIONS(1448),
    [anon_sym_impl] = ACTIONS(1448),
    [anon_sym_let] = ACTIONS(1448),
    [anon_sym_loop] = ACTIONS(1448),
    [anon_sym_match] = ACTIONS(1448),
    [anon_sym_mod] = ACTIONS(1448),
    [anon_sym_pub] = ACTIONS(1448),
    [anon_sym_return] = ACTIONS(1448),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_struct] = ACTIONS(1448),
    [anon_sym_trait] = ACTIONS(1448),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_union] = ACTIONS(1448),
    [anon_sym_unsafe] = ACTIONS(1448),
    [anon_sym_use] = ACTIONS(1448),
    [anon_sym_while] = ACTIONS(1448),
    [anon_sym_extern] = ACTIONS(1448),
    [anon_sym_yield] = ACTIONS(1448),
    [anon_sym_move] = ACTIONS(1448),
    [anon_sym_try] = ACTIONS(1448),
    [sym_integer_literal] = ACTIONS(1446),
    [aux_sym_string_literal_token1] = ACTIONS(1446),
    [sym_char_literal] = ACTIONS(1446),
    [anon_sym_true] = ACTIONS(1448),
    [anon_sym_false] = ACTIONS(1448),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1448),
    [sym_super] = ACTIONS(1448),
    [sym_crate] = ACTIONS(1448),
    [sym_metavariable] = ACTIONS(1446),
    [sym__raw_string_literal_start] = ACTIONS(1446),
    [sym_float_literal] = ACTIONS(1446),
  },
  [399] = {
    [sym_line_comment] = STATE(399),
    [sym_block_comment] = STATE(399),
    [ts_builtin_sym_end] = ACTIONS(1450),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1450),
    [anon_sym_macro_rules_BANG] = ACTIONS(1450),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_RBRACE] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_QMARK] = ACTIONS(1450),
    [anon_sym_u8] = ACTIONS(1452),
    [anon_sym_i8] = ACTIONS(1452),
    [anon_sym_u16] = ACTIONS(1452),
    [anon_sym_i16] = ACTIONS(1452),
    [anon_sym_u32] = ACTIONS(1452),
    [anon_sym_i32] = ACTIONS(1452),
    [anon_sym_u64] = ACTIONS(1452),
    [anon_sym_i64] = ACTIONS(1452),
    [anon_sym_u128] = ACTIONS(1452),
    [anon_sym_i128] = ACTIONS(1452),
    [anon_sym_isize] = ACTIONS(1452),
    [anon_sym_usize] = ACTIONS(1452),
    [anon_sym_f32] = ACTIONS(1452),
    [anon_sym_f64] = ACTIONS(1452),
    [anon_sym_bool] = ACTIONS(1452),
    [anon_sym_str] = ACTIONS(1452),
    [anon_sym_char] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_PERCENT] = ACTIONS(1452),
    [anon_sym_CARET] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_PIPE] = ACTIONS(1452),
    [anon_sym_AMP_AMP] = ACTIONS(1450),
    [anon_sym_PIPE_PIPE] = ACTIONS(1450),
    [anon_sym_LT_LT] = ACTIONS(1452),
    [anon_sym_GT_GT] = ACTIONS(1452),
    [anon_sym_PLUS_EQ] = ACTIONS(1450),
    [anon_sym_DASH_EQ] = ACTIONS(1450),
    [anon_sym_STAR_EQ] = ACTIONS(1450),
    [anon_sym_SLASH_EQ] = ACTIONS(1450),
    [anon_sym_PERCENT_EQ] = ACTIONS(1450),
    [anon_sym_CARET_EQ] = ACTIONS(1450),
    [anon_sym_AMP_EQ] = ACTIONS(1450),
    [anon_sym_PIPE_EQ] = ACTIONS(1450),
    [anon_sym_LT_LT_EQ] = ACTIONS(1450),
    [anon_sym_GT_GT_EQ] = ACTIONS(1450),
    [anon_sym_EQ] = ACTIONS(1452),
    [anon_sym_EQ_EQ] = ACTIONS(1450),
    [anon_sym_BANG_EQ] = ACTIONS(1450),
    [anon_sym_GT] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_GT_EQ] = ACTIONS(1450),
    [anon_sym_LT_EQ] = ACTIONS(1450),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_DOT_DOT] = ACTIONS(1452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1450),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1450),
    [anon_sym_COLON_COLON] = ACTIONS(1450),
    [anon_sym_POUND] = ACTIONS(1450),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_as] = ACTIONS(1452),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_break] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_continue] = ACTIONS(1452),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [anon_sym_fn] = ACTIONS(1452),
    [anon_sym_for] = ACTIONS(1452),
    [anon_sym_if] = ACTIONS(1452),
    [anon_sym_impl] = ACTIONS(1452),
    [anon_sym_let] = ACTIONS(1452),
    [anon_sym_loop] = ACTIONS(1452),
    [anon_sym_match] = ACTIONS(1452),
    [anon_sym_mod] = ACTIONS(1452),
    [anon_sym_pub] = ACTIONS(1452),
    [anon_sym_return] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_struct] = ACTIONS(1452),
    [anon_sym_trait] = ACTIONS(1452),
    [anon_sym_type] = ACTIONS(1452),
    [anon_sym_union] = ACTIONS(1452),
    [anon_sym_unsafe] = ACTIONS(1452),
    [anon_sym_use] = ACTIONS(1452),
    [anon_sym_while] = ACTIONS(1452),
    [anon_sym_extern] = ACTIONS(1452),
    [anon_sym_yield] = ACTIONS(1452),
    [anon_sym_move] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1452),
    [sym_integer_literal] = ACTIONS(1450),
    [aux_sym_string_literal_token1] = ACTIONS(1450),
    [sym_char_literal] = ACTIONS(1450),
    [anon_sym_true] = ACTIONS(1452),
    [anon_sym_false] = ACTIONS(1452),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1452),
    [sym_super] = ACTIONS(1452),
    [sym_crate] = ACTIONS(1452),
    [sym_metavariable] = ACTIONS(1450),
    [sym__raw_string_literal_start] = ACTIONS(1450),
    [sym_float_literal] = ACTIONS(1450),
  },
  [400] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(3262),
    [sym_variadic_parameter] = STATE(3262),
    [sym_parameter] = STATE(3262),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2880),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(400),
    [sym_block_comment] = STATE(400),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1454),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [401] = {
    [sym_line_comment] = STATE(401),
    [sym_block_comment] = STATE(401),
    [sym_identifier] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1394),
    [anon_sym_macro_rules_BANG] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(1394),
    [anon_sym_LBRACK] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1422),
    [anon_sym_RBRACE] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_QMARK] = ACTIONS(1394),
    [anon_sym_u8] = ACTIONS(1424),
    [anon_sym_i8] = ACTIONS(1424),
    [anon_sym_u16] = ACTIONS(1424),
    [anon_sym_i16] = ACTIONS(1424),
    [anon_sym_u32] = ACTIONS(1424),
    [anon_sym_i32] = ACTIONS(1424),
    [anon_sym_u64] = ACTIONS(1424),
    [anon_sym_i64] = ACTIONS(1424),
    [anon_sym_u128] = ACTIONS(1424),
    [anon_sym_i128] = ACTIONS(1424),
    [anon_sym_isize] = ACTIONS(1424),
    [anon_sym_usize] = ACTIONS(1424),
    [anon_sym_f32] = ACTIONS(1424),
    [anon_sym_f64] = ACTIONS(1424),
    [anon_sym_bool] = ACTIONS(1424),
    [anon_sym_str] = ACTIONS(1424),
    [anon_sym_char] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_PIPE] = ACTIONS(1392),
    [anon_sym_AMP_AMP] = ACTIONS(1394),
    [anon_sym_PIPE_PIPE] = ACTIONS(1394),
    [anon_sym_LT_LT] = ACTIONS(1392),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1394),
    [anon_sym_DASH_EQ] = ACTIONS(1394),
    [anon_sym_STAR_EQ] = ACTIONS(1394),
    [anon_sym_SLASH_EQ] = ACTIONS(1394),
    [anon_sym_PERCENT_EQ] = ACTIONS(1394),
    [anon_sym_CARET_EQ] = ACTIONS(1394),
    [anon_sym_AMP_EQ] = ACTIONS(1394),
    [anon_sym_PIPE_EQ] = ACTIONS(1394),
    [anon_sym_LT_LT_EQ] = ACTIONS(1394),
    [anon_sym_GT_GT_EQ] = ACTIONS(1394),
    [anon_sym_EQ] = ACTIONS(1392),
    [anon_sym_EQ_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1394),
    [anon_sym_GT] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1392),
    [anon_sym_GT_EQ] = ACTIONS(1394),
    [anon_sym_LT_EQ] = ACTIONS(1394),
    [anon_sym_DOT] = ACTIONS(1392),
    [anon_sym_DOT_DOT] = ACTIONS(1392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1394),
    [anon_sym_COLON_COLON] = ACTIONS(1422),
    [anon_sym_POUND] = ACTIONS(1422),
    [anon_sym_SQUOTE] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1392),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_break] = ACTIONS(1424),
    [anon_sym_const] = ACTIONS(1424),
    [anon_sym_continue] = ACTIONS(1424),
    [anon_sym_default] = ACTIONS(1424),
    [anon_sym_enum] = ACTIONS(1424),
    [anon_sym_fn] = ACTIONS(1424),
    [anon_sym_for] = ACTIONS(1424),
    [anon_sym_if] = ACTIONS(1424),
    [anon_sym_impl] = ACTIONS(1424),
    [anon_sym_let] = ACTIONS(1424),
    [anon_sym_loop] = ACTIONS(1424),
    [anon_sym_match] = ACTIONS(1424),
    [anon_sym_mod] = ACTIONS(1424),
    [anon_sym_pub] = ACTIONS(1424),
    [anon_sym_return] = ACTIONS(1424),
    [anon_sym_static] = ACTIONS(1424),
    [anon_sym_struct] = ACTIONS(1424),
    [anon_sym_trait] = ACTIONS(1424),
    [anon_sym_type] = ACTIONS(1424),
    [anon_sym_union] = ACTIONS(1424),
    [anon_sym_unsafe] = ACTIONS(1424),
    [anon_sym_use] = ACTIONS(1424),
    [anon_sym_while] = ACTIONS(1424),
    [anon_sym_extern] = ACTIONS(1424),
    [anon_sym_yield] = ACTIONS(1424),
    [anon_sym_move] = ACTIONS(1424),
    [anon_sym_try] = ACTIONS(1424),
    [sym_integer_literal] = ACTIONS(1422),
    [aux_sym_string_literal_token1] = ACTIONS(1422),
    [sym_char_literal] = ACTIONS(1422),
    [anon_sym_true] = ACTIONS(1424),
    [anon_sym_false] = ACTIONS(1424),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1424),
    [sym_super] = ACTIONS(1424),
    [sym_crate] = ACTIONS(1424),
    [sym_metavariable] = ACTIONS(1422),
    [sym__raw_string_literal_start] = ACTIONS(1422),
    [sym_float_literal] = ACTIONS(1422),
  },
  [402] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(3262),
    [sym_variadic_parameter] = STATE(3262),
    [sym_parameter] = STATE(3262),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2880),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(402),
    [sym_block_comment] = STATE(402),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1458),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [403] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(3262),
    [sym_variadic_parameter] = STATE(3262),
    [sym_parameter] = STATE(3262),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2880),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(403),
    [sym_block_comment] = STATE(403),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [404] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(3262),
    [sym_variadic_parameter] = STATE(3262),
    [sym_parameter] = STATE(3262),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2880),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(404),
    [sym_block_comment] = STATE(404),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1462),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [405] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(3262),
    [sym_variadic_parameter] = STATE(3262),
    [sym_parameter] = STATE(3262),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2880),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(405),
    [sym_block_comment] = STATE(405),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [406] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(3262),
    [sym_variadic_parameter] = STATE(3262),
    [sym_parameter] = STATE(3262),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2880),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(406),
    [sym_block_comment] = STATE(406),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1466),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [407] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(3262),
    [sym_variadic_parameter] = STATE(3262),
    [sym_parameter] = STATE(3262),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2880),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(407),
    [sym_block_comment] = STATE(407),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [408] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(3262),
    [sym_variadic_parameter] = STATE(3262),
    [sym_parameter] = STATE(3262),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2880),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(408),
    [sym_block_comment] = STATE(408),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [409] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(3262),
    [sym_variadic_parameter] = STATE(3262),
    [sym_parameter] = STATE(3262),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2880),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(409),
    [sym_block_comment] = STATE(409),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [410] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(3262),
    [sym_variadic_parameter] = STATE(3262),
    [sym_parameter] = STATE(3262),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2880),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(410),
    [sym_block_comment] = STATE(410),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [411] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2637),
    [sym_bracketed_type] = STATE(3533),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3114),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2437),
    [sym_scoped_identifier] = STATE(2126),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym_closure_expression] = STATE(2897),
    [sym_closure_parameters] = STATE(240),
    [sym__pattern] = STATE(2684),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(411),
    [sym_block_comment] = STATE(411),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_RPAREN] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1264),
    [anon_sym_i8] = ACTIONS(1264),
    [anon_sym_u16] = ACTIONS(1264),
    [anon_sym_i16] = ACTIONS(1264),
    [anon_sym_u32] = ACTIONS(1264),
    [anon_sym_i32] = ACTIONS(1264),
    [anon_sym_u64] = ACTIONS(1264),
    [anon_sym_i64] = ACTIONS(1264),
    [anon_sym_u128] = ACTIONS(1264),
    [anon_sym_i128] = ACTIONS(1264),
    [anon_sym_isize] = ACTIONS(1264),
    [anon_sym_usize] = ACTIONS(1264),
    [anon_sym_f32] = ACTIONS(1264),
    [anon_sym_f64] = ACTIONS(1264),
    [anon_sym_bool] = ACTIONS(1264),
    [anon_sym_str] = ACTIONS(1264),
    [anon_sym_char] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1300),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1318),
    [sym_super] = ACTIONS(1318),
    [sym_crate] = ACTIONS(1318),
    [sym_metavariable] = ACTIONS(1320),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [412] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2637),
    [sym_bracketed_type] = STATE(3533),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3114),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2437),
    [sym_scoped_identifier] = STATE(2126),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym_closure_expression] = STATE(2897),
    [sym_closure_parameters] = STATE(240),
    [sym__pattern] = STATE(2684),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(412),
    [sym_block_comment] = STATE(412),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_RPAREN] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1264),
    [anon_sym_i8] = ACTIONS(1264),
    [anon_sym_u16] = ACTIONS(1264),
    [anon_sym_i16] = ACTIONS(1264),
    [anon_sym_u32] = ACTIONS(1264),
    [anon_sym_i32] = ACTIONS(1264),
    [anon_sym_u64] = ACTIONS(1264),
    [anon_sym_i64] = ACTIONS(1264),
    [anon_sym_u128] = ACTIONS(1264),
    [anon_sym_i128] = ACTIONS(1264),
    [anon_sym_isize] = ACTIONS(1264),
    [anon_sym_usize] = ACTIONS(1264),
    [anon_sym_f32] = ACTIONS(1264),
    [anon_sym_f64] = ACTIONS(1264),
    [anon_sym_bool] = ACTIONS(1264),
    [anon_sym_str] = ACTIONS(1264),
    [anon_sym_char] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1300),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1318),
    [sym_super] = ACTIONS(1318),
    [sym_crate] = ACTIONS(1318),
    [sym_metavariable] = ACTIONS(1320),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [413] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2637),
    [sym_bracketed_type] = STATE(3533),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3114),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2437),
    [sym_scoped_identifier] = STATE(2126),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym_closure_expression] = STATE(2897),
    [sym_closure_parameters] = STATE(240),
    [sym__pattern] = STATE(2684),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(413),
    [sym_block_comment] = STATE(413),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_RPAREN] = ACTIONS(1494),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1264),
    [anon_sym_i8] = ACTIONS(1264),
    [anon_sym_u16] = ACTIONS(1264),
    [anon_sym_i16] = ACTIONS(1264),
    [anon_sym_u32] = ACTIONS(1264),
    [anon_sym_i32] = ACTIONS(1264),
    [anon_sym_u64] = ACTIONS(1264),
    [anon_sym_i64] = ACTIONS(1264),
    [anon_sym_u128] = ACTIONS(1264),
    [anon_sym_i128] = ACTIONS(1264),
    [anon_sym_isize] = ACTIONS(1264),
    [anon_sym_usize] = ACTIONS(1264),
    [anon_sym_f32] = ACTIONS(1264),
    [anon_sym_f64] = ACTIONS(1264),
    [anon_sym_bool] = ACTIONS(1264),
    [anon_sym_str] = ACTIONS(1264),
    [anon_sym_char] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1300),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1318),
    [sym_super] = ACTIONS(1318),
    [sym_crate] = ACTIONS(1318),
    [sym_metavariable] = ACTIONS(1320),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [414] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(3225),
    [sym_variadic_parameter] = STATE(3225),
    [sym_parameter] = STATE(3225),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2829),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(414),
    [sym_block_comment] = STATE(414),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1496),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [415] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(2943),
    [sym_variadic_parameter] = STATE(2943),
    [sym_parameter] = STATE(2943),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2582),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(415),
    [sym_block_comment] = STATE(415),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1498),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [416] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(2976),
    [sym_variadic_parameter] = STATE(2976),
    [sym_parameter] = STATE(2976),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2510),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(416),
    [sym_block_comment] = STATE(416),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1500),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [417] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_self_parameter] = STATE(2902),
    [sym_variadic_parameter] = STATE(2902),
    [sym_parameter] = STATE(2902),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2599),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(2852),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3311),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(417),
    [sym_block_comment] = STATE(417),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1502),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1278),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1308),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1352),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [418] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2920),
    [sym_bracketed_type] = STATE(3534),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3112),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2401),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2678),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(418),
    [sym_block_comment] = STATE(418),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1510),
    [anon_sym_i8] = ACTIONS(1510),
    [anon_sym_u16] = ACTIONS(1510),
    [anon_sym_i16] = ACTIONS(1510),
    [anon_sym_u32] = ACTIONS(1510),
    [anon_sym_i32] = ACTIONS(1510),
    [anon_sym_u64] = ACTIONS(1510),
    [anon_sym_i64] = ACTIONS(1510),
    [anon_sym_u128] = ACTIONS(1510),
    [anon_sym_i128] = ACTIONS(1510),
    [anon_sym_isize] = ACTIONS(1510),
    [anon_sym_usize] = ACTIONS(1510),
    [anon_sym_f32] = ACTIONS(1510),
    [anon_sym_f64] = ACTIONS(1510),
    [anon_sym_bool] = ACTIONS(1510),
    [anon_sym_str] = ACTIONS(1510),
    [anon_sym_char] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1520),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1522),
    [sym_super] = ACTIONS(1522),
    [sym_crate] = ACTIONS(1522),
    [sym_metavariable] = ACTIONS(1524),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [419] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2090),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(419),
    [sym_block_comment] = STATE(419),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1354),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [420] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3534),
    [sym_lifetime] = STATE(833),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3112),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2401),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2088),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(420),
    [sym_block_comment] = STATE(420),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1510),
    [anon_sym_i8] = ACTIONS(1510),
    [anon_sym_u16] = ACTIONS(1510),
    [anon_sym_i16] = ACTIONS(1510),
    [anon_sym_u32] = ACTIONS(1510),
    [anon_sym_i32] = ACTIONS(1510),
    [anon_sym_u64] = ACTIONS(1510),
    [anon_sym_i64] = ACTIONS(1510),
    [anon_sym_u128] = ACTIONS(1510),
    [anon_sym_i128] = ACTIONS(1510),
    [anon_sym_isize] = ACTIONS(1510),
    [anon_sym_usize] = ACTIONS(1510),
    [anon_sym_f32] = ACTIONS(1510),
    [anon_sym_f64] = ACTIONS(1510),
    [anon_sym_bool] = ACTIONS(1510),
    [anon_sym_str] = ACTIONS(1510),
    [anon_sym_char] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1520),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1528),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1522),
    [sym_super] = ACTIONS(1522),
    [sym_crate] = ACTIONS(1522),
    [sym_metavariable] = ACTIONS(1524),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [421] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3533),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3114),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2437),
    [sym_scoped_identifier] = STATE(2126),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2090),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(421),
    [sym_block_comment] = STATE(421),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1264),
    [anon_sym_i8] = ACTIONS(1264),
    [anon_sym_u16] = ACTIONS(1264),
    [anon_sym_i16] = ACTIONS(1264),
    [anon_sym_u32] = ACTIONS(1264),
    [anon_sym_i32] = ACTIONS(1264),
    [anon_sym_u64] = ACTIONS(1264),
    [anon_sym_i64] = ACTIONS(1264),
    [anon_sym_u128] = ACTIONS(1264),
    [anon_sym_i128] = ACTIONS(1264),
    [anon_sym_isize] = ACTIONS(1264),
    [anon_sym_usize] = ACTIONS(1264),
    [anon_sym_f32] = ACTIONS(1264),
    [anon_sym_f64] = ACTIONS(1264),
    [anon_sym_bool] = ACTIONS(1264),
    [anon_sym_str] = ACTIONS(1264),
    [anon_sym_char] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1300),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1318),
    [sym_super] = ACTIONS(1318),
    [sym_crate] = ACTIONS(1318),
    [sym_metavariable] = ACTIONS(1320),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [422] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2090),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(422),
    [sym_block_comment] = STATE(422),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1530),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [423] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3533),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3114),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2437),
    [sym_scoped_identifier] = STATE(2126),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2090),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(423),
    [sym_block_comment] = STATE(423),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1264),
    [anon_sym_i8] = ACTIONS(1264),
    [anon_sym_u16] = ACTIONS(1264),
    [anon_sym_i16] = ACTIONS(1264),
    [anon_sym_u32] = ACTIONS(1264),
    [anon_sym_i32] = ACTIONS(1264),
    [anon_sym_u64] = ACTIONS(1264),
    [anon_sym_i64] = ACTIONS(1264),
    [anon_sym_u128] = ACTIONS(1264),
    [anon_sym_i128] = ACTIONS(1264),
    [anon_sym_isize] = ACTIONS(1264),
    [anon_sym_usize] = ACTIONS(1264),
    [anon_sym_f32] = ACTIONS(1264),
    [anon_sym_f64] = ACTIONS(1264),
    [anon_sym_bool] = ACTIONS(1264),
    [anon_sym_str] = ACTIONS(1264),
    [anon_sym_char] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1300),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1532),
    [sym_super] = ACTIONS(1318),
    [sym_crate] = ACTIONS(1318),
    [sym_metavariable] = ACTIONS(1320),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [424] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3533),
    [sym_lifetime] = STATE(830),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3114),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2437),
    [sym_scoped_identifier] = STATE(2126),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2088),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(424),
    [sym_block_comment] = STATE(424),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1264),
    [anon_sym_i8] = ACTIONS(1264),
    [anon_sym_u16] = ACTIONS(1264),
    [anon_sym_i16] = ACTIONS(1264),
    [anon_sym_u32] = ACTIONS(1264),
    [anon_sym_i32] = ACTIONS(1264),
    [anon_sym_u64] = ACTIONS(1264),
    [anon_sym_i64] = ACTIONS(1264),
    [anon_sym_u128] = ACTIONS(1264),
    [anon_sym_i128] = ACTIONS(1264),
    [anon_sym_isize] = ACTIONS(1264),
    [anon_sym_usize] = ACTIONS(1264),
    [anon_sym_f32] = ACTIONS(1264),
    [anon_sym_f64] = ACTIONS(1264),
    [anon_sym_bool] = ACTIONS(1264),
    [anon_sym_str] = ACTIONS(1264),
    [anon_sym_char] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1300),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1534),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1536),
    [sym_super] = ACTIONS(1318),
    [sym_crate] = ACTIONS(1318),
    [sym_metavariable] = ACTIONS(1320),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [425] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3534),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3112),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2401),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2090),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(425),
    [sym_block_comment] = STATE(425),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1510),
    [anon_sym_i8] = ACTIONS(1510),
    [anon_sym_u16] = ACTIONS(1510),
    [anon_sym_i16] = ACTIONS(1510),
    [anon_sym_u32] = ACTIONS(1510),
    [anon_sym_i32] = ACTIONS(1510),
    [anon_sym_u64] = ACTIONS(1510),
    [anon_sym_i64] = ACTIONS(1510),
    [anon_sym_u128] = ACTIONS(1510),
    [anon_sym_i128] = ACTIONS(1510),
    [anon_sym_isize] = ACTIONS(1510),
    [anon_sym_usize] = ACTIONS(1510),
    [anon_sym_f32] = ACTIONS(1510),
    [anon_sym_f64] = ACTIONS(1510),
    [anon_sym_bool] = ACTIONS(1510),
    [anon_sym_str] = ACTIONS(1510),
    [anon_sym_char] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1520),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1522),
    [sym_super] = ACTIONS(1522),
    [sym_crate] = ACTIONS(1522),
    [sym_metavariable] = ACTIONS(1524),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [426] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3533),
    [sym_lifetime] = STATE(833),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3114),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2437),
    [sym_scoped_identifier] = STATE(2126),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2088),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(426),
    [sym_block_comment] = STATE(426),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1264),
    [anon_sym_i8] = ACTIONS(1264),
    [anon_sym_u16] = ACTIONS(1264),
    [anon_sym_i16] = ACTIONS(1264),
    [anon_sym_u32] = ACTIONS(1264),
    [anon_sym_i32] = ACTIONS(1264),
    [anon_sym_u64] = ACTIONS(1264),
    [anon_sym_i64] = ACTIONS(1264),
    [anon_sym_u128] = ACTIONS(1264),
    [anon_sym_i128] = ACTIONS(1264),
    [anon_sym_isize] = ACTIONS(1264),
    [anon_sym_usize] = ACTIONS(1264),
    [anon_sym_f32] = ACTIONS(1264),
    [anon_sym_f64] = ACTIONS(1264),
    [anon_sym_bool] = ACTIONS(1264),
    [anon_sym_str] = ACTIONS(1264),
    [anon_sym_char] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1300),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1538),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1318),
    [sym_super] = ACTIONS(1318),
    [sym_crate] = ACTIONS(1318),
    [sym_metavariable] = ACTIONS(1320),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [427] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(833),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2088),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(427),
    [sym_block_comment] = STATE(427),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1540),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1354),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [428] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3526),
    [sym_lifetime] = STATE(830),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3278),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(2426),
    [sym_scoped_identifier] = STATE(2201),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2088),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(428),
    [sym_block_comment] = STATE(428),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1290),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_ref] = ACTIONS(1304),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(1542),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1544),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1356),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [429] = {
    [sym_line_comment] = STATE(429),
    [sym_block_comment] = STATE(429),
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_SEMI] = ACTIONS(1548),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1548),
    [anon_sym_COLON] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_QMARK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1546),
    [anon_sym_i8] = ACTIONS(1546),
    [anon_sym_u16] = ACTIONS(1546),
    [anon_sym_i16] = ACTIONS(1546),
    [anon_sym_u32] = ACTIONS(1546),
    [anon_sym_i32] = ACTIONS(1546),
    [anon_sym_u64] = ACTIONS(1546),
    [anon_sym_i64] = ACTIONS(1546),
    [anon_sym_u128] = ACTIONS(1546),
    [anon_sym_i128] = ACTIONS(1546),
    [anon_sym_isize] = ACTIONS(1546),
    [anon_sym_usize] = ACTIONS(1546),
    [anon_sym_f32] = ACTIONS(1546),
    [anon_sym_f64] = ACTIONS(1546),
    [anon_sym_bool] = ACTIONS(1546),
    [anon_sym_str] = ACTIONS(1546),
    [anon_sym_char] = ACTIONS(1546),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1546),
    [anon_sym_BANG] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_AMP_AMP] = ACTIONS(1548),
    [anon_sym_PIPE_PIPE] = ACTIONS(1548),
    [anon_sym_LT_LT] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1546),
    [anon_sym_PLUS_EQ] = ACTIONS(1548),
    [anon_sym_DASH_EQ] = ACTIONS(1548),
    [anon_sym_STAR_EQ] = ACTIONS(1548),
    [anon_sym_SLASH_EQ] = ACTIONS(1548),
    [anon_sym_PERCENT_EQ] = ACTIONS(1548),
    [anon_sym_CARET_EQ] = ACTIONS(1548),
    [anon_sym_AMP_EQ] = ACTIONS(1548),
    [anon_sym_PIPE_EQ] = ACTIONS(1548),
    [anon_sym_LT_LT_EQ] = ACTIONS(1548),
    [anon_sym_GT_GT_EQ] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1548),
    [anon_sym_BANG_EQ] = ACTIONS(1548),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1548),
    [anon_sym_LT_EQ] = ACTIONS(1548),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DOT_DOT] = ACTIONS(1546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1548),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1548),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(1546),
    [anon_sym_as] = ACTIONS(1546),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_break] = ACTIONS(1546),
    [anon_sym_const] = ACTIONS(1546),
    [anon_sym_continue] = ACTIONS(1546),
    [anon_sym_default] = ACTIONS(1546),
    [anon_sym_for] = ACTIONS(1546),
    [anon_sym_if] = ACTIONS(1546),
    [anon_sym_loop] = ACTIONS(1546),
    [anon_sym_match] = ACTIONS(1546),
    [anon_sym_return] = ACTIONS(1546),
    [anon_sym_static] = ACTIONS(1546),
    [anon_sym_union] = ACTIONS(1546),
    [anon_sym_unsafe] = ACTIONS(1546),
    [anon_sym_while] = ACTIONS(1546),
    [anon_sym_else] = ACTIONS(1546),
    [anon_sym_yield] = ACTIONS(1546),
    [anon_sym_move] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1546),
    [sym_integer_literal] = ACTIONS(1548),
    [aux_sym_string_literal_token1] = ACTIONS(1548),
    [sym_char_literal] = ACTIONS(1548),
    [anon_sym_true] = ACTIONS(1546),
    [anon_sym_false] = ACTIONS(1546),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1546),
    [sym_super] = ACTIONS(1546),
    [sym_crate] = ACTIONS(1546),
    [sym_metavariable] = ACTIONS(1548),
    [sym__raw_string_literal_start] = ACTIONS(1548),
    [sym_float_literal] = ACTIONS(1548),
  },
  [430] = {
    [sym_line_comment] = STATE(430),
    [sym_block_comment] = STATE(430),
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_EQ_GT] = ACTIONS(1548),
    [anon_sym_COLON] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_QMARK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1546),
    [anon_sym_i8] = ACTIONS(1546),
    [anon_sym_u16] = ACTIONS(1546),
    [anon_sym_i16] = ACTIONS(1546),
    [anon_sym_u32] = ACTIONS(1546),
    [anon_sym_i32] = ACTIONS(1546),
    [anon_sym_u64] = ACTIONS(1546),
    [anon_sym_i64] = ACTIONS(1546),
    [anon_sym_u128] = ACTIONS(1546),
    [anon_sym_i128] = ACTIONS(1546),
    [anon_sym_isize] = ACTIONS(1546),
    [anon_sym_usize] = ACTIONS(1546),
    [anon_sym_f32] = ACTIONS(1546),
    [anon_sym_f64] = ACTIONS(1546),
    [anon_sym_bool] = ACTIONS(1546),
    [anon_sym_str] = ACTIONS(1546),
    [anon_sym_char] = ACTIONS(1546),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1546),
    [anon_sym_BANG] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_AMP_AMP] = ACTIONS(1548),
    [anon_sym_PIPE_PIPE] = ACTIONS(1548),
    [anon_sym_LT_LT] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1546),
    [anon_sym_PLUS_EQ] = ACTIONS(1548),
    [anon_sym_DASH_EQ] = ACTIONS(1548),
    [anon_sym_STAR_EQ] = ACTIONS(1548),
    [anon_sym_SLASH_EQ] = ACTIONS(1548),
    [anon_sym_PERCENT_EQ] = ACTIONS(1548),
    [anon_sym_CARET_EQ] = ACTIONS(1548),
    [anon_sym_AMP_EQ] = ACTIONS(1548),
    [anon_sym_PIPE_EQ] = ACTIONS(1548),
    [anon_sym_LT_LT_EQ] = ACTIONS(1548),
    [anon_sym_GT_GT_EQ] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1548),
    [anon_sym_BANG_EQ] = ACTIONS(1548),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1548),
    [anon_sym_LT_EQ] = ACTIONS(1548),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DOT_DOT] = ACTIONS(1546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1548),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1548),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(1546),
    [anon_sym_as] = ACTIONS(1546),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_break] = ACTIONS(1546),
    [anon_sym_const] = ACTIONS(1546),
    [anon_sym_continue] = ACTIONS(1546),
    [anon_sym_default] = ACTIONS(1546),
    [anon_sym_for] = ACTIONS(1546),
    [anon_sym_if] = ACTIONS(1546),
    [anon_sym_loop] = ACTIONS(1546),
    [anon_sym_match] = ACTIONS(1546),
    [anon_sym_return] = ACTIONS(1546),
    [anon_sym_static] = ACTIONS(1546),
    [anon_sym_union] = ACTIONS(1546),
    [anon_sym_unsafe] = ACTIONS(1546),
    [anon_sym_while] = ACTIONS(1546),
    [anon_sym_yield] = ACTIONS(1546),
    [anon_sym_move] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1546),
    [sym_integer_literal] = ACTIONS(1548),
    [aux_sym_string_literal_token1] = ACTIONS(1548),
    [sym_char_literal] = ACTIONS(1548),
    [anon_sym_true] = ACTIONS(1546),
    [anon_sym_false] = ACTIONS(1546),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1546),
    [sym_super] = ACTIONS(1546),
    [sym_crate] = ACTIONS(1546),
    [sym_metavariable] = ACTIONS(1548),
    [sym__raw_string_literal_start] = ACTIONS(1548),
    [sym_float_literal] = ACTIONS(1548),
  },
  [431] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2109),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(431),
    [sym_block_comment] = STATE(431),
    [sym_identifier] = ACTIONS(1550),
    [anon_sym_LPAREN] = ACTIONS(1552),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [anon_sym_STAR] = ACTIONS(1552),
    [anon_sym_u8] = ACTIONS(1550),
    [anon_sym_i8] = ACTIONS(1550),
    [anon_sym_u16] = ACTIONS(1550),
    [anon_sym_i16] = ACTIONS(1550),
    [anon_sym_u32] = ACTIONS(1550),
    [anon_sym_i32] = ACTIONS(1550),
    [anon_sym_u64] = ACTIONS(1550),
    [anon_sym_i64] = ACTIONS(1550),
    [anon_sym_u128] = ACTIONS(1550),
    [anon_sym_i128] = ACTIONS(1550),
    [anon_sym_isize] = ACTIONS(1550),
    [anon_sym_usize] = ACTIONS(1550),
    [anon_sym_f32] = ACTIONS(1550),
    [anon_sym_f64] = ACTIONS(1550),
    [anon_sym_bool] = ACTIONS(1550),
    [anon_sym_str] = ACTIONS(1550),
    [anon_sym_char] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_BANG] = ACTIONS(1552),
    [anon_sym_AMP] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1550),
    [anon_sym_DOT_DOT] = ACTIONS(1552),
    [anon_sym_COLON_COLON] = ACTIONS(1552),
    [anon_sym_DASH_GT] = ACTIONS(1552),
    [anon_sym_SQUOTE] = ACTIONS(1550),
    [anon_sym_async] = ACTIONS(1550),
    [anon_sym_break] = ACTIONS(1550),
    [anon_sym_const] = ACTIONS(1550),
    [anon_sym_continue] = ACTIONS(1550),
    [anon_sym_default] = ACTIONS(1550),
    [anon_sym_for] = ACTIONS(1550),
    [anon_sym_if] = ACTIONS(1550),
    [anon_sym_loop] = ACTIONS(1550),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_return] = ACTIONS(1550),
    [anon_sym_static] = ACTIONS(1550),
    [anon_sym_union] = ACTIONS(1550),
    [anon_sym_unsafe] = ACTIONS(1550),
    [anon_sym_while] = ACTIONS(1550),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_yield] = ACTIONS(1550),
    [anon_sym_move] = ACTIONS(1550),
    [anon_sym_try] = ACTIONS(1550),
    [sym_integer_literal] = ACTIONS(1552),
    [aux_sym_string_literal_token1] = ACTIONS(1552),
    [sym_char_literal] = ACTIONS(1552),
    [anon_sym_true] = ACTIONS(1550),
    [anon_sym_false] = ACTIONS(1550),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1550),
    [sym_super] = ACTIONS(1550),
    [sym_crate] = ACTIONS(1550),
    [sym_metavariable] = ACTIONS(1552),
    [sym__raw_string_literal_start] = ACTIONS(1552),
    [sym_float_literal] = ACTIONS(1552),
  },
  [432] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2104),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(432),
    [sym_block_comment] = STATE(432),
    [sym_identifier] = ACTIONS(1554),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [anon_sym_LBRACK] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_STAR] = ACTIONS(1556),
    [anon_sym_u8] = ACTIONS(1554),
    [anon_sym_i8] = ACTIONS(1554),
    [anon_sym_u16] = ACTIONS(1554),
    [anon_sym_i16] = ACTIONS(1554),
    [anon_sym_u32] = ACTIONS(1554),
    [anon_sym_i32] = ACTIONS(1554),
    [anon_sym_u64] = ACTIONS(1554),
    [anon_sym_i64] = ACTIONS(1554),
    [anon_sym_u128] = ACTIONS(1554),
    [anon_sym_i128] = ACTIONS(1554),
    [anon_sym_isize] = ACTIONS(1554),
    [anon_sym_usize] = ACTIONS(1554),
    [anon_sym_f32] = ACTIONS(1554),
    [anon_sym_f64] = ACTIONS(1554),
    [anon_sym_bool] = ACTIONS(1554),
    [anon_sym_str] = ACTIONS(1554),
    [anon_sym_char] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1554),
    [anon_sym_BANG] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1556),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DOT_DOT] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [anon_sym_SQUOTE] = ACTIONS(1554),
    [anon_sym_async] = ACTIONS(1554),
    [anon_sym_break] = ACTIONS(1554),
    [anon_sym_const] = ACTIONS(1554),
    [anon_sym_continue] = ACTIONS(1554),
    [anon_sym_default] = ACTIONS(1554),
    [anon_sym_for] = ACTIONS(1554),
    [anon_sym_if] = ACTIONS(1554),
    [anon_sym_loop] = ACTIONS(1554),
    [anon_sym_match] = ACTIONS(1554),
    [anon_sym_return] = ACTIONS(1554),
    [anon_sym_static] = ACTIONS(1554),
    [anon_sym_union] = ACTIONS(1554),
    [anon_sym_unsafe] = ACTIONS(1554),
    [anon_sym_while] = ACTIONS(1554),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_yield] = ACTIONS(1554),
    [anon_sym_move] = ACTIONS(1554),
    [anon_sym_try] = ACTIONS(1554),
    [sym_integer_literal] = ACTIONS(1556),
    [aux_sym_string_literal_token1] = ACTIONS(1556),
    [sym_char_literal] = ACTIONS(1556),
    [anon_sym_true] = ACTIONS(1554),
    [anon_sym_false] = ACTIONS(1554),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1554),
    [sym_super] = ACTIONS(1554),
    [sym_crate] = ACTIONS(1554),
    [sym_metavariable] = ACTIONS(1556),
    [sym__raw_string_literal_start] = ACTIONS(1556),
    [sym_float_literal] = ACTIONS(1556),
  },
  [433] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2457),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2459),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2694),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2694),
    [sym__literal] = STATE(2694),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(433),
    [sym_block_comment] = STATE(433),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [434] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2457),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2459),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2694),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2694),
    [sym__literal] = STATE(2694),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(434),
    [sym_block_comment] = STATE(434),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1586),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [435] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2457),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2459),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2694),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2694),
    [sym__literal] = STATE(2694),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(435),
    [sym_block_comment] = STATE(435),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [436] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2457),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2459),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2694),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2694),
    [sym__literal] = STATE(2694),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(436),
    [sym_block_comment] = STATE(436),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [437] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2457),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2459),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2694),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2694),
    [sym__literal] = STATE(2694),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(437),
    [sym_block_comment] = STATE(437),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [438] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2457),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2459),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2694),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2694),
    [sym__literal] = STATE(2694),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(438),
    [sym_block_comment] = STATE(438),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [439] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2457),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2459),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2694),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2694),
    [sym__literal] = STATE(2694),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(439),
    [sym_block_comment] = STATE(439),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1596),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [440] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2457),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2459),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2694),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2694),
    [sym__literal] = STATE(2694),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(440),
    [sym_block_comment] = STATE(440),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [441] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2457),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2459),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2694),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2694),
    [sym__literal] = STATE(2694),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(441),
    [sym_block_comment] = STATE(441),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [442] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2457),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2459),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2694),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2694),
    [sym__literal] = STATE(2694),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(442),
    [sym_block_comment] = STATE(442),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [443] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2321),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2323),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2466),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2466),
    [sym__literal] = STATE(2466),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(443),
    [sym_block_comment] = STATE(443),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [444] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2316),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2315),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2474),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2474),
    [sym__literal] = STATE(2474),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(444),
    [sym_block_comment] = STATE(444),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [445] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2361),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2366),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_type_binding] = STATE(2419),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_label] = STATE(3588),
    [sym_block] = STATE(2419),
    [sym__literal] = STATE(2419),
    [sym_string_literal] = STATE(2798),
    [sym_raw_string_literal] = STATE(2798),
    [sym_boolean_literal] = STATE(2798),
    [sym_line_comment] = STATE(445),
    [sym_block_comment] = STATE(445),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1580),
  },
  [446] = {
    [sym_else_clause] = STATE(464),
    [sym_line_comment] = STATE(446),
    [sym_block_comment] = STATE(446),
    [sym_identifier] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1196),
    [anon_sym_RBRACE] = ACTIONS(1196),
    [anon_sym_PLUS] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1198),
    [anon_sym_QMARK] = ACTIONS(1196),
    [anon_sym_u8] = ACTIONS(1198),
    [anon_sym_i8] = ACTIONS(1198),
    [anon_sym_u16] = ACTIONS(1198),
    [anon_sym_i16] = ACTIONS(1198),
    [anon_sym_u32] = ACTIONS(1198),
    [anon_sym_i32] = ACTIONS(1198),
    [anon_sym_u64] = ACTIONS(1198),
    [anon_sym_i64] = ACTIONS(1198),
    [anon_sym_u128] = ACTIONS(1198),
    [anon_sym_i128] = ACTIONS(1198),
    [anon_sym_isize] = ACTIONS(1198),
    [anon_sym_usize] = ACTIONS(1198),
    [anon_sym_f32] = ACTIONS(1198),
    [anon_sym_f64] = ACTIONS(1198),
    [anon_sym_bool] = ACTIONS(1198),
    [anon_sym_str] = ACTIONS(1198),
    [anon_sym_char] = ACTIONS(1198),
    [anon_sym_DASH] = ACTIONS(1198),
    [anon_sym_SLASH] = ACTIONS(1198),
    [anon_sym_PERCENT] = ACTIONS(1198),
    [anon_sym_CARET] = ACTIONS(1198),
    [anon_sym_AMP] = ACTIONS(1198),
    [anon_sym_PIPE] = ACTIONS(1198),
    [anon_sym_AMP_AMP] = ACTIONS(1196),
    [anon_sym_PIPE_PIPE] = ACTIONS(1196),
    [anon_sym_LT_LT] = ACTIONS(1198),
    [anon_sym_GT_GT] = ACTIONS(1198),
    [anon_sym_PLUS_EQ] = ACTIONS(1196),
    [anon_sym_DASH_EQ] = ACTIONS(1196),
    [anon_sym_STAR_EQ] = ACTIONS(1196),
    [anon_sym_SLASH_EQ] = ACTIONS(1196),
    [anon_sym_PERCENT_EQ] = ACTIONS(1196),
    [anon_sym_CARET_EQ] = ACTIONS(1196),
    [anon_sym_AMP_EQ] = ACTIONS(1196),
    [anon_sym_PIPE_EQ] = ACTIONS(1196),
    [anon_sym_LT_LT_EQ] = ACTIONS(1196),
    [anon_sym_GT_GT_EQ] = ACTIONS(1196),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_EQ_EQ] = ACTIONS(1196),
    [anon_sym_BANG_EQ] = ACTIONS(1196),
    [anon_sym_GT] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_GT_EQ] = ACTIONS(1196),
    [anon_sym_LT_EQ] = ACTIONS(1196),
    [anon_sym__] = ACTIONS(1198),
    [anon_sym_DOT] = ACTIONS(1198),
    [anon_sym_DOT_DOT] = ACTIONS(1198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1196),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1196),
    [anon_sym_COMMA] = ACTIONS(1196),
    [anon_sym_COLON_COLON] = ACTIONS(1196),
    [anon_sym_POUND] = ACTIONS(1196),
    [anon_sym_as] = ACTIONS(1198),
    [anon_sym_const] = ACTIONS(1198),
    [anon_sym_default] = ACTIONS(1198),
    [anon_sym_union] = ACTIONS(1198),
    [anon_sym_ref] = ACTIONS(1198),
    [anon_sym_else] = ACTIONS(1602),
    [sym_mutable_specifier] = ACTIONS(1198),
    [sym_integer_literal] = ACTIONS(1196),
    [aux_sym_string_literal_token1] = ACTIONS(1196),
    [sym_char_literal] = ACTIONS(1196),
    [anon_sym_true] = ACTIONS(1198),
    [anon_sym_false] = ACTIONS(1198),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1198),
    [sym_super] = ACTIONS(1198),
    [sym_crate] = ACTIONS(1198),
    [sym_metavariable] = ACTIONS(1196),
    [sym__raw_string_literal_start] = ACTIONS(1196),
    [sym_float_literal] = ACTIONS(1196),
  },
  [447] = {
    [sym_line_comment] = STATE(447),
    [sym_block_comment] = STATE(447),
    [sym_identifier] = ACTIONS(1208),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_LBRACK] = ACTIONS(1206),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_PLUS] = ACTIONS(1208),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_QMARK] = ACTIONS(1206),
    [anon_sym_u8] = ACTIONS(1208),
    [anon_sym_i8] = ACTIONS(1208),
    [anon_sym_u16] = ACTIONS(1208),
    [anon_sym_i16] = ACTIONS(1208),
    [anon_sym_u32] = ACTIONS(1208),
    [anon_sym_i32] = ACTIONS(1208),
    [anon_sym_u64] = ACTIONS(1208),
    [anon_sym_i64] = ACTIONS(1208),
    [anon_sym_u128] = ACTIONS(1208),
    [anon_sym_i128] = ACTIONS(1208),
    [anon_sym_isize] = ACTIONS(1208),
    [anon_sym_usize] = ACTIONS(1208),
    [anon_sym_f32] = ACTIONS(1208),
    [anon_sym_f64] = ACTIONS(1208),
    [anon_sym_bool] = ACTIONS(1208),
    [anon_sym_str] = ACTIONS(1208),
    [anon_sym_char] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1208),
    [anon_sym_CARET] = ACTIONS(1208),
    [anon_sym_AMP] = ACTIONS(1208),
    [anon_sym_PIPE] = ACTIONS(1208),
    [anon_sym_AMP_AMP] = ACTIONS(1206),
    [anon_sym_PIPE_PIPE] = ACTIONS(1206),
    [anon_sym_LT_LT] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(1208),
    [anon_sym_PLUS_EQ] = ACTIONS(1206),
    [anon_sym_DASH_EQ] = ACTIONS(1206),
    [anon_sym_STAR_EQ] = ACTIONS(1206),
    [anon_sym_SLASH_EQ] = ACTIONS(1206),
    [anon_sym_PERCENT_EQ] = ACTIONS(1206),
    [anon_sym_CARET_EQ] = ACTIONS(1206),
    [anon_sym_AMP_EQ] = ACTIONS(1206),
    [anon_sym_PIPE_EQ] = ACTIONS(1206),
    [anon_sym_LT_LT_EQ] = ACTIONS(1206),
    [anon_sym_GT_GT_EQ] = ACTIONS(1206),
    [anon_sym_EQ] = ACTIONS(1208),
    [anon_sym_EQ_EQ] = ACTIONS(1206),
    [anon_sym_BANG_EQ] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1208),
    [anon_sym_LT] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(1206),
    [anon_sym_LT_EQ] = ACTIONS(1206),
    [anon_sym__] = ACTIONS(1208),
    [anon_sym_DOT] = ACTIONS(1208),
    [anon_sym_DOT_DOT] = ACTIONS(1208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1206),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1206),
    [anon_sym_COMMA] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(1206),
    [anon_sym_POUND] = ACTIONS(1206),
    [anon_sym_as] = ACTIONS(1208),
    [anon_sym_const] = ACTIONS(1208),
    [anon_sym_default] = ACTIONS(1208),
    [anon_sym_union] = ACTIONS(1208),
    [anon_sym_ref] = ACTIONS(1208),
    [anon_sym_else] = ACTIONS(1208),
    [sym_mutable_specifier] = ACTIONS(1208),
    [sym_integer_literal] = ACTIONS(1206),
    [aux_sym_string_literal_token1] = ACTIONS(1206),
    [sym_char_literal] = ACTIONS(1206),
    [anon_sym_true] = ACTIONS(1208),
    [anon_sym_false] = ACTIONS(1208),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1208),
    [sym_super] = ACTIONS(1208),
    [sym_crate] = ACTIONS(1208),
    [sym_metavariable] = ACTIONS(1206),
    [sym__raw_string_literal_start] = ACTIONS(1206),
    [sym_float_literal] = ACTIONS(1206),
  },
  [448] = {
    [sym_line_comment] = STATE(448),
    [sym_block_comment] = STATE(448),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_LPAREN] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1234),
    [anon_sym_QMARK] = ACTIONS(1232),
    [anon_sym_u8] = ACTIONS(1234),
    [anon_sym_i8] = ACTIONS(1234),
    [anon_sym_u16] = ACTIONS(1234),
    [anon_sym_i16] = ACTIONS(1234),
    [anon_sym_u32] = ACTIONS(1234),
    [anon_sym_i32] = ACTIONS(1234),
    [anon_sym_u64] = ACTIONS(1234),
    [anon_sym_i64] = ACTIONS(1234),
    [anon_sym_u128] = ACTIONS(1234),
    [anon_sym_i128] = ACTIONS(1234),
    [anon_sym_isize] = ACTIONS(1234),
    [anon_sym_usize] = ACTIONS(1234),
    [anon_sym_f32] = ACTIONS(1234),
    [anon_sym_f64] = ACTIONS(1234),
    [anon_sym_bool] = ACTIONS(1234),
    [anon_sym_str] = ACTIONS(1234),
    [anon_sym_char] = ACTIONS(1234),
    [anon_sym_DASH] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(1234),
    [anon_sym_PERCENT] = ACTIONS(1234),
    [anon_sym_CARET] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1234),
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1232),
    [anon_sym_PIPE_PIPE] = ACTIONS(1232),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(1232),
    [anon_sym_DASH_EQ] = ACTIONS(1232),
    [anon_sym_STAR_EQ] = ACTIONS(1232),
    [anon_sym_SLASH_EQ] = ACTIONS(1232),
    [anon_sym_PERCENT_EQ] = ACTIONS(1232),
    [anon_sym_CARET_EQ] = ACTIONS(1232),
    [anon_sym_AMP_EQ] = ACTIONS(1232),
    [anon_sym_PIPE_EQ] = ACTIONS(1232),
    [anon_sym_LT_LT_EQ] = ACTIONS(1232),
    [anon_sym_GT_GT_EQ] = ACTIONS(1232),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_EQ_EQ] = ACTIONS(1232),
    [anon_sym_BANG_EQ] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_LT] = ACTIONS(1234),
    [anon_sym_GT_EQ] = ACTIONS(1232),
    [anon_sym_LT_EQ] = ACTIONS(1232),
    [anon_sym__] = ACTIONS(1234),
    [anon_sym_DOT] = ACTIONS(1234),
    [anon_sym_DOT_DOT] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1232),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1232),
    [anon_sym_COMMA] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(1234),
    [anon_sym_const] = ACTIONS(1234),
    [anon_sym_default] = ACTIONS(1234),
    [anon_sym_union] = ACTIONS(1234),
    [anon_sym_ref] = ACTIONS(1234),
    [anon_sym_else] = ACTIONS(1234),
    [sym_mutable_specifier] = ACTIONS(1234),
    [sym_integer_literal] = ACTIONS(1232),
    [aux_sym_string_literal_token1] = ACTIONS(1232),
    [sym_char_literal] = ACTIONS(1232),
    [anon_sym_true] = ACTIONS(1234),
    [anon_sym_false] = ACTIONS(1234),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1234),
    [sym_super] = ACTIONS(1234),
    [sym_crate] = ACTIONS(1234),
    [sym_metavariable] = ACTIONS(1232),
    [sym__raw_string_literal_start] = ACTIONS(1232),
    [sym_float_literal] = ACTIONS(1232),
  },
  [449] = {
    [sym_line_comment] = STATE(449),
    [sym_block_comment] = STATE(449),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_QMARK] = ACTIONS(1240),
    [anon_sym_u8] = ACTIONS(1242),
    [anon_sym_i8] = ACTIONS(1242),
    [anon_sym_u16] = ACTIONS(1242),
    [anon_sym_i16] = ACTIONS(1242),
    [anon_sym_u32] = ACTIONS(1242),
    [anon_sym_i32] = ACTIONS(1242),
    [anon_sym_u64] = ACTIONS(1242),
    [anon_sym_i64] = ACTIONS(1242),
    [anon_sym_u128] = ACTIONS(1242),
    [anon_sym_i128] = ACTIONS(1242),
    [anon_sym_isize] = ACTIONS(1242),
    [anon_sym_usize] = ACTIONS(1242),
    [anon_sym_f32] = ACTIONS(1242),
    [anon_sym_f64] = ACTIONS(1242),
    [anon_sym_bool] = ACTIONS(1242),
    [anon_sym_str] = ACTIONS(1242),
    [anon_sym_char] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_CARET] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1242),
    [anon_sym_PIPE] = ACTIONS(1242),
    [anon_sym_AMP_AMP] = ACTIONS(1240),
    [anon_sym_PIPE_PIPE] = ACTIONS(1240),
    [anon_sym_LT_LT] = ACTIONS(1242),
    [anon_sym_GT_GT] = ACTIONS(1242),
    [anon_sym_PLUS_EQ] = ACTIONS(1240),
    [anon_sym_DASH_EQ] = ACTIONS(1240),
    [anon_sym_STAR_EQ] = ACTIONS(1240),
    [anon_sym_SLASH_EQ] = ACTIONS(1240),
    [anon_sym_PERCENT_EQ] = ACTIONS(1240),
    [anon_sym_CARET_EQ] = ACTIONS(1240),
    [anon_sym_AMP_EQ] = ACTIONS(1240),
    [anon_sym_PIPE_EQ] = ACTIONS(1240),
    [anon_sym_LT_LT_EQ] = ACTIONS(1240),
    [anon_sym_GT_GT_EQ] = ACTIONS(1240),
    [anon_sym_EQ] = ACTIONS(1242),
    [anon_sym_EQ_EQ] = ACTIONS(1240),
    [anon_sym_BANG_EQ] = ACTIONS(1240),
    [anon_sym_GT] = ACTIONS(1242),
    [anon_sym_LT] = ACTIONS(1242),
    [anon_sym_GT_EQ] = ACTIONS(1240),
    [anon_sym_LT_EQ] = ACTIONS(1240),
    [anon_sym__] = ACTIONS(1242),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_DOT_DOT] = ACTIONS(1242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1240),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1240),
    [anon_sym_COMMA] = ACTIONS(1240),
    [anon_sym_COLON_COLON] = ACTIONS(1240),
    [anon_sym_POUND] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_default] = ACTIONS(1242),
    [anon_sym_union] = ACTIONS(1242),
    [anon_sym_ref] = ACTIONS(1242),
    [anon_sym_else] = ACTIONS(1242),
    [sym_mutable_specifier] = ACTIONS(1242),
    [sym_integer_literal] = ACTIONS(1240),
    [aux_sym_string_literal_token1] = ACTIONS(1240),
    [sym_char_literal] = ACTIONS(1240),
    [anon_sym_true] = ACTIONS(1242),
    [anon_sym_false] = ACTIONS(1242),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1242),
    [sym_super] = ACTIONS(1242),
    [sym_crate] = ACTIONS(1242),
    [sym_metavariable] = ACTIONS(1240),
    [sym__raw_string_literal_start] = ACTIONS(1240),
    [sym_float_literal] = ACTIONS(1240),
  },
  [450] = {
    [sym_line_comment] = STATE(450),
    [sym_block_comment] = STATE(450),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_QMARK] = ACTIONS(1236),
    [anon_sym_u8] = ACTIONS(1238),
    [anon_sym_i8] = ACTIONS(1238),
    [anon_sym_u16] = ACTIONS(1238),
    [anon_sym_i16] = ACTIONS(1238),
    [anon_sym_u32] = ACTIONS(1238),
    [anon_sym_i32] = ACTIONS(1238),
    [anon_sym_u64] = ACTIONS(1238),
    [anon_sym_i64] = ACTIONS(1238),
    [anon_sym_u128] = ACTIONS(1238),
    [anon_sym_i128] = ACTIONS(1238),
    [anon_sym_isize] = ACTIONS(1238),
    [anon_sym_usize] = ACTIONS(1238),
    [anon_sym_f32] = ACTIONS(1238),
    [anon_sym_f64] = ACTIONS(1238),
    [anon_sym_bool] = ACTIONS(1238),
    [anon_sym_str] = ACTIONS(1238),
    [anon_sym_char] = ACTIONS(1238),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(1238),
    [anon_sym_PERCENT] = ACTIONS(1238),
    [anon_sym_CARET] = ACTIONS(1238),
    [anon_sym_AMP] = ACTIONS(1238),
    [anon_sym_PIPE] = ACTIONS(1238),
    [anon_sym_AMP_AMP] = ACTIONS(1236),
    [anon_sym_PIPE_PIPE] = ACTIONS(1236),
    [anon_sym_LT_LT] = ACTIONS(1238),
    [anon_sym_GT_GT] = ACTIONS(1238),
    [anon_sym_PLUS_EQ] = ACTIONS(1236),
    [anon_sym_DASH_EQ] = ACTIONS(1236),
    [anon_sym_STAR_EQ] = ACTIONS(1236),
    [anon_sym_SLASH_EQ] = ACTIONS(1236),
    [anon_sym_PERCENT_EQ] = ACTIONS(1236),
    [anon_sym_CARET_EQ] = ACTIONS(1236),
    [anon_sym_AMP_EQ] = ACTIONS(1236),
    [anon_sym_PIPE_EQ] = ACTIONS(1236),
    [anon_sym_LT_LT_EQ] = ACTIONS(1236),
    [anon_sym_GT_GT_EQ] = ACTIONS(1236),
    [anon_sym_EQ] = ACTIONS(1238),
    [anon_sym_EQ_EQ] = ACTIONS(1236),
    [anon_sym_BANG_EQ] = ACTIONS(1236),
    [anon_sym_GT] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT_EQ] = ACTIONS(1236),
    [anon_sym_LT_EQ] = ACTIONS(1236),
    [anon_sym__] = ACTIONS(1238),
    [anon_sym_DOT] = ACTIONS(1238),
    [anon_sym_DOT_DOT] = ACTIONS(1238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1236),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(1236),
    [anon_sym_COLON_COLON] = ACTIONS(1236),
    [anon_sym_POUND] = ACTIONS(1236),
    [anon_sym_as] = ACTIONS(1238),
    [anon_sym_const] = ACTIONS(1238),
    [anon_sym_default] = ACTIONS(1238),
    [anon_sym_union] = ACTIONS(1238),
    [anon_sym_ref] = ACTIONS(1238),
    [anon_sym_else] = ACTIONS(1238),
    [sym_mutable_specifier] = ACTIONS(1238),
    [sym_integer_literal] = ACTIONS(1236),
    [aux_sym_string_literal_token1] = ACTIONS(1236),
    [sym_char_literal] = ACTIONS(1236),
    [anon_sym_true] = ACTIONS(1238),
    [anon_sym_false] = ACTIONS(1238),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1238),
    [sym_super] = ACTIONS(1238),
    [sym_crate] = ACTIONS(1238),
    [sym_metavariable] = ACTIONS(1236),
    [sym__raw_string_literal_start] = ACTIONS(1236),
    [sym_float_literal] = ACTIONS(1236),
  },
  [451] = {
    [sym_line_comment] = STATE(451),
    [sym_block_comment] = STATE(451),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_LPAREN] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_QMARK] = ACTIONS(1244),
    [anon_sym_u8] = ACTIONS(1246),
    [anon_sym_i8] = ACTIONS(1246),
    [anon_sym_u16] = ACTIONS(1246),
    [anon_sym_i16] = ACTIONS(1246),
    [anon_sym_u32] = ACTIONS(1246),
    [anon_sym_i32] = ACTIONS(1246),
    [anon_sym_u64] = ACTIONS(1246),
    [anon_sym_i64] = ACTIONS(1246),
    [anon_sym_u128] = ACTIONS(1246),
    [anon_sym_i128] = ACTIONS(1246),
    [anon_sym_isize] = ACTIONS(1246),
    [anon_sym_usize] = ACTIONS(1246),
    [anon_sym_f32] = ACTIONS(1246),
    [anon_sym_f64] = ACTIONS(1246),
    [anon_sym_bool] = ACTIONS(1246),
    [anon_sym_str] = ACTIONS(1246),
    [anon_sym_char] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_CARET] = ACTIONS(1246),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1246),
    [anon_sym_AMP_AMP] = ACTIONS(1244),
    [anon_sym_PIPE_PIPE] = ACTIONS(1244),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_PLUS_EQ] = ACTIONS(1244),
    [anon_sym_DASH_EQ] = ACTIONS(1244),
    [anon_sym_STAR_EQ] = ACTIONS(1244),
    [anon_sym_SLASH_EQ] = ACTIONS(1244),
    [anon_sym_PERCENT_EQ] = ACTIONS(1244),
    [anon_sym_CARET_EQ] = ACTIONS(1244),
    [anon_sym_AMP_EQ] = ACTIONS(1244),
    [anon_sym_PIPE_EQ] = ACTIONS(1244),
    [anon_sym_LT_LT_EQ] = ACTIONS(1244),
    [anon_sym_GT_GT_EQ] = ACTIONS(1244),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_EQ_EQ] = ACTIONS(1244),
    [anon_sym_BANG_EQ] = ACTIONS(1244),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1244),
    [anon_sym__] = ACTIONS(1246),
    [anon_sym_DOT] = ACTIONS(1246),
    [anon_sym_DOT_DOT] = ACTIONS(1246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1244),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1244),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [anon_sym_POUND] = ACTIONS(1244),
    [anon_sym_as] = ACTIONS(1246),
    [anon_sym_const] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_union] = ACTIONS(1246),
    [anon_sym_ref] = ACTIONS(1246),
    [anon_sym_else] = ACTIONS(1246),
    [sym_mutable_specifier] = ACTIONS(1246),
    [sym_integer_literal] = ACTIONS(1244),
    [aux_sym_string_literal_token1] = ACTIONS(1244),
    [sym_char_literal] = ACTIONS(1244),
    [anon_sym_true] = ACTIONS(1246),
    [anon_sym_false] = ACTIONS(1246),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1246),
    [sym_super] = ACTIONS(1246),
    [sym_crate] = ACTIONS(1246),
    [sym_metavariable] = ACTIONS(1244),
    [sym__raw_string_literal_start] = ACTIONS(1244),
    [sym_float_literal] = ACTIONS(1244),
  },
  [452] = {
    [sym_line_comment] = STATE(452),
    [sym_block_comment] = STATE(452),
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_LPAREN] = ACTIONS(1410),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACE] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(1412),
    [anon_sym_STAR] = ACTIONS(1412),
    [anon_sym_QMARK] = ACTIONS(1410),
    [anon_sym_u8] = ACTIONS(1412),
    [anon_sym_i8] = ACTIONS(1412),
    [anon_sym_u16] = ACTIONS(1412),
    [anon_sym_i16] = ACTIONS(1412),
    [anon_sym_u32] = ACTIONS(1412),
    [anon_sym_i32] = ACTIONS(1412),
    [anon_sym_u64] = ACTIONS(1412),
    [anon_sym_i64] = ACTIONS(1412),
    [anon_sym_u128] = ACTIONS(1412),
    [anon_sym_i128] = ACTIONS(1412),
    [anon_sym_isize] = ACTIONS(1412),
    [anon_sym_usize] = ACTIONS(1412),
    [anon_sym_f32] = ACTIONS(1412),
    [anon_sym_f64] = ACTIONS(1412),
    [anon_sym_bool] = ACTIONS(1412),
    [anon_sym_str] = ACTIONS(1412),
    [anon_sym_char] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1412),
    [anon_sym_SLASH] = ACTIONS(1412),
    [anon_sym_PERCENT] = ACTIONS(1412),
    [anon_sym_CARET] = ACTIONS(1412),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_PIPE] = ACTIONS(1412),
    [anon_sym_AMP_AMP] = ACTIONS(1410),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_LT_LT] = ACTIONS(1412),
    [anon_sym_GT_GT] = ACTIONS(1412),
    [anon_sym_PLUS_EQ] = ACTIONS(1410),
    [anon_sym_DASH_EQ] = ACTIONS(1410),
    [anon_sym_STAR_EQ] = ACTIONS(1410),
    [anon_sym_SLASH_EQ] = ACTIONS(1410),
    [anon_sym_PERCENT_EQ] = ACTIONS(1410),
    [anon_sym_CARET_EQ] = ACTIONS(1410),
    [anon_sym_AMP_EQ] = ACTIONS(1410),
    [anon_sym_PIPE_EQ] = ACTIONS(1410),
    [anon_sym_LT_LT_EQ] = ACTIONS(1410),
    [anon_sym_GT_GT_EQ] = ACTIONS(1410),
    [anon_sym_EQ] = ACTIONS(1412),
    [anon_sym_EQ_EQ] = ACTIONS(1410),
    [anon_sym_BANG_EQ] = ACTIONS(1410),
    [anon_sym_GT] = ACTIONS(1412),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT_EQ] = ACTIONS(1410),
    [anon_sym_LT_EQ] = ACTIONS(1410),
    [anon_sym__] = ACTIONS(1412),
    [anon_sym_DOT] = ACTIONS(1412),
    [anon_sym_DOT_DOT] = ACTIONS(1412),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1410),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(1410),
    [anon_sym_COLON_COLON] = ACTIONS(1410),
    [anon_sym_POUND] = ACTIONS(1410),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_const] = ACTIONS(1412),
    [anon_sym_default] = ACTIONS(1412),
    [anon_sym_union] = ACTIONS(1412),
    [anon_sym_ref] = ACTIONS(1412),
    [sym_mutable_specifier] = ACTIONS(1412),
    [sym_integer_literal] = ACTIONS(1410),
    [aux_sym_string_literal_token1] = ACTIONS(1410),
    [sym_char_literal] = ACTIONS(1410),
    [anon_sym_true] = ACTIONS(1412),
    [anon_sym_false] = ACTIONS(1412),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1412),
    [sym_super] = ACTIONS(1412),
    [sym_crate] = ACTIONS(1412),
    [sym_metavariable] = ACTIONS(1410),
    [sym__raw_string_literal_start] = ACTIONS(1410),
    [sym_float_literal] = ACTIONS(1410),
  },
  [453] = {
    [sym_attribute_item] = STATE(1478),
    [sym_inner_attribute_item] = STATE(1478),
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3412),
    [sym_match_pattern] = STATE(3493),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2974),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(453),
    [sym_block_comment] = STATE(453),
    [aux_sym_match_block_repeat1] = STATE(478),
    [aux_sym_match_arm_repeat1] = STATE(757),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1610),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [454] = {
    [sym_line_comment] = STATE(454),
    [sym_block_comment] = STATE(454),
    [sym_identifier] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1446),
    [anon_sym_u8] = ACTIONS(1448),
    [anon_sym_i8] = ACTIONS(1448),
    [anon_sym_u16] = ACTIONS(1448),
    [anon_sym_i16] = ACTIONS(1448),
    [anon_sym_u32] = ACTIONS(1448),
    [anon_sym_i32] = ACTIONS(1448),
    [anon_sym_u64] = ACTIONS(1448),
    [anon_sym_i64] = ACTIONS(1448),
    [anon_sym_u128] = ACTIONS(1448),
    [anon_sym_i128] = ACTIONS(1448),
    [anon_sym_isize] = ACTIONS(1448),
    [anon_sym_usize] = ACTIONS(1448),
    [anon_sym_f32] = ACTIONS(1448),
    [anon_sym_f64] = ACTIONS(1448),
    [anon_sym_bool] = ACTIONS(1448),
    [anon_sym_str] = ACTIONS(1448),
    [anon_sym_char] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1448),
    [anon_sym_PLUS_EQ] = ACTIONS(1446),
    [anon_sym_DASH_EQ] = ACTIONS(1446),
    [anon_sym_STAR_EQ] = ACTIONS(1446),
    [anon_sym_SLASH_EQ] = ACTIONS(1446),
    [anon_sym_PERCENT_EQ] = ACTIONS(1446),
    [anon_sym_CARET_EQ] = ACTIONS(1446),
    [anon_sym_AMP_EQ] = ACTIONS(1446),
    [anon_sym_PIPE_EQ] = ACTIONS(1446),
    [anon_sym_LT_LT_EQ] = ACTIONS(1446),
    [anon_sym_GT_GT_EQ] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_EQ_EQ] = ACTIONS(1446),
    [anon_sym_BANG_EQ] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT_EQ] = ACTIONS(1446),
    [anon_sym_LT_EQ] = ACTIONS(1446),
    [anon_sym__] = ACTIONS(1448),
    [anon_sym_DOT] = ACTIONS(1448),
    [anon_sym_DOT_DOT] = ACTIONS(1448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1446),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1446),
    [anon_sym_COMMA] = ACTIONS(1446),
    [anon_sym_COLON_COLON] = ACTIONS(1446),
    [anon_sym_POUND] = ACTIONS(1446),
    [anon_sym_as] = ACTIONS(1448),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_default] = ACTIONS(1448),
    [anon_sym_union] = ACTIONS(1448),
    [anon_sym_ref] = ACTIONS(1448),
    [sym_mutable_specifier] = ACTIONS(1448),
    [sym_integer_literal] = ACTIONS(1446),
    [aux_sym_string_literal_token1] = ACTIONS(1446),
    [sym_char_literal] = ACTIONS(1446),
    [anon_sym_true] = ACTIONS(1448),
    [anon_sym_false] = ACTIONS(1448),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1448),
    [sym_super] = ACTIONS(1448),
    [sym_crate] = ACTIONS(1448),
    [sym_metavariable] = ACTIONS(1446),
    [sym__raw_string_literal_start] = ACTIONS(1446),
    [sym_float_literal] = ACTIONS(1446),
  },
  [455] = {
    [sym_line_comment] = STATE(455),
    [sym_block_comment] = STATE(455),
    [sym_identifier] = ACTIONS(1398),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_LBRACK] = ACTIONS(1396),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1396),
    [anon_sym_u8] = ACTIONS(1398),
    [anon_sym_i8] = ACTIONS(1398),
    [anon_sym_u16] = ACTIONS(1398),
    [anon_sym_i16] = ACTIONS(1398),
    [anon_sym_u32] = ACTIONS(1398),
    [anon_sym_i32] = ACTIONS(1398),
    [anon_sym_u64] = ACTIONS(1398),
    [anon_sym_i64] = ACTIONS(1398),
    [anon_sym_u128] = ACTIONS(1398),
    [anon_sym_i128] = ACTIONS(1398),
    [anon_sym_isize] = ACTIONS(1398),
    [anon_sym_usize] = ACTIONS(1398),
    [anon_sym_f32] = ACTIONS(1398),
    [anon_sym_f64] = ACTIONS(1398),
    [anon_sym_bool] = ACTIONS(1398),
    [anon_sym_str] = ACTIONS(1398),
    [anon_sym_char] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_SLASH] = ACTIONS(1398),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_CARET] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1398),
    [anon_sym_PIPE] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1396),
    [anon_sym_PIPE_PIPE] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_PLUS_EQ] = ACTIONS(1396),
    [anon_sym_DASH_EQ] = ACTIONS(1396),
    [anon_sym_STAR_EQ] = ACTIONS(1396),
    [anon_sym_SLASH_EQ] = ACTIONS(1396),
    [anon_sym_PERCENT_EQ] = ACTIONS(1396),
    [anon_sym_CARET_EQ] = ACTIONS(1396),
    [anon_sym_AMP_EQ] = ACTIONS(1396),
    [anon_sym_PIPE_EQ] = ACTIONS(1396),
    [anon_sym_LT_LT_EQ] = ACTIONS(1396),
    [anon_sym_GT_GT_EQ] = ACTIONS(1396),
    [anon_sym_EQ] = ACTIONS(1398),
    [anon_sym_EQ_EQ] = ACTIONS(1396),
    [anon_sym_BANG_EQ] = ACTIONS(1396),
    [anon_sym_GT] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1398),
    [anon_sym_GT_EQ] = ACTIONS(1396),
    [anon_sym_LT_EQ] = ACTIONS(1396),
    [anon_sym__] = ACTIONS(1398),
    [anon_sym_DOT] = ACTIONS(1398),
    [anon_sym_DOT_DOT] = ACTIONS(1398),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1396),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1396),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_COLON_COLON] = ACTIONS(1396),
    [anon_sym_POUND] = ACTIONS(1396),
    [anon_sym_as] = ACTIONS(1398),
    [anon_sym_const] = ACTIONS(1398),
    [anon_sym_default] = ACTIONS(1398),
    [anon_sym_union] = ACTIONS(1398),
    [anon_sym_ref] = ACTIONS(1398),
    [sym_mutable_specifier] = ACTIONS(1398),
    [sym_integer_literal] = ACTIONS(1396),
    [aux_sym_string_literal_token1] = ACTIONS(1396),
    [sym_char_literal] = ACTIONS(1396),
    [anon_sym_true] = ACTIONS(1398),
    [anon_sym_false] = ACTIONS(1398),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1398),
    [sym_super] = ACTIONS(1398),
    [sym_crate] = ACTIONS(1398),
    [sym_metavariable] = ACTIONS(1396),
    [sym__raw_string_literal_start] = ACTIONS(1396),
    [sym_float_literal] = ACTIONS(1396),
  },
  [456] = {
    [sym_line_comment] = STATE(456),
    [sym_block_comment] = STATE(456),
    [sym_identifier] = ACTIONS(1648),
    [anon_sym_LPAREN] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(1650),
    [anon_sym_RBRACE] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_QMARK] = ACTIONS(1394),
    [anon_sym_u8] = ACTIONS(1648),
    [anon_sym_i8] = ACTIONS(1648),
    [anon_sym_u16] = ACTIONS(1648),
    [anon_sym_i16] = ACTIONS(1648),
    [anon_sym_u32] = ACTIONS(1648),
    [anon_sym_i32] = ACTIONS(1648),
    [anon_sym_u64] = ACTIONS(1648),
    [anon_sym_i64] = ACTIONS(1648),
    [anon_sym_u128] = ACTIONS(1648),
    [anon_sym_i128] = ACTIONS(1648),
    [anon_sym_isize] = ACTIONS(1648),
    [anon_sym_usize] = ACTIONS(1648),
    [anon_sym_f32] = ACTIONS(1648),
    [anon_sym_f64] = ACTIONS(1648),
    [anon_sym_bool] = ACTIONS(1648),
    [anon_sym_str] = ACTIONS(1648),
    [anon_sym_char] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_SLASH] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1394),
    [anon_sym_PIPE_PIPE] = ACTIONS(1394),
    [anon_sym_LT_LT] = ACTIONS(1392),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1394),
    [anon_sym_DASH_EQ] = ACTIONS(1394),
    [anon_sym_STAR_EQ] = ACTIONS(1394),
    [anon_sym_SLASH_EQ] = ACTIONS(1394),
    [anon_sym_PERCENT_EQ] = ACTIONS(1394),
    [anon_sym_CARET_EQ] = ACTIONS(1394),
    [anon_sym_AMP_EQ] = ACTIONS(1394),
    [anon_sym_PIPE_EQ] = ACTIONS(1394),
    [anon_sym_LT_LT_EQ] = ACTIONS(1394),
    [anon_sym_GT_GT_EQ] = ACTIONS(1394),
    [anon_sym_EQ] = ACTIONS(1392),
    [anon_sym_EQ_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1394),
    [anon_sym_GT] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1648),
    [anon_sym_GT_EQ] = ACTIONS(1394),
    [anon_sym_LT_EQ] = ACTIONS(1394),
    [anon_sym__] = ACTIONS(1648),
    [anon_sym_DOT] = ACTIONS(1392),
    [anon_sym_DOT_DOT] = ACTIONS(1648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_COLON_COLON] = ACTIONS(1650),
    [anon_sym_POUND] = ACTIONS(1650),
    [anon_sym_as] = ACTIONS(1392),
    [anon_sym_const] = ACTIONS(1648),
    [anon_sym_default] = ACTIONS(1648),
    [anon_sym_union] = ACTIONS(1648),
    [anon_sym_ref] = ACTIONS(1648),
    [sym_mutable_specifier] = ACTIONS(1648),
    [sym_integer_literal] = ACTIONS(1650),
    [aux_sym_string_literal_token1] = ACTIONS(1650),
    [sym_char_literal] = ACTIONS(1650),
    [anon_sym_true] = ACTIONS(1648),
    [anon_sym_false] = ACTIONS(1648),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1648),
    [sym_super] = ACTIONS(1648),
    [sym_crate] = ACTIONS(1648),
    [sym_metavariable] = ACTIONS(1650),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1650),
  },
  [457] = {
    [sym_line_comment] = STATE(457),
    [sym_block_comment] = STATE(457),
    [sym_identifier] = ACTIONS(1250),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_QMARK] = ACTIONS(1248),
    [anon_sym_u8] = ACTIONS(1250),
    [anon_sym_i8] = ACTIONS(1250),
    [anon_sym_u16] = ACTIONS(1250),
    [anon_sym_i16] = ACTIONS(1250),
    [anon_sym_u32] = ACTIONS(1250),
    [anon_sym_i32] = ACTIONS(1250),
    [anon_sym_u64] = ACTIONS(1250),
    [anon_sym_i64] = ACTIONS(1250),
    [anon_sym_u128] = ACTIONS(1250),
    [anon_sym_i128] = ACTIONS(1250),
    [anon_sym_isize] = ACTIONS(1250),
    [anon_sym_usize] = ACTIONS(1250),
    [anon_sym_f32] = ACTIONS(1250),
    [anon_sym_f64] = ACTIONS(1250),
    [anon_sym_bool] = ACTIONS(1250),
    [anon_sym_str] = ACTIONS(1250),
    [anon_sym_char] = ACTIONS(1250),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_CARET] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_PIPE_PIPE] = ACTIONS(1248),
    [anon_sym_LT_LT] = ACTIONS(1250),
    [anon_sym_GT_GT] = ACTIONS(1250),
    [anon_sym_PLUS_EQ] = ACTIONS(1248),
    [anon_sym_DASH_EQ] = ACTIONS(1248),
    [anon_sym_STAR_EQ] = ACTIONS(1248),
    [anon_sym_SLASH_EQ] = ACTIONS(1248),
    [anon_sym_PERCENT_EQ] = ACTIONS(1248),
    [anon_sym_CARET_EQ] = ACTIONS(1248),
    [anon_sym_AMP_EQ] = ACTIONS(1248),
    [anon_sym_PIPE_EQ] = ACTIONS(1248),
    [anon_sym_LT_LT_EQ] = ACTIONS(1248),
    [anon_sym_GT_GT_EQ] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_EQ_EQ] = ACTIONS(1248),
    [anon_sym_BANG_EQ] = ACTIONS(1248),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_GT_EQ] = ACTIONS(1248),
    [anon_sym_LT_EQ] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(1250),
    [anon_sym_DOT] = ACTIONS(1250),
    [anon_sym_DOT_DOT] = ACTIONS(1250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1248),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1248),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_COLON_COLON] = ACTIONS(1248),
    [anon_sym_POUND] = ACTIONS(1248),
    [anon_sym_as] = ACTIONS(1250),
    [anon_sym_const] = ACTIONS(1250),
    [anon_sym_default] = ACTIONS(1250),
    [anon_sym_union] = ACTIONS(1250),
    [anon_sym_ref] = ACTIONS(1250),
    [sym_mutable_specifier] = ACTIONS(1250),
    [sym_integer_literal] = ACTIONS(1248),
    [aux_sym_string_literal_token1] = ACTIONS(1248),
    [sym_char_literal] = ACTIONS(1248),
    [anon_sym_true] = ACTIONS(1250),
    [anon_sym_false] = ACTIONS(1250),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1250),
    [sym_super] = ACTIONS(1250),
    [sym_crate] = ACTIONS(1250),
    [sym_metavariable] = ACTIONS(1248),
    [sym__raw_string_literal_start] = ACTIONS(1248),
    [sym_float_literal] = ACTIONS(1248),
  },
  [458] = {
    [sym_line_comment] = STATE(458),
    [sym_block_comment] = STATE(458),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1358),
    [anon_sym_RBRACE] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1360),
    [anon_sym_STAR] = ACTIONS(1360),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_u8] = ACTIONS(1360),
    [anon_sym_i8] = ACTIONS(1360),
    [anon_sym_u16] = ACTIONS(1360),
    [anon_sym_i16] = ACTIONS(1360),
    [anon_sym_u32] = ACTIONS(1360),
    [anon_sym_i32] = ACTIONS(1360),
    [anon_sym_u64] = ACTIONS(1360),
    [anon_sym_i64] = ACTIONS(1360),
    [anon_sym_u128] = ACTIONS(1360),
    [anon_sym_i128] = ACTIONS(1360),
    [anon_sym_isize] = ACTIONS(1360),
    [anon_sym_usize] = ACTIONS(1360),
    [anon_sym_f32] = ACTIONS(1360),
    [anon_sym_f64] = ACTIONS(1360),
    [anon_sym_bool] = ACTIONS(1360),
    [anon_sym_str] = ACTIONS(1360),
    [anon_sym_char] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1360),
    [anon_sym_SLASH] = ACTIONS(1360),
    [anon_sym_PERCENT] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1360),
    [anon_sym_PIPE] = ACTIONS(1360),
    [anon_sym_AMP_AMP] = ACTIONS(1358),
    [anon_sym_PIPE_PIPE] = ACTIONS(1358),
    [anon_sym_LT_LT] = ACTIONS(1360),
    [anon_sym_GT_GT] = ACTIONS(1360),
    [anon_sym_PLUS_EQ] = ACTIONS(1358),
    [anon_sym_DASH_EQ] = ACTIONS(1358),
    [anon_sym_STAR_EQ] = ACTIONS(1358),
    [anon_sym_SLASH_EQ] = ACTIONS(1358),
    [anon_sym_PERCENT_EQ] = ACTIONS(1358),
    [anon_sym_CARET_EQ] = ACTIONS(1358),
    [anon_sym_AMP_EQ] = ACTIONS(1358),
    [anon_sym_PIPE_EQ] = ACTIONS(1358),
    [anon_sym_LT_LT_EQ] = ACTIONS(1358),
    [anon_sym_GT_GT_EQ] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1360),
    [anon_sym_EQ_EQ] = ACTIONS(1358),
    [anon_sym_BANG_EQ] = ACTIONS(1358),
    [anon_sym_GT] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1360),
    [anon_sym_GT_EQ] = ACTIONS(1358),
    [anon_sym_LT_EQ] = ACTIONS(1358),
    [anon_sym__] = ACTIONS(1360),
    [anon_sym_DOT] = ACTIONS(1360),
    [anon_sym_DOT_DOT] = ACTIONS(1360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1358),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_COLON_COLON] = ACTIONS(1358),
    [anon_sym_POUND] = ACTIONS(1358),
    [anon_sym_as] = ACTIONS(1360),
    [anon_sym_const] = ACTIONS(1360),
    [anon_sym_default] = ACTIONS(1360),
    [anon_sym_union] = ACTIONS(1360),
    [anon_sym_ref] = ACTIONS(1360),
    [sym_mutable_specifier] = ACTIONS(1360),
    [sym_integer_literal] = ACTIONS(1358),
    [aux_sym_string_literal_token1] = ACTIONS(1358),
    [sym_char_literal] = ACTIONS(1358),
    [anon_sym_true] = ACTIONS(1360),
    [anon_sym_false] = ACTIONS(1360),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1360),
    [sym_super] = ACTIONS(1360),
    [sym_crate] = ACTIONS(1360),
    [sym_metavariable] = ACTIONS(1358),
    [sym__raw_string_literal_start] = ACTIONS(1358),
    [sym_float_literal] = ACTIONS(1358),
  },
  [459] = {
    [sym_line_comment] = STATE(459),
    [sym_block_comment] = STATE(459),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_u8] = ACTIONS(1444),
    [anon_sym_i8] = ACTIONS(1444),
    [anon_sym_u16] = ACTIONS(1444),
    [anon_sym_i16] = ACTIONS(1444),
    [anon_sym_u32] = ACTIONS(1444),
    [anon_sym_i32] = ACTIONS(1444),
    [anon_sym_u64] = ACTIONS(1444),
    [anon_sym_i64] = ACTIONS(1444),
    [anon_sym_u128] = ACTIONS(1444),
    [anon_sym_i128] = ACTIONS(1444),
    [anon_sym_isize] = ACTIONS(1444),
    [anon_sym_usize] = ACTIONS(1444),
    [anon_sym_f32] = ACTIONS(1444),
    [anon_sym_f64] = ACTIONS(1444),
    [anon_sym_bool] = ACTIONS(1444),
    [anon_sym_str] = ACTIONS(1444),
    [anon_sym_char] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1444),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
    [anon_sym_STAR_EQ] = ACTIONS(1442),
    [anon_sym_SLASH_EQ] = ACTIONS(1442),
    [anon_sym_PERCENT_EQ] = ACTIONS(1442),
    [anon_sym_CARET_EQ] = ACTIONS(1442),
    [anon_sym_AMP_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_EQ] = ACTIONS(1442),
    [anon_sym_LT_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT_GT_EQ] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym__] = ACTIONS(1444),
    [anon_sym_DOT] = ACTIONS(1444),
    [anon_sym_DOT_DOT] = ACTIONS(1444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1442),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1442),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(1442),
    [anon_sym_POUND] = ACTIONS(1442),
    [anon_sym_as] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_default] = ACTIONS(1444),
    [anon_sym_union] = ACTIONS(1444),
    [anon_sym_ref] = ACTIONS(1444),
    [sym_mutable_specifier] = ACTIONS(1444),
    [sym_integer_literal] = ACTIONS(1442),
    [aux_sym_string_literal_token1] = ACTIONS(1442),
    [sym_char_literal] = ACTIONS(1442),
    [anon_sym_true] = ACTIONS(1444),
    [anon_sym_false] = ACTIONS(1444),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1444),
    [sym_super] = ACTIONS(1444),
    [sym_crate] = ACTIONS(1444),
    [sym_metavariable] = ACTIONS(1442),
    [sym__raw_string_literal_start] = ACTIONS(1442),
    [sym_float_literal] = ACTIONS(1442),
  },
  [460] = {
    [sym_line_comment] = STATE(460),
    [sym_block_comment] = STATE(460),
    [sym_identifier] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_RBRACE] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_QMARK] = ACTIONS(1362),
    [anon_sym_u8] = ACTIONS(1364),
    [anon_sym_i8] = ACTIONS(1364),
    [anon_sym_u16] = ACTIONS(1364),
    [anon_sym_i16] = ACTIONS(1364),
    [anon_sym_u32] = ACTIONS(1364),
    [anon_sym_i32] = ACTIONS(1364),
    [anon_sym_u64] = ACTIONS(1364),
    [anon_sym_i64] = ACTIONS(1364),
    [anon_sym_u128] = ACTIONS(1364),
    [anon_sym_i128] = ACTIONS(1364),
    [anon_sym_isize] = ACTIONS(1364),
    [anon_sym_usize] = ACTIONS(1364),
    [anon_sym_f32] = ACTIONS(1364),
    [anon_sym_f64] = ACTIONS(1364),
    [anon_sym_bool] = ACTIONS(1364),
    [anon_sym_str] = ACTIONS(1364),
    [anon_sym_char] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_SLASH] = ACTIONS(1364),
    [anon_sym_PERCENT] = ACTIONS(1364),
    [anon_sym_CARET] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1362),
    [anon_sym_PIPE_PIPE] = ACTIONS(1362),
    [anon_sym_LT_LT] = ACTIONS(1364),
    [anon_sym_GT_GT] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1362),
    [anon_sym_DASH_EQ] = ACTIONS(1362),
    [anon_sym_STAR_EQ] = ACTIONS(1362),
    [anon_sym_SLASH_EQ] = ACTIONS(1362),
    [anon_sym_PERCENT_EQ] = ACTIONS(1362),
    [anon_sym_CARET_EQ] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1362),
    [anon_sym_PIPE_EQ] = ACTIONS(1362),
    [anon_sym_LT_LT_EQ] = ACTIONS(1362),
    [anon_sym_GT_GT_EQ] = ACTIONS(1362),
    [anon_sym_EQ] = ACTIONS(1364),
    [anon_sym_EQ_EQ] = ACTIONS(1362),
    [anon_sym_BANG_EQ] = ACTIONS(1362),
    [anon_sym_GT] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1362),
    [anon_sym_LT_EQ] = ACTIONS(1362),
    [anon_sym__] = ACTIONS(1364),
    [anon_sym_DOT] = ACTIONS(1364),
    [anon_sym_DOT_DOT] = ACTIONS(1364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1362),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1362),
    [anon_sym_COMMA] = ACTIONS(1362),
    [anon_sym_COLON_COLON] = ACTIONS(1362),
    [anon_sym_POUND] = ACTIONS(1362),
    [anon_sym_as] = ACTIONS(1364),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_default] = ACTIONS(1364),
    [anon_sym_union] = ACTIONS(1364),
    [anon_sym_ref] = ACTIONS(1364),
    [sym_mutable_specifier] = ACTIONS(1364),
    [sym_integer_literal] = ACTIONS(1362),
    [aux_sym_string_literal_token1] = ACTIONS(1362),
    [sym_char_literal] = ACTIONS(1362),
    [anon_sym_true] = ACTIONS(1364),
    [anon_sym_false] = ACTIONS(1364),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1364),
    [sym_super] = ACTIONS(1364),
    [sym_crate] = ACTIONS(1364),
    [sym_metavariable] = ACTIONS(1362),
    [sym__raw_string_literal_start] = ACTIONS(1362),
    [sym_float_literal] = ACTIONS(1362),
  },
  [461] = {
    [sym_line_comment] = STATE(461),
    [sym_block_comment] = STATE(461),
    [sym_identifier] = ACTIONS(1402),
    [anon_sym_LPAREN] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1400),
    [anon_sym_RBRACE] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1402),
    [anon_sym_QMARK] = ACTIONS(1400),
    [anon_sym_u8] = ACTIONS(1402),
    [anon_sym_i8] = ACTIONS(1402),
    [anon_sym_u16] = ACTIONS(1402),
    [anon_sym_i16] = ACTIONS(1402),
    [anon_sym_u32] = ACTIONS(1402),
    [anon_sym_i32] = ACTIONS(1402),
    [anon_sym_u64] = ACTIONS(1402),
    [anon_sym_i64] = ACTIONS(1402),
    [anon_sym_u128] = ACTIONS(1402),
    [anon_sym_i128] = ACTIONS(1402),
    [anon_sym_isize] = ACTIONS(1402),
    [anon_sym_usize] = ACTIONS(1402),
    [anon_sym_f32] = ACTIONS(1402),
    [anon_sym_f64] = ACTIONS(1402),
    [anon_sym_bool] = ACTIONS(1402),
    [anon_sym_str] = ACTIONS(1402),
    [anon_sym_char] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1402),
    [anon_sym_SLASH] = ACTIONS(1402),
    [anon_sym_PERCENT] = ACTIONS(1402),
    [anon_sym_CARET] = ACTIONS(1402),
    [anon_sym_AMP] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_PLUS_EQ] = ACTIONS(1400),
    [anon_sym_DASH_EQ] = ACTIONS(1400),
    [anon_sym_STAR_EQ] = ACTIONS(1400),
    [anon_sym_SLASH_EQ] = ACTIONS(1400),
    [anon_sym_PERCENT_EQ] = ACTIONS(1400),
    [anon_sym_CARET_EQ] = ACTIONS(1400),
    [anon_sym_AMP_EQ] = ACTIONS(1400),
    [anon_sym_PIPE_EQ] = ACTIONS(1400),
    [anon_sym_LT_LT_EQ] = ACTIONS(1400),
    [anon_sym_GT_GT_EQ] = ACTIONS(1400),
    [anon_sym_EQ] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT_EQ] = ACTIONS(1400),
    [anon_sym_LT_EQ] = ACTIONS(1400),
    [anon_sym__] = ACTIONS(1402),
    [anon_sym_DOT] = ACTIONS(1402),
    [anon_sym_DOT_DOT] = ACTIONS(1402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1400),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1400),
    [anon_sym_COMMA] = ACTIONS(1400),
    [anon_sym_COLON_COLON] = ACTIONS(1400),
    [anon_sym_POUND] = ACTIONS(1400),
    [anon_sym_as] = ACTIONS(1402),
    [anon_sym_const] = ACTIONS(1402),
    [anon_sym_default] = ACTIONS(1402),
    [anon_sym_union] = ACTIONS(1402),
    [anon_sym_ref] = ACTIONS(1402),
    [sym_mutable_specifier] = ACTIONS(1402),
    [sym_integer_literal] = ACTIONS(1400),
    [aux_sym_string_literal_token1] = ACTIONS(1400),
    [sym_char_literal] = ACTIONS(1400),
    [anon_sym_true] = ACTIONS(1402),
    [anon_sym_false] = ACTIONS(1402),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1402),
    [sym_super] = ACTIONS(1402),
    [sym_crate] = ACTIONS(1402),
    [sym_metavariable] = ACTIONS(1400),
    [sym__raw_string_literal_start] = ACTIONS(1400),
    [sym_float_literal] = ACTIONS(1400),
  },
  [462] = {
    [sym_line_comment] = STATE(462),
    [sym_block_comment] = STATE(462),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_RBRACE] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_QMARK] = ACTIONS(1374),
    [anon_sym_u8] = ACTIONS(1376),
    [anon_sym_i8] = ACTIONS(1376),
    [anon_sym_u16] = ACTIONS(1376),
    [anon_sym_i16] = ACTIONS(1376),
    [anon_sym_u32] = ACTIONS(1376),
    [anon_sym_i32] = ACTIONS(1376),
    [anon_sym_u64] = ACTIONS(1376),
    [anon_sym_i64] = ACTIONS(1376),
    [anon_sym_u128] = ACTIONS(1376),
    [anon_sym_i128] = ACTIONS(1376),
    [anon_sym_isize] = ACTIONS(1376),
    [anon_sym_usize] = ACTIONS(1376),
    [anon_sym_f32] = ACTIONS(1376),
    [anon_sym_f64] = ACTIONS(1376),
    [anon_sym_bool] = ACTIONS(1376),
    [anon_sym_str] = ACTIONS(1376),
    [anon_sym_char] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1376),
    [anon_sym_CARET] = ACTIONS(1376),
    [anon_sym_AMP] = ACTIONS(1376),
    [anon_sym_PIPE] = ACTIONS(1376),
    [anon_sym_AMP_AMP] = ACTIONS(1374),
    [anon_sym_PIPE_PIPE] = ACTIONS(1374),
    [anon_sym_LT_LT] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1376),
    [anon_sym_PLUS_EQ] = ACTIONS(1374),
    [anon_sym_DASH_EQ] = ACTIONS(1374),
    [anon_sym_STAR_EQ] = ACTIONS(1374),
    [anon_sym_SLASH_EQ] = ACTIONS(1374),
    [anon_sym_PERCENT_EQ] = ACTIONS(1374),
    [anon_sym_CARET_EQ] = ACTIONS(1374),
    [anon_sym_AMP_EQ] = ACTIONS(1374),
    [anon_sym_PIPE_EQ] = ACTIONS(1374),
    [anon_sym_LT_LT_EQ] = ACTIONS(1374),
    [anon_sym_GT_GT_EQ] = ACTIONS(1374),
    [anon_sym_EQ] = ACTIONS(1376),
    [anon_sym_EQ_EQ] = ACTIONS(1374),
    [anon_sym_BANG_EQ] = ACTIONS(1374),
    [anon_sym_GT] = ACTIONS(1376),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_GT_EQ] = ACTIONS(1374),
    [anon_sym_LT_EQ] = ACTIONS(1374),
    [anon_sym__] = ACTIONS(1376),
    [anon_sym_DOT] = ACTIONS(1376),
    [anon_sym_DOT_DOT] = ACTIONS(1376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1374),
    [anon_sym_COMMA] = ACTIONS(1374),
    [anon_sym_COLON_COLON] = ACTIONS(1374),
    [anon_sym_POUND] = ACTIONS(1374),
    [anon_sym_as] = ACTIONS(1376),
    [anon_sym_const] = ACTIONS(1376),
    [anon_sym_default] = ACTIONS(1376),
    [anon_sym_union] = ACTIONS(1376),
    [anon_sym_ref] = ACTIONS(1376),
    [sym_mutable_specifier] = ACTIONS(1376),
    [sym_integer_literal] = ACTIONS(1374),
    [aux_sym_string_literal_token1] = ACTIONS(1374),
    [sym_char_literal] = ACTIONS(1374),
    [anon_sym_true] = ACTIONS(1376),
    [anon_sym_false] = ACTIONS(1376),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1376),
    [sym_super] = ACTIONS(1376),
    [sym_crate] = ACTIONS(1376),
    [sym_metavariable] = ACTIONS(1374),
    [sym__raw_string_literal_start] = ACTIONS(1374),
    [sym_float_literal] = ACTIONS(1374),
  },
  [463] = {
    [sym_line_comment] = STATE(463),
    [sym_block_comment] = STATE(463),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_RBRACE] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_QMARK] = ACTIONS(1394),
    [anon_sym_u8] = ACTIONS(1652),
    [anon_sym_i8] = ACTIONS(1652),
    [anon_sym_u16] = ACTIONS(1652),
    [anon_sym_i16] = ACTIONS(1652),
    [anon_sym_u32] = ACTIONS(1652),
    [anon_sym_i32] = ACTIONS(1652),
    [anon_sym_u64] = ACTIONS(1652),
    [anon_sym_i64] = ACTIONS(1652),
    [anon_sym_u128] = ACTIONS(1652),
    [anon_sym_i128] = ACTIONS(1652),
    [anon_sym_isize] = ACTIONS(1652),
    [anon_sym_usize] = ACTIONS(1652),
    [anon_sym_f32] = ACTIONS(1652),
    [anon_sym_f64] = ACTIONS(1652),
    [anon_sym_bool] = ACTIONS(1652),
    [anon_sym_str] = ACTIONS(1652),
    [anon_sym_char] = ACTIONS(1652),
    [anon_sym_DASH] = ACTIONS(1652),
    [anon_sym_SLASH] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1652),
    [anon_sym_PIPE] = ACTIONS(1652),
    [anon_sym_AMP_AMP] = ACTIONS(1394),
    [anon_sym_PIPE_PIPE] = ACTIONS(1394),
    [anon_sym_LT_LT] = ACTIONS(1392),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1394),
    [anon_sym_DASH_EQ] = ACTIONS(1394),
    [anon_sym_STAR_EQ] = ACTIONS(1394),
    [anon_sym_SLASH_EQ] = ACTIONS(1394),
    [anon_sym_PERCENT_EQ] = ACTIONS(1394),
    [anon_sym_CARET_EQ] = ACTIONS(1394),
    [anon_sym_AMP_EQ] = ACTIONS(1394),
    [anon_sym_PIPE_EQ] = ACTIONS(1394),
    [anon_sym_LT_LT_EQ] = ACTIONS(1394),
    [anon_sym_GT_GT_EQ] = ACTIONS(1394),
    [anon_sym_EQ] = ACTIONS(1392),
    [anon_sym_EQ_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1394),
    [anon_sym_GT] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1652),
    [anon_sym_GT_EQ] = ACTIONS(1394),
    [anon_sym_LT_EQ] = ACTIONS(1394),
    [anon_sym__] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(1392),
    [anon_sym_DOT_DOT] = ACTIONS(1652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_COLON_COLON] = ACTIONS(1654),
    [anon_sym_POUND] = ACTIONS(1654),
    [anon_sym_as] = ACTIONS(1392),
    [anon_sym_const] = ACTIONS(1652),
    [anon_sym_default] = ACTIONS(1652),
    [anon_sym_union] = ACTIONS(1652),
    [anon_sym_ref] = ACTIONS(1652),
    [sym_mutable_specifier] = ACTIONS(1652),
    [sym_integer_literal] = ACTIONS(1654),
    [aux_sym_string_literal_token1] = ACTIONS(1654),
    [sym_char_literal] = ACTIONS(1654),
    [anon_sym_true] = ACTIONS(1652),
    [anon_sym_false] = ACTIONS(1652),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1652),
    [sym_super] = ACTIONS(1652),
    [sym_crate] = ACTIONS(1652),
    [sym_metavariable] = ACTIONS(1654),
    [sym__raw_string_literal_start] = ACTIONS(1654),
    [sym_float_literal] = ACTIONS(1654),
  },
  [464] = {
    [sym_line_comment] = STATE(464),
    [sym_block_comment] = STATE(464),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_RBRACE] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_QMARK] = ACTIONS(1426),
    [anon_sym_u8] = ACTIONS(1428),
    [anon_sym_i8] = ACTIONS(1428),
    [anon_sym_u16] = ACTIONS(1428),
    [anon_sym_i16] = ACTIONS(1428),
    [anon_sym_u32] = ACTIONS(1428),
    [anon_sym_i32] = ACTIONS(1428),
    [anon_sym_u64] = ACTIONS(1428),
    [anon_sym_i64] = ACTIONS(1428),
    [anon_sym_u128] = ACTIONS(1428),
    [anon_sym_i128] = ACTIONS(1428),
    [anon_sym_isize] = ACTIONS(1428),
    [anon_sym_usize] = ACTIONS(1428),
    [anon_sym_f32] = ACTIONS(1428),
    [anon_sym_f64] = ACTIONS(1428),
    [anon_sym_bool] = ACTIONS(1428),
    [anon_sym_str] = ACTIONS(1428),
    [anon_sym_char] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1428),
    [anon_sym_PERCENT] = ACTIONS(1428),
    [anon_sym_CARET] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1426),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_LT_LT] = ACTIONS(1428),
    [anon_sym_GT_GT] = ACTIONS(1428),
    [anon_sym_PLUS_EQ] = ACTIONS(1426),
    [anon_sym_DASH_EQ] = ACTIONS(1426),
    [anon_sym_STAR_EQ] = ACTIONS(1426),
    [anon_sym_SLASH_EQ] = ACTIONS(1426),
    [anon_sym_PERCENT_EQ] = ACTIONS(1426),
    [anon_sym_CARET_EQ] = ACTIONS(1426),
    [anon_sym_AMP_EQ] = ACTIONS(1426),
    [anon_sym_PIPE_EQ] = ACTIONS(1426),
    [anon_sym_LT_LT_EQ] = ACTIONS(1426),
    [anon_sym_GT_GT_EQ] = ACTIONS(1426),
    [anon_sym_EQ] = ACTIONS(1428),
    [anon_sym_EQ_EQ] = ACTIONS(1426),
    [anon_sym_BANG_EQ] = ACTIONS(1426),
    [anon_sym_GT] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1428),
    [anon_sym_GT_EQ] = ACTIONS(1426),
    [anon_sym_LT_EQ] = ACTIONS(1426),
    [anon_sym__] = ACTIONS(1428),
    [anon_sym_DOT] = ACTIONS(1428),
    [anon_sym_DOT_DOT] = ACTIONS(1428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1426),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1426),
    [anon_sym_COMMA] = ACTIONS(1426),
    [anon_sym_COLON_COLON] = ACTIONS(1426),
    [anon_sym_POUND] = ACTIONS(1426),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_const] = ACTIONS(1428),
    [anon_sym_default] = ACTIONS(1428),
    [anon_sym_union] = ACTIONS(1428),
    [anon_sym_ref] = ACTIONS(1428),
    [sym_mutable_specifier] = ACTIONS(1428),
    [sym_integer_literal] = ACTIONS(1426),
    [aux_sym_string_literal_token1] = ACTIONS(1426),
    [sym_char_literal] = ACTIONS(1426),
    [anon_sym_true] = ACTIONS(1428),
    [anon_sym_false] = ACTIONS(1428),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1428),
    [sym_super] = ACTIONS(1428),
    [sym_crate] = ACTIONS(1428),
    [sym_metavariable] = ACTIONS(1426),
    [sym__raw_string_literal_start] = ACTIONS(1426),
    [sym_float_literal] = ACTIONS(1426),
  },
  [465] = {
    [sym_line_comment] = STATE(465),
    [sym_block_comment] = STATE(465),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_LBRACK] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1420),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_QMARK] = ACTIONS(1418),
    [anon_sym_u8] = ACTIONS(1420),
    [anon_sym_i8] = ACTIONS(1420),
    [anon_sym_u16] = ACTIONS(1420),
    [anon_sym_i16] = ACTIONS(1420),
    [anon_sym_u32] = ACTIONS(1420),
    [anon_sym_i32] = ACTIONS(1420),
    [anon_sym_u64] = ACTIONS(1420),
    [anon_sym_i64] = ACTIONS(1420),
    [anon_sym_u128] = ACTIONS(1420),
    [anon_sym_i128] = ACTIONS(1420),
    [anon_sym_isize] = ACTIONS(1420),
    [anon_sym_usize] = ACTIONS(1420),
    [anon_sym_f32] = ACTIONS(1420),
    [anon_sym_f64] = ACTIONS(1420),
    [anon_sym_bool] = ACTIONS(1420),
    [anon_sym_str] = ACTIONS(1420),
    [anon_sym_char] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_SLASH] = ACTIONS(1420),
    [anon_sym_PERCENT] = ACTIONS(1420),
    [anon_sym_CARET] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_PIPE] = ACTIONS(1420),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_PIPE_PIPE] = ACTIONS(1418),
    [anon_sym_LT_LT] = ACTIONS(1420),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_EQ] = ACTIONS(1418),
    [anon_sym_DASH_EQ] = ACTIONS(1418),
    [anon_sym_STAR_EQ] = ACTIONS(1418),
    [anon_sym_SLASH_EQ] = ACTIONS(1418),
    [anon_sym_PERCENT_EQ] = ACTIONS(1418),
    [anon_sym_CARET_EQ] = ACTIONS(1418),
    [anon_sym_AMP_EQ] = ACTIONS(1418),
    [anon_sym_PIPE_EQ] = ACTIONS(1418),
    [anon_sym_LT_LT_EQ] = ACTIONS(1418),
    [anon_sym_GT_GT_EQ] = ACTIONS(1418),
    [anon_sym_EQ] = ACTIONS(1420),
    [anon_sym_EQ_EQ] = ACTIONS(1418),
    [anon_sym_BANG_EQ] = ACTIONS(1418),
    [anon_sym_GT] = ACTIONS(1420),
    [anon_sym_LT] = ACTIONS(1420),
    [anon_sym_GT_EQ] = ACTIONS(1418),
    [anon_sym_LT_EQ] = ACTIONS(1418),
    [anon_sym__] = ACTIONS(1420),
    [anon_sym_DOT] = ACTIONS(1420),
    [anon_sym_DOT_DOT] = ACTIONS(1420),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1418),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1418),
    [anon_sym_COMMA] = ACTIONS(1418),
    [anon_sym_COLON_COLON] = ACTIONS(1418),
    [anon_sym_POUND] = ACTIONS(1418),
    [anon_sym_as] = ACTIONS(1420),
    [anon_sym_const] = ACTIONS(1420),
    [anon_sym_default] = ACTIONS(1420),
    [anon_sym_union] = ACTIONS(1420),
    [anon_sym_ref] = ACTIONS(1420),
    [sym_mutable_specifier] = ACTIONS(1420),
    [sym_integer_literal] = ACTIONS(1418),
    [aux_sym_string_literal_token1] = ACTIONS(1418),
    [sym_char_literal] = ACTIONS(1418),
    [anon_sym_true] = ACTIONS(1420),
    [anon_sym_false] = ACTIONS(1420),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1420),
    [sym_super] = ACTIONS(1420),
    [sym_crate] = ACTIONS(1420),
    [sym_metavariable] = ACTIONS(1418),
    [sym__raw_string_literal_start] = ACTIONS(1418),
    [sym_float_literal] = ACTIONS(1418),
  },
  [466] = {
    [sym_attribute_item] = STATE(1478),
    [sym_inner_attribute_item] = STATE(1478),
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3467),
    [sym_match_pattern] = STATE(3493),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2974),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(466),
    [sym_block_comment] = STATE(466),
    [aux_sym_match_block_repeat1] = STATE(476),
    [aux_sym_match_arm_repeat1] = STATE(757),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [467] = {
    [sym_line_comment] = STATE(467),
    [sym_block_comment] = STATE(467),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_QMARK] = ACTIONS(1324),
    [anon_sym_u8] = ACTIONS(1326),
    [anon_sym_i8] = ACTIONS(1326),
    [anon_sym_u16] = ACTIONS(1326),
    [anon_sym_i16] = ACTIONS(1326),
    [anon_sym_u32] = ACTIONS(1326),
    [anon_sym_i32] = ACTIONS(1326),
    [anon_sym_u64] = ACTIONS(1326),
    [anon_sym_i64] = ACTIONS(1326),
    [anon_sym_u128] = ACTIONS(1326),
    [anon_sym_i128] = ACTIONS(1326),
    [anon_sym_isize] = ACTIONS(1326),
    [anon_sym_usize] = ACTIONS(1326),
    [anon_sym_f32] = ACTIONS(1326),
    [anon_sym_f64] = ACTIONS(1326),
    [anon_sym_bool] = ACTIONS(1326),
    [anon_sym_str] = ACTIONS(1326),
    [anon_sym_char] = ACTIONS(1326),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1326),
    [anon_sym_CARET] = ACTIONS(1326),
    [anon_sym_AMP] = ACTIONS(1326),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1326),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_PLUS_EQ] = ACTIONS(1324),
    [anon_sym_DASH_EQ] = ACTIONS(1324),
    [anon_sym_STAR_EQ] = ACTIONS(1324),
    [anon_sym_SLASH_EQ] = ACTIONS(1324),
    [anon_sym_PERCENT_EQ] = ACTIONS(1324),
    [anon_sym_CARET_EQ] = ACTIONS(1324),
    [anon_sym_AMP_EQ] = ACTIONS(1324),
    [anon_sym_PIPE_EQ] = ACTIONS(1324),
    [anon_sym_LT_LT_EQ] = ACTIONS(1324),
    [anon_sym_GT_GT_EQ] = ACTIONS(1324),
    [anon_sym_EQ] = ACTIONS(1326),
    [anon_sym_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG_EQ] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1326),
    [anon_sym_LT] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_DOT] = ACTIONS(1326),
    [anon_sym_DOT_DOT] = ACTIONS(1326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1324),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1324),
    [anon_sym_COMMA] = ACTIONS(1324),
    [anon_sym_COLON_COLON] = ACTIONS(1324),
    [anon_sym_POUND] = ACTIONS(1324),
    [anon_sym_as] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [anon_sym_default] = ACTIONS(1326),
    [anon_sym_union] = ACTIONS(1326),
    [anon_sym_ref] = ACTIONS(1326),
    [sym_mutable_specifier] = ACTIONS(1326),
    [sym_integer_literal] = ACTIONS(1324),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1324),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1326),
    [sym_super] = ACTIONS(1326),
    [sym_crate] = ACTIONS(1326),
    [sym_metavariable] = ACTIONS(1324),
    [sym__raw_string_literal_start] = ACTIONS(1324),
    [sym_float_literal] = ACTIONS(1324),
  },
  [468] = {
    [sym_attribute_item] = STATE(1478),
    [sym_inner_attribute_item] = STATE(1478),
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3484),
    [sym_match_pattern] = STATE(3493),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2974),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(468),
    [sym_block_comment] = STATE(468),
    [aux_sym_match_block_repeat1] = STATE(477),
    [aux_sym_match_arm_repeat1] = STATE(757),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1658),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [469] = {
    [sym_line_comment] = STATE(469),
    [sym_block_comment] = STATE(469),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_RBRACE] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_QMARK] = ACTIONS(1450),
    [anon_sym_u8] = ACTIONS(1452),
    [anon_sym_i8] = ACTIONS(1452),
    [anon_sym_u16] = ACTIONS(1452),
    [anon_sym_i16] = ACTIONS(1452),
    [anon_sym_u32] = ACTIONS(1452),
    [anon_sym_i32] = ACTIONS(1452),
    [anon_sym_u64] = ACTIONS(1452),
    [anon_sym_i64] = ACTIONS(1452),
    [anon_sym_u128] = ACTIONS(1452),
    [anon_sym_i128] = ACTIONS(1452),
    [anon_sym_isize] = ACTIONS(1452),
    [anon_sym_usize] = ACTIONS(1452),
    [anon_sym_f32] = ACTIONS(1452),
    [anon_sym_f64] = ACTIONS(1452),
    [anon_sym_bool] = ACTIONS(1452),
    [anon_sym_str] = ACTIONS(1452),
    [anon_sym_char] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_PERCENT] = ACTIONS(1452),
    [anon_sym_CARET] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_PIPE] = ACTIONS(1452),
    [anon_sym_AMP_AMP] = ACTIONS(1450),
    [anon_sym_PIPE_PIPE] = ACTIONS(1450),
    [anon_sym_LT_LT] = ACTIONS(1452),
    [anon_sym_GT_GT] = ACTIONS(1452),
    [anon_sym_PLUS_EQ] = ACTIONS(1450),
    [anon_sym_DASH_EQ] = ACTIONS(1450),
    [anon_sym_STAR_EQ] = ACTIONS(1450),
    [anon_sym_SLASH_EQ] = ACTIONS(1450),
    [anon_sym_PERCENT_EQ] = ACTIONS(1450),
    [anon_sym_CARET_EQ] = ACTIONS(1450),
    [anon_sym_AMP_EQ] = ACTIONS(1450),
    [anon_sym_PIPE_EQ] = ACTIONS(1450),
    [anon_sym_LT_LT_EQ] = ACTIONS(1450),
    [anon_sym_GT_GT_EQ] = ACTIONS(1450),
    [anon_sym_EQ] = ACTIONS(1452),
    [anon_sym_EQ_EQ] = ACTIONS(1450),
    [anon_sym_BANG_EQ] = ACTIONS(1450),
    [anon_sym_GT] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_GT_EQ] = ACTIONS(1450),
    [anon_sym_LT_EQ] = ACTIONS(1450),
    [anon_sym__] = ACTIONS(1452),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_DOT_DOT] = ACTIONS(1452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1450),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1450),
    [anon_sym_COMMA] = ACTIONS(1450),
    [anon_sym_COLON_COLON] = ACTIONS(1450),
    [anon_sym_POUND] = ACTIONS(1450),
    [anon_sym_as] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_union] = ACTIONS(1452),
    [anon_sym_ref] = ACTIONS(1452),
    [sym_mutable_specifier] = ACTIONS(1452),
    [sym_integer_literal] = ACTIONS(1450),
    [aux_sym_string_literal_token1] = ACTIONS(1450),
    [sym_char_literal] = ACTIONS(1450),
    [anon_sym_true] = ACTIONS(1452),
    [anon_sym_false] = ACTIONS(1452),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1452),
    [sym_super] = ACTIONS(1452),
    [sym_crate] = ACTIONS(1452),
    [sym_metavariable] = ACTIONS(1450),
    [sym__raw_string_literal_start] = ACTIONS(1450),
    [sym_float_literal] = ACTIONS(1450),
  },
  [470] = {
    [sym_line_comment] = STATE(470),
    [sym_block_comment] = STATE(470),
    [sym_identifier] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_QMARK] = ACTIONS(1370),
    [anon_sym_u8] = ACTIONS(1372),
    [anon_sym_i8] = ACTIONS(1372),
    [anon_sym_u16] = ACTIONS(1372),
    [anon_sym_i16] = ACTIONS(1372),
    [anon_sym_u32] = ACTIONS(1372),
    [anon_sym_i32] = ACTIONS(1372),
    [anon_sym_u64] = ACTIONS(1372),
    [anon_sym_i64] = ACTIONS(1372),
    [anon_sym_u128] = ACTIONS(1372),
    [anon_sym_i128] = ACTIONS(1372),
    [anon_sym_isize] = ACTIONS(1372),
    [anon_sym_usize] = ACTIONS(1372),
    [anon_sym_f32] = ACTIONS(1372),
    [anon_sym_f64] = ACTIONS(1372),
    [anon_sym_bool] = ACTIONS(1372),
    [anon_sym_str] = ACTIONS(1372),
    [anon_sym_char] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_PIPE_PIPE] = ACTIONS(1370),
    [anon_sym_LT_LT] = ACTIONS(1372),
    [anon_sym_GT_GT] = ACTIONS(1372),
    [anon_sym_PLUS_EQ] = ACTIONS(1370),
    [anon_sym_DASH_EQ] = ACTIONS(1370),
    [anon_sym_STAR_EQ] = ACTIONS(1370),
    [anon_sym_SLASH_EQ] = ACTIONS(1370),
    [anon_sym_PERCENT_EQ] = ACTIONS(1370),
    [anon_sym_CARET_EQ] = ACTIONS(1370),
    [anon_sym_AMP_EQ] = ACTIONS(1370),
    [anon_sym_PIPE_EQ] = ACTIONS(1370),
    [anon_sym_LT_LT_EQ] = ACTIONS(1370),
    [anon_sym_GT_GT_EQ] = ACTIONS(1370),
    [anon_sym_EQ] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym__] = ACTIONS(1372),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_DOT_DOT] = ACTIONS(1372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1370),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1370),
    [anon_sym_COMMA] = ACTIONS(1370),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_POUND] = ACTIONS(1370),
    [anon_sym_as] = ACTIONS(1372),
    [anon_sym_const] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_union] = ACTIONS(1372),
    [anon_sym_ref] = ACTIONS(1372),
    [sym_mutable_specifier] = ACTIONS(1372),
    [sym_integer_literal] = ACTIONS(1370),
    [aux_sym_string_literal_token1] = ACTIONS(1370),
    [sym_char_literal] = ACTIONS(1370),
    [anon_sym_true] = ACTIONS(1372),
    [anon_sym_false] = ACTIONS(1372),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1372),
    [sym_super] = ACTIONS(1372),
    [sym_crate] = ACTIONS(1372),
    [sym_metavariable] = ACTIONS(1370),
    [sym__raw_string_literal_start] = ACTIONS(1370),
    [sym_float_literal] = ACTIONS(1370),
  },
  [471] = {
    [sym_line_comment] = STATE(471),
    [sym_block_comment] = STATE(471),
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1430),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_RBRACE] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1432),
    [anon_sym_STAR] = ACTIONS(1432),
    [anon_sym_QMARK] = ACTIONS(1430),
    [anon_sym_u8] = ACTIONS(1432),
    [anon_sym_i8] = ACTIONS(1432),
    [anon_sym_u16] = ACTIONS(1432),
    [anon_sym_i16] = ACTIONS(1432),
    [anon_sym_u32] = ACTIONS(1432),
    [anon_sym_i32] = ACTIONS(1432),
    [anon_sym_u64] = ACTIONS(1432),
    [anon_sym_i64] = ACTIONS(1432),
    [anon_sym_u128] = ACTIONS(1432),
    [anon_sym_i128] = ACTIONS(1432),
    [anon_sym_isize] = ACTIONS(1432),
    [anon_sym_usize] = ACTIONS(1432),
    [anon_sym_f32] = ACTIONS(1432),
    [anon_sym_f64] = ACTIONS(1432),
    [anon_sym_bool] = ACTIONS(1432),
    [anon_sym_str] = ACTIONS(1432),
    [anon_sym_char] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1432),
    [anon_sym_SLASH] = ACTIONS(1432),
    [anon_sym_PERCENT] = ACTIONS(1432),
    [anon_sym_CARET] = ACTIONS(1432),
    [anon_sym_AMP] = ACTIONS(1432),
    [anon_sym_PIPE] = ACTIONS(1432),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [anon_sym_LT_LT] = ACTIONS(1432),
    [anon_sym_GT_GT] = ACTIONS(1432),
    [anon_sym_PLUS_EQ] = ACTIONS(1430),
    [anon_sym_DASH_EQ] = ACTIONS(1430),
    [anon_sym_STAR_EQ] = ACTIONS(1430),
    [anon_sym_SLASH_EQ] = ACTIONS(1430),
    [anon_sym_PERCENT_EQ] = ACTIONS(1430),
    [anon_sym_CARET_EQ] = ACTIONS(1430),
    [anon_sym_AMP_EQ] = ACTIONS(1430),
    [anon_sym_PIPE_EQ] = ACTIONS(1430),
    [anon_sym_LT_LT_EQ] = ACTIONS(1430),
    [anon_sym_GT_GT_EQ] = ACTIONS(1430),
    [anon_sym_EQ] = ACTIONS(1432),
    [anon_sym_EQ_EQ] = ACTIONS(1430),
    [anon_sym_BANG_EQ] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(1432),
    [anon_sym_GT_EQ] = ACTIONS(1430),
    [anon_sym_LT_EQ] = ACTIONS(1430),
    [anon_sym__] = ACTIONS(1432),
    [anon_sym_DOT] = ACTIONS(1432),
    [anon_sym_DOT_DOT] = ACTIONS(1432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1430),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1430),
    [anon_sym_COMMA] = ACTIONS(1430),
    [anon_sym_COLON_COLON] = ACTIONS(1430),
    [anon_sym_POUND] = ACTIONS(1430),
    [anon_sym_as] = ACTIONS(1432),
    [anon_sym_const] = ACTIONS(1432),
    [anon_sym_default] = ACTIONS(1432),
    [anon_sym_union] = ACTIONS(1432),
    [anon_sym_ref] = ACTIONS(1432),
    [sym_mutable_specifier] = ACTIONS(1432),
    [sym_integer_literal] = ACTIONS(1430),
    [aux_sym_string_literal_token1] = ACTIONS(1430),
    [sym_char_literal] = ACTIONS(1430),
    [anon_sym_true] = ACTIONS(1432),
    [anon_sym_false] = ACTIONS(1432),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1432),
    [sym_super] = ACTIONS(1432),
    [sym_crate] = ACTIONS(1432),
    [sym_metavariable] = ACTIONS(1430),
    [sym__raw_string_literal_start] = ACTIONS(1430),
    [sym_float_literal] = ACTIONS(1430),
  },
  [472] = {
    [sym_line_comment] = STATE(472),
    [sym_block_comment] = STATE(472),
    [sym_identifier] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_QMARK] = ACTIONS(1434),
    [anon_sym_u8] = ACTIONS(1436),
    [anon_sym_i8] = ACTIONS(1436),
    [anon_sym_u16] = ACTIONS(1436),
    [anon_sym_i16] = ACTIONS(1436),
    [anon_sym_u32] = ACTIONS(1436),
    [anon_sym_i32] = ACTIONS(1436),
    [anon_sym_u64] = ACTIONS(1436),
    [anon_sym_i64] = ACTIONS(1436),
    [anon_sym_u128] = ACTIONS(1436),
    [anon_sym_i128] = ACTIONS(1436),
    [anon_sym_isize] = ACTIONS(1436),
    [anon_sym_usize] = ACTIONS(1436),
    [anon_sym_f32] = ACTIONS(1436),
    [anon_sym_f64] = ACTIONS(1436),
    [anon_sym_bool] = ACTIONS(1436),
    [anon_sym_str] = ACTIONS(1436),
    [anon_sym_char] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1436),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_PLUS_EQ] = ACTIONS(1434),
    [anon_sym_DASH_EQ] = ACTIONS(1434),
    [anon_sym_STAR_EQ] = ACTIONS(1434),
    [anon_sym_SLASH_EQ] = ACTIONS(1434),
    [anon_sym_PERCENT_EQ] = ACTIONS(1434),
    [anon_sym_CARET_EQ] = ACTIONS(1434),
    [anon_sym_AMP_EQ] = ACTIONS(1434),
    [anon_sym_PIPE_EQ] = ACTIONS(1434),
    [anon_sym_LT_LT_EQ] = ACTIONS(1434),
    [anon_sym_GT_GT_EQ] = ACTIONS(1434),
    [anon_sym_EQ] = ACTIONS(1436),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_BANG_EQ] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_GT_EQ] = ACTIONS(1434),
    [anon_sym_LT_EQ] = ACTIONS(1434),
    [anon_sym__] = ACTIONS(1436),
    [anon_sym_DOT] = ACTIONS(1436),
    [anon_sym_DOT_DOT] = ACTIONS(1436),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1434),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1434),
    [anon_sym_COMMA] = ACTIONS(1434),
    [anon_sym_COLON_COLON] = ACTIONS(1434),
    [anon_sym_POUND] = ACTIONS(1434),
    [anon_sym_as] = ACTIONS(1436),
    [anon_sym_const] = ACTIONS(1436),
    [anon_sym_default] = ACTIONS(1436),
    [anon_sym_union] = ACTIONS(1436),
    [anon_sym_ref] = ACTIONS(1436),
    [sym_mutable_specifier] = ACTIONS(1436),
    [sym_integer_literal] = ACTIONS(1434),
    [aux_sym_string_literal_token1] = ACTIONS(1434),
    [sym_char_literal] = ACTIONS(1434),
    [anon_sym_true] = ACTIONS(1436),
    [anon_sym_false] = ACTIONS(1436),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1436),
    [sym_super] = ACTIONS(1436),
    [sym_crate] = ACTIONS(1436),
    [sym_metavariable] = ACTIONS(1434),
    [sym__raw_string_literal_start] = ACTIONS(1434),
    [sym_float_literal] = ACTIONS(1434),
  },
  [473] = {
    [sym_attribute_item] = STATE(1478),
    [sym_inner_attribute_item] = STATE(1478),
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3406),
    [sym_match_pattern] = STATE(3493),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2974),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(473),
    [sym_block_comment] = STATE(473),
    [aux_sym_match_block_repeat1] = STATE(475),
    [aux_sym_match_arm_repeat1] = STATE(757),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [474] = {
    [sym_line_comment] = STATE(474),
    [sym_block_comment] = STATE(474),
    [sym_identifier] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1368),
    [anon_sym_STAR] = ACTIONS(1368),
    [anon_sym_QMARK] = ACTIONS(1366),
    [anon_sym_u8] = ACTIONS(1368),
    [anon_sym_i8] = ACTIONS(1368),
    [anon_sym_u16] = ACTIONS(1368),
    [anon_sym_i16] = ACTIONS(1368),
    [anon_sym_u32] = ACTIONS(1368),
    [anon_sym_i32] = ACTIONS(1368),
    [anon_sym_u64] = ACTIONS(1368),
    [anon_sym_i64] = ACTIONS(1368),
    [anon_sym_u128] = ACTIONS(1368),
    [anon_sym_i128] = ACTIONS(1368),
    [anon_sym_isize] = ACTIONS(1368),
    [anon_sym_usize] = ACTIONS(1368),
    [anon_sym_f32] = ACTIONS(1368),
    [anon_sym_f64] = ACTIONS(1368),
    [anon_sym_bool] = ACTIONS(1368),
    [anon_sym_str] = ACTIONS(1368),
    [anon_sym_char] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(1368),
    [anon_sym_PERCENT] = ACTIONS(1368),
    [anon_sym_CARET] = ACTIONS(1368),
    [anon_sym_AMP] = ACTIONS(1368),
    [anon_sym_PIPE] = ACTIONS(1368),
    [anon_sym_AMP_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1366),
    [anon_sym_LT_LT] = ACTIONS(1368),
    [anon_sym_GT_GT] = ACTIONS(1368),
    [anon_sym_PLUS_EQ] = ACTIONS(1366),
    [anon_sym_DASH_EQ] = ACTIONS(1366),
    [anon_sym_STAR_EQ] = ACTIONS(1366),
    [anon_sym_SLASH_EQ] = ACTIONS(1366),
    [anon_sym_PERCENT_EQ] = ACTIONS(1366),
    [anon_sym_CARET_EQ] = ACTIONS(1366),
    [anon_sym_AMP_EQ] = ACTIONS(1366),
    [anon_sym_PIPE_EQ] = ACTIONS(1366),
    [anon_sym_LT_LT_EQ] = ACTIONS(1366),
    [anon_sym_GT_GT_EQ] = ACTIONS(1366),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_EQ_EQ] = ACTIONS(1366),
    [anon_sym_BANG_EQ] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1368),
    [anon_sym_LT] = ACTIONS(1368),
    [anon_sym_GT_EQ] = ACTIONS(1366),
    [anon_sym_LT_EQ] = ACTIONS(1366),
    [anon_sym__] = ACTIONS(1368),
    [anon_sym_DOT] = ACTIONS(1368),
    [anon_sym_DOT_DOT] = ACTIONS(1368),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1366),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1366),
    [anon_sym_COMMA] = ACTIONS(1366),
    [anon_sym_COLON_COLON] = ACTIONS(1366),
    [anon_sym_POUND] = ACTIONS(1366),
    [anon_sym_as] = ACTIONS(1368),
    [anon_sym_const] = ACTIONS(1368),
    [anon_sym_default] = ACTIONS(1368),
    [anon_sym_union] = ACTIONS(1368),
    [anon_sym_ref] = ACTIONS(1368),
    [sym_mutable_specifier] = ACTIONS(1368),
    [sym_integer_literal] = ACTIONS(1366),
    [aux_sym_string_literal_token1] = ACTIONS(1366),
    [sym_char_literal] = ACTIONS(1366),
    [anon_sym_true] = ACTIONS(1368),
    [anon_sym_false] = ACTIONS(1368),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1368),
    [sym_super] = ACTIONS(1368),
    [sym_crate] = ACTIONS(1368),
    [sym_metavariable] = ACTIONS(1366),
    [sym__raw_string_literal_start] = ACTIONS(1366),
    [sym_float_literal] = ACTIONS(1366),
  },
  [475] = {
    [sym_attribute_item] = STATE(1478),
    [sym_inner_attribute_item] = STATE(1478),
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3399),
    [sym_match_pattern] = STATE(3493),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2974),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(475),
    [sym_block_comment] = STATE(475),
    [aux_sym_match_block_repeat1] = STATE(554),
    [aux_sym_match_arm_repeat1] = STATE(757),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [476] = {
    [sym_attribute_item] = STATE(1478),
    [sym_inner_attribute_item] = STATE(1478),
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3456),
    [sym_match_pattern] = STATE(3493),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2974),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(476),
    [sym_block_comment] = STATE(476),
    [aux_sym_match_block_repeat1] = STATE(554),
    [aux_sym_match_arm_repeat1] = STATE(757),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [477] = {
    [sym_attribute_item] = STATE(1478),
    [sym_inner_attribute_item] = STATE(1478),
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3362),
    [sym_match_pattern] = STATE(3493),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2974),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(477),
    [sym_block_comment] = STATE(477),
    [aux_sym_match_block_repeat1] = STATE(554),
    [aux_sym_match_arm_repeat1] = STATE(757),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [478] = {
    [sym_attribute_item] = STATE(1478),
    [sym_inner_attribute_item] = STATE(1478),
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_match_arm] = STATE(1476),
    [sym_last_match_arm] = STATE(3422),
    [sym_match_pattern] = STATE(3493),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2974),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(478),
    [sym_block_comment] = STATE(478),
    [aux_sym_match_block_repeat1] = STATE(554),
    [aux_sym_match_arm_repeat1] = STATE(757),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [479] = {
    [sym_line_comment] = STATE(479),
    [sym_block_comment] = STATE(479),
    [ts_builtin_sym_end] = ACTIONS(1662),
    [sym_identifier] = ACTIONS(1664),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_macro_rules_BANG] = ACTIONS(1662),
    [anon_sym_LPAREN] = ACTIONS(1662),
    [anon_sym_LBRACK] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1662),
    [anon_sym_RBRACE] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(1662),
    [anon_sym_u8] = ACTIONS(1664),
    [anon_sym_i8] = ACTIONS(1664),
    [anon_sym_u16] = ACTIONS(1664),
    [anon_sym_i16] = ACTIONS(1664),
    [anon_sym_u32] = ACTIONS(1664),
    [anon_sym_i32] = ACTIONS(1664),
    [anon_sym_u64] = ACTIONS(1664),
    [anon_sym_i64] = ACTIONS(1664),
    [anon_sym_u128] = ACTIONS(1664),
    [anon_sym_i128] = ACTIONS(1664),
    [anon_sym_isize] = ACTIONS(1664),
    [anon_sym_usize] = ACTIONS(1664),
    [anon_sym_f32] = ACTIONS(1664),
    [anon_sym_f64] = ACTIONS(1664),
    [anon_sym_bool] = ACTIONS(1664),
    [anon_sym_str] = ACTIONS(1664),
    [anon_sym_char] = ACTIONS(1664),
    [anon_sym_DASH] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(1662),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_DOT_DOT] = ACTIONS(1662),
    [anon_sym_COLON_COLON] = ACTIONS(1662),
    [anon_sym_POUND] = ACTIONS(1662),
    [anon_sym_SQUOTE] = ACTIONS(1664),
    [anon_sym_async] = ACTIONS(1664),
    [anon_sym_break] = ACTIONS(1664),
    [anon_sym_const] = ACTIONS(1664),
    [anon_sym_continue] = ACTIONS(1664),
    [anon_sym_default] = ACTIONS(1664),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_fn] = ACTIONS(1664),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_if] = ACTIONS(1664),
    [anon_sym_impl] = ACTIONS(1664),
    [anon_sym_let] = ACTIONS(1664),
    [anon_sym_loop] = ACTIONS(1664),
    [anon_sym_match] = ACTIONS(1664),
    [anon_sym_mod] = ACTIONS(1664),
    [anon_sym_pub] = ACTIONS(1664),
    [anon_sym_return] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1664),
    [anon_sym_struct] = ACTIONS(1664),
    [anon_sym_trait] = ACTIONS(1664),
    [anon_sym_type] = ACTIONS(1664),
    [anon_sym_union] = ACTIONS(1664),
    [anon_sym_unsafe] = ACTIONS(1664),
    [anon_sym_use] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1664),
    [anon_sym_extern] = ACTIONS(1664),
    [anon_sym_yield] = ACTIONS(1664),
    [anon_sym_move] = ACTIONS(1664),
    [anon_sym_try] = ACTIONS(1664),
    [sym_integer_literal] = ACTIONS(1662),
    [aux_sym_string_literal_token1] = ACTIONS(1662),
    [sym_char_literal] = ACTIONS(1662),
    [anon_sym_true] = ACTIONS(1664),
    [anon_sym_false] = ACTIONS(1664),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1664),
    [sym_super] = ACTIONS(1664),
    [sym_crate] = ACTIONS(1664),
    [sym_metavariable] = ACTIONS(1662),
    [sym__raw_string_literal_start] = ACTIONS(1662),
    [sym_float_literal] = ACTIONS(1662),
  },
  [480] = {
    [sym_line_comment] = STATE(480),
    [sym_block_comment] = STATE(480),
    [ts_builtin_sym_end] = ACTIONS(1666),
    [sym_identifier] = ACTIONS(1668),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_macro_rules_BANG] = ACTIONS(1666),
    [anon_sym_LPAREN] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [anon_sym_LBRACE] = ACTIONS(1666),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_STAR] = ACTIONS(1666),
    [anon_sym_u8] = ACTIONS(1668),
    [anon_sym_i8] = ACTIONS(1668),
    [anon_sym_u16] = ACTIONS(1668),
    [anon_sym_i16] = ACTIONS(1668),
    [anon_sym_u32] = ACTIONS(1668),
    [anon_sym_i32] = ACTIONS(1668),
    [anon_sym_u64] = ACTIONS(1668),
    [anon_sym_i64] = ACTIONS(1668),
    [anon_sym_u128] = ACTIONS(1668),
    [anon_sym_i128] = ACTIONS(1668),
    [anon_sym_isize] = ACTIONS(1668),
    [anon_sym_usize] = ACTIONS(1668),
    [anon_sym_f32] = ACTIONS(1668),
    [anon_sym_f64] = ACTIONS(1668),
    [anon_sym_bool] = ACTIONS(1668),
    [anon_sym_str] = ACTIONS(1668),
    [anon_sym_char] = ACTIONS(1668),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_AMP] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_DOT_DOT] = ACTIONS(1666),
    [anon_sym_COLON_COLON] = ACTIONS(1666),
    [anon_sym_POUND] = ACTIONS(1666),
    [anon_sym_SQUOTE] = ACTIONS(1668),
    [anon_sym_async] = ACTIONS(1668),
    [anon_sym_break] = ACTIONS(1668),
    [anon_sym_const] = ACTIONS(1668),
    [anon_sym_continue] = ACTIONS(1668),
    [anon_sym_default] = ACTIONS(1668),
    [anon_sym_enum] = ACTIONS(1668),
    [anon_sym_fn] = ACTIONS(1668),
    [anon_sym_for] = ACTIONS(1668),
    [anon_sym_if] = ACTIONS(1668),
    [anon_sym_impl] = ACTIONS(1668),
    [anon_sym_let] = ACTIONS(1668),
    [anon_sym_loop] = ACTIONS(1668),
    [anon_sym_match] = ACTIONS(1668),
    [anon_sym_mod] = ACTIONS(1668),
    [anon_sym_pub] = ACTIONS(1668),
    [anon_sym_return] = ACTIONS(1668),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_struct] = ACTIONS(1668),
    [anon_sym_trait] = ACTIONS(1668),
    [anon_sym_type] = ACTIONS(1668),
    [anon_sym_union] = ACTIONS(1668),
    [anon_sym_unsafe] = ACTIONS(1668),
    [anon_sym_use] = ACTIONS(1668),
    [anon_sym_while] = ACTIONS(1668),
    [anon_sym_extern] = ACTIONS(1668),
    [anon_sym_yield] = ACTIONS(1668),
    [anon_sym_move] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1668),
    [sym_integer_literal] = ACTIONS(1666),
    [aux_sym_string_literal_token1] = ACTIONS(1666),
    [sym_char_literal] = ACTIONS(1666),
    [anon_sym_true] = ACTIONS(1668),
    [anon_sym_false] = ACTIONS(1668),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1668),
    [sym_super] = ACTIONS(1668),
    [sym_crate] = ACTIONS(1668),
    [sym_metavariable] = ACTIONS(1666),
    [sym__raw_string_literal_start] = ACTIONS(1666),
    [sym_float_literal] = ACTIONS(1666),
  },
  [481] = {
    [sym_line_comment] = STATE(481),
    [sym_block_comment] = STATE(481),
    [ts_builtin_sym_end] = ACTIONS(1670),
    [sym_identifier] = ACTIONS(1672),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym_macro_rules_BANG] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_RBRACE] = ACTIONS(1670),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_u8] = ACTIONS(1672),
    [anon_sym_i8] = ACTIONS(1672),
    [anon_sym_u16] = ACTIONS(1672),
    [anon_sym_i16] = ACTIONS(1672),
    [anon_sym_u32] = ACTIONS(1672),
    [anon_sym_i32] = ACTIONS(1672),
    [anon_sym_u64] = ACTIONS(1672),
    [anon_sym_i64] = ACTIONS(1672),
    [anon_sym_u128] = ACTIONS(1672),
    [anon_sym_i128] = ACTIONS(1672),
    [anon_sym_isize] = ACTIONS(1672),
    [anon_sym_usize] = ACTIONS(1672),
    [anon_sym_f32] = ACTIONS(1672),
    [anon_sym_f64] = ACTIONS(1672),
    [anon_sym_bool] = ACTIONS(1672),
    [anon_sym_str] = ACTIONS(1672),
    [anon_sym_char] = ACTIONS(1672),
    [anon_sym_DASH] = ACTIONS(1670),
    [anon_sym_BANG] = ACTIONS(1670),
    [anon_sym_AMP] = ACTIONS(1670),
    [anon_sym_PIPE] = ACTIONS(1670),
    [anon_sym_LT] = ACTIONS(1670),
    [anon_sym_DOT_DOT] = ACTIONS(1670),
    [anon_sym_COLON_COLON] = ACTIONS(1670),
    [anon_sym_POUND] = ACTIONS(1670),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [anon_sym_async] = ACTIONS(1672),
    [anon_sym_break] = ACTIONS(1672),
    [anon_sym_const] = ACTIONS(1672),
    [anon_sym_continue] = ACTIONS(1672),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_enum] = ACTIONS(1672),
    [anon_sym_fn] = ACTIONS(1672),
    [anon_sym_for] = ACTIONS(1672),
    [anon_sym_if] = ACTIONS(1672),
    [anon_sym_impl] = ACTIONS(1672),
    [anon_sym_let] = ACTIONS(1672),
    [anon_sym_loop] = ACTIONS(1672),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_mod] = ACTIONS(1672),
    [anon_sym_pub] = ACTIONS(1672),
    [anon_sym_return] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1672),
    [anon_sym_struct] = ACTIONS(1672),
    [anon_sym_trait] = ACTIONS(1672),
    [anon_sym_type] = ACTIONS(1672),
    [anon_sym_union] = ACTIONS(1672),
    [anon_sym_unsafe] = ACTIONS(1672),
    [anon_sym_use] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1672),
    [anon_sym_extern] = ACTIONS(1672),
    [anon_sym_yield] = ACTIONS(1672),
    [anon_sym_move] = ACTIONS(1672),
    [anon_sym_try] = ACTIONS(1672),
    [sym_integer_literal] = ACTIONS(1670),
    [aux_sym_string_literal_token1] = ACTIONS(1670),
    [sym_char_literal] = ACTIONS(1670),
    [anon_sym_true] = ACTIONS(1672),
    [anon_sym_false] = ACTIONS(1672),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1672),
    [sym_super] = ACTIONS(1672),
    [sym_crate] = ACTIONS(1672),
    [sym_metavariable] = ACTIONS(1670),
    [sym__raw_string_literal_start] = ACTIONS(1670),
    [sym_float_literal] = ACTIONS(1670),
  },
  [482] = {
    [sym_line_comment] = STATE(482),
    [sym_block_comment] = STATE(482),
    [ts_builtin_sym_end] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1676),
    [anon_sym_SEMI] = ACTIONS(1674),
    [anon_sym_macro_rules_BANG] = ACTIONS(1674),
    [anon_sym_LPAREN] = ACTIONS(1674),
    [anon_sym_LBRACK] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1674),
    [anon_sym_RBRACE] = ACTIONS(1674),
    [anon_sym_STAR] = ACTIONS(1674),
    [anon_sym_u8] = ACTIONS(1676),
    [anon_sym_i8] = ACTIONS(1676),
    [anon_sym_u16] = ACTIONS(1676),
    [anon_sym_i16] = ACTIONS(1676),
    [anon_sym_u32] = ACTIONS(1676),
    [anon_sym_i32] = ACTIONS(1676),
    [anon_sym_u64] = ACTIONS(1676),
    [anon_sym_i64] = ACTIONS(1676),
    [anon_sym_u128] = ACTIONS(1676),
    [anon_sym_i128] = ACTIONS(1676),
    [anon_sym_isize] = ACTIONS(1676),
    [anon_sym_usize] = ACTIONS(1676),
    [anon_sym_f32] = ACTIONS(1676),
    [anon_sym_f64] = ACTIONS(1676),
    [anon_sym_bool] = ACTIONS(1676),
    [anon_sym_str] = ACTIONS(1676),
    [anon_sym_char] = ACTIONS(1676),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_BANG] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1674),
    [anon_sym_PIPE] = ACTIONS(1674),
    [anon_sym_LT] = ACTIONS(1674),
    [anon_sym_DOT_DOT] = ACTIONS(1674),
    [anon_sym_COLON_COLON] = ACTIONS(1674),
    [anon_sym_POUND] = ACTIONS(1674),
    [anon_sym_SQUOTE] = ACTIONS(1676),
    [anon_sym_async] = ACTIONS(1676),
    [anon_sym_break] = ACTIONS(1676),
    [anon_sym_const] = ACTIONS(1676),
    [anon_sym_continue] = ACTIONS(1676),
    [anon_sym_default] = ACTIONS(1676),
    [anon_sym_enum] = ACTIONS(1676),
    [anon_sym_fn] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1676),
    [anon_sym_if] = ACTIONS(1676),
    [anon_sym_impl] = ACTIONS(1676),
    [anon_sym_let] = ACTIONS(1676),
    [anon_sym_loop] = ACTIONS(1676),
    [anon_sym_match] = ACTIONS(1676),
    [anon_sym_mod] = ACTIONS(1676),
    [anon_sym_pub] = ACTIONS(1676),
    [anon_sym_return] = ACTIONS(1676),
    [anon_sym_static] = ACTIONS(1676),
    [anon_sym_struct] = ACTIONS(1676),
    [anon_sym_trait] = ACTIONS(1676),
    [anon_sym_type] = ACTIONS(1676),
    [anon_sym_union] = ACTIONS(1676),
    [anon_sym_unsafe] = ACTIONS(1676),
    [anon_sym_use] = ACTIONS(1676),
    [anon_sym_while] = ACTIONS(1676),
    [anon_sym_extern] = ACTIONS(1676),
    [anon_sym_yield] = ACTIONS(1676),
    [anon_sym_move] = ACTIONS(1676),
    [anon_sym_try] = ACTIONS(1676),
    [sym_integer_literal] = ACTIONS(1674),
    [aux_sym_string_literal_token1] = ACTIONS(1674),
    [sym_char_literal] = ACTIONS(1674),
    [anon_sym_true] = ACTIONS(1676),
    [anon_sym_false] = ACTIONS(1676),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1676),
    [sym_super] = ACTIONS(1676),
    [sym_crate] = ACTIONS(1676),
    [sym_metavariable] = ACTIONS(1674),
    [sym__raw_string_literal_start] = ACTIONS(1674),
    [sym_float_literal] = ACTIONS(1674),
  },
  [483] = {
    [sym_line_comment] = STATE(483),
    [sym_block_comment] = STATE(483),
    [ts_builtin_sym_end] = ACTIONS(1678),
    [sym_identifier] = ACTIONS(1680),
    [anon_sym_SEMI] = ACTIONS(1678),
    [anon_sym_macro_rules_BANG] = ACTIONS(1678),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [anon_sym_LBRACK] = ACTIONS(1678),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_RBRACE] = ACTIONS(1678),
    [anon_sym_STAR] = ACTIONS(1678),
    [anon_sym_u8] = ACTIONS(1680),
    [anon_sym_i8] = ACTIONS(1680),
    [anon_sym_u16] = ACTIONS(1680),
    [anon_sym_i16] = ACTIONS(1680),
    [anon_sym_u32] = ACTIONS(1680),
    [anon_sym_i32] = ACTIONS(1680),
    [anon_sym_u64] = ACTIONS(1680),
    [anon_sym_i64] = ACTIONS(1680),
    [anon_sym_u128] = ACTIONS(1680),
    [anon_sym_i128] = ACTIONS(1680),
    [anon_sym_isize] = ACTIONS(1680),
    [anon_sym_usize] = ACTIONS(1680),
    [anon_sym_f32] = ACTIONS(1680),
    [anon_sym_f64] = ACTIONS(1680),
    [anon_sym_bool] = ACTIONS(1680),
    [anon_sym_str] = ACTIONS(1680),
    [anon_sym_char] = ACTIONS(1680),
    [anon_sym_DASH] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1678),
    [anon_sym_AMP] = ACTIONS(1678),
    [anon_sym_PIPE] = ACTIONS(1678),
    [anon_sym_LT] = ACTIONS(1678),
    [anon_sym_DOT_DOT] = ACTIONS(1678),
    [anon_sym_COLON_COLON] = ACTIONS(1678),
    [anon_sym_POUND] = ACTIONS(1678),
    [anon_sym_SQUOTE] = ACTIONS(1680),
    [anon_sym_async] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1680),
    [anon_sym_const] = ACTIONS(1680),
    [anon_sym_continue] = ACTIONS(1680),
    [anon_sym_default] = ACTIONS(1680),
    [anon_sym_enum] = ACTIONS(1680),
    [anon_sym_fn] = ACTIONS(1680),
    [anon_sym_for] = ACTIONS(1680),
    [anon_sym_if] = ACTIONS(1680),
    [anon_sym_impl] = ACTIONS(1680),
    [anon_sym_let] = ACTIONS(1680),
    [anon_sym_loop] = ACTIONS(1680),
    [anon_sym_match] = ACTIONS(1680),
    [anon_sym_mod] = ACTIONS(1680),
    [anon_sym_pub] = ACTIONS(1680),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_struct] = ACTIONS(1680),
    [anon_sym_trait] = ACTIONS(1680),
    [anon_sym_type] = ACTIONS(1680),
    [anon_sym_union] = ACTIONS(1680),
    [anon_sym_unsafe] = ACTIONS(1680),
    [anon_sym_use] = ACTIONS(1680),
    [anon_sym_while] = ACTIONS(1680),
    [anon_sym_extern] = ACTIONS(1680),
    [anon_sym_yield] = ACTIONS(1680),
    [anon_sym_move] = ACTIONS(1680),
    [anon_sym_try] = ACTIONS(1680),
    [sym_integer_literal] = ACTIONS(1678),
    [aux_sym_string_literal_token1] = ACTIONS(1678),
    [sym_char_literal] = ACTIONS(1678),
    [anon_sym_true] = ACTIONS(1680),
    [anon_sym_false] = ACTIONS(1680),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1680),
    [sym_super] = ACTIONS(1680),
    [sym_crate] = ACTIONS(1680),
    [sym_metavariable] = ACTIONS(1678),
    [sym__raw_string_literal_start] = ACTIONS(1678),
    [sym_float_literal] = ACTIONS(1678),
  },
  [484] = {
    [sym_line_comment] = STATE(484),
    [sym_block_comment] = STATE(484),
    [ts_builtin_sym_end] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym_macro_rules_BANG] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1682),
    [anon_sym_RBRACE] = ACTIONS(1682),
    [anon_sym_STAR] = ACTIONS(1682),
    [anon_sym_u8] = ACTIONS(1684),
    [anon_sym_i8] = ACTIONS(1684),
    [anon_sym_u16] = ACTIONS(1684),
    [anon_sym_i16] = ACTIONS(1684),
    [anon_sym_u32] = ACTIONS(1684),
    [anon_sym_i32] = ACTIONS(1684),
    [anon_sym_u64] = ACTIONS(1684),
    [anon_sym_i64] = ACTIONS(1684),
    [anon_sym_u128] = ACTIONS(1684),
    [anon_sym_i128] = ACTIONS(1684),
    [anon_sym_isize] = ACTIONS(1684),
    [anon_sym_usize] = ACTIONS(1684),
    [anon_sym_f32] = ACTIONS(1684),
    [anon_sym_f64] = ACTIONS(1684),
    [anon_sym_bool] = ACTIONS(1684),
    [anon_sym_str] = ACTIONS(1684),
    [anon_sym_char] = ACTIONS(1684),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_BANG] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_DOT_DOT] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1682),
    [anon_sym_POUND] = ACTIONS(1682),
    [anon_sym_SQUOTE] = ACTIONS(1684),
    [anon_sym_async] = ACTIONS(1684),
    [anon_sym_break] = ACTIONS(1684),
    [anon_sym_const] = ACTIONS(1684),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_default] = ACTIONS(1684),
    [anon_sym_enum] = ACTIONS(1684),
    [anon_sym_fn] = ACTIONS(1684),
    [anon_sym_for] = ACTIONS(1684),
    [anon_sym_if] = ACTIONS(1684),
    [anon_sym_impl] = ACTIONS(1684),
    [anon_sym_let] = ACTIONS(1684),
    [anon_sym_loop] = ACTIONS(1684),
    [anon_sym_match] = ACTIONS(1684),
    [anon_sym_mod] = ACTIONS(1684),
    [anon_sym_pub] = ACTIONS(1684),
    [anon_sym_return] = ACTIONS(1684),
    [anon_sym_static] = ACTIONS(1684),
    [anon_sym_struct] = ACTIONS(1684),
    [anon_sym_trait] = ACTIONS(1684),
    [anon_sym_type] = ACTIONS(1684),
    [anon_sym_union] = ACTIONS(1684),
    [anon_sym_unsafe] = ACTIONS(1684),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_while] = ACTIONS(1684),
    [anon_sym_extern] = ACTIONS(1684),
    [anon_sym_yield] = ACTIONS(1684),
    [anon_sym_move] = ACTIONS(1684),
    [anon_sym_try] = ACTIONS(1684),
    [sym_integer_literal] = ACTIONS(1682),
    [aux_sym_string_literal_token1] = ACTIONS(1682),
    [sym_char_literal] = ACTIONS(1682),
    [anon_sym_true] = ACTIONS(1684),
    [anon_sym_false] = ACTIONS(1684),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1684),
    [sym_super] = ACTIONS(1684),
    [sym_crate] = ACTIONS(1684),
    [sym_metavariable] = ACTIONS(1682),
    [sym__raw_string_literal_start] = ACTIONS(1682),
    [sym_float_literal] = ACTIONS(1682),
  },
  [485] = {
    [sym_line_comment] = STATE(485),
    [sym_block_comment] = STATE(485),
    [ts_builtin_sym_end] = ACTIONS(1686),
    [sym_identifier] = ACTIONS(1688),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym_macro_rules_BANG] = ACTIONS(1686),
    [anon_sym_LPAREN] = ACTIONS(1686),
    [anon_sym_LBRACK] = ACTIONS(1686),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [anon_sym_RBRACE] = ACTIONS(1686),
    [anon_sym_STAR] = ACTIONS(1686),
    [anon_sym_u8] = ACTIONS(1688),
    [anon_sym_i8] = ACTIONS(1688),
    [anon_sym_u16] = ACTIONS(1688),
    [anon_sym_i16] = ACTIONS(1688),
    [anon_sym_u32] = ACTIONS(1688),
    [anon_sym_i32] = ACTIONS(1688),
    [anon_sym_u64] = ACTIONS(1688),
    [anon_sym_i64] = ACTIONS(1688),
    [anon_sym_u128] = ACTIONS(1688),
    [anon_sym_i128] = ACTIONS(1688),
    [anon_sym_isize] = ACTIONS(1688),
    [anon_sym_usize] = ACTIONS(1688),
    [anon_sym_f32] = ACTIONS(1688),
    [anon_sym_f64] = ACTIONS(1688),
    [anon_sym_bool] = ACTIONS(1688),
    [anon_sym_str] = ACTIONS(1688),
    [anon_sym_char] = ACTIONS(1688),
    [anon_sym_DASH] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(1686),
    [anon_sym_PIPE] = ACTIONS(1686),
    [anon_sym_LT] = ACTIONS(1686),
    [anon_sym_DOT_DOT] = ACTIONS(1686),
    [anon_sym_COLON_COLON] = ACTIONS(1686),
    [anon_sym_POUND] = ACTIONS(1686),
    [anon_sym_SQUOTE] = ACTIONS(1688),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_break] = ACTIONS(1688),
    [anon_sym_const] = ACTIONS(1688),
    [anon_sym_continue] = ACTIONS(1688),
    [anon_sym_default] = ACTIONS(1688),
    [anon_sym_enum] = ACTIONS(1688),
    [anon_sym_fn] = ACTIONS(1688),
    [anon_sym_for] = ACTIONS(1688),
    [anon_sym_if] = ACTIONS(1688),
    [anon_sym_impl] = ACTIONS(1688),
    [anon_sym_let] = ACTIONS(1688),
    [anon_sym_loop] = ACTIONS(1688),
    [anon_sym_match] = ACTIONS(1688),
    [anon_sym_mod] = ACTIONS(1688),
    [anon_sym_pub] = ACTIONS(1688),
    [anon_sym_return] = ACTIONS(1688),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_struct] = ACTIONS(1688),
    [anon_sym_trait] = ACTIONS(1688),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_union] = ACTIONS(1688),
    [anon_sym_unsafe] = ACTIONS(1688),
    [anon_sym_use] = ACTIONS(1688),
    [anon_sym_while] = ACTIONS(1688),
    [anon_sym_extern] = ACTIONS(1688),
    [anon_sym_yield] = ACTIONS(1688),
    [anon_sym_move] = ACTIONS(1688),
    [anon_sym_try] = ACTIONS(1688),
    [sym_integer_literal] = ACTIONS(1686),
    [aux_sym_string_literal_token1] = ACTIONS(1686),
    [sym_char_literal] = ACTIONS(1686),
    [anon_sym_true] = ACTIONS(1688),
    [anon_sym_false] = ACTIONS(1688),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1688),
    [sym_super] = ACTIONS(1688),
    [sym_crate] = ACTIONS(1688),
    [sym_metavariable] = ACTIONS(1686),
    [sym__raw_string_literal_start] = ACTIONS(1686),
    [sym_float_literal] = ACTIONS(1686),
  },
  [486] = {
    [sym_line_comment] = STATE(486),
    [sym_block_comment] = STATE(486),
    [ts_builtin_sym_end] = ACTIONS(1690),
    [sym_identifier] = ACTIONS(1692),
    [anon_sym_SEMI] = ACTIONS(1690),
    [anon_sym_macro_rules_BANG] = ACTIONS(1690),
    [anon_sym_LPAREN] = ACTIONS(1690),
    [anon_sym_LBRACK] = ACTIONS(1690),
    [anon_sym_LBRACE] = ACTIONS(1690),
    [anon_sym_RBRACE] = ACTIONS(1690),
    [anon_sym_STAR] = ACTIONS(1690),
    [anon_sym_u8] = ACTIONS(1692),
    [anon_sym_i8] = ACTIONS(1692),
    [anon_sym_u16] = ACTIONS(1692),
    [anon_sym_i16] = ACTIONS(1692),
    [anon_sym_u32] = ACTIONS(1692),
    [anon_sym_i32] = ACTIONS(1692),
    [anon_sym_u64] = ACTIONS(1692),
    [anon_sym_i64] = ACTIONS(1692),
    [anon_sym_u128] = ACTIONS(1692),
    [anon_sym_i128] = ACTIONS(1692),
    [anon_sym_isize] = ACTIONS(1692),
    [anon_sym_usize] = ACTIONS(1692),
    [anon_sym_f32] = ACTIONS(1692),
    [anon_sym_f64] = ACTIONS(1692),
    [anon_sym_bool] = ACTIONS(1692),
    [anon_sym_str] = ACTIONS(1692),
    [anon_sym_char] = ACTIONS(1692),
    [anon_sym_DASH] = ACTIONS(1690),
    [anon_sym_BANG] = ACTIONS(1690),
    [anon_sym_AMP] = ACTIONS(1690),
    [anon_sym_PIPE] = ACTIONS(1690),
    [anon_sym_LT] = ACTIONS(1690),
    [anon_sym_DOT_DOT] = ACTIONS(1690),
    [anon_sym_COLON_COLON] = ACTIONS(1690),
    [anon_sym_POUND] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1692),
    [anon_sym_async] = ACTIONS(1692),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1692),
    [anon_sym_continue] = ACTIONS(1692),
    [anon_sym_default] = ACTIONS(1692),
    [anon_sym_enum] = ACTIONS(1692),
    [anon_sym_fn] = ACTIONS(1692),
    [anon_sym_for] = ACTIONS(1692),
    [anon_sym_if] = ACTIONS(1692),
    [anon_sym_impl] = ACTIONS(1692),
    [anon_sym_let] = ACTIONS(1692),
    [anon_sym_loop] = ACTIONS(1692),
    [anon_sym_match] = ACTIONS(1692),
    [anon_sym_mod] = ACTIONS(1692),
    [anon_sym_pub] = ACTIONS(1692),
    [anon_sym_return] = ACTIONS(1692),
    [anon_sym_static] = ACTIONS(1692),
    [anon_sym_struct] = ACTIONS(1692),
    [anon_sym_trait] = ACTIONS(1692),
    [anon_sym_type] = ACTIONS(1692),
    [anon_sym_union] = ACTIONS(1692),
    [anon_sym_unsafe] = ACTIONS(1692),
    [anon_sym_use] = ACTIONS(1692),
    [anon_sym_while] = ACTIONS(1692),
    [anon_sym_extern] = ACTIONS(1692),
    [anon_sym_yield] = ACTIONS(1692),
    [anon_sym_move] = ACTIONS(1692),
    [anon_sym_try] = ACTIONS(1692),
    [sym_integer_literal] = ACTIONS(1690),
    [aux_sym_string_literal_token1] = ACTIONS(1690),
    [sym_char_literal] = ACTIONS(1690),
    [anon_sym_true] = ACTIONS(1692),
    [anon_sym_false] = ACTIONS(1692),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1692),
    [sym_super] = ACTIONS(1692),
    [sym_crate] = ACTIONS(1692),
    [sym_metavariable] = ACTIONS(1690),
    [sym__raw_string_literal_start] = ACTIONS(1690),
    [sym_float_literal] = ACTIONS(1690),
  },
  [487] = {
    [sym_line_comment] = STATE(487),
    [sym_block_comment] = STATE(487),
    [ts_builtin_sym_end] = ACTIONS(1694),
    [sym_identifier] = ACTIONS(1696),
    [anon_sym_SEMI] = ACTIONS(1694),
    [anon_sym_macro_rules_BANG] = ACTIONS(1694),
    [anon_sym_LPAREN] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1694),
    [anon_sym_LBRACE] = ACTIONS(1694),
    [anon_sym_RBRACE] = ACTIONS(1694),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_u8] = ACTIONS(1696),
    [anon_sym_i8] = ACTIONS(1696),
    [anon_sym_u16] = ACTIONS(1696),
    [anon_sym_i16] = ACTIONS(1696),
    [anon_sym_u32] = ACTIONS(1696),
    [anon_sym_i32] = ACTIONS(1696),
    [anon_sym_u64] = ACTIONS(1696),
    [anon_sym_i64] = ACTIONS(1696),
    [anon_sym_u128] = ACTIONS(1696),
    [anon_sym_i128] = ACTIONS(1696),
    [anon_sym_isize] = ACTIONS(1696),
    [anon_sym_usize] = ACTIONS(1696),
    [anon_sym_f32] = ACTIONS(1696),
    [anon_sym_f64] = ACTIONS(1696),
    [anon_sym_bool] = ACTIONS(1696),
    [anon_sym_str] = ACTIONS(1696),
    [anon_sym_char] = ACTIONS(1696),
    [anon_sym_DASH] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1694),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_PIPE] = ACTIONS(1694),
    [anon_sym_LT] = ACTIONS(1694),
    [anon_sym_DOT_DOT] = ACTIONS(1694),
    [anon_sym_COLON_COLON] = ACTIONS(1694),
    [anon_sym_POUND] = ACTIONS(1694),
    [anon_sym_SQUOTE] = ACTIONS(1696),
    [anon_sym_async] = ACTIONS(1696),
    [anon_sym_break] = ACTIONS(1696),
    [anon_sym_const] = ACTIONS(1696),
    [anon_sym_continue] = ACTIONS(1696),
    [anon_sym_default] = ACTIONS(1696),
    [anon_sym_enum] = ACTIONS(1696),
    [anon_sym_fn] = ACTIONS(1696),
    [anon_sym_for] = ACTIONS(1696),
    [anon_sym_if] = ACTIONS(1696),
    [anon_sym_impl] = ACTIONS(1696),
    [anon_sym_let] = ACTIONS(1696),
    [anon_sym_loop] = ACTIONS(1696),
    [anon_sym_match] = ACTIONS(1696),
    [anon_sym_mod] = ACTIONS(1696),
    [anon_sym_pub] = ACTIONS(1696),
    [anon_sym_return] = ACTIONS(1696),
    [anon_sym_static] = ACTIONS(1696),
    [anon_sym_struct] = ACTIONS(1696),
    [anon_sym_trait] = ACTIONS(1696),
    [anon_sym_type] = ACTIONS(1696),
    [anon_sym_union] = ACTIONS(1696),
    [anon_sym_unsafe] = ACTIONS(1696),
    [anon_sym_use] = ACTIONS(1696),
    [anon_sym_while] = ACTIONS(1696),
    [anon_sym_extern] = ACTIONS(1696),
    [anon_sym_yield] = ACTIONS(1696),
    [anon_sym_move] = ACTIONS(1696),
    [anon_sym_try] = ACTIONS(1696),
    [sym_integer_literal] = ACTIONS(1694),
    [aux_sym_string_literal_token1] = ACTIONS(1694),
    [sym_char_literal] = ACTIONS(1694),
    [anon_sym_true] = ACTIONS(1696),
    [anon_sym_false] = ACTIONS(1696),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1696),
    [sym_super] = ACTIONS(1696),
    [sym_crate] = ACTIONS(1696),
    [sym_metavariable] = ACTIONS(1694),
    [sym__raw_string_literal_start] = ACTIONS(1694),
    [sym_float_literal] = ACTIONS(1694),
  },
  [488] = {
    [sym_line_comment] = STATE(488),
    [sym_block_comment] = STATE(488),
    [ts_builtin_sym_end] = ACTIONS(1698),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym_macro_rules_BANG] = ACTIONS(1698),
    [anon_sym_LPAREN] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1698),
    [anon_sym_LBRACE] = ACTIONS(1698),
    [anon_sym_RBRACE] = ACTIONS(1698),
    [anon_sym_STAR] = ACTIONS(1698),
    [anon_sym_u8] = ACTIONS(1700),
    [anon_sym_i8] = ACTIONS(1700),
    [anon_sym_u16] = ACTIONS(1700),
    [anon_sym_i16] = ACTIONS(1700),
    [anon_sym_u32] = ACTIONS(1700),
    [anon_sym_i32] = ACTIONS(1700),
    [anon_sym_u64] = ACTIONS(1700),
    [anon_sym_i64] = ACTIONS(1700),
    [anon_sym_u128] = ACTIONS(1700),
    [anon_sym_i128] = ACTIONS(1700),
    [anon_sym_isize] = ACTIONS(1700),
    [anon_sym_usize] = ACTIONS(1700),
    [anon_sym_f32] = ACTIONS(1700),
    [anon_sym_f64] = ACTIONS(1700),
    [anon_sym_bool] = ACTIONS(1700),
    [anon_sym_str] = ACTIONS(1700),
    [anon_sym_char] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1698),
    [anon_sym_BANG] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1698),
    [anon_sym_PIPE] = ACTIONS(1698),
    [anon_sym_LT] = ACTIONS(1698),
    [anon_sym_DOT_DOT] = ACTIONS(1698),
    [anon_sym_COLON_COLON] = ACTIONS(1698),
    [anon_sym_POUND] = ACTIONS(1698),
    [anon_sym_SQUOTE] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1700),
    [anon_sym_break] = ACTIONS(1700),
    [anon_sym_const] = ACTIONS(1700),
    [anon_sym_continue] = ACTIONS(1700),
    [anon_sym_default] = ACTIONS(1700),
    [anon_sym_enum] = ACTIONS(1700),
    [anon_sym_fn] = ACTIONS(1700),
    [anon_sym_for] = ACTIONS(1700),
    [anon_sym_if] = ACTIONS(1700),
    [anon_sym_impl] = ACTIONS(1700),
    [anon_sym_let] = ACTIONS(1700),
    [anon_sym_loop] = ACTIONS(1700),
    [anon_sym_match] = ACTIONS(1700),
    [anon_sym_mod] = ACTIONS(1700),
    [anon_sym_pub] = ACTIONS(1700),
    [anon_sym_return] = ACTIONS(1700),
    [anon_sym_static] = ACTIONS(1700),
    [anon_sym_struct] = ACTIONS(1700),
    [anon_sym_trait] = ACTIONS(1700),
    [anon_sym_type] = ACTIONS(1700),
    [anon_sym_union] = ACTIONS(1700),
    [anon_sym_unsafe] = ACTIONS(1700),
    [anon_sym_use] = ACTIONS(1700),
    [anon_sym_while] = ACTIONS(1700),
    [anon_sym_extern] = ACTIONS(1700),
    [anon_sym_yield] = ACTIONS(1700),
    [anon_sym_move] = ACTIONS(1700),
    [anon_sym_try] = ACTIONS(1700),
    [sym_integer_literal] = ACTIONS(1698),
    [aux_sym_string_literal_token1] = ACTIONS(1698),
    [sym_char_literal] = ACTIONS(1698),
    [anon_sym_true] = ACTIONS(1700),
    [anon_sym_false] = ACTIONS(1700),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1700),
    [sym_super] = ACTIONS(1700),
    [sym_crate] = ACTIONS(1700),
    [sym_metavariable] = ACTIONS(1698),
    [sym__raw_string_literal_start] = ACTIONS(1698),
    [sym_float_literal] = ACTIONS(1698),
  },
  [489] = {
    [sym_line_comment] = STATE(489),
    [sym_block_comment] = STATE(489),
    [ts_builtin_sym_end] = ACTIONS(1702),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_SEMI] = ACTIONS(1702),
    [anon_sym_macro_rules_BANG] = ACTIONS(1702),
    [anon_sym_LPAREN] = ACTIONS(1702),
    [anon_sym_LBRACK] = ACTIONS(1702),
    [anon_sym_LBRACE] = ACTIONS(1702),
    [anon_sym_RBRACE] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(1702),
    [anon_sym_u8] = ACTIONS(1704),
    [anon_sym_i8] = ACTIONS(1704),
    [anon_sym_u16] = ACTIONS(1704),
    [anon_sym_i16] = ACTIONS(1704),
    [anon_sym_u32] = ACTIONS(1704),
    [anon_sym_i32] = ACTIONS(1704),
    [anon_sym_u64] = ACTIONS(1704),
    [anon_sym_i64] = ACTIONS(1704),
    [anon_sym_u128] = ACTIONS(1704),
    [anon_sym_i128] = ACTIONS(1704),
    [anon_sym_isize] = ACTIONS(1704),
    [anon_sym_usize] = ACTIONS(1704),
    [anon_sym_f32] = ACTIONS(1704),
    [anon_sym_f64] = ACTIONS(1704),
    [anon_sym_bool] = ACTIONS(1704),
    [anon_sym_str] = ACTIONS(1704),
    [anon_sym_char] = ACTIONS(1704),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_BANG] = ACTIONS(1702),
    [anon_sym_AMP] = ACTIONS(1702),
    [anon_sym_PIPE] = ACTIONS(1702),
    [anon_sym_LT] = ACTIONS(1702),
    [anon_sym_DOT_DOT] = ACTIONS(1702),
    [anon_sym_COLON_COLON] = ACTIONS(1702),
    [anon_sym_POUND] = ACTIONS(1702),
    [anon_sym_SQUOTE] = ACTIONS(1704),
    [anon_sym_async] = ACTIONS(1704),
    [anon_sym_break] = ACTIONS(1704),
    [anon_sym_const] = ACTIONS(1704),
    [anon_sym_continue] = ACTIONS(1704),
    [anon_sym_default] = ACTIONS(1704),
    [anon_sym_enum] = ACTIONS(1704),
    [anon_sym_fn] = ACTIONS(1704),
    [anon_sym_for] = ACTIONS(1704),
    [anon_sym_if] = ACTIONS(1704),
    [anon_sym_impl] = ACTIONS(1704),
    [anon_sym_let] = ACTIONS(1704),
    [anon_sym_loop] = ACTIONS(1704),
    [anon_sym_match] = ACTIONS(1704),
    [anon_sym_mod] = ACTIONS(1704),
    [anon_sym_pub] = ACTIONS(1704),
    [anon_sym_return] = ACTIONS(1704),
    [anon_sym_static] = ACTIONS(1704),
    [anon_sym_struct] = ACTIONS(1704),
    [anon_sym_trait] = ACTIONS(1704),
    [anon_sym_type] = ACTIONS(1704),
    [anon_sym_union] = ACTIONS(1704),
    [anon_sym_unsafe] = ACTIONS(1704),
    [anon_sym_use] = ACTIONS(1704),
    [anon_sym_while] = ACTIONS(1704),
    [anon_sym_extern] = ACTIONS(1704),
    [anon_sym_yield] = ACTIONS(1704),
    [anon_sym_move] = ACTIONS(1704),
    [anon_sym_try] = ACTIONS(1704),
    [sym_integer_literal] = ACTIONS(1702),
    [aux_sym_string_literal_token1] = ACTIONS(1702),
    [sym_char_literal] = ACTIONS(1702),
    [anon_sym_true] = ACTIONS(1704),
    [anon_sym_false] = ACTIONS(1704),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1704),
    [sym_super] = ACTIONS(1704),
    [sym_crate] = ACTIONS(1704),
    [sym_metavariable] = ACTIONS(1702),
    [sym__raw_string_literal_start] = ACTIONS(1702),
    [sym_float_literal] = ACTIONS(1702),
  },
  [490] = {
    [sym_line_comment] = STATE(490),
    [sym_block_comment] = STATE(490),
    [ts_builtin_sym_end] = ACTIONS(1706),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_SEMI] = ACTIONS(1706),
    [anon_sym_macro_rules_BANG] = ACTIONS(1706),
    [anon_sym_LPAREN] = ACTIONS(1706),
    [anon_sym_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(1706),
    [anon_sym_RBRACE] = ACTIONS(1706),
    [anon_sym_STAR] = ACTIONS(1706),
    [anon_sym_u8] = ACTIONS(1708),
    [anon_sym_i8] = ACTIONS(1708),
    [anon_sym_u16] = ACTIONS(1708),
    [anon_sym_i16] = ACTIONS(1708),
    [anon_sym_u32] = ACTIONS(1708),
    [anon_sym_i32] = ACTIONS(1708),
    [anon_sym_u64] = ACTIONS(1708),
    [anon_sym_i64] = ACTIONS(1708),
    [anon_sym_u128] = ACTIONS(1708),
    [anon_sym_i128] = ACTIONS(1708),
    [anon_sym_isize] = ACTIONS(1708),
    [anon_sym_usize] = ACTIONS(1708),
    [anon_sym_f32] = ACTIONS(1708),
    [anon_sym_f64] = ACTIONS(1708),
    [anon_sym_bool] = ACTIONS(1708),
    [anon_sym_str] = ACTIONS(1708),
    [anon_sym_char] = ACTIONS(1708),
    [anon_sym_DASH] = ACTIONS(1706),
    [anon_sym_BANG] = ACTIONS(1706),
    [anon_sym_AMP] = ACTIONS(1706),
    [anon_sym_PIPE] = ACTIONS(1706),
    [anon_sym_LT] = ACTIONS(1706),
    [anon_sym_DOT_DOT] = ACTIONS(1706),
    [anon_sym_COLON_COLON] = ACTIONS(1706),
    [anon_sym_POUND] = ACTIONS(1706),
    [anon_sym_SQUOTE] = ACTIONS(1708),
    [anon_sym_async] = ACTIONS(1708),
    [anon_sym_break] = ACTIONS(1708),
    [anon_sym_const] = ACTIONS(1708),
    [anon_sym_continue] = ACTIONS(1708),
    [anon_sym_default] = ACTIONS(1708),
    [anon_sym_enum] = ACTIONS(1708),
    [anon_sym_fn] = ACTIONS(1708),
    [anon_sym_for] = ACTIONS(1708),
    [anon_sym_if] = ACTIONS(1708),
    [anon_sym_impl] = ACTIONS(1708),
    [anon_sym_let] = ACTIONS(1708),
    [anon_sym_loop] = ACTIONS(1708),
    [anon_sym_match] = ACTIONS(1708),
    [anon_sym_mod] = ACTIONS(1708),
    [anon_sym_pub] = ACTIONS(1708),
    [anon_sym_return] = ACTIONS(1708),
    [anon_sym_static] = ACTIONS(1708),
    [anon_sym_struct] = ACTIONS(1708),
    [anon_sym_trait] = ACTIONS(1708),
    [anon_sym_type] = ACTIONS(1708),
    [anon_sym_union] = ACTIONS(1708),
    [anon_sym_unsafe] = ACTIONS(1708),
    [anon_sym_use] = ACTIONS(1708),
    [anon_sym_while] = ACTIONS(1708),
    [anon_sym_extern] = ACTIONS(1708),
    [anon_sym_yield] = ACTIONS(1708),
    [anon_sym_move] = ACTIONS(1708),
    [anon_sym_try] = ACTIONS(1708),
    [sym_integer_literal] = ACTIONS(1706),
    [aux_sym_string_literal_token1] = ACTIONS(1706),
    [sym_char_literal] = ACTIONS(1706),
    [anon_sym_true] = ACTIONS(1708),
    [anon_sym_false] = ACTIONS(1708),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1708),
    [sym_super] = ACTIONS(1708),
    [sym_crate] = ACTIONS(1708),
    [sym_metavariable] = ACTIONS(1706),
    [sym__raw_string_literal_start] = ACTIONS(1706),
    [sym_float_literal] = ACTIONS(1706),
  },
  [491] = {
    [sym_line_comment] = STATE(491),
    [sym_block_comment] = STATE(491),
    [ts_builtin_sym_end] = ACTIONS(1710),
    [sym_identifier] = ACTIONS(1712),
    [anon_sym_SEMI] = ACTIONS(1710),
    [anon_sym_macro_rules_BANG] = ACTIONS(1710),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_LBRACK] = ACTIONS(1710),
    [anon_sym_LBRACE] = ACTIONS(1710),
    [anon_sym_RBRACE] = ACTIONS(1710),
    [anon_sym_STAR] = ACTIONS(1710),
    [anon_sym_u8] = ACTIONS(1712),
    [anon_sym_i8] = ACTIONS(1712),
    [anon_sym_u16] = ACTIONS(1712),
    [anon_sym_i16] = ACTIONS(1712),
    [anon_sym_u32] = ACTIONS(1712),
    [anon_sym_i32] = ACTIONS(1712),
    [anon_sym_u64] = ACTIONS(1712),
    [anon_sym_i64] = ACTIONS(1712),
    [anon_sym_u128] = ACTIONS(1712),
    [anon_sym_i128] = ACTIONS(1712),
    [anon_sym_isize] = ACTIONS(1712),
    [anon_sym_usize] = ACTIONS(1712),
    [anon_sym_f32] = ACTIONS(1712),
    [anon_sym_f64] = ACTIONS(1712),
    [anon_sym_bool] = ACTIONS(1712),
    [anon_sym_str] = ACTIONS(1712),
    [anon_sym_char] = ACTIONS(1712),
    [anon_sym_DASH] = ACTIONS(1710),
    [anon_sym_BANG] = ACTIONS(1710),
    [anon_sym_AMP] = ACTIONS(1710),
    [anon_sym_PIPE] = ACTIONS(1710),
    [anon_sym_LT] = ACTIONS(1710),
    [anon_sym_DOT_DOT] = ACTIONS(1710),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_POUND] = ACTIONS(1710),
    [anon_sym_SQUOTE] = ACTIONS(1712),
    [anon_sym_async] = ACTIONS(1712),
    [anon_sym_break] = ACTIONS(1712),
    [anon_sym_const] = ACTIONS(1712),
    [anon_sym_continue] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1712),
    [anon_sym_enum] = ACTIONS(1712),
    [anon_sym_fn] = ACTIONS(1712),
    [anon_sym_for] = ACTIONS(1712),
    [anon_sym_if] = ACTIONS(1712),
    [anon_sym_impl] = ACTIONS(1712),
    [anon_sym_let] = ACTIONS(1712),
    [anon_sym_loop] = ACTIONS(1712),
    [anon_sym_match] = ACTIONS(1712),
    [anon_sym_mod] = ACTIONS(1712),
    [anon_sym_pub] = ACTIONS(1712),
    [anon_sym_return] = ACTIONS(1712),
    [anon_sym_static] = ACTIONS(1712),
    [anon_sym_struct] = ACTIONS(1712),
    [anon_sym_trait] = ACTIONS(1712),
    [anon_sym_type] = ACTIONS(1712),
    [anon_sym_union] = ACTIONS(1712),
    [anon_sym_unsafe] = ACTIONS(1712),
    [anon_sym_use] = ACTIONS(1712),
    [anon_sym_while] = ACTIONS(1712),
    [anon_sym_extern] = ACTIONS(1712),
    [anon_sym_yield] = ACTIONS(1712),
    [anon_sym_move] = ACTIONS(1712),
    [anon_sym_try] = ACTIONS(1712),
    [sym_integer_literal] = ACTIONS(1710),
    [aux_sym_string_literal_token1] = ACTIONS(1710),
    [sym_char_literal] = ACTIONS(1710),
    [anon_sym_true] = ACTIONS(1712),
    [anon_sym_false] = ACTIONS(1712),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1712),
    [sym_super] = ACTIONS(1712),
    [sym_crate] = ACTIONS(1712),
    [sym_metavariable] = ACTIONS(1710),
    [sym__raw_string_literal_start] = ACTIONS(1710),
    [sym_float_literal] = ACTIONS(1710),
  },
  [492] = {
    [sym_line_comment] = STATE(492),
    [sym_block_comment] = STATE(492),
    [ts_builtin_sym_end] = ACTIONS(1714),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_SEMI] = ACTIONS(1714),
    [anon_sym_macro_rules_BANG] = ACTIONS(1714),
    [anon_sym_LPAREN] = ACTIONS(1714),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LBRACE] = ACTIONS(1714),
    [anon_sym_RBRACE] = ACTIONS(1714),
    [anon_sym_STAR] = ACTIONS(1714),
    [anon_sym_u8] = ACTIONS(1716),
    [anon_sym_i8] = ACTIONS(1716),
    [anon_sym_u16] = ACTIONS(1716),
    [anon_sym_i16] = ACTIONS(1716),
    [anon_sym_u32] = ACTIONS(1716),
    [anon_sym_i32] = ACTIONS(1716),
    [anon_sym_u64] = ACTIONS(1716),
    [anon_sym_i64] = ACTIONS(1716),
    [anon_sym_u128] = ACTIONS(1716),
    [anon_sym_i128] = ACTIONS(1716),
    [anon_sym_isize] = ACTIONS(1716),
    [anon_sym_usize] = ACTIONS(1716),
    [anon_sym_f32] = ACTIONS(1716),
    [anon_sym_f64] = ACTIONS(1716),
    [anon_sym_bool] = ACTIONS(1716),
    [anon_sym_str] = ACTIONS(1716),
    [anon_sym_char] = ACTIONS(1716),
    [anon_sym_DASH] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1714),
    [anon_sym_AMP] = ACTIONS(1714),
    [anon_sym_PIPE] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1714),
    [anon_sym_DOT_DOT] = ACTIONS(1714),
    [anon_sym_COLON_COLON] = ACTIONS(1714),
    [anon_sym_POUND] = ACTIONS(1714),
    [anon_sym_SQUOTE] = ACTIONS(1716),
    [anon_sym_async] = ACTIONS(1716),
    [anon_sym_break] = ACTIONS(1716),
    [anon_sym_const] = ACTIONS(1716),
    [anon_sym_continue] = ACTIONS(1716),
    [anon_sym_default] = ACTIONS(1716),
    [anon_sym_enum] = ACTIONS(1716),
    [anon_sym_fn] = ACTIONS(1716),
    [anon_sym_for] = ACTIONS(1716),
    [anon_sym_if] = ACTIONS(1716),
    [anon_sym_impl] = ACTIONS(1716),
    [anon_sym_let] = ACTIONS(1716),
    [anon_sym_loop] = ACTIONS(1716),
    [anon_sym_match] = ACTIONS(1716),
    [anon_sym_mod] = ACTIONS(1716),
    [anon_sym_pub] = ACTIONS(1716),
    [anon_sym_return] = ACTIONS(1716),
    [anon_sym_static] = ACTIONS(1716),
    [anon_sym_struct] = ACTIONS(1716),
    [anon_sym_trait] = ACTIONS(1716),
    [anon_sym_type] = ACTIONS(1716),
    [anon_sym_union] = ACTIONS(1716),
    [anon_sym_unsafe] = ACTIONS(1716),
    [anon_sym_use] = ACTIONS(1716),
    [anon_sym_while] = ACTIONS(1716),
    [anon_sym_extern] = ACTIONS(1716),
    [anon_sym_yield] = ACTIONS(1716),
    [anon_sym_move] = ACTIONS(1716),
    [anon_sym_try] = ACTIONS(1716),
    [sym_integer_literal] = ACTIONS(1714),
    [aux_sym_string_literal_token1] = ACTIONS(1714),
    [sym_char_literal] = ACTIONS(1714),
    [anon_sym_true] = ACTIONS(1716),
    [anon_sym_false] = ACTIONS(1716),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1716),
    [sym_super] = ACTIONS(1716),
    [sym_crate] = ACTIONS(1716),
    [sym_metavariable] = ACTIONS(1714),
    [sym__raw_string_literal_start] = ACTIONS(1714),
    [sym_float_literal] = ACTIONS(1714),
  },
  [493] = {
    [sym_line_comment] = STATE(493),
    [sym_block_comment] = STATE(493),
    [ts_builtin_sym_end] = ACTIONS(1718),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_SEMI] = ACTIONS(1718),
    [anon_sym_macro_rules_BANG] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(1718),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_RBRACE] = ACTIONS(1718),
    [anon_sym_STAR] = ACTIONS(1718),
    [anon_sym_u8] = ACTIONS(1720),
    [anon_sym_i8] = ACTIONS(1720),
    [anon_sym_u16] = ACTIONS(1720),
    [anon_sym_i16] = ACTIONS(1720),
    [anon_sym_u32] = ACTIONS(1720),
    [anon_sym_i32] = ACTIONS(1720),
    [anon_sym_u64] = ACTIONS(1720),
    [anon_sym_i64] = ACTIONS(1720),
    [anon_sym_u128] = ACTIONS(1720),
    [anon_sym_i128] = ACTIONS(1720),
    [anon_sym_isize] = ACTIONS(1720),
    [anon_sym_usize] = ACTIONS(1720),
    [anon_sym_f32] = ACTIONS(1720),
    [anon_sym_f64] = ACTIONS(1720),
    [anon_sym_bool] = ACTIONS(1720),
    [anon_sym_str] = ACTIONS(1720),
    [anon_sym_char] = ACTIONS(1720),
    [anon_sym_DASH] = ACTIONS(1718),
    [anon_sym_BANG] = ACTIONS(1718),
    [anon_sym_AMP] = ACTIONS(1718),
    [anon_sym_PIPE] = ACTIONS(1718),
    [anon_sym_LT] = ACTIONS(1718),
    [anon_sym_DOT_DOT] = ACTIONS(1718),
    [anon_sym_COLON_COLON] = ACTIONS(1718),
    [anon_sym_POUND] = ACTIONS(1718),
    [anon_sym_SQUOTE] = ACTIONS(1720),
    [anon_sym_async] = ACTIONS(1720),
    [anon_sym_break] = ACTIONS(1720),
    [anon_sym_const] = ACTIONS(1720),
    [anon_sym_continue] = ACTIONS(1720),
    [anon_sym_default] = ACTIONS(1720),
    [anon_sym_enum] = ACTIONS(1720),
    [anon_sym_fn] = ACTIONS(1720),
    [anon_sym_for] = ACTIONS(1720),
    [anon_sym_if] = ACTIONS(1720),
    [anon_sym_impl] = ACTIONS(1720),
    [anon_sym_let] = ACTIONS(1720),
    [anon_sym_loop] = ACTIONS(1720),
    [anon_sym_match] = ACTIONS(1720),
    [anon_sym_mod] = ACTIONS(1720),
    [anon_sym_pub] = ACTIONS(1720),
    [anon_sym_return] = ACTIONS(1720),
    [anon_sym_static] = ACTIONS(1720),
    [anon_sym_struct] = ACTIONS(1720),
    [anon_sym_trait] = ACTIONS(1720),
    [anon_sym_type] = ACTIONS(1720),
    [anon_sym_union] = ACTIONS(1720),
    [anon_sym_unsafe] = ACTIONS(1720),
    [anon_sym_use] = ACTIONS(1720),
    [anon_sym_while] = ACTIONS(1720),
    [anon_sym_extern] = ACTIONS(1720),
    [anon_sym_yield] = ACTIONS(1720),
    [anon_sym_move] = ACTIONS(1720),
    [anon_sym_try] = ACTIONS(1720),
    [sym_integer_literal] = ACTIONS(1718),
    [aux_sym_string_literal_token1] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [anon_sym_true] = ACTIONS(1720),
    [anon_sym_false] = ACTIONS(1720),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1720),
    [sym_super] = ACTIONS(1720),
    [sym_crate] = ACTIONS(1720),
    [sym_metavariable] = ACTIONS(1718),
    [sym__raw_string_literal_start] = ACTIONS(1718),
    [sym_float_literal] = ACTIONS(1718),
  },
  [494] = {
    [sym_line_comment] = STATE(494),
    [sym_block_comment] = STATE(494),
    [ts_builtin_sym_end] = ACTIONS(1722),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_macro_rules_BANG] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_LBRACK] = ACTIONS(1722),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_RBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(1722),
    [anon_sym_u8] = ACTIONS(1724),
    [anon_sym_i8] = ACTIONS(1724),
    [anon_sym_u16] = ACTIONS(1724),
    [anon_sym_i16] = ACTIONS(1724),
    [anon_sym_u32] = ACTIONS(1724),
    [anon_sym_i32] = ACTIONS(1724),
    [anon_sym_u64] = ACTIONS(1724),
    [anon_sym_i64] = ACTIONS(1724),
    [anon_sym_u128] = ACTIONS(1724),
    [anon_sym_i128] = ACTIONS(1724),
    [anon_sym_isize] = ACTIONS(1724),
    [anon_sym_usize] = ACTIONS(1724),
    [anon_sym_f32] = ACTIONS(1724),
    [anon_sym_f64] = ACTIONS(1724),
    [anon_sym_bool] = ACTIONS(1724),
    [anon_sym_str] = ACTIONS(1724),
    [anon_sym_char] = ACTIONS(1724),
    [anon_sym_DASH] = ACTIONS(1722),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_AMP] = ACTIONS(1722),
    [anon_sym_PIPE] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_DOT_DOT] = ACTIONS(1722),
    [anon_sym_COLON_COLON] = ACTIONS(1722),
    [anon_sym_POUND] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1724),
    [anon_sym_async] = ACTIONS(1724),
    [anon_sym_break] = ACTIONS(1724),
    [anon_sym_const] = ACTIONS(1724),
    [anon_sym_continue] = ACTIONS(1724),
    [anon_sym_default] = ACTIONS(1724),
    [anon_sym_enum] = ACTIONS(1724),
    [anon_sym_fn] = ACTIONS(1724),
    [anon_sym_for] = ACTIONS(1724),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_impl] = ACTIONS(1724),
    [anon_sym_let] = ACTIONS(1724),
    [anon_sym_loop] = ACTIONS(1724),
    [anon_sym_match] = ACTIONS(1724),
    [anon_sym_mod] = ACTIONS(1724),
    [anon_sym_pub] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1724),
    [anon_sym_static] = ACTIONS(1724),
    [anon_sym_struct] = ACTIONS(1724),
    [anon_sym_trait] = ACTIONS(1724),
    [anon_sym_type] = ACTIONS(1724),
    [anon_sym_union] = ACTIONS(1724),
    [anon_sym_unsafe] = ACTIONS(1724),
    [anon_sym_use] = ACTIONS(1724),
    [anon_sym_while] = ACTIONS(1724),
    [anon_sym_extern] = ACTIONS(1724),
    [anon_sym_yield] = ACTIONS(1724),
    [anon_sym_move] = ACTIONS(1724),
    [anon_sym_try] = ACTIONS(1724),
    [sym_integer_literal] = ACTIONS(1722),
    [aux_sym_string_literal_token1] = ACTIONS(1722),
    [sym_char_literal] = ACTIONS(1722),
    [anon_sym_true] = ACTIONS(1724),
    [anon_sym_false] = ACTIONS(1724),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1724),
    [sym_super] = ACTIONS(1724),
    [sym_crate] = ACTIONS(1724),
    [sym_metavariable] = ACTIONS(1722),
    [sym__raw_string_literal_start] = ACTIONS(1722),
    [sym_float_literal] = ACTIONS(1722),
  },
  [495] = {
    [sym_line_comment] = STATE(495),
    [sym_block_comment] = STATE(495),
    [ts_builtin_sym_end] = ACTIONS(1726),
    [sym_identifier] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_macro_rules_BANG] = ACTIONS(1726),
    [anon_sym_LPAREN] = ACTIONS(1726),
    [anon_sym_LBRACK] = ACTIONS(1726),
    [anon_sym_LBRACE] = ACTIONS(1726),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [anon_sym_STAR] = ACTIONS(1726),
    [anon_sym_u8] = ACTIONS(1728),
    [anon_sym_i8] = ACTIONS(1728),
    [anon_sym_u16] = ACTIONS(1728),
    [anon_sym_i16] = ACTIONS(1728),
    [anon_sym_u32] = ACTIONS(1728),
    [anon_sym_i32] = ACTIONS(1728),
    [anon_sym_u64] = ACTIONS(1728),
    [anon_sym_i64] = ACTIONS(1728),
    [anon_sym_u128] = ACTIONS(1728),
    [anon_sym_i128] = ACTIONS(1728),
    [anon_sym_isize] = ACTIONS(1728),
    [anon_sym_usize] = ACTIONS(1728),
    [anon_sym_f32] = ACTIONS(1728),
    [anon_sym_f64] = ACTIONS(1728),
    [anon_sym_bool] = ACTIONS(1728),
    [anon_sym_str] = ACTIONS(1728),
    [anon_sym_char] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1726),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_COLON_COLON] = ACTIONS(1726),
    [anon_sym_POUND] = ACTIONS(1726),
    [anon_sym_SQUOTE] = ACTIONS(1728),
    [anon_sym_async] = ACTIONS(1728),
    [anon_sym_break] = ACTIONS(1728),
    [anon_sym_const] = ACTIONS(1728),
    [anon_sym_continue] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1728),
    [anon_sym_enum] = ACTIONS(1728),
    [anon_sym_fn] = ACTIONS(1728),
    [anon_sym_for] = ACTIONS(1728),
    [anon_sym_if] = ACTIONS(1728),
    [anon_sym_impl] = ACTIONS(1728),
    [anon_sym_let] = ACTIONS(1728),
    [anon_sym_loop] = ACTIONS(1728),
    [anon_sym_match] = ACTIONS(1728),
    [anon_sym_mod] = ACTIONS(1728),
    [anon_sym_pub] = ACTIONS(1728),
    [anon_sym_return] = ACTIONS(1728),
    [anon_sym_static] = ACTIONS(1728),
    [anon_sym_struct] = ACTIONS(1728),
    [anon_sym_trait] = ACTIONS(1728),
    [anon_sym_type] = ACTIONS(1728),
    [anon_sym_union] = ACTIONS(1728),
    [anon_sym_unsafe] = ACTIONS(1728),
    [anon_sym_use] = ACTIONS(1728),
    [anon_sym_while] = ACTIONS(1728),
    [anon_sym_extern] = ACTIONS(1728),
    [anon_sym_yield] = ACTIONS(1728),
    [anon_sym_move] = ACTIONS(1728),
    [anon_sym_try] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1726),
    [aux_sym_string_literal_token1] = ACTIONS(1726),
    [sym_char_literal] = ACTIONS(1726),
    [anon_sym_true] = ACTIONS(1728),
    [anon_sym_false] = ACTIONS(1728),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1728),
    [sym_super] = ACTIONS(1728),
    [sym_crate] = ACTIONS(1728),
    [sym_metavariable] = ACTIONS(1726),
    [sym__raw_string_literal_start] = ACTIONS(1726),
    [sym_float_literal] = ACTIONS(1726),
  },
  [496] = {
    [sym_line_comment] = STATE(496),
    [sym_block_comment] = STATE(496),
    [ts_builtin_sym_end] = ACTIONS(1730),
    [sym_identifier] = ACTIONS(1732),
    [anon_sym_SEMI] = ACTIONS(1730),
    [anon_sym_macro_rules_BANG] = ACTIONS(1730),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_LBRACK] = ACTIONS(1730),
    [anon_sym_LBRACE] = ACTIONS(1730),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_STAR] = ACTIONS(1730),
    [anon_sym_u8] = ACTIONS(1732),
    [anon_sym_i8] = ACTIONS(1732),
    [anon_sym_u16] = ACTIONS(1732),
    [anon_sym_i16] = ACTIONS(1732),
    [anon_sym_u32] = ACTIONS(1732),
    [anon_sym_i32] = ACTIONS(1732),
    [anon_sym_u64] = ACTIONS(1732),
    [anon_sym_i64] = ACTIONS(1732),
    [anon_sym_u128] = ACTIONS(1732),
    [anon_sym_i128] = ACTIONS(1732),
    [anon_sym_isize] = ACTIONS(1732),
    [anon_sym_usize] = ACTIONS(1732),
    [anon_sym_f32] = ACTIONS(1732),
    [anon_sym_f64] = ACTIONS(1732),
    [anon_sym_bool] = ACTIONS(1732),
    [anon_sym_str] = ACTIONS(1732),
    [anon_sym_char] = ACTIONS(1732),
    [anon_sym_DASH] = ACTIONS(1730),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(1730),
    [anon_sym_PIPE] = ACTIONS(1730),
    [anon_sym_LT] = ACTIONS(1730),
    [anon_sym_DOT_DOT] = ACTIONS(1730),
    [anon_sym_COLON_COLON] = ACTIONS(1730),
    [anon_sym_POUND] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_async] = ACTIONS(1732),
    [anon_sym_break] = ACTIONS(1732),
    [anon_sym_const] = ACTIONS(1732),
    [anon_sym_continue] = ACTIONS(1732),
    [anon_sym_default] = ACTIONS(1732),
    [anon_sym_enum] = ACTIONS(1732),
    [anon_sym_fn] = ACTIONS(1732),
    [anon_sym_for] = ACTIONS(1732),
    [anon_sym_if] = ACTIONS(1732),
    [anon_sym_impl] = ACTIONS(1732),
    [anon_sym_let] = ACTIONS(1732),
    [anon_sym_loop] = ACTIONS(1732),
    [anon_sym_match] = ACTIONS(1732),
    [anon_sym_mod] = ACTIONS(1732),
    [anon_sym_pub] = ACTIONS(1732),
    [anon_sym_return] = ACTIONS(1732),
    [anon_sym_static] = ACTIONS(1732),
    [anon_sym_struct] = ACTIONS(1732),
    [anon_sym_trait] = ACTIONS(1732),
    [anon_sym_type] = ACTIONS(1732),
    [anon_sym_union] = ACTIONS(1732),
    [anon_sym_unsafe] = ACTIONS(1732),
    [anon_sym_use] = ACTIONS(1732),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_extern] = ACTIONS(1732),
    [anon_sym_yield] = ACTIONS(1732),
    [anon_sym_move] = ACTIONS(1732),
    [anon_sym_try] = ACTIONS(1732),
    [sym_integer_literal] = ACTIONS(1730),
    [aux_sym_string_literal_token1] = ACTIONS(1730),
    [sym_char_literal] = ACTIONS(1730),
    [anon_sym_true] = ACTIONS(1732),
    [anon_sym_false] = ACTIONS(1732),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1732),
    [sym_super] = ACTIONS(1732),
    [sym_crate] = ACTIONS(1732),
    [sym_metavariable] = ACTIONS(1730),
    [sym__raw_string_literal_start] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
  },
  [497] = {
    [sym_line_comment] = STATE(497),
    [sym_block_comment] = STATE(497),
    [ts_builtin_sym_end] = ACTIONS(1734),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_macro_rules_BANG] = ACTIONS(1734),
    [anon_sym_LPAREN] = ACTIONS(1734),
    [anon_sym_LBRACK] = ACTIONS(1734),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_STAR] = ACTIONS(1734),
    [anon_sym_u8] = ACTIONS(1736),
    [anon_sym_i8] = ACTIONS(1736),
    [anon_sym_u16] = ACTIONS(1736),
    [anon_sym_i16] = ACTIONS(1736),
    [anon_sym_u32] = ACTIONS(1736),
    [anon_sym_i32] = ACTIONS(1736),
    [anon_sym_u64] = ACTIONS(1736),
    [anon_sym_i64] = ACTIONS(1736),
    [anon_sym_u128] = ACTIONS(1736),
    [anon_sym_i128] = ACTIONS(1736),
    [anon_sym_isize] = ACTIONS(1736),
    [anon_sym_usize] = ACTIONS(1736),
    [anon_sym_f32] = ACTIONS(1736),
    [anon_sym_f64] = ACTIONS(1736),
    [anon_sym_bool] = ACTIONS(1736),
    [anon_sym_str] = ACTIONS(1736),
    [anon_sym_char] = ACTIONS(1736),
    [anon_sym_DASH] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(1734),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_DOT_DOT] = ACTIONS(1734),
    [anon_sym_COLON_COLON] = ACTIONS(1734),
    [anon_sym_POUND] = ACTIONS(1734),
    [anon_sym_SQUOTE] = ACTIONS(1736),
    [anon_sym_async] = ACTIONS(1736),
    [anon_sym_break] = ACTIONS(1736),
    [anon_sym_const] = ACTIONS(1736),
    [anon_sym_continue] = ACTIONS(1736),
    [anon_sym_default] = ACTIONS(1736),
    [anon_sym_enum] = ACTIONS(1736),
    [anon_sym_fn] = ACTIONS(1736),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_if] = ACTIONS(1736),
    [anon_sym_impl] = ACTIONS(1736),
    [anon_sym_let] = ACTIONS(1736),
    [anon_sym_loop] = ACTIONS(1736),
    [anon_sym_match] = ACTIONS(1736),
    [anon_sym_mod] = ACTIONS(1736),
    [anon_sym_pub] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1736),
    [anon_sym_static] = ACTIONS(1736),
    [anon_sym_struct] = ACTIONS(1736),
    [anon_sym_trait] = ACTIONS(1736),
    [anon_sym_type] = ACTIONS(1736),
    [anon_sym_union] = ACTIONS(1736),
    [anon_sym_unsafe] = ACTIONS(1736),
    [anon_sym_use] = ACTIONS(1736),
    [anon_sym_while] = ACTIONS(1736),
    [anon_sym_extern] = ACTIONS(1736),
    [anon_sym_yield] = ACTIONS(1736),
    [anon_sym_move] = ACTIONS(1736),
    [anon_sym_try] = ACTIONS(1736),
    [sym_integer_literal] = ACTIONS(1734),
    [aux_sym_string_literal_token1] = ACTIONS(1734),
    [sym_char_literal] = ACTIONS(1734),
    [anon_sym_true] = ACTIONS(1736),
    [anon_sym_false] = ACTIONS(1736),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1736),
    [sym_super] = ACTIONS(1736),
    [sym_crate] = ACTIONS(1736),
    [sym_metavariable] = ACTIONS(1734),
    [sym__raw_string_literal_start] = ACTIONS(1734),
    [sym_float_literal] = ACTIONS(1734),
  },
  [498] = {
    [sym_line_comment] = STATE(498),
    [sym_block_comment] = STATE(498),
    [ts_builtin_sym_end] = ACTIONS(1738),
    [sym_identifier] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(1738),
    [anon_sym_macro_rules_BANG] = ACTIONS(1738),
    [anon_sym_LPAREN] = ACTIONS(1738),
    [anon_sym_LBRACK] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_RBRACE] = ACTIONS(1738),
    [anon_sym_STAR] = ACTIONS(1738),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym_DASH] = ACTIONS(1738),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_AMP] = ACTIONS(1738),
    [anon_sym_PIPE] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1738),
    [anon_sym_DOT_DOT] = ACTIONS(1738),
    [anon_sym_COLON_COLON] = ACTIONS(1738),
    [anon_sym_POUND] = ACTIONS(1738),
    [anon_sym_SQUOTE] = ACTIONS(1740),
    [anon_sym_async] = ACTIONS(1740),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_const] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1740),
    [anon_sym_default] = ACTIONS(1740),
    [anon_sym_enum] = ACTIONS(1740),
    [anon_sym_fn] = ACTIONS(1740),
    [anon_sym_for] = ACTIONS(1740),
    [anon_sym_if] = ACTIONS(1740),
    [anon_sym_impl] = ACTIONS(1740),
    [anon_sym_let] = ACTIONS(1740),
    [anon_sym_loop] = ACTIONS(1740),
    [anon_sym_match] = ACTIONS(1740),
    [anon_sym_mod] = ACTIONS(1740),
    [anon_sym_pub] = ACTIONS(1740),
    [anon_sym_return] = ACTIONS(1740),
    [anon_sym_static] = ACTIONS(1740),
    [anon_sym_struct] = ACTIONS(1740),
    [anon_sym_trait] = ACTIONS(1740),
    [anon_sym_type] = ACTIONS(1740),
    [anon_sym_union] = ACTIONS(1740),
    [anon_sym_unsafe] = ACTIONS(1740),
    [anon_sym_use] = ACTIONS(1740),
    [anon_sym_while] = ACTIONS(1740),
    [anon_sym_extern] = ACTIONS(1740),
    [anon_sym_yield] = ACTIONS(1740),
    [anon_sym_move] = ACTIONS(1740),
    [anon_sym_try] = ACTIONS(1740),
    [sym_integer_literal] = ACTIONS(1738),
    [aux_sym_string_literal_token1] = ACTIONS(1738),
    [sym_char_literal] = ACTIONS(1738),
    [anon_sym_true] = ACTIONS(1740),
    [anon_sym_false] = ACTIONS(1740),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1740),
    [sym_super] = ACTIONS(1740),
    [sym_crate] = ACTIONS(1740),
    [sym_metavariable] = ACTIONS(1738),
    [sym__raw_string_literal_start] = ACTIONS(1738),
    [sym_float_literal] = ACTIONS(1738),
  },
  [499] = {
    [sym_line_comment] = STATE(499),
    [sym_block_comment] = STATE(499),
    [ts_builtin_sym_end] = ACTIONS(1742),
    [sym_identifier] = ACTIONS(1744),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_macro_rules_BANG] = ACTIONS(1742),
    [anon_sym_LPAREN] = ACTIONS(1742),
    [anon_sym_LBRACK] = ACTIONS(1742),
    [anon_sym_LBRACE] = ACTIONS(1742),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [anon_sym_STAR] = ACTIONS(1742),
    [anon_sym_u8] = ACTIONS(1744),
    [anon_sym_i8] = ACTIONS(1744),
    [anon_sym_u16] = ACTIONS(1744),
    [anon_sym_i16] = ACTIONS(1744),
    [anon_sym_u32] = ACTIONS(1744),
    [anon_sym_i32] = ACTIONS(1744),
    [anon_sym_u64] = ACTIONS(1744),
    [anon_sym_i64] = ACTIONS(1744),
    [anon_sym_u128] = ACTIONS(1744),
    [anon_sym_i128] = ACTIONS(1744),
    [anon_sym_isize] = ACTIONS(1744),
    [anon_sym_usize] = ACTIONS(1744),
    [anon_sym_f32] = ACTIONS(1744),
    [anon_sym_f64] = ACTIONS(1744),
    [anon_sym_bool] = ACTIONS(1744),
    [anon_sym_str] = ACTIONS(1744),
    [anon_sym_char] = ACTIONS(1744),
    [anon_sym_DASH] = ACTIONS(1742),
    [anon_sym_BANG] = ACTIONS(1742),
    [anon_sym_AMP] = ACTIONS(1742),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_LT] = ACTIONS(1742),
    [anon_sym_DOT_DOT] = ACTIONS(1742),
    [anon_sym_COLON_COLON] = ACTIONS(1742),
    [anon_sym_POUND] = ACTIONS(1742),
    [anon_sym_SQUOTE] = ACTIONS(1744),
    [anon_sym_async] = ACTIONS(1744),
    [anon_sym_break] = ACTIONS(1744),
    [anon_sym_const] = ACTIONS(1744),
    [anon_sym_continue] = ACTIONS(1744),
    [anon_sym_default] = ACTIONS(1744),
    [anon_sym_enum] = ACTIONS(1744),
    [anon_sym_fn] = ACTIONS(1744),
    [anon_sym_for] = ACTIONS(1744),
    [anon_sym_if] = ACTIONS(1744),
    [anon_sym_impl] = ACTIONS(1744),
    [anon_sym_let] = ACTIONS(1744),
    [anon_sym_loop] = ACTIONS(1744),
    [anon_sym_match] = ACTIONS(1744),
    [anon_sym_mod] = ACTIONS(1744),
    [anon_sym_pub] = ACTIONS(1744),
    [anon_sym_return] = ACTIONS(1744),
    [anon_sym_static] = ACTIONS(1744),
    [anon_sym_struct] = ACTIONS(1744),
    [anon_sym_trait] = ACTIONS(1744),
    [anon_sym_type] = ACTIONS(1744),
    [anon_sym_union] = ACTIONS(1744),
    [anon_sym_unsafe] = ACTIONS(1744),
    [anon_sym_use] = ACTIONS(1744),
    [anon_sym_while] = ACTIONS(1744),
    [anon_sym_extern] = ACTIONS(1744),
    [anon_sym_yield] = ACTIONS(1744),
    [anon_sym_move] = ACTIONS(1744),
    [anon_sym_try] = ACTIONS(1744),
    [sym_integer_literal] = ACTIONS(1742),
    [aux_sym_string_literal_token1] = ACTIONS(1742),
    [sym_char_literal] = ACTIONS(1742),
    [anon_sym_true] = ACTIONS(1744),
    [anon_sym_false] = ACTIONS(1744),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1744),
    [sym_super] = ACTIONS(1744),
    [sym_crate] = ACTIONS(1744),
    [sym_metavariable] = ACTIONS(1742),
    [sym__raw_string_literal_start] = ACTIONS(1742),
    [sym_float_literal] = ACTIONS(1742),
  },
  [500] = {
    [sym_line_comment] = STATE(500),
    [sym_block_comment] = STATE(500),
    [ts_builtin_sym_end] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_macro_rules_BANG] = ACTIONS(1746),
    [anon_sym_LPAREN] = ACTIONS(1746),
    [anon_sym_LBRACK] = ACTIONS(1746),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_RBRACE] = ACTIONS(1746),
    [anon_sym_STAR] = ACTIONS(1746),
    [anon_sym_u8] = ACTIONS(1748),
    [anon_sym_i8] = ACTIONS(1748),
    [anon_sym_u16] = ACTIONS(1748),
    [anon_sym_i16] = ACTIONS(1748),
    [anon_sym_u32] = ACTIONS(1748),
    [anon_sym_i32] = ACTIONS(1748),
    [anon_sym_u64] = ACTIONS(1748),
    [anon_sym_i64] = ACTIONS(1748),
    [anon_sym_u128] = ACTIONS(1748),
    [anon_sym_i128] = ACTIONS(1748),
    [anon_sym_isize] = ACTIONS(1748),
    [anon_sym_usize] = ACTIONS(1748),
    [anon_sym_f32] = ACTIONS(1748),
    [anon_sym_f64] = ACTIONS(1748),
    [anon_sym_bool] = ACTIONS(1748),
    [anon_sym_str] = ACTIONS(1748),
    [anon_sym_char] = ACTIONS(1748),
    [anon_sym_DASH] = ACTIONS(1746),
    [anon_sym_BANG] = ACTIONS(1746),
    [anon_sym_AMP] = ACTIONS(1746),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_DOT_DOT] = ACTIONS(1746),
    [anon_sym_COLON_COLON] = ACTIONS(1746),
    [anon_sym_POUND] = ACTIONS(1746),
    [anon_sym_SQUOTE] = ACTIONS(1748),
    [anon_sym_async] = ACTIONS(1748),
    [anon_sym_break] = ACTIONS(1748),
    [anon_sym_const] = ACTIONS(1748),
    [anon_sym_continue] = ACTIONS(1748),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_enum] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(1748),
    [anon_sym_for] = ACTIONS(1748),
    [anon_sym_if] = ACTIONS(1748),
    [anon_sym_impl] = ACTIONS(1748),
    [anon_sym_let] = ACTIONS(1748),
    [anon_sym_loop] = ACTIONS(1748),
    [anon_sym_match] = ACTIONS(1748),
    [anon_sym_mod] = ACTIONS(1748),
    [anon_sym_pub] = ACTIONS(1748),
    [anon_sym_return] = ACTIONS(1748),
    [anon_sym_static] = ACTIONS(1748),
    [anon_sym_struct] = ACTIONS(1748),
    [anon_sym_trait] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(1748),
    [anon_sym_union] = ACTIONS(1748),
    [anon_sym_unsafe] = ACTIONS(1748),
    [anon_sym_use] = ACTIONS(1748),
    [anon_sym_while] = ACTIONS(1748),
    [anon_sym_extern] = ACTIONS(1748),
    [anon_sym_yield] = ACTIONS(1748),
    [anon_sym_move] = ACTIONS(1748),
    [anon_sym_try] = ACTIONS(1748),
    [sym_integer_literal] = ACTIONS(1746),
    [aux_sym_string_literal_token1] = ACTIONS(1746),
    [sym_char_literal] = ACTIONS(1746),
    [anon_sym_true] = ACTIONS(1748),
    [anon_sym_false] = ACTIONS(1748),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1748),
    [sym_super] = ACTIONS(1748),
    [sym_crate] = ACTIONS(1748),
    [sym_metavariable] = ACTIONS(1746),
    [sym__raw_string_literal_start] = ACTIONS(1746),
    [sym_float_literal] = ACTIONS(1746),
  },
  [501] = {
    [sym_line_comment] = STATE(501),
    [sym_block_comment] = STATE(501),
    [ts_builtin_sym_end] = ACTIONS(1750),
    [sym_identifier] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1750),
    [anon_sym_macro_rules_BANG] = ACTIONS(1750),
    [anon_sym_LPAREN] = ACTIONS(1750),
    [anon_sym_LBRACK] = ACTIONS(1750),
    [anon_sym_LBRACE] = ACTIONS(1750),
    [anon_sym_RBRACE] = ACTIONS(1750),
    [anon_sym_STAR] = ACTIONS(1750),
    [anon_sym_u8] = ACTIONS(1752),
    [anon_sym_i8] = ACTIONS(1752),
    [anon_sym_u16] = ACTIONS(1752),
    [anon_sym_i16] = ACTIONS(1752),
    [anon_sym_u32] = ACTIONS(1752),
    [anon_sym_i32] = ACTIONS(1752),
    [anon_sym_u64] = ACTIONS(1752),
    [anon_sym_i64] = ACTIONS(1752),
    [anon_sym_u128] = ACTIONS(1752),
    [anon_sym_i128] = ACTIONS(1752),
    [anon_sym_isize] = ACTIONS(1752),
    [anon_sym_usize] = ACTIONS(1752),
    [anon_sym_f32] = ACTIONS(1752),
    [anon_sym_f64] = ACTIONS(1752),
    [anon_sym_bool] = ACTIONS(1752),
    [anon_sym_str] = ACTIONS(1752),
    [anon_sym_char] = ACTIONS(1752),
    [anon_sym_DASH] = ACTIONS(1750),
    [anon_sym_BANG] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1750),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_DOT_DOT] = ACTIONS(1750),
    [anon_sym_COLON_COLON] = ACTIONS(1750),
    [anon_sym_POUND] = ACTIONS(1750),
    [anon_sym_SQUOTE] = ACTIONS(1752),
    [anon_sym_async] = ACTIONS(1752),
    [anon_sym_break] = ACTIONS(1752),
    [anon_sym_const] = ACTIONS(1752),
    [anon_sym_continue] = ACTIONS(1752),
    [anon_sym_default] = ACTIONS(1752),
    [anon_sym_enum] = ACTIONS(1752),
    [anon_sym_fn] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1752),
    [anon_sym_if] = ACTIONS(1752),
    [anon_sym_impl] = ACTIONS(1752),
    [anon_sym_let] = ACTIONS(1752),
    [anon_sym_loop] = ACTIONS(1752),
    [anon_sym_match] = ACTIONS(1752),
    [anon_sym_mod] = ACTIONS(1752),
    [anon_sym_pub] = ACTIONS(1752),
    [anon_sym_return] = ACTIONS(1752),
    [anon_sym_static] = ACTIONS(1752),
    [anon_sym_struct] = ACTIONS(1752),
    [anon_sym_trait] = ACTIONS(1752),
    [anon_sym_type] = ACTIONS(1752),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(1752),
    [anon_sym_use] = ACTIONS(1752),
    [anon_sym_while] = ACTIONS(1752),
    [anon_sym_extern] = ACTIONS(1752),
    [anon_sym_yield] = ACTIONS(1752),
    [anon_sym_move] = ACTIONS(1752),
    [anon_sym_try] = ACTIONS(1752),
    [sym_integer_literal] = ACTIONS(1750),
    [aux_sym_string_literal_token1] = ACTIONS(1750),
    [sym_char_literal] = ACTIONS(1750),
    [anon_sym_true] = ACTIONS(1752),
    [anon_sym_false] = ACTIONS(1752),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1752),
    [sym_super] = ACTIONS(1752),
    [sym_crate] = ACTIONS(1752),
    [sym_metavariable] = ACTIONS(1750),
    [sym__raw_string_literal_start] = ACTIONS(1750),
    [sym_float_literal] = ACTIONS(1750),
  },
  [502] = {
    [sym_line_comment] = STATE(502),
    [sym_block_comment] = STATE(502),
    [ts_builtin_sym_end] = ACTIONS(1754),
    [sym_identifier] = ACTIONS(1756),
    [anon_sym_SEMI] = ACTIONS(1754),
    [anon_sym_macro_rules_BANG] = ACTIONS(1754),
    [anon_sym_LPAREN] = ACTIONS(1754),
    [anon_sym_LBRACK] = ACTIONS(1754),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_RBRACE] = ACTIONS(1754),
    [anon_sym_STAR] = ACTIONS(1754),
    [anon_sym_u8] = ACTIONS(1756),
    [anon_sym_i8] = ACTIONS(1756),
    [anon_sym_u16] = ACTIONS(1756),
    [anon_sym_i16] = ACTIONS(1756),
    [anon_sym_u32] = ACTIONS(1756),
    [anon_sym_i32] = ACTIONS(1756),
    [anon_sym_u64] = ACTIONS(1756),
    [anon_sym_i64] = ACTIONS(1756),
    [anon_sym_u128] = ACTIONS(1756),
    [anon_sym_i128] = ACTIONS(1756),
    [anon_sym_isize] = ACTIONS(1756),
    [anon_sym_usize] = ACTIONS(1756),
    [anon_sym_f32] = ACTIONS(1756),
    [anon_sym_f64] = ACTIONS(1756),
    [anon_sym_bool] = ACTIONS(1756),
    [anon_sym_str] = ACTIONS(1756),
    [anon_sym_char] = ACTIONS(1756),
    [anon_sym_DASH] = ACTIONS(1754),
    [anon_sym_BANG] = ACTIONS(1754),
    [anon_sym_AMP] = ACTIONS(1754),
    [anon_sym_PIPE] = ACTIONS(1754),
    [anon_sym_LT] = ACTIONS(1754),
    [anon_sym_DOT_DOT] = ACTIONS(1754),
    [anon_sym_COLON_COLON] = ACTIONS(1754),
    [anon_sym_POUND] = ACTIONS(1754),
    [anon_sym_SQUOTE] = ACTIONS(1756),
    [anon_sym_async] = ACTIONS(1756),
    [anon_sym_break] = ACTIONS(1756),
    [anon_sym_const] = ACTIONS(1756),
    [anon_sym_continue] = ACTIONS(1756),
    [anon_sym_default] = ACTIONS(1756),
    [anon_sym_enum] = ACTIONS(1756),
    [anon_sym_fn] = ACTIONS(1756),
    [anon_sym_for] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(1756),
    [anon_sym_impl] = ACTIONS(1756),
    [anon_sym_let] = ACTIONS(1756),
    [anon_sym_loop] = ACTIONS(1756),
    [anon_sym_match] = ACTIONS(1756),
    [anon_sym_mod] = ACTIONS(1756),
    [anon_sym_pub] = ACTIONS(1756),
    [anon_sym_return] = ACTIONS(1756),
    [anon_sym_static] = ACTIONS(1756),
    [anon_sym_struct] = ACTIONS(1756),
    [anon_sym_trait] = ACTIONS(1756),
    [anon_sym_type] = ACTIONS(1756),
    [anon_sym_union] = ACTIONS(1756),
    [anon_sym_unsafe] = ACTIONS(1756),
    [anon_sym_use] = ACTIONS(1756),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_extern] = ACTIONS(1756),
    [anon_sym_yield] = ACTIONS(1756),
    [anon_sym_move] = ACTIONS(1756),
    [anon_sym_try] = ACTIONS(1756),
    [sym_integer_literal] = ACTIONS(1754),
    [aux_sym_string_literal_token1] = ACTIONS(1754),
    [sym_char_literal] = ACTIONS(1754),
    [anon_sym_true] = ACTIONS(1756),
    [anon_sym_false] = ACTIONS(1756),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1756),
    [sym_super] = ACTIONS(1756),
    [sym_crate] = ACTIONS(1756),
    [sym_metavariable] = ACTIONS(1754),
    [sym__raw_string_literal_start] = ACTIONS(1754),
    [sym_float_literal] = ACTIONS(1754),
  },
  [503] = {
    [sym_line_comment] = STATE(503),
    [sym_block_comment] = STATE(503),
    [ts_builtin_sym_end] = ACTIONS(1758),
    [sym_identifier] = ACTIONS(1760),
    [anon_sym_SEMI] = ACTIONS(1758),
    [anon_sym_macro_rules_BANG] = ACTIONS(1758),
    [anon_sym_LPAREN] = ACTIONS(1758),
    [anon_sym_LBRACK] = ACTIONS(1758),
    [anon_sym_LBRACE] = ACTIONS(1758),
    [anon_sym_RBRACE] = ACTIONS(1758),
    [anon_sym_STAR] = ACTIONS(1758),
    [anon_sym_u8] = ACTIONS(1760),
    [anon_sym_i8] = ACTIONS(1760),
    [anon_sym_u16] = ACTIONS(1760),
    [anon_sym_i16] = ACTIONS(1760),
    [anon_sym_u32] = ACTIONS(1760),
    [anon_sym_i32] = ACTIONS(1760),
    [anon_sym_u64] = ACTIONS(1760),
    [anon_sym_i64] = ACTIONS(1760),
    [anon_sym_u128] = ACTIONS(1760),
    [anon_sym_i128] = ACTIONS(1760),
    [anon_sym_isize] = ACTIONS(1760),
    [anon_sym_usize] = ACTIONS(1760),
    [anon_sym_f32] = ACTIONS(1760),
    [anon_sym_f64] = ACTIONS(1760),
    [anon_sym_bool] = ACTIONS(1760),
    [anon_sym_str] = ACTIONS(1760),
    [anon_sym_char] = ACTIONS(1760),
    [anon_sym_DASH] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_AMP] = ACTIONS(1758),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_LT] = ACTIONS(1758),
    [anon_sym_DOT_DOT] = ACTIONS(1758),
    [anon_sym_COLON_COLON] = ACTIONS(1758),
    [anon_sym_POUND] = ACTIONS(1758),
    [anon_sym_SQUOTE] = ACTIONS(1760),
    [anon_sym_async] = ACTIONS(1760),
    [anon_sym_break] = ACTIONS(1760),
    [anon_sym_const] = ACTIONS(1760),
    [anon_sym_continue] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1760),
    [anon_sym_enum] = ACTIONS(1760),
    [anon_sym_fn] = ACTIONS(1760),
    [anon_sym_for] = ACTIONS(1760),
    [anon_sym_if] = ACTIONS(1760),
    [anon_sym_impl] = ACTIONS(1760),
    [anon_sym_let] = ACTIONS(1760),
    [anon_sym_loop] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1760),
    [anon_sym_mod] = ACTIONS(1760),
    [anon_sym_pub] = ACTIONS(1760),
    [anon_sym_return] = ACTIONS(1760),
    [anon_sym_static] = ACTIONS(1760),
    [anon_sym_struct] = ACTIONS(1760),
    [anon_sym_trait] = ACTIONS(1760),
    [anon_sym_type] = ACTIONS(1760),
    [anon_sym_union] = ACTIONS(1760),
    [anon_sym_unsafe] = ACTIONS(1760),
    [anon_sym_use] = ACTIONS(1760),
    [anon_sym_while] = ACTIONS(1760),
    [anon_sym_extern] = ACTIONS(1760),
    [anon_sym_yield] = ACTIONS(1760),
    [anon_sym_move] = ACTIONS(1760),
    [anon_sym_try] = ACTIONS(1760),
    [sym_integer_literal] = ACTIONS(1758),
    [aux_sym_string_literal_token1] = ACTIONS(1758),
    [sym_char_literal] = ACTIONS(1758),
    [anon_sym_true] = ACTIONS(1760),
    [anon_sym_false] = ACTIONS(1760),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1760),
    [sym_super] = ACTIONS(1760),
    [sym_crate] = ACTIONS(1760),
    [sym_metavariable] = ACTIONS(1758),
    [sym__raw_string_literal_start] = ACTIONS(1758),
    [sym_float_literal] = ACTIONS(1758),
  },
  [504] = {
    [sym_line_comment] = STATE(504),
    [sym_block_comment] = STATE(504),
    [ts_builtin_sym_end] = ACTIONS(1762),
    [sym_identifier] = ACTIONS(1764),
    [anon_sym_SEMI] = ACTIONS(1762),
    [anon_sym_macro_rules_BANG] = ACTIONS(1762),
    [anon_sym_LPAREN] = ACTIONS(1762),
    [anon_sym_LBRACK] = ACTIONS(1762),
    [anon_sym_LBRACE] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(1762),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_u8] = ACTIONS(1764),
    [anon_sym_i8] = ACTIONS(1764),
    [anon_sym_u16] = ACTIONS(1764),
    [anon_sym_i16] = ACTIONS(1764),
    [anon_sym_u32] = ACTIONS(1764),
    [anon_sym_i32] = ACTIONS(1764),
    [anon_sym_u64] = ACTIONS(1764),
    [anon_sym_i64] = ACTIONS(1764),
    [anon_sym_u128] = ACTIONS(1764),
    [anon_sym_i128] = ACTIONS(1764),
    [anon_sym_isize] = ACTIONS(1764),
    [anon_sym_usize] = ACTIONS(1764),
    [anon_sym_f32] = ACTIONS(1764),
    [anon_sym_f64] = ACTIONS(1764),
    [anon_sym_bool] = ACTIONS(1764),
    [anon_sym_str] = ACTIONS(1764),
    [anon_sym_char] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(1762),
    [anon_sym_BANG] = ACTIONS(1762),
    [anon_sym_AMP] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1762),
    [anon_sym_DOT_DOT] = ACTIONS(1762),
    [anon_sym_COLON_COLON] = ACTIONS(1762),
    [anon_sym_POUND] = ACTIONS(1762),
    [anon_sym_SQUOTE] = ACTIONS(1764),
    [anon_sym_async] = ACTIONS(1764),
    [anon_sym_break] = ACTIONS(1764),
    [anon_sym_const] = ACTIONS(1764),
    [anon_sym_continue] = ACTIONS(1764),
    [anon_sym_default] = ACTIONS(1764),
    [anon_sym_enum] = ACTIONS(1764),
    [anon_sym_fn] = ACTIONS(1764),
    [anon_sym_for] = ACTIONS(1764),
    [anon_sym_if] = ACTIONS(1764),
    [anon_sym_impl] = ACTIONS(1764),
    [anon_sym_let] = ACTIONS(1764),
    [anon_sym_loop] = ACTIONS(1764),
    [anon_sym_match] = ACTIONS(1764),
    [anon_sym_mod] = ACTIONS(1764),
    [anon_sym_pub] = ACTIONS(1764),
    [anon_sym_return] = ACTIONS(1764),
    [anon_sym_static] = ACTIONS(1764),
    [anon_sym_struct] = ACTIONS(1764),
    [anon_sym_trait] = ACTIONS(1764),
    [anon_sym_type] = ACTIONS(1764),
    [anon_sym_union] = ACTIONS(1764),
    [anon_sym_unsafe] = ACTIONS(1764),
    [anon_sym_use] = ACTIONS(1764),
    [anon_sym_while] = ACTIONS(1764),
    [anon_sym_extern] = ACTIONS(1764),
    [anon_sym_yield] = ACTIONS(1764),
    [anon_sym_move] = ACTIONS(1764),
    [anon_sym_try] = ACTIONS(1764),
    [sym_integer_literal] = ACTIONS(1762),
    [aux_sym_string_literal_token1] = ACTIONS(1762),
    [sym_char_literal] = ACTIONS(1762),
    [anon_sym_true] = ACTIONS(1764),
    [anon_sym_false] = ACTIONS(1764),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1764),
    [sym_super] = ACTIONS(1764),
    [sym_crate] = ACTIONS(1764),
    [sym_metavariable] = ACTIONS(1762),
    [sym__raw_string_literal_start] = ACTIONS(1762),
    [sym_float_literal] = ACTIONS(1762),
  },
  [505] = {
    [sym_line_comment] = STATE(505),
    [sym_block_comment] = STATE(505),
    [ts_builtin_sym_end] = ACTIONS(1766),
    [sym_identifier] = ACTIONS(1768),
    [anon_sym_SEMI] = ACTIONS(1766),
    [anon_sym_macro_rules_BANG] = ACTIONS(1766),
    [anon_sym_LPAREN] = ACTIONS(1766),
    [anon_sym_LBRACK] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1766),
    [anon_sym_RBRACE] = ACTIONS(1766),
    [anon_sym_STAR] = ACTIONS(1766),
    [anon_sym_u8] = ACTIONS(1768),
    [anon_sym_i8] = ACTIONS(1768),
    [anon_sym_u16] = ACTIONS(1768),
    [anon_sym_i16] = ACTIONS(1768),
    [anon_sym_u32] = ACTIONS(1768),
    [anon_sym_i32] = ACTIONS(1768),
    [anon_sym_u64] = ACTIONS(1768),
    [anon_sym_i64] = ACTIONS(1768),
    [anon_sym_u128] = ACTIONS(1768),
    [anon_sym_i128] = ACTIONS(1768),
    [anon_sym_isize] = ACTIONS(1768),
    [anon_sym_usize] = ACTIONS(1768),
    [anon_sym_f32] = ACTIONS(1768),
    [anon_sym_f64] = ACTIONS(1768),
    [anon_sym_bool] = ACTIONS(1768),
    [anon_sym_str] = ACTIONS(1768),
    [anon_sym_char] = ACTIONS(1768),
    [anon_sym_DASH] = ACTIONS(1766),
    [anon_sym_BANG] = ACTIONS(1766),
    [anon_sym_AMP] = ACTIONS(1766),
    [anon_sym_PIPE] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(1766),
    [anon_sym_DOT_DOT] = ACTIONS(1766),
    [anon_sym_COLON_COLON] = ACTIONS(1766),
    [anon_sym_POUND] = ACTIONS(1766),
    [anon_sym_SQUOTE] = ACTIONS(1768),
    [anon_sym_async] = ACTIONS(1768),
    [anon_sym_break] = ACTIONS(1768),
    [anon_sym_const] = ACTIONS(1768),
    [anon_sym_continue] = ACTIONS(1768),
    [anon_sym_default] = ACTIONS(1768),
    [anon_sym_enum] = ACTIONS(1768),
    [anon_sym_fn] = ACTIONS(1768),
    [anon_sym_for] = ACTIONS(1768),
    [anon_sym_if] = ACTIONS(1768),
    [anon_sym_impl] = ACTIONS(1768),
    [anon_sym_let] = ACTIONS(1768),
    [anon_sym_loop] = ACTIONS(1768),
    [anon_sym_match] = ACTIONS(1768),
    [anon_sym_mod] = ACTIONS(1768),
    [anon_sym_pub] = ACTIONS(1768),
    [anon_sym_return] = ACTIONS(1768),
    [anon_sym_static] = ACTIONS(1768),
    [anon_sym_struct] = ACTIONS(1768),
    [anon_sym_trait] = ACTIONS(1768),
    [anon_sym_type] = ACTIONS(1768),
    [anon_sym_union] = ACTIONS(1768),
    [anon_sym_unsafe] = ACTIONS(1768),
    [anon_sym_use] = ACTIONS(1768),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_extern] = ACTIONS(1768),
    [anon_sym_yield] = ACTIONS(1768),
    [anon_sym_move] = ACTIONS(1768),
    [anon_sym_try] = ACTIONS(1768),
    [sym_integer_literal] = ACTIONS(1766),
    [aux_sym_string_literal_token1] = ACTIONS(1766),
    [sym_char_literal] = ACTIONS(1766),
    [anon_sym_true] = ACTIONS(1768),
    [anon_sym_false] = ACTIONS(1768),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1768),
    [sym_super] = ACTIONS(1768),
    [sym_crate] = ACTIONS(1768),
    [sym_metavariable] = ACTIONS(1766),
    [sym__raw_string_literal_start] = ACTIONS(1766),
    [sym_float_literal] = ACTIONS(1766),
  },
  [506] = {
    [sym_line_comment] = STATE(506),
    [sym_block_comment] = STATE(506),
    [ts_builtin_sym_end] = ACTIONS(1770),
    [sym_identifier] = ACTIONS(1772),
    [anon_sym_SEMI] = ACTIONS(1770),
    [anon_sym_macro_rules_BANG] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(1770),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(1770),
    [anon_sym_STAR] = ACTIONS(1770),
    [anon_sym_u8] = ACTIONS(1772),
    [anon_sym_i8] = ACTIONS(1772),
    [anon_sym_u16] = ACTIONS(1772),
    [anon_sym_i16] = ACTIONS(1772),
    [anon_sym_u32] = ACTIONS(1772),
    [anon_sym_i32] = ACTIONS(1772),
    [anon_sym_u64] = ACTIONS(1772),
    [anon_sym_i64] = ACTIONS(1772),
    [anon_sym_u128] = ACTIONS(1772),
    [anon_sym_i128] = ACTIONS(1772),
    [anon_sym_isize] = ACTIONS(1772),
    [anon_sym_usize] = ACTIONS(1772),
    [anon_sym_f32] = ACTIONS(1772),
    [anon_sym_f64] = ACTIONS(1772),
    [anon_sym_bool] = ACTIONS(1772),
    [anon_sym_str] = ACTIONS(1772),
    [anon_sym_char] = ACTIONS(1772),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1770),
    [anon_sym_AMP] = ACTIONS(1770),
    [anon_sym_PIPE] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1770),
    [anon_sym_DOT_DOT] = ACTIONS(1770),
    [anon_sym_COLON_COLON] = ACTIONS(1770),
    [anon_sym_POUND] = ACTIONS(1770),
    [anon_sym_SQUOTE] = ACTIONS(1772),
    [anon_sym_async] = ACTIONS(1772),
    [anon_sym_break] = ACTIONS(1772),
    [anon_sym_const] = ACTIONS(1772),
    [anon_sym_continue] = ACTIONS(1772),
    [anon_sym_default] = ACTIONS(1772),
    [anon_sym_enum] = ACTIONS(1772),
    [anon_sym_fn] = ACTIONS(1772),
    [anon_sym_for] = ACTIONS(1772),
    [anon_sym_if] = ACTIONS(1772),
    [anon_sym_impl] = ACTIONS(1772),
    [anon_sym_let] = ACTIONS(1772),
    [anon_sym_loop] = ACTIONS(1772),
    [anon_sym_match] = ACTIONS(1772),
    [anon_sym_mod] = ACTIONS(1772),
    [anon_sym_pub] = ACTIONS(1772),
    [anon_sym_return] = ACTIONS(1772),
    [anon_sym_static] = ACTIONS(1772),
    [anon_sym_struct] = ACTIONS(1772),
    [anon_sym_trait] = ACTIONS(1772),
    [anon_sym_type] = ACTIONS(1772),
    [anon_sym_union] = ACTIONS(1772),
    [anon_sym_unsafe] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1772),
    [anon_sym_while] = ACTIONS(1772),
    [anon_sym_extern] = ACTIONS(1772),
    [anon_sym_yield] = ACTIONS(1772),
    [anon_sym_move] = ACTIONS(1772),
    [anon_sym_try] = ACTIONS(1772),
    [sym_integer_literal] = ACTIONS(1770),
    [aux_sym_string_literal_token1] = ACTIONS(1770),
    [sym_char_literal] = ACTIONS(1770),
    [anon_sym_true] = ACTIONS(1772),
    [anon_sym_false] = ACTIONS(1772),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1772),
    [sym_super] = ACTIONS(1772),
    [sym_crate] = ACTIONS(1772),
    [sym_metavariable] = ACTIONS(1770),
    [sym__raw_string_literal_start] = ACTIONS(1770),
    [sym_float_literal] = ACTIONS(1770),
  },
  [507] = {
    [sym_line_comment] = STATE(507),
    [sym_block_comment] = STATE(507),
    [ts_builtin_sym_end] = ACTIONS(1774),
    [sym_identifier] = ACTIONS(1776),
    [anon_sym_SEMI] = ACTIONS(1774),
    [anon_sym_macro_rules_BANG] = ACTIONS(1774),
    [anon_sym_LPAREN] = ACTIONS(1774),
    [anon_sym_LBRACK] = ACTIONS(1774),
    [anon_sym_LBRACE] = ACTIONS(1774),
    [anon_sym_RBRACE] = ACTIONS(1774),
    [anon_sym_STAR] = ACTIONS(1774),
    [anon_sym_u8] = ACTIONS(1776),
    [anon_sym_i8] = ACTIONS(1776),
    [anon_sym_u16] = ACTIONS(1776),
    [anon_sym_i16] = ACTIONS(1776),
    [anon_sym_u32] = ACTIONS(1776),
    [anon_sym_i32] = ACTIONS(1776),
    [anon_sym_u64] = ACTIONS(1776),
    [anon_sym_i64] = ACTIONS(1776),
    [anon_sym_u128] = ACTIONS(1776),
    [anon_sym_i128] = ACTIONS(1776),
    [anon_sym_isize] = ACTIONS(1776),
    [anon_sym_usize] = ACTIONS(1776),
    [anon_sym_f32] = ACTIONS(1776),
    [anon_sym_f64] = ACTIONS(1776),
    [anon_sym_bool] = ACTIONS(1776),
    [anon_sym_str] = ACTIONS(1776),
    [anon_sym_char] = ACTIONS(1776),
    [anon_sym_DASH] = ACTIONS(1774),
    [anon_sym_BANG] = ACTIONS(1774),
    [anon_sym_AMP] = ACTIONS(1774),
    [anon_sym_PIPE] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(1774),
    [anon_sym_DOT_DOT] = ACTIONS(1774),
    [anon_sym_COLON_COLON] = ACTIONS(1774),
    [anon_sym_POUND] = ACTIONS(1774),
    [anon_sym_SQUOTE] = ACTIONS(1776),
    [anon_sym_async] = ACTIONS(1776),
    [anon_sym_break] = ACTIONS(1776),
    [anon_sym_const] = ACTIONS(1776),
    [anon_sym_continue] = ACTIONS(1776),
    [anon_sym_default] = ACTIONS(1776),
    [anon_sym_enum] = ACTIONS(1776),
    [anon_sym_fn] = ACTIONS(1776),
    [anon_sym_for] = ACTIONS(1776),
    [anon_sym_if] = ACTIONS(1776),
    [anon_sym_impl] = ACTIONS(1776),
    [anon_sym_let] = ACTIONS(1776),
    [anon_sym_loop] = ACTIONS(1776),
    [anon_sym_match] = ACTIONS(1776),
    [anon_sym_mod] = ACTIONS(1776),
    [anon_sym_pub] = ACTIONS(1776),
    [anon_sym_return] = ACTIONS(1776),
    [anon_sym_static] = ACTIONS(1776),
    [anon_sym_struct] = ACTIONS(1776),
    [anon_sym_trait] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1776),
    [anon_sym_union] = ACTIONS(1776),
    [anon_sym_unsafe] = ACTIONS(1776),
    [anon_sym_use] = ACTIONS(1776),
    [anon_sym_while] = ACTIONS(1776),
    [anon_sym_extern] = ACTIONS(1776),
    [anon_sym_yield] = ACTIONS(1776),
    [anon_sym_move] = ACTIONS(1776),
    [anon_sym_try] = ACTIONS(1776),
    [sym_integer_literal] = ACTIONS(1774),
    [aux_sym_string_literal_token1] = ACTIONS(1774),
    [sym_char_literal] = ACTIONS(1774),
    [anon_sym_true] = ACTIONS(1776),
    [anon_sym_false] = ACTIONS(1776),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1776),
    [sym_super] = ACTIONS(1776),
    [sym_crate] = ACTIONS(1776),
    [sym_metavariable] = ACTIONS(1774),
    [sym__raw_string_literal_start] = ACTIONS(1774),
    [sym_float_literal] = ACTIONS(1774),
  },
  [508] = {
    [sym_line_comment] = STATE(508),
    [sym_block_comment] = STATE(508),
    [ts_builtin_sym_end] = ACTIONS(1778),
    [sym_identifier] = ACTIONS(1780),
    [anon_sym_SEMI] = ACTIONS(1778),
    [anon_sym_macro_rules_BANG] = ACTIONS(1778),
    [anon_sym_LPAREN] = ACTIONS(1778),
    [anon_sym_LBRACK] = ACTIONS(1778),
    [anon_sym_LBRACE] = ACTIONS(1778),
    [anon_sym_RBRACE] = ACTIONS(1778),
    [anon_sym_STAR] = ACTIONS(1778),
    [anon_sym_u8] = ACTIONS(1780),
    [anon_sym_i8] = ACTIONS(1780),
    [anon_sym_u16] = ACTIONS(1780),
    [anon_sym_i16] = ACTIONS(1780),
    [anon_sym_u32] = ACTIONS(1780),
    [anon_sym_i32] = ACTIONS(1780),
    [anon_sym_u64] = ACTIONS(1780),
    [anon_sym_i64] = ACTIONS(1780),
    [anon_sym_u128] = ACTIONS(1780),
    [anon_sym_i128] = ACTIONS(1780),
    [anon_sym_isize] = ACTIONS(1780),
    [anon_sym_usize] = ACTIONS(1780),
    [anon_sym_f32] = ACTIONS(1780),
    [anon_sym_f64] = ACTIONS(1780),
    [anon_sym_bool] = ACTIONS(1780),
    [anon_sym_str] = ACTIONS(1780),
    [anon_sym_char] = ACTIONS(1780),
    [anon_sym_DASH] = ACTIONS(1778),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_AMP] = ACTIONS(1778),
    [anon_sym_PIPE] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1778),
    [anon_sym_COLON_COLON] = ACTIONS(1778),
    [anon_sym_POUND] = ACTIONS(1778),
    [anon_sym_SQUOTE] = ACTIONS(1780),
    [anon_sym_async] = ACTIONS(1780),
    [anon_sym_break] = ACTIONS(1780),
    [anon_sym_const] = ACTIONS(1780),
    [anon_sym_continue] = ACTIONS(1780),
    [anon_sym_default] = ACTIONS(1780),
    [anon_sym_enum] = ACTIONS(1780),
    [anon_sym_fn] = ACTIONS(1780),
    [anon_sym_for] = ACTIONS(1780),
    [anon_sym_if] = ACTIONS(1780),
    [anon_sym_impl] = ACTIONS(1780),
    [anon_sym_let] = ACTIONS(1780),
    [anon_sym_loop] = ACTIONS(1780),
    [anon_sym_match] = ACTIONS(1780),
    [anon_sym_mod] = ACTIONS(1780),
    [anon_sym_pub] = ACTIONS(1780),
    [anon_sym_return] = ACTIONS(1780),
    [anon_sym_static] = ACTIONS(1780),
    [anon_sym_struct] = ACTIONS(1780),
    [anon_sym_trait] = ACTIONS(1780),
    [anon_sym_type] = ACTIONS(1780),
    [anon_sym_union] = ACTIONS(1780),
    [anon_sym_unsafe] = ACTIONS(1780),
    [anon_sym_use] = ACTIONS(1780),
    [anon_sym_while] = ACTIONS(1780),
    [anon_sym_extern] = ACTIONS(1780),
    [anon_sym_yield] = ACTIONS(1780),
    [anon_sym_move] = ACTIONS(1780),
    [anon_sym_try] = ACTIONS(1780),
    [sym_integer_literal] = ACTIONS(1778),
    [aux_sym_string_literal_token1] = ACTIONS(1778),
    [sym_char_literal] = ACTIONS(1778),
    [anon_sym_true] = ACTIONS(1780),
    [anon_sym_false] = ACTIONS(1780),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1780),
    [sym_super] = ACTIONS(1780),
    [sym_crate] = ACTIONS(1780),
    [sym_metavariable] = ACTIONS(1778),
    [sym__raw_string_literal_start] = ACTIONS(1778),
    [sym_float_literal] = ACTIONS(1778),
  },
  [509] = {
    [sym_line_comment] = STATE(509),
    [sym_block_comment] = STATE(509),
    [ts_builtin_sym_end] = ACTIONS(1782),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_SEMI] = ACTIONS(1782),
    [anon_sym_macro_rules_BANG] = ACTIONS(1782),
    [anon_sym_LPAREN] = ACTIONS(1782),
    [anon_sym_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_RBRACE] = ACTIONS(1782),
    [anon_sym_STAR] = ACTIONS(1782),
    [anon_sym_u8] = ACTIONS(1784),
    [anon_sym_i8] = ACTIONS(1784),
    [anon_sym_u16] = ACTIONS(1784),
    [anon_sym_i16] = ACTIONS(1784),
    [anon_sym_u32] = ACTIONS(1784),
    [anon_sym_i32] = ACTIONS(1784),
    [anon_sym_u64] = ACTIONS(1784),
    [anon_sym_i64] = ACTIONS(1784),
    [anon_sym_u128] = ACTIONS(1784),
    [anon_sym_i128] = ACTIONS(1784),
    [anon_sym_isize] = ACTIONS(1784),
    [anon_sym_usize] = ACTIONS(1784),
    [anon_sym_f32] = ACTIONS(1784),
    [anon_sym_f64] = ACTIONS(1784),
    [anon_sym_bool] = ACTIONS(1784),
    [anon_sym_str] = ACTIONS(1784),
    [anon_sym_char] = ACTIONS(1784),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_AMP] = ACTIONS(1782),
    [anon_sym_PIPE] = ACTIONS(1782),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_DOT_DOT] = ACTIONS(1782),
    [anon_sym_COLON_COLON] = ACTIONS(1782),
    [anon_sym_POUND] = ACTIONS(1782),
    [anon_sym_SQUOTE] = ACTIONS(1784),
    [anon_sym_async] = ACTIONS(1784),
    [anon_sym_break] = ACTIONS(1784),
    [anon_sym_const] = ACTIONS(1784),
    [anon_sym_continue] = ACTIONS(1784),
    [anon_sym_default] = ACTIONS(1784),
    [anon_sym_enum] = ACTIONS(1784),
    [anon_sym_fn] = ACTIONS(1784),
    [anon_sym_for] = ACTIONS(1784),
    [anon_sym_if] = ACTIONS(1784),
    [anon_sym_impl] = ACTIONS(1784),
    [anon_sym_let] = ACTIONS(1784),
    [anon_sym_loop] = ACTIONS(1784),
    [anon_sym_match] = ACTIONS(1784),
    [anon_sym_mod] = ACTIONS(1784),
    [anon_sym_pub] = ACTIONS(1784),
    [anon_sym_return] = ACTIONS(1784),
    [anon_sym_static] = ACTIONS(1784),
    [anon_sym_struct] = ACTIONS(1784),
    [anon_sym_trait] = ACTIONS(1784),
    [anon_sym_type] = ACTIONS(1784),
    [anon_sym_union] = ACTIONS(1784),
    [anon_sym_unsafe] = ACTIONS(1784),
    [anon_sym_use] = ACTIONS(1784),
    [anon_sym_while] = ACTIONS(1784),
    [anon_sym_extern] = ACTIONS(1784),
    [anon_sym_yield] = ACTIONS(1784),
    [anon_sym_move] = ACTIONS(1784),
    [anon_sym_try] = ACTIONS(1784),
    [sym_integer_literal] = ACTIONS(1782),
    [aux_sym_string_literal_token1] = ACTIONS(1782),
    [sym_char_literal] = ACTIONS(1782),
    [anon_sym_true] = ACTIONS(1784),
    [anon_sym_false] = ACTIONS(1784),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1784),
    [sym_super] = ACTIONS(1784),
    [sym_crate] = ACTIONS(1784),
    [sym_metavariable] = ACTIONS(1782),
    [sym__raw_string_literal_start] = ACTIONS(1782),
    [sym_float_literal] = ACTIONS(1782),
  },
  [510] = {
    [sym_line_comment] = STATE(510),
    [sym_block_comment] = STATE(510),
    [ts_builtin_sym_end] = ACTIONS(1786),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_SEMI] = ACTIONS(1786),
    [anon_sym_macro_rules_BANG] = ACTIONS(1786),
    [anon_sym_LPAREN] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(1786),
    [anon_sym_RBRACE] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(1788),
    [anon_sym_i8] = ACTIONS(1788),
    [anon_sym_u16] = ACTIONS(1788),
    [anon_sym_i16] = ACTIONS(1788),
    [anon_sym_u32] = ACTIONS(1788),
    [anon_sym_i32] = ACTIONS(1788),
    [anon_sym_u64] = ACTIONS(1788),
    [anon_sym_i64] = ACTIONS(1788),
    [anon_sym_u128] = ACTIONS(1788),
    [anon_sym_i128] = ACTIONS(1788),
    [anon_sym_isize] = ACTIONS(1788),
    [anon_sym_usize] = ACTIONS(1788),
    [anon_sym_f32] = ACTIONS(1788),
    [anon_sym_f64] = ACTIONS(1788),
    [anon_sym_bool] = ACTIONS(1788),
    [anon_sym_str] = ACTIONS(1788),
    [anon_sym_char] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1786),
    [anon_sym_BANG] = ACTIONS(1786),
    [anon_sym_AMP] = ACTIONS(1786),
    [anon_sym_PIPE] = ACTIONS(1786),
    [anon_sym_LT] = ACTIONS(1786),
    [anon_sym_DOT_DOT] = ACTIONS(1786),
    [anon_sym_COLON_COLON] = ACTIONS(1786),
    [anon_sym_POUND] = ACTIONS(1786),
    [anon_sym_SQUOTE] = ACTIONS(1788),
    [anon_sym_async] = ACTIONS(1788),
    [anon_sym_break] = ACTIONS(1788),
    [anon_sym_const] = ACTIONS(1788),
    [anon_sym_continue] = ACTIONS(1788),
    [anon_sym_default] = ACTIONS(1788),
    [anon_sym_enum] = ACTIONS(1788),
    [anon_sym_fn] = ACTIONS(1788),
    [anon_sym_for] = ACTIONS(1788),
    [anon_sym_if] = ACTIONS(1788),
    [anon_sym_impl] = ACTIONS(1788),
    [anon_sym_let] = ACTIONS(1788),
    [anon_sym_loop] = ACTIONS(1788),
    [anon_sym_match] = ACTIONS(1788),
    [anon_sym_mod] = ACTIONS(1788),
    [anon_sym_pub] = ACTIONS(1788),
    [anon_sym_return] = ACTIONS(1788),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_struct] = ACTIONS(1788),
    [anon_sym_trait] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_union] = ACTIONS(1788),
    [anon_sym_unsafe] = ACTIONS(1788),
    [anon_sym_use] = ACTIONS(1788),
    [anon_sym_while] = ACTIONS(1788),
    [anon_sym_extern] = ACTIONS(1788),
    [anon_sym_yield] = ACTIONS(1788),
    [anon_sym_move] = ACTIONS(1788),
    [anon_sym_try] = ACTIONS(1788),
    [sym_integer_literal] = ACTIONS(1786),
    [aux_sym_string_literal_token1] = ACTIONS(1786),
    [sym_char_literal] = ACTIONS(1786),
    [anon_sym_true] = ACTIONS(1788),
    [anon_sym_false] = ACTIONS(1788),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1788),
    [sym_super] = ACTIONS(1788),
    [sym_crate] = ACTIONS(1788),
    [sym_metavariable] = ACTIONS(1786),
    [sym__raw_string_literal_start] = ACTIONS(1786),
    [sym_float_literal] = ACTIONS(1786),
  },
  [511] = {
    [sym_line_comment] = STATE(511),
    [sym_block_comment] = STATE(511),
    [ts_builtin_sym_end] = ACTIONS(1790),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_macro_rules_BANG] = ACTIONS(1790),
    [anon_sym_LPAREN] = ACTIONS(1790),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_LBRACE] = ACTIONS(1790),
    [anon_sym_RBRACE] = ACTIONS(1790),
    [anon_sym_STAR] = ACTIONS(1790),
    [anon_sym_u8] = ACTIONS(1792),
    [anon_sym_i8] = ACTIONS(1792),
    [anon_sym_u16] = ACTIONS(1792),
    [anon_sym_i16] = ACTIONS(1792),
    [anon_sym_u32] = ACTIONS(1792),
    [anon_sym_i32] = ACTIONS(1792),
    [anon_sym_u64] = ACTIONS(1792),
    [anon_sym_i64] = ACTIONS(1792),
    [anon_sym_u128] = ACTIONS(1792),
    [anon_sym_i128] = ACTIONS(1792),
    [anon_sym_isize] = ACTIONS(1792),
    [anon_sym_usize] = ACTIONS(1792),
    [anon_sym_f32] = ACTIONS(1792),
    [anon_sym_f64] = ACTIONS(1792),
    [anon_sym_bool] = ACTIONS(1792),
    [anon_sym_str] = ACTIONS(1792),
    [anon_sym_char] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(1790),
    [anon_sym_BANG] = ACTIONS(1790),
    [anon_sym_AMP] = ACTIONS(1790),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(1790),
    [anon_sym_DOT_DOT] = ACTIONS(1790),
    [anon_sym_COLON_COLON] = ACTIONS(1790),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_SQUOTE] = ACTIONS(1792),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_break] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1792),
    [anon_sym_continue] = ACTIONS(1792),
    [anon_sym_default] = ACTIONS(1792),
    [anon_sym_enum] = ACTIONS(1792),
    [anon_sym_fn] = ACTIONS(1792),
    [anon_sym_for] = ACTIONS(1792),
    [anon_sym_if] = ACTIONS(1792),
    [anon_sym_impl] = ACTIONS(1792),
    [anon_sym_let] = ACTIONS(1792),
    [anon_sym_loop] = ACTIONS(1792),
    [anon_sym_match] = ACTIONS(1792),
    [anon_sym_mod] = ACTIONS(1792),
    [anon_sym_pub] = ACTIONS(1792),
    [anon_sym_return] = ACTIONS(1792),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(1792),
    [anon_sym_trait] = ACTIONS(1792),
    [anon_sym_type] = ACTIONS(1792),
    [anon_sym_union] = ACTIONS(1792),
    [anon_sym_unsafe] = ACTIONS(1792),
    [anon_sym_use] = ACTIONS(1792),
    [anon_sym_while] = ACTIONS(1792),
    [anon_sym_extern] = ACTIONS(1792),
    [anon_sym_yield] = ACTIONS(1792),
    [anon_sym_move] = ACTIONS(1792),
    [anon_sym_try] = ACTIONS(1792),
    [sym_integer_literal] = ACTIONS(1790),
    [aux_sym_string_literal_token1] = ACTIONS(1790),
    [sym_char_literal] = ACTIONS(1790),
    [anon_sym_true] = ACTIONS(1792),
    [anon_sym_false] = ACTIONS(1792),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1792),
    [sym_super] = ACTIONS(1792),
    [sym_crate] = ACTIONS(1792),
    [sym_metavariable] = ACTIONS(1790),
    [sym__raw_string_literal_start] = ACTIONS(1790),
    [sym_float_literal] = ACTIONS(1790),
  },
  [512] = {
    [sym_line_comment] = STATE(512),
    [sym_block_comment] = STATE(512),
    [ts_builtin_sym_end] = ACTIONS(1794),
    [sym_identifier] = ACTIONS(1796),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_macro_rules_BANG] = ACTIONS(1794),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_LBRACE] = ACTIONS(1794),
    [anon_sym_RBRACE] = ACTIONS(1794),
    [anon_sym_STAR] = ACTIONS(1794),
    [anon_sym_u8] = ACTIONS(1796),
    [anon_sym_i8] = ACTIONS(1796),
    [anon_sym_u16] = ACTIONS(1796),
    [anon_sym_i16] = ACTIONS(1796),
    [anon_sym_u32] = ACTIONS(1796),
    [anon_sym_i32] = ACTIONS(1796),
    [anon_sym_u64] = ACTIONS(1796),
    [anon_sym_i64] = ACTIONS(1796),
    [anon_sym_u128] = ACTIONS(1796),
    [anon_sym_i128] = ACTIONS(1796),
    [anon_sym_isize] = ACTIONS(1796),
    [anon_sym_usize] = ACTIONS(1796),
    [anon_sym_f32] = ACTIONS(1796),
    [anon_sym_f64] = ACTIONS(1796),
    [anon_sym_bool] = ACTIONS(1796),
    [anon_sym_str] = ACTIONS(1796),
    [anon_sym_char] = ACTIONS(1796),
    [anon_sym_DASH] = ACTIONS(1794),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_AMP] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(1794),
    [anon_sym_COLON_COLON] = ACTIONS(1794),
    [anon_sym_POUND] = ACTIONS(1794),
    [anon_sym_SQUOTE] = ACTIONS(1796),
    [anon_sym_async] = ACTIONS(1796),
    [anon_sym_break] = ACTIONS(1796),
    [anon_sym_const] = ACTIONS(1796),
    [anon_sym_continue] = ACTIONS(1796),
    [anon_sym_default] = ACTIONS(1796),
    [anon_sym_enum] = ACTIONS(1796),
    [anon_sym_fn] = ACTIONS(1796),
    [anon_sym_for] = ACTIONS(1796),
    [anon_sym_if] = ACTIONS(1796),
    [anon_sym_impl] = ACTIONS(1796),
    [anon_sym_let] = ACTIONS(1796),
    [anon_sym_loop] = ACTIONS(1796),
    [anon_sym_match] = ACTIONS(1796),
    [anon_sym_mod] = ACTIONS(1796),
    [anon_sym_pub] = ACTIONS(1796),
    [anon_sym_return] = ACTIONS(1796),
    [anon_sym_static] = ACTIONS(1796),
    [anon_sym_struct] = ACTIONS(1796),
    [anon_sym_trait] = ACTIONS(1796),
    [anon_sym_type] = ACTIONS(1796),
    [anon_sym_union] = ACTIONS(1796),
    [anon_sym_unsafe] = ACTIONS(1796),
    [anon_sym_use] = ACTIONS(1796),
    [anon_sym_while] = ACTIONS(1796),
    [anon_sym_extern] = ACTIONS(1796),
    [anon_sym_yield] = ACTIONS(1796),
    [anon_sym_move] = ACTIONS(1796),
    [anon_sym_try] = ACTIONS(1796),
    [sym_integer_literal] = ACTIONS(1794),
    [aux_sym_string_literal_token1] = ACTIONS(1794),
    [sym_char_literal] = ACTIONS(1794),
    [anon_sym_true] = ACTIONS(1796),
    [anon_sym_false] = ACTIONS(1796),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1796),
    [sym_super] = ACTIONS(1796),
    [sym_crate] = ACTIONS(1796),
    [sym_metavariable] = ACTIONS(1794),
    [sym__raw_string_literal_start] = ACTIONS(1794),
    [sym_float_literal] = ACTIONS(1794),
  },
  [513] = {
    [sym_line_comment] = STATE(513),
    [sym_block_comment] = STATE(513),
    [ts_builtin_sym_end] = ACTIONS(1798),
    [sym_identifier] = ACTIONS(1800),
    [anon_sym_SEMI] = ACTIONS(1798),
    [anon_sym_macro_rules_BANG] = ACTIONS(1798),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_u8] = ACTIONS(1800),
    [anon_sym_i8] = ACTIONS(1800),
    [anon_sym_u16] = ACTIONS(1800),
    [anon_sym_i16] = ACTIONS(1800),
    [anon_sym_u32] = ACTIONS(1800),
    [anon_sym_i32] = ACTIONS(1800),
    [anon_sym_u64] = ACTIONS(1800),
    [anon_sym_i64] = ACTIONS(1800),
    [anon_sym_u128] = ACTIONS(1800),
    [anon_sym_i128] = ACTIONS(1800),
    [anon_sym_isize] = ACTIONS(1800),
    [anon_sym_usize] = ACTIONS(1800),
    [anon_sym_f32] = ACTIONS(1800),
    [anon_sym_f64] = ACTIONS(1800),
    [anon_sym_bool] = ACTIONS(1800),
    [anon_sym_str] = ACTIONS(1800),
    [anon_sym_char] = ACTIONS(1800),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_BANG] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1798),
    [anon_sym_LT] = ACTIONS(1798),
    [anon_sym_DOT_DOT] = ACTIONS(1798),
    [anon_sym_COLON_COLON] = ACTIONS(1798),
    [anon_sym_POUND] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1800),
    [anon_sym_async] = ACTIONS(1800),
    [anon_sym_break] = ACTIONS(1800),
    [anon_sym_const] = ACTIONS(1800),
    [anon_sym_continue] = ACTIONS(1800),
    [anon_sym_default] = ACTIONS(1800),
    [anon_sym_enum] = ACTIONS(1800),
    [anon_sym_fn] = ACTIONS(1800),
    [anon_sym_for] = ACTIONS(1800),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_impl] = ACTIONS(1800),
    [anon_sym_let] = ACTIONS(1800),
    [anon_sym_loop] = ACTIONS(1800),
    [anon_sym_match] = ACTIONS(1800),
    [anon_sym_mod] = ACTIONS(1800),
    [anon_sym_pub] = ACTIONS(1800),
    [anon_sym_return] = ACTIONS(1800),
    [anon_sym_static] = ACTIONS(1800),
    [anon_sym_struct] = ACTIONS(1800),
    [anon_sym_trait] = ACTIONS(1800),
    [anon_sym_type] = ACTIONS(1800),
    [anon_sym_union] = ACTIONS(1800),
    [anon_sym_unsafe] = ACTIONS(1800),
    [anon_sym_use] = ACTIONS(1800),
    [anon_sym_while] = ACTIONS(1800),
    [anon_sym_extern] = ACTIONS(1800),
    [anon_sym_yield] = ACTIONS(1800),
    [anon_sym_move] = ACTIONS(1800),
    [anon_sym_try] = ACTIONS(1800),
    [sym_integer_literal] = ACTIONS(1798),
    [aux_sym_string_literal_token1] = ACTIONS(1798),
    [sym_char_literal] = ACTIONS(1798),
    [anon_sym_true] = ACTIONS(1800),
    [anon_sym_false] = ACTIONS(1800),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1800),
    [sym_super] = ACTIONS(1800),
    [sym_crate] = ACTIONS(1800),
    [sym_metavariable] = ACTIONS(1798),
    [sym__raw_string_literal_start] = ACTIONS(1798),
    [sym_float_literal] = ACTIONS(1798),
  },
  [514] = {
    [sym_line_comment] = STATE(514),
    [sym_block_comment] = STATE(514),
    [ts_builtin_sym_end] = ACTIONS(1802),
    [sym_identifier] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1802),
    [anon_sym_macro_rules_BANG] = ACTIONS(1802),
    [anon_sym_LPAREN] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACE] = ACTIONS(1802),
    [anon_sym_RBRACE] = ACTIONS(1802),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_u8] = ACTIONS(1804),
    [anon_sym_i8] = ACTIONS(1804),
    [anon_sym_u16] = ACTIONS(1804),
    [anon_sym_i16] = ACTIONS(1804),
    [anon_sym_u32] = ACTIONS(1804),
    [anon_sym_i32] = ACTIONS(1804),
    [anon_sym_u64] = ACTIONS(1804),
    [anon_sym_i64] = ACTIONS(1804),
    [anon_sym_u128] = ACTIONS(1804),
    [anon_sym_i128] = ACTIONS(1804),
    [anon_sym_isize] = ACTIONS(1804),
    [anon_sym_usize] = ACTIONS(1804),
    [anon_sym_f32] = ACTIONS(1804),
    [anon_sym_f64] = ACTIONS(1804),
    [anon_sym_bool] = ACTIONS(1804),
    [anon_sym_str] = ACTIONS(1804),
    [anon_sym_char] = ACTIONS(1804),
    [anon_sym_DASH] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(1802),
    [anon_sym_AMP] = ACTIONS(1802),
    [anon_sym_PIPE] = ACTIONS(1802),
    [anon_sym_LT] = ACTIONS(1802),
    [anon_sym_DOT_DOT] = ACTIONS(1802),
    [anon_sym_COLON_COLON] = ACTIONS(1802),
    [anon_sym_POUND] = ACTIONS(1802),
    [anon_sym_SQUOTE] = ACTIONS(1804),
    [anon_sym_async] = ACTIONS(1804),
    [anon_sym_break] = ACTIONS(1804),
    [anon_sym_const] = ACTIONS(1804),
    [anon_sym_continue] = ACTIONS(1804),
    [anon_sym_default] = ACTIONS(1804),
    [anon_sym_enum] = ACTIONS(1804),
    [anon_sym_fn] = ACTIONS(1804),
    [anon_sym_for] = ACTIONS(1804),
    [anon_sym_if] = ACTIONS(1804),
    [anon_sym_impl] = ACTIONS(1804),
    [anon_sym_let] = ACTIONS(1804),
    [anon_sym_loop] = ACTIONS(1804),
    [anon_sym_match] = ACTIONS(1804),
    [anon_sym_mod] = ACTIONS(1804),
    [anon_sym_pub] = ACTIONS(1804),
    [anon_sym_return] = ACTIONS(1804),
    [anon_sym_static] = ACTIONS(1804),
    [anon_sym_struct] = ACTIONS(1804),
    [anon_sym_trait] = ACTIONS(1804),
    [anon_sym_type] = ACTIONS(1804),
    [anon_sym_union] = ACTIONS(1804),
    [anon_sym_unsafe] = ACTIONS(1804),
    [anon_sym_use] = ACTIONS(1804),
    [anon_sym_while] = ACTIONS(1804),
    [anon_sym_extern] = ACTIONS(1804),
    [anon_sym_yield] = ACTIONS(1804),
    [anon_sym_move] = ACTIONS(1804),
    [anon_sym_try] = ACTIONS(1804),
    [sym_integer_literal] = ACTIONS(1802),
    [aux_sym_string_literal_token1] = ACTIONS(1802),
    [sym_char_literal] = ACTIONS(1802),
    [anon_sym_true] = ACTIONS(1804),
    [anon_sym_false] = ACTIONS(1804),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1804),
    [sym_super] = ACTIONS(1804),
    [sym_crate] = ACTIONS(1804),
    [sym_metavariable] = ACTIONS(1802),
    [sym__raw_string_literal_start] = ACTIONS(1802),
    [sym_float_literal] = ACTIONS(1802),
  },
  [515] = {
    [sym_line_comment] = STATE(515),
    [sym_block_comment] = STATE(515),
    [ts_builtin_sym_end] = ACTIONS(1806),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_SEMI] = ACTIONS(1806),
    [anon_sym_macro_rules_BANG] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(1806),
    [anon_sym_RBRACE] = ACTIONS(1806),
    [anon_sym_STAR] = ACTIONS(1806),
    [anon_sym_u8] = ACTIONS(1808),
    [anon_sym_i8] = ACTIONS(1808),
    [anon_sym_u16] = ACTIONS(1808),
    [anon_sym_i16] = ACTIONS(1808),
    [anon_sym_u32] = ACTIONS(1808),
    [anon_sym_i32] = ACTIONS(1808),
    [anon_sym_u64] = ACTIONS(1808),
    [anon_sym_i64] = ACTIONS(1808),
    [anon_sym_u128] = ACTIONS(1808),
    [anon_sym_i128] = ACTIONS(1808),
    [anon_sym_isize] = ACTIONS(1808),
    [anon_sym_usize] = ACTIONS(1808),
    [anon_sym_f32] = ACTIONS(1808),
    [anon_sym_f64] = ACTIONS(1808),
    [anon_sym_bool] = ACTIONS(1808),
    [anon_sym_str] = ACTIONS(1808),
    [anon_sym_char] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(1806),
    [anon_sym_BANG] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_PIPE] = ACTIONS(1806),
    [anon_sym_LT] = ACTIONS(1806),
    [anon_sym_DOT_DOT] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_POUND] = ACTIONS(1806),
    [anon_sym_SQUOTE] = ACTIONS(1808),
    [anon_sym_async] = ACTIONS(1808),
    [anon_sym_break] = ACTIONS(1808),
    [anon_sym_const] = ACTIONS(1808),
    [anon_sym_continue] = ACTIONS(1808),
    [anon_sym_default] = ACTIONS(1808),
    [anon_sym_enum] = ACTIONS(1808),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_for] = ACTIONS(1808),
    [anon_sym_if] = ACTIONS(1808),
    [anon_sym_impl] = ACTIONS(1808),
    [anon_sym_let] = ACTIONS(1808),
    [anon_sym_loop] = ACTIONS(1808),
    [anon_sym_match] = ACTIONS(1808),
    [anon_sym_mod] = ACTIONS(1808),
    [anon_sym_pub] = ACTIONS(1808),
    [anon_sym_return] = ACTIONS(1808),
    [anon_sym_static] = ACTIONS(1808),
    [anon_sym_struct] = ACTIONS(1808),
    [anon_sym_trait] = ACTIONS(1808),
    [anon_sym_type] = ACTIONS(1808),
    [anon_sym_union] = ACTIONS(1808),
    [anon_sym_unsafe] = ACTIONS(1808),
    [anon_sym_use] = ACTIONS(1808),
    [anon_sym_while] = ACTIONS(1808),
    [anon_sym_extern] = ACTIONS(1808),
    [anon_sym_yield] = ACTIONS(1808),
    [anon_sym_move] = ACTIONS(1808),
    [anon_sym_try] = ACTIONS(1808),
    [sym_integer_literal] = ACTIONS(1806),
    [aux_sym_string_literal_token1] = ACTIONS(1806),
    [sym_char_literal] = ACTIONS(1806),
    [anon_sym_true] = ACTIONS(1808),
    [anon_sym_false] = ACTIONS(1808),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1808),
    [sym_super] = ACTIONS(1808),
    [sym_crate] = ACTIONS(1808),
    [sym_metavariable] = ACTIONS(1806),
    [sym__raw_string_literal_start] = ACTIONS(1806),
    [sym_float_literal] = ACTIONS(1806),
  },
  [516] = {
    [sym_line_comment] = STATE(516),
    [sym_block_comment] = STATE(516),
    [ts_builtin_sym_end] = ACTIONS(1810),
    [sym_identifier] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1810),
    [anon_sym_macro_rules_BANG] = ACTIONS(1810),
    [anon_sym_LPAREN] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(1810),
    [anon_sym_LBRACE] = ACTIONS(1810),
    [anon_sym_RBRACE] = ACTIONS(1810),
    [anon_sym_STAR] = ACTIONS(1810),
    [anon_sym_u8] = ACTIONS(1812),
    [anon_sym_i8] = ACTIONS(1812),
    [anon_sym_u16] = ACTIONS(1812),
    [anon_sym_i16] = ACTIONS(1812),
    [anon_sym_u32] = ACTIONS(1812),
    [anon_sym_i32] = ACTIONS(1812),
    [anon_sym_u64] = ACTIONS(1812),
    [anon_sym_i64] = ACTIONS(1812),
    [anon_sym_u128] = ACTIONS(1812),
    [anon_sym_i128] = ACTIONS(1812),
    [anon_sym_isize] = ACTIONS(1812),
    [anon_sym_usize] = ACTIONS(1812),
    [anon_sym_f32] = ACTIONS(1812),
    [anon_sym_f64] = ACTIONS(1812),
    [anon_sym_bool] = ACTIONS(1812),
    [anon_sym_str] = ACTIONS(1812),
    [anon_sym_char] = ACTIONS(1812),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE] = ACTIONS(1810),
    [anon_sym_LT] = ACTIONS(1810),
    [anon_sym_DOT_DOT] = ACTIONS(1810),
    [anon_sym_COLON_COLON] = ACTIONS(1810),
    [anon_sym_POUND] = ACTIONS(1810),
    [anon_sym_SQUOTE] = ACTIONS(1812),
    [anon_sym_async] = ACTIONS(1812),
    [anon_sym_break] = ACTIONS(1812),
    [anon_sym_const] = ACTIONS(1812),
    [anon_sym_continue] = ACTIONS(1812),
    [anon_sym_default] = ACTIONS(1812),
    [anon_sym_enum] = ACTIONS(1812),
    [anon_sym_fn] = ACTIONS(1812),
    [anon_sym_for] = ACTIONS(1812),
    [anon_sym_if] = ACTIONS(1812),
    [anon_sym_impl] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1812),
    [anon_sym_loop] = ACTIONS(1812),
    [anon_sym_match] = ACTIONS(1812),
    [anon_sym_mod] = ACTIONS(1812),
    [anon_sym_pub] = ACTIONS(1812),
    [anon_sym_return] = ACTIONS(1812),
    [anon_sym_static] = ACTIONS(1812),
    [anon_sym_struct] = ACTIONS(1812),
    [anon_sym_trait] = ACTIONS(1812),
    [anon_sym_type] = ACTIONS(1812),
    [anon_sym_union] = ACTIONS(1812),
    [anon_sym_unsafe] = ACTIONS(1812),
    [anon_sym_use] = ACTIONS(1812),
    [anon_sym_while] = ACTIONS(1812),
    [anon_sym_extern] = ACTIONS(1812),
    [anon_sym_yield] = ACTIONS(1812),
    [anon_sym_move] = ACTIONS(1812),
    [anon_sym_try] = ACTIONS(1812),
    [sym_integer_literal] = ACTIONS(1810),
    [aux_sym_string_literal_token1] = ACTIONS(1810),
    [sym_char_literal] = ACTIONS(1810),
    [anon_sym_true] = ACTIONS(1812),
    [anon_sym_false] = ACTIONS(1812),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1812),
    [sym_super] = ACTIONS(1812),
    [sym_crate] = ACTIONS(1812),
    [sym_metavariable] = ACTIONS(1810),
    [sym__raw_string_literal_start] = ACTIONS(1810),
    [sym_float_literal] = ACTIONS(1810),
  },
  [517] = {
    [sym_line_comment] = STATE(517),
    [sym_block_comment] = STATE(517),
    [ts_builtin_sym_end] = ACTIONS(1814),
    [sym_identifier] = ACTIONS(1816),
    [anon_sym_SEMI] = ACTIONS(1814),
    [anon_sym_macro_rules_BANG] = ACTIONS(1814),
    [anon_sym_LPAREN] = ACTIONS(1814),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(1814),
    [anon_sym_RBRACE] = ACTIONS(1814),
    [anon_sym_STAR] = ACTIONS(1814),
    [anon_sym_u8] = ACTIONS(1816),
    [anon_sym_i8] = ACTIONS(1816),
    [anon_sym_u16] = ACTIONS(1816),
    [anon_sym_i16] = ACTIONS(1816),
    [anon_sym_u32] = ACTIONS(1816),
    [anon_sym_i32] = ACTIONS(1816),
    [anon_sym_u64] = ACTIONS(1816),
    [anon_sym_i64] = ACTIONS(1816),
    [anon_sym_u128] = ACTIONS(1816),
    [anon_sym_i128] = ACTIONS(1816),
    [anon_sym_isize] = ACTIONS(1816),
    [anon_sym_usize] = ACTIONS(1816),
    [anon_sym_f32] = ACTIONS(1816),
    [anon_sym_f64] = ACTIONS(1816),
    [anon_sym_bool] = ACTIONS(1816),
    [anon_sym_str] = ACTIONS(1816),
    [anon_sym_char] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1814),
    [anon_sym_BANG] = ACTIONS(1814),
    [anon_sym_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1814),
    [anon_sym_LT] = ACTIONS(1814),
    [anon_sym_DOT_DOT] = ACTIONS(1814),
    [anon_sym_COLON_COLON] = ACTIONS(1814),
    [anon_sym_POUND] = ACTIONS(1814),
    [anon_sym_SQUOTE] = ACTIONS(1816),
    [anon_sym_async] = ACTIONS(1816),
    [anon_sym_break] = ACTIONS(1816),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_continue] = ACTIONS(1816),
    [anon_sym_default] = ACTIONS(1816),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_fn] = ACTIONS(1816),
    [anon_sym_for] = ACTIONS(1816),
    [anon_sym_if] = ACTIONS(1816),
    [anon_sym_impl] = ACTIONS(1816),
    [anon_sym_let] = ACTIONS(1816),
    [anon_sym_loop] = ACTIONS(1816),
    [anon_sym_match] = ACTIONS(1816),
    [anon_sym_mod] = ACTIONS(1816),
    [anon_sym_pub] = ACTIONS(1816),
    [anon_sym_return] = ACTIONS(1816),
    [anon_sym_static] = ACTIONS(1816),
    [anon_sym_struct] = ACTIONS(1816),
    [anon_sym_trait] = ACTIONS(1816),
    [anon_sym_type] = ACTIONS(1816),
    [anon_sym_union] = ACTIONS(1816),
    [anon_sym_unsafe] = ACTIONS(1816),
    [anon_sym_use] = ACTIONS(1816),
    [anon_sym_while] = ACTIONS(1816),
    [anon_sym_extern] = ACTIONS(1816),
    [anon_sym_yield] = ACTIONS(1816),
    [anon_sym_move] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1816),
    [sym_integer_literal] = ACTIONS(1814),
    [aux_sym_string_literal_token1] = ACTIONS(1814),
    [sym_char_literal] = ACTIONS(1814),
    [anon_sym_true] = ACTIONS(1816),
    [anon_sym_false] = ACTIONS(1816),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1816),
    [sym_super] = ACTIONS(1816),
    [sym_crate] = ACTIONS(1816),
    [sym_metavariable] = ACTIONS(1814),
    [sym__raw_string_literal_start] = ACTIONS(1814),
    [sym_float_literal] = ACTIONS(1814),
  },
  [518] = {
    [sym_line_comment] = STATE(518),
    [sym_block_comment] = STATE(518),
    [ts_builtin_sym_end] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_macro_rules_BANG] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_RBRACE] = ACTIONS(1818),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_u8] = ACTIONS(1820),
    [anon_sym_i8] = ACTIONS(1820),
    [anon_sym_u16] = ACTIONS(1820),
    [anon_sym_i16] = ACTIONS(1820),
    [anon_sym_u32] = ACTIONS(1820),
    [anon_sym_i32] = ACTIONS(1820),
    [anon_sym_u64] = ACTIONS(1820),
    [anon_sym_i64] = ACTIONS(1820),
    [anon_sym_u128] = ACTIONS(1820),
    [anon_sym_i128] = ACTIONS(1820),
    [anon_sym_isize] = ACTIONS(1820),
    [anon_sym_usize] = ACTIONS(1820),
    [anon_sym_f32] = ACTIONS(1820),
    [anon_sym_f64] = ACTIONS(1820),
    [anon_sym_bool] = ACTIONS(1820),
    [anon_sym_str] = ACTIONS(1820),
    [anon_sym_char] = ACTIONS(1820),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_DOT_DOT] = ACTIONS(1818),
    [anon_sym_COLON_COLON] = ACTIONS(1818),
    [anon_sym_POUND] = ACTIONS(1818),
    [anon_sym_SQUOTE] = ACTIONS(1820),
    [anon_sym_async] = ACTIONS(1820),
    [anon_sym_break] = ACTIONS(1820),
    [anon_sym_const] = ACTIONS(1820),
    [anon_sym_continue] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1820),
    [anon_sym_enum] = ACTIONS(1820),
    [anon_sym_fn] = ACTIONS(1820),
    [anon_sym_for] = ACTIONS(1820),
    [anon_sym_if] = ACTIONS(1820),
    [anon_sym_impl] = ACTIONS(1820),
    [anon_sym_let] = ACTIONS(1820),
    [anon_sym_loop] = ACTIONS(1820),
    [anon_sym_match] = ACTIONS(1820),
    [anon_sym_mod] = ACTIONS(1820),
    [anon_sym_pub] = ACTIONS(1820),
    [anon_sym_return] = ACTIONS(1820),
    [anon_sym_static] = ACTIONS(1820),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_trait] = ACTIONS(1820),
    [anon_sym_type] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1820),
    [anon_sym_unsafe] = ACTIONS(1820),
    [anon_sym_use] = ACTIONS(1820),
    [anon_sym_while] = ACTIONS(1820),
    [anon_sym_extern] = ACTIONS(1820),
    [anon_sym_yield] = ACTIONS(1820),
    [anon_sym_move] = ACTIONS(1820),
    [anon_sym_try] = ACTIONS(1820),
    [sym_integer_literal] = ACTIONS(1818),
    [aux_sym_string_literal_token1] = ACTIONS(1818),
    [sym_char_literal] = ACTIONS(1818),
    [anon_sym_true] = ACTIONS(1820),
    [anon_sym_false] = ACTIONS(1820),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1820),
    [sym_super] = ACTIONS(1820),
    [sym_crate] = ACTIONS(1820),
    [sym_metavariable] = ACTIONS(1818),
    [sym__raw_string_literal_start] = ACTIONS(1818),
    [sym_float_literal] = ACTIONS(1818),
  },
  [519] = {
    [sym_line_comment] = STATE(519),
    [sym_block_comment] = STATE(519),
    [ts_builtin_sym_end] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1824),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_macro_rules_BANG] = ACTIONS(1822),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_LBRACK] = ACTIONS(1822),
    [anon_sym_LBRACE] = ACTIONS(1822),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_STAR] = ACTIONS(1822),
    [anon_sym_u8] = ACTIONS(1824),
    [anon_sym_i8] = ACTIONS(1824),
    [anon_sym_u16] = ACTIONS(1824),
    [anon_sym_i16] = ACTIONS(1824),
    [anon_sym_u32] = ACTIONS(1824),
    [anon_sym_i32] = ACTIONS(1824),
    [anon_sym_u64] = ACTIONS(1824),
    [anon_sym_i64] = ACTIONS(1824),
    [anon_sym_u128] = ACTIONS(1824),
    [anon_sym_i128] = ACTIONS(1824),
    [anon_sym_isize] = ACTIONS(1824),
    [anon_sym_usize] = ACTIONS(1824),
    [anon_sym_f32] = ACTIONS(1824),
    [anon_sym_f64] = ACTIONS(1824),
    [anon_sym_bool] = ACTIONS(1824),
    [anon_sym_str] = ACTIONS(1824),
    [anon_sym_char] = ACTIONS(1824),
    [anon_sym_DASH] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1822),
    [anon_sym_AMP] = ACTIONS(1822),
    [anon_sym_PIPE] = ACTIONS(1822),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_DOT_DOT] = ACTIONS(1822),
    [anon_sym_COLON_COLON] = ACTIONS(1822),
    [anon_sym_POUND] = ACTIONS(1822),
    [anon_sym_SQUOTE] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1824),
    [anon_sym_break] = ACTIONS(1824),
    [anon_sym_const] = ACTIONS(1824),
    [anon_sym_continue] = ACTIONS(1824),
    [anon_sym_default] = ACTIONS(1824),
    [anon_sym_enum] = ACTIONS(1824),
    [anon_sym_fn] = ACTIONS(1824),
    [anon_sym_for] = ACTIONS(1824),
    [anon_sym_if] = ACTIONS(1824),
    [anon_sym_impl] = ACTIONS(1824),
    [anon_sym_let] = ACTIONS(1824),
    [anon_sym_loop] = ACTIONS(1824),
    [anon_sym_match] = ACTIONS(1824),
    [anon_sym_mod] = ACTIONS(1824),
    [anon_sym_pub] = ACTIONS(1824),
    [anon_sym_return] = ACTIONS(1824),
    [anon_sym_static] = ACTIONS(1824),
    [anon_sym_struct] = ACTIONS(1824),
    [anon_sym_trait] = ACTIONS(1824),
    [anon_sym_type] = ACTIONS(1824),
    [anon_sym_union] = ACTIONS(1824),
    [anon_sym_unsafe] = ACTIONS(1824),
    [anon_sym_use] = ACTIONS(1824),
    [anon_sym_while] = ACTIONS(1824),
    [anon_sym_extern] = ACTIONS(1824),
    [anon_sym_yield] = ACTIONS(1824),
    [anon_sym_move] = ACTIONS(1824),
    [anon_sym_try] = ACTIONS(1824),
    [sym_integer_literal] = ACTIONS(1822),
    [aux_sym_string_literal_token1] = ACTIONS(1822),
    [sym_char_literal] = ACTIONS(1822),
    [anon_sym_true] = ACTIONS(1824),
    [anon_sym_false] = ACTIONS(1824),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1824),
    [sym_super] = ACTIONS(1824),
    [sym_crate] = ACTIONS(1824),
    [sym_metavariable] = ACTIONS(1822),
    [sym__raw_string_literal_start] = ACTIONS(1822),
    [sym_float_literal] = ACTIONS(1822),
  },
  [520] = {
    [sym_line_comment] = STATE(520),
    [sym_block_comment] = STATE(520),
    [ts_builtin_sym_end] = ACTIONS(1826),
    [sym_identifier] = ACTIONS(1828),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_macro_rules_BANG] = ACTIONS(1826),
    [anon_sym_LPAREN] = ACTIONS(1826),
    [anon_sym_LBRACK] = ACTIONS(1826),
    [anon_sym_LBRACE] = ACTIONS(1826),
    [anon_sym_RBRACE] = ACTIONS(1826),
    [anon_sym_STAR] = ACTIONS(1826),
    [anon_sym_u8] = ACTIONS(1828),
    [anon_sym_i8] = ACTIONS(1828),
    [anon_sym_u16] = ACTIONS(1828),
    [anon_sym_i16] = ACTIONS(1828),
    [anon_sym_u32] = ACTIONS(1828),
    [anon_sym_i32] = ACTIONS(1828),
    [anon_sym_u64] = ACTIONS(1828),
    [anon_sym_i64] = ACTIONS(1828),
    [anon_sym_u128] = ACTIONS(1828),
    [anon_sym_i128] = ACTIONS(1828),
    [anon_sym_isize] = ACTIONS(1828),
    [anon_sym_usize] = ACTIONS(1828),
    [anon_sym_f32] = ACTIONS(1828),
    [anon_sym_f64] = ACTIONS(1828),
    [anon_sym_bool] = ACTIONS(1828),
    [anon_sym_str] = ACTIONS(1828),
    [anon_sym_char] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1826),
    [anon_sym_BANG] = ACTIONS(1826),
    [anon_sym_AMP] = ACTIONS(1826),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_DOT_DOT] = ACTIONS(1826),
    [anon_sym_COLON_COLON] = ACTIONS(1826),
    [anon_sym_POUND] = ACTIONS(1826),
    [anon_sym_SQUOTE] = ACTIONS(1828),
    [anon_sym_async] = ACTIONS(1828),
    [anon_sym_break] = ACTIONS(1828),
    [anon_sym_const] = ACTIONS(1828),
    [anon_sym_continue] = ACTIONS(1828),
    [anon_sym_default] = ACTIONS(1828),
    [anon_sym_enum] = ACTIONS(1828),
    [anon_sym_fn] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_impl] = ACTIONS(1828),
    [anon_sym_let] = ACTIONS(1828),
    [anon_sym_loop] = ACTIONS(1828),
    [anon_sym_match] = ACTIONS(1828),
    [anon_sym_mod] = ACTIONS(1828),
    [anon_sym_pub] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_static] = ACTIONS(1828),
    [anon_sym_struct] = ACTIONS(1828),
    [anon_sym_trait] = ACTIONS(1828),
    [anon_sym_type] = ACTIONS(1828),
    [anon_sym_union] = ACTIONS(1828),
    [anon_sym_unsafe] = ACTIONS(1828),
    [anon_sym_use] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_extern] = ACTIONS(1828),
    [anon_sym_yield] = ACTIONS(1828),
    [anon_sym_move] = ACTIONS(1828),
    [anon_sym_try] = ACTIONS(1828),
    [sym_integer_literal] = ACTIONS(1826),
    [aux_sym_string_literal_token1] = ACTIONS(1826),
    [sym_char_literal] = ACTIONS(1826),
    [anon_sym_true] = ACTIONS(1828),
    [anon_sym_false] = ACTIONS(1828),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1828),
    [sym_super] = ACTIONS(1828),
    [sym_crate] = ACTIONS(1828),
    [sym_metavariable] = ACTIONS(1826),
    [sym__raw_string_literal_start] = ACTIONS(1826),
    [sym_float_literal] = ACTIONS(1826),
  },
  [521] = {
    [sym_line_comment] = STATE(521),
    [sym_block_comment] = STATE(521),
    [ts_builtin_sym_end] = ACTIONS(1830),
    [sym_identifier] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1830),
    [anon_sym_macro_rules_BANG] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(1830),
    [anon_sym_LBRACK] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1830),
    [anon_sym_RBRACE] = ACTIONS(1830),
    [anon_sym_STAR] = ACTIONS(1830),
    [anon_sym_u8] = ACTIONS(1832),
    [anon_sym_i8] = ACTIONS(1832),
    [anon_sym_u16] = ACTIONS(1832),
    [anon_sym_i16] = ACTIONS(1832),
    [anon_sym_u32] = ACTIONS(1832),
    [anon_sym_i32] = ACTIONS(1832),
    [anon_sym_u64] = ACTIONS(1832),
    [anon_sym_i64] = ACTIONS(1832),
    [anon_sym_u128] = ACTIONS(1832),
    [anon_sym_i128] = ACTIONS(1832),
    [anon_sym_isize] = ACTIONS(1832),
    [anon_sym_usize] = ACTIONS(1832),
    [anon_sym_f32] = ACTIONS(1832),
    [anon_sym_f64] = ACTIONS(1832),
    [anon_sym_bool] = ACTIONS(1832),
    [anon_sym_str] = ACTIONS(1832),
    [anon_sym_char] = ACTIONS(1832),
    [anon_sym_DASH] = ACTIONS(1830),
    [anon_sym_BANG] = ACTIONS(1830),
    [anon_sym_AMP] = ACTIONS(1830),
    [anon_sym_PIPE] = ACTIONS(1830),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_DOT_DOT] = ACTIONS(1830),
    [anon_sym_COLON_COLON] = ACTIONS(1830),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_SQUOTE] = ACTIONS(1832),
    [anon_sym_async] = ACTIONS(1832),
    [anon_sym_break] = ACTIONS(1832),
    [anon_sym_const] = ACTIONS(1832),
    [anon_sym_continue] = ACTIONS(1832),
    [anon_sym_default] = ACTIONS(1832),
    [anon_sym_enum] = ACTIONS(1832),
    [anon_sym_fn] = ACTIONS(1832),
    [anon_sym_for] = ACTIONS(1832),
    [anon_sym_if] = ACTIONS(1832),
    [anon_sym_impl] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(1832),
    [anon_sym_loop] = ACTIONS(1832),
    [anon_sym_match] = ACTIONS(1832),
    [anon_sym_mod] = ACTIONS(1832),
    [anon_sym_pub] = ACTIONS(1832),
    [anon_sym_return] = ACTIONS(1832),
    [anon_sym_static] = ACTIONS(1832),
    [anon_sym_struct] = ACTIONS(1832),
    [anon_sym_trait] = ACTIONS(1832),
    [anon_sym_type] = ACTIONS(1832),
    [anon_sym_union] = ACTIONS(1832),
    [anon_sym_unsafe] = ACTIONS(1832),
    [anon_sym_use] = ACTIONS(1832),
    [anon_sym_while] = ACTIONS(1832),
    [anon_sym_extern] = ACTIONS(1832),
    [anon_sym_yield] = ACTIONS(1832),
    [anon_sym_move] = ACTIONS(1832),
    [anon_sym_try] = ACTIONS(1832),
    [sym_integer_literal] = ACTIONS(1830),
    [aux_sym_string_literal_token1] = ACTIONS(1830),
    [sym_char_literal] = ACTIONS(1830),
    [anon_sym_true] = ACTIONS(1832),
    [anon_sym_false] = ACTIONS(1832),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1832),
    [sym_super] = ACTIONS(1832),
    [sym_crate] = ACTIONS(1832),
    [sym_metavariable] = ACTIONS(1830),
    [sym__raw_string_literal_start] = ACTIONS(1830),
    [sym_float_literal] = ACTIONS(1830),
  },
  [522] = {
    [sym_line_comment] = STATE(522),
    [sym_block_comment] = STATE(522),
    [ts_builtin_sym_end] = ACTIONS(1834),
    [sym_identifier] = ACTIONS(1836),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_macro_rules_BANG] = ACTIONS(1834),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_LBRACK] = ACTIONS(1834),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1834),
    [anon_sym_u8] = ACTIONS(1836),
    [anon_sym_i8] = ACTIONS(1836),
    [anon_sym_u16] = ACTIONS(1836),
    [anon_sym_i16] = ACTIONS(1836),
    [anon_sym_u32] = ACTIONS(1836),
    [anon_sym_i32] = ACTIONS(1836),
    [anon_sym_u64] = ACTIONS(1836),
    [anon_sym_i64] = ACTIONS(1836),
    [anon_sym_u128] = ACTIONS(1836),
    [anon_sym_i128] = ACTIONS(1836),
    [anon_sym_isize] = ACTIONS(1836),
    [anon_sym_usize] = ACTIONS(1836),
    [anon_sym_f32] = ACTIONS(1836),
    [anon_sym_f64] = ACTIONS(1836),
    [anon_sym_bool] = ACTIONS(1836),
    [anon_sym_str] = ACTIONS(1836),
    [anon_sym_char] = ACTIONS(1836),
    [anon_sym_DASH] = ACTIONS(1834),
    [anon_sym_BANG] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_COLON_COLON] = ACTIONS(1834),
    [anon_sym_POUND] = ACTIONS(1834),
    [anon_sym_SQUOTE] = ACTIONS(1836),
    [anon_sym_async] = ACTIONS(1836),
    [anon_sym_break] = ACTIONS(1836),
    [anon_sym_const] = ACTIONS(1836),
    [anon_sym_continue] = ACTIONS(1836),
    [anon_sym_default] = ACTIONS(1836),
    [anon_sym_enum] = ACTIONS(1836),
    [anon_sym_fn] = ACTIONS(1836),
    [anon_sym_for] = ACTIONS(1836),
    [anon_sym_if] = ACTIONS(1836),
    [anon_sym_impl] = ACTIONS(1836),
    [anon_sym_let] = ACTIONS(1836),
    [anon_sym_loop] = ACTIONS(1836),
    [anon_sym_match] = ACTIONS(1836),
    [anon_sym_mod] = ACTIONS(1836),
    [anon_sym_pub] = ACTIONS(1836),
    [anon_sym_return] = ACTIONS(1836),
    [anon_sym_static] = ACTIONS(1836),
    [anon_sym_struct] = ACTIONS(1836),
    [anon_sym_trait] = ACTIONS(1836),
    [anon_sym_type] = ACTIONS(1836),
    [anon_sym_union] = ACTIONS(1836),
    [anon_sym_unsafe] = ACTIONS(1836),
    [anon_sym_use] = ACTIONS(1836),
    [anon_sym_while] = ACTIONS(1836),
    [anon_sym_extern] = ACTIONS(1836),
    [anon_sym_yield] = ACTIONS(1836),
    [anon_sym_move] = ACTIONS(1836),
    [anon_sym_try] = ACTIONS(1836),
    [sym_integer_literal] = ACTIONS(1834),
    [aux_sym_string_literal_token1] = ACTIONS(1834),
    [sym_char_literal] = ACTIONS(1834),
    [anon_sym_true] = ACTIONS(1836),
    [anon_sym_false] = ACTIONS(1836),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1836),
    [sym_super] = ACTIONS(1836),
    [sym_crate] = ACTIONS(1836),
    [sym_metavariable] = ACTIONS(1834),
    [sym__raw_string_literal_start] = ACTIONS(1834),
    [sym_float_literal] = ACTIONS(1834),
  },
  [523] = {
    [sym_line_comment] = STATE(523),
    [sym_block_comment] = STATE(523),
    [ts_builtin_sym_end] = ACTIONS(1838),
    [sym_identifier] = ACTIONS(1840),
    [anon_sym_SEMI] = ACTIONS(1838),
    [anon_sym_macro_rules_BANG] = ACTIONS(1838),
    [anon_sym_LPAREN] = ACTIONS(1838),
    [anon_sym_LBRACK] = ACTIONS(1838),
    [anon_sym_LBRACE] = ACTIONS(1838),
    [anon_sym_RBRACE] = ACTIONS(1838),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(1840),
    [anon_sym_i8] = ACTIONS(1840),
    [anon_sym_u16] = ACTIONS(1840),
    [anon_sym_i16] = ACTIONS(1840),
    [anon_sym_u32] = ACTIONS(1840),
    [anon_sym_i32] = ACTIONS(1840),
    [anon_sym_u64] = ACTIONS(1840),
    [anon_sym_i64] = ACTIONS(1840),
    [anon_sym_u128] = ACTIONS(1840),
    [anon_sym_i128] = ACTIONS(1840),
    [anon_sym_isize] = ACTIONS(1840),
    [anon_sym_usize] = ACTIONS(1840),
    [anon_sym_f32] = ACTIONS(1840),
    [anon_sym_f64] = ACTIONS(1840),
    [anon_sym_bool] = ACTIONS(1840),
    [anon_sym_str] = ACTIONS(1840),
    [anon_sym_char] = ACTIONS(1840),
    [anon_sym_DASH] = ACTIONS(1838),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(1838),
    [anon_sym_PIPE] = ACTIONS(1838),
    [anon_sym_LT] = ACTIONS(1838),
    [anon_sym_DOT_DOT] = ACTIONS(1838),
    [anon_sym_COLON_COLON] = ACTIONS(1838),
    [anon_sym_POUND] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1840),
    [anon_sym_async] = ACTIONS(1840),
    [anon_sym_break] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1840),
    [anon_sym_continue] = ACTIONS(1840),
    [anon_sym_default] = ACTIONS(1840),
    [anon_sym_enum] = ACTIONS(1840),
    [anon_sym_fn] = ACTIONS(1840),
    [anon_sym_for] = ACTIONS(1840),
    [anon_sym_if] = ACTIONS(1840),
    [anon_sym_impl] = ACTIONS(1840),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_loop] = ACTIONS(1840),
    [anon_sym_match] = ACTIONS(1840),
    [anon_sym_mod] = ACTIONS(1840),
    [anon_sym_pub] = ACTIONS(1840),
    [anon_sym_return] = ACTIONS(1840),
    [anon_sym_static] = ACTIONS(1840),
    [anon_sym_struct] = ACTIONS(1840),
    [anon_sym_trait] = ACTIONS(1840),
    [anon_sym_type] = ACTIONS(1840),
    [anon_sym_union] = ACTIONS(1840),
    [anon_sym_unsafe] = ACTIONS(1840),
    [anon_sym_use] = ACTIONS(1840),
    [anon_sym_while] = ACTIONS(1840),
    [anon_sym_extern] = ACTIONS(1840),
    [anon_sym_yield] = ACTIONS(1840),
    [anon_sym_move] = ACTIONS(1840),
    [anon_sym_try] = ACTIONS(1840),
    [sym_integer_literal] = ACTIONS(1838),
    [aux_sym_string_literal_token1] = ACTIONS(1838),
    [sym_char_literal] = ACTIONS(1838),
    [anon_sym_true] = ACTIONS(1840),
    [anon_sym_false] = ACTIONS(1840),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1840),
    [sym_super] = ACTIONS(1840),
    [sym_crate] = ACTIONS(1840),
    [sym_metavariable] = ACTIONS(1838),
    [sym__raw_string_literal_start] = ACTIONS(1838),
    [sym_float_literal] = ACTIONS(1838),
  },
  [524] = {
    [sym_line_comment] = STATE(524),
    [sym_block_comment] = STATE(524),
    [ts_builtin_sym_end] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(1844),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_macro_rules_BANG] = ACTIONS(1842),
    [anon_sym_LPAREN] = ACTIONS(1842),
    [anon_sym_LBRACK] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1842),
    [anon_sym_RBRACE] = ACTIONS(1842),
    [anon_sym_STAR] = ACTIONS(1842),
    [anon_sym_u8] = ACTIONS(1844),
    [anon_sym_i8] = ACTIONS(1844),
    [anon_sym_u16] = ACTIONS(1844),
    [anon_sym_i16] = ACTIONS(1844),
    [anon_sym_u32] = ACTIONS(1844),
    [anon_sym_i32] = ACTIONS(1844),
    [anon_sym_u64] = ACTIONS(1844),
    [anon_sym_i64] = ACTIONS(1844),
    [anon_sym_u128] = ACTIONS(1844),
    [anon_sym_i128] = ACTIONS(1844),
    [anon_sym_isize] = ACTIONS(1844),
    [anon_sym_usize] = ACTIONS(1844),
    [anon_sym_f32] = ACTIONS(1844),
    [anon_sym_f64] = ACTIONS(1844),
    [anon_sym_bool] = ACTIONS(1844),
    [anon_sym_str] = ACTIONS(1844),
    [anon_sym_char] = ACTIONS(1844),
    [anon_sym_DASH] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(1842),
    [anon_sym_AMP] = ACTIONS(1842),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_DOT_DOT] = ACTIONS(1842),
    [anon_sym_COLON_COLON] = ACTIONS(1842),
    [anon_sym_POUND] = ACTIONS(1842),
    [anon_sym_SQUOTE] = ACTIONS(1844),
    [anon_sym_async] = ACTIONS(1844),
    [anon_sym_break] = ACTIONS(1844),
    [anon_sym_const] = ACTIONS(1844),
    [anon_sym_continue] = ACTIONS(1844),
    [anon_sym_default] = ACTIONS(1844),
    [anon_sym_enum] = ACTIONS(1844),
    [anon_sym_fn] = ACTIONS(1844),
    [anon_sym_for] = ACTIONS(1844),
    [anon_sym_if] = ACTIONS(1844),
    [anon_sym_impl] = ACTIONS(1844),
    [anon_sym_let] = ACTIONS(1844),
    [anon_sym_loop] = ACTIONS(1844),
    [anon_sym_match] = ACTIONS(1844),
    [anon_sym_mod] = ACTIONS(1844),
    [anon_sym_pub] = ACTIONS(1844),
    [anon_sym_return] = ACTIONS(1844),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_struct] = ACTIONS(1844),
    [anon_sym_trait] = ACTIONS(1844),
    [anon_sym_type] = ACTIONS(1844),
    [anon_sym_union] = ACTIONS(1844),
    [anon_sym_unsafe] = ACTIONS(1844),
    [anon_sym_use] = ACTIONS(1844),
    [anon_sym_while] = ACTIONS(1844),
    [anon_sym_extern] = ACTIONS(1844),
    [anon_sym_yield] = ACTIONS(1844),
    [anon_sym_move] = ACTIONS(1844),
    [anon_sym_try] = ACTIONS(1844),
    [sym_integer_literal] = ACTIONS(1842),
    [aux_sym_string_literal_token1] = ACTIONS(1842),
    [sym_char_literal] = ACTIONS(1842),
    [anon_sym_true] = ACTIONS(1844),
    [anon_sym_false] = ACTIONS(1844),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1844),
    [sym_super] = ACTIONS(1844),
    [sym_crate] = ACTIONS(1844),
    [sym_metavariable] = ACTIONS(1842),
    [sym__raw_string_literal_start] = ACTIONS(1842),
    [sym_float_literal] = ACTIONS(1842),
  },
  [525] = {
    [sym_line_comment] = STATE(525),
    [sym_block_comment] = STATE(525),
    [ts_builtin_sym_end] = ACTIONS(1846),
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_macro_rules_BANG] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1846),
    [anon_sym_LBRACK] = ACTIONS(1846),
    [anon_sym_LBRACE] = ACTIONS(1846),
    [anon_sym_RBRACE] = ACTIONS(1846),
    [anon_sym_STAR] = ACTIONS(1846),
    [anon_sym_u8] = ACTIONS(1848),
    [anon_sym_i8] = ACTIONS(1848),
    [anon_sym_u16] = ACTIONS(1848),
    [anon_sym_i16] = ACTIONS(1848),
    [anon_sym_u32] = ACTIONS(1848),
    [anon_sym_i32] = ACTIONS(1848),
    [anon_sym_u64] = ACTIONS(1848),
    [anon_sym_i64] = ACTIONS(1848),
    [anon_sym_u128] = ACTIONS(1848),
    [anon_sym_i128] = ACTIONS(1848),
    [anon_sym_isize] = ACTIONS(1848),
    [anon_sym_usize] = ACTIONS(1848),
    [anon_sym_f32] = ACTIONS(1848),
    [anon_sym_f64] = ACTIONS(1848),
    [anon_sym_bool] = ACTIONS(1848),
    [anon_sym_str] = ACTIONS(1848),
    [anon_sym_char] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1846),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1846),
    [anon_sym_PIPE] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1846),
    [anon_sym_DOT_DOT] = ACTIONS(1846),
    [anon_sym_COLON_COLON] = ACTIONS(1846),
    [anon_sym_POUND] = ACTIONS(1846),
    [anon_sym_SQUOTE] = ACTIONS(1848),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_break] = ACTIONS(1848),
    [anon_sym_const] = ACTIONS(1848),
    [anon_sym_continue] = ACTIONS(1848),
    [anon_sym_default] = ACTIONS(1848),
    [anon_sym_enum] = ACTIONS(1848),
    [anon_sym_fn] = ACTIONS(1848),
    [anon_sym_for] = ACTIONS(1848),
    [anon_sym_if] = ACTIONS(1848),
    [anon_sym_impl] = ACTIONS(1848),
    [anon_sym_let] = ACTIONS(1848),
    [anon_sym_loop] = ACTIONS(1848),
    [anon_sym_match] = ACTIONS(1848),
    [anon_sym_mod] = ACTIONS(1848),
    [anon_sym_pub] = ACTIONS(1848),
    [anon_sym_return] = ACTIONS(1848),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_struct] = ACTIONS(1848),
    [anon_sym_trait] = ACTIONS(1848),
    [anon_sym_type] = ACTIONS(1848),
    [anon_sym_union] = ACTIONS(1848),
    [anon_sym_unsafe] = ACTIONS(1848),
    [anon_sym_use] = ACTIONS(1848),
    [anon_sym_while] = ACTIONS(1848),
    [anon_sym_extern] = ACTIONS(1848),
    [anon_sym_yield] = ACTIONS(1848),
    [anon_sym_move] = ACTIONS(1848),
    [anon_sym_try] = ACTIONS(1848),
    [sym_integer_literal] = ACTIONS(1846),
    [aux_sym_string_literal_token1] = ACTIONS(1846),
    [sym_char_literal] = ACTIONS(1846),
    [anon_sym_true] = ACTIONS(1848),
    [anon_sym_false] = ACTIONS(1848),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1848),
    [sym_super] = ACTIONS(1848),
    [sym_crate] = ACTIONS(1848),
    [sym_metavariable] = ACTIONS(1846),
    [sym__raw_string_literal_start] = ACTIONS(1846),
    [sym_float_literal] = ACTIONS(1846),
  },
  [526] = {
    [sym_line_comment] = STATE(526),
    [sym_block_comment] = STATE(526),
    [ts_builtin_sym_end] = ACTIONS(1850),
    [sym_identifier] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1850),
    [anon_sym_macro_rules_BANG] = ACTIONS(1850),
    [anon_sym_LPAREN] = ACTIONS(1850),
    [anon_sym_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(1850),
    [anon_sym_RBRACE] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(1850),
    [anon_sym_u8] = ACTIONS(1852),
    [anon_sym_i8] = ACTIONS(1852),
    [anon_sym_u16] = ACTIONS(1852),
    [anon_sym_i16] = ACTIONS(1852),
    [anon_sym_u32] = ACTIONS(1852),
    [anon_sym_i32] = ACTIONS(1852),
    [anon_sym_u64] = ACTIONS(1852),
    [anon_sym_i64] = ACTIONS(1852),
    [anon_sym_u128] = ACTIONS(1852),
    [anon_sym_i128] = ACTIONS(1852),
    [anon_sym_isize] = ACTIONS(1852),
    [anon_sym_usize] = ACTIONS(1852),
    [anon_sym_f32] = ACTIONS(1852),
    [anon_sym_f64] = ACTIONS(1852),
    [anon_sym_bool] = ACTIONS(1852),
    [anon_sym_str] = ACTIONS(1852),
    [anon_sym_char] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1850),
    [anon_sym_BANG] = ACTIONS(1850),
    [anon_sym_AMP] = ACTIONS(1850),
    [anon_sym_PIPE] = ACTIONS(1850),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_DOT_DOT] = ACTIONS(1850),
    [anon_sym_COLON_COLON] = ACTIONS(1850),
    [anon_sym_POUND] = ACTIONS(1850),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [anon_sym_async] = ACTIONS(1852),
    [anon_sym_break] = ACTIONS(1852),
    [anon_sym_const] = ACTIONS(1852),
    [anon_sym_continue] = ACTIONS(1852),
    [anon_sym_default] = ACTIONS(1852),
    [anon_sym_enum] = ACTIONS(1852),
    [anon_sym_fn] = ACTIONS(1852),
    [anon_sym_for] = ACTIONS(1852),
    [anon_sym_if] = ACTIONS(1852),
    [anon_sym_impl] = ACTIONS(1852),
    [anon_sym_let] = ACTIONS(1852),
    [anon_sym_loop] = ACTIONS(1852),
    [anon_sym_match] = ACTIONS(1852),
    [anon_sym_mod] = ACTIONS(1852),
    [anon_sym_pub] = ACTIONS(1852),
    [anon_sym_return] = ACTIONS(1852),
    [anon_sym_static] = ACTIONS(1852),
    [anon_sym_struct] = ACTIONS(1852),
    [anon_sym_trait] = ACTIONS(1852),
    [anon_sym_type] = ACTIONS(1852),
    [anon_sym_union] = ACTIONS(1852),
    [anon_sym_unsafe] = ACTIONS(1852),
    [anon_sym_use] = ACTIONS(1852),
    [anon_sym_while] = ACTIONS(1852),
    [anon_sym_extern] = ACTIONS(1852),
    [anon_sym_yield] = ACTIONS(1852),
    [anon_sym_move] = ACTIONS(1852),
    [anon_sym_try] = ACTIONS(1852),
    [sym_integer_literal] = ACTIONS(1850),
    [aux_sym_string_literal_token1] = ACTIONS(1850),
    [sym_char_literal] = ACTIONS(1850),
    [anon_sym_true] = ACTIONS(1852),
    [anon_sym_false] = ACTIONS(1852),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1852),
    [sym_super] = ACTIONS(1852),
    [sym_crate] = ACTIONS(1852),
    [sym_metavariable] = ACTIONS(1850),
    [sym__raw_string_literal_start] = ACTIONS(1850),
    [sym_float_literal] = ACTIONS(1850),
  },
  [527] = {
    [sym_line_comment] = STATE(527),
    [sym_block_comment] = STATE(527),
    [ts_builtin_sym_end] = ACTIONS(1854),
    [sym_identifier] = ACTIONS(1856),
    [anon_sym_SEMI] = ACTIONS(1854),
    [anon_sym_macro_rules_BANG] = ACTIONS(1854),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1854),
    [anon_sym_RBRACE] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(1854),
    [anon_sym_u8] = ACTIONS(1856),
    [anon_sym_i8] = ACTIONS(1856),
    [anon_sym_u16] = ACTIONS(1856),
    [anon_sym_i16] = ACTIONS(1856),
    [anon_sym_u32] = ACTIONS(1856),
    [anon_sym_i32] = ACTIONS(1856),
    [anon_sym_u64] = ACTIONS(1856),
    [anon_sym_i64] = ACTIONS(1856),
    [anon_sym_u128] = ACTIONS(1856),
    [anon_sym_i128] = ACTIONS(1856),
    [anon_sym_isize] = ACTIONS(1856),
    [anon_sym_usize] = ACTIONS(1856),
    [anon_sym_f32] = ACTIONS(1856),
    [anon_sym_f64] = ACTIONS(1856),
    [anon_sym_bool] = ACTIONS(1856),
    [anon_sym_str] = ACTIONS(1856),
    [anon_sym_char] = ACTIONS(1856),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_BANG] = ACTIONS(1854),
    [anon_sym_AMP] = ACTIONS(1854),
    [anon_sym_PIPE] = ACTIONS(1854),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_DOT_DOT] = ACTIONS(1854),
    [anon_sym_COLON_COLON] = ACTIONS(1854),
    [anon_sym_POUND] = ACTIONS(1854),
    [anon_sym_SQUOTE] = ACTIONS(1856),
    [anon_sym_async] = ACTIONS(1856),
    [anon_sym_break] = ACTIONS(1856),
    [anon_sym_const] = ACTIONS(1856),
    [anon_sym_continue] = ACTIONS(1856),
    [anon_sym_default] = ACTIONS(1856),
    [anon_sym_enum] = ACTIONS(1856),
    [anon_sym_fn] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1856),
    [anon_sym_if] = ACTIONS(1856),
    [anon_sym_impl] = ACTIONS(1856),
    [anon_sym_let] = ACTIONS(1856),
    [anon_sym_loop] = ACTIONS(1856),
    [anon_sym_match] = ACTIONS(1856),
    [anon_sym_mod] = ACTIONS(1856),
    [anon_sym_pub] = ACTIONS(1856),
    [anon_sym_return] = ACTIONS(1856),
    [anon_sym_static] = ACTIONS(1856),
    [anon_sym_struct] = ACTIONS(1856),
    [anon_sym_trait] = ACTIONS(1856),
    [anon_sym_type] = ACTIONS(1856),
    [anon_sym_union] = ACTIONS(1856),
    [anon_sym_unsafe] = ACTIONS(1856),
    [anon_sym_use] = ACTIONS(1856),
    [anon_sym_while] = ACTIONS(1856),
    [anon_sym_extern] = ACTIONS(1856),
    [anon_sym_yield] = ACTIONS(1856),
    [anon_sym_move] = ACTIONS(1856),
    [anon_sym_try] = ACTIONS(1856),
    [sym_integer_literal] = ACTIONS(1854),
    [aux_sym_string_literal_token1] = ACTIONS(1854),
    [sym_char_literal] = ACTIONS(1854),
    [anon_sym_true] = ACTIONS(1856),
    [anon_sym_false] = ACTIONS(1856),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1856),
    [sym_super] = ACTIONS(1856),
    [sym_crate] = ACTIONS(1856),
    [sym_metavariable] = ACTIONS(1854),
    [sym__raw_string_literal_start] = ACTIONS(1854),
    [sym_float_literal] = ACTIONS(1854),
  },
  [528] = {
    [sym_line_comment] = STATE(528),
    [sym_block_comment] = STATE(528),
    [ts_builtin_sym_end] = ACTIONS(1858),
    [sym_identifier] = ACTIONS(1860),
    [anon_sym_SEMI] = ACTIONS(1858),
    [anon_sym_macro_rules_BANG] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(1858),
    [anon_sym_LBRACK] = ACTIONS(1858),
    [anon_sym_LBRACE] = ACTIONS(1858),
    [anon_sym_RBRACE] = ACTIONS(1858),
    [anon_sym_STAR] = ACTIONS(1858),
    [anon_sym_u8] = ACTIONS(1860),
    [anon_sym_i8] = ACTIONS(1860),
    [anon_sym_u16] = ACTIONS(1860),
    [anon_sym_i16] = ACTIONS(1860),
    [anon_sym_u32] = ACTIONS(1860),
    [anon_sym_i32] = ACTIONS(1860),
    [anon_sym_u64] = ACTIONS(1860),
    [anon_sym_i64] = ACTIONS(1860),
    [anon_sym_u128] = ACTIONS(1860),
    [anon_sym_i128] = ACTIONS(1860),
    [anon_sym_isize] = ACTIONS(1860),
    [anon_sym_usize] = ACTIONS(1860),
    [anon_sym_f32] = ACTIONS(1860),
    [anon_sym_f64] = ACTIONS(1860),
    [anon_sym_bool] = ACTIONS(1860),
    [anon_sym_str] = ACTIONS(1860),
    [anon_sym_char] = ACTIONS(1860),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1858),
    [anon_sym_AMP] = ACTIONS(1858),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_LT] = ACTIONS(1858),
    [anon_sym_DOT_DOT] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [anon_sym_POUND] = ACTIONS(1858),
    [anon_sym_SQUOTE] = ACTIONS(1860),
    [anon_sym_async] = ACTIONS(1860),
    [anon_sym_break] = ACTIONS(1860),
    [anon_sym_const] = ACTIONS(1860),
    [anon_sym_continue] = ACTIONS(1860),
    [anon_sym_default] = ACTIONS(1860),
    [anon_sym_enum] = ACTIONS(1860),
    [anon_sym_fn] = ACTIONS(1860),
    [anon_sym_for] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(1860),
    [anon_sym_impl] = ACTIONS(1860),
    [anon_sym_let] = ACTIONS(1860),
    [anon_sym_loop] = ACTIONS(1860),
    [anon_sym_match] = ACTIONS(1860),
    [anon_sym_mod] = ACTIONS(1860),
    [anon_sym_pub] = ACTIONS(1860),
    [anon_sym_return] = ACTIONS(1860),
    [anon_sym_static] = ACTIONS(1860),
    [anon_sym_struct] = ACTIONS(1860),
    [anon_sym_trait] = ACTIONS(1860),
    [anon_sym_type] = ACTIONS(1860),
    [anon_sym_union] = ACTIONS(1860),
    [anon_sym_unsafe] = ACTIONS(1860),
    [anon_sym_use] = ACTIONS(1860),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_extern] = ACTIONS(1860),
    [anon_sym_yield] = ACTIONS(1860),
    [anon_sym_move] = ACTIONS(1860),
    [anon_sym_try] = ACTIONS(1860),
    [sym_integer_literal] = ACTIONS(1858),
    [aux_sym_string_literal_token1] = ACTIONS(1858),
    [sym_char_literal] = ACTIONS(1858),
    [anon_sym_true] = ACTIONS(1860),
    [anon_sym_false] = ACTIONS(1860),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1860),
    [sym_super] = ACTIONS(1860),
    [sym_crate] = ACTIONS(1860),
    [sym_metavariable] = ACTIONS(1858),
    [sym__raw_string_literal_start] = ACTIONS(1858),
    [sym_float_literal] = ACTIONS(1858),
  },
  [529] = {
    [sym_line_comment] = STATE(529),
    [sym_block_comment] = STATE(529),
    [ts_builtin_sym_end] = ACTIONS(1862),
    [sym_identifier] = ACTIONS(1864),
    [anon_sym_SEMI] = ACTIONS(1862),
    [anon_sym_macro_rules_BANG] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [anon_sym_LBRACE] = ACTIONS(1862),
    [anon_sym_RBRACE] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1862),
    [anon_sym_u8] = ACTIONS(1864),
    [anon_sym_i8] = ACTIONS(1864),
    [anon_sym_u16] = ACTIONS(1864),
    [anon_sym_i16] = ACTIONS(1864),
    [anon_sym_u32] = ACTIONS(1864),
    [anon_sym_i32] = ACTIONS(1864),
    [anon_sym_u64] = ACTIONS(1864),
    [anon_sym_i64] = ACTIONS(1864),
    [anon_sym_u128] = ACTIONS(1864),
    [anon_sym_i128] = ACTIONS(1864),
    [anon_sym_isize] = ACTIONS(1864),
    [anon_sym_usize] = ACTIONS(1864),
    [anon_sym_f32] = ACTIONS(1864),
    [anon_sym_f64] = ACTIONS(1864),
    [anon_sym_bool] = ACTIONS(1864),
    [anon_sym_str] = ACTIONS(1864),
    [anon_sym_char] = ACTIONS(1864),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1862),
    [anon_sym_DOT_DOT] = ACTIONS(1862),
    [anon_sym_COLON_COLON] = ACTIONS(1862),
    [anon_sym_POUND] = ACTIONS(1862),
    [anon_sym_SQUOTE] = ACTIONS(1864),
    [anon_sym_async] = ACTIONS(1864),
    [anon_sym_break] = ACTIONS(1864),
    [anon_sym_const] = ACTIONS(1864),
    [anon_sym_continue] = ACTIONS(1864),
    [anon_sym_default] = ACTIONS(1864),
    [anon_sym_enum] = ACTIONS(1864),
    [anon_sym_fn] = ACTIONS(1864),
    [anon_sym_for] = ACTIONS(1864),
    [anon_sym_if] = ACTIONS(1864),
    [anon_sym_impl] = ACTIONS(1864),
    [anon_sym_let] = ACTIONS(1864),
    [anon_sym_loop] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1864),
    [anon_sym_mod] = ACTIONS(1864),
    [anon_sym_pub] = ACTIONS(1864),
    [anon_sym_return] = ACTIONS(1864),
    [anon_sym_static] = ACTIONS(1864),
    [anon_sym_struct] = ACTIONS(1864),
    [anon_sym_trait] = ACTIONS(1864),
    [anon_sym_type] = ACTIONS(1864),
    [anon_sym_union] = ACTIONS(1864),
    [anon_sym_unsafe] = ACTIONS(1864),
    [anon_sym_use] = ACTIONS(1864),
    [anon_sym_while] = ACTIONS(1864),
    [anon_sym_extern] = ACTIONS(1864),
    [anon_sym_yield] = ACTIONS(1864),
    [anon_sym_move] = ACTIONS(1864),
    [anon_sym_try] = ACTIONS(1864),
    [sym_integer_literal] = ACTIONS(1862),
    [aux_sym_string_literal_token1] = ACTIONS(1862),
    [sym_char_literal] = ACTIONS(1862),
    [anon_sym_true] = ACTIONS(1864),
    [anon_sym_false] = ACTIONS(1864),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1864),
    [sym_super] = ACTIONS(1864),
    [sym_crate] = ACTIONS(1864),
    [sym_metavariable] = ACTIONS(1862),
    [sym__raw_string_literal_start] = ACTIONS(1862),
    [sym_float_literal] = ACTIONS(1862),
  },
  [530] = {
    [sym_line_comment] = STATE(530),
    [sym_block_comment] = STATE(530),
    [ts_builtin_sym_end] = ACTIONS(1866),
    [sym_identifier] = ACTIONS(1868),
    [anon_sym_SEMI] = ACTIONS(1866),
    [anon_sym_macro_rules_BANG] = ACTIONS(1866),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [anon_sym_LBRACK] = ACTIONS(1866),
    [anon_sym_LBRACE] = ACTIONS(1866),
    [anon_sym_RBRACE] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(1866),
    [anon_sym_u8] = ACTIONS(1868),
    [anon_sym_i8] = ACTIONS(1868),
    [anon_sym_u16] = ACTIONS(1868),
    [anon_sym_i16] = ACTIONS(1868),
    [anon_sym_u32] = ACTIONS(1868),
    [anon_sym_i32] = ACTIONS(1868),
    [anon_sym_u64] = ACTIONS(1868),
    [anon_sym_i64] = ACTIONS(1868),
    [anon_sym_u128] = ACTIONS(1868),
    [anon_sym_i128] = ACTIONS(1868),
    [anon_sym_isize] = ACTIONS(1868),
    [anon_sym_usize] = ACTIONS(1868),
    [anon_sym_f32] = ACTIONS(1868),
    [anon_sym_f64] = ACTIONS(1868),
    [anon_sym_bool] = ACTIONS(1868),
    [anon_sym_str] = ACTIONS(1868),
    [anon_sym_char] = ACTIONS(1868),
    [anon_sym_DASH] = ACTIONS(1866),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_AMP] = ACTIONS(1866),
    [anon_sym_PIPE] = ACTIONS(1866),
    [anon_sym_LT] = ACTIONS(1866),
    [anon_sym_DOT_DOT] = ACTIONS(1866),
    [anon_sym_COLON_COLON] = ACTIONS(1866),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_SQUOTE] = ACTIONS(1868),
    [anon_sym_async] = ACTIONS(1868),
    [anon_sym_break] = ACTIONS(1868),
    [anon_sym_const] = ACTIONS(1868),
    [anon_sym_continue] = ACTIONS(1868),
    [anon_sym_default] = ACTIONS(1868),
    [anon_sym_enum] = ACTIONS(1868),
    [anon_sym_fn] = ACTIONS(1868),
    [anon_sym_for] = ACTIONS(1868),
    [anon_sym_if] = ACTIONS(1868),
    [anon_sym_impl] = ACTIONS(1868),
    [anon_sym_let] = ACTIONS(1868),
    [anon_sym_loop] = ACTIONS(1868),
    [anon_sym_match] = ACTIONS(1868),
    [anon_sym_mod] = ACTIONS(1868),
    [anon_sym_pub] = ACTIONS(1868),
    [anon_sym_return] = ACTIONS(1868),
    [anon_sym_static] = ACTIONS(1868),
    [anon_sym_struct] = ACTIONS(1868),
    [anon_sym_trait] = ACTIONS(1868),
    [anon_sym_type] = ACTIONS(1868),
    [anon_sym_union] = ACTIONS(1868),
    [anon_sym_unsafe] = ACTIONS(1868),
    [anon_sym_use] = ACTIONS(1868),
    [anon_sym_while] = ACTIONS(1868),
    [anon_sym_extern] = ACTIONS(1868),
    [anon_sym_yield] = ACTIONS(1868),
    [anon_sym_move] = ACTIONS(1868),
    [anon_sym_try] = ACTIONS(1868),
    [sym_integer_literal] = ACTIONS(1866),
    [aux_sym_string_literal_token1] = ACTIONS(1866),
    [sym_char_literal] = ACTIONS(1866),
    [anon_sym_true] = ACTIONS(1868),
    [anon_sym_false] = ACTIONS(1868),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1868),
    [sym_super] = ACTIONS(1868),
    [sym_crate] = ACTIONS(1868),
    [sym_metavariable] = ACTIONS(1866),
    [sym__raw_string_literal_start] = ACTIONS(1866),
    [sym_float_literal] = ACTIONS(1866),
  },
  [531] = {
    [sym_empty_statement] = STATE(1456),
    [sym_macro_definition] = STATE(1456),
    [sym_attribute_item] = STATE(1456),
    [sym_inner_attribute_item] = STATE(1456),
    [sym_mod_item] = STATE(1456),
    [sym_foreign_mod_item] = STATE(1456),
    [sym_struct_item] = STATE(1456),
    [sym_union_item] = STATE(1456),
    [sym_enum_item] = STATE(1456),
    [sym_extern_crate_declaration] = STATE(1456),
    [sym_const_item] = STATE(1456),
    [sym_static_item] = STATE(1456),
    [sym_type_item] = STATE(1456),
    [sym_function_item] = STATE(1456),
    [sym_function_signature_item] = STATE(1456),
    [sym_function_modifiers] = STATE(3599),
    [sym_impl_item] = STATE(1456),
    [sym_trait_item] = STATE(1456),
    [sym_associated_type] = STATE(1456),
    [sym_let_declaration] = STATE(1456),
    [sym_use_declaration] = STATE(1456),
    [sym_extern_modifier] = STATE(2139),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3323),
    [sym_generic_type_with_turbofish] = STATE(3349),
    [sym_macro_invocation] = STATE(1456),
    [sym_scoped_identifier] = STATE(3208),
    [sym_line_comment] = STATE(531),
    [sym_block_comment] = STATE(531),
    [aux_sym_declaration_list_repeat1] = STATE(707),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1870),
    [anon_sym_SEMI] = ACTIONS(1872),
    [anon_sym_macro_rules_BANG] = ACTIONS(1874),
    [anon_sym_RBRACE] = ACTIONS(1876),
    [anon_sym_u8] = ACTIONS(1878),
    [anon_sym_i8] = ACTIONS(1878),
    [anon_sym_u16] = ACTIONS(1878),
    [anon_sym_i16] = ACTIONS(1878),
    [anon_sym_u32] = ACTIONS(1878),
    [anon_sym_i32] = ACTIONS(1878),
    [anon_sym_u64] = ACTIONS(1878),
    [anon_sym_i64] = ACTIONS(1878),
    [anon_sym_u128] = ACTIONS(1878),
    [anon_sym_i128] = ACTIONS(1878),
    [anon_sym_isize] = ACTIONS(1878),
    [anon_sym_usize] = ACTIONS(1878),
    [anon_sym_f32] = ACTIONS(1878),
    [anon_sym_f64] = ACTIONS(1878),
    [anon_sym_bool] = ACTIONS(1878),
    [anon_sym_str] = ACTIONS(1878),
    [anon_sym_char] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_POUND] = ACTIONS(1882),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1884),
    [anon_sym_default] = ACTIONS(1886),
    [anon_sym_enum] = ACTIONS(1888),
    [anon_sym_fn] = ACTIONS(1890),
    [anon_sym_impl] = ACTIONS(1892),
    [anon_sym_let] = ACTIONS(1894),
    [anon_sym_mod] = ACTIONS(1896),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(1898),
    [anon_sym_struct] = ACTIONS(1900),
    [anon_sym_trait] = ACTIONS(1902),
    [anon_sym_type] = ACTIONS(1904),
    [anon_sym_union] = ACTIONS(1906),
    [anon_sym_unsafe] = ACTIONS(1908),
    [anon_sym_use] = ACTIONS(1910),
    [anon_sym_extern] = ACTIONS(1912),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1914),
    [sym_super] = ACTIONS(1914),
    [sym_crate] = ACTIONS(1916),
    [sym_metavariable] = ACTIONS(1918),
  },
  [532] = {
    [sym_line_comment] = STATE(532),
    [sym_block_comment] = STATE(532),
    [ts_builtin_sym_end] = ACTIONS(1920),
    [sym_identifier] = ACTIONS(1922),
    [anon_sym_SEMI] = ACTIONS(1920),
    [anon_sym_macro_rules_BANG] = ACTIONS(1920),
    [anon_sym_LPAREN] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_LBRACE] = ACTIONS(1920),
    [anon_sym_RBRACE] = ACTIONS(1920),
    [anon_sym_STAR] = ACTIONS(1920),
    [anon_sym_u8] = ACTIONS(1922),
    [anon_sym_i8] = ACTIONS(1922),
    [anon_sym_u16] = ACTIONS(1922),
    [anon_sym_i16] = ACTIONS(1922),
    [anon_sym_u32] = ACTIONS(1922),
    [anon_sym_i32] = ACTIONS(1922),
    [anon_sym_u64] = ACTIONS(1922),
    [anon_sym_i64] = ACTIONS(1922),
    [anon_sym_u128] = ACTIONS(1922),
    [anon_sym_i128] = ACTIONS(1922),
    [anon_sym_isize] = ACTIONS(1922),
    [anon_sym_usize] = ACTIONS(1922),
    [anon_sym_f32] = ACTIONS(1922),
    [anon_sym_f64] = ACTIONS(1922),
    [anon_sym_bool] = ACTIONS(1922),
    [anon_sym_str] = ACTIONS(1922),
    [anon_sym_char] = ACTIONS(1922),
    [anon_sym_DASH] = ACTIONS(1920),
    [anon_sym_BANG] = ACTIONS(1920),
    [anon_sym_AMP] = ACTIONS(1920),
    [anon_sym_PIPE] = ACTIONS(1920),
    [anon_sym_LT] = ACTIONS(1920),
    [anon_sym_DOT_DOT] = ACTIONS(1920),
    [anon_sym_COLON_COLON] = ACTIONS(1920),
    [anon_sym_POUND] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(1922),
    [anon_sym_break] = ACTIONS(1922),
    [anon_sym_const] = ACTIONS(1922),
    [anon_sym_continue] = ACTIONS(1922),
    [anon_sym_default] = ACTIONS(1922),
    [anon_sym_enum] = ACTIONS(1922),
    [anon_sym_fn] = ACTIONS(1922),
    [anon_sym_for] = ACTIONS(1922),
    [anon_sym_if] = ACTIONS(1922),
    [anon_sym_impl] = ACTIONS(1922),
    [anon_sym_let] = ACTIONS(1922),
    [anon_sym_loop] = ACTIONS(1922),
    [anon_sym_match] = ACTIONS(1922),
    [anon_sym_mod] = ACTIONS(1922),
    [anon_sym_pub] = ACTIONS(1922),
    [anon_sym_return] = ACTIONS(1922),
    [anon_sym_static] = ACTIONS(1922),
    [anon_sym_struct] = ACTIONS(1922),
    [anon_sym_trait] = ACTIONS(1922),
    [anon_sym_type] = ACTIONS(1922),
    [anon_sym_union] = ACTIONS(1922),
    [anon_sym_unsafe] = ACTIONS(1922),
    [anon_sym_use] = ACTIONS(1922),
    [anon_sym_while] = ACTIONS(1922),
    [anon_sym_extern] = ACTIONS(1922),
    [anon_sym_yield] = ACTIONS(1922),
    [anon_sym_move] = ACTIONS(1922),
    [anon_sym_try] = ACTIONS(1922),
    [sym_integer_literal] = ACTIONS(1920),
    [aux_sym_string_literal_token1] = ACTIONS(1920),
    [sym_char_literal] = ACTIONS(1920),
    [anon_sym_true] = ACTIONS(1922),
    [anon_sym_false] = ACTIONS(1922),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1922),
    [sym_super] = ACTIONS(1922),
    [sym_crate] = ACTIONS(1922),
    [sym_metavariable] = ACTIONS(1920),
    [sym__raw_string_literal_start] = ACTIONS(1920),
    [sym_float_literal] = ACTIONS(1920),
  },
  [533] = {
    [sym_line_comment] = STATE(533),
    [sym_block_comment] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(1924),
    [sym_identifier] = ACTIONS(1926),
    [anon_sym_SEMI] = ACTIONS(1924),
    [anon_sym_macro_rules_BANG] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_LBRACE] = ACTIONS(1924),
    [anon_sym_RBRACE] = ACTIONS(1924),
    [anon_sym_STAR] = ACTIONS(1924),
    [anon_sym_u8] = ACTIONS(1926),
    [anon_sym_i8] = ACTIONS(1926),
    [anon_sym_u16] = ACTIONS(1926),
    [anon_sym_i16] = ACTIONS(1926),
    [anon_sym_u32] = ACTIONS(1926),
    [anon_sym_i32] = ACTIONS(1926),
    [anon_sym_u64] = ACTIONS(1926),
    [anon_sym_i64] = ACTIONS(1926),
    [anon_sym_u128] = ACTIONS(1926),
    [anon_sym_i128] = ACTIONS(1926),
    [anon_sym_isize] = ACTIONS(1926),
    [anon_sym_usize] = ACTIONS(1926),
    [anon_sym_f32] = ACTIONS(1926),
    [anon_sym_f64] = ACTIONS(1926),
    [anon_sym_bool] = ACTIONS(1926),
    [anon_sym_str] = ACTIONS(1926),
    [anon_sym_char] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1924),
    [anon_sym_BANG] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1924),
    [anon_sym_PIPE] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1924),
    [anon_sym_DOT_DOT] = ACTIONS(1924),
    [anon_sym_COLON_COLON] = ACTIONS(1924),
    [anon_sym_POUND] = ACTIONS(1924),
    [anon_sym_SQUOTE] = ACTIONS(1926),
    [anon_sym_async] = ACTIONS(1926),
    [anon_sym_break] = ACTIONS(1926),
    [anon_sym_const] = ACTIONS(1926),
    [anon_sym_continue] = ACTIONS(1926),
    [anon_sym_default] = ACTIONS(1926),
    [anon_sym_enum] = ACTIONS(1926),
    [anon_sym_fn] = ACTIONS(1926),
    [anon_sym_for] = ACTIONS(1926),
    [anon_sym_if] = ACTIONS(1926),
    [anon_sym_impl] = ACTIONS(1926),
    [anon_sym_let] = ACTIONS(1926),
    [anon_sym_loop] = ACTIONS(1926),
    [anon_sym_match] = ACTIONS(1926),
    [anon_sym_mod] = ACTIONS(1926),
    [anon_sym_pub] = ACTIONS(1926),
    [anon_sym_return] = ACTIONS(1926),
    [anon_sym_static] = ACTIONS(1926),
    [anon_sym_struct] = ACTIONS(1926),
    [anon_sym_trait] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(1926),
    [anon_sym_union] = ACTIONS(1926),
    [anon_sym_unsafe] = ACTIONS(1926),
    [anon_sym_use] = ACTIONS(1926),
    [anon_sym_while] = ACTIONS(1926),
    [anon_sym_extern] = ACTIONS(1926),
    [anon_sym_yield] = ACTIONS(1926),
    [anon_sym_move] = ACTIONS(1926),
    [anon_sym_try] = ACTIONS(1926),
    [sym_integer_literal] = ACTIONS(1924),
    [aux_sym_string_literal_token1] = ACTIONS(1924),
    [sym_char_literal] = ACTIONS(1924),
    [anon_sym_true] = ACTIONS(1926),
    [anon_sym_false] = ACTIONS(1926),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1926),
    [sym_super] = ACTIONS(1926),
    [sym_crate] = ACTIONS(1926),
    [sym_metavariable] = ACTIONS(1924),
    [sym__raw_string_literal_start] = ACTIONS(1924),
    [sym_float_literal] = ACTIONS(1924),
  },
  [534] = {
    [sym_line_comment] = STATE(534),
    [sym_block_comment] = STATE(534),
    [ts_builtin_sym_end] = ACTIONS(1928),
    [sym_identifier] = ACTIONS(1930),
    [anon_sym_SEMI] = ACTIONS(1928),
    [anon_sym_macro_rules_BANG] = ACTIONS(1928),
    [anon_sym_LPAREN] = ACTIONS(1928),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [anon_sym_LBRACE] = ACTIONS(1928),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(1930),
    [anon_sym_i8] = ACTIONS(1930),
    [anon_sym_u16] = ACTIONS(1930),
    [anon_sym_i16] = ACTIONS(1930),
    [anon_sym_u32] = ACTIONS(1930),
    [anon_sym_i32] = ACTIONS(1930),
    [anon_sym_u64] = ACTIONS(1930),
    [anon_sym_i64] = ACTIONS(1930),
    [anon_sym_u128] = ACTIONS(1930),
    [anon_sym_i128] = ACTIONS(1930),
    [anon_sym_isize] = ACTIONS(1930),
    [anon_sym_usize] = ACTIONS(1930),
    [anon_sym_f32] = ACTIONS(1930),
    [anon_sym_f64] = ACTIONS(1930),
    [anon_sym_bool] = ACTIONS(1930),
    [anon_sym_str] = ACTIONS(1930),
    [anon_sym_char] = ACTIONS(1930),
    [anon_sym_DASH] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1928),
    [anon_sym_PIPE] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(1928),
    [anon_sym_DOT_DOT] = ACTIONS(1928),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_POUND] = ACTIONS(1928),
    [anon_sym_SQUOTE] = ACTIONS(1930),
    [anon_sym_async] = ACTIONS(1930),
    [anon_sym_break] = ACTIONS(1930),
    [anon_sym_const] = ACTIONS(1930),
    [anon_sym_continue] = ACTIONS(1930),
    [anon_sym_default] = ACTIONS(1930),
    [anon_sym_enum] = ACTIONS(1930),
    [anon_sym_fn] = ACTIONS(1930),
    [anon_sym_for] = ACTIONS(1930),
    [anon_sym_if] = ACTIONS(1930),
    [anon_sym_impl] = ACTIONS(1930),
    [anon_sym_let] = ACTIONS(1930),
    [anon_sym_loop] = ACTIONS(1930),
    [anon_sym_match] = ACTIONS(1930),
    [anon_sym_mod] = ACTIONS(1930),
    [anon_sym_pub] = ACTIONS(1930),
    [anon_sym_return] = ACTIONS(1930),
    [anon_sym_static] = ACTIONS(1930),
    [anon_sym_struct] = ACTIONS(1930),
    [anon_sym_trait] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(1930),
    [anon_sym_union] = ACTIONS(1930),
    [anon_sym_unsafe] = ACTIONS(1930),
    [anon_sym_use] = ACTIONS(1930),
    [anon_sym_while] = ACTIONS(1930),
    [anon_sym_extern] = ACTIONS(1930),
    [anon_sym_yield] = ACTIONS(1930),
    [anon_sym_move] = ACTIONS(1930),
    [anon_sym_try] = ACTIONS(1930),
    [sym_integer_literal] = ACTIONS(1928),
    [aux_sym_string_literal_token1] = ACTIONS(1928),
    [sym_char_literal] = ACTIONS(1928),
    [anon_sym_true] = ACTIONS(1930),
    [anon_sym_false] = ACTIONS(1930),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1930),
    [sym_super] = ACTIONS(1930),
    [sym_crate] = ACTIONS(1930),
    [sym_metavariable] = ACTIONS(1928),
    [sym__raw_string_literal_start] = ACTIONS(1928),
    [sym_float_literal] = ACTIONS(1928),
  },
  [535] = {
    [sym_line_comment] = STATE(535),
    [sym_block_comment] = STATE(535),
    [ts_builtin_sym_end] = ACTIONS(1932),
    [sym_identifier] = ACTIONS(1934),
    [anon_sym_SEMI] = ACTIONS(1932),
    [anon_sym_macro_rules_BANG] = ACTIONS(1932),
    [anon_sym_LPAREN] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LBRACE] = ACTIONS(1932),
    [anon_sym_RBRACE] = ACTIONS(1932),
    [anon_sym_STAR] = ACTIONS(1932),
    [anon_sym_u8] = ACTIONS(1934),
    [anon_sym_i8] = ACTIONS(1934),
    [anon_sym_u16] = ACTIONS(1934),
    [anon_sym_i16] = ACTIONS(1934),
    [anon_sym_u32] = ACTIONS(1934),
    [anon_sym_i32] = ACTIONS(1934),
    [anon_sym_u64] = ACTIONS(1934),
    [anon_sym_i64] = ACTIONS(1934),
    [anon_sym_u128] = ACTIONS(1934),
    [anon_sym_i128] = ACTIONS(1934),
    [anon_sym_isize] = ACTIONS(1934),
    [anon_sym_usize] = ACTIONS(1934),
    [anon_sym_f32] = ACTIONS(1934),
    [anon_sym_f64] = ACTIONS(1934),
    [anon_sym_bool] = ACTIONS(1934),
    [anon_sym_str] = ACTIONS(1934),
    [anon_sym_char] = ACTIONS(1934),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_AMP] = ACTIONS(1932),
    [anon_sym_PIPE] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1932),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_COLON_COLON] = ACTIONS(1932),
    [anon_sym_POUND] = ACTIONS(1932),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [anon_sym_async] = ACTIONS(1934),
    [anon_sym_break] = ACTIONS(1934),
    [anon_sym_const] = ACTIONS(1934),
    [anon_sym_continue] = ACTIONS(1934),
    [anon_sym_default] = ACTIONS(1934),
    [anon_sym_enum] = ACTIONS(1934),
    [anon_sym_fn] = ACTIONS(1934),
    [anon_sym_for] = ACTIONS(1934),
    [anon_sym_if] = ACTIONS(1934),
    [anon_sym_impl] = ACTIONS(1934),
    [anon_sym_let] = ACTIONS(1934),
    [anon_sym_loop] = ACTIONS(1934),
    [anon_sym_match] = ACTIONS(1934),
    [anon_sym_mod] = ACTIONS(1934),
    [anon_sym_pub] = ACTIONS(1934),
    [anon_sym_return] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1934),
    [anon_sym_struct] = ACTIONS(1934),
    [anon_sym_trait] = ACTIONS(1934),
    [anon_sym_type] = ACTIONS(1934),
    [anon_sym_union] = ACTIONS(1934),
    [anon_sym_unsafe] = ACTIONS(1934),
    [anon_sym_use] = ACTIONS(1934),
    [anon_sym_while] = ACTIONS(1934),
    [anon_sym_extern] = ACTIONS(1934),
    [anon_sym_yield] = ACTIONS(1934),
    [anon_sym_move] = ACTIONS(1934),
    [anon_sym_try] = ACTIONS(1934),
    [sym_integer_literal] = ACTIONS(1932),
    [aux_sym_string_literal_token1] = ACTIONS(1932),
    [sym_char_literal] = ACTIONS(1932),
    [anon_sym_true] = ACTIONS(1934),
    [anon_sym_false] = ACTIONS(1934),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1934),
    [sym_super] = ACTIONS(1934),
    [sym_crate] = ACTIONS(1934),
    [sym_metavariable] = ACTIONS(1932),
    [sym__raw_string_literal_start] = ACTIONS(1932),
    [sym_float_literal] = ACTIONS(1932),
  },
  [536] = {
    [sym_line_comment] = STATE(536),
    [sym_block_comment] = STATE(536),
    [ts_builtin_sym_end] = ACTIONS(1936),
    [sym_identifier] = ACTIONS(1938),
    [anon_sym_SEMI] = ACTIONS(1936),
    [anon_sym_macro_rules_BANG] = ACTIONS(1936),
    [anon_sym_LPAREN] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_LBRACE] = ACTIONS(1936),
    [anon_sym_RBRACE] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(1936),
    [anon_sym_u8] = ACTIONS(1938),
    [anon_sym_i8] = ACTIONS(1938),
    [anon_sym_u16] = ACTIONS(1938),
    [anon_sym_i16] = ACTIONS(1938),
    [anon_sym_u32] = ACTIONS(1938),
    [anon_sym_i32] = ACTIONS(1938),
    [anon_sym_u64] = ACTIONS(1938),
    [anon_sym_i64] = ACTIONS(1938),
    [anon_sym_u128] = ACTIONS(1938),
    [anon_sym_i128] = ACTIONS(1938),
    [anon_sym_isize] = ACTIONS(1938),
    [anon_sym_usize] = ACTIONS(1938),
    [anon_sym_f32] = ACTIONS(1938),
    [anon_sym_f64] = ACTIONS(1938),
    [anon_sym_bool] = ACTIONS(1938),
    [anon_sym_str] = ACTIONS(1938),
    [anon_sym_char] = ACTIONS(1938),
    [anon_sym_DASH] = ACTIONS(1936),
    [anon_sym_BANG] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1936),
    [anon_sym_PIPE] = ACTIONS(1936),
    [anon_sym_LT] = ACTIONS(1936),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(1936),
    [anon_sym_POUND] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_async] = ACTIONS(1938),
    [anon_sym_break] = ACTIONS(1938),
    [anon_sym_const] = ACTIONS(1938),
    [anon_sym_continue] = ACTIONS(1938),
    [anon_sym_default] = ACTIONS(1938),
    [anon_sym_enum] = ACTIONS(1938),
    [anon_sym_fn] = ACTIONS(1938),
    [anon_sym_for] = ACTIONS(1938),
    [anon_sym_if] = ACTIONS(1938),
    [anon_sym_impl] = ACTIONS(1938),
    [anon_sym_let] = ACTIONS(1938),
    [anon_sym_loop] = ACTIONS(1938),
    [anon_sym_match] = ACTIONS(1938),
    [anon_sym_mod] = ACTIONS(1938),
    [anon_sym_pub] = ACTIONS(1938),
    [anon_sym_return] = ACTIONS(1938),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_struct] = ACTIONS(1938),
    [anon_sym_trait] = ACTIONS(1938),
    [anon_sym_type] = ACTIONS(1938),
    [anon_sym_union] = ACTIONS(1938),
    [anon_sym_unsafe] = ACTIONS(1938),
    [anon_sym_use] = ACTIONS(1938),
    [anon_sym_while] = ACTIONS(1938),
    [anon_sym_extern] = ACTIONS(1938),
    [anon_sym_yield] = ACTIONS(1938),
    [anon_sym_move] = ACTIONS(1938),
    [anon_sym_try] = ACTIONS(1938),
    [sym_integer_literal] = ACTIONS(1936),
    [aux_sym_string_literal_token1] = ACTIONS(1936),
    [sym_char_literal] = ACTIONS(1936),
    [anon_sym_true] = ACTIONS(1938),
    [anon_sym_false] = ACTIONS(1938),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1938),
    [sym_super] = ACTIONS(1938),
    [sym_crate] = ACTIONS(1938),
    [sym_metavariable] = ACTIONS(1936),
    [sym__raw_string_literal_start] = ACTIONS(1936),
    [sym_float_literal] = ACTIONS(1936),
  },
  [537] = {
    [sym_line_comment] = STATE(537),
    [sym_block_comment] = STATE(537),
    [ts_builtin_sym_end] = ACTIONS(1940),
    [sym_identifier] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1940),
    [anon_sym_macro_rules_BANG] = ACTIONS(1940),
    [anon_sym_LPAREN] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1940),
    [anon_sym_RBRACE] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(1940),
    [anon_sym_u8] = ACTIONS(1942),
    [anon_sym_i8] = ACTIONS(1942),
    [anon_sym_u16] = ACTIONS(1942),
    [anon_sym_i16] = ACTIONS(1942),
    [anon_sym_u32] = ACTIONS(1942),
    [anon_sym_i32] = ACTIONS(1942),
    [anon_sym_u64] = ACTIONS(1942),
    [anon_sym_i64] = ACTIONS(1942),
    [anon_sym_u128] = ACTIONS(1942),
    [anon_sym_i128] = ACTIONS(1942),
    [anon_sym_isize] = ACTIONS(1942),
    [anon_sym_usize] = ACTIONS(1942),
    [anon_sym_f32] = ACTIONS(1942),
    [anon_sym_f64] = ACTIONS(1942),
    [anon_sym_bool] = ACTIONS(1942),
    [anon_sym_str] = ACTIONS(1942),
    [anon_sym_char] = ACTIONS(1942),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_BANG] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PIPE] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1940),
    [anon_sym_DOT_DOT] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1940),
    [anon_sym_POUND] = ACTIONS(1940),
    [anon_sym_SQUOTE] = ACTIONS(1942),
    [anon_sym_async] = ACTIONS(1942),
    [anon_sym_break] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_continue] = ACTIONS(1942),
    [anon_sym_default] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_fn] = ACTIONS(1942),
    [anon_sym_for] = ACTIONS(1942),
    [anon_sym_if] = ACTIONS(1942),
    [anon_sym_impl] = ACTIONS(1942),
    [anon_sym_let] = ACTIONS(1942),
    [anon_sym_loop] = ACTIONS(1942),
    [anon_sym_match] = ACTIONS(1942),
    [anon_sym_mod] = ACTIONS(1942),
    [anon_sym_pub] = ACTIONS(1942),
    [anon_sym_return] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_trait] = ACTIONS(1942),
    [anon_sym_type] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [anon_sym_unsafe] = ACTIONS(1942),
    [anon_sym_use] = ACTIONS(1942),
    [anon_sym_while] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym_yield] = ACTIONS(1942),
    [anon_sym_move] = ACTIONS(1942),
    [anon_sym_try] = ACTIONS(1942),
    [sym_integer_literal] = ACTIONS(1940),
    [aux_sym_string_literal_token1] = ACTIONS(1940),
    [sym_char_literal] = ACTIONS(1940),
    [anon_sym_true] = ACTIONS(1942),
    [anon_sym_false] = ACTIONS(1942),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1942),
    [sym_super] = ACTIONS(1942),
    [sym_crate] = ACTIONS(1942),
    [sym_metavariable] = ACTIONS(1940),
    [sym__raw_string_literal_start] = ACTIONS(1940),
    [sym_float_literal] = ACTIONS(1940),
  },
  [538] = {
    [sym_line_comment] = STATE(538),
    [sym_block_comment] = STATE(538),
    [ts_builtin_sym_end] = ACTIONS(1944),
    [sym_identifier] = ACTIONS(1946),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym_macro_rules_BANG] = ACTIONS(1944),
    [anon_sym_LPAREN] = ACTIONS(1944),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_RBRACE] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_u8] = ACTIONS(1946),
    [anon_sym_i8] = ACTIONS(1946),
    [anon_sym_u16] = ACTIONS(1946),
    [anon_sym_i16] = ACTIONS(1946),
    [anon_sym_u32] = ACTIONS(1946),
    [anon_sym_i32] = ACTIONS(1946),
    [anon_sym_u64] = ACTIONS(1946),
    [anon_sym_i64] = ACTIONS(1946),
    [anon_sym_u128] = ACTIONS(1946),
    [anon_sym_i128] = ACTIONS(1946),
    [anon_sym_isize] = ACTIONS(1946),
    [anon_sym_usize] = ACTIONS(1946),
    [anon_sym_f32] = ACTIONS(1946),
    [anon_sym_f64] = ACTIONS(1946),
    [anon_sym_bool] = ACTIONS(1946),
    [anon_sym_str] = ACTIONS(1946),
    [anon_sym_char] = ACTIONS(1946),
    [anon_sym_DASH] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1944),
    [anon_sym_LT] = ACTIONS(1944),
    [anon_sym_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_POUND] = ACTIONS(1944),
    [anon_sym_SQUOTE] = ACTIONS(1946),
    [anon_sym_async] = ACTIONS(1946),
    [anon_sym_break] = ACTIONS(1946),
    [anon_sym_const] = ACTIONS(1946),
    [anon_sym_continue] = ACTIONS(1946),
    [anon_sym_default] = ACTIONS(1946),
    [anon_sym_enum] = ACTIONS(1946),
    [anon_sym_fn] = ACTIONS(1946),
    [anon_sym_for] = ACTIONS(1946),
    [anon_sym_if] = ACTIONS(1946),
    [anon_sym_impl] = ACTIONS(1946),
    [anon_sym_let] = ACTIONS(1946),
    [anon_sym_loop] = ACTIONS(1946),
    [anon_sym_match] = ACTIONS(1946),
    [anon_sym_mod] = ACTIONS(1946),
    [anon_sym_pub] = ACTIONS(1946),
    [anon_sym_return] = ACTIONS(1946),
    [anon_sym_static] = ACTIONS(1946),
    [anon_sym_struct] = ACTIONS(1946),
    [anon_sym_trait] = ACTIONS(1946),
    [anon_sym_type] = ACTIONS(1946),
    [anon_sym_union] = ACTIONS(1946),
    [anon_sym_unsafe] = ACTIONS(1946),
    [anon_sym_use] = ACTIONS(1946),
    [anon_sym_while] = ACTIONS(1946),
    [anon_sym_extern] = ACTIONS(1946),
    [anon_sym_yield] = ACTIONS(1946),
    [anon_sym_move] = ACTIONS(1946),
    [anon_sym_try] = ACTIONS(1946),
    [sym_integer_literal] = ACTIONS(1944),
    [aux_sym_string_literal_token1] = ACTIONS(1944),
    [sym_char_literal] = ACTIONS(1944),
    [anon_sym_true] = ACTIONS(1946),
    [anon_sym_false] = ACTIONS(1946),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1946),
    [sym_super] = ACTIONS(1946),
    [sym_crate] = ACTIONS(1946),
    [sym_metavariable] = ACTIONS(1944),
    [sym__raw_string_literal_start] = ACTIONS(1944),
    [sym_float_literal] = ACTIONS(1944),
  },
  [539] = {
    [sym_line_comment] = STATE(539),
    [sym_block_comment] = STATE(539),
    [ts_builtin_sym_end] = ACTIONS(1948),
    [sym_identifier] = ACTIONS(1950),
    [anon_sym_SEMI] = ACTIONS(1948),
    [anon_sym_macro_rules_BANG] = ACTIONS(1948),
    [anon_sym_LPAREN] = ACTIONS(1948),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(1948),
    [anon_sym_RBRACE] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(1948),
    [anon_sym_u8] = ACTIONS(1950),
    [anon_sym_i8] = ACTIONS(1950),
    [anon_sym_u16] = ACTIONS(1950),
    [anon_sym_i16] = ACTIONS(1950),
    [anon_sym_u32] = ACTIONS(1950),
    [anon_sym_i32] = ACTIONS(1950),
    [anon_sym_u64] = ACTIONS(1950),
    [anon_sym_i64] = ACTIONS(1950),
    [anon_sym_u128] = ACTIONS(1950),
    [anon_sym_i128] = ACTIONS(1950),
    [anon_sym_isize] = ACTIONS(1950),
    [anon_sym_usize] = ACTIONS(1950),
    [anon_sym_f32] = ACTIONS(1950),
    [anon_sym_f64] = ACTIONS(1950),
    [anon_sym_bool] = ACTIONS(1950),
    [anon_sym_str] = ACTIONS(1950),
    [anon_sym_char] = ACTIONS(1950),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_PIPE] = ACTIONS(1948),
    [anon_sym_LT] = ACTIONS(1948),
    [anon_sym_DOT_DOT] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(1948),
    [anon_sym_POUND] = ACTIONS(1948),
    [anon_sym_SQUOTE] = ACTIONS(1950),
    [anon_sym_async] = ACTIONS(1950),
    [anon_sym_break] = ACTIONS(1950),
    [anon_sym_const] = ACTIONS(1950),
    [anon_sym_continue] = ACTIONS(1950),
    [anon_sym_default] = ACTIONS(1950),
    [anon_sym_enum] = ACTIONS(1950),
    [anon_sym_fn] = ACTIONS(1950),
    [anon_sym_for] = ACTIONS(1950),
    [anon_sym_if] = ACTIONS(1950),
    [anon_sym_impl] = ACTIONS(1950),
    [anon_sym_let] = ACTIONS(1950),
    [anon_sym_loop] = ACTIONS(1950),
    [anon_sym_match] = ACTIONS(1950),
    [anon_sym_mod] = ACTIONS(1950),
    [anon_sym_pub] = ACTIONS(1950),
    [anon_sym_return] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1950),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_trait] = ACTIONS(1950),
    [anon_sym_type] = ACTIONS(1950),
    [anon_sym_union] = ACTIONS(1950),
    [anon_sym_unsafe] = ACTIONS(1950),
    [anon_sym_use] = ACTIONS(1950),
    [anon_sym_while] = ACTIONS(1950),
    [anon_sym_extern] = ACTIONS(1950),
    [anon_sym_yield] = ACTIONS(1950),
    [anon_sym_move] = ACTIONS(1950),
    [anon_sym_try] = ACTIONS(1950),
    [sym_integer_literal] = ACTIONS(1948),
    [aux_sym_string_literal_token1] = ACTIONS(1948),
    [sym_char_literal] = ACTIONS(1948),
    [anon_sym_true] = ACTIONS(1950),
    [anon_sym_false] = ACTIONS(1950),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1950),
    [sym_super] = ACTIONS(1950),
    [sym_crate] = ACTIONS(1950),
    [sym_metavariable] = ACTIONS(1948),
    [sym__raw_string_literal_start] = ACTIONS(1948),
    [sym_float_literal] = ACTIONS(1948),
  },
  [540] = {
    [sym_line_comment] = STATE(540),
    [sym_block_comment] = STATE(540),
    [ts_builtin_sym_end] = ACTIONS(1952),
    [sym_identifier] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1952),
    [anon_sym_macro_rules_BANG] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(1952),
    [anon_sym_LBRACE] = ACTIONS(1952),
    [anon_sym_RBRACE] = ACTIONS(1952),
    [anon_sym_STAR] = ACTIONS(1952),
    [anon_sym_u8] = ACTIONS(1954),
    [anon_sym_i8] = ACTIONS(1954),
    [anon_sym_u16] = ACTIONS(1954),
    [anon_sym_i16] = ACTIONS(1954),
    [anon_sym_u32] = ACTIONS(1954),
    [anon_sym_i32] = ACTIONS(1954),
    [anon_sym_u64] = ACTIONS(1954),
    [anon_sym_i64] = ACTIONS(1954),
    [anon_sym_u128] = ACTIONS(1954),
    [anon_sym_i128] = ACTIONS(1954),
    [anon_sym_isize] = ACTIONS(1954),
    [anon_sym_usize] = ACTIONS(1954),
    [anon_sym_f32] = ACTIONS(1954),
    [anon_sym_f64] = ACTIONS(1954),
    [anon_sym_bool] = ACTIONS(1954),
    [anon_sym_str] = ACTIONS(1954),
    [anon_sym_char] = ACTIONS(1954),
    [anon_sym_DASH] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1952),
    [anon_sym_LT] = ACTIONS(1952),
    [anon_sym_DOT_DOT] = ACTIONS(1952),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_POUND] = ACTIONS(1952),
    [anon_sym_SQUOTE] = ACTIONS(1954),
    [anon_sym_async] = ACTIONS(1954),
    [anon_sym_break] = ACTIONS(1954),
    [anon_sym_const] = ACTIONS(1954),
    [anon_sym_continue] = ACTIONS(1954),
    [anon_sym_default] = ACTIONS(1954),
    [anon_sym_enum] = ACTIONS(1954),
    [anon_sym_fn] = ACTIONS(1954),
    [anon_sym_for] = ACTIONS(1954),
    [anon_sym_if] = ACTIONS(1954),
    [anon_sym_impl] = ACTIONS(1954),
    [anon_sym_let] = ACTIONS(1954),
    [anon_sym_loop] = ACTIONS(1954),
    [anon_sym_match] = ACTIONS(1954),
    [anon_sym_mod] = ACTIONS(1954),
    [anon_sym_pub] = ACTIONS(1954),
    [anon_sym_return] = ACTIONS(1954),
    [anon_sym_static] = ACTIONS(1954),
    [anon_sym_struct] = ACTIONS(1954),
    [anon_sym_trait] = ACTIONS(1954),
    [anon_sym_type] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1954),
    [anon_sym_unsafe] = ACTIONS(1954),
    [anon_sym_use] = ACTIONS(1954),
    [anon_sym_while] = ACTIONS(1954),
    [anon_sym_extern] = ACTIONS(1954),
    [anon_sym_yield] = ACTIONS(1954),
    [anon_sym_move] = ACTIONS(1954),
    [anon_sym_try] = ACTIONS(1954),
    [sym_integer_literal] = ACTIONS(1952),
    [aux_sym_string_literal_token1] = ACTIONS(1952),
    [sym_char_literal] = ACTIONS(1952),
    [anon_sym_true] = ACTIONS(1954),
    [anon_sym_false] = ACTIONS(1954),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1954),
    [sym_super] = ACTIONS(1954),
    [sym_crate] = ACTIONS(1954),
    [sym_metavariable] = ACTIONS(1952),
    [sym__raw_string_literal_start] = ACTIONS(1952),
    [sym_float_literal] = ACTIONS(1952),
  },
  [541] = {
    [sym_line_comment] = STATE(541),
    [sym_block_comment] = STATE(541),
    [ts_builtin_sym_end] = ACTIONS(1956),
    [sym_identifier] = ACTIONS(1958),
    [anon_sym_SEMI] = ACTIONS(1956),
    [anon_sym_macro_rules_BANG] = ACTIONS(1956),
    [anon_sym_LPAREN] = ACTIONS(1956),
    [anon_sym_LBRACK] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1956),
    [anon_sym_RBRACE] = ACTIONS(1956),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_u8] = ACTIONS(1958),
    [anon_sym_i8] = ACTIONS(1958),
    [anon_sym_u16] = ACTIONS(1958),
    [anon_sym_i16] = ACTIONS(1958),
    [anon_sym_u32] = ACTIONS(1958),
    [anon_sym_i32] = ACTIONS(1958),
    [anon_sym_u64] = ACTIONS(1958),
    [anon_sym_i64] = ACTIONS(1958),
    [anon_sym_u128] = ACTIONS(1958),
    [anon_sym_i128] = ACTIONS(1958),
    [anon_sym_isize] = ACTIONS(1958),
    [anon_sym_usize] = ACTIONS(1958),
    [anon_sym_f32] = ACTIONS(1958),
    [anon_sym_f64] = ACTIONS(1958),
    [anon_sym_bool] = ACTIONS(1958),
    [anon_sym_str] = ACTIONS(1958),
    [anon_sym_char] = ACTIONS(1958),
    [anon_sym_DASH] = ACTIONS(1956),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_AMP] = ACTIONS(1956),
    [anon_sym_PIPE] = ACTIONS(1956),
    [anon_sym_LT] = ACTIONS(1956),
    [anon_sym_DOT_DOT] = ACTIONS(1956),
    [anon_sym_COLON_COLON] = ACTIONS(1956),
    [anon_sym_POUND] = ACTIONS(1956),
    [anon_sym_SQUOTE] = ACTIONS(1958),
    [anon_sym_async] = ACTIONS(1958),
    [anon_sym_break] = ACTIONS(1958),
    [anon_sym_const] = ACTIONS(1958),
    [anon_sym_continue] = ACTIONS(1958),
    [anon_sym_default] = ACTIONS(1958),
    [anon_sym_enum] = ACTIONS(1958),
    [anon_sym_fn] = ACTIONS(1958),
    [anon_sym_for] = ACTIONS(1958),
    [anon_sym_if] = ACTIONS(1958),
    [anon_sym_impl] = ACTIONS(1958),
    [anon_sym_let] = ACTIONS(1958),
    [anon_sym_loop] = ACTIONS(1958),
    [anon_sym_match] = ACTIONS(1958),
    [anon_sym_mod] = ACTIONS(1958),
    [anon_sym_pub] = ACTIONS(1958),
    [anon_sym_return] = ACTIONS(1958),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_struct] = ACTIONS(1958),
    [anon_sym_trait] = ACTIONS(1958),
    [anon_sym_type] = ACTIONS(1958),
    [anon_sym_union] = ACTIONS(1958),
    [anon_sym_unsafe] = ACTIONS(1958),
    [anon_sym_use] = ACTIONS(1958),
    [anon_sym_while] = ACTIONS(1958),
    [anon_sym_extern] = ACTIONS(1958),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_move] = ACTIONS(1958),
    [anon_sym_try] = ACTIONS(1958),
    [sym_integer_literal] = ACTIONS(1956),
    [aux_sym_string_literal_token1] = ACTIONS(1956),
    [sym_char_literal] = ACTIONS(1956),
    [anon_sym_true] = ACTIONS(1958),
    [anon_sym_false] = ACTIONS(1958),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1958),
    [sym_super] = ACTIONS(1958),
    [sym_crate] = ACTIONS(1958),
    [sym_metavariable] = ACTIONS(1956),
    [sym__raw_string_literal_start] = ACTIONS(1956),
    [sym_float_literal] = ACTIONS(1956),
  },
  [542] = {
    [sym_line_comment] = STATE(542),
    [sym_block_comment] = STATE(542),
    [ts_builtin_sym_end] = ACTIONS(1960),
    [sym_identifier] = ACTIONS(1962),
    [anon_sym_SEMI] = ACTIONS(1960),
    [anon_sym_macro_rules_BANG] = ACTIONS(1960),
    [anon_sym_LPAREN] = ACTIONS(1960),
    [anon_sym_LBRACK] = ACTIONS(1960),
    [anon_sym_LBRACE] = ACTIONS(1960),
    [anon_sym_RBRACE] = ACTIONS(1960),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_u8] = ACTIONS(1962),
    [anon_sym_i8] = ACTIONS(1962),
    [anon_sym_u16] = ACTIONS(1962),
    [anon_sym_i16] = ACTIONS(1962),
    [anon_sym_u32] = ACTIONS(1962),
    [anon_sym_i32] = ACTIONS(1962),
    [anon_sym_u64] = ACTIONS(1962),
    [anon_sym_i64] = ACTIONS(1962),
    [anon_sym_u128] = ACTIONS(1962),
    [anon_sym_i128] = ACTIONS(1962),
    [anon_sym_isize] = ACTIONS(1962),
    [anon_sym_usize] = ACTIONS(1962),
    [anon_sym_f32] = ACTIONS(1962),
    [anon_sym_f64] = ACTIONS(1962),
    [anon_sym_bool] = ACTIONS(1962),
    [anon_sym_str] = ACTIONS(1962),
    [anon_sym_char] = ACTIONS(1962),
    [anon_sym_DASH] = ACTIONS(1960),
    [anon_sym_BANG] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_DOT_DOT] = ACTIONS(1960),
    [anon_sym_COLON_COLON] = ACTIONS(1960),
    [anon_sym_POUND] = ACTIONS(1960),
    [anon_sym_SQUOTE] = ACTIONS(1962),
    [anon_sym_async] = ACTIONS(1962),
    [anon_sym_break] = ACTIONS(1962),
    [anon_sym_const] = ACTIONS(1962),
    [anon_sym_continue] = ACTIONS(1962),
    [anon_sym_default] = ACTIONS(1962),
    [anon_sym_enum] = ACTIONS(1962),
    [anon_sym_fn] = ACTIONS(1962),
    [anon_sym_for] = ACTIONS(1962),
    [anon_sym_if] = ACTIONS(1962),
    [anon_sym_impl] = ACTIONS(1962),
    [anon_sym_let] = ACTIONS(1962),
    [anon_sym_loop] = ACTIONS(1962),
    [anon_sym_match] = ACTIONS(1962),
    [anon_sym_mod] = ACTIONS(1962),
    [anon_sym_pub] = ACTIONS(1962),
    [anon_sym_return] = ACTIONS(1962),
    [anon_sym_static] = ACTIONS(1962),
    [anon_sym_struct] = ACTIONS(1962),
    [anon_sym_trait] = ACTIONS(1962),
    [anon_sym_type] = ACTIONS(1962),
    [anon_sym_union] = ACTIONS(1962),
    [anon_sym_unsafe] = ACTIONS(1962),
    [anon_sym_use] = ACTIONS(1962),
    [anon_sym_while] = ACTIONS(1962),
    [anon_sym_extern] = ACTIONS(1962),
    [anon_sym_yield] = ACTIONS(1962),
    [anon_sym_move] = ACTIONS(1962),
    [anon_sym_try] = ACTIONS(1962),
    [sym_integer_literal] = ACTIONS(1960),
    [aux_sym_string_literal_token1] = ACTIONS(1960),
    [sym_char_literal] = ACTIONS(1960),
    [anon_sym_true] = ACTIONS(1962),
    [anon_sym_false] = ACTIONS(1962),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1962),
    [sym_super] = ACTIONS(1962),
    [sym_crate] = ACTIONS(1962),
    [sym_metavariable] = ACTIONS(1960),
    [sym__raw_string_literal_start] = ACTIONS(1960),
    [sym_float_literal] = ACTIONS(1960),
  },
  [543] = {
    [sym_line_comment] = STATE(543),
    [sym_block_comment] = STATE(543),
    [ts_builtin_sym_end] = ACTIONS(1964),
    [sym_identifier] = ACTIONS(1966),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_macro_rules_BANG] = ACTIONS(1964),
    [anon_sym_LPAREN] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_LBRACE] = ACTIONS(1964),
    [anon_sym_RBRACE] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(1964),
    [anon_sym_u8] = ACTIONS(1966),
    [anon_sym_i8] = ACTIONS(1966),
    [anon_sym_u16] = ACTIONS(1966),
    [anon_sym_i16] = ACTIONS(1966),
    [anon_sym_u32] = ACTIONS(1966),
    [anon_sym_i32] = ACTIONS(1966),
    [anon_sym_u64] = ACTIONS(1966),
    [anon_sym_i64] = ACTIONS(1966),
    [anon_sym_u128] = ACTIONS(1966),
    [anon_sym_i128] = ACTIONS(1966),
    [anon_sym_isize] = ACTIONS(1966),
    [anon_sym_usize] = ACTIONS(1966),
    [anon_sym_f32] = ACTIONS(1966),
    [anon_sym_f64] = ACTIONS(1966),
    [anon_sym_bool] = ACTIONS(1966),
    [anon_sym_str] = ACTIONS(1966),
    [anon_sym_char] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_BANG] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1964),
    [anon_sym_POUND] = ACTIONS(1964),
    [anon_sym_SQUOTE] = ACTIONS(1966),
    [anon_sym_async] = ACTIONS(1966),
    [anon_sym_break] = ACTIONS(1966),
    [anon_sym_const] = ACTIONS(1966),
    [anon_sym_continue] = ACTIONS(1966),
    [anon_sym_default] = ACTIONS(1966),
    [anon_sym_enum] = ACTIONS(1966),
    [anon_sym_fn] = ACTIONS(1966),
    [anon_sym_for] = ACTIONS(1966),
    [anon_sym_if] = ACTIONS(1966),
    [anon_sym_impl] = ACTIONS(1966),
    [anon_sym_let] = ACTIONS(1966),
    [anon_sym_loop] = ACTIONS(1966),
    [anon_sym_match] = ACTIONS(1966),
    [anon_sym_mod] = ACTIONS(1966),
    [anon_sym_pub] = ACTIONS(1966),
    [anon_sym_return] = ACTIONS(1966),
    [anon_sym_static] = ACTIONS(1966),
    [anon_sym_struct] = ACTIONS(1966),
    [anon_sym_trait] = ACTIONS(1966),
    [anon_sym_type] = ACTIONS(1966),
    [anon_sym_union] = ACTIONS(1966),
    [anon_sym_unsafe] = ACTIONS(1966),
    [anon_sym_use] = ACTIONS(1966),
    [anon_sym_while] = ACTIONS(1966),
    [anon_sym_extern] = ACTIONS(1966),
    [anon_sym_yield] = ACTIONS(1966),
    [anon_sym_move] = ACTIONS(1966),
    [anon_sym_try] = ACTIONS(1966),
    [sym_integer_literal] = ACTIONS(1964),
    [aux_sym_string_literal_token1] = ACTIONS(1964),
    [sym_char_literal] = ACTIONS(1964),
    [anon_sym_true] = ACTIONS(1966),
    [anon_sym_false] = ACTIONS(1966),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1966),
    [sym_super] = ACTIONS(1966),
    [sym_crate] = ACTIONS(1966),
    [sym_metavariable] = ACTIONS(1964),
    [sym__raw_string_literal_start] = ACTIONS(1964),
    [sym_float_literal] = ACTIONS(1964),
  },
  [544] = {
    [sym_line_comment] = STATE(544),
    [sym_block_comment] = STATE(544),
    [ts_builtin_sym_end] = ACTIONS(1968),
    [sym_identifier] = ACTIONS(1970),
    [anon_sym_SEMI] = ACTIONS(1968),
    [anon_sym_macro_rules_BANG] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1968),
    [anon_sym_LBRACK] = ACTIONS(1968),
    [anon_sym_LBRACE] = ACTIONS(1968),
    [anon_sym_RBRACE] = ACTIONS(1968),
    [anon_sym_STAR] = ACTIONS(1968),
    [anon_sym_u8] = ACTIONS(1970),
    [anon_sym_i8] = ACTIONS(1970),
    [anon_sym_u16] = ACTIONS(1970),
    [anon_sym_i16] = ACTIONS(1970),
    [anon_sym_u32] = ACTIONS(1970),
    [anon_sym_i32] = ACTIONS(1970),
    [anon_sym_u64] = ACTIONS(1970),
    [anon_sym_i64] = ACTIONS(1970),
    [anon_sym_u128] = ACTIONS(1970),
    [anon_sym_i128] = ACTIONS(1970),
    [anon_sym_isize] = ACTIONS(1970),
    [anon_sym_usize] = ACTIONS(1970),
    [anon_sym_f32] = ACTIONS(1970),
    [anon_sym_f64] = ACTIONS(1970),
    [anon_sym_bool] = ACTIONS(1970),
    [anon_sym_str] = ACTIONS(1970),
    [anon_sym_char] = ACTIONS(1970),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_BANG] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_DOT_DOT] = ACTIONS(1968),
    [anon_sym_COLON_COLON] = ACTIONS(1968),
    [anon_sym_POUND] = ACTIONS(1968),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_async] = ACTIONS(1970),
    [anon_sym_break] = ACTIONS(1970),
    [anon_sym_const] = ACTIONS(1970),
    [anon_sym_continue] = ACTIONS(1970),
    [anon_sym_default] = ACTIONS(1970),
    [anon_sym_enum] = ACTIONS(1970),
    [anon_sym_fn] = ACTIONS(1970),
    [anon_sym_for] = ACTIONS(1970),
    [anon_sym_if] = ACTIONS(1970),
    [anon_sym_impl] = ACTIONS(1970),
    [anon_sym_let] = ACTIONS(1970),
    [anon_sym_loop] = ACTIONS(1970),
    [anon_sym_match] = ACTIONS(1970),
    [anon_sym_mod] = ACTIONS(1970),
    [anon_sym_pub] = ACTIONS(1970),
    [anon_sym_return] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1970),
    [anon_sym_struct] = ACTIONS(1970),
    [anon_sym_trait] = ACTIONS(1970),
    [anon_sym_type] = ACTIONS(1970),
    [anon_sym_union] = ACTIONS(1970),
    [anon_sym_unsafe] = ACTIONS(1970),
    [anon_sym_use] = ACTIONS(1970),
    [anon_sym_while] = ACTIONS(1970),
    [anon_sym_extern] = ACTIONS(1970),
    [anon_sym_yield] = ACTIONS(1970),
    [anon_sym_move] = ACTIONS(1970),
    [anon_sym_try] = ACTIONS(1970),
    [sym_integer_literal] = ACTIONS(1968),
    [aux_sym_string_literal_token1] = ACTIONS(1968),
    [sym_char_literal] = ACTIONS(1968),
    [anon_sym_true] = ACTIONS(1970),
    [anon_sym_false] = ACTIONS(1970),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1970),
    [sym_super] = ACTIONS(1970),
    [sym_crate] = ACTIONS(1970),
    [sym_metavariable] = ACTIONS(1968),
    [sym__raw_string_literal_start] = ACTIONS(1968),
    [sym_float_literal] = ACTIONS(1968),
  },
  [545] = {
    [sym_line_comment] = STATE(545),
    [sym_block_comment] = STATE(545),
    [ts_builtin_sym_end] = ACTIONS(1972),
    [sym_identifier] = ACTIONS(1974),
    [anon_sym_SEMI] = ACTIONS(1972),
    [anon_sym_macro_rules_BANG] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1972),
    [anon_sym_RBRACE] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_u8] = ACTIONS(1974),
    [anon_sym_i8] = ACTIONS(1974),
    [anon_sym_u16] = ACTIONS(1974),
    [anon_sym_i16] = ACTIONS(1974),
    [anon_sym_u32] = ACTIONS(1974),
    [anon_sym_i32] = ACTIONS(1974),
    [anon_sym_u64] = ACTIONS(1974),
    [anon_sym_i64] = ACTIONS(1974),
    [anon_sym_u128] = ACTIONS(1974),
    [anon_sym_i128] = ACTIONS(1974),
    [anon_sym_isize] = ACTIONS(1974),
    [anon_sym_usize] = ACTIONS(1974),
    [anon_sym_f32] = ACTIONS(1974),
    [anon_sym_f64] = ACTIONS(1974),
    [anon_sym_bool] = ACTIONS(1974),
    [anon_sym_str] = ACTIONS(1974),
    [anon_sym_char] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1972),
    [anon_sym_BANG] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1972),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_COLON_COLON] = ACTIONS(1972),
    [anon_sym_POUND] = ACTIONS(1972),
    [anon_sym_SQUOTE] = ACTIONS(1974),
    [anon_sym_async] = ACTIONS(1974),
    [anon_sym_break] = ACTIONS(1974),
    [anon_sym_const] = ACTIONS(1974),
    [anon_sym_continue] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1974),
    [anon_sym_enum] = ACTIONS(1974),
    [anon_sym_fn] = ACTIONS(1974),
    [anon_sym_for] = ACTIONS(1974),
    [anon_sym_if] = ACTIONS(1974),
    [anon_sym_impl] = ACTIONS(1974),
    [anon_sym_let] = ACTIONS(1974),
    [anon_sym_loop] = ACTIONS(1974),
    [anon_sym_match] = ACTIONS(1974),
    [anon_sym_mod] = ACTIONS(1974),
    [anon_sym_pub] = ACTIONS(1974),
    [anon_sym_return] = ACTIONS(1974),
    [anon_sym_static] = ACTIONS(1974),
    [anon_sym_struct] = ACTIONS(1974),
    [anon_sym_trait] = ACTIONS(1974),
    [anon_sym_type] = ACTIONS(1974),
    [anon_sym_union] = ACTIONS(1974),
    [anon_sym_unsafe] = ACTIONS(1974),
    [anon_sym_use] = ACTIONS(1974),
    [anon_sym_while] = ACTIONS(1974),
    [anon_sym_extern] = ACTIONS(1974),
    [anon_sym_yield] = ACTIONS(1974),
    [anon_sym_move] = ACTIONS(1974),
    [anon_sym_try] = ACTIONS(1974),
    [sym_integer_literal] = ACTIONS(1972),
    [aux_sym_string_literal_token1] = ACTIONS(1972),
    [sym_char_literal] = ACTIONS(1972),
    [anon_sym_true] = ACTIONS(1974),
    [anon_sym_false] = ACTIONS(1974),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1974),
    [sym_super] = ACTIONS(1974),
    [sym_crate] = ACTIONS(1974),
    [sym_metavariable] = ACTIONS(1972),
    [sym__raw_string_literal_start] = ACTIONS(1972),
    [sym_float_literal] = ACTIONS(1972),
  },
  [546] = {
    [sym_line_comment] = STATE(546),
    [sym_block_comment] = STATE(546),
    [ts_builtin_sym_end] = ACTIONS(1976),
    [sym_identifier] = ACTIONS(1978),
    [anon_sym_SEMI] = ACTIONS(1976),
    [anon_sym_macro_rules_BANG] = ACTIONS(1976),
    [anon_sym_LPAREN] = ACTIONS(1976),
    [anon_sym_LBRACK] = ACTIONS(1976),
    [anon_sym_LBRACE] = ACTIONS(1976),
    [anon_sym_RBRACE] = ACTIONS(1976),
    [anon_sym_STAR] = ACTIONS(1976),
    [anon_sym_u8] = ACTIONS(1978),
    [anon_sym_i8] = ACTIONS(1978),
    [anon_sym_u16] = ACTIONS(1978),
    [anon_sym_i16] = ACTIONS(1978),
    [anon_sym_u32] = ACTIONS(1978),
    [anon_sym_i32] = ACTIONS(1978),
    [anon_sym_u64] = ACTIONS(1978),
    [anon_sym_i64] = ACTIONS(1978),
    [anon_sym_u128] = ACTIONS(1978),
    [anon_sym_i128] = ACTIONS(1978),
    [anon_sym_isize] = ACTIONS(1978),
    [anon_sym_usize] = ACTIONS(1978),
    [anon_sym_f32] = ACTIONS(1978),
    [anon_sym_f64] = ACTIONS(1978),
    [anon_sym_bool] = ACTIONS(1978),
    [anon_sym_str] = ACTIONS(1978),
    [anon_sym_char] = ACTIONS(1978),
    [anon_sym_DASH] = ACTIONS(1976),
    [anon_sym_BANG] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1976),
    [anon_sym_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1976),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_COLON_COLON] = ACTIONS(1976),
    [anon_sym_POUND] = ACTIONS(1976),
    [anon_sym_SQUOTE] = ACTIONS(1978),
    [anon_sym_async] = ACTIONS(1978),
    [anon_sym_break] = ACTIONS(1978),
    [anon_sym_const] = ACTIONS(1978),
    [anon_sym_continue] = ACTIONS(1978),
    [anon_sym_default] = ACTIONS(1978),
    [anon_sym_enum] = ACTIONS(1978),
    [anon_sym_fn] = ACTIONS(1978),
    [anon_sym_for] = ACTIONS(1978),
    [anon_sym_if] = ACTIONS(1978),
    [anon_sym_impl] = ACTIONS(1978),
    [anon_sym_let] = ACTIONS(1978),
    [anon_sym_loop] = ACTIONS(1978),
    [anon_sym_match] = ACTIONS(1978),
    [anon_sym_mod] = ACTIONS(1978),
    [anon_sym_pub] = ACTIONS(1978),
    [anon_sym_return] = ACTIONS(1978),
    [anon_sym_static] = ACTIONS(1978),
    [anon_sym_struct] = ACTIONS(1978),
    [anon_sym_trait] = ACTIONS(1978),
    [anon_sym_type] = ACTIONS(1978),
    [anon_sym_union] = ACTIONS(1978),
    [anon_sym_unsafe] = ACTIONS(1978),
    [anon_sym_use] = ACTIONS(1978),
    [anon_sym_while] = ACTIONS(1978),
    [anon_sym_extern] = ACTIONS(1978),
    [anon_sym_yield] = ACTIONS(1978),
    [anon_sym_move] = ACTIONS(1978),
    [anon_sym_try] = ACTIONS(1978),
    [sym_integer_literal] = ACTIONS(1976),
    [aux_sym_string_literal_token1] = ACTIONS(1976),
    [sym_char_literal] = ACTIONS(1976),
    [anon_sym_true] = ACTIONS(1978),
    [anon_sym_false] = ACTIONS(1978),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1978),
    [sym_super] = ACTIONS(1978),
    [sym_crate] = ACTIONS(1978),
    [sym_metavariable] = ACTIONS(1976),
    [sym__raw_string_literal_start] = ACTIONS(1976),
    [sym_float_literal] = ACTIONS(1976),
  },
  [547] = {
    [sym_line_comment] = STATE(547),
    [sym_block_comment] = STATE(547),
    [ts_builtin_sym_end] = ACTIONS(1980),
    [sym_identifier] = ACTIONS(1982),
    [anon_sym_SEMI] = ACTIONS(1980),
    [anon_sym_macro_rules_BANG] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_u8] = ACTIONS(1982),
    [anon_sym_i8] = ACTIONS(1982),
    [anon_sym_u16] = ACTIONS(1982),
    [anon_sym_i16] = ACTIONS(1982),
    [anon_sym_u32] = ACTIONS(1982),
    [anon_sym_i32] = ACTIONS(1982),
    [anon_sym_u64] = ACTIONS(1982),
    [anon_sym_i64] = ACTIONS(1982),
    [anon_sym_u128] = ACTIONS(1982),
    [anon_sym_i128] = ACTIONS(1982),
    [anon_sym_isize] = ACTIONS(1982),
    [anon_sym_usize] = ACTIONS(1982),
    [anon_sym_f32] = ACTIONS(1982),
    [anon_sym_f64] = ACTIONS(1982),
    [anon_sym_bool] = ACTIONS(1982),
    [anon_sym_str] = ACTIONS(1982),
    [anon_sym_char] = ACTIONS(1982),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_BANG] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1980),
    [anon_sym_DOT_DOT] = ACTIONS(1980),
    [anon_sym_COLON_COLON] = ACTIONS(1980),
    [anon_sym_POUND] = ACTIONS(1980),
    [anon_sym_SQUOTE] = ACTIONS(1982),
    [anon_sym_async] = ACTIONS(1982),
    [anon_sym_break] = ACTIONS(1982),
    [anon_sym_const] = ACTIONS(1982),
    [anon_sym_continue] = ACTIONS(1982),
    [anon_sym_default] = ACTIONS(1982),
    [anon_sym_enum] = ACTIONS(1982),
    [anon_sym_fn] = ACTIONS(1982),
    [anon_sym_for] = ACTIONS(1982),
    [anon_sym_if] = ACTIONS(1982),
    [anon_sym_impl] = ACTIONS(1982),
    [anon_sym_let] = ACTIONS(1982),
    [anon_sym_loop] = ACTIONS(1982),
    [anon_sym_match] = ACTIONS(1982),
    [anon_sym_mod] = ACTIONS(1982),
    [anon_sym_pub] = ACTIONS(1982),
    [anon_sym_return] = ACTIONS(1982),
    [anon_sym_static] = ACTIONS(1982),
    [anon_sym_struct] = ACTIONS(1982),
    [anon_sym_trait] = ACTIONS(1982),
    [anon_sym_type] = ACTIONS(1982),
    [anon_sym_union] = ACTIONS(1982),
    [anon_sym_unsafe] = ACTIONS(1982),
    [anon_sym_use] = ACTIONS(1982),
    [anon_sym_while] = ACTIONS(1982),
    [anon_sym_extern] = ACTIONS(1982),
    [anon_sym_yield] = ACTIONS(1982),
    [anon_sym_move] = ACTIONS(1982),
    [anon_sym_try] = ACTIONS(1982),
    [sym_integer_literal] = ACTIONS(1980),
    [aux_sym_string_literal_token1] = ACTIONS(1980),
    [sym_char_literal] = ACTIONS(1980),
    [anon_sym_true] = ACTIONS(1982),
    [anon_sym_false] = ACTIONS(1982),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1982),
    [sym_super] = ACTIONS(1982),
    [sym_crate] = ACTIONS(1982),
    [sym_metavariable] = ACTIONS(1980),
    [sym__raw_string_literal_start] = ACTIONS(1980),
    [sym_float_literal] = ACTIONS(1980),
  },
  [548] = {
    [sym_line_comment] = STATE(548),
    [sym_block_comment] = STATE(548),
    [ts_builtin_sym_end] = ACTIONS(1984),
    [sym_identifier] = ACTIONS(1986),
    [anon_sym_SEMI] = ACTIONS(1984),
    [anon_sym_macro_rules_BANG] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1984),
    [anon_sym_u8] = ACTIONS(1986),
    [anon_sym_i8] = ACTIONS(1986),
    [anon_sym_u16] = ACTIONS(1986),
    [anon_sym_i16] = ACTIONS(1986),
    [anon_sym_u32] = ACTIONS(1986),
    [anon_sym_i32] = ACTIONS(1986),
    [anon_sym_u64] = ACTIONS(1986),
    [anon_sym_i64] = ACTIONS(1986),
    [anon_sym_u128] = ACTIONS(1986),
    [anon_sym_i128] = ACTIONS(1986),
    [anon_sym_isize] = ACTIONS(1986),
    [anon_sym_usize] = ACTIONS(1986),
    [anon_sym_f32] = ACTIONS(1986),
    [anon_sym_f64] = ACTIONS(1986),
    [anon_sym_bool] = ACTIONS(1986),
    [anon_sym_str] = ACTIONS(1986),
    [anon_sym_char] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_DOT_DOT] = ACTIONS(1984),
    [anon_sym_COLON_COLON] = ACTIONS(1984),
    [anon_sym_POUND] = ACTIONS(1984),
    [anon_sym_SQUOTE] = ACTIONS(1986),
    [anon_sym_async] = ACTIONS(1986),
    [anon_sym_break] = ACTIONS(1986),
    [anon_sym_const] = ACTIONS(1986),
    [anon_sym_continue] = ACTIONS(1986),
    [anon_sym_default] = ACTIONS(1986),
    [anon_sym_enum] = ACTIONS(1986),
    [anon_sym_fn] = ACTIONS(1986),
    [anon_sym_for] = ACTIONS(1986),
    [anon_sym_if] = ACTIONS(1986),
    [anon_sym_impl] = ACTIONS(1986),
    [anon_sym_let] = ACTIONS(1986),
    [anon_sym_loop] = ACTIONS(1986),
    [anon_sym_match] = ACTIONS(1986),
    [anon_sym_mod] = ACTIONS(1986),
    [anon_sym_pub] = ACTIONS(1986),
    [anon_sym_return] = ACTIONS(1986),
    [anon_sym_static] = ACTIONS(1986),
    [anon_sym_struct] = ACTIONS(1986),
    [anon_sym_trait] = ACTIONS(1986),
    [anon_sym_type] = ACTIONS(1986),
    [anon_sym_union] = ACTIONS(1986),
    [anon_sym_unsafe] = ACTIONS(1986),
    [anon_sym_use] = ACTIONS(1986),
    [anon_sym_while] = ACTIONS(1986),
    [anon_sym_extern] = ACTIONS(1986),
    [anon_sym_yield] = ACTIONS(1986),
    [anon_sym_move] = ACTIONS(1986),
    [anon_sym_try] = ACTIONS(1986),
    [sym_integer_literal] = ACTIONS(1984),
    [aux_sym_string_literal_token1] = ACTIONS(1984),
    [sym_char_literal] = ACTIONS(1984),
    [anon_sym_true] = ACTIONS(1986),
    [anon_sym_false] = ACTIONS(1986),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1986),
    [sym_super] = ACTIONS(1986),
    [sym_crate] = ACTIONS(1986),
    [sym_metavariable] = ACTIONS(1984),
    [sym__raw_string_literal_start] = ACTIONS(1984),
    [sym_float_literal] = ACTIONS(1984),
  },
  [549] = {
    [sym_line_comment] = STATE(549),
    [sym_block_comment] = STATE(549),
    [ts_builtin_sym_end] = ACTIONS(1988),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_SEMI] = ACTIONS(1988),
    [anon_sym_macro_rules_BANG] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1988),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1988),
    [anon_sym_u8] = ACTIONS(1990),
    [anon_sym_i8] = ACTIONS(1990),
    [anon_sym_u16] = ACTIONS(1990),
    [anon_sym_i16] = ACTIONS(1990),
    [anon_sym_u32] = ACTIONS(1990),
    [anon_sym_i32] = ACTIONS(1990),
    [anon_sym_u64] = ACTIONS(1990),
    [anon_sym_i64] = ACTIONS(1990),
    [anon_sym_u128] = ACTIONS(1990),
    [anon_sym_i128] = ACTIONS(1990),
    [anon_sym_isize] = ACTIONS(1990),
    [anon_sym_usize] = ACTIONS(1990),
    [anon_sym_f32] = ACTIONS(1990),
    [anon_sym_f64] = ACTIONS(1990),
    [anon_sym_bool] = ACTIONS(1990),
    [anon_sym_str] = ACTIONS(1990),
    [anon_sym_char] = ACTIONS(1990),
    [anon_sym_DASH] = ACTIONS(1988),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_PIPE] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_DOT_DOT] = ACTIONS(1988),
    [anon_sym_COLON_COLON] = ACTIONS(1988),
    [anon_sym_POUND] = ACTIONS(1988),
    [anon_sym_SQUOTE] = ACTIONS(1990),
    [anon_sym_async] = ACTIONS(1990),
    [anon_sym_break] = ACTIONS(1990),
    [anon_sym_const] = ACTIONS(1990),
    [anon_sym_continue] = ACTIONS(1990),
    [anon_sym_default] = ACTIONS(1990),
    [anon_sym_enum] = ACTIONS(1990),
    [anon_sym_fn] = ACTIONS(1990),
    [anon_sym_for] = ACTIONS(1990),
    [anon_sym_if] = ACTIONS(1990),
    [anon_sym_impl] = ACTIONS(1990),
    [anon_sym_let] = ACTIONS(1990),
    [anon_sym_loop] = ACTIONS(1990),
    [anon_sym_match] = ACTIONS(1990),
    [anon_sym_mod] = ACTIONS(1990),
    [anon_sym_pub] = ACTIONS(1990),
    [anon_sym_return] = ACTIONS(1990),
    [anon_sym_static] = ACTIONS(1990),
    [anon_sym_struct] = ACTIONS(1990),
    [anon_sym_trait] = ACTIONS(1990),
    [anon_sym_type] = ACTIONS(1990),
    [anon_sym_union] = ACTIONS(1990),
    [anon_sym_unsafe] = ACTIONS(1990),
    [anon_sym_use] = ACTIONS(1990),
    [anon_sym_while] = ACTIONS(1990),
    [anon_sym_extern] = ACTIONS(1990),
    [anon_sym_yield] = ACTIONS(1990),
    [anon_sym_move] = ACTIONS(1990),
    [anon_sym_try] = ACTIONS(1990),
    [sym_integer_literal] = ACTIONS(1988),
    [aux_sym_string_literal_token1] = ACTIONS(1988),
    [sym_char_literal] = ACTIONS(1988),
    [anon_sym_true] = ACTIONS(1990),
    [anon_sym_false] = ACTIONS(1990),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1990),
    [sym_super] = ACTIONS(1990),
    [sym_crate] = ACTIONS(1990),
    [sym_metavariable] = ACTIONS(1988),
    [sym__raw_string_literal_start] = ACTIONS(1988),
    [sym_float_literal] = ACTIONS(1988),
  },
  [550] = {
    [sym_line_comment] = STATE(550),
    [sym_block_comment] = STATE(550),
    [ts_builtin_sym_end] = ACTIONS(1992),
    [sym_identifier] = ACTIONS(1994),
    [anon_sym_SEMI] = ACTIONS(1992),
    [anon_sym_macro_rules_BANG] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1992),
    [anon_sym_LBRACK] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1992),
    [anon_sym_RBRACE] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1992),
    [anon_sym_u8] = ACTIONS(1994),
    [anon_sym_i8] = ACTIONS(1994),
    [anon_sym_u16] = ACTIONS(1994),
    [anon_sym_i16] = ACTIONS(1994),
    [anon_sym_u32] = ACTIONS(1994),
    [anon_sym_i32] = ACTIONS(1994),
    [anon_sym_u64] = ACTIONS(1994),
    [anon_sym_i64] = ACTIONS(1994),
    [anon_sym_u128] = ACTIONS(1994),
    [anon_sym_i128] = ACTIONS(1994),
    [anon_sym_isize] = ACTIONS(1994),
    [anon_sym_usize] = ACTIONS(1994),
    [anon_sym_f32] = ACTIONS(1994),
    [anon_sym_f64] = ACTIONS(1994),
    [anon_sym_bool] = ACTIONS(1994),
    [anon_sym_str] = ACTIONS(1994),
    [anon_sym_char] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_BANG] = ACTIONS(1992),
    [anon_sym_AMP] = ACTIONS(1992),
    [anon_sym_PIPE] = ACTIONS(1992),
    [anon_sym_LT] = ACTIONS(1992),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_COLON_COLON] = ACTIONS(1992),
    [anon_sym_POUND] = ACTIONS(1992),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [anon_sym_async] = ACTIONS(1994),
    [anon_sym_break] = ACTIONS(1994),
    [anon_sym_const] = ACTIONS(1994),
    [anon_sym_continue] = ACTIONS(1994),
    [anon_sym_default] = ACTIONS(1994),
    [anon_sym_enum] = ACTIONS(1994),
    [anon_sym_fn] = ACTIONS(1994),
    [anon_sym_for] = ACTIONS(1994),
    [anon_sym_if] = ACTIONS(1994),
    [anon_sym_impl] = ACTIONS(1994),
    [anon_sym_let] = ACTIONS(1994),
    [anon_sym_loop] = ACTIONS(1994),
    [anon_sym_match] = ACTIONS(1994),
    [anon_sym_mod] = ACTIONS(1994),
    [anon_sym_pub] = ACTIONS(1994),
    [anon_sym_return] = ACTIONS(1994),
    [anon_sym_static] = ACTIONS(1994),
    [anon_sym_struct] = ACTIONS(1994),
    [anon_sym_trait] = ACTIONS(1994),
    [anon_sym_type] = ACTIONS(1994),
    [anon_sym_union] = ACTIONS(1994),
    [anon_sym_unsafe] = ACTIONS(1994),
    [anon_sym_use] = ACTIONS(1994),
    [anon_sym_while] = ACTIONS(1994),
    [anon_sym_extern] = ACTIONS(1994),
    [anon_sym_yield] = ACTIONS(1994),
    [anon_sym_move] = ACTIONS(1994),
    [anon_sym_try] = ACTIONS(1994),
    [sym_integer_literal] = ACTIONS(1992),
    [aux_sym_string_literal_token1] = ACTIONS(1992),
    [sym_char_literal] = ACTIONS(1992),
    [anon_sym_true] = ACTIONS(1994),
    [anon_sym_false] = ACTIONS(1994),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1994),
    [sym_super] = ACTIONS(1994),
    [sym_crate] = ACTIONS(1994),
    [sym_metavariable] = ACTIONS(1992),
    [sym__raw_string_literal_start] = ACTIONS(1992),
    [sym_float_literal] = ACTIONS(1992),
  },
  [551] = {
    [sym_line_comment] = STATE(551),
    [sym_block_comment] = STATE(551),
    [ts_builtin_sym_end] = ACTIONS(1996),
    [sym_identifier] = ACTIONS(1998),
    [anon_sym_SEMI] = ACTIONS(1996),
    [anon_sym_macro_rules_BANG] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(1996),
    [anon_sym_LBRACK] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1996),
    [anon_sym_RBRACE] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(1996),
    [anon_sym_u8] = ACTIONS(1998),
    [anon_sym_i8] = ACTIONS(1998),
    [anon_sym_u16] = ACTIONS(1998),
    [anon_sym_i16] = ACTIONS(1998),
    [anon_sym_u32] = ACTIONS(1998),
    [anon_sym_i32] = ACTIONS(1998),
    [anon_sym_u64] = ACTIONS(1998),
    [anon_sym_i64] = ACTIONS(1998),
    [anon_sym_u128] = ACTIONS(1998),
    [anon_sym_i128] = ACTIONS(1998),
    [anon_sym_isize] = ACTIONS(1998),
    [anon_sym_usize] = ACTIONS(1998),
    [anon_sym_f32] = ACTIONS(1998),
    [anon_sym_f64] = ACTIONS(1998),
    [anon_sym_bool] = ACTIONS(1998),
    [anon_sym_str] = ACTIONS(1998),
    [anon_sym_char] = ACTIONS(1998),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_BANG] = ACTIONS(1996),
    [anon_sym_AMP] = ACTIONS(1996),
    [anon_sym_PIPE] = ACTIONS(1996),
    [anon_sym_LT] = ACTIONS(1996),
    [anon_sym_DOT_DOT] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1996),
    [anon_sym_POUND] = ACTIONS(1996),
    [anon_sym_SQUOTE] = ACTIONS(1998),
    [anon_sym_async] = ACTIONS(1998),
    [anon_sym_break] = ACTIONS(1998),
    [anon_sym_const] = ACTIONS(1998),
    [anon_sym_continue] = ACTIONS(1998),
    [anon_sym_default] = ACTIONS(1998),
    [anon_sym_enum] = ACTIONS(1998),
    [anon_sym_fn] = ACTIONS(1998),
    [anon_sym_for] = ACTIONS(1998),
    [anon_sym_if] = ACTIONS(1998),
    [anon_sym_impl] = ACTIONS(1998),
    [anon_sym_let] = ACTIONS(1998),
    [anon_sym_loop] = ACTIONS(1998),
    [anon_sym_match] = ACTIONS(1998),
    [anon_sym_mod] = ACTIONS(1998),
    [anon_sym_pub] = ACTIONS(1998),
    [anon_sym_return] = ACTIONS(1998),
    [anon_sym_static] = ACTIONS(1998),
    [anon_sym_struct] = ACTIONS(1998),
    [anon_sym_trait] = ACTIONS(1998),
    [anon_sym_type] = ACTIONS(1998),
    [anon_sym_union] = ACTIONS(1998),
    [anon_sym_unsafe] = ACTIONS(1998),
    [anon_sym_use] = ACTIONS(1998),
    [anon_sym_while] = ACTIONS(1998),
    [anon_sym_extern] = ACTIONS(1998),
    [anon_sym_yield] = ACTIONS(1998),
    [anon_sym_move] = ACTIONS(1998),
    [anon_sym_try] = ACTIONS(1998),
    [sym_integer_literal] = ACTIONS(1996),
    [aux_sym_string_literal_token1] = ACTIONS(1996),
    [sym_char_literal] = ACTIONS(1996),
    [anon_sym_true] = ACTIONS(1998),
    [anon_sym_false] = ACTIONS(1998),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1998),
    [sym_super] = ACTIONS(1998),
    [sym_crate] = ACTIONS(1998),
    [sym_metavariable] = ACTIONS(1996),
    [sym__raw_string_literal_start] = ACTIONS(1996),
    [sym_float_literal] = ACTIONS(1996),
  },
  [552] = {
    [sym_line_comment] = STATE(552),
    [sym_block_comment] = STATE(552),
    [ts_builtin_sym_end] = ACTIONS(2000),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_macro_rules_BANG] = ACTIONS(2000),
    [anon_sym_LPAREN] = ACTIONS(2000),
    [anon_sym_LBRACK] = ACTIONS(2000),
    [anon_sym_LBRACE] = ACTIONS(2000),
    [anon_sym_RBRACE] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(2000),
    [anon_sym_u8] = ACTIONS(2002),
    [anon_sym_i8] = ACTIONS(2002),
    [anon_sym_u16] = ACTIONS(2002),
    [anon_sym_i16] = ACTIONS(2002),
    [anon_sym_u32] = ACTIONS(2002),
    [anon_sym_i32] = ACTIONS(2002),
    [anon_sym_u64] = ACTIONS(2002),
    [anon_sym_i64] = ACTIONS(2002),
    [anon_sym_u128] = ACTIONS(2002),
    [anon_sym_i128] = ACTIONS(2002),
    [anon_sym_isize] = ACTIONS(2002),
    [anon_sym_usize] = ACTIONS(2002),
    [anon_sym_f32] = ACTIONS(2002),
    [anon_sym_f64] = ACTIONS(2002),
    [anon_sym_bool] = ACTIONS(2002),
    [anon_sym_str] = ACTIONS(2002),
    [anon_sym_char] = ACTIONS(2002),
    [anon_sym_DASH] = ACTIONS(2000),
    [anon_sym_BANG] = ACTIONS(2000),
    [anon_sym_AMP] = ACTIONS(2000),
    [anon_sym_PIPE] = ACTIONS(2000),
    [anon_sym_LT] = ACTIONS(2000),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_COLON_COLON] = ACTIONS(2000),
    [anon_sym_POUND] = ACTIONS(2000),
    [anon_sym_SQUOTE] = ACTIONS(2002),
    [anon_sym_async] = ACTIONS(2002),
    [anon_sym_break] = ACTIONS(2002),
    [anon_sym_const] = ACTIONS(2002),
    [anon_sym_continue] = ACTIONS(2002),
    [anon_sym_default] = ACTIONS(2002),
    [anon_sym_enum] = ACTIONS(2002),
    [anon_sym_fn] = ACTIONS(2002),
    [anon_sym_for] = ACTIONS(2002),
    [anon_sym_if] = ACTIONS(2002),
    [anon_sym_impl] = ACTIONS(2002),
    [anon_sym_let] = ACTIONS(2002),
    [anon_sym_loop] = ACTIONS(2002),
    [anon_sym_match] = ACTIONS(2002),
    [anon_sym_mod] = ACTIONS(2002),
    [anon_sym_pub] = ACTIONS(2002),
    [anon_sym_return] = ACTIONS(2002),
    [anon_sym_static] = ACTIONS(2002),
    [anon_sym_struct] = ACTIONS(2002),
    [anon_sym_trait] = ACTIONS(2002),
    [anon_sym_type] = ACTIONS(2002),
    [anon_sym_union] = ACTIONS(2002),
    [anon_sym_unsafe] = ACTIONS(2002),
    [anon_sym_use] = ACTIONS(2002),
    [anon_sym_while] = ACTIONS(2002),
    [anon_sym_extern] = ACTIONS(2002),
    [anon_sym_yield] = ACTIONS(2002),
    [anon_sym_move] = ACTIONS(2002),
    [anon_sym_try] = ACTIONS(2002),
    [sym_integer_literal] = ACTIONS(2000),
    [aux_sym_string_literal_token1] = ACTIONS(2000),
    [sym_char_literal] = ACTIONS(2000),
    [anon_sym_true] = ACTIONS(2002),
    [anon_sym_false] = ACTIONS(2002),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2002),
    [sym_super] = ACTIONS(2002),
    [sym_crate] = ACTIONS(2002),
    [sym_metavariable] = ACTIONS(2000),
    [sym__raw_string_literal_start] = ACTIONS(2000),
    [sym_float_literal] = ACTIONS(2000),
  },
  [553] = {
    [sym_line_comment] = STATE(553),
    [sym_block_comment] = STATE(553),
    [ts_builtin_sym_end] = ACTIONS(2004),
    [sym_identifier] = ACTIONS(2006),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_macro_rules_BANG] = ACTIONS(2004),
    [anon_sym_LPAREN] = ACTIONS(2004),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_LBRACE] = ACTIONS(2004),
    [anon_sym_RBRACE] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(2006),
    [anon_sym_i8] = ACTIONS(2006),
    [anon_sym_u16] = ACTIONS(2006),
    [anon_sym_i16] = ACTIONS(2006),
    [anon_sym_u32] = ACTIONS(2006),
    [anon_sym_i32] = ACTIONS(2006),
    [anon_sym_u64] = ACTIONS(2006),
    [anon_sym_i64] = ACTIONS(2006),
    [anon_sym_u128] = ACTIONS(2006),
    [anon_sym_i128] = ACTIONS(2006),
    [anon_sym_isize] = ACTIONS(2006),
    [anon_sym_usize] = ACTIONS(2006),
    [anon_sym_f32] = ACTIONS(2006),
    [anon_sym_f64] = ACTIONS(2006),
    [anon_sym_bool] = ACTIONS(2006),
    [anon_sym_str] = ACTIONS(2006),
    [anon_sym_char] = ACTIONS(2006),
    [anon_sym_DASH] = ACTIONS(2004),
    [anon_sym_BANG] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_DOT_DOT] = ACTIONS(2004),
    [anon_sym_COLON_COLON] = ACTIONS(2004),
    [anon_sym_POUND] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2006),
    [anon_sym_async] = ACTIONS(2006),
    [anon_sym_break] = ACTIONS(2006),
    [anon_sym_const] = ACTIONS(2006),
    [anon_sym_continue] = ACTIONS(2006),
    [anon_sym_default] = ACTIONS(2006),
    [anon_sym_enum] = ACTIONS(2006),
    [anon_sym_fn] = ACTIONS(2006),
    [anon_sym_for] = ACTIONS(2006),
    [anon_sym_if] = ACTIONS(2006),
    [anon_sym_impl] = ACTIONS(2006),
    [anon_sym_let] = ACTIONS(2006),
    [anon_sym_loop] = ACTIONS(2006),
    [anon_sym_match] = ACTIONS(2006),
    [anon_sym_mod] = ACTIONS(2006),
    [anon_sym_pub] = ACTIONS(2006),
    [anon_sym_return] = ACTIONS(2006),
    [anon_sym_static] = ACTIONS(2006),
    [anon_sym_struct] = ACTIONS(2006),
    [anon_sym_trait] = ACTIONS(2006),
    [anon_sym_type] = ACTIONS(2006),
    [anon_sym_union] = ACTIONS(2006),
    [anon_sym_unsafe] = ACTIONS(2006),
    [anon_sym_use] = ACTIONS(2006),
    [anon_sym_while] = ACTIONS(2006),
    [anon_sym_extern] = ACTIONS(2006),
    [anon_sym_yield] = ACTIONS(2006),
    [anon_sym_move] = ACTIONS(2006),
    [anon_sym_try] = ACTIONS(2006),
    [sym_integer_literal] = ACTIONS(2004),
    [aux_sym_string_literal_token1] = ACTIONS(2004),
    [sym_char_literal] = ACTIONS(2004),
    [anon_sym_true] = ACTIONS(2006),
    [anon_sym_false] = ACTIONS(2006),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2006),
    [sym_super] = ACTIONS(2006),
    [sym_crate] = ACTIONS(2006),
    [sym_metavariable] = ACTIONS(2004),
    [sym__raw_string_literal_start] = ACTIONS(2004),
    [sym_float_literal] = ACTIONS(2004),
  },
  [554] = {
    [sym_attribute_item] = STATE(1478),
    [sym_inner_attribute_item] = STATE(1478),
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_match_arm] = STATE(1476),
    [sym_match_pattern] = STATE(3342),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2974),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(554),
    [sym_block_comment] = STATE(554),
    [aux_sym_match_block_repeat1] = STATE(554),
    [aux_sym_match_arm_repeat1] = STATE(759),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2014),
    [anon_sym_u8] = ACTIONS(2017),
    [anon_sym_i8] = ACTIONS(2017),
    [anon_sym_u16] = ACTIONS(2017),
    [anon_sym_i16] = ACTIONS(2017),
    [anon_sym_u32] = ACTIONS(2017),
    [anon_sym_i32] = ACTIONS(2017),
    [anon_sym_u64] = ACTIONS(2017),
    [anon_sym_i64] = ACTIONS(2017),
    [anon_sym_u128] = ACTIONS(2017),
    [anon_sym_i128] = ACTIONS(2017),
    [anon_sym_isize] = ACTIONS(2017),
    [anon_sym_usize] = ACTIONS(2017),
    [anon_sym_f32] = ACTIONS(2017),
    [anon_sym_f64] = ACTIONS(2017),
    [anon_sym_bool] = ACTIONS(2017),
    [anon_sym_str] = ACTIONS(2017),
    [anon_sym_char] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2020),
    [anon_sym_AMP] = ACTIONS(2023),
    [anon_sym_PIPE] = ACTIONS(2026),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym__] = ACTIONS(2032),
    [anon_sym_DOT_DOT] = ACTIONS(2035),
    [anon_sym_COLON_COLON] = ACTIONS(2038),
    [anon_sym_POUND] = ACTIONS(2041),
    [anon_sym_const] = ACTIONS(2044),
    [anon_sym_default] = ACTIONS(2047),
    [anon_sym_union] = ACTIONS(2047),
    [anon_sym_ref] = ACTIONS(2050),
    [sym_mutable_specifier] = ACTIONS(2053),
    [sym_integer_literal] = ACTIONS(2056),
    [aux_sym_string_literal_token1] = ACTIONS(2059),
    [sym_char_literal] = ACTIONS(2056),
    [anon_sym_true] = ACTIONS(2062),
    [anon_sym_false] = ACTIONS(2062),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2065),
    [sym_super] = ACTIONS(2065),
    [sym_crate] = ACTIONS(2065),
    [sym_metavariable] = ACTIONS(2068),
    [sym__raw_string_literal_start] = ACTIONS(2071),
    [sym_float_literal] = ACTIONS(2056),
  },
  [555] = {
    [sym_line_comment] = STATE(555),
    [sym_block_comment] = STATE(555),
    [ts_builtin_sym_end] = ACTIONS(2074),
    [sym_identifier] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_macro_rules_BANG] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(2074),
    [anon_sym_LBRACK] = ACTIONS(2074),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_RBRACE] = ACTIONS(2074),
    [anon_sym_STAR] = ACTIONS(2074),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym_DASH] = ACTIONS(2074),
    [anon_sym_BANG] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2074),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_COLON_COLON] = ACTIONS(2074),
    [anon_sym_POUND] = ACTIONS(2074),
    [anon_sym_SQUOTE] = ACTIONS(2076),
    [anon_sym_async] = ACTIONS(2076),
    [anon_sym_break] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_continue] = ACTIONS(2076),
    [anon_sym_default] = ACTIONS(2076),
    [anon_sym_enum] = ACTIONS(2076),
    [anon_sym_fn] = ACTIONS(2076),
    [anon_sym_for] = ACTIONS(2076),
    [anon_sym_if] = ACTIONS(2076),
    [anon_sym_impl] = ACTIONS(2076),
    [anon_sym_let] = ACTIONS(2076),
    [anon_sym_loop] = ACTIONS(2076),
    [anon_sym_match] = ACTIONS(2076),
    [anon_sym_mod] = ACTIONS(2076),
    [anon_sym_pub] = ACTIONS(2076),
    [anon_sym_return] = ACTIONS(2076),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_struct] = ACTIONS(2076),
    [anon_sym_trait] = ACTIONS(2076),
    [anon_sym_type] = ACTIONS(2076),
    [anon_sym_union] = ACTIONS(2076),
    [anon_sym_unsafe] = ACTIONS(2076),
    [anon_sym_use] = ACTIONS(2076),
    [anon_sym_while] = ACTIONS(2076),
    [anon_sym_extern] = ACTIONS(2076),
    [anon_sym_yield] = ACTIONS(2076),
    [anon_sym_move] = ACTIONS(2076),
    [anon_sym_try] = ACTIONS(2076),
    [sym_integer_literal] = ACTIONS(2074),
    [aux_sym_string_literal_token1] = ACTIONS(2074),
    [sym_char_literal] = ACTIONS(2074),
    [anon_sym_true] = ACTIONS(2076),
    [anon_sym_false] = ACTIONS(2076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2076),
    [sym_super] = ACTIONS(2076),
    [sym_crate] = ACTIONS(2076),
    [sym_metavariable] = ACTIONS(2074),
    [sym__raw_string_literal_start] = ACTIONS(2074),
    [sym_float_literal] = ACTIONS(2074),
  },
  [556] = {
    [sym_line_comment] = STATE(556),
    [sym_block_comment] = STATE(556),
    [ts_builtin_sym_end] = ACTIONS(2078),
    [sym_identifier] = ACTIONS(2080),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_macro_rules_BANG] = ACTIONS(2078),
    [anon_sym_LPAREN] = ACTIONS(2078),
    [anon_sym_LBRACK] = ACTIONS(2078),
    [anon_sym_LBRACE] = ACTIONS(2078),
    [anon_sym_RBRACE] = ACTIONS(2078),
    [anon_sym_STAR] = ACTIONS(2078),
    [anon_sym_u8] = ACTIONS(2080),
    [anon_sym_i8] = ACTIONS(2080),
    [anon_sym_u16] = ACTIONS(2080),
    [anon_sym_i16] = ACTIONS(2080),
    [anon_sym_u32] = ACTIONS(2080),
    [anon_sym_i32] = ACTIONS(2080),
    [anon_sym_u64] = ACTIONS(2080),
    [anon_sym_i64] = ACTIONS(2080),
    [anon_sym_u128] = ACTIONS(2080),
    [anon_sym_i128] = ACTIONS(2080),
    [anon_sym_isize] = ACTIONS(2080),
    [anon_sym_usize] = ACTIONS(2080),
    [anon_sym_f32] = ACTIONS(2080),
    [anon_sym_f64] = ACTIONS(2080),
    [anon_sym_bool] = ACTIONS(2080),
    [anon_sym_str] = ACTIONS(2080),
    [anon_sym_char] = ACTIONS(2080),
    [anon_sym_DASH] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_COLON_COLON] = ACTIONS(2078),
    [anon_sym_POUND] = ACTIONS(2078),
    [anon_sym_SQUOTE] = ACTIONS(2080),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_break] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_continue] = ACTIONS(2080),
    [anon_sym_default] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
    [anon_sym_fn] = ACTIONS(2080),
    [anon_sym_for] = ACTIONS(2080),
    [anon_sym_if] = ACTIONS(2080),
    [anon_sym_impl] = ACTIONS(2080),
    [anon_sym_let] = ACTIONS(2080),
    [anon_sym_loop] = ACTIONS(2080),
    [anon_sym_match] = ACTIONS(2080),
    [anon_sym_mod] = ACTIONS(2080),
    [anon_sym_pub] = ACTIONS(2080),
    [anon_sym_return] = ACTIONS(2080),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_struct] = ACTIONS(2080),
    [anon_sym_trait] = ACTIONS(2080),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_union] = ACTIONS(2080),
    [anon_sym_unsafe] = ACTIONS(2080),
    [anon_sym_use] = ACTIONS(2080),
    [anon_sym_while] = ACTIONS(2080),
    [anon_sym_extern] = ACTIONS(2080),
    [anon_sym_yield] = ACTIONS(2080),
    [anon_sym_move] = ACTIONS(2080),
    [anon_sym_try] = ACTIONS(2080),
    [sym_integer_literal] = ACTIONS(2078),
    [aux_sym_string_literal_token1] = ACTIONS(2078),
    [sym_char_literal] = ACTIONS(2078),
    [anon_sym_true] = ACTIONS(2080),
    [anon_sym_false] = ACTIONS(2080),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2080),
    [sym_super] = ACTIONS(2080),
    [sym_crate] = ACTIONS(2080),
    [sym_metavariable] = ACTIONS(2078),
    [sym__raw_string_literal_start] = ACTIONS(2078),
    [sym_float_literal] = ACTIONS(2078),
  },
  [557] = {
    [sym_line_comment] = STATE(557),
    [sym_block_comment] = STATE(557),
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_macro_rules_BANG] = ACTIONS(2082),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_STAR] = ACTIONS(2082),
    [anon_sym_u8] = ACTIONS(2084),
    [anon_sym_i8] = ACTIONS(2084),
    [anon_sym_u16] = ACTIONS(2084),
    [anon_sym_i16] = ACTIONS(2084),
    [anon_sym_u32] = ACTIONS(2084),
    [anon_sym_i32] = ACTIONS(2084),
    [anon_sym_u64] = ACTIONS(2084),
    [anon_sym_i64] = ACTIONS(2084),
    [anon_sym_u128] = ACTIONS(2084),
    [anon_sym_i128] = ACTIONS(2084),
    [anon_sym_isize] = ACTIONS(2084),
    [anon_sym_usize] = ACTIONS(2084),
    [anon_sym_f32] = ACTIONS(2084),
    [anon_sym_f64] = ACTIONS(2084),
    [anon_sym_bool] = ACTIONS(2084),
    [anon_sym_str] = ACTIONS(2084),
    [anon_sym_char] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2082),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2082),
    [anon_sym_PIPE] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_DOT_DOT] = ACTIONS(2082),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
    [anon_sym_fn] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_impl] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_loop] = ACTIONS(2084),
    [anon_sym_match] = ACTIONS(2084),
    [anon_sym_mod] = ACTIONS(2084),
    [anon_sym_pub] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_struct] = ACTIONS(2084),
    [anon_sym_trait] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_union] = ACTIONS(2084),
    [anon_sym_unsafe] = ACTIONS(2084),
    [anon_sym_use] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_extern] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_move] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [sym_integer_literal] = ACTIONS(2082),
    [aux_sym_string_literal_token1] = ACTIONS(2082),
    [sym_char_literal] = ACTIONS(2082),
    [anon_sym_true] = ACTIONS(2084),
    [anon_sym_false] = ACTIONS(2084),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_crate] = ACTIONS(2084),
    [sym_metavariable] = ACTIONS(2082),
    [sym__raw_string_literal_start] = ACTIONS(2082),
    [sym_float_literal] = ACTIONS(2082),
  },
  [558] = {
    [sym_line_comment] = STATE(558),
    [sym_block_comment] = STATE(558),
    [ts_builtin_sym_end] = ACTIONS(2086),
    [sym_identifier] = ACTIONS(2088),
    [anon_sym_SEMI] = ACTIONS(2086),
    [anon_sym_macro_rules_BANG] = ACTIONS(2086),
    [anon_sym_LPAREN] = ACTIONS(2086),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [anon_sym_LBRACE] = ACTIONS(2086),
    [anon_sym_RBRACE] = ACTIONS(2086),
    [anon_sym_STAR] = ACTIONS(2086),
    [anon_sym_u8] = ACTIONS(2088),
    [anon_sym_i8] = ACTIONS(2088),
    [anon_sym_u16] = ACTIONS(2088),
    [anon_sym_i16] = ACTIONS(2088),
    [anon_sym_u32] = ACTIONS(2088),
    [anon_sym_i32] = ACTIONS(2088),
    [anon_sym_u64] = ACTIONS(2088),
    [anon_sym_i64] = ACTIONS(2088),
    [anon_sym_u128] = ACTIONS(2088),
    [anon_sym_i128] = ACTIONS(2088),
    [anon_sym_isize] = ACTIONS(2088),
    [anon_sym_usize] = ACTIONS(2088),
    [anon_sym_f32] = ACTIONS(2088),
    [anon_sym_f64] = ACTIONS(2088),
    [anon_sym_bool] = ACTIONS(2088),
    [anon_sym_str] = ACTIONS(2088),
    [anon_sym_char] = ACTIONS(2088),
    [anon_sym_DASH] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(2086),
    [anon_sym_AMP] = ACTIONS(2086),
    [anon_sym_PIPE] = ACTIONS(2086),
    [anon_sym_LT] = ACTIONS(2086),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [anon_sym_COLON_COLON] = ACTIONS(2086),
    [anon_sym_POUND] = ACTIONS(2086),
    [anon_sym_SQUOTE] = ACTIONS(2088),
    [anon_sym_async] = ACTIONS(2088),
    [anon_sym_break] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(2088),
    [anon_sym_continue] = ACTIONS(2088),
    [anon_sym_default] = ACTIONS(2088),
    [anon_sym_enum] = ACTIONS(2088),
    [anon_sym_fn] = ACTIONS(2088),
    [anon_sym_for] = ACTIONS(2088),
    [anon_sym_if] = ACTIONS(2088),
    [anon_sym_impl] = ACTIONS(2088),
    [anon_sym_let] = ACTIONS(2088),
    [anon_sym_loop] = ACTIONS(2088),
    [anon_sym_match] = ACTIONS(2088),
    [anon_sym_mod] = ACTIONS(2088),
    [anon_sym_pub] = ACTIONS(2088),
    [anon_sym_return] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(2088),
    [anon_sym_struct] = ACTIONS(2088),
    [anon_sym_trait] = ACTIONS(2088),
    [anon_sym_type] = ACTIONS(2088),
    [anon_sym_union] = ACTIONS(2088),
    [anon_sym_unsafe] = ACTIONS(2088),
    [anon_sym_use] = ACTIONS(2088),
    [anon_sym_while] = ACTIONS(2088),
    [anon_sym_extern] = ACTIONS(2088),
    [anon_sym_yield] = ACTIONS(2088),
    [anon_sym_move] = ACTIONS(2088),
    [anon_sym_try] = ACTIONS(2088),
    [sym_integer_literal] = ACTIONS(2086),
    [aux_sym_string_literal_token1] = ACTIONS(2086),
    [sym_char_literal] = ACTIONS(2086),
    [anon_sym_true] = ACTIONS(2088),
    [anon_sym_false] = ACTIONS(2088),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2088),
    [sym_super] = ACTIONS(2088),
    [sym_crate] = ACTIONS(2088),
    [sym_metavariable] = ACTIONS(2086),
    [sym__raw_string_literal_start] = ACTIONS(2086),
    [sym_float_literal] = ACTIONS(2086),
  },
  [559] = {
    [sym_line_comment] = STATE(559),
    [sym_block_comment] = STATE(559),
    [ts_builtin_sym_end] = ACTIONS(2090),
    [sym_identifier] = ACTIONS(2092),
    [anon_sym_SEMI] = ACTIONS(2090),
    [anon_sym_macro_rules_BANG] = ACTIONS(2090),
    [anon_sym_LPAREN] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_LBRACE] = ACTIONS(2090),
    [anon_sym_RBRACE] = ACTIONS(2090),
    [anon_sym_STAR] = ACTIONS(2090),
    [anon_sym_u8] = ACTIONS(2092),
    [anon_sym_i8] = ACTIONS(2092),
    [anon_sym_u16] = ACTIONS(2092),
    [anon_sym_i16] = ACTIONS(2092),
    [anon_sym_u32] = ACTIONS(2092),
    [anon_sym_i32] = ACTIONS(2092),
    [anon_sym_u64] = ACTIONS(2092),
    [anon_sym_i64] = ACTIONS(2092),
    [anon_sym_u128] = ACTIONS(2092),
    [anon_sym_i128] = ACTIONS(2092),
    [anon_sym_isize] = ACTIONS(2092),
    [anon_sym_usize] = ACTIONS(2092),
    [anon_sym_f32] = ACTIONS(2092),
    [anon_sym_f64] = ACTIONS(2092),
    [anon_sym_bool] = ACTIONS(2092),
    [anon_sym_str] = ACTIONS(2092),
    [anon_sym_char] = ACTIONS(2092),
    [anon_sym_DASH] = ACTIONS(2090),
    [anon_sym_BANG] = ACTIONS(2090),
    [anon_sym_AMP] = ACTIONS(2090),
    [anon_sym_PIPE] = ACTIONS(2090),
    [anon_sym_LT] = ACTIONS(2090),
    [anon_sym_DOT_DOT] = ACTIONS(2090),
    [anon_sym_COLON_COLON] = ACTIONS(2090),
    [anon_sym_POUND] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2092),
    [anon_sym_async] = ACTIONS(2092),
    [anon_sym_break] = ACTIONS(2092),
    [anon_sym_const] = ACTIONS(2092),
    [anon_sym_continue] = ACTIONS(2092),
    [anon_sym_default] = ACTIONS(2092),
    [anon_sym_enum] = ACTIONS(2092),
    [anon_sym_fn] = ACTIONS(2092),
    [anon_sym_for] = ACTIONS(2092),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_impl] = ACTIONS(2092),
    [anon_sym_let] = ACTIONS(2092),
    [anon_sym_loop] = ACTIONS(2092),
    [anon_sym_match] = ACTIONS(2092),
    [anon_sym_mod] = ACTIONS(2092),
    [anon_sym_pub] = ACTIONS(2092),
    [anon_sym_return] = ACTIONS(2092),
    [anon_sym_static] = ACTIONS(2092),
    [anon_sym_struct] = ACTIONS(2092),
    [anon_sym_trait] = ACTIONS(2092),
    [anon_sym_type] = ACTIONS(2092),
    [anon_sym_union] = ACTIONS(2092),
    [anon_sym_unsafe] = ACTIONS(2092),
    [anon_sym_use] = ACTIONS(2092),
    [anon_sym_while] = ACTIONS(2092),
    [anon_sym_extern] = ACTIONS(2092),
    [anon_sym_yield] = ACTIONS(2092),
    [anon_sym_move] = ACTIONS(2092),
    [anon_sym_try] = ACTIONS(2092),
    [sym_integer_literal] = ACTIONS(2090),
    [aux_sym_string_literal_token1] = ACTIONS(2090),
    [sym_char_literal] = ACTIONS(2090),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2092),
    [sym_super] = ACTIONS(2092),
    [sym_crate] = ACTIONS(2092),
    [sym_metavariable] = ACTIONS(2090),
    [sym__raw_string_literal_start] = ACTIONS(2090),
    [sym_float_literal] = ACTIONS(2090),
  },
  [560] = {
    [sym_line_comment] = STATE(560),
    [sym_block_comment] = STATE(560),
    [ts_builtin_sym_end] = ACTIONS(2094),
    [sym_identifier] = ACTIONS(2096),
    [anon_sym_SEMI] = ACTIONS(2094),
    [anon_sym_macro_rules_BANG] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_LBRACE] = ACTIONS(2094),
    [anon_sym_RBRACE] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(2094),
    [anon_sym_u8] = ACTIONS(2096),
    [anon_sym_i8] = ACTIONS(2096),
    [anon_sym_u16] = ACTIONS(2096),
    [anon_sym_i16] = ACTIONS(2096),
    [anon_sym_u32] = ACTIONS(2096),
    [anon_sym_i32] = ACTIONS(2096),
    [anon_sym_u64] = ACTIONS(2096),
    [anon_sym_i64] = ACTIONS(2096),
    [anon_sym_u128] = ACTIONS(2096),
    [anon_sym_i128] = ACTIONS(2096),
    [anon_sym_isize] = ACTIONS(2096),
    [anon_sym_usize] = ACTIONS(2096),
    [anon_sym_f32] = ACTIONS(2096),
    [anon_sym_f64] = ACTIONS(2096),
    [anon_sym_bool] = ACTIONS(2096),
    [anon_sym_str] = ACTIONS(2096),
    [anon_sym_char] = ACTIONS(2096),
    [anon_sym_DASH] = ACTIONS(2094),
    [anon_sym_BANG] = ACTIONS(2094),
    [anon_sym_AMP] = ACTIONS(2094),
    [anon_sym_PIPE] = ACTIONS(2094),
    [anon_sym_LT] = ACTIONS(2094),
    [anon_sym_DOT_DOT] = ACTIONS(2094),
    [anon_sym_COLON_COLON] = ACTIONS(2094),
    [anon_sym_POUND] = ACTIONS(2094),
    [anon_sym_SQUOTE] = ACTIONS(2096),
    [anon_sym_async] = ACTIONS(2096),
    [anon_sym_break] = ACTIONS(2096),
    [anon_sym_const] = ACTIONS(2096),
    [anon_sym_continue] = ACTIONS(2096),
    [anon_sym_default] = ACTIONS(2096),
    [anon_sym_enum] = ACTIONS(2096),
    [anon_sym_fn] = ACTIONS(2096),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_if] = ACTIONS(2096),
    [anon_sym_impl] = ACTIONS(2096),
    [anon_sym_let] = ACTIONS(2096),
    [anon_sym_loop] = ACTIONS(2096),
    [anon_sym_match] = ACTIONS(2096),
    [anon_sym_mod] = ACTIONS(2096),
    [anon_sym_pub] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(2096),
    [anon_sym_static] = ACTIONS(2096),
    [anon_sym_struct] = ACTIONS(2096),
    [anon_sym_trait] = ACTIONS(2096),
    [anon_sym_type] = ACTIONS(2096),
    [anon_sym_union] = ACTIONS(2096),
    [anon_sym_unsafe] = ACTIONS(2096),
    [anon_sym_use] = ACTIONS(2096),
    [anon_sym_while] = ACTIONS(2096),
    [anon_sym_extern] = ACTIONS(2096),
    [anon_sym_yield] = ACTIONS(2096),
    [anon_sym_move] = ACTIONS(2096),
    [anon_sym_try] = ACTIONS(2096),
    [sym_integer_literal] = ACTIONS(2094),
    [aux_sym_string_literal_token1] = ACTIONS(2094),
    [sym_char_literal] = ACTIONS(2094),
    [anon_sym_true] = ACTIONS(2096),
    [anon_sym_false] = ACTIONS(2096),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2094),
    [sym__raw_string_literal_start] = ACTIONS(2094),
    [sym_float_literal] = ACTIONS(2094),
  },
  [561] = {
    [sym_line_comment] = STATE(561),
    [sym_block_comment] = STATE(561),
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_macro_rules_BANG] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(2098),
    [anon_sym_u8] = ACTIONS(2100),
    [anon_sym_i8] = ACTIONS(2100),
    [anon_sym_u16] = ACTIONS(2100),
    [anon_sym_i16] = ACTIONS(2100),
    [anon_sym_u32] = ACTIONS(2100),
    [anon_sym_i32] = ACTIONS(2100),
    [anon_sym_u64] = ACTIONS(2100),
    [anon_sym_i64] = ACTIONS(2100),
    [anon_sym_u128] = ACTIONS(2100),
    [anon_sym_i128] = ACTIONS(2100),
    [anon_sym_isize] = ACTIONS(2100),
    [anon_sym_usize] = ACTIONS(2100),
    [anon_sym_f32] = ACTIONS(2100),
    [anon_sym_f64] = ACTIONS(2100),
    [anon_sym_bool] = ACTIONS(2100),
    [anon_sym_str] = ACTIONS(2100),
    [anon_sym_char] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2098),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_AMP] = ACTIONS(2098),
    [anon_sym_PIPE] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_COLON_COLON] = ACTIONS(2098),
    [anon_sym_POUND] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
    [anon_sym_fn] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_impl] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_loop] = ACTIONS(2100),
    [anon_sym_match] = ACTIONS(2100),
    [anon_sym_mod] = ACTIONS(2100),
    [anon_sym_pub] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_struct] = ACTIONS(2100),
    [anon_sym_trait] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_union] = ACTIONS(2100),
    [anon_sym_unsafe] = ACTIONS(2100),
    [anon_sym_use] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_extern] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_move] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [sym_integer_literal] = ACTIONS(2098),
    [aux_sym_string_literal_token1] = ACTIONS(2098),
    [sym_char_literal] = ACTIONS(2098),
    [anon_sym_true] = ACTIONS(2100),
    [anon_sym_false] = ACTIONS(2100),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_crate] = ACTIONS(2100),
    [sym_metavariable] = ACTIONS(2098),
    [sym__raw_string_literal_start] = ACTIONS(2098),
    [sym_float_literal] = ACTIONS(2098),
  },
  [562] = {
    [sym_line_comment] = STATE(562),
    [sym_block_comment] = STATE(562),
    [ts_builtin_sym_end] = ACTIONS(2102),
    [sym_identifier] = ACTIONS(2104),
    [anon_sym_SEMI] = ACTIONS(2102),
    [anon_sym_macro_rules_BANG] = ACTIONS(2102),
    [anon_sym_LPAREN] = ACTIONS(2102),
    [anon_sym_LBRACK] = ACTIONS(2102),
    [anon_sym_LBRACE] = ACTIONS(2102),
    [anon_sym_RBRACE] = ACTIONS(2102),
    [anon_sym_STAR] = ACTIONS(2102),
    [anon_sym_u8] = ACTIONS(2104),
    [anon_sym_i8] = ACTIONS(2104),
    [anon_sym_u16] = ACTIONS(2104),
    [anon_sym_i16] = ACTIONS(2104),
    [anon_sym_u32] = ACTIONS(2104),
    [anon_sym_i32] = ACTIONS(2104),
    [anon_sym_u64] = ACTIONS(2104),
    [anon_sym_i64] = ACTIONS(2104),
    [anon_sym_u128] = ACTIONS(2104),
    [anon_sym_i128] = ACTIONS(2104),
    [anon_sym_isize] = ACTIONS(2104),
    [anon_sym_usize] = ACTIONS(2104),
    [anon_sym_f32] = ACTIONS(2104),
    [anon_sym_f64] = ACTIONS(2104),
    [anon_sym_bool] = ACTIONS(2104),
    [anon_sym_str] = ACTIONS(2104),
    [anon_sym_char] = ACTIONS(2104),
    [anon_sym_DASH] = ACTIONS(2102),
    [anon_sym_BANG] = ACTIONS(2102),
    [anon_sym_AMP] = ACTIONS(2102),
    [anon_sym_PIPE] = ACTIONS(2102),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_COLON_COLON] = ACTIONS(2102),
    [anon_sym_POUND] = ACTIONS(2102),
    [anon_sym_SQUOTE] = ACTIONS(2104),
    [anon_sym_async] = ACTIONS(2104),
    [anon_sym_break] = ACTIONS(2104),
    [anon_sym_const] = ACTIONS(2104),
    [anon_sym_continue] = ACTIONS(2104),
    [anon_sym_default] = ACTIONS(2104),
    [anon_sym_enum] = ACTIONS(2104),
    [anon_sym_fn] = ACTIONS(2104),
    [anon_sym_for] = ACTIONS(2104),
    [anon_sym_if] = ACTIONS(2104),
    [anon_sym_impl] = ACTIONS(2104),
    [anon_sym_let] = ACTIONS(2104),
    [anon_sym_loop] = ACTIONS(2104),
    [anon_sym_match] = ACTIONS(2104),
    [anon_sym_mod] = ACTIONS(2104),
    [anon_sym_pub] = ACTIONS(2104),
    [anon_sym_return] = ACTIONS(2104),
    [anon_sym_static] = ACTIONS(2104),
    [anon_sym_struct] = ACTIONS(2104),
    [anon_sym_trait] = ACTIONS(2104),
    [anon_sym_type] = ACTIONS(2104),
    [anon_sym_union] = ACTIONS(2104),
    [anon_sym_unsafe] = ACTIONS(2104),
    [anon_sym_use] = ACTIONS(2104),
    [anon_sym_while] = ACTIONS(2104),
    [anon_sym_extern] = ACTIONS(2104),
    [anon_sym_yield] = ACTIONS(2104),
    [anon_sym_move] = ACTIONS(2104),
    [anon_sym_try] = ACTIONS(2104),
    [sym_integer_literal] = ACTIONS(2102),
    [aux_sym_string_literal_token1] = ACTIONS(2102),
    [sym_char_literal] = ACTIONS(2102),
    [anon_sym_true] = ACTIONS(2104),
    [anon_sym_false] = ACTIONS(2104),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2104),
    [sym_super] = ACTIONS(2104),
    [sym_crate] = ACTIONS(2104),
    [sym_metavariable] = ACTIONS(2102),
    [sym__raw_string_literal_start] = ACTIONS(2102),
    [sym_float_literal] = ACTIONS(2102),
  },
  [563] = {
    [sym_line_comment] = STATE(563),
    [sym_block_comment] = STATE(563),
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_macro_rules_BANG] = ACTIONS(2106),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_STAR] = ACTIONS(2106),
    [anon_sym_u8] = ACTIONS(2108),
    [anon_sym_i8] = ACTIONS(2108),
    [anon_sym_u16] = ACTIONS(2108),
    [anon_sym_i16] = ACTIONS(2108),
    [anon_sym_u32] = ACTIONS(2108),
    [anon_sym_i32] = ACTIONS(2108),
    [anon_sym_u64] = ACTIONS(2108),
    [anon_sym_i64] = ACTIONS(2108),
    [anon_sym_u128] = ACTIONS(2108),
    [anon_sym_i128] = ACTIONS(2108),
    [anon_sym_isize] = ACTIONS(2108),
    [anon_sym_usize] = ACTIONS(2108),
    [anon_sym_f32] = ACTIONS(2108),
    [anon_sym_f64] = ACTIONS(2108),
    [anon_sym_bool] = ACTIONS(2108),
    [anon_sym_str] = ACTIONS(2108),
    [anon_sym_char] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2106),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_AMP] = ACTIONS(2106),
    [anon_sym_PIPE] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_DOT_DOT] = ACTIONS(2106),
    [anon_sym_COLON_COLON] = ACTIONS(2106),
    [anon_sym_POUND] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
    [anon_sym_fn] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_impl] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_loop] = ACTIONS(2108),
    [anon_sym_match] = ACTIONS(2108),
    [anon_sym_mod] = ACTIONS(2108),
    [anon_sym_pub] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_struct] = ACTIONS(2108),
    [anon_sym_trait] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_union] = ACTIONS(2108),
    [anon_sym_unsafe] = ACTIONS(2108),
    [anon_sym_use] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_extern] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_move] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [sym_integer_literal] = ACTIONS(2106),
    [aux_sym_string_literal_token1] = ACTIONS(2106),
    [sym_char_literal] = ACTIONS(2106),
    [anon_sym_true] = ACTIONS(2108),
    [anon_sym_false] = ACTIONS(2108),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_crate] = ACTIONS(2108),
    [sym_metavariable] = ACTIONS(2106),
    [sym__raw_string_literal_start] = ACTIONS(2106),
    [sym_float_literal] = ACTIONS(2106),
  },
  [564] = {
    [sym_line_comment] = STATE(564),
    [sym_block_comment] = STATE(564),
    [ts_builtin_sym_end] = ACTIONS(2110),
    [sym_identifier] = ACTIONS(2112),
    [anon_sym_SEMI] = ACTIONS(2110),
    [anon_sym_macro_rules_BANG] = ACTIONS(2110),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_LBRACK] = ACTIONS(2110),
    [anon_sym_LBRACE] = ACTIONS(2110),
    [anon_sym_RBRACE] = ACTIONS(2110),
    [anon_sym_STAR] = ACTIONS(2110),
    [anon_sym_u8] = ACTIONS(2112),
    [anon_sym_i8] = ACTIONS(2112),
    [anon_sym_u16] = ACTIONS(2112),
    [anon_sym_i16] = ACTIONS(2112),
    [anon_sym_u32] = ACTIONS(2112),
    [anon_sym_i32] = ACTIONS(2112),
    [anon_sym_u64] = ACTIONS(2112),
    [anon_sym_i64] = ACTIONS(2112),
    [anon_sym_u128] = ACTIONS(2112),
    [anon_sym_i128] = ACTIONS(2112),
    [anon_sym_isize] = ACTIONS(2112),
    [anon_sym_usize] = ACTIONS(2112),
    [anon_sym_f32] = ACTIONS(2112),
    [anon_sym_f64] = ACTIONS(2112),
    [anon_sym_bool] = ACTIONS(2112),
    [anon_sym_str] = ACTIONS(2112),
    [anon_sym_char] = ACTIONS(2112),
    [anon_sym_DASH] = ACTIONS(2110),
    [anon_sym_BANG] = ACTIONS(2110),
    [anon_sym_AMP] = ACTIONS(2110),
    [anon_sym_PIPE] = ACTIONS(2110),
    [anon_sym_LT] = ACTIONS(2110),
    [anon_sym_DOT_DOT] = ACTIONS(2110),
    [anon_sym_COLON_COLON] = ACTIONS(2110),
    [anon_sym_POUND] = ACTIONS(2110),
    [anon_sym_SQUOTE] = ACTIONS(2112),
    [anon_sym_async] = ACTIONS(2112),
    [anon_sym_break] = ACTIONS(2112),
    [anon_sym_const] = ACTIONS(2112),
    [anon_sym_continue] = ACTIONS(2112),
    [anon_sym_default] = ACTIONS(2112),
    [anon_sym_enum] = ACTIONS(2112),
    [anon_sym_fn] = ACTIONS(2112),
    [anon_sym_for] = ACTIONS(2112),
    [anon_sym_if] = ACTIONS(2112),
    [anon_sym_impl] = ACTIONS(2112),
    [anon_sym_let] = ACTIONS(2112),
    [anon_sym_loop] = ACTIONS(2112),
    [anon_sym_match] = ACTIONS(2112),
    [anon_sym_mod] = ACTIONS(2112),
    [anon_sym_pub] = ACTIONS(2112),
    [anon_sym_return] = ACTIONS(2112),
    [anon_sym_static] = ACTIONS(2112),
    [anon_sym_struct] = ACTIONS(2112),
    [anon_sym_trait] = ACTIONS(2112),
    [anon_sym_type] = ACTIONS(2112),
    [anon_sym_union] = ACTIONS(2112),
    [anon_sym_unsafe] = ACTIONS(2112),
    [anon_sym_use] = ACTIONS(2112),
    [anon_sym_while] = ACTIONS(2112),
    [anon_sym_extern] = ACTIONS(2112),
    [anon_sym_yield] = ACTIONS(2112),
    [anon_sym_move] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2112),
    [sym_integer_literal] = ACTIONS(2110),
    [aux_sym_string_literal_token1] = ACTIONS(2110),
    [sym_char_literal] = ACTIONS(2110),
    [anon_sym_true] = ACTIONS(2112),
    [anon_sym_false] = ACTIONS(2112),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2112),
    [sym_super] = ACTIONS(2112),
    [sym_crate] = ACTIONS(2112),
    [sym_metavariable] = ACTIONS(2110),
    [sym__raw_string_literal_start] = ACTIONS(2110),
    [sym_float_literal] = ACTIONS(2110),
  },
  [565] = {
    [sym_line_comment] = STATE(565),
    [sym_block_comment] = STATE(565),
    [ts_builtin_sym_end] = ACTIONS(2114),
    [sym_identifier] = ACTIONS(2116),
    [anon_sym_SEMI] = ACTIONS(2114),
    [anon_sym_macro_rules_BANG] = ACTIONS(2114),
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_LBRACK] = ACTIONS(2114),
    [anon_sym_LBRACE] = ACTIONS(2114),
    [anon_sym_RBRACE] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(2114),
    [anon_sym_u8] = ACTIONS(2116),
    [anon_sym_i8] = ACTIONS(2116),
    [anon_sym_u16] = ACTIONS(2116),
    [anon_sym_i16] = ACTIONS(2116),
    [anon_sym_u32] = ACTIONS(2116),
    [anon_sym_i32] = ACTIONS(2116),
    [anon_sym_u64] = ACTIONS(2116),
    [anon_sym_i64] = ACTIONS(2116),
    [anon_sym_u128] = ACTIONS(2116),
    [anon_sym_i128] = ACTIONS(2116),
    [anon_sym_isize] = ACTIONS(2116),
    [anon_sym_usize] = ACTIONS(2116),
    [anon_sym_f32] = ACTIONS(2116),
    [anon_sym_f64] = ACTIONS(2116),
    [anon_sym_bool] = ACTIONS(2116),
    [anon_sym_str] = ACTIONS(2116),
    [anon_sym_char] = ACTIONS(2116),
    [anon_sym_DASH] = ACTIONS(2114),
    [anon_sym_BANG] = ACTIONS(2114),
    [anon_sym_AMP] = ACTIONS(2114),
    [anon_sym_PIPE] = ACTIONS(2114),
    [anon_sym_LT] = ACTIONS(2114),
    [anon_sym_DOT_DOT] = ACTIONS(2114),
    [anon_sym_COLON_COLON] = ACTIONS(2114),
    [anon_sym_POUND] = ACTIONS(2114),
    [anon_sym_SQUOTE] = ACTIONS(2116),
    [anon_sym_async] = ACTIONS(2116),
    [anon_sym_break] = ACTIONS(2116),
    [anon_sym_const] = ACTIONS(2116),
    [anon_sym_continue] = ACTIONS(2116),
    [anon_sym_default] = ACTIONS(2116),
    [anon_sym_enum] = ACTIONS(2116),
    [anon_sym_fn] = ACTIONS(2116),
    [anon_sym_for] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(2116),
    [anon_sym_impl] = ACTIONS(2116),
    [anon_sym_let] = ACTIONS(2116),
    [anon_sym_loop] = ACTIONS(2116),
    [anon_sym_match] = ACTIONS(2116),
    [anon_sym_mod] = ACTIONS(2116),
    [anon_sym_pub] = ACTIONS(2116),
    [anon_sym_return] = ACTIONS(2116),
    [anon_sym_static] = ACTIONS(2116),
    [anon_sym_struct] = ACTIONS(2116),
    [anon_sym_trait] = ACTIONS(2116),
    [anon_sym_type] = ACTIONS(2116),
    [anon_sym_union] = ACTIONS(2116),
    [anon_sym_unsafe] = ACTIONS(2116),
    [anon_sym_use] = ACTIONS(2116),
    [anon_sym_while] = ACTIONS(2116),
    [anon_sym_extern] = ACTIONS(2116),
    [anon_sym_yield] = ACTIONS(2116),
    [anon_sym_move] = ACTIONS(2116),
    [anon_sym_try] = ACTIONS(2116),
    [sym_integer_literal] = ACTIONS(2114),
    [aux_sym_string_literal_token1] = ACTIONS(2114),
    [sym_char_literal] = ACTIONS(2114),
    [anon_sym_true] = ACTIONS(2116),
    [anon_sym_false] = ACTIONS(2116),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2116),
    [sym_super] = ACTIONS(2116),
    [sym_crate] = ACTIONS(2116),
    [sym_metavariable] = ACTIONS(2114),
    [sym__raw_string_literal_start] = ACTIONS(2114),
    [sym_float_literal] = ACTIONS(2114),
  },
  [566] = {
    [sym_line_comment] = STATE(566),
    [sym_block_comment] = STATE(566),
    [ts_builtin_sym_end] = ACTIONS(2118),
    [sym_identifier] = ACTIONS(2120),
    [anon_sym_SEMI] = ACTIONS(2118),
    [anon_sym_macro_rules_BANG] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(2118),
    [anon_sym_LBRACK] = ACTIONS(2118),
    [anon_sym_LBRACE] = ACTIONS(2118),
    [anon_sym_RBRACE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2118),
    [anon_sym_u8] = ACTIONS(2120),
    [anon_sym_i8] = ACTIONS(2120),
    [anon_sym_u16] = ACTIONS(2120),
    [anon_sym_i16] = ACTIONS(2120),
    [anon_sym_u32] = ACTIONS(2120),
    [anon_sym_i32] = ACTIONS(2120),
    [anon_sym_u64] = ACTIONS(2120),
    [anon_sym_i64] = ACTIONS(2120),
    [anon_sym_u128] = ACTIONS(2120),
    [anon_sym_i128] = ACTIONS(2120),
    [anon_sym_isize] = ACTIONS(2120),
    [anon_sym_usize] = ACTIONS(2120),
    [anon_sym_f32] = ACTIONS(2120),
    [anon_sym_f64] = ACTIONS(2120),
    [anon_sym_bool] = ACTIONS(2120),
    [anon_sym_str] = ACTIONS(2120),
    [anon_sym_char] = ACTIONS(2120),
    [anon_sym_DASH] = ACTIONS(2118),
    [anon_sym_BANG] = ACTIONS(2118),
    [anon_sym_AMP] = ACTIONS(2118),
    [anon_sym_PIPE] = ACTIONS(2118),
    [anon_sym_LT] = ACTIONS(2118),
    [anon_sym_DOT_DOT] = ACTIONS(2118),
    [anon_sym_COLON_COLON] = ACTIONS(2118),
    [anon_sym_POUND] = ACTIONS(2118),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_async] = ACTIONS(2120),
    [anon_sym_break] = ACTIONS(2120),
    [anon_sym_const] = ACTIONS(2120),
    [anon_sym_continue] = ACTIONS(2120),
    [anon_sym_default] = ACTIONS(2120),
    [anon_sym_enum] = ACTIONS(2120),
    [anon_sym_fn] = ACTIONS(2120),
    [anon_sym_for] = ACTIONS(2120),
    [anon_sym_if] = ACTIONS(2120),
    [anon_sym_impl] = ACTIONS(2120),
    [anon_sym_let] = ACTIONS(2120),
    [anon_sym_loop] = ACTIONS(2120),
    [anon_sym_match] = ACTIONS(2120),
    [anon_sym_mod] = ACTIONS(2120),
    [anon_sym_pub] = ACTIONS(2120),
    [anon_sym_return] = ACTIONS(2120),
    [anon_sym_static] = ACTIONS(2120),
    [anon_sym_struct] = ACTIONS(2120),
    [anon_sym_trait] = ACTIONS(2120),
    [anon_sym_type] = ACTIONS(2120),
    [anon_sym_union] = ACTIONS(2120),
    [anon_sym_unsafe] = ACTIONS(2120),
    [anon_sym_use] = ACTIONS(2120),
    [anon_sym_while] = ACTIONS(2120),
    [anon_sym_extern] = ACTIONS(2120),
    [anon_sym_yield] = ACTIONS(2120),
    [anon_sym_move] = ACTIONS(2120),
    [anon_sym_try] = ACTIONS(2120),
    [sym_integer_literal] = ACTIONS(2118),
    [aux_sym_string_literal_token1] = ACTIONS(2118),
    [sym_char_literal] = ACTIONS(2118),
    [anon_sym_true] = ACTIONS(2120),
    [anon_sym_false] = ACTIONS(2120),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2120),
    [sym_super] = ACTIONS(2120),
    [sym_crate] = ACTIONS(2120),
    [sym_metavariable] = ACTIONS(2118),
    [sym__raw_string_literal_start] = ACTIONS(2118),
    [sym_float_literal] = ACTIONS(2118),
  },
  [567] = {
    [sym_line_comment] = STATE(567),
    [sym_block_comment] = STATE(567),
    [ts_builtin_sym_end] = ACTIONS(2122),
    [sym_identifier] = ACTIONS(2124),
    [anon_sym_SEMI] = ACTIONS(2122),
    [anon_sym_macro_rules_BANG] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(2122),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_LBRACE] = ACTIONS(2122),
    [anon_sym_RBRACE] = ACTIONS(2122),
    [anon_sym_STAR] = ACTIONS(2122),
    [anon_sym_u8] = ACTIONS(2124),
    [anon_sym_i8] = ACTIONS(2124),
    [anon_sym_u16] = ACTIONS(2124),
    [anon_sym_i16] = ACTIONS(2124),
    [anon_sym_u32] = ACTIONS(2124),
    [anon_sym_i32] = ACTIONS(2124),
    [anon_sym_u64] = ACTIONS(2124),
    [anon_sym_i64] = ACTIONS(2124),
    [anon_sym_u128] = ACTIONS(2124),
    [anon_sym_i128] = ACTIONS(2124),
    [anon_sym_isize] = ACTIONS(2124),
    [anon_sym_usize] = ACTIONS(2124),
    [anon_sym_f32] = ACTIONS(2124),
    [anon_sym_f64] = ACTIONS(2124),
    [anon_sym_bool] = ACTIONS(2124),
    [anon_sym_str] = ACTIONS(2124),
    [anon_sym_char] = ACTIONS(2124),
    [anon_sym_DASH] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2122),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_PIPE] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(2122),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_COLON_COLON] = ACTIONS(2122),
    [anon_sym_POUND] = ACTIONS(2122),
    [anon_sym_SQUOTE] = ACTIONS(2124),
    [anon_sym_async] = ACTIONS(2124),
    [anon_sym_break] = ACTIONS(2124),
    [anon_sym_const] = ACTIONS(2124),
    [anon_sym_continue] = ACTIONS(2124),
    [anon_sym_default] = ACTIONS(2124),
    [anon_sym_enum] = ACTIONS(2124),
    [anon_sym_fn] = ACTIONS(2124),
    [anon_sym_for] = ACTIONS(2124),
    [anon_sym_if] = ACTIONS(2124),
    [anon_sym_impl] = ACTIONS(2124),
    [anon_sym_let] = ACTIONS(2124),
    [anon_sym_loop] = ACTIONS(2124),
    [anon_sym_match] = ACTIONS(2124),
    [anon_sym_mod] = ACTIONS(2124),
    [anon_sym_pub] = ACTIONS(2124),
    [anon_sym_return] = ACTIONS(2124),
    [anon_sym_static] = ACTIONS(2124),
    [anon_sym_struct] = ACTIONS(2124),
    [anon_sym_trait] = ACTIONS(2124),
    [anon_sym_type] = ACTIONS(2124),
    [anon_sym_union] = ACTIONS(2124),
    [anon_sym_unsafe] = ACTIONS(2124),
    [anon_sym_use] = ACTIONS(2124),
    [anon_sym_while] = ACTIONS(2124),
    [anon_sym_extern] = ACTIONS(2124),
    [anon_sym_yield] = ACTIONS(2124),
    [anon_sym_move] = ACTIONS(2124),
    [anon_sym_try] = ACTIONS(2124),
    [sym_integer_literal] = ACTIONS(2122),
    [aux_sym_string_literal_token1] = ACTIONS(2122),
    [sym_char_literal] = ACTIONS(2122),
    [anon_sym_true] = ACTIONS(2124),
    [anon_sym_false] = ACTIONS(2124),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2124),
    [sym_super] = ACTIONS(2124),
    [sym_crate] = ACTIONS(2124),
    [sym_metavariable] = ACTIONS(2122),
    [sym__raw_string_literal_start] = ACTIONS(2122),
    [sym_float_literal] = ACTIONS(2122),
  },
  [568] = {
    [sym_line_comment] = STATE(568),
    [sym_block_comment] = STATE(568),
    [ts_builtin_sym_end] = ACTIONS(2126),
    [sym_identifier] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_macro_rules_BANG] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_u8] = ACTIONS(2128),
    [anon_sym_i8] = ACTIONS(2128),
    [anon_sym_u16] = ACTIONS(2128),
    [anon_sym_i16] = ACTIONS(2128),
    [anon_sym_u32] = ACTIONS(2128),
    [anon_sym_i32] = ACTIONS(2128),
    [anon_sym_u64] = ACTIONS(2128),
    [anon_sym_i64] = ACTIONS(2128),
    [anon_sym_u128] = ACTIONS(2128),
    [anon_sym_i128] = ACTIONS(2128),
    [anon_sym_isize] = ACTIONS(2128),
    [anon_sym_usize] = ACTIONS(2128),
    [anon_sym_f32] = ACTIONS(2128),
    [anon_sym_f64] = ACTIONS(2128),
    [anon_sym_bool] = ACTIONS(2128),
    [anon_sym_str] = ACTIONS(2128),
    [anon_sym_char] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_COLON_COLON] = ACTIONS(2126),
    [anon_sym_POUND] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_async] = ACTIONS(2128),
    [anon_sym_break] = ACTIONS(2128),
    [anon_sym_const] = ACTIONS(2128),
    [anon_sym_continue] = ACTIONS(2128),
    [anon_sym_default] = ACTIONS(2128),
    [anon_sym_enum] = ACTIONS(2128),
    [anon_sym_fn] = ACTIONS(2128),
    [anon_sym_for] = ACTIONS(2128),
    [anon_sym_if] = ACTIONS(2128),
    [anon_sym_impl] = ACTIONS(2128),
    [anon_sym_let] = ACTIONS(2128),
    [anon_sym_loop] = ACTIONS(2128),
    [anon_sym_match] = ACTIONS(2128),
    [anon_sym_mod] = ACTIONS(2128),
    [anon_sym_pub] = ACTIONS(2128),
    [anon_sym_return] = ACTIONS(2128),
    [anon_sym_static] = ACTIONS(2128),
    [anon_sym_struct] = ACTIONS(2128),
    [anon_sym_trait] = ACTIONS(2128),
    [anon_sym_type] = ACTIONS(2128),
    [anon_sym_union] = ACTIONS(2128),
    [anon_sym_unsafe] = ACTIONS(2128),
    [anon_sym_use] = ACTIONS(2128),
    [anon_sym_while] = ACTIONS(2128),
    [anon_sym_extern] = ACTIONS(2128),
    [anon_sym_yield] = ACTIONS(2128),
    [anon_sym_move] = ACTIONS(2128),
    [anon_sym_try] = ACTIONS(2128),
    [sym_integer_literal] = ACTIONS(2126),
    [aux_sym_string_literal_token1] = ACTIONS(2126),
    [sym_char_literal] = ACTIONS(2126),
    [anon_sym_true] = ACTIONS(2128),
    [anon_sym_false] = ACTIONS(2128),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2128),
    [sym_super] = ACTIONS(2128),
    [sym_crate] = ACTIONS(2128),
    [sym_metavariable] = ACTIONS(2126),
    [sym__raw_string_literal_start] = ACTIONS(2126),
    [sym_float_literal] = ACTIONS(2126),
  },
  [569] = {
    [sym_line_comment] = STATE(569),
    [sym_block_comment] = STATE(569),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2132),
    [anon_sym_SEMI] = ACTIONS(2130),
    [anon_sym_macro_rules_BANG] = ACTIONS(2130),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_LBRACE] = ACTIONS(2130),
    [anon_sym_RBRACE] = ACTIONS(2130),
    [anon_sym_STAR] = ACTIONS(2130),
    [anon_sym_u8] = ACTIONS(2132),
    [anon_sym_i8] = ACTIONS(2132),
    [anon_sym_u16] = ACTIONS(2132),
    [anon_sym_i16] = ACTIONS(2132),
    [anon_sym_u32] = ACTIONS(2132),
    [anon_sym_i32] = ACTIONS(2132),
    [anon_sym_u64] = ACTIONS(2132),
    [anon_sym_i64] = ACTIONS(2132),
    [anon_sym_u128] = ACTIONS(2132),
    [anon_sym_i128] = ACTIONS(2132),
    [anon_sym_isize] = ACTIONS(2132),
    [anon_sym_usize] = ACTIONS(2132),
    [anon_sym_f32] = ACTIONS(2132),
    [anon_sym_f64] = ACTIONS(2132),
    [anon_sym_bool] = ACTIONS(2132),
    [anon_sym_str] = ACTIONS(2132),
    [anon_sym_char] = ACTIONS(2132),
    [anon_sym_DASH] = ACTIONS(2130),
    [anon_sym_BANG] = ACTIONS(2130),
    [anon_sym_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2130),
    [anon_sym_LT] = ACTIONS(2130),
    [anon_sym_DOT_DOT] = ACTIONS(2130),
    [anon_sym_COLON_COLON] = ACTIONS(2130),
    [anon_sym_POUND] = ACTIONS(2130),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym_async] = ACTIONS(2132),
    [anon_sym_break] = ACTIONS(2132),
    [anon_sym_const] = ACTIONS(2132),
    [anon_sym_continue] = ACTIONS(2132),
    [anon_sym_default] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2132),
    [anon_sym_fn] = ACTIONS(2132),
    [anon_sym_for] = ACTIONS(2132),
    [anon_sym_if] = ACTIONS(2132),
    [anon_sym_impl] = ACTIONS(2132),
    [anon_sym_let] = ACTIONS(2132),
    [anon_sym_loop] = ACTIONS(2132),
    [anon_sym_match] = ACTIONS(2132),
    [anon_sym_mod] = ACTIONS(2132),
    [anon_sym_pub] = ACTIONS(2132),
    [anon_sym_return] = ACTIONS(2132),
    [anon_sym_static] = ACTIONS(2132),
    [anon_sym_struct] = ACTIONS(2132),
    [anon_sym_trait] = ACTIONS(2132),
    [anon_sym_type] = ACTIONS(2132),
    [anon_sym_union] = ACTIONS(2132),
    [anon_sym_unsafe] = ACTIONS(2132),
    [anon_sym_use] = ACTIONS(2132),
    [anon_sym_while] = ACTIONS(2132),
    [anon_sym_extern] = ACTIONS(2132),
    [anon_sym_yield] = ACTIONS(2132),
    [anon_sym_move] = ACTIONS(2132),
    [anon_sym_try] = ACTIONS(2132),
    [sym_integer_literal] = ACTIONS(2130),
    [aux_sym_string_literal_token1] = ACTIONS(2130),
    [sym_char_literal] = ACTIONS(2130),
    [anon_sym_true] = ACTIONS(2132),
    [anon_sym_false] = ACTIONS(2132),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2132),
    [sym_super] = ACTIONS(2132),
    [sym_crate] = ACTIONS(2132),
    [sym_metavariable] = ACTIONS(2130),
    [sym__raw_string_literal_start] = ACTIONS(2130),
    [sym_float_literal] = ACTIONS(2130),
  },
  [570] = {
    [sym_line_comment] = STATE(570),
    [sym_block_comment] = STATE(570),
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_identifier] = ACTIONS(2136),
    [anon_sym_SEMI] = ACTIONS(2134),
    [anon_sym_macro_rules_BANG] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_u8] = ACTIONS(2136),
    [anon_sym_i8] = ACTIONS(2136),
    [anon_sym_u16] = ACTIONS(2136),
    [anon_sym_i16] = ACTIONS(2136),
    [anon_sym_u32] = ACTIONS(2136),
    [anon_sym_i32] = ACTIONS(2136),
    [anon_sym_u64] = ACTIONS(2136),
    [anon_sym_i64] = ACTIONS(2136),
    [anon_sym_u128] = ACTIONS(2136),
    [anon_sym_i128] = ACTIONS(2136),
    [anon_sym_isize] = ACTIONS(2136),
    [anon_sym_usize] = ACTIONS(2136),
    [anon_sym_f32] = ACTIONS(2136),
    [anon_sym_f64] = ACTIONS(2136),
    [anon_sym_bool] = ACTIONS(2136),
    [anon_sym_str] = ACTIONS(2136),
    [anon_sym_char] = ACTIONS(2136),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_BANG] = ACTIONS(2134),
    [anon_sym_AMP] = ACTIONS(2134),
    [anon_sym_PIPE] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2134),
    [anon_sym_DOT_DOT] = ACTIONS(2134),
    [anon_sym_COLON_COLON] = ACTIONS(2134),
    [anon_sym_POUND] = ACTIONS(2134),
    [anon_sym_SQUOTE] = ACTIONS(2136),
    [anon_sym_async] = ACTIONS(2136),
    [anon_sym_break] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(2136),
    [anon_sym_continue] = ACTIONS(2136),
    [anon_sym_default] = ACTIONS(2136),
    [anon_sym_enum] = ACTIONS(2136),
    [anon_sym_fn] = ACTIONS(2136),
    [anon_sym_for] = ACTIONS(2136),
    [anon_sym_if] = ACTIONS(2136),
    [anon_sym_impl] = ACTIONS(2136),
    [anon_sym_let] = ACTIONS(2136),
    [anon_sym_loop] = ACTIONS(2136),
    [anon_sym_match] = ACTIONS(2136),
    [anon_sym_mod] = ACTIONS(2136),
    [anon_sym_pub] = ACTIONS(2136),
    [anon_sym_return] = ACTIONS(2136),
    [anon_sym_static] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2136),
    [anon_sym_trait] = ACTIONS(2136),
    [anon_sym_type] = ACTIONS(2136),
    [anon_sym_union] = ACTIONS(2136),
    [anon_sym_unsafe] = ACTIONS(2136),
    [anon_sym_use] = ACTIONS(2136),
    [anon_sym_while] = ACTIONS(2136),
    [anon_sym_extern] = ACTIONS(2136),
    [anon_sym_yield] = ACTIONS(2136),
    [anon_sym_move] = ACTIONS(2136),
    [anon_sym_try] = ACTIONS(2136),
    [sym_integer_literal] = ACTIONS(2134),
    [aux_sym_string_literal_token1] = ACTIONS(2134),
    [sym_char_literal] = ACTIONS(2134),
    [anon_sym_true] = ACTIONS(2136),
    [anon_sym_false] = ACTIONS(2136),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2136),
    [sym_super] = ACTIONS(2136),
    [sym_crate] = ACTIONS(2136),
    [sym_metavariable] = ACTIONS(2134),
    [sym__raw_string_literal_start] = ACTIONS(2134),
    [sym_float_literal] = ACTIONS(2134),
  },
  [571] = {
    [sym_line_comment] = STATE(571),
    [sym_block_comment] = STATE(571),
    [ts_builtin_sym_end] = ACTIONS(2138),
    [sym_identifier] = ACTIONS(2140),
    [anon_sym_SEMI] = ACTIONS(2138),
    [anon_sym_macro_rules_BANG] = ACTIONS(2138),
    [anon_sym_LPAREN] = ACTIONS(2138),
    [anon_sym_LBRACK] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2138),
    [anon_sym_RBRACE] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(2138),
    [anon_sym_u8] = ACTIONS(2140),
    [anon_sym_i8] = ACTIONS(2140),
    [anon_sym_u16] = ACTIONS(2140),
    [anon_sym_i16] = ACTIONS(2140),
    [anon_sym_u32] = ACTIONS(2140),
    [anon_sym_i32] = ACTIONS(2140),
    [anon_sym_u64] = ACTIONS(2140),
    [anon_sym_i64] = ACTIONS(2140),
    [anon_sym_u128] = ACTIONS(2140),
    [anon_sym_i128] = ACTIONS(2140),
    [anon_sym_isize] = ACTIONS(2140),
    [anon_sym_usize] = ACTIONS(2140),
    [anon_sym_f32] = ACTIONS(2140),
    [anon_sym_f64] = ACTIONS(2140),
    [anon_sym_bool] = ACTIONS(2140),
    [anon_sym_str] = ACTIONS(2140),
    [anon_sym_char] = ACTIONS(2140),
    [anon_sym_DASH] = ACTIONS(2138),
    [anon_sym_BANG] = ACTIONS(2138),
    [anon_sym_AMP] = ACTIONS(2138),
    [anon_sym_PIPE] = ACTIONS(2138),
    [anon_sym_LT] = ACTIONS(2138),
    [anon_sym_DOT_DOT] = ACTIONS(2138),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_POUND] = ACTIONS(2138),
    [anon_sym_SQUOTE] = ACTIONS(2140),
    [anon_sym_async] = ACTIONS(2140),
    [anon_sym_break] = ACTIONS(2140),
    [anon_sym_const] = ACTIONS(2140),
    [anon_sym_continue] = ACTIONS(2140),
    [anon_sym_default] = ACTIONS(2140),
    [anon_sym_enum] = ACTIONS(2140),
    [anon_sym_fn] = ACTIONS(2140),
    [anon_sym_for] = ACTIONS(2140),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_impl] = ACTIONS(2140),
    [anon_sym_let] = ACTIONS(2140),
    [anon_sym_loop] = ACTIONS(2140),
    [anon_sym_match] = ACTIONS(2140),
    [anon_sym_mod] = ACTIONS(2140),
    [anon_sym_pub] = ACTIONS(2140),
    [anon_sym_return] = ACTIONS(2140),
    [anon_sym_static] = ACTIONS(2140),
    [anon_sym_struct] = ACTIONS(2140),
    [anon_sym_trait] = ACTIONS(2140),
    [anon_sym_type] = ACTIONS(2140),
    [anon_sym_union] = ACTIONS(2140),
    [anon_sym_unsafe] = ACTIONS(2140),
    [anon_sym_use] = ACTIONS(2140),
    [anon_sym_while] = ACTIONS(2140),
    [anon_sym_extern] = ACTIONS(2140),
    [anon_sym_yield] = ACTIONS(2140),
    [anon_sym_move] = ACTIONS(2140),
    [anon_sym_try] = ACTIONS(2140),
    [sym_integer_literal] = ACTIONS(2138),
    [aux_sym_string_literal_token1] = ACTIONS(2138),
    [sym_char_literal] = ACTIONS(2138),
    [anon_sym_true] = ACTIONS(2140),
    [anon_sym_false] = ACTIONS(2140),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2140),
    [sym_super] = ACTIONS(2140),
    [sym_crate] = ACTIONS(2140),
    [sym_metavariable] = ACTIONS(2138),
    [sym__raw_string_literal_start] = ACTIONS(2138),
    [sym_float_literal] = ACTIONS(2138),
  },
  [572] = {
    [sym_line_comment] = STATE(572),
    [sym_block_comment] = STATE(572),
    [ts_builtin_sym_end] = ACTIONS(2142),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_macro_rules_BANG] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_STAR] = ACTIONS(2142),
    [anon_sym_u8] = ACTIONS(2144),
    [anon_sym_i8] = ACTIONS(2144),
    [anon_sym_u16] = ACTIONS(2144),
    [anon_sym_i16] = ACTIONS(2144),
    [anon_sym_u32] = ACTIONS(2144),
    [anon_sym_i32] = ACTIONS(2144),
    [anon_sym_u64] = ACTIONS(2144),
    [anon_sym_i64] = ACTIONS(2144),
    [anon_sym_u128] = ACTIONS(2144),
    [anon_sym_i128] = ACTIONS(2144),
    [anon_sym_isize] = ACTIONS(2144),
    [anon_sym_usize] = ACTIONS(2144),
    [anon_sym_f32] = ACTIONS(2144),
    [anon_sym_f64] = ACTIONS(2144),
    [anon_sym_bool] = ACTIONS(2144),
    [anon_sym_str] = ACTIONS(2144),
    [anon_sym_char] = ACTIONS(2144),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_AMP] = ACTIONS(2142),
    [anon_sym_PIPE] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_DOT_DOT] = ACTIONS(2142),
    [anon_sym_COLON_COLON] = ACTIONS(2142),
    [anon_sym_POUND] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym_async] = ACTIONS(2144),
    [anon_sym_break] = ACTIONS(2144),
    [anon_sym_const] = ACTIONS(2144),
    [anon_sym_continue] = ACTIONS(2144),
    [anon_sym_default] = ACTIONS(2144),
    [anon_sym_enum] = ACTIONS(2144),
    [anon_sym_fn] = ACTIONS(2144),
    [anon_sym_for] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(2144),
    [anon_sym_impl] = ACTIONS(2144),
    [anon_sym_let] = ACTIONS(2144),
    [anon_sym_loop] = ACTIONS(2144),
    [anon_sym_match] = ACTIONS(2144),
    [anon_sym_mod] = ACTIONS(2144),
    [anon_sym_pub] = ACTIONS(2144),
    [anon_sym_return] = ACTIONS(2144),
    [anon_sym_static] = ACTIONS(2144),
    [anon_sym_struct] = ACTIONS(2144),
    [anon_sym_trait] = ACTIONS(2144),
    [anon_sym_type] = ACTIONS(2144),
    [anon_sym_union] = ACTIONS(2144),
    [anon_sym_unsafe] = ACTIONS(2144),
    [anon_sym_use] = ACTIONS(2144),
    [anon_sym_while] = ACTIONS(2144),
    [anon_sym_extern] = ACTIONS(2144),
    [anon_sym_yield] = ACTIONS(2144),
    [anon_sym_move] = ACTIONS(2144),
    [anon_sym_try] = ACTIONS(2144),
    [sym_integer_literal] = ACTIONS(2142),
    [aux_sym_string_literal_token1] = ACTIONS(2142),
    [sym_char_literal] = ACTIONS(2142),
    [anon_sym_true] = ACTIONS(2144),
    [anon_sym_false] = ACTIONS(2144),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2144),
    [sym_super] = ACTIONS(2144),
    [sym_crate] = ACTIONS(2144),
    [sym_metavariable] = ACTIONS(2142),
    [sym__raw_string_literal_start] = ACTIONS(2142),
    [sym_float_literal] = ACTIONS(2142),
  },
  [573] = {
    [sym_line_comment] = STATE(573),
    [sym_block_comment] = STATE(573),
    [ts_builtin_sym_end] = ACTIONS(2146),
    [sym_identifier] = ACTIONS(2148),
    [anon_sym_SEMI] = ACTIONS(2146),
    [anon_sym_macro_rules_BANG] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_RBRACE] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_u8] = ACTIONS(2148),
    [anon_sym_i8] = ACTIONS(2148),
    [anon_sym_u16] = ACTIONS(2148),
    [anon_sym_i16] = ACTIONS(2148),
    [anon_sym_u32] = ACTIONS(2148),
    [anon_sym_i32] = ACTIONS(2148),
    [anon_sym_u64] = ACTIONS(2148),
    [anon_sym_i64] = ACTIONS(2148),
    [anon_sym_u128] = ACTIONS(2148),
    [anon_sym_i128] = ACTIONS(2148),
    [anon_sym_isize] = ACTIONS(2148),
    [anon_sym_usize] = ACTIONS(2148),
    [anon_sym_f32] = ACTIONS(2148),
    [anon_sym_f64] = ACTIONS(2148),
    [anon_sym_bool] = ACTIONS(2148),
    [anon_sym_str] = ACTIONS(2148),
    [anon_sym_char] = ACTIONS(2148),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_AMP] = ACTIONS(2146),
    [anon_sym_PIPE] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2146),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_COLON_COLON] = ACTIONS(2146),
    [anon_sym_POUND] = ACTIONS(2146),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_async] = ACTIONS(2148),
    [anon_sym_break] = ACTIONS(2148),
    [anon_sym_const] = ACTIONS(2148),
    [anon_sym_continue] = ACTIONS(2148),
    [anon_sym_default] = ACTIONS(2148),
    [anon_sym_enum] = ACTIONS(2148),
    [anon_sym_fn] = ACTIONS(2148),
    [anon_sym_for] = ACTIONS(2148),
    [anon_sym_if] = ACTIONS(2148),
    [anon_sym_impl] = ACTIONS(2148),
    [anon_sym_let] = ACTIONS(2148),
    [anon_sym_loop] = ACTIONS(2148),
    [anon_sym_match] = ACTIONS(2148),
    [anon_sym_mod] = ACTIONS(2148),
    [anon_sym_pub] = ACTIONS(2148),
    [anon_sym_return] = ACTIONS(2148),
    [anon_sym_static] = ACTIONS(2148),
    [anon_sym_struct] = ACTIONS(2148),
    [anon_sym_trait] = ACTIONS(2148),
    [anon_sym_type] = ACTIONS(2148),
    [anon_sym_union] = ACTIONS(2148),
    [anon_sym_unsafe] = ACTIONS(2148),
    [anon_sym_use] = ACTIONS(2148),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_extern] = ACTIONS(2148),
    [anon_sym_yield] = ACTIONS(2148),
    [anon_sym_move] = ACTIONS(2148),
    [anon_sym_try] = ACTIONS(2148),
    [sym_integer_literal] = ACTIONS(2146),
    [aux_sym_string_literal_token1] = ACTIONS(2146),
    [sym_char_literal] = ACTIONS(2146),
    [anon_sym_true] = ACTIONS(2148),
    [anon_sym_false] = ACTIONS(2148),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2148),
    [sym_super] = ACTIONS(2148),
    [sym_crate] = ACTIONS(2148),
    [sym_metavariable] = ACTIONS(2146),
    [sym__raw_string_literal_start] = ACTIONS(2146),
    [sym_float_literal] = ACTIONS(2146),
  },
  [574] = {
    [sym_line_comment] = STATE(574),
    [sym_block_comment] = STATE(574),
    [ts_builtin_sym_end] = ACTIONS(2150),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2150),
    [anon_sym_macro_rules_BANG] = ACTIONS(2150),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2150),
    [anon_sym_RBRACE] = ACTIONS(2150),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_u8] = ACTIONS(2152),
    [anon_sym_i8] = ACTIONS(2152),
    [anon_sym_u16] = ACTIONS(2152),
    [anon_sym_i16] = ACTIONS(2152),
    [anon_sym_u32] = ACTIONS(2152),
    [anon_sym_i32] = ACTIONS(2152),
    [anon_sym_u64] = ACTIONS(2152),
    [anon_sym_i64] = ACTIONS(2152),
    [anon_sym_u128] = ACTIONS(2152),
    [anon_sym_i128] = ACTIONS(2152),
    [anon_sym_isize] = ACTIONS(2152),
    [anon_sym_usize] = ACTIONS(2152),
    [anon_sym_f32] = ACTIONS(2152),
    [anon_sym_f64] = ACTIONS(2152),
    [anon_sym_bool] = ACTIONS(2152),
    [anon_sym_str] = ACTIONS(2152),
    [anon_sym_char] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_BANG] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2150),
    [anon_sym_PIPE] = ACTIONS(2150),
    [anon_sym_LT] = ACTIONS(2150),
    [anon_sym_DOT_DOT] = ACTIONS(2150),
    [anon_sym_COLON_COLON] = ACTIONS(2150),
    [anon_sym_POUND] = ACTIONS(2150),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_default] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
    [anon_sym_fn] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_impl] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_loop] = ACTIONS(2152),
    [anon_sym_match] = ACTIONS(2152),
    [anon_sym_mod] = ACTIONS(2152),
    [anon_sym_pub] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_struct] = ACTIONS(2152),
    [anon_sym_trait] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_union] = ACTIONS(2152),
    [anon_sym_unsafe] = ACTIONS(2152),
    [anon_sym_use] = ACTIONS(2152),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_extern] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_move] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [sym_integer_literal] = ACTIONS(2150),
    [aux_sym_string_literal_token1] = ACTIONS(2150),
    [sym_char_literal] = ACTIONS(2150),
    [anon_sym_true] = ACTIONS(2152),
    [anon_sym_false] = ACTIONS(2152),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_crate] = ACTIONS(2152),
    [sym_metavariable] = ACTIONS(2150),
    [sym__raw_string_literal_start] = ACTIONS(2150),
    [sym_float_literal] = ACTIONS(2150),
  },
  [575] = {
    [sym_line_comment] = STATE(575),
    [sym_block_comment] = STATE(575),
    [ts_builtin_sym_end] = ACTIONS(2154),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_SEMI] = ACTIONS(2154),
    [anon_sym_macro_rules_BANG] = ACTIONS(2154),
    [anon_sym_LPAREN] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(2154),
    [anon_sym_STAR] = ACTIONS(2154),
    [anon_sym_u8] = ACTIONS(2156),
    [anon_sym_i8] = ACTIONS(2156),
    [anon_sym_u16] = ACTIONS(2156),
    [anon_sym_i16] = ACTIONS(2156),
    [anon_sym_u32] = ACTIONS(2156),
    [anon_sym_i32] = ACTIONS(2156),
    [anon_sym_u64] = ACTIONS(2156),
    [anon_sym_i64] = ACTIONS(2156),
    [anon_sym_u128] = ACTIONS(2156),
    [anon_sym_i128] = ACTIONS(2156),
    [anon_sym_isize] = ACTIONS(2156),
    [anon_sym_usize] = ACTIONS(2156),
    [anon_sym_f32] = ACTIONS(2156),
    [anon_sym_f64] = ACTIONS(2156),
    [anon_sym_bool] = ACTIONS(2156),
    [anon_sym_str] = ACTIONS(2156),
    [anon_sym_char] = ACTIONS(2156),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_BANG] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym_PIPE] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(2154),
    [anon_sym_DOT_DOT] = ACTIONS(2154),
    [anon_sym_COLON_COLON] = ACTIONS(2154),
    [anon_sym_POUND] = ACTIONS(2154),
    [anon_sym_SQUOTE] = ACTIONS(2156),
    [anon_sym_async] = ACTIONS(2156),
    [anon_sym_break] = ACTIONS(2156),
    [anon_sym_const] = ACTIONS(2156),
    [anon_sym_continue] = ACTIONS(2156),
    [anon_sym_default] = ACTIONS(2156),
    [anon_sym_enum] = ACTIONS(2156),
    [anon_sym_fn] = ACTIONS(2156),
    [anon_sym_for] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(2156),
    [anon_sym_impl] = ACTIONS(2156),
    [anon_sym_let] = ACTIONS(2156),
    [anon_sym_loop] = ACTIONS(2156),
    [anon_sym_match] = ACTIONS(2156),
    [anon_sym_mod] = ACTIONS(2156),
    [anon_sym_pub] = ACTIONS(2156),
    [anon_sym_return] = ACTIONS(2156),
    [anon_sym_static] = ACTIONS(2156),
    [anon_sym_struct] = ACTIONS(2156),
    [anon_sym_trait] = ACTIONS(2156),
    [anon_sym_type] = ACTIONS(2156),
    [anon_sym_union] = ACTIONS(2156),
    [anon_sym_unsafe] = ACTIONS(2156),
    [anon_sym_use] = ACTIONS(2156),
    [anon_sym_while] = ACTIONS(2156),
    [anon_sym_extern] = ACTIONS(2156),
    [anon_sym_yield] = ACTIONS(2156),
    [anon_sym_move] = ACTIONS(2156),
    [anon_sym_try] = ACTIONS(2156),
    [sym_integer_literal] = ACTIONS(2154),
    [aux_sym_string_literal_token1] = ACTIONS(2154),
    [sym_char_literal] = ACTIONS(2154),
    [anon_sym_true] = ACTIONS(2156),
    [anon_sym_false] = ACTIONS(2156),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2156),
    [sym_super] = ACTIONS(2156),
    [sym_crate] = ACTIONS(2156),
    [sym_metavariable] = ACTIONS(2154),
    [sym__raw_string_literal_start] = ACTIONS(2154),
    [sym_float_literal] = ACTIONS(2154),
  },
  [576] = {
    [sym_line_comment] = STATE(576),
    [sym_block_comment] = STATE(576),
    [ts_builtin_sym_end] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_SEMI] = ACTIONS(1240),
    [anon_sym_macro_rules_BANG] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_STAR] = ACTIONS(1240),
    [anon_sym_u8] = ACTIONS(1242),
    [anon_sym_i8] = ACTIONS(1242),
    [anon_sym_u16] = ACTIONS(1242),
    [anon_sym_i16] = ACTIONS(1242),
    [anon_sym_u32] = ACTIONS(1242),
    [anon_sym_i32] = ACTIONS(1242),
    [anon_sym_u64] = ACTIONS(1242),
    [anon_sym_i64] = ACTIONS(1242),
    [anon_sym_u128] = ACTIONS(1242),
    [anon_sym_i128] = ACTIONS(1242),
    [anon_sym_isize] = ACTIONS(1242),
    [anon_sym_usize] = ACTIONS(1242),
    [anon_sym_f32] = ACTIONS(1242),
    [anon_sym_f64] = ACTIONS(1242),
    [anon_sym_bool] = ACTIONS(1242),
    [anon_sym_str] = ACTIONS(1242),
    [anon_sym_char] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1240),
    [anon_sym_BANG] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(1240),
    [anon_sym_PIPE] = ACTIONS(1240),
    [anon_sym_LT] = ACTIONS(1240),
    [anon_sym_DOT_DOT] = ACTIONS(1240),
    [anon_sym_COLON_COLON] = ACTIONS(1240),
    [anon_sym_POUND] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [anon_sym_async] = ACTIONS(1242),
    [anon_sym_break] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_continue] = ACTIONS(1242),
    [anon_sym_default] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1242),
    [anon_sym_fn] = ACTIONS(1242),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_impl] = ACTIONS(1242),
    [anon_sym_let] = ACTIONS(1242),
    [anon_sym_loop] = ACTIONS(1242),
    [anon_sym_match] = ACTIONS(1242),
    [anon_sym_mod] = ACTIONS(1242),
    [anon_sym_pub] = ACTIONS(1242),
    [anon_sym_return] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(1242),
    [anon_sym_struct] = ACTIONS(1242),
    [anon_sym_trait] = ACTIONS(1242),
    [anon_sym_type] = ACTIONS(1242),
    [anon_sym_union] = ACTIONS(1242),
    [anon_sym_unsafe] = ACTIONS(1242),
    [anon_sym_use] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(1242),
    [anon_sym_extern] = ACTIONS(1242),
    [anon_sym_yield] = ACTIONS(1242),
    [anon_sym_move] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1242),
    [sym_integer_literal] = ACTIONS(1240),
    [aux_sym_string_literal_token1] = ACTIONS(1240),
    [sym_char_literal] = ACTIONS(1240),
    [anon_sym_true] = ACTIONS(1242),
    [anon_sym_false] = ACTIONS(1242),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1242),
    [sym_super] = ACTIONS(1242),
    [sym_crate] = ACTIONS(1242),
    [sym_metavariable] = ACTIONS(1240),
    [sym__raw_string_literal_start] = ACTIONS(1240),
    [sym_float_literal] = ACTIONS(1240),
  },
  [577] = {
    [sym_line_comment] = STATE(577),
    [sym_block_comment] = STATE(577),
    [ts_builtin_sym_end] = ACTIONS(2158),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2158),
    [anon_sym_macro_rules_BANG] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(2158),
    [anon_sym_STAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_PIPE] = ACTIONS(2158),
    [anon_sym_LT] = ACTIONS(2158),
    [anon_sym_DOT_DOT] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2158),
    [anon_sym_POUND] = ACTIONS(2158),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [anon_sym_fn] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_impl] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_loop] = ACTIONS(2160),
    [anon_sym_match] = ACTIONS(2160),
    [anon_sym_mod] = ACTIONS(2160),
    [anon_sym_pub] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_struct] = ACTIONS(2160),
    [anon_sym_trait] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_union] = ACTIONS(2160),
    [anon_sym_unsafe] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_extern] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_move] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [sym_integer_literal] = ACTIONS(2158),
    [aux_sym_string_literal_token1] = ACTIONS(2158),
    [sym_char_literal] = ACTIONS(2158),
    [anon_sym_true] = ACTIONS(2160),
    [anon_sym_false] = ACTIONS(2160),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_crate] = ACTIONS(2160),
    [sym_metavariable] = ACTIONS(2158),
    [sym__raw_string_literal_start] = ACTIONS(2158),
    [sym_float_literal] = ACTIONS(2158),
  },
  [578] = {
    [sym_line_comment] = STATE(578),
    [sym_block_comment] = STATE(578),
    [ts_builtin_sym_end] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_SEMI] = ACTIONS(2162),
    [anon_sym_macro_rules_BANG] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(2162),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_LBRACE] = ACTIONS(2162),
    [anon_sym_RBRACE] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(2162),
    [anon_sym_u8] = ACTIONS(2164),
    [anon_sym_i8] = ACTIONS(2164),
    [anon_sym_u16] = ACTIONS(2164),
    [anon_sym_i16] = ACTIONS(2164),
    [anon_sym_u32] = ACTIONS(2164),
    [anon_sym_i32] = ACTIONS(2164),
    [anon_sym_u64] = ACTIONS(2164),
    [anon_sym_i64] = ACTIONS(2164),
    [anon_sym_u128] = ACTIONS(2164),
    [anon_sym_i128] = ACTIONS(2164),
    [anon_sym_isize] = ACTIONS(2164),
    [anon_sym_usize] = ACTIONS(2164),
    [anon_sym_f32] = ACTIONS(2164),
    [anon_sym_f64] = ACTIONS(2164),
    [anon_sym_bool] = ACTIONS(2164),
    [anon_sym_str] = ACTIONS(2164),
    [anon_sym_char] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2162),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2162),
    [anon_sym_LT] = ACTIONS(2162),
    [anon_sym_DOT_DOT] = ACTIONS(2162),
    [anon_sym_COLON_COLON] = ACTIONS(2162),
    [anon_sym_POUND] = ACTIONS(2162),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [anon_sym_extern] = ACTIONS(2164),
    [anon_sym_yield] = ACTIONS(2164),
    [anon_sym_move] = ACTIONS(2164),
    [anon_sym_try] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2162),
    [aux_sym_string_literal_token1] = ACTIONS(2162),
    [sym_char_literal] = ACTIONS(2162),
    [anon_sym_true] = ACTIONS(2164),
    [anon_sym_false] = ACTIONS(2164),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2162),
    [sym__raw_string_literal_start] = ACTIONS(2162),
    [sym_float_literal] = ACTIONS(2162),
  },
  [579] = {
    [sym_line_comment] = STATE(579),
    [sym_block_comment] = STATE(579),
    [ts_builtin_sym_end] = ACTIONS(2166),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_macro_rules_BANG] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_STAR] = ACTIONS(2166),
    [anon_sym_u8] = ACTIONS(2168),
    [anon_sym_i8] = ACTIONS(2168),
    [anon_sym_u16] = ACTIONS(2168),
    [anon_sym_i16] = ACTIONS(2168),
    [anon_sym_u32] = ACTIONS(2168),
    [anon_sym_i32] = ACTIONS(2168),
    [anon_sym_u64] = ACTIONS(2168),
    [anon_sym_i64] = ACTIONS(2168),
    [anon_sym_u128] = ACTIONS(2168),
    [anon_sym_i128] = ACTIONS(2168),
    [anon_sym_isize] = ACTIONS(2168),
    [anon_sym_usize] = ACTIONS(2168),
    [anon_sym_f32] = ACTIONS(2168),
    [anon_sym_f64] = ACTIONS(2168),
    [anon_sym_bool] = ACTIONS(2168),
    [anon_sym_str] = ACTIONS(2168),
    [anon_sym_char] = ACTIONS(2168),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_AMP] = ACTIONS(2166),
    [anon_sym_PIPE] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_COLON_COLON] = ACTIONS(2166),
    [anon_sym_POUND] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2168),
    [anon_sym_async] = ACTIONS(2168),
    [anon_sym_break] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_continue] = ACTIONS(2168),
    [anon_sym_default] = ACTIONS(2168),
    [anon_sym_enum] = ACTIONS(2168),
    [anon_sym_fn] = ACTIONS(2168),
    [anon_sym_for] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2168),
    [anon_sym_impl] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_loop] = ACTIONS(2168),
    [anon_sym_match] = ACTIONS(2168),
    [anon_sym_mod] = ACTIONS(2168),
    [anon_sym_pub] = ACTIONS(2168),
    [anon_sym_return] = ACTIONS(2168),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_struct] = ACTIONS(2168),
    [anon_sym_trait] = ACTIONS(2168),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_union] = ACTIONS(2168),
    [anon_sym_unsafe] = ACTIONS(2168),
    [anon_sym_use] = ACTIONS(2168),
    [anon_sym_while] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym_yield] = ACTIONS(2168),
    [anon_sym_move] = ACTIONS(2168),
    [anon_sym_try] = ACTIONS(2168),
    [sym_integer_literal] = ACTIONS(2166),
    [aux_sym_string_literal_token1] = ACTIONS(2166),
    [sym_char_literal] = ACTIONS(2166),
    [anon_sym_true] = ACTIONS(2168),
    [anon_sym_false] = ACTIONS(2168),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2168),
    [sym_super] = ACTIONS(2168),
    [sym_crate] = ACTIONS(2168),
    [sym_metavariable] = ACTIONS(2166),
    [sym__raw_string_literal_start] = ACTIONS(2166),
    [sym_float_literal] = ACTIONS(2166),
  },
  [580] = {
    [sym_line_comment] = STATE(580),
    [sym_block_comment] = STATE(580),
    [ts_builtin_sym_end] = ACTIONS(2170),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_macro_rules_BANG] = ACTIONS(2170),
    [anon_sym_LPAREN] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_LBRACE] = ACTIONS(2170),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_STAR] = ACTIONS(2170),
    [anon_sym_u8] = ACTIONS(2172),
    [anon_sym_i8] = ACTIONS(2172),
    [anon_sym_u16] = ACTIONS(2172),
    [anon_sym_i16] = ACTIONS(2172),
    [anon_sym_u32] = ACTIONS(2172),
    [anon_sym_i32] = ACTIONS(2172),
    [anon_sym_u64] = ACTIONS(2172),
    [anon_sym_i64] = ACTIONS(2172),
    [anon_sym_u128] = ACTIONS(2172),
    [anon_sym_i128] = ACTIONS(2172),
    [anon_sym_isize] = ACTIONS(2172),
    [anon_sym_usize] = ACTIONS(2172),
    [anon_sym_f32] = ACTIONS(2172),
    [anon_sym_f64] = ACTIONS(2172),
    [anon_sym_bool] = ACTIONS(2172),
    [anon_sym_str] = ACTIONS(2172),
    [anon_sym_char] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2170),
    [anon_sym_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2170),
    [anon_sym_LT] = ACTIONS(2170),
    [anon_sym_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2170),
    [anon_sym_POUND] = ACTIONS(2170),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [anon_sym_fn] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_impl] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_loop] = ACTIONS(2172),
    [anon_sym_match] = ACTIONS(2172),
    [anon_sym_mod] = ACTIONS(2172),
    [anon_sym_pub] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_struct] = ACTIONS(2172),
    [anon_sym_trait] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_union] = ACTIONS(2172),
    [anon_sym_unsafe] = ACTIONS(2172),
    [anon_sym_use] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_extern] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_move] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [sym_integer_literal] = ACTIONS(2170),
    [aux_sym_string_literal_token1] = ACTIONS(2170),
    [sym_char_literal] = ACTIONS(2170),
    [anon_sym_true] = ACTIONS(2172),
    [anon_sym_false] = ACTIONS(2172),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_crate] = ACTIONS(2172),
    [sym_metavariable] = ACTIONS(2170),
    [sym__raw_string_literal_start] = ACTIONS(2170),
    [sym_float_literal] = ACTIONS(2170),
  },
  [581] = {
    [sym_line_comment] = STATE(581),
    [sym_block_comment] = STATE(581),
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_identifier] = ACTIONS(2176),
    [anon_sym_SEMI] = ACTIONS(2174),
    [anon_sym_macro_rules_BANG] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_u8] = ACTIONS(2176),
    [anon_sym_i8] = ACTIONS(2176),
    [anon_sym_u16] = ACTIONS(2176),
    [anon_sym_i16] = ACTIONS(2176),
    [anon_sym_u32] = ACTIONS(2176),
    [anon_sym_i32] = ACTIONS(2176),
    [anon_sym_u64] = ACTIONS(2176),
    [anon_sym_i64] = ACTIONS(2176),
    [anon_sym_u128] = ACTIONS(2176),
    [anon_sym_i128] = ACTIONS(2176),
    [anon_sym_isize] = ACTIONS(2176),
    [anon_sym_usize] = ACTIONS(2176),
    [anon_sym_f32] = ACTIONS(2176),
    [anon_sym_f64] = ACTIONS(2176),
    [anon_sym_bool] = ACTIONS(2176),
    [anon_sym_str] = ACTIONS(2176),
    [anon_sym_char] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_AMP] = ACTIONS(2174),
    [anon_sym_PIPE] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2174),
    [anon_sym_DOT_DOT] = ACTIONS(2174),
    [anon_sym_COLON_COLON] = ACTIONS(2174),
    [anon_sym_POUND] = ACTIONS(2174),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_async] = ACTIONS(2176),
    [anon_sym_break] = ACTIONS(2176),
    [anon_sym_const] = ACTIONS(2176),
    [anon_sym_continue] = ACTIONS(2176),
    [anon_sym_default] = ACTIONS(2176),
    [anon_sym_enum] = ACTIONS(2176),
    [anon_sym_fn] = ACTIONS(2176),
    [anon_sym_for] = ACTIONS(2176),
    [anon_sym_if] = ACTIONS(2176),
    [anon_sym_impl] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_loop] = ACTIONS(2176),
    [anon_sym_match] = ACTIONS(2176),
    [anon_sym_mod] = ACTIONS(2176),
    [anon_sym_pub] = ACTIONS(2176),
    [anon_sym_return] = ACTIONS(2176),
    [anon_sym_static] = ACTIONS(2176),
    [anon_sym_struct] = ACTIONS(2176),
    [anon_sym_trait] = ACTIONS(2176),
    [anon_sym_type] = ACTIONS(2176),
    [anon_sym_union] = ACTIONS(2176),
    [anon_sym_unsafe] = ACTIONS(2176),
    [anon_sym_use] = ACTIONS(2176),
    [anon_sym_while] = ACTIONS(2176),
    [anon_sym_extern] = ACTIONS(2176),
    [anon_sym_yield] = ACTIONS(2176),
    [anon_sym_move] = ACTIONS(2176),
    [anon_sym_try] = ACTIONS(2176),
    [sym_integer_literal] = ACTIONS(2174),
    [aux_sym_string_literal_token1] = ACTIONS(2174),
    [sym_char_literal] = ACTIONS(2174),
    [anon_sym_true] = ACTIONS(2176),
    [anon_sym_false] = ACTIONS(2176),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2176),
    [sym_super] = ACTIONS(2176),
    [sym_crate] = ACTIONS(2176),
    [sym_metavariable] = ACTIONS(2174),
    [sym__raw_string_literal_start] = ACTIONS(2174),
    [sym_float_literal] = ACTIONS(2174),
  },
  [582] = {
    [sym_line_comment] = STATE(582),
    [sym_block_comment] = STATE(582),
    [ts_builtin_sym_end] = ACTIONS(2178),
    [sym_identifier] = ACTIONS(2180),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_macro_rules_BANG] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_u8] = ACTIONS(2180),
    [anon_sym_i8] = ACTIONS(2180),
    [anon_sym_u16] = ACTIONS(2180),
    [anon_sym_i16] = ACTIONS(2180),
    [anon_sym_u32] = ACTIONS(2180),
    [anon_sym_i32] = ACTIONS(2180),
    [anon_sym_u64] = ACTIONS(2180),
    [anon_sym_i64] = ACTIONS(2180),
    [anon_sym_u128] = ACTIONS(2180),
    [anon_sym_i128] = ACTIONS(2180),
    [anon_sym_isize] = ACTIONS(2180),
    [anon_sym_usize] = ACTIONS(2180),
    [anon_sym_f32] = ACTIONS(2180),
    [anon_sym_f64] = ACTIONS(2180),
    [anon_sym_bool] = ACTIONS(2180),
    [anon_sym_str] = ACTIONS(2180),
    [anon_sym_char] = ACTIONS(2180),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_PIPE] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_DOT_DOT] = ACTIONS(2178),
    [anon_sym_COLON_COLON] = ACTIONS(2178),
    [anon_sym_POUND] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2180),
    [anon_sym_async] = ACTIONS(2180),
    [anon_sym_break] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_continue] = ACTIONS(2180),
    [anon_sym_default] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
    [anon_sym_fn] = ACTIONS(2180),
    [anon_sym_for] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2180),
    [anon_sym_impl] = ACTIONS(2180),
    [anon_sym_let] = ACTIONS(2180),
    [anon_sym_loop] = ACTIONS(2180),
    [anon_sym_match] = ACTIONS(2180),
    [anon_sym_mod] = ACTIONS(2180),
    [anon_sym_pub] = ACTIONS(2180),
    [anon_sym_return] = ACTIONS(2180),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2180),
    [anon_sym_trait] = ACTIONS(2180),
    [anon_sym_type] = ACTIONS(2180),
    [anon_sym_union] = ACTIONS(2180),
    [anon_sym_unsafe] = ACTIONS(2180),
    [anon_sym_use] = ACTIONS(2180),
    [anon_sym_while] = ACTIONS(2180),
    [anon_sym_extern] = ACTIONS(2180),
    [anon_sym_yield] = ACTIONS(2180),
    [anon_sym_move] = ACTIONS(2180),
    [anon_sym_try] = ACTIONS(2180),
    [sym_integer_literal] = ACTIONS(2178),
    [aux_sym_string_literal_token1] = ACTIONS(2178),
    [sym_char_literal] = ACTIONS(2178),
    [anon_sym_true] = ACTIONS(2180),
    [anon_sym_false] = ACTIONS(2180),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2180),
    [sym_super] = ACTIONS(2180),
    [sym_crate] = ACTIONS(2180),
    [sym_metavariable] = ACTIONS(2178),
    [sym__raw_string_literal_start] = ACTIONS(2178),
    [sym_float_literal] = ACTIONS(2178),
  },
  [583] = {
    [sym_line_comment] = STATE(583),
    [sym_block_comment] = STATE(583),
    [ts_builtin_sym_end] = ACTIONS(2182),
    [sym_identifier] = ACTIONS(2184),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_macro_rules_BANG] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(2182),
    [anon_sym_u8] = ACTIONS(2184),
    [anon_sym_i8] = ACTIONS(2184),
    [anon_sym_u16] = ACTIONS(2184),
    [anon_sym_i16] = ACTIONS(2184),
    [anon_sym_u32] = ACTIONS(2184),
    [anon_sym_i32] = ACTIONS(2184),
    [anon_sym_u64] = ACTIONS(2184),
    [anon_sym_i64] = ACTIONS(2184),
    [anon_sym_u128] = ACTIONS(2184),
    [anon_sym_i128] = ACTIONS(2184),
    [anon_sym_isize] = ACTIONS(2184),
    [anon_sym_usize] = ACTIONS(2184),
    [anon_sym_f32] = ACTIONS(2184),
    [anon_sym_f64] = ACTIONS(2184),
    [anon_sym_bool] = ACTIONS(2184),
    [anon_sym_str] = ACTIONS(2184),
    [anon_sym_char] = ACTIONS(2184),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_AMP] = ACTIONS(2182),
    [anon_sym_PIPE] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_COLON_COLON] = ACTIONS(2182),
    [anon_sym_POUND] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2184),
    [anon_sym_async] = ACTIONS(2184),
    [anon_sym_break] = ACTIONS(2184),
    [anon_sym_const] = ACTIONS(2184),
    [anon_sym_continue] = ACTIONS(2184),
    [anon_sym_default] = ACTIONS(2184),
    [anon_sym_enum] = ACTIONS(2184),
    [anon_sym_fn] = ACTIONS(2184),
    [anon_sym_for] = ACTIONS(2184),
    [anon_sym_if] = ACTIONS(2184),
    [anon_sym_impl] = ACTIONS(2184),
    [anon_sym_let] = ACTIONS(2184),
    [anon_sym_loop] = ACTIONS(2184),
    [anon_sym_match] = ACTIONS(2184),
    [anon_sym_mod] = ACTIONS(2184),
    [anon_sym_pub] = ACTIONS(2184),
    [anon_sym_return] = ACTIONS(2184),
    [anon_sym_static] = ACTIONS(2184),
    [anon_sym_struct] = ACTIONS(2184),
    [anon_sym_trait] = ACTIONS(2184),
    [anon_sym_type] = ACTIONS(2184),
    [anon_sym_union] = ACTIONS(2184),
    [anon_sym_unsafe] = ACTIONS(2184),
    [anon_sym_use] = ACTIONS(2184),
    [anon_sym_while] = ACTIONS(2184),
    [anon_sym_extern] = ACTIONS(2184),
    [anon_sym_yield] = ACTIONS(2184),
    [anon_sym_move] = ACTIONS(2184),
    [anon_sym_try] = ACTIONS(2184),
    [sym_integer_literal] = ACTIONS(2182),
    [aux_sym_string_literal_token1] = ACTIONS(2182),
    [sym_char_literal] = ACTIONS(2182),
    [anon_sym_true] = ACTIONS(2184),
    [anon_sym_false] = ACTIONS(2184),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2184),
    [sym_super] = ACTIONS(2184),
    [sym_crate] = ACTIONS(2184),
    [sym_metavariable] = ACTIONS(2182),
    [sym__raw_string_literal_start] = ACTIONS(2182),
    [sym_float_literal] = ACTIONS(2182),
  },
  [584] = {
    [sym_line_comment] = STATE(584),
    [sym_block_comment] = STATE(584),
    [ts_builtin_sym_end] = ACTIONS(2186),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_macro_rules_BANG] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_RBRACE] = ACTIONS(2186),
    [anon_sym_STAR] = ACTIONS(2186),
    [anon_sym_u8] = ACTIONS(2188),
    [anon_sym_i8] = ACTIONS(2188),
    [anon_sym_u16] = ACTIONS(2188),
    [anon_sym_i16] = ACTIONS(2188),
    [anon_sym_u32] = ACTIONS(2188),
    [anon_sym_i32] = ACTIONS(2188),
    [anon_sym_u64] = ACTIONS(2188),
    [anon_sym_i64] = ACTIONS(2188),
    [anon_sym_u128] = ACTIONS(2188),
    [anon_sym_i128] = ACTIONS(2188),
    [anon_sym_isize] = ACTIONS(2188),
    [anon_sym_usize] = ACTIONS(2188),
    [anon_sym_f32] = ACTIONS(2188),
    [anon_sym_f64] = ACTIONS(2188),
    [anon_sym_bool] = ACTIONS(2188),
    [anon_sym_str] = ACTIONS(2188),
    [anon_sym_char] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_BANG] = ACTIONS(2186),
    [anon_sym_AMP] = ACTIONS(2186),
    [anon_sym_PIPE] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_DOT_DOT] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_POUND] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_default] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
    [anon_sym_fn] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_impl] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_loop] = ACTIONS(2188),
    [anon_sym_match] = ACTIONS(2188),
    [anon_sym_mod] = ACTIONS(2188),
    [anon_sym_pub] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_struct] = ACTIONS(2188),
    [anon_sym_trait] = ACTIONS(2188),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_union] = ACTIONS(2188),
    [anon_sym_unsafe] = ACTIONS(2188),
    [anon_sym_use] = ACTIONS(2188),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_extern] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_move] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [sym_integer_literal] = ACTIONS(2186),
    [aux_sym_string_literal_token1] = ACTIONS(2186),
    [sym_char_literal] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2188),
    [anon_sym_false] = ACTIONS(2188),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_crate] = ACTIONS(2188),
    [sym_metavariable] = ACTIONS(2186),
    [sym__raw_string_literal_start] = ACTIONS(2186),
    [sym_float_literal] = ACTIONS(2186),
  },
  [585] = {
    [sym_line_comment] = STATE(585),
    [sym_block_comment] = STATE(585),
    [ts_builtin_sym_end] = ACTIONS(2190),
    [sym_identifier] = ACTIONS(2192),
    [anon_sym_SEMI] = ACTIONS(2190),
    [anon_sym_macro_rules_BANG] = ACTIONS(2190),
    [anon_sym_LPAREN] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2190),
    [anon_sym_RBRACE] = ACTIONS(2190),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_u8] = ACTIONS(2192),
    [anon_sym_i8] = ACTIONS(2192),
    [anon_sym_u16] = ACTIONS(2192),
    [anon_sym_i16] = ACTIONS(2192),
    [anon_sym_u32] = ACTIONS(2192),
    [anon_sym_i32] = ACTIONS(2192),
    [anon_sym_u64] = ACTIONS(2192),
    [anon_sym_i64] = ACTIONS(2192),
    [anon_sym_u128] = ACTIONS(2192),
    [anon_sym_i128] = ACTIONS(2192),
    [anon_sym_isize] = ACTIONS(2192),
    [anon_sym_usize] = ACTIONS(2192),
    [anon_sym_f32] = ACTIONS(2192),
    [anon_sym_f64] = ACTIONS(2192),
    [anon_sym_bool] = ACTIONS(2192),
    [anon_sym_str] = ACTIONS(2192),
    [anon_sym_char] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_DOT_DOT] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2190),
    [anon_sym_POUND] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [anon_sym_async] = ACTIONS(2192),
    [anon_sym_break] = ACTIONS(2192),
    [anon_sym_const] = ACTIONS(2192),
    [anon_sym_continue] = ACTIONS(2192),
    [anon_sym_default] = ACTIONS(2192),
    [anon_sym_enum] = ACTIONS(2192),
    [anon_sym_fn] = ACTIONS(2192),
    [anon_sym_for] = ACTIONS(2192),
    [anon_sym_if] = ACTIONS(2192),
    [anon_sym_impl] = ACTIONS(2192),
    [anon_sym_let] = ACTIONS(2192),
    [anon_sym_loop] = ACTIONS(2192),
    [anon_sym_match] = ACTIONS(2192),
    [anon_sym_mod] = ACTIONS(2192),
    [anon_sym_pub] = ACTIONS(2192),
    [anon_sym_return] = ACTIONS(2192),
    [anon_sym_static] = ACTIONS(2192),
    [anon_sym_struct] = ACTIONS(2192),
    [anon_sym_trait] = ACTIONS(2192),
    [anon_sym_type] = ACTIONS(2192),
    [anon_sym_union] = ACTIONS(2192),
    [anon_sym_unsafe] = ACTIONS(2192),
    [anon_sym_use] = ACTIONS(2192),
    [anon_sym_while] = ACTIONS(2192),
    [anon_sym_extern] = ACTIONS(2192),
    [anon_sym_yield] = ACTIONS(2192),
    [anon_sym_move] = ACTIONS(2192),
    [anon_sym_try] = ACTIONS(2192),
    [sym_integer_literal] = ACTIONS(2190),
    [aux_sym_string_literal_token1] = ACTIONS(2190),
    [sym_char_literal] = ACTIONS(2190),
    [anon_sym_true] = ACTIONS(2192),
    [anon_sym_false] = ACTIONS(2192),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2192),
    [sym_super] = ACTIONS(2192),
    [sym_crate] = ACTIONS(2192),
    [sym_metavariable] = ACTIONS(2190),
    [sym__raw_string_literal_start] = ACTIONS(2190),
    [sym_float_literal] = ACTIONS(2190),
  },
  [586] = {
    [sym_line_comment] = STATE(586),
    [sym_block_comment] = STATE(586),
    [ts_builtin_sym_end] = ACTIONS(2194),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2194),
    [anon_sym_macro_rules_BANG] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2194),
    [anon_sym_RBRACE] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2194),
    [anon_sym_u8] = ACTIONS(2196),
    [anon_sym_i8] = ACTIONS(2196),
    [anon_sym_u16] = ACTIONS(2196),
    [anon_sym_i16] = ACTIONS(2196),
    [anon_sym_u32] = ACTIONS(2196),
    [anon_sym_i32] = ACTIONS(2196),
    [anon_sym_u64] = ACTIONS(2196),
    [anon_sym_i64] = ACTIONS(2196),
    [anon_sym_u128] = ACTIONS(2196),
    [anon_sym_i128] = ACTIONS(2196),
    [anon_sym_isize] = ACTIONS(2196),
    [anon_sym_usize] = ACTIONS(2196),
    [anon_sym_f32] = ACTIONS(2196),
    [anon_sym_f64] = ACTIONS(2196),
    [anon_sym_bool] = ACTIONS(2196),
    [anon_sym_str] = ACTIONS(2196),
    [anon_sym_char] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_DOT_DOT] = ACTIONS(2194),
    [anon_sym_COLON_COLON] = ACTIONS(2194),
    [anon_sym_POUND] = ACTIONS(2194),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_default] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
    [anon_sym_fn] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_impl] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_loop] = ACTIONS(2196),
    [anon_sym_match] = ACTIONS(2196),
    [anon_sym_mod] = ACTIONS(2196),
    [anon_sym_pub] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_struct] = ACTIONS(2196),
    [anon_sym_trait] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_union] = ACTIONS(2196),
    [anon_sym_unsafe] = ACTIONS(2196),
    [anon_sym_use] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_extern] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_move] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [sym_integer_literal] = ACTIONS(2194),
    [aux_sym_string_literal_token1] = ACTIONS(2194),
    [sym_char_literal] = ACTIONS(2194),
    [anon_sym_true] = ACTIONS(2196),
    [anon_sym_false] = ACTIONS(2196),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_crate] = ACTIONS(2196),
    [sym_metavariable] = ACTIONS(2194),
    [sym__raw_string_literal_start] = ACTIONS(2194),
    [sym_float_literal] = ACTIONS(2194),
  },
  [587] = {
    [sym_line_comment] = STATE(587),
    [sym_block_comment] = STATE(587),
    [ts_builtin_sym_end] = ACTIONS(2198),
    [sym_identifier] = ACTIONS(2200),
    [anon_sym_SEMI] = ACTIONS(2198),
    [anon_sym_macro_rules_BANG] = ACTIONS(2198),
    [anon_sym_LPAREN] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2198),
    [anon_sym_u8] = ACTIONS(2200),
    [anon_sym_i8] = ACTIONS(2200),
    [anon_sym_u16] = ACTIONS(2200),
    [anon_sym_i16] = ACTIONS(2200),
    [anon_sym_u32] = ACTIONS(2200),
    [anon_sym_i32] = ACTIONS(2200),
    [anon_sym_u64] = ACTIONS(2200),
    [anon_sym_i64] = ACTIONS(2200),
    [anon_sym_u128] = ACTIONS(2200),
    [anon_sym_i128] = ACTIONS(2200),
    [anon_sym_isize] = ACTIONS(2200),
    [anon_sym_usize] = ACTIONS(2200),
    [anon_sym_f32] = ACTIONS(2200),
    [anon_sym_f64] = ACTIONS(2200),
    [anon_sym_bool] = ACTIONS(2200),
    [anon_sym_str] = ACTIONS(2200),
    [anon_sym_char] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_DOT_DOT] = ACTIONS(2198),
    [anon_sym_COLON_COLON] = ACTIONS(2198),
    [anon_sym_POUND] = ACTIONS(2198),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_async] = ACTIONS(2200),
    [anon_sym_break] = ACTIONS(2200),
    [anon_sym_const] = ACTIONS(2200),
    [anon_sym_continue] = ACTIONS(2200),
    [anon_sym_default] = ACTIONS(2200),
    [anon_sym_enum] = ACTIONS(2200),
    [anon_sym_fn] = ACTIONS(2200),
    [anon_sym_for] = ACTIONS(2200),
    [anon_sym_if] = ACTIONS(2200),
    [anon_sym_impl] = ACTIONS(2200),
    [anon_sym_let] = ACTIONS(2200),
    [anon_sym_loop] = ACTIONS(2200),
    [anon_sym_match] = ACTIONS(2200),
    [anon_sym_mod] = ACTIONS(2200),
    [anon_sym_pub] = ACTIONS(2200),
    [anon_sym_return] = ACTIONS(2200),
    [anon_sym_static] = ACTIONS(2200),
    [anon_sym_struct] = ACTIONS(2200),
    [anon_sym_trait] = ACTIONS(2200),
    [anon_sym_type] = ACTIONS(2200),
    [anon_sym_union] = ACTIONS(2200),
    [anon_sym_unsafe] = ACTIONS(2200),
    [anon_sym_use] = ACTIONS(2200),
    [anon_sym_while] = ACTIONS(2200),
    [anon_sym_extern] = ACTIONS(2200),
    [anon_sym_yield] = ACTIONS(2200),
    [anon_sym_move] = ACTIONS(2200),
    [anon_sym_try] = ACTIONS(2200),
    [sym_integer_literal] = ACTIONS(2198),
    [aux_sym_string_literal_token1] = ACTIONS(2198),
    [sym_char_literal] = ACTIONS(2198),
    [anon_sym_true] = ACTIONS(2200),
    [anon_sym_false] = ACTIONS(2200),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2200),
    [sym_super] = ACTIONS(2200),
    [sym_crate] = ACTIONS(2200),
    [sym_metavariable] = ACTIONS(2198),
    [sym__raw_string_literal_start] = ACTIONS(2198),
    [sym_float_literal] = ACTIONS(2198),
  },
  [588] = {
    [sym_line_comment] = STATE(588),
    [sym_block_comment] = STATE(588),
    [ts_builtin_sym_end] = ACTIONS(2202),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2202),
    [anon_sym_macro_rules_BANG] = ACTIONS(2202),
    [anon_sym_LPAREN] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2202),
    [anon_sym_RBRACE] = ACTIONS(2202),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_u8] = ACTIONS(2204),
    [anon_sym_i8] = ACTIONS(2204),
    [anon_sym_u16] = ACTIONS(2204),
    [anon_sym_i16] = ACTIONS(2204),
    [anon_sym_u32] = ACTIONS(2204),
    [anon_sym_i32] = ACTIONS(2204),
    [anon_sym_u64] = ACTIONS(2204),
    [anon_sym_i64] = ACTIONS(2204),
    [anon_sym_u128] = ACTIONS(2204),
    [anon_sym_i128] = ACTIONS(2204),
    [anon_sym_isize] = ACTIONS(2204),
    [anon_sym_usize] = ACTIONS(2204),
    [anon_sym_f32] = ACTIONS(2204),
    [anon_sym_f64] = ACTIONS(2204),
    [anon_sym_bool] = ACTIONS(2204),
    [anon_sym_str] = ACTIONS(2204),
    [anon_sym_char] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_BANG] = ACTIONS(2202),
    [anon_sym_AMP] = ACTIONS(2202),
    [anon_sym_PIPE] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_COLON_COLON] = ACTIONS(2202),
    [anon_sym_POUND] = ACTIONS(2202),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_default] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
    [anon_sym_fn] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_impl] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_loop] = ACTIONS(2204),
    [anon_sym_match] = ACTIONS(2204),
    [anon_sym_mod] = ACTIONS(2204),
    [anon_sym_pub] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_struct] = ACTIONS(2204),
    [anon_sym_trait] = ACTIONS(2204),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_union] = ACTIONS(2204),
    [anon_sym_unsafe] = ACTIONS(2204),
    [anon_sym_use] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_extern] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_move] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [sym_integer_literal] = ACTIONS(2202),
    [aux_sym_string_literal_token1] = ACTIONS(2202),
    [sym_char_literal] = ACTIONS(2202),
    [anon_sym_true] = ACTIONS(2204),
    [anon_sym_false] = ACTIONS(2204),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_crate] = ACTIONS(2204),
    [sym_metavariable] = ACTIONS(2202),
    [sym__raw_string_literal_start] = ACTIONS(2202),
    [sym_float_literal] = ACTIONS(2202),
  },
  [589] = {
    [sym_line_comment] = STATE(589),
    [sym_block_comment] = STATE(589),
    [ts_builtin_sym_end] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2208),
    [anon_sym_SEMI] = ACTIONS(2206),
    [anon_sym_macro_rules_BANG] = ACTIONS(2206),
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_u8] = ACTIONS(2208),
    [anon_sym_i8] = ACTIONS(2208),
    [anon_sym_u16] = ACTIONS(2208),
    [anon_sym_i16] = ACTIONS(2208),
    [anon_sym_u32] = ACTIONS(2208),
    [anon_sym_i32] = ACTIONS(2208),
    [anon_sym_u64] = ACTIONS(2208),
    [anon_sym_i64] = ACTIONS(2208),
    [anon_sym_u128] = ACTIONS(2208),
    [anon_sym_i128] = ACTIONS(2208),
    [anon_sym_isize] = ACTIONS(2208),
    [anon_sym_usize] = ACTIONS(2208),
    [anon_sym_f32] = ACTIONS(2208),
    [anon_sym_f64] = ACTIONS(2208),
    [anon_sym_bool] = ACTIONS(2208),
    [anon_sym_str] = ACTIONS(2208),
    [anon_sym_char] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_DOT_DOT] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2206),
    [anon_sym_POUND] = ACTIONS(2206),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_async] = ACTIONS(2208),
    [anon_sym_break] = ACTIONS(2208),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_continue] = ACTIONS(2208),
    [anon_sym_default] = ACTIONS(2208),
    [anon_sym_enum] = ACTIONS(2208),
    [anon_sym_fn] = ACTIONS(2208),
    [anon_sym_for] = ACTIONS(2208),
    [anon_sym_if] = ACTIONS(2208),
    [anon_sym_impl] = ACTIONS(2208),
    [anon_sym_let] = ACTIONS(2208),
    [anon_sym_loop] = ACTIONS(2208),
    [anon_sym_match] = ACTIONS(2208),
    [anon_sym_mod] = ACTIONS(2208),
    [anon_sym_pub] = ACTIONS(2208),
    [anon_sym_return] = ACTIONS(2208),
    [anon_sym_static] = ACTIONS(2208),
    [anon_sym_struct] = ACTIONS(2208),
    [anon_sym_trait] = ACTIONS(2208),
    [anon_sym_type] = ACTIONS(2208),
    [anon_sym_union] = ACTIONS(2208),
    [anon_sym_unsafe] = ACTIONS(2208),
    [anon_sym_use] = ACTIONS(2208),
    [anon_sym_while] = ACTIONS(2208),
    [anon_sym_extern] = ACTIONS(2208),
    [anon_sym_yield] = ACTIONS(2208),
    [anon_sym_move] = ACTIONS(2208),
    [anon_sym_try] = ACTIONS(2208),
    [sym_integer_literal] = ACTIONS(2206),
    [aux_sym_string_literal_token1] = ACTIONS(2206),
    [sym_char_literal] = ACTIONS(2206),
    [anon_sym_true] = ACTIONS(2208),
    [anon_sym_false] = ACTIONS(2208),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2208),
    [sym_super] = ACTIONS(2208),
    [sym_crate] = ACTIONS(2208),
    [sym_metavariable] = ACTIONS(2206),
    [sym__raw_string_literal_start] = ACTIONS(2206),
    [sym_float_literal] = ACTIONS(2206),
  },
  [590] = {
    [sym_line_comment] = STATE(590),
    [sym_block_comment] = STATE(590),
    [ts_builtin_sym_end] = ACTIONS(2210),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2210),
    [anon_sym_macro_rules_BANG] = ACTIONS(2210),
    [anon_sym_LPAREN] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2210),
    [anon_sym_RBRACE] = ACTIONS(2210),
    [anon_sym_STAR] = ACTIONS(2210),
    [anon_sym_u8] = ACTIONS(2212),
    [anon_sym_i8] = ACTIONS(2212),
    [anon_sym_u16] = ACTIONS(2212),
    [anon_sym_i16] = ACTIONS(2212),
    [anon_sym_u32] = ACTIONS(2212),
    [anon_sym_i32] = ACTIONS(2212),
    [anon_sym_u64] = ACTIONS(2212),
    [anon_sym_i64] = ACTIONS(2212),
    [anon_sym_u128] = ACTIONS(2212),
    [anon_sym_i128] = ACTIONS(2212),
    [anon_sym_isize] = ACTIONS(2212),
    [anon_sym_usize] = ACTIONS(2212),
    [anon_sym_f32] = ACTIONS(2212),
    [anon_sym_f64] = ACTIONS(2212),
    [anon_sym_bool] = ACTIONS(2212),
    [anon_sym_str] = ACTIONS(2212),
    [anon_sym_char] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_PIPE] = ACTIONS(2210),
    [anon_sym_LT] = ACTIONS(2210),
    [anon_sym_DOT_DOT] = ACTIONS(2210),
    [anon_sym_COLON_COLON] = ACTIONS(2210),
    [anon_sym_POUND] = ACTIONS(2210),
    [anon_sym_SQUOTE] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_default] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
    [anon_sym_fn] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_impl] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_loop] = ACTIONS(2212),
    [anon_sym_match] = ACTIONS(2212),
    [anon_sym_mod] = ACTIONS(2212),
    [anon_sym_pub] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_struct] = ACTIONS(2212),
    [anon_sym_trait] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_union] = ACTIONS(2212),
    [anon_sym_unsafe] = ACTIONS(2212),
    [anon_sym_use] = ACTIONS(2212),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_move] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [sym_integer_literal] = ACTIONS(2210),
    [aux_sym_string_literal_token1] = ACTIONS(2210),
    [sym_char_literal] = ACTIONS(2210),
    [anon_sym_true] = ACTIONS(2212),
    [anon_sym_false] = ACTIONS(2212),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_crate] = ACTIONS(2212),
    [sym_metavariable] = ACTIONS(2210),
    [sym__raw_string_literal_start] = ACTIONS(2210),
    [sym_float_literal] = ACTIONS(2210),
  },
  [591] = {
    [sym_line_comment] = STATE(591),
    [sym_block_comment] = STATE(591),
    [ts_builtin_sym_end] = ACTIONS(2214),
    [sym_identifier] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_macro_rules_BANG] = ACTIONS(2214),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2214),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_u8] = ACTIONS(2216),
    [anon_sym_i8] = ACTIONS(2216),
    [anon_sym_u16] = ACTIONS(2216),
    [anon_sym_i16] = ACTIONS(2216),
    [anon_sym_u32] = ACTIONS(2216),
    [anon_sym_i32] = ACTIONS(2216),
    [anon_sym_u64] = ACTIONS(2216),
    [anon_sym_i64] = ACTIONS(2216),
    [anon_sym_u128] = ACTIONS(2216),
    [anon_sym_i128] = ACTIONS(2216),
    [anon_sym_isize] = ACTIONS(2216),
    [anon_sym_usize] = ACTIONS(2216),
    [anon_sym_f32] = ACTIONS(2216),
    [anon_sym_f64] = ACTIONS(2216),
    [anon_sym_bool] = ACTIONS(2216),
    [anon_sym_str] = ACTIONS(2216),
    [anon_sym_char] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2214),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_DOT_DOT] = ACTIONS(2214),
    [anon_sym_COLON_COLON] = ACTIONS(2214),
    [anon_sym_POUND] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2216),
    [anon_sym_async] = ACTIONS(2216),
    [anon_sym_break] = ACTIONS(2216),
    [anon_sym_const] = ACTIONS(2216),
    [anon_sym_continue] = ACTIONS(2216),
    [anon_sym_default] = ACTIONS(2216),
    [anon_sym_enum] = ACTIONS(2216),
    [anon_sym_fn] = ACTIONS(2216),
    [anon_sym_for] = ACTIONS(2216),
    [anon_sym_if] = ACTIONS(2216),
    [anon_sym_impl] = ACTIONS(2216),
    [anon_sym_let] = ACTIONS(2216),
    [anon_sym_loop] = ACTIONS(2216),
    [anon_sym_match] = ACTIONS(2216),
    [anon_sym_mod] = ACTIONS(2216),
    [anon_sym_pub] = ACTIONS(2216),
    [anon_sym_return] = ACTIONS(2216),
    [anon_sym_static] = ACTIONS(2216),
    [anon_sym_struct] = ACTIONS(2216),
    [anon_sym_trait] = ACTIONS(2216),
    [anon_sym_type] = ACTIONS(2216),
    [anon_sym_union] = ACTIONS(2216),
    [anon_sym_unsafe] = ACTIONS(2216),
    [anon_sym_use] = ACTIONS(2216),
    [anon_sym_while] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(2216),
    [anon_sym_yield] = ACTIONS(2216),
    [anon_sym_move] = ACTIONS(2216),
    [anon_sym_try] = ACTIONS(2216),
    [sym_integer_literal] = ACTIONS(2214),
    [aux_sym_string_literal_token1] = ACTIONS(2214),
    [sym_char_literal] = ACTIONS(2214),
    [anon_sym_true] = ACTIONS(2216),
    [anon_sym_false] = ACTIONS(2216),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2216),
    [sym_super] = ACTIONS(2216),
    [sym_crate] = ACTIONS(2216),
    [sym_metavariable] = ACTIONS(2214),
    [sym__raw_string_literal_start] = ACTIONS(2214),
    [sym_float_literal] = ACTIONS(2214),
  },
  [592] = {
    [sym_line_comment] = STATE(592),
    [sym_block_comment] = STATE(592),
    [ts_builtin_sym_end] = ACTIONS(2218),
    [sym_identifier] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_macro_rules_BANG] = ACTIONS(2218),
    [anon_sym_LPAREN] = ACTIONS(2218),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_RBRACE] = ACTIONS(2218),
    [anon_sym_STAR] = ACTIONS(2218),
    [anon_sym_u8] = ACTIONS(2220),
    [anon_sym_i8] = ACTIONS(2220),
    [anon_sym_u16] = ACTIONS(2220),
    [anon_sym_i16] = ACTIONS(2220),
    [anon_sym_u32] = ACTIONS(2220),
    [anon_sym_i32] = ACTIONS(2220),
    [anon_sym_u64] = ACTIONS(2220),
    [anon_sym_i64] = ACTIONS(2220),
    [anon_sym_u128] = ACTIONS(2220),
    [anon_sym_i128] = ACTIONS(2220),
    [anon_sym_isize] = ACTIONS(2220),
    [anon_sym_usize] = ACTIONS(2220),
    [anon_sym_f32] = ACTIONS(2220),
    [anon_sym_f64] = ACTIONS(2220),
    [anon_sym_bool] = ACTIONS(2220),
    [anon_sym_str] = ACTIONS(2220),
    [anon_sym_char] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_AMP] = ACTIONS(2218),
    [anon_sym_PIPE] = ACTIONS(2218),
    [anon_sym_LT] = ACTIONS(2218),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_COLON_COLON] = ACTIONS(2218),
    [anon_sym_POUND] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_async] = ACTIONS(2220),
    [anon_sym_break] = ACTIONS(2220),
    [anon_sym_const] = ACTIONS(2220),
    [anon_sym_continue] = ACTIONS(2220),
    [anon_sym_default] = ACTIONS(2220),
    [anon_sym_enum] = ACTIONS(2220),
    [anon_sym_fn] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2220),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_impl] = ACTIONS(2220),
    [anon_sym_let] = ACTIONS(2220),
    [anon_sym_loop] = ACTIONS(2220),
    [anon_sym_match] = ACTIONS(2220),
    [anon_sym_mod] = ACTIONS(2220),
    [anon_sym_pub] = ACTIONS(2220),
    [anon_sym_return] = ACTIONS(2220),
    [anon_sym_static] = ACTIONS(2220),
    [anon_sym_struct] = ACTIONS(2220),
    [anon_sym_trait] = ACTIONS(2220),
    [anon_sym_type] = ACTIONS(2220),
    [anon_sym_union] = ACTIONS(2220),
    [anon_sym_unsafe] = ACTIONS(2220),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_while] = ACTIONS(2220),
    [anon_sym_extern] = ACTIONS(2220),
    [anon_sym_yield] = ACTIONS(2220),
    [anon_sym_move] = ACTIONS(2220),
    [anon_sym_try] = ACTIONS(2220),
    [sym_integer_literal] = ACTIONS(2218),
    [aux_sym_string_literal_token1] = ACTIONS(2218),
    [sym_char_literal] = ACTIONS(2218),
    [anon_sym_true] = ACTIONS(2220),
    [anon_sym_false] = ACTIONS(2220),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2220),
    [sym_super] = ACTIONS(2220),
    [sym_crate] = ACTIONS(2220),
    [sym_metavariable] = ACTIONS(2218),
    [sym__raw_string_literal_start] = ACTIONS(2218),
    [sym_float_literal] = ACTIONS(2218),
  },
  [593] = {
    [sym_line_comment] = STATE(593),
    [sym_block_comment] = STATE(593),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_macro_rules_BANG] = ACTIONS(2222),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_RBRACE] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_u8] = ACTIONS(2224),
    [anon_sym_i8] = ACTIONS(2224),
    [anon_sym_u16] = ACTIONS(2224),
    [anon_sym_i16] = ACTIONS(2224),
    [anon_sym_u32] = ACTIONS(2224),
    [anon_sym_i32] = ACTIONS(2224),
    [anon_sym_u64] = ACTIONS(2224),
    [anon_sym_i64] = ACTIONS(2224),
    [anon_sym_u128] = ACTIONS(2224),
    [anon_sym_i128] = ACTIONS(2224),
    [anon_sym_isize] = ACTIONS(2224),
    [anon_sym_usize] = ACTIONS(2224),
    [anon_sym_f32] = ACTIONS(2224),
    [anon_sym_f64] = ACTIONS(2224),
    [anon_sym_bool] = ACTIONS(2224),
    [anon_sym_str] = ACTIONS(2224),
    [anon_sym_char] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_DOT_DOT] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2222),
    [anon_sym_POUND] = ACTIONS(2222),
    [anon_sym_SQUOTE] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_fn] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_impl] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_loop] = ACTIONS(2224),
    [anon_sym_match] = ACTIONS(2224),
    [anon_sym_mod] = ACTIONS(2224),
    [anon_sym_pub] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_trait] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_unsafe] = ACTIONS(2224),
    [anon_sym_use] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym_yield] = ACTIONS(2224),
    [anon_sym_move] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [sym_integer_literal] = ACTIONS(2222),
    [aux_sym_string_literal_token1] = ACTIONS(2222),
    [sym_char_literal] = ACTIONS(2222),
    [anon_sym_true] = ACTIONS(2224),
    [anon_sym_false] = ACTIONS(2224),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2224),
    [sym_super] = ACTIONS(2224),
    [sym_crate] = ACTIONS(2224),
    [sym_metavariable] = ACTIONS(2222),
    [sym__raw_string_literal_start] = ACTIONS(2222),
    [sym_float_literal] = ACTIONS(2222),
  },
  [594] = {
    [sym_line_comment] = STATE(594),
    [sym_block_comment] = STATE(594),
    [ts_builtin_sym_end] = ACTIONS(2226),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_macro_rules_BANG] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_u8] = ACTIONS(2228),
    [anon_sym_i8] = ACTIONS(2228),
    [anon_sym_u16] = ACTIONS(2228),
    [anon_sym_i16] = ACTIONS(2228),
    [anon_sym_u32] = ACTIONS(2228),
    [anon_sym_i32] = ACTIONS(2228),
    [anon_sym_u64] = ACTIONS(2228),
    [anon_sym_i64] = ACTIONS(2228),
    [anon_sym_u128] = ACTIONS(2228),
    [anon_sym_i128] = ACTIONS(2228),
    [anon_sym_isize] = ACTIONS(2228),
    [anon_sym_usize] = ACTIONS(2228),
    [anon_sym_f32] = ACTIONS(2228),
    [anon_sym_f64] = ACTIONS(2228),
    [anon_sym_bool] = ACTIONS(2228),
    [anon_sym_str] = ACTIONS(2228),
    [anon_sym_char] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_POUND] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2228),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_fn] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_impl] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_loop] = ACTIONS(2228),
    [anon_sym_match] = ACTIONS(2228),
    [anon_sym_mod] = ACTIONS(2228),
    [anon_sym_pub] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_trait] = ACTIONS(2228),
    [anon_sym_type] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_unsafe] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2228),
    [anon_sym_move] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [sym_integer_literal] = ACTIONS(2226),
    [aux_sym_string_literal_token1] = ACTIONS(2226),
    [sym_char_literal] = ACTIONS(2226),
    [anon_sym_true] = ACTIONS(2228),
    [anon_sym_false] = ACTIONS(2228),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2228),
    [sym_super] = ACTIONS(2228),
    [sym_crate] = ACTIONS(2228),
    [sym_metavariable] = ACTIONS(2226),
    [sym__raw_string_literal_start] = ACTIONS(2226),
    [sym_float_literal] = ACTIONS(2226),
  },
  [595] = {
    [sym_line_comment] = STATE(595),
    [sym_block_comment] = STATE(595),
    [ts_builtin_sym_end] = ACTIONS(2230),
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym_macro_rules_BANG] = ACTIONS(2230),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_u8] = ACTIONS(2232),
    [anon_sym_i8] = ACTIONS(2232),
    [anon_sym_u16] = ACTIONS(2232),
    [anon_sym_i16] = ACTIONS(2232),
    [anon_sym_u32] = ACTIONS(2232),
    [anon_sym_i32] = ACTIONS(2232),
    [anon_sym_u64] = ACTIONS(2232),
    [anon_sym_i64] = ACTIONS(2232),
    [anon_sym_u128] = ACTIONS(2232),
    [anon_sym_i128] = ACTIONS(2232),
    [anon_sym_isize] = ACTIONS(2232),
    [anon_sym_usize] = ACTIONS(2232),
    [anon_sym_f32] = ACTIONS(2232),
    [anon_sym_f64] = ACTIONS(2232),
    [anon_sym_bool] = ACTIONS(2232),
    [anon_sym_str] = ACTIONS(2232),
    [anon_sym_char] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2230),
    [anon_sym_LT] = ACTIONS(2230),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_POUND] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym_async] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_fn] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_impl] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_loop] = ACTIONS(2232),
    [anon_sym_match] = ACTIONS(2232),
    [anon_sym_mod] = ACTIONS(2232),
    [anon_sym_pub] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_trait] = ACTIONS(2232),
    [anon_sym_type] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_unsafe] = ACTIONS(2232),
    [anon_sym_use] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym_yield] = ACTIONS(2232),
    [anon_sym_move] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [sym_integer_literal] = ACTIONS(2230),
    [aux_sym_string_literal_token1] = ACTIONS(2230),
    [sym_char_literal] = ACTIONS(2230),
    [anon_sym_true] = ACTIONS(2232),
    [anon_sym_false] = ACTIONS(2232),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2232),
    [sym_super] = ACTIONS(2232),
    [sym_crate] = ACTIONS(2232),
    [sym_metavariable] = ACTIONS(2230),
    [sym__raw_string_literal_start] = ACTIONS(2230),
    [sym_float_literal] = ACTIONS(2230),
  },
  [596] = {
    [sym_line_comment] = STATE(596),
    [sym_block_comment] = STATE(596),
    [ts_builtin_sym_end] = ACTIONS(2234),
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_macro_rules_BANG] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_u8] = ACTIONS(2236),
    [anon_sym_i8] = ACTIONS(2236),
    [anon_sym_u16] = ACTIONS(2236),
    [anon_sym_i16] = ACTIONS(2236),
    [anon_sym_u32] = ACTIONS(2236),
    [anon_sym_i32] = ACTIONS(2236),
    [anon_sym_u64] = ACTIONS(2236),
    [anon_sym_i64] = ACTIONS(2236),
    [anon_sym_u128] = ACTIONS(2236),
    [anon_sym_i128] = ACTIONS(2236),
    [anon_sym_isize] = ACTIONS(2236),
    [anon_sym_usize] = ACTIONS(2236),
    [anon_sym_f32] = ACTIONS(2236),
    [anon_sym_f64] = ACTIONS(2236),
    [anon_sym_bool] = ACTIONS(2236),
    [anon_sym_str] = ACTIONS(2236),
    [anon_sym_char] = ACTIONS(2236),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_DOT_DOT] = ACTIONS(2234),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_POUND] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_fn] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_impl] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_loop] = ACTIONS(2236),
    [anon_sym_match] = ACTIONS(2236),
    [anon_sym_mod] = ACTIONS(2236),
    [anon_sym_pub] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_trait] = ACTIONS(2236),
    [anon_sym_type] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_unsafe] = ACTIONS(2236),
    [anon_sym_use] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym_yield] = ACTIONS(2236),
    [anon_sym_move] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [sym_integer_literal] = ACTIONS(2234),
    [aux_sym_string_literal_token1] = ACTIONS(2234),
    [sym_char_literal] = ACTIONS(2234),
    [anon_sym_true] = ACTIONS(2236),
    [anon_sym_false] = ACTIONS(2236),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2236),
    [sym_super] = ACTIONS(2236),
    [sym_crate] = ACTIONS(2236),
    [sym_metavariable] = ACTIONS(2234),
    [sym__raw_string_literal_start] = ACTIONS(2234),
    [sym_float_literal] = ACTIONS(2234),
  },
  [597] = {
    [sym_line_comment] = STATE(597),
    [sym_block_comment] = STATE(597),
    [ts_builtin_sym_end] = ACTIONS(2238),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_macro_rules_BANG] = ACTIONS(2238),
    [anon_sym_LPAREN] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_u8] = ACTIONS(2240),
    [anon_sym_i8] = ACTIONS(2240),
    [anon_sym_u16] = ACTIONS(2240),
    [anon_sym_i16] = ACTIONS(2240),
    [anon_sym_u32] = ACTIONS(2240),
    [anon_sym_i32] = ACTIONS(2240),
    [anon_sym_u64] = ACTIONS(2240),
    [anon_sym_i64] = ACTIONS(2240),
    [anon_sym_u128] = ACTIONS(2240),
    [anon_sym_i128] = ACTIONS(2240),
    [anon_sym_isize] = ACTIONS(2240),
    [anon_sym_usize] = ACTIONS(2240),
    [anon_sym_f32] = ACTIONS(2240),
    [anon_sym_f64] = ACTIONS(2240),
    [anon_sym_bool] = ACTIONS(2240),
    [anon_sym_str] = ACTIONS(2240),
    [anon_sym_char] = ACTIONS(2240),
    [anon_sym_DASH] = ACTIONS(2238),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_DOT_DOT] = ACTIONS(2238),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_POUND] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2240),
    [anon_sym_async] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_fn] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_impl] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_loop] = ACTIONS(2240),
    [anon_sym_match] = ACTIONS(2240),
    [anon_sym_mod] = ACTIONS(2240),
    [anon_sym_pub] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_trait] = ACTIONS(2240),
    [anon_sym_type] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_unsafe] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2240),
    [anon_sym_move] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [sym_integer_literal] = ACTIONS(2238),
    [aux_sym_string_literal_token1] = ACTIONS(2238),
    [sym_char_literal] = ACTIONS(2238),
    [anon_sym_true] = ACTIONS(2240),
    [anon_sym_false] = ACTIONS(2240),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2240),
    [sym_super] = ACTIONS(2240),
    [sym_crate] = ACTIONS(2240),
    [sym_metavariable] = ACTIONS(2238),
    [sym__raw_string_literal_start] = ACTIONS(2238),
    [sym_float_literal] = ACTIONS(2238),
  },
  [598] = {
    [sym_line_comment] = STATE(598),
    [sym_block_comment] = STATE(598),
    [ts_builtin_sym_end] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_macro_rules_BANG] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_u8] = ACTIONS(2244),
    [anon_sym_i8] = ACTIONS(2244),
    [anon_sym_u16] = ACTIONS(2244),
    [anon_sym_i16] = ACTIONS(2244),
    [anon_sym_u32] = ACTIONS(2244),
    [anon_sym_i32] = ACTIONS(2244),
    [anon_sym_u64] = ACTIONS(2244),
    [anon_sym_i64] = ACTIONS(2244),
    [anon_sym_u128] = ACTIONS(2244),
    [anon_sym_i128] = ACTIONS(2244),
    [anon_sym_isize] = ACTIONS(2244),
    [anon_sym_usize] = ACTIONS(2244),
    [anon_sym_f32] = ACTIONS(2244),
    [anon_sym_f64] = ACTIONS(2244),
    [anon_sym_bool] = ACTIONS(2244),
    [anon_sym_str] = ACTIONS(2244),
    [anon_sym_char] = ACTIONS(2244),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2242),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_DOT_DOT] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_POUND] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2244),
    [anon_sym_async] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_fn] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_impl] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_loop] = ACTIONS(2244),
    [anon_sym_match] = ACTIONS(2244),
    [anon_sym_mod] = ACTIONS(2244),
    [anon_sym_pub] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_trait] = ACTIONS(2244),
    [anon_sym_type] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_unsafe] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2244),
    [anon_sym_move] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [sym_integer_literal] = ACTIONS(2242),
    [aux_sym_string_literal_token1] = ACTIONS(2242),
    [sym_char_literal] = ACTIONS(2242),
    [anon_sym_true] = ACTIONS(2244),
    [anon_sym_false] = ACTIONS(2244),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2244),
    [sym_super] = ACTIONS(2244),
    [sym_crate] = ACTIONS(2244),
    [sym_metavariable] = ACTIONS(2242),
    [sym__raw_string_literal_start] = ACTIONS(2242),
    [sym_float_literal] = ACTIONS(2242),
  },
  [599] = {
    [sym_line_comment] = STATE(599),
    [sym_block_comment] = STATE(599),
    [ts_builtin_sym_end] = ACTIONS(2246),
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym_macro_rules_BANG] = ACTIONS(2246),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_u8] = ACTIONS(2248),
    [anon_sym_i8] = ACTIONS(2248),
    [anon_sym_u16] = ACTIONS(2248),
    [anon_sym_i16] = ACTIONS(2248),
    [anon_sym_u32] = ACTIONS(2248),
    [anon_sym_i32] = ACTIONS(2248),
    [anon_sym_u64] = ACTIONS(2248),
    [anon_sym_i64] = ACTIONS(2248),
    [anon_sym_u128] = ACTIONS(2248),
    [anon_sym_i128] = ACTIONS(2248),
    [anon_sym_isize] = ACTIONS(2248),
    [anon_sym_usize] = ACTIONS(2248),
    [anon_sym_f32] = ACTIONS(2248),
    [anon_sym_f64] = ACTIONS(2248),
    [anon_sym_bool] = ACTIONS(2248),
    [anon_sym_str] = ACTIONS(2248),
    [anon_sym_char] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(2246),
    [anon_sym_DOT_DOT] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_POUND] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2248),
    [anon_sym_async] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_fn] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_impl] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_loop] = ACTIONS(2248),
    [anon_sym_match] = ACTIONS(2248),
    [anon_sym_mod] = ACTIONS(2248),
    [anon_sym_pub] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_trait] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_unsafe] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2248),
    [anon_sym_move] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [sym_integer_literal] = ACTIONS(2246),
    [aux_sym_string_literal_token1] = ACTIONS(2246),
    [sym_char_literal] = ACTIONS(2246),
    [anon_sym_true] = ACTIONS(2248),
    [anon_sym_false] = ACTIONS(2248),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2248),
    [sym_super] = ACTIONS(2248),
    [sym_crate] = ACTIONS(2248),
    [sym_metavariable] = ACTIONS(2246),
    [sym__raw_string_literal_start] = ACTIONS(2246),
    [sym_float_literal] = ACTIONS(2246),
  },
  [600] = {
    [sym_line_comment] = STATE(600),
    [sym_block_comment] = STATE(600),
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_macro_rules_BANG] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_u8] = ACTIONS(2252),
    [anon_sym_i8] = ACTIONS(2252),
    [anon_sym_u16] = ACTIONS(2252),
    [anon_sym_i16] = ACTIONS(2252),
    [anon_sym_u32] = ACTIONS(2252),
    [anon_sym_i32] = ACTIONS(2252),
    [anon_sym_u64] = ACTIONS(2252),
    [anon_sym_i64] = ACTIONS(2252),
    [anon_sym_u128] = ACTIONS(2252),
    [anon_sym_i128] = ACTIONS(2252),
    [anon_sym_isize] = ACTIONS(2252),
    [anon_sym_usize] = ACTIONS(2252),
    [anon_sym_f32] = ACTIONS(2252),
    [anon_sym_f64] = ACTIONS(2252),
    [anon_sym_bool] = ACTIONS(2252),
    [anon_sym_str] = ACTIONS(2252),
    [anon_sym_char] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_POUND] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_async] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_fn] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_impl] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_loop] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_mod] = ACTIONS(2252),
    [anon_sym_pub] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_trait] = ACTIONS(2252),
    [anon_sym_type] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_unsafe] = ACTIONS(2252),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_move] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [sym_integer_literal] = ACTIONS(2250),
    [aux_sym_string_literal_token1] = ACTIONS(2250),
    [sym_char_literal] = ACTIONS(2250),
    [anon_sym_true] = ACTIONS(2252),
    [anon_sym_false] = ACTIONS(2252),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2252),
    [sym_super] = ACTIONS(2252),
    [sym_crate] = ACTIONS(2252),
    [sym_metavariable] = ACTIONS(2250),
    [sym__raw_string_literal_start] = ACTIONS(2250),
    [sym_float_literal] = ACTIONS(2250),
  },
  [601] = {
    [sym_line_comment] = STATE(601),
    [sym_block_comment] = STATE(601),
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_macro_rules_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_u8] = ACTIONS(2256),
    [anon_sym_i8] = ACTIONS(2256),
    [anon_sym_u16] = ACTIONS(2256),
    [anon_sym_i16] = ACTIONS(2256),
    [anon_sym_u32] = ACTIONS(2256),
    [anon_sym_i32] = ACTIONS(2256),
    [anon_sym_u64] = ACTIONS(2256),
    [anon_sym_i64] = ACTIONS(2256),
    [anon_sym_u128] = ACTIONS(2256),
    [anon_sym_i128] = ACTIONS(2256),
    [anon_sym_isize] = ACTIONS(2256),
    [anon_sym_usize] = ACTIONS(2256),
    [anon_sym_f32] = ACTIONS(2256),
    [anon_sym_f64] = ACTIONS(2256),
    [anon_sym_bool] = ACTIONS(2256),
    [anon_sym_str] = ACTIONS(2256),
    [anon_sym_char] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_DOT_DOT] = ACTIONS(2254),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_POUND] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2256),
    [anon_sym_async] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_fn] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_impl] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_loop] = ACTIONS(2256),
    [anon_sym_match] = ACTIONS(2256),
    [anon_sym_mod] = ACTIONS(2256),
    [anon_sym_pub] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_trait] = ACTIONS(2256),
    [anon_sym_type] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_unsafe] = ACTIONS(2256),
    [anon_sym_use] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym_yield] = ACTIONS(2256),
    [anon_sym_move] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [sym_integer_literal] = ACTIONS(2254),
    [aux_sym_string_literal_token1] = ACTIONS(2254),
    [sym_char_literal] = ACTIONS(2254),
    [anon_sym_true] = ACTIONS(2256),
    [anon_sym_false] = ACTIONS(2256),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2256),
    [sym_super] = ACTIONS(2256),
    [sym_crate] = ACTIONS(2256),
    [sym_metavariable] = ACTIONS(2254),
    [sym__raw_string_literal_start] = ACTIONS(2254),
    [sym_float_literal] = ACTIONS(2254),
  },
  [602] = {
    [sym_line_comment] = STATE(602),
    [sym_block_comment] = STATE(602),
    [ts_builtin_sym_end] = ACTIONS(2258),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_macro_rules_BANG] = ACTIONS(2258),
    [anon_sym_LPAREN] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_u8] = ACTIONS(2260),
    [anon_sym_i8] = ACTIONS(2260),
    [anon_sym_u16] = ACTIONS(2260),
    [anon_sym_i16] = ACTIONS(2260),
    [anon_sym_u32] = ACTIONS(2260),
    [anon_sym_i32] = ACTIONS(2260),
    [anon_sym_u64] = ACTIONS(2260),
    [anon_sym_i64] = ACTIONS(2260),
    [anon_sym_u128] = ACTIONS(2260),
    [anon_sym_i128] = ACTIONS(2260),
    [anon_sym_isize] = ACTIONS(2260),
    [anon_sym_usize] = ACTIONS(2260),
    [anon_sym_f32] = ACTIONS(2260),
    [anon_sym_f64] = ACTIONS(2260),
    [anon_sym_bool] = ACTIONS(2260),
    [anon_sym_str] = ACTIONS(2260),
    [anon_sym_char] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_DOT_DOT] = ACTIONS(2258),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_fn] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_impl] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_loop] = ACTIONS(2260),
    [anon_sym_match] = ACTIONS(2260),
    [anon_sym_mod] = ACTIONS(2260),
    [anon_sym_pub] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_trait] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_unsafe] = ACTIONS(2260),
    [anon_sym_use] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_move] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [sym_integer_literal] = ACTIONS(2258),
    [aux_sym_string_literal_token1] = ACTIONS(2258),
    [sym_char_literal] = ACTIONS(2258),
    [anon_sym_true] = ACTIONS(2260),
    [anon_sym_false] = ACTIONS(2260),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_crate] = ACTIONS(2260),
    [sym_metavariable] = ACTIONS(2258),
    [sym__raw_string_literal_start] = ACTIONS(2258),
    [sym_float_literal] = ACTIONS(2258),
  },
  [603] = {
    [sym_line_comment] = STATE(603),
    [sym_block_comment] = STATE(603),
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_macro_rules_BANG] = ACTIONS(2262),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_u8] = ACTIONS(2264),
    [anon_sym_i8] = ACTIONS(2264),
    [anon_sym_u16] = ACTIONS(2264),
    [anon_sym_i16] = ACTIONS(2264),
    [anon_sym_u32] = ACTIONS(2264),
    [anon_sym_i32] = ACTIONS(2264),
    [anon_sym_u64] = ACTIONS(2264),
    [anon_sym_i64] = ACTIONS(2264),
    [anon_sym_u128] = ACTIONS(2264),
    [anon_sym_i128] = ACTIONS(2264),
    [anon_sym_isize] = ACTIONS(2264),
    [anon_sym_usize] = ACTIONS(2264),
    [anon_sym_f32] = ACTIONS(2264),
    [anon_sym_f64] = ACTIONS(2264),
    [anon_sym_bool] = ACTIONS(2264),
    [anon_sym_str] = ACTIONS(2264),
    [anon_sym_char] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_POUND] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_fn] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_impl] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_loop] = ACTIONS(2264),
    [anon_sym_match] = ACTIONS(2264),
    [anon_sym_mod] = ACTIONS(2264),
    [anon_sym_pub] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_trait] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_unsafe] = ACTIONS(2264),
    [anon_sym_use] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_move] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [sym_integer_literal] = ACTIONS(2262),
    [aux_sym_string_literal_token1] = ACTIONS(2262),
    [sym_char_literal] = ACTIONS(2262),
    [anon_sym_true] = ACTIONS(2264),
    [anon_sym_false] = ACTIONS(2264),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_crate] = ACTIONS(2264),
    [sym_metavariable] = ACTIONS(2262),
    [sym__raw_string_literal_start] = ACTIONS(2262),
    [sym_float_literal] = ACTIONS(2262),
  },
  [604] = {
    [sym_line_comment] = STATE(604),
    [sym_block_comment] = STATE(604),
    [ts_builtin_sym_end] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym_macro_rules_BANG] = ACTIONS(2266),
    [anon_sym_LPAREN] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_u8] = ACTIONS(2268),
    [anon_sym_i8] = ACTIONS(2268),
    [anon_sym_u16] = ACTIONS(2268),
    [anon_sym_i16] = ACTIONS(2268),
    [anon_sym_u32] = ACTIONS(2268),
    [anon_sym_i32] = ACTIONS(2268),
    [anon_sym_u64] = ACTIONS(2268),
    [anon_sym_i64] = ACTIONS(2268),
    [anon_sym_u128] = ACTIONS(2268),
    [anon_sym_i128] = ACTIONS(2268),
    [anon_sym_isize] = ACTIONS(2268),
    [anon_sym_usize] = ACTIONS(2268),
    [anon_sym_f32] = ACTIONS(2268),
    [anon_sym_f64] = ACTIONS(2268),
    [anon_sym_bool] = ACTIONS(2268),
    [anon_sym_str] = ACTIONS(2268),
    [anon_sym_char] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2266),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_POUND] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2268),
    [anon_sym_async] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_fn] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_impl] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_loop] = ACTIONS(2268),
    [anon_sym_match] = ACTIONS(2268),
    [anon_sym_mod] = ACTIONS(2268),
    [anon_sym_pub] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_trait] = ACTIONS(2268),
    [anon_sym_type] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_unsafe] = ACTIONS(2268),
    [anon_sym_use] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym_yield] = ACTIONS(2268),
    [anon_sym_move] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [sym_integer_literal] = ACTIONS(2266),
    [aux_sym_string_literal_token1] = ACTIONS(2266),
    [sym_char_literal] = ACTIONS(2266),
    [anon_sym_true] = ACTIONS(2268),
    [anon_sym_false] = ACTIONS(2268),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2268),
    [sym_super] = ACTIONS(2268),
    [sym_crate] = ACTIONS(2268),
    [sym_metavariable] = ACTIONS(2266),
    [sym__raw_string_literal_start] = ACTIONS(2266),
    [sym_float_literal] = ACTIONS(2266),
  },
  [605] = {
    [sym_line_comment] = STATE(605),
    [sym_block_comment] = STATE(605),
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_macro_rules_BANG] = ACTIONS(2270),
    [anon_sym_LPAREN] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_u8] = ACTIONS(2272),
    [anon_sym_i8] = ACTIONS(2272),
    [anon_sym_u16] = ACTIONS(2272),
    [anon_sym_i16] = ACTIONS(2272),
    [anon_sym_u32] = ACTIONS(2272),
    [anon_sym_i32] = ACTIONS(2272),
    [anon_sym_u64] = ACTIONS(2272),
    [anon_sym_i64] = ACTIONS(2272),
    [anon_sym_u128] = ACTIONS(2272),
    [anon_sym_i128] = ACTIONS(2272),
    [anon_sym_isize] = ACTIONS(2272),
    [anon_sym_usize] = ACTIONS(2272),
    [anon_sym_f32] = ACTIONS(2272),
    [anon_sym_f64] = ACTIONS(2272),
    [anon_sym_bool] = ACTIONS(2272),
    [anon_sym_str] = ACTIONS(2272),
    [anon_sym_char] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_POUND] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_fn] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_impl] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_loop] = ACTIONS(2272),
    [anon_sym_match] = ACTIONS(2272),
    [anon_sym_mod] = ACTIONS(2272),
    [anon_sym_pub] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_trait] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_unsafe] = ACTIONS(2272),
    [anon_sym_use] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_move] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [sym_integer_literal] = ACTIONS(2270),
    [aux_sym_string_literal_token1] = ACTIONS(2270),
    [sym_char_literal] = ACTIONS(2270),
    [anon_sym_true] = ACTIONS(2272),
    [anon_sym_false] = ACTIONS(2272),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_crate] = ACTIONS(2272),
    [sym_metavariable] = ACTIONS(2270),
    [sym__raw_string_literal_start] = ACTIONS(2270),
    [sym_float_literal] = ACTIONS(2270),
  },
  [606] = {
    [sym_line_comment] = STATE(606),
    [sym_block_comment] = STATE(606),
    [ts_builtin_sym_end] = ACTIONS(2274),
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym_macro_rules_BANG] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_u8] = ACTIONS(2276),
    [anon_sym_i8] = ACTIONS(2276),
    [anon_sym_u16] = ACTIONS(2276),
    [anon_sym_i16] = ACTIONS(2276),
    [anon_sym_u32] = ACTIONS(2276),
    [anon_sym_i32] = ACTIONS(2276),
    [anon_sym_u64] = ACTIONS(2276),
    [anon_sym_i64] = ACTIONS(2276),
    [anon_sym_u128] = ACTIONS(2276),
    [anon_sym_i128] = ACTIONS(2276),
    [anon_sym_isize] = ACTIONS(2276),
    [anon_sym_usize] = ACTIONS(2276),
    [anon_sym_f32] = ACTIONS(2276),
    [anon_sym_f64] = ACTIONS(2276),
    [anon_sym_bool] = ACTIONS(2276),
    [anon_sym_str] = ACTIONS(2276),
    [anon_sym_char] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2274),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_LT] = ACTIONS(2274),
    [anon_sym_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_POUND] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2276),
    [anon_sym_async] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_fn] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_impl] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_loop] = ACTIONS(2276),
    [anon_sym_match] = ACTIONS(2276),
    [anon_sym_mod] = ACTIONS(2276),
    [anon_sym_pub] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_trait] = ACTIONS(2276),
    [anon_sym_type] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_unsafe] = ACTIONS(2276),
    [anon_sym_use] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym_yield] = ACTIONS(2276),
    [anon_sym_move] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [sym_integer_literal] = ACTIONS(2274),
    [aux_sym_string_literal_token1] = ACTIONS(2274),
    [sym_char_literal] = ACTIONS(2274),
    [anon_sym_true] = ACTIONS(2276),
    [anon_sym_false] = ACTIONS(2276),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2276),
    [sym_super] = ACTIONS(2276),
    [sym_crate] = ACTIONS(2276),
    [sym_metavariable] = ACTIONS(2274),
    [sym__raw_string_literal_start] = ACTIONS(2274),
    [sym_float_literal] = ACTIONS(2274),
  },
  [607] = {
    [sym_line_comment] = STATE(607),
    [sym_block_comment] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_macro_rules_BANG] = ACTIONS(2278),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_u8] = ACTIONS(2280),
    [anon_sym_i8] = ACTIONS(2280),
    [anon_sym_u16] = ACTIONS(2280),
    [anon_sym_i16] = ACTIONS(2280),
    [anon_sym_u32] = ACTIONS(2280),
    [anon_sym_i32] = ACTIONS(2280),
    [anon_sym_u64] = ACTIONS(2280),
    [anon_sym_i64] = ACTIONS(2280),
    [anon_sym_u128] = ACTIONS(2280),
    [anon_sym_i128] = ACTIONS(2280),
    [anon_sym_isize] = ACTIONS(2280),
    [anon_sym_usize] = ACTIONS(2280),
    [anon_sym_f32] = ACTIONS(2280),
    [anon_sym_f64] = ACTIONS(2280),
    [anon_sym_bool] = ACTIONS(2280),
    [anon_sym_str] = ACTIONS(2280),
    [anon_sym_char] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_POUND] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_fn] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_impl] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_loop] = ACTIONS(2280),
    [anon_sym_match] = ACTIONS(2280),
    [anon_sym_mod] = ACTIONS(2280),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_trait] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(2280),
    [anon_sym_use] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_move] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [sym_integer_literal] = ACTIONS(2278),
    [aux_sym_string_literal_token1] = ACTIONS(2278),
    [sym_char_literal] = ACTIONS(2278),
    [anon_sym_true] = ACTIONS(2280),
    [anon_sym_false] = ACTIONS(2280),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_crate] = ACTIONS(2280),
    [sym_metavariable] = ACTIONS(2278),
    [sym__raw_string_literal_start] = ACTIONS(2278),
    [sym_float_literal] = ACTIONS(2278),
  },
  [608] = {
    [sym_line_comment] = STATE(608),
    [sym_block_comment] = STATE(608),
    [ts_builtin_sym_end] = ACTIONS(2282),
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym_macro_rules_BANG] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_u8] = ACTIONS(2284),
    [anon_sym_i8] = ACTIONS(2284),
    [anon_sym_u16] = ACTIONS(2284),
    [anon_sym_i16] = ACTIONS(2284),
    [anon_sym_u32] = ACTIONS(2284),
    [anon_sym_i32] = ACTIONS(2284),
    [anon_sym_u64] = ACTIONS(2284),
    [anon_sym_i64] = ACTIONS(2284),
    [anon_sym_u128] = ACTIONS(2284),
    [anon_sym_i128] = ACTIONS(2284),
    [anon_sym_isize] = ACTIONS(2284),
    [anon_sym_usize] = ACTIONS(2284),
    [anon_sym_f32] = ACTIONS(2284),
    [anon_sym_f64] = ACTIONS(2284),
    [anon_sym_bool] = ACTIONS(2284),
    [anon_sym_str] = ACTIONS(2284),
    [anon_sym_char] = ACTIONS(2284),
    [anon_sym_DASH] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2282),
    [anon_sym_LT] = ACTIONS(2282),
    [anon_sym_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2284),
    [anon_sym_async] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_fn] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_impl] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_loop] = ACTIONS(2284),
    [anon_sym_match] = ACTIONS(2284),
    [anon_sym_mod] = ACTIONS(2284),
    [anon_sym_pub] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_trait] = ACTIONS(2284),
    [anon_sym_type] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_unsafe] = ACTIONS(2284),
    [anon_sym_use] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym_yield] = ACTIONS(2284),
    [anon_sym_move] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [sym_integer_literal] = ACTIONS(2282),
    [aux_sym_string_literal_token1] = ACTIONS(2282),
    [sym_char_literal] = ACTIONS(2282),
    [anon_sym_true] = ACTIONS(2284),
    [anon_sym_false] = ACTIONS(2284),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2284),
    [sym_super] = ACTIONS(2284),
    [sym_crate] = ACTIONS(2284),
    [sym_metavariable] = ACTIONS(2282),
    [sym__raw_string_literal_start] = ACTIONS(2282),
    [sym_float_literal] = ACTIONS(2282),
  },
  [609] = {
    [sym_line_comment] = STATE(609),
    [sym_block_comment] = STATE(609),
    [ts_builtin_sym_end] = ACTIONS(1422),
    [sym_identifier] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1422),
    [anon_sym_macro_rules_BANG] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1422),
    [anon_sym_RBRACE] = ACTIONS(1422),
    [anon_sym_STAR] = ACTIONS(1422),
    [anon_sym_u8] = ACTIONS(1424),
    [anon_sym_i8] = ACTIONS(1424),
    [anon_sym_u16] = ACTIONS(1424),
    [anon_sym_i16] = ACTIONS(1424),
    [anon_sym_u32] = ACTIONS(1424),
    [anon_sym_i32] = ACTIONS(1424),
    [anon_sym_u64] = ACTIONS(1424),
    [anon_sym_i64] = ACTIONS(1424),
    [anon_sym_u128] = ACTIONS(1424),
    [anon_sym_i128] = ACTIONS(1424),
    [anon_sym_isize] = ACTIONS(1424),
    [anon_sym_usize] = ACTIONS(1424),
    [anon_sym_f32] = ACTIONS(1424),
    [anon_sym_f64] = ACTIONS(1424),
    [anon_sym_bool] = ACTIONS(1424),
    [anon_sym_str] = ACTIONS(1424),
    [anon_sym_char] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_BANG] = ACTIONS(1422),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(1422),
    [anon_sym_DOT_DOT] = ACTIONS(1422),
    [anon_sym_COLON_COLON] = ACTIONS(1422),
    [anon_sym_POUND] = ACTIONS(1422),
    [anon_sym_SQUOTE] = ACTIONS(1424),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_break] = ACTIONS(1424),
    [anon_sym_const] = ACTIONS(1424),
    [anon_sym_continue] = ACTIONS(1424),
    [anon_sym_default] = ACTIONS(1424),
    [anon_sym_enum] = ACTIONS(1424),
    [anon_sym_fn] = ACTIONS(1424),
    [anon_sym_for] = ACTIONS(1424),
    [anon_sym_if] = ACTIONS(1424),
    [anon_sym_impl] = ACTIONS(1424),
    [anon_sym_let] = ACTIONS(1424),
    [anon_sym_loop] = ACTIONS(1424),
    [anon_sym_match] = ACTIONS(1424),
    [anon_sym_mod] = ACTIONS(1424),
    [anon_sym_pub] = ACTIONS(1424),
    [anon_sym_return] = ACTIONS(1424),
    [anon_sym_static] = ACTIONS(1424),
    [anon_sym_struct] = ACTIONS(1424),
    [anon_sym_trait] = ACTIONS(1424),
    [anon_sym_type] = ACTIONS(1424),
    [anon_sym_union] = ACTIONS(1424),
    [anon_sym_unsafe] = ACTIONS(1424),
    [anon_sym_use] = ACTIONS(1424),
    [anon_sym_while] = ACTIONS(1424),
    [anon_sym_extern] = ACTIONS(1424),
    [anon_sym_yield] = ACTIONS(1424),
    [anon_sym_move] = ACTIONS(1424),
    [anon_sym_try] = ACTIONS(1424),
    [sym_integer_literal] = ACTIONS(1422),
    [aux_sym_string_literal_token1] = ACTIONS(1422),
    [sym_char_literal] = ACTIONS(1422),
    [anon_sym_true] = ACTIONS(1424),
    [anon_sym_false] = ACTIONS(1424),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1424),
    [sym_super] = ACTIONS(1424),
    [sym_crate] = ACTIONS(1424),
    [sym_metavariable] = ACTIONS(1422),
    [sym__raw_string_literal_start] = ACTIONS(1422),
    [sym_float_literal] = ACTIONS(1422),
  },
  [610] = {
    [sym_line_comment] = STATE(610),
    [sym_block_comment] = STATE(610),
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_macro_rules_BANG] = ACTIONS(2286),
    [anon_sym_LPAREN] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_u8] = ACTIONS(2288),
    [anon_sym_i8] = ACTIONS(2288),
    [anon_sym_u16] = ACTIONS(2288),
    [anon_sym_i16] = ACTIONS(2288),
    [anon_sym_u32] = ACTIONS(2288),
    [anon_sym_i32] = ACTIONS(2288),
    [anon_sym_u64] = ACTIONS(2288),
    [anon_sym_i64] = ACTIONS(2288),
    [anon_sym_u128] = ACTIONS(2288),
    [anon_sym_i128] = ACTIONS(2288),
    [anon_sym_isize] = ACTIONS(2288),
    [anon_sym_usize] = ACTIONS(2288),
    [anon_sym_f32] = ACTIONS(2288),
    [anon_sym_f64] = ACTIONS(2288),
    [anon_sym_bool] = ACTIONS(2288),
    [anon_sym_str] = ACTIONS(2288),
    [anon_sym_char] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2286),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_POUND] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_fn] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_impl] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_loop] = ACTIONS(2288),
    [anon_sym_match] = ACTIONS(2288),
    [anon_sym_mod] = ACTIONS(2288),
    [anon_sym_pub] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_trait] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_unsafe] = ACTIONS(2288),
    [anon_sym_use] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_move] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [sym_integer_literal] = ACTIONS(2286),
    [aux_sym_string_literal_token1] = ACTIONS(2286),
    [sym_char_literal] = ACTIONS(2286),
    [anon_sym_true] = ACTIONS(2288),
    [anon_sym_false] = ACTIONS(2288),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_crate] = ACTIONS(2288),
    [sym_metavariable] = ACTIONS(2286),
    [sym__raw_string_literal_start] = ACTIONS(2286),
    [sym_float_literal] = ACTIONS(2286),
  },
  [611] = {
    [sym_line_comment] = STATE(611),
    [sym_block_comment] = STATE(611),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_macro_rules_BANG] = ACTIONS(2290),
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_u8] = ACTIONS(2292),
    [anon_sym_i8] = ACTIONS(2292),
    [anon_sym_u16] = ACTIONS(2292),
    [anon_sym_i16] = ACTIONS(2292),
    [anon_sym_u32] = ACTIONS(2292),
    [anon_sym_i32] = ACTIONS(2292),
    [anon_sym_u64] = ACTIONS(2292),
    [anon_sym_i64] = ACTIONS(2292),
    [anon_sym_u128] = ACTIONS(2292),
    [anon_sym_i128] = ACTIONS(2292),
    [anon_sym_isize] = ACTIONS(2292),
    [anon_sym_usize] = ACTIONS(2292),
    [anon_sym_f32] = ACTIONS(2292),
    [anon_sym_f64] = ACTIONS(2292),
    [anon_sym_bool] = ACTIONS(2292),
    [anon_sym_str] = ACTIONS(2292),
    [anon_sym_char] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_POUND] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_fn] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_impl] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_loop] = ACTIONS(2292),
    [anon_sym_match] = ACTIONS(2292),
    [anon_sym_mod] = ACTIONS(2292),
    [anon_sym_pub] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_trait] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_unsafe] = ACTIONS(2292),
    [anon_sym_use] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_move] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [sym_integer_literal] = ACTIONS(2290),
    [aux_sym_string_literal_token1] = ACTIONS(2290),
    [sym_char_literal] = ACTIONS(2290),
    [anon_sym_true] = ACTIONS(2292),
    [anon_sym_false] = ACTIONS(2292),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_crate] = ACTIONS(2292),
    [sym_metavariable] = ACTIONS(2290),
    [sym__raw_string_literal_start] = ACTIONS(2290),
    [sym_float_literal] = ACTIONS(2290),
  },
  [612] = {
    [sym_line_comment] = STATE(612),
    [sym_block_comment] = STATE(612),
    [ts_builtin_sym_end] = ACTIONS(2294),
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_macro_rules_BANG] = ACTIONS(2294),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_u8] = ACTIONS(2296),
    [anon_sym_i8] = ACTIONS(2296),
    [anon_sym_u16] = ACTIONS(2296),
    [anon_sym_i16] = ACTIONS(2296),
    [anon_sym_u32] = ACTIONS(2296),
    [anon_sym_i32] = ACTIONS(2296),
    [anon_sym_u64] = ACTIONS(2296),
    [anon_sym_i64] = ACTIONS(2296),
    [anon_sym_u128] = ACTIONS(2296),
    [anon_sym_i128] = ACTIONS(2296),
    [anon_sym_isize] = ACTIONS(2296),
    [anon_sym_usize] = ACTIONS(2296),
    [anon_sym_f32] = ACTIONS(2296),
    [anon_sym_f64] = ACTIONS(2296),
    [anon_sym_bool] = ACTIONS(2296),
    [anon_sym_str] = ACTIONS(2296),
    [anon_sym_char] = ACTIONS(2296),
    [anon_sym_DASH] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2294),
    [anon_sym_LT] = ACTIONS(2294),
    [anon_sym_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_POUND] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2296),
    [anon_sym_async] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_fn] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_impl] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_loop] = ACTIONS(2296),
    [anon_sym_match] = ACTIONS(2296),
    [anon_sym_mod] = ACTIONS(2296),
    [anon_sym_pub] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_trait] = ACTIONS(2296),
    [anon_sym_type] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_unsafe] = ACTIONS(2296),
    [anon_sym_use] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym_yield] = ACTIONS(2296),
    [anon_sym_move] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [sym_integer_literal] = ACTIONS(2294),
    [aux_sym_string_literal_token1] = ACTIONS(2294),
    [sym_char_literal] = ACTIONS(2294),
    [anon_sym_true] = ACTIONS(2296),
    [anon_sym_false] = ACTIONS(2296),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2296),
    [sym_super] = ACTIONS(2296),
    [sym_crate] = ACTIONS(2296),
    [sym_metavariable] = ACTIONS(2294),
    [sym__raw_string_literal_start] = ACTIONS(2294),
    [sym_float_literal] = ACTIONS(2294),
  },
  [613] = {
    [sym_line_comment] = STATE(613),
    [sym_block_comment] = STATE(613),
    [ts_builtin_sym_end] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym_macro_rules_BANG] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_u8] = ACTIONS(2300),
    [anon_sym_i8] = ACTIONS(2300),
    [anon_sym_u16] = ACTIONS(2300),
    [anon_sym_i16] = ACTIONS(2300),
    [anon_sym_u32] = ACTIONS(2300),
    [anon_sym_i32] = ACTIONS(2300),
    [anon_sym_u64] = ACTIONS(2300),
    [anon_sym_i64] = ACTIONS(2300),
    [anon_sym_u128] = ACTIONS(2300),
    [anon_sym_i128] = ACTIONS(2300),
    [anon_sym_isize] = ACTIONS(2300),
    [anon_sym_usize] = ACTIONS(2300),
    [anon_sym_f32] = ACTIONS(2300),
    [anon_sym_f64] = ACTIONS(2300),
    [anon_sym_bool] = ACTIONS(2300),
    [anon_sym_str] = ACTIONS(2300),
    [anon_sym_char] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2298),
    [anon_sym_LT] = ACTIONS(2298),
    [anon_sym_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_POUND] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_fn] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_impl] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_loop] = ACTIONS(2300),
    [anon_sym_match] = ACTIONS(2300),
    [anon_sym_mod] = ACTIONS(2300),
    [anon_sym_pub] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_trait] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_unsafe] = ACTIONS(2300),
    [anon_sym_use] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_move] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [sym_integer_literal] = ACTIONS(2298),
    [aux_sym_string_literal_token1] = ACTIONS(2298),
    [sym_char_literal] = ACTIONS(2298),
    [anon_sym_true] = ACTIONS(2300),
    [anon_sym_false] = ACTIONS(2300),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_crate] = ACTIONS(2300),
    [sym_metavariable] = ACTIONS(2298),
    [sym__raw_string_literal_start] = ACTIONS(2298),
    [sym_float_literal] = ACTIONS(2298),
  },
  [614] = {
    [sym_line_comment] = STATE(614),
    [sym_block_comment] = STATE(614),
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym_macro_rules_BANG] = ACTIONS(2302),
    [anon_sym_LPAREN] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_u8] = ACTIONS(2304),
    [anon_sym_i8] = ACTIONS(2304),
    [anon_sym_u16] = ACTIONS(2304),
    [anon_sym_i16] = ACTIONS(2304),
    [anon_sym_u32] = ACTIONS(2304),
    [anon_sym_i32] = ACTIONS(2304),
    [anon_sym_u64] = ACTIONS(2304),
    [anon_sym_i64] = ACTIONS(2304),
    [anon_sym_u128] = ACTIONS(2304),
    [anon_sym_i128] = ACTIONS(2304),
    [anon_sym_isize] = ACTIONS(2304),
    [anon_sym_usize] = ACTIONS(2304),
    [anon_sym_f32] = ACTIONS(2304),
    [anon_sym_f64] = ACTIONS(2304),
    [anon_sym_bool] = ACTIONS(2304),
    [anon_sym_str] = ACTIONS(2304),
    [anon_sym_char] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2302),
    [anon_sym_LT] = ACTIONS(2302),
    [anon_sym_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_POUND] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_fn] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_impl] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_loop] = ACTIONS(2304),
    [anon_sym_match] = ACTIONS(2304),
    [anon_sym_mod] = ACTIONS(2304),
    [anon_sym_pub] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_trait] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_unsafe] = ACTIONS(2304),
    [anon_sym_use] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_move] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [sym_integer_literal] = ACTIONS(2302),
    [aux_sym_string_literal_token1] = ACTIONS(2302),
    [sym_char_literal] = ACTIONS(2302),
    [anon_sym_true] = ACTIONS(2304),
    [anon_sym_false] = ACTIONS(2304),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_crate] = ACTIONS(2304),
    [sym_metavariable] = ACTIONS(2302),
    [sym__raw_string_literal_start] = ACTIONS(2302),
    [sym_float_literal] = ACTIONS(2302),
  },
  [615] = {
    [sym_line_comment] = STATE(615),
    [sym_block_comment] = STATE(615),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym_macro_rules_BANG] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_u8] = ACTIONS(2308),
    [anon_sym_i8] = ACTIONS(2308),
    [anon_sym_u16] = ACTIONS(2308),
    [anon_sym_i16] = ACTIONS(2308),
    [anon_sym_u32] = ACTIONS(2308),
    [anon_sym_i32] = ACTIONS(2308),
    [anon_sym_u64] = ACTIONS(2308),
    [anon_sym_i64] = ACTIONS(2308),
    [anon_sym_u128] = ACTIONS(2308),
    [anon_sym_i128] = ACTIONS(2308),
    [anon_sym_isize] = ACTIONS(2308),
    [anon_sym_usize] = ACTIONS(2308),
    [anon_sym_f32] = ACTIONS(2308),
    [anon_sym_f64] = ACTIONS(2308),
    [anon_sym_bool] = ACTIONS(2308),
    [anon_sym_str] = ACTIONS(2308),
    [anon_sym_char] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2306),
    [anon_sym_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_POUND] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_fn] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_impl] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_loop] = ACTIONS(2308),
    [anon_sym_match] = ACTIONS(2308),
    [anon_sym_mod] = ACTIONS(2308),
    [anon_sym_pub] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_trait] = ACTIONS(2308),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_unsafe] = ACTIONS(2308),
    [anon_sym_use] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_move] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [sym_integer_literal] = ACTIONS(2306),
    [aux_sym_string_literal_token1] = ACTIONS(2306),
    [sym_char_literal] = ACTIONS(2306),
    [anon_sym_true] = ACTIONS(2308),
    [anon_sym_false] = ACTIONS(2308),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_crate] = ACTIONS(2308),
    [sym_metavariable] = ACTIONS(2306),
    [sym__raw_string_literal_start] = ACTIONS(2306),
    [sym_float_literal] = ACTIONS(2306),
  },
  [616] = {
    [sym_line_comment] = STATE(616),
    [sym_block_comment] = STATE(616),
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_macro_rules_BANG] = ACTIONS(2310),
    [anon_sym_LPAREN] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_u8] = ACTIONS(2312),
    [anon_sym_i8] = ACTIONS(2312),
    [anon_sym_u16] = ACTIONS(2312),
    [anon_sym_i16] = ACTIONS(2312),
    [anon_sym_u32] = ACTIONS(2312),
    [anon_sym_i32] = ACTIONS(2312),
    [anon_sym_u64] = ACTIONS(2312),
    [anon_sym_i64] = ACTIONS(2312),
    [anon_sym_u128] = ACTIONS(2312),
    [anon_sym_i128] = ACTIONS(2312),
    [anon_sym_isize] = ACTIONS(2312),
    [anon_sym_usize] = ACTIONS(2312),
    [anon_sym_f32] = ACTIONS(2312),
    [anon_sym_f64] = ACTIONS(2312),
    [anon_sym_bool] = ACTIONS(2312),
    [anon_sym_str] = ACTIONS(2312),
    [anon_sym_char] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2310),
    [anon_sym_LT] = ACTIONS(2310),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_POUND] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2312),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_fn] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_impl] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_loop] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_mod] = ACTIONS(2312),
    [anon_sym_pub] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_trait] = ACTIONS(2312),
    [anon_sym_type] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_unsafe] = ACTIONS(2312),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_move] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [sym_integer_literal] = ACTIONS(2310),
    [aux_sym_string_literal_token1] = ACTIONS(2310),
    [sym_char_literal] = ACTIONS(2310),
    [anon_sym_true] = ACTIONS(2312),
    [anon_sym_false] = ACTIONS(2312),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2312),
    [sym_super] = ACTIONS(2312),
    [sym_crate] = ACTIONS(2312),
    [sym_metavariable] = ACTIONS(2310),
    [sym__raw_string_literal_start] = ACTIONS(2310),
    [sym_float_literal] = ACTIONS(2310),
  },
  [617] = {
    [sym_line_comment] = STATE(617),
    [sym_block_comment] = STATE(617),
    [ts_builtin_sym_end] = ACTIONS(2314),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym_macro_rules_BANG] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_u8] = ACTIONS(2316),
    [anon_sym_i8] = ACTIONS(2316),
    [anon_sym_u16] = ACTIONS(2316),
    [anon_sym_i16] = ACTIONS(2316),
    [anon_sym_u32] = ACTIONS(2316),
    [anon_sym_i32] = ACTIONS(2316),
    [anon_sym_u64] = ACTIONS(2316),
    [anon_sym_i64] = ACTIONS(2316),
    [anon_sym_u128] = ACTIONS(2316),
    [anon_sym_i128] = ACTIONS(2316),
    [anon_sym_isize] = ACTIONS(2316),
    [anon_sym_usize] = ACTIONS(2316),
    [anon_sym_f32] = ACTIONS(2316),
    [anon_sym_f64] = ACTIONS(2316),
    [anon_sym_bool] = ACTIONS(2316),
    [anon_sym_str] = ACTIONS(2316),
    [anon_sym_char] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_POUND] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_async] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_enum] = ACTIONS(2316),
    [anon_sym_fn] = ACTIONS(2316),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(2316),
    [anon_sym_impl] = ACTIONS(2316),
    [anon_sym_let] = ACTIONS(2316),
    [anon_sym_loop] = ACTIONS(2316),
    [anon_sym_match] = ACTIONS(2316),
    [anon_sym_mod] = ACTIONS(2316),
    [anon_sym_pub] = ACTIONS(2316),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_struct] = ACTIONS(2316),
    [anon_sym_trait] = ACTIONS(2316),
    [anon_sym_type] = ACTIONS(2316),
    [anon_sym_union] = ACTIONS(2316),
    [anon_sym_unsafe] = ACTIONS(2316),
    [anon_sym_use] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_extern] = ACTIONS(2316),
    [anon_sym_yield] = ACTIONS(2316),
    [anon_sym_move] = ACTIONS(2316),
    [anon_sym_try] = ACTIONS(2316),
    [sym_integer_literal] = ACTIONS(2314),
    [aux_sym_string_literal_token1] = ACTIONS(2314),
    [sym_char_literal] = ACTIONS(2314),
    [anon_sym_true] = ACTIONS(2316),
    [anon_sym_false] = ACTIONS(2316),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2316),
    [sym_super] = ACTIONS(2316),
    [sym_crate] = ACTIONS(2316),
    [sym_metavariable] = ACTIONS(2314),
    [sym__raw_string_literal_start] = ACTIONS(2314),
    [sym_float_literal] = ACTIONS(2314),
  },
  [618] = {
    [sym_line_comment] = STATE(618),
    [sym_block_comment] = STATE(618),
    [ts_builtin_sym_end] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_macro_rules_BANG] = ACTIONS(2318),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2318),
    [anon_sym_u8] = ACTIONS(2320),
    [anon_sym_i8] = ACTIONS(2320),
    [anon_sym_u16] = ACTIONS(2320),
    [anon_sym_i16] = ACTIONS(2320),
    [anon_sym_u32] = ACTIONS(2320),
    [anon_sym_i32] = ACTIONS(2320),
    [anon_sym_u64] = ACTIONS(2320),
    [anon_sym_i64] = ACTIONS(2320),
    [anon_sym_u128] = ACTIONS(2320),
    [anon_sym_i128] = ACTIONS(2320),
    [anon_sym_isize] = ACTIONS(2320),
    [anon_sym_usize] = ACTIONS(2320),
    [anon_sym_f32] = ACTIONS(2320),
    [anon_sym_f64] = ACTIONS(2320),
    [anon_sym_bool] = ACTIONS(2320),
    [anon_sym_str] = ACTIONS(2320),
    [anon_sym_char] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2318),
    [anon_sym_PIPE] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2318),
    [anon_sym_DOT_DOT] = ACTIONS(2318),
    [anon_sym_COLON_COLON] = ACTIONS(2318),
    [anon_sym_POUND] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2320),
    [anon_sym_async] = ACTIONS(2320),
    [anon_sym_break] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2320),
    [anon_sym_continue] = ACTIONS(2320),
    [anon_sym_default] = ACTIONS(2320),
    [anon_sym_enum] = ACTIONS(2320),
    [anon_sym_fn] = ACTIONS(2320),
    [anon_sym_for] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(2320),
    [anon_sym_impl] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(2320),
    [anon_sym_loop] = ACTIONS(2320),
    [anon_sym_match] = ACTIONS(2320),
    [anon_sym_mod] = ACTIONS(2320),
    [anon_sym_pub] = ACTIONS(2320),
    [anon_sym_return] = ACTIONS(2320),
    [anon_sym_static] = ACTIONS(2320),
    [anon_sym_struct] = ACTIONS(2320),
    [anon_sym_trait] = ACTIONS(2320),
    [anon_sym_type] = ACTIONS(2320),
    [anon_sym_union] = ACTIONS(2320),
    [anon_sym_unsafe] = ACTIONS(2320),
    [anon_sym_use] = ACTIONS(2320),
    [anon_sym_while] = ACTIONS(2320),
    [anon_sym_extern] = ACTIONS(2320),
    [anon_sym_yield] = ACTIONS(2320),
    [anon_sym_move] = ACTIONS(2320),
    [anon_sym_try] = ACTIONS(2320),
    [sym_integer_literal] = ACTIONS(2318),
    [aux_sym_string_literal_token1] = ACTIONS(2318),
    [sym_char_literal] = ACTIONS(2318),
    [anon_sym_true] = ACTIONS(2320),
    [anon_sym_false] = ACTIONS(2320),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2320),
    [sym_super] = ACTIONS(2320),
    [sym_crate] = ACTIONS(2320),
    [sym_metavariable] = ACTIONS(2318),
    [sym__raw_string_literal_start] = ACTIONS(2318),
    [sym_float_literal] = ACTIONS(2318),
  },
  [619] = {
    [sym_line_comment] = STATE(619),
    [sym_block_comment] = STATE(619),
    [ts_builtin_sym_end] = ACTIONS(2322),
    [sym_identifier] = ACTIONS(2324),
    [anon_sym_SEMI] = ACTIONS(2322),
    [anon_sym_macro_rules_BANG] = ACTIONS(2322),
    [anon_sym_LPAREN] = ACTIONS(2322),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(2322),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_STAR] = ACTIONS(2322),
    [anon_sym_u8] = ACTIONS(2324),
    [anon_sym_i8] = ACTIONS(2324),
    [anon_sym_u16] = ACTIONS(2324),
    [anon_sym_i16] = ACTIONS(2324),
    [anon_sym_u32] = ACTIONS(2324),
    [anon_sym_i32] = ACTIONS(2324),
    [anon_sym_u64] = ACTIONS(2324),
    [anon_sym_i64] = ACTIONS(2324),
    [anon_sym_u128] = ACTIONS(2324),
    [anon_sym_i128] = ACTIONS(2324),
    [anon_sym_isize] = ACTIONS(2324),
    [anon_sym_usize] = ACTIONS(2324),
    [anon_sym_f32] = ACTIONS(2324),
    [anon_sym_f64] = ACTIONS(2324),
    [anon_sym_bool] = ACTIONS(2324),
    [anon_sym_str] = ACTIONS(2324),
    [anon_sym_char] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2322),
    [anon_sym_AMP] = ACTIONS(2322),
    [anon_sym_PIPE] = ACTIONS(2322),
    [anon_sym_LT] = ACTIONS(2322),
    [anon_sym_DOT_DOT] = ACTIONS(2322),
    [anon_sym_COLON_COLON] = ACTIONS(2322),
    [anon_sym_POUND] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_async] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2324),
    [anon_sym_continue] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2324),
    [anon_sym_enum] = ACTIONS(2324),
    [anon_sym_fn] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2324),
    [anon_sym_if] = ACTIONS(2324),
    [anon_sym_impl] = ACTIONS(2324),
    [anon_sym_let] = ACTIONS(2324),
    [anon_sym_loop] = ACTIONS(2324),
    [anon_sym_match] = ACTIONS(2324),
    [anon_sym_mod] = ACTIONS(2324),
    [anon_sym_pub] = ACTIONS(2324),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_static] = ACTIONS(2324),
    [anon_sym_struct] = ACTIONS(2324),
    [anon_sym_trait] = ACTIONS(2324),
    [anon_sym_type] = ACTIONS(2324),
    [anon_sym_union] = ACTIONS(2324),
    [anon_sym_unsafe] = ACTIONS(2324),
    [anon_sym_use] = ACTIONS(2324),
    [anon_sym_while] = ACTIONS(2324),
    [anon_sym_extern] = ACTIONS(2324),
    [anon_sym_yield] = ACTIONS(2324),
    [anon_sym_move] = ACTIONS(2324),
    [anon_sym_try] = ACTIONS(2324),
    [sym_integer_literal] = ACTIONS(2322),
    [aux_sym_string_literal_token1] = ACTIONS(2322),
    [sym_char_literal] = ACTIONS(2322),
    [anon_sym_true] = ACTIONS(2324),
    [anon_sym_false] = ACTIONS(2324),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2324),
    [sym_super] = ACTIONS(2324),
    [sym_crate] = ACTIONS(2324),
    [sym_metavariable] = ACTIONS(2322),
    [sym__raw_string_literal_start] = ACTIONS(2322),
    [sym_float_literal] = ACTIONS(2322),
  },
  [620] = {
    [sym_line_comment] = STATE(620),
    [sym_block_comment] = STATE(620),
    [ts_builtin_sym_end] = ACTIONS(2326),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_SEMI] = ACTIONS(2326),
    [anon_sym_macro_rules_BANG] = ACTIONS(2326),
    [anon_sym_LPAREN] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2326),
    [anon_sym_RBRACE] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2326),
    [anon_sym_u8] = ACTIONS(2328),
    [anon_sym_i8] = ACTIONS(2328),
    [anon_sym_u16] = ACTIONS(2328),
    [anon_sym_i16] = ACTIONS(2328),
    [anon_sym_u32] = ACTIONS(2328),
    [anon_sym_i32] = ACTIONS(2328),
    [anon_sym_u64] = ACTIONS(2328),
    [anon_sym_i64] = ACTIONS(2328),
    [anon_sym_u128] = ACTIONS(2328),
    [anon_sym_i128] = ACTIONS(2328),
    [anon_sym_isize] = ACTIONS(2328),
    [anon_sym_usize] = ACTIONS(2328),
    [anon_sym_f32] = ACTIONS(2328),
    [anon_sym_f64] = ACTIONS(2328),
    [anon_sym_bool] = ACTIONS(2328),
    [anon_sym_str] = ACTIONS(2328),
    [anon_sym_char] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_BANG] = ACTIONS(2326),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym_PIPE] = ACTIONS(2326),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_COLON_COLON] = ACTIONS(2326),
    [anon_sym_POUND] = ACTIONS(2326),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_async] = ACTIONS(2328),
    [anon_sym_break] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(2328),
    [anon_sym_continue] = ACTIONS(2328),
    [anon_sym_default] = ACTIONS(2328),
    [anon_sym_enum] = ACTIONS(2328),
    [anon_sym_fn] = ACTIONS(2328),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_impl] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_loop] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_mod] = ACTIONS(2328),
    [anon_sym_pub] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(2328),
    [anon_sym_struct] = ACTIONS(2328),
    [anon_sym_trait] = ACTIONS(2328),
    [anon_sym_type] = ACTIONS(2328),
    [anon_sym_union] = ACTIONS(2328),
    [anon_sym_unsafe] = ACTIONS(2328),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_extern] = ACTIONS(2328),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_move] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [sym_integer_literal] = ACTIONS(2326),
    [aux_sym_string_literal_token1] = ACTIONS(2326),
    [sym_char_literal] = ACTIONS(2326),
    [anon_sym_true] = ACTIONS(2328),
    [anon_sym_false] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2328),
    [sym_super] = ACTIONS(2328),
    [sym_crate] = ACTIONS(2328),
    [sym_metavariable] = ACTIONS(2326),
    [sym__raw_string_literal_start] = ACTIONS(2326),
    [sym_float_literal] = ACTIONS(2326),
  },
  [621] = {
    [sym_line_comment] = STATE(621),
    [sym_block_comment] = STATE(621),
    [ts_builtin_sym_end] = ACTIONS(1244),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_SEMI] = ACTIONS(1244),
    [anon_sym_macro_rules_BANG] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_LBRACE] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_u8] = ACTIONS(1246),
    [anon_sym_i8] = ACTIONS(1246),
    [anon_sym_u16] = ACTIONS(1246),
    [anon_sym_i16] = ACTIONS(1246),
    [anon_sym_u32] = ACTIONS(1246),
    [anon_sym_i32] = ACTIONS(1246),
    [anon_sym_u64] = ACTIONS(1246),
    [anon_sym_i64] = ACTIONS(1246),
    [anon_sym_u128] = ACTIONS(1246),
    [anon_sym_i128] = ACTIONS(1246),
    [anon_sym_isize] = ACTIONS(1246),
    [anon_sym_usize] = ACTIONS(1246),
    [anon_sym_f32] = ACTIONS(1246),
    [anon_sym_f64] = ACTIONS(1246),
    [anon_sym_bool] = ACTIONS(1246),
    [anon_sym_str] = ACTIONS(1246),
    [anon_sym_char] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1244),
    [anon_sym_BANG] = ACTIONS(1244),
    [anon_sym_AMP] = ACTIONS(1244),
    [anon_sym_PIPE] = ACTIONS(1244),
    [anon_sym_LT] = ACTIONS(1244),
    [anon_sym_DOT_DOT] = ACTIONS(1244),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [anon_sym_POUND] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_async] = ACTIONS(1246),
    [anon_sym_break] = ACTIONS(1246),
    [anon_sym_const] = ACTIONS(1246),
    [anon_sym_continue] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_enum] = ACTIONS(1246),
    [anon_sym_fn] = ACTIONS(1246),
    [anon_sym_for] = ACTIONS(1246),
    [anon_sym_if] = ACTIONS(1246),
    [anon_sym_impl] = ACTIONS(1246),
    [anon_sym_let] = ACTIONS(1246),
    [anon_sym_loop] = ACTIONS(1246),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_mod] = ACTIONS(1246),
    [anon_sym_pub] = ACTIONS(1246),
    [anon_sym_return] = ACTIONS(1246),
    [anon_sym_static] = ACTIONS(1246),
    [anon_sym_struct] = ACTIONS(1246),
    [anon_sym_trait] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1246),
    [anon_sym_union] = ACTIONS(1246),
    [anon_sym_unsafe] = ACTIONS(1246),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_while] = ACTIONS(1246),
    [anon_sym_extern] = ACTIONS(1246),
    [anon_sym_yield] = ACTIONS(1246),
    [anon_sym_move] = ACTIONS(1246),
    [anon_sym_try] = ACTIONS(1246),
    [sym_integer_literal] = ACTIONS(1244),
    [aux_sym_string_literal_token1] = ACTIONS(1244),
    [sym_char_literal] = ACTIONS(1244),
    [anon_sym_true] = ACTIONS(1246),
    [anon_sym_false] = ACTIONS(1246),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1246),
    [sym_super] = ACTIONS(1246),
    [sym_crate] = ACTIONS(1246),
    [sym_metavariable] = ACTIONS(1244),
    [sym__raw_string_literal_start] = ACTIONS(1244),
    [sym_float_literal] = ACTIONS(1244),
  },
  [622] = {
    [sym_line_comment] = STATE(622),
    [sym_block_comment] = STATE(622),
    [ts_builtin_sym_end] = ACTIONS(2330),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_SEMI] = ACTIONS(2330),
    [anon_sym_macro_rules_BANG] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2330),
    [anon_sym_RBRACE] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2330),
    [anon_sym_u8] = ACTIONS(2332),
    [anon_sym_i8] = ACTIONS(2332),
    [anon_sym_u16] = ACTIONS(2332),
    [anon_sym_i16] = ACTIONS(2332),
    [anon_sym_u32] = ACTIONS(2332),
    [anon_sym_i32] = ACTIONS(2332),
    [anon_sym_u64] = ACTIONS(2332),
    [anon_sym_i64] = ACTIONS(2332),
    [anon_sym_u128] = ACTIONS(2332),
    [anon_sym_i128] = ACTIONS(2332),
    [anon_sym_isize] = ACTIONS(2332),
    [anon_sym_usize] = ACTIONS(2332),
    [anon_sym_f32] = ACTIONS(2332),
    [anon_sym_f64] = ACTIONS(2332),
    [anon_sym_bool] = ACTIONS(2332),
    [anon_sym_str] = ACTIONS(2332),
    [anon_sym_char] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_BANG] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_PIPE] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_DOT_DOT] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_POUND] = ACTIONS(2330),
    [anon_sym_SQUOTE] = ACTIONS(2332),
    [anon_sym_async] = ACTIONS(2332),
    [anon_sym_break] = ACTIONS(2332),
    [anon_sym_const] = ACTIONS(2332),
    [anon_sym_continue] = ACTIONS(2332),
    [anon_sym_default] = ACTIONS(2332),
    [anon_sym_enum] = ACTIONS(2332),
    [anon_sym_fn] = ACTIONS(2332),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_impl] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_loop] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_mod] = ACTIONS(2332),
    [anon_sym_pub] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_static] = ACTIONS(2332),
    [anon_sym_struct] = ACTIONS(2332),
    [anon_sym_trait] = ACTIONS(2332),
    [anon_sym_type] = ACTIONS(2332),
    [anon_sym_union] = ACTIONS(2332),
    [anon_sym_unsafe] = ACTIONS(2332),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_extern] = ACTIONS(2332),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_move] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [sym_integer_literal] = ACTIONS(2330),
    [aux_sym_string_literal_token1] = ACTIONS(2330),
    [sym_char_literal] = ACTIONS(2330),
    [anon_sym_true] = ACTIONS(2332),
    [anon_sym_false] = ACTIONS(2332),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2332),
    [sym_super] = ACTIONS(2332),
    [sym_crate] = ACTIONS(2332),
    [sym_metavariable] = ACTIONS(2330),
    [sym__raw_string_literal_start] = ACTIONS(2330),
    [sym_float_literal] = ACTIONS(2330),
  },
  [623] = {
    [sym_line_comment] = STATE(623),
    [sym_block_comment] = STATE(623),
    [ts_builtin_sym_end] = ACTIONS(2334),
    [sym_identifier] = ACTIONS(2336),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_macro_rules_BANG] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2334),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_u8] = ACTIONS(2336),
    [anon_sym_i8] = ACTIONS(2336),
    [anon_sym_u16] = ACTIONS(2336),
    [anon_sym_i16] = ACTIONS(2336),
    [anon_sym_u32] = ACTIONS(2336),
    [anon_sym_i32] = ACTIONS(2336),
    [anon_sym_u64] = ACTIONS(2336),
    [anon_sym_i64] = ACTIONS(2336),
    [anon_sym_u128] = ACTIONS(2336),
    [anon_sym_i128] = ACTIONS(2336),
    [anon_sym_isize] = ACTIONS(2336),
    [anon_sym_usize] = ACTIONS(2336),
    [anon_sym_f32] = ACTIONS(2336),
    [anon_sym_f64] = ACTIONS(2336),
    [anon_sym_bool] = ACTIONS(2336),
    [anon_sym_str] = ACTIONS(2336),
    [anon_sym_char] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym_PIPE] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_DOT_DOT] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_POUND] = ACTIONS(2334),
    [anon_sym_SQUOTE] = ACTIONS(2336),
    [anon_sym_async] = ACTIONS(2336),
    [anon_sym_break] = ACTIONS(2336),
    [anon_sym_const] = ACTIONS(2336),
    [anon_sym_continue] = ACTIONS(2336),
    [anon_sym_default] = ACTIONS(2336),
    [anon_sym_enum] = ACTIONS(2336),
    [anon_sym_fn] = ACTIONS(2336),
    [anon_sym_for] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(2336),
    [anon_sym_impl] = ACTIONS(2336),
    [anon_sym_let] = ACTIONS(2336),
    [anon_sym_loop] = ACTIONS(2336),
    [anon_sym_match] = ACTIONS(2336),
    [anon_sym_mod] = ACTIONS(2336),
    [anon_sym_pub] = ACTIONS(2336),
    [anon_sym_return] = ACTIONS(2336),
    [anon_sym_static] = ACTIONS(2336),
    [anon_sym_struct] = ACTIONS(2336),
    [anon_sym_trait] = ACTIONS(2336),
    [anon_sym_type] = ACTIONS(2336),
    [anon_sym_union] = ACTIONS(2336),
    [anon_sym_unsafe] = ACTIONS(2336),
    [anon_sym_use] = ACTIONS(2336),
    [anon_sym_while] = ACTIONS(2336),
    [anon_sym_extern] = ACTIONS(2336),
    [anon_sym_yield] = ACTIONS(2336),
    [anon_sym_move] = ACTIONS(2336),
    [anon_sym_try] = ACTIONS(2336),
    [sym_integer_literal] = ACTIONS(2334),
    [aux_sym_string_literal_token1] = ACTIONS(2334),
    [sym_char_literal] = ACTIONS(2334),
    [anon_sym_true] = ACTIONS(2336),
    [anon_sym_false] = ACTIONS(2336),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2336),
    [sym_super] = ACTIONS(2336),
    [sym_crate] = ACTIONS(2336),
    [sym_metavariable] = ACTIONS(2334),
    [sym__raw_string_literal_start] = ACTIONS(2334),
    [sym_float_literal] = ACTIONS(2334),
  },
  [624] = {
    [sym_line_comment] = STATE(624),
    [sym_block_comment] = STATE(624),
    [ts_builtin_sym_end] = ACTIONS(2338),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2338),
    [anon_sym_macro_rules_BANG] = ACTIONS(2338),
    [anon_sym_LPAREN] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_RBRACE] = ACTIONS(2338),
    [anon_sym_STAR] = ACTIONS(2338),
    [anon_sym_u8] = ACTIONS(2340),
    [anon_sym_i8] = ACTIONS(2340),
    [anon_sym_u16] = ACTIONS(2340),
    [anon_sym_i16] = ACTIONS(2340),
    [anon_sym_u32] = ACTIONS(2340),
    [anon_sym_i32] = ACTIONS(2340),
    [anon_sym_u64] = ACTIONS(2340),
    [anon_sym_i64] = ACTIONS(2340),
    [anon_sym_u128] = ACTIONS(2340),
    [anon_sym_i128] = ACTIONS(2340),
    [anon_sym_isize] = ACTIONS(2340),
    [anon_sym_usize] = ACTIONS(2340),
    [anon_sym_f32] = ACTIONS(2340),
    [anon_sym_f64] = ACTIONS(2340),
    [anon_sym_bool] = ACTIONS(2340),
    [anon_sym_str] = ACTIONS(2340),
    [anon_sym_char] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2338),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_PIPE] = ACTIONS(2338),
    [anon_sym_LT] = ACTIONS(2338),
    [anon_sym_DOT_DOT] = ACTIONS(2338),
    [anon_sym_COLON_COLON] = ACTIONS(2338),
    [anon_sym_POUND] = ACTIONS(2338),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(2340),
    [anon_sym_break] = ACTIONS(2340),
    [anon_sym_const] = ACTIONS(2340),
    [anon_sym_continue] = ACTIONS(2340),
    [anon_sym_default] = ACTIONS(2340),
    [anon_sym_enum] = ACTIONS(2340),
    [anon_sym_fn] = ACTIONS(2340),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_impl] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_loop] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_mod] = ACTIONS(2340),
    [anon_sym_pub] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_struct] = ACTIONS(2340),
    [anon_sym_trait] = ACTIONS(2340),
    [anon_sym_type] = ACTIONS(2340),
    [anon_sym_union] = ACTIONS(2340),
    [anon_sym_unsafe] = ACTIONS(2340),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_extern] = ACTIONS(2340),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_move] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [sym_integer_literal] = ACTIONS(2338),
    [aux_sym_string_literal_token1] = ACTIONS(2338),
    [sym_char_literal] = ACTIONS(2338),
    [anon_sym_true] = ACTIONS(2340),
    [anon_sym_false] = ACTIONS(2340),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2340),
    [sym_super] = ACTIONS(2340),
    [sym_crate] = ACTIONS(2340),
    [sym_metavariable] = ACTIONS(2338),
    [sym__raw_string_literal_start] = ACTIONS(2338),
    [sym_float_literal] = ACTIONS(2338),
  },
  [625] = {
    [sym_line_comment] = STATE(625),
    [sym_block_comment] = STATE(625),
    [ts_builtin_sym_end] = ACTIONS(2342),
    [sym_identifier] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_macro_rules_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2342),
    [anon_sym_u8] = ACTIONS(2344),
    [anon_sym_i8] = ACTIONS(2344),
    [anon_sym_u16] = ACTIONS(2344),
    [anon_sym_i16] = ACTIONS(2344),
    [anon_sym_u32] = ACTIONS(2344),
    [anon_sym_i32] = ACTIONS(2344),
    [anon_sym_u64] = ACTIONS(2344),
    [anon_sym_i64] = ACTIONS(2344),
    [anon_sym_u128] = ACTIONS(2344),
    [anon_sym_i128] = ACTIONS(2344),
    [anon_sym_isize] = ACTIONS(2344),
    [anon_sym_usize] = ACTIONS(2344),
    [anon_sym_f32] = ACTIONS(2344),
    [anon_sym_f64] = ACTIONS(2344),
    [anon_sym_bool] = ACTIONS(2344),
    [anon_sym_str] = ACTIONS(2344),
    [anon_sym_char] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_PIPE] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_POUND] = ACTIONS(2342),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_async] = ACTIONS(2344),
    [anon_sym_break] = ACTIONS(2344),
    [anon_sym_const] = ACTIONS(2344),
    [anon_sym_continue] = ACTIONS(2344),
    [anon_sym_default] = ACTIONS(2344),
    [anon_sym_enum] = ACTIONS(2344),
    [anon_sym_fn] = ACTIONS(2344),
    [anon_sym_for] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(2344),
    [anon_sym_impl] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(2344),
    [anon_sym_loop] = ACTIONS(2344),
    [anon_sym_match] = ACTIONS(2344),
    [anon_sym_mod] = ACTIONS(2344),
    [anon_sym_pub] = ACTIONS(2344),
    [anon_sym_return] = ACTIONS(2344),
    [anon_sym_static] = ACTIONS(2344),
    [anon_sym_struct] = ACTIONS(2344),
    [anon_sym_trait] = ACTIONS(2344),
    [anon_sym_type] = ACTIONS(2344),
    [anon_sym_union] = ACTIONS(2344),
    [anon_sym_unsafe] = ACTIONS(2344),
    [anon_sym_use] = ACTIONS(2344),
    [anon_sym_while] = ACTIONS(2344),
    [anon_sym_extern] = ACTIONS(2344),
    [anon_sym_yield] = ACTIONS(2344),
    [anon_sym_move] = ACTIONS(2344),
    [anon_sym_try] = ACTIONS(2344),
    [sym_integer_literal] = ACTIONS(2342),
    [aux_sym_string_literal_token1] = ACTIONS(2342),
    [sym_char_literal] = ACTIONS(2342),
    [anon_sym_true] = ACTIONS(2344),
    [anon_sym_false] = ACTIONS(2344),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2344),
    [sym_super] = ACTIONS(2344),
    [sym_crate] = ACTIONS(2344),
    [sym_metavariable] = ACTIONS(2342),
    [sym__raw_string_literal_start] = ACTIONS(2342),
    [sym_float_literal] = ACTIONS(2342),
  },
  [626] = {
    [sym_line_comment] = STATE(626),
    [sym_block_comment] = STATE(626),
    [ts_builtin_sym_end] = ACTIONS(2346),
    [sym_identifier] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_macro_rules_BANG] = ACTIONS(2346),
    [anon_sym_LPAREN] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_LBRACE] = ACTIONS(2346),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_STAR] = ACTIONS(2346),
    [anon_sym_u8] = ACTIONS(2348),
    [anon_sym_i8] = ACTIONS(2348),
    [anon_sym_u16] = ACTIONS(2348),
    [anon_sym_i16] = ACTIONS(2348),
    [anon_sym_u32] = ACTIONS(2348),
    [anon_sym_i32] = ACTIONS(2348),
    [anon_sym_u64] = ACTIONS(2348),
    [anon_sym_i64] = ACTIONS(2348),
    [anon_sym_u128] = ACTIONS(2348),
    [anon_sym_i128] = ACTIONS(2348),
    [anon_sym_isize] = ACTIONS(2348),
    [anon_sym_usize] = ACTIONS(2348),
    [anon_sym_f32] = ACTIONS(2348),
    [anon_sym_f64] = ACTIONS(2348),
    [anon_sym_bool] = ACTIONS(2348),
    [anon_sym_str] = ACTIONS(2348),
    [anon_sym_char] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_DOT_DOT] = ACTIONS(2346),
    [anon_sym_COLON_COLON] = ACTIONS(2346),
    [anon_sym_POUND] = ACTIONS(2346),
    [anon_sym_SQUOTE] = ACTIONS(2348),
    [anon_sym_async] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
    [anon_sym_fn] = ACTIONS(2348),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_impl] = ACTIONS(2348),
    [anon_sym_let] = ACTIONS(2348),
    [anon_sym_loop] = ACTIONS(2348),
    [anon_sym_match] = ACTIONS(2348),
    [anon_sym_mod] = ACTIONS(2348),
    [anon_sym_pub] = ACTIONS(2348),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_struct] = ACTIONS(2348),
    [anon_sym_trait] = ACTIONS(2348),
    [anon_sym_type] = ACTIONS(2348),
    [anon_sym_union] = ACTIONS(2348),
    [anon_sym_unsafe] = ACTIONS(2348),
    [anon_sym_use] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(2348),
    [anon_sym_yield] = ACTIONS(2348),
    [anon_sym_move] = ACTIONS(2348),
    [anon_sym_try] = ACTIONS(2348),
    [sym_integer_literal] = ACTIONS(2346),
    [aux_sym_string_literal_token1] = ACTIONS(2346),
    [sym_char_literal] = ACTIONS(2346),
    [anon_sym_true] = ACTIONS(2348),
    [anon_sym_false] = ACTIONS(2348),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2348),
    [sym_super] = ACTIONS(2348),
    [sym_crate] = ACTIONS(2348),
    [sym_metavariable] = ACTIONS(2346),
    [sym__raw_string_literal_start] = ACTIONS(2346),
    [sym_float_literal] = ACTIONS(2346),
  },
  [627] = {
    [sym_line_comment] = STATE(627),
    [sym_block_comment] = STATE(627),
    [ts_builtin_sym_end] = ACTIONS(2350),
    [sym_identifier] = ACTIONS(2352),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_macro_rules_BANG] = ACTIONS(2350),
    [anon_sym_LPAREN] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_RBRACE] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_u8] = ACTIONS(2352),
    [anon_sym_i8] = ACTIONS(2352),
    [anon_sym_u16] = ACTIONS(2352),
    [anon_sym_i16] = ACTIONS(2352),
    [anon_sym_u32] = ACTIONS(2352),
    [anon_sym_i32] = ACTIONS(2352),
    [anon_sym_u64] = ACTIONS(2352),
    [anon_sym_i64] = ACTIONS(2352),
    [anon_sym_u128] = ACTIONS(2352),
    [anon_sym_i128] = ACTIONS(2352),
    [anon_sym_isize] = ACTIONS(2352),
    [anon_sym_usize] = ACTIONS(2352),
    [anon_sym_f32] = ACTIONS(2352),
    [anon_sym_f64] = ACTIONS(2352),
    [anon_sym_bool] = ACTIONS(2352),
    [anon_sym_str] = ACTIONS(2352),
    [anon_sym_char] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(2350),
    [anon_sym_PIPE] = ACTIONS(2350),
    [anon_sym_LT] = ACTIONS(2350),
    [anon_sym_DOT_DOT] = ACTIONS(2350),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_POUND] = ACTIONS(2350),
    [anon_sym_SQUOTE] = ACTIONS(2352),
    [anon_sym_async] = ACTIONS(2352),
    [anon_sym_break] = ACTIONS(2352),
    [anon_sym_const] = ACTIONS(2352),
    [anon_sym_continue] = ACTIONS(2352),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2352),
    [anon_sym_fn] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_impl] = ACTIONS(2352),
    [anon_sym_let] = ACTIONS(2352),
    [anon_sym_loop] = ACTIONS(2352),
    [anon_sym_match] = ACTIONS(2352),
    [anon_sym_mod] = ACTIONS(2352),
    [anon_sym_pub] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_struct] = ACTIONS(2352),
    [anon_sym_trait] = ACTIONS(2352),
    [anon_sym_type] = ACTIONS(2352),
    [anon_sym_union] = ACTIONS(2352),
    [anon_sym_unsafe] = ACTIONS(2352),
    [anon_sym_use] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_extern] = ACTIONS(2352),
    [anon_sym_yield] = ACTIONS(2352),
    [anon_sym_move] = ACTIONS(2352),
    [anon_sym_try] = ACTIONS(2352),
    [sym_integer_literal] = ACTIONS(2350),
    [aux_sym_string_literal_token1] = ACTIONS(2350),
    [sym_char_literal] = ACTIONS(2350),
    [anon_sym_true] = ACTIONS(2352),
    [anon_sym_false] = ACTIONS(2352),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2352),
    [sym_super] = ACTIONS(2352),
    [sym_crate] = ACTIONS(2352),
    [sym_metavariable] = ACTIONS(2350),
    [sym__raw_string_literal_start] = ACTIONS(2350),
    [sym_float_literal] = ACTIONS(2350),
  },
  [628] = {
    [sym_line_comment] = STATE(628),
    [sym_block_comment] = STATE(628),
    [ts_builtin_sym_end] = ACTIONS(2354),
    [sym_identifier] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_macro_rules_BANG] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_RBRACE] = ACTIONS(2354),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_u8] = ACTIONS(2356),
    [anon_sym_i8] = ACTIONS(2356),
    [anon_sym_u16] = ACTIONS(2356),
    [anon_sym_i16] = ACTIONS(2356),
    [anon_sym_u32] = ACTIONS(2356),
    [anon_sym_i32] = ACTIONS(2356),
    [anon_sym_u64] = ACTIONS(2356),
    [anon_sym_i64] = ACTIONS(2356),
    [anon_sym_u128] = ACTIONS(2356),
    [anon_sym_i128] = ACTIONS(2356),
    [anon_sym_isize] = ACTIONS(2356),
    [anon_sym_usize] = ACTIONS(2356),
    [anon_sym_f32] = ACTIONS(2356),
    [anon_sym_f64] = ACTIONS(2356),
    [anon_sym_bool] = ACTIONS(2356),
    [anon_sym_str] = ACTIONS(2356),
    [anon_sym_char] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_DOT_DOT] = ACTIONS(2354),
    [anon_sym_COLON_COLON] = ACTIONS(2354),
    [anon_sym_POUND] = ACTIONS(2354),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [anon_sym_async] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
    [anon_sym_fn] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_impl] = ACTIONS(2356),
    [anon_sym_let] = ACTIONS(2356),
    [anon_sym_loop] = ACTIONS(2356),
    [anon_sym_match] = ACTIONS(2356),
    [anon_sym_mod] = ACTIONS(2356),
    [anon_sym_pub] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2356),
    [anon_sym_trait] = ACTIONS(2356),
    [anon_sym_type] = ACTIONS(2356),
    [anon_sym_union] = ACTIONS(2356),
    [anon_sym_unsafe] = ACTIONS(2356),
    [anon_sym_use] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_extern] = ACTIONS(2356),
    [anon_sym_yield] = ACTIONS(2356),
    [anon_sym_move] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [sym_integer_literal] = ACTIONS(2354),
    [aux_sym_string_literal_token1] = ACTIONS(2354),
    [sym_char_literal] = ACTIONS(2354),
    [anon_sym_true] = ACTIONS(2356),
    [anon_sym_false] = ACTIONS(2356),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2356),
    [sym_super] = ACTIONS(2356),
    [sym_crate] = ACTIONS(2356),
    [sym_metavariable] = ACTIONS(2354),
    [sym__raw_string_literal_start] = ACTIONS(2354),
    [sym_float_literal] = ACTIONS(2354),
  },
  [629] = {
    [sym_empty_statement] = STATE(1456),
    [sym_macro_definition] = STATE(1456),
    [sym_attribute_item] = STATE(1456),
    [sym_inner_attribute_item] = STATE(1456),
    [sym_mod_item] = STATE(1456),
    [sym_foreign_mod_item] = STATE(1456),
    [sym_struct_item] = STATE(1456),
    [sym_union_item] = STATE(1456),
    [sym_enum_item] = STATE(1456),
    [sym_extern_crate_declaration] = STATE(1456),
    [sym_const_item] = STATE(1456),
    [sym_static_item] = STATE(1456),
    [sym_type_item] = STATE(1456),
    [sym_function_item] = STATE(1456),
    [sym_function_signature_item] = STATE(1456),
    [sym_function_modifiers] = STATE(3599),
    [sym_impl_item] = STATE(1456),
    [sym_trait_item] = STATE(1456),
    [sym_associated_type] = STATE(1456),
    [sym_let_declaration] = STATE(1456),
    [sym_use_declaration] = STATE(1456),
    [sym_extern_modifier] = STATE(2139),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3323),
    [sym_generic_type_with_turbofish] = STATE(3349),
    [sym_macro_invocation] = STATE(1456),
    [sym_scoped_identifier] = STATE(3208),
    [sym_line_comment] = STATE(629),
    [sym_block_comment] = STATE(629),
    [aux_sym_declaration_list_repeat1] = STATE(707),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1870),
    [anon_sym_SEMI] = ACTIONS(1872),
    [anon_sym_macro_rules_BANG] = ACTIONS(1874),
    [anon_sym_RBRACE] = ACTIONS(2358),
    [anon_sym_u8] = ACTIONS(1878),
    [anon_sym_i8] = ACTIONS(1878),
    [anon_sym_u16] = ACTIONS(1878),
    [anon_sym_i16] = ACTIONS(1878),
    [anon_sym_u32] = ACTIONS(1878),
    [anon_sym_i32] = ACTIONS(1878),
    [anon_sym_u64] = ACTIONS(1878),
    [anon_sym_i64] = ACTIONS(1878),
    [anon_sym_u128] = ACTIONS(1878),
    [anon_sym_i128] = ACTIONS(1878),
    [anon_sym_isize] = ACTIONS(1878),
    [anon_sym_usize] = ACTIONS(1878),
    [anon_sym_f32] = ACTIONS(1878),
    [anon_sym_f64] = ACTIONS(1878),
    [anon_sym_bool] = ACTIONS(1878),
    [anon_sym_str] = ACTIONS(1878),
    [anon_sym_char] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_POUND] = ACTIONS(1882),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1884),
    [anon_sym_default] = ACTIONS(1886),
    [anon_sym_enum] = ACTIONS(1888),
    [anon_sym_fn] = ACTIONS(1890),
    [anon_sym_impl] = ACTIONS(1892),
    [anon_sym_let] = ACTIONS(1894),
    [anon_sym_mod] = ACTIONS(1896),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(1898),
    [anon_sym_struct] = ACTIONS(1900),
    [anon_sym_trait] = ACTIONS(1902),
    [anon_sym_type] = ACTIONS(1904),
    [anon_sym_union] = ACTIONS(1906),
    [anon_sym_unsafe] = ACTIONS(1908),
    [anon_sym_use] = ACTIONS(1910),
    [anon_sym_extern] = ACTIONS(1912),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1914),
    [sym_super] = ACTIONS(1914),
    [sym_crate] = ACTIONS(1916),
    [sym_metavariable] = ACTIONS(1918),
  },
  [630] = {
    [sym_line_comment] = STATE(630),
    [sym_block_comment] = STATE(630),
    [ts_builtin_sym_end] = ACTIONS(2360),
    [sym_identifier] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2360),
    [anon_sym_macro_rules_BANG] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(2360),
    [anon_sym_LBRACK] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2360),
    [anon_sym_RBRACE] = ACTIONS(2360),
    [anon_sym_STAR] = ACTIONS(2360),
    [anon_sym_u8] = ACTIONS(2362),
    [anon_sym_i8] = ACTIONS(2362),
    [anon_sym_u16] = ACTIONS(2362),
    [anon_sym_i16] = ACTIONS(2362),
    [anon_sym_u32] = ACTIONS(2362),
    [anon_sym_i32] = ACTIONS(2362),
    [anon_sym_u64] = ACTIONS(2362),
    [anon_sym_i64] = ACTIONS(2362),
    [anon_sym_u128] = ACTIONS(2362),
    [anon_sym_i128] = ACTIONS(2362),
    [anon_sym_isize] = ACTIONS(2362),
    [anon_sym_usize] = ACTIONS(2362),
    [anon_sym_f32] = ACTIONS(2362),
    [anon_sym_f64] = ACTIONS(2362),
    [anon_sym_bool] = ACTIONS(2362),
    [anon_sym_str] = ACTIONS(2362),
    [anon_sym_char] = ACTIONS(2362),
    [anon_sym_DASH] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2360),
    [anon_sym_AMP] = ACTIONS(2360),
    [anon_sym_PIPE] = ACTIONS(2360),
    [anon_sym_LT] = ACTIONS(2360),
    [anon_sym_DOT_DOT] = ACTIONS(2360),
    [anon_sym_COLON_COLON] = ACTIONS(2360),
    [anon_sym_POUND] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(2362),
    [anon_sym_async] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_fn] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_impl] = ACTIONS(2362),
    [anon_sym_let] = ACTIONS(2362),
    [anon_sym_loop] = ACTIONS(2362),
    [anon_sym_match] = ACTIONS(2362),
    [anon_sym_mod] = ACTIONS(2362),
    [anon_sym_pub] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_struct] = ACTIONS(2362),
    [anon_sym_trait] = ACTIONS(2362),
    [anon_sym_type] = ACTIONS(2362),
    [anon_sym_union] = ACTIONS(2362),
    [anon_sym_unsafe] = ACTIONS(2362),
    [anon_sym_use] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2362),
    [anon_sym_yield] = ACTIONS(2362),
    [anon_sym_move] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [sym_integer_literal] = ACTIONS(2360),
    [aux_sym_string_literal_token1] = ACTIONS(2360),
    [sym_char_literal] = ACTIONS(2360),
    [anon_sym_true] = ACTIONS(2362),
    [anon_sym_false] = ACTIONS(2362),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2362),
    [sym_super] = ACTIONS(2362),
    [sym_crate] = ACTIONS(2362),
    [sym_metavariable] = ACTIONS(2360),
    [sym__raw_string_literal_start] = ACTIONS(2360),
    [sym_float_literal] = ACTIONS(2360),
  },
  [631] = {
    [sym_line_comment] = STATE(631),
    [sym_block_comment] = STATE(631),
    [ts_builtin_sym_end] = ACTIONS(2364),
    [sym_identifier] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_macro_rules_BANG] = ACTIONS(2364),
    [anon_sym_LPAREN] = ACTIONS(2364),
    [anon_sym_LBRACK] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_RBRACE] = ACTIONS(2364),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_u8] = ACTIONS(2366),
    [anon_sym_i8] = ACTIONS(2366),
    [anon_sym_u16] = ACTIONS(2366),
    [anon_sym_i16] = ACTIONS(2366),
    [anon_sym_u32] = ACTIONS(2366),
    [anon_sym_i32] = ACTIONS(2366),
    [anon_sym_u64] = ACTIONS(2366),
    [anon_sym_i64] = ACTIONS(2366),
    [anon_sym_u128] = ACTIONS(2366),
    [anon_sym_i128] = ACTIONS(2366),
    [anon_sym_isize] = ACTIONS(2366),
    [anon_sym_usize] = ACTIONS(2366),
    [anon_sym_f32] = ACTIONS(2366),
    [anon_sym_f64] = ACTIONS(2366),
    [anon_sym_bool] = ACTIONS(2366),
    [anon_sym_str] = ACTIONS(2366),
    [anon_sym_char] = ACTIONS(2366),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_DOT_DOT] = ACTIONS(2364),
    [anon_sym_COLON_COLON] = ACTIONS(2364),
    [anon_sym_POUND] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2366),
    [anon_sym_async] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_fn] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_impl] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2366),
    [anon_sym_loop] = ACTIONS(2366),
    [anon_sym_match] = ACTIONS(2366),
    [anon_sym_mod] = ACTIONS(2366),
    [anon_sym_pub] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_trait] = ACTIONS(2366),
    [anon_sym_type] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [anon_sym_unsafe] = ACTIONS(2366),
    [anon_sym_use] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym_yield] = ACTIONS(2366),
    [anon_sym_move] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [sym_integer_literal] = ACTIONS(2364),
    [aux_sym_string_literal_token1] = ACTIONS(2364),
    [sym_char_literal] = ACTIONS(2364),
    [anon_sym_true] = ACTIONS(2366),
    [anon_sym_false] = ACTIONS(2366),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2366),
    [sym_super] = ACTIONS(2366),
    [sym_crate] = ACTIONS(2366),
    [sym_metavariable] = ACTIONS(2364),
    [sym__raw_string_literal_start] = ACTIONS(2364),
    [sym_float_literal] = ACTIONS(2364),
  },
  [632] = {
    [sym_line_comment] = STATE(632),
    [sym_block_comment] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(2368),
    [sym_identifier] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym_macro_rules_BANG] = ACTIONS(2368),
    [anon_sym_LPAREN] = ACTIONS(2368),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_RBRACE] = ACTIONS(2368),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_u8] = ACTIONS(2370),
    [anon_sym_i8] = ACTIONS(2370),
    [anon_sym_u16] = ACTIONS(2370),
    [anon_sym_i16] = ACTIONS(2370),
    [anon_sym_u32] = ACTIONS(2370),
    [anon_sym_i32] = ACTIONS(2370),
    [anon_sym_u64] = ACTIONS(2370),
    [anon_sym_i64] = ACTIONS(2370),
    [anon_sym_u128] = ACTIONS(2370),
    [anon_sym_i128] = ACTIONS(2370),
    [anon_sym_isize] = ACTIONS(2370),
    [anon_sym_usize] = ACTIONS(2370),
    [anon_sym_f32] = ACTIONS(2370),
    [anon_sym_f64] = ACTIONS(2370),
    [anon_sym_bool] = ACTIONS(2370),
    [anon_sym_str] = ACTIONS(2370),
    [anon_sym_char] = ACTIONS(2370),
    [anon_sym_DASH] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2368),
    [anon_sym_PIPE] = ACTIONS(2368),
    [anon_sym_LT] = ACTIONS(2368),
    [anon_sym_DOT_DOT] = ACTIONS(2368),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_POUND] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_async] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_fn] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_impl] = ACTIONS(2370),
    [anon_sym_let] = ACTIONS(2370),
    [anon_sym_loop] = ACTIONS(2370),
    [anon_sym_match] = ACTIONS(2370),
    [anon_sym_mod] = ACTIONS(2370),
    [anon_sym_pub] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_trait] = ACTIONS(2370),
    [anon_sym_type] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_unsafe] = ACTIONS(2370),
    [anon_sym_use] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym_yield] = ACTIONS(2370),
    [anon_sym_move] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [sym_integer_literal] = ACTIONS(2368),
    [aux_sym_string_literal_token1] = ACTIONS(2368),
    [sym_char_literal] = ACTIONS(2368),
    [anon_sym_true] = ACTIONS(2370),
    [anon_sym_false] = ACTIONS(2370),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2370),
    [sym_super] = ACTIONS(2370),
    [sym_crate] = ACTIONS(2370),
    [sym_metavariable] = ACTIONS(2368),
    [sym__raw_string_literal_start] = ACTIONS(2368),
    [sym_float_literal] = ACTIONS(2368),
  },
  [633] = {
    [sym_line_comment] = STATE(633),
    [sym_block_comment] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(2372),
    [sym_identifier] = ACTIONS(2374),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym_macro_rules_BANG] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(2372),
    [anon_sym_LBRACK] = ACTIONS(2372),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_u8] = ACTIONS(2374),
    [anon_sym_i8] = ACTIONS(2374),
    [anon_sym_u16] = ACTIONS(2374),
    [anon_sym_i16] = ACTIONS(2374),
    [anon_sym_u32] = ACTIONS(2374),
    [anon_sym_i32] = ACTIONS(2374),
    [anon_sym_u64] = ACTIONS(2374),
    [anon_sym_i64] = ACTIONS(2374),
    [anon_sym_u128] = ACTIONS(2374),
    [anon_sym_i128] = ACTIONS(2374),
    [anon_sym_isize] = ACTIONS(2374),
    [anon_sym_usize] = ACTIONS(2374),
    [anon_sym_f32] = ACTIONS(2374),
    [anon_sym_f64] = ACTIONS(2374),
    [anon_sym_bool] = ACTIONS(2374),
    [anon_sym_str] = ACTIONS(2374),
    [anon_sym_char] = ACTIONS(2374),
    [anon_sym_DASH] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2372),
    [anon_sym_PIPE] = ACTIONS(2372),
    [anon_sym_LT] = ACTIONS(2372),
    [anon_sym_DOT_DOT] = ACTIONS(2372),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2374),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_default] = ACTIONS(2374),
    [anon_sym_enum] = ACTIONS(2374),
    [anon_sym_fn] = ACTIONS(2374),
    [anon_sym_for] = ACTIONS(2374),
    [anon_sym_if] = ACTIONS(2374),
    [anon_sym_impl] = ACTIONS(2374),
    [anon_sym_let] = ACTIONS(2374),
    [anon_sym_loop] = ACTIONS(2374),
    [anon_sym_match] = ACTIONS(2374),
    [anon_sym_mod] = ACTIONS(2374),
    [anon_sym_pub] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2374),
    [anon_sym_struct] = ACTIONS(2374),
    [anon_sym_trait] = ACTIONS(2374),
    [anon_sym_type] = ACTIONS(2374),
    [anon_sym_union] = ACTIONS(2374),
    [anon_sym_unsafe] = ACTIONS(2374),
    [anon_sym_use] = ACTIONS(2374),
    [anon_sym_while] = ACTIONS(2374),
    [anon_sym_extern] = ACTIONS(2374),
    [anon_sym_yield] = ACTIONS(2374),
    [anon_sym_move] = ACTIONS(2374),
    [anon_sym_try] = ACTIONS(2374),
    [sym_integer_literal] = ACTIONS(2372),
    [aux_sym_string_literal_token1] = ACTIONS(2372),
    [sym_char_literal] = ACTIONS(2372),
    [anon_sym_true] = ACTIONS(2374),
    [anon_sym_false] = ACTIONS(2374),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2374),
    [sym_super] = ACTIONS(2374),
    [sym_crate] = ACTIONS(2374),
    [sym_metavariable] = ACTIONS(2372),
    [sym__raw_string_literal_start] = ACTIONS(2372),
    [sym_float_literal] = ACTIONS(2372),
  },
  [634] = {
    [sym_line_comment] = STATE(634),
    [sym_block_comment] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(2376),
    [sym_identifier] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym_macro_rules_BANG] = ACTIONS(2376),
    [anon_sym_LPAREN] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2376),
    [anon_sym_RBRACE] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(2376),
    [anon_sym_u8] = ACTIONS(2378),
    [anon_sym_i8] = ACTIONS(2378),
    [anon_sym_u16] = ACTIONS(2378),
    [anon_sym_i16] = ACTIONS(2378),
    [anon_sym_u32] = ACTIONS(2378),
    [anon_sym_i32] = ACTIONS(2378),
    [anon_sym_u64] = ACTIONS(2378),
    [anon_sym_i64] = ACTIONS(2378),
    [anon_sym_u128] = ACTIONS(2378),
    [anon_sym_i128] = ACTIONS(2378),
    [anon_sym_isize] = ACTIONS(2378),
    [anon_sym_usize] = ACTIONS(2378),
    [anon_sym_f32] = ACTIONS(2378),
    [anon_sym_f64] = ACTIONS(2378),
    [anon_sym_bool] = ACTIONS(2378),
    [anon_sym_str] = ACTIONS(2378),
    [anon_sym_char] = ACTIONS(2378),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2376),
    [anon_sym_AMP] = ACTIONS(2376),
    [anon_sym_PIPE] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2376),
    [anon_sym_DOT_DOT] = ACTIONS(2376),
    [anon_sym_COLON_COLON] = ACTIONS(2376),
    [anon_sym_POUND] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2378),
    [anon_sym_async] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_fn] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_impl] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(2378),
    [anon_sym_loop] = ACTIONS(2378),
    [anon_sym_match] = ACTIONS(2378),
    [anon_sym_mod] = ACTIONS(2378),
    [anon_sym_pub] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_trait] = ACTIONS(2378),
    [anon_sym_type] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_unsafe] = ACTIONS(2378),
    [anon_sym_use] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym_yield] = ACTIONS(2378),
    [anon_sym_move] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [sym_integer_literal] = ACTIONS(2376),
    [aux_sym_string_literal_token1] = ACTIONS(2376),
    [sym_char_literal] = ACTIONS(2376),
    [anon_sym_true] = ACTIONS(2378),
    [anon_sym_false] = ACTIONS(2378),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2378),
    [sym_super] = ACTIONS(2378),
    [sym_crate] = ACTIONS(2378),
    [sym_metavariable] = ACTIONS(2376),
    [sym__raw_string_literal_start] = ACTIONS(2376),
    [sym_float_literal] = ACTIONS(2376),
  },
  [635] = {
    [sym_line_comment] = STATE(635),
    [sym_block_comment] = STATE(635),
    [ts_builtin_sym_end] = ACTIONS(2380),
    [sym_identifier] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym_macro_rules_BANG] = ACTIONS(2380),
    [anon_sym_LPAREN] = ACTIONS(2380),
    [anon_sym_LBRACK] = ACTIONS(2380),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_RBRACE] = ACTIONS(2380),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_u8] = ACTIONS(2382),
    [anon_sym_i8] = ACTIONS(2382),
    [anon_sym_u16] = ACTIONS(2382),
    [anon_sym_i16] = ACTIONS(2382),
    [anon_sym_u32] = ACTIONS(2382),
    [anon_sym_i32] = ACTIONS(2382),
    [anon_sym_u64] = ACTIONS(2382),
    [anon_sym_i64] = ACTIONS(2382),
    [anon_sym_u128] = ACTIONS(2382),
    [anon_sym_i128] = ACTIONS(2382),
    [anon_sym_isize] = ACTIONS(2382),
    [anon_sym_usize] = ACTIONS(2382),
    [anon_sym_f32] = ACTIONS(2382),
    [anon_sym_f64] = ACTIONS(2382),
    [anon_sym_bool] = ACTIONS(2382),
    [anon_sym_str] = ACTIONS(2382),
    [anon_sym_char] = ACTIONS(2382),
    [anon_sym_DASH] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2380),
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_LT] = ACTIONS(2380),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_POUND] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2382),
    [anon_sym_async] = ACTIONS(2382),
    [anon_sym_break] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_continue] = ACTIONS(2382),
    [anon_sym_default] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [anon_sym_fn] = ACTIONS(2382),
    [anon_sym_for] = ACTIONS(2382),
    [anon_sym_if] = ACTIONS(2382),
    [anon_sym_impl] = ACTIONS(2382),
    [anon_sym_let] = ACTIONS(2382),
    [anon_sym_loop] = ACTIONS(2382),
    [anon_sym_match] = ACTIONS(2382),
    [anon_sym_mod] = ACTIONS(2382),
    [anon_sym_pub] = ACTIONS(2382),
    [anon_sym_return] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_struct] = ACTIONS(2382),
    [anon_sym_trait] = ACTIONS(2382),
    [anon_sym_type] = ACTIONS(2382),
    [anon_sym_union] = ACTIONS(2382),
    [anon_sym_unsafe] = ACTIONS(2382),
    [anon_sym_use] = ACTIONS(2382),
    [anon_sym_while] = ACTIONS(2382),
    [anon_sym_extern] = ACTIONS(2382),
    [anon_sym_yield] = ACTIONS(2382),
    [anon_sym_move] = ACTIONS(2382),
    [anon_sym_try] = ACTIONS(2382),
    [sym_integer_literal] = ACTIONS(2380),
    [aux_sym_string_literal_token1] = ACTIONS(2380),
    [sym_char_literal] = ACTIONS(2380),
    [anon_sym_true] = ACTIONS(2382),
    [anon_sym_false] = ACTIONS(2382),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2382),
    [sym_super] = ACTIONS(2382),
    [sym_crate] = ACTIONS(2382),
    [sym_metavariable] = ACTIONS(2380),
    [sym__raw_string_literal_start] = ACTIONS(2380),
    [sym_float_literal] = ACTIONS(2380),
  },
  [636] = {
    [sym_line_comment] = STATE(636),
    [sym_block_comment] = STATE(636),
    [ts_builtin_sym_end] = ACTIONS(2384),
    [sym_identifier] = ACTIONS(2386),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym_macro_rules_BANG] = ACTIONS(2384),
    [anon_sym_LPAREN] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_RBRACE] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_u8] = ACTIONS(2386),
    [anon_sym_i8] = ACTIONS(2386),
    [anon_sym_u16] = ACTIONS(2386),
    [anon_sym_i16] = ACTIONS(2386),
    [anon_sym_u32] = ACTIONS(2386),
    [anon_sym_i32] = ACTIONS(2386),
    [anon_sym_u64] = ACTIONS(2386),
    [anon_sym_i64] = ACTIONS(2386),
    [anon_sym_u128] = ACTIONS(2386),
    [anon_sym_i128] = ACTIONS(2386),
    [anon_sym_isize] = ACTIONS(2386),
    [anon_sym_usize] = ACTIONS(2386),
    [anon_sym_f32] = ACTIONS(2386),
    [anon_sym_f64] = ACTIONS(2386),
    [anon_sym_bool] = ACTIONS(2386),
    [anon_sym_str] = ACTIONS(2386),
    [anon_sym_char] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_PIPE] = ACTIONS(2384),
    [anon_sym_LT] = ACTIONS(2384),
    [anon_sym_DOT_DOT] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2384),
    [anon_sym_POUND] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [anon_sym_async] = ACTIONS(2386),
    [anon_sym_break] = ACTIONS(2386),
    [anon_sym_const] = ACTIONS(2386),
    [anon_sym_continue] = ACTIONS(2386),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_enum] = ACTIONS(2386),
    [anon_sym_fn] = ACTIONS(2386),
    [anon_sym_for] = ACTIONS(2386),
    [anon_sym_if] = ACTIONS(2386),
    [anon_sym_impl] = ACTIONS(2386),
    [anon_sym_let] = ACTIONS(2386),
    [anon_sym_loop] = ACTIONS(2386),
    [anon_sym_match] = ACTIONS(2386),
    [anon_sym_mod] = ACTIONS(2386),
    [anon_sym_pub] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2386),
    [anon_sym_static] = ACTIONS(2386),
    [anon_sym_struct] = ACTIONS(2386),
    [anon_sym_trait] = ACTIONS(2386),
    [anon_sym_type] = ACTIONS(2386),
    [anon_sym_union] = ACTIONS(2386),
    [anon_sym_unsafe] = ACTIONS(2386),
    [anon_sym_use] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2386),
    [anon_sym_extern] = ACTIONS(2386),
    [anon_sym_yield] = ACTIONS(2386),
    [anon_sym_move] = ACTIONS(2386),
    [anon_sym_try] = ACTIONS(2386),
    [sym_integer_literal] = ACTIONS(2384),
    [aux_sym_string_literal_token1] = ACTIONS(2384),
    [sym_char_literal] = ACTIONS(2384),
    [anon_sym_true] = ACTIONS(2386),
    [anon_sym_false] = ACTIONS(2386),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2386),
    [sym_super] = ACTIONS(2386),
    [sym_crate] = ACTIONS(2386),
    [sym_metavariable] = ACTIONS(2384),
    [sym__raw_string_literal_start] = ACTIONS(2384),
    [sym_float_literal] = ACTIONS(2384),
  },
  [637] = {
    [sym_line_comment] = STATE(637),
    [sym_block_comment] = STATE(637),
    [ts_builtin_sym_end] = ACTIONS(2388),
    [sym_identifier] = ACTIONS(2390),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym_macro_rules_BANG] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_STAR] = ACTIONS(2388),
    [anon_sym_u8] = ACTIONS(2390),
    [anon_sym_i8] = ACTIONS(2390),
    [anon_sym_u16] = ACTIONS(2390),
    [anon_sym_i16] = ACTIONS(2390),
    [anon_sym_u32] = ACTIONS(2390),
    [anon_sym_i32] = ACTIONS(2390),
    [anon_sym_u64] = ACTIONS(2390),
    [anon_sym_i64] = ACTIONS(2390),
    [anon_sym_u128] = ACTIONS(2390),
    [anon_sym_i128] = ACTIONS(2390),
    [anon_sym_isize] = ACTIONS(2390),
    [anon_sym_usize] = ACTIONS(2390),
    [anon_sym_f32] = ACTIONS(2390),
    [anon_sym_f64] = ACTIONS(2390),
    [anon_sym_bool] = ACTIONS(2390),
    [anon_sym_str] = ACTIONS(2390),
    [anon_sym_char] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2388),
    [anon_sym_DOT_DOT] = ACTIONS(2388),
    [anon_sym_COLON_COLON] = ACTIONS(2388),
    [anon_sym_POUND] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_break] = ACTIONS(2390),
    [anon_sym_const] = ACTIONS(2390),
    [anon_sym_continue] = ACTIONS(2390),
    [anon_sym_default] = ACTIONS(2390),
    [anon_sym_enum] = ACTIONS(2390),
    [anon_sym_fn] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_impl] = ACTIONS(2390),
    [anon_sym_let] = ACTIONS(2390),
    [anon_sym_loop] = ACTIONS(2390),
    [anon_sym_match] = ACTIONS(2390),
    [anon_sym_mod] = ACTIONS(2390),
    [anon_sym_pub] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_static] = ACTIONS(2390),
    [anon_sym_struct] = ACTIONS(2390),
    [anon_sym_trait] = ACTIONS(2390),
    [anon_sym_type] = ACTIONS(2390),
    [anon_sym_union] = ACTIONS(2390),
    [anon_sym_unsafe] = ACTIONS(2390),
    [anon_sym_use] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_extern] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_move] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [sym_integer_literal] = ACTIONS(2388),
    [aux_sym_string_literal_token1] = ACTIONS(2388),
    [sym_char_literal] = ACTIONS(2388),
    [anon_sym_true] = ACTIONS(2390),
    [anon_sym_false] = ACTIONS(2390),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2390),
    [sym_super] = ACTIONS(2390),
    [sym_crate] = ACTIONS(2390),
    [sym_metavariable] = ACTIONS(2388),
    [sym__raw_string_literal_start] = ACTIONS(2388),
    [sym_float_literal] = ACTIONS(2388),
  },
  [638] = {
    [sym_line_comment] = STATE(638),
    [sym_block_comment] = STATE(638),
    [ts_builtin_sym_end] = ACTIONS(2392),
    [sym_identifier] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_macro_rules_BANG] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_STAR] = ACTIONS(2392),
    [anon_sym_u8] = ACTIONS(2394),
    [anon_sym_i8] = ACTIONS(2394),
    [anon_sym_u16] = ACTIONS(2394),
    [anon_sym_i16] = ACTIONS(2394),
    [anon_sym_u32] = ACTIONS(2394),
    [anon_sym_i32] = ACTIONS(2394),
    [anon_sym_u64] = ACTIONS(2394),
    [anon_sym_i64] = ACTIONS(2394),
    [anon_sym_u128] = ACTIONS(2394),
    [anon_sym_i128] = ACTIONS(2394),
    [anon_sym_isize] = ACTIONS(2394),
    [anon_sym_usize] = ACTIONS(2394),
    [anon_sym_f32] = ACTIONS(2394),
    [anon_sym_f64] = ACTIONS(2394),
    [anon_sym_bool] = ACTIONS(2394),
    [anon_sym_str] = ACTIONS(2394),
    [anon_sym_char] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2392),
    [anon_sym_DOT_DOT] = ACTIONS(2392),
    [anon_sym_COLON_COLON] = ACTIONS(2392),
    [anon_sym_POUND] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [anon_sym_async] = ACTIONS(2394),
    [anon_sym_break] = ACTIONS(2394),
    [anon_sym_const] = ACTIONS(2394),
    [anon_sym_continue] = ACTIONS(2394),
    [anon_sym_default] = ACTIONS(2394),
    [anon_sym_enum] = ACTIONS(2394),
    [anon_sym_fn] = ACTIONS(2394),
    [anon_sym_for] = ACTIONS(2394),
    [anon_sym_if] = ACTIONS(2394),
    [anon_sym_impl] = ACTIONS(2394),
    [anon_sym_let] = ACTIONS(2394),
    [anon_sym_loop] = ACTIONS(2394),
    [anon_sym_match] = ACTIONS(2394),
    [anon_sym_mod] = ACTIONS(2394),
    [anon_sym_pub] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2394),
    [anon_sym_struct] = ACTIONS(2394),
    [anon_sym_trait] = ACTIONS(2394),
    [anon_sym_type] = ACTIONS(2394),
    [anon_sym_union] = ACTIONS(2394),
    [anon_sym_unsafe] = ACTIONS(2394),
    [anon_sym_use] = ACTIONS(2394),
    [anon_sym_while] = ACTIONS(2394),
    [anon_sym_extern] = ACTIONS(2394),
    [anon_sym_yield] = ACTIONS(2394),
    [anon_sym_move] = ACTIONS(2394),
    [anon_sym_try] = ACTIONS(2394),
    [sym_integer_literal] = ACTIONS(2392),
    [aux_sym_string_literal_token1] = ACTIONS(2392),
    [sym_char_literal] = ACTIONS(2392),
    [anon_sym_true] = ACTIONS(2394),
    [anon_sym_false] = ACTIONS(2394),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2394),
    [sym_super] = ACTIONS(2394),
    [sym_crate] = ACTIONS(2394),
    [sym_metavariable] = ACTIONS(2392),
    [sym__raw_string_literal_start] = ACTIONS(2392),
    [sym_float_literal] = ACTIONS(2392),
  },
  [639] = {
    [sym_line_comment] = STATE(639),
    [sym_block_comment] = STATE(639),
    [ts_builtin_sym_end] = ACTIONS(2396),
    [sym_identifier] = ACTIONS(2398),
    [anon_sym_SEMI] = ACTIONS(2396),
    [anon_sym_macro_rules_BANG] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_RBRACE] = ACTIONS(2396),
    [anon_sym_STAR] = ACTIONS(2396),
    [anon_sym_u8] = ACTIONS(2398),
    [anon_sym_i8] = ACTIONS(2398),
    [anon_sym_u16] = ACTIONS(2398),
    [anon_sym_i16] = ACTIONS(2398),
    [anon_sym_u32] = ACTIONS(2398),
    [anon_sym_i32] = ACTIONS(2398),
    [anon_sym_u64] = ACTIONS(2398),
    [anon_sym_i64] = ACTIONS(2398),
    [anon_sym_u128] = ACTIONS(2398),
    [anon_sym_i128] = ACTIONS(2398),
    [anon_sym_isize] = ACTIONS(2398),
    [anon_sym_usize] = ACTIONS(2398),
    [anon_sym_f32] = ACTIONS(2398),
    [anon_sym_f64] = ACTIONS(2398),
    [anon_sym_bool] = ACTIONS(2398),
    [anon_sym_str] = ACTIONS(2398),
    [anon_sym_char] = ACTIONS(2398),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym_PIPE] = ACTIONS(2396),
    [anon_sym_LT] = ACTIONS(2396),
    [anon_sym_DOT_DOT] = ACTIONS(2396),
    [anon_sym_COLON_COLON] = ACTIONS(2396),
    [anon_sym_POUND] = ACTIONS(2396),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [anon_sym_async] = ACTIONS(2398),
    [anon_sym_break] = ACTIONS(2398),
    [anon_sym_const] = ACTIONS(2398),
    [anon_sym_continue] = ACTIONS(2398),
    [anon_sym_default] = ACTIONS(2398),
    [anon_sym_enum] = ACTIONS(2398),
    [anon_sym_fn] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2398),
    [anon_sym_if] = ACTIONS(2398),
    [anon_sym_impl] = ACTIONS(2398),
    [anon_sym_let] = ACTIONS(2398),
    [anon_sym_loop] = ACTIONS(2398),
    [anon_sym_match] = ACTIONS(2398),
    [anon_sym_mod] = ACTIONS(2398),
    [anon_sym_pub] = ACTIONS(2398),
    [anon_sym_return] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2398),
    [anon_sym_struct] = ACTIONS(2398),
    [anon_sym_trait] = ACTIONS(2398),
    [anon_sym_type] = ACTIONS(2398),
    [anon_sym_union] = ACTIONS(2398),
    [anon_sym_unsafe] = ACTIONS(2398),
    [anon_sym_use] = ACTIONS(2398),
    [anon_sym_while] = ACTIONS(2398),
    [anon_sym_extern] = ACTIONS(2398),
    [anon_sym_yield] = ACTIONS(2398),
    [anon_sym_move] = ACTIONS(2398),
    [anon_sym_try] = ACTIONS(2398),
    [sym_integer_literal] = ACTIONS(2396),
    [aux_sym_string_literal_token1] = ACTIONS(2396),
    [sym_char_literal] = ACTIONS(2396),
    [anon_sym_true] = ACTIONS(2398),
    [anon_sym_false] = ACTIONS(2398),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2398),
    [sym_super] = ACTIONS(2398),
    [sym_crate] = ACTIONS(2398),
    [sym_metavariable] = ACTIONS(2396),
    [sym__raw_string_literal_start] = ACTIONS(2396),
    [sym_float_literal] = ACTIONS(2396),
  },
  [640] = {
    [sym_line_comment] = STATE(640),
    [sym_block_comment] = STATE(640),
    [ts_builtin_sym_end] = ACTIONS(1236),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_SEMI] = ACTIONS(1236),
    [anon_sym_macro_rules_BANG] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LBRACE] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [anon_sym_STAR] = ACTIONS(1236),
    [anon_sym_u8] = ACTIONS(1238),
    [anon_sym_i8] = ACTIONS(1238),
    [anon_sym_u16] = ACTIONS(1238),
    [anon_sym_i16] = ACTIONS(1238),
    [anon_sym_u32] = ACTIONS(1238),
    [anon_sym_i32] = ACTIONS(1238),
    [anon_sym_u64] = ACTIONS(1238),
    [anon_sym_i64] = ACTIONS(1238),
    [anon_sym_u128] = ACTIONS(1238),
    [anon_sym_i128] = ACTIONS(1238),
    [anon_sym_isize] = ACTIONS(1238),
    [anon_sym_usize] = ACTIONS(1238),
    [anon_sym_f32] = ACTIONS(1238),
    [anon_sym_f64] = ACTIONS(1238),
    [anon_sym_bool] = ACTIONS(1238),
    [anon_sym_str] = ACTIONS(1238),
    [anon_sym_char] = ACTIONS(1238),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_BANG] = ACTIONS(1236),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_PIPE] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1236),
    [anon_sym_DOT_DOT] = ACTIONS(1236),
    [anon_sym_COLON_COLON] = ACTIONS(1236),
    [anon_sym_POUND] = ACTIONS(1236),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_async] = ACTIONS(1238),
    [anon_sym_break] = ACTIONS(1238),
    [anon_sym_const] = ACTIONS(1238),
    [anon_sym_continue] = ACTIONS(1238),
    [anon_sym_default] = ACTIONS(1238),
    [anon_sym_enum] = ACTIONS(1238),
    [anon_sym_fn] = ACTIONS(1238),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_if] = ACTIONS(1238),
    [anon_sym_impl] = ACTIONS(1238),
    [anon_sym_let] = ACTIONS(1238),
    [anon_sym_loop] = ACTIONS(1238),
    [anon_sym_match] = ACTIONS(1238),
    [anon_sym_mod] = ACTIONS(1238),
    [anon_sym_pub] = ACTIONS(1238),
    [anon_sym_return] = ACTIONS(1238),
    [anon_sym_static] = ACTIONS(1238),
    [anon_sym_struct] = ACTIONS(1238),
    [anon_sym_trait] = ACTIONS(1238),
    [anon_sym_type] = ACTIONS(1238),
    [anon_sym_union] = ACTIONS(1238),
    [anon_sym_unsafe] = ACTIONS(1238),
    [anon_sym_use] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(1238),
    [anon_sym_yield] = ACTIONS(1238),
    [anon_sym_move] = ACTIONS(1238),
    [anon_sym_try] = ACTIONS(1238),
    [sym_integer_literal] = ACTIONS(1236),
    [aux_sym_string_literal_token1] = ACTIONS(1236),
    [sym_char_literal] = ACTIONS(1236),
    [anon_sym_true] = ACTIONS(1238),
    [anon_sym_false] = ACTIONS(1238),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1238),
    [sym_super] = ACTIONS(1238),
    [sym_crate] = ACTIONS(1238),
    [sym_metavariable] = ACTIONS(1236),
    [sym__raw_string_literal_start] = ACTIONS(1236),
    [sym_float_literal] = ACTIONS(1236),
  },
  [641] = {
    [sym_line_comment] = STATE(641),
    [sym_block_comment] = STATE(641),
    [ts_builtin_sym_end] = ACTIONS(2400),
    [sym_identifier] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_macro_rules_BANG] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_u8] = ACTIONS(2402),
    [anon_sym_i8] = ACTIONS(2402),
    [anon_sym_u16] = ACTIONS(2402),
    [anon_sym_i16] = ACTIONS(2402),
    [anon_sym_u32] = ACTIONS(2402),
    [anon_sym_i32] = ACTIONS(2402),
    [anon_sym_u64] = ACTIONS(2402),
    [anon_sym_i64] = ACTIONS(2402),
    [anon_sym_u128] = ACTIONS(2402),
    [anon_sym_i128] = ACTIONS(2402),
    [anon_sym_isize] = ACTIONS(2402),
    [anon_sym_usize] = ACTIONS(2402),
    [anon_sym_f32] = ACTIONS(2402),
    [anon_sym_f64] = ACTIONS(2402),
    [anon_sym_bool] = ACTIONS(2402),
    [anon_sym_str] = ACTIONS(2402),
    [anon_sym_char] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_PIPE] = ACTIONS(2400),
    [anon_sym_LT] = ACTIONS(2400),
    [anon_sym_DOT_DOT] = ACTIONS(2400),
    [anon_sym_COLON_COLON] = ACTIONS(2400),
    [anon_sym_POUND] = ACTIONS(2400),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_async] = ACTIONS(2402),
    [anon_sym_break] = ACTIONS(2402),
    [anon_sym_const] = ACTIONS(2402),
    [anon_sym_continue] = ACTIONS(2402),
    [anon_sym_default] = ACTIONS(2402),
    [anon_sym_enum] = ACTIONS(2402),
    [anon_sym_fn] = ACTIONS(2402),
    [anon_sym_for] = ACTIONS(2402),
    [anon_sym_if] = ACTIONS(2402),
    [anon_sym_impl] = ACTIONS(2402),
    [anon_sym_let] = ACTIONS(2402),
    [anon_sym_loop] = ACTIONS(2402),
    [anon_sym_match] = ACTIONS(2402),
    [anon_sym_mod] = ACTIONS(2402),
    [anon_sym_pub] = ACTIONS(2402),
    [anon_sym_return] = ACTIONS(2402),
    [anon_sym_static] = ACTIONS(2402),
    [anon_sym_struct] = ACTIONS(2402),
    [anon_sym_trait] = ACTIONS(2402),
    [anon_sym_type] = ACTIONS(2402),
    [anon_sym_union] = ACTIONS(2402),
    [anon_sym_unsafe] = ACTIONS(2402),
    [anon_sym_use] = ACTIONS(2402),
    [anon_sym_while] = ACTIONS(2402),
    [anon_sym_extern] = ACTIONS(2402),
    [anon_sym_yield] = ACTIONS(2402),
    [anon_sym_move] = ACTIONS(2402),
    [anon_sym_try] = ACTIONS(2402),
    [sym_integer_literal] = ACTIONS(2400),
    [aux_sym_string_literal_token1] = ACTIONS(2400),
    [sym_char_literal] = ACTIONS(2400),
    [anon_sym_true] = ACTIONS(2402),
    [anon_sym_false] = ACTIONS(2402),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2402),
    [sym_super] = ACTIONS(2402),
    [sym_crate] = ACTIONS(2402),
    [sym_metavariable] = ACTIONS(2400),
    [sym__raw_string_literal_start] = ACTIONS(2400),
    [sym_float_literal] = ACTIONS(2400),
  },
  [642] = {
    [sym_line_comment] = STATE(642),
    [sym_block_comment] = STATE(642),
    [ts_builtin_sym_end] = ACTIONS(2404),
    [sym_identifier] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2404),
    [anon_sym_macro_rules_BANG] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2404),
    [anon_sym_u8] = ACTIONS(2406),
    [anon_sym_i8] = ACTIONS(2406),
    [anon_sym_u16] = ACTIONS(2406),
    [anon_sym_i16] = ACTIONS(2406),
    [anon_sym_u32] = ACTIONS(2406),
    [anon_sym_i32] = ACTIONS(2406),
    [anon_sym_u64] = ACTIONS(2406),
    [anon_sym_i64] = ACTIONS(2406),
    [anon_sym_u128] = ACTIONS(2406),
    [anon_sym_i128] = ACTIONS(2406),
    [anon_sym_isize] = ACTIONS(2406),
    [anon_sym_usize] = ACTIONS(2406),
    [anon_sym_f32] = ACTIONS(2406),
    [anon_sym_f64] = ACTIONS(2406),
    [anon_sym_bool] = ACTIONS(2406),
    [anon_sym_str] = ACTIONS(2406),
    [anon_sym_char] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_BANG] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_PIPE] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(2404),
    [anon_sym_DOT_DOT] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2404),
    [anon_sym_POUND] = ACTIONS(2404),
    [anon_sym_SQUOTE] = ACTIONS(2406),
    [anon_sym_async] = ACTIONS(2406),
    [anon_sym_break] = ACTIONS(2406),
    [anon_sym_const] = ACTIONS(2406),
    [anon_sym_continue] = ACTIONS(2406),
    [anon_sym_default] = ACTIONS(2406),
    [anon_sym_enum] = ACTIONS(2406),
    [anon_sym_fn] = ACTIONS(2406),
    [anon_sym_for] = ACTIONS(2406),
    [anon_sym_if] = ACTIONS(2406),
    [anon_sym_impl] = ACTIONS(2406),
    [anon_sym_let] = ACTIONS(2406),
    [anon_sym_loop] = ACTIONS(2406),
    [anon_sym_match] = ACTIONS(2406),
    [anon_sym_mod] = ACTIONS(2406),
    [anon_sym_pub] = ACTIONS(2406),
    [anon_sym_return] = ACTIONS(2406),
    [anon_sym_static] = ACTIONS(2406),
    [anon_sym_struct] = ACTIONS(2406),
    [anon_sym_trait] = ACTIONS(2406),
    [anon_sym_type] = ACTIONS(2406),
    [anon_sym_union] = ACTIONS(2406),
    [anon_sym_unsafe] = ACTIONS(2406),
    [anon_sym_use] = ACTIONS(2406),
    [anon_sym_while] = ACTIONS(2406),
    [anon_sym_extern] = ACTIONS(2406),
    [anon_sym_yield] = ACTIONS(2406),
    [anon_sym_move] = ACTIONS(2406),
    [anon_sym_try] = ACTIONS(2406),
    [sym_integer_literal] = ACTIONS(2404),
    [aux_sym_string_literal_token1] = ACTIONS(2404),
    [sym_char_literal] = ACTIONS(2404),
    [anon_sym_true] = ACTIONS(2406),
    [anon_sym_false] = ACTIONS(2406),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2406),
    [sym_super] = ACTIONS(2406),
    [sym_crate] = ACTIONS(2406),
    [sym_metavariable] = ACTIONS(2404),
    [sym__raw_string_literal_start] = ACTIONS(2404),
    [sym_float_literal] = ACTIONS(2404),
  },
  [643] = {
    [sym_line_comment] = STATE(643),
    [sym_block_comment] = STATE(643),
    [ts_builtin_sym_end] = ACTIONS(2408),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_macro_rules_BANG] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2408),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_u8] = ACTIONS(2410),
    [anon_sym_i8] = ACTIONS(2410),
    [anon_sym_u16] = ACTIONS(2410),
    [anon_sym_i16] = ACTIONS(2410),
    [anon_sym_u32] = ACTIONS(2410),
    [anon_sym_i32] = ACTIONS(2410),
    [anon_sym_u64] = ACTIONS(2410),
    [anon_sym_i64] = ACTIONS(2410),
    [anon_sym_u128] = ACTIONS(2410),
    [anon_sym_i128] = ACTIONS(2410),
    [anon_sym_isize] = ACTIONS(2410),
    [anon_sym_usize] = ACTIONS(2410),
    [anon_sym_f32] = ACTIONS(2410),
    [anon_sym_f64] = ACTIONS(2410),
    [anon_sym_bool] = ACTIONS(2410),
    [anon_sym_str] = ACTIONS(2410),
    [anon_sym_char] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_DOT_DOT] = ACTIONS(2408),
    [anon_sym_COLON_COLON] = ACTIONS(2408),
    [anon_sym_POUND] = ACTIONS(2408),
    [anon_sym_SQUOTE] = ACTIONS(2410),
    [anon_sym_async] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_fn] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_impl] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_loop] = ACTIONS(2410),
    [anon_sym_match] = ACTIONS(2410),
    [anon_sym_mod] = ACTIONS(2410),
    [anon_sym_pub] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_trait] = ACTIONS(2410),
    [anon_sym_type] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [anon_sym_unsafe] = ACTIONS(2410),
    [anon_sym_use] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym_yield] = ACTIONS(2410),
    [anon_sym_move] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [sym_integer_literal] = ACTIONS(2408),
    [aux_sym_string_literal_token1] = ACTIONS(2408),
    [sym_char_literal] = ACTIONS(2408),
    [anon_sym_true] = ACTIONS(2410),
    [anon_sym_false] = ACTIONS(2410),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2410),
    [sym_super] = ACTIONS(2410),
    [sym_crate] = ACTIONS(2410),
    [sym_metavariable] = ACTIONS(2408),
    [sym__raw_string_literal_start] = ACTIONS(2408),
    [sym_float_literal] = ACTIONS(2408),
  },
  [644] = {
    [sym_line_comment] = STATE(644),
    [sym_block_comment] = STATE(644),
    [ts_builtin_sym_end] = ACTIONS(2412),
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym_macro_rules_BANG] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_u8] = ACTIONS(2414),
    [anon_sym_i8] = ACTIONS(2414),
    [anon_sym_u16] = ACTIONS(2414),
    [anon_sym_i16] = ACTIONS(2414),
    [anon_sym_u32] = ACTIONS(2414),
    [anon_sym_i32] = ACTIONS(2414),
    [anon_sym_u64] = ACTIONS(2414),
    [anon_sym_i64] = ACTIONS(2414),
    [anon_sym_u128] = ACTIONS(2414),
    [anon_sym_i128] = ACTIONS(2414),
    [anon_sym_isize] = ACTIONS(2414),
    [anon_sym_usize] = ACTIONS(2414),
    [anon_sym_f32] = ACTIONS(2414),
    [anon_sym_f64] = ACTIONS(2414),
    [anon_sym_bool] = ACTIONS(2414),
    [anon_sym_str] = ACTIONS(2414),
    [anon_sym_char] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2412),
    [anon_sym_DOT_DOT] = ACTIONS(2412),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_POUND] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2414),
    [anon_sym_async] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_fn] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_impl] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_loop] = ACTIONS(2414),
    [anon_sym_match] = ACTIONS(2414),
    [anon_sym_mod] = ACTIONS(2414),
    [anon_sym_pub] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_trait] = ACTIONS(2414),
    [anon_sym_type] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_unsafe] = ACTIONS(2414),
    [anon_sym_use] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym_yield] = ACTIONS(2414),
    [anon_sym_move] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [sym_integer_literal] = ACTIONS(2412),
    [aux_sym_string_literal_token1] = ACTIONS(2412),
    [sym_char_literal] = ACTIONS(2412),
    [anon_sym_true] = ACTIONS(2414),
    [anon_sym_false] = ACTIONS(2414),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2414),
    [sym_super] = ACTIONS(2414),
    [sym_crate] = ACTIONS(2414),
    [sym_metavariable] = ACTIONS(2412),
    [sym__raw_string_literal_start] = ACTIONS(2412),
    [sym_float_literal] = ACTIONS(2412),
  },
  [645] = {
    [sym_line_comment] = STATE(645),
    [sym_block_comment] = STATE(645),
    [ts_builtin_sym_end] = ACTIONS(1206),
    [sym_identifier] = ACTIONS(1208),
    [anon_sym_SEMI] = ACTIONS(1206),
    [anon_sym_macro_rules_BANG] = ACTIONS(1206),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_LBRACK] = ACTIONS(1206),
    [anon_sym_LBRACE] = ACTIONS(1206),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_STAR] = ACTIONS(1206),
    [anon_sym_u8] = ACTIONS(1208),
    [anon_sym_i8] = ACTIONS(1208),
    [anon_sym_u16] = ACTIONS(1208),
    [anon_sym_i16] = ACTIONS(1208),
    [anon_sym_u32] = ACTIONS(1208),
    [anon_sym_i32] = ACTIONS(1208),
    [anon_sym_u64] = ACTIONS(1208),
    [anon_sym_i64] = ACTIONS(1208),
    [anon_sym_u128] = ACTIONS(1208),
    [anon_sym_i128] = ACTIONS(1208),
    [anon_sym_isize] = ACTIONS(1208),
    [anon_sym_usize] = ACTIONS(1208),
    [anon_sym_f32] = ACTIONS(1208),
    [anon_sym_f64] = ACTIONS(1208),
    [anon_sym_bool] = ACTIONS(1208),
    [anon_sym_str] = ACTIONS(1208),
    [anon_sym_char] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1206),
    [anon_sym_BANG] = ACTIONS(1206),
    [anon_sym_AMP] = ACTIONS(1206),
    [anon_sym_PIPE] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1206),
    [anon_sym_DOT_DOT] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(1206),
    [anon_sym_POUND] = ACTIONS(1206),
    [anon_sym_SQUOTE] = ACTIONS(1208),
    [anon_sym_async] = ACTIONS(1208),
    [anon_sym_break] = ACTIONS(1208),
    [anon_sym_const] = ACTIONS(1208),
    [anon_sym_continue] = ACTIONS(1208),
    [anon_sym_default] = ACTIONS(1208),
    [anon_sym_enum] = ACTIONS(1208),
    [anon_sym_fn] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1208),
    [anon_sym_if] = ACTIONS(1208),
    [anon_sym_impl] = ACTIONS(1208),
    [anon_sym_let] = ACTIONS(1208),
    [anon_sym_loop] = ACTIONS(1208),
    [anon_sym_match] = ACTIONS(1208),
    [anon_sym_mod] = ACTIONS(1208),
    [anon_sym_pub] = ACTIONS(1208),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_static] = ACTIONS(1208),
    [anon_sym_struct] = ACTIONS(1208),
    [anon_sym_trait] = ACTIONS(1208),
    [anon_sym_type] = ACTIONS(1208),
    [anon_sym_union] = ACTIONS(1208),
    [anon_sym_unsafe] = ACTIONS(1208),
    [anon_sym_use] = ACTIONS(1208),
    [anon_sym_while] = ACTIONS(1208),
    [anon_sym_extern] = ACTIONS(1208),
    [anon_sym_yield] = ACTIONS(1208),
    [anon_sym_move] = ACTIONS(1208),
    [anon_sym_try] = ACTIONS(1208),
    [sym_integer_literal] = ACTIONS(1206),
    [aux_sym_string_literal_token1] = ACTIONS(1206),
    [sym_char_literal] = ACTIONS(1206),
    [anon_sym_true] = ACTIONS(1208),
    [anon_sym_false] = ACTIONS(1208),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1208),
    [sym_super] = ACTIONS(1208),
    [sym_crate] = ACTIONS(1208),
    [sym_metavariable] = ACTIONS(1206),
    [sym__raw_string_literal_start] = ACTIONS(1206),
    [sym_float_literal] = ACTIONS(1206),
  },
  [646] = {
    [sym_line_comment] = STATE(646),
    [sym_block_comment] = STATE(646),
    [ts_builtin_sym_end] = ACTIONS(2416),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_macro_rules_BANG] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_u8] = ACTIONS(2418),
    [anon_sym_i8] = ACTIONS(2418),
    [anon_sym_u16] = ACTIONS(2418),
    [anon_sym_i16] = ACTIONS(2418),
    [anon_sym_u32] = ACTIONS(2418),
    [anon_sym_i32] = ACTIONS(2418),
    [anon_sym_u64] = ACTIONS(2418),
    [anon_sym_i64] = ACTIONS(2418),
    [anon_sym_u128] = ACTIONS(2418),
    [anon_sym_i128] = ACTIONS(2418),
    [anon_sym_isize] = ACTIONS(2418),
    [anon_sym_usize] = ACTIONS(2418),
    [anon_sym_f32] = ACTIONS(2418),
    [anon_sym_f64] = ACTIONS(2418),
    [anon_sym_bool] = ACTIONS(2418),
    [anon_sym_str] = ACTIONS(2418),
    [anon_sym_char] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_DOT_DOT] = ACTIONS(2416),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_POUND] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2418),
    [anon_sym_async] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_fn] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_impl] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_loop] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_mod] = ACTIONS(2418),
    [anon_sym_pub] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_trait] = ACTIONS(2418),
    [anon_sym_type] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [anon_sym_unsafe] = ACTIONS(2418),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_move] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [sym_integer_literal] = ACTIONS(2416),
    [aux_sym_string_literal_token1] = ACTIONS(2416),
    [sym_char_literal] = ACTIONS(2416),
    [anon_sym_true] = ACTIONS(2418),
    [anon_sym_false] = ACTIONS(2418),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2418),
    [sym_super] = ACTIONS(2418),
    [sym_crate] = ACTIONS(2418),
    [sym_metavariable] = ACTIONS(2416),
    [sym__raw_string_literal_start] = ACTIONS(2416),
    [sym_float_literal] = ACTIONS(2416),
  },
  [647] = {
    [sym_line_comment] = STATE(647),
    [sym_block_comment] = STATE(647),
    [ts_builtin_sym_end] = ACTIONS(2420),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_macro_rules_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_u8] = ACTIONS(2422),
    [anon_sym_i8] = ACTIONS(2422),
    [anon_sym_u16] = ACTIONS(2422),
    [anon_sym_i16] = ACTIONS(2422),
    [anon_sym_u32] = ACTIONS(2422),
    [anon_sym_i32] = ACTIONS(2422),
    [anon_sym_u64] = ACTIONS(2422),
    [anon_sym_i64] = ACTIONS(2422),
    [anon_sym_u128] = ACTIONS(2422),
    [anon_sym_i128] = ACTIONS(2422),
    [anon_sym_isize] = ACTIONS(2422),
    [anon_sym_usize] = ACTIONS(2422),
    [anon_sym_f32] = ACTIONS(2422),
    [anon_sym_f64] = ACTIONS(2422),
    [anon_sym_bool] = ACTIONS(2422),
    [anon_sym_str] = ACTIONS(2422),
    [anon_sym_char] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_POUND] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2422),
    [anon_sym_async] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_fn] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_impl] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_loop] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_mod] = ACTIONS(2422),
    [anon_sym_pub] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_trait] = ACTIONS(2422),
    [anon_sym_type] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_unsafe] = ACTIONS(2422),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_move] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [sym_integer_literal] = ACTIONS(2420),
    [aux_sym_string_literal_token1] = ACTIONS(2420),
    [sym_char_literal] = ACTIONS(2420),
    [anon_sym_true] = ACTIONS(2422),
    [anon_sym_false] = ACTIONS(2422),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2422),
    [sym_super] = ACTIONS(2422),
    [sym_crate] = ACTIONS(2422),
    [sym_metavariable] = ACTIONS(2420),
    [sym__raw_string_literal_start] = ACTIONS(2420),
    [sym_float_literal] = ACTIONS(2420),
  },
  [648] = {
    [sym_line_comment] = STATE(648),
    [sym_block_comment] = STATE(648),
    [ts_builtin_sym_end] = ACTIONS(2424),
    [sym_identifier] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_macro_rules_BANG] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_STAR] = ACTIONS(2424),
    [anon_sym_u8] = ACTIONS(2426),
    [anon_sym_i8] = ACTIONS(2426),
    [anon_sym_u16] = ACTIONS(2426),
    [anon_sym_i16] = ACTIONS(2426),
    [anon_sym_u32] = ACTIONS(2426),
    [anon_sym_i32] = ACTIONS(2426),
    [anon_sym_u64] = ACTIONS(2426),
    [anon_sym_i64] = ACTIONS(2426),
    [anon_sym_u128] = ACTIONS(2426),
    [anon_sym_i128] = ACTIONS(2426),
    [anon_sym_isize] = ACTIONS(2426),
    [anon_sym_usize] = ACTIONS(2426),
    [anon_sym_f32] = ACTIONS(2426),
    [anon_sym_f64] = ACTIONS(2426),
    [anon_sym_bool] = ACTIONS(2426),
    [anon_sym_str] = ACTIONS(2426),
    [anon_sym_char] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_DOT_DOT] = ACTIONS(2424),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_POUND] = ACTIONS(2424),
    [anon_sym_SQUOTE] = ACTIONS(2426),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_break] = ACTIONS(2426),
    [anon_sym_const] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(2426),
    [anon_sym_default] = ACTIONS(2426),
    [anon_sym_enum] = ACTIONS(2426),
    [anon_sym_fn] = ACTIONS(2426),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_impl] = ACTIONS(2426),
    [anon_sym_let] = ACTIONS(2426),
    [anon_sym_loop] = ACTIONS(2426),
    [anon_sym_match] = ACTIONS(2426),
    [anon_sym_mod] = ACTIONS(2426),
    [anon_sym_pub] = ACTIONS(2426),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2426),
    [anon_sym_struct] = ACTIONS(2426),
    [anon_sym_trait] = ACTIONS(2426),
    [anon_sym_type] = ACTIONS(2426),
    [anon_sym_union] = ACTIONS(2426),
    [anon_sym_unsafe] = ACTIONS(2426),
    [anon_sym_use] = ACTIONS(2426),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_extern] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [anon_sym_move] = ACTIONS(2426),
    [anon_sym_try] = ACTIONS(2426),
    [sym_integer_literal] = ACTIONS(2424),
    [aux_sym_string_literal_token1] = ACTIONS(2424),
    [sym_char_literal] = ACTIONS(2424),
    [anon_sym_true] = ACTIONS(2426),
    [anon_sym_false] = ACTIONS(2426),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2426),
    [sym_super] = ACTIONS(2426),
    [sym_crate] = ACTIONS(2426),
    [sym_metavariable] = ACTIONS(2424),
    [sym__raw_string_literal_start] = ACTIONS(2424),
    [sym_float_literal] = ACTIONS(2424),
  },
  [649] = {
    [sym_line_comment] = STATE(649),
    [sym_block_comment] = STATE(649),
    [ts_builtin_sym_end] = ACTIONS(2428),
    [sym_identifier] = ACTIONS(2430),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_macro_rules_BANG] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_u8] = ACTIONS(2430),
    [anon_sym_i8] = ACTIONS(2430),
    [anon_sym_u16] = ACTIONS(2430),
    [anon_sym_i16] = ACTIONS(2430),
    [anon_sym_u32] = ACTIONS(2430),
    [anon_sym_i32] = ACTIONS(2430),
    [anon_sym_u64] = ACTIONS(2430),
    [anon_sym_i64] = ACTIONS(2430),
    [anon_sym_u128] = ACTIONS(2430),
    [anon_sym_i128] = ACTIONS(2430),
    [anon_sym_isize] = ACTIONS(2430),
    [anon_sym_usize] = ACTIONS(2430),
    [anon_sym_f32] = ACTIONS(2430),
    [anon_sym_f64] = ACTIONS(2430),
    [anon_sym_bool] = ACTIONS(2430),
    [anon_sym_str] = ACTIONS(2430),
    [anon_sym_char] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2428),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2428),
    [anon_sym_DOT_DOT] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(2428),
    [anon_sym_POUND] = ACTIONS(2428),
    [anon_sym_SQUOTE] = ACTIONS(2430),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_break] = ACTIONS(2430),
    [anon_sym_const] = ACTIONS(2430),
    [anon_sym_continue] = ACTIONS(2430),
    [anon_sym_default] = ACTIONS(2430),
    [anon_sym_enum] = ACTIONS(2430),
    [anon_sym_fn] = ACTIONS(2430),
    [anon_sym_for] = ACTIONS(2430),
    [anon_sym_if] = ACTIONS(2430),
    [anon_sym_impl] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_loop] = ACTIONS(2430),
    [anon_sym_match] = ACTIONS(2430),
    [anon_sym_mod] = ACTIONS(2430),
    [anon_sym_pub] = ACTIONS(2430),
    [anon_sym_return] = ACTIONS(2430),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_struct] = ACTIONS(2430),
    [anon_sym_trait] = ACTIONS(2430),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_union] = ACTIONS(2430),
    [anon_sym_unsafe] = ACTIONS(2430),
    [anon_sym_use] = ACTIONS(2430),
    [anon_sym_while] = ACTIONS(2430),
    [anon_sym_extern] = ACTIONS(2430),
    [anon_sym_yield] = ACTIONS(2430),
    [anon_sym_move] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2430),
    [sym_integer_literal] = ACTIONS(2428),
    [aux_sym_string_literal_token1] = ACTIONS(2428),
    [sym_char_literal] = ACTIONS(2428),
    [anon_sym_true] = ACTIONS(2430),
    [anon_sym_false] = ACTIONS(2430),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2430),
    [sym_super] = ACTIONS(2430),
    [sym_crate] = ACTIONS(2430),
    [sym_metavariable] = ACTIONS(2428),
    [sym__raw_string_literal_start] = ACTIONS(2428),
    [sym_float_literal] = ACTIONS(2428),
  },
  [650] = {
    [sym_line_comment] = STATE(650),
    [sym_block_comment] = STATE(650),
    [ts_builtin_sym_end] = ACTIONS(2432),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_macro_rules_BANG] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LBRACE] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_STAR] = ACTIONS(2432),
    [anon_sym_u8] = ACTIONS(2434),
    [anon_sym_i8] = ACTIONS(2434),
    [anon_sym_u16] = ACTIONS(2434),
    [anon_sym_i16] = ACTIONS(2434),
    [anon_sym_u32] = ACTIONS(2434),
    [anon_sym_i32] = ACTIONS(2434),
    [anon_sym_u64] = ACTIONS(2434),
    [anon_sym_i64] = ACTIONS(2434),
    [anon_sym_u128] = ACTIONS(2434),
    [anon_sym_i128] = ACTIONS(2434),
    [anon_sym_isize] = ACTIONS(2434),
    [anon_sym_usize] = ACTIONS(2434),
    [anon_sym_f32] = ACTIONS(2434),
    [anon_sym_f64] = ACTIONS(2434),
    [anon_sym_bool] = ACTIONS(2434),
    [anon_sym_str] = ACTIONS(2434),
    [anon_sym_char] = ACTIONS(2434),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2432),
    [anon_sym_DOT_DOT] = ACTIONS(2432),
    [anon_sym_COLON_COLON] = ACTIONS(2432),
    [anon_sym_POUND] = ACTIONS(2432),
    [anon_sym_SQUOTE] = ACTIONS(2434),
    [anon_sym_async] = ACTIONS(2434),
    [anon_sym_break] = ACTIONS(2434),
    [anon_sym_const] = ACTIONS(2434),
    [anon_sym_continue] = ACTIONS(2434),
    [anon_sym_default] = ACTIONS(2434),
    [anon_sym_enum] = ACTIONS(2434),
    [anon_sym_fn] = ACTIONS(2434),
    [anon_sym_for] = ACTIONS(2434),
    [anon_sym_if] = ACTIONS(2434),
    [anon_sym_impl] = ACTIONS(2434),
    [anon_sym_let] = ACTIONS(2434),
    [anon_sym_loop] = ACTIONS(2434),
    [anon_sym_match] = ACTIONS(2434),
    [anon_sym_mod] = ACTIONS(2434),
    [anon_sym_pub] = ACTIONS(2434),
    [anon_sym_return] = ACTIONS(2434),
    [anon_sym_static] = ACTIONS(2434),
    [anon_sym_struct] = ACTIONS(2434),
    [anon_sym_trait] = ACTIONS(2434),
    [anon_sym_type] = ACTIONS(2434),
    [anon_sym_union] = ACTIONS(2434),
    [anon_sym_unsafe] = ACTIONS(2434),
    [anon_sym_use] = ACTIONS(2434),
    [anon_sym_while] = ACTIONS(2434),
    [anon_sym_extern] = ACTIONS(2434),
    [anon_sym_yield] = ACTIONS(2434),
    [anon_sym_move] = ACTIONS(2434),
    [anon_sym_try] = ACTIONS(2434),
    [sym_integer_literal] = ACTIONS(2432),
    [aux_sym_string_literal_token1] = ACTIONS(2432),
    [sym_char_literal] = ACTIONS(2432),
    [anon_sym_true] = ACTIONS(2434),
    [anon_sym_false] = ACTIONS(2434),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2434),
    [sym_super] = ACTIONS(2434),
    [sym_crate] = ACTIONS(2434),
    [sym_metavariable] = ACTIONS(2432),
    [sym__raw_string_literal_start] = ACTIONS(2432),
    [sym_float_literal] = ACTIONS(2432),
  },
  [651] = {
    [sym_line_comment] = STATE(651),
    [sym_block_comment] = STATE(651),
    [ts_builtin_sym_end] = ACTIONS(2436),
    [sym_identifier] = ACTIONS(2438),
    [anon_sym_SEMI] = ACTIONS(2436),
    [anon_sym_macro_rules_BANG] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_STAR] = ACTIONS(2436),
    [anon_sym_u8] = ACTIONS(2438),
    [anon_sym_i8] = ACTIONS(2438),
    [anon_sym_u16] = ACTIONS(2438),
    [anon_sym_i16] = ACTIONS(2438),
    [anon_sym_u32] = ACTIONS(2438),
    [anon_sym_i32] = ACTIONS(2438),
    [anon_sym_u64] = ACTIONS(2438),
    [anon_sym_i64] = ACTIONS(2438),
    [anon_sym_u128] = ACTIONS(2438),
    [anon_sym_i128] = ACTIONS(2438),
    [anon_sym_isize] = ACTIONS(2438),
    [anon_sym_usize] = ACTIONS(2438),
    [anon_sym_f32] = ACTIONS(2438),
    [anon_sym_f64] = ACTIONS(2438),
    [anon_sym_bool] = ACTIONS(2438),
    [anon_sym_str] = ACTIONS(2438),
    [anon_sym_char] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_DOT_DOT] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(2436),
    [anon_sym_POUND] = ACTIONS(2436),
    [anon_sym_SQUOTE] = ACTIONS(2438),
    [anon_sym_async] = ACTIONS(2438),
    [anon_sym_break] = ACTIONS(2438),
    [anon_sym_const] = ACTIONS(2438),
    [anon_sym_continue] = ACTIONS(2438),
    [anon_sym_default] = ACTIONS(2438),
    [anon_sym_enum] = ACTIONS(2438),
    [anon_sym_fn] = ACTIONS(2438),
    [anon_sym_for] = ACTIONS(2438),
    [anon_sym_if] = ACTIONS(2438),
    [anon_sym_impl] = ACTIONS(2438),
    [anon_sym_let] = ACTIONS(2438),
    [anon_sym_loop] = ACTIONS(2438),
    [anon_sym_match] = ACTIONS(2438),
    [anon_sym_mod] = ACTIONS(2438),
    [anon_sym_pub] = ACTIONS(2438),
    [anon_sym_return] = ACTIONS(2438),
    [anon_sym_static] = ACTIONS(2438),
    [anon_sym_struct] = ACTIONS(2438),
    [anon_sym_trait] = ACTIONS(2438),
    [anon_sym_type] = ACTIONS(2438),
    [anon_sym_union] = ACTIONS(2438),
    [anon_sym_unsafe] = ACTIONS(2438),
    [anon_sym_use] = ACTIONS(2438),
    [anon_sym_while] = ACTIONS(2438),
    [anon_sym_extern] = ACTIONS(2438),
    [anon_sym_yield] = ACTIONS(2438),
    [anon_sym_move] = ACTIONS(2438),
    [anon_sym_try] = ACTIONS(2438),
    [sym_integer_literal] = ACTIONS(2436),
    [aux_sym_string_literal_token1] = ACTIONS(2436),
    [sym_char_literal] = ACTIONS(2436),
    [anon_sym_true] = ACTIONS(2438),
    [anon_sym_false] = ACTIONS(2438),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2438),
    [sym_super] = ACTIONS(2438),
    [sym_crate] = ACTIONS(2438),
    [sym_metavariable] = ACTIONS(2436),
    [sym__raw_string_literal_start] = ACTIONS(2436),
    [sym_float_literal] = ACTIONS(2436),
  },
  [652] = {
    [sym_line_comment] = STATE(652),
    [sym_block_comment] = STATE(652),
    [ts_builtin_sym_end] = ACTIONS(2440),
    [sym_identifier] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_macro_rules_BANG] = ACTIONS(2440),
    [anon_sym_LPAREN] = ACTIONS(2440),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_STAR] = ACTIONS(2440),
    [anon_sym_u8] = ACTIONS(2442),
    [anon_sym_i8] = ACTIONS(2442),
    [anon_sym_u16] = ACTIONS(2442),
    [anon_sym_i16] = ACTIONS(2442),
    [anon_sym_u32] = ACTIONS(2442),
    [anon_sym_i32] = ACTIONS(2442),
    [anon_sym_u64] = ACTIONS(2442),
    [anon_sym_i64] = ACTIONS(2442),
    [anon_sym_u128] = ACTIONS(2442),
    [anon_sym_i128] = ACTIONS(2442),
    [anon_sym_isize] = ACTIONS(2442),
    [anon_sym_usize] = ACTIONS(2442),
    [anon_sym_f32] = ACTIONS(2442),
    [anon_sym_f64] = ACTIONS(2442),
    [anon_sym_bool] = ACTIONS(2442),
    [anon_sym_str] = ACTIONS(2442),
    [anon_sym_char] = ACTIONS(2442),
    [anon_sym_DASH] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2440),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_DOT_DOT] = ACTIONS(2440),
    [anon_sym_COLON_COLON] = ACTIONS(2440),
    [anon_sym_POUND] = ACTIONS(2440),
    [anon_sym_SQUOTE] = ACTIONS(2442),
    [anon_sym_async] = ACTIONS(2442),
    [anon_sym_break] = ACTIONS(2442),
    [anon_sym_const] = ACTIONS(2442),
    [anon_sym_continue] = ACTIONS(2442),
    [anon_sym_default] = ACTIONS(2442),
    [anon_sym_enum] = ACTIONS(2442),
    [anon_sym_fn] = ACTIONS(2442),
    [anon_sym_for] = ACTIONS(2442),
    [anon_sym_if] = ACTIONS(2442),
    [anon_sym_impl] = ACTIONS(2442),
    [anon_sym_let] = ACTIONS(2442),
    [anon_sym_loop] = ACTIONS(2442),
    [anon_sym_match] = ACTIONS(2442),
    [anon_sym_mod] = ACTIONS(2442),
    [anon_sym_pub] = ACTIONS(2442),
    [anon_sym_return] = ACTIONS(2442),
    [anon_sym_static] = ACTIONS(2442),
    [anon_sym_struct] = ACTIONS(2442),
    [anon_sym_trait] = ACTIONS(2442),
    [anon_sym_type] = ACTIONS(2442),
    [anon_sym_union] = ACTIONS(2442),
    [anon_sym_unsafe] = ACTIONS(2442),
    [anon_sym_use] = ACTIONS(2442),
    [anon_sym_while] = ACTIONS(2442),
    [anon_sym_extern] = ACTIONS(2442),
    [anon_sym_yield] = ACTIONS(2442),
    [anon_sym_move] = ACTIONS(2442),
    [anon_sym_try] = ACTIONS(2442),
    [sym_integer_literal] = ACTIONS(2440),
    [aux_sym_string_literal_token1] = ACTIONS(2440),
    [sym_char_literal] = ACTIONS(2440),
    [anon_sym_true] = ACTIONS(2442),
    [anon_sym_false] = ACTIONS(2442),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2442),
    [sym_super] = ACTIONS(2442),
    [sym_crate] = ACTIONS(2442),
    [sym_metavariable] = ACTIONS(2440),
    [sym__raw_string_literal_start] = ACTIONS(2440),
    [sym_float_literal] = ACTIONS(2440),
  },
  [653] = {
    [sym_line_comment] = STATE(653),
    [sym_block_comment] = STATE(653),
    [ts_builtin_sym_end] = ACTIONS(2444),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_macro_rules_BANG] = ACTIONS(2444),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_STAR] = ACTIONS(2444),
    [anon_sym_u8] = ACTIONS(2446),
    [anon_sym_i8] = ACTIONS(2446),
    [anon_sym_u16] = ACTIONS(2446),
    [anon_sym_i16] = ACTIONS(2446),
    [anon_sym_u32] = ACTIONS(2446),
    [anon_sym_i32] = ACTIONS(2446),
    [anon_sym_u64] = ACTIONS(2446),
    [anon_sym_i64] = ACTIONS(2446),
    [anon_sym_u128] = ACTIONS(2446),
    [anon_sym_i128] = ACTIONS(2446),
    [anon_sym_isize] = ACTIONS(2446),
    [anon_sym_usize] = ACTIONS(2446),
    [anon_sym_f32] = ACTIONS(2446),
    [anon_sym_f64] = ACTIONS(2446),
    [anon_sym_bool] = ACTIONS(2446),
    [anon_sym_str] = ACTIONS(2446),
    [anon_sym_char] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_DOT_DOT] = ACTIONS(2444),
    [anon_sym_COLON_COLON] = ACTIONS(2444),
    [anon_sym_POUND] = ACTIONS(2444),
    [anon_sym_SQUOTE] = ACTIONS(2446),
    [anon_sym_async] = ACTIONS(2446),
    [anon_sym_break] = ACTIONS(2446),
    [anon_sym_const] = ACTIONS(2446),
    [anon_sym_continue] = ACTIONS(2446),
    [anon_sym_default] = ACTIONS(2446),
    [anon_sym_enum] = ACTIONS(2446),
    [anon_sym_fn] = ACTIONS(2446),
    [anon_sym_for] = ACTIONS(2446),
    [anon_sym_if] = ACTIONS(2446),
    [anon_sym_impl] = ACTIONS(2446),
    [anon_sym_let] = ACTIONS(2446),
    [anon_sym_loop] = ACTIONS(2446),
    [anon_sym_match] = ACTIONS(2446),
    [anon_sym_mod] = ACTIONS(2446),
    [anon_sym_pub] = ACTIONS(2446),
    [anon_sym_return] = ACTIONS(2446),
    [anon_sym_static] = ACTIONS(2446),
    [anon_sym_struct] = ACTIONS(2446),
    [anon_sym_trait] = ACTIONS(2446),
    [anon_sym_type] = ACTIONS(2446),
    [anon_sym_union] = ACTIONS(2446),
    [anon_sym_unsafe] = ACTIONS(2446),
    [anon_sym_use] = ACTIONS(2446),
    [anon_sym_while] = ACTIONS(2446),
    [anon_sym_extern] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2446),
    [anon_sym_move] = ACTIONS(2446),
    [anon_sym_try] = ACTIONS(2446),
    [sym_integer_literal] = ACTIONS(2444),
    [aux_sym_string_literal_token1] = ACTIONS(2444),
    [sym_char_literal] = ACTIONS(2444),
    [anon_sym_true] = ACTIONS(2446),
    [anon_sym_false] = ACTIONS(2446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2446),
    [sym_super] = ACTIONS(2446),
    [sym_crate] = ACTIONS(2446),
    [sym_metavariable] = ACTIONS(2444),
    [sym__raw_string_literal_start] = ACTIONS(2444),
    [sym_float_literal] = ACTIONS(2444),
  },
  [654] = {
    [sym_line_comment] = STATE(654),
    [sym_block_comment] = STATE(654),
    [ts_builtin_sym_end] = ACTIONS(2448),
    [sym_identifier] = ACTIONS(2450),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_macro_rules_BANG] = ACTIONS(2448),
    [anon_sym_LPAREN] = ACTIONS(2448),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_LBRACE] = ACTIONS(2448),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2448),
    [anon_sym_u8] = ACTIONS(2450),
    [anon_sym_i8] = ACTIONS(2450),
    [anon_sym_u16] = ACTIONS(2450),
    [anon_sym_i16] = ACTIONS(2450),
    [anon_sym_u32] = ACTIONS(2450),
    [anon_sym_i32] = ACTIONS(2450),
    [anon_sym_u64] = ACTIONS(2450),
    [anon_sym_i64] = ACTIONS(2450),
    [anon_sym_u128] = ACTIONS(2450),
    [anon_sym_i128] = ACTIONS(2450),
    [anon_sym_isize] = ACTIONS(2450),
    [anon_sym_usize] = ACTIONS(2450),
    [anon_sym_f32] = ACTIONS(2450),
    [anon_sym_f64] = ACTIONS(2450),
    [anon_sym_bool] = ACTIONS(2450),
    [anon_sym_str] = ACTIONS(2450),
    [anon_sym_char] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_PIPE] = ACTIONS(2448),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_DOT_DOT] = ACTIONS(2448),
    [anon_sym_COLON_COLON] = ACTIONS(2448),
    [anon_sym_POUND] = ACTIONS(2448),
    [anon_sym_SQUOTE] = ACTIONS(2450),
    [anon_sym_async] = ACTIONS(2450),
    [anon_sym_break] = ACTIONS(2450),
    [anon_sym_const] = ACTIONS(2450),
    [anon_sym_continue] = ACTIONS(2450),
    [anon_sym_default] = ACTIONS(2450),
    [anon_sym_enum] = ACTIONS(2450),
    [anon_sym_fn] = ACTIONS(2450),
    [anon_sym_for] = ACTIONS(2450),
    [anon_sym_if] = ACTIONS(2450),
    [anon_sym_impl] = ACTIONS(2450),
    [anon_sym_let] = ACTIONS(2450),
    [anon_sym_loop] = ACTIONS(2450),
    [anon_sym_match] = ACTIONS(2450),
    [anon_sym_mod] = ACTIONS(2450),
    [anon_sym_pub] = ACTIONS(2450),
    [anon_sym_return] = ACTIONS(2450),
    [anon_sym_static] = ACTIONS(2450),
    [anon_sym_struct] = ACTIONS(2450),
    [anon_sym_trait] = ACTIONS(2450),
    [anon_sym_type] = ACTIONS(2450),
    [anon_sym_union] = ACTIONS(2450),
    [anon_sym_unsafe] = ACTIONS(2450),
    [anon_sym_use] = ACTIONS(2450),
    [anon_sym_while] = ACTIONS(2450),
    [anon_sym_extern] = ACTIONS(2450),
    [anon_sym_yield] = ACTIONS(2450),
    [anon_sym_move] = ACTIONS(2450),
    [anon_sym_try] = ACTIONS(2450),
    [sym_integer_literal] = ACTIONS(2448),
    [aux_sym_string_literal_token1] = ACTIONS(2448),
    [sym_char_literal] = ACTIONS(2448),
    [anon_sym_true] = ACTIONS(2450),
    [anon_sym_false] = ACTIONS(2450),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2450),
    [sym_super] = ACTIONS(2450),
    [sym_crate] = ACTIONS(2450),
    [sym_metavariable] = ACTIONS(2448),
    [sym__raw_string_literal_start] = ACTIONS(2448),
    [sym_float_literal] = ACTIONS(2448),
  },
  [655] = {
    [sym_line_comment] = STATE(655),
    [sym_block_comment] = STATE(655),
    [ts_builtin_sym_end] = ACTIONS(2452),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_macro_rules_BANG] = ACTIONS(2452),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_u8] = ACTIONS(2454),
    [anon_sym_i8] = ACTIONS(2454),
    [anon_sym_u16] = ACTIONS(2454),
    [anon_sym_i16] = ACTIONS(2454),
    [anon_sym_u32] = ACTIONS(2454),
    [anon_sym_i32] = ACTIONS(2454),
    [anon_sym_u64] = ACTIONS(2454),
    [anon_sym_i64] = ACTIONS(2454),
    [anon_sym_u128] = ACTIONS(2454),
    [anon_sym_i128] = ACTIONS(2454),
    [anon_sym_isize] = ACTIONS(2454),
    [anon_sym_usize] = ACTIONS(2454),
    [anon_sym_f32] = ACTIONS(2454),
    [anon_sym_f64] = ACTIONS(2454),
    [anon_sym_bool] = ACTIONS(2454),
    [anon_sym_str] = ACTIONS(2454),
    [anon_sym_char] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_DOT_DOT] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2452),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_SQUOTE] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_break] = ACTIONS(2454),
    [anon_sym_const] = ACTIONS(2454),
    [anon_sym_continue] = ACTIONS(2454),
    [anon_sym_default] = ACTIONS(2454),
    [anon_sym_enum] = ACTIONS(2454),
    [anon_sym_fn] = ACTIONS(2454),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_impl] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_loop] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_mod] = ACTIONS(2454),
    [anon_sym_pub] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_struct] = ACTIONS(2454),
    [anon_sym_trait] = ACTIONS(2454),
    [anon_sym_type] = ACTIONS(2454),
    [anon_sym_union] = ACTIONS(2454),
    [anon_sym_unsafe] = ACTIONS(2454),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_extern] = ACTIONS(2454),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_move] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [sym_integer_literal] = ACTIONS(2452),
    [aux_sym_string_literal_token1] = ACTIONS(2452),
    [sym_char_literal] = ACTIONS(2452),
    [anon_sym_true] = ACTIONS(2454),
    [anon_sym_false] = ACTIONS(2454),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2454),
    [sym_super] = ACTIONS(2454),
    [sym_crate] = ACTIONS(2454),
    [sym_metavariable] = ACTIONS(2452),
    [sym__raw_string_literal_start] = ACTIONS(2452),
    [sym_float_literal] = ACTIONS(2452),
  },
  [656] = {
    [sym_line_comment] = STATE(656),
    [sym_block_comment] = STATE(656),
    [ts_builtin_sym_end] = ACTIONS(2456),
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_macro_rules_BANG] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(2456),
    [anon_sym_u8] = ACTIONS(2458),
    [anon_sym_i8] = ACTIONS(2458),
    [anon_sym_u16] = ACTIONS(2458),
    [anon_sym_i16] = ACTIONS(2458),
    [anon_sym_u32] = ACTIONS(2458),
    [anon_sym_i32] = ACTIONS(2458),
    [anon_sym_u64] = ACTIONS(2458),
    [anon_sym_i64] = ACTIONS(2458),
    [anon_sym_u128] = ACTIONS(2458),
    [anon_sym_i128] = ACTIONS(2458),
    [anon_sym_isize] = ACTIONS(2458),
    [anon_sym_usize] = ACTIONS(2458),
    [anon_sym_f32] = ACTIONS(2458),
    [anon_sym_f64] = ACTIONS(2458),
    [anon_sym_bool] = ACTIONS(2458),
    [anon_sym_str] = ACTIONS(2458),
    [anon_sym_char] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_DOT_DOT] = ACTIONS(2456),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_POUND] = ACTIONS(2456),
    [anon_sym_SQUOTE] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_default] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
    [anon_sym_fn] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_impl] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_loop] = ACTIONS(2458),
    [anon_sym_match] = ACTIONS(2458),
    [anon_sym_mod] = ACTIONS(2458),
    [anon_sym_pub] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_struct] = ACTIONS(2458),
    [anon_sym_trait] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_union] = ACTIONS(2458),
    [anon_sym_unsafe] = ACTIONS(2458),
    [anon_sym_use] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_extern] = ACTIONS(2458),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_move] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [sym_integer_literal] = ACTIONS(2456),
    [aux_sym_string_literal_token1] = ACTIONS(2456),
    [sym_char_literal] = ACTIONS(2456),
    [anon_sym_true] = ACTIONS(2458),
    [anon_sym_false] = ACTIONS(2458),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_crate] = ACTIONS(2458),
    [sym_metavariable] = ACTIONS(2456),
    [sym__raw_string_literal_start] = ACTIONS(2456),
    [sym_float_literal] = ACTIONS(2456),
  },
  [657] = {
    [sym_line_comment] = STATE(657),
    [sym_block_comment] = STATE(657),
    [ts_builtin_sym_end] = ACTIONS(2460),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_macro_rules_BANG] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_RBRACE] = ACTIONS(2460),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_u8] = ACTIONS(2462),
    [anon_sym_i8] = ACTIONS(2462),
    [anon_sym_u16] = ACTIONS(2462),
    [anon_sym_i16] = ACTIONS(2462),
    [anon_sym_u32] = ACTIONS(2462),
    [anon_sym_i32] = ACTIONS(2462),
    [anon_sym_u64] = ACTIONS(2462),
    [anon_sym_i64] = ACTIONS(2462),
    [anon_sym_u128] = ACTIONS(2462),
    [anon_sym_i128] = ACTIONS(2462),
    [anon_sym_isize] = ACTIONS(2462),
    [anon_sym_usize] = ACTIONS(2462),
    [anon_sym_f32] = ACTIONS(2462),
    [anon_sym_f64] = ACTIONS(2462),
    [anon_sym_bool] = ACTIONS(2462),
    [anon_sym_str] = ACTIONS(2462),
    [anon_sym_char] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_COLON_COLON] = ACTIONS(2460),
    [anon_sym_POUND] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2462),
    [anon_sym_async] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_fn] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_impl] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_loop] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_mod] = ACTIONS(2462),
    [anon_sym_pub] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_trait] = ACTIONS(2462),
    [anon_sym_type] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [anon_sym_unsafe] = ACTIONS(2462),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_move] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [sym_integer_literal] = ACTIONS(2460),
    [aux_sym_string_literal_token1] = ACTIONS(2460),
    [sym_char_literal] = ACTIONS(2460),
    [anon_sym_true] = ACTIONS(2462),
    [anon_sym_false] = ACTIONS(2462),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2462),
    [sym_super] = ACTIONS(2462),
    [sym_crate] = ACTIONS(2462),
    [sym_metavariable] = ACTIONS(2460),
    [sym__raw_string_literal_start] = ACTIONS(2460),
    [sym_float_literal] = ACTIONS(2460),
  },
  [658] = {
    [sym_line_comment] = STATE(658),
    [sym_block_comment] = STATE(658),
    [ts_builtin_sym_end] = ACTIONS(2464),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_macro_rules_BANG] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_u8] = ACTIONS(2466),
    [anon_sym_i8] = ACTIONS(2466),
    [anon_sym_u16] = ACTIONS(2466),
    [anon_sym_i16] = ACTIONS(2466),
    [anon_sym_u32] = ACTIONS(2466),
    [anon_sym_i32] = ACTIONS(2466),
    [anon_sym_u64] = ACTIONS(2466),
    [anon_sym_i64] = ACTIONS(2466),
    [anon_sym_u128] = ACTIONS(2466),
    [anon_sym_i128] = ACTIONS(2466),
    [anon_sym_isize] = ACTIONS(2466),
    [anon_sym_usize] = ACTIONS(2466),
    [anon_sym_f32] = ACTIONS(2466),
    [anon_sym_f64] = ACTIONS(2466),
    [anon_sym_bool] = ACTIONS(2466),
    [anon_sym_str] = ACTIONS(2466),
    [anon_sym_char] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_DOT_DOT] = ACTIONS(2464),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_POUND] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2466),
    [anon_sym_async] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [anon_sym_fn] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_impl] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_loop] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_mod] = ACTIONS(2466),
    [anon_sym_pub] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_struct] = ACTIONS(2466),
    [anon_sym_trait] = ACTIONS(2466),
    [anon_sym_type] = ACTIONS(2466),
    [anon_sym_union] = ACTIONS(2466),
    [anon_sym_unsafe] = ACTIONS(2466),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_extern] = ACTIONS(2466),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_move] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [sym_integer_literal] = ACTIONS(2464),
    [aux_sym_string_literal_token1] = ACTIONS(2464),
    [sym_char_literal] = ACTIONS(2464),
    [anon_sym_true] = ACTIONS(2466),
    [anon_sym_false] = ACTIONS(2466),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2466),
    [sym_super] = ACTIONS(2466),
    [sym_crate] = ACTIONS(2466),
    [sym_metavariable] = ACTIONS(2464),
    [sym__raw_string_literal_start] = ACTIONS(2464),
    [sym_float_literal] = ACTIONS(2464),
  },
  [659] = {
    [sym_line_comment] = STATE(659),
    [sym_block_comment] = STATE(659),
    [ts_builtin_sym_end] = ACTIONS(2468),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_macro_rules_BANG] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_u8] = ACTIONS(2470),
    [anon_sym_i8] = ACTIONS(2470),
    [anon_sym_u16] = ACTIONS(2470),
    [anon_sym_i16] = ACTIONS(2470),
    [anon_sym_u32] = ACTIONS(2470),
    [anon_sym_i32] = ACTIONS(2470),
    [anon_sym_u64] = ACTIONS(2470),
    [anon_sym_i64] = ACTIONS(2470),
    [anon_sym_u128] = ACTIONS(2470),
    [anon_sym_i128] = ACTIONS(2470),
    [anon_sym_isize] = ACTIONS(2470),
    [anon_sym_usize] = ACTIONS(2470),
    [anon_sym_f32] = ACTIONS(2470),
    [anon_sym_f64] = ACTIONS(2470),
    [anon_sym_bool] = ACTIONS(2470),
    [anon_sym_str] = ACTIONS(2470),
    [anon_sym_char] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2468),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_DOT_DOT] = ACTIONS(2468),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_POUND] = ACTIONS(2468),
    [anon_sym_SQUOTE] = ACTIONS(2470),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [anon_sym_fn] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_impl] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_loop] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_mod] = ACTIONS(2470),
    [anon_sym_pub] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_struct] = ACTIONS(2470),
    [anon_sym_trait] = ACTIONS(2470),
    [anon_sym_type] = ACTIONS(2470),
    [anon_sym_union] = ACTIONS(2470),
    [anon_sym_unsafe] = ACTIONS(2470),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_extern] = ACTIONS(2470),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_move] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [sym_integer_literal] = ACTIONS(2468),
    [aux_sym_string_literal_token1] = ACTIONS(2468),
    [sym_char_literal] = ACTIONS(2468),
    [anon_sym_true] = ACTIONS(2470),
    [anon_sym_false] = ACTIONS(2470),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2470),
    [sym_super] = ACTIONS(2470),
    [sym_crate] = ACTIONS(2470),
    [sym_metavariable] = ACTIONS(2468),
    [sym__raw_string_literal_start] = ACTIONS(2468),
    [sym_float_literal] = ACTIONS(2468),
  },
  [660] = {
    [sym_line_comment] = STATE(660),
    [sym_block_comment] = STATE(660),
    [ts_builtin_sym_end] = ACTIONS(2472),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_macro_rules_BANG] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_u8] = ACTIONS(2474),
    [anon_sym_i8] = ACTIONS(2474),
    [anon_sym_u16] = ACTIONS(2474),
    [anon_sym_i16] = ACTIONS(2474),
    [anon_sym_u32] = ACTIONS(2474),
    [anon_sym_i32] = ACTIONS(2474),
    [anon_sym_u64] = ACTIONS(2474),
    [anon_sym_i64] = ACTIONS(2474),
    [anon_sym_u128] = ACTIONS(2474),
    [anon_sym_i128] = ACTIONS(2474),
    [anon_sym_isize] = ACTIONS(2474),
    [anon_sym_usize] = ACTIONS(2474),
    [anon_sym_f32] = ACTIONS(2474),
    [anon_sym_f64] = ACTIONS(2474),
    [anon_sym_bool] = ACTIONS(2474),
    [anon_sym_str] = ACTIONS(2474),
    [anon_sym_char] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_POUND] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2474),
    [anon_sym_async] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
    [anon_sym_fn] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_impl] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_loop] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_mod] = ACTIONS(2474),
    [anon_sym_pub] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2474),
    [anon_sym_trait] = ACTIONS(2474),
    [anon_sym_type] = ACTIONS(2474),
    [anon_sym_union] = ACTIONS(2474),
    [anon_sym_unsafe] = ACTIONS(2474),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_extern] = ACTIONS(2474),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_move] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [sym_integer_literal] = ACTIONS(2472),
    [aux_sym_string_literal_token1] = ACTIONS(2472),
    [sym_char_literal] = ACTIONS(2472),
    [anon_sym_true] = ACTIONS(2474),
    [anon_sym_false] = ACTIONS(2474),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2474),
    [sym_super] = ACTIONS(2474),
    [sym_crate] = ACTIONS(2474),
    [sym_metavariable] = ACTIONS(2472),
    [sym__raw_string_literal_start] = ACTIONS(2472),
    [sym_float_literal] = ACTIONS(2472),
  },
  [661] = {
    [sym_line_comment] = STATE(661),
    [sym_block_comment] = STATE(661),
    [ts_builtin_sym_end] = ACTIONS(2476),
    [sym_identifier] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_macro_rules_BANG] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2476),
    [anon_sym_u8] = ACTIONS(2478),
    [anon_sym_i8] = ACTIONS(2478),
    [anon_sym_u16] = ACTIONS(2478),
    [anon_sym_i16] = ACTIONS(2478),
    [anon_sym_u32] = ACTIONS(2478),
    [anon_sym_i32] = ACTIONS(2478),
    [anon_sym_u64] = ACTIONS(2478),
    [anon_sym_i64] = ACTIONS(2478),
    [anon_sym_u128] = ACTIONS(2478),
    [anon_sym_i128] = ACTIONS(2478),
    [anon_sym_isize] = ACTIONS(2478),
    [anon_sym_usize] = ACTIONS(2478),
    [anon_sym_f32] = ACTIONS(2478),
    [anon_sym_f64] = ACTIONS(2478),
    [anon_sym_bool] = ACTIONS(2478),
    [anon_sym_str] = ACTIONS(2478),
    [anon_sym_char] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_DOT_DOT] = ACTIONS(2476),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_POUND] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(2478),
    [anon_sym_async] = ACTIONS(2478),
    [anon_sym_break] = ACTIONS(2478),
    [anon_sym_const] = ACTIONS(2478),
    [anon_sym_continue] = ACTIONS(2478),
    [anon_sym_default] = ACTIONS(2478),
    [anon_sym_enum] = ACTIONS(2478),
    [anon_sym_fn] = ACTIONS(2478),
    [anon_sym_for] = ACTIONS(2478),
    [anon_sym_if] = ACTIONS(2478),
    [anon_sym_impl] = ACTIONS(2478),
    [anon_sym_let] = ACTIONS(2478),
    [anon_sym_loop] = ACTIONS(2478),
    [anon_sym_match] = ACTIONS(2478),
    [anon_sym_mod] = ACTIONS(2478),
    [anon_sym_pub] = ACTIONS(2478),
    [anon_sym_return] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2478),
    [anon_sym_struct] = ACTIONS(2478),
    [anon_sym_trait] = ACTIONS(2478),
    [anon_sym_type] = ACTIONS(2478),
    [anon_sym_union] = ACTIONS(2478),
    [anon_sym_unsafe] = ACTIONS(2478),
    [anon_sym_use] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2478),
    [anon_sym_extern] = ACTIONS(2478),
    [anon_sym_yield] = ACTIONS(2478),
    [anon_sym_move] = ACTIONS(2478),
    [anon_sym_try] = ACTIONS(2478),
    [sym_integer_literal] = ACTIONS(2476),
    [aux_sym_string_literal_token1] = ACTIONS(2476),
    [sym_char_literal] = ACTIONS(2476),
    [anon_sym_true] = ACTIONS(2478),
    [anon_sym_false] = ACTIONS(2478),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2478),
    [sym_super] = ACTIONS(2478),
    [sym_crate] = ACTIONS(2478),
    [sym_metavariable] = ACTIONS(2476),
    [sym__raw_string_literal_start] = ACTIONS(2476),
    [sym_float_literal] = ACTIONS(2476),
  },
  [662] = {
    [sym_line_comment] = STATE(662),
    [sym_block_comment] = STATE(662),
    [ts_builtin_sym_end] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_macro_rules_BANG] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_STAR] = ACTIONS(2480),
    [anon_sym_u8] = ACTIONS(2482),
    [anon_sym_i8] = ACTIONS(2482),
    [anon_sym_u16] = ACTIONS(2482),
    [anon_sym_i16] = ACTIONS(2482),
    [anon_sym_u32] = ACTIONS(2482),
    [anon_sym_i32] = ACTIONS(2482),
    [anon_sym_u64] = ACTIONS(2482),
    [anon_sym_i64] = ACTIONS(2482),
    [anon_sym_u128] = ACTIONS(2482),
    [anon_sym_i128] = ACTIONS(2482),
    [anon_sym_isize] = ACTIONS(2482),
    [anon_sym_usize] = ACTIONS(2482),
    [anon_sym_f32] = ACTIONS(2482),
    [anon_sym_f64] = ACTIONS(2482),
    [anon_sym_bool] = ACTIONS(2482),
    [anon_sym_str] = ACTIONS(2482),
    [anon_sym_char] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2480),
    [anon_sym_DOT_DOT] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2480),
    [anon_sym_POUND] = ACTIONS(2480),
    [anon_sym_SQUOTE] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_fn] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_impl] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_loop] = ACTIONS(2482),
    [anon_sym_match] = ACTIONS(2482),
    [anon_sym_mod] = ACTIONS(2482),
    [anon_sym_pub] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_struct] = ACTIONS(2482),
    [anon_sym_trait] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_union] = ACTIONS(2482),
    [anon_sym_unsafe] = ACTIONS(2482),
    [anon_sym_use] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_move] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [sym_integer_literal] = ACTIONS(2480),
    [aux_sym_string_literal_token1] = ACTIONS(2480),
    [sym_char_literal] = ACTIONS(2480),
    [anon_sym_true] = ACTIONS(2482),
    [anon_sym_false] = ACTIONS(2482),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_crate] = ACTIONS(2482),
    [sym_metavariable] = ACTIONS(2480),
    [sym__raw_string_literal_start] = ACTIONS(2480),
    [sym_float_literal] = ACTIONS(2480),
  },
  [663] = {
    [sym_line_comment] = STATE(663),
    [sym_block_comment] = STATE(663),
    [ts_builtin_sym_end] = ACTIONS(2484),
    [sym_identifier] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_macro_rules_BANG] = ACTIONS(2484),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_u8] = ACTIONS(2486),
    [anon_sym_i8] = ACTIONS(2486),
    [anon_sym_u16] = ACTIONS(2486),
    [anon_sym_i16] = ACTIONS(2486),
    [anon_sym_u32] = ACTIONS(2486),
    [anon_sym_i32] = ACTIONS(2486),
    [anon_sym_u64] = ACTIONS(2486),
    [anon_sym_i64] = ACTIONS(2486),
    [anon_sym_u128] = ACTIONS(2486),
    [anon_sym_i128] = ACTIONS(2486),
    [anon_sym_isize] = ACTIONS(2486),
    [anon_sym_usize] = ACTIONS(2486),
    [anon_sym_f32] = ACTIONS(2486),
    [anon_sym_f64] = ACTIONS(2486),
    [anon_sym_bool] = ACTIONS(2486),
    [anon_sym_str] = ACTIONS(2486),
    [anon_sym_char] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_PIPE] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_DOT_DOT] = ACTIONS(2484),
    [anon_sym_COLON_COLON] = ACTIONS(2484),
    [anon_sym_POUND] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [anon_sym_async] = ACTIONS(2486),
    [anon_sym_break] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_continue] = ACTIONS(2486),
    [anon_sym_default] = ACTIONS(2486),
    [anon_sym_enum] = ACTIONS(2486),
    [anon_sym_fn] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2486),
    [anon_sym_if] = ACTIONS(2486),
    [anon_sym_impl] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_loop] = ACTIONS(2486),
    [anon_sym_match] = ACTIONS(2486),
    [anon_sym_mod] = ACTIONS(2486),
    [anon_sym_pub] = ACTIONS(2486),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_static] = ACTIONS(2486),
    [anon_sym_struct] = ACTIONS(2486),
    [anon_sym_trait] = ACTIONS(2486),
    [anon_sym_type] = ACTIONS(2486),
    [anon_sym_union] = ACTIONS(2486),
    [anon_sym_unsafe] = ACTIONS(2486),
    [anon_sym_use] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [anon_sym_extern] = ACTIONS(2486),
    [anon_sym_yield] = ACTIONS(2486),
    [anon_sym_move] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2486),
    [sym_integer_literal] = ACTIONS(2484),
    [aux_sym_string_literal_token1] = ACTIONS(2484),
    [sym_char_literal] = ACTIONS(2484),
    [anon_sym_true] = ACTIONS(2486),
    [anon_sym_false] = ACTIONS(2486),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2486),
    [sym_super] = ACTIONS(2486),
    [sym_crate] = ACTIONS(2486),
    [sym_metavariable] = ACTIONS(2484),
    [sym__raw_string_literal_start] = ACTIONS(2484),
    [sym_float_literal] = ACTIONS(2484),
  },
  [664] = {
    [sym_line_comment] = STATE(664),
    [sym_block_comment] = STATE(664),
    [ts_builtin_sym_end] = ACTIONS(2488),
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_macro_rules_BANG] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2488),
    [anon_sym_u8] = ACTIONS(2490),
    [anon_sym_i8] = ACTIONS(2490),
    [anon_sym_u16] = ACTIONS(2490),
    [anon_sym_i16] = ACTIONS(2490),
    [anon_sym_u32] = ACTIONS(2490),
    [anon_sym_i32] = ACTIONS(2490),
    [anon_sym_u64] = ACTIONS(2490),
    [anon_sym_i64] = ACTIONS(2490),
    [anon_sym_u128] = ACTIONS(2490),
    [anon_sym_i128] = ACTIONS(2490),
    [anon_sym_isize] = ACTIONS(2490),
    [anon_sym_usize] = ACTIONS(2490),
    [anon_sym_f32] = ACTIONS(2490),
    [anon_sym_f64] = ACTIONS(2490),
    [anon_sym_bool] = ACTIONS(2490),
    [anon_sym_str] = ACTIONS(2490),
    [anon_sym_char] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_PIPE] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(2488),
    [anon_sym_DOT_DOT] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2488),
    [anon_sym_POUND] = ACTIONS(2488),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_break] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_continue] = ACTIONS(2490),
    [anon_sym_default] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
    [anon_sym_fn] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_impl] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_loop] = ACTIONS(2490),
    [anon_sym_match] = ACTIONS(2490),
    [anon_sym_mod] = ACTIONS(2490),
    [anon_sym_pub] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_trait] = ACTIONS(2490),
    [anon_sym_type] = ACTIONS(2490),
    [anon_sym_union] = ACTIONS(2490),
    [anon_sym_unsafe] = ACTIONS(2490),
    [anon_sym_use] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [anon_sym_extern] = ACTIONS(2490),
    [anon_sym_yield] = ACTIONS(2490),
    [anon_sym_move] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [sym_integer_literal] = ACTIONS(2488),
    [aux_sym_string_literal_token1] = ACTIONS(2488),
    [sym_char_literal] = ACTIONS(2488),
    [anon_sym_true] = ACTIONS(2490),
    [anon_sym_false] = ACTIONS(2490),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2490),
    [sym_super] = ACTIONS(2490),
    [sym_crate] = ACTIONS(2490),
    [sym_metavariable] = ACTIONS(2488),
    [sym__raw_string_literal_start] = ACTIONS(2488),
    [sym_float_literal] = ACTIONS(2488),
  },
  [665] = {
    [sym_line_comment] = STATE(665),
    [sym_block_comment] = STATE(665),
    [ts_builtin_sym_end] = ACTIONS(2492),
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_macro_rules_BANG] = ACTIONS(2492),
    [anon_sym_LPAREN] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_u8] = ACTIONS(2494),
    [anon_sym_i8] = ACTIONS(2494),
    [anon_sym_u16] = ACTIONS(2494),
    [anon_sym_i16] = ACTIONS(2494),
    [anon_sym_u32] = ACTIONS(2494),
    [anon_sym_i32] = ACTIONS(2494),
    [anon_sym_u64] = ACTIONS(2494),
    [anon_sym_i64] = ACTIONS(2494),
    [anon_sym_u128] = ACTIONS(2494),
    [anon_sym_i128] = ACTIONS(2494),
    [anon_sym_isize] = ACTIONS(2494),
    [anon_sym_usize] = ACTIONS(2494),
    [anon_sym_f32] = ACTIONS(2494),
    [anon_sym_f64] = ACTIONS(2494),
    [anon_sym_bool] = ACTIONS(2494),
    [anon_sym_str] = ACTIONS(2494),
    [anon_sym_char] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2492),
    [anon_sym_DOT_DOT] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_POUND] = ACTIONS(2492),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_async] = ACTIONS(2494),
    [anon_sym_break] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_continue] = ACTIONS(2494),
    [anon_sym_default] = ACTIONS(2494),
    [anon_sym_enum] = ACTIONS(2494),
    [anon_sym_fn] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_impl] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_loop] = ACTIONS(2494),
    [anon_sym_match] = ACTIONS(2494),
    [anon_sym_mod] = ACTIONS(2494),
    [anon_sym_pub] = ACTIONS(2494),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_static] = ACTIONS(2494),
    [anon_sym_struct] = ACTIONS(2494),
    [anon_sym_trait] = ACTIONS(2494),
    [anon_sym_type] = ACTIONS(2494),
    [anon_sym_union] = ACTIONS(2494),
    [anon_sym_unsafe] = ACTIONS(2494),
    [anon_sym_use] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [anon_sym_extern] = ACTIONS(2494),
    [anon_sym_yield] = ACTIONS(2494),
    [anon_sym_move] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [sym_integer_literal] = ACTIONS(2492),
    [aux_sym_string_literal_token1] = ACTIONS(2492),
    [sym_char_literal] = ACTIONS(2492),
    [anon_sym_true] = ACTIONS(2494),
    [anon_sym_false] = ACTIONS(2494),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2494),
    [sym_super] = ACTIONS(2494),
    [sym_crate] = ACTIONS(2494),
    [sym_metavariable] = ACTIONS(2492),
    [sym__raw_string_literal_start] = ACTIONS(2492),
    [sym_float_literal] = ACTIONS(2492),
  },
  [666] = {
    [sym_line_comment] = STATE(666),
    [sym_block_comment] = STATE(666),
    [ts_builtin_sym_end] = ACTIONS(2496),
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_macro_rules_BANG] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(2496),
    [anon_sym_u8] = ACTIONS(2498),
    [anon_sym_i8] = ACTIONS(2498),
    [anon_sym_u16] = ACTIONS(2498),
    [anon_sym_i16] = ACTIONS(2498),
    [anon_sym_u32] = ACTIONS(2498),
    [anon_sym_i32] = ACTIONS(2498),
    [anon_sym_u64] = ACTIONS(2498),
    [anon_sym_i64] = ACTIONS(2498),
    [anon_sym_u128] = ACTIONS(2498),
    [anon_sym_i128] = ACTIONS(2498),
    [anon_sym_isize] = ACTIONS(2498),
    [anon_sym_usize] = ACTIONS(2498),
    [anon_sym_f32] = ACTIONS(2498),
    [anon_sym_f64] = ACTIONS(2498),
    [anon_sym_bool] = ACTIONS(2498),
    [anon_sym_str] = ACTIONS(2498),
    [anon_sym_char] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2496),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_PIPE] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(2496),
    [anon_sym_DOT_DOT] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2496),
    [anon_sym_POUND] = ACTIONS(2496),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_async] = ACTIONS(2498),
    [anon_sym_break] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_continue] = ACTIONS(2498),
    [anon_sym_default] = ACTIONS(2498),
    [anon_sym_enum] = ACTIONS(2498),
    [anon_sym_fn] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_impl] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_loop] = ACTIONS(2498),
    [anon_sym_match] = ACTIONS(2498),
    [anon_sym_mod] = ACTIONS(2498),
    [anon_sym_pub] = ACTIONS(2498),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_static] = ACTIONS(2498),
    [anon_sym_struct] = ACTIONS(2498),
    [anon_sym_trait] = ACTIONS(2498),
    [anon_sym_type] = ACTIONS(2498),
    [anon_sym_union] = ACTIONS(2498),
    [anon_sym_unsafe] = ACTIONS(2498),
    [anon_sym_use] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [anon_sym_extern] = ACTIONS(2498),
    [anon_sym_yield] = ACTIONS(2498),
    [anon_sym_move] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [sym_integer_literal] = ACTIONS(2496),
    [aux_sym_string_literal_token1] = ACTIONS(2496),
    [sym_char_literal] = ACTIONS(2496),
    [anon_sym_true] = ACTIONS(2498),
    [anon_sym_false] = ACTIONS(2498),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2498),
    [sym_super] = ACTIONS(2498),
    [sym_crate] = ACTIONS(2498),
    [sym_metavariable] = ACTIONS(2496),
    [sym__raw_string_literal_start] = ACTIONS(2496),
    [sym_float_literal] = ACTIONS(2496),
  },
  [667] = {
    [sym_line_comment] = STATE(667),
    [sym_block_comment] = STATE(667),
    [ts_builtin_sym_end] = ACTIONS(2500),
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2500),
    [anon_sym_macro_rules_BANG] = ACTIONS(2500),
    [anon_sym_LPAREN] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_u8] = ACTIONS(2502),
    [anon_sym_i8] = ACTIONS(2502),
    [anon_sym_u16] = ACTIONS(2502),
    [anon_sym_i16] = ACTIONS(2502),
    [anon_sym_u32] = ACTIONS(2502),
    [anon_sym_i32] = ACTIONS(2502),
    [anon_sym_u64] = ACTIONS(2502),
    [anon_sym_i64] = ACTIONS(2502),
    [anon_sym_u128] = ACTIONS(2502),
    [anon_sym_i128] = ACTIONS(2502),
    [anon_sym_isize] = ACTIONS(2502),
    [anon_sym_usize] = ACTIONS(2502),
    [anon_sym_f32] = ACTIONS(2502),
    [anon_sym_f64] = ACTIONS(2502),
    [anon_sym_bool] = ACTIONS(2502),
    [anon_sym_str] = ACTIONS(2502),
    [anon_sym_char] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2500),
    [anon_sym_DOT_DOT] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2500),
    [anon_sym_POUND] = ACTIONS(2500),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_async] = ACTIONS(2502),
    [anon_sym_break] = ACTIONS(2502),
    [anon_sym_const] = ACTIONS(2502),
    [anon_sym_continue] = ACTIONS(2502),
    [anon_sym_default] = ACTIONS(2502),
    [anon_sym_enum] = ACTIONS(2502),
    [anon_sym_fn] = ACTIONS(2502),
    [anon_sym_for] = ACTIONS(2502),
    [anon_sym_if] = ACTIONS(2502),
    [anon_sym_impl] = ACTIONS(2502),
    [anon_sym_let] = ACTIONS(2502),
    [anon_sym_loop] = ACTIONS(2502),
    [anon_sym_match] = ACTIONS(2502),
    [anon_sym_mod] = ACTIONS(2502),
    [anon_sym_pub] = ACTIONS(2502),
    [anon_sym_return] = ACTIONS(2502),
    [anon_sym_static] = ACTIONS(2502),
    [anon_sym_struct] = ACTIONS(2502),
    [anon_sym_trait] = ACTIONS(2502),
    [anon_sym_type] = ACTIONS(2502),
    [anon_sym_union] = ACTIONS(2502),
    [anon_sym_unsafe] = ACTIONS(2502),
    [anon_sym_use] = ACTIONS(2502),
    [anon_sym_while] = ACTIONS(2502),
    [anon_sym_extern] = ACTIONS(2502),
    [anon_sym_yield] = ACTIONS(2502),
    [anon_sym_move] = ACTIONS(2502),
    [anon_sym_try] = ACTIONS(2502),
    [sym_integer_literal] = ACTIONS(2500),
    [aux_sym_string_literal_token1] = ACTIONS(2500),
    [sym_char_literal] = ACTIONS(2500),
    [anon_sym_true] = ACTIONS(2502),
    [anon_sym_false] = ACTIONS(2502),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2502),
    [sym_super] = ACTIONS(2502),
    [sym_crate] = ACTIONS(2502),
    [sym_metavariable] = ACTIONS(2500),
    [sym__raw_string_literal_start] = ACTIONS(2500),
    [sym_float_literal] = ACTIONS(2500),
  },
  [668] = {
    [sym_empty_statement] = STATE(1456),
    [sym_macro_definition] = STATE(1456),
    [sym_attribute_item] = STATE(1456),
    [sym_inner_attribute_item] = STATE(1456),
    [sym_mod_item] = STATE(1456),
    [sym_foreign_mod_item] = STATE(1456),
    [sym_struct_item] = STATE(1456),
    [sym_union_item] = STATE(1456),
    [sym_enum_item] = STATE(1456),
    [sym_extern_crate_declaration] = STATE(1456),
    [sym_const_item] = STATE(1456),
    [sym_static_item] = STATE(1456),
    [sym_type_item] = STATE(1456),
    [sym_function_item] = STATE(1456),
    [sym_function_signature_item] = STATE(1456),
    [sym_function_modifiers] = STATE(3599),
    [sym_impl_item] = STATE(1456),
    [sym_trait_item] = STATE(1456),
    [sym_associated_type] = STATE(1456),
    [sym_let_declaration] = STATE(1456),
    [sym_use_declaration] = STATE(1456),
    [sym_extern_modifier] = STATE(2139),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3323),
    [sym_generic_type_with_turbofish] = STATE(3349),
    [sym_macro_invocation] = STATE(1456),
    [sym_scoped_identifier] = STATE(3208),
    [sym_line_comment] = STATE(668),
    [sym_block_comment] = STATE(668),
    [aux_sym_declaration_list_repeat1] = STATE(629),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1870),
    [anon_sym_SEMI] = ACTIONS(1872),
    [anon_sym_macro_rules_BANG] = ACTIONS(1874),
    [anon_sym_RBRACE] = ACTIONS(2504),
    [anon_sym_u8] = ACTIONS(1878),
    [anon_sym_i8] = ACTIONS(1878),
    [anon_sym_u16] = ACTIONS(1878),
    [anon_sym_i16] = ACTIONS(1878),
    [anon_sym_u32] = ACTIONS(1878),
    [anon_sym_i32] = ACTIONS(1878),
    [anon_sym_u64] = ACTIONS(1878),
    [anon_sym_i64] = ACTIONS(1878),
    [anon_sym_u128] = ACTIONS(1878),
    [anon_sym_i128] = ACTIONS(1878),
    [anon_sym_isize] = ACTIONS(1878),
    [anon_sym_usize] = ACTIONS(1878),
    [anon_sym_f32] = ACTIONS(1878),
    [anon_sym_f64] = ACTIONS(1878),
    [anon_sym_bool] = ACTIONS(1878),
    [anon_sym_str] = ACTIONS(1878),
    [anon_sym_char] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_POUND] = ACTIONS(1882),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1884),
    [anon_sym_default] = ACTIONS(1886),
    [anon_sym_enum] = ACTIONS(1888),
    [anon_sym_fn] = ACTIONS(1890),
    [anon_sym_impl] = ACTIONS(1892),
    [anon_sym_let] = ACTIONS(1894),
    [anon_sym_mod] = ACTIONS(1896),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(1898),
    [anon_sym_struct] = ACTIONS(1900),
    [anon_sym_trait] = ACTIONS(1902),
    [anon_sym_type] = ACTIONS(1904),
    [anon_sym_union] = ACTIONS(1906),
    [anon_sym_unsafe] = ACTIONS(1908),
    [anon_sym_use] = ACTIONS(1910),
    [anon_sym_extern] = ACTIONS(1912),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1914),
    [sym_super] = ACTIONS(1914),
    [sym_crate] = ACTIONS(1916),
    [sym_metavariable] = ACTIONS(1918),
  },
  [669] = {
    [sym_line_comment] = STATE(669),
    [sym_block_comment] = STATE(669),
    [ts_builtin_sym_end] = ACTIONS(2506),
    [sym_identifier] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_macro_rules_BANG] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_u8] = ACTIONS(2508),
    [anon_sym_i8] = ACTIONS(2508),
    [anon_sym_u16] = ACTIONS(2508),
    [anon_sym_i16] = ACTIONS(2508),
    [anon_sym_u32] = ACTIONS(2508),
    [anon_sym_i32] = ACTIONS(2508),
    [anon_sym_u64] = ACTIONS(2508),
    [anon_sym_i64] = ACTIONS(2508),
    [anon_sym_u128] = ACTIONS(2508),
    [anon_sym_i128] = ACTIONS(2508),
    [anon_sym_isize] = ACTIONS(2508),
    [anon_sym_usize] = ACTIONS(2508),
    [anon_sym_f32] = ACTIONS(2508),
    [anon_sym_f64] = ACTIONS(2508),
    [anon_sym_bool] = ACTIONS(2508),
    [anon_sym_str] = ACTIONS(2508),
    [anon_sym_char] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_POUND] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2508),
    [anon_sym_async] = ACTIONS(2508),
    [anon_sym_break] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_continue] = ACTIONS(2508),
    [anon_sym_default] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [anon_sym_fn] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2508),
    [anon_sym_impl] = ACTIONS(2508),
    [anon_sym_let] = ACTIONS(2508),
    [anon_sym_loop] = ACTIONS(2508),
    [anon_sym_match] = ACTIONS(2508),
    [anon_sym_mod] = ACTIONS(2508),
    [anon_sym_pub] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2508),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_struct] = ACTIONS(2508),
    [anon_sym_trait] = ACTIONS(2508),
    [anon_sym_type] = ACTIONS(2508),
    [anon_sym_union] = ACTIONS(2508),
    [anon_sym_unsafe] = ACTIONS(2508),
    [anon_sym_use] = ACTIONS(2508),
    [anon_sym_while] = ACTIONS(2508),
    [anon_sym_extern] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2508),
    [anon_sym_move] = ACTIONS(2508),
    [anon_sym_try] = ACTIONS(2508),
    [sym_integer_literal] = ACTIONS(2506),
    [aux_sym_string_literal_token1] = ACTIONS(2506),
    [sym_char_literal] = ACTIONS(2506),
    [anon_sym_true] = ACTIONS(2508),
    [anon_sym_false] = ACTIONS(2508),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2508),
    [sym_super] = ACTIONS(2508),
    [sym_crate] = ACTIONS(2508),
    [sym_metavariable] = ACTIONS(2506),
    [sym__raw_string_literal_start] = ACTIONS(2506),
    [sym_float_literal] = ACTIONS(2506),
  },
  [670] = {
    [sym_line_comment] = STATE(670),
    [sym_block_comment] = STATE(670),
    [ts_builtin_sym_end] = ACTIONS(2510),
    [sym_identifier] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym_macro_rules_BANG] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_RBRACE] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_u8] = ACTIONS(2512),
    [anon_sym_i8] = ACTIONS(2512),
    [anon_sym_u16] = ACTIONS(2512),
    [anon_sym_i16] = ACTIONS(2512),
    [anon_sym_u32] = ACTIONS(2512),
    [anon_sym_i32] = ACTIONS(2512),
    [anon_sym_u64] = ACTIONS(2512),
    [anon_sym_i64] = ACTIONS(2512),
    [anon_sym_u128] = ACTIONS(2512),
    [anon_sym_i128] = ACTIONS(2512),
    [anon_sym_isize] = ACTIONS(2512),
    [anon_sym_usize] = ACTIONS(2512),
    [anon_sym_f32] = ACTIONS(2512),
    [anon_sym_f64] = ACTIONS(2512),
    [anon_sym_bool] = ACTIONS(2512),
    [anon_sym_str] = ACTIONS(2512),
    [anon_sym_char] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2510),
    [anon_sym_LT] = ACTIONS(2510),
    [anon_sym_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_async] = ACTIONS(2512),
    [anon_sym_break] = ACTIONS(2512),
    [anon_sym_const] = ACTIONS(2512),
    [anon_sym_continue] = ACTIONS(2512),
    [anon_sym_default] = ACTIONS(2512),
    [anon_sym_enum] = ACTIONS(2512),
    [anon_sym_fn] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2512),
    [anon_sym_if] = ACTIONS(2512),
    [anon_sym_impl] = ACTIONS(2512),
    [anon_sym_let] = ACTIONS(2512),
    [anon_sym_loop] = ACTIONS(2512),
    [anon_sym_match] = ACTIONS(2512),
    [anon_sym_mod] = ACTIONS(2512),
    [anon_sym_pub] = ACTIONS(2512),
    [anon_sym_return] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2512),
    [anon_sym_struct] = ACTIONS(2512),
    [anon_sym_trait] = ACTIONS(2512),
    [anon_sym_type] = ACTIONS(2512),
    [anon_sym_union] = ACTIONS(2512),
    [anon_sym_unsafe] = ACTIONS(2512),
    [anon_sym_use] = ACTIONS(2512),
    [anon_sym_while] = ACTIONS(2512),
    [anon_sym_extern] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2512),
    [anon_sym_move] = ACTIONS(2512),
    [anon_sym_try] = ACTIONS(2512),
    [sym_integer_literal] = ACTIONS(2510),
    [aux_sym_string_literal_token1] = ACTIONS(2510),
    [sym_char_literal] = ACTIONS(2510),
    [anon_sym_true] = ACTIONS(2512),
    [anon_sym_false] = ACTIONS(2512),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2512),
    [sym_super] = ACTIONS(2512),
    [sym_crate] = ACTIONS(2512),
    [sym_metavariable] = ACTIONS(2510),
    [sym__raw_string_literal_start] = ACTIONS(2510),
    [sym_float_literal] = ACTIONS(2510),
  },
  [671] = {
    [sym_line_comment] = STATE(671),
    [sym_block_comment] = STATE(671),
    [ts_builtin_sym_end] = ACTIONS(2514),
    [sym_identifier] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_macro_rules_BANG] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_RBRACE] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_u8] = ACTIONS(2516),
    [anon_sym_i8] = ACTIONS(2516),
    [anon_sym_u16] = ACTIONS(2516),
    [anon_sym_i16] = ACTIONS(2516),
    [anon_sym_u32] = ACTIONS(2516),
    [anon_sym_i32] = ACTIONS(2516),
    [anon_sym_u64] = ACTIONS(2516),
    [anon_sym_i64] = ACTIONS(2516),
    [anon_sym_u128] = ACTIONS(2516),
    [anon_sym_i128] = ACTIONS(2516),
    [anon_sym_isize] = ACTIONS(2516),
    [anon_sym_usize] = ACTIONS(2516),
    [anon_sym_f32] = ACTIONS(2516),
    [anon_sym_f64] = ACTIONS(2516),
    [anon_sym_bool] = ACTIONS(2516),
    [anon_sym_str] = ACTIONS(2516),
    [anon_sym_char] = ACTIONS(2516),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_DOT_DOT] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_POUND] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [anon_sym_async] = ACTIONS(2516),
    [anon_sym_break] = ACTIONS(2516),
    [anon_sym_const] = ACTIONS(2516),
    [anon_sym_continue] = ACTIONS(2516),
    [anon_sym_default] = ACTIONS(2516),
    [anon_sym_enum] = ACTIONS(2516),
    [anon_sym_fn] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2516),
    [anon_sym_impl] = ACTIONS(2516),
    [anon_sym_let] = ACTIONS(2516),
    [anon_sym_loop] = ACTIONS(2516),
    [anon_sym_match] = ACTIONS(2516),
    [anon_sym_mod] = ACTIONS(2516),
    [anon_sym_pub] = ACTIONS(2516),
    [anon_sym_return] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2516),
    [anon_sym_struct] = ACTIONS(2516),
    [anon_sym_trait] = ACTIONS(2516),
    [anon_sym_type] = ACTIONS(2516),
    [anon_sym_union] = ACTIONS(2516),
    [anon_sym_unsafe] = ACTIONS(2516),
    [anon_sym_use] = ACTIONS(2516),
    [anon_sym_while] = ACTIONS(2516),
    [anon_sym_extern] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2516),
    [anon_sym_move] = ACTIONS(2516),
    [anon_sym_try] = ACTIONS(2516),
    [sym_integer_literal] = ACTIONS(2514),
    [aux_sym_string_literal_token1] = ACTIONS(2514),
    [sym_char_literal] = ACTIONS(2514),
    [anon_sym_true] = ACTIONS(2516),
    [anon_sym_false] = ACTIONS(2516),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2516),
    [sym_super] = ACTIONS(2516),
    [sym_crate] = ACTIONS(2516),
    [sym_metavariable] = ACTIONS(2514),
    [sym__raw_string_literal_start] = ACTIONS(2514),
    [sym_float_literal] = ACTIONS(2514),
  },
  [672] = {
    [sym_line_comment] = STATE(672),
    [sym_block_comment] = STATE(672),
    [ts_builtin_sym_end] = ACTIONS(2518),
    [sym_identifier] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym_macro_rules_BANG] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(2518),
    [anon_sym_STAR] = ACTIONS(2518),
    [anon_sym_u8] = ACTIONS(2520),
    [anon_sym_i8] = ACTIONS(2520),
    [anon_sym_u16] = ACTIONS(2520),
    [anon_sym_i16] = ACTIONS(2520),
    [anon_sym_u32] = ACTIONS(2520),
    [anon_sym_i32] = ACTIONS(2520),
    [anon_sym_u64] = ACTIONS(2520),
    [anon_sym_i64] = ACTIONS(2520),
    [anon_sym_u128] = ACTIONS(2520),
    [anon_sym_i128] = ACTIONS(2520),
    [anon_sym_isize] = ACTIONS(2520),
    [anon_sym_usize] = ACTIONS(2520),
    [anon_sym_f32] = ACTIONS(2520),
    [anon_sym_f64] = ACTIONS(2520),
    [anon_sym_bool] = ACTIONS(2520),
    [anon_sym_str] = ACTIONS(2520),
    [anon_sym_char] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_BANG] = ACTIONS(2518),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_PIPE] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2518),
    [anon_sym_DOT_DOT] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_POUND] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2520),
    [anon_sym_async] = ACTIONS(2520),
    [anon_sym_break] = ACTIONS(2520),
    [anon_sym_const] = ACTIONS(2520),
    [anon_sym_continue] = ACTIONS(2520),
    [anon_sym_default] = ACTIONS(2520),
    [anon_sym_enum] = ACTIONS(2520),
    [anon_sym_fn] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2520),
    [anon_sym_if] = ACTIONS(2520),
    [anon_sym_impl] = ACTIONS(2520),
    [anon_sym_let] = ACTIONS(2520),
    [anon_sym_loop] = ACTIONS(2520),
    [anon_sym_match] = ACTIONS(2520),
    [anon_sym_mod] = ACTIONS(2520),
    [anon_sym_pub] = ACTIONS(2520),
    [anon_sym_return] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2520),
    [anon_sym_struct] = ACTIONS(2520),
    [anon_sym_trait] = ACTIONS(2520),
    [anon_sym_type] = ACTIONS(2520),
    [anon_sym_union] = ACTIONS(2520),
    [anon_sym_unsafe] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2520),
    [anon_sym_while] = ACTIONS(2520),
    [anon_sym_extern] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2520),
    [anon_sym_move] = ACTIONS(2520),
    [anon_sym_try] = ACTIONS(2520),
    [sym_integer_literal] = ACTIONS(2518),
    [aux_sym_string_literal_token1] = ACTIONS(2518),
    [sym_char_literal] = ACTIONS(2518),
    [anon_sym_true] = ACTIONS(2520),
    [anon_sym_false] = ACTIONS(2520),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2520),
    [sym_super] = ACTIONS(2520),
    [sym_crate] = ACTIONS(2520),
    [sym_metavariable] = ACTIONS(2518),
    [sym__raw_string_literal_start] = ACTIONS(2518),
    [sym_float_literal] = ACTIONS(2518),
  },
  [673] = {
    [sym_line_comment] = STATE(673),
    [sym_block_comment] = STATE(673),
    [ts_builtin_sym_end] = ACTIONS(2522),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_macro_rules_BANG] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2522),
    [anon_sym_LBRACE] = ACTIONS(2522),
    [anon_sym_RBRACE] = ACTIONS(2522),
    [anon_sym_STAR] = ACTIONS(2522),
    [anon_sym_u8] = ACTIONS(2524),
    [anon_sym_i8] = ACTIONS(2524),
    [anon_sym_u16] = ACTIONS(2524),
    [anon_sym_i16] = ACTIONS(2524),
    [anon_sym_u32] = ACTIONS(2524),
    [anon_sym_i32] = ACTIONS(2524),
    [anon_sym_u64] = ACTIONS(2524),
    [anon_sym_i64] = ACTIONS(2524),
    [anon_sym_u128] = ACTIONS(2524),
    [anon_sym_i128] = ACTIONS(2524),
    [anon_sym_isize] = ACTIONS(2524),
    [anon_sym_usize] = ACTIONS(2524),
    [anon_sym_f32] = ACTIONS(2524),
    [anon_sym_f64] = ACTIONS(2524),
    [anon_sym_bool] = ACTIONS(2524),
    [anon_sym_str] = ACTIONS(2524),
    [anon_sym_char] = ACTIONS(2524),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_DOT_DOT] = ACTIONS(2522),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_POUND] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_fn] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_impl] = ACTIONS(2524),
    [anon_sym_let] = ACTIONS(2524),
    [anon_sym_loop] = ACTIONS(2524),
    [anon_sym_match] = ACTIONS(2524),
    [anon_sym_mod] = ACTIONS(2524),
    [anon_sym_pub] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_trait] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_unsafe] = ACTIONS(2524),
    [anon_sym_use] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym_yield] = ACTIONS(2524),
    [anon_sym_move] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [sym_integer_literal] = ACTIONS(2522),
    [aux_sym_string_literal_token1] = ACTIONS(2522),
    [sym_char_literal] = ACTIONS(2522),
    [anon_sym_true] = ACTIONS(2524),
    [anon_sym_false] = ACTIONS(2524),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2524),
    [sym_super] = ACTIONS(2524),
    [sym_crate] = ACTIONS(2524),
    [sym_metavariable] = ACTIONS(2522),
    [sym__raw_string_literal_start] = ACTIONS(2522),
    [sym_float_literal] = ACTIONS(2522),
  },
  [674] = {
    [sym_line_comment] = STATE(674),
    [sym_block_comment] = STATE(674),
    [ts_builtin_sym_end] = ACTIONS(2526),
    [sym_identifier] = ACTIONS(2528),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym_macro_rules_BANG] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2526),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_u8] = ACTIONS(2528),
    [anon_sym_i8] = ACTIONS(2528),
    [anon_sym_u16] = ACTIONS(2528),
    [anon_sym_i16] = ACTIONS(2528),
    [anon_sym_u32] = ACTIONS(2528),
    [anon_sym_i32] = ACTIONS(2528),
    [anon_sym_u64] = ACTIONS(2528),
    [anon_sym_i64] = ACTIONS(2528),
    [anon_sym_u128] = ACTIONS(2528),
    [anon_sym_i128] = ACTIONS(2528),
    [anon_sym_isize] = ACTIONS(2528),
    [anon_sym_usize] = ACTIONS(2528),
    [anon_sym_f32] = ACTIONS(2528),
    [anon_sym_f64] = ACTIONS(2528),
    [anon_sym_bool] = ACTIONS(2528),
    [anon_sym_str] = ACTIONS(2528),
    [anon_sym_char] = ACTIONS(2528),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_LT] = ACTIONS(2526),
    [anon_sym_DOT_DOT] = ACTIONS(2526),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_POUND] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2528),
    [anon_sym_async] = ACTIONS(2528),
    [anon_sym_break] = ACTIONS(2528),
    [anon_sym_const] = ACTIONS(2528),
    [anon_sym_continue] = ACTIONS(2528),
    [anon_sym_default] = ACTIONS(2528),
    [anon_sym_enum] = ACTIONS(2528),
    [anon_sym_fn] = ACTIONS(2528),
    [anon_sym_for] = ACTIONS(2528),
    [anon_sym_if] = ACTIONS(2528),
    [anon_sym_impl] = ACTIONS(2528),
    [anon_sym_let] = ACTIONS(2528),
    [anon_sym_loop] = ACTIONS(2528),
    [anon_sym_match] = ACTIONS(2528),
    [anon_sym_mod] = ACTIONS(2528),
    [anon_sym_pub] = ACTIONS(2528),
    [anon_sym_return] = ACTIONS(2528),
    [anon_sym_static] = ACTIONS(2528),
    [anon_sym_struct] = ACTIONS(2528),
    [anon_sym_trait] = ACTIONS(2528),
    [anon_sym_type] = ACTIONS(2528),
    [anon_sym_union] = ACTIONS(2528),
    [anon_sym_unsafe] = ACTIONS(2528),
    [anon_sym_use] = ACTIONS(2528),
    [anon_sym_while] = ACTIONS(2528),
    [anon_sym_extern] = ACTIONS(2528),
    [anon_sym_yield] = ACTIONS(2528),
    [anon_sym_move] = ACTIONS(2528),
    [anon_sym_try] = ACTIONS(2528),
    [sym_integer_literal] = ACTIONS(2526),
    [aux_sym_string_literal_token1] = ACTIONS(2526),
    [sym_char_literal] = ACTIONS(2526),
    [anon_sym_true] = ACTIONS(2528),
    [anon_sym_false] = ACTIONS(2528),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2528),
    [sym_super] = ACTIONS(2528),
    [sym_crate] = ACTIONS(2528),
    [sym_metavariable] = ACTIONS(2526),
    [sym__raw_string_literal_start] = ACTIONS(2526),
    [sym_float_literal] = ACTIONS(2526),
  },
  [675] = {
    [sym_line_comment] = STATE(675),
    [sym_block_comment] = STATE(675),
    [ts_builtin_sym_end] = ACTIONS(2530),
    [sym_identifier] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym_macro_rules_BANG] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2530),
    [anon_sym_LBRACK] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(2530),
    [anon_sym_RBRACE] = ACTIONS(2530),
    [anon_sym_STAR] = ACTIONS(2530),
    [anon_sym_u8] = ACTIONS(2532),
    [anon_sym_i8] = ACTIONS(2532),
    [anon_sym_u16] = ACTIONS(2532),
    [anon_sym_i16] = ACTIONS(2532),
    [anon_sym_u32] = ACTIONS(2532),
    [anon_sym_i32] = ACTIONS(2532),
    [anon_sym_u64] = ACTIONS(2532),
    [anon_sym_i64] = ACTIONS(2532),
    [anon_sym_u128] = ACTIONS(2532),
    [anon_sym_i128] = ACTIONS(2532),
    [anon_sym_isize] = ACTIONS(2532),
    [anon_sym_usize] = ACTIONS(2532),
    [anon_sym_f32] = ACTIONS(2532),
    [anon_sym_f64] = ACTIONS(2532),
    [anon_sym_bool] = ACTIONS(2532),
    [anon_sym_str] = ACTIONS(2532),
    [anon_sym_char] = ACTIONS(2532),
    [anon_sym_DASH] = ACTIONS(2530),
    [anon_sym_BANG] = ACTIONS(2530),
    [anon_sym_AMP] = ACTIONS(2530),
    [anon_sym_PIPE] = ACTIONS(2530),
    [anon_sym_LT] = ACTIONS(2530),
    [anon_sym_DOT_DOT] = ACTIONS(2530),
    [anon_sym_COLON_COLON] = ACTIONS(2530),
    [anon_sym_POUND] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2532),
    [anon_sym_async] = ACTIONS(2532),
    [anon_sym_break] = ACTIONS(2532),
    [anon_sym_const] = ACTIONS(2532),
    [anon_sym_continue] = ACTIONS(2532),
    [anon_sym_default] = ACTIONS(2532),
    [anon_sym_enum] = ACTIONS(2532),
    [anon_sym_fn] = ACTIONS(2532),
    [anon_sym_for] = ACTIONS(2532),
    [anon_sym_if] = ACTIONS(2532),
    [anon_sym_impl] = ACTIONS(2532),
    [anon_sym_let] = ACTIONS(2532),
    [anon_sym_loop] = ACTIONS(2532),
    [anon_sym_match] = ACTIONS(2532),
    [anon_sym_mod] = ACTIONS(2532),
    [anon_sym_pub] = ACTIONS(2532),
    [anon_sym_return] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2532),
    [anon_sym_struct] = ACTIONS(2532),
    [anon_sym_trait] = ACTIONS(2532),
    [anon_sym_type] = ACTIONS(2532),
    [anon_sym_union] = ACTIONS(2532),
    [anon_sym_unsafe] = ACTIONS(2532),
    [anon_sym_use] = ACTIONS(2532),
    [anon_sym_while] = ACTIONS(2532),
    [anon_sym_extern] = ACTIONS(2532),
    [anon_sym_yield] = ACTIONS(2532),
    [anon_sym_move] = ACTIONS(2532),
    [anon_sym_try] = ACTIONS(2532),
    [sym_integer_literal] = ACTIONS(2530),
    [aux_sym_string_literal_token1] = ACTIONS(2530),
    [sym_char_literal] = ACTIONS(2530),
    [anon_sym_true] = ACTIONS(2532),
    [anon_sym_false] = ACTIONS(2532),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2532),
    [sym_super] = ACTIONS(2532),
    [sym_crate] = ACTIONS(2532),
    [sym_metavariable] = ACTIONS(2530),
    [sym__raw_string_literal_start] = ACTIONS(2530),
    [sym_float_literal] = ACTIONS(2530),
  },
  [676] = {
    [sym_line_comment] = STATE(676),
    [sym_block_comment] = STATE(676),
    [ts_builtin_sym_end] = ACTIONS(2534),
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym_macro_rules_BANG] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2534),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_u8] = ACTIONS(2536),
    [anon_sym_i8] = ACTIONS(2536),
    [anon_sym_u16] = ACTIONS(2536),
    [anon_sym_i16] = ACTIONS(2536),
    [anon_sym_u32] = ACTIONS(2536),
    [anon_sym_i32] = ACTIONS(2536),
    [anon_sym_u64] = ACTIONS(2536),
    [anon_sym_i64] = ACTIONS(2536),
    [anon_sym_u128] = ACTIONS(2536),
    [anon_sym_i128] = ACTIONS(2536),
    [anon_sym_isize] = ACTIONS(2536),
    [anon_sym_usize] = ACTIONS(2536),
    [anon_sym_f32] = ACTIONS(2536),
    [anon_sym_f64] = ACTIONS(2536),
    [anon_sym_bool] = ACTIONS(2536),
    [anon_sym_str] = ACTIONS(2536),
    [anon_sym_char] = ACTIONS(2536),
    [anon_sym_DASH] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2534),
    [anon_sym_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2534),
    [anon_sym_DOT_DOT] = ACTIONS(2534),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_POUND] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2536),
    [anon_sym_async] = ACTIONS(2536),
    [anon_sym_break] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_continue] = ACTIONS(2536),
    [anon_sym_default] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_fn] = ACTIONS(2536),
    [anon_sym_for] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2536),
    [anon_sym_impl] = ACTIONS(2536),
    [anon_sym_let] = ACTIONS(2536),
    [anon_sym_loop] = ACTIONS(2536),
    [anon_sym_match] = ACTIONS(2536),
    [anon_sym_mod] = ACTIONS(2536),
    [anon_sym_pub] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_trait] = ACTIONS(2536),
    [anon_sym_type] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_unsafe] = ACTIONS(2536),
    [anon_sym_use] = ACTIONS(2536),
    [anon_sym_while] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym_yield] = ACTIONS(2536),
    [anon_sym_move] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [sym_integer_literal] = ACTIONS(2534),
    [aux_sym_string_literal_token1] = ACTIONS(2534),
    [sym_char_literal] = ACTIONS(2534),
    [anon_sym_true] = ACTIONS(2536),
    [anon_sym_false] = ACTIONS(2536),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2536),
    [sym_super] = ACTIONS(2536),
    [sym_crate] = ACTIONS(2536),
    [sym_metavariable] = ACTIONS(2534),
    [sym__raw_string_literal_start] = ACTIONS(2534),
    [sym_float_literal] = ACTIONS(2534),
  },
  [677] = {
    [sym_line_comment] = STATE(677),
    [sym_block_comment] = STATE(677),
    [ts_builtin_sym_end] = ACTIONS(2538),
    [sym_identifier] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2538),
    [anon_sym_macro_rules_BANG] = ACTIONS(2538),
    [anon_sym_LPAREN] = ACTIONS(2538),
    [anon_sym_LBRACK] = ACTIONS(2538),
    [anon_sym_LBRACE] = ACTIONS(2538),
    [anon_sym_RBRACE] = ACTIONS(2538),
    [anon_sym_STAR] = ACTIONS(2538),
    [anon_sym_u8] = ACTIONS(2540),
    [anon_sym_i8] = ACTIONS(2540),
    [anon_sym_u16] = ACTIONS(2540),
    [anon_sym_i16] = ACTIONS(2540),
    [anon_sym_u32] = ACTIONS(2540),
    [anon_sym_i32] = ACTIONS(2540),
    [anon_sym_u64] = ACTIONS(2540),
    [anon_sym_i64] = ACTIONS(2540),
    [anon_sym_u128] = ACTIONS(2540),
    [anon_sym_i128] = ACTIONS(2540),
    [anon_sym_isize] = ACTIONS(2540),
    [anon_sym_usize] = ACTIONS(2540),
    [anon_sym_f32] = ACTIONS(2540),
    [anon_sym_f64] = ACTIONS(2540),
    [anon_sym_bool] = ACTIONS(2540),
    [anon_sym_str] = ACTIONS(2540),
    [anon_sym_char] = ACTIONS(2540),
    [anon_sym_DASH] = ACTIONS(2538),
    [anon_sym_BANG] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2538),
    [anon_sym_PIPE] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2538),
    [anon_sym_DOT_DOT] = ACTIONS(2538),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_POUND] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2540),
    [anon_sym_async] = ACTIONS(2540),
    [anon_sym_break] = ACTIONS(2540),
    [anon_sym_const] = ACTIONS(2540),
    [anon_sym_continue] = ACTIONS(2540),
    [anon_sym_default] = ACTIONS(2540),
    [anon_sym_enum] = ACTIONS(2540),
    [anon_sym_fn] = ACTIONS(2540),
    [anon_sym_for] = ACTIONS(2540),
    [anon_sym_if] = ACTIONS(2540),
    [anon_sym_impl] = ACTIONS(2540),
    [anon_sym_let] = ACTIONS(2540),
    [anon_sym_loop] = ACTIONS(2540),
    [anon_sym_match] = ACTIONS(2540),
    [anon_sym_mod] = ACTIONS(2540),
    [anon_sym_pub] = ACTIONS(2540),
    [anon_sym_return] = ACTIONS(2540),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_trait] = ACTIONS(2540),
    [anon_sym_type] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2540),
    [anon_sym_unsafe] = ACTIONS(2540),
    [anon_sym_use] = ACTIONS(2540),
    [anon_sym_while] = ACTIONS(2540),
    [anon_sym_extern] = ACTIONS(2540),
    [anon_sym_yield] = ACTIONS(2540),
    [anon_sym_move] = ACTIONS(2540),
    [anon_sym_try] = ACTIONS(2540),
    [sym_integer_literal] = ACTIONS(2538),
    [aux_sym_string_literal_token1] = ACTIONS(2538),
    [sym_char_literal] = ACTIONS(2538),
    [anon_sym_true] = ACTIONS(2540),
    [anon_sym_false] = ACTIONS(2540),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2540),
    [sym_super] = ACTIONS(2540),
    [sym_crate] = ACTIONS(2540),
    [sym_metavariable] = ACTIONS(2538),
    [sym__raw_string_literal_start] = ACTIONS(2538),
    [sym_float_literal] = ACTIONS(2538),
  },
  [678] = {
    [sym_line_comment] = STATE(678),
    [sym_block_comment] = STATE(678),
    [ts_builtin_sym_end] = ACTIONS(2542),
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym_macro_rules_BANG] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(2542),
    [anon_sym_LBRACE] = ACTIONS(2542),
    [anon_sym_RBRACE] = ACTIONS(2542),
    [anon_sym_STAR] = ACTIONS(2542),
    [anon_sym_u8] = ACTIONS(2544),
    [anon_sym_i8] = ACTIONS(2544),
    [anon_sym_u16] = ACTIONS(2544),
    [anon_sym_i16] = ACTIONS(2544),
    [anon_sym_u32] = ACTIONS(2544),
    [anon_sym_i32] = ACTIONS(2544),
    [anon_sym_u64] = ACTIONS(2544),
    [anon_sym_i64] = ACTIONS(2544),
    [anon_sym_u128] = ACTIONS(2544),
    [anon_sym_i128] = ACTIONS(2544),
    [anon_sym_isize] = ACTIONS(2544),
    [anon_sym_usize] = ACTIONS(2544),
    [anon_sym_f32] = ACTIONS(2544),
    [anon_sym_f64] = ACTIONS(2544),
    [anon_sym_bool] = ACTIONS(2544),
    [anon_sym_str] = ACTIONS(2544),
    [anon_sym_char] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2542),
    [anon_sym_BANG] = ACTIONS(2542),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_LT] = ACTIONS(2542),
    [anon_sym_DOT_DOT] = ACTIONS(2542),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_POUND] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_fn] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_impl] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_loop] = ACTIONS(2544),
    [anon_sym_match] = ACTIONS(2544),
    [anon_sym_mod] = ACTIONS(2544),
    [anon_sym_pub] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_struct] = ACTIONS(2544),
    [anon_sym_trait] = ACTIONS(2544),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_union] = ACTIONS(2544),
    [anon_sym_unsafe] = ACTIONS(2544),
    [anon_sym_use] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_extern] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_move] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [sym_integer_literal] = ACTIONS(2542),
    [aux_sym_string_literal_token1] = ACTIONS(2542),
    [sym_char_literal] = ACTIONS(2542),
    [anon_sym_true] = ACTIONS(2544),
    [anon_sym_false] = ACTIONS(2544),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_crate] = ACTIONS(2544),
    [sym_metavariable] = ACTIONS(2542),
    [sym__raw_string_literal_start] = ACTIONS(2542),
    [sym_float_literal] = ACTIONS(2542),
  },
  [679] = {
    [sym_line_comment] = STATE(679),
    [sym_block_comment] = STATE(679),
    [ts_builtin_sym_end] = ACTIONS(2546),
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_macro_rules_BANG] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_STAR] = ACTIONS(2546),
    [anon_sym_u8] = ACTIONS(2548),
    [anon_sym_i8] = ACTIONS(2548),
    [anon_sym_u16] = ACTIONS(2548),
    [anon_sym_i16] = ACTIONS(2548),
    [anon_sym_u32] = ACTIONS(2548),
    [anon_sym_i32] = ACTIONS(2548),
    [anon_sym_u64] = ACTIONS(2548),
    [anon_sym_i64] = ACTIONS(2548),
    [anon_sym_u128] = ACTIONS(2548),
    [anon_sym_i128] = ACTIONS(2548),
    [anon_sym_isize] = ACTIONS(2548),
    [anon_sym_usize] = ACTIONS(2548),
    [anon_sym_f32] = ACTIONS(2548),
    [anon_sym_f64] = ACTIONS(2548),
    [anon_sym_bool] = ACTIONS(2548),
    [anon_sym_str] = ACTIONS(2548),
    [anon_sym_char] = ACTIONS(2548),
    [anon_sym_DASH] = ACTIONS(2546),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2546),
    [anon_sym_PIPE] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2546),
    [anon_sym_DOT_DOT] = ACTIONS(2546),
    [anon_sym_COLON_COLON] = ACTIONS(2546),
    [anon_sym_POUND] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [anon_sym_async] = ACTIONS(2548),
    [anon_sym_break] = ACTIONS(2548),
    [anon_sym_const] = ACTIONS(2548),
    [anon_sym_continue] = ACTIONS(2548),
    [anon_sym_default] = ACTIONS(2548),
    [anon_sym_enum] = ACTIONS(2548),
    [anon_sym_fn] = ACTIONS(2548),
    [anon_sym_for] = ACTIONS(2548),
    [anon_sym_if] = ACTIONS(2548),
    [anon_sym_impl] = ACTIONS(2548),
    [anon_sym_let] = ACTIONS(2548),
    [anon_sym_loop] = ACTIONS(2548),
    [anon_sym_match] = ACTIONS(2548),
    [anon_sym_mod] = ACTIONS(2548),
    [anon_sym_pub] = ACTIONS(2548),
    [anon_sym_return] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_struct] = ACTIONS(2548),
    [anon_sym_trait] = ACTIONS(2548),
    [anon_sym_type] = ACTIONS(2548),
    [anon_sym_union] = ACTIONS(2548),
    [anon_sym_unsafe] = ACTIONS(2548),
    [anon_sym_use] = ACTIONS(2548),
    [anon_sym_while] = ACTIONS(2548),
    [anon_sym_extern] = ACTIONS(2548),
    [anon_sym_yield] = ACTIONS(2548),
    [anon_sym_move] = ACTIONS(2548),
    [anon_sym_try] = ACTIONS(2548),
    [sym_integer_literal] = ACTIONS(2546),
    [aux_sym_string_literal_token1] = ACTIONS(2546),
    [sym_char_literal] = ACTIONS(2546),
    [anon_sym_true] = ACTIONS(2548),
    [anon_sym_false] = ACTIONS(2548),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2548),
    [sym_super] = ACTIONS(2548),
    [sym_crate] = ACTIONS(2548),
    [sym_metavariable] = ACTIONS(2546),
    [sym__raw_string_literal_start] = ACTIONS(2546),
    [sym_float_literal] = ACTIONS(2546),
  },
  [680] = {
    [sym_line_comment] = STATE(680),
    [sym_block_comment] = STATE(680),
    [ts_builtin_sym_end] = ACTIONS(2550),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_macro_rules_BANG] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_u8] = ACTIONS(2552),
    [anon_sym_i8] = ACTIONS(2552),
    [anon_sym_u16] = ACTIONS(2552),
    [anon_sym_i16] = ACTIONS(2552),
    [anon_sym_u32] = ACTIONS(2552),
    [anon_sym_i32] = ACTIONS(2552),
    [anon_sym_u64] = ACTIONS(2552),
    [anon_sym_i64] = ACTIONS(2552),
    [anon_sym_u128] = ACTIONS(2552),
    [anon_sym_i128] = ACTIONS(2552),
    [anon_sym_isize] = ACTIONS(2552),
    [anon_sym_usize] = ACTIONS(2552),
    [anon_sym_f32] = ACTIONS(2552),
    [anon_sym_f64] = ACTIONS(2552),
    [anon_sym_bool] = ACTIONS(2552),
    [anon_sym_str] = ACTIONS(2552),
    [anon_sym_char] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_PIPE] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2550),
    [anon_sym_DOT_DOT] = ACTIONS(2550),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_POUND] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2552),
    [anon_sym_async] = ACTIONS(2552),
    [anon_sym_break] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_continue] = ACTIONS(2552),
    [anon_sym_default] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_fn] = ACTIONS(2552),
    [anon_sym_for] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_impl] = ACTIONS(2552),
    [anon_sym_let] = ACTIONS(2552),
    [anon_sym_loop] = ACTIONS(2552),
    [anon_sym_match] = ACTIONS(2552),
    [anon_sym_mod] = ACTIONS(2552),
    [anon_sym_pub] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2552),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_trait] = ACTIONS(2552),
    [anon_sym_type] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_unsafe] = ACTIONS(2552),
    [anon_sym_use] = ACTIONS(2552),
    [anon_sym_while] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym_yield] = ACTIONS(2552),
    [anon_sym_move] = ACTIONS(2552),
    [anon_sym_try] = ACTIONS(2552),
    [sym_integer_literal] = ACTIONS(2550),
    [aux_sym_string_literal_token1] = ACTIONS(2550),
    [sym_char_literal] = ACTIONS(2550),
    [anon_sym_true] = ACTIONS(2552),
    [anon_sym_false] = ACTIONS(2552),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2552),
    [sym_super] = ACTIONS(2552),
    [sym_crate] = ACTIONS(2552),
    [sym_metavariable] = ACTIONS(2550),
    [sym__raw_string_literal_start] = ACTIONS(2550),
    [sym_float_literal] = ACTIONS(2550),
  },
  [681] = {
    [sym_line_comment] = STATE(681),
    [sym_block_comment] = STATE(681),
    [ts_builtin_sym_end] = ACTIONS(2554),
    [sym_identifier] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym_macro_rules_BANG] = ACTIONS(2554),
    [anon_sym_LPAREN] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_RBRACE] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(2554),
    [anon_sym_u8] = ACTIONS(2556),
    [anon_sym_i8] = ACTIONS(2556),
    [anon_sym_u16] = ACTIONS(2556),
    [anon_sym_i16] = ACTIONS(2556),
    [anon_sym_u32] = ACTIONS(2556),
    [anon_sym_i32] = ACTIONS(2556),
    [anon_sym_u64] = ACTIONS(2556),
    [anon_sym_i64] = ACTIONS(2556),
    [anon_sym_u128] = ACTIONS(2556),
    [anon_sym_i128] = ACTIONS(2556),
    [anon_sym_isize] = ACTIONS(2556),
    [anon_sym_usize] = ACTIONS(2556),
    [anon_sym_f32] = ACTIONS(2556),
    [anon_sym_f64] = ACTIONS(2556),
    [anon_sym_bool] = ACTIONS(2556),
    [anon_sym_str] = ACTIONS(2556),
    [anon_sym_char] = ACTIONS(2556),
    [anon_sym_DASH] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2554),
    [anon_sym_DOT_DOT] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(2554),
    [anon_sym_POUND] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2556),
    [anon_sym_async] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_fn] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_impl] = ACTIONS(2556),
    [anon_sym_let] = ACTIONS(2556),
    [anon_sym_loop] = ACTIONS(2556),
    [anon_sym_match] = ACTIONS(2556),
    [anon_sym_mod] = ACTIONS(2556),
    [anon_sym_pub] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_trait] = ACTIONS(2556),
    [anon_sym_type] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_unsafe] = ACTIONS(2556),
    [anon_sym_use] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym_yield] = ACTIONS(2556),
    [anon_sym_move] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [sym_integer_literal] = ACTIONS(2554),
    [aux_sym_string_literal_token1] = ACTIONS(2554),
    [sym_char_literal] = ACTIONS(2554),
    [anon_sym_true] = ACTIONS(2556),
    [anon_sym_false] = ACTIONS(2556),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2556),
    [sym_super] = ACTIONS(2556),
    [sym_crate] = ACTIONS(2556),
    [sym_metavariable] = ACTIONS(2554),
    [sym__raw_string_literal_start] = ACTIONS(2554),
    [sym_float_literal] = ACTIONS(2554),
  },
  [682] = {
    [sym_line_comment] = STATE(682),
    [sym_block_comment] = STATE(682),
    [ts_builtin_sym_end] = ACTIONS(2558),
    [sym_identifier] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym_macro_rules_BANG] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2558),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_u8] = ACTIONS(2560),
    [anon_sym_i8] = ACTIONS(2560),
    [anon_sym_u16] = ACTIONS(2560),
    [anon_sym_i16] = ACTIONS(2560),
    [anon_sym_u32] = ACTIONS(2560),
    [anon_sym_i32] = ACTIONS(2560),
    [anon_sym_u64] = ACTIONS(2560),
    [anon_sym_i64] = ACTIONS(2560),
    [anon_sym_u128] = ACTIONS(2560),
    [anon_sym_i128] = ACTIONS(2560),
    [anon_sym_isize] = ACTIONS(2560),
    [anon_sym_usize] = ACTIONS(2560),
    [anon_sym_f32] = ACTIONS(2560),
    [anon_sym_f64] = ACTIONS(2560),
    [anon_sym_bool] = ACTIONS(2560),
    [anon_sym_str] = ACTIONS(2560),
    [anon_sym_char] = ACTIONS(2560),
    [anon_sym_DASH] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2558),
    [anon_sym_PIPE] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_DOT_DOT] = ACTIONS(2558),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_POUND] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2560),
    [anon_sym_async] = ACTIONS(2560),
    [anon_sym_break] = ACTIONS(2560),
    [anon_sym_const] = ACTIONS(2560),
    [anon_sym_continue] = ACTIONS(2560),
    [anon_sym_default] = ACTIONS(2560),
    [anon_sym_enum] = ACTIONS(2560),
    [anon_sym_fn] = ACTIONS(2560),
    [anon_sym_for] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(2560),
    [anon_sym_impl] = ACTIONS(2560),
    [anon_sym_let] = ACTIONS(2560),
    [anon_sym_loop] = ACTIONS(2560),
    [anon_sym_match] = ACTIONS(2560),
    [anon_sym_mod] = ACTIONS(2560),
    [anon_sym_pub] = ACTIONS(2560),
    [anon_sym_return] = ACTIONS(2560),
    [anon_sym_static] = ACTIONS(2560),
    [anon_sym_struct] = ACTIONS(2560),
    [anon_sym_trait] = ACTIONS(2560),
    [anon_sym_type] = ACTIONS(2560),
    [anon_sym_union] = ACTIONS(2560),
    [anon_sym_unsafe] = ACTIONS(2560),
    [anon_sym_use] = ACTIONS(2560),
    [anon_sym_while] = ACTIONS(2560),
    [anon_sym_extern] = ACTIONS(2560),
    [anon_sym_yield] = ACTIONS(2560),
    [anon_sym_move] = ACTIONS(2560),
    [anon_sym_try] = ACTIONS(2560),
    [sym_integer_literal] = ACTIONS(2558),
    [aux_sym_string_literal_token1] = ACTIONS(2558),
    [sym_char_literal] = ACTIONS(2558),
    [anon_sym_true] = ACTIONS(2560),
    [anon_sym_false] = ACTIONS(2560),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2560),
    [sym_super] = ACTIONS(2560),
    [sym_crate] = ACTIONS(2560),
    [sym_metavariable] = ACTIONS(2558),
    [sym__raw_string_literal_start] = ACTIONS(2558),
    [sym_float_literal] = ACTIONS(2558),
  },
  [683] = {
    [sym_line_comment] = STATE(683),
    [sym_block_comment] = STATE(683),
    [ts_builtin_sym_end] = ACTIONS(2562),
    [sym_identifier] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_macro_rules_BANG] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_RBRACE] = ACTIONS(2562),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_u8] = ACTIONS(2564),
    [anon_sym_i8] = ACTIONS(2564),
    [anon_sym_u16] = ACTIONS(2564),
    [anon_sym_i16] = ACTIONS(2564),
    [anon_sym_u32] = ACTIONS(2564),
    [anon_sym_i32] = ACTIONS(2564),
    [anon_sym_u64] = ACTIONS(2564),
    [anon_sym_i64] = ACTIONS(2564),
    [anon_sym_u128] = ACTIONS(2564),
    [anon_sym_i128] = ACTIONS(2564),
    [anon_sym_isize] = ACTIONS(2564),
    [anon_sym_usize] = ACTIONS(2564),
    [anon_sym_f32] = ACTIONS(2564),
    [anon_sym_f64] = ACTIONS(2564),
    [anon_sym_bool] = ACTIONS(2564),
    [anon_sym_str] = ACTIONS(2564),
    [anon_sym_char] = ACTIONS(2564),
    [anon_sym_DASH] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_DOT_DOT] = ACTIONS(2562),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_POUND] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [anon_sym_async] = ACTIONS(2564),
    [anon_sym_break] = ACTIONS(2564),
    [anon_sym_const] = ACTIONS(2564),
    [anon_sym_continue] = ACTIONS(2564),
    [anon_sym_default] = ACTIONS(2564),
    [anon_sym_enum] = ACTIONS(2564),
    [anon_sym_fn] = ACTIONS(2564),
    [anon_sym_for] = ACTIONS(2564),
    [anon_sym_if] = ACTIONS(2564),
    [anon_sym_impl] = ACTIONS(2564),
    [anon_sym_let] = ACTIONS(2564),
    [anon_sym_loop] = ACTIONS(2564),
    [anon_sym_match] = ACTIONS(2564),
    [anon_sym_mod] = ACTIONS(2564),
    [anon_sym_pub] = ACTIONS(2564),
    [anon_sym_return] = ACTIONS(2564),
    [anon_sym_static] = ACTIONS(2564),
    [anon_sym_struct] = ACTIONS(2564),
    [anon_sym_trait] = ACTIONS(2564),
    [anon_sym_type] = ACTIONS(2564),
    [anon_sym_union] = ACTIONS(2564),
    [anon_sym_unsafe] = ACTIONS(2564),
    [anon_sym_use] = ACTIONS(2564),
    [anon_sym_while] = ACTIONS(2564),
    [anon_sym_extern] = ACTIONS(2564),
    [anon_sym_yield] = ACTIONS(2564),
    [anon_sym_move] = ACTIONS(2564),
    [anon_sym_try] = ACTIONS(2564),
    [sym_integer_literal] = ACTIONS(2562),
    [aux_sym_string_literal_token1] = ACTIONS(2562),
    [sym_char_literal] = ACTIONS(2562),
    [anon_sym_true] = ACTIONS(2564),
    [anon_sym_false] = ACTIONS(2564),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2564),
    [sym_super] = ACTIONS(2564),
    [sym_crate] = ACTIONS(2564),
    [sym_metavariable] = ACTIONS(2562),
    [sym__raw_string_literal_start] = ACTIONS(2562),
    [sym_float_literal] = ACTIONS(2562),
  },
  [684] = {
    [sym_line_comment] = STATE(684),
    [sym_block_comment] = STATE(684),
    [ts_builtin_sym_end] = ACTIONS(2566),
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_macro_rules_BANG] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2566),
    [anon_sym_RBRACE] = ACTIONS(2566),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_u8] = ACTIONS(2568),
    [anon_sym_i8] = ACTIONS(2568),
    [anon_sym_u16] = ACTIONS(2568),
    [anon_sym_i16] = ACTIONS(2568),
    [anon_sym_u32] = ACTIONS(2568),
    [anon_sym_i32] = ACTIONS(2568),
    [anon_sym_u64] = ACTIONS(2568),
    [anon_sym_i64] = ACTIONS(2568),
    [anon_sym_u128] = ACTIONS(2568),
    [anon_sym_i128] = ACTIONS(2568),
    [anon_sym_isize] = ACTIONS(2568),
    [anon_sym_usize] = ACTIONS(2568),
    [anon_sym_f32] = ACTIONS(2568),
    [anon_sym_f64] = ACTIONS(2568),
    [anon_sym_bool] = ACTIONS(2568),
    [anon_sym_str] = ACTIONS(2568),
    [anon_sym_char] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_DOT_DOT] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_POUND] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2568),
    [anon_sym_async] = ACTIONS(2568),
    [anon_sym_break] = ACTIONS(2568),
    [anon_sym_const] = ACTIONS(2568),
    [anon_sym_continue] = ACTIONS(2568),
    [anon_sym_default] = ACTIONS(2568),
    [anon_sym_enum] = ACTIONS(2568),
    [anon_sym_fn] = ACTIONS(2568),
    [anon_sym_for] = ACTIONS(2568),
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_impl] = ACTIONS(2568),
    [anon_sym_let] = ACTIONS(2568),
    [anon_sym_loop] = ACTIONS(2568),
    [anon_sym_match] = ACTIONS(2568),
    [anon_sym_mod] = ACTIONS(2568),
    [anon_sym_pub] = ACTIONS(2568),
    [anon_sym_return] = ACTIONS(2568),
    [anon_sym_static] = ACTIONS(2568),
    [anon_sym_struct] = ACTIONS(2568),
    [anon_sym_trait] = ACTIONS(2568),
    [anon_sym_type] = ACTIONS(2568),
    [anon_sym_union] = ACTIONS(2568),
    [anon_sym_unsafe] = ACTIONS(2568),
    [anon_sym_use] = ACTIONS(2568),
    [anon_sym_while] = ACTIONS(2568),
    [anon_sym_extern] = ACTIONS(2568),
    [anon_sym_yield] = ACTIONS(2568),
    [anon_sym_move] = ACTIONS(2568),
    [anon_sym_try] = ACTIONS(2568),
    [sym_integer_literal] = ACTIONS(2566),
    [aux_sym_string_literal_token1] = ACTIONS(2566),
    [sym_char_literal] = ACTIONS(2566),
    [anon_sym_true] = ACTIONS(2568),
    [anon_sym_false] = ACTIONS(2568),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2568),
    [sym_super] = ACTIONS(2568),
    [sym_crate] = ACTIONS(2568),
    [sym_metavariable] = ACTIONS(2566),
    [sym__raw_string_literal_start] = ACTIONS(2566),
    [sym_float_literal] = ACTIONS(2566),
  },
  [685] = {
    [sym_line_comment] = STATE(685),
    [sym_block_comment] = STATE(685),
    [ts_builtin_sym_end] = ACTIONS(2570),
    [sym_identifier] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_macro_rules_BANG] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2570),
    [anon_sym_LBRACK] = ACTIONS(2570),
    [anon_sym_LBRACE] = ACTIONS(2570),
    [anon_sym_RBRACE] = ACTIONS(2570),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_u8] = ACTIONS(2572),
    [anon_sym_i8] = ACTIONS(2572),
    [anon_sym_u16] = ACTIONS(2572),
    [anon_sym_i16] = ACTIONS(2572),
    [anon_sym_u32] = ACTIONS(2572),
    [anon_sym_i32] = ACTIONS(2572),
    [anon_sym_u64] = ACTIONS(2572),
    [anon_sym_i64] = ACTIONS(2572),
    [anon_sym_u128] = ACTIONS(2572),
    [anon_sym_i128] = ACTIONS(2572),
    [anon_sym_isize] = ACTIONS(2572),
    [anon_sym_usize] = ACTIONS(2572),
    [anon_sym_f32] = ACTIONS(2572),
    [anon_sym_f64] = ACTIONS(2572),
    [anon_sym_bool] = ACTIONS(2572),
    [anon_sym_str] = ACTIONS(2572),
    [anon_sym_char] = ACTIONS(2572),
    [anon_sym_DASH] = ACTIONS(2570),
    [anon_sym_BANG] = ACTIONS(2570),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2570),
    [anon_sym_POUND] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2572),
    [anon_sym_break] = ACTIONS(2572),
    [anon_sym_const] = ACTIONS(2572),
    [anon_sym_continue] = ACTIONS(2572),
    [anon_sym_default] = ACTIONS(2572),
    [anon_sym_enum] = ACTIONS(2572),
    [anon_sym_fn] = ACTIONS(2572),
    [anon_sym_for] = ACTIONS(2572),
    [anon_sym_if] = ACTIONS(2572),
    [anon_sym_impl] = ACTIONS(2572),
    [anon_sym_let] = ACTIONS(2572),
    [anon_sym_loop] = ACTIONS(2572),
    [anon_sym_match] = ACTIONS(2572),
    [anon_sym_mod] = ACTIONS(2572),
    [anon_sym_pub] = ACTIONS(2572),
    [anon_sym_return] = ACTIONS(2572),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_struct] = ACTIONS(2572),
    [anon_sym_trait] = ACTIONS(2572),
    [anon_sym_type] = ACTIONS(2572),
    [anon_sym_union] = ACTIONS(2572),
    [anon_sym_unsafe] = ACTIONS(2572),
    [anon_sym_use] = ACTIONS(2572),
    [anon_sym_while] = ACTIONS(2572),
    [anon_sym_extern] = ACTIONS(2572),
    [anon_sym_yield] = ACTIONS(2572),
    [anon_sym_move] = ACTIONS(2572),
    [anon_sym_try] = ACTIONS(2572),
    [sym_integer_literal] = ACTIONS(2570),
    [aux_sym_string_literal_token1] = ACTIONS(2570),
    [sym_char_literal] = ACTIONS(2570),
    [anon_sym_true] = ACTIONS(2572),
    [anon_sym_false] = ACTIONS(2572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2572),
    [sym_super] = ACTIONS(2572),
    [sym_crate] = ACTIONS(2572),
    [sym_metavariable] = ACTIONS(2570),
    [sym__raw_string_literal_start] = ACTIONS(2570),
    [sym_float_literal] = ACTIONS(2570),
  },
  [686] = {
    [sym_line_comment] = STATE(686),
    [sym_block_comment] = STATE(686),
    [ts_builtin_sym_end] = ACTIONS(2574),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_macro_rules_BANG] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2574),
    [anon_sym_LBRACK] = ACTIONS(2574),
    [anon_sym_LBRACE] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2574),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_u8] = ACTIONS(2576),
    [anon_sym_i8] = ACTIONS(2576),
    [anon_sym_u16] = ACTIONS(2576),
    [anon_sym_i16] = ACTIONS(2576),
    [anon_sym_u32] = ACTIONS(2576),
    [anon_sym_i32] = ACTIONS(2576),
    [anon_sym_u64] = ACTIONS(2576),
    [anon_sym_i64] = ACTIONS(2576),
    [anon_sym_u128] = ACTIONS(2576),
    [anon_sym_i128] = ACTIONS(2576),
    [anon_sym_isize] = ACTIONS(2576),
    [anon_sym_usize] = ACTIONS(2576),
    [anon_sym_f32] = ACTIONS(2576),
    [anon_sym_f64] = ACTIONS(2576),
    [anon_sym_bool] = ACTIONS(2576),
    [anon_sym_str] = ACTIONS(2576),
    [anon_sym_char] = ACTIONS(2576),
    [anon_sym_DASH] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(2574),
    [anon_sym_PIPE] = ACTIONS(2574),
    [anon_sym_LT] = ACTIONS(2574),
    [anon_sym_DOT_DOT] = ACTIONS(2574),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_POUND] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2576),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_break] = ACTIONS(2576),
    [anon_sym_const] = ACTIONS(2576),
    [anon_sym_continue] = ACTIONS(2576),
    [anon_sym_default] = ACTIONS(2576),
    [anon_sym_enum] = ACTIONS(2576),
    [anon_sym_fn] = ACTIONS(2576),
    [anon_sym_for] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2576),
    [anon_sym_impl] = ACTIONS(2576),
    [anon_sym_let] = ACTIONS(2576),
    [anon_sym_loop] = ACTIONS(2576),
    [anon_sym_match] = ACTIONS(2576),
    [anon_sym_mod] = ACTIONS(2576),
    [anon_sym_pub] = ACTIONS(2576),
    [anon_sym_return] = ACTIONS(2576),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_struct] = ACTIONS(2576),
    [anon_sym_trait] = ACTIONS(2576),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_union] = ACTIONS(2576),
    [anon_sym_unsafe] = ACTIONS(2576),
    [anon_sym_use] = ACTIONS(2576),
    [anon_sym_while] = ACTIONS(2576),
    [anon_sym_extern] = ACTIONS(2576),
    [anon_sym_yield] = ACTIONS(2576),
    [anon_sym_move] = ACTIONS(2576),
    [anon_sym_try] = ACTIONS(2576),
    [sym_integer_literal] = ACTIONS(2574),
    [aux_sym_string_literal_token1] = ACTIONS(2574),
    [sym_char_literal] = ACTIONS(2574),
    [anon_sym_true] = ACTIONS(2576),
    [anon_sym_false] = ACTIONS(2576),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2576),
    [sym_super] = ACTIONS(2576),
    [sym_crate] = ACTIONS(2576),
    [sym_metavariable] = ACTIONS(2574),
    [sym__raw_string_literal_start] = ACTIONS(2574),
    [sym_float_literal] = ACTIONS(2574),
  },
  [687] = {
    [sym_line_comment] = STATE(687),
    [sym_block_comment] = STATE(687),
    [ts_builtin_sym_end] = ACTIONS(2578),
    [sym_identifier] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_macro_rules_BANG] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2578),
    [anon_sym_RBRACE] = ACTIONS(2578),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_u8] = ACTIONS(2580),
    [anon_sym_i8] = ACTIONS(2580),
    [anon_sym_u16] = ACTIONS(2580),
    [anon_sym_i16] = ACTIONS(2580),
    [anon_sym_u32] = ACTIONS(2580),
    [anon_sym_i32] = ACTIONS(2580),
    [anon_sym_u64] = ACTIONS(2580),
    [anon_sym_i64] = ACTIONS(2580),
    [anon_sym_u128] = ACTIONS(2580),
    [anon_sym_i128] = ACTIONS(2580),
    [anon_sym_isize] = ACTIONS(2580),
    [anon_sym_usize] = ACTIONS(2580),
    [anon_sym_f32] = ACTIONS(2580),
    [anon_sym_f64] = ACTIONS(2580),
    [anon_sym_bool] = ACTIONS(2580),
    [anon_sym_str] = ACTIONS(2580),
    [anon_sym_char] = ACTIONS(2580),
    [anon_sym_DASH] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_POUND] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2580),
    [anon_sym_async] = ACTIONS(2580),
    [anon_sym_break] = ACTIONS(2580),
    [anon_sym_const] = ACTIONS(2580),
    [anon_sym_continue] = ACTIONS(2580),
    [anon_sym_default] = ACTIONS(2580),
    [anon_sym_enum] = ACTIONS(2580),
    [anon_sym_fn] = ACTIONS(2580),
    [anon_sym_for] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2580),
    [anon_sym_impl] = ACTIONS(2580),
    [anon_sym_let] = ACTIONS(2580),
    [anon_sym_loop] = ACTIONS(2580),
    [anon_sym_match] = ACTIONS(2580),
    [anon_sym_mod] = ACTIONS(2580),
    [anon_sym_pub] = ACTIONS(2580),
    [anon_sym_return] = ACTIONS(2580),
    [anon_sym_static] = ACTIONS(2580),
    [anon_sym_struct] = ACTIONS(2580),
    [anon_sym_trait] = ACTIONS(2580),
    [anon_sym_type] = ACTIONS(2580),
    [anon_sym_union] = ACTIONS(2580),
    [anon_sym_unsafe] = ACTIONS(2580),
    [anon_sym_use] = ACTIONS(2580),
    [anon_sym_while] = ACTIONS(2580),
    [anon_sym_extern] = ACTIONS(2580),
    [anon_sym_yield] = ACTIONS(2580),
    [anon_sym_move] = ACTIONS(2580),
    [anon_sym_try] = ACTIONS(2580),
    [sym_integer_literal] = ACTIONS(2578),
    [aux_sym_string_literal_token1] = ACTIONS(2578),
    [sym_char_literal] = ACTIONS(2578),
    [anon_sym_true] = ACTIONS(2580),
    [anon_sym_false] = ACTIONS(2580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2580),
    [sym_super] = ACTIONS(2580),
    [sym_crate] = ACTIONS(2580),
    [sym_metavariable] = ACTIONS(2578),
    [sym__raw_string_literal_start] = ACTIONS(2578),
    [sym_float_literal] = ACTIONS(2578),
  },
  [688] = {
    [sym_line_comment] = STATE(688),
    [sym_block_comment] = STATE(688),
    [ts_builtin_sym_end] = ACTIONS(2582),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_macro_rules_BANG] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_RBRACE] = ACTIONS(2582),
    [anon_sym_STAR] = ACTIONS(2582),
    [anon_sym_u8] = ACTIONS(2584),
    [anon_sym_i8] = ACTIONS(2584),
    [anon_sym_u16] = ACTIONS(2584),
    [anon_sym_i16] = ACTIONS(2584),
    [anon_sym_u32] = ACTIONS(2584),
    [anon_sym_i32] = ACTIONS(2584),
    [anon_sym_u64] = ACTIONS(2584),
    [anon_sym_i64] = ACTIONS(2584),
    [anon_sym_u128] = ACTIONS(2584),
    [anon_sym_i128] = ACTIONS(2584),
    [anon_sym_isize] = ACTIONS(2584),
    [anon_sym_usize] = ACTIONS(2584),
    [anon_sym_f32] = ACTIONS(2584),
    [anon_sym_f64] = ACTIONS(2584),
    [anon_sym_bool] = ACTIONS(2584),
    [anon_sym_str] = ACTIONS(2584),
    [anon_sym_char] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_POUND] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2584),
    [anon_sym_async] = ACTIONS(2584),
    [anon_sym_break] = ACTIONS(2584),
    [anon_sym_const] = ACTIONS(2584),
    [anon_sym_continue] = ACTIONS(2584),
    [anon_sym_default] = ACTIONS(2584),
    [anon_sym_enum] = ACTIONS(2584),
    [anon_sym_fn] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2584),
    [anon_sym_if] = ACTIONS(2584),
    [anon_sym_impl] = ACTIONS(2584),
    [anon_sym_let] = ACTIONS(2584),
    [anon_sym_loop] = ACTIONS(2584),
    [anon_sym_match] = ACTIONS(2584),
    [anon_sym_mod] = ACTIONS(2584),
    [anon_sym_pub] = ACTIONS(2584),
    [anon_sym_return] = ACTIONS(2584),
    [anon_sym_static] = ACTIONS(2584),
    [anon_sym_struct] = ACTIONS(2584),
    [anon_sym_trait] = ACTIONS(2584),
    [anon_sym_type] = ACTIONS(2584),
    [anon_sym_union] = ACTIONS(2584),
    [anon_sym_unsafe] = ACTIONS(2584),
    [anon_sym_use] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2584),
    [anon_sym_extern] = ACTIONS(2584),
    [anon_sym_yield] = ACTIONS(2584),
    [anon_sym_move] = ACTIONS(2584),
    [anon_sym_try] = ACTIONS(2584),
    [sym_integer_literal] = ACTIONS(2582),
    [aux_sym_string_literal_token1] = ACTIONS(2582),
    [sym_char_literal] = ACTIONS(2582),
    [anon_sym_true] = ACTIONS(2584),
    [anon_sym_false] = ACTIONS(2584),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2584),
    [sym_super] = ACTIONS(2584),
    [sym_crate] = ACTIONS(2584),
    [sym_metavariable] = ACTIONS(2582),
    [sym__raw_string_literal_start] = ACTIONS(2582),
    [sym_float_literal] = ACTIONS(2582),
  },
  [689] = {
    [sym_line_comment] = STATE(689),
    [sym_block_comment] = STATE(689),
    [ts_builtin_sym_end] = ACTIONS(2586),
    [sym_identifier] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_macro_rules_BANG] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [anon_sym_STAR] = ACTIONS(2586),
    [anon_sym_u8] = ACTIONS(2588),
    [anon_sym_i8] = ACTIONS(2588),
    [anon_sym_u16] = ACTIONS(2588),
    [anon_sym_i16] = ACTIONS(2588),
    [anon_sym_u32] = ACTIONS(2588),
    [anon_sym_i32] = ACTIONS(2588),
    [anon_sym_u64] = ACTIONS(2588),
    [anon_sym_i64] = ACTIONS(2588),
    [anon_sym_u128] = ACTIONS(2588),
    [anon_sym_i128] = ACTIONS(2588),
    [anon_sym_isize] = ACTIONS(2588),
    [anon_sym_usize] = ACTIONS(2588),
    [anon_sym_f32] = ACTIONS(2588),
    [anon_sym_f64] = ACTIONS(2588),
    [anon_sym_bool] = ACTIONS(2588),
    [anon_sym_str] = ACTIONS(2588),
    [anon_sym_char] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_DOT_DOT] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_POUND] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2588),
    [anon_sym_async] = ACTIONS(2588),
    [anon_sym_break] = ACTIONS(2588),
    [anon_sym_const] = ACTIONS(2588),
    [anon_sym_continue] = ACTIONS(2588),
    [anon_sym_default] = ACTIONS(2588),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_fn] = ACTIONS(2588),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_impl] = ACTIONS(2588),
    [anon_sym_let] = ACTIONS(2588),
    [anon_sym_loop] = ACTIONS(2588),
    [anon_sym_match] = ACTIONS(2588),
    [anon_sym_mod] = ACTIONS(2588),
    [anon_sym_pub] = ACTIONS(2588),
    [anon_sym_return] = ACTIONS(2588),
    [anon_sym_static] = ACTIONS(2588),
    [anon_sym_struct] = ACTIONS(2588),
    [anon_sym_trait] = ACTIONS(2588),
    [anon_sym_type] = ACTIONS(2588),
    [anon_sym_union] = ACTIONS(2588),
    [anon_sym_unsafe] = ACTIONS(2588),
    [anon_sym_use] = ACTIONS(2588),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_extern] = ACTIONS(2588),
    [anon_sym_yield] = ACTIONS(2588),
    [anon_sym_move] = ACTIONS(2588),
    [anon_sym_try] = ACTIONS(2588),
    [sym_integer_literal] = ACTIONS(2586),
    [aux_sym_string_literal_token1] = ACTIONS(2586),
    [sym_char_literal] = ACTIONS(2586),
    [anon_sym_true] = ACTIONS(2588),
    [anon_sym_false] = ACTIONS(2588),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2588),
    [sym_super] = ACTIONS(2588),
    [sym_crate] = ACTIONS(2588),
    [sym_metavariable] = ACTIONS(2586),
    [sym__raw_string_literal_start] = ACTIONS(2586),
    [sym_float_literal] = ACTIONS(2586),
  },
  [690] = {
    [sym_line_comment] = STATE(690),
    [sym_block_comment] = STATE(690),
    [ts_builtin_sym_end] = ACTIONS(2590),
    [sym_identifier] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_macro_rules_BANG] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_u8] = ACTIONS(2592),
    [anon_sym_i8] = ACTIONS(2592),
    [anon_sym_u16] = ACTIONS(2592),
    [anon_sym_i16] = ACTIONS(2592),
    [anon_sym_u32] = ACTIONS(2592),
    [anon_sym_i32] = ACTIONS(2592),
    [anon_sym_u64] = ACTIONS(2592),
    [anon_sym_i64] = ACTIONS(2592),
    [anon_sym_u128] = ACTIONS(2592),
    [anon_sym_i128] = ACTIONS(2592),
    [anon_sym_isize] = ACTIONS(2592),
    [anon_sym_usize] = ACTIONS(2592),
    [anon_sym_f32] = ACTIONS(2592),
    [anon_sym_f64] = ACTIONS(2592),
    [anon_sym_bool] = ACTIONS(2592),
    [anon_sym_str] = ACTIONS(2592),
    [anon_sym_char] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_DOT_DOT] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2590),
    [anon_sym_POUND] = ACTIONS(2590),
    [anon_sym_SQUOTE] = ACTIONS(2592),
    [anon_sym_async] = ACTIONS(2592),
    [anon_sym_break] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_continue] = ACTIONS(2592),
    [anon_sym_default] = ACTIONS(2592),
    [anon_sym_enum] = ACTIONS(2592),
    [anon_sym_fn] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_impl] = ACTIONS(2592),
    [anon_sym_let] = ACTIONS(2592),
    [anon_sym_loop] = ACTIONS(2592),
    [anon_sym_match] = ACTIONS(2592),
    [anon_sym_mod] = ACTIONS(2592),
    [anon_sym_pub] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_struct] = ACTIONS(2592),
    [anon_sym_trait] = ACTIONS(2592),
    [anon_sym_type] = ACTIONS(2592),
    [anon_sym_union] = ACTIONS(2592),
    [anon_sym_unsafe] = ACTIONS(2592),
    [anon_sym_use] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [anon_sym_extern] = ACTIONS(2592),
    [anon_sym_yield] = ACTIONS(2592),
    [anon_sym_move] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [sym_integer_literal] = ACTIONS(2590),
    [aux_sym_string_literal_token1] = ACTIONS(2590),
    [sym_char_literal] = ACTIONS(2590),
    [anon_sym_true] = ACTIONS(2592),
    [anon_sym_false] = ACTIONS(2592),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2592),
    [sym_super] = ACTIONS(2592),
    [sym_crate] = ACTIONS(2592),
    [sym_metavariable] = ACTIONS(2590),
    [sym__raw_string_literal_start] = ACTIONS(2590),
    [sym_float_literal] = ACTIONS(2590),
  },
  [691] = {
    [sym_line_comment] = STATE(691),
    [sym_block_comment] = STATE(691),
    [ts_builtin_sym_end] = ACTIONS(2594),
    [sym_identifier] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_macro_rules_BANG] = ACTIONS(2594),
    [anon_sym_LPAREN] = ACTIONS(2594),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_LBRACE] = ACTIONS(2594),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_u8] = ACTIONS(2596),
    [anon_sym_i8] = ACTIONS(2596),
    [anon_sym_u16] = ACTIONS(2596),
    [anon_sym_i16] = ACTIONS(2596),
    [anon_sym_u32] = ACTIONS(2596),
    [anon_sym_i32] = ACTIONS(2596),
    [anon_sym_u64] = ACTIONS(2596),
    [anon_sym_i64] = ACTIONS(2596),
    [anon_sym_u128] = ACTIONS(2596),
    [anon_sym_i128] = ACTIONS(2596),
    [anon_sym_isize] = ACTIONS(2596),
    [anon_sym_usize] = ACTIONS(2596),
    [anon_sym_f32] = ACTIONS(2596),
    [anon_sym_f64] = ACTIONS(2596),
    [anon_sym_bool] = ACTIONS(2596),
    [anon_sym_str] = ACTIONS(2596),
    [anon_sym_char] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(2594),
    [anon_sym_BANG] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(2594),
    [anon_sym_PIPE] = ACTIONS(2594),
    [anon_sym_LT] = ACTIONS(2594),
    [anon_sym_DOT_DOT] = ACTIONS(2594),
    [anon_sym_COLON_COLON] = ACTIONS(2594),
    [anon_sym_POUND] = ACTIONS(2594),
    [anon_sym_SQUOTE] = ACTIONS(2596),
    [anon_sym_async] = ACTIONS(2596),
    [anon_sym_break] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_continue] = ACTIONS(2596),
    [anon_sym_default] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [anon_sym_fn] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_impl] = ACTIONS(2596),
    [anon_sym_let] = ACTIONS(2596),
    [anon_sym_loop] = ACTIONS(2596),
    [anon_sym_match] = ACTIONS(2596),
    [anon_sym_mod] = ACTIONS(2596),
    [anon_sym_pub] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_trait] = ACTIONS(2596),
    [anon_sym_type] = ACTIONS(2596),
    [anon_sym_union] = ACTIONS(2596),
    [anon_sym_unsafe] = ACTIONS(2596),
    [anon_sym_use] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [anon_sym_extern] = ACTIONS(2596),
    [anon_sym_yield] = ACTIONS(2596),
    [anon_sym_move] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [sym_integer_literal] = ACTIONS(2594),
    [aux_sym_string_literal_token1] = ACTIONS(2594),
    [sym_char_literal] = ACTIONS(2594),
    [anon_sym_true] = ACTIONS(2596),
    [anon_sym_false] = ACTIONS(2596),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2596),
    [sym_super] = ACTIONS(2596),
    [sym_crate] = ACTIONS(2596),
    [sym_metavariable] = ACTIONS(2594),
    [sym__raw_string_literal_start] = ACTIONS(2594),
    [sym_float_literal] = ACTIONS(2594),
  },
  [692] = {
    [sym_line_comment] = STATE(692),
    [sym_block_comment] = STATE(692),
    [ts_builtin_sym_end] = ACTIONS(2598),
    [sym_identifier] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_macro_rules_BANG] = ACTIONS(2598),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_STAR] = ACTIONS(2598),
    [anon_sym_u8] = ACTIONS(2600),
    [anon_sym_i8] = ACTIONS(2600),
    [anon_sym_u16] = ACTIONS(2600),
    [anon_sym_i16] = ACTIONS(2600),
    [anon_sym_u32] = ACTIONS(2600),
    [anon_sym_i32] = ACTIONS(2600),
    [anon_sym_u64] = ACTIONS(2600),
    [anon_sym_i64] = ACTIONS(2600),
    [anon_sym_u128] = ACTIONS(2600),
    [anon_sym_i128] = ACTIONS(2600),
    [anon_sym_isize] = ACTIONS(2600),
    [anon_sym_usize] = ACTIONS(2600),
    [anon_sym_f32] = ACTIONS(2600),
    [anon_sym_f64] = ACTIONS(2600),
    [anon_sym_bool] = ACTIONS(2600),
    [anon_sym_str] = ACTIONS(2600),
    [anon_sym_char] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_DOT_DOT] = ACTIONS(2598),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_POUND] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2600),
    [anon_sym_async] = ACTIONS(2600),
    [anon_sym_break] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_continue] = ACTIONS(2600),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_enum] = ACTIONS(2600),
    [anon_sym_fn] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_impl] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_loop] = ACTIONS(2600),
    [anon_sym_match] = ACTIONS(2600),
    [anon_sym_mod] = ACTIONS(2600),
    [anon_sym_pub] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_static] = ACTIONS(2600),
    [anon_sym_struct] = ACTIONS(2600),
    [anon_sym_trait] = ACTIONS(2600),
    [anon_sym_type] = ACTIONS(2600),
    [anon_sym_union] = ACTIONS(2600),
    [anon_sym_unsafe] = ACTIONS(2600),
    [anon_sym_use] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [anon_sym_extern] = ACTIONS(2600),
    [anon_sym_yield] = ACTIONS(2600),
    [anon_sym_move] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [sym_integer_literal] = ACTIONS(2598),
    [aux_sym_string_literal_token1] = ACTIONS(2598),
    [sym_char_literal] = ACTIONS(2598),
    [anon_sym_true] = ACTIONS(2600),
    [anon_sym_false] = ACTIONS(2600),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2600),
    [sym_super] = ACTIONS(2600),
    [sym_crate] = ACTIONS(2600),
    [sym_metavariable] = ACTIONS(2598),
    [sym__raw_string_literal_start] = ACTIONS(2598),
    [sym_float_literal] = ACTIONS(2598),
  },
  [693] = {
    [sym_line_comment] = STATE(693),
    [sym_block_comment] = STATE(693),
    [ts_builtin_sym_end] = ACTIONS(2602),
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_macro_rules_BANG] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_STAR] = ACTIONS(2602),
    [anon_sym_u8] = ACTIONS(2604),
    [anon_sym_i8] = ACTIONS(2604),
    [anon_sym_u16] = ACTIONS(2604),
    [anon_sym_i16] = ACTIONS(2604),
    [anon_sym_u32] = ACTIONS(2604),
    [anon_sym_i32] = ACTIONS(2604),
    [anon_sym_u64] = ACTIONS(2604),
    [anon_sym_i64] = ACTIONS(2604),
    [anon_sym_u128] = ACTIONS(2604),
    [anon_sym_i128] = ACTIONS(2604),
    [anon_sym_isize] = ACTIONS(2604),
    [anon_sym_usize] = ACTIONS(2604),
    [anon_sym_f32] = ACTIONS(2604),
    [anon_sym_f64] = ACTIONS(2604),
    [anon_sym_bool] = ACTIONS(2604),
    [anon_sym_str] = ACTIONS(2604),
    [anon_sym_char] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_DOT_DOT] = ACTIONS(2602),
    [anon_sym_COLON_COLON] = ACTIONS(2602),
    [anon_sym_POUND] = ACTIONS(2602),
    [anon_sym_SQUOTE] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_fn] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_impl] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_loop] = ACTIONS(2604),
    [anon_sym_match] = ACTIONS(2604),
    [anon_sym_mod] = ACTIONS(2604),
    [anon_sym_pub] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_trait] = ACTIONS(2604),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [anon_sym_unsafe] = ACTIONS(2604),
    [anon_sym_use] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_move] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [sym_integer_literal] = ACTIONS(2602),
    [aux_sym_string_literal_token1] = ACTIONS(2602),
    [sym_char_literal] = ACTIONS(2602),
    [anon_sym_true] = ACTIONS(2604),
    [anon_sym_false] = ACTIONS(2604),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_crate] = ACTIONS(2604),
    [sym_metavariable] = ACTIONS(2602),
    [sym__raw_string_literal_start] = ACTIONS(2602),
    [sym_float_literal] = ACTIONS(2602),
  },
  [694] = {
    [sym_line_comment] = STATE(694),
    [sym_block_comment] = STATE(694),
    [ts_builtin_sym_end] = ACTIONS(2606),
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_macro_rules_BANG] = ACTIONS(2606),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_u8] = ACTIONS(2608),
    [anon_sym_i8] = ACTIONS(2608),
    [anon_sym_u16] = ACTIONS(2608),
    [anon_sym_i16] = ACTIONS(2608),
    [anon_sym_u32] = ACTIONS(2608),
    [anon_sym_i32] = ACTIONS(2608),
    [anon_sym_u64] = ACTIONS(2608),
    [anon_sym_i64] = ACTIONS(2608),
    [anon_sym_u128] = ACTIONS(2608),
    [anon_sym_i128] = ACTIONS(2608),
    [anon_sym_isize] = ACTIONS(2608),
    [anon_sym_usize] = ACTIONS(2608),
    [anon_sym_f32] = ACTIONS(2608),
    [anon_sym_f64] = ACTIONS(2608),
    [anon_sym_bool] = ACTIONS(2608),
    [anon_sym_str] = ACTIONS(2608),
    [anon_sym_char] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PIPE] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2606),
    [anon_sym_DOT_DOT] = ACTIONS(2606),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_POUND] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_fn] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_impl] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_loop] = ACTIONS(2608),
    [anon_sym_match] = ACTIONS(2608),
    [anon_sym_mod] = ACTIONS(2608),
    [anon_sym_pub] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_struct] = ACTIONS(2608),
    [anon_sym_trait] = ACTIONS(2608),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_union] = ACTIONS(2608),
    [anon_sym_unsafe] = ACTIONS(2608),
    [anon_sym_use] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_extern] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_move] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [sym_integer_literal] = ACTIONS(2606),
    [aux_sym_string_literal_token1] = ACTIONS(2606),
    [sym_char_literal] = ACTIONS(2606),
    [anon_sym_true] = ACTIONS(2608),
    [anon_sym_false] = ACTIONS(2608),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_crate] = ACTIONS(2608),
    [sym_metavariable] = ACTIONS(2606),
    [sym__raw_string_literal_start] = ACTIONS(2606),
    [sym_float_literal] = ACTIONS(2606),
  },
  [695] = {
    [sym_line_comment] = STATE(695),
    [sym_block_comment] = STATE(695),
    [ts_builtin_sym_end] = ACTIONS(2610),
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_macro_rules_BANG] = ACTIONS(2610),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_u8] = ACTIONS(2612),
    [anon_sym_i8] = ACTIONS(2612),
    [anon_sym_u16] = ACTIONS(2612),
    [anon_sym_i16] = ACTIONS(2612),
    [anon_sym_u32] = ACTIONS(2612),
    [anon_sym_i32] = ACTIONS(2612),
    [anon_sym_u64] = ACTIONS(2612),
    [anon_sym_i64] = ACTIONS(2612),
    [anon_sym_u128] = ACTIONS(2612),
    [anon_sym_i128] = ACTIONS(2612),
    [anon_sym_isize] = ACTIONS(2612),
    [anon_sym_usize] = ACTIONS(2612),
    [anon_sym_f32] = ACTIONS(2612),
    [anon_sym_f64] = ACTIONS(2612),
    [anon_sym_bool] = ACTIONS(2612),
    [anon_sym_str] = ACTIONS(2612),
    [anon_sym_char] = ACTIONS(2612),
    [anon_sym_DASH] = ACTIONS(2610),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PIPE] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2610),
    [anon_sym_DOT_DOT] = ACTIONS(2610),
    [anon_sym_COLON_COLON] = ACTIONS(2610),
    [anon_sym_POUND] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2612),
    [anon_sym_async] = ACTIONS(2612),
    [anon_sym_break] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_continue] = ACTIONS(2612),
    [anon_sym_default] = ACTIONS(2612),
    [anon_sym_enum] = ACTIONS(2612),
    [anon_sym_fn] = ACTIONS(2612),
    [anon_sym_for] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(2612),
    [anon_sym_impl] = ACTIONS(2612),
    [anon_sym_let] = ACTIONS(2612),
    [anon_sym_loop] = ACTIONS(2612),
    [anon_sym_match] = ACTIONS(2612),
    [anon_sym_mod] = ACTIONS(2612),
    [anon_sym_pub] = ACTIONS(2612),
    [anon_sym_return] = ACTIONS(2612),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_trait] = ACTIONS(2612),
    [anon_sym_type] = ACTIONS(2612),
    [anon_sym_union] = ACTIONS(2612),
    [anon_sym_unsafe] = ACTIONS(2612),
    [anon_sym_use] = ACTIONS(2612),
    [anon_sym_while] = ACTIONS(2612),
    [anon_sym_extern] = ACTIONS(2612),
    [anon_sym_yield] = ACTIONS(2612),
    [anon_sym_move] = ACTIONS(2612),
    [anon_sym_try] = ACTIONS(2612),
    [sym_integer_literal] = ACTIONS(2610),
    [aux_sym_string_literal_token1] = ACTIONS(2610),
    [sym_char_literal] = ACTIONS(2610),
    [anon_sym_true] = ACTIONS(2612),
    [anon_sym_false] = ACTIONS(2612),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2612),
    [sym_super] = ACTIONS(2612),
    [sym_crate] = ACTIONS(2612),
    [sym_metavariable] = ACTIONS(2610),
    [sym__raw_string_literal_start] = ACTIONS(2610),
    [sym_float_literal] = ACTIONS(2610),
  },
  [696] = {
    [sym_line_comment] = STATE(696),
    [sym_block_comment] = STATE(696),
    [ts_builtin_sym_end] = ACTIONS(2614),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_macro_rules_BANG] = ACTIONS(2614),
    [anon_sym_LPAREN] = ACTIONS(2614),
    [anon_sym_LBRACK] = ACTIONS(2614),
    [anon_sym_LBRACE] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(2614),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_u8] = ACTIONS(2616),
    [anon_sym_i8] = ACTIONS(2616),
    [anon_sym_u16] = ACTIONS(2616),
    [anon_sym_i16] = ACTIONS(2616),
    [anon_sym_u32] = ACTIONS(2616),
    [anon_sym_i32] = ACTIONS(2616),
    [anon_sym_u64] = ACTIONS(2616),
    [anon_sym_i64] = ACTIONS(2616),
    [anon_sym_u128] = ACTIONS(2616),
    [anon_sym_i128] = ACTIONS(2616),
    [anon_sym_isize] = ACTIONS(2616),
    [anon_sym_usize] = ACTIONS(2616),
    [anon_sym_f32] = ACTIONS(2616),
    [anon_sym_f64] = ACTIONS(2616),
    [anon_sym_bool] = ACTIONS(2616),
    [anon_sym_str] = ACTIONS(2616),
    [anon_sym_char] = ACTIONS(2616),
    [anon_sym_DASH] = ACTIONS(2614),
    [anon_sym_BANG] = ACTIONS(2614),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_DOT_DOT] = ACTIONS(2614),
    [anon_sym_COLON_COLON] = ACTIONS(2614),
    [anon_sym_POUND] = ACTIONS(2614),
    [anon_sym_SQUOTE] = ACTIONS(2616),
    [anon_sym_async] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_continue] = ACTIONS(2616),
    [anon_sym_default] = ACTIONS(2616),
    [anon_sym_enum] = ACTIONS(2616),
    [anon_sym_fn] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_impl] = ACTIONS(2616),
    [anon_sym_let] = ACTIONS(2616),
    [anon_sym_loop] = ACTIONS(2616),
    [anon_sym_match] = ACTIONS(2616),
    [anon_sym_mod] = ACTIONS(2616),
    [anon_sym_pub] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_static] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_trait] = ACTIONS(2616),
    [anon_sym_type] = ACTIONS(2616),
    [anon_sym_union] = ACTIONS(2616),
    [anon_sym_unsafe] = ACTIONS(2616),
    [anon_sym_use] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_extern] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_move] = ACTIONS(2616),
    [anon_sym_try] = ACTIONS(2616),
    [sym_integer_literal] = ACTIONS(2614),
    [aux_sym_string_literal_token1] = ACTIONS(2614),
    [sym_char_literal] = ACTIONS(2614),
    [anon_sym_true] = ACTIONS(2616),
    [anon_sym_false] = ACTIONS(2616),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_crate] = ACTIONS(2616),
    [sym_metavariable] = ACTIONS(2614),
    [sym__raw_string_literal_start] = ACTIONS(2614),
    [sym_float_literal] = ACTIONS(2614),
  },
  [697] = {
    [sym_line_comment] = STATE(697),
    [sym_block_comment] = STATE(697),
    [ts_builtin_sym_end] = ACTIONS(2618),
    [sym_identifier] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_macro_rules_BANG] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_u8] = ACTIONS(2620),
    [anon_sym_i8] = ACTIONS(2620),
    [anon_sym_u16] = ACTIONS(2620),
    [anon_sym_i16] = ACTIONS(2620),
    [anon_sym_u32] = ACTIONS(2620),
    [anon_sym_i32] = ACTIONS(2620),
    [anon_sym_u64] = ACTIONS(2620),
    [anon_sym_i64] = ACTIONS(2620),
    [anon_sym_u128] = ACTIONS(2620),
    [anon_sym_i128] = ACTIONS(2620),
    [anon_sym_isize] = ACTIONS(2620),
    [anon_sym_usize] = ACTIONS(2620),
    [anon_sym_f32] = ACTIONS(2620),
    [anon_sym_f64] = ACTIONS(2620),
    [anon_sym_bool] = ACTIONS(2620),
    [anon_sym_str] = ACTIONS(2620),
    [anon_sym_char] = ACTIONS(2620),
    [anon_sym_DASH] = ACTIONS(2618),
    [anon_sym_BANG] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2618),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_POUND] = ACTIONS(2618),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [anon_sym_async] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_default] = ACTIONS(2620),
    [anon_sym_enum] = ACTIONS(2620),
    [anon_sym_fn] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_impl] = ACTIONS(2620),
    [anon_sym_let] = ACTIONS(2620),
    [anon_sym_loop] = ACTIONS(2620),
    [anon_sym_match] = ACTIONS(2620),
    [anon_sym_mod] = ACTIONS(2620),
    [anon_sym_pub] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_trait] = ACTIONS(2620),
    [anon_sym_type] = ACTIONS(2620),
    [anon_sym_union] = ACTIONS(2620),
    [anon_sym_unsafe] = ACTIONS(2620),
    [anon_sym_use] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_extern] = ACTIONS(2620),
    [anon_sym_yield] = ACTIONS(2620),
    [anon_sym_move] = ACTIONS(2620),
    [anon_sym_try] = ACTIONS(2620),
    [sym_integer_literal] = ACTIONS(2618),
    [aux_sym_string_literal_token1] = ACTIONS(2618),
    [sym_char_literal] = ACTIONS(2618),
    [anon_sym_true] = ACTIONS(2620),
    [anon_sym_false] = ACTIONS(2620),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2620),
    [sym_super] = ACTIONS(2620),
    [sym_crate] = ACTIONS(2620),
    [sym_metavariable] = ACTIONS(2618),
    [sym__raw_string_literal_start] = ACTIONS(2618),
    [sym_float_literal] = ACTIONS(2618),
  },
  [698] = {
    [sym_line_comment] = STATE(698),
    [sym_block_comment] = STATE(698),
    [ts_builtin_sym_end] = ACTIONS(2622),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_macro_rules_BANG] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_u8] = ACTIONS(2624),
    [anon_sym_i8] = ACTIONS(2624),
    [anon_sym_u16] = ACTIONS(2624),
    [anon_sym_i16] = ACTIONS(2624),
    [anon_sym_u32] = ACTIONS(2624),
    [anon_sym_i32] = ACTIONS(2624),
    [anon_sym_u64] = ACTIONS(2624),
    [anon_sym_i64] = ACTIONS(2624),
    [anon_sym_u128] = ACTIONS(2624),
    [anon_sym_i128] = ACTIONS(2624),
    [anon_sym_isize] = ACTIONS(2624),
    [anon_sym_usize] = ACTIONS(2624),
    [anon_sym_f32] = ACTIONS(2624),
    [anon_sym_f64] = ACTIONS(2624),
    [anon_sym_bool] = ACTIONS(2624),
    [anon_sym_str] = ACTIONS(2624),
    [anon_sym_char] = ACTIONS(2624),
    [anon_sym_DASH] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_POUND] = ACTIONS(2622),
    [anon_sym_SQUOTE] = ACTIONS(2624),
    [anon_sym_async] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_continue] = ACTIONS(2624),
    [anon_sym_default] = ACTIONS(2624),
    [anon_sym_enum] = ACTIONS(2624),
    [anon_sym_fn] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_impl] = ACTIONS(2624),
    [anon_sym_let] = ACTIONS(2624),
    [anon_sym_loop] = ACTIONS(2624),
    [anon_sym_match] = ACTIONS(2624),
    [anon_sym_mod] = ACTIONS(2624),
    [anon_sym_pub] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_static] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_trait] = ACTIONS(2624),
    [anon_sym_type] = ACTIONS(2624),
    [anon_sym_union] = ACTIONS(2624),
    [anon_sym_unsafe] = ACTIONS(2624),
    [anon_sym_use] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_extern] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_move] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [sym_integer_literal] = ACTIONS(2622),
    [aux_sym_string_literal_token1] = ACTIONS(2622),
    [sym_char_literal] = ACTIONS(2622),
    [anon_sym_true] = ACTIONS(2624),
    [anon_sym_false] = ACTIONS(2624),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_crate] = ACTIONS(2624),
    [sym_metavariable] = ACTIONS(2622),
    [sym__raw_string_literal_start] = ACTIONS(2622),
    [sym_float_literal] = ACTIONS(2622),
  },
  [699] = {
    [sym_line_comment] = STATE(699),
    [sym_block_comment] = STATE(699),
    [ts_builtin_sym_end] = ACTIONS(2626),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_macro_rules_BANG] = ACTIONS(2626),
    [anon_sym_LPAREN] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_u8] = ACTIONS(2628),
    [anon_sym_i8] = ACTIONS(2628),
    [anon_sym_u16] = ACTIONS(2628),
    [anon_sym_i16] = ACTIONS(2628),
    [anon_sym_u32] = ACTIONS(2628),
    [anon_sym_i32] = ACTIONS(2628),
    [anon_sym_u64] = ACTIONS(2628),
    [anon_sym_i64] = ACTIONS(2628),
    [anon_sym_u128] = ACTIONS(2628),
    [anon_sym_i128] = ACTIONS(2628),
    [anon_sym_isize] = ACTIONS(2628),
    [anon_sym_usize] = ACTIONS(2628),
    [anon_sym_f32] = ACTIONS(2628),
    [anon_sym_f64] = ACTIONS(2628),
    [anon_sym_bool] = ACTIONS(2628),
    [anon_sym_str] = ACTIONS(2628),
    [anon_sym_char] = ACTIONS(2628),
    [anon_sym_DASH] = ACTIONS(2626),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2626),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_POUND] = ACTIONS(2626),
    [anon_sym_SQUOTE] = ACTIONS(2628),
    [anon_sym_async] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_continue] = ACTIONS(2628),
    [anon_sym_default] = ACTIONS(2628),
    [anon_sym_enum] = ACTIONS(2628),
    [anon_sym_fn] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_impl] = ACTIONS(2628),
    [anon_sym_let] = ACTIONS(2628),
    [anon_sym_loop] = ACTIONS(2628),
    [anon_sym_match] = ACTIONS(2628),
    [anon_sym_mod] = ACTIONS(2628),
    [anon_sym_pub] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_static] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_trait] = ACTIONS(2628),
    [anon_sym_type] = ACTIONS(2628),
    [anon_sym_union] = ACTIONS(2628),
    [anon_sym_unsafe] = ACTIONS(2628),
    [anon_sym_use] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_extern] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_move] = ACTIONS(2628),
    [anon_sym_try] = ACTIONS(2628),
    [sym_integer_literal] = ACTIONS(2626),
    [aux_sym_string_literal_token1] = ACTIONS(2626),
    [sym_char_literal] = ACTIONS(2626),
    [anon_sym_true] = ACTIONS(2628),
    [anon_sym_false] = ACTIONS(2628),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_crate] = ACTIONS(2628),
    [sym_metavariable] = ACTIONS(2626),
    [sym__raw_string_literal_start] = ACTIONS(2626),
    [sym_float_literal] = ACTIONS(2626),
  },
  [700] = {
    [sym_line_comment] = STATE(700),
    [sym_block_comment] = STATE(700),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_macro_rules_BANG] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_u8] = ACTIONS(2632),
    [anon_sym_i8] = ACTIONS(2632),
    [anon_sym_u16] = ACTIONS(2632),
    [anon_sym_i16] = ACTIONS(2632),
    [anon_sym_u32] = ACTIONS(2632),
    [anon_sym_i32] = ACTIONS(2632),
    [anon_sym_u64] = ACTIONS(2632),
    [anon_sym_i64] = ACTIONS(2632),
    [anon_sym_u128] = ACTIONS(2632),
    [anon_sym_i128] = ACTIONS(2632),
    [anon_sym_isize] = ACTIONS(2632),
    [anon_sym_usize] = ACTIONS(2632),
    [anon_sym_f32] = ACTIONS(2632),
    [anon_sym_f64] = ACTIONS(2632),
    [anon_sym_bool] = ACTIONS(2632),
    [anon_sym_str] = ACTIONS(2632),
    [anon_sym_char] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2630),
    [anon_sym_LT] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2630),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_POUND] = ACTIONS(2630),
    [anon_sym_SQUOTE] = ACTIONS(2632),
    [anon_sym_async] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_continue] = ACTIONS(2632),
    [anon_sym_default] = ACTIONS(2632),
    [anon_sym_enum] = ACTIONS(2632),
    [anon_sym_fn] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_impl] = ACTIONS(2632),
    [anon_sym_let] = ACTIONS(2632),
    [anon_sym_loop] = ACTIONS(2632),
    [anon_sym_match] = ACTIONS(2632),
    [anon_sym_mod] = ACTIONS(2632),
    [anon_sym_pub] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_trait] = ACTIONS(2632),
    [anon_sym_type] = ACTIONS(2632),
    [anon_sym_union] = ACTIONS(2632),
    [anon_sym_unsafe] = ACTIONS(2632),
    [anon_sym_use] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_extern] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_move] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [sym_integer_literal] = ACTIONS(2630),
    [aux_sym_string_literal_token1] = ACTIONS(2630),
    [sym_char_literal] = ACTIONS(2630),
    [anon_sym_true] = ACTIONS(2632),
    [anon_sym_false] = ACTIONS(2632),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_crate] = ACTIONS(2632),
    [sym_metavariable] = ACTIONS(2630),
    [sym__raw_string_literal_start] = ACTIONS(2630),
    [sym_float_literal] = ACTIONS(2630),
  },
  [701] = {
    [sym_line_comment] = STATE(701),
    [sym_block_comment] = STATE(701),
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_macro_rules_BANG] = ACTIONS(2634),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_u8] = ACTIONS(2636),
    [anon_sym_i8] = ACTIONS(2636),
    [anon_sym_u16] = ACTIONS(2636),
    [anon_sym_i16] = ACTIONS(2636),
    [anon_sym_u32] = ACTIONS(2636),
    [anon_sym_i32] = ACTIONS(2636),
    [anon_sym_u64] = ACTIONS(2636),
    [anon_sym_i64] = ACTIONS(2636),
    [anon_sym_u128] = ACTIONS(2636),
    [anon_sym_i128] = ACTIONS(2636),
    [anon_sym_isize] = ACTIONS(2636),
    [anon_sym_usize] = ACTIONS(2636),
    [anon_sym_f32] = ACTIONS(2636),
    [anon_sym_f64] = ACTIONS(2636),
    [anon_sym_bool] = ACTIONS(2636),
    [anon_sym_str] = ACTIONS(2636),
    [anon_sym_char] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2634),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_POUND] = ACTIONS(2634),
    [anon_sym_SQUOTE] = ACTIONS(2636),
    [anon_sym_async] = ACTIONS(2636),
    [anon_sym_break] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_continue] = ACTIONS(2636),
    [anon_sym_default] = ACTIONS(2636),
    [anon_sym_enum] = ACTIONS(2636),
    [anon_sym_fn] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_impl] = ACTIONS(2636),
    [anon_sym_let] = ACTIONS(2636),
    [anon_sym_loop] = ACTIONS(2636),
    [anon_sym_match] = ACTIONS(2636),
    [anon_sym_mod] = ACTIONS(2636),
    [anon_sym_pub] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_trait] = ACTIONS(2636),
    [anon_sym_type] = ACTIONS(2636),
    [anon_sym_union] = ACTIONS(2636),
    [anon_sym_unsafe] = ACTIONS(2636),
    [anon_sym_use] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_extern] = ACTIONS(2636),
    [anon_sym_yield] = ACTIONS(2636),
    [anon_sym_move] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [sym_integer_literal] = ACTIONS(2634),
    [aux_sym_string_literal_token1] = ACTIONS(2634),
    [sym_char_literal] = ACTIONS(2634),
    [anon_sym_true] = ACTIONS(2636),
    [anon_sym_false] = ACTIONS(2636),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2636),
    [sym_super] = ACTIONS(2636),
    [sym_crate] = ACTIONS(2636),
    [sym_metavariable] = ACTIONS(2634),
    [sym__raw_string_literal_start] = ACTIONS(2634),
    [sym_float_literal] = ACTIONS(2634),
  },
  [702] = {
    [sym_line_comment] = STATE(702),
    [sym_block_comment] = STATE(702),
    [ts_builtin_sym_end] = ACTIONS(2638),
    [sym_identifier] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_macro_rules_BANG] = ACTIONS(2638),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2638),
    [anon_sym_LBRACE] = ACTIONS(2638),
    [anon_sym_RBRACE] = ACTIONS(2638),
    [anon_sym_STAR] = ACTIONS(2638),
    [anon_sym_u8] = ACTIONS(2640),
    [anon_sym_i8] = ACTIONS(2640),
    [anon_sym_u16] = ACTIONS(2640),
    [anon_sym_i16] = ACTIONS(2640),
    [anon_sym_u32] = ACTIONS(2640),
    [anon_sym_i32] = ACTIONS(2640),
    [anon_sym_u64] = ACTIONS(2640),
    [anon_sym_i64] = ACTIONS(2640),
    [anon_sym_u128] = ACTIONS(2640),
    [anon_sym_i128] = ACTIONS(2640),
    [anon_sym_isize] = ACTIONS(2640),
    [anon_sym_usize] = ACTIONS(2640),
    [anon_sym_f32] = ACTIONS(2640),
    [anon_sym_f64] = ACTIONS(2640),
    [anon_sym_bool] = ACTIONS(2640),
    [anon_sym_str] = ACTIONS(2640),
    [anon_sym_char] = ACTIONS(2640),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_BANG] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2638),
    [anon_sym_POUND] = ACTIONS(2638),
    [anon_sym_SQUOTE] = ACTIONS(2640),
    [anon_sym_async] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_const] = ACTIONS(2640),
    [anon_sym_continue] = ACTIONS(2640),
    [anon_sym_default] = ACTIONS(2640),
    [anon_sym_enum] = ACTIONS(2640),
    [anon_sym_fn] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_impl] = ACTIONS(2640),
    [anon_sym_let] = ACTIONS(2640),
    [anon_sym_loop] = ACTIONS(2640),
    [anon_sym_match] = ACTIONS(2640),
    [anon_sym_mod] = ACTIONS(2640),
    [anon_sym_pub] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_static] = ACTIONS(2640),
    [anon_sym_struct] = ACTIONS(2640),
    [anon_sym_trait] = ACTIONS(2640),
    [anon_sym_type] = ACTIONS(2640),
    [anon_sym_union] = ACTIONS(2640),
    [anon_sym_unsafe] = ACTIONS(2640),
    [anon_sym_use] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_extern] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_move] = ACTIONS(2640),
    [anon_sym_try] = ACTIONS(2640),
    [sym_integer_literal] = ACTIONS(2638),
    [aux_sym_string_literal_token1] = ACTIONS(2638),
    [sym_char_literal] = ACTIONS(2638),
    [anon_sym_true] = ACTIONS(2640),
    [anon_sym_false] = ACTIONS(2640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_crate] = ACTIONS(2640),
    [sym_metavariable] = ACTIONS(2638),
    [sym__raw_string_literal_start] = ACTIONS(2638),
    [sym_float_literal] = ACTIONS(2638),
  },
  [703] = {
    [sym_line_comment] = STATE(703),
    [sym_block_comment] = STATE(703),
    [ts_builtin_sym_end] = ACTIONS(2642),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_macro_rules_BANG] = ACTIONS(2642),
    [anon_sym_LPAREN] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2642),
    [anon_sym_u8] = ACTIONS(2644),
    [anon_sym_i8] = ACTIONS(2644),
    [anon_sym_u16] = ACTIONS(2644),
    [anon_sym_i16] = ACTIONS(2644),
    [anon_sym_u32] = ACTIONS(2644),
    [anon_sym_i32] = ACTIONS(2644),
    [anon_sym_u64] = ACTIONS(2644),
    [anon_sym_i64] = ACTIONS(2644),
    [anon_sym_u128] = ACTIONS(2644),
    [anon_sym_i128] = ACTIONS(2644),
    [anon_sym_isize] = ACTIONS(2644),
    [anon_sym_usize] = ACTIONS(2644),
    [anon_sym_f32] = ACTIONS(2644),
    [anon_sym_f64] = ACTIONS(2644),
    [anon_sym_bool] = ACTIONS(2644),
    [anon_sym_str] = ACTIONS(2644),
    [anon_sym_char] = ACTIONS(2644),
    [anon_sym_DASH] = ACTIONS(2642),
    [anon_sym_BANG] = ACTIONS(2642),
    [anon_sym_AMP] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2642),
    [anon_sym_LT] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2642),
    [anon_sym_COLON_COLON] = ACTIONS(2642),
    [anon_sym_POUND] = ACTIONS(2642),
    [anon_sym_SQUOTE] = ACTIONS(2644),
    [anon_sym_async] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_const] = ACTIONS(2644),
    [anon_sym_continue] = ACTIONS(2644),
    [anon_sym_default] = ACTIONS(2644),
    [anon_sym_enum] = ACTIONS(2644),
    [anon_sym_fn] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_impl] = ACTIONS(2644),
    [anon_sym_let] = ACTIONS(2644),
    [anon_sym_loop] = ACTIONS(2644),
    [anon_sym_match] = ACTIONS(2644),
    [anon_sym_mod] = ACTIONS(2644),
    [anon_sym_pub] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_static] = ACTIONS(2644),
    [anon_sym_struct] = ACTIONS(2644),
    [anon_sym_trait] = ACTIONS(2644),
    [anon_sym_type] = ACTIONS(2644),
    [anon_sym_union] = ACTIONS(2644),
    [anon_sym_unsafe] = ACTIONS(2644),
    [anon_sym_use] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_extern] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_move] = ACTIONS(2644),
    [anon_sym_try] = ACTIONS(2644),
    [sym_integer_literal] = ACTIONS(2642),
    [aux_sym_string_literal_token1] = ACTIONS(2642),
    [sym_char_literal] = ACTIONS(2642),
    [anon_sym_true] = ACTIONS(2644),
    [anon_sym_false] = ACTIONS(2644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_crate] = ACTIONS(2644),
    [sym_metavariable] = ACTIONS(2642),
    [sym__raw_string_literal_start] = ACTIONS(2642),
    [sym_float_literal] = ACTIONS(2642),
  },
  [704] = {
    [sym_line_comment] = STATE(704),
    [sym_block_comment] = STATE(704),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_macro_rules_BANG] = ACTIONS(2646),
    [anon_sym_LPAREN] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_u8] = ACTIONS(2648),
    [anon_sym_i8] = ACTIONS(2648),
    [anon_sym_u16] = ACTIONS(2648),
    [anon_sym_i16] = ACTIONS(2648),
    [anon_sym_u32] = ACTIONS(2648),
    [anon_sym_i32] = ACTIONS(2648),
    [anon_sym_u64] = ACTIONS(2648),
    [anon_sym_i64] = ACTIONS(2648),
    [anon_sym_u128] = ACTIONS(2648),
    [anon_sym_i128] = ACTIONS(2648),
    [anon_sym_isize] = ACTIONS(2648),
    [anon_sym_usize] = ACTIONS(2648),
    [anon_sym_f32] = ACTIONS(2648),
    [anon_sym_f64] = ACTIONS(2648),
    [anon_sym_bool] = ACTIONS(2648),
    [anon_sym_str] = ACTIONS(2648),
    [anon_sym_char] = ACTIONS(2648),
    [anon_sym_DASH] = ACTIONS(2646),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2646),
    [anon_sym_LT] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2646),
    [anon_sym_COLON_COLON] = ACTIONS(2646),
    [anon_sym_POUND] = ACTIONS(2646),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [anon_sym_async] = ACTIONS(2648),
    [anon_sym_break] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_continue] = ACTIONS(2648),
    [anon_sym_default] = ACTIONS(2648),
    [anon_sym_enum] = ACTIONS(2648),
    [anon_sym_fn] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_impl] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_loop] = ACTIONS(2648),
    [anon_sym_match] = ACTIONS(2648),
    [anon_sym_mod] = ACTIONS(2648),
    [anon_sym_pub] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_static] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_trait] = ACTIONS(2648),
    [anon_sym_type] = ACTIONS(2648),
    [anon_sym_union] = ACTIONS(2648),
    [anon_sym_unsafe] = ACTIONS(2648),
    [anon_sym_use] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [anon_sym_extern] = ACTIONS(2648),
    [anon_sym_yield] = ACTIONS(2648),
    [anon_sym_move] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [sym_integer_literal] = ACTIONS(2646),
    [aux_sym_string_literal_token1] = ACTIONS(2646),
    [sym_char_literal] = ACTIONS(2646),
    [anon_sym_true] = ACTIONS(2648),
    [anon_sym_false] = ACTIONS(2648),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2648),
    [sym_super] = ACTIONS(2648),
    [sym_crate] = ACTIONS(2648),
    [sym_metavariable] = ACTIONS(2646),
    [sym__raw_string_literal_start] = ACTIONS(2646),
    [sym_float_literal] = ACTIONS(2646),
  },
  [705] = {
    [sym_line_comment] = STATE(705),
    [sym_block_comment] = STATE(705),
    [ts_builtin_sym_end] = ACTIONS(2650),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2650),
    [anon_sym_macro_rules_BANG] = ACTIONS(2650),
    [anon_sym_LPAREN] = ACTIONS(2650),
    [anon_sym_LBRACK] = ACTIONS(2650),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_STAR] = ACTIONS(2650),
    [anon_sym_u8] = ACTIONS(2652),
    [anon_sym_i8] = ACTIONS(2652),
    [anon_sym_u16] = ACTIONS(2652),
    [anon_sym_i16] = ACTIONS(2652),
    [anon_sym_u32] = ACTIONS(2652),
    [anon_sym_i32] = ACTIONS(2652),
    [anon_sym_u64] = ACTIONS(2652),
    [anon_sym_i64] = ACTIONS(2652),
    [anon_sym_u128] = ACTIONS(2652),
    [anon_sym_i128] = ACTIONS(2652),
    [anon_sym_isize] = ACTIONS(2652),
    [anon_sym_usize] = ACTIONS(2652),
    [anon_sym_f32] = ACTIONS(2652),
    [anon_sym_f64] = ACTIONS(2652),
    [anon_sym_bool] = ACTIONS(2652),
    [anon_sym_str] = ACTIONS(2652),
    [anon_sym_char] = ACTIONS(2652),
    [anon_sym_DASH] = ACTIONS(2650),
    [anon_sym_BANG] = ACTIONS(2650),
    [anon_sym_AMP] = ACTIONS(2650),
    [anon_sym_PIPE] = ACTIONS(2650),
    [anon_sym_LT] = ACTIONS(2650),
    [anon_sym_DOT_DOT] = ACTIONS(2650),
    [anon_sym_COLON_COLON] = ACTIONS(2650),
    [anon_sym_POUND] = ACTIONS(2650),
    [anon_sym_SQUOTE] = ACTIONS(2652),
    [anon_sym_async] = ACTIONS(2652),
    [anon_sym_break] = ACTIONS(2652),
    [anon_sym_const] = ACTIONS(2652),
    [anon_sym_continue] = ACTIONS(2652),
    [anon_sym_default] = ACTIONS(2652),
    [anon_sym_enum] = ACTIONS(2652),
    [anon_sym_fn] = ACTIONS(2652),
    [anon_sym_for] = ACTIONS(2652),
    [anon_sym_if] = ACTIONS(2652),
    [anon_sym_impl] = ACTIONS(2652),
    [anon_sym_let] = ACTIONS(2652),
    [anon_sym_loop] = ACTIONS(2652),
    [anon_sym_match] = ACTIONS(2652),
    [anon_sym_mod] = ACTIONS(2652),
    [anon_sym_pub] = ACTIONS(2652),
    [anon_sym_return] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2652),
    [anon_sym_struct] = ACTIONS(2652),
    [anon_sym_trait] = ACTIONS(2652),
    [anon_sym_type] = ACTIONS(2652),
    [anon_sym_union] = ACTIONS(2652),
    [anon_sym_unsafe] = ACTIONS(2652),
    [anon_sym_use] = ACTIONS(2652),
    [anon_sym_while] = ACTIONS(2652),
    [anon_sym_extern] = ACTIONS(2652),
    [anon_sym_yield] = ACTIONS(2652),
    [anon_sym_move] = ACTIONS(2652),
    [anon_sym_try] = ACTIONS(2652),
    [sym_integer_literal] = ACTIONS(2650),
    [aux_sym_string_literal_token1] = ACTIONS(2650),
    [sym_char_literal] = ACTIONS(2650),
    [anon_sym_true] = ACTIONS(2652),
    [anon_sym_false] = ACTIONS(2652),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2652),
    [sym_super] = ACTIONS(2652),
    [sym_crate] = ACTIONS(2652),
    [sym_metavariable] = ACTIONS(2650),
    [sym__raw_string_literal_start] = ACTIONS(2650),
    [sym_float_literal] = ACTIONS(2650),
  },
  [706] = {
    [sym_line_comment] = STATE(706),
    [sym_block_comment] = STATE(706),
    [ts_builtin_sym_end] = ACTIONS(2654),
    [sym_identifier] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym_macro_rules_BANG] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2654),
    [anon_sym_LBRACK] = ACTIONS(2654),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_RBRACE] = ACTIONS(2654),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_u8] = ACTIONS(2656),
    [anon_sym_i8] = ACTIONS(2656),
    [anon_sym_u16] = ACTIONS(2656),
    [anon_sym_i16] = ACTIONS(2656),
    [anon_sym_u32] = ACTIONS(2656),
    [anon_sym_i32] = ACTIONS(2656),
    [anon_sym_u64] = ACTIONS(2656),
    [anon_sym_i64] = ACTIONS(2656),
    [anon_sym_u128] = ACTIONS(2656),
    [anon_sym_i128] = ACTIONS(2656),
    [anon_sym_isize] = ACTIONS(2656),
    [anon_sym_usize] = ACTIONS(2656),
    [anon_sym_f32] = ACTIONS(2656),
    [anon_sym_f64] = ACTIONS(2656),
    [anon_sym_bool] = ACTIONS(2656),
    [anon_sym_str] = ACTIONS(2656),
    [anon_sym_char] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2654),
    [anon_sym_PIPE] = ACTIONS(2654),
    [anon_sym_LT] = ACTIONS(2654),
    [anon_sym_DOT_DOT] = ACTIONS(2654),
    [anon_sym_COLON_COLON] = ACTIONS(2654),
    [anon_sym_POUND] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2656),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_break] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_continue] = ACTIONS(2656),
    [anon_sym_default] = ACTIONS(2656),
    [anon_sym_enum] = ACTIONS(2656),
    [anon_sym_fn] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2656),
    [anon_sym_impl] = ACTIONS(2656),
    [anon_sym_let] = ACTIONS(2656),
    [anon_sym_loop] = ACTIONS(2656),
    [anon_sym_match] = ACTIONS(2656),
    [anon_sym_mod] = ACTIONS(2656),
    [anon_sym_pub] = ACTIONS(2656),
    [anon_sym_return] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_struct] = ACTIONS(2656),
    [anon_sym_trait] = ACTIONS(2656),
    [anon_sym_type] = ACTIONS(2656),
    [anon_sym_union] = ACTIONS(2656),
    [anon_sym_unsafe] = ACTIONS(2656),
    [anon_sym_use] = ACTIONS(2656),
    [anon_sym_while] = ACTIONS(2656),
    [anon_sym_extern] = ACTIONS(2656),
    [anon_sym_yield] = ACTIONS(2656),
    [anon_sym_move] = ACTIONS(2656),
    [anon_sym_try] = ACTIONS(2656),
    [sym_integer_literal] = ACTIONS(2654),
    [aux_sym_string_literal_token1] = ACTIONS(2654),
    [sym_char_literal] = ACTIONS(2654),
    [anon_sym_true] = ACTIONS(2656),
    [anon_sym_false] = ACTIONS(2656),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2656),
    [sym_super] = ACTIONS(2656),
    [sym_crate] = ACTIONS(2656),
    [sym_metavariable] = ACTIONS(2654),
    [sym__raw_string_literal_start] = ACTIONS(2654),
    [sym_float_literal] = ACTIONS(2654),
  },
  [707] = {
    [sym_empty_statement] = STATE(1456),
    [sym_macro_definition] = STATE(1456),
    [sym_attribute_item] = STATE(1456),
    [sym_inner_attribute_item] = STATE(1456),
    [sym_mod_item] = STATE(1456),
    [sym_foreign_mod_item] = STATE(1456),
    [sym_struct_item] = STATE(1456),
    [sym_union_item] = STATE(1456),
    [sym_enum_item] = STATE(1456),
    [sym_extern_crate_declaration] = STATE(1456),
    [sym_const_item] = STATE(1456),
    [sym_static_item] = STATE(1456),
    [sym_type_item] = STATE(1456),
    [sym_function_item] = STATE(1456),
    [sym_function_signature_item] = STATE(1456),
    [sym_function_modifiers] = STATE(3599),
    [sym_impl_item] = STATE(1456),
    [sym_trait_item] = STATE(1456),
    [sym_associated_type] = STATE(1456),
    [sym_let_declaration] = STATE(1456),
    [sym_use_declaration] = STATE(1456),
    [sym_extern_modifier] = STATE(2139),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3323),
    [sym_generic_type_with_turbofish] = STATE(3349),
    [sym_macro_invocation] = STATE(1456),
    [sym_scoped_identifier] = STATE(3208),
    [sym_line_comment] = STATE(707),
    [sym_block_comment] = STATE(707),
    [aux_sym_declaration_list_repeat1] = STATE(707),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2658),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_macro_rules_BANG] = ACTIONS(2664),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_u8] = ACTIONS(2669),
    [anon_sym_i8] = ACTIONS(2669),
    [anon_sym_u16] = ACTIONS(2669),
    [anon_sym_i16] = ACTIONS(2669),
    [anon_sym_u32] = ACTIONS(2669),
    [anon_sym_i32] = ACTIONS(2669),
    [anon_sym_u64] = ACTIONS(2669),
    [anon_sym_i64] = ACTIONS(2669),
    [anon_sym_u128] = ACTIONS(2669),
    [anon_sym_i128] = ACTIONS(2669),
    [anon_sym_isize] = ACTIONS(2669),
    [anon_sym_usize] = ACTIONS(2669),
    [anon_sym_f32] = ACTIONS(2669),
    [anon_sym_f64] = ACTIONS(2669),
    [anon_sym_bool] = ACTIONS(2669),
    [anon_sym_str] = ACTIONS(2669),
    [anon_sym_char] = ACTIONS(2669),
    [anon_sym_LT] = ACTIONS(2672),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_POUND] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2684),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2690),
    [anon_sym_fn] = ACTIONS(2693),
    [anon_sym_impl] = ACTIONS(2696),
    [anon_sym_let] = ACTIONS(2699),
    [anon_sym_mod] = ACTIONS(2702),
    [anon_sym_pub] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2708),
    [anon_sym_struct] = ACTIONS(2711),
    [anon_sym_trait] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2720),
    [anon_sym_unsafe] = ACTIONS(2723),
    [anon_sym_use] = ACTIONS(2726),
    [anon_sym_extern] = ACTIONS(2729),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2732),
    [sym_super] = ACTIONS(2732),
    [sym_crate] = ACTIONS(2735),
    [sym_metavariable] = ACTIONS(2738),
  },
  [708] = {
    [sym_line_comment] = STATE(708),
    [sym_block_comment] = STATE(708),
    [ts_builtin_sym_end] = ACTIONS(2741),
    [sym_identifier] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym_macro_rules_BANG] = ACTIONS(2741),
    [anon_sym_LPAREN] = ACTIONS(2741),
    [anon_sym_LBRACK] = ACTIONS(2741),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_RBRACE] = ACTIONS(2741),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_u8] = ACTIONS(2743),
    [anon_sym_i8] = ACTIONS(2743),
    [anon_sym_u16] = ACTIONS(2743),
    [anon_sym_i16] = ACTIONS(2743),
    [anon_sym_u32] = ACTIONS(2743),
    [anon_sym_i32] = ACTIONS(2743),
    [anon_sym_u64] = ACTIONS(2743),
    [anon_sym_i64] = ACTIONS(2743),
    [anon_sym_u128] = ACTIONS(2743),
    [anon_sym_i128] = ACTIONS(2743),
    [anon_sym_isize] = ACTIONS(2743),
    [anon_sym_usize] = ACTIONS(2743),
    [anon_sym_f32] = ACTIONS(2743),
    [anon_sym_f64] = ACTIONS(2743),
    [anon_sym_bool] = ACTIONS(2743),
    [anon_sym_str] = ACTIONS(2743),
    [anon_sym_char] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_POUND] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2743),
    [anon_sym_async] = ACTIONS(2743),
    [anon_sym_break] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_continue] = ACTIONS(2743),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2743),
    [anon_sym_fn] = ACTIONS(2743),
    [anon_sym_for] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_impl] = ACTIONS(2743),
    [anon_sym_let] = ACTIONS(2743),
    [anon_sym_loop] = ACTIONS(2743),
    [anon_sym_match] = ACTIONS(2743),
    [anon_sym_mod] = ACTIONS(2743),
    [anon_sym_pub] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_trait] = ACTIONS(2743),
    [anon_sym_type] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_unsafe] = ACTIONS(2743),
    [anon_sym_use] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_extern] = ACTIONS(2743),
    [anon_sym_yield] = ACTIONS(2743),
    [anon_sym_move] = ACTIONS(2743),
    [anon_sym_try] = ACTIONS(2743),
    [sym_integer_literal] = ACTIONS(2741),
    [aux_sym_string_literal_token1] = ACTIONS(2741),
    [sym_char_literal] = ACTIONS(2741),
    [anon_sym_true] = ACTIONS(2743),
    [anon_sym_false] = ACTIONS(2743),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2743),
    [sym_super] = ACTIONS(2743),
    [sym_crate] = ACTIONS(2743),
    [sym_metavariable] = ACTIONS(2741),
    [sym__raw_string_literal_start] = ACTIONS(2741),
    [sym_float_literal] = ACTIONS(2741),
  },
  [709] = {
    [sym_empty_statement] = STATE(1456),
    [sym_macro_definition] = STATE(1456),
    [sym_attribute_item] = STATE(1456),
    [sym_inner_attribute_item] = STATE(1456),
    [sym_mod_item] = STATE(1456),
    [sym_foreign_mod_item] = STATE(1456),
    [sym_struct_item] = STATE(1456),
    [sym_union_item] = STATE(1456),
    [sym_enum_item] = STATE(1456),
    [sym_extern_crate_declaration] = STATE(1456),
    [sym_const_item] = STATE(1456),
    [sym_static_item] = STATE(1456),
    [sym_type_item] = STATE(1456),
    [sym_function_item] = STATE(1456),
    [sym_function_signature_item] = STATE(1456),
    [sym_function_modifiers] = STATE(3599),
    [sym_impl_item] = STATE(1456),
    [sym_trait_item] = STATE(1456),
    [sym_associated_type] = STATE(1456),
    [sym_let_declaration] = STATE(1456),
    [sym_use_declaration] = STATE(1456),
    [sym_extern_modifier] = STATE(2139),
    [sym_visibility_modifier] = STATE(1932),
    [sym_bracketed_type] = STATE(3323),
    [sym_generic_type_with_turbofish] = STATE(3349),
    [sym_macro_invocation] = STATE(1456),
    [sym_scoped_identifier] = STATE(3208),
    [sym_line_comment] = STATE(709),
    [sym_block_comment] = STATE(709),
    [aux_sym_declaration_list_repeat1] = STATE(531),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(1870),
    [anon_sym_SEMI] = ACTIONS(1872),
    [anon_sym_macro_rules_BANG] = ACTIONS(1874),
    [anon_sym_RBRACE] = ACTIONS(2745),
    [anon_sym_u8] = ACTIONS(1878),
    [anon_sym_i8] = ACTIONS(1878),
    [anon_sym_u16] = ACTIONS(1878),
    [anon_sym_i16] = ACTIONS(1878),
    [anon_sym_u32] = ACTIONS(1878),
    [anon_sym_i32] = ACTIONS(1878),
    [anon_sym_u64] = ACTIONS(1878),
    [anon_sym_i64] = ACTIONS(1878),
    [anon_sym_u128] = ACTIONS(1878),
    [anon_sym_i128] = ACTIONS(1878),
    [anon_sym_isize] = ACTIONS(1878),
    [anon_sym_usize] = ACTIONS(1878),
    [anon_sym_f32] = ACTIONS(1878),
    [anon_sym_f64] = ACTIONS(1878),
    [anon_sym_bool] = ACTIONS(1878),
    [anon_sym_str] = ACTIONS(1878),
    [anon_sym_char] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_POUND] = ACTIONS(1882),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1884),
    [anon_sym_default] = ACTIONS(1886),
    [anon_sym_enum] = ACTIONS(1888),
    [anon_sym_fn] = ACTIONS(1890),
    [anon_sym_impl] = ACTIONS(1892),
    [anon_sym_let] = ACTIONS(1894),
    [anon_sym_mod] = ACTIONS(1896),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(1898),
    [anon_sym_struct] = ACTIONS(1900),
    [anon_sym_trait] = ACTIONS(1902),
    [anon_sym_type] = ACTIONS(1904),
    [anon_sym_union] = ACTIONS(1906),
    [anon_sym_unsafe] = ACTIONS(1908),
    [anon_sym_use] = ACTIONS(1910),
    [anon_sym_extern] = ACTIONS(1912),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1914),
    [sym_super] = ACTIONS(1914),
    [sym_crate] = ACTIONS(1916),
    [sym_metavariable] = ACTIONS(1918),
  },
  [710] = {
    [sym_line_comment] = STATE(710),
    [sym_block_comment] = STATE(710),
    [ts_builtin_sym_end] = ACTIONS(2747),
    [sym_identifier] = ACTIONS(2749),
    [anon_sym_SEMI] = ACTIONS(2747),
    [anon_sym_macro_rules_BANG] = ACTIONS(2747),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2747),
    [anon_sym_RBRACE] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2747),
    [anon_sym_u8] = ACTIONS(2749),
    [anon_sym_i8] = ACTIONS(2749),
    [anon_sym_u16] = ACTIONS(2749),
    [anon_sym_i16] = ACTIONS(2749),
    [anon_sym_u32] = ACTIONS(2749),
    [anon_sym_i32] = ACTIONS(2749),
    [anon_sym_u64] = ACTIONS(2749),
    [anon_sym_i64] = ACTIONS(2749),
    [anon_sym_u128] = ACTIONS(2749),
    [anon_sym_i128] = ACTIONS(2749),
    [anon_sym_isize] = ACTIONS(2749),
    [anon_sym_usize] = ACTIONS(2749),
    [anon_sym_f32] = ACTIONS(2749),
    [anon_sym_f64] = ACTIONS(2749),
    [anon_sym_bool] = ACTIONS(2749),
    [anon_sym_str] = ACTIONS(2749),
    [anon_sym_char] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_LT] = ACTIONS(2747),
    [anon_sym_DOT_DOT] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2747),
    [anon_sym_POUND] = ACTIONS(2747),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_async] = ACTIONS(2749),
    [anon_sym_break] = ACTIONS(2749),
    [anon_sym_const] = ACTIONS(2749),
    [anon_sym_continue] = ACTIONS(2749),
    [anon_sym_default] = ACTIONS(2749),
    [anon_sym_enum] = ACTIONS(2749),
    [anon_sym_fn] = ACTIONS(2749),
    [anon_sym_for] = ACTIONS(2749),
    [anon_sym_if] = ACTIONS(2749),
    [anon_sym_impl] = ACTIONS(2749),
    [anon_sym_let] = ACTIONS(2749),
    [anon_sym_loop] = ACTIONS(2749),
    [anon_sym_match] = ACTIONS(2749),
    [anon_sym_mod] = ACTIONS(2749),
    [anon_sym_pub] = ACTIONS(2749),
    [anon_sym_return] = ACTIONS(2749),
    [anon_sym_static] = ACTIONS(2749),
    [anon_sym_struct] = ACTIONS(2749),
    [anon_sym_trait] = ACTIONS(2749),
    [anon_sym_type] = ACTIONS(2749),
    [anon_sym_union] = ACTIONS(2749),
    [anon_sym_unsafe] = ACTIONS(2749),
    [anon_sym_use] = ACTIONS(2749),
    [anon_sym_while] = ACTIONS(2749),
    [anon_sym_extern] = ACTIONS(2749),
    [anon_sym_yield] = ACTIONS(2749),
    [anon_sym_move] = ACTIONS(2749),
    [anon_sym_try] = ACTIONS(2749),
    [sym_integer_literal] = ACTIONS(2747),
    [aux_sym_string_literal_token1] = ACTIONS(2747),
    [sym_char_literal] = ACTIONS(2747),
    [anon_sym_true] = ACTIONS(2749),
    [anon_sym_false] = ACTIONS(2749),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2749),
    [sym_super] = ACTIONS(2749),
    [sym_crate] = ACTIONS(2749),
    [sym_metavariable] = ACTIONS(2747),
    [sym__raw_string_literal_start] = ACTIONS(2747),
    [sym_float_literal] = ACTIONS(2747),
  },
  [711] = {
    [sym_line_comment] = STATE(711),
    [sym_block_comment] = STATE(711),
    [ts_builtin_sym_end] = ACTIONS(2751),
    [sym_identifier] = ACTIONS(2753),
    [anon_sym_SEMI] = ACTIONS(2751),
    [anon_sym_macro_rules_BANG] = ACTIONS(2751),
    [anon_sym_LPAREN] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2751),
    [anon_sym_RBRACE] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2751),
    [anon_sym_u8] = ACTIONS(2753),
    [anon_sym_i8] = ACTIONS(2753),
    [anon_sym_u16] = ACTIONS(2753),
    [anon_sym_i16] = ACTIONS(2753),
    [anon_sym_u32] = ACTIONS(2753),
    [anon_sym_i32] = ACTIONS(2753),
    [anon_sym_u64] = ACTIONS(2753),
    [anon_sym_i64] = ACTIONS(2753),
    [anon_sym_u128] = ACTIONS(2753),
    [anon_sym_i128] = ACTIONS(2753),
    [anon_sym_isize] = ACTIONS(2753),
    [anon_sym_usize] = ACTIONS(2753),
    [anon_sym_f32] = ACTIONS(2753),
    [anon_sym_f64] = ACTIONS(2753),
    [anon_sym_bool] = ACTIONS(2753),
    [anon_sym_str] = ACTIONS(2753),
    [anon_sym_char] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_BANG] = ACTIONS(2751),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_PIPE] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_DOT_DOT] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2751),
    [anon_sym_POUND] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_async] = ACTIONS(2753),
    [anon_sym_break] = ACTIONS(2753),
    [anon_sym_const] = ACTIONS(2753),
    [anon_sym_continue] = ACTIONS(2753),
    [anon_sym_default] = ACTIONS(2753),
    [anon_sym_enum] = ACTIONS(2753),
    [anon_sym_fn] = ACTIONS(2753),
    [anon_sym_for] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_impl] = ACTIONS(2753),
    [anon_sym_let] = ACTIONS(2753),
    [anon_sym_loop] = ACTIONS(2753),
    [anon_sym_match] = ACTIONS(2753),
    [anon_sym_mod] = ACTIONS(2753),
    [anon_sym_pub] = ACTIONS(2753),
    [anon_sym_return] = ACTIONS(2753),
    [anon_sym_static] = ACTIONS(2753),
    [anon_sym_struct] = ACTIONS(2753),
    [anon_sym_trait] = ACTIONS(2753),
    [anon_sym_type] = ACTIONS(2753),
    [anon_sym_union] = ACTIONS(2753),
    [anon_sym_unsafe] = ACTIONS(2753),
    [anon_sym_use] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_extern] = ACTIONS(2753),
    [anon_sym_yield] = ACTIONS(2753),
    [anon_sym_move] = ACTIONS(2753),
    [anon_sym_try] = ACTIONS(2753),
    [sym_integer_literal] = ACTIONS(2751),
    [aux_sym_string_literal_token1] = ACTIONS(2751),
    [sym_char_literal] = ACTIONS(2751),
    [anon_sym_true] = ACTIONS(2753),
    [anon_sym_false] = ACTIONS(2753),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2753),
    [sym_super] = ACTIONS(2753),
    [sym_crate] = ACTIONS(2753),
    [sym_metavariable] = ACTIONS(2751),
    [sym__raw_string_literal_start] = ACTIONS(2751),
    [sym_float_literal] = ACTIONS(2751),
  },
  [712] = {
    [sym_line_comment] = STATE(712),
    [sym_block_comment] = STATE(712),
    [ts_builtin_sym_end] = ACTIONS(2755),
    [sym_identifier] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2755),
    [anon_sym_macro_rules_BANG] = ACTIONS(2755),
    [anon_sym_LPAREN] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2755),
    [anon_sym_RBRACE] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2755),
    [anon_sym_u8] = ACTIONS(2757),
    [anon_sym_i8] = ACTIONS(2757),
    [anon_sym_u16] = ACTIONS(2757),
    [anon_sym_i16] = ACTIONS(2757),
    [anon_sym_u32] = ACTIONS(2757),
    [anon_sym_i32] = ACTIONS(2757),
    [anon_sym_u64] = ACTIONS(2757),
    [anon_sym_i64] = ACTIONS(2757),
    [anon_sym_u128] = ACTIONS(2757),
    [anon_sym_i128] = ACTIONS(2757),
    [anon_sym_isize] = ACTIONS(2757),
    [anon_sym_usize] = ACTIONS(2757),
    [anon_sym_f32] = ACTIONS(2757),
    [anon_sym_f64] = ACTIONS(2757),
    [anon_sym_bool] = ACTIONS(2757),
    [anon_sym_str] = ACTIONS(2757),
    [anon_sym_char] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2755),
    [anon_sym_POUND] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_async] = ACTIONS(2757),
    [anon_sym_break] = ACTIONS(2757),
    [anon_sym_const] = ACTIONS(2757),
    [anon_sym_continue] = ACTIONS(2757),
    [anon_sym_default] = ACTIONS(2757),
    [anon_sym_enum] = ACTIONS(2757),
    [anon_sym_fn] = ACTIONS(2757),
    [anon_sym_for] = ACTIONS(2757),
    [anon_sym_if] = ACTIONS(2757),
    [anon_sym_impl] = ACTIONS(2757),
    [anon_sym_let] = ACTIONS(2757),
    [anon_sym_loop] = ACTIONS(2757),
    [anon_sym_match] = ACTIONS(2757),
    [anon_sym_mod] = ACTIONS(2757),
    [anon_sym_pub] = ACTIONS(2757),
    [anon_sym_return] = ACTIONS(2757),
    [anon_sym_static] = ACTIONS(2757),
    [anon_sym_struct] = ACTIONS(2757),
    [anon_sym_trait] = ACTIONS(2757),
    [anon_sym_type] = ACTIONS(2757),
    [anon_sym_union] = ACTIONS(2757),
    [anon_sym_unsafe] = ACTIONS(2757),
    [anon_sym_use] = ACTIONS(2757),
    [anon_sym_while] = ACTIONS(2757),
    [anon_sym_extern] = ACTIONS(2757),
    [anon_sym_yield] = ACTIONS(2757),
    [anon_sym_move] = ACTIONS(2757),
    [anon_sym_try] = ACTIONS(2757),
    [sym_integer_literal] = ACTIONS(2755),
    [aux_sym_string_literal_token1] = ACTIONS(2755),
    [sym_char_literal] = ACTIONS(2755),
    [anon_sym_true] = ACTIONS(2757),
    [anon_sym_false] = ACTIONS(2757),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2757),
    [sym_super] = ACTIONS(2757),
    [sym_crate] = ACTIONS(2757),
    [sym_metavariable] = ACTIONS(2755),
    [sym__raw_string_literal_start] = ACTIONS(2755),
    [sym_float_literal] = ACTIONS(2755),
  },
  [713] = {
    [sym_line_comment] = STATE(713),
    [sym_block_comment] = STATE(713),
    [ts_builtin_sym_end] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_macro_rules_BANG] = ACTIONS(2759),
    [anon_sym_LPAREN] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2759),
    [anon_sym_u8] = ACTIONS(2761),
    [anon_sym_i8] = ACTIONS(2761),
    [anon_sym_u16] = ACTIONS(2761),
    [anon_sym_i16] = ACTIONS(2761),
    [anon_sym_u32] = ACTIONS(2761),
    [anon_sym_i32] = ACTIONS(2761),
    [anon_sym_u64] = ACTIONS(2761),
    [anon_sym_i64] = ACTIONS(2761),
    [anon_sym_u128] = ACTIONS(2761),
    [anon_sym_i128] = ACTIONS(2761),
    [anon_sym_isize] = ACTIONS(2761),
    [anon_sym_usize] = ACTIONS(2761),
    [anon_sym_f32] = ACTIONS(2761),
    [anon_sym_f64] = ACTIONS(2761),
    [anon_sym_bool] = ACTIONS(2761),
    [anon_sym_str] = ACTIONS(2761),
    [anon_sym_char] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_BANG] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2759),
    [anon_sym_LT] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2759),
    [anon_sym_POUND] = ACTIONS(2759),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [anon_sym_async] = ACTIONS(2761),
    [anon_sym_break] = ACTIONS(2761),
    [anon_sym_const] = ACTIONS(2761),
    [anon_sym_continue] = ACTIONS(2761),
    [anon_sym_default] = ACTIONS(2761),
    [anon_sym_enum] = ACTIONS(2761),
    [anon_sym_fn] = ACTIONS(2761),
    [anon_sym_for] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2761),
    [anon_sym_impl] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(2761),
    [anon_sym_loop] = ACTIONS(2761),
    [anon_sym_match] = ACTIONS(2761),
    [anon_sym_mod] = ACTIONS(2761),
    [anon_sym_pub] = ACTIONS(2761),
    [anon_sym_return] = ACTIONS(2761),
    [anon_sym_static] = ACTIONS(2761),
    [anon_sym_struct] = ACTIONS(2761),
    [anon_sym_trait] = ACTIONS(2761),
    [anon_sym_type] = ACTIONS(2761),
    [anon_sym_union] = ACTIONS(2761),
    [anon_sym_unsafe] = ACTIONS(2761),
    [anon_sym_use] = ACTIONS(2761),
    [anon_sym_while] = ACTIONS(2761),
    [anon_sym_extern] = ACTIONS(2761),
    [anon_sym_yield] = ACTIONS(2761),
    [anon_sym_move] = ACTIONS(2761),
    [anon_sym_try] = ACTIONS(2761),
    [sym_integer_literal] = ACTIONS(2759),
    [aux_sym_string_literal_token1] = ACTIONS(2759),
    [sym_char_literal] = ACTIONS(2759),
    [anon_sym_true] = ACTIONS(2761),
    [anon_sym_false] = ACTIONS(2761),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2761),
    [sym_super] = ACTIONS(2761),
    [sym_crate] = ACTIONS(2761),
    [sym_metavariable] = ACTIONS(2759),
    [sym__raw_string_literal_start] = ACTIONS(2759),
    [sym_float_literal] = ACTIONS(2759),
  },
  [714] = {
    [sym_line_comment] = STATE(714),
    [sym_block_comment] = STATE(714),
    [ts_builtin_sym_end] = ACTIONS(2763),
    [sym_identifier] = ACTIONS(2765),
    [anon_sym_SEMI] = ACTIONS(2763),
    [anon_sym_macro_rules_BANG] = ACTIONS(2763),
    [anon_sym_LPAREN] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2763),
    [anon_sym_RBRACE] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2763),
    [anon_sym_u8] = ACTIONS(2765),
    [anon_sym_i8] = ACTIONS(2765),
    [anon_sym_u16] = ACTIONS(2765),
    [anon_sym_i16] = ACTIONS(2765),
    [anon_sym_u32] = ACTIONS(2765),
    [anon_sym_i32] = ACTIONS(2765),
    [anon_sym_u64] = ACTIONS(2765),
    [anon_sym_i64] = ACTIONS(2765),
    [anon_sym_u128] = ACTIONS(2765),
    [anon_sym_i128] = ACTIONS(2765),
    [anon_sym_isize] = ACTIONS(2765),
    [anon_sym_usize] = ACTIONS(2765),
    [anon_sym_f32] = ACTIONS(2765),
    [anon_sym_f64] = ACTIONS(2765),
    [anon_sym_bool] = ACTIONS(2765),
    [anon_sym_str] = ACTIONS(2765),
    [anon_sym_char] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_BANG] = ACTIONS(2763),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_PIPE] = ACTIONS(2763),
    [anon_sym_LT] = ACTIONS(2763),
    [anon_sym_DOT_DOT] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2763),
    [anon_sym_POUND] = ACTIONS(2763),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [anon_sym_async] = ACTIONS(2765),
    [anon_sym_break] = ACTIONS(2765),
    [anon_sym_const] = ACTIONS(2765),
    [anon_sym_continue] = ACTIONS(2765),
    [anon_sym_default] = ACTIONS(2765),
    [anon_sym_enum] = ACTIONS(2765),
    [anon_sym_fn] = ACTIONS(2765),
    [anon_sym_for] = ACTIONS(2765),
    [anon_sym_if] = ACTIONS(2765),
    [anon_sym_impl] = ACTIONS(2765),
    [anon_sym_let] = ACTIONS(2765),
    [anon_sym_loop] = ACTIONS(2765),
    [anon_sym_match] = ACTIONS(2765),
    [anon_sym_mod] = ACTIONS(2765),
    [anon_sym_pub] = ACTIONS(2765),
    [anon_sym_return] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(2765),
    [anon_sym_struct] = ACTIONS(2765),
    [anon_sym_trait] = ACTIONS(2765),
    [anon_sym_type] = ACTIONS(2765),
    [anon_sym_union] = ACTIONS(2765),
    [anon_sym_unsafe] = ACTIONS(2765),
    [anon_sym_use] = ACTIONS(2765),
    [anon_sym_while] = ACTIONS(2765),
    [anon_sym_extern] = ACTIONS(2765),
    [anon_sym_yield] = ACTIONS(2765),
    [anon_sym_move] = ACTIONS(2765),
    [anon_sym_try] = ACTIONS(2765),
    [sym_integer_literal] = ACTIONS(2763),
    [aux_sym_string_literal_token1] = ACTIONS(2763),
    [sym_char_literal] = ACTIONS(2763),
    [anon_sym_true] = ACTIONS(2765),
    [anon_sym_false] = ACTIONS(2765),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2765),
    [sym_super] = ACTIONS(2765),
    [sym_crate] = ACTIONS(2765),
    [sym_metavariable] = ACTIONS(2763),
    [sym__raw_string_literal_start] = ACTIONS(2763),
    [sym_float_literal] = ACTIONS(2763),
  },
  [715] = {
    [sym_line_comment] = STATE(715),
    [sym_block_comment] = STATE(715),
    [ts_builtin_sym_end] = ACTIONS(2767),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym_macro_rules_BANG] = ACTIONS(2767),
    [anon_sym_LPAREN] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_RBRACE] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_u8] = ACTIONS(2769),
    [anon_sym_i8] = ACTIONS(2769),
    [anon_sym_u16] = ACTIONS(2769),
    [anon_sym_i16] = ACTIONS(2769),
    [anon_sym_u32] = ACTIONS(2769),
    [anon_sym_i32] = ACTIONS(2769),
    [anon_sym_u64] = ACTIONS(2769),
    [anon_sym_i64] = ACTIONS(2769),
    [anon_sym_u128] = ACTIONS(2769),
    [anon_sym_i128] = ACTIONS(2769),
    [anon_sym_isize] = ACTIONS(2769),
    [anon_sym_usize] = ACTIONS(2769),
    [anon_sym_f32] = ACTIONS(2769),
    [anon_sym_f64] = ACTIONS(2769),
    [anon_sym_bool] = ACTIONS(2769),
    [anon_sym_str] = ACTIONS(2769),
    [anon_sym_char] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_PIPE] = ACTIONS(2767),
    [anon_sym_LT] = ACTIONS(2767),
    [anon_sym_DOT_DOT] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [anon_sym_POUND] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_async] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_fn] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_impl] = ACTIONS(2769),
    [anon_sym_let] = ACTIONS(2769),
    [anon_sym_loop] = ACTIONS(2769),
    [anon_sym_match] = ACTIONS(2769),
    [anon_sym_mod] = ACTIONS(2769),
    [anon_sym_pub] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_trait] = ACTIONS(2769),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_unsafe] = ACTIONS(2769),
    [anon_sym_use] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym_yield] = ACTIONS(2769),
    [anon_sym_move] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [sym_integer_literal] = ACTIONS(2767),
    [aux_sym_string_literal_token1] = ACTIONS(2767),
    [sym_char_literal] = ACTIONS(2767),
    [anon_sym_true] = ACTIONS(2769),
    [anon_sym_false] = ACTIONS(2769),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2769),
    [sym_super] = ACTIONS(2769),
    [sym_crate] = ACTIONS(2769),
    [sym_metavariable] = ACTIONS(2767),
    [sym__raw_string_literal_start] = ACTIONS(2767),
    [sym_float_literal] = ACTIONS(2767),
  },
  [716] = {
    [sym_line_comment] = STATE(716),
    [sym_block_comment] = STATE(716),
    [ts_builtin_sym_end] = ACTIONS(2771),
    [sym_identifier] = ACTIONS(2773),
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym_macro_rules_BANG] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_RBRACE] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2771),
    [anon_sym_u8] = ACTIONS(2773),
    [anon_sym_i8] = ACTIONS(2773),
    [anon_sym_u16] = ACTIONS(2773),
    [anon_sym_i16] = ACTIONS(2773),
    [anon_sym_u32] = ACTIONS(2773),
    [anon_sym_i32] = ACTIONS(2773),
    [anon_sym_u64] = ACTIONS(2773),
    [anon_sym_i64] = ACTIONS(2773),
    [anon_sym_u128] = ACTIONS(2773),
    [anon_sym_i128] = ACTIONS(2773),
    [anon_sym_isize] = ACTIONS(2773),
    [anon_sym_usize] = ACTIONS(2773),
    [anon_sym_f32] = ACTIONS(2773),
    [anon_sym_f64] = ACTIONS(2773),
    [anon_sym_bool] = ACTIONS(2773),
    [anon_sym_str] = ACTIONS(2773),
    [anon_sym_char] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_PIPE] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2771),
    [anon_sym_DOT_DOT] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2771),
    [anon_sym_POUND] = ACTIONS(2771),
    [anon_sym_SQUOTE] = ACTIONS(2773),
    [anon_sym_async] = ACTIONS(2773),
    [anon_sym_break] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_continue] = ACTIONS(2773),
    [anon_sym_default] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_fn] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_impl] = ACTIONS(2773),
    [anon_sym_let] = ACTIONS(2773),
    [anon_sym_loop] = ACTIONS(2773),
    [anon_sym_match] = ACTIONS(2773),
    [anon_sym_mod] = ACTIONS(2773),
    [anon_sym_pub] = ACTIONS(2773),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_trait] = ACTIONS(2773),
    [anon_sym_type] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [anon_sym_unsafe] = ACTIONS(2773),
    [anon_sym_use] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2773),
    [anon_sym_move] = ACTIONS(2773),
    [anon_sym_try] = ACTIONS(2773),
    [sym_integer_literal] = ACTIONS(2771),
    [aux_sym_string_literal_token1] = ACTIONS(2771),
    [sym_char_literal] = ACTIONS(2771),
    [anon_sym_true] = ACTIONS(2773),
    [anon_sym_false] = ACTIONS(2773),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2773),
    [sym_super] = ACTIONS(2773),
    [sym_crate] = ACTIONS(2773),
    [sym_metavariable] = ACTIONS(2771),
    [sym__raw_string_literal_start] = ACTIONS(2771),
    [sym_float_literal] = ACTIONS(2771),
  },
  [717] = {
    [sym_line_comment] = STATE(717),
    [sym_block_comment] = STATE(717),
    [ts_builtin_sym_end] = ACTIONS(2775),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym_macro_rules_BANG] = ACTIONS(2775),
    [anon_sym_LPAREN] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_u8] = ACTIONS(2777),
    [anon_sym_i8] = ACTIONS(2777),
    [anon_sym_u16] = ACTIONS(2777),
    [anon_sym_i16] = ACTIONS(2777),
    [anon_sym_u32] = ACTIONS(2777),
    [anon_sym_i32] = ACTIONS(2777),
    [anon_sym_u64] = ACTIONS(2777),
    [anon_sym_i64] = ACTIONS(2777),
    [anon_sym_u128] = ACTIONS(2777),
    [anon_sym_i128] = ACTIONS(2777),
    [anon_sym_isize] = ACTIONS(2777),
    [anon_sym_usize] = ACTIONS(2777),
    [anon_sym_f32] = ACTIONS(2777),
    [anon_sym_f64] = ACTIONS(2777),
    [anon_sym_bool] = ACTIONS(2777),
    [anon_sym_str] = ACTIONS(2777),
    [anon_sym_char] = ACTIONS(2777),
    [anon_sym_DASH] = ACTIONS(2775),
    [anon_sym_BANG] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_PIPE] = ACTIONS(2775),
    [anon_sym_LT] = ACTIONS(2775),
    [anon_sym_DOT_DOT] = ACTIONS(2775),
    [anon_sym_COLON_COLON] = ACTIONS(2775),
    [anon_sym_POUND] = ACTIONS(2775),
    [anon_sym_SQUOTE] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(2777),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_const] = ACTIONS(2777),
    [anon_sym_continue] = ACTIONS(2777),
    [anon_sym_default] = ACTIONS(2777),
    [anon_sym_enum] = ACTIONS(2777),
    [anon_sym_fn] = ACTIONS(2777),
    [anon_sym_for] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2777),
    [anon_sym_impl] = ACTIONS(2777),
    [anon_sym_let] = ACTIONS(2777),
    [anon_sym_loop] = ACTIONS(2777),
    [anon_sym_match] = ACTIONS(2777),
    [anon_sym_mod] = ACTIONS(2777),
    [anon_sym_pub] = ACTIONS(2777),
    [anon_sym_return] = ACTIONS(2777),
    [anon_sym_static] = ACTIONS(2777),
    [anon_sym_struct] = ACTIONS(2777),
    [anon_sym_trait] = ACTIONS(2777),
    [anon_sym_type] = ACTIONS(2777),
    [anon_sym_union] = ACTIONS(2777),
    [anon_sym_unsafe] = ACTIONS(2777),
    [anon_sym_use] = ACTIONS(2777),
    [anon_sym_while] = ACTIONS(2777),
    [anon_sym_extern] = ACTIONS(2777),
    [anon_sym_yield] = ACTIONS(2777),
    [anon_sym_move] = ACTIONS(2777),
    [anon_sym_try] = ACTIONS(2777),
    [sym_integer_literal] = ACTIONS(2775),
    [aux_sym_string_literal_token1] = ACTIONS(2775),
    [sym_char_literal] = ACTIONS(2775),
    [anon_sym_true] = ACTIONS(2777),
    [anon_sym_false] = ACTIONS(2777),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2777),
    [sym_super] = ACTIONS(2777),
    [sym_crate] = ACTIONS(2777),
    [sym_metavariable] = ACTIONS(2775),
    [sym__raw_string_literal_start] = ACTIONS(2775),
    [sym_float_literal] = ACTIONS(2775),
  },
  [718] = {
    [sym_line_comment] = STATE(718),
    [sym_block_comment] = STATE(718),
    [ts_builtin_sym_end] = ACTIONS(2779),
    [sym_identifier] = ACTIONS(2781),
    [anon_sym_SEMI] = ACTIONS(2779),
    [anon_sym_macro_rules_BANG] = ACTIONS(2779),
    [anon_sym_LPAREN] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2779),
    [anon_sym_RBRACE] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2779),
    [anon_sym_u8] = ACTIONS(2781),
    [anon_sym_i8] = ACTIONS(2781),
    [anon_sym_u16] = ACTIONS(2781),
    [anon_sym_i16] = ACTIONS(2781),
    [anon_sym_u32] = ACTIONS(2781),
    [anon_sym_i32] = ACTIONS(2781),
    [anon_sym_u64] = ACTIONS(2781),
    [anon_sym_i64] = ACTIONS(2781),
    [anon_sym_u128] = ACTIONS(2781),
    [anon_sym_i128] = ACTIONS(2781),
    [anon_sym_isize] = ACTIONS(2781),
    [anon_sym_usize] = ACTIONS(2781),
    [anon_sym_f32] = ACTIONS(2781),
    [anon_sym_f64] = ACTIONS(2781),
    [anon_sym_bool] = ACTIONS(2781),
    [anon_sym_str] = ACTIONS(2781),
    [anon_sym_char] = ACTIONS(2781),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG] = ACTIONS(2779),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_PIPE] = ACTIONS(2779),
    [anon_sym_LT] = ACTIONS(2779),
    [anon_sym_DOT_DOT] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2779),
    [anon_sym_POUND] = ACTIONS(2779),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_async] = ACTIONS(2781),
    [anon_sym_break] = ACTIONS(2781),
    [anon_sym_const] = ACTIONS(2781),
    [anon_sym_continue] = ACTIONS(2781),
    [anon_sym_default] = ACTIONS(2781),
    [anon_sym_enum] = ACTIONS(2781),
    [anon_sym_fn] = ACTIONS(2781),
    [anon_sym_for] = ACTIONS(2781),
    [anon_sym_if] = ACTIONS(2781),
    [anon_sym_impl] = ACTIONS(2781),
    [anon_sym_let] = ACTIONS(2781),
    [anon_sym_loop] = ACTIONS(2781),
    [anon_sym_match] = ACTIONS(2781),
    [anon_sym_mod] = ACTIONS(2781),
    [anon_sym_pub] = ACTIONS(2781),
    [anon_sym_return] = ACTIONS(2781),
    [anon_sym_static] = ACTIONS(2781),
    [anon_sym_struct] = ACTIONS(2781),
    [anon_sym_trait] = ACTIONS(2781),
    [anon_sym_type] = ACTIONS(2781),
    [anon_sym_union] = ACTIONS(2781),
    [anon_sym_unsafe] = ACTIONS(2781),
    [anon_sym_use] = ACTIONS(2781),
    [anon_sym_while] = ACTIONS(2781),
    [anon_sym_extern] = ACTIONS(2781),
    [anon_sym_yield] = ACTIONS(2781),
    [anon_sym_move] = ACTIONS(2781),
    [anon_sym_try] = ACTIONS(2781),
    [sym_integer_literal] = ACTIONS(2779),
    [aux_sym_string_literal_token1] = ACTIONS(2779),
    [sym_char_literal] = ACTIONS(2779),
    [anon_sym_true] = ACTIONS(2781),
    [anon_sym_false] = ACTIONS(2781),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2781),
    [sym_super] = ACTIONS(2781),
    [sym_crate] = ACTIONS(2781),
    [sym_metavariable] = ACTIONS(2779),
    [sym__raw_string_literal_start] = ACTIONS(2779),
    [sym_float_literal] = ACTIONS(2779),
  },
  [719] = {
    [sym_line_comment] = STATE(719),
    [sym_block_comment] = STATE(719),
    [ts_builtin_sym_end] = ACTIONS(2783),
    [sym_identifier] = ACTIONS(2785),
    [anon_sym_SEMI] = ACTIONS(2783),
    [anon_sym_macro_rules_BANG] = ACTIONS(2783),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_RBRACE] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2783),
    [anon_sym_u8] = ACTIONS(2785),
    [anon_sym_i8] = ACTIONS(2785),
    [anon_sym_u16] = ACTIONS(2785),
    [anon_sym_i16] = ACTIONS(2785),
    [anon_sym_u32] = ACTIONS(2785),
    [anon_sym_i32] = ACTIONS(2785),
    [anon_sym_u64] = ACTIONS(2785),
    [anon_sym_i64] = ACTIONS(2785),
    [anon_sym_u128] = ACTIONS(2785),
    [anon_sym_i128] = ACTIONS(2785),
    [anon_sym_isize] = ACTIONS(2785),
    [anon_sym_usize] = ACTIONS(2785),
    [anon_sym_f32] = ACTIONS(2785),
    [anon_sym_f64] = ACTIONS(2785),
    [anon_sym_bool] = ACTIONS(2785),
    [anon_sym_str] = ACTIONS(2785),
    [anon_sym_char] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2783),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_PIPE] = ACTIONS(2783),
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_DOT_DOT] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2783),
    [anon_sym_POUND] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_async] = ACTIONS(2785),
    [anon_sym_break] = ACTIONS(2785),
    [anon_sym_const] = ACTIONS(2785),
    [anon_sym_continue] = ACTIONS(2785),
    [anon_sym_default] = ACTIONS(2785),
    [anon_sym_enum] = ACTIONS(2785),
    [anon_sym_fn] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2785),
    [anon_sym_if] = ACTIONS(2785),
    [anon_sym_impl] = ACTIONS(2785),
    [anon_sym_let] = ACTIONS(2785),
    [anon_sym_loop] = ACTIONS(2785),
    [anon_sym_match] = ACTIONS(2785),
    [anon_sym_mod] = ACTIONS(2785),
    [anon_sym_pub] = ACTIONS(2785),
    [anon_sym_return] = ACTIONS(2785),
    [anon_sym_static] = ACTIONS(2785),
    [anon_sym_struct] = ACTIONS(2785),
    [anon_sym_trait] = ACTIONS(2785),
    [anon_sym_type] = ACTIONS(2785),
    [anon_sym_union] = ACTIONS(2785),
    [anon_sym_unsafe] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2785),
    [anon_sym_while] = ACTIONS(2785),
    [anon_sym_extern] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2785),
    [anon_sym_move] = ACTIONS(2785),
    [anon_sym_try] = ACTIONS(2785),
    [sym_integer_literal] = ACTIONS(2783),
    [aux_sym_string_literal_token1] = ACTIONS(2783),
    [sym_char_literal] = ACTIONS(2783),
    [anon_sym_true] = ACTIONS(2785),
    [anon_sym_false] = ACTIONS(2785),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2785),
    [sym_super] = ACTIONS(2785),
    [sym_crate] = ACTIONS(2785),
    [sym_metavariable] = ACTIONS(2783),
    [sym__raw_string_literal_start] = ACTIONS(2783),
    [sym_float_literal] = ACTIONS(2783),
  },
  [720] = {
    [sym_line_comment] = STATE(720),
    [sym_block_comment] = STATE(720),
    [ts_builtin_sym_end] = ACTIONS(2787),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_SEMI] = ACTIONS(2787),
    [anon_sym_macro_rules_BANG] = ACTIONS(2787),
    [anon_sym_LPAREN] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_LBRACE] = ACTIONS(2787),
    [anon_sym_RBRACE] = ACTIONS(2787),
    [anon_sym_STAR] = ACTIONS(2787),
    [anon_sym_u8] = ACTIONS(2789),
    [anon_sym_i8] = ACTIONS(2789),
    [anon_sym_u16] = ACTIONS(2789),
    [anon_sym_i16] = ACTIONS(2789),
    [anon_sym_u32] = ACTIONS(2789),
    [anon_sym_i32] = ACTIONS(2789),
    [anon_sym_u64] = ACTIONS(2789),
    [anon_sym_i64] = ACTIONS(2789),
    [anon_sym_u128] = ACTIONS(2789),
    [anon_sym_i128] = ACTIONS(2789),
    [anon_sym_isize] = ACTIONS(2789),
    [anon_sym_usize] = ACTIONS(2789),
    [anon_sym_f32] = ACTIONS(2789),
    [anon_sym_f64] = ACTIONS(2789),
    [anon_sym_bool] = ACTIONS(2789),
    [anon_sym_str] = ACTIONS(2789),
    [anon_sym_char] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2787),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PIPE] = ACTIONS(2787),
    [anon_sym_LT] = ACTIONS(2787),
    [anon_sym_DOT_DOT] = ACTIONS(2787),
    [anon_sym_COLON_COLON] = ACTIONS(2787),
    [anon_sym_POUND] = ACTIONS(2787),
    [anon_sym_SQUOTE] = ACTIONS(2789),
    [anon_sym_async] = ACTIONS(2789),
    [anon_sym_break] = ACTIONS(2789),
    [anon_sym_const] = ACTIONS(2789),
    [anon_sym_continue] = ACTIONS(2789),
    [anon_sym_default] = ACTIONS(2789),
    [anon_sym_enum] = ACTIONS(2789),
    [anon_sym_fn] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2789),
    [anon_sym_if] = ACTIONS(2789),
    [anon_sym_impl] = ACTIONS(2789),
    [anon_sym_let] = ACTIONS(2789),
    [anon_sym_loop] = ACTIONS(2789),
    [anon_sym_match] = ACTIONS(2789),
    [anon_sym_mod] = ACTIONS(2789),
    [anon_sym_pub] = ACTIONS(2789),
    [anon_sym_return] = ACTIONS(2789),
    [anon_sym_static] = ACTIONS(2789),
    [anon_sym_struct] = ACTIONS(2789),
    [anon_sym_trait] = ACTIONS(2789),
    [anon_sym_type] = ACTIONS(2789),
    [anon_sym_union] = ACTIONS(2789),
    [anon_sym_unsafe] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(2789),
    [anon_sym_extern] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2789),
    [anon_sym_move] = ACTIONS(2789),
    [anon_sym_try] = ACTIONS(2789),
    [sym_integer_literal] = ACTIONS(2787),
    [aux_sym_string_literal_token1] = ACTIONS(2787),
    [sym_char_literal] = ACTIONS(2787),
    [anon_sym_true] = ACTIONS(2789),
    [anon_sym_false] = ACTIONS(2789),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2789),
    [sym_super] = ACTIONS(2789),
    [sym_crate] = ACTIONS(2789),
    [sym_metavariable] = ACTIONS(2787),
    [sym__raw_string_literal_start] = ACTIONS(2787),
    [sym_float_literal] = ACTIONS(2787),
  },
  [721] = {
    [sym_line_comment] = STATE(721),
    [sym_block_comment] = STATE(721),
    [ts_builtin_sym_end] = ACTIONS(2791),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_SEMI] = ACTIONS(2791),
    [anon_sym_macro_rules_BANG] = ACTIONS(2791),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_RBRACE] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2791),
    [anon_sym_u8] = ACTIONS(2793),
    [anon_sym_i8] = ACTIONS(2793),
    [anon_sym_u16] = ACTIONS(2793),
    [anon_sym_i16] = ACTIONS(2793),
    [anon_sym_u32] = ACTIONS(2793),
    [anon_sym_i32] = ACTIONS(2793),
    [anon_sym_u64] = ACTIONS(2793),
    [anon_sym_i64] = ACTIONS(2793),
    [anon_sym_u128] = ACTIONS(2793),
    [anon_sym_i128] = ACTIONS(2793),
    [anon_sym_isize] = ACTIONS(2793),
    [anon_sym_usize] = ACTIONS(2793),
    [anon_sym_f32] = ACTIONS(2793),
    [anon_sym_f64] = ACTIONS(2793),
    [anon_sym_bool] = ACTIONS(2793),
    [anon_sym_str] = ACTIONS(2793),
    [anon_sym_char] = ACTIONS(2793),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_BANG] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_DOT_DOT] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2791),
    [anon_sym_POUND] = ACTIONS(2791),
    [anon_sym_SQUOTE] = ACTIONS(2793),
    [anon_sym_async] = ACTIONS(2793),
    [anon_sym_break] = ACTIONS(2793),
    [anon_sym_const] = ACTIONS(2793),
    [anon_sym_continue] = ACTIONS(2793),
    [anon_sym_default] = ACTIONS(2793),
    [anon_sym_enum] = ACTIONS(2793),
    [anon_sym_fn] = ACTIONS(2793),
    [anon_sym_for] = ACTIONS(2793),
    [anon_sym_if] = ACTIONS(2793),
    [anon_sym_impl] = ACTIONS(2793),
    [anon_sym_let] = ACTIONS(2793),
    [anon_sym_loop] = ACTIONS(2793),
    [anon_sym_match] = ACTIONS(2793),
    [anon_sym_mod] = ACTIONS(2793),
    [anon_sym_pub] = ACTIONS(2793),
    [anon_sym_return] = ACTIONS(2793),
    [anon_sym_static] = ACTIONS(2793),
    [anon_sym_struct] = ACTIONS(2793),
    [anon_sym_trait] = ACTIONS(2793),
    [anon_sym_type] = ACTIONS(2793),
    [anon_sym_union] = ACTIONS(2793),
    [anon_sym_unsafe] = ACTIONS(2793),
    [anon_sym_use] = ACTIONS(2793),
    [anon_sym_while] = ACTIONS(2793),
    [anon_sym_extern] = ACTIONS(2793),
    [anon_sym_yield] = ACTIONS(2793),
    [anon_sym_move] = ACTIONS(2793),
    [anon_sym_try] = ACTIONS(2793),
    [sym_integer_literal] = ACTIONS(2791),
    [aux_sym_string_literal_token1] = ACTIONS(2791),
    [sym_char_literal] = ACTIONS(2791),
    [anon_sym_true] = ACTIONS(2793),
    [anon_sym_false] = ACTIONS(2793),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2793),
    [sym_super] = ACTIONS(2793),
    [sym_crate] = ACTIONS(2793),
    [sym_metavariable] = ACTIONS(2791),
    [sym__raw_string_literal_start] = ACTIONS(2791),
    [sym_float_literal] = ACTIONS(2791),
  },
  [722] = {
    [sym_line_comment] = STATE(722),
    [sym_block_comment] = STATE(722),
    [ts_builtin_sym_end] = ACTIONS(2795),
    [sym_identifier] = ACTIONS(2797),
    [anon_sym_SEMI] = ACTIONS(2795),
    [anon_sym_macro_rules_BANG] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2795),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(2795),
    [anon_sym_RBRACE] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2795),
    [anon_sym_u8] = ACTIONS(2797),
    [anon_sym_i8] = ACTIONS(2797),
    [anon_sym_u16] = ACTIONS(2797),
    [anon_sym_i16] = ACTIONS(2797),
    [anon_sym_u32] = ACTIONS(2797),
    [anon_sym_i32] = ACTIONS(2797),
    [anon_sym_u64] = ACTIONS(2797),
    [anon_sym_i64] = ACTIONS(2797),
    [anon_sym_u128] = ACTIONS(2797),
    [anon_sym_i128] = ACTIONS(2797),
    [anon_sym_isize] = ACTIONS(2797),
    [anon_sym_usize] = ACTIONS(2797),
    [anon_sym_f32] = ACTIONS(2797),
    [anon_sym_f64] = ACTIONS(2797),
    [anon_sym_bool] = ACTIONS(2797),
    [anon_sym_str] = ACTIONS(2797),
    [anon_sym_char] = ACTIONS(2797),
    [anon_sym_DASH] = ACTIONS(2795),
    [anon_sym_BANG] = ACTIONS(2795),
    [anon_sym_AMP] = ACTIONS(2795),
    [anon_sym_PIPE] = ACTIONS(2795),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_DOT_DOT] = ACTIONS(2795),
    [anon_sym_COLON_COLON] = ACTIONS(2795),
    [anon_sym_POUND] = ACTIONS(2795),
    [anon_sym_SQUOTE] = ACTIONS(2797),
    [anon_sym_async] = ACTIONS(2797),
    [anon_sym_break] = ACTIONS(2797),
    [anon_sym_const] = ACTIONS(2797),
    [anon_sym_continue] = ACTIONS(2797),
    [anon_sym_default] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(2797),
    [anon_sym_fn] = ACTIONS(2797),
    [anon_sym_for] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(2797),
    [anon_sym_impl] = ACTIONS(2797),
    [anon_sym_let] = ACTIONS(2797),
    [anon_sym_loop] = ACTIONS(2797),
    [anon_sym_match] = ACTIONS(2797),
    [anon_sym_mod] = ACTIONS(2797),
    [anon_sym_pub] = ACTIONS(2797),
    [anon_sym_return] = ACTIONS(2797),
    [anon_sym_static] = ACTIONS(2797),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_trait] = ACTIONS(2797),
    [anon_sym_type] = ACTIONS(2797),
    [anon_sym_union] = ACTIONS(2797),
    [anon_sym_unsafe] = ACTIONS(2797),
    [anon_sym_use] = ACTIONS(2797),
    [anon_sym_while] = ACTIONS(2797),
    [anon_sym_extern] = ACTIONS(2797),
    [anon_sym_yield] = ACTIONS(2797),
    [anon_sym_move] = ACTIONS(2797),
    [anon_sym_try] = ACTIONS(2797),
    [sym_integer_literal] = ACTIONS(2795),
    [aux_sym_string_literal_token1] = ACTIONS(2795),
    [sym_char_literal] = ACTIONS(2795),
    [anon_sym_true] = ACTIONS(2797),
    [anon_sym_false] = ACTIONS(2797),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2797),
    [sym_super] = ACTIONS(2797),
    [sym_crate] = ACTIONS(2797),
    [sym_metavariable] = ACTIONS(2795),
    [sym__raw_string_literal_start] = ACTIONS(2795),
    [sym_float_literal] = ACTIONS(2795),
  },
  [723] = {
    [sym_line_comment] = STATE(723),
    [sym_block_comment] = STATE(723),
    [ts_builtin_sym_end] = ACTIONS(2799),
    [sym_identifier] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym_macro_rules_BANG] = ACTIONS(2799),
    [anon_sym_LPAREN] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_u8] = ACTIONS(2801),
    [anon_sym_i8] = ACTIONS(2801),
    [anon_sym_u16] = ACTIONS(2801),
    [anon_sym_i16] = ACTIONS(2801),
    [anon_sym_u32] = ACTIONS(2801),
    [anon_sym_i32] = ACTIONS(2801),
    [anon_sym_u64] = ACTIONS(2801),
    [anon_sym_i64] = ACTIONS(2801),
    [anon_sym_u128] = ACTIONS(2801),
    [anon_sym_i128] = ACTIONS(2801),
    [anon_sym_isize] = ACTIONS(2801),
    [anon_sym_usize] = ACTIONS(2801),
    [anon_sym_f32] = ACTIONS(2801),
    [anon_sym_f64] = ACTIONS(2801),
    [anon_sym_bool] = ACTIONS(2801),
    [anon_sym_str] = ACTIONS(2801),
    [anon_sym_char] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_BANG] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_PIPE] = ACTIONS(2799),
    [anon_sym_LT] = ACTIONS(2799),
    [anon_sym_DOT_DOT] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2799),
    [anon_sym_POUND] = ACTIONS(2799),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_async] = ACTIONS(2801),
    [anon_sym_break] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_continue] = ACTIONS(2801),
    [anon_sym_default] = ACTIONS(2801),
    [anon_sym_enum] = ACTIONS(2801),
    [anon_sym_fn] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_impl] = ACTIONS(2801),
    [anon_sym_let] = ACTIONS(2801),
    [anon_sym_loop] = ACTIONS(2801),
    [anon_sym_match] = ACTIONS(2801),
    [anon_sym_mod] = ACTIONS(2801),
    [anon_sym_pub] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_static] = ACTIONS(2801),
    [anon_sym_struct] = ACTIONS(2801),
    [anon_sym_trait] = ACTIONS(2801),
    [anon_sym_type] = ACTIONS(2801),
    [anon_sym_union] = ACTIONS(2801),
    [anon_sym_unsafe] = ACTIONS(2801),
    [anon_sym_use] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [anon_sym_extern] = ACTIONS(2801),
    [anon_sym_yield] = ACTIONS(2801),
    [anon_sym_move] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [sym_integer_literal] = ACTIONS(2799),
    [aux_sym_string_literal_token1] = ACTIONS(2799),
    [sym_char_literal] = ACTIONS(2799),
    [anon_sym_true] = ACTIONS(2801),
    [anon_sym_false] = ACTIONS(2801),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2801),
    [sym_super] = ACTIONS(2801),
    [sym_crate] = ACTIONS(2801),
    [sym_metavariable] = ACTIONS(2799),
    [sym__raw_string_literal_start] = ACTIONS(2799),
    [sym_float_literal] = ACTIONS(2799),
  },
  [724] = {
    [sym_line_comment] = STATE(724),
    [sym_block_comment] = STATE(724),
    [ts_builtin_sym_end] = ACTIONS(2803),
    [sym_identifier] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym_macro_rules_BANG] = ACTIONS(2803),
    [anon_sym_LPAREN] = ACTIONS(2803),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_STAR] = ACTIONS(2803),
    [anon_sym_u8] = ACTIONS(2805),
    [anon_sym_i8] = ACTIONS(2805),
    [anon_sym_u16] = ACTIONS(2805),
    [anon_sym_i16] = ACTIONS(2805),
    [anon_sym_u32] = ACTIONS(2805),
    [anon_sym_i32] = ACTIONS(2805),
    [anon_sym_u64] = ACTIONS(2805),
    [anon_sym_i64] = ACTIONS(2805),
    [anon_sym_u128] = ACTIONS(2805),
    [anon_sym_i128] = ACTIONS(2805),
    [anon_sym_isize] = ACTIONS(2805),
    [anon_sym_usize] = ACTIONS(2805),
    [anon_sym_f32] = ACTIONS(2805),
    [anon_sym_f64] = ACTIONS(2805),
    [anon_sym_bool] = ACTIONS(2805),
    [anon_sym_str] = ACTIONS(2805),
    [anon_sym_char] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2803),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_AMP] = ACTIONS(2803),
    [anon_sym_PIPE] = ACTIONS(2803),
    [anon_sym_LT] = ACTIONS(2803),
    [anon_sym_DOT_DOT] = ACTIONS(2803),
    [anon_sym_COLON_COLON] = ACTIONS(2803),
    [anon_sym_POUND] = ACTIONS(2803),
    [anon_sym_SQUOTE] = ACTIONS(2805),
    [anon_sym_async] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_fn] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_impl] = ACTIONS(2805),
    [anon_sym_let] = ACTIONS(2805),
    [anon_sym_loop] = ACTIONS(2805),
    [anon_sym_match] = ACTIONS(2805),
    [anon_sym_mod] = ACTIONS(2805),
    [anon_sym_pub] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_trait] = ACTIONS(2805),
    [anon_sym_type] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [anon_sym_unsafe] = ACTIONS(2805),
    [anon_sym_use] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym_yield] = ACTIONS(2805),
    [anon_sym_move] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [sym_integer_literal] = ACTIONS(2803),
    [aux_sym_string_literal_token1] = ACTIONS(2803),
    [sym_char_literal] = ACTIONS(2803),
    [anon_sym_true] = ACTIONS(2805),
    [anon_sym_false] = ACTIONS(2805),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2805),
    [sym_super] = ACTIONS(2805),
    [sym_crate] = ACTIONS(2805),
    [sym_metavariable] = ACTIONS(2803),
    [sym__raw_string_literal_start] = ACTIONS(2803),
    [sym_float_literal] = ACTIONS(2803),
  },
  [725] = {
    [sym_line_comment] = STATE(725),
    [sym_block_comment] = STATE(725),
    [ts_builtin_sym_end] = ACTIONS(2807),
    [sym_identifier] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_macro_rules_BANG] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_u8] = ACTIONS(2809),
    [anon_sym_i8] = ACTIONS(2809),
    [anon_sym_u16] = ACTIONS(2809),
    [anon_sym_i16] = ACTIONS(2809),
    [anon_sym_u32] = ACTIONS(2809),
    [anon_sym_i32] = ACTIONS(2809),
    [anon_sym_u64] = ACTIONS(2809),
    [anon_sym_i64] = ACTIONS(2809),
    [anon_sym_u128] = ACTIONS(2809),
    [anon_sym_i128] = ACTIONS(2809),
    [anon_sym_isize] = ACTIONS(2809),
    [anon_sym_usize] = ACTIONS(2809),
    [anon_sym_f32] = ACTIONS(2809),
    [anon_sym_f64] = ACTIONS(2809),
    [anon_sym_bool] = ACTIONS(2809),
    [anon_sym_str] = ACTIONS(2809),
    [anon_sym_char] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_LT] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_POUND] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2809),
    [anon_sym_async] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_fn] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_impl] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_loop] = ACTIONS(2809),
    [anon_sym_match] = ACTIONS(2809),
    [anon_sym_mod] = ACTIONS(2809),
    [anon_sym_pub] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_trait] = ACTIONS(2809),
    [anon_sym_type] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [anon_sym_unsafe] = ACTIONS(2809),
    [anon_sym_use] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym_yield] = ACTIONS(2809),
    [anon_sym_move] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [sym_integer_literal] = ACTIONS(2807),
    [aux_sym_string_literal_token1] = ACTIONS(2807),
    [sym_char_literal] = ACTIONS(2807),
    [anon_sym_true] = ACTIONS(2809),
    [anon_sym_false] = ACTIONS(2809),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2809),
    [sym_super] = ACTIONS(2809),
    [sym_crate] = ACTIONS(2809),
    [sym_metavariable] = ACTIONS(2807),
    [sym__raw_string_literal_start] = ACTIONS(2807),
    [sym_float_literal] = ACTIONS(2807),
  },
  [726] = {
    [sym_line_comment] = STATE(726),
    [sym_block_comment] = STATE(726),
    [ts_builtin_sym_end] = ACTIONS(2811),
    [sym_identifier] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym_macro_rules_BANG] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_u8] = ACTIONS(2813),
    [anon_sym_i8] = ACTIONS(2813),
    [anon_sym_u16] = ACTIONS(2813),
    [anon_sym_i16] = ACTIONS(2813),
    [anon_sym_u32] = ACTIONS(2813),
    [anon_sym_i32] = ACTIONS(2813),
    [anon_sym_u64] = ACTIONS(2813),
    [anon_sym_i64] = ACTIONS(2813),
    [anon_sym_u128] = ACTIONS(2813),
    [anon_sym_i128] = ACTIONS(2813),
    [anon_sym_isize] = ACTIONS(2813),
    [anon_sym_usize] = ACTIONS(2813),
    [anon_sym_f32] = ACTIONS(2813),
    [anon_sym_f64] = ACTIONS(2813),
    [anon_sym_bool] = ACTIONS(2813),
    [anon_sym_str] = ACTIONS(2813),
    [anon_sym_char] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym_PIPE] = ACTIONS(2811),
    [anon_sym_LT] = ACTIONS(2811),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_POUND] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2813),
    [anon_sym_async] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_fn] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_impl] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_loop] = ACTIONS(2813),
    [anon_sym_match] = ACTIONS(2813),
    [anon_sym_mod] = ACTIONS(2813),
    [anon_sym_pub] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_trait] = ACTIONS(2813),
    [anon_sym_type] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [anon_sym_unsafe] = ACTIONS(2813),
    [anon_sym_use] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym_yield] = ACTIONS(2813),
    [anon_sym_move] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [sym_integer_literal] = ACTIONS(2811),
    [aux_sym_string_literal_token1] = ACTIONS(2811),
    [sym_char_literal] = ACTIONS(2811),
    [anon_sym_true] = ACTIONS(2813),
    [anon_sym_false] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2813),
    [sym_super] = ACTIONS(2813),
    [sym_crate] = ACTIONS(2813),
    [sym_metavariable] = ACTIONS(2811),
    [sym__raw_string_literal_start] = ACTIONS(2811),
    [sym_float_literal] = ACTIONS(2811),
  },
  [727] = {
    [sym_line_comment] = STATE(727),
    [sym_block_comment] = STATE(727),
    [ts_builtin_sym_end] = ACTIONS(2815),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_macro_rules_BANG] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_u8] = ACTIONS(2817),
    [anon_sym_i8] = ACTIONS(2817),
    [anon_sym_u16] = ACTIONS(2817),
    [anon_sym_i16] = ACTIONS(2817),
    [anon_sym_u32] = ACTIONS(2817),
    [anon_sym_i32] = ACTIONS(2817),
    [anon_sym_u64] = ACTIONS(2817),
    [anon_sym_i64] = ACTIONS(2817),
    [anon_sym_u128] = ACTIONS(2817),
    [anon_sym_i128] = ACTIONS(2817),
    [anon_sym_isize] = ACTIONS(2817),
    [anon_sym_usize] = ACTIONS(2817),
    [anon_sym_f32] = ACTIONS(2817),
    [anon_sym_f64] = ACTIONS(2817),
    [anon_sym_bool] = ACTIONS(2817),
    [anon_sym_str] = ACTIONS(2817),
    [anon_sym_char] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_PIPE] = ACTIONS(2815),
    [anon_sym_LT] = ACTIONS(2815),
    [anon_sym_DOT_DOT] = ACTIONS(2815),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_POUND] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [anon_sym_async] = ACTIONS(2817),
    [anon_sym_break] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_continue] = ACTIONS(2817),
    [anon_sym_default] = ACTIONS(2817),
    [anon_sym_enum] = ACTIONS(2817),
    [anon_sym_fn] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_impl] = ACTIONS(2817),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_loop] = ACTIONS(2817),
    [anon_sym_match] = ACTIONS(2817),
    [anon_sym_mod] = ACTIONS(2817),
    [anon_sym_pub] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_static] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2817),
    [anon_sym_trait] = ACTIONS(2817),
    [anon_sym_type] = ACTIONS(2817),
    [anon_sym_union] = ACTIONS(2817),
    [anon_sym_unsafe] = ACTIONS(2817),
    [anon_sym_use] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [anon_sym_extern] = ACTIONS(2817),
    [anon_sym_yield] = ACTIONS(2817),
    [anon_sym_move] = ACTIONS(2817),
    [anon_sym_try] = ACTIONS(2817),
    [sym_integer_literal] = ACTIONS(2815),
    [aux_sym_string_literal_token1] = ACTIONS(2815),
    [sym_char_literal] = ACTIONS(2815),
    [anon_sym_true] = ACTIONS(2817),
    [anon_sym_false] = ACTIONS(2817),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2817),
    [sym_super] = ACTIONS(2817),
    [sym_crate] = ACTIONS(2817),
    [sym_metavariable] = ACTIONS(2815),
    [sym__raw_string_literal_start] = ACTIONS(2815),
    [sym_float_literal] = ACTIONS(2815),
  },
  [728] = {
    [sym_line_comment] = STATE(728),
    [sym_block_comment] = STATE(728),
    [ts_builtin_sym_end] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2821),
    [anon_sym_SEMI] = ACTIONS(2819),
    [anon_sym_macro_rules_BANG] = ACTIONS(2819),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_u8] = ACTIONS(2821),
    [anon_sym_i8] = ACTIONS(2821),
    [anon_sym_u16] = ACTIONS(2821),
    [anon_sym_i16] = ACTIONS(2821),
    [anon_sym_u32] = ACTIONS(2821),
    [anon_sym_i32] = ACTIONS(2821),
    [anon_sym_u64] = ACTIONS(2821),
    [anon_sym_i64] = ACTIONS(2821),
    [anon_sym_u128] = ACTIONS(2821),
    [anon_sym_i128] = ACTIONS(2821),
    [anon_sym_isize] = ACTIONS(2821),
    [anon_sym_usize] = ACTIONS(2821),
    [anon_sym_f32] = ACTIONS(2821),
    [anon_sym_f64] = ACTIONS(2821),
    [anon_sym_bool] = ACTIONS(2821),
    [anon_sym_str] = ACTIONS(2821),
    [anon_sym_char] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_BANG] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2819),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_DOT_DOT] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2819),
    [anon_sym_POUND] = ACTIONS(2819),
    [anon_sym_SQUOTE] = ACTIONS(2821),
    [anon_sym_async] = ACTIONS(2821),
    [anon_sym_break] = ACTIONS(2821),
    [anon_sym_const] = ACTIONS(2821),
    [anon_sym_continue] = ACTIONS(2821),
    [anon_sym_default] = ACTIONS(2821),
    [anon_sym_enum] = ACTIONS(2821),
    [anon_sym_fn] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2821),
    [anon_sym_if] = ACTIONS(2821),
    [anon_sym_impl] = ACTIONS(2821),
    [anon_sym_let] = ACTIONS(2821),
    [anon_sym_loop] = ACTIONS(2821),
    [anon_sym_match] = ACTIONS(2821),
    [anon_sym_mod] = ACTIONS(2821),
    [anon_sym_pub] = ACTIONS(2821),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_struct] = ACTIONS(2821),
    [anon_sym_trait] = ACTIONS(2821),
    [anon_sym_type] = ACTIONS(2821),
    [anon_sym_union] = ACTIONS(2821),
    [anon_sym_unsafe] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2821),
    [anon_sym_while] = ACTIONS(2821),
    [anon_sym_extern] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2821),
    [anon_sym_move] = ACTIONS(2821),
    [anon_sym_try] = ACTIONS(2821),
    [sym_integer_literal] = ACTIONS(2819),
    [aux_sym_string_literal_token1] = ACTIONS(2819),
    [sym_char_literal] = ACTIONS(2819),
    [anon_sym_true] = ACTIONS(2821),
    [anon_sym_false] = ACTIONS(2821),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2821),
    [sym_super] = ACTIONS(2821),
    [sym_crate] = ACTIONS(2821),
    [sym_metavariable] = ACTIONS(2819),
    [sym__raw_string_literal_start] = ACTIONS(2819),
    [sym_float_literal] = ACTIONS(2819),
  },
  [729] = {
    [sym_line_comment] = STATE(729),
    [sym_block_comment] = STATE(729),
    [ts_builtin_sym_end] = ACTIONS(2823),
    [sym_identifier] = ACTIONS(2825),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_macro_rules_BANG] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2823),
    [anon_sym_u8] = ACTIONS(2825),
    [anon_sym_i8] = ACTIONS(2825),
    [anon_sym_u16] = ACTIONS(2825),
    [anon_sym_i16] = ACTIONS(2825),
    [anon_sym_u32] = ACTIONS(2825),
    [anon_sym_i32] = ACTIONS(2825),
    [anon_sym_u64] = ACTIONS(2825),
    [anon_sym_i64] = ACTIONS(2825),
    [anon_sym_u128] = ACTIONS(2825),
    [anon_sym_i128] = ACTIONS(2825),
    [anon_sym_isize] = ACTIONS(2825),
    [anon_sym_usize] = ACTIONS(2825),
    [anon_sym_f32] = ACTIONS(2825),
    [anon_sym_f64] = ACTIONS(2825),
    [anon_sym_bool] = ACTIONS(2825),
    [anon_sym_str] = ACTIONS(2825),
    [anon_sym_char] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2823),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2823),
    [anon_sym_POUND] = ACTIONS(2823),
    [anon_sym_SQUOTE] = ACTIONS(2825),
    [anon_sym_async] = ACTIONS(2825),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_const] = ACTIONS(2825),
    [anon_sym_continue] = ACTIONS(2825),
    [anon_sym_default] = ACTIONS(2825),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_fn] = ACTIONS(2825),
    [anon_sym_for] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_impl] = ACTIONS(2825),
    [anon_sym_let] = ACTIONS(2825),
    [anon_sym_loop] = ACTIONS(2825),
    [anon_sym_match] = ACTIONS(2825),
    [anon_sym_mod] = ACTIONS(2825),
    [anon_sym_pub] = ACTIONS(2825),
    [anon_sym_return] = ACTIONS(2825),
    [anon_sym_static] = ACTIONS(2825),
    [anon_sym_struct] = ACTIONS(2825),
    [anon_sym_trait] = ACTIONS(2825),
    [anon_sym_type] = ACTIONS(2825),
    [anon_sym_union] = ACTIONS(2825),
    [anon_sym_unsafe] = ACTIONS(2825),
    [anon_sym_use] = ACTIONS(2825),
    [anon_sym_while] = ACTIONS(2825),
    [anon_sym_extern] = ACTIONS(2825),
    [anon_sym_yield] = ACTIONS(2825),
    [anon_sym_move] = ACTIONS(2825),
    [anon_sym_try] = ACTIONS(2825),
    [sym_integer_literal] = ACTIONS(2823),
    [aux_sym_string_literal_token1] = ACTIONS(2823),
    [sym_char_literal] = ACTIONS(2823),
    [anon_sym_true] = ACTIONS(2825),
    [anon_sym_false] = ACTIONS(2825),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2825),
    [sym_super] = ACTIONS(2825),
    [sym_crate] = ACTIONS(2825),
    [sym_metavariable] = ACTIONS(2823),
    [sym__raw_string_literal_start] = ACTIONS(2823),
    [sym_float_literal] = ACTIONS(2823),
  },
  [730] = {
    [sym_line_comment] = STATE(730),
    [sym_block_comment] = STATE(730),
    [ts_builtin_sym_end] = ACTIONS(2827),
    [sym_identifier] = ACTIONS(2829),
    [anon_sym_SEMI] = ACTIONS(2827),
    [anon_sym_macro_rules_BANG] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_RBRACE] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_u8] = ACTIONS(2829),
    [anon_sym_i8] = ACTIONS(2829),
    [anon_sym_u16] = ACTIONS(2829),
    [anon_sym_i16] = ACTIONS(2829),
    [anon_sym_u32] = ACTIONS(2829),
    [anon_sym_i32] = ACTIONS(2829),
    [anon_sym_u64] = ACTIONS(2829),
    [anon_sym_i64] = ACTIONS(2829),
    [anon_sym_u128] = ACTIONS(2829),
    [anon_sym_i128] = ACTIONS(2829),
    [anon_sym_isize] = ACTIONS(2829),
    [anon_sym_usize] = ACTIONS(2829),
    [anon_sym_f32] = ACTIONS(2829),
    [anon_sym_f64] = ACTIONS(2829),
    [anon_sym_bool] = ACTIONS(2829),
    [anon_sym_str] = ACTIONS(2829),
    [anon_sym_char] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2827),
    [anon_sym_POUND] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(2829),
    [anon_sym_async] = ACTIONS(2829),
    [anon_sym_break] = ACTIONS(2829),
    [anon_sym_const] = ACTIONS(2829),
    [anon_sym_continue] = ACTIONS(2829),
    [anon_sym_default] = ACTIONS(2829),
    [anon_sym_enum] = ACTIONS(2829),
    [anon_sym_fn] = ACTIONS(2829),
    [anon_sym_for] = ACTIONS(2829),
    [anon_sym_if] = ACTIONS(2829),
    [anon_sym_impl] = ACTIONS(2829),
    [anon_sym_let] = ACTIONS(2829),
    [anon_sym_loop] = ACTIONS(2829),
    [anon_sym_match] = ACTIONS(2829),
    [anon_sym_mod] = ACTIONS(2829),
    [anon_sym_pub] = ACTIONS(2829),
    [anon_sym_return] = ACTIONS(2829),
    [anon_sym_static] = ACTIONS(2829),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_trait] = ACTIONS(2829),
    [anon_sym_type] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2829),
    [anon_sym_unsafe] = ACTIONS(2829),
    [anon_sym_use] = ACTIONS(2829),
    [anon_sym_while] = ACTIONS(2829),
    [anon_sym_extern] = ACTIONS(2829),
    [anon_sym_yield] = ACTIONS(2829),
    [anon_sym_move] = ACTIONS(2829),
    [anon_sym_try] = ACTIONS(2829),
    [sym_integer_literal] = ACTIONS(2827),
    [aux_sym_string_literal_token1] = ACTIONS(2827),
    [sym_char_literal] = ACTIONS(2827),
    [anon_sym_true] = ACTIONS(2829),
    [anon_sym_false] = ACTIONS(2829),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2829),
    [sym_super] = ACTIONS(2829),
    [sym_crate] = ACTIONS(2829),
    [sym_metavariable] = ACTIONS(2827),
    [sym__raw_string_literal_start] = ACTIONS(2827),
    [sym_float_literal] = ACTIONS(2827),
  },
  [731] = {
    [sym_line_comment] = STATE(731),
    [sym_block_comment] = STATE(731),
    [ts_builtin_sym_end] = ACTIONS(1232),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_SEMI] = ACTIONS(1232),
    [anon_sym_macro_rules_BANG] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_LBRACE] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_u8] = ACTIONS(1234),
    [anon_sym_i8] = ACTIONS(1234),
    [anon_sym_u16] = ACTIONS(1234),
    [anon_sym_i16] = ACTIONS(1234),
    [anon_sym_u32] = ACTIONS(1234),
    [anon_sym_i32] = ACTIONS(1234),
    [anon_sym_u64] = ACTIONS(1234),
    [anon_sym_i64] = ACTIONS(1234),
    [anon_sym_u128] = ACTIONS(1234),
    [anon_sym_i128] = ACTIONS(1234),
    [anon_sym_isize] = ACTIONS(1234),
    [anon_sym_usize] = ACTIONS(1234),
    [anon_sym_f32] = ACTIONS(1234),
    [anon_sym_f64] = ACTIONS(1234),
    [anon_sym_bool] = ACTIONS(1234),
    [anon_sym_str] = ACTIONS(1234),
    [anon_sym_char] = ACTIONS(1234),
    [anon_sym_DASH] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_PIPE] = ACTIONS(1232),
    [anon_sym_LT] = ACTIONS(1232),
    [anon_sym_DOT_DOT] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1232),
    [anon_sym_SQUOTE] = ACTIONS(1234),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_break] = ACTIONS(1234),
    [anon_sym_const] = ACTIONS(1234),
    [anon_sym_continue] = ACTIONS(1234),
    [anon_sym_default] = ACTIONS(1234),
    [anon_sym_enum] = ACTIONS(1234),
    [anon_sym_fn] = ACTIONS(1234),
    [anon_sym_for] = ACTIONS(1234),
    [anon_sym_if] = ACTIONS(1234),
    [anon_sym_impl] = ACTIONS(1234),
    [anon_sym_let] = ACTIONS(1234),
    [anon_sym_loop] = ACTIONS(1234),
    [anon_sym_match] = ACTIONS(1234),
    [anon_sym_mod] = ACTIONS(1234),
    [anon_sym_pub] = ACTIONS(1234),
    [anon_sym_return] = ACTIONS(1234),
    [anon_sym_static] = ACTIONS(1234),
    [anon_sym_struct] = ACTIONS(1234),
    [anon_sym_trait] = ACTIONS(1234),
    [anon_sym_type] = ACTIONS(1234),
    [anon_sym_union] = ACTIONS(1234),
    [anon_sym_unsafe] = ACTIONS(1234),
    [anon_sym_use] = ACTIONS(1234),
    [anon_sym_while] = ACTIONS(1234),
    [anon_sym_extern] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1234),
    [anon_sym_move] = ACTIONS(1234),
    [anon_sym_try] = ACTIONS(1234),
    [sym_integer_literal] = ACTIONS(1232),
    [aux_sym_string_literal_token1] = ACTIONS(1232),
    [sym_char_literal] = ACTIONS(1232),
    [anon_sym_true] = ACTIONS(1234),
    [anon_sym_false] = ACTIONS(1234),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1234),
    [sym_super] = ACTIONS(1234),
    [sym_crate] = ACTIONS(1234),
    [sym_metavariable] = ACTIONS(1232),
    [sym__raw_string_literal_start] = ACTIONS(1232),
    [sym_float_literal] = ACTIONS(1232),
  },
  [732] = {
    [sym_line_comment] = STATE(732),
    [sym_block_comment] = STATE(732),
    [ts_builtin_sym_end] = ACTIONS(2831),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2831),
    [anon_sym_macro_rules_BANG] = ACTIONS(2831),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_STAR] = ACTIONS(2831),
    [anon_sym_u8] = ACTIONS(2833),
    [anon_sym_i8] = ACTIONS(2833),
    [anon_sym_u16] = ACTIONS(2833),
    [anon_sym_i16] = ACTIONS(2833),
    [anon_sym_u32] = ACTIONS(2833),
    [anon_sym_i32] = ACTIONS(2833),
    [anon_sym_u64] = ACTIONS(2833),
    [anon_sym_i64] = ACTIONS(2833),
    [anon_sym_u128] = ACTIONS(2833),
    [anon_sym_i128] = ACTIONS(2833),
    [anon_sym_isize] = ACTIONS(2833),
    [anon_sym_usize] = ACTIONS(2833),
    [anon_sym_f32] = ACTIONS(2833),
    [anon_sym_f64] = ACTIONS(2833),
    [anon_sym_bool] = ACTIONS(2833),
    [anon_sym_str] = ACTIONS(2833),
    [anon_sym_char] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_DOT_DOT] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_POUND] = ACTIONS(2831),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_break] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_continue] = ACTIONS(2833),
    [anon_sym_default] = ACTIONS(2833),
    [anon_sym_enum] = ACTIONS(2833),
    [anon_sym_fn] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_impl] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_loop] = ACTIONS(2833),
    [anon_sym_match] = ACTIONS(2833),
    [anon_sym_mod] = ACTIONS(2833),
    [anon_sym_pub] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_trait] = ACTIONS(2833),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_union] = ACTIONS(2833),
    [anon_sym_unsafe] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2833),
    [anon_sym_while] = ACTIONS(2833),
    [anon_sym_extern] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2833),
    [anon_sym_move] = ACTIONS(2833),
    [anon_sym_try] = ACTIONS(2833),
    [sym_integer_literal] = ACTIONS(2831),
    [aux_sym_string_literal_token1] = ACTIONS(2831),
    [sym_char_literal] = ACTIONS(2831),
    [anon_sym_true] = ACTIONS(2833),
    [anon_sym_false] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2833),
    [sym_super] = ACTIONS(2833),
    [sym_crate] = ACTIONS(2833),
    [sym_metavariable] = ACTIONS(2831),
    [sym__raw_string_literal_start] = ACTIONS(2831),
    [sym_float_literal] = ACTIONS(2831),
  },
  [733] = {
    [sym_line_comment] = STATE(733),
    [sym_block_comment] = STATE(733),
    [ts_builtin_sym_end] = ACTIONS(2835),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_macro_rules_BANG] = ACTIONS(2835),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_STAR] = ACTIONS(2835),
    [anon_sym_u8] = ACTIONS(2837),
    [anon_sym_i8] = ACTIONS(2837),
    [anon_sym_u16] = ACTIONS(2837),
    [anon_sym_i16] = ACTIONS(2837),
    [anon_sym_u32] = ACTIONS(2837),
    [anon_sym_i32] = ACTIONS(2837),
    [anon_sym_u64] = ACTIONS(2837),
    [anon_sym_i64] = ACTIONS(2837),
    [anon_sym_u128] = ACTIONS(2837),
    [anon_sym_i128] = ACTIONS(2837),
    [anon_sym_isize] = ACTIONS(2837),
    [anon_sym_usize] = ACTIONS(2837),
    [anon_sym_f32] = ACTIONS(2837),
    [anon_sym_f64] = ACTIONS(2837),
    [anon_sym_bool] = ACTIONS(2837),
    [anon_sym_str] = ACTIONS(2837),
    [anon_sym_char] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_PIPE] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2835),
    [anon_sym_DOT_DOT] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2835),
    [anon_sym_POUND] = ACTIONS(2835),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_continue] = ACTIONS(2837),
    [anon_sym_default] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(2837),
    [anon_sym_fn] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_impl] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_loop] = ACTIONS(2837),
    [anon_sym_match] = ACTIONS(2837),
    [anon_sym_mod] = ACTIONS(2837),
    [anon_sym_pub] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_trait] = ACTIONS(2837),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_union] = ACTIONS(2837),
    [anon_sym_unsafe] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_extern] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2837),
    [anon_sym_move] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [sym_integer_literal] = ACTIONS(2835),
    [aux_sym_string_literal_token1] = ACTIONS(2835),
    [sym_char_literal] = ACTIONS(2835),
    [anon_sym_true] = ACTIONS(2837),
    [anon_sym_false] = ACTIONS(2837),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2837),
    [sym_super] = ACTIONS(2837),
    [sym_crate] = ACTIONS(2837),
    [sym_metavariable] = ACTIONS(2835),
    [sym__raw_string_literal_start] = ACTIONS(2835),
    [sym_float_literal] = ACTIONS(2835),
  },
  [734] = {
    [sym_line_comment] = STATE(734),
    [sym_block_comment] = STATE(734),
    [ts_builtin_sym_end] = ACTIONS(2839),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2839),
    [anon_sym_macro_rules_BANG] = ACTIONS(2839),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_RBRACE] = ACTIONS(2839),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_u8] = ACTIONS(2841),
    [anon_sym_i8] = ACTIONS(2841),
    [anon_sym_u16] = ACTIONS(2841),
    [anon_sym_i16] = ACTIONS(2841),
    [anon_sym_u32] = ACTIONS(2841),
    [anon_sym_i32] = ACTIONS(2841),
    [anon_sym_u64] = ACTIONS(2841),
    [anon_sym_i64] = ACTIONS(2841),
    [anon_sym_u128] = ACTIONS(2841),
    [anon_sym_i128] = ACTIONS(2841),
    [anon_sym_isize] = ACTIONS(2841),
    [anon_sym_usize] = ACTIONS(2841),
    [anon_sym_f32] = ACTIONS(2841),
    [anon_sym_f64] = ACTIONS(2841),
    [anon_sym_bool] = ACTIONS(2841),
    [anon_sym_str] = ACTIONS(2841),
    [anon_sym_char] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_BANG] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_PIPE] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2839),
    [anon_sym_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2839),
    [anon_sym_POUND] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_async] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_default] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2841),
    [anon_sym_fn] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_impl] = ACTIONS(2841),
    [anon_sym_let] = ACTIONS(2841),
    [anon_sym_loop] = ACTIONS(2841),
    [anon_sym_match] = ACTIONS(2841),
    [anon_sym_mod] = ACTIONS(2841),
    [anon_sym_pub] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_static] = ACTIONS(2841),
    [anon_sym_struct] = ACTIONS(2841),
    [anon_sym_trait] = ACTIONS(2841),
    [anon_sym_type] = ACTIONS(2841),
    [anon_sym_union] = ACTIONS(2841),
    [anon_sym_unsafe] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2841),
    [anon_sym_while] = ACTIONS(2841),
    [anon_sym_extern] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2841),
    [anon_sym_move] = ACTIONS(2841),
    [anon_sym_try] = ACTIONS(2841),
    [sym_integer_literal] = ACTIONS(2839),
    [aux_sym_string_literal_token1] = ACTIONS(2839),
    [sym_char_literal] = ACTIONS(2839),
    [anon_sym_true] = ACTIONS(2841),
    [anon_sym_false] = ACTIONS(2841),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2841),
    [sym_super] = ACTIONS(2841),
    [sym_crate] = ACTIONS(2841),
    [sym_metavariable] = ACTIONS(2839),
    [sym__raw_string_literal_start] = ACTIONS(2839),
    [sym_float_literal] = ACTIONS(2839),
  },
  [735] = {
    [sym_line_comment] = STATE(735),
    [sym_block_comment] = STATE(735),
    [ts_builtin_sym_end] = ACTIONS(2843),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_SEMI] = ACTIONS(2843),
    [anon_sym_macro_rules_BANG] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2843),
    [anon_sym_u8] = ACTIONS(2845),
    [anon_sym_i8] = ACTIONS(2845),
    [anon_sym_u16] = ACTIONS(2845),
    [anon_sym_i16] = ACTIONS(2845),
    [anon_sym_u32] = ACTIONS(2845),
    [anon_sym_i32] = ACTIONS(2845),
    [anon_sym_u64] = ACTIONS(2845),
    [anon_sym_i64] = ACTIONS(2845),
    [anon_sym_u128] = ACTIONS(2845),
    [anon_sym_i128] = ACTIONS(2845),
    [anon_sym_isize] = ACTIONS(2845),
    [anon_sym_usize] = ACTIONS(2845),
    [anon_sym_f32] = ACTIONS(2845),
    [anon_sym_f64] = ACTIONS(2845),
    [anon_sym_bool] = ACTIONS(2845),
    [anon_sym_str] = ACTIONS(2845),
    [anon_sym_char] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_BANG] = ACTIONS(2843),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_PIPE] = ACTIONS(2843),
    [anon_sym_LT] = ACTIONS(2843),
    [anon_sym_DOT_DOT] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2843),
    [anon_sym_POUND] = ACTIONS(2843),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_async] = ACTIONS(2845),
    [anon_sym_break] = ACTIONS(2845),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_continue] = ACTIONS(2845),
    [anon_sym_default] = ACTIONS(2845),
    [anon_sym_enum] = ACTIONS(2845),
    [anon_sym_fn] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2845),
    [anon_sym_if] = ACTIONS(2845),
    [anon_sym_impl] = ACTIONS(2845),
    [anon_sym_let] = ACTIONS(2845),
    [anon_sym_loop] = ACTIONS(2845),
    [anon_sym_match] = ACTIONS(2845),
    [anon_sym_mod] = ACTIONS(2845),
    [anon_sym_pub] = ACTIONS(2845),
    [anon_sym_return] = ACTIONS(2845),
    [anon_sym_static] = ACTIONS(2845),
    [anon_sym_struct] = ACTIONS(2845),
    [anon_sym_trait] = ACTIONS(2845),
    [anon_sym_type] = ACTIONS(2845),
    [anon_sym_union] = ACTIONS(2845),
    [anon_sym_unsafe] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2845),
    [anon_sym_while] = ACTIONS(2845),
    [anon_sym_extern] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2845),
    [anon_sym_move] = ACTIONS(2845),
    [anon_sym_try] = ACTIONS(2845),
    [sym_integer_literal] = ACTIONS(2843),
    [aux_sym_string_literal_token1] = ACTIONS(2843),
    [sym_char_literal] = ACTIONS(2843),
    [anon_sym_true] = ACTIONS(2845),
    [anon_sym_false] = ACTIONS(2845),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2845),
    [sym_super] = ACTIONS(2845),
    [sym_crate] = ACTIONS(2845),
    [sym_metavariable] = ACTIONS(2843),
    [sym__raw_string_literal_start] = ACTIONS(2843),
    [sym_float_literal] = ACTIONS(2843),
  },
  [736] = {
    [sym_line_comment] = STATE(736),
    [sym_block_comment] = STATE(736),
    [ts_builtin_sym_end] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_SEMI] = ACTIONS(2847),
    [anon_sym_macro_rules_BANG] = ACTIONS(2847),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_STAR] = ACTIONS(2847),
    [anon_sym_u8] = ACTIONS(2849),
    [anon_sym_i8] = ACTIONS(2849),
    [anon_sym_u16] = ACTIONS(2849),
    [anon_sym_i16] = ACTIONS(2849),
    [anon_sym_u32] = ACTIONS(2849),
    [anon_sym_i32] = ACTIONS(2849),
    [anon_sym_u64] = ACTIONS(2849),
    [anon_sym_i64] = ACTIONS(2849),
    [anon_sym_u128] = ACTIONS(2849),
    [anon_sym_i128] = ACTIONS(2849),
    [anon_sym_isize] = ACTIONS(2849),
    [anon_sym_usize] = ACTIONS(2849),
    [anon_sym_f32] = ACTIONS(2849),
    [anon_sym_f64] = ACTIONS(2849),
    [anon_sym_bool] = ACTIONS(2849),
    [anon_sym_str] = ACTIONS(2849),
    [anon_sym_char] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_BANG] = ACTIONS(2847),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_PIPE] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2847),
    [anon_sym_DOT_DOT] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2847),
    [anon_sym_POUND] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2849),
    [anon_sym_async] = ACTIONS(2849),
    [anon_sym_break] = ACTIONS(2849),
    [anon_sym_const] = ACTIONS(2849),
    [anon_sym_continue] = ACTIONS(2849),
    [anon_sym_default] = ACTIONS(2849),
    [anon_sym_enum] = ACTIONS(2849),
    [anon_sym_fn] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2849),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_impl] = ACTIONS(2849),
    [anon_sym_let] = ACTIONS(2849),
    [anon_sym_loop] = ACTIONS(2849),
    [anon_sym_match] = ACTIONS(2849),
    [anon_sym_mod] = ACTIONS(2849),
    [anon_sym_pub] = ACTIONS(2849),
    [anon_sym_return] = ACTIONS(2849),
    [anon_sym_static] = ACTIONS(2849),
    [anon_sym_struct] = ACTIONS(2849),
    [anon_sym_trait] = ACTIONS(2849),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_union] = ACTIONS(2849),
    [anon_sym_unsafe] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2849),
    [anon_sym_while] = ACTIONS(2849),
    [anon_sym_extern] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2849),
    [anon_sym_move] = ACTIONS(2849),
    [anon_sym_try] = ACTIONS(2849),
    [sym_integer_literal] = ACTIONS(2847),
    [aux_sym_string_literal_token1] = ACTIONS(2847),
    [sym_char_literal] = ACTIONS(2847),
    [anon_sym_true] = ACTIONS(2849),
    [anon_sym_false] = ACTIONS(2849),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2849),
    [sym_super] = ACTIONS(2849),
    [sym_crate] = ACTIONS(2849),
    [sym_metavariable] = ACTIONS(2847),
    [sym__raw_string_literal_start] = ACTIONS(2847),
    [sym_float_literal] = ACTIONS(2847),
  },
  [737] = {
    [sym_line_comment] = STATE(737),
    [sym_block_comment] = STATE(737),
    [ts_builtin_sym_end] = ACTIONS(2851),
    [sym_identifier] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_macro_rules_BANG] = ACTIONS(2851),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_STAR] = ACTIONS(2851),
    [anon_sym_u8] = ACTIONS(2853),
    [anon_sym_i8] = ACTIONS(2853),
    [anon_sym_u16] = ACTIONS(2853),
    [anon_sym_i16] = ACTIONS(2853),
    [anon_sym_u32] = ACTIONS(2853),
    [anon_sym_i32] = ACTIONS(2853),
    [anon_sym_u64] = ACTIONS(2853),
    [anon_sym_i64] = ACTIONS(2853),
    [anon_sym_u128] = ACTIONS(2853),
    [anon_sym_i128] = ACTIONS(2853),
    [anon_sym_isize] = ACTIONS(2853),
    [anon_sym_usize] = ACTIONS(2853),
    [anon_sym_f32] = ACTIONS(2853),
    [anon_sym_f64] = ACTIONS(2853),
    [anon_sym_bool] = ACTIONS(2853),
    [anon_sym_str] = ACTIONS(2853),
    [anon_sym_char] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_BANG] = ACTIONS(2851),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2851),
    [anon_sym_POUND] = ACTIONS(2851),
    [anon_sym_SQUOTE] = ACTIONS(2853),
    [anon_sym_async] = ACTIONS(2853),
    [anon_sym_break] = ACTIONS(2853),
    [anon_sym_const] = ACTIONS(2853),
    [anon_sym_continue] = ACTIONS(2853),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_enum] = ACTIONS(2853),
    [anon_sym_fn] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2853),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_impl] = ACTIONS(2853),
    [anon_sym_let] = ACTIONS(2853),
    [anon_sym_loop] = ACTIONS(2853),
    [anon_sym_match] = ACTIONS(2853),
    [anon_sym_mod] = ACTIONS(2853),
    [anon_sym_pub] = ACTIONS(2853),
    [anon_sym_return] = ACTIONS(2853),
    [anon_sym_static] = ACTIONS(2853),
    [anon_sym_struct] = ACTIONS(2853),
    [anon_sym_trait] = ACTIONS(2853),
    [anon_sym_type] = ACTIONS(2853),
    [anon_sym_union] = ACTIONS(2853),
    [anon_sym_unsafe] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2853),
    [anon_sym_extern] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2853),
    [anon_sym_move] = ACTIONS(2853),
    [anon_sym_try] = ACTIONS(2853),
    [sym_integer_literal] = ACTIONS(2851),
    [aux_sym_string_literal_token1] = ACTIONS(2851),
    [sym_char_literal] = ACTIONS(2851),
    [anon_sym_true] = ACTIONS(2853),
    [anon_sym_false] = ACTIONS(2853),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2853),
    [sym_super] = ACTIONS(2853),
    [sym_crate] = ACTIONS(2853),
    [sym_metavariable] = ACTIONS(2851),
    [sym__raw_string_literal_start] = ACTIONS(2851),
    [sym_float_literal] = ACTIONS(2851),
  },
  [738] = {
    [sym_line_comment] = STATE(738),
    [sym_block_comment] = STATE(738),
    [ts_builtin_sym_end] = ACTIONS(2855),
    [sym_identifier] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2855),
    [anon_sym_macro_rules_BANG] = ACTIONS(2855),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_u8] = ACTIONS(2857),
    [anon_sym_i8] = ACTIONS(2857),
    [anon_sym_u16] = ACTIONS(2857),
    [anon_sym_i16] = ACTIONS(2857),
    [anon_sym_u32] = ACTIONS(2857),
    [anon_sym_i32] = ACTIONS(2857),
    [anon_sym_u64] = ACTIONS(2857),
    [anon_sym_i64] = ACTIONS(2857),
    [anon_sym_u128] = ACTIONS(2857),
    [anon_sym_i128] = ACTIONS(2857),
    [anon_sym_isize] = ACTIONS(2857),
    [anon_sym_usize] = ACTIONS(2857),
    [anon_sym_f32] = ACTIONS(2857),
    [anon_sym_f64] = ACTIONS(2857),
    [anon_sym_bool] = ACTIONS(2857),
    [anon_sym_str] = ACTIONS(2857),
    [anon_sym_char] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [anon_sym_POUND] = ACTIONS(2855),
    [anon_sym_SQUOTE] = ACTIONS(2857),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_break] = ACTIONS(2857),
    [anon_sym_const] = ACTIONS(2857),
    [anon_sym_continue] = ACTIONS(2857),
    [anon_sym_default] = ACTIONS(2857),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_fn] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_impl] = ACTIONS(2857),
    [anon_sym_let] = ACTIONS(2857),
    [anon_sym_loop] = ACTIONS(2857),
    [anon_sym_match] = ACTIONS(2857),
    [anon_sym_mod] = ACTIONS(2857),
    [anon_sym_pub] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(2857),
    [anon_sym_static] = ACTIONS(2857),
    [anon_sym_struct] = ACTIONS(2857),
    [anon_sym_trait] = ACTIONS(2857),
    [anon_sym_type] = ACTIONS(2857),
    [anon_sym_union] = ACTIONS(2857),
    [anon_sym_unsafe] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2857),
    [anon_sym_extern] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2857),
    [anon_sym_move] = ACTIONS(2857),
    [anon_sym_try] = ACTIONS(2857),
    [sym_integer_literal] = ACTIONS(2855),
    [aux_sym_string_literal_token1] = ACTIONS(2855),
    [sym_char_literal] = ACTIONS(2855),
    [anon_sym_true] = ACTIONS(2857),
    [anon_sym_false] = ACTIONS(2857),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2857),
    [sym_super] = ACTIONS(2857),
    [sym_crate] = ACTIONS(2857),
    [sym_metavariable] = ACTIONS(2855),
    [sym__raw_string_literal_start] = ACTIONS(2855),
    [sym_float_literal] = ACTIONS(2855),
  },
  [739] = {
    [sym_line_comment] = STATE(739),
    [sym_block_comment] = STATE(739),
    [ts_builtin_sym_end] = ACTIONS(2859),
    [sym_identifier] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_macro_rules_BANG] = ACTIONS(2859),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2859),
    [anon_sym_u8] = ACTIONS(2861),
    [anon_sym_i8] = ACTIONS(2861),
    [anon_sym_u16] = ACTIONS(2861),
    [anon_sym_i16] = ACTIONS(2861),
    [anon_sym_u32] = ACTIONS(2861),
    [anon_sym_i32] = ACTIONS(2861),
    [anon_sym_u64] = ACTIONS(2861),
    [anon_sym_i64] = ACTIONS(2861),
    [anon_sym_u128] = ACTIONS(2861),
    [anon_sym_i128] = ACTIONS(2861),
    [anon_sym_isize] = ACTIONS(2861),
    [anon_sym_usize] = ACTIONS(2861),
    [anon_sym_f32] = ACTIONS(2861),
    [anon_sym_f64] = ACTIONS(2861),
    [anon_sym_bool] = ACTIONS(2861),
    [anon_sym_str] = ACTIONS(2861),
    [anon_sym_char] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_BANG] = ACTIONS(2859),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_PIPE] = ACTIONS(2859),
    [anon_sym_LT] = ACTIONS(2859),
    [anon_sym_DOT_DOT] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2859),
    [anon_sym_POUND] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2861),
    [anon_sym_async] = ACTIONS(2861),
    [anon_sym_break] = ACTIONS(2861),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_continue] = ACTIONS(2861),
    [anon_sym_default] = ACTIONS(2861),
    [anon_sym_enum] = ACTIONS(2861),
    [anon_sym_fn] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2861),
    [anon_sym_impl] = ACTIONS(2861),
    [anon_sym_let] = ACTIONS(2861),
    [anon_sym_loop] = ACTIONS(2861),
    [anon_sym_match] = ACTIONS(2861),
    [anon_sym_mod] = ACTIONS(2861),
    [anon_sym_pub] = ACTIONS(2861),
    [anon_sym_return] = ACTIONS(2861),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_trait] = ACTIONS(2861),
    [anon_sym_type] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2861),
    [anon_sym_unsafe] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2861),
    [anon_sym_extern] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2861),
    [anon_sym_move] = ACTIONS(2861),
    [anon_sym_try] = ACTIONS(2861),
    [sym_integer_literal] = ACTIONS(2859),
    [aux_sym_string_literal_token1] = ACTIONS(2859),
    [sym_char_literal] = ACTIONS(2859),
    [anon_sym_true] = ACTIONS(2861),
    [anon_sym_false] = ACTIONS(2861),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2861),
    [sym_super] = ACTIONS(2861),
    [sym_crate] = ACTIONS(2861),
    [sym_metavariable] = ACTIONS(2859),
    [sym__raw_string_literal_start] = ACTIONS(2859),
    [sym_float_literal] = ACTIONS(2859),
  },
  [740] = {
    [sym_line_comment] = STATE(740),
    [sym_block_comment] = STATE(740),
    [ts_builtin_sym_end] = ACTIONS(2863),
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_macro_rules_BANG] = ACTIONS(2863),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_STAR] = ACTIONS(2863),
    [anon_sym_u8] = ACTIONS(2865),
    [anon_sym_i8] = ACTIONS(2865),
    [anon_sym_u16] = ACTIONS(2865),
    [anon_sym_i16] = ACTIONS(2865),
    [anon_sym_u32] = ACTIONS(2865),
    [anon_sym_i32] = ACTIONS(2865),
    [anon_sym_u64] = ACTIONS(2865),
    [anon_sym_i64] = ACTIONS(2865),
    [anon_sym_u128] = ACTIONS(2865),
    [anon_sym_i128] = ACTIONS(2865),
    [anon_sym_isize] = ACTIONS(2865),
    [anon_sym_usize] = ACTIONS(2865),
    [anon_sym_f32] = ACTIONS(2865),
    [anon_sym_f64] = ACTIONS(2865),
    [anon_sym_bool] = ACTIONS(2865),
    [anon_sym_str] = ACTIONS(2865),
    [anon_sym_char] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_BANG] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2863),
    [anon_sym_LT] = ACTIONS(2863),
    [anon_sym_DOT_DOT] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2863),
    [anon_sym_POUND] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_async] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2865),
    [anon_sym_const] = ACTIONS(2865),
    [anon_sym_continue] = ACTIONS(2865),
    [anon_sym_default] = ACTIONS(2865),
    [anon_sym_enum] = ACTIONS(2865),
    [anon_sym_fn] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_impl] = ACTIONS(2865),
    [anon_sym_let] = ACTIONS(2865),
    [anon_sym_loop] = ACTIONS(2865),
    [anon_sym_match] = ACTIONS(2865),
    [anon_sym_mod] = ACTIONS(2865),
    [anon_sym_pub] = ACTIONS(2865),
    [anon_sym_return] = ACTIONS(2865),
    [anon_sym_static] = ACTIONS(2865),
    [anon_sym_struct] = ACTIONS(2865),
    [anon_sym_trait] = ACTIONS(2865),
    [anon_sym_type] = ACTIONS(2865),
    [anon_sym_union] = ACTIONS(2865),
    [anon_sym_unsafe] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2865),
    [anon_sym_while] = ACTIONS(2865),
    [anon_sym_extern] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_move] = ACTIONS(2865),
    [anon_sym_try] = ACTIONS(2865),
    [sym_integer_literal] = ACTIONS(2863),
    [aux_sym_string_literal_token1] = ACTIONS(2863),
    [sym_char_literal] = ACTIONS(2863),
    [anon_sym_true] = ACTIONS(2865),
    [anon_sym_false] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2865),
    [sym_super] = ACTIONS(2865),
    [sym_crate] = ACTIONS(2865),
    [sym_metavariable] = ACTIONS(2863),
    [sym__raw_string_literal_start] = ACTIONS(2863),
    [sym_float_literal] = ACTIONS(2863),
  },
  [741] = {
    [sym_line_comment] = STATE(741),
    [sym_block_comment] = STATE(741),
    [ts_builtin_sym_end] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_macro_rules_BANG] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2867),
    [anon_sym_u8] = ACTIONS(2869),
    [anon_sym_i8] = ACTIONS(2869),
    [anon_sym_u16] = ACTIONS(2869),
    [anon_sym_i16] = ACTIONS(2869),
    [anon_sym_u32] = ACTIONS(2869),
    [anon_sym_i32] = ACTIONS(2869),
    [anon_sym_u64] = ACTIONS(2869),
    [anon_sym_i64] = ACTIONS(2869),
    [anon_sym_u128] = ACTIONS(2869),
    [anon_sym_i128] = ACTIONS(2869),
    [anon_sym_isize] = ACTIONS(2869),
    [anon_sym_usize] = ACTIONS(2869),
    [anon_sym_f32] = ACTIONS(2869),
    [anon_sym_f64] = ACTIONS(2869),
    [anon_sym_bool] = ACTIONS(2869),
    [anon_sym_str] = ACTIONS(2869),
    [anon_sym_char] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_DOT_DOT] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2867),
    [anon_sym_POUND] = ACTIONS(2867),
    [anon_sym_SQUOTE] = ACTIONS(2869),
    [anon_sym_async] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_fn] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_impl] = ACTIONS(2869),
    [anon_sym_let] = ACTIONS(2869),
    [anon_sym_loop] = ACTIONS(2869),
    [anon_sym_match] = ACTIONS(2869),
    [anon_sym_mod] = ACTIONS(2869),
    [anon_sym_pub] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_trait] = ACTIONS(2869),
    [anon_sym_type] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_unsafe] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2869),
    [anon_sym_move] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [sym_integer_literal] = ACTIONS(2867),
    [aux_sym_string_literal_token1] = ACTIONS(2867),
    [sym_char_literal] = ACTIONS(2867),
    [anon_sym_true] = ACTIONS(2869),
    [anon_sym_false] = ACTIONS(2869),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2869),
    [sym_super] = ACTIONS(2869),
    [sym_crate] = ACTIONS(2869),
    [sym_metavariable] = ACTIONS(2867),
    [sym__raw_string_literal_start] = ACTIONS(2867),
    [sym_float_literal] = ACTIONS(2867),
  },
  [742] = {
    [sym_line_comment] = STATE(742),
    [sym_block_comment] = STATE(742),
    [ts_builtin_sym_end] = ACTIONS(2871),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_macro_rules_BANG] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_LBRACE] = ACTIONS(2871),
    [anon_sym_RBRACE] = ACTIONS(2871),
    [anon_sym_STAR] = ACTIONS(2871),
    [anon_sym_u8] = ACTIONS(2873),
    [anon_sym_i8] = ACTIONS(2873),
    [anon_sym_u16] = ACTIONS(2873),
    [anon_sym_i16] = ACTIONS(2873),
    [anon_sym_u32] = ACTIONS(2873),
    [anon_sym_i32] = ACTIONS(2873),
    [anon_sym_u64] = ACTIONS(2873),
    [anon_sym_i64] = ACTIONS(2873),
    [anon_sym_u128] = ACTIONS(2873),
    [anon_sym_i128] = ACTIONS(2873),
    [anon_sym_isize] = ACTIONS(2873),
    [anon_sym_usize] = ACTIONS(2873),
    [anon_sym_f32] = ACTIONS(2873),
    [anon_sym_f64] = ACTIONS(2873),
    [anon_sym_bool] = ACTIONS(2873),
    [anon_sym_str] = ACTIONS(2873),
    [anon_sym_char] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2871),
    [anon_sym_BANG] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_COLON_COLON] = ACTIONS(2871),
    [anon_sym_POUND] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2873),
    [anon_sym_break] = ACTIONS(2873),
    [anon_sym_const] = ACTIONS(2873),
    [anon_sym_continue] = ACTIONS(2873),
    [anon_sym_default] = ACTIONS(2873),
    [anon_sym_enum] = ACTIONS(2873),
    [anon_sym_fn] = ACTIONS(2873),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_impl] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_loop] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_mod] = ACTIONS(2873),
    [anon_sym_pub] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_static] = ACTIONS(2873),
    [anon_sym_struct] = ACTIONS(2873),
    [anon_sym_trait] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_union] = ACTIONS(2873),
    [anon_sym_unsafe] = ACTIONS(2873),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_extern] = ACTIONS(2873),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_move] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [sym_integer_literal] = ACTIONS(2871),
    [aux_sym_string_literal_token1] = ACTIONS(2871),
    [sym_char_literal] = ACTIONS(2871),
    [anon_sym_true] = ACTIONS(2873),
    [anon_sym_false] = ACTIONS(2873),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2873),
    [sym_super] = ACTIONS(2873),
    [sym_crate] = ACTIONS(2873),
    [sym_metavariable] = ACTIONS(2871),
    [sym__raw_string_literal_start] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
  },
  [743] = {
    [sym_line_comment] = STATE(743),
    [sym_block_comment] = STATE(743),
    [ts_builtin_sym_end] = ACTIONS(2875),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_macro_rules_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_u8] = ACTIONS(2877),
    [anon_sym_i8] = ACTIONS(2877),
    [anon_sym_u16] = ACTIONS(2877),
    [anon_sym_i16] = ACTIONS(2877),
    [anon_sym_u32] = ACTIONS(2877),
    [anon_sym_i32] = ACTIONS(2877),
    [anon_sym_u64] = ACTIONS(2877),
    [anon_sym_i64] = ACTIONS(2877),
    [anon_sym_u128] = ACTIONS(2877),
    [anon_sym_i128] = ACTIONS(2877),
    [anon_sym_isize] = ACTIONS(2877),
    [anon_sym_usize] = ACTIONS(2877),
    [anon_sym_f32] = ACTIONS(2877),
    [anon_sym_f64] = ACTIONS(2877),
    [anon_sym_bool] = ACTIONS(2877),
    [anon_sym_str] = ACTIONS(2877),
    [anon_sym_char] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_POUND] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_async] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_default] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_fn] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_impl] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_loop] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_mod] = ACTIONS(2877),
    [anon_sym_pub] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_trait] = ACTIONS(2877),
    [anon_sym_type] = ACTIONS(2877),
    [anon_sym_union] = ACTIONS(2877),
    [anon_sym_unsafe] = ACTIONS(2877),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_extern] = ACTIONS(2877),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_move] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [sym_integer_literal] = ACTIONS(2875),
    [aux_sym_string_literal_token1] = ACTIONS(2875),
    [sym_char_literal] = ACTIONS(2875),
    [anon_sym_true] = ACTIONS(2877),
    [anon_sym_false] = ACTIONS(2877),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2877),
    [sym_super] = ACTIONS(2877),
    [sym_crate] = ACTIONS(2877),
    [sym_metavariable] = ACTIONS(2875),
    [sym__raw_string_literal_start] = ACTIONS(2875),
    [sym_float_literal] = ACTIONS(2875),
  },
  [744] = {
    [sym_line_comment] = STATE(744),
    [sym_block_comment] = STATE(744),
    [ts_builtin_sym_end] = ACTIONS(2879),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_macro_rules_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2879),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_u8] = ACTIONS(2881),
    [anon_sym_i8] = ACTIONS(2881),
    [anon_sym_u16] = ACTIONS(2881),
    [anon_sym_i16] = ACTIONS(2881),
    [anon_sym_u32] = ACTIONS(2881),
    [anon_sym_i32] = ACTIONS(2881),
    [anon_sym_u64] = ACTIONS(2881),
    [anon_sym_i64] = ACTIONS(2881),
    [anon_sym_u128] = ACTIONS(2881),
    [anon_sym_i128] = ACTIONS(2881),
    [anon_sym_isize] = ACTIONS(2881),
    [anon_sym_usize] = ACTIONS(2881),
    [anon_sym_f32] = ACTIONS(2881),
    [anon_sym_f64] = ACTIONS(2881),
    [anon_sym_bool] = ACTIONS(2881),
    [anon_sym_str] = ACTIONS(2881),
    [anon_sym_char] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2879),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_POUND] = ACTIONS(2879),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_break] = ACTIONS(2881),
    [anon_sym_const] = ACTIONS(2881),
    [anon_sym_continue] = ACTIONS(2881),
    [anon_sym_default] = ACTIONS(2881),
    [anon_sym_enum] = ACTIONS(2881),
    [anon_sym_fn] = ACTIONS(2881),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_impl] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_loop] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_mod] = ACTIONS(2881),
    [anon_sym_pub] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_static] = ACTIONS(2881),
    [anon_sym_struct] = ACTIONS(2881),
    [anon_sym_trait] = ACTIONS(2881),
    [anon_sym_type] = ACTIONS(2881),
    [anon_sym_union] = ACTIONS(2881),
    [anon_sym_unsafe] = ACTIONS(2881),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_extern] = ACTIONS(2881),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_move] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [sym_integer_literal] = ACTIONS(2879),
    [aux_sym_string_literal_token1] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [anon_sym_true] = ACTIONS(2881),
    [anon_sym_false] = ACTIONS(2881),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2881),
    [sym_super] = ACTIONS(2881),
    [sym_crate] = ACTIONS(2881),
    [sym_metavariable] = ACTIONS(2879),
    [sym__raw_string_literal_start] = ACTIONS(2879),
    [sym_float_literal] = ACTIONS(2879),
  },
  [745] = {
    [sym_line_comment] = STATE(745),
    [sym_block_comment] = STATE(745),
    [ts_builtin_sym_end] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_macro_rules_BANG] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2883),
    [anon_sym_u8] = ACTIONS(2885),
    [anon_sym_i8] = ACTIONS(2885),
    [anon_sym_u16] = ACTIONS(2885),
    [anon_sym_i16] = ACTIONS(2885),
    [anon_sym_u32] = ACTIONS(2885),
    [anon_sym_i32] = ACTIONS(2885),
    [anon_sym_u64] = ACTIONS(2885),
    [anon_sym_i64] = ACTIONS(2885),
    [anon_sym_u128] = ACTIONS(2885),
    [anon_sym_i128] = ACTIONS(2885),
    [anon_sym_isize] = ACTIONS(2885),
    [anon_sym_usize] = ACTIONS(2885),
    [anon_sym_f32] = ACTIONS(2885),
    [anon_sym_f64] = ACTIONS(2885),
    [anon_sym_bool] = ACTIONS(2885),
    [anon_sym_str] = ACTIONS(2885),
    [anon_sym_char] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2883),
    [anon_sym_POUND] = ACTIONS(2883),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_async] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_fn] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_impl] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_loop] = ACTIONS(2885),
    [anon_sym_match] = ACTIONS(2885),
    [anon_sym_mod] = ACTIONS(2885),
    [anon_sym_pub] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_trait] = ACTIONS(2885),
    [anon_sym_type] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_unsafe] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2885),
    [anon_sym_move] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [sym_integer_literal] = ACTIONS(2883),
    [aux_sym_string_literal_token1] = ACTIONS(2883),
    [sym_char_literal] = ACTIONS(2883),
    [anon_sym_true] = ACTIONS(2885),
    [anon_sym_false] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2885),
    [sym_super] = ACTIONS(2885),
    [sym_crate] = ACTIONS(2885),
    [sym_metavariable] = ACTIONS(2883),
    [sym__raw_string_literal_start] = ACTIONS(2883),
    [sym_float_literal] = ACTIONS(2883),
  },
  [746] = {
    [sym_line_comment] = STATE(746),
    [sym_block_comment] = STATE(746),
    [ts_builtin_sym_end] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_macro_rules_BANG] = ACTIONS(2887),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_u8] = ACTIONS(2889),
    [anon_sym_i8] = ACTIONS(2889),
    [anon_sym_u16] = ACTIONS(2889),
    [anon_sym_i16] = ACTIONS(2889),
    [anon_sym_u32] = ACTIONS(2889),
    [anon_sym_i32] = ACTIONS(2889),
    [anon_sym_u64] = ACTIONS(2889),
    [anon_sym_i64] = ACTIONS(2889),
    [anon_sym_u128] = ACTIONS(2889),
    [anon_sym_i128] = ACTIONS(2889),
    [anon_sym_isize] = ACTIONS(2889),
    [anon_sym_usize] = ACTIONS(2889),
    [anon_sym_f32] = ACTIONS(2889),
    [anon_sym_f64] = ACTIONS(2889),
    [anon_sym_bool] = ACTIONS(2889),
    [anon_sym_str] = ACTIONS(2889),
    [anon_sym_char] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_PIPE] = ACTIONS(2887),
    [anon_sym_LT] = ACTIONS(2887),
    [anon_sym_DOT_DOT] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_POUND] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_async] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_default] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [anon_sym_fn] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_impl] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_loop] = ACTIONS(2889),
    [anon_sym_match] = ACTIONS(2889),
    [anon_sym_mod] = ACTIONS(2889),
    [anon_sym_pub] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_static] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_trait] = ACTIONS(2889),
    [anon_sym_type] = ACTIONS(2889),
    [anon_sym_union] = ACTIONS(2889),
    [anon_sym_unsafe] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_extern] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2889),
    [anon_sym_move] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [sym_integer_literal] = ACTIONS(2887),
    [aux_sym_string_literal_token1] = ACTIONS(2887),
    [sym_char_literal] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(2889),
    [anon_sym_false] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2889),
    [sym_super] = ACTIONS(2889),
    [sym_crate] = ACTIONS(2889),
    [sym_metavariable] = ACTIONS(2887),
    [sym__raw_string_literal_start] = ACTIONS(2887),
    [sym_float_literal] = ACTIONS(2887),
  },
  [747] = {
    [sym_line_comment] = STATE(747),
    [sym_block_comment] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_macro_rules_BANG] = ACTIONS(2891),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2891),
    [anon_sym_u8] = ACTIONS(2893),
    [anon_sym_i8] = ACTIONS(2893),
    [anon_sym_u16] = ACTIONS(2893),
    [anon_sym_i16] = ACTIONS(2893),
    [anon_sym_u32] = ACTIONS(2893),
    [anon_sym_i32] = ACTIONS(2893),
    [anon_sym_u64] = ACTIONS(2893),
    [anon_sym_i64] = ACTIONS(2893),
    [anon_sym_u128] = ACTIONS(2893),
    [anon_sym_i128] = ACTIONS(2893),
    [anon_sym_isize] = ACTIONS(2893),
    [anon_sym_usize] = ACTIONS(2893),
    [anon_sym_f32] = ACTIONS(2893),
    [anon_sym_f64] = ACTIONS(2893),
    [anon_sym_bool] = ACTIONS(2893),
    [anon_sym_str] = ACTIONS(2893),
    [anon_sym_char] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2891),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_DOT_DOT] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2891),
    [anon_sym_POUND] = ACTIONS(2891),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_async] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_fn] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_impl] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_loop] = ACTIONS(2893),
    [anon_sym_match] = ACTIONS(2893),
    [anon_sym_mod] = ACTIONS(2893),
    [anon_sym_pub] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_trait] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_unsafe] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2893),
    [anon_sym_move] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [sym_integer_literal] = ACTIONS(2891),
    [aux_sym_string_literal_token1] = ACTIONS(2891),
    [sym_char_literal] = ACTIONS(2891),
    [anon_sym_true] = ACTIONS(2893),
    [anon_sym_false] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2893),
    [sym_super] = ACTIONS(2893),
    [sym_crate] = ACTIONS(2893),
    [sym_metavariable] = ACTIONS(2891),
    [sym__raw_string_literal_start] = ACTIONS(2891),
    [sym_float_literal] = ACTIONS(2891),
  },
  [748] = {
    [sym_line_comment] = STATE(748),
    [sym_block_comment] = STATE(748),
    [ts_builtin_sym_end] = ACTIONS(2895),
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_macro_rules_BANG] = ACTIONS(2895),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_u8] = ACTIONS(2897),
    [anon_sym_i8] = ACTIONS(2897),
    [anon_sym_u16] = ACTIONS(2897),
    [anon_sym_i16] = ACTIONS(2897),
    [anon_sym_u32] = ACTIONS(2897),
    [anon_sym_i32] = ACTIONS(2897),
    [anon_sym_u64] = ACTIONS(2897),
    [anon_sym_i64] = ACTIONS(2897),
    [anon_sym_u128] = ACTIONS(2897),
    [anon_sym_i128] = ACTIONS(2897),
    [anon_sym_isize] = ACTIONS(2897),
    [anon_sym_usize] = ACTIONS(2897),
    [anon_sym_f32] = ACTIONS(2897),
    [anon_sym_f64] = ACTIONS(2897),
    [anon_sym_bool] = ACTIONS(2897),
    [anon_sym_str] = ACTIONS(2897),
    [anon_sym_char] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2895),
    [anon_sym_LT] = ACTIONS(2895),
    [anon_sym_DOT_DOT] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_POUND] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2897),
    [anon_sym_async] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_default] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [anon_sym_fn] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_impl] = ACTIONS(2897),
    [anon_sym_let] = ACTIONS(2897),
    [anon_sym_loop] = ACTIONS(2897),
    [anon_sym_match] = ACTIONS(2897),
    [anon_sym_mod] = ACTIONS(2897),
    [anon_sym_pub] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_struct] = ACTIONS(2897),
    [anon_sym_trait] = ACTIONS(2897),
    [anon_sym_type] = ACTIONS(2897),
    [anon_sym_union] = ACTIONS(2897),
    [anon_sym_unsafe] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_extern] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2897),
    [anon_sym_move] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [sym_integer_literal] = ACTIONS(2895),
    [aux_sym_string_literal_token1] = ACTIONS(2895),
    [sym_char_literal] = ACTIONS(2895),
    [anon_sym_true] = ACTIONS(2897),
    [anon_sym_false] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2897),
    [sym_super] = ACTIONS(2897),
    [sym_crate] = ACTIONS(2897),
    [sym_metavariable] = ACTIONS(2895),
    [sym__raw_string_literal_start] = ACTIONS(2895),
    [sym_float_literal] = ACTIONS(2895),
  },
  [749] = {
    [sym_line_comment] = STATE(749),
    [sym_block_comment] = STATE(749),
    [ts_builtin_sym_end] = ACTIONS(2899),
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_macro_rules_BANG] = ACTIONS(2899),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_u8] = ACTIONS(2901),
    [anon_sym_i8] = ACTIONS(2901),
    [anon_sym_u16] = ACTIONS(2901),
    [anon_sym_i16] = ACTIONS(2901),
    [anon_sym_u32] = ACTIONS(2901),
    [anon_sym_i32] = ACTIONS(2901),
    [anon_sym_u64] = ACTIONS(2901),
    [anon_sym_i64] = ACTIONS(2901),
    [anon_sym_u128] = ACTIONS(2901),
    [anon_sym_i128] = ACTIONS(2901),
    [anon_sym_isize] = ACTIONS(2901),
    [anon_sym_usize] = ACTIONS(2901),
    [anon_sym_f32] = ACTIONS(2901),
    [anon_sym_f64] = ACTIONS(2901),
    [anon_sym_bool] = ACTIONS(2901),
    [anon_sym_str] = ACTIONS(2901),
    [anon_sym_char] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_DOT_DOT] = ACTIONS(2899),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_POUND] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2901),
    [anon_sym_async] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_fn] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_impl] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_loop] = ACTIONS(2901),
    [anon_sym_match] = ACTIONS(2901),
    [anon_sym_mod] = ACTIONS(2901),
    [anon_sym_pub] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_trait] = ACTIONS(2901),
    [anon_sym_type] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [anon_sym_unsafe] = ACTIONS(2901),
    [anon_sym_use] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym_yield] = ACTIONS(2901),
    [anon_sym_move] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [sym_integer_literal] = ACTIONS(2899),
    [aux_sym_string_literal_token1] = ACTIONS(2899),
    [sym_char_literal] = ACTIONS(2899),
    [anon_sym_true] = ACTIONS(2901),
    [anon_sym_false] = ACTIONS(2901),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2901),
    [sym_super] = ACTIONS(2901),
    [sym_crate] = ACTIONS(2901),
    [sym_metavariable] = ACTIONS(2899),
    [sym__raw_string_literal_start] = ACTIONS(2899),
    [sym_float_literal] = ACTIONS(2899),
  },
  [750] = {
    [sym_line_comment] = STATE(750),
    [sym_block_comment] = STATE(750),
    [ts_builtin_sym_end] = ACTIONS(2903),
    [sym_identifier] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_macro_rules_BANG] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_u8] = ACTIONS(2905),
    [anon_sym_i8] = ACTIONS(2905),
    [anon_sym_u16] = ACTIONS(2905),
    [anon_sym_i16] = ACTIONS(2905),
    [anon_sym_u32] = ACTIONS(2905),
    [anon_sym_i32] = ACTIONS(2905),
    [anon_sym_u64] = ACTIONS(2905),
    [anon_sym_i64] = ACTIONS(2905),
    [anon_sym_u128] = ACTIONS(2905),
    [anon_sym_i128] = ACTIONS(2905),
    [anon_sym_isize] = ACTIONS(2905),
    [anon_sym_usize] = ACTIONS(2905),
    [anon_sym_f32] = ACTIONS(2905),
    [anon_sym_f64] = ACTIONS(2905),
    [anon_sym_bool] = ACTIONS(2905),
    [anon_sym_str] = ACTIONS(2905),
    [anon_sym_char] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_PIPE] = ACTIONS(2903),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_POUND] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2905),
    [anon_sym_async] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_default] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [anon_sym_fn] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_impl] = ACTIONS(2905),
    [anon_sym_let] = ACTIONS(2905),
    [anon_sym_loop] = ACTIONS(2905),
    [anon_sym_match] = ACTIONS(2905),
    [anon_sym_mod] = ACTIONS(2905),
    [anon_sym_pub] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_struct] = ACTIONS(2905),
    [anon_sym_trait] = ACTIONS(2905),
    [anon_sym_type] = ACTIONS(2905),
    [anon_sym_union] = ACTIONS(2905),
    [anon_sym_unsafe] = ACTIONS(2905),
    [anon_sym_use] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_extern] = ACTIONS(2905),
    [anon_sym_yield] = ACTIONS(2905),
    [anon_sym_move] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [sym_integer_literal] = ACTIONS(2903),
    [aux_sym_string_literal_token1] = ACTIONS(2903),
    [sym_char_literal] = ACTIONS(2903),
    [anon_sym_true] = ACTIONS(2905),
    [anon_sym_false] = ACTIONS(2905),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2905),
    [sym_super] = ACTIONS(2905),
    [sym_crate] = ACTIONS(2905),
    [sym_metavariable] = ACTIONS(2903),
    [sym__raw_string_literal_start] = ACTIONS(2903),
    [sym_float_literal] = ACTIONS(2903),
  },
  [751] = {
    [sym_line_comment] = STATE(751),
    [sym_block_comment] = STATE(751),
    [ts_builtin_sym_end] = ACTIONS(2907),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_macro_rules_BANG] = ACTIONS(2907),
    [anon_sym_LPAREN] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_STAR] = ACTIONS(2907),
    [anon_sym_u8] = ACTIONS(2909),
    [anon_sym_i8] = ACTIONS(2909),
    [anon_sym_u16] = ACTIONS(2909),
    [anon_sym_i16] = ACTIONS(2909),
    [anon_sym_u32] = ACTIONS(2909),
    [anon_sym_i32] = ACTIONS(2909),
    [anon_sym_u64] = ACTIONS(2909),
    [anon_sym_i64] = ACTIONS(2909),
    [anon_sym_u128] = ACTIONS(2909),
    [anon_sym_i128] = ACTIONS(2909),
    [anon_sym_isize] = ACTIONS(2909),
    [anon_sym_usize] = ACTIONS(2909),
    [anon_sym_f32] = ACTIONS(2909),
    [anon_sym_f64] = ACTIONS(2909),
    [anon_sym_bool] = ACTIONS(2909),
    [anon_sym_str] = ACTIONS(2909),
    [anon_sym_char] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2907),
    [anon_sym_BANG] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_LT] = ACTIONS(2907),
    [anon_sym_DOT_DOT] = ACTIONS(2907),
    [anon_sym_COLON_COLON] = ACTIONS(2907),
    [anon_sym_POUND] = ACTIONS(2907),
    [anon_sym_SQUOTE] = ACTIONS(2909),
    [anon_sym_async] = ACTIONS(2909),
    [anon_sym_break] = ACTIONS(2909),
    [anon_sym_const] = ACTIONS(2909),
    [anon_sym_continue] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2909),
    [anon_sym_enum] = ACTIONS(2909),
    [anon_sym_fn] = ACTIONS(2909),
    [anon_sym_for] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2909),
    [anon_sym_impl] = ACTIONS(2909),
    [anon_sym_let] = ACTIONS(2909),
    [anon_sym_loop] = ACTIONS(2909),
    [anon_sym_match] = ACTIONS(2909),
    [anon_sym_mod] = ACTIONS(2909),
    [anon_sym_pub] = ACTIONS(2909),
    [anon_sym_return] = ACTIONS(2909),
    [anon_sym_static] = ACTIONS(2909),
    [anon_sym_struct] = ACTIONS(2909),
    [anon_sym_trait] = ACTIONS(2909),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_union] = ACTIONS(2909),
    [anon_sym_unsafe] = ACTIONS(2909),
    [anon_sym_use] = ACTIONS(2909),
    [anon_sym_while] = ACTIONS(2909),
    [anon_sym_extern] = ACTIONS(2909),
    [anon_sym_yield] = ACTIONS(2909),
    [anon_sym_move] = ACTIONS(2909),
    [anon_sym_try] = ACTIONS(2909),
    [sym_integer_literal] = ACTIONS(2907),
    [aux_sym_string_literal_token1] = ACTIONS(2907),
    [sym_char_literal] = ACTIONS(2907),
    [anon_sym_true] = ACTIONS(2909),
    [anon_sym_false] = ACTIONS(2909),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2909),
    [sym_super] = ACTIONS(2909),
    [sym_crate] = ACTIONS(2909),
    [sym_metavariable] = ACTIONS(2907),
    [sym__raw_string_literal_start] = ACTIONS(2907),
    [sym_float_literal] = ACTIONS(2907),
  },
  [752] = {
    [sym_line_comment] = STATE(752),
    [sym_block_comment] = STATE(752),
    [ts_builtin_sym_end] = ACTIONS(2911),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_macro_rules_BANG] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(2911),
    [anon_sym_u8] = ACTIONS(2913),
    [anon_sym_i8] = ACTIONS(2913),
    [anon_sym_u16] = ACTIONS(2913),
    [anon_sym_i16] = ACTIONS(2913),
    [anon_sym_u32] = ACTIONS(2913),
    [anon_sym_i32] = ACTIONS(2913),
    [anon_sym_u64] = ACTIONS(2913),
    [anon_sym_i64] = ACTIONS(2913),
    [anon_sym_u128] = ACTIONS(2913),
    [anon_sym_i128] = ACTIONS(2913),
    [anon_sym_isize] = ACTIONS(2913),
    [anon_sym_usize] = ACTIONS(2913),
    [anon_sym_f32] = ACTIONS(2913),
    [anon_sym_f64] = ACTIONS(2913),
    [anon_sym_bool] = ACTIONS(2913),
    [anon_sym_str] = ACTIONS(2913),
    [anon_sym_char] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_BANG] = ACTIONS(2911),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2911),
    [anon_sym_LT] = ACTIONS(2911),
    [anon_sym_DOT_DOT] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2911),
    [anon_sym_POUND] = ACTIONS(2911),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [anon_sym_async] = ACTIONS(2913),
    [anon_sym_break] = ACTIONS(2913),
    [anon_sym_const] = ACTIONS(2913),
    [anon_sym_continue] = ACTIONS(2913),
    [anon_sym_default] = ACTIONS(2913),
    [anon_sym_enum] = ACTIONS(2913),
    [anon_sym_fn] = ACTIONS(2913),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2913),
    [anon_sym_impl] = ACTIONS(2913),
    [anon_sym_let] = ACTIONS(2913),
    [anon_sym_loop] = ACTIONS(2913),
    [anon_sym_match] = ACTIONS(2913),
    [anon_sym_mod] = ACTIONS(2913),
    [anon_sym_pub] = ACTIONS(2913),
    [anon_sym_return] = ACTIONS(2913),
    [anon_sym_static] = ACTIONS(2913),
    [anon_sym_struct] = ACTIONS(2913),
    [anon_sym_trait] = ACTIONS(2913),
    [anon_sym_type] = ACTIONS(2913),
    [anon_sym_union] = ACTIONS(2913),
    [anon_sym_unsafe] = ACTIONS(2913),
    [anon_sym_use] = ACTIONS(2913),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_extern] = ACTIONS(2913),
    [anon_sym_yield] = ACTIONS(2913),
    [anon_sym_move] = ACTIONS(2913),
    [anon_sym_try] = ACTIONS(2913),
    [sym_integer_literal] = ACTIONS(2911),
    [aux_sym_string_literal_token1] = ACTIONS(2911),
    [sym_char_literal] = ACTIONS(2911),
    [anon_sym_true] = ACTIONS(2913),
    [anon_sym_false] = ACTIONS(2913),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2913),
    [sym_super] = ACTIONS(2913),
    [sym_crate] = ACTIONS(2913),
    [sym_metavariable] = ACTIONS(2911),
    [sym__raw_string_literal_start] = ACTIONS(2911),
    [sym_float_literal] = ACTIONS(2911),
  },
  [753] = {
    [sym_line_comment] = STATE(753),
    [sym_block_comment] = STATE(753),
    [ts_builtin_sym_end] = ACTIONS(2915),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_macro_rules_BANG] = ACTIONS(2915),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2915),
    [anon_sym_u8] = ACTIONS(2917),
    [anon_sym_i8] = ACTIONS(2917),
    [anon_sym_u16] = ACTIONS(2917),
    [anon_sym_i16] = ACTIONS(2917),
    [anon_sym_u32] = ACTIONS(2917),
    [anon_sym_i32] = ACTIONS(2917),
    [anon_sym_u64] = ACTIONS(2917),
    [anon_sym_i64] = ACTIONS(2917),
    [anon_sym_u128] = ACTIONS(2917),
    [anon_sym_i128] = ACTIONS(2917),
    [anon_sym_isize] = ACTIONS(2917),
    [anon_sym_usize] = ACTIONS(2917),
    [anon_sym_f32] = ACTIONS(2917),
    [anon_sym_f64] = ACTIONS(2917),
    [anon_sym_bool] = ACTIONS(2917),
    [anon_sym_str] = ACTIONS(2917),
    [anon_sym_char] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_BANG] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_DOT_DOT] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_POUND] = ACTIONS(2915),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_async] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2917),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_continue] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2917),
    [anon_sym_enum] = ACTIONS(2917),
    [anon_sym_fn] = ACTIONS(2917),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2917),
    [anon_sym_impl] = ACTIONS(2917),
    [anon_sym_let] = ACTIONS(2917),
    [anon_sym_loop] = ACTIONS(2917),
    [anon_sym_match] = ACTIONS(2917),
    [anon_sym_mod] = ACTIONS(2917),
    [anon_sym_pub] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2917),
    [anon_sym_static] = ACTIONS(2917),
    [anon_sym_struct] = ACTIONS(2917),
    [anon_sym_trait] = ACTIONS(2917),
    [anon_sym_type] = ACTIONS(2917),
    [anon_sym_union] = ACTIONS(2917),
    [anon_sym_unsafe] = ACTIONS(2917),
    [anon_sym_use] = ACTIONS(2917),
    [anon_sym_while] = ACTIONS(2917),
    [anon_sym_extern] = ACTIONS(2917),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_move] = ACTIONS(2917),
    [anon_sym_try] = ACTIONS(2917),
    [sym_integer_literal] = ACTIONS(2915),
    [aux_sym_string_literal_token1] = ACTIONS(2915),
    [sym_char_literal] = ACTIONS(2915),
    [anon_sym_true] = ACTIONS(2917),
    [anon_sym_false] = ACTIONS(2917),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2917),
    [sym_super] = ACTIONS(2917),
    [sym_crate] = ACTIONS(2917),
    [sym_metavariable] = ACTIONS(2915),
    [sym__raw_string_literal_start] = ACTIONS(2915),
    [sym_float_literal] = ACTIONS(2915),
  },
  [754] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym_closure_expression] = STATE(2797),
    [sym_closure_parameters] = STATE(240),
    [sym__pattern] = STATE(2679),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(754),
    [sym_block_comment] = STATE(754),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2931),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [755] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym_closure_expression] = STATE(2897),
    [sym_closure_parameters] = STATE(240),
    [sym__pattern] = STATE(2684),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(755),
    [sym_block_comment] = STATE(755),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [756] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym_closure_expression] = STATE(3098),
    [sym_closure_parameters] = STATE(240),
    [sym__pattern] = STATE(2998),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(756),
    [sym_block_comment] = STATE(756),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [757] = {
    [sym_attribute_item] = STATE(1478),
    [sym_inner_attribute_item] = STATE(1478),
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_match_pattern] = STATE(3442),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2974),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(757),
    [sym_block_comment] = STATE(757),
    [aux_sym_match_arm_repeat1] = STATE(1042),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [758] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym_closure_expression] = STATE(3098),
    [sym_closure_parameters] = STATE(240),
    [sym__pattern] = STATE(2998),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(758),
    [sym_block_comment] = STATE(758),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [759] = {
    [sym_attribute_item] = STATE(1478),
    [sym_inner_attribute_item] = STATE(1478),
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_match_pattern] = STATE(3403),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2974),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(759),
    [sym_block_comment] = STATE(759),
    [aux_sym_match_arm_repeat1] = STATE(1042),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [760] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym_closure_expression] = STATE(3098),
    [sym_closure_parameters] = STATE(240),
    [sym__pattern] = STATE(2998),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(760),
    [sym_block_comment] = STATE(760),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [761] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym_closure_expression] = STATE(3098),
    [sym_closure_parameters] = STATE(240),
    [sym__pattern] = STATE(2998),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(761),
    [sym_block_comment] = STATE(761),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [762] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym_closure_expression] = STATE(3098),
    [sym_closure_parameters] = STATE(240),
    [sym__pattern] = STATE(2998),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(762),
    [sym_block_comment] = STATE(762),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [763] = {
    [sym_attribute_item] = STATE(1481),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_const_parameter] = STATE(2973),
    [sym_constrained_type_parameter] = STATE(2555),
    [sym_optional_type_parameter] = STATE(2973),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2823),
    [sym_bracketed_type] = STATE(3331),
    [sym_qualified_type] = STATE(3424),
    [sym_lifetime] = STATE(2345),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(763),
    [sym_block_comment] = STATE(763),
    [aux_sym_enum_variant_list_repeat1] = STATE(2073),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(2959),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(2961),
  },
  [764] = {
    [sym_attribute_item] = STATE(1481),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym_visibility_modifier] = STATE(979),
    [sym__type] = STATE(2536),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(764),
    [sym_block_comment] = STATE(764),
    [aux_sym_enum_variant_list_repeat1] = STATE(774),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2965),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_pub] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2973),
    [sym_metavariable] = ACTIONS(1584),
  },
  [765] = {
    [sym_attribute_item] = STATE(1481),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym_visibility_modifier] = STATE(934),
    [sym__type] = STATE(2854),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(765),
    [sym_block_comment] = STATE(765),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_pub] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2973),
    [sym_metavariable] = ACTIONS(1584),
  },
  [766] = {
    [sym_attribute_item] = STATE(1481),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym_visibility_modifier] = STATE(934),
    [sym__type] = STATE(2854),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(766),
    [sym_block_comment] = STATE(766),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_pub] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2973),
    [sym_metavariable] = ACTIONS(1584),
  },
  [767] = {
    [sym_attribute_item] = STATE(1481),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym_visibility_modifier] = STATE(934),
    [sym__type] = STATE(2854),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(767),
    [sym_block_comment] = STATE(767),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_pub] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2973),
    [sym_metavariable] = ACTIONS(1584),
  },
  [768] = {
    [sym_attribute_item] = STATE(1481),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym_visibility_modifier] = STATE(934),
    [sym__type] = STATE(2854),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(768),
    [sym_block_comment] = STATE(768),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_pub] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2973),
    [sym_metavariable] = ACTIONS(1584),
  },
  [769] = {
    [sym_attribute_item] = STATE(1481),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym_visibility_modifier] = STATE(934),
    [sym__type] = STATE(2854),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(769),
    [sym_block_comment] = STATE(769),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_pub] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2973),
    [sym_metavariable] = ACTIONS(1584),
  },
  [770] = {
    [sym_attribute_item] = STATE(1481),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym_visibility_modifier] = STATE(934),
    [sym__type] = STATE(2854),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(770),
    [sym_block_comment] = STATE(770),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_pub] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2973),
    [sym_metavariable] = ACTIONS(1584),
  },
  [771] = {
    [sym_attribute_item] = STATE(1481),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym_visibility_modifier] = STATE(968),
    [sym__type] = STATE(2834),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(771),
    [sym_block_comment] = STATE(771),
    [aux_sym_enum_variant_list_repeat1] = STATE(1069),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_pub] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2973),
    [sym_metavariable] = ACTIONS(1584),
  },
  [772] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2678),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(772),
    [sym_block_comment] = STATE(772),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [773] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2713),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(773),
    [sym_block_comment] = STATE(773),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2989),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [774] = {
    [sym_attribute_item] = STATE(1481),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym_visibility_modifier] = STATE(976),
    [sym__type] = STATE(2589),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(774),
    [sym_block_comment] = STATE(774),
    [aux_sym_enum_variant_list_repeat1] = STATE(1069),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_pub] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2973),
    [sym_metavariable] = ACTIONS(1584),
  },
  [775] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2681),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(775),
    [sym_block_comment] = STATE(775),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(2991),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [776] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2693),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(776),
    [sym_block_comment] = STATE(776),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2995),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2997),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [777] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2689),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(777),
    [sym_block_comment] = STATE(777),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(3001),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [778] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2683),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(778),
    [sym_block_comment] = STATE(778),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [779] = {
    [sym_attribute_item] = STATE(1481),
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym_visibility_modifier] = STATE(934),
    [sym__type] = STATE(2854),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(779),
    [sym_block_comment] = STATE(779),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_pub] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2973),
    [sym_metavariable] = ACTIONS(1584),
  },
  [780] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(780),
    [sym_block_comment] = STATE(780),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(3007),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [781] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(781),
    [sym_block_comment] = STATE(781),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [782] = {
    [sym_parameter] = STATE(2803),
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2461),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(782),
    [sym_block_comment] = STATE(782),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(3011),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(3013),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3015),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [783] = {
    [sym_parameter] = STATE(2803),
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2556),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(783),
    [sym_block_comment] = STATE(783),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(3011),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(3013),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3015),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [784] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(784),
    [sym_block_comment] = STATE(784),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(3017),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [785] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(785),
    [sym_block_comment] = STATE(785),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [786] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(786),
    [sym_block_comment] = STATE(786),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [787] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(787),
    [sym_block_comment] = STATE(787),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [788] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(788),
    [sym_block_comment] = STATE(788),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(3025),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [789] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(789),
    [sym_block_comment] = STATE(789),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [790] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(790),
    [sym_block_comment] = STATE(790),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3029),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [791] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(791),
    [sym_block_comment] = STATE(791),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [792] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(792),
    [sym_block_comment] = STATE(792),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(3033),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [793] = {
    [sym_parameter] = STATE(3115),
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2776),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(793),
    [sym_block_comment] = STATE(793),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(3013),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3015),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [794] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2560),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(794),
    [sym_block_comment] = STATE(794),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3037),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [795] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(795),
    [sym_block_comment] = STATE(795),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_RBRACK] = ACTIONS(3039),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [796] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2086),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(796),
    [sym_block_comment] = STATE(796),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [797] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2492),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(797),
    [sym_block_comment] = STATE(797),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [798] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2428),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(798),
    [sym_block_comment] = STATE(798),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(3041),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [799] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2843),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(799),
    [sym_block_comment] = STATE(799),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [800] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3048),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(800),
    [sym_block_comment] = STATE(800),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [801] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3053),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(801),
    [sym_block_comment] = STATE(801),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [802] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2110),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(802),
    [sym_block_comment] = STATE(802),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [803] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2088),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(803),
    [sym_block_comment] = STATE(803),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(3043),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [804] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3055),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(804),
    [sym_block_comment] = STATE(804),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [805] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3080),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(805),
    [sym_block_comment] = STATE(805),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [806] = {
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2779),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(806),
    [sym_block_comment] = STATE(806),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [807] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2538),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(807),
    [sym_block_comment] = STATE(807),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [808] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2109),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(808),
    [sym_block_comment] = STATE(808),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [809] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2820),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(809),
    [sym_block_comment] = STATE(809),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [810] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2673),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(810),
    [sym_block_comment] = STATE(810),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3045),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [811] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3069),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(811),
    [sym_block_comment] = STATE(811),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [812] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2104),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(812),
    [sym_block_comment] = STATE(812),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [813] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3047),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(813),
    [sym_block_comment] = STATE(813),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [814] = {
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2785),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(814),
    [sym_block_comment] = STATE(814),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [815] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3197),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(815),
    [sym_block_comment] = STATE(815),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [816] = {
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2766),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(816),
    [sym_block_comment] = STATE(816),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [817] = {
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2762),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(817),
    [sym_block_comment] = STATE(817),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [818] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2447),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(818),
    [sym_block_comment] = STATE(818),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [819] = {
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2758),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(819),
    [sym_block_comment] = STATE(819),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [820] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2121),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(820),
    [sym_block_comment] = STATE(820),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [821] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3073),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(821),
    [sym_block_comment] = STATE(821),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [822] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2445),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(822),
    [sym_block_comment] = STATE(822),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(3047),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [823] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2884),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(823),
    [sym_block_comment] = STATE(823),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [824] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3104),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(824),
    [sym_block_comment] = STATE(824),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [825] = {
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2789),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(825),
    [sym_block_comment] = STATE(825),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(3049),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [826] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(2090),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(826),
    [sym_block_comment] = STATE(826),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [827] = {
    [sym_bracketed_type] = STATE(3529),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3133),
    [sym_macro_invocation] = STATE(2796),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(2859),
    [sym_const_block] = STATE(2796),
    [sym__pattern] = STATE(2839),
    [sym_tuple_pattern] = STATE(2796),
    [sym_slice_pattern] = STATE(2796),
    [sym_tuple_struct_pattern] = STATE(2796),
    [sym_struct_pattern] = STATE(2796),
    [sym_remaining_field_pattern] = STATE(2796),
    [sym_mut_pattern] = STATE(2796),
    [sym_range_pattern] = STATE(2796),
    [sym_ref_pattern] = STATE(2796),
    [sym_captured_pattern] = STATE(2796),
    [sym_reference_pattern] = STATE(2796),
    [sym_or_pattern] = STATE(2796),
    [sym__literal_pattern] = STATE(2362),
    [sym_negative_literal] = STATE(2309),
    [sym_string_literal] = STATE(2309),
    [sym_raw_string_literal] = STATE(2309),
    [sym_boolean_literal] = STATE(2309),
    [sym_line_comment] = STATE(827),
    [sym_block_comment] = STATE(827),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_u8] = ACTIONS(1612),
    [anon_sym_i8] = ACTIONS(1612),
    [anon_sym_u16] = ACTIONS(1612),
    [anon_sym_i16] = ACTIONS(1612),
    [anon_sym_u32] = ACTIONS(1612),
    [anon_sym_i32] = ACTIONS(1612),
    [anon_sym_u64] = ACTIONS(1612),
    [anon_sym_i64] = ACTIONS(1612),
    [anon_sym_u128] = ACTIONS(1612),
    [anon_sym_i128] = ACTIONS(1612),
    [anon_sym_isize] = ACTIONS(1612),
    [anon_sym_usize] = ACTIONS(1612),
    [anon_sym_f32] = ACTIONS(1612),
    [anon_sym_f64] = ACTIONS(1612),
    [anon_sym_bool] = ACTIONS(1612),
    [anon_sym_str] = ACTIONS(1612),
    [anon_sym_char] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_DOT_DOT] = ACTIONS(1622),
    [anon_sym_COLON_COLON] = ACTIONS(1624),
    [anon_sym_const] = ACTIONS(1628),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_union] = ACTIONS(1630),
    [anon_sym_ref] = ACTIONS(1632),
    [sym_mutable_specifier] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_string_literal_token1] = ACTIONS(1638),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(1640),
    [anon_sym_false] = ACTIONS(1640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_crate] = ACTIONS(1642),
    [sym_metavariable] = ACTIONS(1644),
    [sym__raw_string_literal_start] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1636),
  },
  [828] = {
    [sym_bracketed_type] = STATE(3450),
    [sym_generic_type] = STATE(3448),
    [sym_generic_type_with_turbofish] = STATE(3252),
    [sym_macro_invocation] = STATE(2116),
    [sym_scoped_identifier] = STATE(1964),
    [sym_scoped_type_identifier] = STATE(2809),
    [sym_const_block] = STATE(2116),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2116),
    [sym_slice_pattern] = STATE(2116),
    [sym_tuple_struct_pattern] = STATE(2116),
    [sym_struct_pattern] = STATE(2116),
    [sym_remaining_field_pattern] = STATE(2116),
    [sym_mut_pattern] = STATE(2116),
    [sym_range_pattern] = STATE(2116),
    [sym_ref_pattern] = STATE(2116),
    [sym_captured_pattern] = STATE(2116),
    [sym_reference_pattern] = STATE(2116),
    [sym_or_pattern] = STATE(2116),
    [sym__literal_pattern] = STATE(2007),
    [sym_negative_literal] = STATE(2017),
    [sym_string_literal] = STATE(2017),
    [sym_raw_string_literal] = STATE(2017),
    [sym_boolean_literal] = STATE(2017),
    [sym_line_comment] = STATE(828),
    [sym_block_comment] = STATE(828),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_u8] = ACTIONS(2927),
    [anon_sym_i8] = ACTIONS(2927),
    [anon_sym_u16] = ACTIONS(2927),
    [anon_sym_i16] = ACTIONS(2927),
    [anon_sym_u32] = ACTIONS(2927),
    [anon_sym_i32] = ACTIONS(2927),
    [anon_sym_u64] = ACTIONS(2927),
    [anon_sym_i64] = ACTIONS(2927),
    [anon_sym_u128] = ACTIONS(2927),
    [anon_sym_i128] = ACTIONS(2927),
    [anon_sym_isize] = ACTIONS(2927),
    [anon_sym_usize] = ACTIONS(2927),
    [anon_sym_f32] = ACTIONS(2927),
    [anon_sym_f64] = ACTIONS(2927),
    [anon_sym_bool] = ACTIONS(2927),
    [anon_sym_str] = ACTIONS(2927),
    [anon_sym_char] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(1304),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1310),
    [aux_sym_string_literal_token1] = ACTIONS(1312),
    [sym_char_literal] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1314),
    [anon_sym_false] = ACTIONS(1314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_crate] = ACTIONS(2939),
    [sym_metavariable] = ACTIONS(2941),
    [sym__raw_string_literal_start] = ACTIONS(1322),
    [sym_float_literal] = ACTIONS(1310),
  },
  [829] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1254),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(829),
    [sym_block_comment] = STATE(829),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [sym_mutable_specifier] = ACTIONS(3081),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [830] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(830),
    [sym_block_comment] = STATE(830),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(3089),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3091),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [831] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1745),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(831),
    [sym_block_comment] = STATE(831),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [sym_mutable_specifier] = ACTIONS(3123),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [832] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(3169),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(832),
    [sym_block_comment] = STATE(832),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(3129),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [833] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(833),
    [sym_block_comment] = STATE(833),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(3131),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [834] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_type_parameters] = STATE(936),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2303),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(2297),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(2173),
    [sym_line_comment] = STATE(834),
    [sym_block_comment] = STATE(834),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [835] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2982),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(835),
    [sym_block_comment] = STATE(835),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [836] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2982),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(836),
    [sym_block_comment] = STATE(836),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3141),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [837] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_higher_ranked_trait_bound] = STATE(2219),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2225),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2227),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(837),
    [sym_block_comment] = STATE(837),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(3143),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [838] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_type_parameters] = STATE(945),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2311),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(2319),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(2155),
    [sym_line_comment] = STATE(838),
    [sym_block_comment] = STATE(838),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3145),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3147),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [839] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2982),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(839),
    [sym_block_comment] = STATE(839),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3149),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [840] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_type_parameters] = STATE(890),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2352),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(2339),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(2149),
    [sym_line_comment] = STATE(840),
    [sym_block_comment] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3153),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [841] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_higher_ranked_trait_bound] = STATE(2219),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2221),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2223),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(841),
    [sym_block_comment] = STATE(841),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(3143),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [842] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2637),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(842),
    [sym_block_comment] = STATE(842),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3155),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [843] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1323),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(829),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(843),
    [sym_block_comment] = STATE(843),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [sym_mutable_specifier] = ACTIONS(3157),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [844] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2594),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(844),
    [sym_block_comment] = STATE(844),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3159),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [845] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_higher_ranked_trait_bound] = STATE(2219),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2225),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2223),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(845),
    [sym_block_comment] = STATE(845),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(3143),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [846] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2982),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(846),
    [sym_block_comment] = STATE(846),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3161),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [847] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2982),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(847),
    [sym_block_comment] = STATE(847),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3163),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [848] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(833),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(848),
    [sym_block_comment] = STATE(848),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(3165),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [849] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1659),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(831),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(849),
    [sym_block_comment] = STATE(849),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [sym_mutable_specifier] = ACTIONS(3167),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [850] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2823),
    [sym_bracketed_type] = STATE(3331),
    [sym_qualified_type] = STATE(3424),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(850),
    [sym_block_comment] = STATE(850),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [851] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2542),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(851),
    [sym_block_comment] = STATE(851),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3169),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [852] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2541),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(852),
    [sym_block_comment] = STATE(852),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3171),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [853] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(3247),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(832),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(853),
    [sym_block_comment] = STATE(853),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [sym_mutable_specifier] = ACTIONS(3173),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [854] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_higher_ranked_trait_bound] = STATE(2166),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2168),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(2169),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(854),
    [sym_block_comment] = STATE(854),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(3143),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [855] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_type_parameters] = STATE(932),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2293),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(2317),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(2158),
    [sym_line_comment] = STATE(855),
    [sym_block_comment] = STATE(855),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3175),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3177),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [856] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2982),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(856),
    [sym_block_comment] = STATE(856),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [857] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2692),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(857),
    [sym_block_comment] = STATE(857),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3181),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [858] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(3022),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(858),
    [sym_block_comment] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [859] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(3141),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(859),
    [sym_block_comment] = STATE(859),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [860] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2189),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(860),
    [sym_block_comment] = STATE(860),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [861] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2948),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(861),
    [sym_block_comment] = STATE(861),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [862] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2429),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(862),
    [sym_block_comment] = STATE(862),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [863] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2332),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(863),
    [sym_block_comment] = STATE(863),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [864] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2989),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(864),
    [sym_block_comment] = STATE(864),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [865] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2329),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(865),
    [sym_block_comment] = STATE(865),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [866] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1986),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(866),
    [sym_block_comment] = STATE(866),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [867] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2832),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(867),
    [sym_block_comment] = STATE(867),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [868] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2651),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(868),
    [sym_block_comment] = STATE(868),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [869] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2348),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(869),
    [sym_block_comment] = STATE(869),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [870] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2960),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(870),
    [sym_block_comment] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [871] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2378),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(871),
    [sym_block_comment] = STATE(871),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [872] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2572),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(872),
    [sym_block_comment] = STATE(872),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [873] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2374),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(873),
    [sym_block_comment] = STATE(873),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [874] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2328),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(874),
    [sym_block_comment] = STATE(874),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [875] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1662),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(875),
    [sym_block_comment] = STATE(875),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [876] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2346),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(876),
    [sym_block_comment] = STATE(876),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [877] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2800),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(877),
    [sym_block_comment] = STATE(877),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [878] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2933),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(878),
    [sym_block_comment] = STATE(878),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [879] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2229),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(879),
    [sym_block_comment] = STATE(879),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [880] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2909),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(880),
    [sym_block_comment] = STATE(880),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [881] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2991),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(881),
    [sym_block_comment] = STATE(881),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [882] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1993),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(882),
    [sym_block_comment] = STATE(882),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [883] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2487),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(883),
    [sym_block_comment] = STATE(883),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [884] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2451),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(884),
    [sym_block_comment] = STATE(884),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [885] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2372),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(885),
    [sym_block_comment] = STATE(885),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [886] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2920),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(886),
    [sym_block_comment] = STATE(886),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [887] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2230),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(887),
    [sym_block_comment] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [888] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2327),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(888),
    [sym_block_comment] = STATE(888),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [889] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2326),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(889),
    [sym_block_comment] = STATE(889),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [890] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2302),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(2325),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(2154),
    [sym_line_comment] = STATE(890),
    [sym_block_comment] = STATE(890),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [891] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2782),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(891),
    [sym_block_comment] = STATE(891),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [892] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2907),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(892),
    [sym_block_comment] = STATE(892),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [893] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1803),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(893),
    [sym_block_comment] = STATE(893),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [894] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1779),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(894),
    [sym_block_comment] = STATE(894),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [895] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2404),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(895),
    [sym_block_comment] = STATE(895),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [896] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1965),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(896),
    [sym_block_comment] = STATE(896),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [897] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1991),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(897),
    [sym_block_comment] = STATE(897),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [898] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1979),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(898),
    [sym_block_comment] = STATE(898),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [899] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1985),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(899),
    [sym_block_comment] = STATE(899),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [900] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2528),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(900),
    [sym_block_comment] = STATE(900),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [901] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2669),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(901),
    [sym_block_comment] = STATE(901),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [902] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1324),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(902),
    [sym_block_comment] = STATE(902),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [903] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2387),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(903),
    [sym_block_comment] = STATE(903),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [904] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1709),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(904),
    [sym_block_comment] = STATE(904),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [905] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2217),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(905),
    [sym_block_comment] = STATE(905),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [906] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1415),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(906),
    [sym_block_comment] = STATE(906),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [907] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2424),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(907),
    [sym_block_comment] = STATE(907),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [908] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2384),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(908),
    [sym_block_comment] = STATE(908),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [909] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2383),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(909),
    [sym_block_comment] = STATE(909),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [910] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2291),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(910),
    [sym_block_comment] = STATE(910),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [911] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2379),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(911),
    [sym_block_comment] = STATE(911),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [912] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1983),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(912),
    [sym_block_comment] = STATE(912),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [913] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1790),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(913),
    [sym_block_comment] = STATE(913),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [914] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2869),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(914),
    [sym_block_comment] = STATE(914),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [915] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(3170),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(915),
    [sym_block_comment] = STATE(915),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [916] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2296),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(916),
    [sym_block_comment] = STATE(916),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [917] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1809),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(917),
    [sym_block_comment] = STATE(917),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [918] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2181),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(918),
    [sym_block_comment] = STATE(918),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [919] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2586),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(919),
    [sym_block_comment] = STATE(919),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [920] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(3169),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(920),
    [sym_block_comment] = STATE(920),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [921] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2375),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(921),
    [sym_block_comment] = STATE(921),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [922] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2182),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(922),
    [sym_block_comment] = STATE(922),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [923] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2692),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(923),
    [sym_block_comment] = STATE(923),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [924] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2924),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(924),
    [sym_block_comment] = STATE(924),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [925] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2176),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(925),
    [sym_block_comment] = STATE(925),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [926] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2610),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(926),
    [sym_block_comment] = STATE(926),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [927] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2995),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(927),
    [sym_block_comment] = STATE(927),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [928] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2638),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(928),
    [sym_block_comment] = STATE(928),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [929] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1255),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(929),
    [sym_block_comment] = STATE(929),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [930] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1981),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(1996),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(930),
    [sym_block_comment] = STATE(930),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [931] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1254),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(931),
    [sym_block_comment] = STATE(931),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [932] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2355),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(2310),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(2162),
    [sym_line_comment] = STATE(932),
    [sym_block_comment] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3189),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [933] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2521),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(933),
    [sym_block_comment] = STATE(933),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [934] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2834),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(934),
    [sym_block_comment] = STATE(934),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [935] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2553),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(935),
    [sym_block_comment] = STATE(935),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [936] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2318),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(2312),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(2175),
    [sym_line_comment] = STATE(936),
    [sym_block_comment] = STATE(936),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [937] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1742),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(937),
    [sym_block_comment] = STATE(937),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [938] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2542),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(938),
    [sym_block_comment] = STATE(938),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [939] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2370),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(939),
    [sym_block_comment] = STATE(939),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [940] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1987),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(940),
    [sym_block_comment] = STATE(940),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [941] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2541),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(941),
    [sym_block_comment] = STATE(941),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [942] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1244),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(942),
    [sym_block_comment] = STATE(942),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [943] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2801),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(943),
    [sym_block_comment] = STATE(943),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [944] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1983),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(944),
    [sym_block_comment] = STATE(944),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3195),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [945] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2344),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(2341),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(2147),
    [sym_line_comment] = STATE(945),
    [sym_block_comment] = STATE(945),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3197),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [946] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2198),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(946),
    [sym_block_comment] = STATE(946),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [947] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2386),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(947),
    [sym_block_comment] = STATE(947),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [948] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2290),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(948),
    [sym_block_comment] = STATE(948),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [949] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2304),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(949),
    [sym_block_comment] = STATE(949),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [950] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1970),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(950),
    [sym_block_comment] = STATE(950),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [951] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2301),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(951),
    [sym_block_comment] = STATE(951),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [952] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2334),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(952),
    [sym_block_comment] = STATE(952),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [953] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2550),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(953),
    [sym_block_comment] = STATE(953),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [954] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1967),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(954),
    [sym_block_comment] = STATE(954),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [955] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2299),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(955),
    [sym_block_comment] = STATE(955),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [956] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(3072),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(956),
    [sym_block_comment] = STATE(956),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [957] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2180),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(957),
    [sym_block_comment] = STATE(957),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [958] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1172),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(958),
    [sym_block_comment] = STATE(958),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [959] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2298),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(959),
    [sym_block_comment] = STATE(959),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [960] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2687),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(960),
    [sym_block_comment] = STATE(960),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [961] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1811),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(961),
    [sym_block_comment] = STATE(961),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [962] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2850),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(962),
    [sym_block_comment] = STATE(962),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [963] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1170),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(963),
    [sym_block_comment] = STATE(963),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [964] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1166),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(964),
    [sym_block_comment] = STATE(964),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [965] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2594),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(965),
    [sym_block_comment] = STATE(965),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [966] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1167),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(966),
    [sym_block_comment] = STATE(966),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [967] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1165),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(967),
    [sym_block_comment] = STATE(967),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [968] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2819),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(968),
    [sym_block_comment] = STATE(968),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [969] = {
    [sym_line_comment] = STATE(969),
    [sym_block_comment] = STATE(969),
    [sym_identifier] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2654),
    [anon_sym_LBRACK] = ACTIONS(2654),
    [anon_sym_RBRACK] = ACTIONS(2654),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_u8] = ACTIONS(2656),
    [anon_sym_i8] = ACTIONS(2656),
    [anon_sym_u16] = ACTIONS(2656),
    [anon_sym_i16] = ACTIONS(2656),
    [anon_sym_u32] = ACTIONS(2656),
    [anon_sym_i32] = ACTIONS(2656),
    [anon_sym_u64] = ACTIONS(2656),
    [anon_sym_i64] = ACTIONS(2656),
    [anon_sym_u128] = ACTIONS(2656),
    [anon_sym_i128] = ACTIONS(2656),
    [anon_sym_isize] = ACTIONS(2656),
    [anon_sym_usize] = ACTIONS(2656),
    [anon_sym_f32] = ACTIONS(2656),
    [anon_sym_f64] = ACTIONS(2656),
    [anon_sym_bool] = ACTIONS(2656),
    [anon_sym_str] = ACTIONS(2656),
    [anon_sym_char] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2654),
    [anon_sym_PIPE] = ACTIONS(2654),
    [anon_sym_LT] = ACTIONS(2654),
    [anon_sym__] = ACTIONS(2656),
    [anon_sym_DOT_DOT] = ACTIONS(2654),
    [anon_sym_COMMA] = ACTIONS(2654),
    [anon_sym_COLON_COLON] = ACTIONS(2654),
    [anon_sym_POUND] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2656),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_break] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_continue] = ACTIONS(2656),
    [anon_sym_default] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2656),
    [anon_sym_loop] = ACTIONS(2656),
    [anon_sym_match] = ACTIONS(2656),
    [anon_sym_return] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_union] = ACTIONS(2656),
    [anon_sym_unsafe] = ACTIONS(2656),
    [anon_sym_while] = ACTIONS(2656),
    [anon_sym_ref] = ACTIONS(2656),
    [sym_mutable_specifier] = ACTIONS(2656),
    [anon_sym_yield] = ACTIONS(2656),
    [anon_sym_move] = ACTIONS(2656),
    [anon_sym_try] = ACTIONS(2656),
    [sym_integer_literal] = ACTIONS(2654),
    [aux_sym_string_literal_token1] = ACTIONS(2654),
    [sym_char_literal] = ACTIONS(2654),
    [anon_sym_true] = ACTIONS(2656),
    [anon_sym_false] = ACTIONS(2656),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2656),
    [sym_super] = ACTIONS(2656),
    [sym_crate] = ACTIONS(2656),
    [sym_metavariable] = ACTIONS(2654),
    [sym__raw_string_literal_start] = ACTIONS(2654),
    [sym_float_literal] = ACTIONS(2654),
  },
  [970] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2337),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(970),
    [sym_block_comment] = STATE(970),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [971] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1409),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(971),
    [sym_block_comment] = STATE(971),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [972] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2584),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(972),
    [sym_block_comment] = STATE(972),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [973] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1981),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(973),
    [sym_block_comment] = STATE(973),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [974] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2195),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(974),
    [sym_block_comment] = STATE(974),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [975] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1995),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(975),
    [sym_block_comment] = STATE(975),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [976] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2641),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(976),
    [sym_block_comment] = STATE(976),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [977] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(977),
    [sym_block_comment] = STATE(977),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [978] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2982),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(978),
    [sym_block_comment] = STATE(978),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [979] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2589),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(979),
    [sym_block_comment] = STATE(979),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [980] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(3305),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(980),
    [sym_block_comment] = STATE(980),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [981] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1776),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(981),
    [sym_block_comment] = STATE(981),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [982] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2568),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(982),
    [sym_block_comment] = STATE(982),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [983] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1981),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(1996),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(983),
    [sym_block_comment] = STATE(983),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [984] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1745),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(984),
    [sym_block_comment] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [985] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2824),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(985),
    [sym_block_comment] = STATE(985),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [986] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2858),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(986),
    [sym_block_comment] = STATE(986),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [987] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2376),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(987),
    [sym_block_comment] = STATE(987),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [988] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1663),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(988),
    [sym_block_comment] = STATE(988),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [989] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2942),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(989),
    [sym_block_comment] = STATE(989),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [990] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2377),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(990),
    [sym_block_comment] = STATE(990),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [991] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1685),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(991),
    [sym_block_comment] = STATE(991),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [992] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2578),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(992),
    [sym_block_comment] = STATE(992),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [993] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2390),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(993),
    [sym_block_comment] = STATE(993),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [994] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2210),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(994),
    [sym_block_comment] = STATE(994),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [995] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1780),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(995),
    [sym_block_comment] = STATE(995),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [996] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2637),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(996),
    [sym_block_comment] = STATE(996),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [997] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1168),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(997),
    [sym_block_comment] = STATE(997),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [998] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1171),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(998),
    [sym_block_comment] = STATE(998),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [999] = {
    [sym_function_modifiers] = STATE(3337),
    [sym_removed_trait_bound] = STATE(1387),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1175),
    [sym_bracketed_type] = STATE(3520),
    [sym_lifetime] = STATE(3355),
    [sym_array_type] = STATE(1387),
    [sym_for_lifetimes] = STATE(1630),
    [sym_function_type] = STATE(1387),
    [sym_tuple_type] = STATE(1387),
    [sym_unit_type] = STATE(1387),
    [sym_generic_type] = STATE(1072),
    [sym_generic_type_with_turbofish] = STATE(3510),
    [sym_bounded_type] = STATE(1387),
    [sym_reference_type] = STATE(1387),
    [sym_pointer_type] = STATE(1387),
    [sym_never_type] = STATE(1387),
    [sym_abstract_type] = STATE(1387),
    [sym_dynamic_type] = STATE(1387),
    [sym_macro_invocation] = STATE(1387),
    [sym_scoped_identifier] = STATE(3266),
    [sym_scoped_type_identifier] = STATE(1030),
    [sym_line_comment] = STATE(999),
    [sym_block_comment] = STATE(999),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_u8] = ACTIONS(3063),
    [anon_sym_i8] = ACTIONS(3063),
    [anon_sym_u16] = ACTIONS(3063),
    [anon_sym_i16] = ACTIONS(3063),
    [anon_sym_u32] = ACTIONS(3063),
    [anon_sym_i32] = ACTIONS(3063),
    [anon_sym_u64] = ACTIONS(3063),
    [anon_sym_i64] = ACTIONS(3063),
    [anon_sym_u128] = ACTIONS(3063),
    [anon_sym_i128] = ACTIONS(3063),
    [anon_sym_isize] = ACTIONS(3063),
    [anon_sym_usize] = ACTIONS(3063),
    [anon_sym_f32] = ACTIONS(3063),
    [anon_sym_f64] = ACTIONS(3063),
    [anon_sym_bool] = ACTIONS(3063),
    [anon_sym_str] = ACTIONS(3063),
    [anon_sym_char] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_fn] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3077),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_crate] = ACTIONS(3083),
    [sym_metavariable] = ACTIONS(3085),
  },
  [1000] = {
    [sym_function_modifiers] = STATE(3432),
    [sym_removed_trait_bound] = STATE(1994),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(2205),
    [sym_bracketed_type] = STATE(3331),
    [sym_lifetime] = STATE(3423),
    [sym_array_type] = STATE(1994),
    [sym_for_lifetimes] = STATE(1624),
    [sym_function_type] = STATE(1994),
    [sym_tuple_type] = STATE(1994),
    [sym_unit_type] = STATE(1994),
    [sym_generic_type] = STATE(1949),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1994),
    [sym_reference_type] = STATE(1994),
    [sym_pointer_type] = STATE(1994),
    [sym_never_type] = STATE(1994),
    [sym_abstract_type] = STATE(1994),
    [sym_dynamic_type] = STATE(1994),
    [sym_macro_invocation] = STATE(1994),
    [sym_scoped_identifier] = STATE(3193),
    [sym_scoped_type_identifier] = STATE(1917),
    [sym_line_comment] = STATE(1000),
    [sym_block_comment] = STATE(1000),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_QMARK] = ACTIONS(1262),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(1306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [1001] = {
    [sym_function_modifiers] = STATE(3478),
    [sym_removed_trait_bound] = STATE(1831),
    [sym_extern_modifier] = STATE(2351),
    [sym__type] = STATE(1705),
    [sym_bracketed_type] = STATE(3535),
    [sym_lifetime] = STATE(3573),
    [sym_array_type] = STATE(1831),
    [sym_for_lifetimes] = STATE(1612),
    [sym_function_type] = STATE(1831),
    [sym_tuple_type] = STATE(1831),
    [sym_unit_type] = STATE(1831),
    [sym_generic_type] = STATE(1601),
    [sym_generic_type_with_turbofish] = STATE(3527),
    [sym_bounded_type] = STATE(1831),
    [sym_reference_type] = STATE(1831),
    [sym_pointer_type] = STATE(1831),
    [sym_never_type] = STATE(1831),
    [sym_abstract_type] = STATE(1831),
    [sym_dynamic_type] = STATE(1831),
    [sym_macro_invocation] = STATE(1831),
    [sym_scoped_identifier] = STATE(3131),
    [sym_scoped_type_identifier] = STATE(1527),
    [sym_line_comment] = STATE(1001),
    [sym_block_comment] = STATE(1001),
    [aux_sym_function_modifiers_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_u8] = ACTIONS(3105),
    [anon_sym_i8] = ACTIONS(3105),
    [anon_sym_u16] = ACTIONS(3105),
    [anon_sym_i16] = ACTIONS(3105),
    [anon_sym_u32] = ACTIONS(3105),
    [anon_sym_i32] = ACTIONS(3105),
    [anon_sym_u64] = ACTIONS(3105),
    [anon_sym_i64] = ACTIONS(3105),
    [anon_sym_u128] = ACTIONS(3105),
    [anon_sym_i128] = ACTIONS(3105),
    [anon_sym_isize] = ACTIONS(3105),
    [anon_sym_usize] = ACTIONS(3105),
    [anon_sym_f32] = ACTIONS(3105),
    [anon_sym_f64] = ACTIONS(3105),
    [anon_sym_bool] = ACTIONS(3105),
    [anon_sym_str] = ACTIONS(3105),
    [anon_sym_char] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_fn] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_impl] = ACTIONS(3117),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym_dyn] = ACTIONS(3121),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_crate] = ACTIONS(3125),
    [sym_metavariable] = ACTIONS(3127),
  },
  [1002] = {
    [sym_attribute_item] = STATE(1003),
    [sym_line_comment] = STATE(1002),
    [sym_block_comment] = STATE(1002),
    [aux_sym_enum_variant_list_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(3201),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_RBRACK] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_u8] = ACTIONS(3201),
    [anon_sym_i8] = ACTIONS(3201),
    [anon_sym_u16] = ACTIONS(3201),
    [anon_sym_i16] = ACTIONS(3201),
    [anon_sym_u32] = ACTIONS(3201),
    [anon_sym_i32] = ACTIONS(3201),
    [anon_sym_u64] = ACTIONS(3201),
    [anon_sym_i64] = ACTIONS(3201),
    [anon_sym_u128] = ACTIONS(3201),
    [anon_sym_i128] = ACTIONS(3201),
    [anon_sym_isize] = ACTIONS(3201),
    [anon_sym_usize] = ACTIONS(3201),
    [anon_sym_f32] = ACTIONS(3201),
    [anon_sym_f64] = ACTIONS(3201),
    [anon_sym_bool] = ACTIONS(3201),
    [anon_sym_str] = ACTIONS(3201),
    [anon_sym_char] = ACTIONS(3201),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_BANG] = ACTIONS(848),
    [anon_sym_AMP] = ACTIONS(848),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_LT] = ACTIONS(848),
    [anon_sym_DOT_DOT] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_COLON_COLON] = ACTIONS(848),
    [anon_sym_POUND] = ACTIONS(874),
    [anon_sym_SQUOTE] = ACTIONS(3201),
    [anon_sym_async] = ACTIONS(3201),
    [anon_sym_break] = ACTIONS(3201),
    [anon_sym_const] = ACTIONS(3201),
    [anon_sym_continue] = ACTIONS(3201),
    [anon_sym_default] = ACTIONS(3201),
    [anon_sym_for] = ACTIONS(3201),
    [anon_sym_if] = ACTIONS(3201),
    [anon_sym_loop] = ACTIONS(3201),
    [anon_sym_match] = ACTIONS(3201),
    [anon_sym_return] = ACTIONS(3201),
    [anon_sym_static] = ACTIONS(3201),
    [anon_sym_union] = ACTIONS(3201),
    [anon_sym_unsafe] = ACTIONS(3201),
    [anon_sym_while] = ACTIONS(3201),
    [anon_sym_yield] = ACTIONS(3201),
    [anon_sym_move] = ACTIONS(3201),
    [anon_sym_try] = ACTIONS(3201),
    [sym_integer_literal] = ACTIONS(848),
    [aux_sym_string_literal_token1] = ACTIONS(848),
    [sym_char_literal] = ACTIONS(848),
    [anon_sym_true] = ACTIONS(3201),
    [anon_sym_false] = ACTIONS(3201),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3201),
    [sym_super] = ACTIONS(3201),
    [sym_crate] = ACTIONS(3201),
    [sym_metavariable] = ACTIONS(848),
    [sym__raw_string_literal_start] = ACTIONS(848),
    [sym_float_literal] = ACTIONS(848),
  },
  [1003] = {
    [sym_line_comment] = STATE(1003),
    [sym_block_comment] = STATE(1003),
    [sym_identifier] = ACTIONS(3203),
    [anon_sym_LPAREN] = ACTIONS(3205),
    [anon_sym_LBRACK] = ACTIONS(3205),
    [anon_sym_RBRACK] = ACTIONS(3205),
    [anon_sym_LBRACE] = ACTIONS(3205),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(3203),
    [anon_sym_i8] = ACTIONS(3203),
    [anon_sym_u16] = ACTIONS(3203),
    [anon_sym_i16] = ACTIONS(3203),
    [anon_sym_u32] = ACTIONS(3203),
    [anon_sym_i32] = ACTIONS(3203),
    [anon_sym_u64] = ACTIONS(3203),
    [anon_sym_i64] = ACTIONS(3203),
    [anon_sym_u128] = ACTIONS(3203),
    [anon_sym_i128] = ACTIONS(3203),
    [anon_sym_isize] = ACTIONS(3203),
    [anon_sym_usize] = ACTIONS(3203),
    [anon_sym_f32] = ACTIONS(3203),
    [anon_sym_f64] = ACTIONS(3203),
    [anon_sym_bool] = ACTIONS(3203),
    [anon_sym_str] = ACTIONS(3203),
    [anon_sym_char] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_BANG] = ACTIONS(3205),
    [anon_sym_AMP] = ACTIONS(3205),
    [anon_sym_PIPE] = ACTIONS(3205),
    [anon_sym_LT] = ACTIONS(3205),
    [anon_sym_DOT_DOT] = ACTIONS(3205),
    [anon_sym_COMMA] = ACTIONS(3205),
    [anon_sym_COLON_COLON] = ACTIONS(3205),
    [anon_sym_POUND] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_async] = ACTIONS(3203),
    [anon_sym_break] = ACTIONS(3203),
    [anon_sym_const] = ACTIONS(3203),
    [anon_sym_continue] = ACTIONS(3203),
    [anon_sym_default] = ACTIONS(3203),
    [anon_sym_for] = ACTIONS(3203),
    [anon_sym_if] = ACTIONS(3203),
    [anon_sym_loop] = ACTIONS(3203),
    [anon_sym_match] = ACTIONS(3203),
    [anon_sym_return] = ACTIONS(3203),
    [anon_sym_static] = ACTIONS(3203),
    [anon_sym_union] = ACTIONS(3203),
    [anon_sym_unsafe] = ACTIONS(3203),
    [anon_sym_while] = ACTIONS(3203),
    [anon_sym_yield] = ACTIONS(3203),
    [anon_sym_move] = ACTIONS(3203),
    [anon_sym_try] = ACTIONS(3203),
    [sym_integer_literal] = ACTIONS(3205),
    [aux_sym_string_literal_token1] = ACTIONS(3205),
    [sym_char_literal] = ACTIONS(3205),
    [anon_sym_true] = ACTIONS(3203),
    [anon_sym_false] = ACTIONS(3203),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3203),
    [sym_super] = ACTIONS(3203),
    [sym_crate] = ACTIONS(3203),
    [sym_metavariable] = ACTIONS(3205),
    [sym__raw_string_literal_start] = ACTIONS(3205),
    [sym_float_literal] = ACTIONS(3205),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1004), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1552), 17,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(1550), 43,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_DASH,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [75] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1005), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3209), 17,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3207), 43,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_DASH,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [150] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1006), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1089), 18,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3211), 41,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [224] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1007), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2654), 17,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(2656), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_ref,
      anon_sym_dyn,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [294] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1008), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3215), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3213), 34,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_else,
      anon_sym_dyn,
      sym_mutable_specifier,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [363] = 21,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1266), 1,
      anon_sym_DASH,
    ACTIONS(1312), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1322), 1,
      sym__raw_string_literal_start,
    ACTIONS(1880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3217), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      sym_metavariable,
    STATE(2056), 1,
      sym_scoped_identifier,
    STATE(2087), 1,
      sym__literal_pattern,
    STATE(3323), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1314), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1009), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1310), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3221), 3,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
    ACTIONS(3225), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2017), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3219), 7,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
    ACTIONS(3223), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [462] = 21,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1266), 1,
      anon_sym_DASH,
    ACTIONS(1312), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1322), 1,
      sym__raw_string_literal_start,
    ACTIONS(1880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3229), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      sym_metavariable,
    STATE(2071), 1,
      sym_scoped_identifier,
    STATE(2092), 1,
      sym__literal_pattern,
    STATE(3323), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1314), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1010), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1310), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3233), 3,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
    ACTIONS(3237), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2017), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3231), 7,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
    ACTIONS(3235), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [561] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3247), 1,
      anon_sym_BANG,
    ACTIONS(3249), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    STATE(1060), 1,
      sym_parameters,
    STATE(1067), 1,
      sym_type_arguments,
    STATE(1011), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3245), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3241), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [638] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(3257), 1,
      anon_sym_COLON_COLON,
    STATE(1060), 1,
      sym_parameters,
    STATE(1067), 1,
      sym_type_arguments,
    STATE(1012), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3255), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3253), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [712] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(3257), 1,
      anon_sym_COLON_COLON,
    STATE(1060), 1,
      sym_parameters,
    STATE(1067), 1,
      sym_type_arguments,
    STATE(1013), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3261), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3259), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [786] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(3257), 1,
      anon_sym_COLON_COLON,
    STATE(1060), 1,
      sym_parameters,
    STATE(1067), 1,
      sym_type_arguments,
    STATE(1014), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3265), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3263), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [860] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1015), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1232), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1234), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [923] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1016), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1236), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1238), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [986] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3271), 1,
      anon_sym_BANG,
    ACTIONS(3273), 1,
      anon_sym_COLON_COLON,
    STATE(1017), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3267), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [1053] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 1,
      anon_sym_BANG,
    ACTIONS(3281), 1,
      anon_sym_COLON_COLON,
    STATE(1018), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3277), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3275), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [1120] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1019), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1244), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1246), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1183] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    STATE(1059), 1,
      sym_parameters,
    STATE(1066), 1,
      sym_type_arguments,
    STATE(1020), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3285), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [1254] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    STATE(1059), 1,
      sym_parameters,
    STATE(1066), 1,
      sym_type_arguments,
    STATE(1021), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3289), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3287), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [1325] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1022), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(993), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(991), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1388] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3295), 1,
      anon_sym_BANG,
    ACTIONS(3297), 1,
      anon_sym_COLON_COLON,
    STATE(1023), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [1455] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1024), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1328), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1330), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1518] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1025), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(999), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(997), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1581] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    STATE(1059), 1,
      sym_parameters,
    STATE(1066), 1,
      sym_type_arguments,
    STATE(1026), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3301), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3299), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [1652] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1027), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1206), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1208), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1715] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 1,
      anon_sym_BANG,
    ACTIONS(3309), 1,
      anon_sym_COLON_COLON,
    STATE(1028), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3305), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [1782] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1029), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1240), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1242), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1845] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    STATE(1059), 1,
      sym_parameters,
    STATE(1066), 1,
      sym_type_arguments,
    STATE(1030), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [1916] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1031), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1414), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1416), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1979] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1032), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3273), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2041] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1033), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3307), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3309), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2103] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1034), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2130), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2132), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2165] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1035), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3281), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2227] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1036), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3297), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2289] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3247), 1,
      anon_sym_BANG,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    ACTIONS(3317), 1,
      anon_sym_COLON_COLON,
    STATE(1455), 1,
      sym_field_initializer_list,
    STATE(1037), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [2359] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1038), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1734), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1736), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2421] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1039), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2326), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2328), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2483] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1040), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2322), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2324), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2545] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3323), 1,
      anon_sym_BANG,
    ACTIONS(3325), 1,
      anon_sym_COLON_COLON,
    STATE(1041), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
    ACTIONS(3321), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_as,
    ACTIONS(3319), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [2613] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3333), 1,
      anon_sym_POUND,
    STATE(1478), 2,
      sym_attribute_item,
      sym_inner_attribute_item,
    STATE(1042), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_match_arm_repeat1,
    ACTIONS(3331), 14,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3329), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2679] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1043), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2346), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2348), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2741] = 24,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(3336), 1,
      sym_identifier,
    ACTIONS(3340), 1,
      anon_sym_LPAREN,
    ACTIONS(3342), 1,
      anon_sym_STAR,
    ACTIONS(3346), 1,
      anon_sym_AMP,
    ACTIONS(3348), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3350), 1,
      anon_sym_SQUOTE,
    ACTIONS(3354), 1,
      anon_sym_for,
    ACTIONS(3358), 1,
      sym_metavariable,
    STATE(2577), 1,
      sym_scoped_type_identifier,
    STATE(2716), 1,
      sym_where_predicate,
    STATE(2937), 1,
      sym_generic_type,
    STATE(3339), 1,
      sym_generic_type_with_turbofish,
    STATE(3411), 1,
      sym_scoped_identifier,
    STATE(3474), 1,
      sym_bracketed_type,
    ACTIONS(3338), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(3352), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1044), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3356), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3172), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3344), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2840] = 24,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(3336), 1,
      sym_identifier,
    ACTIONS(3340), 1,
      anon_sym_LPAREN,
    ACTIONS(3342), 1,
      anon_sym_STAR,
    ACTIONS(3346), 1,
      anon_sym_AMP,
    ACTIONS(3348), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3350), 1,
      anon_sym_SQUOTE,
    ACTIONS(3354), 1,
      anon_sym_for,
    ACTIONS(3358), 1,
      sym_metavariable,
    STATE(2577), 1,
      sym_scoped_type_identifier,
    STATE(2716), 1,
      sym_where_predicate,
    STATE(2937), 1,
      sym_generic_type,
    STATE(3339), 1,
      sym_generic_type_with_turbofish,
    STATE(3411), 1,
      sym_scoped_identifier,
    STATE(3474), 1,
      sym_bracketed_type,
    ACTIONS(3352), 2,
      anon_sym_default,
      anon_sym_union,
    ACTIONS(3360), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(1045), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3356), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3172), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3344), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2939] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1046), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3362), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3000] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3370), 1,
      anon_sym_DASH_GT,
    STATE(1047), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3368), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3366), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3063] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1413), 1,
      sym_label,
    STATE(1048), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3374), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3372), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [3128] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1049), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3380), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3378), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3189] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3382), 1,
      anon_sym_COLON_COLON,
    STATE(1050), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3285), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3252] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1051), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3386), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3384), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3313] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1052), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3390), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3388), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3374] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3396), 1,
      anon_sym_DASH_GT,
    STATE(1053), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3394), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3392), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3437] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3402), 1,
      anon_sym_DASH_GT,
    STATE(1054), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3400), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3398), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3500] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3408), 1,
      anon_sym_DASH_GT,
    STATE(1055), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3404), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3563] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1056), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3412), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3410), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3624] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1057), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3267), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [3685] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3414), 1,
      anon_sym_else,
    STATE(1227), 1,
      sym_else_clause,
    STATE(1058), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1198), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1196), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
  [3750] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3420), 1,
      anon_sym_DASH_GT,
    STATE(1059), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3418), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3416), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3813] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3426), 1,
      anon_sym_DASH_GT,
    STATE(1060), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3424), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3422), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3876] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3382), 1,
      anon_sym_COLON_COLON,
    STATE(1061), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3289), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3287), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3939] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3428), 1,
      anon_sym_COLON_COLON,
    STATE(1062), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4002] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3382), 1,
      anon_sym_COLON_COLON,
    STATE(1063), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3301), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3299), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4065] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3434), 1,
      anon_sym_DASH_GT,
    STATE(1064), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3432), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3430), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4128] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1065), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3213), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3215), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4189] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1066), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3438), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3436), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4250] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1067), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3442), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3440), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4311] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1068), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3446), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3444), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4372] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3448), 1,
      anon_sym_POUND,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(1069), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_enum_variant_list_repeat1,
    ACTIONS(848), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_integer_literal,
      sym_metavariable,
    ACTIONS(3201), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [4437] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3453), 1,
      anon_sym_LPAREN,
    STATE(1470), 1,
      sym_arguments,
    STATE(1070), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3455), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3451), 29,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4502] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1262), 1,
      anon_sym_QMARK,
    ACTIONS(1294), 1,
      anon_sym_fn,
    ACTIONS(1302), 1,
      anon_sym_extern,
    ACTIONS(3340), 1,
      anon_sym_LPAREN,
    ACTIONS(3348), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3352), 1,
      anon_sym_union,
    ACTIONS(3358), 1,
      sym_metavariable,
    ACTIONS(3457), 1,
      sym_identifier,
    ACTIONS(3461), 1,
      anon_sym_default,
    ACTIONS(3463), 1,
      anon_sym_for,
    STATE(1624), 1,
      sym_for_lifetimes,
    STATE(1916), 1,
      sym_scoped_type_identifier,
    STATE(1941), 1,
      sym_generic_type,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(3339), 1,
      sym_generic_type_with_turbofish,
    STATE(3411), 1,
      sym_scoped_identifier,
    STATE(3432), 1,
      sym_function_modifiers,
    STATE(3474), 1,
      sym_bracketed_type,
    STATE(1071), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1288), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3356), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1972), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3459), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4607] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3382), 1,
      anon_sym_COLON_COLON,
    STATE(1072), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4670] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3465), 1,
      anon_sym_COLON_COLON,
    STATE(1073), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4733] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3467), 1,
      anon_sym_COLON_COLON,
    STATE(1074), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4796] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3469), 1,
      anon_sym_LBRACE,
    STATE(1075), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3307), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3309), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
  [4859] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1076), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1546), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1548), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4920] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1077), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3473), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3471), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4981] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1078), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3477), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3475), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5042] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1079), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3281), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
  [5105] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1296), 1,
      anon_sym_for,
    ACTIONS(1302), 1,
      anon_sym_extern,
    ACTIONS(3103), 1,
      anon_sym_QMARK,
    ACTIONS(3115), 1,
      anon_sym_fn,
    ACTIONS(3481), 1,
      sym_identifier,
    ACTIONS(3483), 1,
      anon_sym_LPAREN,
    ACTIONS(3487), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3489), 1,
      anon_sym_default,
    ACTIONS(3491), 1,
      anon_sym_union,
    ACTIONS(3495), 1,
      sym_metavariable,
    STATE(1531), 1,
      sym_scoped_type_identifier,
    STATE(1581), 1,
      sym_generic_type,
    STATE(1612), 1,
      sym_for_lifetimes,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(3478), 1,
      sym_function_modifiers,
    STATE(3513), 1,
      sym_scoped_identifier,
    STATE(3530), 1,
      sym_generic_type_with_turbofish,
    STATE(3536), 1,
      sym_bracketed_type,
    STATE(1080), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1288), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3493), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1716), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3485), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5210] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1302), 1,
      anon_sym_extern,
    ACTIONS(3103), 1,
      anon_sym_QMARK,
    ACTIONS(3115), 1,
      anon_sym_fn,
    ACTIONS(3483), 1,
      anon_sym_LPAREN,
    ACTIONS(3487), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3489), 1,
      anon_sym_default,
    ACTIONS(3491), 1,
      anon_sym_union,
    ACTIONS(3495), 1,
      sym_metavariable,
    ACTIONS(3497), 1,
      sym_identifier,
    ACTIONS(3499), 1,
      anon_sym_for,
    STATE(1530), 1,
      sym_scoped_type_identifier,
    STATE(1612), 1,
      sym_for_lifetimes,
    STATE(1616), 1,
      sym_generic_type,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(3478), 1,
      sym_function_modifiers,
    STATE(3513), 1,
      sym_scoped_identifier,
    STATE(3530), 1,
      sym_generic_type_with_turbofish,
    STATE(3536), 1,
      sym_bracketed_type,
    STATE(1081), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1288), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3493), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1772), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3485), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5315] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(1082), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3273), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
  [5378] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1083), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3505), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3503), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5439] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1084), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3509), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3507), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5500] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3511), 1,
      anon_sym_LBRACE,
    STATE(1085), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3297), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
  [5563] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1086), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3515), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3513), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5624] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1087), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3519), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3517), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5685] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1296), 1,
      anon_sym_for,
    ACTIONS(1302), 1,
      anon_sym_extern,
    ACTIONS(3061), 1,
      anon_sym_QMARK,
    ACTIONS(3073), 1,
      anon_sym_fn,
    ACTIONS(3521), 1,
      sym_identifier,
    ACTIONS(3523), 1,
      anon_sym_LPAREN,
    ACTIONS(3527), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3529), 1,
      anon_sym_default,
    ACTIONS(3531), 1,
      anon_sym_union,
    ACTIONS(3535), 1,
      sym_metavariable,
    STATE(1020), 1,
      sym_scoped_type_identifier,
    STATE(1050), 1,
      sym_generic_type,
    STATE(1630), 1,
      sym_for_lifetimes,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(3337), 1,
      sym_function_modifiers,
    STATE(3488), 1,
      sym_scoped_identifier,
    STATE(3522), 1,
      sym_generic_type_with_turbofish,
    STATE(3532), 1,
      sym_bracketed_type,
    STATE(1088), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1288), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3533), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1169), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3525), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5790] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1302), 1,
      anon_sym_extern,
    ACTIONS(3061), 1,
      anon_sym_QMARK,
    ACTIONS(3073), 1,
      anon_sym_fn,
    ACTIONS(3523), 1,
      anon_sym_LPAREN,
    ACTIONS(3527), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3529), 1,
      anon_sym_default,
    ACTIONS(3531), 1,
      anon_sym_union,
    ACTIONS(3535), 1,
      sym_metavariable,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3539), 1,
      anon_sym_for,
    STATE(1026), 1,
      sym_scoped_type_identifier,
    STATE(1063), 1,
      sym_generic_type,
    STATE(1630), 1,
      sym_for_lifetimes,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(3337), 1,
      sym_function_modifiers,
    STATE(3488), 1,
      sym_scoped_identifier,
    STATE(3522), 1,
      sym_generic_type_with_turbofish,
    STATE(3532), 1,
      sym_bracketed_type,
    STATE(1089), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1288), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3533), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1322), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3525), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5895] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1262), 1,
      anon_sym_QMARK,
    ACTIONS(1294), 1,
      anon_sym_fn,
    ACTIONS(1296), 1,
      anon_sym_for,
    ACTIONS(1302), 1,
      anon_sym_extern,
    ACTIONS(3340), 1,
      anon_sym_LPAREN,
    ACTIONS(3348), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3352), 1,
      anon_sym_union,
    ACTIONS(3358), 1,
      sym_metavariable,
    ACTIONS(3461), 1,
      anon_sym_default,
    ACTIONS(3541), 1,
      sym_identifier,
    STATE(1624), 1,
      sym_for_lifetimes,
    STATE(1914), 1,
      sym_scoped_type_identifier,
    STATE(1957), 1,
      sym_generic_type,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(3339), 1,
      sym_generic_type_with_turbofish,
    STATE(3411), 1,
      sym_scoped_identifier,
    STATE(3432), 1,
      sym_function_modifiers,
    STATE(3474), 1,
      sym_bracketed_type,
    STATE(1090), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1288), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3356), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1968), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3459), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6000] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1091), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2795), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2797), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6060] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1092), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3545), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3543), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6120] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1093), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3549), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3547), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [6180] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1094), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1940), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1942), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6240] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1095), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2334), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2336), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6300] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1096), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1706), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1708), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6360] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1097), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1402), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1400), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [6420] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1098), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1238), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1236), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [6480] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1099), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2530), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2532), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6540] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1100), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2570), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2572), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6600] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1101), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2578), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2580), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6660] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1102), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2915), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2917), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6720] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1103), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2879), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2881), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6780] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1104), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2871), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2873), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6840] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1105), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2867), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2869), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6900] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1106), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3553), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3551), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [6960] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1107), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2843), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2845), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7020] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1108), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2827), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2829), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7080] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1109), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2825), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7140] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1110), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2807), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2809), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7200] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1111), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2799), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2801), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7260] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1112), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2779), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2781), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7320] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1113), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2634), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2636), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7380] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1114), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2566), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2568), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7440] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1115), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2562), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2564), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7500] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1116), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2558), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2560), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7560] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1117), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2534), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2536), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7620] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1118), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2488), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2490), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7680] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1119), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2464), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2466), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7740] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1120), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2456), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2458), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7800] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1121), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2420), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2422), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7860] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1122), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2416), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2418), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7920] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1123), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2412), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2414), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7980] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1124), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1662), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1664), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8040] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1125), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2314), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2316), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8100] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1126), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3557), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3555), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8160] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1127), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2290), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2292), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8220] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1128), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3561), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3559), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8280] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1129), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2258), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2260), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8340] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1130), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2226), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2228), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8400] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1131), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3565), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3563), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8460] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1132), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2206), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2208), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8520] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1133), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2110), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2112), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8580] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1134), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2144), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8640] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1135), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2368), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2370), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8700] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1136), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3569), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3567), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8760] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1137), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1432), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1430), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8820] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1138), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3573), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3571), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8880] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1139), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1996), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1998), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8940] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1140), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1972), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1974), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9000] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1141), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1924), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1926), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9060] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1142), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1830), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1832), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9120] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1143), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1822), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1824), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9180] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1144), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3577), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3575), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [9240] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1145), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1806), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1808), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9300] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1146), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1782), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1784), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9360] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1147), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1730), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1732), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9420] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1148), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1726), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1728), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9480] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1149), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3581), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3579), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [9540] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1150), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1682), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1684), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9600] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1151), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1360), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1358), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [9660] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1152), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1368), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1366), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [9720] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1153), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2895), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2897), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9780] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1154), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2911), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2913), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9840] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1155), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1858), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1860), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9900] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1156), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1742), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1744), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9960] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1157), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1702), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1704), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10020] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1158), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1794), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1796), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10080] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1159), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2338), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2340), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10140] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1160), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(991), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(993), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10200] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1161), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2891), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2893), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10260] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1162), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1678), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1680), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10320] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1163), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1686), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1688), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10380] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1164), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3585), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3583), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10440] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1165), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3589), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3587), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10500] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1166), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3593), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3591), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10560] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1167), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3597), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3595), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10620] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1168), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3601), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3599), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10680] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1169), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3285), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10740] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1170), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3605), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3603), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10800] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1171), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3609), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3607), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10860] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1172), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3613), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3611), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10920] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1173), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3617), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3615), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10980] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1174), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3621), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3619), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [11040] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1175), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3625), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3623), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [11100] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1176), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2803), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2805), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11160] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1177), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2791), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2793), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11220] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1178), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1690), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1692), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11280] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1179), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2646), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2648), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11340] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1180), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2638), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2640), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11400] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1181), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2354), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2356), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11460] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1182), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2574), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2576), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11520] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1183), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1250), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1248), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [11580] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1184), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2506), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2508), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11640] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1185), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2554), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2556), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11700] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1186), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2396), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2398), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11760] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1187), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2590), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2592), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11820] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1188), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2654), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2656), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11880] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1189), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2594), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2596), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11940] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1190), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2626), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2628), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12000] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1191), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2642), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2644), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12060] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1192), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2759), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2761), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12120] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1193), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2392), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2394), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12180] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1194), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2811), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2813), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12240] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1195), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2899), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2901), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12300] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1196), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2903), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2905), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12360] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1197), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2432), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2434), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12420] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1198), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1666), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1668), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12480] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1199), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2907), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2909), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12540] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1200), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3629), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3627), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [12600] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1201), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2428), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2430), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12660] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1202), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2408), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2410), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12720] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1203), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2400), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2402), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12780] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1204), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2350), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2352), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12840] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1205), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2342), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2344), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12900] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1206), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2278), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2280), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12960] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1207), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2222), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2224), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13020] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1208), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2118), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2120), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13080] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1209), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2819), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2821), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13140] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1210), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2114), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2116), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13200] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1211), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1952), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1954), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13260] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1212), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1948), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1950), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13320] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1213), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1936), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1938), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13380] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1214), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(957), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(959), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13440] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1215), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1774), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1776), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13500] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1216), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1436), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1434), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13560] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1217), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2134), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2136), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13620] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1218), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2154), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2156), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13680] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1219), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2166), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2168), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13740] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1220), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3633), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3631), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13800] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1221), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2254), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2256), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13860] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1222), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2274), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2276), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13920] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1223), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3637), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3635), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13980] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1224), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3641), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3639), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14040] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1225), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2622), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2624), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14100] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1226), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2618), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2620), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14160] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1227), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1428), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1426), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14220] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1228), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2855), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2857), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14280] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1229), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1770), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1772), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14340] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1230), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2875), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2877), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14400] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1231), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2863), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2865), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14460] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1232), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2851), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2853), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14520] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1233), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2847), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2849), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14580] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1234), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2783), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2785), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14640] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1235), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(997), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(999), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14700] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1236), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2614), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2616), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14760] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1237), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14820] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1238), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2602), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2604), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14880] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1239), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2242), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2244), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14940] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1240), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1698), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1700), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15000] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1241), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2598), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2600), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15060] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1242), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3645), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3643), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15120] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1243), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3649), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3647), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15180] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1244), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3649), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3647), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15240] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1245), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3653), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3651), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15300] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1246), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(817), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(819), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15360] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1247), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2542), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2544), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15420] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1248), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2538), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2540), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15480] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1249), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3657), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3655), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15540] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1250), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2526), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2528), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15600] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1251), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2835), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2837), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15660] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1252), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3661), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15720] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1253), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1710), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1712), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15780] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1254), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3665), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3663), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15840] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1255), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3669), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3667), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15900] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1256), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3673), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3671), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15960] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1257), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3677), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3675), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [16020] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1258), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2522), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2524), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16080] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1259), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2514), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2516), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16140] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1260), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2510), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2512), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16200] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1261), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2484), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2486), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16260] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1262), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2480), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2482), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16320] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1263), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2476), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2478), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16380] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1264), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2440), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2442), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16440] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1265), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2436), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2438), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16500] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1266), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3681), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3679), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16560] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1267), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1372), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1370), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [16620] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1268), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1960), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1962), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16680] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1269), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2310), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2312), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16740] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1270), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3685), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3683), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16800] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1271), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2306), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2308), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16860] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1272), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2302), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2304), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16920] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1273), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2298), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2300), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16980] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1274), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2294), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2296), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17040] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1275), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2238), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2240), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17100] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1276), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1838), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1840), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17160] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1277), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17220] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1278), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2234), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2236), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17280] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1279), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1234), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1232), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17340] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1280), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2202), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2204), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17400] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3691), 1,
      anon_sym_RBRACE,
    STATE(1281), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3689), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3687), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17462] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1282), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2170), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2172), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17522] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1283), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1718), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1720), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17582] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1284), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1964), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1966), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17642] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1285), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1842), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1844), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17702] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1286), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1722), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1724), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17762] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1287), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2388), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2390), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17822] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1288), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1846), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1848), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17882] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1289), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1850), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1852), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17942] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1290), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1834), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1836), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18002] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1291), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3695), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3693), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [18062] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1292), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1330), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1328), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [18122] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1293), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1376), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1374), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [18182] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1294), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1738), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1740), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18242] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1295), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1758), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1760), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18302] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1296), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1694), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1696), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18362] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1297), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1674), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1676), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18422] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1298), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2262), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2264), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18482] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1299), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2182), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2184), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18542] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1300), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2839), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2841), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18602] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1301), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1814), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1816), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18662] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1302), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1798), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1800), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18722] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1303), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1412), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1410), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [18782] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1304), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1826), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1828), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18842] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1305), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1790), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1792), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18902] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1306), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1786), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1788), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18962] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1307), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [19022] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1308), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2230), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2232), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19082] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1309), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1714), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1716), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19142] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1310), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1750), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1752), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19202] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1311), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1416), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1414), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [19262] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1312), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1448), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1446), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [19322] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1313), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2218), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2220), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19382] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1314), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3699), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3697), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19442] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1315), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1754), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1756), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19502] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1316), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3703), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3701), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19562] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1317), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1670), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1672), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19622] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1318), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3289), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3287), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [19682] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1319), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3455), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3451), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [19742] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1320), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1854), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1856), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19802] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1321), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3707), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3705), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19862] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1322), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3301), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3299), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [19922] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1323), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3711), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3709), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [19982] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1324), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3715), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3713), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [20042] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1325), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3717), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [20102] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1326), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3723), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3721), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20162] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1327), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1746), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1748), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20222] = 21,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1614), 1,
      anon_sym_DASH,
    ACTIONS(1638), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1646), 1,
      sym__raw_string_literal_start,
    ACTIONS(3221), 1,
      anon_sym_if,
    ACTIONS(3725), 1,
      sym_identifier,
    ACTIONS(3729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3733), 1,
      sym_metavariable,
    STATE(2665), 1,
      sym_scoped_identifier,
    STATE(2761), 1,
      sym__literal_pattern,
    STATE(3470), 1,
      sym_bracketed_type,
    STATE(3483), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1640), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3219), 2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(1328), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1636), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3731), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2309), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3727), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [20314] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1329), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2214), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2216), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20374] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1330), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2210), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2212), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20434] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1331), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1928), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1930), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20494] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1332), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2186), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2188), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20554] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1333), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2178), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2180), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20614] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1334), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2282), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2284), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20674] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1335), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1762), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1764), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20734] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1336), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2286), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2288), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20794] = 21,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1614), 1,
      anon_sym_DASH,
    ACTIONS(1638), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1646), 1,
      sym__raw_string_literal_start,
    ACTIONS(3233), 1,
      anon_sym_if,
    ACTIONS(3729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3735), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      sym_metavariable,
    STATE(2645), 1,
      sym_scoped_identifier,
    STATE(2774), 1,
      sym__literal_pattern,
    STATE(3470), 1,
      sym_bracketed_type,
    STATE(3483), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1640), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3231), 2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(1337), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1636), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3739), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2309), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3737), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [20886] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1338), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2174), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2176), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20946] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1339), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2380), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2382), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21006] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1340), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2424), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2426), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21066] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1341), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2162), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2164), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21126] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1342), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1766), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1768), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21186] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1343), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2887), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2889), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21246] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1344), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1208), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1206), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21306] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1345), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2883), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2885), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21366] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1346), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3745), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3743), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21426] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1347), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3749), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3747), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21486] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1348), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2859), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2861), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21546] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3325), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3751), 1,
      anon_sym_BANG,
    STATE(1349), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3321), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3319), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [21610] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1350), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21670] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1351), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3755), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3753), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21730] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1352), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3759), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3757), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21790] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1353), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2831), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2833), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21850] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    STATE(1354), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3765), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3761), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21916] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1355), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2815), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2817), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21976] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1356), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2787), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2789), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22036] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    STATE(1357), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3773), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3771), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22102] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1358), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2775), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2777), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22162] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1359), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2741), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2743), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22222] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1360), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2771), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2773), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22282] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1361), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2747), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2749), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22342] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1362), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2767), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2769), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22402] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1363), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2763), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2765), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22462] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1364), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2755), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2757), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22522] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1365), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1364), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1362), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22582] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1366), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2751), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2753), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22642] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1367), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2650), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2652), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22702] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1368), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2630), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2632), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22762] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1369), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2610), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2612), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22822] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1370), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1420), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1418), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [22882] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1371), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2606), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2608), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22942] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1372), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1398), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1396), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [23002] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1373), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2586), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2588), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23062] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1374), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2582), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2584), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23122] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1375), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2550), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2552), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23182] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1376), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2546), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2548), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23242] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1377), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2518), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2520), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23302] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1378), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2500), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2502), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23362] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1379), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1452), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1450), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [23422] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1380), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1444), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1442), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [23482] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1381), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3777), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3775), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23542] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1382), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2496), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2498), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23602] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3783), 1,
      anon_sym_RBRACE,
    STATE(1383), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3781), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3779), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23664] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1384), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2492), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2494), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23724] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1385), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2472), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2474), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23784] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1386), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1778), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1780), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23844] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1387), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [23904] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1388), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2468), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2470), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23964] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1389), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3787), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3785), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24024] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1390), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2158), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2160), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24084] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1391), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2460), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2462), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24144] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3791), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3789), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24204] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1393), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2122), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2124), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24264] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1394), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2106), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2108), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24324] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1395), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1920), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1922), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24384] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1396), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2448), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2450), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24444] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1397), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2102), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2104), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24504] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1398), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3795), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3793), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24564] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1399), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3799), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3797), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24624] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1400), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2444), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2446), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24684] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1401), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2098), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2100), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24744] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1402), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2094), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2096), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24804] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1403), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2090), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2092), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24864] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1404), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1242), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1240), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24924] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1405), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2404), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2406), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24984] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1406), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1810), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1812), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25044] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1407), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1802), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1804), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25104] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1408), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1818), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1820), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25164] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1409), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3803), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3801), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25224] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1410), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(797), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(799), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25284] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1411), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1932), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1934), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25344] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1412), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3807), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3805), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25404] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1413), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3811), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3809), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25464] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3813), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1414), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3807), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3805), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [25526] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1415), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3817), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3815), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25586] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1416), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2384), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2386), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25646] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1417), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3821), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3819), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25706] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1418), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2360), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2362), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25766] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1419), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2376), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2378), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25826] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1420), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2374), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25886] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1421), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2086), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2088), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25946] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1422), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3825), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3823), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26006] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1423), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1944), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1946), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26066] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1424), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2364), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2366), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26126] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    STATE(1425), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3829), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3827), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26192] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1426), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3833), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3831), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26252] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1427), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2330), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2332), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26312] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1428), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2318), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2320), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26372] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1429), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2266), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2268), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26432] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1430), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2082), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2084), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26492] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1431), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1956), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1958), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26552] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1432), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2250), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2252), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26612] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1433), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3837), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3835), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26672] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1434), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3841), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3839), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26732] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1435), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1968), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1970), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26792] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1436), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(777), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(779), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26852] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3843), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1437), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3807), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3805), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [26914] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1438), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2246), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2248), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26974] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1439), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27034] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    STATE(1440), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3847), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 27,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_else,
  [27102] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1441), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1976), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1978), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27162] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1442), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2198), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2200), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27222] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1443), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2194), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2196), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27282] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1444), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1980), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1982), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27342] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1445), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2078), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2080), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27402] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1446), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2074), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2076), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27462] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1447), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3853), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3851), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27522] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1448), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2004), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2006), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27582] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1449), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3857), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3855), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27642] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1450), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(785), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(787), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27702] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1451), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3861), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3859), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27762] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1452), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3865), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3863), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27822] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1453), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2190), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2192), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27882] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1454), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2150), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2152), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27942] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1455), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3869), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3867), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [28002] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1456), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3873), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(3871), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28062] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1457), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1984), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1986), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28122] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1458), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2146), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2148), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28182] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1459), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1988), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1990), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28242] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1460), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2138), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2140), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28302] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3247), 1,
      anon_sym_BANG,
    ACTIONS(3875), 1,
      anon_sym_COLON_COLON,
    STATE(1461), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [28366] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1462), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1246), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1244), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [28426] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1463), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1866), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1868), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28486] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1464), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1326), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1324), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [28546] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1465), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1862), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1864), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28606] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1466), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2126), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2128), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28666] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1467), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2000), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2002), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28726] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1468), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1992), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1994), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28786] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1469), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3879), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3877), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [28846] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1470), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3883), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [28906] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1471), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2654), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      sym_integer_literal,
      sym_metavariable,
    ACTIONS(2656), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28965] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3325), 1,
      anon_sym_COLON_COLON,
    STATE(1472), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3321), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3319), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [29026] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1473), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1686), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(1688), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29085] = 23,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(3336), 1,
      sym_identifier,
    ACTIONS(3340), 1,
      anon_sym_LPAREN,
    ACTIONS(3342), 1,
      anon_sym_STAR,
    ACTIONS(3346), 1,
      anon_sym_AMP,
    ACTIONS(3348), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3350), 1,
      anon_sym_SQUOTE,
    ACTIONS(3354), 1,
      anon_sym_for,
    ACTIONS(3358), 1,
      sym_metavariable,
    STATE(2395), 1,
      sym_where_predicate,
    STATE(2577), 1,
      sym_scoped_type_identifier,
    STATE(2937), 1,
      sym_generic_type,
    STATE(3339), 1,
      sym_generic_type_with_turbofish,
    STATE(3411), 1,
      sym_scoped_identifier,
    STATE(3474), 1,
      sym_bracketed_type,
    ACTIONS(3352), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1474), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3356), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3172), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3344), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [29180] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1475), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3781), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3779), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29239] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1476), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3887), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3885), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29298] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3889), 1,
      anon_sym_COLON_COLON,
    STATE(1477), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [29359] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1478), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3893), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3891), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29418] = 23,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(3336), 1,
      sym_identifier,
    ACTIONS(3340), 1,
      anon_sym_LPAREN,
    ACTIONS(3342), 1,
      anon_sym_STAR,
    ACTIONS(3346), 1,
      anon_sym_AMP,
    ACTIONS(3348), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3350), 1,
      anon_sym_SQUOTE,
    ACTIONS(3354), 1,
      anon_sym_for,
    ACTIONS(3358), 1,
      sym_metavariable,
    STATE(2577), 1,
      sym_scoped_type_identifier,
    STATE(2716), 1,
      sym_where_predicate,
    STATE(2937), 1,
      sym_generic_type,
    STATE(3339), 1,
      sym_generic_type_with_turbofish,
    STATE(3411), 1,
      sym_scoped_identifier,
    STATE(3474), 1,
      sym_bracketed_type,
    ACTIONS(3352), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1479), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3356), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3172), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3344), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [29513] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1480), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3689), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3687), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29572] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1481), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3205), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      sym_integer_literal,
      sym_metavariable,
    ACTIONS(3203), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29631] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3913), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1482), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3895), 19,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [29717] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3925), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1483), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3855), 7,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29809] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1484), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 7,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [29881] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1485), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [29957] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1486), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3845), 21,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30039] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3847), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1487), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3845), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30123] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3929), 1,
      anon_sym_EQ,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3925), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1488), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3927), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30213] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3933), 1,
      anon_sym_EQ,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3925), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1489), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3931), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30303] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1490), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30381] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(342), 1,
      anon_sym_EQ,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3925), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1491), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(336), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30471] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3937), 1,
      anon_sym_EQ,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3925), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1492), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3935), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30561] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1493), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 6,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30635] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(380), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1494), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(378), 19,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30721] = 25,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1302), 1,
      anon_sym_extern,
    ACTIONS(3115), 1,
      anon_sym_fn,
    ACTIONS(3487), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3489), 1,
      anon_sym_default,
    ACTIONS(3491), 1,
      anon_sym_union,
    ACTIONS(3495), 1,
      sym_metavariable,
    ACTIONS(3939), 1,
      sym_identifier,
    ACTIONS(3941), 1,
      anon_sym_for,
    STATE(1532), 1,
      sym_scoped_type_identifier,
    STATE(1612), 1,
      sym_for_lifetimes,
    STATE(1621), 1,
      sym_generic_type,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(3478), 1,
      sym_function_modifiers,
    STATE(3513), 1,
      sym_scoped_identifier,
    STATE(3530), 1,
      sym_generic_type_with_turbofish,
    STATE(3536), 1,
      sym_bracketed_type,
    STATE(1495), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1763), 2,
      sym_higher_ranked_trait_bound,
      sym_function_type,
    ACTIONS(1288), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3493), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3485), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30819] = 25,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1294), 1,
      anon_sym_fn,
    ACTIONS(1302), 1,
      anon_sym_extern,
    ACTIONS(3143), 1,
      anon_sym_for,
    ACTIONS(3348), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3352), 1,
      anon_sym_union,
    ACTIONS(3358), 1,
      sym_metavariable,
    ACTIONS(3461), 1,
      anon_sym_default,
    ACTIONS(3943), 1,
      sym_identifier,
    STATE(1624), 1,
      sym_for_lifetimes,
    STATE(1915), 1,
      sym_scoped_type_identifier,
    STATE(1944), 1,
      sym_generic_type,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(3339), 1,
      sym_generic_type_with_turbofish,
    STATE(3411), 1,
      sym_scoped_identifier,
    STATE(3432), 1,
      sym_function_modifiers,
    STATE(3474), 1,
      sym_bracketed_type,
    STATE(1496), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1966), 2,
      sym_higher_ranked_trait_bound,
      sym_function_type,
    ACTIONS(1288), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3356), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3459), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30917] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3947), 1,
      anon_sym_EQ,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3925), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1497), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3945), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [31007] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1498), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 9,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [31077] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3925), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1499), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3659), 7,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31169] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    STATE(1500), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [31237] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    ACTIONS(3317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3949), 1,
      anon_sym_BANG,
    STATE(1455), 1,
      sym_field_initializer_list,
    STATE(1501), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [31303] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3953), 1,
      anon_sym_EQ,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3925), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1502), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3951), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [31393] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3925), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1503), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3643), 7,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31485] = 25,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1302), 1,
      anon_sym_extern,
    ACTIONS(3073), 1,
      anon_sym_fn,
    ACTIONS(3527), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3529), 1,
      anon_sym_default,
    ACTIONS(3531), 1,
      anon_sym_union,
    ACTIONS(3535), 1,
      sym_metavariable,
    ACTIONS(3955), 1,
      sym_identifier,
    ACTIONS(3957), 1,
      anon_sym_for,
    STATE(1021), 1,
      sym_scoped_type_identifier,
    STATE(1061), 1,
      sym_generic_type,
    STATE(1630), 1,
      sym_for_lifetimes,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(3337), 1,
      sym_function_modifiers,
    STATE(3488), 1,
      sym_scoped_identifier,
    STATE(3522), 1,
      sym_generic_type_with_turbofish,
    STATE(3532), 1,
      sym_bracketed_type,
    STATE(1318), 2,
      sym_higher_ranked_trait_bound,
      sym_function_type,
    STATE(1504), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1288), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3533), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3525), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [31583] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    ACTIONS(3961), 1,
      anon_sym_BANG,
    ACTIONS(3963), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    STATE(1606), 1,
      sym_type_arguments,
    STATE(1619), 1,
      sym_parameters,
    STATE(1505), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3245), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3241), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [31653] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3961), 1,
      anon_sym_BANG,
    ACTIONS(3967), 1,
      anon_sym_LBRACE,
    ACTIONS(3969), 1,
      anon_sym_COLON_COLON,
    STATE(1746), 1,
      sym_field_initializer_list,
    STATE(1506), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [31718] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    ACTIONS(3971), 1,
      anon_sym_COLON_COLON,
    STATE(1606), 1,
      sym_type_arguments,
    STATE(1619), 1,
      sym_parameters,
    STATE(1507), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3261), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3259), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [31785] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    ACTIONS(3971), 1,
      anon_sym_COLON_COLON,
    STATE(1606), 1,
      sym_type_arguments,
    STATE(1619), 1,
      sym_parameters,
    STATE(1508), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3255), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3253), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [31852] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3323), 1,
      anon_sym_BANG,
    ACTIONS(3325), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3973), 1,
      sym_identifier,
    STATE(1509), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3321), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_as,
    ACTIONS(3319), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [31915] = 19,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1614), 1,
      anon_sym_DASH,
    ACTIONS(1638), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1646), 1,
      sym__raw_string_literal_start,
    ACTIONS(3725), 1,
      sym_identifier,
    ACTIONS(3729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3733), 1,
      sym_metavariable,
    STATE(2665), 1,
      sym_scoped_identifier,
    STATE(2761), 1,
      sym__literal_pattern,
    STATE(3470), 1,
      sym_bracketed_type,
    STATE(3483), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1640), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1510), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1636), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3731), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2309), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3727), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [32000] = 19,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1266), 1,
      anon_sym_DASH,
    ACTIONS(1312), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1322), 1,
      sym__raw_string_literal_start,
    ACTIONS(1880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3217), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      sym_metavariable,
    STATE(2056), 1,
      sym_scoped_identifier,
    STATE(2087), 1,
      sym__literal_pattern,
    STATE(3323), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1314), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1511), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1310), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3225), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2017), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3223), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [32085] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    ACTIONS(3971), 1,
      anon_sym_COLON_COLON,
    STATE(1606), 1,
      sym_type_arguments,
    STATE(1619), 1,
      sym_parameters,
    STATE(1512), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3265), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3263), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [32152] = 19,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1614), 1,
      anon_sym_DASH,
    ACTIONS(1638), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1646), 1,
      sym__raw_string_literal_start,
    ACTIONS(3729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3735), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      sym_metavariable,
    STATE(2645), 1,
      sym_scoped_identifier,
    STATE(2774), 1,
      sym__literal_pattern,
    STATE(3470), 1,
      sym_bracketed_type,
    STATE(3483), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1640), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1513), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1636), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3739), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2309), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3737), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [32237] = 19,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1266), 1,
      anon_sym_DASH,
    ACTIONS(1312), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1322), 1,
      sym__raw_string_literal_start,
    ACTIONS(1880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3229), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      sym_metavariable,
    STATE(2071), 1,
      sym_scoped_identifier,
    STATE(2092), 1,
      sym__literal_pattern,
    STATE(3323), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1314), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1514), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1310), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3237), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2017), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3235), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [32322] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3247), 1,
      anon_sym_BANG,
    ACTIONS(3975), 1,
      anon_sym_COLON_COLON,
    STATE(1455), 1,
      sym_field_initializer_list,
    STATE(1515), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [32385] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3469), 1,
      anon_sym_LBRACE,
    STATE(1516), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3307), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3309), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [32443] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1517), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3681), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3679), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32499] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 1,
      anon_sym_BANG,
    ACTIONS(3309), 1,
      anon_sym_COLON_COLON,
    STATE(1518), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3305), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [32559] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3751), 1,
      anon_sym_BANG,
    ACTIONS(3977), 1,
      anon_sym_COLON_COLON,
    STATE(1519), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3321), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3319), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [32619] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3981), 1,
      anon_sym_LPAREN,
    STATE(1520), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3984), 9,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3979), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32677] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 1,
      anon_sym_BANG,
    ACTIONS(3281), 1,
      anon_sym_COLON_COLON,
    STATE(1521), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3277), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3275), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [32737] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1522), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3297), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
  [32793] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3271), 1,
      anon_sym_BANG,
    ACTIONS(3273), 1,
      anon_sym_COLON_COLON,
    STATE(1523), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3267), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [32853] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3295), 1,
      anon_sym_BANG,
    ACTIONS(3297), 1,
      anon_sym_COLON_COLON,
    STATE(1524), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [32913] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1525), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3281), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [32971] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3986), 1,
      anon_sym_COLON_COLON,
    STATE(1526), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3984), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3979), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33029] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    STATE(1607), 1,
      sym_type_arguments,
    STATE(1620), 1,
      sym_parameters,
    STATE(1527), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [33093] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1528), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3991), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3989), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33149] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1529), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3273), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33205] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    STATE(1607), 1,
      sym_type_arguments,
    STATE(1620), 1,
      sym_parameters,
    STATE(1530), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3301), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3299), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [33269] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    STATE(1607), 1,
      sym_type_arguments,
    STATE(1620), 1,
      sym_parameters,
    STATE(1531), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3285), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [33333] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    STATE(1607), 1,
      sym_type_arguments,
    STATE(1620), 1,
      sym_parameters,
    STATE(1532), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3289), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3287), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [33397] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1533), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3707), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3705), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33453] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3949), 1,
      anon_sym_BANG,
    STATE(1534), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [33513] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(1535), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3273), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [33571] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3511), 1,
      anon_sym_LBRACE,
    STATE(1536), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3297), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [33629] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3247), 1,
      anon_sym_BANG,
    ACTIONS(3993), 1,
      anon_sym_COLON_COLON,
    STATE(1537), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33689] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1538), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3997), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3995), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33745] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1539), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4001), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3999), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33801] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1540), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3281), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33857] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1541), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3307), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3309), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33913] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(1781), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1542), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34008] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1543), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3505), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3503), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [34063] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1544), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3281), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [34118] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(763), 1,
      anon_sym_RBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_SEMI,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4037), 1,
      anon_sym_COMMA,
    STATE(2807), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1545), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34213] = 25,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(378), 1,
      sym_block,
    STATE(3414), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1546), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34308] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3813), 1,
      anon_sym_COLON_COLON,
    STATE(1547), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3807), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3805), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [34365] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1548), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3307), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3309), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [34420] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3843), 1,
      anon_sym_COLON_COLON,
    STATE(1549), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3807), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3805), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [34477] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1550), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3390), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3388), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [34532] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1551), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3380), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3378), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [34587] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4039), 1,
      anon_sym_SQUOTE,
    STATE(1735), 1,
      sym_label,
    STATE(1552), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3374), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3372), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [34646] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(989), 1,
      anon_sym_RBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4041), 1,
      anon_sym_SEMI,
    ACTIONS(4043), 1,
      anon_sym_COMMA,
    STATE(2768), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1553), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34741] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(793), 1,
      anon_sym_RBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4045), 1,
      anon_sym_SEMI,
    ACTIONS(4047), 1,
      anon_sym_COMMA,
    STATE(2889), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1554), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34836] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(474), 1,
      sym_block,
    STATE(3596), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1555), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34931] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(1152), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1556), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35026] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4049), 1,
      anon_sym_BANG,
    ACTIONS(4051), 1,
      anon_sym_COLON_COLON,
    STATE(1557), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3321), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3319), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [35085] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3961), 1,
      anon_sym_BANG,
    ACTIONS(4053), 1,
      anon_sym_COLON_COLON,
    STATE(1558), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [35144] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1413), 1,
      sym_label,
    STATE(1559), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3374), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3372), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [35201] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1560), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3273), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [35256] = 25,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(373), 1,
      sym_block,
    STATE(3414), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1561), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35351] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3843), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1562), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3807), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3805), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [35408] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(987), 1,
      anon_sym_RBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4055), 1,
      anon_sym_SEMI,
    ACTIONS(4057), 1,
      anon_sym_COMMA,
    STATE(2788), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1563), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35503] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4059), 1,
      anon_sym_COLON_COLON,
    STATE(1564), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [35560] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(1464), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1565), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35655] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3977), 1,
      anon_sym_COLON_COLON,
    STATE(1566), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3321), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3319), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [35712] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(1788), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1567), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35807] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1568), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3473), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3471), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [35862] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    STATE(467), 1,
      sym_block,
    STATE(3596), 1,
      sym_label,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1569), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35957] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1570), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3297), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [36012] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3813), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1571), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3807), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3805), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [36069] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4061), 1,
      anon_sym_else,
    STATE(1751), 1,
      sym_else_clause,
    STATE(1572), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1198), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1196), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [36128] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4065), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1573), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3643), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36216] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4067), 1,
      anon_sym_RPAREN,
    ACTIONS(4069), 1,
      anon_sym_COMMA,
    STATE(3002), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1574), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36308] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4071), 1,
      anon_sym_DASH_GT,
    STATE(1575), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3368), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3366), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [36364] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1576), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3386), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3384), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [36418] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1577), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1242), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1240), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [36472] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1578), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1208), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1206), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [36526] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1579), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3477), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3475), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [36580] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1580), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1234), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1232), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [36634] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4073), 1,
      anon_sym_COLON_COLON,
    STATE(1581), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3285), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [36690] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1582), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1238), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1236), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [36744] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1583), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3509), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3507), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [36798] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1584), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1246), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1244), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [36852] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1585), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3267), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [36906] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1586), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3362), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [36960] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1587), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3895), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37042] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1588), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3519), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3517), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [37096] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1589), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3515), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3513), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [37150] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1590), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37224] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3933), 1,
      anon_sym_EQ,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4065), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1591), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3931), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [37310] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3929), 1,
      anon_sym_EQ,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4065), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1592), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3927), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [37396] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(983), 1,
      anon_sym_RBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4075), 1,
      anon_sym_COMMA,
    STATE(2881), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1593), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37488] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1594), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 9,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37554] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3847), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1595), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3845), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37634] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1596), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3845), 17,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37712] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1597), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37784] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1598), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 7,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37852] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1599), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 6,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37922] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    STATE(1600), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37986] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4073), 1,
      anon_sym_COLON_COLON,
    STATE(1601), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38042] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4077), 1,
      anon_sym_COLON_COLON,
    STATE(1602), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38098] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1603), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4079), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38186] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4081), 1,
      anon_sym_COLON_COLON,
    STATE(1604), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38242] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4065), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1605), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3659), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38330] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1606), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3442), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3440), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [38384] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1607), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3438), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3436), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [38438] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3937), 1,
      anon_sym_EQ,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4065), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1608), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3935), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [38524] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(380), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1609), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(378), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [38606] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(342), 1,
      anon_sym_EQ,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4065), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1610), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(336), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [38692] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1611), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3446), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3444), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [38746] = 22,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1302), 1,
      anon_sym_extern,
    ACTIONS(3348), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3352), 1,
      anon_sym_union,
    ACTIONS(3358), 1,
      sym_metavariable,
    ACTIONS(3461), 1,
      anon_sym_default,
    ACTIONS(4083), 1,
      sym_identifier,
    ACTIONS(4085), 1,
      anon_sym_fn,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(2549), 1,
      sym_scoped_type_identifier,
    STATE(3339), 1,
      sym_generic_type_with_turbofish,
    STATE(3411), 1,
      sym_scoped_identifier,
    STATE(3448), 1,
      sym_generic_type,
    STATE(3474), 1,
      sym_bracketed_type,
    STATE(3489), 1,
      sym_function_modifiers,
    STATE(1612), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1288), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3356), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3459), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [38834] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3953), 1,
      anon_sym_EQ,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4065), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1613), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3951), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [38920] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_EQ,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4065), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1614), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3945), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [39006] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4087), 1,
      anon_sym_DASH_GT,
    STATE(1615), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3432), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3430), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [39062] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4073), 1,
      anon_sym_COLON_COLON,
    STATE(1616), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3301), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3299), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [39118] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4013), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4065), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1617), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3855), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39206] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4089), 1,
      anon_sym_RPAREN,
    ACTIONS(4091), 1,
      anon_sym_COMMA,
    STATE(2865), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1618), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39298] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4093), 1,
      anon_sym_DASH_GT,
    STATE(1619), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3424), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3422), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [39354] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4095), 1,
      anon_sym_DASH_GT,
    STATE(1620), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3418), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3416), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [39410] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4073), 1,
      anon_sym_COLON_COLON,
    STATE(1621), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3289), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3287), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [39466] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(973), 1,
      anon_sym_RBRACK,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4097), 1,
      anon_sym_COMMA,
    STATE(2999), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1622), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39558] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1623), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4099), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39646] = 22,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1302), 1,
      anon_sym_extern,
    ACTIONS(3348), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3352), 1,
      anon_sym_union,
    ACTIONS(3358), 1,
      sym_metavariable,
    ACTIONS(3461), 1,
      anon_sym_default,
    ACTIONS(4101), 1,
      sym_identifier,
    ACTIONS(4103), 1,
      anon_sym_fn,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(2588), 1,
      sym_scoped_type_identifier,
    STATE(3339), 1,
      sym_generic_type_with_turbofish,
    STATE(3411), 1,
      sym_scoped_identifier,
    STATE(3433), 1,
      sym_function_modifiers,
    STATE(3448), 1,
      sym_generic_type,
    STATE(3474), 1,
      sym_bracketed_type,
    STATE(1624), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1288), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3356), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3459), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [39734] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4105), 1,
      anon_sym_DASH_GT,
    STATE(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3400), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3398), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [39790] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4107), 1,
      anon_sym_DASH_GT,
    STATE(1626), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3394), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3392), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [39846] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1627), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3412), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3410), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [39900] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1003), 1,
      anon_sym_RPAREN,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4109), 1,
      anon_sym_COMMA,
    STATE(2954), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1628), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39992] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1005), 1,
      anon_sym_RPAREN,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 1,
      anon_sym_COMMA,
    STATE(2900), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1629), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40084] = 22,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1302), 1,
      anon_sym_extern,
    ACTIONS(3348), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3352), 1,
      anon_sym_union,
    ACTIONS(3358), 1,
      sym_metavariable,
    ACTIONS(3461), 1,
      anon_sym_default,
    ACTIONS(4113), 1,
      sym_identifier,
    ACTIONS(4115), 1,
      anon_sym_fn,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(2706), 1,
      sym_scoped_type_identifier,
    STATE(3339), 1,
      sym_generic_type_with_turbofish,
    STATE(3370), 1,
      sym_function_modifiers,
    STATE(3411), 1,
      sym_scoped_identifier,
    STATE(3448), 1,
      sym_generic_type,
    STATE(3474), 1,
      sym_bracketed_type,
    STATE(1630), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1288), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3356), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3459), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [40172] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4051), 1,
      anon_sym_COLON_COLON,
    STATE(1631), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3321), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3319), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40228] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4117), 1,
      anon_sym_DASH_GT,
    STATE(1632), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3406), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3404), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40284] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4119), 1,
      anon_sym_COLON_COLON,
    STATE(1633), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40340] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4121), 1,
      anon_sym_COLON_COLON,
    STATE(1634), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40396] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4123), 1,
      anon_sym_LPAREN,
    STATE(1750), 1,
      sym_arguments,
    STATE(1635), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3455), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3451), 22,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40454] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1636), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1250), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1248), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40507] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1637), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3617), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3615), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40560] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1638), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1416), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1414), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40613] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1639), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 9,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [40678] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4129), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1640), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40765] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1641), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3649), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3647), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40818] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(121), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1642), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40907] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(4133), 1,
      anon_sym_RBRACE,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1643), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40996] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1644), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41085] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1645), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3865), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3863), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [41138] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(137), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1646), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41227] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4135), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1647), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41314] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4137), 1,
      anon_sym_SEMI,
    ACTIONS(4139), 1,
      anon_sym_else,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1648), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41403] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(141), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1649), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41492] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3847), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1650), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3845), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [41571] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4155), 1,
      anon_sym_SEMI,
    ACTIONS(4157), 1,
      anon_sym_else,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1651), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41660] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1652), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3861), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3859), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [41713] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(4159), 1,
      anon_sym_RBRACE,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1653), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41802] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1654), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3845), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [41879] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1655), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [41950] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4161), 1,
      anon_sym_LBRACE,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_EQ,
    ACTIONS(4169), 1,
      anon_sym_DOT_DOT,
    STATE(452), 1,
      sym_match_block,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4171), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1656), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4165), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42039] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4203), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(3659), 2,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4205), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1657), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4193), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42126] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1658), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3695), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3693), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42179] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1659), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3711), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3709), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42232] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1660), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1448), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1446), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42285] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4209), 1,
      anon_sym_SEMI,
    ACTIONS(4211), 1,
      anon_sym_else,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1661), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42374] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1662), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3649), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3647), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42427] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1663), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3605), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3603), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42480] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1664), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 7,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [42547] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1665), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3841), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3839), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42600] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4213), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1666), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42687] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1667), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1412), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1410), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42740] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1668), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42827] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1669), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1376), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1374), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42880] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_EQ,
    ACTIONS(4215), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3855), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4217), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1670), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4165), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42967] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1671), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(797), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(799), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43020] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1672), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1330), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1328), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43073] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1673), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3673), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3671), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43126] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4219), 1,
      anon_sym_SEMI,
    ACTIONS(4221), 1,
      anon_sym_else,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1674), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43215] = 18,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(4227), 1,
      anon_sym_RBRACE,
    ACTIONS(4229), 1,
      anon_sym_STAR,
    ACTIONS(4233), 1,
      anon_sym_COMMA,
    ACTIONS(4235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4239), 1,
      sym_metavariable,
    STATE(2420), 1,
      sym_scoped_identifier,
    STATE(3014), 1,
      sym__use_clause,
    STATE(3357), 1,
      sym_generic_type_with_turbofish,
    STATE(3515), 1,
      sym_bracketed_type,
    STATE(1675), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4237), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2877), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4231), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [43294] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1676), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 6,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [43363] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    STATE(1677), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [43426] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    STATE(1678), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [43489] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3953), 1,
      anon_sym_EQ,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4215), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4217), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1679), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3951), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43574] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1680), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3677), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3675), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43627] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_EQ,
    ACTIONS(4169), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4241), 1,
      anon_sym_LBRACE,
    STATE(389), 1,
      sym_match_block,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4171), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1681), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4165), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43716] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(129), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1682), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43805] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(342), 1,
      anon_sym_EQ,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4215), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4217), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1683), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(336), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43890] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(145), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1684), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43979] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1685), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3803), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3801), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44032] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(4243), 1,
      anon_sym_RBRACE,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1686), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44121] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4247), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4245), 2,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(1687), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44208] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1081), 1,
      anon_sym_RPAREN,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4249), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1688), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44297] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4251), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1689), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44384] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(4253), 1,
      anon_sym_RBRACE,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1690), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44473] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(324), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1691), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44562] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4255), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1692), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44649] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1693), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 6,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [44718] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1694), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 7,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [44785] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1695), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44838] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1696), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4257), 3,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_SQUOTE,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44923] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1697), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3629), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3627), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44976] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1698), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3455), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3451), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45029] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1699), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [45100] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1700), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3749), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3747), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45153] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1701), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3585), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3583), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45206] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(3847), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1702), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3845), 16,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [45283] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1703), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45336] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1704), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3759), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3757), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45389] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1705), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3597), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3595), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45442] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    STATE(1706), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3765), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3761), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45501] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_EQ,
    ACTIONS(4215), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4217), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1707), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4165), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45588] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    STATE(1708), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3773), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3771), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45647] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1709), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3625), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3623), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45700] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(4259), 1,
      anon_sym_RBRACE,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1710), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45789] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(316), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1711), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45878] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4261), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1712), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45965] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4263), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1713), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46052] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(133), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1714), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46141] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(3847), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1715), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3845), 15,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [46220] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1716), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3285), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46273] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1045), 1,
      anon_sym_RPAREN,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4249), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1717), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46362] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1718), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(997), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(999), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46415] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1719), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 9,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [46480] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(123), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1720), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46569] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4203), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(3643), 2,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4205), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1721), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4193), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46656] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3929), 1,
      anon_sym_EQ,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4203), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4205), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1722), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3927), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46741] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3933), 1,
      anon_sym_EQ,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4203), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4205), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1723), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3931), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46826] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(326), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1724), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46915] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1725), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(991), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(993), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46968] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1726), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3755), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3753), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47021] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(380), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1727), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(378), 14,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [47102] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3937), 1,
      anon_sym_EQ,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4215), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4217), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1728), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3935), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47187] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1729), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3557), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3555), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47240] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1730), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3561), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3559), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47293] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1731), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3565), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3563), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47346] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(342), 1,
      anon_sym_EQ,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4203), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4205), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1732), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(336), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47431] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4265), 1,
      anon_sym_RBRACE,
    ACTIONS(4267), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1733), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47520] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1734), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3569), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3567), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47573] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1735), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3811), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3809), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47626] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1736), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3573), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3571), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47679] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(380), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1737), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(378), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [47760] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4007), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_AMP,
    ACTIONS(4011), 1,
      anon_sym_PIPE,
    ACTIONS(4015), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4017), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4025), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4029), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1738), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4005), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4269), 3,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_SQUOTE,
    ACTIONS(4023), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4019), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47845] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1739), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1546), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1548), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47898] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3953), 1,
      anon_sym_EQ,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4203), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4205), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1740), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3951), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47983] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1741), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3577), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3575), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48036] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1742), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3669), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3667), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48089] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3947), 1,
      anon_sym_EQ,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4203), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4205), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1743), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3945), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48174] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(320), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1744), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48263] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1745), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3665), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3663), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48316] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1746), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3869), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3867), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48369] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1067), 1,
      anon_sym_RPAREN,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4249), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1747), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48458] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1748), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3791), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3789), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48511] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1749), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3879), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3877), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48564] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1750), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3883), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48617] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1751), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1428), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1426), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48670] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1752), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1436), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1434), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48723] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1753), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3657), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3655), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48776] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_EQ,
    ACTIONS(4169), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4271), 1,
      anon_sym_LBRACE,
    STATE(1667), 1,
      sym_match_block,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4171), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1754), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4165), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48865] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3643), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1755), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48952] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(131), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1756), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49041] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(3913), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1757), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3895), 14,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [49122] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(139), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1758), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49211] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1759), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3795), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3793), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49264] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4249), 1,
      anon_sym_COMMA,
    ACTIONS(4273), 1,
      anon_sym_RPAREN,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1760), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49353] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1761), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3807), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3805), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49406] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4275), 1,
      anon_sym_RPAREN,
    ACTIONS(4277), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1762), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49495] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1763), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3289), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3287), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49548] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1764), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [49621] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1765), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3857), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3855), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49674] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3929), 1,
      anon_sym_EQ,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4215), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4217), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1766), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3927), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49759] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1767), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49812] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1768), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3553), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3551), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49865] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1769), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3837), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3835), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49918] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1770), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3621), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3619), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49971] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1771), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3833), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3831), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50024] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1772), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3301), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3299), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50077] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(330), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1773), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50166] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(4279), 1,
      anon_sym_RBRACE,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1774), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50255] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    STATE(1775), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3829), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3827), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50314] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1776), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3613), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3611), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50367] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4281), 1,
      anon_sym_RBRACE,
    ACTIONS(4283), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1777), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50456] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4285), 1,
      anon_sym_SEMI,
    ACTIONS(4287), 1,
      anon_sym_else,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1778), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50545] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1779), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3609), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3607), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50598] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1780), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3593), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3591), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50651] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1781), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1368), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1366), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50704] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1782), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3581), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3579), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50757] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1783), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3799), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3797), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50810] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1784), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1432), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1430), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50863] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1785), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1402), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1400), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50916] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_EQ,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4215), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4217), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1786), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3945), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51001] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1787), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1372), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1370), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51054] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1788), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1326), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1324), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51107] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_SEMI,
    ACTIONS(4291), 1,
      anon_sym_else,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1789), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51196] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1790), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3817), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3815), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51249] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1791), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51302] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1792), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1444), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1442), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51355] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_EQ,
    ACTIONS(4169), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4293), 1,
      anon_sym_LBRACE,
    STATE(1303), 1,
      sym_match_block,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4171), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1793), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4165), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51444] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4295), 1,
      anon_sym_SEMI,
    ACTIONS(4297), 1,
      anon_sym_else,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1794), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51533] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3855), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1795), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51620] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1796), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3645), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3643), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51673] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1797), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3213), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3215), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51726] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1798), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(957), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(959), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51779] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3937), 1,
      anon_sym_EQ,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4203), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4205), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1799), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3935), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51864] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1800), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(817), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(819), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51917] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1801), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1452), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1450), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51970] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1802), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1398), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1396), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52023] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1803), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3601), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3599), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52076] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_EQ,
    ACTIONS(4215), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3643), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4217), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1804), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4165), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52163] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4299), 1,
      anon_sym_SEMI,
    ACTIONS(4301), 1,
      anon_sym_else,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1805), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52252] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1806), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1360), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1358), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52305] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4249), 1,
      anon_sym_COMMA,
    ACTIONS(4303), 1,
      anon_sym_RPAREN,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1807), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52394] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1808), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(785), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(787), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52447] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1809), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3715), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3713), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52500] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1810), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3825), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3823), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52553] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1811), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3589), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3587), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52606] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4203), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(3855), 2,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4205), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1812), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4193), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52693] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1813), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(777), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(779), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52746] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3933), 1,
      anon_sym_EQ,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4215), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4217), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1814), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3931), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52831] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(149), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1815), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52920] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1816), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3633), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3631), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52973] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1817), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3717), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53026] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1818), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3847), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [53099] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1819), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3549), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3547), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53152] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1820), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3637), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3635), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53205] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1821), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1420), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1418), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53258] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(328), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1822), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53347] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1823), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3661), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53400] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(310), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1824), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53489] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1825), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53542] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1190), 1,
      anon_sym_RPAREN,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4249), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1826), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53631] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4305), 1,
      anon_sym_RPAREN,
    ACTIONS(4307), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1827), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53720] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1828), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3787), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3785), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53773] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1829), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3821), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3819), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53826] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(332), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1830), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53915] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1831), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3313), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53968] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1832), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3641), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3639), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54021] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(4309), 1,
      anon_sym_RBRACE,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1833), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54110] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(314), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1834), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54199] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4311), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1835), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54286] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1836), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3853), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3851), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54339] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(318), 1,
      anon_sym_RBRACE,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1837), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54428] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    STATE(1838), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3847), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [54489] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1839), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1364), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1362), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54542] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4313), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1840), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54629] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(4141), 1,
      anon_sym_CARET,
    ACTIONS(4143), 1,
      anon_sym_AMP,
    ACTIONS(4145), 1,
      anon_sym_PIPE,
    ACTIONS(4147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3913), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4149), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4153), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1841), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4127), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4151), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3895), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [54710] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4315), 1,
      anon_sym_RBRACK,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1842), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54796] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4317), 1,
      anon_sym_RBRACK,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1843), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54882] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4249), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1844), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54968] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4319), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1845), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55054] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4321), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1846), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55140] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4323), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4269), 2,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
    ACTIONS(4325), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1847), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4193), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55224] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4131), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1848), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55310] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4327), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1849), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55396] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4329), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1850), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55482] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4331), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1851), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55568] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4333), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1852), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55654] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4335), 1,
      anon_sym_RBRACK,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1853), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55740] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4337), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1854), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55826] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4339), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1855), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55912] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4341), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1856), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55998] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4343), 1,
      anon_sym_RBRACK,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1857), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56084] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(4229), 1,
      anon_sym_STAR,
    ACTIONS(4235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4239), 1,
      sym_metavariable,
    ACTIONS(4345), 1,
      anon_sym_RBRACE,
    STATE(2420), 1,
      sym_scoped_identifier,
    STATE(3207), 1,
      sym__use_clause,
    STATE(3357), 1,
      sym_generic_type_with_turbofish,
    STATE(3515), 1,
      sym_bracketed_type,
    STATE(1858), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4237), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2877), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4231), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [56160] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4245), 1,
      anon_sym_EQ_GT,
    ACTIONS(4323), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4325), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1859), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4193), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56246] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4349), 1,
      anon_sym_RBRACK,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1860), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56332] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4351), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1861), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56418] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4353), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1862), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56504] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4355), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1863), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56590] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4357), 1,
      anon_sym_RBRACK,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1864), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56676] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4359), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1865), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56762] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4361), 1,
      anon_sym_RBRACK,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1866), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56848] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(4229), 1,
      anon_sym_STAR,
    ACTIONS(4235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4239), 1,
      sym_metavariable,
    ACTIONS(4363), 1,
      anon_sym_RBRACE,
    STATE(2420), 1,
      sym_scoped_identifier,
    STATE(3207), 1,
      sym__use_clause,
    STATE(3357), 1,
      sym_generic_type_with_turbofish,
    STATE(3515), 1,
      sym_bracketed_type,
    STATE(1867), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4237), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2877), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4231), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [56924] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4365), 1,
      anon_sym_RBRACK,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1868), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57010] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4367), 1,
      anon_sym_RBRACK,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1869), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57096] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4173), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_QMARK,
    ACTIONS(4181), 1,
      anon_sym_CARET,
    ACTIONS(4183), 1,
      anon_sym_AMP,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4189), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4201), 1,
      anon_sym_DOT,
    ACTIONS(4207), 1,
      anon_sym_as,
    ACTIONS(4323), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4191), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4199), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4257), 2,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
    ACTIONS(4325), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1870), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4177), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4197), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4193), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57180] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4369), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1871), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57266] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4371), 1,
      anon_sym_RBRACK,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1872), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57352] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4373), 1,
      anon_sym_RBRACK,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1873), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57438] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4375), 1,
      anon_sym_SEMI,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1874), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57524] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3763), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_QMARK,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3901), 1,
      anon_sym_CARET,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3905), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3909), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    ACTIONS(4033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4377), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3911), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3917), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4035), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1875), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3899), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3915), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3919), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57610] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(4229), 1,
      anon_sym_STAR,
    ACTIONS(4235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4239), 1,
      sym_metavariable,
    STATE(2420), 1,
      sym_scoped_identifier,
    STATE(3357), 1,
      sym_generic_type_with_turbofish,
    STATE(3515), 1,
      sym_bracketed_type,
    STATE(3572), 1,
      sym__use_clause,
    STATE(1876), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4237), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2877), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4231), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57683] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(4229), 1,
      anon_sym_STAR,
    ACTIONS(4235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4239), 1,
      sym_metavariable,
    STATE(2420), 1,
      sym_scoped_identifier,
    STATE(3357), 1,
      sym_generic_type_with_turbofish,
    STATE(3416), 1,
      sym__use_clause,
    STATE(3515), 1,
      sym_bracketed_type,
    STATE(1877), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4237), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2877), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4231), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57756] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(4229), 1,
      anon_sym_STAR,
    ACTIONS(4235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4239), 1,
      sym_metavariable,
    STATE(2420), 1,
      sym_scoped_identifier,
    STATE(3357), 1,
      sym_generic_type_with_turbofish,
    STATE(3364), 1,
      sym__use_clause,
    STATE(3515), 1,
      sym_bracketed_type,
    STATE(1878), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4237), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2877), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4231), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57829] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(4229), 1,
      anon_sym_STAR,
    ACTIONS(4235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4239), 1,
      sym_metavariable,
    STATE(2420), 1,
      sym_scoped_identifier,
    STATE(3357), 1,
      sym_generic_type_with_turbofish,
    STATE(3360), 1,
      sym__use_clause,
    STATE(3515), 1,
      sym_bracketed_type,
    STATE(1879), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4237), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2877), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4231), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57902] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(4229), 1,
      anon_sym_STAR,
    ACTIONS(4235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4239), 1,
      sym_metavariable,
    STATE(2420), 1,
      sym_scoped_identifier,
    STATE(3207), 1,
      sym__use_clause,
    STATE(3357), 1,
      sym_generic_type_with_turbofish,
    STATE(3515), 1,
      sym_bracketed_type,
    STATE(1880), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4237), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2877), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4231), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57975] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3787), 1,
      anon_sym_where,
    ACTIONS(4379), 1,
      sym_identifier,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    STATE(2966), 1,
      sym_scoped_type_identifier,
    STATE(3135), 1,
      sym_generic_type,
    STATE(3369), 1,
      sym_scoped_identifier,
    STATE(3480), 1,
      sym_generic_type_with_turbofish,
    STATE(3507), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1881), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58049] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3787), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4391), 1,
      sym_identifier,
    STATE(2748), 1,
      sym_scoped_type_identifier,
    STATE(3078), 1,
      sym_generic_type,
    STATE(3369), 1,
      sym_scoped_identifier,
    STATE(3480), 1,
      sym_generic_type_with_turbofish,
    STATE(3507), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1882), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58123] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3787), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4393), 1,
      sym_identifier,
    STATE(3004), 1,
      sym_scoped_type_identifier,
    STATE(3145), 1,
      sym_generic_type,
    STATE(3369), 1,
      sym_scoped_identifier,
    STATE(3480), 1,
      sym_generic_type_with_turbofish,
    STATE(3507), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1883), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58197] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3787), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4395), 1,
      sym_identifier,
    STATE(3024), 1,
      sym_scoped_type_identifier,
    STATE(3038), 1,
      sym_generic_type,
    STATE(3369), 1,
      sym_scoped_identifier,
    STATE(3480), 1,
      sym_generic_type_with_turbofish,
    STATE(3507), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1884), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58271] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3787), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4397), 1,
      sym_identifier,
    STATE(2926), 1,
      sym_scoped_type_identifier,
    STATE(3189), 1,
      sym_generic_type,
    STATE(3369), 1,
      sym_scoped_identifier,
    STATE(3480), 1,
      sym_generic_type_with_turbofish,
    STATE(3507), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1885), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58345] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3787), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4399), 1,
      sym_identifier,
    STATE(2738), 1,
      sym_scoped_type_identifier,
    STATE(3062), 1,
      sym_generic_type,
    STATE(3369), 1,
      sym_scoped_identifier,
    STATE(3480), 1,
      sym_generic_type_with_turbofish,
    STATE(3507), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1886), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58419] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3787), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4401), 1,
      sym_identifier,
    STATE(2755), 1,
      sym_scoped_type_identifier,
    STATE(3089), 1,
      sym_generic_type,
    STATE(3369), 1,
      sym_scoped_identifier,
    STATE(3480), 1,
      sym_generic_type_with_turbofish,
    STATE(3507), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1887), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58493] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3787), 1,
      anon_sym_where,
    ACTIONS(4383), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4389), 1,
      sym_metavariable,
    ACTIONS(4403), 1,
      sym_identifier,
    STATE(2745), 1,
      sym_scoped_type_identifier,
    STATE(3076), 1,
      sym_generic_type,
    STATE(3369), 1,
      sym_scoped_identifier,
    STATE(3480), 1,
      sym_generic_type_with_turbofish,
    STATE(3507), 1,
      sym_bracketed_type,
    ACTIONS(4385), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1888), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4387), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4381), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58567] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1889), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4407), 3,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(4405), 28,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [58613] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1890), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4411), 3,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(4409), 28,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [58659] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1891), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4415), 3,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(4413), 28,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [58705] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2234), 1,
      sym_scoped_identifier,
    STATE(3323), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_generic_type_with_turbofish,
    STATE(3521), 1,
      sym_attribute,
    STATE(1892), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58766] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2234), 1,
      sym_scoped_identifier,
    STATE(3323), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_generic_type_with_turbofish,
    STATE(3481), 1,
      sym_attribute,
    STATE(1893), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58827] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2234), 1,
      sym_scoped_identifier,
    STATE(3323), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_generic_type_with_turbofish,
    STATE(3458), 1,
      sym_attribute,
    STATE(1894), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58888] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2234), 1,
      sym_scoped_identifier,
    STATE(3323), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_generic_type_with_turbofish,
    STATE(3553), 1,
      sym_attribute,
    STATE(1895), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58949] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2234), 1,
      sym_scoped_identifier,
    STATE(3323), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_generic_type_with_turbofish,
    STATE(3454), 1,
      sym_attribute,
    STATE(1896), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59010] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2234), 1,
      sym_scoped_identifier,
    STATE(3323), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_generic_type_with_turbofish,
    STATE(3473), 1,
      sym_attribute,
    STATE(1897), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59071] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2234), 1,
      sym_scoped_identifier,
    STATE(3323), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_generic_type_with_turbofish,
    STATE(3418), 1,
      sym_attribute,
    STATE(1898), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59132] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1880), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_identifier,
    ACTIONS(4423), 1,
      sym_metavariable,
    STATE(2234), 1,
      sym_scoped_identifier,
    STATE(3323), 1,
      sym_bracketed_type,
    STATE(3349), 1,
      sym_generic_type_with_turbofish,
    STATE(3388), 1,
      sym_attribute,
    STATE(1899), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4421), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4419), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59193] = 12,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4425), 1,
      sym_identifier,
    ACTIONS(4429), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      sym_metavariable,
    STATE(3116), 1,
      sym_scoped_identifier,
    STATE(3357), 1,
      sym_generic_type_with_turbofish,
    STATE(3515), 1,
      sym_bracketed_type,
    STATE(1900), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4431), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4427), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59251] = 12,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4429), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4435), 1,
      sym_identifier,
    ACTIONS(4441), 1,
      sym_metavariable,
    STATE(3203), 1,
      sym_scoped_identifier,
    STATE(3357), 1,
      sym_generic_type_with_turbofish,
    STATE(3515), 1,
      sym_bracketed_type,
    STATE(1901), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4439), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4437), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59309] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(785), 1,
      anon_sym_DOT_DOT,
    STATE(1902), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(787), 20,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_else,
      anon_sym_in,
  [59345] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(797), 1,
      anon_sym_DOT_DOT,
    STATE(1903), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(799), 20,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_else,
      anon_sym_in,
  [59381] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3245), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(1904), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59429] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3281), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    STATE(1905), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59466] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3265), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4451), 1,
      anon_sym_COLON_COLON,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(1906), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3263), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59511] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3261), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4451), 1,
      anon_sym_COLON_COLON,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(1907), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3259), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59556] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3293), 1,
      anon_sym_COLON,
    ACTIONS(3297), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    STATE(1908), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59593] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3269), 1,
      anon_sym_COLON,
    ACTIONS(3273), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    STATE(1909), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59630] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4459), 1,
      anon_sym_COLON,
    ACTIONS(4461), 1,
      anon_sym_AT,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4467), 1,
      anon_sym_COLON_COLON,
    STATE(1934), 1,
      sym_type_arguments,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1910), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [59683] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3255), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4451), 1,
      anon_sym_COLON_COLON,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(1911), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3253), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59728] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3305), 1,
      anon_sym_COLON,
    ACTIONS(3309), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    STATE(1912), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3303), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59765] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1913), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 3,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_LT2,
    ACTIONS(3281), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [59801] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(1914), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59841] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(1915), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59881] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(1916), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3299), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59921] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(1917), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59961] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3271), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1918), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 3,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_LT2,
    ACTIONS(3273), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [59997] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3295), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1919), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 3,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_LT2,
    ACTIONS(3297), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60033] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1920), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3303), 3,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_LT2,
    ACTIONS(3309), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60069] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3271), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1921), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60102] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1922), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3281), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60135] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3390), 1,
      anon_sym_COLON,
    STATE(1923), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3388), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60168] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3380), 1,
      anon_sym_COLON,
    STATE(1924), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3378), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60201] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1925), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 18,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [60232] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3473), 1,
      anon_sym_COLON,
    STATE(1926), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3471), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60265] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1927), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3309), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60298] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3505), 1,
      anon_sym_COLON,
    STATE(1928), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3503), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60331] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3295), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1929), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3297), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60364] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4479), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1930), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [60408] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4483), 1,
      anon_sym_const,
    ACTIONS(4485), 1,
      anon_sym_enum,
    ACTIONS(4487), 1,
      anon_sym_fn,
    ACTIONS(4489), 1,
      anon_sym_mod,
    ACTIONS(4491), 1,
      anon_sym_static,
    ACTIONS(4493), 1,
      anon_sym_struct,
    ACTIONS(4495), 1,
      anon_sym_trait,
    ACTIONS(4497), 1,
      anon_sym_type,
    ACTIONS(4499), 1,
      anon_sym_union,
    ACTIONS(4501), 1,
      anon_sym_unsafe,
    ACTIONS(4503), 1,
      anon_sym_use,
    ACTIONS(4505), 1,
      anon_sym_extern,
    STATE(2160), 1,
      sym_extern_modifier,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(3328), 1,
      sym_function_modifiers,
    ACTIONS(4481), 2,
      anon_sym_async,
      anon_sym_default,
    STATE(1931), 2,
      sym_line_comment,
      sym_block_comment,
  [60468] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4507), 1,
      anon_sym_const,
    ACTIONS(4509), 1,
      anon_sym_enum,
    ACTIONS(4511), 1,
      anon_sym_fn,
    ACTIONS(4513), 1,
      anon_sym_mod,
    ACTIONS(4515), 1,
      anon_sym_static,
    ACTIONS(4517), 1,
      anon_sym_struct,
    ACTIONS(4519), 1,
      anon_sym_trait,
    ACTIONS(4521), 1,
      anon_sym_type,
    ACTIONS(4523), 1,
      anon_sym_union,
    ACTIONS(4525), 1,
      anon_sym_unsafe,
    ACTIONS(4527), 1,
      anon_sym_use,
    ACTIONS(4529), 1,
      anon_sym_extern,
    STATE(2145), 1,
      sym_extern_modifier,
    STATE(2224), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(3606), 1,
      sym_function_modifiers,
    ACTIONS(4481), 2,
      anon_sym_async,
      anon_sym_default,
    STATE(1932), 2,
      sym_line_comment,
      sym_block_comment,
  [60528] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3446), 1,
      anon_sym_COLON,
    STATE(1933), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3444), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60560] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3442), 1,
      anon_sym_COLON,
    STATE(1934), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3440), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60592] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3438), 1,
      anon_sym_COLON,
    STATE(1935), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3436), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60624] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1936), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [60670] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1937), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(993), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [60699] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1938), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 3,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_COMMA,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [60742] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4535), 1,
      anon_sym_DASH_GT,
    STATE(1939), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3422), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60773] = 16,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4453), 1,
      anon_sym_PIPE,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4459), 1,
      anon_sym_COLON,
    ACTIONS(4461), 1,
      anon_sym_AT,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4537), 1,
      anon_sym_LPAREN,
    ACTIONS(4539), 1,
      anon_sym_COLON_COLON,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1940), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [60826] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3301), 1,
      anon_sym_COLON,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    STATE(1941), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3299), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60859] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1942), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(999), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [60888] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1943), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1328), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [60917] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3289), 1,
      anon_sym_COLON,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    STATE(1944), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60950] = 16,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4461), 1,
      anon_sym_AT,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_LPAREN,
    ACTIONS(4545), 1,
      anon_sym_RBRACK,
    ACTIONS(4548), 1,
      anon_sym_COLON_COLON,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    ACTIONS(3241), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4453), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1945), 2,
      sym_line_comment,
      sym_block_comment,
  [61003] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1946), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3410), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61032] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1947), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3362), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61061] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4550), 1,
      anon_sym_DASH_GT,
    STATE(1948), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3416), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61092] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3313), 1,
      anon_sym_COLON,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    STATE(1949), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61125] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4552), 1,
      anon_sym_LPAREN,
    STATE(1950), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3979), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [61156] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3313), 1,
      anon_sym_COLON,
    ACTIONS(4554), 1,
      anon_sym_COLON_COLON,
    STATE(1951), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61189] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1952), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3384), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61218] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4556), 1,
      anon_sym_DASH_GT,
    STATE(1953), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3404), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61249] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4558), 1,
      anon_sym_DASH_GT,
    STATE(1954), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3398), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61280] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1955), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3475), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61309] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4560), 1,
      anon_sym_DASH_GT,
    STATE(1956), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3366), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61340] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3285), 1,
      anon_sym_COLON,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    STATE(1957), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61373] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1958), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1414), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [61402] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4562), 1,
      anon_sym_DASH_GT,
    STATE(1959), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3392), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61433] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1960), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3507), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61462] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3241), 1,
      anon_sym_PLUS,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4453), 1,
      anon_sym_PIPE,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4459), 1,
      anon_sym_COLON,
    ACTIONS(4461), 1,
      anon_sym_AT,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4564), 1,
      anon_sym_LPAREN,
    ACTIONS(4566), 1,
      anon_sym_COLON_COLON,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4545), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1961), 2,
      sym_line_comment,
      sym_block_comment,
  [61517] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3313), 1,
      anon_sym_COLON,
    ACTIONS(4568), 1,
      anon_sym_COLON_COLON,
    STATE(1962), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61550] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4570), 1,
      anon_sym_DASH_GT,
    STATE(1963), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3430), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61581] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4459), 1,
      anon_sym_COLON,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4572), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1964), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [61622] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1965), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3587), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61650] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1966), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61678] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1967), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3599), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61706] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1968), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61734] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4574), 1,
      anon_sym_COLON_COLON,
    STATE(1969), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3984), 14,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
  [61764] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1970), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3607), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61792] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1971), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3709), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61820] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1972), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3299), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61848] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1973), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3663), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61876] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4469), 1,
      anon_sym_PIPE,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4576), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1974), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [61920] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1975), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3547), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61948] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1976), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61976] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1977), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3995), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [62004] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3889), 1,
      anon_sym_COLON_COLON,
    STATE(1978), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3984), 14,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
  [62034] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1979), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3591), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62062] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1980), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3579), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62090] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1981), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3647), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62118] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1982), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3999), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [62146] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1983), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3611), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62174] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1984), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62202] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1985), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3603), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62230] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1986), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3713), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62258] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1987), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3623), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62286] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1988), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3675), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62314] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1989), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3619), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62342] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1990), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3671), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62370] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1991), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3595), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62398] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1992), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3989), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [62426] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1993), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3801), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62454] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1994), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62482] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1995), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3667), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62510] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1996), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3647), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62538] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(777), 1,
      anon_sym_DOT_DOT,
    STATE(1997), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(779), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62567] = 16,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4578), 1,
      anon_sym_COLON,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4582), 1,
      anon_sym_GT,
    ACTIONS(4584), 1,
      anon_sym_COMMA,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(2941), 1,
      sym_trait_bounds,
    STATE(2947), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3241), 2,
      anon_sym_PLUS,
      anon_sym_as,
    STATE(1998), 2,
      sym_line_comment,
      sym_block_comment,
  [62618] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4588), 1,
      anon_sym_pat,
    STATE(159), 1,
      sym_fragment_specifier,
    STATE(1999), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4586), 12,
      anon_sym_block,
      anon_sym_expr,
      anon_sym_ident,
      anon_sym_item,
      anon_sym_lifetime,
      anon_sym_literal,
      anon_sym_meta,
      anon_sym_path,
      anon_sym_stmt,
      anon_sym_tt,
      anon_sym_ty,
      anon_sym_vis,
  [62649] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2000), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62684] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(817), 1,
      anon_sym_DOT_DOT,
    STATE(2001), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(819), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62713] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3295), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2002), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4590), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3297), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62745] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2003), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4593), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3281), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62777] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4593), 1,
      anon_sym_LPAREN,
    ACTIONS(3279), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2004), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3281), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62809] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4593), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2005), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3281), 6,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [62841] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4596), 1,
      anon_sym_LPAREN,
    ACTIONS(3271), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2006), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3273), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62873] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2007), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62903] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4601), 1,
      anon_sym_DOT_DOT,
    STATE(2008), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4599), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62931] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4590), 1,
      anon_sym_LPAREN,
    ACTIONS(3295), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2009), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3297), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62963] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4603), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2010), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3303), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3309), 6,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [62995] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4596), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2011), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3273), 6,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [63027] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4606), 1,
      anon_sym_LPAREN,
    ACTIONS(4608), 1,
      anon_sym_LBRACE,
    ACTIONS(4610), 1,
      anon_sym_BANG,
    ACTIONS(4612), 1,
      anon_sym_AT,
    ACTIONS(4614), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4618), 1,
      anon_sym_COLON_COLON,
    STATE(1934), 1,
      sym_type_arguments,
    ACTIONS(4616), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2012), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [63071] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3295), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4590), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2013), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3297), 6,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [63103] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(3307), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2014), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3303), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3309), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [63135] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2015), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3303), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4603), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3309), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [63167] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3271), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2016), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4596), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3273), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [63199] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4622), 1,
      anon_sym_DOT_DOT,
    STATE(2017), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4620), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [63227] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4626), 1,
      anon_sym_GT,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2018), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63272] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4632), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2019), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63317] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4634), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2020), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63362] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4636), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2021), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63407] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4638), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2022), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63452] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4640), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2023), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63497] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4642), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2024), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63542] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4644), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2025), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63587] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4646), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2026), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63632] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4648), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2027), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63677] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4650), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2028), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63722] = 10,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4495), 1,
      anon_sym_trait,
    ACTIONS(4652), 1,
      anon_sym_impl,
    STATE(391), 1,
      sym_block,
    STATE(3414), 1,
      sym_label,
    STATE(2029), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [63759] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4654), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2030), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63804] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4656), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2031), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63849] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4658), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2655), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2032), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63894] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    ACTIONS(4660), 1,
      anon_sym_GT,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2033), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63939] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4662), 1,
      sym_identifier,
    ACTIONS(4664), 1,
      sym_metavariable,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2073), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2368), 1,
      sym_lifetime,
    STATE(2555), 1,
      sym_constrained_type_parameter,
    STATE(2034), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2973), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63981] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4666), 1,
      sym_identifier,
    ACTIONS(4668), 1,
      anon_sym_RBRACE,
    ACTIONS(4670), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4672), 1,
      anon_sym_COMMA,
    ACTIONS(4674), 1,
      sym_integer_literal,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2438), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2035), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2963), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [64021] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3295), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2036), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3297), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [64049] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2037), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1206), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64073] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2038), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3309), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [64101] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4676), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(2039), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64139] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1312), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4680), 1,
      sym_crate,
    STATE(2203), 1,
      sym_string_literal,
    STATE(2040), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4678), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64169] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1312), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4682), 1,
      sym_crate,
    STATE(2203), 1,
      sym_string_literal,
    STATE(2041), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4678), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64199] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4684), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(2042), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64237] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2043), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1240), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64261] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4688), 1,
      anon_sym_COLON,
    ACTIONS(4690), 1,
      anon_sym_COLON_COLON,
    STATE(2044), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64289] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4574), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4688), 1,
      anon_sym_COLON,
    STATE(2045), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64317] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1312), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4692), 1,
      sym_crate,
    STATE(2203), 1,
      sym_string_literal,
    STATE(2046), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4678), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64347] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2047), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1232), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64371] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2048), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1236), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64395] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4624), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4630), 1,
      sym_metavariable,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2050), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2574), 1,
      sym_lifetime,
    STATE(2959), 1,
      sym_constrained_type_parameter,
    STATE(2049), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3140), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64437] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4694), 1,
      sym_identifier,
    ACTIONS(4696), 1,
      sym_metavariable,
    STATE(1069), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2721), 1,
      sym_lifetime,
    STATE(2864), 1,
      sym_constrained_type_parameter,
    STATE(2050), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3304), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64479] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4698), 1,
      sym_identifier,
    ACTIONS(4700), 1,
      sym_metavariable,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2052), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2443), 1,
      sym_lifetime,
    STATE(2718), 1,
      sym_constrained_type_parameter,
    STATE(2051), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2751), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64521] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4702), 1,
      sym_identifier,
    ACTIONS(4704), 1,
      sym_metavariable,
    STATE(1069), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2432), 1,
      sym_lifetime,
    STATE(2661), 1,
      sym_constrained_type_parameter,
    STATE(2052), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2818), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64563] = 9,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4706), 1,
      anon_sym_move,
    STATE(397), 1,
      sym_block,
    STATE(3414), 1,
      sym_label,
    STATE(2053), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64597] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4666), 1,
      sym_identifier,
    ACTIONS(4670), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4674), 1,
      sym_integer_literal,
    ACTIONS(4708), 1,
      anon_sym_RBRACE,
    ACTIONS(4710), 1,
      anon_sym_COMMA,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2438), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2054), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2741), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [64637] = 9,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4712), 1,
      sym_identifier,
    STATE(399), 1,
      sym_block,
    STATE(3414), 1,
      sym_label,
    STATE(2055), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64671] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4688), 1,
      anon_sym_COLON,
    ACTIONS(4716), 1,
      anon_sym_COLON_COLON,
    STATE(2056), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64699] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2057), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [64737] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4718), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(2058), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64775] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4720), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(2059), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64813] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2060), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1244), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64837] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4722), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(2061), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64875] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4724), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(2062), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64913] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3275), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2063), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3281), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [64941] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4726), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(2064), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64979] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4730), 1,
      anon_sym_COLON,
    ACTIONS(4732), 1,
      anon_sym_COLON_COLON,
    STATE(2065), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4728), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65007] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4690), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4736), 1,
      anon_sym_COLON,
    STATE(2066), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4734), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65035] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3271), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3267), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2067), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [65063] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4574), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4736), 1,
      anon_sym_COLON,
    STATE(2068), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4734), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65091] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1312), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4738), 1,
      sym_crate,
    STATE(2203), 1,
      sym_string_literal,
    STATE(2069), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4678), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [65121] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4662), 1,
      sym_identifier,
    ACTIONS(4664), 1,
      sym_metavariable,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2073), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2441), 1,
      sym_lifetime,
    STATE(2555), 1,
      sym_constrained_type_parameter,
    STATE(2070), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2973), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [65163] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4716), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4736), 1,
      anon_sym_COLON,
    STATE(2071), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4734), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65191] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3245), 1,
      anon_sym_COLON,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4740), 1,
      anon_sym_EQ,
    STATE(1939), 1,
      sym_parameters,
    STATE(2330), 1,
      sym_type_arguments,
    STATE(2072), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 3,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_COMMA,
  [65231] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(2957), 1,
      anon_sym_SQUOTE,
    ACTIONS(4628), 1,
      anon_sym_const,
    ACTIONS(4742), 1,
      sym_identifier,
    ACTIONS(4744), 1,
      sym_metavariable,
    STATE(1069), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2412), 1,
      sym_lifetime,
    STATE(2564), 1,
      sym_constrained_type_parameter,
    STATE(2073), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2952), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [65273] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4732), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4748), 1,
      anon_sym_COLON,
    STATE(2074), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4746), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65301] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4750), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1939), 1,
      sym_parameters,
    STATE(2075), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3241), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [65339] = 13,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_RBRACE,
    ACTIONS(4756), 1,
      anon_sym_COMMA,
    ACTIONS(4758), 1,
      sym_crate,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2187), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2805), 1,
      sym_enum_variant,
    STATE(3407), 1,
      sym_visibility_modifier,
    STATE(2076), 2,
      sym_line_comment,
      sym_block_comment,
  [65380] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4666), 1,
      sym_identifier,
    ACTIONS(4670), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4674), 1,
      sym_integer_literal,
    ACTIONS(4760), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2438), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2077), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3215), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [65417] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    ACTIONS(4081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4762), 1,
      anon_sym_BANG,
    STATE(1611), 1,
      sym_type_arguments,
    STATE(2078), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [65448] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2079), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4764), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65471] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2080), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4766), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65494] = 13,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4768), 1,
      sym_identifier,
    ACTIONS(4770), 1,
      anon_sym_RBRACE,
    ACTIONS(4772), 1,
      anon_sym_COMMA,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2179), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2835), 1,
      sym_field_declaration,
    STATE(3555), 1,
      sym_visibility_modifier,
    STATE(2081), 2,
      sym_line_comment,
      sym_block_comment,
  [65535] = 13,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4768), 1,
      sym_identifier,
    ACTIONS(4774), 1,
      anon_sym_RBRACE,
    ACTIONS(4776), 1,
      anon_sym_COMMA,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2197), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2997), 1,
      sym_field_declaration,
    STATE(3555), 1,
      sym_visibility_modifier,
    STATE(2082), 2,
      sym_line_comment,
      sym_block_comment,
  [65576] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2083), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4778), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65599] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2084), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4780), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65622] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2085), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4782), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65645] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2086), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4784), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65668] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2087), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65691] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2088), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4786), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65714] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2089), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4788), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65737] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2090), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4790), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65760] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2091), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4792), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65783] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2092), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4734), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65806] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4568), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    STATE(2093), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [65837] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2094), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4794), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65860] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2095), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4796), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65883] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2096), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4798), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65906] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2097), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4800), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65929] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2098), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4802), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65952] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2099), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4804), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65975] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2100), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4806), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65998] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2101), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4808), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66021] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2102), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4810), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66044] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2103), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4812), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66067] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2104), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4814), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66090] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2105), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1450), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66113] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4666), 1,
      sym_identifier,
    ACTIONS(4670), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4674), 1,
      sym_integer_literal,
    ACTIONS(4816), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2438), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2106), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3215), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [66150] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2107), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4818), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66173] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2108), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4820), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66196] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2109), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4822), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66219] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2110), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4824), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66242] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2111), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4826), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66265] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2112), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4828), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66288] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4666), 1,
      sym_identifier,
    ACTIONS(4670), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4674), 1,
      sym_integer_literal,
    ACTIONS(4830), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2438), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2113), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3215), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [66325] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2114), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4832), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66348] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2115), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4834), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66371] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2116), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66394] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2117), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4836), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66417] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4838), 1,
      anon_sym_BANG,
    ACTIONS(4840), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4844), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    ACTIONS(4842), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2118), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [66452] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1564), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(2105), 1,
      sym_block,
    STATE(3588), 1,
      sym_label,
    STATE(2119), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [66483] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2120), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4846), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66506] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2121), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4848), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66529] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4666), 1,
      sym_identifier,
    ACTIONS(4670), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4674), 1,
      sym_integer_literal,
    ACTIONS(4850), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2438), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2122), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3215), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [66566] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(3467), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4852), 1,
      anon_sym_BANG,
    STATE(1068), 1,
      sym_type_arguments,
    STATE(2123), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [66597] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2124), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 3,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [66632] = 13,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4854), 1,
      anon_sym_RBRACE,
    ACTIONS(4856), 1,
      anon_sym_COMMA,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2215), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2918), 1,
      sym_enum_variant,
    STATE(3407), 1,
      sym_visibility_modifier,
    STATE(2125), 2,
      sym_line_comment,
      sym_block_comment,
  [66673] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4459), 1,
      anon_sym_COLON,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4858), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2126), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [66708] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4860), 1,
      anon_sym_LBRACE,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(2127), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 5,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [66741] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4666), 1,
      sym_identifier,
    ACTIONS(4670), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4674), 1,
      sym_integer_literal,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2438), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2128), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3215), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [66775] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4533), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4862), 1,
      anon_sym_RBRACK,
    ACTIONS(3311), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4469), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2129), 2,
      sym_line_comment,
      sym_block_comment,
  [66807] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4768), 1,
      sym_identifier,
    ACTIONS(4865), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2218), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3260), 1,
      sym_field_declaration,
    STATE(3555), 1,
      sym_visibility_modifier,
    STATE(2130), 2,
      sym_line_comment,
      sym_block_comment,
  [66845] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4869), 1,
      anon_sym_PLUS,
    STATE(2131), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_trait_bounds_repeat1,
    ACTIONS(4867), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [66869] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4872), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2183), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3249), 1,
      sym_enum_variant,
    STATE(3407), 1,
      sym_visibility_modifier,
    STATE(2132), 2,
      sym_line_comment,
      sym_block_comment,
  [66907] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4874), 1,
      anon_sym_LPAREN,
    ACTIONS(4879), 1,
      anon_sym_LBRACK,
    ACTIONS(4882), 1,
      anon_sym_LBRACE,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(3380), 1,
      sym_macro_rule,
    ACTIONS(4877), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(2133), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_macro_definition_repeat1,
  [66939] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4887), 1,
      anon_sym_PLUS,
    STATE(2131), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2134), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4885), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [66965] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4889), 1,
      anon_sym_SEMI,
    ACTIONS(4891), 1,
      anon_sym_LPAREN,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(4897), 1,
      anon_sym_where,
    STATE(583), 1,
      sym_field_declaration_list,
    STATE(2276), 1,
      sym_type_parameters,
    STATE(3001), 1,
      sym_ordered_field_declaration_list,
    STATE(3077), 1,
      sym_where_clause,
    STATE(2135), 2,
      sym_line_comment,
      sym_block_comment,
  [67003] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4606), 1,
      anon_sym_LPAREN,
    ACTIONS(4610), 1,
      anon_sym_BANG,
    ACTIONS(4614), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4899), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4616), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2136), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [67035] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4901), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2137), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 3,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [67067] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4891), 1,
      anon_sym_LPAREN,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_SEMI,
    STATE(639), 1,
      sym_field_declaration_list,
    STATE(2277), 1,
      sym_type_parameters,
    STATE(3006), 1,
      sym_ordered_field_declaration_list,
    STATE(3061), 1,
      sym_where_clause,
    STATE(2138), 2,
      sym_line_comment,
      sym_block_comment,
  [67105] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4905), 1,
      anon_sym_SEMI,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1359), 1,
      sym_declaration_list,
    STATE(2139), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67133] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4768), 1,
      sym_identifier,
    ACTIONS(4909), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2218), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3260), 1,
      sym_field_declaration,
    STATE(3555), 1,
      sym_visibility_modifier,
    STATE(2140), 2,
      sym_line_comment,
      sym_block_comment,
  [67171] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4911), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2183), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3249), 1,
      sym_enum_variant,
    STATE(3407), 1,
      sym_visibility_modifier,
    STATE(2141), 2,
      sym_line_comment,
      sym_block_comment,
  [67209] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4913), 1,
      anon_sym_SEMI,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(708), 1,
      sym_declaration_list,
    STATE(2142), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67237] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4891), 1,
      anon_sym_LPAREN,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4917), 1,
      anon_sym_SEMI,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1299), 1,
      sym_field_declaration_list,
    STATE(2286), 1,
      sym_type_parameters,
    STATE(2743), 1,
      sym_ordered_field_declaration_list,
    STATE(3034), 1,
      sym_where_clause,
    STATE(2143), 2,
      sym_line_comment,
      sym_block_comment,
  [67275] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4921), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    STATE(2144), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67303] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4923), 1,
      anon_sym_SEMI,
    STATE(1284), 1,
      sym_declaration_list,
    STATE(2145), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67331] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4469), 1,
      anon_sym_PIPE,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2146), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [67363] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4925), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(2147), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67395] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4768), 1,
      sym_identifier,
    ACTIONS(4927), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2218), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3260), 1,
      sym_field_declaration,
    STATE(3555), 1,
      sym_visibility_modifier,
    STATE(2148), 2,
      sym_line_comment,
      sym_block_comment,
  [67433] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4929), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(2149), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67465] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3311), 1,
      anon_sym_PLUS,
    ACTIONS(4469), 1,
      anon_sym_PIPE,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4862), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2150), 2,
      sym_line_comment,
      sym_block_comment,
  [67499] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    ACTIONS(4931), 1,
      anon_sym_COLON_COLON,
    STATE(1611), 1,
      sym_type_arguments,
    STATE(2151), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67527] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4469), 1,
      anon_sym_PIPE,
    ACTIONS(4471), 1,
      anon_sym_COLON,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4576), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    ACTIONS(4477), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2152), 2,
      sym_line_comment,
      sym_block_comment,
  [67563] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4891), 1,
      anon_sym_LPAREN,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    ACTIONS(4933), 1,
      anon_sym_SEMI,
    STATE(1186), 1,
      sym_field_declaration_list,
    STATE(2236), 1,
      sym_type_parameters,
    STATE(2857), 1,
      sym_ordered_field_declaration_list,
    STATE(3265), 1,
      sym_where_clause,
    STATE(2153), 2,
      sym_line_comment,
      sym_block_comment,
  [67601] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4935), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(2154), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67633] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4937), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(2155), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67665] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 1,
      anon_sym_DOT_DOT,
    STATE(2156), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3309), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [67689] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4939), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2183), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3249), 1,
      sym_enum_variant,
    STATE(3407), 1,
      sym_visibility_modifier,
    STATE(2157), 2,
      sym_line_comment,
      sym_block_comment,
  [67727] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4941), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(2158), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67759] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(4943), 1,
      anon_sym_COLON_COLON,
    STATE(1068), 1,
      sym_type_arguments,
    STATE(2159), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67787] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4945), 1,
      anon_sym_SEMI,
    STATE(543), 1,
      sym_declaration_list,
    STATE(2160), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67815] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4947), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2183), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3249), 1,
      sym_enum_variant,
    STATE(3407), 1,
      sym_visibility_modifier,
    STATE(2161), 2,
      sym_line_comment,
      sym_block_comment,
  [67853] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4949), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(2162), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67885] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4768), 1,
      sym_identifier,
    ACTIONS(4951), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2218), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3260), 1,
      sym_field_declaration,
    STATE(3555), 1,
      sym_visibility_modifier,
    STATE(2163), 2,
      sym_line_comment,
      sym_block_comment,
  [67923] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4953), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2183), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3249), 1,
      sym_enum_variant,
    STATE(3407), 1,
      sym_visibility_modifier,
    STATE(2164), 2,
      sym_line_comment,
      sym_block_comment,
  [67961] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 1,
      anon_sym_DOT_DOT,
    STATE(2165), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3281), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [67985] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4887), 1,
      anon_sym_PLUS,
    STATE(2134), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2166), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4955), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [68011] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3271), 1,
      anon_sym_DOT_DOT,
    STATE(2167), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [68035] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4957), 1,
      anon_sym_PLUS,
    STATE(2134), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2168), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4955), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [68061] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4959), 1,
      anon_sym_PLUS,
    STATE(2134), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2169), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4955), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [68087] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4768), 1,
      sym_identifier,
    ACTIONS(4961), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2218), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3260), 1,
      sym_field_declaration,
    STATE(3555), 1,
      sym_visibility_modifier,
    STATE(2170), 2,
      sym_line_comment,
      sym_block_comment,
  [68125] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3295), 1,
      anon_sym_DOT_DOT,
    STATE(2171), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3297), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [68149] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4963), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2183), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3249), 1,
      sym_enum_variant,
    STATE(3407), 1,
      sym_visibility_modifier,
    STATE(2172), 2,
      sym_line_comment,
      sym_block_comment,
  [68187] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4965), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(2173), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [68219] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4768), 1,
      sym_identifier,
    ACTIONS(4967), 1,
      anon_sym_RBRACE,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2218), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3260), 1,
      sym_field_declaration,
    STATE(3555), 1,
      sym_visibility_modifier,
    STATE(2174), 2,
      sym_line_comment,
      sym_block_comment,
  [68257] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4969), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1948), 1,
      sym_parameters,
    STATE(2175), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [68289] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4971), 1,
      anon_sym_SEMI,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    STATE(1348), 1,
      sym_block,
    STATE(2482), 1,
      sym_where_clause,
    STATE(3595), 1,
      sym_label,
    STATE(2176), 2,
      sym_line_comment,
      sym_block_comment,
  [68324] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(4979), 1,
      anon_sym_LT,
    STATE(1100), 1,
      sym_declaration_list,
    STATE(2373), 1,
      sym_type_parameters,
    STATE(2567), 1,
      sym_trait_bounds,
    STATE(3146), 1,
      sym_where_clause,
    STATE(2177), 2,
      sym_line_comment,
      sym_block_comment,
  [68359] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(4979), 1,
      anon_sym_LT,
    STATE(749), 1,
      sym_declaration_list,
    STATE(2382), 1,
      sym_type_parameters,
    STATE(2508), 1,
      sym_trait_bounds,
    STATE(3179), 1,
      sym_where_clause,
    STATE(2178), 2,
      sym_line_comment,
      sym_block_comment,
  [68394] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4768), 1,
      sym_identifier,
    STATE(1069), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2928), 1,
      sym_field_declaration,
    STATE(3555), 1,
      sym_visibility_modifier,
    STATE(2179), 2,
      sym_line_comment,
      sym_block_comment,
  [68429] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(4981), 1,
      anon_sym_SEMI,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    STATE(666), 1,
      sym_block,
    STATE(2403), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_label,
    STATE(2180), 2,
      sym_line_comment,
      sym_block_comment,
  [68464] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(4985), 1,
      anon_sym_SEMI,
    STATE(1382), 1,
      sym_block,
    STATE(2486), 1,
      sym_where_clause,
    STATE(3595), 1,
      sym_label,
    STATE(2181), 2,
      sym_line_comment,
      sym_block_comment,
  [68499] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(4987), 1,
      anon_sym_SEMI,
    STATE(1367), 1,
      sym_block,
    STATE(2483), 1,
      sym_where_clause,
    STATE(3595), 1,
      sym_label,
    STATE(2182), 2,
      sym_line_comment,
      sym_block_comment,
  [68534] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4758), 1,
      sym_crate,
    STATE(1069), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(3213), 1,
      sym_enum_variant,
    STATE(3407), 1,
      sym_visibility_modifier,
    STATE(2183), 2,
      sym_line_comment,
      sym_block_comment,
  [68569] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(4989), 1,
      anon_sym_SEMI,
    ACTIONS(4991), 1,
      anon_sym_DASH_GT,
    STATE(725), 1,
      sym_block,
    STATE(2431), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_label,
    STATE(2184), 2,
      sym_line_comment,
      sym_block_comment,
  [68604] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(4979), 1,
      anon_sym_LT,
    STATE(1195), 1,
      sym_declaration_list,
    STATE(2356), 1,
      sym_type_parameters,
    STATE(2632), 1,
      sym_trait_bounds,
    STATE(3258), 1,
      sym_where_clause,
    STATE(2185), 2,
      sym_line_comment,
      sym_block_comment,
  [68639] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(4993), 1,
      anon_sym_SEMI,
    ACTIONS(4995), 1,
      anon_sym_DASH_GT,
    STATE(1230), 1,
      sym_block,
    STATE(2435), 1,
      sym_where_clause,
    STATE(3595), 1,
      sym_label,
    STATE(2186), 2,
      sym_line_comment,
      sym_block_comment,
  [68674] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4758), 1,
      sym_crate,
    STATE(1069), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2906), 1,
      sym_enum_variant,
    STATE(3407), 1,
      sym_visibility_modifier,
    STATE(2187), 2,
      sym_line_comment,
      sym_block_comment,
  [68709] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4768), 1,
      sym_identifier,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2218), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3260), 1,
      sym_field_declaration,
    STATE(3555), 1,
      sym_visibility_modifier,
    STATE(2188), 2,
      sym_line_comment,
      sym_block_comment,
  [68744] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(4997), 1,
      anon_sym_SEMI,
    STATE(505), 1,
      sym_block,
    STATE(2458), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_label,
    STATE(2189), 2,
      sym_line_comment,
      sym_block_comment,
  [68779] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5002), 1,
      anon_sym_fn,
    ACTIONS(5004), 1,
      anon_sym_extern,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(2190), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(4999), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
  [68806] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5007), 1,
      anon_sym_SEMI,
    ACTIONS(5009), 1,
      anon_sym_DASH_GT,
    STATE(1468), 1,
      sym_block,
    STATE(2489), 1,
      sym_where_clause,
    STATE(3595), 1,
      sym_label,
    STATE(2191), 2,
      sym_line_comment,
      sym_block_comment,
  [68841] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5013), 1,
      anon_sym_RBRACE,
    ACTIONS(5015), 1,
      anon_sym_COMMA,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    STATE(2192), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2784), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [68874] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(4979), 1,
      anon_sym_LT,
    STATE(685), 1,
      sym_declaration_list,
    STATE(2336), 1,
      sym_type_parameters,
    STATE(2672), 1,
      sym_trait_bounds,
    STATE(3291), 1,
      sym_where_clause,
    STATE(2193), 2,
      sym_line_comment,
      sym_block_comment,
  [68909] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1312), 1,
      aux_sym_string_literal_token1,
    STATE(2203), 1,
      sym_string_literal,
    STATE(2194), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4678), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [68934] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5021), 1,
      anon_sym_SEMI,
    STATE(1331), 1,
      sym_block,
    STATE(2491), 1,
      sym_where_clause,
    STATE(3595), 1,
      sym_label,
    STATE(2195), 2,
      sym_line_comment,
      sym_block_comment,
  [68969] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_SEMI,
    ACTIONS(5025), 1,
      anon_sym_DASH_GT,
    STATE(553), 1,
      sym_block,
    STATE(2415), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_label,
    STATE(2196), 2,
      sym_line_comment,
      sym_block_comment,
  [69004] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4768), 1,
      sym_identifier,
    STATE(1069), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2929), 1,
      sym_field_declaration,
    STATE(3555), 1,
      sym_visibility_modifier,
    STATE(2197), 2,
      sym_line_comment,
      sym_block_comment,
  [69039] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5027), 1,
      anon_sym_SEMI,
    STATE(1342), 1,
      sym_block,
    STATE(2468), 1,
      sym_where_clause,
    STATE(3595), 1,
      sym_label,
    STATE(2198), 2,
      sym_line_comment,
      sym_block_comment,
  [69074] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    ACTIONS(5029), 1,
      anon_sym_RBRACE,
    ACTIONS(5031), 1,
      anon_sym_COMMA,
    STATE(2199), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2780), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [69107] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5033), 1,
      anon_sym_SEMI,
    ACTIONS(5035), 1,
      anon_sym_DASH_GT,
    STATE(1155), 1,
      sym_block,
    STATE(2416), 1,
      sym_where_clause,
    STATE(3595), 1,
      sym_label,
    STATE(2200), 2,
      sym_line_comment,
      sym_block_comment,
  [69142] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(4453), 1,
      anon_sym_PIPE,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4459), 1,
      anon_sym_COLON,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5037), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2201), 2,
      sym_line_comment,
      sym_block_comment,
  [69175] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(4979), 1,
      anon_sym_LT,
    ACTIONS(5039), 1,
      anon_sym_SEMI,
    ACTIONS(5041), 1,
      anon_sym_EQ,
    STATE(2294), 1,
      sym_type_parameters,
    STATE(2930), 1,
      sym_trait_bounds,
    STATE(3574), 1,
      sym_where_clause,
    STATE(2202), 2,
      sym_line_comment,
      sym_block_comment,
  [69210] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2203), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5043), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69231] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4758), 1,
      sym_crate,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2183), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3249), 1,
      sym_enum_variant,
    STATE(3407), 1,
      sym_visibility_modifier,
    STATE(2204), 2,
      sym_line_comment,
      sym_block_comment,
  [69266] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5045), 1,
      anon_sym_SEMI,
    STATE(705), 1,
      sym_block,
    STATE(2399), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_label,
    STATE(2205), 2,
      sym_line_comment,
      sym_block_comment,
  [69301] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    ACTIONS(5047), 1,
      anon_sym_RBRACE,
    ACTIONS(5049), 1,
      anon_sym_COMMA,
    STATE(2206), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2757), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [69334] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5051), 1,
      anon_sym_SEMI,
    ACTIONS(5053), 1,
      anon_sym_DASH_GT,
    STATE(582), 1,
      sym_block,
    STATE(2391), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_label,
    STATE(2207), 2,
      sym_line_comment,
      sym_block_comment,
  [69369] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4732), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4838), 1,
      anon_sym_BANG,
    STATE(2208), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69394] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5055), 1,
      anon_sym_SEMI,
    ACTIONS(5057), 1,
      anon_sym_DASH_GT,
    STATE(1448), 1,
      sym_block,
    STATE(2463), 1,
      sym_where_clause,
    STATE(3595), 1,
      sym_label,
    STATE(2209), 2,
      sym_line_comment,
      sym_block_comment,
  [69429] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5059), 1,
      anon_sym_SEMI,
    STATE(739), 1,
      sym_block,
    STATE(2410), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_label,
    STATE(2210), 2,
      sym_line_comment,
      sym_block_comment,
  [69464] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(4979), 1,
      anon_sym_LT,
    STATE(1298), 1,
      sym_declaration_list,
    STATE(2295), 1,
      sym_type_parameters,
    STATE(2724), 1,
      sym_trait_bounds,
    STATE(3043), 1,
      sym_where_clause,
    STATE(2211), 2,
      sym_line_comment,
      sym_block_comment,
  [69499] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5061), 1,
      anon_sym_SEMI,
    ACTIONS(5063), 1,
      anon_sym_DASH_GT,
    STATE(1333), 1,
      sym_block,
    STATE(2460), 1,
      sym_where_clause,
    STATE(3595), 1,
      sym_label,
    STATE(2212), 2,
      sym_line_comment,
      sym_block_comment,
  [69534] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5065), 1,
      anon_sym_SEMI,
    ACTIONS(5067), 1,
      anon_sym_DASH_GT,
    STATE(528), 1,
      sym_block,
    STATE(2407), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_label,
    STATE(2213), 2,
      sym_line_comment,
      sym_block_comment,
  [69569] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4519), 1,
      anon_sym_trait,
    ACTIONS(5069), 1,
      anon_sym_impl,
    STATE(2214), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69594] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym_identifier,
    ACTIONS(4758), 1,
      sym_crate,
    STATE(1069), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2961), 1,
      sym_enum_variant,
    STATE(3407), 1,
      sym_visibility_modifier,
    STATE(2215), 2,
      sym_line_comment,
      sym_block_comment,
  [69629] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    ACTIONS(5071), 1,
      anon_sym_RBRACE,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    STATE(2216), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2810), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [69662] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5075), 1,
      anon_sym_SEMI,
    STATE(1225), 1,
      sym_block,
    STATE(2442), 1,
      sym_where_clause,
    STATE(3595), 1,
      sym_label,
    STATE(2217), 2,
      sym_line_comment,
      sym_block_comment,
  [69697] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym_crate,
    ACTIONS(4768), 1,
      sym_identifier,
    STATE(1069), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(3201), 1,
      sym_field_declaration,
    STATE(3555), 1,
      sym_visibility_modifier,
    STATE(2218), 2,
      sym_line_comment,
      sym_block_comment,
  [69732] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2219), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4867), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69753] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(4979), 1,
      anon_sym_LT,
    STATE(603), 1,
      sym_declaration_list,
    STATE(2307), 1,
      sym_type_parameters,
    STATE(2501), 1,
      sym_trait_bounds,
    STATE(3071), 1,
      sym_where_clause,
    STATE(2220), 2,
      sym_line_comment,
      sym_block_comment,
  [69788] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2221), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4867), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69809] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(4979), 1,
      anon_sym_LT,
    ACTIONS(5077), 1,
      anon_sym_SEMI,
    ACTIONS(5079), 1,
      anon_sym_EQ,
    STATE(2306), 1,
      sym_type_parameters,
    STATE(3007), 1,
      sym_trait_bounds,
    STATE(3581), 1,
      sym_where_clause,
    STATE(2222), 2,
      sym_line_comment,
      sym_block_comment,
  [69844] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2223), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4867), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69865] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5081), 1,
      anon_sym_fn,
    ACTIONS(5083), 1,
      anon_sym_extern,
    STATE(2190), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2351), 1,
      sym_extern_modifier,
    STATE(2224), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4481), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
  [69894] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2225), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4867), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69915] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5085), 1,
      anon_sym_SEMI,
    ACTIONS(5087), 1,
      anon_sym_DASH_GT,
    STATE(550), 1,
      sym_block,
    STATE(2467), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_label,
    STATE(2226), 2,
      sym_line_comment,
      sym_block_comment,
  [69950] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2227), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4867), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69971] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5089), 1,
      anon_sym_SEMI,
    ACTIONS(5091), 1,
      anon_sym_DASH_GT,
    STATE(1110), 1,
      sym_block,
    STATE(2406), 1,
      sym_where_clause,
    STATE(3595), 1,
      sym_label,
    STATE(2228), 2,
      sym_line_comment,
      sym_block_comment,
  [70006] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5093), 1,
      anon_sym_SEMI,
    STATE(698), 1,
      sym_block,
    STATE(2485), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_label,
    STATE(2229), 2,
      sym_line_comment,
      sym_block_comment,
  [70041] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5095), 1,
      anon_sym_SEMI,
    STATE(534), 1,
      sym_block,
    STATE(2473), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_label,
    STATE(2230), 2,
      sym_line_comment,
      sym_block_comment,
  [70076] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5097), 1,
      anon_sym_SEMI,
    ACTIONS(5099), 1,
      anon_sym_DASH_GT,
    STATE(743), 1,
      sym_block,
    STATE(2396), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_label,
    STATE(2231), 2,
      sym_line_comment,
      sym_block_comment,
  [70111] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_RPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    STATE(2133), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3184), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2232), 2,
      sym_line_comment,
      sym_block_comment,
  [70143] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    ACTIONS(5109), 1,
      anon_sym_RBRACE,
    STATE(2233), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3259), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70173] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4716), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5111), 1,
      anon_sym_LPAREN,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5115), 1,
      anon_sym_RBRACK,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    ACTIONS(5119), 1,
      anon_sym_EQ,
    STATE(3368), 1,
      sym_delim_token_tree,
    STATE(2234), 2,
      sym_line_comment,
      sym_block_comment,
  [70205] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4574), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5111), 1,
      anon_sym_LPAREN,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5115), 1,
      anon_sym_RBRACK,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    ACTIONS(5119), 1,
      anon_sym_EQ,
    STATE(3368), 1,
      sym_delim_token_tree,
    STATE(2235), 2,
      sym_line_comment,
      sym_block_comment,
  [70237] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4891), 1,
      anon_sym_LPAREN,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    ACTIONS(5121), 1,
      anon_sym_SEMI,
    STATE(1103), 1,
      sym_field_declaration_list,
    STATE(2945), 1,
      sym_ordered_field_declaration_list,
    STATE(3149), 1,
      sym_where_clause,
    STATE(2236), 2,
      sym_line_comment,
      sym_block_comment,
  [70269] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_RBRACK,
    STATE(2274), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3209), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2237), 2,
      sym_line_comment,
      sym_block_comment,
  [70301] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_RPAREN,
    STATE(2273), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3212), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2238), 2,
      sym_line_comment,
      sym_block_comment,
  [70333] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4690), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5111), 1,
      anon_sym_LPAREN,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5115), 1,
      anon_sym_RBRACK,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    ACTIONS(5119), 1,
      anon_sym_EQ,
    STATE(3368), 1,
      sym_delim_token_tree,
    STATE(2239), 2,
      sym_line_comment,
      sym_block_comment,
  [70365] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4732), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5111), 1,
      anon_sym_LPAREN,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    ACTIONS(5125), 1,
      anon_sym_RBRACK,
    ACTIONS(5127), 1,
      anon_sym_EQ,
    STATE(3363), 1,
      sym_delim_token_tree,
    STATE(2240), 2,
      sym_line_comment,
      sym_block_comment,
  [70397] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5131), 1,
      anon_sym_STAR,
    STATE(3015), 1,
      sym_use_list,
    STATE(3106), 1,
      sym_type_arguments,
    ACTIONS(5129), 2,
      sym_identifier,
      sym_super,
    STATE(2241), 2,
      sym_line_comment,
      sym_block_comment,
  [70427] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5133), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2242), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_PLUS,
  [70453] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5135), 1,
      anon_sym_RBRACK,
    STATE(2269), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3216), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2243), 2,
      sym_line_comment,
      sym_block_comment,
  [70485] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5137), 1,
      sym_identifier,
    STATE(2244), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [70507] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4891), 1,
      anon_sym_LPAREN,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    ACTIONS(5141), 1,
      anon_sym_EQ,
    ACTIONS(5139), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2245), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2873), 2,
      sym_field_declaration_list,
      sym_ordered_field_declaration_list,
  [70535] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5143), 1,
      anon_sym_RPAREN,
    STATE(2133), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3081), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2246), 2,
      sym_line_comment,
      sym_block_comment,
  [70567] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    ACTIONS(5145), 1,
      anon_sym_RBRACE,
    STATE(2247), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3259), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70597] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5149), 1,
      anon_sym_COLON,
    ACTIONS(5151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5147), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2248), 2,
      sym_line_comment,
      sym_block_comment,
  [70625] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    ACTIONS(5153), 1,
      anon_sym_RBRACE,
    STATE(2249), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3259), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70655] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5135), 1,
      anon_sym_RPAREN,
    STATE(2232), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3220), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2250), 2,
      sym_line_comment,
      sym_block_comment,
  [70687] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5155), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2251), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [70713] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5155), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5159), 1,
      anon_sym_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5157), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2252), 2,
      sym_line_comment,
      sym_block_comment,
  [70741] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    ACTIONS(5161), 1,
      anon_sym_RBRACE,
    STATE(2253), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3259), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70771] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5163), 1,
      anon_sym_RBRACE,
    STATE(2133), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3087), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2254), 2,
      sym_line_comment,
      sym_block_comment,
  [70803] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4840), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4844), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4842), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2255), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4469), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [70829] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4891), 1,
      anon_sym_LPAREN,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    ACTIONS(5167), 1,
      anon_sym_EQ,
    ACTIONS(5165), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2256), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2917), 2,
      sym_field_declaration_list,
      sym_ordered_field_declaration_list,
  [70857] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    ACTIONS(5169), 1,
      anon_sym_RBRACE,
    STATE(2257), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3259), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70887] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5171), 1,
      sym_identifier,
    STATE(2258), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [70909] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5131), 1,
      anon_sym_STAR,
    STATE(3015), 1,
      sym_use_list,
    STATE(3154), 1,
      sym_type_arguments,
    ACTIONS(5129), 2,
      sym_identifier,
      sym_super,
    STATE(2259), 2,
      sym_line_comment,
      sym_block_comment,
  [70939] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    ACTIONS(5173), 1,
      anon_sym_RBRACE,
    STATE(2260), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3259), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70969] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5143), 1,
      anon_sym_RBRACK,
    STATE(2133), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3083), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2261), 2,
      sym_line_comment,
      sym_block_comment,
  [71001] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5175), 1,
      anon_sym_RBRACK,
    STATE(2270), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3156), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2262), 2,
      sym_line_comment,
      sym_block_comment,
  [71033] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5177), 1,
      anon_sym_RPAREN,
    STATE(2133), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3117), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2263), 2,
      sym_line_comment,
      sym_block_comment,
  [71065] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5179), 1,
      anon_sym_trait,
    STATE(2264), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [71087] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5181), 1,
      anon_sym_RBRACE,
    STATE(2272), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3151), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2265), 2,
      sym_line_comment,
      sym_block_comment,
  [71119] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    ACTIONS(5183), 1,
      anon_sym_RBRACE,
    STATE(2266), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3259), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [71149] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5185), 1,
      anon_sym_RBRACE,
    STATE(2283), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3090), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2267), 2,
      sym_line_comment,
      sym_block_comment,
  [71181] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5187), 1,
      anon_sym_RBRACE,
    STATE(2280), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3100), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2268), 2,
      sym_line_comment,
      sym_block_comment,
  [71213] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_RBRACK,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    STATE(2133), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3181), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2269), 2,
      sym_line_comment,
      sym_block_comment,
  [71245] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5177), 1,
      anon_sym_RBRACK,
    STATE(2133), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3091), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2270), 2,
      sym_line_comment,
      sym_block_comment,
  [71277] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5189), 1,
      sym_identifier,
    STATE(2271), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [71299] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5191), 1,
      anon_sym_RBRACE,
    STATE(2133), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3095), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2272), 2,
      sym_line_comment,
      sym_block_comment,
  [71331] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5193), 1,
      anon_sym_RPAREN,
    STATE(2133), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3180), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2273), 2,
      sym_line_comment,
      sym_block_comment,
  [71363] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5193), 1,
      anon_sym_RBRACK,
    STATE(2133), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3178), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2274), 2,
      sym_line_comment,
      sym_block_comment,
  [71395] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5195), 1,
      anon_sym_trait,
    STATE(2275), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [71417] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4891), 1,
      anon_sym_LPAREN,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(5197), 1,
      anon_sym_SEMI,
    STATE(565), 1,
      sym_field_declaration_list,
    STATE(3003), 1,
      sym_ordered_field_declaration_list,
    STATE(3059), 1,
      sym_where_clause,
    STATE(2276), 2,
      sym_line_comment,
      sym_block_comment,
  [71449] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4891), 1,
      anon_sym_LPAREN,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(5199), 1,
      anon_sym_SEMI,
    STATE(744), 1,
      sym_field_declaration_list,
    STATE(2904), 1,
      sym_ordered_field_declaration_list,
    STATE(3228), 1,
      sym_where_clause,
    STATE(2277), 2,
      sym_line_comment,
      sym_block_comment,
  [71481] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5201), 1,
      anon_sym_RPAREN,
    STATE(2246), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3299), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2278), 2,
      sym_line_comment,
      sym_block_comment,
  [71513] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5201), 1,
      anon_sym_RBRACK,
    STATE(2261), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3306), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2279), 2,
      sym_line_comment,
      sym_block_comment,
  [71545] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5203), 1,
      anon_sym_RBRACE,
    STATE(2133), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3287), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2280), 2,
      sym_line_comment,
      sym_block_comment,
  [71577] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5205), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3045), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2281), 2,
      sym_line_comment,
      sym_block_comment,
  [71609] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5159), 1,
      anon_sym_COLON,
    ACTIONS(5207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5157), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2282), 2,
      sym_line_comment,
      sym_block_comment,
  [71637] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5209), 1,
      anon_sym_RBRACE,
    STATE(2133), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3294), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2283), 2,
      sym_line_comment,
      sym_block_comment,
  [71669] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    ACTIONS(5211), 1,
      anon_sym_RBRACE,
    STATE(2284), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3259), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [71699] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2285), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [71725] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4891), 1,
      anon_sym_LPAREN,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    ACTIONS(5213), 1,
      anon_sym_SEMI,
    STATE(1210), 1,
      sym_field_declaration_list,
    STATE(2837), 1,
      sym_ordered_field_declaration_list,
    STATE(3210), 1,
      sym_where_clause,
    STATE(2286), 2,
      sym_line_comment,
      sym_block_comment,
  [71757] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5101), 1,
      anon_sym_LPAREN,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    ACTIONS(5175), 1,
      anon_sym_RPAREN,
    STATE(2263), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3165), 1,
      sym_macro_rule,
    STATE(3319), 1,
      sym_token_tree_pattern,
    STATE(2287), 2,
      sym_line_comment,
      sym_block_comment,
  [71789] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5215), 1,
      sym_identifier,
    STATE(2288), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [71811] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5217), 1,
      anon_sym_GT,
    ACTIONS(5219), 1,
      anon_sym_COMMA,
    STATE(2941), 1,
      sym_trait_bounds,
    STATE(2944), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2289), 2,
      sym_line_comment,
      sym_block_comment,
  [71840] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5221), 1,
      anon_sym_SEMI,
    STATE(670), 1,
      sym_declaration_list,
    STATE(2860), 1,
      sym_where_clause,
    STATE(2290), 2,
      sym_line_comment,
      sym_block_comment,
  [71869] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5223), 1,
      anon_sym_SEMI,
    STATE(1405), 1,
      sym_declaration_list,
    STATE(3013), 1,
      sym_where_clause,
    STATE(2291), 2,
      sym_line_comment,
      sym_block_comment,
  [71898] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(5225), 1,
      anon_sym_LBRACE,
    STATE(1191), 1,
      sym_enum_variant_list,
    STATE(2623), 1,
      sym_type_parameters,
    STATE(3264), 1,
      sym_where_clause,
    STATE(2292), 2,
      sym_line_comment,
      sym_block_comment,
  [71927] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5227), 1,
      anon_sym_SEMI,
    STATE(1196), 1,
      sym_declaration_list,
    STATE(2731), 1,
      sym_where_clause,
    STATE(2293), 2,
      sym_line_comment,
      sym_block_comment,
  [71956] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5229), 1,
      anon_sym_SEMI,
    ACTIONS(5231), 1,
      anon_sym_EQ,
    STATE(2845), 1,
      sym_trait_bounds,
    STATE(3374), 1,
      sym_where_clause,
    STATE(2294), 2,
      sym_line_comment,
      sym_block_comment,
  [71985] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(1206), 1,
      sym_declaration_list,
    STATE(2639), 1,
      sym_trait_bounds,
    STATE(3232), 1,
      sym_where_clause,
    STATE(2295), 2,
      sym_line_comment,
      sym_block_comment,
  [72014] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5233), 1,
      anon_sym_SEMI,
    STATE(1396), 1,
      sym_declaration_list,
    STATE(3012), 1,
      sym_where_clause,
    STATE(2296), 2,
      sym_line_comment,
      sym_block_comment,
  [72043] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4965), 1,
      anon_sym_for,
    STATE(2297), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72066] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5235), 1,
      anon_sym_SEMI,
    STATE(490), 1,
      sym_declaration_list,
    STATE(2836), 1,
      sym_where_clause,
    STATE(2298), 2,
      sym_line_comment,
      sym_block_comment,
  [72095] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5237), 1,
      anon_sym_SEMI,
    STATE(492), 1,
      sym_declaration_list,
    STATE(2838), 1,
      sym_where_clause,
    STATE(2299), 2,
      sym_line_comment,
      sym_block_comment,
  [72124] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1185), 1,
      sym_field_declaration_list,
    STATE(2620), 1,
      sym_type_parameters,
    STATE(3033), 1,
      sym_where_clause,
    STATE(2300), 2,
      sym_line_comment,
      sym_block_comment,
  [72153] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5239), 1,
      anon_sym_SEMI,
    STATE(654), 1,
      sym_declaration_list,
    STATE(2813), 1,
      sym_where_clause,
    STATE(2301), 2,
      sym_line_comment,
      sym_block_comment,
  [72182] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5241), 1,
      anon_sym_SEMI,
    STATE(1221), 1,
      sym_declaration_list,
    STATE(2822), 1,
      sym_where_clause,
    STATE(2302), 2,
      sym_line_comment,
      sym_block_comment,
  [72211] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5243), 1,
      anon_sym_SEMI,
    STATE(750), 1,
      sym_declaration_list,
    STATE(3025), 1,
      sym_where_clause,
    STATE(2303), 2,
      sym_line_comment,
      sym_block_comment,
  [72240] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5245), 1,
      anon_sym_SEMI,
    STATE(642), 1,
      sym_declaration_list,
    STATE(2815), 1,
      sym_where_clause,
    STATE(2304), 2,
      sym_line_comment,
      sym_block_comment,
  [72269] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(722), 1,
      sym_enum_variant_list,
    STATE(2581), 1,
      sym_type_parameters,
    STATE(3147), 1,
      sym_where_clause,
    STATE(2305), 2,
      sym_line_comment,
      sym_block_comment,
  [72298] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5249), 1,
      anon_sym_SEMI,
    ACTIONS(5251), 1,
      anon_sym_EQ,
    STATE(3017), 1,
      sym_trait_bounds,
    STATE(3610), 1,
      sym_where_clause,
    STATE(2306), 2,
      sym_line_comment,
      sym_block_comment,
  [72327] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(607), 1,
      sym_declaration_list,
    STATE(2522), 1,
      sym_trait_bounds,
    STATE(3046), 1,
      sym_where_clause,
    STATE(2307), 2,
      sym_line_comment,
      sym_block_comment,
  [72356] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3410), 2,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
    ACTIONS(4782), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5253), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2308), 2,
      sym_line_comment,
      sym_block_comment,
  [72379] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4622), 1,
      anon_sym_DOT_DOT,
    STATE(2309), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4620), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [72400] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4949), 1,
      anon_sym_for,
    STATE(2310), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72423] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5256), 1,
      anon_sym_SEMI,
    STATE(511), 1,
      sym_declaration_list,
    STATE(2980), 1,
      sym_where_clause,
    STATE(2311), 2,
      sym_line_comment,
      sym_block_comment,
  [72452] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4969), 1,
      anon_sym_for,
    STATE(2312), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72475] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2313), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4877), 6,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [72494] = 9,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5258), 1,
      sym_identifier,
    ACTIONS(5260), 1,
      anon_sym_ref,
    ACTIONS(5262), 1,
      sym_mutable_specifier,
    ACTIONS(5264), 1,
      anon_sym_move,
    STATE(220), 1,
      sym_closure_parameters,
    STATE(2314), 2,
      sym_line_comment,
      sym_block_comment,
  [72523] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5266), 1,
      anon_sym_GT,
    ACTIONS(5268), 1,
      anon_sym_COMMA,
    STATE(2994), 1,
      sym_trait_bounds,
    STATE(3000), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2315), 2,
      sym_line_comment,
      sym_block_comment,
  [72552] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5266), 1,
      anon_sym_GT,
    ACTIONS(5268), 1,
      anon_sym_COMMA,
    ACTIONS(5270), 1,
      anon_sym_PLUS,
    STATE(2994), 1,
      sym_trait_bounds,
    STATE(3000), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2316), 2,
      sym_line_comment,
      sym_block_comment,
  [72581] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4941), 1,
      anon_sym_for,
    STATE(2317), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72604] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5272), 1,
      anon_sym_SEMI,
    STATE(676), 1,
      sym_declaration_list,
    STATE(2921), 1,
      sym_where_clause,
    STATE(2318), 2,
      sym_line_comment,
      sym_block_comment,
  [72633] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4937), 1,
      anon_sym_for,
    STATE(2319), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72656] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4782), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2320), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3410), 4,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [72677] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5270), 1,
      anon_sym_PLUS,
    ACTIONS(5274), 1,
      anon_sym_GT,
    ACTIONS(5276), 1,
      anon_sym_COMMA,
    STATE(2885), 1,
      sym_trait_bounds,
    STATE(2886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2321), 2,
      sym_line_comment,
      sym_block_comment,
  [72706] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5155), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5278), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2322), 2,
      sym_line_comment,
      sym_block_comment,
  [72731] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5274), 1,
      anon_sym_GT,
    ACTIONS(5276), 1,
      anon_sym_COMMA,
    STATE(2885), 1,
      sym_trait_bounds,
    STATE(2886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2323), 2,
      sym_line_comment,
      sym_block_comment,
  [72760] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5147), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2324), 2,
      sym_line_comment,
      sym_block_comment,
  [72785] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4935), 1,
      anon_sym_for,
    STATE(2325), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72808] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5280), 1,
      anon_sym_SEMI,
    STATE(1276), 1,
      sym_declaration_list,
    STATE(3031), 1,
      sym_where_clause,
    STATE(2326), 2,
      sym_line_comment,
      sym_block_comment,
  [72837] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5282), 1,
      anon_sym_SEMI,
    STATE(1229), 1,
      sym_declaration_list,
    STATE(3030), 1,
      sym_where_clause,
    STATE(2327), 2,
      sym_line_comment,
      sym_block_comment,
  [72866] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5284), 1,
      anon_sym_SEMI,
    STATE(1198), 1,
      sym_declaration_list,
    STATE(3027), 1,
      sym_where_clause,
    STATE(2328), 2,
      sym_line_comment,
      sym_block_comment,
  [72895] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5286), 1,
      anon_sym_SEMI,
    STATE(1178), 1,
      sym_declaration_list,
    STATE(3026), 1,
      sym_where_clause,
    STATE(2329), 2,
      sym_line_comment,
      sym_block_comment,
  [72924] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3442), 1,
      anon_sym_COLON,
    ACTIONS(5288), 1,
      anon_sym_EQ,
    STATE(2330), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3440), 4,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [72947] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4796), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2331), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3384), 4,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [72968] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5290), 1,
      anon_sym_SEMI,
    STATE(1096), 1,
      sym_declaration_list,
    STATE(3020), 1,
      sym_where_clause,
    STATE(2332), 2,
      sym_line_comment,
      sym_block_comment,
  [72997] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5292), 1,
      anon_sym_GT,
    ACTIONS(5294), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2941), 1,
      sym_trait_bounds,
    STATE(2333), 2,
      sym_line_comment,
      sym_block_comment,
  [73026] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5296), 1,
      anon_sym_SEMI,
    STATE(1309), 1,
      sym_declaration_list,
    STATE(3019), 1,
      sym_where_clause,
    STATE(2334), 2,
      sym_line_comment,
      sym_block_comment,
  [73055] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(5017), 1,
      anon_sym_ref,
    ACTIONS(5019), 1,
      sym_mutable_specifier,
    STATE(2335), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3259), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [73082] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(556), 1,
      sym_declaration_list,
    STATE(2563), 1,
      sym_trait_bounds,
    STATE(3242), 1,
      sym_where_clause,
    STATE(2336), 2,
      sym_line_comment,
      sym_block_comment,
  [73111] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5298), 1,
      anon_sym_SEMI,
    STATE(521), 1,
      sym_declaration_list,
    STATE(2936), 1,
      sym_where_clause,
    STATE(2337), 2,
      sym_line_comment,
      sym_block_comment,
  [73140] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3384), 2,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
    ACTIONS(4796), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5300), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2338), 2,
      sym_line_comment,
      sym_block_comment,
  [73163] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4929), 1,
      anon_sym_for,
    STATE(2339), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [73186] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5300), 1,
      anon_sym_RBRACK,
    ACTIONS(4796), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2340), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3384), 3,
      anon_sym_SEMI,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
  [73209] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4925), 1,
      anon_sym_for,
    STATE(2341), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [73232] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(5303), 1,
      anon_sym_if,
    STATE(3545), 1,
      sym_label,
    STATE(1151), 2,
      sym_if_expression,
      sym_block,
    STATE(2342), 2,
      sym_line_comment,
      sym_block_comment,
  [73259] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5305), 1,
      anon_sym_GT,
    ACTIONS(5307), 1,
      anon_sym_COMMA,
    STATE(2914), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2941), 1,
      sym_trait_bounds,
    STATE(2343), 2,
      sym_line_comment,
      sym_block_comment,
  [73288] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5309), 1,
      anon_sym_SEMI,
    STATE(601), 1,
      sym_declaration_list,
    STATE(2962), 1,
      sym_where_clause,
    STATE(2344), 2,
      sym_line_comment,
      sym_block_comment,
  [73317] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5311), 1,
      anon_sym_GT,
    ACTIONS(5313), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2951), 1,
      sym_trait_bounds,
    STATE(2345), 2,
      sym_line_comment,
      sym_block_comment,
  [73346] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5315), 1,
      anon_sym_SEMI,
    STATE(1147), 1,
      sym_declaration_list,
    STATE(2916), 1,
      sym_where_clause,
    STATE(2346), 2,
      sym_line_comment,
      sym_block_comment,
  [73375] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5155), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5147), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2347), 2,
      sym_line_comment,
      sym_block_comment,
  [73400] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5317), 1,
      anon_sym_SEMI,
    STATE(1142), 1,
      sym_declaration_list,
    STATE(2919), 1,
      sym_where_clause,
    STATE(2348), 2,
      sym_line_comment,
      sym_block_comment,
  [73429] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1296), 1,
      sym_field_declaration_list,
    STATE(2727), 1,
      sym_type_parameters,
    STATE(3035), 1,
      sym_where_clause,
    STATE(2349), 2,
      sym_line_comment,
      sym_block_comment,
  [73458] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(817), 1,
      anon_sym_DOT_DOT,
    STATE(2350), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(819), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [73479] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2351), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3327), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [73498] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5319), 1,
      anon_sym_SEMI,
    STATE(1305), 1,
      sym_declaration_list,
    STATE(2746), 1,
      sym_where_clause,
    STATE(2352), 2,
      sym_line_comment,
      sym_block_comment,
  [73527] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(5225), 1,
      anon_sym_LBRACE,
    STATE(1091), 1,
      sym_enum_variant_list,
    STATE(2714), 1,
      sym_type_parameters,
    STATE(3084), 1,
      sym_where_clause,
    STATE(2353), 2,
      sym_line_comment,
      sym_block_comment,
  [73556] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(5321), 1,
      anon_sym_if,
    STATE(3597), 1,
      sym_label,
    STATE(1806), 2,
      sym_if_expression,
      sym_block,
    STATE(2354), 2,
      sym_line_comment,
      sym_block_comment,
  [73583] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5323), 1,
      anon_sym_SEMI,
    STATE(1117), 1,
      sym_declaration_list,
    STATE(2934), 1,
      sym_where_clause,
    STATE(2355), 2,
      sym_line_comment,
      sym_block_comment,
  [73612] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(1112), 1,
      sym_declaration_list,
    STATE(2576), 1,
      sym_trait_bounds,
    STATE(3158), 1,
      sym_where_clause,
    STATE(2356), 2,
      sym_line_comment,
      sym_block_comment,
  [73641] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(785), 1,
      anon_sym_DOT_DOT,
    STATE(2357), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(787), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [73662] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_RBRACK,
    ACTIONS(4782), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2358), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3410), 3,
      anon_sym_SEMI,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
  [73685] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4601), 1,
      anon_sym_DOT_DOT,
    STATE(2359), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4599), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [73706] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5278), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2360), 2,
      sym_line_comment,
      sym_block_comment,
  [73731] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5270), 1,
      anon_sym_PLUS,
    ACTIONS(5325), 1,
      anon_sym_GT,
    ACTIONS(5327), 1,
      anon_sym_COMMA,
    STATE(2956), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2958), 1,
      sym_trait_bounds,
    STATE(2361), 2,
      sym_line_comment,
      sym_block_comment,
  [73760] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4614), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4616), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2362), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [73783] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(4897), 1,
      anon_sym_where,
    STATE(681), 1,
      sym_field_declaration_list,
    STATE(2503), 1,
      sym_type_parameters,
    STATE(3082), 1,
      sym_where_clause,
    STATE(2363), 2,
      sym_line_comment,
      sym_block_comment,
  [73812] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(777), 1,
      anon_sym_DOT_DOT,
    STATE(2364), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(779), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [73833] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(703), 1,
      sym_enum_variant_list,
    STATE(2502), 1,
      sym_type_parameters,
    STATE(3056), 1,
      sym_where_clause,
    STATE(2365), 2,
      sym_line_comment,
      sym_block_comment,
  [73862] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5325), 1,
      anon_sym_GT,
    ACTIONS(5327), 1,
      anon_sym_COMMA,
    STATE(2956), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2958), 1,
      sym_trait_bounds,
    STATE(2366), 2,
      sym_line_comment,
      sym_block_comment,
  [73891] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4554), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5311), 1,
      anon_sym_GT,
    ACTIONS(5313), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3311), 2,
      anon_sym_PLUS,
      anon_sym_as,
    STATE(2367), 2,
      sym_line_comment,
      sym_block_comment,
  [73918] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5329), 1,
      anon_sym_GT,
    ACTIONS(5331), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2951), 1,
      sym_trait_bounds,
    STATE(2968), 1,
      aux_sym_for_lifetimes_repeat1,
    STATE(2368), 2,
      sym_line_comment,
      sym_block_comment,
  [73947] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(4897), 1,
      anon_sym_where,
    STATE(487), 1,
      sym_field_declaration_list,
    STATE(2507), 1,
      sym_type_parameters,
    STATE(3051), 1,
      sym_where_clause,
    STATE(2369), 2,
      sym_line_comment,
      sym_block_comment,
  [73976] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5333), 1,
      anon_sym_SEMI,
    STATE(496), 1,
      sym_declaration_list,
    STATE(2939), 1,
      sym_where_clause,
    STATE(2370), 2,
      sym_line_comment,
      sym_block_comment,
  [74005] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(797), 1,
      anon_sym_DOT_DOT,
    STATE(2371), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(799), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [74026] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5335), 1,
      anon_sym_SEMI,
    STATE(1236), 1,
      sym_declaration_list,
    STATE(2978), 1,
      sym_where_clause,
    STATE(2372), 2,
      sym_line_comment,
      sym_block_comment,
  [74055] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(1445), 1,
      sym_declaration_list,
    STATE(2524), 1,
      sym_trait_bounds,
    STATE(3063), 1,
      sym_where_clause,
    STATE(2373), 2,
      sym_line_comment,
      sym_block_comment,
  [74084] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5337), 1,
      anon_sym_SEMI,
    STATE(696), 1,
      sym_declaration_list,
    STATE(2871), 1,
      sym_where_clause,
    STATE(2374), 2,
      sym_line_comment,
      sym_block_comment,
  [74113] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5339), 1,
      anon_sym_SEMI,
    STATE(1241), 1,
      sym_declaration_list,
    STATE(2979), 1,
      sym_where_clause,
    STATE(2375), 2,
      sym_line_comment,
      sym_block_comment,
  [74142] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5341), 1,
      anon_sym_SEMI,
    STATE(1258), 1,
      sym_declaration_list,
    STATE(2984), 1,
      sym_where_clause,
    STATE(2376), 2,
      sym_line_comment,
      sym_block_comment,
  [74171] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5343), 1,
      anon_sym_SEMI,
    STATE(1260), 1,
      sym_declaration_list,
    STATE(2985), 1,
      sym_where_clause,
    STATE(2377), 2,
      sym_line_comment,
      sym_block_comment,
  [74200] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5345), 1,
      anon_sym_SEMI,
    STATE(692), 1,
      sym_declaration_list,
    STATE(2870), 1,
      sym_where_clause,
    STATE(2378), 2,
      sym_line_comment,
      sym_block_comment,
  [74229] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5347), 1,
      anon_sym_SEMI,
    STATE(486), 1,
      sym_declaration_list,
    STATE(2828), 1,
      sym_where_clause,
    STATE(2379), 2,
      sym_line_comment,
      sym_block_comment,
  [74258] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(5349), 1,
      anon_sym_if,
    STATE(3596), 1,
      sym_label,
    STATE(458), 2,
      sym_if_expression,
      sym_block,
    STATE(2380), 2,
      sym_line_comment,
      sym_block_comment,
  [74285] = 8,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(5351), 1,
      anon_sym_if,
    STATE(3414), 1,
      sym_label,
    STATE(376), 2,
      sym_if_expression,
      sym_block,
    STATE(2381), 2,
      sym_line_comment,
      sym_block_comment,
  [74312] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(718), 1,
      sym_declaration_list,
    STATE(2633), 1,
      sym_trait_bounds,
    STATE(3233), 1,
      sym_where_clause,
    STATE(2382), 2,
      sym_line_comment,
      sym_block_comment,
  [74341] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5353), 1,
      anon_sym_SEMI,
    STATE(480), 1,
      sym_declaration_list,
    STATE(2827), 1,
      sym_where_clause,
    STATE(2383), 2,
      sym_line_comment,
      sym_block_comment,
  [74370] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5355), 1,
      anon_sym_SEMI,
    STATE(506), 1,
      sym_declaration_list,
    STATE(2826), 1,
      sym_where_clause,
    STATE(2384), 2,
      sym_line_comment,
      sym_block_comment,
  [74399] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4582), 1,
      anon_sym_GT,
    ACTIONS(4584), 1,
      anon_sym_COMMA,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(2941), 1,
      sym_trait_bounds,
    STATE(2947), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2385), 2,
      sym_line_comment,
      sym_block_comment,
  [74428] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5357), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_declaration_list,
    STATE(2861), 1,
      sym_where_clause,
    STATE(2386), 2,
      sym_line_comment,
      sym_block_comment,
  [74457] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5359), 1,
      anon_sym_SEMI,
    STATE(523), 1,
      sym_declaration_list,
    STATE(2825), 1,
      sym_where_clause,
    STATE(2387), 2,
      sym_line_comment,
      sym_block_comment,
  [74486] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4451), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4578), 1,
      anon_sym_COLON,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(2569), 1,
      sym_trait_bounds,
    STATE(2388), 2,
      sym_line_comment,
      sym_block_comment,
  [74512] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4451), 1,
      anon_sym_COLON_COLON,
    STATE(1625), 1,
      sym_parameters,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(2389), 2,
      sym_line_comment,
      sym_block_comment,
  [74538] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    STATE(1726), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2390), 2,
      sym_line_comment,
      sym_block_comment,
  [74564] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5361), 1,
      anon_sym_SEMI,
    STATE(526), 1,
      sym_block,
    STATE(3592), 1,
      sym_label,
    STATE(2391), 2,
      sym_line_comment,
      sym_block_comment,
  [74590] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5363), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74608] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
    ACTIONS(5365), 1,
      anon_sym_COMMA,
    STATE(2935), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4453), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2393), 2,
      sym_line_comment,
      sym_block_comment,
  [74632] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5369), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5371), 1,
      anon_sym_as,
    STATE(2394), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5367), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [74654] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5375), 1,
      anon_sym_COMMA,
    STATE(2408), 1,
      aux_sym_where_clause_repeat1,
    STATE(2395), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5373), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
  [74676] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5377), 1,
      anon_sym_SEMI,
    STATE(748), 1,
      sym_block,
    STATE(3592), 1,
      sym_label,
    STATE(2396), 2,
      sym_line_comment,
      sym_block_comment,
  [74702] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2397), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5379), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74720] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5371), 1,
      anon_sym_as,
    ACTIONS(5381), 1,
      anon_sym_COLON_COLON,
    STATE(2398), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5367), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [74742] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5383), 1,
      anon_sym_SEMI,
    STATE(746), 1,
      sym_block,
    STATE(3592), 1,
      sym_label,
    STATE(2399), 2,
      sym_line_comment,
      sym_block_comment,
  [74768] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5385), 1,
      anon_sym_RBRACK,
    ACTIONS(3717), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4800), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2400), 2,
      sym_line_comment,
      sym_block_comment,
  [74790] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5388), 1,
      anon_sym_RBRACK,
    ACTIONS(3311), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4453), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2401), 2,
      sym_line_comment,
      sym_block_comment,
  [74812] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(2941), 1,
      sym_trait_bounds,
    ACTIONS(5391), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2402), 2,
      sym_line_comment,
      sym_block_comment,
  [74836] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5393), 1,
      anon_sym_SEMI,
    STATE(727), 1,
      sym_block,
    STATE(3592), 1,
      sym_label,
    STATE(2403), 2,
      sym_line_comment,
      sym_block_comment,
  [74862] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    STATE(1351), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2404), 2,
      sym_line_comment,
      sym_block_comment,
  [74888] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2405), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5395), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74906] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5397), 1,
      anon_sym_SEMI,
    STATE(1341), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2406), 2,
      sym_line_comment,
      sym_block_comment,
  [74932] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5399), 1,
      anon_sym_SEMI,
    STATE(704), 1,
      sym_block,
    STATE(3592), 1,
      sym_label,
    STATE(2407), 2,
      sym_line_comment,
      sym_block_comment,
  [74958] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5401), 1,
      anon_sym_COMMA,
    STATE(2484), 1,
      aux_sym_where_clause_repeat1,
    STATE(2408), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3338), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
  [74980] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2409), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5403), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74998] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5405), 1,
      anon_sym_SEMI,
    STATE(608), 1,
      sym_block,
    STATE(3592), 1,
      sym_label,
    STATE(2410), 2,
      sym_line_comment,
      sym_block_comment,
  [75024] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5411), 1,
      anon_sym_as,
    STATE(2411), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5407), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [75046] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4632), 1,
      anon_sym_GT,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5413), 1,
      anon_sym_COMMA,
    STATE(2940), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2951), 1,
      sym_trait_bounds,
    STATE(2412), 2,
      sym_line_comment,
      sym_block_comment,
  [75072] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5159), 1,
      anon_sym_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2413), 2,
      sym_line_comment,
      sym_block_comment,
  [75096] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5149), 1,
      anon_sym_COLON,
    ACTIONS(5151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2414), 2,
      sym_line_comment,
      sym_block_comment,
  [75120] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5415), 1,
      anon_sym_SEMI,
    STATE(568), 1,
      sym_block,
    STATE(3592), 1,
      sym_label,
    STATE(2415), 2,
      sym_line_comment,
      sym_block_comment,
  [75146] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5417), 1,
      anon_sym_SEMI,
    STATE(1179), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2416), 2,
      sym_line_comment,
      sym_block_comment,
  [75172] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5419), 1,
      anon_sym_RPAREN,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(2946), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4453), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2417), 2,
      sym_line_comment,
      sym_block_comment,
  [75196] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5423), 1,
      anon_sym_STAR_SLASH,
    ACTIONS(5425), 1,
      sym__outer_block_doc_comment_marker,
    ACTIONS(5427), 1,
      sym__inner_block_doc_comment_marker,
    ACTIONS(5429), 1,
      sym__block_comment_content,
    STATE(3130), 1,
      sym__block_doc_comment_marker,
    STATE(2418), 2,
      sym_line_comment,
      sym_block_comment,
  [75222] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5325), 1,
      anon_sym_GT,
    ACTIONS(5327), 1,
      anon_sym_COMMA,
    STATE(2956), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2958), 1,
      sym_trait_bounds,
    STATE(2419), 2,
      sym_line_comment,
      sym_block_comment,
  [75248] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5371), 1,
      anon_sym_as,
    ACTIONS(5431), 1,
      anon_sym_COLON_COLON,
    STATE(2420), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5367), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [75270] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1470), 1,
      anon_sym_RPAREN,
    ACTIONS(5433), 1,
      anon_sym_COMMA,
    STATE(2972), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4453), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2421), 2,
      sym_line_comment,
      sym_block_comment,
  [75294] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(5435), 1,
      anon_sym_move,
    STATE(459), 1,
      sym_block,
    STATE(3596), 1,
      sym_label,
    STATE(2422), 2,
      sym_line_comment,
      sym_block_comment,
  [75320] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
    ACTIONS(5437), 1,
      anon_sym_COMMA,
    STATE(2878), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4453), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2423), 2,
      sym_line_comment,
      sym_block_comment,
  [75344] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    STATE(1136), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2424), 2,
      sym_line_comment,
      sym_block_comment,
  [75370] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(5439), 1,
      anon_sym_move,
    STATE(1380), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2425), 2,
      sym_line_comment,
      sym_block_comment,
  [75396] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4453), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2426), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [75416] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5441), 1,
      aux_sym_line_comment_token1,
    ACTIONS(5443), 1,
      aux_sym_line_comment_token3,
    ACTIONS(5445), 1,
      sym__inner_line_doc_comment_marker,
    ACTIONS(5447), 1,
      sym__outer_line_doc_comment_marker,
    STATE(3494), 1,
      sym__line_doc_comment_marker,
    STATE(2427), 2,
      sym_line_comment,
      sym_block_comment,
  [75442] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5449), 1,
      anon_sym_SEMI,
    ACTIONS(5451), 1,
      anon_sym_COLON,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(5455), 1,
      anon_sym_EQ,
    ACTIONS(5457), 1,
      anon_sym_else,
    STATE(2428), 2,
      sym_line_comment,
      sym_block_comment,
  [75468] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    STATE(1768), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2429), 2,
      sym_line_comment,
      sym_block_comment,
  [75494] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4800), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2430), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [75514] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5459), 1,
      anon_sym_SEMI,
    STATE(578), 1,
      sym_block,
    STATE(3592), 1,
      sym_label,
    STATE(2431), 2,
      sym_line_comment,
      sym_block_comment,
  [75540] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4634), 1,
      anon_sym_GT,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5461), 1,
      anon_sym_COMMA,
    STATE(2915), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2951), 1,
      sym_trait_bounds,
    STATE(2432), 2,
      sym_line_comment,
      sym_block_comment,
  [75566] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5463), 1,
      anon_sym_RPAREN,
    ACTIONS(5465), 1,
      anon_sym_COMMA,
    STATE(2977), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4453), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2433), 2,
      sym_line_comment,
      sym_block_comment,
  [75590] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2434), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5467), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75608] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5469), 1,
      anon_sym_SEMI,
    STATE(1153), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2435), 2,
      sym_line_comment,
      sym_block_comment,
  [75634] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5471), 1,
      anon_sym_RPAREN,
    ACTIONS(5474), 1,
      anon_sym_COMMA,
    STATE(2977), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4453), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2436), 2,
      sym_line_comment,
      sym_block_comment,
  [75658] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3311), 1,
      anon_sym_PLUS,
    ACTIONS(4453), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5388), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2437), 2,
      sym_line_comment,
      sym_block_comment,
  [75680] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2955), 1,
      anon_sym_POUND,
    ACTIONS(5477), 1,
      sym_identifier,
    ACTIONS(5479), 1,
      sym_integer_literal,
    STATE(1069), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1481), 1,
      sym_attribute_item,
    STATE(2438), 2,
      sym_line_comment,
      sym_block_comment,
  [75706] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2439), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5481), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75724] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2440), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5483), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75742] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5311), 1,
      anon_sym_GT,
    ACTIONS(5313), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2951), 1,
      sym_trait_bounds,
    STATE(2441), 2,
      sym_line_comment,
      sym_block_comment,
  [75768] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5485), 1,
      anon_sym_SEMI,
    STATE(1315), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2442), 2,
      sym_line_comment,
      sym_block_comment,
  [75794] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5487), 1,
      anon_sym_GT,
    ACTIONS(5489), 1,
      anon_sym_COMMA,
    STATE(2816), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2951), 1,
      sym_trait_bounds,
    STATE(2443), 2,
      sym_line_comment,
      sym_block_comment,
  [75820] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4451), 1,
      anon_sym_COLON_COLON,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(1954), 1,
      sym_parameters,
    STATE(2444), 2,
      sym_line_comment,
      sym_block_comment,
  [75846] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(5491), 1,
      anon_sym_SEMI,
    ACTIONS(5493), 1,
      anon_sym_COLON,
    ACTIONS(5495), 1,
      anon_sym_EQ,
    ACTIONS(5497), 1,
      anon_sym_else,
    STATE(2445), 2,
      sym_line_comment,
      sym_block_comment,
  [75872] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2446), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5499), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75890] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4848), 1,
      anon_sym_PIPE,
    ACTIONS(5501), 1,
      anon_sym_SEMI,
    ACTIONS(5503), 1,
      anon_sym_COLON,
    ACTIONS(5505), 1,
      anon_sym_EQ,
    ACTIONS(5507), 1,
      anon_sym_else,
    STATE(2447), 2,
      sym_line_comment,
      sym_block_comment,
  [75916] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2448), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3545), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [75934] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(5131), 1,
      anon_sym_STAR,
    STATE(3015), 1,
      sym_use_list,
    ACTIONS(5129), 2,
      sym_identifier,
      sym_super,
    STATE(2449), 2,
      sym_line_comment,
      sym_block_comment,
  [75958] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2450), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3703), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [75976] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    STATE(1106), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2451), 2,
      sym_line_comment,
      sym_block_comment,
  [76002] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2452), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5509), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76020] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2453), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5511), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76038] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2454), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5513), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76056] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2455), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3699), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76074] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5515), 1,
      anon_sym_RPAREN,
    ACTIONS(5517), 1,
      anon_sym_COMMA,
    STATE(2899), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4453), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2456), 2,
      sym_line_comment,
      sym_block_comment,
  [76098] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5270), 1,
      anon_sym_PLUS,
    STATE(3241), 1,
      sym_trait_bounds,
    ACTIONS(5519), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2457), 2,
      sym_line_comment,
      sym_block_comment,
  [76122] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5521), 1,
      anon_sym_SEMI,
    STATE(574), 1,
      sym_block,
    STATE(3592), 1,
      sym_label,
    STATE(2458), 2,
      sym_line_comment,
      sym_block_comment,
  [76148] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(3241), 1,
      sym_trait_bounds,
    ACTIONS(5519), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2459), 2,
      sym_line_comment,
      sym_block_comment,
  [76172] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5523), 1,
      anon_sym_SEMI,
    STATE(1289), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2460), 2,
      sym_line_comment,
      sym_block_comment,
  [76198] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4814), 1,
      anon_sym_RPAREN,
    ACTIONS(5525), 1,
      anon_sym_COLON,
    ACTIONS(5527), 1,
      anon_sym_PIPE,
    ACTIONS(5529), 1,
      anon_sym_COMMA,
    STATE(2911), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2461), 2,
      sym_line_comment,
      sym_block_comment,
  [76224] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2462), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3777), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76242] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5531), 1,
      anon_sym_SEMI,
    STATE(1466), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2463), 2,
      sym_line_comment,
      sym_block_comment,
  [76268] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2464), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3745), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76286] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(5535), 1,
      anon_sym_STAR,
    STATE(3023), 1,
      sym_use_list,
    ACTIONS(5533), 2,
      sym_identifier,
      sym_super,
    STATE(2465), 2,
      sym_line_comment,
      sym_block_comment,
  [76310] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5274), 1,
      anon_sym_GT,
    ACTIONS(5276), 1,
      anon_sym_COMMA,
    STATE(2885), 1,
      sym_trait_bounds,
    STATE(2886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2466), 2,
      sym_line_comment,
      sym_block_comment,
  [76336] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5537), 1,
      anon_sym_SEMI,
    STATE(695), 1,
      sym_block,
    STATE(3592), 1,
      sym_label,
    STATE(2467), 2,
      sym_line_comment,
      sym_block_comment,
  [76362] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5539), 1,
      anon_sym_SEMI,
    STATE(1454), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2468), 2,
      sym_line_comment,
      sym_block_comment,
  [76388] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2469), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3681), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76406] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(5541), 1,
      anon_sym_RPAREN,
    ACTIONS(5543), 1,
      anon_sym_COLON,
    ACTIONS(5545), 1,
      anon_sym_COMMA,
    STATE(2993), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2470), 2,
      sym_line_comment,
      sym_block_comment,
  [76432] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4451), 1,
      anon_sym_COLON_COLON,
    STATE(1054), 1,
      sym_parameters,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(2471), 2,
      sym_line_comment,
      sym_block_comment,
  [76458] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3717), 1,
      anon_sym_PLUS,
    ACTIONS(4800), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5385), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2472), 2,
      sym_line_comment,
      sym_block_comment,
  [76480] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5547), 1,
      anon_sym_SEMI,
    STATE(672), 1,
      sym_block,
    STATE(3592), 1,
      sym_label,
    STATE(2473), 2,
      sym_line_comment,
      sym_block_comment,
  [76506] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(5266), 1,
      anon_sym_GT,
    ACTIONS(5268), 1,
      anon_sym_COMMA,
    STATE(2994), 1,
      sym_trait_bounds,
    STATE(3000), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2474), 2,
      sym_line_comment,
      sym_block_comment,
  [76532] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2475), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3653), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76550] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2476), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3215), 5,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_as,
  [76568] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2477), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5549), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76586] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(5551), 1,
      anon_sym_move,
    STATE(1792), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2478), 2,
      sym_line_comment,
      sym_block_comment,
  [76612] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2479), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5553), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76630] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2480), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5555), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76648] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2481), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3707), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76666] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5557), 1,
      anon_sym_SEMI,
    STATE(1334), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2482), 2,
      sym_line_comment,
      sym_block_comment,
  [76692] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5559), 1,
      anon_sym_SEMI,
    STATE(1343), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2483), 2,
      sym_line_comment,
      sym_block_comment,
  [76718] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5563), 1,
      anon_sym_COMMA,
    ACTIONS(5561), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(2484), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_where_clause_repeat1,
  [76738] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4983), 1,
      anon_sym_LBRACE,
    ACTIONS(5566), 1,
      anon_sym_SEMI,
    STATE(502), 1,
      sym_block,
    STATE(3592), 1,
      sym_label,
    STATE(2485), 2,
      sym_line_comment,
      sym_block_comment,
  [76764] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5568), 1,
      anon_sym_SEMI,
    STATE(1355), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2486), 2,
      sym_line_comment,
      sym_block_comment,
  [76790] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    STATE(1734), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2487), 2,
      sym_line_comment,
      sym_block_comment,
  [76816] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2488), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3723), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76834] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5570), 1,
      anon_sym_SEMI,
    STATE(1369), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2489), 2,
      sym_line_comment,
      sym_block_comment,
  [76860] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(2941), 1,
      sym_trait_bounds,
    ACTIONS(5572), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2490), 2,
      sym_line_comment,
      sym_block_comment,
  [76884] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    ACTIONS(5574), 1,
      anon_sym_SEMI,
    STATE(1377), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2491), 2,
      sym_line_comment,
      sym_block_comment,
  [76910] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4848), 1,
      anon_sym_PIPE,
    ACTIONS(5576), 1,
      anon_sym_SEMI,
    ACTIONS(5578), 1,
      anon_sym_COLON,
    ACTIONS(5580), 1,
      anon_sym_EQ,
    ACTIONS(5582), 1,
      anon_sym_else,
    STATE(2492), 2,
      sym_line_comment,
      sym_block_comment,
  [76936] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2493), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3685), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76954] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3410), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2494), 2,
      sym_line_comment,
      sym_block_comment,
  [76977] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5584), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5586), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(2495), 2,
      sym_line_comment,
      sym_block_comment,
  [77000] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(245), 1,
      sym_block,
    STATE(3414), 1,
      sym_label,
    STATE(2496), 2,
      sym_line_comment,
      sym_block_comment,
  [77023] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5588), 1,
      anon_sym_DQUOTE,
    STATE(2525), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5590), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2497), 2,
      sym_line_comment,
      sym_block_comment,
  [77044] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(460), 1,
      sym_block,
    STATE(3596), 1,
      sym_label,
    STATE(2498), 2,
      sym_line_comment,
      sym_block_comment,
  [77067] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(455), 1,
      sym_block,
    STATE(3596), 1,
      sym_label,
    STATE(2499), 2,
      sym_line_comment,
      sym_block_comment,
  [77090] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1821), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2500), 2,
      sym_line_comment,
      sym_block_comment,
  [77113] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(593), 1,
      sym_declaration_list,
    STATE(3049), 1,
      sym_where_clause,
    STATE(2501), 2,
      sym_line_comment,
      sym_block_comment,
  [77136] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(730), 1,
      sym_enum_variant_list,
    STATE(3222), 1,
      sym_where_clause,
    STATE(2502), 2,
      sym_line_comment,
      sym_block_comment,
  [77159] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    ACTIONS(4897), 1,
      anon_sym_where,
    STATE(687), 1,
      sym_field_declaration_list,
    STATE(3231), 1,
      sym_where_clause,
    STATE(2503), 2,
      sym_line_comment,
      sym_block_comment,
  [77182] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5592), 1,
      anon_sym_LPAREN,
    ACTIONS(5594), 1,
      anon_sym_LBRACK,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    STATE(390), 1,
      sym_delim_token_tree,
    STATE(2504), 2,
      sym_line_comment,
      sym_block_comment,
  [77205] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4895), 1,
      anon_sym_LT,
    STATE(2231), 1,
      sym_parameters,
    STATE(3143), 1,
      sym_type_parameters,
    STATE(2505), 2,
      sym_line_comment,
      sym_block_comment,
  [77228] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      anon_sym_LBRACE,
    STATE(2957), 1,
      sym_block,
    STATE(3595), 1,
      sym_label,
    STATE(2506), 2,
      sym_line_comment,
      sym_block_comment,
  [77251] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    ACTIONS(4897), 1,
      anon_sym_where,
    STATE(649), 1,
      sym_field_declaration_list,
    STATE(3039), 1,
      sym_where_clause,
    STATE(2507), 2,
      sym_line_comment,
      sym_block_comment,
  [77274] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(701), 1,
      sym_declaration_list,
    STATE(3200), 1,
      sym_where_clause,
    STATE(2508), 2,
      sym_line_comment,
      sym_block_comment,
  [77297] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5598), 1,
      anon_sym_DQUOTE,
    STATE(2546), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5590), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2509), 2,
      sym_line_comment,
      sym_block_comment,
  [77318] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5437), 1,
      anon_sym_COMMA,
    STATE(2878), 1,
      aux_sym_parameters_repeat1,
    STATE(2510), 2,
      sym_line_comment,
      sym_block_comment,
  [77341] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(398), 1,
      sym_block,
    STATE(3414), 1,
      sym_label,
    STATE(2511), 2,
      sym_line_comment,
      sym_block_comment,
  [77364] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(386), 1,
      sym_block,
    STATE(3414), 1,
      sym_label,
    STATE(2512), 2,
      sym_line_comment,
      sym_block_comment,
  [77387] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3436), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2513), 2,
      sym_line_comment,
      sym_block_comment,
  [77410] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4895), 1,
      anon_sym_LT,
    STATE(2209), 1,
      sym_parameters,
    STATE(3159), 1,
      sym_type_parameters,
    STATE(2514), 2,
      sym_line_comment,
      sym_block_comment,
  [77433] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    ACTIONS(4081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4762), 1,
      anon_sym_BANG,
    STATE(1611), 1,
      sym_type_arguments,
    STATE(2515), 2,
      sym_line_comment,
      sym_block_comment,
  [77456] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5584), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5600), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(2516), 2,
      sym_line_comment,
      sym_block_comment,
  [77479] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5602), 1,
      anon_sym_LPAREN,
    ACTIONS(5604), 1,
      anon_sym_LBRACK,
    ACTIONS(5606), 1,
      anon_sym_LBRACE,
    STATE(2675), 1,
      sym_token_tree,
    STATE(2517), 2,
      sym_line_comment,
      sym_block_comment,
  [77502] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(454), 1,
      sym_block,
    STATE(3596), 1,
      sym_label,
    STATE(2518), 2,
      sym_line_comment,
      sym_block_comment,
  [77525] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5608), 1,
      anon_sym_LPAREN,
    ACTIONS(5610), 1,
      anon_sym_LBRACK,
    ACTIONS(5612), 1,
      anon_sym_LBRACE,
    STATE(1958), 1,
      sym_delim_token_tree,
    STATE(2519), 2,
      sym_line_comment,
      sym_block_comment,
  [77548] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(446), 1,
      sym_block,
    STATE(3596), 1,
      sym_label,
    STATE(2520), 2,
      sym_line_comment,
      sym_block_comment,
  [77571] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5614), 1,
      anon_sym_SEMI,
    STATE(3427), 1,
      sym_where_clause,
    STATE(2521), 2,
      sym_line_comment,
      sym_block_comment,
  [77594] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(479), 1,
      sym_declaration_list,
    STATE(3183), 1,
      sym_where_clause,
    STATE(2522), 2,
      sym_line_comment,
      sym_block_comment,
  [77617] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(462), 1,
      sym_block,
    STATE(3596), 1,
      sym_label,
    STATE(2523), 2,
      sym_line_comment,
      sym_block_comment,
  [77640] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1444), 1,
      sym_declaration_list,
    STATE(3037), 1,
      sym_where_clause,
    STATE(2524), 2,
      sym_line_comment,
      sym_block_comment,
  [77663] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5616), 1,
      anon_sym_DQUOTE,
    STATE(2546), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5590), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2525), 2,
      sym_line_comment,
      sym_block_comment,
  [77684] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5618), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2526), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5620), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [77703] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2527), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(803), 4,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [77720] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5622), 1,
      anon_sym_SEMI,
    STATE(3343), 1,
      sym_where_clause,
    STATE(2528), 2,
      sym_line_comment,
      sym_block_comment,
  [77743] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3455), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2529), 2,
      sym_line_comment,
      sym_block_comment,
  [77766] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5608), 1,
      anon_sym_LPAREN,
    ACTIONS(5610), 1,
      anon_sym_LBRACK,
    ACTIONS(5612), 1,
      anon_sym_LBRACE,
    STATE(1943), 1,
      sym_delim_token_tree,
    STATE(2530), 2,
      sym_line_comment,
      sym_block_comment,
  [77789] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4473), 1,
      anon_sym_BANG,
    ACTIONS(4568), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    STATE(2531), 2,
      sym_line_comment,
      sym_block_comment,
  [77812] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    ACTIONS(5624), 1,
      sym_identifier,
    ACTIONS(5626), 1,
      sym_super,
    STATE(1562), 1,
      sym_type_arguments,
    STATE(2532), 2,
      sym_line_comment,
      sym_block_comment,
  [77835] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    ACTIONS(5624), 1,
      sym_identifier,
    ACTIONS(5626), 1,
      sym_super,
    STATE(1571), 1,
      sym_type_arguments,
    STATE(2533), 2,
      sym_line_comment,
      sym_block_comment,
  [77858] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3475), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2534), 2,
      sym_line_comment,
      sym_block_comment,
  [77881] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5628), 1,
      sym_identifier,
    STATE(3106), 1,
      sym_type_arguments,
    STATE(2535), 2,
      sym_line_comment,
      sym_block_comment,
  [77904] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5630), 1,
      anon_sym_RPAREN,
    ACTIONS(5632), 1,
      anon_sym_COMMA,
    STATE(2932), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2536), 2,
      sym_line_comment,
      sym_block_comment,
  [77927] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5628), 1,
      sym_identifier,
    STATE(3154), 1,
      sym_type_arguments,
    STATE(2537), 2,
      sym_line_comment,
      sym_block_comment,
  [77950] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    STATE(2538), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5634), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [77969] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5636), 1,
      anon_sym_COMMA,
    ACTIONS(5634), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2539), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_slice_pattern_repeat1,
  [77988] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2540), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3215), 4,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_COMMA,
  [78005] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5639), 1,
      anon_sym_RPAREN,
    ACTIONS(5641), 1,
      anon_sym_COMMA,
    STATE(2971), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2541), 2,
      sym_line_comment,
      sym_block_comment,
  [78028] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    STATE(2542), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5643), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [78047] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4895), 1,
      anon_sym_LT,
    STATE(2228), 1,
      sym_parameters,
    STATE(3185), 1,
      sym_type_parameters,
    STATE(2543), 2,
      sym_line_comment,
      sym_block_comment,
  [78070] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3512), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2544), 2,
      sym_line_comment,
      sym_block_comment,
  [78093] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5645), 1,
      anon_sym_in,
    STATE(2545), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5647), 3,
      sym_self,
      sym_super,
      sym_crate,
  [78112] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5649), 1,
      anon_sym_DQUOTE,
    ACTIONS(5651), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2546), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_string_literal_repeat1,
  [78131] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4453), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5654), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2547), 2,
      sym_line_comment,
      sym_block_comment,
  [78150] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3537), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2548), 2,
      sym_line_comment,
      sym_block_comment,
  [78173] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1626), 1,
      sym_parameters,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2549), 2,
      sym_line_comment,
      sym_block_comment,
  [78196] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5656), 1,
      anon_sym_SEMI,
    ACTIONS(5658), 1,
      anon_sym_EQ,
    ACTIONS(5660), 1,
      anon_sym_else,
    STATE(2550), 2,
      sym_line_comment,
      sym_block_comment,
  [78219] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3447), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2551), 2,
      sym_line_comment,
      sym_block_comment,
  [78242] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3415), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2552), 2,
      sym_line_comment,
      sym_block_comment,
  [78265] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5270), 1,
      anon_sym_PLUS,
    STATE(2553), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5662), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_COMMA,
  [78284] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2554), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(955), 4,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [78301] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5311), 1,
      anon_sym_GT,
    ACTIONS(5313), 1,
      anon_sym_COMMA,
    ACTIONS(5664), 1,
      anon_sym_EQ,
    STATE(2950), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2555), 2,
      sym_line_comment,
      sym_block_comment,
  [78324] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5525), 1,
      anon_sym_COLON,
    ACTIONS(5527), 1,
      anon_sym_PIPE,
    ACTIONS(5529), 1,
      anon_sym_COMMA,
    STATE(2911), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2556), 2,
      sym_line_comment,
      sym_block_comment,
  [78347] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(457), 1,
      sym_block,
    STATE(3596), 1,
      sym_label,
    STATE(2557), 2,
      sym_line_comment,
      sym_block_comment,
  [78370] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5666), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2558), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5668), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [78389] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5584), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5670), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(2559), 2,
      sym_line_comment,
      sym_block_comment,
  [78412] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    STATE(2560), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4848), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [78431] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5674), 1,
      anon_sym_LPAREN,
    ACTIONS(5676), 1,
      anon_sym_LBRACK,
    ACTIONS(5678), 1,
      anon_sym_LBRACE,
    STATE(1031), 1,
      sym_delim_token_tree,
    STATE(2561), 2,
      sym_line_comment,
      sym_block_comment,
  [78454] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5419), 1,
      anon_sym_RPAREN,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(2946), 1,
      aux_sym_parameters_repeat1,
    STATE(2562), 2,
      sym_line_comment,
      sym_block_comment,
  [78477] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(547), 1,
      sym_declaration_list,
    STATE(3177), 1,
      sym_where_clause,
    STATE(2563), 2,
      sym_line_comment,
      sym_block_comment,
  [78500] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4632), 1,
      anon_sym_GT,
    ACTIONS(5413), 1,
      anon_sym_COMMA,
    ACTIONS(5664), 1,
      anon_sym_EQ,
    STATE(2940), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2564), 2,
      sym_line_comment,
      sym_block_comment,
  [78523] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2565), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5680), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
  [78540] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3334), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2566), 2,
      sym_line_comment,
      sym_block_comment,
  [78563] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1430), 1,
      sym_declaration_list,
    STATE(3064), 1,
      sym_where_clause,
    STATE(2567), 2,
      sym_line_comment,
      sym_block_comment,
  [78586] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5682), 1,
      anon_sym_SEMI,
    STATE(3580), 1,
      sym_where_clause,
    STATE(2568), 2,
      sym_line_comment,
      sym_block_comment,
  [78609] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2569), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5684), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
  [78626] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    STATE(3011), 1,
      sym_use_list,
    ACTIONS(5686), 2,
      sym_identifier,
      sym_super,
    STATE(2570), 2,
      sym_line_comment,
      sym_block_comment,
  [78647] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4676), 1,
      anon_sym_for,
    ACTIONS(5584), 1,
      anon_sym_COLON_COLON,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(2571), 2,
      sym_line_comment,
      sym_block_comment,
  [78670] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5688), 1,
      anon_sym_SEMI,
    STATE(3425), 1,
      sym_where_clause,
    STATE(2572), 2,
      sym_line_comment,
      sym_block_comment,
  [78693] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2573), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4269), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_SQUOTE,
  [78710] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(2951), 1,
      sym_trait_bounds,
    ACTIONS(5690), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2574), 2,
      sym_line_comment,
      sym_block_comment,
  [78731] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3492), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2575), 2,
      sym_line_comment,
      sym_block_comment,
  [78754] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1329), 1,
      sym_declaration_list,
    STATE(3102), 1,
      sym_where_clause,
    STATE(2576), 2,
      sym_line_comment,
      sym_block_comment,
  [78777] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2565), 1,
      sym_trait_bounds,
    STATE(2577), 2,
      sym_line_comment,
      sym_block_comment,
  [78800] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5692), 1,
      anon_sym_SEMI,
    STATE(3540), 1,
      sym_where_clause,
    STATE(2578), 2,
      sym_line_comment,
      sym_block_comment,
  [78823] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5694), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2579), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5696), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [78842] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(461), 1,
      sym_block,
    STATE(3596), 1,
      sym_label,
    STATE(2580), 2,
      sym_line_comment,
      sym_block_comment,
  [78865] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(737), 1,
      sym_enum_variant_list,
    STATE(3155), 1,
      sym_where_clause,
    STATE(2581), 2,
      sym_line_comment,
      sym_block_comment,
  [78888] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5365), 1,
      anon_sym_COMMA,
    STATE(2935), 1,
      aux_sym_parameters_repeat1,
    STATE(2582), 2,
      sym_line_comment,
      sym_block_comment,
  [78911] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2583), 2,
      sym_line_comment,
      sym_block_comment,
  [78932] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5698), 1,
      anon_sym_SEMI,
    ACTIONS(5700), 1,
      anon_sym_EQ,
    ACTIONS(5702), 1,
      anon_sym_else,
    STATE(2584), 2,
      sym_line_comment,
      sym_block_comment,
  [78955] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3333), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2585), 2,
      sym_line_comment,
      sym_block_comment,
  [78978] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5704), 1,
      anon_sym_SEMI,
    ACTIONS(5706), 1,
      anon_sym_EQ,
    ACTIONS(5708), 1,
      anon_sym_else,
    STATE(2586), 2,
      sym_line_comment,
      sym_block_comment,
  [79001] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3338), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2587), 2,
      sym_line_comment,
      sym_block_comment,
  [79024] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(1959), 1,
      sym_parameters,
    STATE(2588), 2,
      sym_line_comment,
      sym_block_comment,
  [79047] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5710), 1,
      anon_sym_RPAREN,
    ACTIONS(5712), 1,
      anon_sym_COMMA,
    STATE(2855), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2589), 2,
      sym_line_comment,
      sym_block_comment,
  [79070] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1802), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2590), 2,
      sym_line_comment,
      sym_block_comment,
  [79093] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1839), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2591), 2,
      sym_line_comment,
      sym_block_comment,
  [79116] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5714), 1,
      anon_sym_DQUOTE,
    STATE(2611), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5590), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2592), 2,
      sym_line_comment,
      sym_block_comment,
  [79137] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5716), 1,
      anon_sym_LBRACE,
    ACTIONS(5718), 1,
      anon_sym_for,
    ACTIONS(5720), 1,
      anon_sym_loop,
    ACTIONS(5722), 1,
      anon_sym_while,
    STATE(2593), 2,
      sym_line_comment,
      sym_block_comment,
  [79160] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    STATE(2594), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5724), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [79179] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(3154), 1,
      sym_type_arguments,
    ACTIONS(5726), 2,
      sym_identifier,
      sym_super,
    STATE(2595), 2,
      sym_line_comment,
      sym_block_comment,
  [79200] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(469), 1,
      sym_block,
    STATE(3596), 1,
      sym_label,
    STATE(2596), 2,
      sym_line_comment,
      sym_block_comment,
  [79223] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5728), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2597), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5730), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [79242] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1372), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2598), 2,
      sym_line_comment,
      sym_block_comment,
  [79265] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1470), 1,
      anon_sym_RPAREN,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5433), 1,
      anon_sym_COMMA,
    STATE(2972), 1,
      aux_sym_parameters_repeat1,
    STATE(2599), 2,
      sym_line_comment,
      sym_block_comment,
  [79288] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1365), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2600), 2,
      sym_line_comment,
      sym_block_comment,
  [79311] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5732), 1,
      anon_sym_DQUOTE,
    STATE(2654), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5590), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2601), 2,
      sym_line_comment,
      sym_block_comment,
  [79332] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1660), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2602), 2,
      sym_line_comment,
      sym_block_comment,
  [79355] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4895), 1,
      anon_sym_LT,
    STATE(2186), 1,
      sym_parameters,
    STATE(3244), 1,
      sym_type_parameters,
    STATE(2603), 2,
      sym_line_comment,
      sym_block_comment,
  [79378] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1572), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2604), 2,
      sym_line_comment,
      sym_block_comment,
  [79401] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3345), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2605), 2,
      sym_line_comment,
      sym_block_comment,
  [79424] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1669), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2606), 2,
      sym_line_comment,
      sym_block_comment,
  [79447] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1564), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(2105), 1,
      sym_block,
    STATE(3588), 1,
      sym_label,
    STATE(2607), 2,
      sym_line_comment,
      sym_block_comment,
  [79470] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3545), 1,
      sym_label,
    STATE(3600), 1,
      sym_block,
    STATE(2608), 2,
      sym_line_comment,
      sym_block_comment,
  [79493] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1212), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(465), 1,
      sym_block,
    STATE(3596), 1,
      sym_label,
    STATE(2609), 2,
      sym_line_comment,
      sym_block_comment,
  [79516] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5734), 1,
      anon_sym_SEMI,
    STATE(3361), 1,
      sym_where_clause,
    STATE(2610), 2,
      sym_line_comment,
      sym_block_comment,
  [79539] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5736), 1,
      anon_sym_DQUOTE,
    STATE(2546), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5590), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2611), 2,
      sym_line_comment,
      sym_block_comment,
  [79560] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(3106), 1,
      sym_type_arguments,
    ACTIONS(5726), 2,
      sym_identifier,
      sym_super,
    STATE(2612), 2,
      sym_line_comment,
      sym_block_comment,
  [79581] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4895), 1,
      anon_sym_LT,
    STATE(2196), 1,
      sym_parameters,
    STATE(3235), 1,
      sym_type_parameters,
    STATE(2613), 2,
      sym_line_comment,
      sym_block_comment,
  [79604] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(371), 1,
      sym_block,
    STATE(3414), 1,
      sym_label,
    STATE(2614), 2,
      sym_line_comment,
      sym_block_comment,
  [79627] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1097), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2615), 2,
      sym_line_comment,
      sym_block_comment,
  [79650] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1370), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2616), 2,
      sym_line_comment,
      sym_block_comment,
  [79673] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1379), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2617), 2,
      sym_line_comment,
      sym_block_comment,
  [79696] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4895), 1,
      anon_sym_LT,
    STATE(2184), 1,
      sym_parameters,
    STATE(3052), 1,
      sym_type_parameters,
    STATE(2618), 2,
      sym_line_comment,
      sym_block_comment,
  [79719] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5674), 1,
      anon_sym_LPAREN,
    ACTIONS(5676), 1,
      anon_sym_LBRACK,
    ACTIONS(5678), 1,
      anon_sym_LBRACE,
    STATE(1024), 1,
      sym_delim_token_tree,
    STATE(2619), 2,
      sym_line_comment,
      sym_block_comment,
  [79742] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1101), 1,
      sym_field_declaration_list,
    STATE(3148), 1,
      sym_where_clause,
    STATE(2620), 2,
      sym_line_comment,
      sym_block_comment,
  [79765] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4614), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5738), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4616), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2621), 2,
      sym_line_comment,
      sym_block_comment,
  [79786] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5740), 1,
      sym_identifier,
    STATE(3106), 1,
      sym_type_arguments,
    STATE(2622), 2,
      sym_line_comment,
      sym_block_comment,
  [79809] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(5225), 1,
      anon_sym_LBRACE,
    STATE(1108), 1,
      sym_enum_variant_list,
    STATE(3152), 1,
      sym_where_clause,
    STATE(2623), 2,
      sym_line_comment,
      sym_block_comment,
  [79832] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2624), 2,
      sym_line_comment,
      sym_block_comment,
  [79853] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5740), 1,
      sym_identifier,
    STATE(3154), 1,
      sym_type_arguments,
    STATE(2625), 2,
      sym_line_comment,
      sym_block_comment,
  [79876] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5742), 1,
      anon_sym_LBRACE,
    ACTIONS(5744), 1,
      anon_sym_for,
    ACTIONS(5746), 1,
      anon_sym_loop,
    ACTIONS(5748), 1,
      anon_sym_while,
    STATE(2626), 2,
      sym_line_comment,
      sym_block_comment,
  [79899] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(381), 1,
      sym_block,
    STATE(3414), 1,
      sym_label,
    STATE(2627), 2,
      sym_line_comment,
      sym_block_comment,
  [79922] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5750), 1,
      anon_sym_COLON_COLON,
    STATE(2628), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4728), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [79941] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1636), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2629), 2,
      sym_line_comment,
      sym_block_comment,
  [79964] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(3467), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4852), 1,
      anon_sym_BANG,
    STATE(1068), 1,
      sym_type_arguments,
    STATE(2630), 2,
      sym_line_comment,
      sym_block_comment,
  [79987] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5463), 1,
      anon_sym_RPAREN,
    ACTIONS(5465), 1,
      anon_sym_COMMA,
    STATE(2977), 1,
      aux_sym_parameters_repeat1,
    STATE(2631), 2,
      sym_line_comment,
      sym_block_comment,
  [80010] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1113), 1,
      sym_declaration_list,
    STATE(3160), 1,
      sym_where_clause,
    STATE(2632), 2,
      sym_line_comment,
      sym_block_comment,
  [80033] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(591), 1,
      sym_declaration_list,
    STATE(3236), 1,
      sym_where_clause,
    STATE(2633), 2,
      sym_line_comment,
      sym_block_comment,
  [80056] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1312), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2634), 2,
      sym_line_comment,
      sym_block_comment,
  [80079] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5752), 1,
      anon_sym_COLON_COLON,
    STATE(2635), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4734), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [80098] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5111), 1,
      anon_sym_LPAREN,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    STATE(1311), 1,
      sym_delim_token_tree,
    STATE(2636), 2,
      sym_line_comment,
      sym_block_comment,
  [80121] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5754), 1,
      anon_sym_RPAREN,
    ACTIONS(5756), 1,
      anon_sym_COMMA,
    STATE(2812), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2637), 2,
      sym_line_comment,
      sym_block_comment,
  [80144] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5758), 1,
      anon_sym_SEMI,
    STATE(3434), 1,
      sym_where_clause,
    STATE(2638), 2,
      sym_line_comment,
      sym_block_comment,
  [80167] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1124), 1,
      sym_declaration_list,
    STATE(3175), 1,
      sym_where_clause,
    STATE(2639), 2,
      sym_line_comment,
      sym_block_comment,
  [80190] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1058), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2640), 2,
      sym_line_comment,
      sym_block_comment,
  [80213] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5760), 1,
      anon_sym_RPAREN,
    ACTIONS(5762), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2641), 2,
      sym_line_comment,
      sym_block_comment,
  [80236] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5740), 1,
      sym_identifier,
    STATE(3154), 1,
      sym_type_arguments,
    STATE(2642), 2,
      sym_line_comment,
      sym_block_comment,
  [80259] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5764), 1,
      anon_sym_COLON_COLON,
    STATE(2643), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4734), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [80278] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1785), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2644), 2,
      sym_line_comment,
      sym_block_comment,
  [80301] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5766), 1,
      anon_sym_COLON_COLON,
    STATE(2645), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4734), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [80320] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5133), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2646), 2,
      sym_line_comment,
      sym_block_comment,
  [80341] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5768), 1,
      anon_sym_LBRACE,
    ACTIONS(5770), 1,
      anon_sym_for,
    ACTIONS(5772), 1,
      anon_sym_loop,
    ACTIONS(5774), 1,
      anon_sym_while,
    STATE(2647), 2,
      sym_line_comment,
      sym_block_comment,
  [80364] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5776), 1,
      anon_sym_DQUOTE,
    STATE(2509), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5590), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2648), 2,
      sym_line_comment,
      sym_block_comment,
  [80385] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5750), 1,
      anon_sym_COLON_COLON,
    STATE(2649), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4746), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [80404] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5778), 1,
      anon_sym_in,
    STATE(2650), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5780), 3,
      sym_self,
      sym_super,
      sym_crate,
  [80423] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5782), 1,
      anon_sym_SEMI,
    ACTIONS(5784), 1,
      anon_sym_EQ,
    ACTIONS(5786), 1,
      anon_sym_else,
    STATE(2651), 2,
      sym_line_comment,
      sym_block_comment,
  [80446] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1293), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2652), 2,
      sym_line_comment,
      sym_block_comment,
  [80469] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5788), 1,
      anon_sym_DQUOTE,
    STATE(2664), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5590), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2653), 2,
      sym_line_comment,
      sym_block_comment,
  [80490] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5790), 1,
      anon_sym_DQUOTE,
    STATE(2546), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5590), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2654), 2,
      sym_line_comment,
      sym_block_comment,
  [80511] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(2951), 1,
      sym_trait_bounds,
    ACTIONS(5792), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2655), 2,
      sym_line_comment,
      sym_block_comment,
  [80532] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5111), 1,
      anon_sym_LPAREN,
    ACTIONS(5113), 1,
      anon_sym_LBRACK,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    STATE(1292), 1,
      sym_delim_token_tree,
    STATE(2656), 2,
      sym_line_comment,
      sym_block_comment,
  [80555] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5795), 1,
      sym_identifier,
    STATE(1549), 1,
      sym_type_arguments,
    STATE(2657), 2,
      sym_line_comment,
      sym_block_comment,
  [80578] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1801), 1,
      sym_block,
    STATE(3597), 1,
      sym_label,
    STATE(2658), 2,
      sym_line_comment,
      sym_block_comment,
  [80601] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5740), 1,
      sym_identifier,
    STATE(3106), 1,
      sym_type_arguments,
    STATE(2659), 2,
      sym_line_comment,
      sym_block_comment,
  [80624] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5752), 1,
      anon_sym_COLON_COLON,
    STATE(2660), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [80643] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4634), 1,
      anon_sym_GT,
    ACTIONS(5461), 1,
      anon_sym_COMMA,
    ACTIONS(5664), 1,
      anon_sym_EQ,
    STATE(2915), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2661), 2,
      sym_line_comment,
      sym_block_comment,
  [80666] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5797), 1,
      anon_sym_LPAREN,
    ACTIONS(5799), 1,
      anon_sym_LBRACK,
    ACTIONS(5801), 1,
      anon_sym_LBRACE,
    STATE(1638), 1,
      sym_delim_token_tree,
    STATE(2662), 2,
      sym_line_comment,
      sym_block_comment,
  [80689] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5764), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [80708] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5803), 1,
      anon_sym_DQUOTE,
    STATE(2546), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5590), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2664), 2,
      sym_line_comment,
      sym_block_comment,
  [80729] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5766), 1,
      anon_sym_COLON_COLON,
    STATE(2665), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [80748] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5795), 1,
      sym_identifier,
    STATE(1547), 1,
      sym_type_arguments,
    STATE(2666), 2,
      sym_line_comment,
      sym_block_comment,
  [80771] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5797), 1,
      anon_sym_LPAREN,
    ACTIONS(5799), 1,
      anon_sym_LBRACK,
    ACTIONS(5801), 1,
      anon_sym_LBRACE,
    STATE(1672), 1,
      sym_delim_token_tree,
    STATE(2667), 2,
      sym_line_comment,
      sym_block_comment,
  [80794] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(377), 1,
      sym_block,
    STATE(3414), 1,
      sym_label,
    STATE(2668), 2,
      sym_line_comment,
      sym_block_comment,
  [80817] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5805), 1,
      anon_sym_SEMI,
    STATE(3371), 1,
      sym_where_clause,
    STATE(2669), 2,
      sym_line_comment,
      sym_block_comment,
  [80840] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5807), 1,
      sym_identifier,
    STATE(3106), 1,
      sym_type_arguments,
    STATE(2670), 2,
      sym_line_comment,
      sym_block_comment,
  [80863] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5807), 1,
      sym_identifier,
    STATE(3154), 1,
      sym_type_arguments,
    STATE(2671), 2,
      sym_line_comment,
      sym_block_comment,
  [80886] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(557), 1,
      sym_declaration_list,
    STATE(3245), 1,
      sym_where_clause,
    STATE(2672), 2,
      sym_line_comment,
      sym_block_comment,
  [80909] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5809), 1,
      anon_sym_COLON,
    STATE(2673), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4848), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [80928] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4722), 1,
      anon_sym_for,
    ACTIONS(5584), 1,
      anon_sym_COLON_COLON,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(2674), 2,
      sym_line_comment,
      sym_block_comment,
  [80951] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2675), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5811), 4,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [80968] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(3154), 1,
      sym_type_arguments,
    ACTIONS(5813), 2,
      sym_identifier,
      sym_super,
    STATE(2676), 2,
      sym_line_comment,
      sym_block_comment,
  [80989] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(3106), 1,
      sym_type_arguments,
    ACTIONS(5813), 2,
      sym_identifier,
      sym_super,
    STATE(2677), 2,
      sym_line_comment,
      sym_block_comment,
  [81010] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(5815), 1,
      anon_sym_RBRACK,
    ACTIONS(5817), 1,
      anon_sym_COMMA,
    STATE(2769), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2678), 2,
      sym_line_comment,
      sym_block_comment,
  [81033] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(5819), 1,
      anon_sym_RPAREN,
    ACTIONS(5821), 1,
      anon_sym_COMMA,
    STATE(2771), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2679), 2,
      sym_line_comment,
      sym_block_comment,
  [81056] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5823), 1,
      anon_sym_COMMA,
    ACTIONS(4099), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2680), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_arguments_repeat1,
  [81075] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(5826), 1,
      anon_sym_RBRACK,
    ACTIONS(5828), 1,
      anon_sym_COMMA,
    STATE(2773), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2681), 2,
      sym_line_comment,
      sym_block_comment,
  [81098] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5515), 1,
      anon_sym_RPAREN,
    ACTIONS(5517), 1,
      anon_sym_COMMA,
    STATE(2899), 1,
      aux_sym_parameters_repeat1,
    STATE(2682), 2,
      sym_line_comment,
      sym_block_comment,
  [81121] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(5830), 1,
      anon_sym_RPAREN,
    ACTIONS(5832), 1,
      anon_sym_COMMA,
    STATE(2986), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2683), 2,
      sym_line_comment,
      sym_block_comment,
  [81144] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(5834), 1,
      anon_sym_RPAREN,
    ACTIONS(5836), 1,
      anon_sym_COMMA,
    STATE(2772), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2684), 2,
      sym_line_comment,
      sym_block_comment,
  [81167] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5628), 1,
      sym_identifier,
    ACTIONS(5726), 1,
      sym_super,
    STATE(3106), 1,
      sym_type_arguments,
    STATE(2685), 2,
      sym_line_comment,
      sym_block_comment,
  [81190] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5838), 1,
      anon_sym_DQUOTE,
    STATE(2695), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5590), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2686), 2,
      sym_line_comment,
      sym_block_comment,
  [81211] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5270), 1,
      anon_sym_PLUS,
    STATE(2687), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5840), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_COMMA,
  [81230] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(3106), 1,
      sym_type_arguments,
    ACTIONS(5129), 2,
      sym_identifier,
      sym_super,
    STATE(2688), 2,
      sym_line_comment,
      sym_block_comment,
  [81251] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(5842), 1,
      anon_sym_RPAREN,
    ACTIONS(5844), 1,
      anon_sym_COMMA,
    STATE(2892), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2689), 2,
      sym_line_comment,
      sym_block_comment,
  [81274] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5628), 1,
      sym_identifier,
    ACTIONS(5726), 1,
      sym_super,
    STATE(3154), 1,
      sym_type_arguments,
    STATE(2690), 2,
      sym_line_comment,
      sym_block_comment,
  [81297] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(3154), 1,
      sym_type_arguments,
    ACTIONS(5129), 2,
      sym_identifier,
      sym_super,
    STATE(2691), 2,
      sym_line_comment,
      sym_block_comment,
  [81318] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5846), 1,
      anon_sym_RPAREN,
    ACTIONS(5848), 1,
      anon_sym_COMMA,
    STATE(2786), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2692), 2,
      sym_line_comment,
      sym_block_comment,
  [81341] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(5850), 1,
      anon_sym_RPAREN,
    ACTIONS(5852), 1,
      anon_sym_COMMA,
    STATE(2888), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2693), 2,
      sym_line_comment,
      sym_block_comment,
  [81364] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(3241), 1,
      sym_trait_bounds,
    ACTIONS(5519), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2694), 2,
      sym_line_comment,
      sym_block_comment,
  [81385] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5854), 1,
      anon_sym_DQUOTE,
    STATE(2546), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5590), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2695), 2,
      sym_line_comment,
      sym_block_comment,
  [81406] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5856), 1,
      sym_identifier,
    STATE(3106), 1,
      sym_type_arguments,
    STATE(2696), 2,
      sym_line_comment,
      sym_block_comment,
  [81429] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5856), 1,
      sym_identifier,
    STATE(3154), 1,
      sym_type_arguments,
    STATE(2697), 2,
      sym_line_comment,
      sym_block_comment,
  [81452] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4453), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5858), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2698), 2,
      sym_line_comment,
      sym_block_comment,
  [81471] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5813), 1,
      sym_super,
    ACTIONS(5860), 1,
      sym_identifier,
    STATE(3106), 1,
      sym_type_arguments,
    STATE(2699), 2,
      sym_line_comment,
      sym_block_comment,
  [81494] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5584), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5862), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(2700), 2,
      sym_line_comment,
      sym_block_comment,
  [81517] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5584), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5864), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(2701), 2,
      sym_line_comment,
      sym_block_comment,
  [81540] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5813), 1,
      sym_super,
    ACTIONS(5860), 1,
      sym_identifier,
    STATE(3154), 1,
      sym_type_arguments,
    STATE(2702), 2,
      sym_line_comment,
      sym_block_comment,
  [81563] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5866), 1,
      anon_sym_LBRACE,
    ACTIONS(5868), 1,
      anon_sym_for,
    ACTIONS(5870), 1,
      anon_sym_loop,
    ACTIONS(5872), 1,
      anon_sym_while,
    STATE(2703), 2,
      sym_line_comment,
      sym_block_comment,
  [81586] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5874), 1,
      sym_identifier,
    STATE(1414), 1,
      sym_type_arguments,
    STATE(2704), 2,
      sym_line_comment,
      sym_block_comment,
  [81609] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5807), 1,
      sym_identifier,
    STATE(3106), 1,
      sym_type_arguments,
    STATE(2705), 2,
      sym_line_comment,
      sym_block_comment,
  [81632] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    STATE(1053), 1,
      sym_parameters,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2706), 2,
      sym_line_comment,
      sym_block_comment,
  [81655] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5807), 1,
      sym_identifier,
    STATE(3154), 1,
      sym_type_arguments,
    STATE(2707), 2,
      sym_line_comment,
      sym_block_comment,
  [81678] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5876), 1,
      sym_identifier,
    STATE(3106), 1,
      sym_type_arguments,
    STATE(2708), 2,
      sym_line_comment,
      sym_block_comment,
  [81701] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5876), 1,
      sym_identifier,
    STATE(3154), 1,
      sym_type_arguments,
    STATE(2709), 2,
      sym_line_comment,
      sym_block_comment,
  [81724] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5878), 1,
      sym_identifier,
    STATE(3106), 1,
      sym_type_arguments,
    STATE(2710), 2,
      sym_line_comment,
      sym_block_comment,
  [81747] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5878), 1,
      sym_identifier,
    STATE(3154), 1,
      sym_type_arguments,
    STATE(2711), 2,
      sym_line_comment,
      sym_block_comment,
  [81770] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(1183), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2712), 2,
      sym_line_comment,
      sym_block_comment,
  [81793] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(5541), 1,
      anon_sym_RPAREN,
    ACTIONS(5545), 1,
      anon_sym_COMMA,
    STATE(2993), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2713), 2,
      sym_line_comment,
      sym_block_comment,
  [81816] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(5225), 1,
      anon_sym_LBRACE,
    STATE(1232), 1,
      sym_enum_variant_list,
    STATE(3157), 1,
      sym_where_clause,
    STATE(2714), 2,
      sym_line_comment,
      sym_block_comment,
  [81839] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5880), 1,
      sym_identifier,
    STATE(3106), 1,
      sym_type_arguments,
    STATE(2715), 2,
      sym_line_comment,
      sym_block_comment,
  [81862] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2716), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5561), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
  [81879] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5880), 1,
      sym_identifier,
    STATE(3154), 1,
      sym_type_arguments,
    STATE(2717), 2,
      sym_line_comment,
      sym_block_comment,
  [81902] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5487), 1,
      anon_sym_GT,
    ACTIONS(5489), 1,
      anon_sym_COMMA,
    ACTIONS(5664), 1,
      anon_sym_EQ,
    STATE(2816), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2718), 2,
      sym_line_comment,
      sym_block_comment,
  [81925] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5880), 1,
      sym_identifier,
    STATE(3106), 1,
      sym_type_arguments,
    STATE(2719), 2,
      sym_line_comment,
      sym_block_comment,
  [81948] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5880), 1,
      sym_identifier,
    STATE(3154), 1,
      sym_type_arguments,
    STATE(2720), 2,
      sym_line_comment,
      sym_block_comment,
  [81971] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(2951), 1,
      sym_trait_bounds,
    ACTIONS(5882), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2721), 2,
      sym_line_comment,
      sym_block_comment,
  [81992] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3401), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2722), 2,
      sym_line_comment,
      sym_block_comment,
  [82015] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5584), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5884), 1,
      anon_sym_for,
    STATE(1934), 1,
      sym_type_arguments,
    STATE(2723), 2,
      sym_line_comment,
      sym_block_comment,
  [82038] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1207), 1,
      sym_declaration_list,
    STATE(3217), 1,
      sym_where_clause,
    STATE(2724), 2,
      sym_line_comment,
      sym_block_comment,
  [82061] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(3402), 1,
      sym_block,
    STATE(3545), 1,
      sym_label,
    STATE(2725), 2,
      sym_line_comment,
      sym_block_comment,
  [82084] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5155), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4465), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2726), 2,
      sym_line_comment,
      sym_block_comment,
  [82105] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1201), 1,
      sym_field_declaration_list,
    STATE(3250), 1,
      sym_where_clause,
    STATE(2727), 2,
      sym_line_comment,
      sym_block_comment,
  [82128] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5874), 1,
      sym_identifier,
    STATE(1437), 1,
      sym_type_arguments,
    STATE(2728), 2,
      sym_line_comment,
      sym_block_comment,
  [82151] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_SQUOTE,
    STATE(385), 1,
      sym_block,
    STATE(3414), 1,
      sym_label,
    STATE(2729), 2,
      sym_line_comment,
      sym_block_comment,
  [82174] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5592), 1,
      anon_sym_LPAREN,
    ACTIONS(5594), 1,
      anon_sym_LBRACK,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    STATE(374), 1,
      sym_delim_token_tree,
    STATE(2730), 2,
      sym_line_comment,
      sym_block_comment,
  [82197] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(5886), 1,
      anon_sym_SEMI,
    STATE(1115), 1,
      sym_declaration_list,
    STATE(2731), 2,
      sym_line_comment,
      sym_block_comment,
  [82217] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4865), 1,
      anon_sym_RBRACE,
    ACTIONS(5888), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2732), 2,
      sym_line_comment,
      sym_block_comment,
  [82237] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2733), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4818), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82253] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5890), 1,
      sym_identifier,
    ACTIONS(5892), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(2734), 2,
      sym_line_comment,
      sym_block_comment,
  [82271] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5894), 1,
      sym_identifier,
    ACTIONS(5896), 1,
      anon_sym_ref,
    ACTIONS(5898), 1,
      sym_mutable_specifier,
    STATE(2735), 2,
      sym_line_comment,
      sym_block_comment,
  [82291] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2736), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4764), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82307] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2737), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4766), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82323] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5900), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2738), 2,
      sym_line_comment,
      sym_block_comment,
  [82343] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2739), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4804), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82359] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2740), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4832), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82375] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5902), 1,
      anon_sym_RBRACE,
    ACTIONS(5904), 1,
      anon_sym_COMMA,
    STATE(2853), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2741), 2,
      sym_line_comment,
      sym_block_comment,
  [82395] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2742), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4820), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82411] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(5906), 1,
      anon_sym_SEMI,
    STATE(3400), 1,
      sym_where_clause,
    STATE(2743), 2,
      sym_line_comment,
      sym_block_comment,
  [82431] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(5908), 1,
      anon_sym_SEMI,
    STATE(1189), 1,
      sym_declaration_list,
    STATE(2744), 2,
      sym_line_comment,
      sym_block_comment,
  [82451] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5910), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2745), 2,
      sym_line_comment,
      sym_block_comment,
  [82471] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(5912), 1,
      anon_sym_SEMI,
    STATE(1218), 1,
      sym_declaration_list,
    STATE(2746), 2,
      sym_line_comment,
      sym_block_comment,
  [82491] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2747), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4806), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82507] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5914), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2748), 2,
      sym_line_comment,
      sym_block_comment,
  [82527] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2749), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4796), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82543] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5463), 1,
      anon_sym_RPAREN,
    ACTIONS(5465), 1,
      anon_sym_COMMA,
    STATE(2977), 1,
      aux_sym_parameters_repeat1,
    STATE(2750), 2,
      sym_line_comment,
      sym_block_comment,
  [82563] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5487), 1,
      anon_sym_GT,
    ACTIONS(5489), 1,
      anon_sym_COMMA,
    STATE(2816), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2751), 2,
      sym_line_comment,
      sym_block_comment,
  [82583] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(5916), 1,
      anon_sym_EQ,
    STATE(3578), 1,
      sym_type_parameters,
    STATE(2752), 2,
      sym_line_comment,
      sym_block_comment,
  [82603] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2753), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4792), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82619] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2754), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4788), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82635] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4941), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2755), 2,
      sym_line_comment,
      sym_block_comment,
  [82655] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5920), 1,
      anon_sym_COLON,
    ACTIONS(5918), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2756), 2,
      sym_line_comment,
      sym_block_comment,
  [82673] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5922), 1,
      anon_sym_RBRACE,
    ACTIONS(5924), 1,
      anon_sym_COMMA,
    STATE(2987), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2757), 2,
      sym_line_comment,
      sym_block_comment,
  [82693] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2758), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4822), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82709] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2759), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4808), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82725] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2760), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4798), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82741] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2761), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82757] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2762), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4784), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82773] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2763), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4778), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82789] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5926), 1,
      sym_identifier,
    ACTIONS(5928), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(2764), 2,
      sym_line_comment,
      sym_block_comment,
  [82807] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2765), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4782), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82823] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2766), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4790), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82839] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(5930), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    STATE(2767), 2,
      sym_line_comment,
      sym_block_comment,
  [82859] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(983), 1,
      anon_sym_RBRACK,
    ACTIONS(4075), 1,
      anon_sym_COMMA,
    STATE(2680), 1,
      aux_sym_arguments_repeat1,
    STATE(2768), 2,
      sym_line_comment,
      sym_block_comment,
  [82879] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3017), 1,
      anon_sym_RBRACK,
    ACTIONS(5932), 1,
      anon_sym_COMMA,
    STATE(2539), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2769), 2,
      sym_line_comment,
      sym_block_comment,
  [82899] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    ACTIONS(5934), 1,
      anon_sym_COLON_COLON,
    STATE(1469), 1,
      sym_field_initializer_list,
    STATE(2770), 2,
      sym_line_comment,
      sym_block_comment,
  [82919] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2949), 1,
      anon_sym_RPAREN,
    ACTIONS(5936), 1,
      anon_sym_COMMA,
    STATE(2996), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2771), 2,
      sym_line_comment,
      sym_block_comment,
  [82939] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2945), 1,
      anon_sym_RPAREN,
    ACTIONS(5938), 1,
      anon_sym_COMMA,
    STATE(2996), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2772), 2,
      sym_line_comment,
      sym_block_comment,
  [82959] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3025), 1,
      anon_sym_RBRACK,
    ACTIONS(5940), 1,
      anon_sym_COMMA,
    STATE(2539), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2773), 2,
      sym_line_comment,
      sym_block_comment,
  [82979] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2774), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4734), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82995] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2775), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4794), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83011] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5525), 1,
      anon_sym_COLON,
    ACTIONS(5942), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2776), 2,
      sym_line_comment,
      sym_block_comment,
  [83029] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2777), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4802), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83045] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5942), 1,
      anon_sym_PIPE,
    ACTIONS(5944), 1,
      anon_sym_COMMA,
    STATE(2778), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_closure_parameters_repeat1,
  [83063] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2779), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4848), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83079] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5947), 1,
      anon_sym_RBRACE,
    ACTIONS(5949), 1,
      anon_sym_COMMA,
    STATE(2890), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2780), 2,
      sym_line_comment,
      sym_block_comment,
  [83099] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2781), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5951), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [83115] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5953), 1,
      anon_sym_SEMI,
    ACTIONS(5955), 1,
      anon_sym_RBRACK,
    STATE(2782), 2,
      sym_line_comment,
      sym_block_comment,
  [83135] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2783), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4812), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83151] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5957), 1,
      anon_sym_RBRACE,
    ACTIONS(5959), 1,
      anon_sym_COMMA,
    STATE(2894), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2784), 2,
      sym_line_comment,
      sym_block_comment,
  [83171] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2785), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4814), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83187] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3141), 1,
      anon_sym_RPAREN,
    ACTIONS(5961), 1,
      anon_sym_COMMA,
    STATE(2981), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2786), 2,
      sym_line_comment,
      sym_block_comment,
  [83207] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5963), 1,
      anon_sym_LPAREN,
    ACTIONS(5965), 1,
      anon_sym_LBRACK,
    ACTIONS(5967), 1,
      anon_sym_LBRACE,
    STATE(2787), 2,
      sym_line_comment,
      sym_block_comment,
  [83227] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(973), 1,
      anon_sym_RBRACK,
    ACTIONS(4097), 1,
      anon_sym_COMMA,
    STATE(2680), 1,
      aux_sym_arguments_repeat1,
    STATE(2788), 2,
      sym_line_comment,
      sym_block_comment,
  [83247] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2789), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4786), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83263] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5969), 1,
      anon_sym_LPAREN,
    ACTIONS(5971), 1,
      anon_sym_LBRACK,
    ACTIONS(5973), 1,
      anon_sym_LBRACE,
    STATE(2790), 2,
      sym_line_comment,
      sym_block_comment,
  [83283] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5515), 1,
      anon_sym_RPAREN,
    ACTIONS(5517), 1,
      anon_sym_COMMA,
    STATE(2899), 1,
      aux_sym_parameters_repeat1,
    STATE(2791), 2,
      sym_line_comment,
      sym_block_comment,
  [83303] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2792), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4780), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83319] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2793), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4800), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83335] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5975), 1,
      anon_sym_move,
    STATE(220), 1,
      sym_closure_parameters,
    STATE(2794), 2,
      sym_line_comment,
      sym_block_comment,
  [83355] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2795), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4834), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83371] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2796), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83387] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5819), 1,
      anon_sym_RPAREN,
    ACTIONS(5821), 1,
      anon_sym_COMMA,
    STATE(2771), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2797), 2,
      sym_line_comment,
      sym_block_comment,
  [83407] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2798), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(959), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_COMMA,
  [83423] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2799), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5977), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [83439] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5979), 1,
      anon_sym_SEMI,
    ACTIONS(5981), 1,
      anon_sym_EQ,
    STATE(2800), 2,
      sym_line_comment,
      sym_block_comment,
  [83459] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5983), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2801), 2,
      sym_line_comment,
      sym_block_comment,
  [83477] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2802), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5985), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [83493] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5529), 1,
      anon_sym_COMMA,
    ACTIONS(5987), 1,
      anon_sym_PIPE,
    STATE(2911), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2803), 2,
      sym_line_comment,
      sym_block_comment,
  [83513] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2804), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4846), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83529] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5989), 1,
      anon_sym_RBRACE,
    ACTIONS(5991), 1,
      anon_sym_COMMA,
    STATE(2905), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2805), 2,
      sym_line_comment,
      sym_block_comment,
  [83549] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2806), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4836), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83565] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(989), 1,
      anon_sym_RBRACK,
    ACTIONS(4043), 1,
      anon_sym_COMMA,
    STATE(2680), 1,
      aux_sym_arguments_repeat1,
    STATE(2807), 2,
      sym_line_comment,
      sym_block_comment,
  [83585] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2808), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4828), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83601] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4860), 1,
      anon_sym_LBRACE,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2809), 2,
      sym_line_comment,
      sym_block_comment,
  [83621] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5993), 1,
      anon_sym_RBRACE,
    ACTIONS(5995), 1,
      anon_sym_COMMA,
    STATE(2983), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2810), 2,
      sym_line_comment,
      sym_block_comment,
  [83641] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2811), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4826), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83657] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3139), 1,
      anon_sym_RPAREN,
    ACTIONS(5997), 1,
      anon_sym_COMMA,
    STATE(2981), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2812), 2,
      sym_line_comment,
      sym_block_comment,
  [83677] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(5999), 1,
      anon_sym_SEMI,
    STATE(717), 1,
      sym_declaration_list,
    STATE(2813), 2,
      sym_line_comment,
      sym_block_comment,
  [83697] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4644), 1,
      anon_sym_GT,
    ACTIONS(6001), 1,
      anon_sym_COMMA,
    STATE(2949), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2814), 2,
      sym_line_comment,
      sym_block_comment,
  [83717] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6003), 1,
      anon_sym_SEMI,
    STATE(715), 1,
      sym_declaration_list,
    STATE(2815), 2,
      sym_line_comment,
      sym_block_comment,
  [83737] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4634), 1,
      anon_sym_GT,
    ACTIONS(5461), 1,
      anon_sym_COMMA,
    STATE(2949), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2816), 2,
      sym_line_comment,
      sym_block_comment,
  [83757] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6005), 1,
      sym_identifier,
    ACTIONS(6007), 1,
      anon_sym_await,
    ACTIONS(6009), 1,
      sym_integer_literal,
    STATE(2817), 2,
      sym_line_comment,
      sym_block_comment,
  [83777] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4634), 1,
      anon_sym_GT,
    ACTIONS(5461), 1,
      anon_sym_COMMA,
    STATE(2915), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2818), 2,
      sym_line_comment,
      sym_block_comment,
  [83797] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6011), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2819), 2,
      sym_line_comment,
      sym_block_comment,
  [83815] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6013), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2820), 2,
      sym_line_comment,
      sym_block_comment,
  [83833] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2821), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6015), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [83849] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6017), 1,
      anon_sym_SEMI,
    STATE(1145), 1,
      sym_declaration_list,
    STATE(2822), 2,
      sym_line_comment,
      sym_block_comment,
  [83869] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5270), 1,
      anon_sym_PLUS,
    ACTIONS(6019), 1,
      anon_sym_GT,
    ACTIONS(6021), 1,
      anon_sym_as,
    STATE(2823), 2,
      sym_line_comment,
      sym_block_comment,
  [83889] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6023), 1,
      anon_sym_SEMI,
    ACTIONS(6025), 1,
      anon_sym_EQ,
    STATE(2824), 2,
      sym_line_comment,
      sym_block_comment,
  [83909] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6027), 1,
      anon_sym_SEMI,
    STATE(660), 1,
      sym_declaration_list,
    STATE(2825), 2,
      sym_line_comment,
      sym_block_comment,
  [83929] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6029), 1,
      anon_sym_SEMI,
    STATE(657), 1,
      sym_declaration_list,
    STATE(2826), 2,
      sym_line_comment,
      sym_block_comment,
  [83949] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6031), 1,
      anon_sym_SEMI,
    STATE(636), 1,
      sym_declaration_list,
    STATE(2827), 2,
      sym_line_comment,
      sym_block_comment,
  [83969] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6033), 1,
      anon_sym_SEMI,
    STATE(633), 1,
      sym_declaration_list,
    STATE(2828), 2,
      sym_line_comment,
      sym_block_comment,
  [83989] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5654), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2829), 2,
      sym_line_comment,
      sym_block_comment,
  [84007] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6035), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4245), 2,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(2830), 2,
      sym_line_comment,
      sym_block_comment,
  [84025] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6035), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6037), 2,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(2831), 2,
      sym_line_comment,
      sym_block_comment,
  [84043] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6039), 1,
      anon_sym_SEMI,
    ACTIONS(6041), 1,
      anon_sym_EQ,
    STATE(2832), 2,
      sym_line_comment,
      sym_block_comment,
  [84063] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6043), 1,
      anon_sym_RPAREN,
    ACTIONS(6045), 1,
      anon_sym_COMMA,
    STATE(2851), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2833), 2,
      sym_line_comment,
      sym_block_comment,
  [84083] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6047), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2834), 2,
      sym_line_comment,
      sym_block_comment,
  [84101] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6049), 1,
      anon_sym_RBRACE,
    ACTIONS(6051), 1,
      anon_sym_COMMA,
    STATE(2927), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2835), 2,
      sym_line_comment,
      sym_block_comment,
  [84121] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6053), 1,
      anon_sym_SEMI,
    STATE(599), 1,
      sym_declaration_list,
    STATE(2836), 2,
      sym_line_comment,
      sym_block_comment,
  [84141] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(6055), 1,
      anon_sym_SEMI,
    STATE(3312), 1,
      sym_where_clause,
    STATE(2837), 2,
      sym_line_comment,
      sym_block_comment,
  [84161] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6057), 1,
      anon_sym_SEMI,
    STATE(586), 1,
      sym_declaration_list,
    STATE(2838), 2,
      sym_line_comment,
      sym_block_comment,
  [84181] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2839), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4824), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [84197] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6059), 1,
      anon_sym_SEMI,
    STATE(517), 1,
      sym_declaration_list,
    STATE(2840), 2,
      sym_line_comment,
      sym_block_comment,
  [84217] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6061), 1,
      anon_sym_SEMI,
    STATE(1301), 1,
      sym_declaration_list,
    STATE(2841), 2,
      sym_line_comment,
      sym_block_comment,
  [84237] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4554), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6063), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2842), 2,
      sym_line_comment,
      sym_block_comment,
  [84255] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6065), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2843), 2,
      sym_line_comment,
      sym_block_comment,
  [84273] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2844), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6067), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [84289] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(6069), 1,
      anon_sym_SEMI,
    STATE(3438), 1,
      sym_where_clause,
    STATE(2845), 2,
      sym_line_comment,
      sym_block_comment,
  [84309] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2846), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6071), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [84325] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4909), 1,
      anon_sym_RBRACE,
    ACTIONS(6073), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2847), 2,
      sym_line_comment,
      sym_block_comment,
  [84345] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2848), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4810), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [84361] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6075), 1,
      anon_sym_RBRACE,
    ACTIONS(6077), 1,
      anon_sym_COMMA,
    STATE(2849), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_field_declaration_list_repeat1,
  [84379] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6080), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2850), 2,
      sym_line_comment,
      sym_block_comment,
  [84397] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6082), 1,
      anon_sym_RPAREN,
    ACTIONS(6084), 1,
      anon_sym_COMMA,
    STATE(2851), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_ordered_field_declaration_list_repeat1,
  [84415] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    ACTIONS(6087), 1,
      sym_mutable_specifier,
    ACTIONS(6089), 1,
      sym_self,
    STATE(2852), 2,
      sym_line_comment,
      sym_block_comment,
  [84435] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4850), 1,
      anon_sym_RBRACE,
    ACTIONS(6091), 1,
      anon_sym_COMMA,
    STATE(2910), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2853), 2,
      sym_line_comment,
      sym_block_comment,
  [84455] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6093), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2854), 2,
      sym_line_comment,
      sym_block_comment,
  [84473] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6095), 1,
      anon_sym_RPAREN,
    ACTIONS(6097), 1,
      anon_sym_COMMA,
    STATE(2851), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2855), 2,
      sym_line_comment,
      sym_block_comment,
  [84493] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2856), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6099), 3,
      sym_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
  [84509] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(6101), 1,
      anon_sym_SEMI,
    STATE(3459), 1,
      sym_where_clause,
    STATE(2857), 2,
      sym_line_comment,
      sym_block_comment,
  [84529] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6103), 1,
      anon_sym_SEMI,
    ACTIONS(6105), 1,
      anon_sym_EQ,
    STATE(2858), 2,
      sym_line_comment,
      sym_block_comment,
  [84549] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(6107), 1,
      anon_sym_LBRACE,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2859), 2,
      sym_line_comment,
      sym_block_comment,
  [84569] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6109), 1,
      anon_sym_SEMI,
    STATE(632), 1,
      sym_declaration_list,
    STATE(2860), 2,
      sym_line_comment,
      sym_block_comment,
  [84589] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6111), 1,
      anon_sym_SEMI,
    STATE(488), 1,
      sym_declaration_list,
    STATE(2861), 2,
      sym_line_comment,
      sym_block_comment,
  [84609] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6113), 1,
      anon_sym_LPAREN,
    ACTIONS(6115), 1,
      anon_sym_LBRACK,
    ACTIONS(6117), 1,
      anon_sym_LBRACE,
    STATE(2862), 2,
      sym_line_comment,
      sym_block_comment,
  [84629] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6119), 1,
      anon_sym_LPAREN,
    ACTIONS(6121), 1,
      anon_sym_LBRACK,
    ACTIONS(6123), 1,
      anon_sym_LBRACE,
    STATE(2863), 2,
      sym_line_comment,
      sym_block_comment,
  [84649] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5664), 1,
      anon_sym_EQ,
    ACTIONS(5882), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2864), 2,
      sym_line_comment,
      sym_block_comment,
  [84667] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1003), 1,
      anon_sym_RPAREN,
    ACTIONS(4109), 1,
      anon_sym_COMMA,
    STATE(2680), 1,
      aux_sym_arguments_repeat1,
    STATE(2865), 2,
      sym_line_comment,
      sym_block_comment,
  [84687] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6125), 1,
      anon_sym_GT,
    ACTIONS(6127), 1,
      anon_sym_COMMA,
    STATE(2968), 1,
      aux_sym_for_lifetimes_repeat1,
    STATE(2866), 2,
      sym_line_comment,
      sym_block_comment,
  [84707] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    ACTIONS(6129), 1,
      anon_sym_COLON_COLON,
    STATE(1469), 1,
      sym_field_initializer_list,
    STATE(2867), 2,
      sym_line_comment,
      sym_block_comment,
  [84727] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6131), 1,
      sym_identifier,
    ACTIONS(6133), 1,
      anon_sym_ref,
    ACTIONS(6135), 1,
      sym_mutable_specifier,
    STATE(2868), 2,
      sym_line_comment,
      sym_block_comment,
  [84747] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6137), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2869), 2,
      sym_line_comment,
      sym_block_comment,
  [84765] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6139), 1,
      anon_sym_SEMI,
    STATE(494), 1,
      sym_declaration_list,
    STATE(2870), 2,
      sym_line_comment,
      sym_block_comment,
  [84785] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6141), 1,
      anon_sym_SEMI,
    STATE(500), 1,
      sym_declaration_list,
    STATE(2871), 2,
      sym_line_comment,
      sym_block_comment,
  [84805] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4953), 1,
      anon_sym_RBRACE,
    ACTIONS(6143), 1,
      anon_sym_COMMA,
    STATE(2874), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2872), 2,
      sym_line_comment,
      sym_block_comment,
  [84825] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6147), 1,
      anon_sym_EQ,
    ACTIONS(6145), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2873), 2,
      sym_line_comment,
      sym_block_comment,
  [84843] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6149), 1,
      anon_sym_RBRACE,
    ACTIONS(6151), 1,
      anon_sym_COMMA,
    STATE(2874), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_enum_variant_list_repeat2,
  [84861] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6154), 1,
      anon_sym_GT,
    ACTIONS(6156), 1,
      anon_sym_COMMA,
    STATE(2875), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_for_lifetimes_repeat1,
  [84879] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(6159), 1,
      anon_sym_GT,
    STATE(3285), 1,
      sym_lifetime,
    STATE(2876), 2,
      sym_line_comment,
      sym_block_comment,
  [84899] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2877), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5367), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [84915] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1464), 1,
      anon_sym_RPAREN,
    ACTIONS(6161), 1,
      anon_sym_COMMA,
    STATE(2879), 1,
      aux_sym_parameters_repeat1,
    STATE(2878), 2,
      sym_line_comment,
      sym_block_comment,
  [84935] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5858), 1,
      anon_sym_RPAREN,
    ACTIONS(6163), 1,
      anon_sym_COMMA,
    STATE(2879), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_parameters_repeat1,
  [84953] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(5858), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2880), 2,
      sym_line_comment,
      sym_block_comment,
  [84971] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1035), 1,
      anon_sym_RBRACK,
    ACTIONS(6166), 1,
      anon_sym_COMMA,
    STATE(2680), 1,
      aux_sym_arguments_repeat1,
    STATE(2881), 2,
      sym_line_comment,
      sym_block_comment,
  [84991] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4554), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5278), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2882), 2,
      sym_line_comment,
      sym_block_comment,
  [85009] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6168), 1,
      anon_sym_RBRACE,
    ACTIONS(6170), 1,
      anon_sym_COMMA,
    STATE(2883), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_struct_pattern_repeat1,
  [85027] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6173), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2884), 2,
      sym_line_comment,
      sym_block_comment,
  [85045] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1598), 1,
      anon_sym_GT,
    ACTIONS(6175), 1,
      anon_sym_COMMA,
    STATE(2964), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2885), 2,
      sym_line_comment,
      sym_block_comment,
  [85065] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1598), 1,
      anon_sym_GT,
    ACTIONS(6175), 1,
      anon_sym_COMMA,
    STATE(2891), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2886), 2,
      sym_line_comment,
      sym_block_comment,
  [85085] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6179), 1,
      anon_sym_COLON,
    ACTIONS(6177), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2887), 2,
      sym_line_comment,
      sym_block_comment,
  [85103] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3019), 1,
      anon_sym_RPAREN,
    ACTIONS(6181), 1,
      anon_sym_COMMA,
    STATE(2539), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2888), 2,
      sym_line_comment,
      sym_block_comment,
  [85123] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(987), 1,
      anon_sym_RBRACK,
    ACTIONS(4057), 1,
      anon_sym_COMMA,
    STATE(2680), 1,
      aux_sym_arguments_repeat1,
    STATE(2889), 2,
      sym_line_comment,
      sym_block_comment,
  [85143] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5145), 1,
      anon_sym_RBRACE,
    ACTIONS(6183), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2890), 2,
      sym_line_comment,
      sym_block_comment,
  [85163] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5519), 1,
      anon_sym_GT,
    ACTIONS(6185), 1,
      anon_sym_COMMA,
    STATE(2891), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_type_arguments_repeat1,
  [85181] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3021), 1,
      anon_sym_RPAREN,
    ACTIONS(6188), 1,
      anon_sym_COMMA,
    STATE(2539), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2892), 2,
      sym_line_comment,
      sym_block_comment,
  [85201] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1586), 1,
      anon_sym_GT,
    ACTIONS(6190), 1,
      anon_sym_COMMA,
    STATE(2891), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2893), 2,
      sym_line_comment,
      sym_block_comment,
  [85221] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5161), 1,
      anon_sym_RBRACE,
    ACTIONS(6192), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2894), 2,
      sym_line_comment,
      sym_block_comment,
  [85241] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      anon_sym_LT,
    ACTIONS(6194), 1,
      anon_sym_EQ,
    STATE(3582), 1,
      sym_type_parameters,
    STATE(2895), 2,
      sym_line_comment,
      sym_block_comment,
  [85261] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6196), 1,
      anon_sym_move,
    STATE(216), 1,
      sym_closure_parameters,
    STATE(2896), 2,
      sym_line_comment,
      sym_block_comment,
  [85281] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5834), 1,
      anon_sym_RPAREN,
    ACTIONS(5836), 1,
      anon_sym_COMMA,
    STATE(2772), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2897), 2,
      sym_line_comment,
      sym_block_comment,
  [85301] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6198), 1,
      anon_sym_SEMI,
    STATE(691), 1,
      sym_declaration_list,
    STATE(2898), 2,
      sym_line_comment,
      sym_block_comment,
  [85321] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1470), 1,
      anon_sym_RPAREN,
    ACTIONS(5433), 1,
      anon_sym_COMMA,
    STATE(2879), 1,
      aux_sym_parameters_repeat1,
    STATE(2899), 2,
      sym_line_comment,
      sym_block_comment,
  [85341] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(995), 1,
      anon_sym_RPAREN,
    ACTIONS(6200), 1,
      anon_sym_COMMA,
    STATE(2680), 1,
      aux_sym_arguments_repeat1,
    STATE(2900), 2,
      sym_line_comment,
      sym_block_comment,
  [85361] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6202), 1,
      sym_identifier,
    ACTIONS(6204), 1,
      anon_sym_await,
    ACTIONS(6206), 1,
      sym_integer_literal,
    STATE(2901), 2,
      sym_line_comment,
      sym_block_comment,
  [85381] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1470), 1,
      anon_sym_RPAREN,
    ACTIONS(5433), 1,
      anon_sym_COMMA,
    STATE(2972), 1,
      aux_sym_parameters_repeat1,
    STATE(2902), 2,
      sym_line_comment,
      sym_block_comment,
  [85401] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3967), 1,
      anon_sym_LBRACE,
    ACTIONS(6208), 1,
      anon_sym_COLON_COLON,
    STATE(1749), 1,
      sym_field_initializer_list,
    STATE(2903), 2,
      sym_line_comment,
      sym_block_comment,
  [85421] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(6210), 1,
      anon_sym_SEMI,
    STATE(3391), 1,
      sym_where_clause,
    STATE(2904), 2,
      sym_line_comment,
      sym_block_comment,
  [85441] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4911), 1,
      anon_sym_RBRACE,
    ACTIONS(6212), 1,
      anon_sym_COMMA,
    STATE(2874), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2905), 2,
      sym_line_comment,
      sym_block_comment,
  [85461] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4911), 1,
      anon_sym_RBRACE,
    ACTIONS(6212), 1,
      anon_sym_COMMA,
    STATE(2975), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2906), 2,
      sym_line_comment,
      sym_block_comment,
  [85481] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6214), 1,
      anon_sym_SEMI,
    ACTIONS(6216), 1,
      anon_sym_EQ,
    STATE(2907), 2,
      sym_line_comment,
      sym_block_comment,
  [85501] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6218), 1,
      anon_sym_move,
    STATE(218), 1,
      sym_closure_parameters,
    STATE(2908), 2,
      sym_line_comment,
      sym_block_comment,
  [85521] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6220), 1,
      anon_sym_SEMI,
    ACTIONS(6222), 1,
      anon_sym_EQ,
    STATE(2909), 2,
      sym_line_comment,
      sym_block_comment,
  [85541] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6224), 1,
      anon_sym_RBRACE,
    ACTIONS(6226), 1,
      anon_sym_COMMA,
    STATE(2910), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_field_initializer_list_repeat1,
  [85559] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5529), 1,
      anon_sym_COMMA,
    ACTIONS(6229), 1,
      anon_sym_PIPE,
    STATE(2778), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2911), 2,
      sym_line_comment,
      sym_block_comment,
  [85579] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6231), 1,
      anon_sym_RBRACE,
    ACTIONS(6233), 1,
      anon_sym_COMMA,
    STATE(2912), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_use_list_repeat1,
  [85597] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2913), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6236), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [85613] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4640), 1,
      anon_sym_GT,
    ACTIONS(6238), 1,
      anon_sym_COMMA,
    STATE(2949), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2914), 2,
      sym_line_comment,
      sym_block_comment,
  [85633] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4638), 1,
      anon_sym_GT,
    ACTIONS(6240), 1,
      anon_sym_COMMA,
    STATE(2949), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2915), 2,
      sym_line_comment,
      sym_block_comment,
  [85653] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6242), 1,
      anon_sym_SEMI,
    STATE(1248), 1,
      sym_declaration_list,
    STATE(2916), 2,
      sym_line_comment,
      sym_block_comment,
  [85673] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6246), 1,
      anon_sym_EQ,
    ACTIONS(6244), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2917), 2,
      sym_line_comment,
      sym_block_comment,
  [85691] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6248), 1,
      anon_sym_RBRACE,
    ACTIONS(6250), 1,
      anon_sym_COMMA,
    STATE(2967), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2918), 2,
      sym_line_comment,
      sym_block_comment,
  [85711] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6252), 1,
      anon_sym_SEMI,
    STATE(1262), 1,
      sym_declaration_list,
    STATE(2919), 2,
      sym_line_comment,
      sym_block_comment,
  [85731] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6254), 1,
      anon_sym_SEMI,
    ACTIONS(6256), 1,
      anon_sym_RBRACK,
    STATE(2920), 2,
      sym_line_comment,
      sym_block_comment,
  [85751] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6258), 1,
      anon_sym_SEMI,
    STATE(596), 1,
      sym_declaration_list,
    STATE(2921), 2,
      sym_line_comment,
      sym_block_comment,
  [85771] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4921), 1,
      anon_sym_COLON_COLON,
    STATE(1933), 1,
      sym_type_arguments,
    STATE(2922), 2,
      sym_line_comment,
      sym_block_comment,
  [85791] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    ACTIONS(4931), 1,
      anon_sym_COLON_COLON,
    STATE(1611), 1,
      sym_type_arguments,
    STATE(2923), 2,
      sym_line_comment,
      sym_block_comment,
  [85811] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6260), 1,
      anon_sym_SEMI,
    ACTIONS(6262), 1,
      anon_sym_EQ,
    STATE(2924), 2,
      sym_line_comment,
      sym_block_comment,
  [85831] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4578), 1,
      anon_sym_COLON,
    ACTIONS(4921), 1,
      anon_sym_COLON_COLON,
    STATE(2565), 1,
      sym_trait_bounds,
    STATE(2925), 2,
      sym_line_comment,
      sym_block_comment,
  [85851] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(6264), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2926), 2,
      sym_line_comment,
      sym_block_comment,
  [85871] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4927), 1,
      anon_sym_RBRACE,
    ACTIONS(6266), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2927), 2,
      sym_line_comment,
      sym_block_comment,
  [85891] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4927), 1,
      anon_sym_RBRACE,
    ACTIONS(6266), 1,
      anon_sym_COMMA,
    STATE(2992), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2928), 2,
      sym_line_comment,
      sym_block_comment,
  [85911] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4865), 1,
      anon_sym_RBRACE,
    ACTIONS(5888), 1,
      anon_sym_COMMA,
    STATE(2847), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2929), 2,
      sym_line_comment,
      sym_block_comment,
  [85931] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(6268), 1,
      anon_sym_SEMI,
    STATE(3382), 1,
      sym_where_clause,
    STATE(2930), 2,
      sym_line_comment,
      sym_block_comment,
  [85951] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6270), 1,
      anon_sym_move,
    STATE(239), 1,
      sym_closure_parameters,
    STATE(2931), 2,
      sym_line_comment,
      sym_block_comment,
  [85971] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6272), 1,
      anon_sym_RPAREN,
    ACTIONS(6274), 1,
      anon_sym_COMMA,
    STATE(2851), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2932), 2,
      sym_line_comment,
      sym_block_comment,
  [85991] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6276), 1,
      anon_sym_SEMI,
    ACTIONS(6278), 1,
      anon_sym_EQ,
    STATE(2933), 2,
      sym_line_comment,
      sym_block_comment,
  [86011] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6280), 1,
      anon_sym_SEMI,
    STATE(1278), 1,
      sym_declaration_list,
    STATE(2934), 2,
      sym_line_comment,
      sym_block_comment,
  [86031] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1458), 1,
      anon_sym_RPAREN,
    ACTIONS(6282), 1,
      anon_sym_COMMA,
    STATE(2879), 1,
      aux_sym_parameters_repeat1,
    STATE(2935), 2,
      sym_line_comment,
      sym_block_comment,
  [86051] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6284), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_declaration_list,
    STATE(2936), 2,
      sym_line_comment,
      sym_block_comment,
  [86071] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4578), 1,
      anon_sym_COLON,
    STATE(2565), 1,
      sym_trait_bounds,
    STATE(2937), 2,
      sym_line_comment,
      sym_block_comment,
  [86091] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1592), 1,
      anon_sym_GT,
    ACTIONS(6286), 1,
      anon_sym_COMMA,
    STATE(2891), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2938), 2,
      sym_line_comment,
      sym_block_comment,
  [86111] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6288), 1,
      anon_sym_SEMI,
    STATE(677), 1,
      sym_declaration_list,
    STATE(2939), 2,
      sym_line_comment,
      sym_block_comment,
  [86131] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4626), 1,
      anon_sym_GT,
    ACTIONS(6290), 1,
      anon_sym_COMMA,
    STATE(2949), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2940), 2,
      sym_line_comment,
      sym_block_comment,
  [86151] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2941), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6292), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
  [86167] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6294), 1,
      anon_sym_SEMI,
    ACTIONS(6296), 1,
      anon_sym_EQ,
    STATE(2942), 2,
      sym_line_comment,
      sym_block_comment,
  [86187] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
    ACTIONS(5365), 1,
      anon_sym_COMMA,
    STATE(2935), 1,
      aux_sym_parameters_repeat1,
    STATE(2943), 2,
      sym_line_comment,
      sym_block_comment,
  [86207] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4636), 1,
      anon_sym_GT,
    ACTIONS(6298), 1,
      anon_sym_COMMA,
    STATE(2949), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2944), 2,
      sym_line_comment,
      sym_block_comment,
  [86227] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(6300), 1,
      anon_sym_SEMI,
    STATE(3569), 1,
      sym_where_clause,
    STATE(2945), 2,
      sym_line_comment,
      sym_block_comment,
  [86247] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
    ACTIONS(5365), 1,
      anon_sym_COMMA,
    STATE(2879), 1,
      aux_sym_parameters_repeat1,
    STATE(2946), 2,
      sym_line_comment,
      sym_block_comment,
  [86267] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4660), 1,
      anon_sym_GT,
    ACTIONS(6302), 1,
      anon_sym_COMMA,
    STATE(2949), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2947), 2,
      sym_line_comment,
      sym_block_comment,
  [86287] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6304), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2948), 2,
      sym_line_comment,
      sym_block_comment,
  [86305] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5690), 1,
      anon_sym_GT,
    ACTIONS(6306), 1,
      anon_sym_COMMA,
    STATE(2949), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_type_parameters_repeat1,
  [86323] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4632), 1,
      anon_sym_GT,
    ACTIONS(5413), 1,
      anon_sym_COMMA,
    STATE(2949), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2950), 2,
      sym_line_comment,
      sym_block_comment,
  [86343] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2951), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6309), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
  [86359] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4632), 1,
      anon_sym_GT,
    ACTIONS(5413), 1,
      anon_sym_COMMA,
    STATE(2940), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2952), 2,
      sym_line_comment,
      sym_block_comment,
  [86379] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4732), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4838), 1,
      anon_sym_BANG,
    ACTIONS(6311), 1,
      sym_identifier,
    STATE(2953), 2,
      sym_line_comment,
      sym_block_comment,
  [86399] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1027), 1,
      anon_sym_RPAREN,
    ACTIONS(6313), 1,
      anon_sym_COMMA,
    STATE(2680), 1,
      aux_sym_arguments_repeat1,
    STATE(2954), 2,
      sym_line_comment,
      sym_block_comment,
  [86419] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6315), 1,
      sym_identifier,
    ACTIONS(6317), 1,
      anon_sym_ref,
    ACTIONS(6319), 1,
      sym_mutable_specifier,
    STATE(2955), 2,
      sym_line_comment,
      sym_block_comment,
  [86439] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1594), 1,
      anon_sym_GT,
    ACTIONS(6321), 1,
      anon_sym_COMMA,
    STATE(2891), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2956), 2,
      sym_line_comment,
      sym_block_comment,
  [86459] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2957), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1450), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86475] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1594), 1,
      anon_sym_GT,
    ACTIONS(6321), 1,
      anon_sym_COMMA,
    STATE(2938), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2958), 2,
      sym_line_comment,
      sym_block_comment,
  [86495] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5664), 1,
      anon_sym_EQ,
    ACTIONS(5690), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2959), 2,
      sym_line_comment,
      sym_block_comment,
  [86513] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6323), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2960), 2,
      sym_line_comment,
      sym_block_comment,
  [86531] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4872), 1,
      anon_sym_RBRACE,
    ACTIONS(6325), 1,
      anon_sym_COMMA,
    STATE(2872), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2961), 2,
      sym_line_comment,
      sym_block_comment,
  [86551] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6327), 1,
      anon_sym_SEMI,
    STATE(515), 1,
      sym_declaration_list,
    STATE(2962), 2,
      sym_line_comment,
      sym_block_comment,
  [86571] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6329), 1,
      anon_sym_RBRACE,
    ACTIONS(6331), 1,
      anon_sym_COMMA,
    STATE(3009), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2963), 2,
      sym_line_comment,
      sym_block_comment,
  [86591] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1596), 1,
      anon_sym_GT,
    ACTIONS(6333), 1,
      anon_sym_COMMA,
    STATE(2891), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2964), 2,
      sym_line_comment,
      sym_block_comment,
  [86611] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6337), 1,
      anon_sym_COLON,
    ACTIONS(6335), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2965), 2,
      sym_line_comment,
      sym_block_comment,
  [86629] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(4965), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(2966), 2,
      sym_line_comment,
      sym_block_comment,
  [86649] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4872), 1,
      anon_sym_RBRACE,
    ACTIONS(6325), 1,
      anon_sym_COMMA,
    STATE(2874), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2967), 2,
      sym_line_comment,
      sym_block_comment,
  [86669] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6339), 1,
      anon_sym_GT,
    ACTIONS(6341), 1,
      anon_sym_COMMA,
    STATE(2875), 1,
      aux_sym_for_lifetimes_repeat1,
    STATE(2968), 2,
      sym_line_comment,
      sym_block_comment,
  [86689] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5419), 1,
      anon_sym_RPAREN,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(2946), 1,
      aux_sym_parameters_repeat1,
    STATE(2969), 2,
      sym_line_comment,
      sym_block_comment,
  [86709] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    ACTIONS(6339), 1,
      anon_sym_GT,
    STATE(3285), 1,
      sym_lifetime,
    STATE(2970), 2,
      sym_line_comment,
      sym_block_comment,
  [86729] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3163), 1,
      anon_sym_RPAREN,
    ACTIONS(6343), 1,
      anon_sym_COMMA,
    STATE(2981), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2971), 2,
      sym_line_comment,
      sym_block_comment,
  [86749] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1472), 1,
      anon_sym_RPAREN,
    ACTIONS(6345), 1,
      anon_sym_COMMA,
    STATE(2879), 1,
      aux_sym_parameters_repeat1,
    STATE(2972), 2,
      sym_line_comment,
      sym_block_comment,
  [86769] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5311), 1,
      anon_sym_GT,
    ACTIONS(5313), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2973), 2,
      sym_line_comment,
      sym_block_comment,
  [86789] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6347), 1,
      anon_sym_EQ_GT,
    ACTIONS(6349), 1,
      anon_sym_PIPE,
    ACTIONS(6351), 1,
      anon_sym_if,
    STATE(2974), 2,
      sym_line_comment,
      sym_block_comment,
  [86809] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4947), 1,
      anon_sym_RBRACE,
    ACTIONS(6353), 1,
      anon_sym_COMMA,
    STATE(2874), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2975), 2,
      sym_line_comment,
      sym_block_comment,
  [86829] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
    ACTIONS(5437), 1,
      anon_sym_COMMA,
    STATE(2878), 1,
      aux_sym_parameters_repeat1,
    STATE(2976), 2,
      sym_line_comment,
      sym_block_comment,
  [86849] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
    ACTIONS(5437), 1,
      anon_sym_COMMA,
    STATE(2879), 1,
      aux_sym_parameters_repeat1,
    STATE(2977), 2,
      sym_line_comment,
      sym_block_comment,
  [86869] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6355), 1,
      anon_sym_SEMI,
    STATE(1327), 1,
      sym_declaration_list,
    STATE(2978), 2,
      sym_line_comment,
      sym_block_comment,
  [86889] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6357), 1,
      anon_sym_SEMI,
    STATE(1286), 1,
      sym_declaration_list,
    STATE(2979), 2,
      sym_line_comment,
      sym_block_comment,
  [86909] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6359), 1,
      anon_sym_SEMI,
    STATE(575), 1,
      sym_declaration_list,
    STATE(2980), 2,
      sym_line_comment,
      sym_block_comment,
  [86929] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6361), 1,
      anon_sym_RPAREN,
    ACTIONS(6363), 1,
      anon_sym_COMMA,
    STATE(2981), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_tuple_type_repeat1,
  [86947] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6361), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2982), 2,
      sym_line_comment,
      sym_block_comment,
  [86965] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5153), 1,
      anon_sym_RBRACE,
    ACTIONS(6366), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2983), 2,
      sym_line_comment,
      sym_block_comment,
  [86985] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6368), 1,
      anon_sym_SEMI,
    STATE(1240), 1,
      sym_declaration_list,
    STATE(2984), 2,
      sym_line_comment,
      sym_block_comment,
  [87005] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6370), 1,
      anon_sym_SEMI,
    STATE(1135), 1,
      sym_declaration_list,
    STATE(2985), 2,
      sym_line_comment,
      sym_block_comment,
  [87025] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3009), 1,
      anon_sym_RPAREN,
    ACTIONS(6372), 1,
      anon_sym_COMMA,
    STATE(2539), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2986), 2,
      sym_line_comment,
      sym_block_comment,
  [87045] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5169), 1,
      anon_sym_RBRACE,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2987), 2,
      sym_line_comment,
      sym_block_comment,
  [87065] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6378), 1,
      anon_sym_COLON,
    ACTIONS(6376), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2988), 2,
      sym_line_comment,
      sym_block_comment,
  [87083] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6380), 1,
      anon_sym_SEMI,
    ACTIONS(6382), 1,
      anon_sym_EQ,
    STATE(2989), 2,
      sym_line_comment,
      sym_block_comment,
  [87103] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    ACTIONS(4943), 1,
      anon_sym_COLON_COLON,
    STATE(1068), 1,
      sym_type_arguments,
    STATE(2990), 2,
      sym_line_comment,
      sym_block_comment,
  [87123] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6384), 1,
      anon_sym_SEMI,
    ACTIONS(6386), 1,
      anon_sym_EQ,
    STATE(2991), 2,
      sym_line_comment,
      sym_block_comment,
  [87143] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4951), 1,
      anon_sym_RBRACE,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2992), 2,
      sym_line_comment,
      sym_block_comment,
  [87163] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3027), 1,
      anon_sym_RPAREN,
    ACTIONS(6390), 1,
      anon_sym_COMMA,
    STATE(2539), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2993), 2,
      sym_line_comment,
      sym_block_comment,
  [87183] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1600), 1,
      anon_sym_GT,
    ACTIONS(6392), 1,
      anon_sym_COMMA,
    STATE(2893), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2994), 2,
      sym_line_comment,
      sym_block_comment,
  [87203] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6394), 1,
      anon_sym_SEMI,
    ACTIONS(6396), 1,
      anon_sym_RBRACK,
    STATE(2995), 2,
      sym_line_comment,
      sym_block_comment,
  [87223] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6398), 1,
      anon_sym_RPAREN,
    ACTIONS(6400), 1,
      anon_sym_COMMA,
    STATE(2996), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_tuple_pattern_repeat1,
  [87241] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6403), 1,
      anon_sym_RBRACE,
    ACTIONS(6405), 1,
      anon_sym_COMMA,
    STATE(2732), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2997), 2,
      sym_line_comment,
      sym_block_comment,
  [87261] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2998), 2,
      sym_line_comment,
      sym_block_comment,
  [87279] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1001), 1,
      anon_sym_RBRACK,
    ACTIONS(6407), 1,
      anon_sym_COMMA,
    STATE(2680), 1,
      aux_sym_arguments_repeat1,
    STATE(2999), 2,
      sym_line_comment,
      sym_block_comment,
  [87299] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1600), 1,
      anon_sym_GT,
    ACTIONS(6392), 1,
      anon_sym_COMMA,
    STATE(2891), 1,
      aux_sym_type_arguments_repeat1,
    STATE(3000), 2,
      sym_line_comment,
      sym_block_comment,
  [87319] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(6409), 1,
      anon_sym_SEMI,
    STATE(3556), 1,
      sym_where_clause,
    STATE(3001), 2,
      sym_line_comment,
      sym_block_comment,
  [87339] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1005), 1,
      anon_sym_RPAREN,
    ACTIONS(4111), 1,
      anon_sym_COMMA,
    STATE(2680), 1,
      aux_sym_arguments_repeat1,
    STATE(3002), 2,
      sym_line_comment,
      sym_block_comment,
  [87359] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(6411), 1,
      anon_sym_SEMI,
    STATE(3429), 1,
      sym_where_clause,
    STATE(3003), 2,
      sym_line_comment,
      sym_block_comment,
  [87379] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(6413), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(3004), 2,
      sym_line_comment,
      sym_block_comment,
  [87399] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6415), 1,
      anon_sym_move,
    STATE(222), 1,
      sym_closure_parameters,
    STATE(3005), 2,
      sym_line_comment,
      sym_block_comment,
  [87419] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(6417), 1,
      anon_sym_SEMI,
    STATE(3392), 1,
      sym_where_clause,
    STATE(3006), 2,
      sym_line_comment,
      sym_block_comment,
  [87439] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(6419), 1,
      anon_sym_SEMI,
    STATE(3603), 1,
      sym_where_clause,
    STATE(3007), 2,
      sym_line_comment,
      sym_block_comment,
  [87459] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6423), 1,
      anon_sym_COLON,
    ACTIONS(6421), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3008), 2,
      sym_line_comment,
      sym_block_comment,
  [87477] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4816), 1,
      anon_sym_RBRACE,
    ACTIONS(6425), 1,
      anon_sym_COMMA,
    STATE(2910), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(3009), 2,
      sym_line_comment,
      sym_block_comment,
  [87497] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3010), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6427), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87513] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3011), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6429), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87529] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6431), 1,
      anon_sym_SEMI,
    STATE(1358), 1,
      sym_declaration_list,
    STATE(3012), 2,
      sym_line_comment,
      sym_block_comment,
  [87549] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6433), 1,
      anon_sym_SEMI,
    STATE(1362), 1,
      sym_declaration_list,
    STATE(3013), 2,
      sym_line_comment,
      sym_block_comment,
  [87569] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6435), 1,
      anon_sym_RBRACE,
    ACTIONS(6437), 1,
      anon_sym_COMMA,
    STATE(3032), 1,
      aux_sym_use_list_repeat1,
    STATE(3014), 2,
      sym_line_comment,
      sym_block_comment,
  [87589] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3015), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6439), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87605] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3016), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6441), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87621] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4897), 1,
      anon_sym_where,
    ACTIONS(6443), 1,
      anon_sym_SEMI,
    STATE(3426), 1,
      sym_where_clause,
    STATE(3017), 2,
      sym_line_comment,
      sym_block_comment,
  [87641] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3018), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6445), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87657] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6447), 1,
      anon_sym_SEMI,
    STATE(1443), 1,
      sym_declaration_list,
    STATE(3019), 2,
      sym_line_comment,
      sym_block_comment,
  [87677] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6449), 1,
      anon_sym_SEMI,
    STATE(1438), 1,
      sym_declaration_list,
    STATE(3020), 2,
      sym_line_comment,
      sym_block_comment,
  [87697] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3021), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6451), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87713] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6453), 1,
      anon_sym_SEMI,
    ACTIONS(6455), 1,
      anon_sym_EQ,
    STATE(3022), 2,
      sym_line_comment,
      sym_block_comment,
  [87733] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3023), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6457), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87749] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT2,
    ACTIONS(6459), 1,
      anon_sym_for,
    STATE(1935), 1,
      sym_type_arguments,
    STATE(3024), 2,
      sym_line_comment,
      sym_block_comment,
  [87769] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    ACTIONS(6461), 1,
      anon_sym_SEMI,
    STATE(683), 1,
      sym_declaration_list,
    STATE(3025), 2,
      sym_line_comment,
      sym_block_comment,
  [87789] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6463), 1,
      anon_sym_SEMI,
    STATE(1420), 1,
      sym_declaration_list,
    STATE(3026), 2,
      sym_line_comment,
      sym_block_comment,
  [87809] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6465), 1,
      anon_sym_SEMI,
    STATE(1416), 1,
      sym_declaration_list,
    STATE(3027), 2,
      sym_line_comment,
      sym_block_comment,
  [87829] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3028), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6467), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87845] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3029), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6469), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87861] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6471), 1,
      anon_sym_SEMI,
    STATE(1391), 1,
      sym_declaration_list,
    STATE(3030), 2,
      sym_line_comment,
      sym_block_comment,
  [87881] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    ACTIONS(6473), 1,
      anon_sym_SEMI,
    STATE(1385), 1,
      sym_declaration_list,
    STATE(3031), 2,
      sym_line_comment,
      sym_block_comment,
  [87901] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4345), 1,
      anon_sym_RBRACE,
    ACTIONS(6475), 1,
      anon_sym_COMMA,
    STATE(2912), 1,
      aux_sym_use_list_repeat1,
    STATE(3032), 2,
      sym_line_comment,
      sym_block_comment,
  [87921] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1102), 1,
      sym_field_declaration_list,
    STATE(3033), 2,
      sym_line_comment,
      sym_block_comment,
  [87938] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1212), 1,
      sym_field_declaration_list,
    STATE(3034), 2,
      sym_line_comment,
      sym_block_comment,
  [87955] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1202), 1,
      sym_field_declaration_list,
    STATE(3035), 2,
      sym_line_comment,
      sym_block_comment,
  [87972] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5686), 1,
      sym_super,
    ACTIONS(6477), 1,
      sym_identifier,
    STATE(3036), 2,
      sym_line_comment,
      sym_block_comment,
  [87989] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1373), 1,
      sym_declaration_list,
    STATE(3037), 2,
      sym_line_comment,
      sym_block_comment,
  [88006] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6459), 1,
      anon_sym_for,
    STATE(3038), 2,
      sym_line_comment,
      sym_block_comment,
  [88023] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    STATE(658), 1,
      sym_field_declaration_list,
    STATE(3039), 2,
      sym_line_comment,
      sym_block_comment,
  [88040] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6479), 1,
      anon_sym_LBRACK,
    ACTIONS(6481), 1,
      anon_sym_BANG,
    STATE(3040), 2,
      sym_line_comment,
      sym_block_comment,
  [88057] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6483), 1,
      sym_identifier,
    ACTIONS(6485), 1,
      sym_mutable_specifier,
    STATE(3041), 2,
      sym_line_comment,
      sym_block_comment,
  [88074] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6487), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3042), 2,
      sym_line_comment,
      sym_block_comment,
  [88089] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1208), 1,
      sym_declaration_list,
    STATE(3043), 2,
      sym_line_comment,
      sym_block_comment,
  [88106] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5894), 1,
      sym_identifier,
    ACTIONS(5898), 1,
      sym_mutable_specifier,
    STATE(3044), 2,
      sym_line_comment,
      sym_block_comment,
  [88123] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5163), 1,
      anon_sym_RBRACE,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3045), 2,
      sym_line_comment,
      sym_block_comment,
  [88140] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(617), 1,
      sym_declaration_list,
    STATE(3046), 2,
      sym_line_comment,
      sym_block_comment,
  [88157] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6491), 1,
      anon_sym_in,
    STATE(3047), 2,
      sym_line_comment,
      sym_block_comment,
  [88174] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6493), 1,
      anon_sym_in,
    STATE(3048), 2,
      sym_line_comment,
      sym_block_comment,
  [88191] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(611), 1,
      sym_declaration_list,
    STATE(3049), 2,
      sym_line_comment,
      sym_block_comment,
  [88208] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5533), 1,
      sym_super,
    ACTIONS(6495), 1,
      sym_identifier,
    STATE(3050), 2,
      sym_line_comment,
      sym_block_comment,
  [88225] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    STATE(643), 1,
      sym_field_declaration_list,
    STATE(3051), 2,
      sym_line_comment,
      sym_block_comment,
  [88242] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(2207), 1,
      sym_parameters,
    STATE(3052), 2,
      sym_line_comment,
      sym_block_comment,
  [88259] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6497), 1,
      anon_sym_in,
    STATE(3053), 2,
      sym_line_comment,
      sym_block_comment,
  [88276] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6499), 1,
      sym_identifier,
    ACTIONS(6501), 1,
      sym_super,
    STATE(3054), 2,
      sym_line_comment,
      sym_block_comment,
  [88293] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6503), 1,
      anon_sym_in,
    STATE(3055), 2,
      sym_line_comment,
      sym_block_comment,
  [88310] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(729), 1,
      sym_enum_variant_list,
    STATE(3056), 2,
      sym_line_comment,
      sym_block_comment,
  [88327] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(222), 1,
      sym_closure_parameters,
    STATE(3057), 2,
      sym_line_comment,
      sym_block_comment,
  [88344] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6505), 1,
      anon_sym_LBRACK,
    ACTIONS(6507), 1,
      anon_sym_BANG,
    STATE(3058), 2,
      sym_line_comment,
      sym_block_comment,
  [88361] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    STATE(602), 1,
      sym_field_declaration_list,
    STATE(3059), 2,
      sym_line_comment,
      sym_block_comment,
  [88378] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6509), 2,
      sym_identifier,
      sym_super,
    STATE(3060), 2,
      sym_line_comment,
      sym_block_comment,
  [88393] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    STATE(741), 1,
      sym_field_declaration_list,
    STATE(3061), 2,
      sym_line_comment,
      sym_block_comment,
  [88410] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5900), 1,
      anon_sym_for,
    STATE(3062), 2,
      sym_line_comment,
      sym_block_comment,
  [88427] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1441), 1,
      sym_declaration_list,
    STATE(3063), 2,
      sym_line_comment,
      sym_block_comment,
  [88444] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1435), 1,
      sym_declaration_list,
    STATE(3064), 2,
      sym_line_comment,
      sym_block_comment,
  [88461] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6513), 1,
      anon_sym_as,
    STATE(3065), 2,
      sym_line_comment,
      sym_block_comment,
  [88478] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6515), 1,
      anon_sym_SEMI,
    ACTIONS(6517), 1,
      anon_sym_as,
    STATE(3066), 2,
      sym_line_comment,
      sym_block_comment,
  [88495] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6519), 1,
      sym_identifier,
    ACTIONS(6521), 1,
      sym_super,
    STATE(3067), 2,
      sym_line_comment,
      sym_block_comment,
  [88512] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5686), 1,
      sym_super,
    ACTIONS(6523), 1,
      sym_identifier,
    STATE(3068), 2,
      sym_line_comment,
      sym_block_comment,
  [88529] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_in,
    STATE(3069), 2,
      sym_line_comment,
      sym_block_comment,
  [88546] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6527), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3070), 2,
      sym_line_comment,
      sym_block_comment,
  [88561] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(566), 1,
      sym_declaration_list,
    STATE(3071), 2,
      sym_line_comment,
      sym_block_comment,
  [88578] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3591), 1,
      anon_sym_COLON,
    ACTIONS(5270), 1,
      anon_sym_PLUS,
    STATE(3072), 2,
      sym_line_comment,
      sym_block_comment,
  [88595] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6529), 1,
      anon_sym_in,
    STATE(3073), 2,
      sym_line_comment,
      sym_block_comment,
  [88612] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    STATE(1615), 1,
      sym_parameters,
    STATE(3074), 2,
      sym_line_comment,
      sym_block_comment,
  [88629] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6531), 1,
      sym_identifier,
    ACTIONS(6533), 1,
      sym_mutable_specifier,
    STATE(3075), 2,
      sym_line_comment,
      sym_block_comment,
  [88646] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5910), 1,
      anon_sym_for,
    STATE(3076), 2,
      sym_line_comment,
      sym_block_comment,
  [88663] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    STATE(539), 1,
      sym_field_declaration_list,
    STATE(3077), 2,
      sym_line_comment,
      sym_block_comment,
  [88680] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5914), 1,
      anon_sym_for,
    STATE(3078), 2,
      sym_line_comment,
      sym_block_comment,
  [88697] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6535), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3079), 2,
      sym_line_comment,
      sym_block_comment,
  [88712] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6537), 1,
      anon_sym_EQ,
    STATE(3080), 2,
      sym_line_comment,
      sym_block_comment,
  [88729] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    ACTIONS(6539), 1,
      anon_sym_RPAREN,
    STATE(3081), 2,
      sym_line_comment,
      sym_block_comment,
  [88746] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    STATE(753), 1,
      sym_field_declaration_list,
    STATE(3082), 2,
      sym_line_comment,
      sym_block_comment,
  [88763] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    ACTIONS(6539), 1,
      anon_sym_RBRACK,
    STATE(3083), 2,
      sym_line_comment,
      sym_block_comment,
  [88780] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5225), 1,
      anon_sym_LBRACE,
    STATE(1233), 1,
      sym_enum_variant_list,
    STATE(3084), 2,
      sym_line_comment,
      sym_block_comment,
  [88797] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5686), 2,
      sym_identifier,
      sym_super,
    STATE(3085), 2,
      sym_line_comment,
      sym_block_comment,
  [88812] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(221), 1,
      sym_closure_parameters,
    STATE(3086), 2,
      sym_line_comment,
      sym_block_comment,
  [88829] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    ACTIONS(6541), 1,
      anon_sym_RBRACE,
    STATE(3087), 2,
      sym_line_comment,
      sym_block_comment,
  [88846] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5533), 2,
      sym_identifier,
      sym_super,
    STATE(3088), 2,
      sym_line_comment,
      sym_block_comment,
  [88861] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4941), 1,
      anon_sym_for,
    STATE(3089), 2,
      sym_line_comment,
      sym_block_comment,
  [88878] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5209), 1,
      anon_sym_RBRACE,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3090), 2,
      sym_line_comment,
      sym_block_comment,
  [88895] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    ACTIONS(6543), 1,
      anon_sym_RBRACK,
    STATE(3091), 2,
      sym_line_comment,
      sym_block_comment,
  [88912] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5624), 1,
      sym_identifier,
    ACTIONS(5626), 1,
      sym_super,
    STATE(3092), 2,
      sym_line_comment,
      sym_block_comment,
  [88929] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5813), 2,
      sym_identifier,
      sym_super,
    STATE(3093), 2,
      sym_line_comment,
      sym_block_comment,
  [88944] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6545), 1,
      sym_identifier,
    ACTIONS(6547), 1,
      sym_super,
    STATE(3094), 2,
      sym_line_comment,
      sym_block_comment,
  [88961] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    ACTIONS(6549), 1,
      anon_sym_RBRACE,
    STATE(3095), 2,
      sym_line_comment,
      sym_block_comment,
  [88978] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6551), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3096), 2,
      sym_line_comment,
      sym_block_comment,
  [88993] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6495), 1,
      sym_identifier,
    ACTIONS(6553), 1,
      sym_super,
    STATE(3097), 2,
      sym_line_comment,
      sym_block_comment,
  [89010] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6398), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3098), 2,
      sym_line_comment,
      sym_block_comment,
  [89025] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5628), 1,
      sym_identifier,
    STATE(3099), 2,
      sym_line_comment,
      sym_block_comment,
  [89042] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5203), 1,
      anon_sym_RBRACE,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3100), 2,
      sym_line_comment,
      sym_block_comment,
  [89059] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6555), 1,
      sym_identifier,
    ACTIONS(6557), 1,
      sym_super,
    STATE(3101), 2,
      sym_line_comment,
      sym_block_comment,
  [89076] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1285), 1,
      sym_declaration_list,
    STATE(3102), 2,
      sym_line_comment,
      sym_block_comment,
  [89093] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(220), 1,
      sym_closure_parameters,
    STATE(3103), 2,
      sym_line_comment,
      sym_block_comment,
  [89110] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6559), 1,
      anon_sym_in,
    STATE(3104), 2,
      sym_line_comment,
      sym_block_comment,
  [89127] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6561), 2,
      sym_identifier,
      sym_super,
    STATE(3105), 2,
      sym_line_comment,
      sym_block_comment,
  [89142] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3843), 2,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
    STATE(3106), 2,
      sym_line_comment,
      sym_block_comment,
  [89157] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6563), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3107), 2,
      sym_line_comment,
      sym_block_comment,
  [89172] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6565), 1,
      anon_sym_LBRACK,
    ACTIONS(6567), 1,
      anon_sym_BANG,
    STATE(3108), 2,
      sym_line_comment,
      sym_block_comment,
  [89189] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6569), 1,
      anon_sym_LT,
    STATE(995), 1,
      sym_type_parameters,
    STATE(3109), 2,
      sym_line_comment,
      sym_block_comment,
  [89206] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    STATE(1632), 1,
      sym_parameters,
    STATE(3110), 2,
      sym_line_comment,
      sym_block_comment,
  [89223] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    STATE(1055), 1,
      sym_parameters,
    STATE(3111), 2,
      sym_line_comment,
      sym_block_comment,
  [89240] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6571), 1,
      anon_sym_LPAREN,
    ACTIONS(6573), 1,
      anon_sym_COLON_COLON,
    STATE(3112), 2,
      sym_line_comment,
      sym_block_comment,
  [89257] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6569), 1,
      anon_sym_LT,
    STATE(964), 1,
      sym_type_parameters,
    STATE(3113), 2,
      sym_line_comment,
      sym_block_comment,
  [89274] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6571), 1,
      anon_sym_LPAREN,
    ACTIONS(6575), 1,
      anon_sym_COLON_COLON,
    STATE(3114), 2,
      sym_line_comment,
      sym_block_comment,
  [89291] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5942), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(3115), 2,
      sym_line_comment,
      sym_block_comment,
  [89306] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6577), 1,
      anon_sym_RPAREN,
    ACTIONS(6579), 1,
      anon_sym_COLON_COLON,
    STATE(3116), 2,
      sym_line_comment,
      sym_block_comment,
  [89323] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    ACTIONS(6543), 1,
      anon_sym_RPAREN,
    STATE(3117), 2,
      sym_line_comment,
      sym_block_comment,
  [89340] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6581), 2,
      sym_identifier,
      sym_super,
    STATE(3118), 2,
      sym_line_comment,
      sym_block_comment,
  [89355] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6557), 2,
      sym_identifier,
      sym_super,
    STATE(3119), 2,
      sym_line_comment,
      sym_block_comment,
  [89370] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6577), 1,
      anon_sym_RPAREN,
    ACTIONS(6583), 1,
      anon_sym_COLON_COLON,
    STATE(3120), 2,
      sym_line_comment,
      sym_block_comment,
  [89387] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6585), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3121), 2,
      sym_line_comment,
      sym_block_comment,
  [89402] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6587), 1,
      anon_sym_RPAREN,
    ACTIONS(6589), 1,
      anon_sym_COLON_COLON,
    STATE(3122), 2,
      sym_line_comment,
      sym_block_comment,
  [89419] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    STATE(1469), 1,
      sym_field_initializer_list,
    STATE(3123), 2,
      sym_line_comment,
      sym_block_comment,
  [89436] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6591), 1,
      anon_sym_SEMI,
    ACTIONS(6593), 1,
      anon_sym_as,
    STATE(3124), 2,
      sym_line_comment,
      sym_block_comment,
  [89453] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6595), 2,
      sym__block_comment_content,
      anon_sym_STAR_SLASH,
    STATE(3125), 2,
      sym_line_comment,
      sym_block_comment,
  [89468] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5147), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3126), 2,
      sym_line_comment,
      sym_block_comment,
  [89483] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6597), 2,
      sym__block_comment_content,
      anon_sym_STAR_SLASH,
    STATE(3127), 2,
      sym_line_comment,
      sym_block_comment,
  [89498] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6569), 1,
      anon_sym_LT,
    STATE(1080), 1,
      sym_type_parameters,
    STATE(3128), 2,
      sym_line_comment,
      sym_block_comment,
  [89515] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6509), 1,
      sym_super,
    ACTIONS(6555), 1,
      sym_identifier,
    STATE(3129), 2,
      sym_line_comment,
      sym_block_comment,
  [89532] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6599), 1,
      anon_sym_STAR_SLASH,
    ACTIONS(6601), 1,
      sym__block_comment_content,
    STATE(3130), 2,
      sym_line_comment,
      sym_block_comment,
  [89549] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6603), 1,
      anon_sym_BANG,
    ACTIONS(6605), 1,
      anon_sym_COLON_COLON,
    STATE(3131), 2,
      sym_line_comment,
      sym_block_comment,
  [89566] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    STATE(1575), 1,
      sym_parameters,
    STATE(3132), 2,
      sym_line_comment,
      sym_block_comment,
  [89583] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6607), 1,
      anon_sym_LPAREN,
    ACTIONS(6609), 1,
      anon_sym_COLON_COLON,
    STATE(3133), 2,
      sym_line_comment,
      sym_block_comment,
  [89600] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5533), 1,
      sym_super,
    ACTIONS(6611), 1,
      sym_identifier,
    STATE(3134), 2,
      sym_line_comment,
      sym_block_comment,
  [89617] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4965), 1,
      anon_sym_for,
    STATE(3135), 2,
      sym_line_comment,
      sym_block_comment,
  [89634] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5628), 1,
      sym_identifier,
    ACTIONS(5726), 1,
      sym_super,
    STATE(3136), 2,
      sym_line_comment,
      sym_block_comment,
  [89651] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6613), 1,
      anon_sym_EQ,
    STATE(3137), 2,
      sym_line_comment,
      sym_block_comment,
  [89668] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 1,
      sym_super,
    ACTIONS(6611), 1,
      sym_identifier,
    STATE(3138), 2,
      sym_line_comment,
      sym_block_comment,
  [89685] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    STATE(1047), 1,
      sym_parameters,
    STATE(3139), 2,
      sym_line_comment,
      sym_block_comment,
  [89702] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5690), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(3140), 2,
      sym_line_comment,
      sym_block_comment,
  [89717] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3611), 1,
      anon_sym_COLON,
    ACTIONS(5270), 1,
      anon_sym_PLUS,
    STATE(3141), 2,
      sym_line_comment,
      sym_block_comment,
  [89734] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6615), 2,
      sym_identifier,
      sym_super,
    STATE(3142), 2,
      sym_line_comment,
      sym_block_comment,
  [89749] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(2213), 1,
      sym_parameters,
    STATE(3143), 2,
      sym_line_comment,
      sym_block_comment,
  [89766] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5533), 1,
      sym_super,
    ACTIONS(6617), 1,
      sym_identifier,
    STATE(3144), 2,
      sym_line_comment,
      sym_block_comment,
  [89783] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6413), 1,
      anon_sym_for,
    STATE(3145), 2,
      sym_line_comment,
      sym_block_comment,
  [89800] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1421), 1,
      sym_declaration_list,
    STATE(3146), 2,
      sym_line_comment,
      sym_block_comment,
  [89817] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(736), 1,
      sym_enum_variant_list,
    STATE(3147), 2,
      sym_line_comment,
      sym_block_comment,
  [89834] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1403), 1,
      sym_field_declaration_list,
    STATE(3148), 2,
      sym_line_comment,
      sym_block_comment,
  [89851] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1401), 1,
      sym_field_declaration_list,
    STATE(3149), 2,
      sym_line_comment,
      sym_block_comment,
  [89868] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6619), 2,
      sym_float_literal,
      sym_integer_literal,
    STATE(3150), 2,
      sym_line_comment,
      sym_block_comment,
  [89883] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5191), 1,
      anon_sym_RBRACE,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3151), 2,
      sym_line_comment,
      sym_block_comment,
  [89900] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5225), 1,
      anon_sym_LBRACE,
    STATE(1393), 1,
      sym_enum_variant_list,
    STATE(3152), 2,
      sym_line_comment,
      sym_block_comment,
  [89917] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6621), 1,
      sym_identifier,
    ACTIONS(6623), 1,
      sym_super,
    STATE(3153), 2,
      sym_line_comment,
      sym_block_comment,
  [89934] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3813), 2,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
    STATE(3154), 2,
      sym_line_comment,
      sym_block_comment,
  [89949] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(512), 1,
      sym_enum_variant_list,
    STATE(3155), 2,
      sym_line_comment,
      sym_block_comment,
  [89966] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5177), 1,
      anon_sym_RBRACK,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3156), 2,
      sym_line_comment,
      sym_block_comment,
  [89983] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5225), 1,
      anon_sym_LBRACE,
    STATE(1158), 1,
      sym_enum_variant_list,
    STATE(3157), 2,
      sym_line_comment,
      sym_block_comment,
  [90000] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1313), 1,
      sym_declaration_list,
    STATE(3158), 2,
      sym_line_comment,
      sym_block_comment,
  [90017] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(2191), 1,
      sym_parameters,
    STATE(3159), 2,
      sym_line_comment,
      sym_block_comment,
  [90034] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1308), 1,
      sym_declaration_list,
    STATE(3160), 2,
      sym_line_comment,
      sym_block_comment,
  [90051] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3965), 1,
      anon_sym_LT2,
    STATE(1761), 1,
      sym_type_arguments,
    STATE(3161), 2,
      sym_line_comment,
      sym_block_comment,
  [90068] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6623), 2,
      sym_identifier,
      sym_super,
    STATE(3162), 2,
      sym_line_comment,
      sym_block_comment,
  [90083] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6625), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3163), 2,
      sym_line_comment,
      sym_block_comment,
  [90098] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5533), 1,
      sym_super,
    ACTIONS(6627), 1,
      sym_identifier,
    STATE(3164), 2,
      sym_line_comment,
      sym_block_comment,
  [90115] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5177), 1,
      anon_sym_RPAREN,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3165), 2,
      sym_line_comment,
      sym_block_comment,
  [90132] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(1963), 1,
      sym_parameters,
    STATE(3166), 2,
      sym_line_comment,
      sym_block_comment,
  [90149] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6557), 1,
      sym_super,
    ACTIONS(6629), 1,
      sym_identifier,
    STATE(3167), 2,
      sym_line_comment,
      sym_block_comment,
  [90166] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(239), 1,
      sym_closure_parameters,
    STATE(3168), 2,
      sym_line_comment,
      sym_block_comment,
  [90183] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3663), 1,
      anon_sym_COLON,
    ACTIONS(5270), 1,
      anon_sym_PLUS,
    STATE(3169), 2,
      sym_line_comment,
      sym_block_comment,
  [90200] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3667), 1,
      anon_sym_COLON,
    ACTIONS(5270), 1,
      anon_sym_PLUS,
    STATE(3170), 2,
      sym_line_comment,
      sym_block_comment,
  [90217] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5726), 2,
      sym_identifier,
      sym_super,
    STATE(3171), 2,
      sym_line_comment,
      sym_block_comment,
  [90232] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    STATE(2565), 1,
      sym_trait_bounds,
    STATE(3172), 2,
      sym_line_comment,
      sym_block_comment,
  [90249] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5795), 1,
      sym_identifier,
    STATE(3173), 2,
      sym_line_comment,
      sym_block_comment,
  [90266] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6631), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3174), 2,
      sym_line_comment,
      sym_block_comment,
  [90281] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1271), 1,
      sym_declaration_list,
    STATE(3175), 2,
      sym_line_comment,
      sym_block_comment,
  [90298] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5686), 1,
      sym_super,
    ACTIONS(6621), 1,
      sym_identifier,
    STATE(3176), 2,
      sym_line_comment,
      sym_block_comment,
  [90315] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(689), 1,
      sym_declaration_list,
    STATE(3177), 2,
      sym_line_comment,
      sym_block_comment,
  [90332] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    ACTIONS(6633), 1,
      anon_sym_RBRACK,
    STATE(3178), 2,
      sym_line_comment,
      sym_block_comment,
  [90349] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(684), 1,
      sym_declaration_list,
    STATE(3179), 2,
      sym_line_comment,
      sym_block_comment,
  [90366] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    ACTIONS(6633), 1,
      anon_sym_RPAREN,
    STATE(3180), 2,
      sym_line_comment,
      sym_block_comment,
  [90383] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    ACTIONS(6635), 1,
      anon_sym_RBRACK,
    STATE(3181), 2,
      sym_line_comment,
      sym_block_comment,
  [90400] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(231), 1,
      sym_closure_parameters,
    STATE(3182), 2,
      sym_line_comment,
      sym_block_comment,
  [90417] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(615), 1,
      sym_declaration_list,
    STATE(3183), 2,
      sym_line_comment,
      sym_block_comment,
  [90434] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    ACTIONS(6635), 1,
      anon_sym_RPAREN,
    STATE(3184), 2,
      sym_line_comment,
      sym_block_comment,
  [90451] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(2212), 1,
      sym_parameters,
    STATE(3185), 2,
      sym_line_comment,
      sym_block_comment,
  [90468] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5626), 2,
      sym_identifier,
      sym_super,
    STATE(3186), 2,
      sym_line_comment,
      sym_block_comment,
  [90483] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(1953), 1,
      sym_parameters,
    STATE(3187), 2,
      sym_line_comment,
      sym_block_comment,
  [90500] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 1,
      sym_super,
    ACTIONS(6637), 1,
      sym_identifier,
    STATE(3188), 2,
      sym_line_comment,
      sym_block_comment,
  [90517] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6264), 1,
      anon_sym_for,
    STATE(3189), 2,
      sym_line_comment,
      sym_block_comment,
  [90534] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5740), 1,
      sym_identifier,
    STATE(3190), 2,
      sym_line_comment,
      sym_block_comment,
  [90551] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6557), 1,
      sym_super,
    ACTIONS(6639), 1,
      sym_identifier,
    STATE(3191), 2,
      sym_line_comment,
      sym_block_comment,
  [90568] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4895), 1,
      anon_sym_LT,
    STATE(956), 1,
      sym_type_parameters,
    STATE(3192), 2,
      sym_line_comment,
      sym_block_comment,
  [90585] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4445), 1,
      anon_sym_BANG,
    ACTIONS(6641), 1,
      anon_sym_COLON_COLON,
    STATE(3193), 2,
      sym_line_comment,
      sym_block_comment,
  [90602] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6589), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6643), 1,
      anon_sym_RPAREN,
    STATE(3194), 2,
      sym_line_comment,
      sym_block_comment,
  [90619] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6569), 1,
      anon_sym_LT,
    STATE(898), 1,
      sym_type_parameters,
    STATE(3195), 2,
      sym_line_comment,
      sym_block_comment,
  [90636] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6583), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6645), 1,
      anon_sym_RPAREN,
    STATE(3196), 2,
      sym_line_comment,
      sym_block_comment,
  [90653] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(6647), 1,
      anon_sym_in,
    STATE(3197), 2,
      sym_line_comment,
      sym_block_comment,
  [90670] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6569), 1,
      anon_sym_LT,
    STATE(1090), 1,
      sym_type_parameters,
    STATE(3198), 2,
      sym_line_comment,
      sym_block_comment,
  [90687] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6645), 1,
      anon_sym_RPAREN,
    ACTIONS(6649), 1,
      anon_sym_COLON_COLON,
    STATE(3199), 2,
      sym_line_comment,
      sym_block_comment,
  [90704] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(595), 1,
      sym_declaration_list,
    STATE(3200), 2,
      sym_line_comment,
      sym_block_comment,
  [90721] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6651), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3201), 2,
      sym_line_comment,
      sym_block_comment,
  [90736] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    STATE(2866), 1,
      sym_lifetime,
    STATE(3202), 2,
      sym_line_comment,
      sym_block_comment,
  [90753] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6579), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6645), 1,
      anon_sym_RPAREN,
    STATE(3203), 2,
      sym_line_comment,
      sym_block_comment,
  [90770] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6577), 1,
      anon_sym_RPAREN,
    ACTIONS(6649), 1,
      anon_sym_COLON_COLON,
    STATE(3204), 2,
      sym_line_comment,
      sym_block_comment,
  [90787] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4610), 1,
      anon_sym_BANG,
    ACTIONS(4690), 1,
      anon_sym_COLON_COLON,
    STATE(3205), 2,
      sym_line_comment,
      sym_block_comment,
  [90804] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(238), 1,
      sym_closure_parameters,
    STATE(3206), 2,
      sym_line_comment,
      sym_block_comment,
  [90821] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6231), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3207), 2,
      sym_line_comment,
      sym_block_comment,
  [90836] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4610), 1,
      anon_sym_BANG,
    ACTIONS(4716), 1,
      anon_sym_COLON_COLON,
    STATE(3208), 2,
      sym_line_comment,
      sym_block_comment,
  [90853] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5193), 1,
      anon_sym_RBRACK,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3209), 2,
      sym_line_comment,
      sym_block_comment,
  [90870] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1129), 1,
      sym_field_declaration_list,
    STATE(3210), 2,
      sym_line_comment,
      sym_block_comment,
  [90887] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6509), 1,
      sym_super,
    ACTIONS(6639), 1,
      sym_identifier,
    STATE(3211), 2,
      sym_line_comment,
      sym_block_comment,
  [90904] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5193), 1,
      anon_sym_RPAREN,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3212), 2,
      sym_line_comment,
      sym_block_comment,
  [90921] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6653), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3213), 2,
      sym_line_comment,
      sym_block_comment,
  [90936] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(218), 1,
      sym_closure_parameters,
    STATE(3214), 2,
      sym_line_comment,
      sym_block_comment,
  [90953] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6224), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3215), 2,
      sym_line_comment,
      sym_block_comment,
  [90968] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5103), 1,
      anon_sym_RBRACK,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3216), 2,
      sym_line_comment,
      sym_block_comment,
  [90985] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1127), 1,
      sym_declaration_list,
    STATE(3217), 2,
      sym_line_comment,
      sym_block_comment,
  [91002] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5686), 1,
      sym_super,
    ACTIONS(6655), 1,
      sym_identifier,
    STATE(3218), 2,
      sym_line_comment,
      sym_block_comment,
  [91019] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5740), 1,
      sym_identifier,
    STATE(3219), 2,
      sym_line_comment,
      sym_block_comment,
  [91036] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5103), 1,
      anon_sym_RPAREN,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3220), 2,
      sym_line_comment,
      sym_block_comment,
  [91053] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6623), 1,
      sym_super,
    ACTIONS(6657), 1,
      sym_identifier,
    STATE(3221), 2,
      sym_line_comment,
      sym_block_comment,
  [91070] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(567), 1,
      sym_enum_variant_list,
    STATE(3222), 2,
      sym_line_comment,
      sym_block_comment,
  [91087] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(232), 1,
      sym_closure_parameters,
    STATE(3223), 2,
      sym_line_comment,
      sym_block_comment,
  [91104] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6659), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3224), 2,
      sym_line_comment,
      sym_block_comment,
  [91119] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5654), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3225), 2,
      sym_line_comment,
      sym_block_comment,
  [91134] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(216), 1,
      sym_closure_parameters,
    STATE(3226), 2,
      sym_line_comment,
      sym_block_comment,
  [91151] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6615), 1,
      sym_super,
    ACTIONS(6661), 1,
      sym_identifier,
    STATE(3227), 2,
      sym_line_comment,
      sym_block_comment,
  [91168] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    STATE(561), 1,
      sym_field_declaration_list,
    STATE(3228), 2,
      sym_line_comment,
      sym_block_comment,
  [91185] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5807), 1,
      sym_identifier,
    STATE(3229), 2,
      sym_line_comment,
      sym_block_comment,
  [91202] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6509), 1,
      sym_super,
    ACTIONS(6663), 1,
      sym_identifier,
    STATE(3230), 2,
      sym_line_comment,
      sym_block_comment,
  [91219] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4893), 1,
      anon_sym_LBRACE,
    STATE(559), 1,
      sym_field_declaration_list,
    STATE(3231), 2,
      sym_line_comment,
      sym_block_comment,
  [91236] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1125), 1,
      sym_declaration_list,
    STATE(3232), 2,
      sym_line_comment,
      sym_block_comment,
  [91253] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(592), 1,
      sym_declaration_list,
    STATE(3233), 2,
      sym_line_comment,
      sym_block_comment,
  [91270] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3967), 1,
      anon_sym_LBRACE,
    STATE(1749), 1,
      sym_field_initializer_list,
    STATE(3234), 2,
      sym_line_comment,
      sym_block_comment,
  [91287] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_parameters,
    STATE(3235), 2,
      sym_line_comment,
      sym_block_comment,
  [91304] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(524), 1,
      sym_declaration_list,
    STATE(3236), 2,
      sym_line_comment,
      sym_block_comment,
  [91321] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6037), 1,
      anon_sym_EQ_GT,
    ACTIONS(6665), 1,
      anon_sym_AMP_AMP,
    STATE(3237), 2,
      sym_line_comment,
      sym_block_comment,
  [91338] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 1,
      sym_super,
    ACTIONS(6667), 1,
      sym_identifier,
    STATE(3238), 2,
      sym_line_comment,
      sym_block_comment,
  [91355] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6131), 1,
      sym_identifier,
    ACTIONS(6135), 1,
      sym_mutable_specifier,
    STATE(3239), 2,
      sym_line_comment,
      sym_block_comment,
  [91372] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(219), 1,
      sym_closure_parameters,
    STATE(3240), 2,
      sym_line_comment,
      sym_block_comment,
  [91389] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6669), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(3241), 2,
      sym_line_comment,
      sym_block_comment,
  [91404] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(546), 1,
      sym_declaration_list,
    STATE(3242), 2,
      sym_line_comment,
      sym_block_comment,
  [91421] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6671), 1,
      sym_identifier,
    ACTIONS(6673), 1,
      sym_mutable_specifier,
    STATE(3243), 2,
      sym_line_comment,
      sym_block_comment,
  [91438] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(2200), 1,
      sym_parameters,
    STATE(3244), 2,
      sym_line_comment,
      sym_block_comment,
  [91455] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(544), 1,
      sym_declaration_list,
    STATE(3245), 2,
      sym_line_comment,
      sym_block_comment,
  [91472] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6569), 1,
      anon_sym_LT,
    STATE(1088), 1,
      sym_type_parameters,
    STATE(3246), 2,
      sym_line_comment,
      sym_block_comment,
  [91489] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3709), 1,
      anon_sym_COLON,
    ACTIONS(5270), 1,
      anon_sym_PLUS,
    STATE(3247), 2,
      sym_line_comment,
      sym_block_comment,
  [91506] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6623), 1,
      sym_super,
    ACTIONS(6675), 1,
      sym_identifier,
    STATE(3248), 2,
      sym_line_comment,
      sym_block_comment,
  [91523] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6149), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3249), 2,
      sym_line_comment,
      sym_block_comment,
  [91538] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1119), 1,
      sym_field_declaration_list,
    STATE(3250), 2,
      sym_line_comment,
      sym_block_comment,
  [91555] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 1,
      sym_super,
    ACTIONS(6677), 1,
      sym_identifier,
    STATE(3251), 2,
      sym_line_comment,
      sym_block_comment,
  [91572] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6571), 1,
      anon_sym_LPAREN,
    ACTIONS(6679), 1,
      anon_sym_COLON_COLON,
    STATE(3252), 2,
      sym_line_comment,
      sym_block_comment,
  [91589] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5856), 1,
      sym_identifier,
    STATE(3253), 2,
      sym_line_comment,
      sym_block_comment,
  [91606] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6509), 1,
      sym_super,
    ACTIONS(6681), 1,
      sym_identifier,
    STATE(3254), 2,
      sym_line_comment,
      sym_block_comment,
  [91623] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5533), 1,
      sym_super,
    ACTIONS(6667), 1,
      sym_identifier,
    STATE(3255), 2,
      sym_line_comment,
      sym_block_comment,
  [91640] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2969), 1,
      anon_sym_SQUOTE,
    STATE(3285), 1,
      sym_lifetime,
    STATE(3256), 2,
      sym_line_comment,
      sym_block_comment,
  [91657] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4245), 1,
      anon_sym_EQ_GT,
    ACTIONS(6665), 1,
      anon_sym_AMP_AMP,
    STATE(3257), 2,
      sym_line_comment,
      sym_block_comment,
  [91674] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACE,
    STATE(1114), 1,
      sym_declaration_list,
    STATE(3258), 2,
      sym_line_comment,
      sym_block_comment,
  [91691] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6168), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3259), 2,
      sym_line_comment,
      sym_block_comment,
  [91706] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6075), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3260), 2,
      sym_line_comment,
      sym_block_comment,
  [91721] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6683), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3261), 2,
      sym_line_comment,
      sym_block_comment,
  [91736] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5858), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3262), 2,
      sym_line_comment,
      sym_block_comment,
  [91751] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3243), 1,
      anon_sym_LPAREN,
    STATE(1064), 1,
      sym_parameters,
    STATE(3263), 2,
      sym_line_comment,
      sym_block_comment,
  [91768] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5225), 1,
      anon_sym_LBRACE,
    STATE(1109), 1,
      sym_enum_variant_list,
    STATE(3264), 2,
      sym_line_comment,
      sym_block_comment,
  [91785] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4919), 1,
      anon_sym_LBRACE,
    STATE(1105), 1,
      sym_field_declaration_list,
    STATE(3265), 2,
      sym_line_comment,
      sym_block_comment,
  [91802] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6685), 1,
      anon_sym_BANG,
    ACTIONS(6687), 1,
      anon_sym_COLON_COLON,
    STATE(3266), 2,
      sym_line_comment,
      sym_block_comment,
  [91819] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6689), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3267), 2,
      sym_line_comment,
      sym_block_comment,
  [91834] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5874), 1,
      sym_identifier,
    STATE(3268), 2,
      sym_line_comment,
      sym_block_comment,
  [91851] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6561), 1,
      sym_super,
    ACTIONS(6691), 1,
      sym_identifier,
    STATE(3269), 2,
      sym_line_comment,
      sym_block_comment,
  [91868] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3251), 1,
      anon_sym_LT2,
    STATE(1412), 1,
      sym_type_arguments,
    STATE(3270), 2,
      sym_line_comment,
      sym_block_comment,
  [91885] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 1,
      sym_super,
    ACTIONS(6693), 1,
      sym_identifier,
    STATE(3271), 2,
      sym_line_comment,
      sym_block_comment,
  [91902] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 2,
      sym_identifier,
      sym_super,
    STATE(3272), 2,
      sym_line_comment,
      sym_block_comment,
  [91917] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5813), 1,
      sym_super,
    ACTIONS(5860), 1,
      sym_identifier,
    STATE(3273), 2,
      sym_line_comment,
      sym_block_comment,
  [91934] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6581), 1,
      sym_super,
    ACTIONS(6695), 1,
      sym_identifier,
    STATE(3274), 2,
      sym_line_comment,
      sym_block_comment,
  [91951] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6697), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3275), 2,
      sym_line_comment,
      sym_block_comment,
  [91966] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    STATE(1956), 1,
      sym_parameters,
    STATE(3276), 2,
      sym_line_comment,
      sym_block_comment,
  [91983] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5278), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3277), 2,
      sym_line_comment,
      sym_block_comment,
  [91998] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6571), 1,
      anon_sym_LPAREN,
    ACTIONS(6699), 1,
      anon_sym_COLON_COLON,
    STATE(3278), 2,
      sym_line_comment,
      sym_block_comment,
  [92015] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6557), 1,
      sym_super,
    ACTIONS(6701), 1,
      sym_identifier,
    STATE(3279), 2,
      sym_line_comment,
      sym_block_comment,
  [92032] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5686), 1,
      sym_super,
    ACTIONS(6657), 1,
      sym_identifier,
    STATE(3280), 2,
      sym_line_comment,
      sym_block_comment,
  [92049] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 1,
      sym_super,
    ACTIONS(6627), 1,
      sym_identifier,
    STATE(3281), 2,
      sym_line_comment,
      sym_block_comment,
  [92066] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6703), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3282), 2,
      sym_line_comment,
      sym_block_comment,
  [92081] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5807), 1,
      sym_identifier,
    STATE(3283), 2,
      sym_line_comment,
      sym_block_comment,
  [92098] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6557), 1,
      sym_super,
    ACTIONS(6663), 1,
      sym_identifier,
    STATE(3284), 2,
      sym_line_comment,
      sym_block_comment,
  [92115] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6154), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(3285), 2,
      sym_line_comment,
      sym_block_comment,
  [92130] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6623), 1,
      sym_super,
    ACTIONS(6705), 1,
      sym_identifier,
    STATE(3286), 2,
      sym_line_comment,
      sym_block_comment,
  [92147] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    ACTIONS(6707), 1,
      anon_sym_RBRACE,
    STATE(3287), 2,
      sym_line_comment,
      sym_block_comment,
  [92164] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5876), 1,
      sym_identifier,
    STATE(3288), 2,
      sym_line_comment,
      sym_block_comment,
  [92181] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6509), 1,
      sym_super,
    ACTIONS(6709), 1,
      sym_identifier,
    STATE(3289), 2,
      sym_line_comment,
      sym_block_comment,
  [92198] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6623), 1,
      sym_super,
    ACTIONS(6711), 1,
      sym_identifier,
    STATE(3290), 2,
      sym_line_comment,
      sym_block_comment,
  [92215] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4915), 1,
      anon_sym_LBRACE,
    STATE(558), 1,
      sym_declaration_list,
    STATE(3291), 2,
      sym_line_comment,
      sym_block_comment,
  [92232] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5878), 1,
      sym_identifier,
    STATE(3292), 2,
      sym_line_comment,
      sym_block_comment,
  [92249] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6509), 1,
      sym_super,
    ACTIONS(6713), 1,
      sym_identifier,
    STATE(3293), 2,
      sym_line_comment,
      sym_block_comment,
  [92266] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    ACTIONS(6715), 1,
      anon_sym_RBRACE,
    STATE(3294), 2,
      sym_line_comment,
      sym_block_comment,
  [92283] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6623), 1,
      sym_super,
    ACTIONS(6717), 1,
      sym_identifier,
    STATE(3295), 2,
      sym_line_comment,
      sym_block_comment,
  [92300] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5726), 1,
      sym_super,
    ACTIONS(5880), 1,
      sym_identifier,
    STATE(3296), 2,
      sym_line_comment,
      sym_block_comment,
  [92317] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6509), 1,
      sym_super,
    ACTIONS(6719), 1,
      sym_identifier,
    STATE(3297), 2,
      sym_line_comment,
      sym_block_comment,
  [92334] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5686), 1,
      sym_super,
    ACTIONS(6717), 1,
      sym_identifier,
    STATE(3298), 2,
      sym_line_comment,
      sym_block_comment,
  [92351] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_RPAREN,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3299), 2,
      sym_line_comment,
      sym_block_comment,
  [92368] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5129), 1,
      sym_super,
    ACTIONS(5880), 1,
      sym_identifier,
    STATE(3300), 2,
      sym_line_comment,
      sym_block_comment,
  [92385] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6557), 1,
      sym_super,
    ACTIONS(6719), 1,
      sym_identifier,
    STATE(3301), 2,
      sym_line_comment,
      sym_block_comment,
  [92402] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5129), 2,
      sym_identifier,
      sym_super,
    STATE(3302), 2,
      sym_line_comment,
      sym_block_comment,
  [92417] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5533), 1,
      sym_super,
    ACTIONS(6721), 1,
      sym_identifier,
    STATE(3303), 2,
      sym_line_comment,
      sym_block_comment,
  [92434] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5882), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(3304), 2,
      sym_line_comment,
      sym_block_comment,
  [92449] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4975), 1,
      anon_sym_PLUS,
    ACTIONS(6723), 1,
      anon_sym_GT,
    STATE(3305), 2,
      sym_line_comment,
      sym_block_comment,
  [92466] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_RBRACK,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3306), 2,
      sym_line_comment,
      sym_block_comment,
  [92483] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6725), 2,
      sym_float_literal,
      sym_integer_literal,
    STATE(3307), 2,
      sym_line_comment,
      sym_block_comment,
  [92498] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6727), 1,
      anon_sym_SEMI,
    ACTIONS(6729), 1,
      anon_sym_as,
    STATE(3308), 2,
      sym_line_comment,
      sym_block_comment,
  [92515] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6523), 1,
      sym_identifier,
    ACTIONS(6623), 1,
      sym_super,
    STATE(3309), 2,
      sym_line_comment,
      sym_block_comment,
  [92532] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6731), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3310), 2,
      sym_line_comment,
      sym_block_comment,
  [92547] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5453), 1,
      anon_sym_PIPE,
    ACTIONS(5543), 1,
      anon_sym_COLON,
    STATE(3311), 2,
      sym_line_comment,
      sym_block_comment,
  [92564] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6733), 1,
      anon_sym_SEMI,
    STATE(3312), 2,
      sym_line_comment,
      sym_block_comment,
  [92578] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6735), 1,
      sym_raw_string_literal_content,
    STATE(3313), 2,
      sym_line_comment,
      sym_block_comment,
  [92592] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6737), 1,
      sym_identifier,
    STATE(3314), 2,
      sym_line_comment,
      sym_block_comment,
  [92606] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6739), 1,
      sym_identifier,
    STATE(3315), 2,
      sym_line_comment,
      sym_block_comment,
  [92620] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6741), 1,
      sym_identifier,
    STATE(3316), 2,
      sym_line_comment,
      sym_block_comment,
  [92634] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6743), 1,
      sym_identifier,
    STATE(3317), 2,
      sym_line_comment,
      sym_block_comment,
  [92648] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6745), 1,
      sym_identifier,
    STATE(3318), 2,
      sym_line_comment,
      sym_block_comment,
  [92662] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6747), 1,
      anon_sym_EQ_GT,
    STATE(3319), 2,
      sym_line_comment,
      sym_block_comment,
  [92676] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6749), 1,
      sym_identifier,
    STATE(3320), 2,
      sym_line_comment,
      sym_block_comment,
  [92690] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4059), 1,
      anon_sym_COLON_COLON,
    STATE(3321), 2,
      sym_line_comment,
      sym_block_comment,
  [92704] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6751), 1,
      sym_identifier,
    STATE(3322), 2,
      sym_line_comment,
      sym_block_comment,
  [92718] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4574), 1,
      anon_sym_COLON_COLON,
    STATE(3323), 2,
      sym_line_comment,
      sym_block_comment,
  [92732] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6753), 1,
      sym_raw_string_literal_content,
    STATE(3324), 2,
      sym_line_comment,
      sym_block_comment,
  [92746] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6715), 1,
      anon_sym_SEMI,
    STATE(3325), 2,
      sym_line_comment,
      sym_block_comment,
  [92760] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6755), 1,
      sym_identifier,
    STATE(3326), 2,
      sym_line_comment,
      sym_block_comment,
  [92774] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5163), 1,
      anon_sym_SEMI,
    STATE(3327), 2,
      sym_line_comment,
      sym_block_comment,
  [92788] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6757), 1,
      anon_sym_fn,
    STATE(3328), 2,
      sym_line_comment,
      sym_block_comment,
  [92802] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6707), 1,
      anon_sym_SEMI,
    STATE(3329), 2,
      sym_line_comment,
      sym_block_comment,
  [92816] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6759), 1,
      sym_identifier,
    STATE(3330), 2,
      sym_line_comment,
      sym_block_comment,
  [92830] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4554), 1,
      anon_sym_COLON_COLON,
    STATE(3331), 2,
      sym_line_comment,
      sym_block_comment,
  [92844] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6761), 1,
      sym_identifier,
    STATE(3332), 2,
      sym_line_comment,
      sym_block_comment,
  [92858] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6763), 1,
      anon_sym_SEMI,
    STATE(3333), 2,
      sym_line_comment,
      sym_block_comment,
  [92872] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6765), 1,
      anon_sym_SEMI,
    STATE(3334), 2,
      sym_line_comment,
      sym_block_comment,
  [92886] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6767), 1,
      anon_sym_RPAREN,
    STATE(3335), 2,
      sym_line_comment,
      sym_block_comment,
  [92900] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4067), 1,
      anon_sym_RPAREN,
    STATE(3336), 2,
      sym_line_comment,
      sym_block_comment,
  [92914] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6769), 1,
      anon_sym_fn,
    STATE(3337), 2,
      sym_line_comment,
      sym_block_comment,
  [92928] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6771), 1,
      anon_sym_SEMI,
    STATE(3338), 2,
      sym_line_comment,
      sym_block_comment,
  [92942] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6773), 1,
      anon_sym_COLON_COLON,
    STATE(3339), 2,
      sym_line_comment,
      sym_block_comment,
  [92956] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6775), 1,
      sym_raw_string_literal_content,
    STATE(3340), 2,
      sym_line_comment,
      sym_block_comment,
  [92970] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6777), 1,
      anon_sym_EQ_GT,
    STATE(3341), 2,
      sym_line_comment,
      sym_block_comment,
  [92984] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6779), 1,
      anon_sym_EQ_GT,
    STATE(3342), 2,
      sym_line_comment,
      sym_block_comment,
  [92998] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6781), 1,
      anon_sym_SEMI,
    STATE(3343), 2,
      sym_line_comment,
      sym_block_comment,
  [93012] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6783), 1,
      sym_identifier,
    STATE(3344), 2,
      sym_line_comment,
      sym_block_comment,
  [93026] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6785), 1,
      anon_sym_SEMI,
    STATE(3345), 2,
      sym_line_comment,
      sym_block_comment,
  [93040] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6787), 1,
      anon_sym_STAR_SLASH,
    STATE(3346), 2,
      sym_line_comment,
      sym_block_comment,
  [93054] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6789), 1,
      sym_identifier,
    STATE(3347), 2,
      sym_line_comment,
      sym_block_comment,
  [93068] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6791), 1,
      sym_identifier,
    STATE(3348), 2,
      sym_line_comment,
      sym_block_comment,
  [93082] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6793), 1,
      anon_sym_COLON_COLON,
    STATE(3349), 2,
      sym_line_comment,
      sym_block_comment,
  [93096] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6795), 1,
      sym_identifier,
    STATE(3350), 2,
      sym_line_comment,
      sym_block_comment,
  [93110] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6797), 1,
      sym_identifier,
    STATE(3351), 2,
      sym_line_comment,
      sym_block_comment,
  [93124] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6799), 1,
      sym_identifier,
    STATE(3352), 2,
      sym_line_comment,
      sym_block_comment,
  [93138] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6801), 1,
      sym_identifier,
    STATE(3353), 2,
      sym_line_comment,
      sym_block_comment,
  [93152] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6803), 1,
      sym_identifier,
    STATE(3354), 2,
      sym_line_comment,
      sym_block_comment,
  [93166] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3057), 1,
      anon_sym_PLUS,
    STATE(3355), 2,
      sym_line_comment,
      sym_block_comment,
  [93180] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3984), 1,
      sym_identifier,
    STATE(3356), 2,
      sym_line_comment,
      sym_block_comment,
  [93194] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6805), 1,
      anon_sym_COLON_COLON,
    STATE(3357), 2,
      sym_line_comment,
      sym_block_comment,
  [93208] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6807), 1,
      sym_identifier,
    STATE(3358), 2,
      sym_line_comment,
      sym_block_comment,
  [93222] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6809), 1,
      sym_identifier,
    STATE(3359), 2,
      sym_line_comment,
      sym_block_comment,
  [93236] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6811), 1,
      anon_sym_SEMI,
    STATE(3360), 2,
      sym_line_comment,
      sym_block_comment,
  [93250] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6813), 1,
      anon_sym_SEMI,
    STATE(3361), 2,
      sym_line_comment,
      sym_block_comment,
  [93264] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6815), 1,
      anon_sym_RBRACE,
    STATE(3362), 2,
      sym_line_comment,
      sym_block_comment,
  [93278] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6817), 1,
      anon_sym_RBRACK,
    STATE(3363), 2,
      sym_line_comment,
      sym_block_comment,
  [93292] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6819), 1,
      anon_sym_SEMI,
    STATE(3364), 2,
      sym_line_comment,
      sym_block_comment,
  [93306] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(763), 1,
      anon_sym_RBRACK,
    STATE(3365), 2,
      sym_line_comment,
      sym_block_comment,
  [93320] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(987), 1,
      anon_sym_RBRACK,
    STATE(3366), 2,
      sym_line_comment,
      sym_block_comment,
  [93334] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4943), 1,
      anon_sym_COLON_COLON,
    STATE(3367), 2,
      sym_line_comment,
      sym_block_comment,
  [93348] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6821), 1,
      anon_sym_RBRACK,
    STATE(3368), 2,
      sym_line_comment,
      sym_block_comment,
  [93362] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6823), 1,
      anon_sym_COLON_COLON,
    STATE(3369), 2,
      sym_line_comment,
      sym_block_comment,
  [93376] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6825), 1,
      anon_sym_fn,
    STATE(3370), 2,
      sym_line_comment,
      sym_block_comment,
  [93390] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6827), 1,
      anon_sym_SEMI,
    STATE(3371), 2,
      sym_line_comment,
      sym_block_comment,
  [93404] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5716), 1,
      anon_sym_LBRACE,
    STATE(3372), 2,
      sym_line_comment,
      sym_block_comment,
  [93418] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5834), 1,
      anon_sym_RPAREN,
    STATE(3373), 2,
      sym_line_comment,
      sym_block_comment,
  [93432] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6829), 1,
      anon_sym_SEMI,
    STATE(3374), 2,
      sym_line_comment,
      sym_block_comment,
  [93446] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6831), 1,
      sym__raw_string_literal_end,
    STATE(3375), 2,
      sym_line_comment,
      sym_block_comment,
  [93460] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6833), 1,
      sym_identifier,
    STATE(3376), 2,
      sym_line_comment,
      sym_block_comment,
  [93474] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6835), 1,
      anon_sym_SEMI,
    STATE(3377), 2,
      sym_line_comment,
      sym_block_comment,
  [93488] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6837), 1,
      anon_sym_SEMI,
    STATE(3378), 2,
      sym_line_comment,
      sym_block_comment,
  [93502] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6839), 1,
      anon_sym_LPAREN,
    STATE(3379), 2,
      sym_line_comment,
      sym_block_comment,
  [93516] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_SEMI,
    STATE(3380), 2,
      sym_line_comment,
      sym_block_comment,
  [93530] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6841), 1,
      anon_sym_COLON,
    STATE(3381), 2,
      sym_line_comment,
      sym_block_comment,
  [93544] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6843), 1,
      anon_sym_SEMI,
    STATE(3382), 2,
      sym_line_comment,
      sym_block_comment,
  [93558] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6845), 1,
      anon_sym_SEMI,
    STATE(3383), 2,
      sym_line_comment,
      sym_block_comment,
  [93572] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6847), 1,
      sym_identifier,
    STATE(3384), 2,
      sym_line_comment,
      sym_block_comment,
  [93586] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5815), 1,
      anon_sym_RBRACK,
    STATE(3385), 2,
      sym_line_comment,
      sym_block_comment,
  [93600] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(773), 1,
      anon_sym_EQ_GT,
    STATE(3386), 2,
      sym_line_comment,
      sym_block_comment,
  [93614] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6849), 1,
      sym__raw_string_literal_end,
    STATE(3387), 2,
      sym_line_comment,
      sym_block_comment,
  [93628] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6851), 1,
      anon_sym_RBRACK,
    STATE(3388), 2,
      sym_line_comment,
      sym_block_comment,
  [93642] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6853), 1,
      sym_identifier,
    STATE(3389), 2,
      sym_line_comment,
      sym_block_comment,
  [93656] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6855), 1,
      sym_identifier,
    STATE(3390), 2,
      sym_line_comment,
      sym_block_comment,
  [93670] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6857), 1,
      anon_sym_SEMI,
    STATE(3391), 2,
      sym_line_comment,
      sym_block_comment,
  [93684] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6859), 1,
      anon_sym_SEMI,
    STATE(3392), 2,
      sym_line_comment,
      sym_block_comment,
  [93698] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6861), 1,
      anon_sym_COLON,
    STATE(3393), 2,
      sym_line_comment,
      sym_block_comment,
  [93712] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6863), 1,
      sym_identifier,
    STATE(3394), 2,
      sym_line_comment,
      sym_block_comment,
  [93726] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6248), 1,
      anon_sym_RBRACE,
    STATE(3395), 2,
      sym_line_comment,
      sym_block_comment,
  [93740] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6865), 1,
      sym__raw_string_literal_end,
    STATE(3396), 2,
      sym_line_comment,
      sym_block_comment,
  [93754] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6867), 1,
      anon_sym_COLON,
    STATE(3397), 2,
      sym_line_comment,
      sym_block_comment,
  [93768] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6869), 1,
      sym_identifier,
    STATE(3398), 2,
      sym_line_comment,
      sym_block_comment,
  [93782] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6871), 1,
      anon_sym_RBRACE,
    STATE(3399), 2,
      sym_line_comment,
      sym_block_comment,
  [93796] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6873), 1,
      anon_sym_SEMI,
    STATE(3400), 2,
      sym_line_comment,
      sym_block_comment,
  [93810] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6875), 1,
      anon_sym_SEMI,
    STATE(3401), 2,
      sym_line_comment,
      sym_block_comment,
  [93824] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6877), 1,
      anon_sym_SEMI,
    STATE(3402), 2,
      sym_line_comment,
      sym_block_comment,
  [93838] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6879), 1,
      anon_sym_EQ_GT,
    STATE(3403), 2,
      sym_line_comment,
      sym_block_comment,
  [93852] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6049), 1,
      anon_sym_RBRACE,
    STATE(3404), 2,
      sym_line_comment,
      sym_block_comment,
  [93866] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6881), 1,
      anon_sym_SEMI,
    STATE(3405), 2,
      sym_line_comment,
      sym_block_comment,
  [93880] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6883), 1,
      anon_sym_RBRACE,
    STATE(3406), 2,
      sym_line_comment,
      sym_block_comment,
  [93894] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6885), 1,
      sym_identifier,
    STATE(3407), 2,
      sym_line_comment,
      sym_block_comment,
  [93908] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4921), 1,
      anon_sym_COLON_COLON,
    STATE(3408), 2,
      sym_line_comment,
      sym_block_comment,
  [93922] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6887), 1,
      sym_identifier,
    STATE(3409), 2,
      sym_line_comment,
      sym_block_comment,
  [93936] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6889), 1,
      anon_sym_SEMI,
    STATE(3410), 2,
      sym_line_comment,
      sym_block_comment,
  [93950] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6891), 1,
      anon_sym_COLON_COLON,
    STATE(3411), 2,
      sym_line_comment,
      sym_block_comment,
  [93964] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6893), 1,
      anon_sym_RBRACE,
    STATE(3412), 2,
      sym_line_comment,
      sym_block_comment,
  [93978] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6895), 1,
      anon_sym_COLON,
    STATE(3413), 2,
      sym_line_comment,
      sym_block_comment,
  [93992] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6897), 1,
      anon_sym_COLON,
    STATE(3414), 2,
      sym_line_comment,
      sym_block_comment,
  [94006] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6899), 1,
      anon_sym_SEMI,
    STATE(3415), 2,
      sym_line_comment,
      sym_block_comment,
  [94020] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6901), 1,
      anon_sym_SEMI,
    STATE(3416), 2,
      sym_line_comment,
      sym_block_comment,
  [94034] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6903), 1,
      anon_sym_LBRACK,
    STATE(3417), 2,
      sym_line_comment,
      sym_block_comment,
  [94048] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6905), 1,
      anon_sym_RBRACK,
    STATE(3418), 2,
      sym_line_comment,
      sym_block_comment,
  [94062] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5463), 1,
      anon_sym_RPAREN,
    STATE(3419), 2,
      sym_line_comment,
      sym_block_comment,
  [94076] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6907), 1,
      anon_sym_COLON_COLON,
    STATE(3420), 2,
      sym_line_comment,
      sym_block_comment,
  [94090] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6909), 1,
      sym_identifier,
    STATE(3421), 2,
      sym_line_comment,
      sym_block_comment,
  [94104] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6911), 1,
      anon_sym_RBRACE,
    STATE(3422), 2,
      sym_line_comment,
      sym_block_comment,
  [94118] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    STATE(3423), 2,
      sym_line_comment,
      sym_block_comment,
  [94132] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6019), 1,
      anon_sym_GT,
    STATE(3424), 2,
      sym_line_comment,
      sym_block_comment,
  [94146] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6913), 1,
      anon_sym_SEMI,
    STATE(3425), 2,
      sym_line_comment,
      sym_block_comment,
  [94160] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6915), 1,
      anon_sym_SEMI,
    STATE(3426), 2,
      sym_line_comment,
      sym_block_comment,
  [94174] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6917), 1,
      anon_sym_SEMI,
    STATE(3427), 2,
      sym_line_comment,
      sym_block_comment,
  [94188] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6919), 1,
      anon_sym_COLON_COLON,
    STATE(3428), 2,
      sym_line_comment,
      sym_block_comment,
  [94202] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6921), 1,
      anon_sym_SEMI,
    STATE(3429), 2,
      sym_line_comment,
      sym_block_comment,
  [94216] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6923), 1,
      anon_sym_COLON,
    STATE(3430), 2,
      sym_line_comment,
      sym_block_comment,
  [94230] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6925), 1,
      sym_identifier,
    STATE(3431), 2,
      sym_line_comment,
      sym_block_comment,
  [94244] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6927), 1,
      anon_sym_fn,
    STATE(3432), 2,
      sym_line_comment,
      sym_block_comment,
  [94258] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6929), 1,
      anon_sym_fn,
    STATE(3433), 2,
      sym_line_comment,
      sym_block_comment,
  [94272] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6931), 1,
      anon_sym_SEMI,
    STATE(3434), 2,
      sym_line_comment,
      sym_block_comment,
  [94286] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6933), 1,
      anon_sym_LT,
    STATE(3435), 2,
      sym_line_comment,
      sym_block_comment,
  [94300] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6935), 1,
      anon_sym_SEMI,
    STATE(3436), 2,
      sym_line_comment,
      sym_block_comment,
  [94314] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6937), 1,
      sym__raw_string_literal_end,
    STATE(3437), 2,
      sym_line_comment,
      sym_block_comment,
  [94328] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6939), 1,
      anon_sym_SEMI,
    STATE(3438), 2,
      sym_line_comment,
      sym_block_comment,
  [94342] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5191), 1,
      anon_sym_SEMI,
    STATE(3439), 2,
      sym_line_comment,
      sym_block_comment,
  [94356] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6941), 1,
      sym_identifier,
    STATE(3440), 2,
      sym_line_comment,
      sym_block_comment,
  [94370] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6943), 1,
      sym_identifier,
    STATE(3441), 2,
      sym_line_comment,
      sym_block_comment,
  [94384] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6945), 1,
      anon_sym_EQ_GT,
    STATE(3442), 2,
      sym_line_comment,
      sym_block_comment,
  [94398] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5419), 1,
      anon_sym_RPAREN,
    STATE(3443), 2,
      sym_line_comment,
      sym_block_comment,
  [94412] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5993), 1,
      anon_sym_RBRACE,
    STATE(3444), 2,
      sym_line_comment,
      sym_block_comment,
  [94426] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6947), 1,
      anon_sym_STAR_SLASH,
    STATE(3445), 2,
      sym_line_comment,
      sym_block_comment,
  [94440] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6949), 1,
      sym_identifier,
    STATE(3446), 2,
      sym_line_comment,
      sym_block_comment,
  [94454] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6951), 1,
      anon_sym_SEMI,
    STATE(3447), 2,
      sym_line_comment,
      sym_block_comment,
  [94468] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4541), 1,
      anon_sym_COLON_COLON,
    STATE(3448), 2,
      sym_line_comment,
      sym_block_comment,
  [94482] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6953), 1,
      anon_sym_RPAREN,
    STATE(3449), 2,
      sym_line_comment,
      sym_block_comment,
  [94496] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5151), 1,
      anon_sym_COLON_COLON,
    STATE(3450), 2,
      sym_line_comment,
      sym_block_comment,
  [94510] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(989), 1,
      anon_sym_RBRACK,
    STATE(3451), 2,
      sym_line_comment,
      sym_block_comment,
  [94524] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5989), 1,
      anon_sym_RBRACE,
    STATE(3452), 2,
      sym_line_comment,
      sym_block_comment,
  [94538] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6955), 1,
      anon_sym_SEMI,
    STATE(3453), 2,
      sym_line_comment,
      sym_block_comment,
  [94552] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6957), 1,
      anon_sym_RBRACK,
    STATE(3454), 2,
      sym_line_comment,
      sym_block_comment,
  [94566] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6959), 1,
      anon_sym_SEMI,
    STATE(3455), 2,
      sym_line_comment,
      sym_block_comment,
  [94580] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6961), 1,
      anon_sym_RBRACE,
    STATE(3456), 2,
      sym_line_comment,
      sym_block_comment,
  [94594] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6963), 1,
      anon_sym_COLON,
    STATE(3457), 2,
      sym_line_comment,
      sym_block_comment,
  [94608] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6965), 1,
      anon_sym_RBRACK,
    STATE(3458), 2,
      sym_line_comment,
      sym_block_comment,
  [94622] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6967), 1,
      anon_sym_SEMI,
    STATE(3459), 2,
      sym_line_comment,
      sym_block_comment,
  [94636] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5819), 1,
      anon_sym_RPAREN,
    STATE(3460), 2,
      sym_line_comment,
      sym_block_comment,
  [94650] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5866), 1,
      anon_sym_LBRACE,
    STATE(3461), 2,
      sym_line_comment,
      sym_block_comment,
  [94664] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(793), 1,
      anon_sym_RBRACK,
    STATE(3462), 2,
      sym_line_comment,
      sym_block_comment,
  [94678] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4732), 1,
      anon_sym_COLON_COLON,
    STATE(3463), 2,
      sym_line_comment,
      sym_block_comment,
  [94692] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6969), 1,
      anon_sym_SEMI,
    STATE(3464), 2,
      sym_line_comment,
      sym_block_comment,
  [94706] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6971), 1,
      sym_identifier,
    STATE(3465), 2,
      sym_line_comment,
      sym_block_comment,
  [94720] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5826), 1,
      anon_sym_RBRACK,
    STATE(3466), 2,
      sym_line_comment,
      sym_block_comment,
  [94734] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6973), 1,
      anon_sym_RBRACE,
    STATE(3467), 2,
      sym_line_comment,
      sym_block_comment,
  [94748] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6975), 1,
      anon_sym_SEMI,
    STATE(3468), 2,
      sym_line_comment,
      sym_block_comment,
  [94762] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4119), 1,
      anon_sym_COLON_COLON,
    STATE(3469), 2,
      sym_line_comment,
      sym_block_comment,
  [94776] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5764), 1,
      anon_sym_COLON_COLON,
    STATE(3470), 2,
      sym_line_comment,
      sym_block_comment,
  [94790] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6505), 1,
      anon_sym_LBRACK,
    STATE(3471), 2,
      sym_line_comment,
      sym_block_comment,
  [94804] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5515), 1,
      anon_sym_RPAREN,
    STATE(3472), 2,
      sym_line_comment,
      sym_block_comment,
  [94818] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6977), 1,
      anon_sym_RBRACK,
    STATE(3473), 2,
      sym_line_comment,
      sym_block_comment,
  [94832] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6979), 1,
      anon_sym_COLON_COLON,
    STATE(3474), 2,
      sym_line_comment,
      sym_block_comment,
  [94846] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6981), 1,
      anon_sym_SEMI,
    STATE(3475), 2,
      sym_line_comment,
      sym_block_comment,
  [94860] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6983), 1,
      sym_identifier,
    STATE(3476), 2,
      sym_line_comment,
      sym_block_comment,
  [94874] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5830), 1,
      anon_sym_RPAREN,
    STATE(3477), 2,
      sym_line_comment,
      sym_block_comment,
  [94888] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6985), 1,
      anon_sym_fn,
    STATE(3478), 2,
      sym_line_comment,
      sym_block_comment,
  [94902] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6987), 1,
      sym__raw_string_literal_end,
    STATE(3479), 2,
      sym_line_comment,
      sym_block_comment,
  [94916] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6989), 1,
      anon_sym_COLON_COLON,
    STATE(3480), 2,
      sym_line_comment,
      sym_block_comment,
  [94930] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6991), 1,
      anon_sym_RBRACK,
    STATE(3481), 2,
      sym_line_comment,
      sym_block_comment,
  [94944] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6993), 1,
      anon_sym_COLON,
    STATE(3482), 2,
      sym_line_comment,
      sym_block_comment,
  [94958] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6995), 1,
      anon_sym_COLON_COLON,
    STATE(3483), 2,
      sym_line_comment,
      sym_block_comment,
  [94972] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6997), 1,
      anon_sym_RBRACE,
    STATE(3484), 2,
      sym_line_comment,
      sym_block_comment,
  [94986] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6435), 1,
      anon_sym_RBRACE,
    STATE(3485), 2,
      sym_line_comment,
      sym_block_comment,
  [95000] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4931), 1,
      anon_sym_COLON_COLON,
    STATE(3486), 2,
      sym_line_comment,
      sym_block_comment,
  [95014] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6329), 1,
      anon_sym_RBRACE,
    STATE(3487), 2,
      sym_line_comment,
      sym_block_comment,
  [95028] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6999), 1,
      anon_sym_COLON_COLON,
    STATE(3488), 2,
      sym_line_comment,
      sym_block_comment,
  [95042] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7001), 1,
      anon_sym_fn,
    STATE(3489), 2,
      sym_line_comment,
      sym_block_comment,
  [95056] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5957), 1,
      anon_sym_RBRACE,
    STATE(3490), 2,
      sym_line_comment,
      sym_block_comment,
  [95070] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7003), 1,
      anon_sym_LBRACE,
    STATE(3491), 2,
      sym_line_comment,
      sym_block_comment,
  [95084] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7005), 1,
      anon_sym_SEMI,
    STATE(3492), 2,
      sym_line_comment,
      sym_block_comment,
  [95098] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7007), 1,
      anon_sym_EQ_GT,
    STATE(3493), 2,
      sym_line_comment,
      sym_block_comment,
  [95112] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7009), 1,
      sym__line_doc_content,
    STATE(3494), 2,
      sym_line_comment,
      sym_block_comment,
  [95126] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7011), 1,
      sym__line_doc_content,
    STATE(3495), 2,
      sym_line_comment,
      sym_block_comment,
  [95140] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5842), 1,
      anon_sym_RPAREN,
    STATE(3496), 2,
      sym_line_comment,
      sym_block_comment,
  [95154] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7013), 1,
      sym__line_doc_content,
    STATE(3497), 2,
      sym_line_comment,
      sym_block_comment,
  [95168] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7015), 1,
      sym_identifier,
    STATE(3498), 2,
      sym_line_comment,
      sym_block_comment,
  [95182] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7017), 1,
      aux_sym_line_comment_token2,
    STATE(3499), 2,
      sym_line_comment,
      sym_block_comment,
  [95196] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7019), 1,
      sym_raw_string_literal_content,
    STATE(3500), 2,
      sym_line_comment,
      sym_block_comment,
  [95210] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5947), 1,
      anon_sym_RBRACE,
    STATE(3501), 2,
      sym_line_comment,
      sym_block_comment,
  [95224] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7021), 1,
      anon_sym_COLON,
    STATE(3502), 2,
      sym_line_comment,
      sym_block_comment,
  [95238] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7023), 1,
      anon_sym_RPAREN,
    STATE(3503), 2,
      sym_line_comment,
      sym_block_comment,
  [95252] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7025), 1,
      anon_sym_COLON_COLON,
    STATE(3504), 2,
      sym_line_comment,
      sym_block_comment,
  [95266] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5850), 1,
      anon_sym_RPAREN,
    STATE(3505), 2,
      sym_line_comment,
      sym_block_comment,
  [95280] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7027), 1,
      sym_self,
    STATE(3506), 2,
      sym_line_comment,
      sym_block_comment,
  [95294] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7029), 1,
      anon_sym_COLON_COLON,
    STATE(3507), 2,
      sym_line_comment,
      sym_block_comment,
  [95308] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7031), 1,
      anon_sym_COLON,
    STATE(3508), 2,
      sym_line_comment,
      sym_block_comment,
  [95322] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7033), 1,
      sym_identifier,
    STATE(3509), 2,
      sym_line_comment,
      sym_block_comment,
  [95336] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7035), 1,
      anon_sym_COLON_COLON,
    STATE(3510), 2,
      sym_line_comment,
      sym_block_comment,
  [95350] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5930), 1,
      anon_sym_COLON_COLON,
    STATE(3511), 2,
      sym_line_comment,
      sym_block_comment,
  [95364] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7037), 1,
      anon_sym_SEMI,
    STATE(3512), 2,
      sym_line_comment,
      sym_block_comment,
  [95378] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7039), 1,
      anon_sym_COLON_COLON,
    STATE(3513), 2,
      sym_line_comment,
      sym_block_comment,
  [95392] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7041), 1,
      anon_sym_LBRACE,
    STATE(3514), 2,
      sym_line_comment,
      sym_block_comment,
  [95406] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6649), 1,
      anon_sym_COLON_COLON,
    STATE(3515), 2,
      sym_line_comment,
      sym_block_comment,
  [95420] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7043), 1,
      sym_identifier,
    STATE(3516), 2,
      sym_line_comment,
      sym_block_comment,
  [95434] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4487), 1,
      anon_sym_fn,
    STATE(3517), 2,
      sym_line_comment,
      sym_block_comment,
  [95448] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7045), 1,
      ts_builtin_sym_end,
    STATE(3518), 2,
      sym_line_comment,
      sym_block_comment,
  [95462] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7047), 1,
      sym_raw_string_literal_content,
    STATE(3519), 2,
      sym_line_comment,
      sym_block_comment,
  [95476] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3465), 1,
      anon_sym_COLON_COLON,
    STATE(3520), 2,
      sym_line_comment,
      sym_block_comment,
  [95490] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7049), 1,
      anon_sym_RBRACK,
    STATE(3521), 2,
      sym_line_comment,
      sym_block_comment,
  [95504] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7051), 1,
      anon_sym_COLON_COLON,
    STATE(3522), 2,
      sym_line_comment,
      sym_block_comment,
  [95518] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3889), 1,
      anon_sym_COLON_COLON,
    STATE(3523), 2,
      sym_line_comment,
      sym_block_comment,
  [95532] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7053), 1,
      anon_sym_LBRACE,
    STATE(3524), 2,
      sym_line_comment,
      sym_block_comment,
  [95546] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7055), 1,
      sym_raw_string_literal_content,
    STATE(3525), 2,
      sym_line_comment,
      sym_block_comment,
  [95560] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5155), 1,
      anon_sym_COLON_COLON,
    STATE(3526), 2,
      sym_line_comment,
      sym_block_comment,
  [95574] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7057), 1,
      anon_sym_COLON_COLON,
    STATE(3527), 2,
      sym_line_comment,
      sym_block_comment,
  [95588] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5742), 1,
      anon_sym_LBRACE,
    STATE(3528), 2,
      sym_line_comment,
      sym_block_comment,
  [95602] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5738), 1,
      anon_sym_COLON_COLON,
    STATE(3529), 2,
      sym_line_comment,
      sym_block_comment,
  [95616] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7059), 1,
      anon_sym_COLON_COLON,
    STATE(3530), 2,
      sym_line_comment,
      sym_block_comment,
  [95630] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5768), 1,
      anon_sym_LBRACE,
    STATE(3531), 2,
      sym_line_comment,
      sym_block_comment,
  [95644] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7061), 1,
      anon_sym_COLON_COLON,
    STATE(3532), 2,
      sym_line_comment,
      sym_block_comment,
  [95658] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5207), 1,
      anon_sym_COLON_COLON,
    STATE(3533), 2,
      sym_line_comment,
      sym_block_comment,
  [95672] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5133), 1,
      anon_sym_COLON_COLON,
    STATE(3534), 2,
      sym_line_comment,
      sym_block_comment,
  [95686] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4077), 1,
      anon_sym_COLON_COLON,
    STATE(3535), 2,
      sym_line_comment,
      sym_block_comment,
  [95700] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7063), 1,
      anon_sym_COLON_COLON,
    STATE(3536), 2,
      sym_line_comment,
      sym_block_comment,
  [95714] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7065), 1,
      anon_sym_SEMI,
    STATE(3537), 2,
      sym_line_comment,
      sym_block_comment,
  [95728] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7067), 1,
      sym_identifier,
    STATE(3538), 2,
      sym_line_comment,
      sym_block_comment,
  [95742] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7069), 1,
      sym_identifier,
    STATE(3539), 2,
      sym_line_comment,
      sym_block_comment,
  [95756] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7071), 1,
      anon_sym_SEMI,
    STATE(3540), 2,
      sym_line_comment,
      sym_block_comment,
  [95770] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7073), 1,
      anon_sym_COLON,
    STATE(3541), 2,
      sym_line_comment,
      sym_block_comment,
  [95784] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7075), 1,
      anon_sym_LBRACK,
    STATE(3542), 2,
      sym_line_comment,
      sym_block_comment,
  [95798] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7077), 1,
      sym_identifier,
    STATE(3543), 2,
      sym_line_comment,
      sym_block_comment,
  [95812] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7079), 1,
      anon_sym_LBRACK,
    STATE(3544), 2,
      sym_line_comment,
      sym_block_comment,
  [95826] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7081), 1,
      anon_sym_COLON,
    STATE(3545), 2,
      sym_line_comment,
      sym_block_comment,
  [95840] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7083), 1,
      anon_sym_COLON,
    STATE(3546), 2,
      sym_line_comment,
      sym_block_comment,
  [95854] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7085), 1,
      anon_sym_RPAREN,
    STATE(3547), 2,
      sym_line_comment,
      sym_block_comment,
  [95868] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6403), 1,
      anon_sym_RBRACE,
    STATE(3548), 2,
      sym_line_comment,
      sym_block_comment,
  [95882] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7087), 1,
      anon_sym_COLON,
    STATE(3549), 2,
      sym_line_comment,
      sym_block_comment,
  [95896] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5203), 1,
      anon_sym_SEMI,
    STATE(3550), 2,
      sym_line_comment,
      sym_block_comment,
  [95910] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7089), 1,
      anon_sym_COLON,
    STATE(3551), 2,
      sym_line_comment,
      sym_block_comment,
  [95924] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7091), 1,
      sym_identifier,
    STATE(3552), 2,
      sym_line_comment,
      sym_block_comment,
  [95938] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7093), 1,
      anon_sym_RBRACK,
    STATE(3553), 2,
      sym_line_comment,
      sym_block_comment,
  [95952] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7095), 1,
      sym_identifier,
    STATE(3554), 2,
      sym_line_comment,
      sym_block_comment,
  [95966] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7097), 1,
      sym_identifier,
    STATE(3555), 2,
      sym_line_comment,
      sym_block_comment,
  [95980] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7099), 1,
      anon_sym_SEMI,
    STATE(3556), 2,
      sym_line_comment,
      sym_block_comment,
  [95994] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5209), 1,
      anon_sym_SEMI,
    STATE(3557), 2,
      sym_line_comment,
      sym_block_comment,
  [96008] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7101), 1,
      sym_identifier,
    STATE(3558), 2,
      sym_line_comment,
      sym_block_comment,
  [96022] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6549), 1,
      anon_sym_SEMI,
    STATE(3559), 2,
      sym_line_comment,
      sym_block_comment,
  [96036] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7103), 1,
      anon_sym_RPAREN,
    STATE(3560), 2,
      sym_line_comment,
      sym_block_comment,
  [96050] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7105), 1,
      anon_sym_COLON,
    STATE(3561), 2,
      sym_line_comment,
      sym_block_comment,
  [96064] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7107), 1,
      sym_identifier,
    STATE(3562), 2,
      sym_line_comment,
      sym_block_comment,
  [96078] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5541), 1,
      anon_sym_RPAREN,
    STATE(3563), 2,
      sym_line_comment,
      sym_block_comment,
  [96092] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7109), 1,
      sym_identifier,
    STATE(3564), 2,
      sym_line_comment,
      sym_block_comment,
  [96106] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7111), 1,
      anon_sym_COLON,
    STATE(3565), 2,
      sym_line_comment,
      sym_block_comment,
  [96120] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7113), 1,
      anon_sym_COLON,
    STATE(3566), 2,
      sym_line_comment,
      sym_block_comment,
  [96134] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6541), 1,
      anon_sym_SEMI,
    STATE(3567), 2,
      sym_line_comment,
      sym_block_comment,
  [96148] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5922), 1,
      anon_sym_RBRACE,
    STATE(3568), 2,
      sym_line_comment,
      sym_block_comment,
  [96162] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7115), 1,
      anon_sym_SEMI,
    STATE(3569), 2,
      sym_line_comment,
      sym_block_comment,
  [96176] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4089), 1,
      anon_sym_RPAREN,
    STATE(3570), 2,
      sym_line_comment,
      sym_block_comment,
  [96190] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7117), 1,
      anon_sym_COLON,
    STATE(3571), 2,
      sym_line_comment,
      sym_block_comment,
  [96204] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7119), 1,
      anon_sym_SEMI,
    STATE(3572), 2,
      sym_line_comment,
      sym_block_comment,
  [96218] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3099), 1,
      anon_sym_PLUS,
    STATE(3573), 2,
      sym_line_comment,
      sym_block_comment,
  [96232] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7121), 1,
      anon_sym_SEMI,
    STATE(3574), 2,
      sym_line_comment,
      sym_block_comment,
  [96246] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7123), 1,
      anon_sym_LPAREN,
    STATE(3575), 2,
      sym_line_comment,
      sym_block_comment,
  [96260] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5902), 1,
      anon_sym_RBRACE,
    STATE(3576), 2,
      sym_line_comment,
      sym_block_comment,
  [96274] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(951), 1,
      anon_sym_EQ_GT,
    STATE(3577), 2,
      sym_line_comment,
      sym_block_comment,
  [96288] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7125), 1,
      anon_sym_EQ,
    STATE(3578), 2,
      sym_line_comment,
      sym_block_comment,
  [96302] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7127), 1,
      sym_identifier,
    STATE(3579), 2,
      sym_line_comment,
      sym_block_comment,
  [96316] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7129), 1,
      anon_sym_SEMI,
    STATE(3580), 2,
      sym_line_comment,
      sym_block_comment,
  [96330] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7131), 1,
      anon_sym_SEMI,
    STATE(3581), 2,
      sym_line_comment,
      sym_block_comment,
  [96344] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7133), 1,
      anon_sym_EQ,
    STATE(3582), 2,
      sym_line_comment,
      sym_block_comment,
  [96358] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7135), 1,
      anon_sym_COLON,
    STATE(3583), 2,
      sym_line_comment,
      sym_block_comment,
  [96372] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7137), 1,
      sym__raw_string_literal_end,
    STATE(3584), 2,
      sym_line_comment,
      sym_block_comment,
  [96386] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7139), 1,
      anon_sym_COLON,
    STATE(3585), 2,
      sym_line_comment,
      sym_block_comment,
  [96400] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7141), 1,
      anon_sym_LBRACK,
    STATE(3586), 2,
      sym_line_comment,
      sym_block_comment,
  [96414] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7143), 1,
      anon_sym_LBRACK,
    STATE(3587), 2,
      sym_line_comment,
      sym_block_comment,
  [96428] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7145), 1,
      anon_sym_COLON,
    STATE(3588), 2,
      sym_line_comment,
      sym_block_comment,
  [96442] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7147), 1,
      sym_identifier,
    STATE(3589), 2,
      sym_line_comment,
      sym_block_comment,
  [96456] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7149), 1,
      sym_identifier,
    STATE(3590), 2,
      sym_line_comment,
      sym_block_comment,
  [96470] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7151), 1,
      anon_sym_COLON,
    STATE(3591), 2,
      sym_line_comment,
      sym_block_comment,
  [96484] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7153), 1,
      anon_sym_COLON,
    STATE(3592), 2,
      sym_line_comment,
      sym_block_comment,
  [96498] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7155), 1,
      anon_sym_SEMI,
    STATE(3593), 2,
      sym_line_comment,
      sym_block_comment,
  [96512] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7157), 1,
      anon_sym_COLON,
    STATE(3594), 2,
      sym_line_comment,
      sym_block_comment,
  [96526] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7159), 1,
      anon_sym_COLON,
    STATE(3595), 2,
      sym_line_comment,
      sym_block_comment,
  [96540] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7161), 1,
      anon_sym_COLON,
    STATE(3596), 2,
      sym_line_comment,
      sym_block_comment,
  [96554] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7163), 1,
      anon_sym_COLON,
    STATE(3597), 2,
      sym_line_comment,
      sym_block_comment,
  [96568] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7165), 1,
      sym_identifier,
    STATE(3598), 2,
      sym_line_comment,
      sym_block_comment,
  [96582] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4511), 1,
      anon_sym_fn,
    STATE(3599), 2,
      sym_line_comment,
      sym_block_comment,
  [96596] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7167), 1,
      anon_sym_SEMI,
    STATE(3600), 2,
      sym_line_comment,
      sym_block_comment,
  [96610] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7169), 1,
      sym_identifier,
    STATE(3601), 2,
      sym_line_comment,
      sym_block_comment,
  [96624] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7171), 1,
      sym_identifier,
    STATE(3602), 2,
      sym_line_comment,
      sym_block_comment,
  [96638] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7173), 1,
      anon_sym_SEMI,
    STATE(3603), 2,
      sym_line_comment,
      sym_block_comment,
  [96652] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7175), 1,
      anon_sym_RPAREN,
    STATE(3604), 2,
      sym_line_comment,
      sym_block_comment,
  [96666] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7177), 1,
      sym_identifier,
    STATE(3605), 2,
      sym_line_comment,
      sym_block_comment,
  [96680] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7179), 1,
      anon_sym_fn,
    STATE(3606), 2,
      sym_line_comment,
      sym_block_comment,
  [96694] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7181), 1,
      sym_identifier,
    STATE(3607), 2,
      sym_line_comment,
      sym_block_comment,
  [96708] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7183), 1,
      sym_identifier,
    STATE(3608), 2,
      sym_line_comment,
      sym_block_comment,
  [96722] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7185), 1,
      sym_identifier,
    STATE(3609), 2,
      sym_line_comment,
      sym_block_comment,
  [96736] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7187), 1,
      anon_sym_SEMI,
    STATE(3610), 2,
      sym_line_comment,
      sym_block_comment,
  [96750] = 1,
    ACTIONS(7189), 1,
      ts_builtin_sym_end,
  [96754] = 1,
    ACTIONS(7191), 1,
      ts_builtin_sym_end,
  [96758] = 1,
    ACTIONS(7193), 1,
      ts_builtin_sym_end,
  [96762] = 1,
    ACTIONS(7195), 1,
      ts_builtin_sym_end,
  [96766] = 1,
    ACTIONS(7197), 1,
      ts_builtin_sym_end,
  [96770] = 1,
    ACTIONS(7199), 1,
      ts_builtin_sym_end,
  [96774] = 1,
    ACTIONS(7201), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1004)] = 0,
  [SMALL_STATE(1005)] = 75,
  [SMALL_STATE(1006)] = 150,
  [SMALL_STATE(1007)] = 224,
  [SMALL_STATE(1008)] = 294,
  [SMALL_STATE(1009)] = 363,
  [SMALL_STATE(1010)] = 462,
  [SMALL_STATE(1011)] = 561,
  [SMALL_STATE(1012)] = 638,
  [SMALL_STATE(1013)] = 712,
  [SMALL_STATE(1014)] = 786,
  [SMALL_STATE(1015)] = 860,
  [SMALL_STATE(1016)] = 923,
  [SMALL_STATE(1017)] = 986,
  [SMALL_STATE(1018)] = 1053,
  [SMALL_STATE(1019)] = 1120,
  [SMALL_STATE(1020)] = 1183,
  [SMALL_STATE(1021)] = 1254,
  [SMALL_STATE(1022)] = 1325,
  [SMALL_STATE(1023)] = 1388,
  [SMALL_STATE(1024)] = 1455,
  [SMALL_STATE(1025)] = 1518,
  [SMALL_STATE(1026)] = 1581,
  [SMALL_STATE(1027)] = 1652,
  [SMALL_STATE(1028)] = 1715,
  [SMALL_STATE(1029)] = 1782,
  [SMALL_STATE(1030)] = 1845,
  [SMALL_STATE(1031)] = 1916,
  [SMALL_STATE(1032)] = 1979,
  [SMALL_STATE(1033)] = 2041,
  [SMALL_STATE(1034)] = 2103,
  [SMALL_STATE(1035)] = 2165,
  [SMALL_STATE(1036)] = 2227,
  [SMALL_STATE(1037)] = 2289,
  [SMALL_STATE(1038)] = 2359,
  [SMALL_STATE(1039)] = 2421,
  [SMALL_STATE(1040)] = 2483,
  [SMALL_STATE(1041)] = 2545,
  [SMALL_STATE(1042)] = 2613,
  [SMALL_STATE(1043)] = 2679,
  [SMALL_STATE(1044)] = 2741,
  [SMALL_STATE(1045)] = 2840,
  [SMALL_STATE(1046)] = 2939,
  [SMALL_STATE(1047)] = 3000,
  [SMALL_STATE(1048)] = 3063,
  [SMALL_STATE(1049)] = 3128,
  [SMALL_STATE(1050)] = 3189,
  [SMALL_STATE(1051)] = 3252,
  [SMALL_STATE(1052)] = 3313,
  [SMALL_STATE(1053)] = 3374,
  [SMALL_STATE(1054)] = 3437,
  [SMALL_STATE(1055)] = 3500,
  [SMALL_STATE(1056)] = 3563,
  [SMALL_STATE(1057)] = 3624,
  [SMALL_STATE(1058)] = 3685,
  [SMALL_STATE(1059)] = 3750,
  [SMALL_STATE(1060)] = 3813,
  [SMALL_STATE(1061)] = 3876,
  [SMALL_STATE(1062)] = 3939,
  [SMALL_STATE(1063)] = 4002,
  [SMALL_STATE(1064)] = 4065,
  [SMALL_STATE(1065)] = 4128,
  [SMALL_STATE(1066)] = 4189,
  [SMALL_STATE(1067)] = 4250,
  [SMALL_STATE(1068)] = 4311,
  [SMALL_STATE(1069)] = 4372,
  [SMALL_STATE(1070)] = 4437,
  [SMALL_STATE(1071)] = 4502,
  [SMALL_STATE(1072)] = 4607,
  [SMALL_STATE(1073)] = 4670,
  [SMALL_STATE(1074)] = 4733,
  [SMALL_STATE(1075)] = 4796,
  [SMALL_STATE(1076)] = 4859,
  [SMALL_STATE(1077)] = 4920,
  [SMALL_STATE(1078)] = 4981,
  [SMALL_STATE(1079)] = 5042,
  [SMALL_STATE(1080)] = 5105,
  [SMALL_STATE(1081)] = 5210,
  [SMALL_STATE(1082)] = 5315,
  [SMALL_STATE(1083)] = 5378,
  [SMALL_STATE(1084)] = 5439,
  [SMALL_STATE(1085)] = 5500,
  [SMALL_STATE(1086)] = 5563,
  [SMALL_STATE(1087)] = 5624,
  [SMALL_STATE(1088)] = 5685,
  [SMALL_STATE(1089)] = 5790,
  [SMALL_STATE(1090)] = 5895,
  [SMALL_STATE(1091)] = 6000,
  [SMALL_STATE(1092)] = 6060,
  [SMALL_STATE(1093)] = 6120,
  [SMALL_STATE(1094)] = 6180,
  [SMALL_STATE(1095)] = 6240,
  [SMALL_STATE(1096)] = 6300,
  [SMALL_STATE(1097)] = 6360,
  [SMALL_STATE(1098)] = 6420,
  [SMALL_STATE(1099)] = 6480,
  [SMALL_STATE(1100)] = 6540,
  [SMALL_STATE(1101)] = 6600,
  [SMALL_STATE(1102)] = 6660,
  [SMALL_STATE(1103)] = 6720,
  [SMALL_STATE(1104)] = 6780,
  [SMALL_STATE(1105)] = 6840,
  [SMALL_STATE(1106)] = 6900,
  [SMALL_STATE(1107)] = 6960,
  [SMALL_STATE(1108)] = 7020,
  [SMALL_STATE(1109)] = 7080,
  [SMALL_STATE(1110)] = 7140,
  [SMALL_STATE(1111)] = 7200,
  [SMALL_STATE(1112)] = 7260,
  [SMALL_STATE(1113)] = 7320,
  [SMALL_STATE(1114)] = 7380,
  [SMALL_STATE(1115)] = 7440,
  [SMALL_STATE(1116)] = 7500,
  [SMALL_STATE(1117)] = 7560,
  [SMALL_STATE(1118)] = 7620,
  [SMALL_STATE(1119)] = 7680,
  [SMALL_STATE(1120)] = 7740,
  [SMALL_STATE(1121)] = 7800,
  [SMALL_STATE(1122)] = 7860,
  [SMALL_STATE(1123)] = 7920,
  [SMALL_STATE(1124)] = 7980,
  [SMALL_STATE(1125)] = 8040,
  [SMALL_STATE(1126)] = 8100,
  [SMALL_STATE(1127)] = 8160,
  [SMALL_STATE(1128)] = 8220,
  [SMALL_STATE(1129)] = 8280,
  [SMALL_STATE(1130)] = 8340,
  [SMALL_STATE(1131)] = 8400,
  [SMALL_STATE(1132)] = 8460,
  [SMALL_STATE(1133)] = 8520,
  [SMALL_STATE(1134)] = 8580,
  [SMALL_STATE(1135)] = 8640,
  [SMALL_STATE(1136)] = 8700,
  [SMALL_STATE(1137)] = 8760,
  [SMALL_STATE(1138)] = 8820,
  [SMALL_STATE(1139)] = 8880,
  [SMALL_STATE(1140)] = 8940,
  [SMALL_STATE(1141)] = 9000,
  [SMALL_STATE(1142)] = 9060,
  [SMALL_STATE(1143)] = 9120,
  [SMALL_STATE(1144)] = 9180,
  [SMALL_STATE(1145)] = 9240,
  [SMALL_STATE(1146)] = 9300,
  [SMALL_STATE(1147)] = 9360,
  [SMALL_STATE(1148)] = 9420,
  [SMALL_STATE(1149)] = 9480,
  [SMALL_STATE(1150)] = 9540,
  [SMALL_STATE(1151)] = 9600,
  [SMALL_STATE(1152)] = 9660,
  [SMALL_STATE(1153)] = 9720,
  [SMALL_STATE(1154)] = 9780,
  [SMALL_STATE(1155)] = 9840,
  [SMALL_STATE(1156)] = 9900,
  [SMALL_STATE(1157)] = 9960,
  [SMALL_STATE(1158)] = 10020,
  [SMALL_STATE(1159)] = 10080,
  [SMALL_STATE(1160)] = 10140,
  [SMALL_STATE(1161)] = 10200,
  [SMALL_STATE(1162)] = 10260,
  [SMALL_STATE(1163)] = 10320,
  [SMALL_STATE(1164)] = 10380,
  [SMALL_STATE(1165)] = 10440,
  [SMALL_STATE(1166)] = 10500,
  [SMALL_STATE(1167)] = 10560,
  [SMALL_STATE(1168)] = 10620,
  [SMALL_STATE(1169)] = 10680,
  [SMALL_STATE(1170)] = 10740,
  [SMALL_STATE(1171)] = 10800,
  [SMALL_STATE(1172)] = 10860,
  [SMALL_STATE(1173)] = 10920,
  [SMALL_STATE(1174)] = 10980,
  [SMALL_STATE(1175)] = 11040,
  [SMALL_STATE(1176)] = 11100,
  [SMALL_STATE(1177)] = 11160,
  [SMALL_STATE(1178)] = 11220,
  [SMALL_STATE(1179)] = 11280,
  [SMALL_STATE(1180)] = 11340,
  [SMALL_STATE(1181)] = 11400,
  [SMALL_STATE(1182)] = 11460,
  [SMALL_STATE(1183)] = 11520,
  [SMALL_STATE(1184)] = 11580,
  [SMALL_STATE(1185)] = 11640,
  [SMALL_STATE(1186)] = 11700,
  [SMALL_STATE(1187)] = 11760,
  [SMALL_STATE(1188)] = 11820,
  [SMALL_STATE(1189)] = 11880,
  [SMALL_STATE(1190)] = 11940,
  [SMALL_STATE(1191)] = 12000,
  [SMALL_STATE(1192)] = 12060,
  [SMALL_STATE(1193)] = 12120,
  [SMALL_STATE(1194)] = 12180,
  [SMALL_STATE(1195)] = 12240,
  [SMALL_STATE(1196)] = 12300,
  [SMALL_STATE(1197)] = 12360,
  [SMALL_STATE(1198)] = 12420,
  [SMALL_STATE(1199)] = 12480,
  [SMALL_STATE(1200)] = 12540,
  [SMALL_STATE(1201)] = 12600,
  [SMALL_STATE(1202)] = 12660,
  [SMALL_STATE(1203)] = 12720,
  [SMALL_STATE(1204)] = 12780,
  [SMALL_STATE(1205)] = 12840,
  [SMALL_STATE(1206)] = 12900,
  [SMALL_STATE(1207)] = 12960,
  [SMALL_STATE(1208)] = 13020,
  [SMALL_STATE(1209)] = 13080,
  [SMALL_STATE(1210)] = 13140,
  [SMALL_STATE(1211)] = 13200,
  [SMALL_STATE(1212)] = 13260,
  [SMALL_STATE(1213)] = 13320,
  [SMALL_STATE(1214)] = 13380,
  [SMALL_STATE(1215)] = 13440,
  [SMALL_STATE(1216)] = 13500,
  [SMALL_STATE(1217)] = 13560,
  [SMALL_STATE(1218)] = 13620,
  [SMALL_STATE(1219)] = 13680,
  [SMALL_STATE(1220)] = 13740,
  [SMALL_STATE(1221)] = 13800,
  [SMALL_STATE(1222)] = 13860,
  [SMALL_STATE(1223)] = 13920,
  [SMALL_STATE(1224)] = 13980,
  [SMALL_STATE(1225)] = 14040,
  [SMALL_STATE(1226)] = 14100,
  [SMALL_STATE(1227)] = 14160,
  [SMALL_STATE(1228)] = 14220,
  [SMALL_STATE(1229)] = 14280,
  [SMALL_STATE(1230)] = 14340,
  [SMALL_STATE(1231)] = 14400,
  [SMALL_STATE(1232)] = 14460,
  [SMALL_STATE(1233)] = 14520,
  [SMALL_STATE(1234)] = 14580,
  [SMALL_STATE(1235)] = 14640,
  [SMALL_STATE(1236)] = 14700,
  [SMALL_STATE(1237)] = 14760,
  [SMALL_STATE(1238)] = 14820,
  [SMALL_STATE(1239)] = 14880,
  [SMALL_STATE(1240)] = 14940,
  [SMALL_STATE(1241)] = 15000,
  [SMALL_STATE(1242)] = 15060,
  [SMALL_STATE(1243)] = 15120,
  [SMALL_STATE(1244)] = 15180,
  [SMALL_STATE(1245)] = 15240,
  [SMALL_STATE(1246)] = 15300,
  [SMALL_STATE(1247)] = 15360,
  [SMALL_STATE(1248)] = 15420,
  [SMALL_STATE(1249)] = 15480,
  [SMALL_STATE(1250)] = 15540,
  [SMALL_STATE(1251)] = 15600,
  [SMALL_STATE(1252)] = 15660,
  [SMALL_STATE(1253)] = 15720,
  [SMALL_STATE(1254)] = 15780,
  [SMALL_STATE(1255)] = 15840,
  [SMALL_STATE(1256)] = 15900,
  [SMALL_STATE(1257)] = 15960,
  [SMALL_STATE(1258)] = 16020,
  [SMALL_STATE(1259)] = 16080,
  [SMALL_STATE(1260)] = 16140,
  [SMALL_STATE(1261)] = 16200,
  [SMALL_STATE(1262)] = 16260,
  [SMALL_STATE(1263)] = 16320,
  [SMALL_STATE(1264)] = 16380,
  [SMALL_STATE(1265)] = 16440,
  [SMALL_STATE(1266)] = 16500,
  [SMALL_STATE(1267)] = 16560,
  [SMALL_STATE(1268)] = 16620,
  [SMALL_STATE(1269)] = 16680,
  [SMALL_STATE(1270)] = 16740,
  [SMALL_STATE(1271)] = 16800,
  [SMALL_STATE(1272)] = 16860,
  [SMALL_STATE(1273)] = 16920,
  [SMALL_STATE(1274)] = 16980,
  [SMALL_STATE(1275)] = 17040,
  [SMALL_STATE(1276)] = 17100,
  [SMALL_STATE(1277)] = 17160,
  [SMALL_STATE(1278)] = 17220,
  [SMALL_STATE(1279)] = 17280,
  [SMALL_STATE(1280)] = 17340,
  [SMALL_STATE(1281)] = 17400,
  [SMALL_STATE(1282)] = 17462,
  [SMALL_STATE(1283)] = 17522,
  [SMALL_STATE(1284)] = 17582,
  [SMALL_STATE(1285)] = 17642,
  [SMALL_STATE(1286)] = 17702,
  [SMALL_STATE(1287)] = 17762,
  [SMALL_STATE(1288)] = 17822,
  [SMALL_STATE(1289)] = 17882,
  [SMALL_STATE(1290)] = 17942,
  [SMALL_STATE(1291)] = 18002,
  [SMALL_STATE(1292)] = 18062,
  [SMALL_STATE(1293)] = 18122,
  [SMALL_STATE(1294)] = 18182,
  [SMALL_STATE(1295)] = 18242,
  [SMALL_STATE(1296)] = 18302,
  [SMALL_STATE(1297)] = 18362,
  [SMALL_STATE(1298)] = 18422,
  [SMALL_STATE(1299)] = 18482,
  [SMALL_STATE(1300)] = 18542,
  [SMALL_STATE(1301)] = 18602,
  [SMALL_STATE(1302)] = 18662,
  [SMALL_STATE(1303)] = 18722,
  [SMALL_STATE(1304)] = 18782,
  [SMALL_STATE(1305)] = 18842,
  [SMALL_STATE(1306)] = 18902,
  [SMALL_STATE(1307)] = 18962,
  [SMALL_STATE(1308)] = 19022,
  [SMALL_STATE(1309)] = 19082,
  [SMALL_STATE(1310)] = 19142,
  [SMALL_STATE(1311)] = 19202,
  [SMALL_STATE(1312)] = 19262,
  [SMALL_STATE(1313)] = 19322,
  [SMALL_STATE(1314)] = 19382,
  [SMALL_STATE(1315)] = 19442,
  [SMALL_STATE(1316)] = 19502,
  [SMALL_STATE(1317)] = 19562,
  [SMALL_STATE(1318)] = 19622,
  [SMALL_STATE(1319)] = 19682,
  [SMALL_STATE(1320)] = 19742,
  [SMALL_STATE(1321)] = 19802,
  [SMALL_STATE(1322)] = 19862,
  [SMALL_STATE(1323)] = 19922,
  [SMALL_STATE(1324)] = 19982,
  [SMALL_STATE(1325)] = 20042,
  [SMALL_STATE(1326)] = 20102,
  [SMALL_STATE(1327)] = 20162,
  [SMALL_STATE(1328)] = 20222,
  [SMALL_STATE(1329)] = 20314,
  [SMALL_STATE(1330)] = 20374,
  [SMALL_STATE(1331)] = 20434,
  [SMALL_STATE(1332)] = 20494,
  [SMALL_STATE(1333)] = 20554,
  [SMALL_STATE(1334)] = 20614,
  [SMALL_STATE(1335)] = 20674,
  [SMALL_STATE(1336)] = 20734,
  [SMALL_STATE(1337)] = 20794,
  [SMALL_STATE(1338)] = 20886,
  [SMALL_STATE(1339)] = 20946,
  [SMALL_STATE(1340)] = 21006,
  [SMALL_STATE(1341)] = 21066,
  [SMALL_STATE(1342)] = 21126,
  [SMALL_STATE(1343)] = 21186,
  [SMALL_STATE(1344)] = 21246,
  [SMALL_STATE(1345)] = 21306,
  [SMALL_STATE(1346)] = 21366,
  [SMALL_STATE(1347)] = 21426,
  [SMALL_STATE(1348)] = 21486,
  [SMALL_STATE(1349)] = 21546,
  [SMALL_STATE(1350)] = 21610,
  [SMALL_STATE(1351)] = 21670,
  [SMALL_STATE(1352)] = 21730,
  [SMALL_STATE(1353)] = 21790,
  [SMALL_STATE(1354)] = 21850,
  [SMALL_STATE(1355)] = 21916,
  [SMALL_STATE(1356)] = 21976,
  [SMALL_STATE(1357)] = 22036,
  [SMALL_STATE(1358)] = 22102,
  [SMALL_STATE(1359)] = 22162,
  [SMALL_STATE(1360)] = 22222,
  [SMALL_STATE(1361)] = 22282,
  [SMALL_STATE(1362)] = 22342,
  [SMALL_STATE(1363)] = 22402,
  [SMALL_STATE(1364)] = 22462,
  [SMALL_STATE(1365)] = 22522,
  [SMALL_STATE(1366)] = 22582,
  [SMALL_STATE(1367)] = 22642,
  [SMALL_STATE(1368)] = 22702,
  [SMALL_STATE(1369)] = 22762,
  [SMALL_STATE(1370)] = 22822,
  [SMALL_STATE(1371)] = 22882,
  [SMALL_STATE(1372)] = 22942,
  [SMALL_STATE(1373)] = 23002,
  [SMALL_STATE(1374)] = 23062,
  [SMALL_STATE(1375)] = 23122,
  [SMALL_STATE(1376)] = 23182,
  [SMALL_STATE(1377)] = 23242,
  [SMALL_STATE(1378)] = 23302,
  [SMALL_STATE(1379)] = 23362,
  [SMALL_STATE(1380)] = 23422,
  [SMALL_STATE(1381)] = 23482,
  [SMALL_STATE(1382)] = 23542,
  [SMALL_STATE(1383)] = 23602,
  [SMALL_STATE(1384)] = 23664,
  [SMALL_STATE(1385)] = 23724,
  [SMALL_STATE(1386)] = 23784,
  [SMALL_STATE(1387)] = 23844,
  [SMALL_STATE(1388)] = 23904,
  [SMALL_STATE(1389)] = 23964,
  [SMALL_STATE(1390)] = 24024,
  [SMALL_STATE(1391)] = 24084,
  [SMALL_STATE(1392)] = 24144,
  [SMALL_STATE(1393)] = 24204,
  [SMALL_STATE(1394)] = 24264,
  [SMALL_STATE(1395)] = 24324,
  [SMALL_STATE(1396)] = 24384,
  [SMALL_STATE(1397)] = 24444,
  [SMALL_STATE(1398)] = 24504,
  [SMALL_STATE(1399)] = 24564,
  [SMALL_STATE(1400)] = 24624,
  [SMALL_STATE(1401)] = 24684,
  [SMALL_STATE(1402)] = 24744,
  [SMALL_STATE(1403)] = 24804,
  [SMALL_STATE(1404)] = 24864,
  [SMALL_STATE(1405)] = 24924,
  [SMALL_STATE(1406)] = 24984,
  [SMALL_STATE(1407)] = 25044,
  [SMALL_STATE(1408)] = 25104,
  [SMALL_STATE(1409)] = 25164,
  [SMALL_STATE(1410)] = 25224,
  [SMALL_STATE(1411)] = 25284,
  [SMALL_STATE(1412)] = 25344,
  [SMALL_STATE(1413)] = 25404,
  [SMALL_STATE(1414)] = 25464,
  [SMALL_STATE(1415)] = 25526,
  [SMALL_STATE(1416)] = 25586,
  [SMALL_STATE(1417)] = 25646,
  [SMALL_STATE(1418)] = 25706,
  [SMALL_STATE(1419)] = 25766,
  [SMALL_STATE(1420)] = 25826,
  [SMALL_STATE(1421)] = 25886,
  [SMALL_STATE(1422)] = 25946,
  [SMALL_STATE(1423)] = 26006,
  [SMALL_STATE(1424)] = 26066,
  [SMALL_STATE(1425)] = 26126,
  [SMALL_STATE(1426)] = 26192,
  [SMALL_STATE(1427)] = 26252,
  [SMALL_STATE(1428)] = 26312,
  [SMALL_STATE(1429)] = 26372,
  [SMALL_STATE(1430)] = 26432,
  [SMALL_STATE(1431)] = 26492,
  [SMALL_STATE(1432)] = 26552,
  [SMALL_STATE(1433)] = 26612,
  [SMALL_STATE(1434)] = 26672,
  [SMALL_STATE(1435)] = 26732,
  [SMALL_STATE(1436)] = 26792,
  [SMALL_STATE(1437)] = 26852,
  [SMALL_STATE(1438)] = 26914,
  [SMALL_STATE(1439)] = 26974,
  [SMALL_STATE(1440)] = 27034,
  [SMALL_STATE(1441)] = 27102,
  [SMALL_STATE(1442)] = 27162,
  [SMALL_STATE(1443)] = 27222,
  [SMALL_STATE(1444)] = 27282,
  [SMALL_STATE(1445)] = 27342,
  [SMALL_STATE(1446)] = 27402,
  [SMALL_STATE(1447)] = 27462,
  [SMALL_STATE(1448)] = 27522,
  [SMALL_STATE(1449)] = 27582,
  [SMALL_STATE(1450)] = 27642,
  [SMALL_STATE(1451)] = 27702,
  [SMALL_STATE(1452)] = 27762,
  [SMALL_STATE(1453)] = 27822,
  [SMALL_STATE(1454)] = 27882,
  [SMALL_STATE(1455)] = 27942,
  [SMALL_STATE(1456)] = 28002,
  [SMALL_STATE(1457)] = 28062,
  [SMALL_STATE(1458)] = 28122,
  [SMALL_STATE(1459)] = 28182,
  [SMALL_STATE(1460)] = 28242,
  [SMALL_STATE(1461)] = 28302,
  [SMALL_STATE(1462)] = 28366,
  [SMALL_STATE(1463)] = 28426,
  [SMALL_STATE(1464)] = 28486,
  [SMALL_STATE(1465)] = 28546,
  [SMALL_STATE(1466)] = 28606,
  [SMALL_STATE(1467)] = 28666,
  [SMALL_STATE(1468)] = 28726,
  [SMALL_STATE(1469)] = 28786,
  [SMALL_STATE(1470)] = 28846,
  [SMALL_STATE(1471)] = 28906,
  [SMALL_STATE(1472)] = 28965,
  [SMALL_STATE(1473)] = 29026,
  [SMALL_STATE(1474)] = 29085,
  [SMALL_STATE(1475)] = 29180,
  [SMALL_STATE(1476)] = 29239,
  [SMALL_STATE(1477)] = 29298,
  [SMALL_STATE(1478)] = 29359,
  [SMALL_STATE(1479)] = 29418,
  [SMALL_STATE(1480)] = 29513,
  [SMALL_STATE(1481)] = 29572,
  [SMALL_STATE(1482)] = 29631,
  [SMALL_STATE(1483)] = 29717,
  [SMALL_STATE(1484)] = 29809,
  [SMALL_STATE(1485)] = 29881,
  [SMALL_STATE(1486)] = 29957,
  [SMALL_STATE(1487)] = 30039,
  [SMALL_STATE(1488)] = 30123,
  [SMALL_STATE(1489)] = 30213,
  [SMALL_STATE(1490)] = 30303,
  [SMALL_STATE(1491)] = 30381,
  [SMALL_STATE(1492)] = 30471,
  [SMALL_STATE(1493)] = 30561,
  [SMALL_STATE(1494)] = 30635,
  [SMALL_STATE(1495)] = 30721,
  [SMALL_STATE(1496)] = 30819,
  [SMALL_STATE(1497)] = 30917,
  [SMALL_STATE(1498)] = 31007,
  [SMALL_STATE(1499)] = 31077,
  [SMALL_STATE(1500)] = 31169,
  [SMALL_STATE(1501)] = 31237,
  [SMALL_STATE(1502)] = 31303,
  [SMALL_STATE(1503)] = 31393,
  [SMALL_STATE(1504)] = 31485,
  [SMALL_STATE(1505)] = 31583,
  [SMALL_STATE(1506)] = 31653,
  [SMALL_STATE(1507)] = 31718,
  [SMALL_STATE(1508)] = 31785,
  [SMALL_STATE(1509)] = 31852,
  [SMALL_STATE(1510)] = 31915,
  [SMALL_STATE(1511)] = 32000,
  [SMALL_STATE(1512)] = 32085,
  [SMALL_STATE(1513)] = 32152,
  [SMALL_STATE(1514)] = 32237,
  [SMALL_STATE(1515)] = 32322,
  [SMALL_STATE(1516)] = 32385,
  [SMALL_STATE(1517)] = 32443,
  [SMALL_STATE(1518)] = 32499,
  [SMALL_STATE(1519)] = 32559,
  [SMALL_STATE(1520)] = 32619,
  [SMALL_STATE(1521)] = 32677,
  [SMALL_STATE(1522)] = 32737,
  [SMALL_STATE(1523)] = 32793,
  [SMALL_STATE(1524)] = 32853,
  [SMALL_STATE(1525)] = 32913,
  [SMALL_STATE(1526)] = 32971,
  [SMALL_STATE(1527)] = 33029,
  [SMALL_STATE(1528)] = 33093,
  [SMALL_STATE(1529)] = 33149,
  [SMALL_STATE(1530)] = 33205,
  [SMALL_STATE(1531)] = 33269,
  [SMALL_STATE(1532)] = 33333,
  [SMALL_STATE(1533)] = 33397,
  [SMALL_STATE(1534)] = 33453,
  [SMALL_STATE(1535)] = 33513,
  [SMALL_STATE(1536)] = 33571,
  [SMALL_STATE(1537)] = 33629,
  [SMALL_STATE(1538)] = 33689,
  [SMALL_STATE(1539)] = 33745,
  [SMALL_STATE(1540)] = 33801,
  [SMALL_STATE(1541)] = 33857,
  [SMALL_STATE(1542)] = 33913,
  [SMALL_STATE(1543)] = 34008,
  [SMALL_STATE(1544)] = 34063,
  [SMALL_STATE(1545)] = 34118,
  [SMALL_STATE(1546)] = 34213,
  [SMALL_STATE(1547)] = 34308,
  [SMALL_STATE(1548)] = 34365,
  [SMALL_STATE(1549)] = 34420,
  [SMALL_STATE(1550)] = 34477,
  [SMALL_STATE(1551)] = 34532,
  [SMALL_STATE(1552)] = 34587,
  [SMALL_STATE(1553)] = 34646,
  [SMALL_STATE(1554)] = 34741,
  [SMALL_STATE(1555)] = 34836,
  [SMALL_STATE(1556)] = 34931,
  [SMALL_STATE(1557)] = 35026,
  [SMALL_STATE(1558)] = 35085,
  [SMALL_STATE(1559)] = 35144,
  [SMALL_STATE(1560)] = 35201,
  [SMALL_STATE(1561)] = 35256,
  [SMALL_STATE(1562)] = 35351,
  [SMALL_STATE(1563)] = 35408,
  [SMALL_STATE(1564)] = 35503,
  [SMALL_STATE(1565)] = 35560,
  [SMALL_STATE(1566)] = 35655,
  [SMALL_STATE(1567)] = 35712,
  [SMALL_STATE(1568)] = 35807,
  [SMALL_STATE(1569)] = 35862,
  [SMALL_STATE(1570)] = 35957,
  [SMALL_STATE(1571)] = 36012,
  [SMALL_STATE(1572)] = 36069,
  [SMALL_STATE(1573)] = 36128,
  [SMALL_STATE(1574)] = 36216,
  [SMALL_STATE(1575)] = 36308,
  [SMALL_STATE(1576)] = 36364,
  [SMALL_STATE(1577)] = 36418,
  [SMALL_STATE(1578)] = 36472,
  [SMALL_STATE(1579)] = 36526,
  [SMALL_STATE(1580)] = 36580,
  [SMALL_STATE(1581)] = 36634,
  [SMALL_STATE(1582)] = 36690,
  [SMALL_STATE(1583)] = 36744,
  [SMALL_STATE(1584)] = 36798,
  [SMALL_STATE(1585)] = 36852,
  [SMALL_STATE(1586)] = 36906,
  [SMALL_STATE(1587)] = 36960,
  [SMALL_STATE(1588)] = 37042,
  [SMALL_STATE(1589)] = 37096,
  [SMALL_STATE(1590)] = 37150,
  [SMALL_STATE(1591)] = 37224,
  [SMALL_STATE(1592)] = 37310,
  [SMALL_STATE(1593)] = 37396,
  [SMALL_STATE(1594)] = 37488,
  [SMALL_STATE(1595)] = 37554,
  [SMALL_STATE(1596)] = 37634,
  [SMALL_STATE(1597)] = 37712,
  [SMALL_STATE(1598)] = 37784,
  [SMALL_STATE(1599)] = 37852,
  [SMALL_STATE(1600)] = 37922,
  [SMALL_STATE(1601)] = 37986,
  [SMALL_STATE(1602)] = 38042,
  [SMALL_STATE(1603)] = 38098,
  [SMALL_STATE(1604)] = 38186,
  [SMALL_STATE(1605)] = 38242,
  [SMALL_STATE(1606)] = 38330,
  [SMALL_STATE(1607)] = 38384,
  [SMALL_STATE(1608)] = 38438,
  [SMALL_STATE(1609)] = 38524,
  [SMALL_STATE(1610)] = 38606,
  [SMALL_STATE(1611)] = 38692,
  [SMALL_STATE(1612)] = 38746,
  [SMALL_STATE(1613)] = 38834,
  [SMALL_STATE(1614)] = 38920,
  [SMALL_STATE(1615)] = 39006,
  [SMALL_STATE(1616)] = 39062,
  [SMALL_STATE(1617)] = 39118,
  [SMALL_STATE(1618)] = 39206,
  [SMALL_STATE(1619)] = 39298,
  [SMALL_STATE(1620)] = 39354,
  [SMALL_STATE(1621)] = 39410,
  [SMALL_STATE(1622)] = 39466,
  [SMALL_STATE(1623)] = 39558,
  [SMALL_STATE(1624)] = 39646,
  [SMALL_STATE(1625)] = 39734,
  [SMALL_STATE(1626)] = 39790,
  [SMALL_STATE(1627)] = 39846,
  [SMALL_STATE(1628)] = 39900,
  [SMALL_STATE(1629)] = 39992,
  [SMALL_STATE(1630)] = 40084,
  [SMALL_STATE(1631)] = 40172,
  [SMALL_STATE(1632)] = 40228,
  [SMALL_STATE(1633)] = 40284,
  [SMALL_STATE(1634)] = 40340,
  [SMALL_STATE(1635)] = 40396,
  [SMALL_STATE(1636)] = 40454,
  [SMALL_STATE(1637)] = 40507,
  [SMALL_STATE(1638)] = 40560,
  [SMALL_STATE(1639)] = 40613,
  [SMALL_STATE(1640)] = 40678,
  [SMALL_STATE(1641)] = 40765,
  [SMALL_STATE(1642)] = 40818,
  [SMALL_STATE(1643)] = 40907,
  [SMALL_STATE(1644)] = 40996,
  [SMALL_STATE(1645)] = 41085,
  [SMALL_STATE(1646)] = 41138,
  [SMALL_STATE(1647)] = 41227,
  [SMALL_STATE(1648)] = 41314,
  [SMALL_STATE(1649)] = 41403,
  [SMALL_STATE(1650)] = 41492,
  [SMALL_STATE(1651)] = 41571,
  [SMALL_STATE(1652)] = 41660,
  [SMALL_STATE(1653)] = 41713,
  [SMALL_STATE(1654)] = 41802,
  [SMALL_STATE(1655)] = 41879,
  [SMALL_STATE(1656)] = 41950,
  [SMALL_STATE(1657)] = 42039,
  [SMALL_STATE(1658)] = 42126,
  [SMALL_STATE(1659)] = 42179,
  [SMALL_STATE(1660)] = 42232,
  [SMALL_STATE(1661)] = 42285,
  [SMALL_STATE(1662)] = 42374,
  [SMALL_STATE(1663)] = 42427,
  [SMALL_STATE(1664)] = 42480,
  [SMALL_STATE(1665)] = 42547,
  [SMALL_STATE(1666)] = 42600,
  [SMALL_STATE(1667)] = 42687,
  [SMALL_STATE(1668)] = 42740,
  [SMALL_STATE(1669)] = 42827,
  [SMALL_STATE(1670)] = 42880,
  [SMALL_STATE(1671)] = 42967,
  [SMALL_STATE(1672)] = 43020,
  [SMALL_STATE(1673)] = 43073,
  [SMALL_STATE(1674)] = 43126,
  [SMALL_STATE(1675)] = 43215,
  [SMALL_STATE(1676)] = 43294,
  [SMALL_STATE(1677)] = 43363,
  [SMALL_STATE(1678)] = 43426,
  [SMALL_STATE(1679)] = 43489,
  [SMALL_STATE(1680)] = 43574,
  [SMALL_STATE(1681)] = 43627,
  [SMALL_STATE(1682)] = 43716,
  [SMALL_STATE(1683)] = 43805,
  [SMALL_STATE(1684)] = 43890,
  [SMALL_STATE(1685)] = 43979,
  [SMALL_STATE(1686)] = 44032,
  [SMALL_STATE(1687)] = 44121,
  [SMALL_STATE(1688)] = 44208,
  [SMALL_STATE(1689)] = 44297,
  [SMALL_STATE(1690)] = 44384,
  [SMALL_STATE(1691)] = 44473,
  [SMALL_STATE(1692)] = 44562,
  [SMALL_STATE(1693)] = 44649,
  [SMALL_STATE(1694)] = 44718,
  [SMALL_STATE(1695)] = 44785,
  [SMALL_STATE(1696)] = 44838,
  [SMALL_STATE(1697)] = 44923,
  [SMALL_STATE(1698)] = 44976,
  [SMALL_STATE(1699)] = 45029,
  [SMALL_STATE(1700)] = 45100,
  [SMALL_STATE(1701)] = 45153,
  [SMALL_STATE(1702)] = 45206,
  [SMALL_STATE(1703)] = 45283,
  [SMALL_STATE(1704)] = 45336,
  [SMALL_STATE(1705)] = 45389,
  [SMALL_STATE(1706)] = 45442,
  [SMALL_STATE(1707)] = 45501,
  [SMALL_STATE(1708)] = 45588,
  [SMALL_STATE(1709)] = 45647,
  [SMALL_STATE(1710)] = 45700,
  [SMALL_STATE(1711)] = 45789,
  [SMALL_STATE(1712)] = 45878,
  [SMALL_STATE(1713)] = 45965,
  [SMALL_STATE(1714)] = 46052,
  [SMALL_STATE(1715)] = 46141,
  [SMALL_STATE(1716)] = 46220,
  [SMALL_STATE(1717)] = 46273,
  [SMALL_STATE(1718)] = 46362,
  [SMALL_STATE(1719)] = 46415,
  [SMALL_STATE(1720)] = 46480,
  [SMALL_STATE(1721)] = 46569,
  [SMALL_STATE(1722)] = 46656,
  [SMALL_STATE(1723)] = 46741,
  [SMALL_STATE(1724)] = 46826,
  [SMALL_STATE(1725)] = 46915,
  [SMALL_STATE(1726)] = 46968,
  [SMALL_STATE(1727)] = 47021,
  [SMALL_STATE(1728)] = 47102,
  [SMALL_STATE(1729)] = 47187,
  [SMALL_STATE(1730)] = 47240,
  [SMALL_STATE(1731)] = 47293,
  [SMALL_STATE(1732)] = 47346,
  [SMALL_STATE(1733)] = 47431,
  [SMALL_STATE(1734)] = 47520,
  [SMALL_STATE(1735)] = 47573,
  [SMALL_STATE(1736)] = 47626,
  [SMALL_STATE(1737)] = 47679,
  [SMALL_STATE(1738)] = 47760,
  [SMALL_STATE(1739)] = 47845,
  [SMALL_STATE(1740)] = 47898,
  [SMALL_STATE(1741)] = 47983,
  [SMALL_STATE(1742)] = 48036,
  [SMALL_STATE(1743)] = 48089,
  [SMALL_STATE(1744)] = 48174,
  [SMALL_STATE(1745)] = 48263,
  [SMALL_STATE(1746)] = 48316,
  [SMALL_STATE(1747)] = 48369,
  [SMALL_STATE(1748)] = 48458,
  [SMALL_STATE(1749)] = 48511,
  [SMALL_STATE(1750)] = 48564,
  [SMALL_STATE(1751)] = 48617,
  [SMALL_STATE(1752)] = 48670,
  [SMALL_STATE(1753)] = 48723,
  [SMALL_STATE(1754)] = 48776,
  [SMALL_STATE(1755)] = 48865,
  [SMALL_STATE(1756)] = 48952,
  [SMALL_STATE(1757)] = 49041,
  [SMALL_STATE(1758)] = 49122,
  [SMALL_STATE(1759)] = 49211,
  [SMALL_STATE(1760)] = 49264,
  [SMALL_STATE(1761)] = 49353,
  [SMALL_STATE(1762)] = 49406,
  [SMALL_STATE(1763)] = 49495,
  [SMALL_STATE(1764)] = 49548,
  [SMALL_STATE(1765)] = 49621,
  [SMALL_STATE(1766)] = 49674,
  [SMALL_STATE(1767)] = 49759,
  [SMALL_STATE(1768)] = 49812,
  [SMALL_STATE(1769)] = 49865,
  [SMALL_STATE(1770)] = 49918,
  [SMALL_STATE(1771)] = 49971,
  [SMALL_STATE(1772)] = 50024,
  [SMALL_STATE(1773)] = 50077,
  [SMALL_STATE(1774)] = 50166,
  [SMALL_STATE(1775)] = 50255,
  [SMALL_STATE(1776)] = 50314,
  [SMALL_STATE(1777)] = 50367,
  [SMALL_STATE(1778)] = 50456,
  [SMALL_STATE(1779)] = 50545,
  [SMALL_STATE(1780)] = 50598,
  [SMALL_STATE(1781)] = 50651,
  [SMALL_STATE(1782)] = 50704,
  [SMALL_STATE(1783)] = 50757,
  [SMALL_STATE(1784)] = 50810,
  [SMALL_STATE(1785)] = 50863,
  [SMALL_STATE(1786)] = 50916,
  [SMALL_STATE(1787)] = 51001,
  [SMALL_STATE(1788)] = 51054,
  [SMALL_STATE(1789)] = 51107,
  [SMALL_STATE(1790)] = 51196,
  [SMALL_STATE(1791)] = 51249,
  [SMALL_STATE(1792)] = 51302,
  [SMALL_STATE(1793)] = 51355,
  [SMALL_STATE(1794)] = 51444,
  [SMALL_STATE(1795)] = 51533,
  [SMALL_STATE(1796)] = 51620,
  [SMALL_STATE(1797)] = 51673,
  [SMALL_STATE(1798)] = 51726,
  [SMALL_STATE(1799)] = 51779,
  [SMALL_STATE(1800)] = 51864,
  [SMALL_STATE(1801)] = 51917,
  [SMALL_STATE(1802)] = 51970,
  [SMALL_STATE(1803)] = 52023,
  [SMALL_STATE(1804)] = 52076,
  [SMALL_STATE(1805)] = 52163,
  [SMALL_STATE(1806)] = 52252,
  [SMALL_STATE(1807)] = 52305,
  [SMALL_STATE(1808)] = 52394,
  [SMALL_STATE(1809)] = 52447,
  [SMALL_STATE(1810)] = 52500,
  [SMALL_STATE(1811)] = 52553,
  [SMALL_STATE(1812)] = 52606,
  [SMALL_STATE(1813)] = 52693,
  [SMALL_STATE(1814)] = 52746,
  [SMALL_STATE(1815)] = 52831,
  [SMALL_STATE(1816)] = 52920,
  [SMALL_STATE(1817)] = 52973,
  [SMALL_STATE(1818)] = 53026,
  [SMALL_STATE(1819)] = 53099,
  [SMALL_STATE(1820)] = 53152,
  [SMALL_STATE(1821)] = 53205,
  [SMALL_STATE(1822)] = 53258,
  [SMALL_STATE(1823)] = 53347,
  [SMALL_STATE(1824)] = 53400,
  [SMALL_STATE(1825)] = 53489,
  [SMALL_STATE(1826)] = 53542,
  [SMALL_STATE(1827)] = 53631,
  [SMALL_STATE(1828)] = 53720,
  [SMALL_STATE(1829)] = 53773,
  [SMALL_STATE(1830)] = 53826,
  [SMALL_STATE(1831)] = 53915,
  [SMALL_STATE(1832)] = 53968,
  [SMALL_STATE(1833)] = 54021,
  [SMALL_STATE(1834)] = 54110,
  [SMALL_STATE(1835)] = 54199,
  [SMALL_STATE(1836)] = 54286,
  [SMALL_STATE(1837)] = 54339,
  [SMALL_STATE(1838)] = 54428,
  [SMALL_STATE(1839)] = 54489,
  [SMALL_STATE(1840)] = 54542,
  [SMALL_STATE(1841)] = 54629,
  [SMALL_STATE(1842)] = 54710,
  [SMALL_STATE(1843)] = 54796,
  [SMALL_STATE(1844)] = 54882,
  [SMALL_STATE(1845)] = 54968,
  [SMALL_STATE(1846)] = 55054,
  [SMALL_STATE(1847)] = 55140,
  [SMALL_STATE(1848)] = 55224,
  [SMALL_STATE(1849)] = 55310,
  [SMALL_STATE(1850)] = 55396,
  [SMALL_STATE(1851)] = 55482,
  [SMALL_STATE(1852)] = 55568,
  [SMALL_STATE(1853)] = 55654,
  [SMALL_STATE(1854)] = 55740,
  [SMALL_STATE(1855)] = 55826,
  [SMALL_STATE(1856)] = 55912,
  [SMALL_STATE(1857)] = 55998,
  [SMALL_STATE(1858)] = 56084,
  [SMALL_STATE(1859)] = 56160,
  [SMALL_STATE(1860)] = 56246,
  [SMALL_STATE(1861)] = 56332,
  [SMALL_STATE(1862)] = 56418,
  [SMALL_STATE(1863)] = 56504,
  [SMALL_STATE(1864)] = 56590,
  [SMALL_STATE(1865)] = 56676,
  [SMALL_STATE(1866)] = 56762,
  [SMALL_STATE(1867)] = 56848,
  [SMALL_STATE(1868)] = 56924,
  [SMALL_STATE(1869)] = 57010,
  [SMALL_STATE(1870)] = 57096,
  [SMALL_STATE(1871)] = 57180,
  [SMALL_STATE(1872)] = 57266,
  [SMALL_STATE(1873)] = 57352,
  [SMALL_STATE(1874)] = 57438,
  [SMALL_STATE(1875)] = 57524,
  [SMALL_STATE(1876)] = 57610,
  [SMALL_STATE(1877)] = 57683,
  [SMALL_STATE(1878)] = 57756,
  [SMALL_STATE(1879)] = 57829,
  [SMALL_STATE(1880)] = 57902,
  [SMALL_STATE(1881)] = 57975,
  [SMALL_STATE(1882)] = 58049,
  [SMALL_STATE(1883)] = 58123,
  [SMALL_STATE(1884)] = 58197,
  [SMALL_STATE(1885)] = 58271,
  [SMALL_STATE(1886)] = 58345,
  [SMALL_STATE(1887)] = 58419,
  [SMALL_STATE(1888)] = 58493,
  [SMALL_STATE(1889)] = 58567,
  [SMALL_STATE(1890)] = 58613,
  [SMALL_STATE(1891)] = 58659,
  [SMALL_STATE(1892)] = 58705,
  [SMALL_STATE(1893)] = 58766,
  [SMALL_STATE(1894)] = 58827,
  [SMALL_STATE(1895)] = 58888,
  [SMALL_STATE(1896)] = 58949,
  [SMALL_STATE(1897)] = 59010,
  [SMALL_STATE(1898)] = 59071,
  [SMALL_STATE(1899)] = 59132,
  [SMALL_STATE(1900)] = 59193,
  [SMALL_STATE(1901)] = 59251,
  [SMALL_STATE(1902)] = 59309,
  [SMALL_STATE(1903)] = 59345,
  [SMALL_STATE(1904)] = 59381,
  [SMALL_STATE(1905)] = 59429,
  [SMALL_STATE(1906)] = 59466,
  [SMALL_STATE(1907)] = 59511,
  [SMALL_STATE(1908)] = 59556,
  [SMALL_STATE(1909)] = 59593,
  [SMALL_STATE(1910)] = 59630,
  [SMALL_STATE(1911)] = 59683,
  [SMALL_STATE(1912)] = 59728,
  [SMALL_STATE(1913)] = 59765,
  [SMALL_STATE(1914)] = 59801,
  [SMALL_STATE(1915)] = 59841,
  [SMALL_STATE(1916)] = 59881,
  [SMALL_STATE(1917)] = 59921,
  [SMALL_STATE(1918)] = 59961,
  [SMALL_STATE(1919)] = 59997,
  [SMALL_STATE(1920)] = 60033,
  [SMALL_STATE(1921)] = 60069,
  [SMALL_STATE(1922)] = 60102,
  [SMALL_STATE(1923)] = 60135,
  [SMALL_STATE(1924)] = 60168,
  [SMALL_STATE(1925)] = 60201,
  [SMALL_STATE(1926)] = 60232,
  [SMALL_STATE(1927)] = 60265,
  [SMALL_STATE(1928)] = 60298,
  [SMALL_STATE(1929)] = 60331,
  [SMALL_STATE(1930)] = 60364,
  [SMALL_STATE(1931)] = 60408,
  [SMALL_STATE(1932)] = 60468,
  [SMALL_STATE(1933)] = 60528,
  [SMALL_STATE(1934)] = 60560,
  [SMALL_STATE(1935)] = 60592,
  [SMALL_STATE(1936)] = 60624,
  [SMALL_STATE(1937)] = 60670,
  [SMALL_STATE(1938)] = 60699,
  [SMALL_STATE(1939)] = 60742,
  [SMALL_STATE(1940)] = 60773,
  [SMALL_STATE(1941)] = 60826,
  [SMALL_STATE(1942)] = 60859,
  [SMALL_STATE(1943)] = 60888,
  [SMALL_STATE(1944)] = 60917,
  [SMALL_STATE(1945)] = 60950,
  [SMALL_STATE(1946)] = 61003,
  [SMALL_STATE(1947)] = 61032,
  [SMALL_STATE(1948)] = 61061,
  [SMALL_STATE(1949)] = 61092,
  [SMALL_STATE(1950)] = 61125,
  [SMALL_STATE(1951)] = 61156,
  [SMALL_STATE(1952)] = 61189,
  [SMALL_STATE(1953)] = 61218,
  [SMALL_STATE(1954)] = 61249,
  [SMALL_STATE(1955)] = 61280,
  [SMALL_STATE(1956)] = 61309,
  [SMALL_STATE(1957)] = 61340,
  [SMALL_STATE(1958)] = 61373,
  [SMALL_STATE(1959)] = 61402,
  [SMALL_STATE(1960)] = 61433,
  [SMALL_STATE(1961)] = 61462,
  [SMALL_STATE(1962)] = 61517,
  [SMALL_STATE(1963)] = 61550,
  [SMALL_STATE(1964)] = 61581,
  [SMALL_STATE(1965)] = 61622,
  [SMALL_STATE(1966)] = 61650,
  [SMALL_STATE(1967)] = 61678,
  [SMALL_STATE(1968)] = 61706,
  [SMALL_STATE(1969)] = 61734,
  [SMALL_STATE(1970)] = 61764,
  [SMALL_STATE(1971)] = 61792,
  [SMALL_STATE(1972)] = 61820,
  [SMALL_STATE(1973)] = 61848,
  [SMALL_STATE(1974)] = 61876,
  [SMALL_STATE(1975)] = 61920,
  [SMALL_STATE(1976)] = 61948,
  [SMALL_STATE(1977)] = 61976,
  [SMALL_STATE(1978)] = 62004,
  [SMALL_STATE(1979)] = 62034,
  [SMALL_STATE(1980)] = 62062,
  [SMALL_STATE(1981)] = 62090,
  [SMALL_STATE(1982)] = 62118,
  [SMALL_STATE(1983)] = 62146,
  [SMALL_STATE(1984)] = 62174,
  [SMALL_STATE(1985)] = 62202,
  [SMALL_STATE(1986)] = 62230,
  [SMALL_STATE(1987)] = 62258,
  [SMALL_STATE(1988)] = 62286,
  [SMALL_STATE(1989)] = 62314,
  [SMALL_STATE(1990)] = 62342,
  [SMALL_STATE(1991)] = 62370,
  [SMALL_STATE(1992)] = 62398,
  [SMALL_STATE(1993)] = 62426,
  [SMALL_STATE(1994)] = 62454,
  [SMALL_STATE(1995)] = 62482,
  [SMALL_STATE(1996)] = 62510,
  [SMALL_STATE(1997)] = 62538,
  [SMALL_STATE(1998)] = 62567,
  [SMALL_STATE(1999)] = 62618,
  [SMALL_STATE(2000)] = 62649,
  [SMALL_STATE(2001)] = 62684,
  [SMALL_STATE(2002)] = 62713,
  [SMALL_STATE(2003)] = 62745,
  [SMALL_STATE(2004)] = 62777,
  [SMALL_STATE(2005)] = 62809,
  [SMALL_STATE(2006)] = 62841,
  [SMALL_STATE(2007)] = 62873,
  [SMALL_STATE(2008)] = 62903,
  [SMALL_STATE(2009)] = 62931,
  [SMALL_STATE(2010)] = 62963,
  [SMALL_STATE(2011)] = 62995,
  [SMALL_STATE(2012)] = 63027,
  [SMALL_STATE(2013)] = 63071,
  [SMALL_STATE(2014)] = 63103,
  [SMALL_STATE(2015)] = 63135,
  [SMALL_STATE(2016)] = 63167,
  [SMALL_STATE(2017)] = 63199,
  [SMALL_STATE(2018)] = 63227,
  [SMALL_STATE(2019)] = 63272,
  [SMALL_STATE(2020)] = 63317,
  [SMALL_STATE(2021)] = 63362,
  [SMALL_STATE(2022)] = 63407,
  [SMALL_STATE(2023)] = 63452,
  [SMALL_STATE(2024)] = 63497,
  [SMALL_STATE(2025)] = 63542,
  [SMALL_STATE(2026)] = 63587,
  [SMALL_STATE(2027)] = 63632,
  [SMALL_STATE(2028)] = 63677,
  [SMALL_STATE(2029)] = 63722,
  [SMALL_STATE(2030)] = 63759,
  [SMALL_STATE(2031)] = 63804,
  [SMALL_STATE(2032)] = 63849,
  [SMALL_STATE(2033)] = 63894,
  [SMALL_STATE(2034)] = 63939,
  [SMALL_STATE(2035)] = 63981,
  [SMALL_STATE(2036)] = 64021,
  [SMALL_STATE(2037)] = 64049,
  [SMALL_STATE(2038)] = 64073,
  [SMALL_STATE(2039)] = 64101,
  [SMALL_STATE(2040)] = 64139,
  [SMALL_STATE(2041)] = 64169,
  [SMALL_STATE(2042)] = 64199,
  [SMALL_STATE(2043)] = 64237,
  [SMALL_STATE(2044)] = 64261,
  [SMALL_STATE(2045)] = 64289,
  [SMALL_STATE(2046)] = 64317,
  [SMALL_STATE(2047)] = 64347,
  [SMALL_STATE(2048)] = 64371,
  [SMALL_STATE(2049)] = 64395,
  [SMALL_STATE(2050)] = 64437,
  [SMALL_STATE(2051)] = 64479,
  [SMALL_STATE(2052)] = 64521,
  [SMALL_STATE(2053)] = 64563,
  [SMALL_STATE(2054)] = 64597,
  [SMALL_STATE(2055)] = 64637,
  [SMALL_STATE(2056)] = 64671,
  [SMALL_STATE(2057)] = 64699,
  [SMALL_STATE(2058)] = 64737,
  [SMALL_STATE(2059)] = 64775,
  [SMALL_STATE(2060)] = 64813,
  [SMALL_STATE(2061)] = 64837,
  [SMALL_STATE(2062)] = 64875,
  [SMALL_STATE(2063)] = 64913,
  [SMALL_STATE(2064)] = 64941,
  [SMALL_STATE(2065)] = 64979,
  [SMALL_STATE(2066)] = 65007,
  [SMALL_STATE(2067)] = 65035,
  [SMALL_STATE(2068)] = 65063,
  [SMALL_STATE(2069)] = 65091,
  [SMALL_STATE(2070)] = 65121,
  [SMALL_STATE(2071)] = 65163,
  [SMALL_STATE(2072)] = 65191,
  [SMALL_STATE(2073)] = 65231,
  [SMALL_STATE(2074)] = 65273,
  [SMALL_STATE(2075)] = 65301,
  [SMALL_STATE(2076)] = 65339,
  [SMALL_STATE(2077)] = 65380,
  [SMALL_STATE(2078)] = 65417,
  [SMALL_STATE(2079)] = 65448,
  [SMALL_STATE(2080)] = 65471,
  [SMALL_STATE(2081)] = 65494,
  [SMALL_STATE(2082)] = 65535,
  [SMALL_STATE(2083)] = 65576,
  [SMALL_STATE(2084)] = 65599,
  [SMALL_STATE(2085)] = 65622,
  [SMALL_STATE(2086)] = 65645,
  [SMALL_STATE(2087)] = 65668,
  [SMALL_STATE(2088)] = 65691,
  [SMALL_STATE(2089)] = 65714,
  [SMALL_STATE(2090)] = 65737,
  [SMALL_STATE(2091)] = 65760,
  [SMALL_STATE(2092)] = 65783,
  [SMALL_STATE(2093)] = 65806,
  [SMALL_STATE(2094)] = 65837,
  [SMALL_STATE(2095)] = 65860,
  [SMALL_STATE(2096)] = 65883,
  [SMALL_STATE(2097)] = 65906,
  [SMALL_STATE(2098)] = 65929,
  [SMALL_STATE(2099)] = 65952,
  [SMALL_STATE(2100)] = 65975,
  [SMALL_STATE(2101)] = 65998,
  [SMALL_STATE(2102)] = 66021,
  [SMALL_STATE(2103)] = 66044,
  [SMALL_STATE(2104)] = 66067,
  [SMALL_STATE(2105)] = 66090,
  [SMALL_STATE(2106)] = 66113,
  [SMALL_STATE(2107)] = 66150,
  [SMALL_STATE(2108)] = 66173,
  [SMALL_STATE(2109)] = 66196,
  [SMALL_STATE(2110)] = 66219,
  [SMALL_STATE(2111)] = 66242,
  [SMALL_STATE(2112)] = 66265,
  [SMALL_STATE(2113)] = 66288,
  [SMALL_STATE(2114)] = 66325,
  [SMALL_STATE(2115)] = 66348,
  [SMALL_STATE(2116)] = 66371,
  [SMALL_STATE(2117)] = 66394,
  [SMALL_STATE(2118)] = 66417,
  [SMALL_STATE(2119)] = 66452,
  [SMALL_STATE(2120)] = 66483,
  [SMALL_STATE(2121)] = 66506,
  [SMALL_STATE(2122)] = 66529,
  [SMALL_STATE(2123)] = 66566,
  [SMALL_STATE(2124)] = 66597,
  [SMALL_STATE(2125)] = 66632,
  [SMALL_STATE(2126)] = 66673,
  [SMALL_STATE(2127)] = 66708,
  [SMALL_STATE(2128)] = 66741,
  [SMALL_STATE(2129)] = 66775,
  [SMALL_STATE(2130)] = 66807,
  [SMALL_STATE(2131)] = 66845,
  [SMALL_STATE(2132)] = 66869,
  [SMALL_STATE(2133)] = 66907,
  [SMALL_STATE(2134)] = 66939,
  [SMALL_STATE(2135)] = 66965,
  [SMALL_STATE(2136)] = 67003,
  [SMALL_STATE(2137)] = 67035,
  [SMALL_STATE(2138)] = 67067,
  [SMALL_STATE(2139)] = 67105,
  [SMALL_STATE(2140)] = 67133,
  [SMALL_STATE(2141)] = 67171,
  [SMALL_STATE(2142)] = 67209,
  [SMALL_STATE(2143)] = 67237,
  [SMALL_STATE(2144)] = 67275,
  [SMALL_STATE(2145)] = 67303,
  [SMALL_STATE(2146)] = 67331,
  [SMALL_STATE(2147)] = 67363,
  [SMALL_STATE(2148)] = 67395,
  [SMALL_STATE(2149)] = 67433,
  [SMALL_STATE(2150)] = 67465,
  [SMALL_STATE(2151)] = 67499,
  [SMALL_STATE(2152)] = 67527,
  [SMALL_STATE(2153)] = 67563,
  [SMALL_STATE(2154)] = 67601,
  [SMALL_STATE(2155)] = 67633,
  [SMALL_STATE(2156)] = 67665,
  [SMALL_STATE(2157)] = 67689,
  [SMALL_STATE(2158)] = 67727,
  [SMALL_STATE(2159)] = 67759,
  [SMALL_STATE(2160)] = 67787,
  [SMALL_STATE(2161)] = 67815,
  [SMALL_STATE(2162)] = 67853,
  [SMALL_STATE(2163)] = 67885,
  [SMALL_STATE(2164)] = 67923,
  [SMALL_STATE(2165)] = 67961,
  [SMALL_STATE(2166)] = 67985,
  [SMALL_STATE(2167)] = 68011,
  [SMALL_STATE(2168)] = 68035,
  [SMALL_STATE(2169)] = 68061,
  [SMALL_STATE(2170)] = 68087,
  [SMALL_STATE(2171)] = 68125,
  [SMALL_STATE(2172)] = 68149,
  [SMALL_STATE(2173)] = 68187,
  [SMALL_STATE(2174)] = 68219,
  [SMALL_STATE(2175)] = 68257,
  [SMALL_STATE(2176)] = 68289,
  [SMALL_STATE(2177)] = 68324,
  [SMALL_STATE(2178)] = 68359,
  [SMALL_STATE(2179)] = 68394,
  [SMALL_STATE(2180)] = 68429,
  [SMALL_STATE(2181)] = 68464,
  [SMALL_STATE(2182)] = 68499,
  [SMALL_STATE(2183)] = 68534,
  [SMALL_STATE(2184)] = 68569,
  [SMALL_STATE(2185)] = 68604,
  [SMALL_STATE(2186)] = 68639,
  [SMALL_STATE(2187)] = 68674,
  [SMALL_STATE(2188)] = 68709,
  [SMALL_STATE(2189)] = 68744,
  [SMALL_STATE(2190)] = 68779,
  [SMALL_STATE(2191)] = 68806,
  [SMALL_STATE(2192)] = 68841,
  [SMALL_STATE(2193)] = 68874,
  [SMALL_STATE(2194)] = 68909,
  [SMALL_STATE(2195)] = 68934,
  [SMALL_STATE(2196)] = 68969,
  [SMALL_STATE(2197)] = 69004,
  [SMALL_STATE(2198)] = 69039,
  [SMALL_STATE(2199)] = 69074,
  [SMALL_STATE(2200)] = 69107,
  [SMALL_STATE(2201)] = 69142,
  [SMALL_STATE(2202)] = 69175,
  [SMALL_STATE(2203)] = 69210,
  [SMALL_STATE(2204)] = 69231,
  [SMALL_STATE(2205)] = 69266,
  [SMALL_STATE(2206)] = 69301,
  [SMALL_STATE(2207)] = 69334,
  [SMALL_STATE(2208)] = 69369,
  [SMALL_STATE(2209)] = 69394,
  [SMALL_STATE(2210)] = 69429,
  [SMALL_STATE(2211)] = 69464,
  [SMALL_STATE(2212)] = 69499,
  [SMALL_STATE(2213)] = 69534,
  [SMALL_STATE(2214)] = 69569,
  [SMALL_STATE(2215)] = 69594,
  [SMALL_STATE(2216)] = 69629,
  [SMALL_STATE(2217)] = 69662,
  [SMALL_STATE(2218)] = 69697,
  [SMALL_STATE(2219)] = 69732,
  [SMALL_STATE(2220)] = 69753,
  [SMALL_STATE(2221)] = 69788,
  [SMALL_STATE(2222)] = 69809,
  [SMALL_STATE(2223)] = 69844,
  [SMALL_STATE(2224)] = 69865,
  [SMALL_STATE(2225)] = 69894,
  [SMALL_STATE(2226)] = 69915,
  [SMALL_STATE(2227)] = 69950,
  [SMALL_STATE(2228)] = 69971,
  [SMALL_STATE(2229)] = 70006,
  [SMALL_STATE(2230)] = 70041,
  [SMALL_STATE(2231)] = 70076,
  [SMALL_STATE(2232)] = 70111,
  [SMALL_STATE(2233)] = 70143,
  [SMALL_STATE(2234)] = 70173,
  [SMALL_STATE(2235)] = 70205,
  [SMALL_STATE(2236)] = 70237,
  [SMALL_STATE(2237)] = 70269,
  [SMALL_STATE(2238)] = 70301,
  [SMALL_STATE(2239)] = 70333,
  [SMALL_STATE(2240)] = 70365,
  [SMALL_STATE(2241)] = 70397,
  [SMALL_STATE(2242)] = 70427,
  [SMALL_STATE(2243)] = 70453,
  [SMALL_STATE(2244)] = 70485,
  [SMALL_STATE(2245)] = 70507,
  [SMALL_STATE(2246)] = 70535,
  [SMALL_STATE(2247)] = 70567,
  [SMALL_STATE(2248)] = 70597,
  [SMALL_STATE(2249)] = 70625,
  [SMALL_STATE(2250)] = 70655,
  [SMALL_STATE(2251)] = 70687,
  [SMALL_STATE(2252)] = 70713,
  [SMALL_STATE(2253)] = 70741,
  [SMALL_STATE(2254)] = 70771,
  [SMALL_STATE(2255)] = 70803,
  [SMALL_STATE(2256)] = 70829,
  [SMALL_STATE(2257)] = 70857,
  [SMALL_STATE(2258)] = 70887,
  [SMALL_STATE(2259)] = 70909,
  [SMALL_STATE(2260)] = 70939,
  [SMALL_STATE(2261)] = 70969,
  [SMALL_STATE(2262)] = 71001,
  [SMALL_STATE(2263)] = 71033,
  [SMALL_STATE(2264)] = 71065,
  [SMALL_STATE(2265)] = 71087,
  [SMALL_STATE(2266)] = 71119,
  [SMALL_STATE(2267)] = 71149,
  [SMALL_STATE(2268)] = 71181,
  [SMALL_STATE(2269)] = 71213,
  [SMALL_STATE(2270)] = 71245,
  [SMALL_STATE(2271)] = 71277,
  [SMALL_STATE(2272)] = 71299,
  [SMALL_STATE(2273)] = 71331,
  [SMALL_STATE(2274)] = 71363,
  [SMALL_STATE(2275)] = 71395,
  [SMALL_STATE(2276)] = 71417,
  [SMALL_STATE(2277)] = 71449,
  [SMALL_STATE(2278)] = 71481,
  [SMALL_STATE(2279)] = 71513,
  [SMALL_STATE(2280)] = 71545,
  [SMALL_STATE(2281)] = 71577,
  [SMALL_STATE(2282)] = 71609,
  [SMALL_STATE(2283)] = 71637,
  [SMALL_STATE(2284)] = 71669,
  [SMALL_STATE(2285)] = 71699,
  [SMALL_STATE(2286)] = 71725,
  [SMALL_STATE(2287)] = 71757,
  [SMALL_STATE(2288)] = 71789,
  [SMALL_STATE(2289)] = 71811,
  [SMALL_STATE(2290)] = 71840,
  [SMALL_STATE(2291)] = 71869,
  [SMALL_STATE(2292)] = 71898,
  [SMALL_STATE(2293)] = 71927,
  [SMALL_STATE(2294)] = 71956,
  [SMALL_STATE(2295)] = 71985,
  [SMALL_STATE(2296)] = 72014,
  [SMALL_STATE(2297)] = 72043,
  [SMALL_STATE(2298)] = 72066,
  [SMALL_STATE(2299)] = 72095,
  [SMALL_STATE(2300)] = 72124,
  [SMALL_STATE(2301)] = 72153,
  [SMALL_STATE(2302)] = 72182,
  [SMALL_STATE(2303)] = 72211,
  [SMALL_STATE(2304)] = 72240,
  [SMALL_STATE(2305)] = 72269,
  [SMALL_STATE(2306)] = 72298,
  [SMALL_STATE(2307)] = 72327,
  [SMALL_STATE(2308)] = 72356,
  [SMALL_STATE(2309)] = 72379,
  [SMALL_STATE(2310)] = 72400,
  [SMALL_STATE(2311)] = 72423,
  [SMALL_STATE(2312)] = 72452,
  [SMALL_STATE(2313)] = 72475,
  [SMALL_STATE(2314)] = 72494,
  [SMALL_STATE(2315)] = 72523,
  [SMALL_STATE(2316)] = 72552,
  [SMALL_STATE(2317)] = 72581,
  [SMALL_STATE(2318)] = 72604,
  [SMALL_STATE(2319)] = 72633,
  [SMALL_STATE(2320)] = 72656,
  [SMALL_STATE(2321)] = 72677,
  [SMALL_STATE(2322)] = 72706,
  [SMALL_STATE(2323)] = 72731,
  [SMALL_STATE(2324)] = 72760,
  [SMALL_STATE(2325)] = 72785,
  [SMALL_STATE(2326)] = 72808,
  [SMALL_STATE(2327)] = 72837,
  [SMALL_STATE(2328)] = 72866,
  [SMALL_STATE(2329)] = 72895,
  [SMALL_STATE(2330)] = 72924,
  [SMALL_STATE(2331)] = 72947,
  [SMALL_STATE(2332)] = 72968,
  [SMALL_STATE(2333)] = 72997,
  [SMALL_STATE(2334)] = 73026,
  [SMALL_STATE(2335)] = 73055,
  [SMALL_STATE(2336)] = 73082,
  [SMALL_STATE(2337)] = 73111,
  [SMALL_STATE(2338)] = 73140,
  [SMALL_STATE(2339)] = 73163,
  [SMALL_STATE(2340)] = 73186,
  [SMALL_STATE(2341)] = 73209,
  [SMALL_STATE(2342)] = 73232,
  [SMALL_STATE(2343)] = 73259,
  [SMALL_STATE(2344)] = 73288,
  [SMALL_STATE(2345)] = 73317,
  [SMALL_STATE(2346)] = 73346,
  [SMALL_STATE(2347)] = 73375,
  [SMALL_STATE(2348)] = 73400,
  [SMALL_STATE(2349)] = 73429,
  [SMALL_STATE(2350)] = 73458,
  [SMALL_STATE(2351)] = 73479,
  [SMALL_STATE(2352)] = 73498,
  [SMALL_STATE(2353)] = 73527,
  [SMALL_STATE(2354)] = 73556,
  [SMALL_STATE(2355)] = 73583,
  [SMALL_STATE(2356)] = 73612,
  [SMALL_STATE(2357)] = 73641,
  [SMALL_STATE(2358)] = 73662,
  [SMALL_STATE(2359)] = 73685,
  [SMALL_STATE(2360)] = 73706,
  [SMALL_STATE(2361)] = 73731,
  [SMALL_STATE(2362)] = 73760,
  [SMALL_STATE(2363)] = 73783,
  [SMALL_STATE(2364)] = 73812,
  [SMALL_STATE(2365)] = 73833,
  [SMALL_STATE(2366)] = 73862,
  [SMALL_STATE(2367)] = 73891,
  [SMALL_STATE(2368)] = 73918,
  [SMALL_STATE(2369)] = 73947,
  [SMALL_STATE(2370)] = 73976,
  [SMALL_STATE(2371)] = 74005,
  [SMALL_STATE(2372)] = 74026,
  [SMALL_STATE(2373)] = 74055,
  [SMALL_STATE(2374)] = 74084,
  [SMALL_STATE(2375)] = 74113,
  [SMALL_STATE(2376)] = 74142,
  [SMALL_STATE(2377)] = 74171,
  [SMALL_STATE(2378)] = 74200,
  [SMALL_STATE(2379)] = 74229,
  [SMALL_STATE(2380)] = 74258,
  [SMALL_STATE(2381)] = 74285,
  [SMALL_STATE(2382)] = 74312,
  [SMALL_STATE(2383)] = 74341,
  [SMALL_STATE(2384)] = 74370,
  [SMALL_STATE(2385)] = 74399,
  [SMALL_STATE(2386)] = 74428,
  [SMALL_STATE(2387)] = 74457,
  [SMALL_STATE(2388)] = 74486,
  [SMALL_STATE(2389)] = 74512,
  [SMALL_STATE(2390)] = 74538,
  [SMALL_STATE(2391)] = 74564,
  [SMALL_STATE(2392)] = 74590,
  [SMALL_STATE(2393)] = 74608,
  [SMALL_STATE(2394)] = 74632,
  [SMALL_STATE(2395)] = 74654,
  [SMALL_STATE(2396)] = 74676,
  [SMALL_STATE(2397)] = 74702,
  [SMALL_STATE(2398)] = 74720,
  [SMALL_STATE(2399)] = 74742,
  [SMALL_STATE(2400)] = 74768,
  [SMALL_STATE(2401)] = 74790,
  [SMALL_STATE(2402)] = 74812,
  [SMALL_STATE(2403)] = 74836,
  [SMALL_STATE(2404)] = 74862,
  [SMALL_STATE(2405)] = 74888,
  [SMALL_STATE(2406)] = 74906,
  [SMALL_STATE(2407)] = 74932,
  [SMALL_STATE(2408)] = 74958,
  [SMALL_STATE(2409)] = 74980,
  [SMALL_STATE(2410)] = 74998,
  [SMALL_STATE(2411)] = 75024,
  [SMALL_STATE(2412)] = 75046,
  [SMALL_STATE(2413)] = 75072,
  [SMALL_STATE(2414)] = 75096,
  [SMALL_STATE(2415)] = 75120,
  [SMALL_STATE(2416)] = 75146,
  [SMALL_STATE(2417)] = 75172,
  [SMALL_STATE(2418)] = 75196,
  [SMALL_STATE(2419)] = 75222,
  [SMALL_STATE(2420)] = 75248,
  [SMALL_STATE(2421)] = 75270,
  [SMALL_STATE(2422)] = 75294,
  [SMALL_STATE(2423)] = 75320,
  [SMALL_STATE(2424)] = 75344,
  [SMALL_STATE(2425)] = 75370,
  [SMALL_STATE(2426)] = 75396,
  [SMALL_STATE(2427)] = 75416,
  [SMALL_STATE(2428)] = 75442,
  [SMALL_STATE(2429)] = 75468,
  [SMALL_STATE(2430)] = 75494,
  [SMALL_STATE(2431)] = 75514,
  [SMALL_STATE(2432)] = 75540,
  [SMALL_STATE(2433)] = 75566,
  [SMALL_STATE(2434)] = 75590,
  [SMALL_STATE(2435)] = 75608,
  [SMALL_STATE(2436)] = 75634,
  [SMALL_STATE(2437)] = 75658,
  [SMALL_STATE(2438)] = 75680,
  [SMALL_STATE(2439)] = 75706,
  [SMALL_STATE(2440)] = 75724,
  [SMALL_STATE(2441)] = 75742,
  [SMALL_STATE(2442)] = 75768,
  [SMALL_STATE(2443)] = 75794,
  [SMALL_STATE(2444)] = 75820,
  [SMALL_STATE(2445)] = 75846,
  [SMALL_STATE(2446)] = 75872,
  [SMALL_STATE(2447)] = 75890,
  [SMALL_STATE(2448)] = 75916,
  [SMALL_STATE(2449)] = 75934,
  [SMALL_STATE(2450)] = 75958,
  [SMALL_STATE(2451)] = 75976,
  [SMALL_STATE(2452)] = 76002,
  [SMALL_STATE(2453)] = 76020,
  [SMALL_STATE(2454)] = 76038,
  [SMALL_STATE(2455)] = 76056,
  [SMALL_STATE(2456)] = 76074,
  [SMALL_STATE(2457)] = 76098,
  [SMALL_STATE(2458)] = 76122,
  [SMALL_STATE(2459)] = 76148,
  [SMALL_STATE(2460)] = 76172,
  [SMALL_STATE(2461)] = 76198,
  [SMALL_STATE(2462)] = 76224,
  [SMALL_STATE(2463)] = 76242,
  [SMALL_STATE(2464)] = 76268,
  [SMALL_STATE(2465)] = 76286,
  [SMALL_STATE(2466)] = 76310,
  [SMALL_STATE(2467)] = 76336,
  [SMALL_STATE(2468)] = 76362,
  [SMALL_STATE(2469)] = 76388,
  [SMALL_STATE(2470)] = 76406,
  [SMALL_STATE(2471)] = 76432,
  [SMALL_STATE(2472)] = 76458,
  [SMALL_STATE(2473)] = 76480,
  [SMALL_STATE(2474)] = 76506,
  [SMALL_STATE(2475)] = 76532,
  [SMALL_STATE(2476)] = 76550,
  [SMALL_STATE(2477)] = 76568,
  [SMALL_STATE(2478)] = 76586,
  [SMALL_STATE(2479)] = 76612,
  [SMALL_STATE(2480)] = 76630,
  [SMALL_STATE(2481)] = 76648,
  [SMALL_STATE(2482)] = 76666,
  [SMALL_STATE(2483)] = 76692,
  [SMALL_STATE(2484)] = 76718,
  [SMALL_STATE(2485)] = 76738,
  [SMALL_STATE(2486)] = 76764,
  [SMALL_STATE(2487)] = 76790,
  [SMALL_STATE(2488)] = 76816,
  [SMALL_STATE(2489)] = 76834,
  [SMALL_STATE(2490)] = 76860,
  [SMALL_STATE(2491)] = 76884,
  [SMALL_STATE(2492)] = 76910,
  [SMALL_STATE(2493)] = 76936,
  [SMALL_STATE(2494)] = 76954,
  [SMALL_STATE(2495)] = 76977,
  [SMALL_STATE(2496)] = 77000,
  [SMALL_STATE(2497)] = 77023,
  [SMALL_STATE(2498)] = 77044,
  [SMALL_STATE(2499)] = 77067,
  [SMALL_STATE(2500)] = 77090,
  [SMALL_STATE(2501)] = 77113,
  [SMALL_STATE(2502)] = 77136,
  [SMALL_STATE(2503)] = 77159,
  [SMALL_STATE(2504)] = 77182,
  [SMALL_STATE(2505)] = 77205,
  [SMALL_STATE(2506)] = 77228,
  [SMALL_STATE(2507)] = 77251,
  [SMALL_STATE(2508)] = 77274,
  [SMALL_STATE(2509)] = 77297,
  [SMALL_STATE(2510)] = 77318,
  [SMALL_STATE(2511)] = 77341,
  [SMALL_STATE(2512)] = 77364,
  [SMALL_STATE(2513)] = 77387,
  [SMALL_STATE(2514)] = 77410,
  [SMALL_STATE(2515)] = 77433,
  [SMALL_STATE(2516)] = 77456,
  [SMALL_STATE(2517)] = 77479,
  [SMALL_STATE(2518)] = 77502,
  [SMALL_STATE(2519)] = 77525,
  [SMALL_STATE(2520)] = 77548,
  [SMALL_STATE(2521)] = 77571,
  [SMALL_STATE(2522)] = 77594,
  [SMALL_STATE(2523)] = 77617,
  [SMALL_STATE(2524)] = 77640,
  [SMALL_STATE(2525)] = 77663,
  [SMALL_STATE(2526)] = 77684,
  [SMALL_STATE(2527)] = 77703,
  [SMALL_STATE(2528)] = 77720,
  [SMALL_STATE(2529)] = 77743,
  [SMALL_STATE(2530)] = 77766,
  [SMALL_STATE(2531)] = 77789,
  [SMALL_STATE(2532)] = 77812,
  [SMALL_STATE(2533)] = 77835,
  [SMALL_STATE(2534)] = 77858,
  [SMALL_STATE(2535)] = 77881,
  [SMALL_STATE(2536)] = 77904,
  [SMALL_STATE(2537)] = 77927,
  [SMALL_STATE(2538)] = 77950,
  [SMALL_STATE(2539)] = 77969,
  [SMALL_STATE(2540)] = 77988,
  [SMALL_STATE(2541)] = 78005,
  [SMALL_STATE(2542)] = 78028,
  [SMALL_STATE(2543)] = 78047,
  [SMALL_STATE(2544)] = 78070,
  [SMALL_STATE(2545)] = 78093,
  [SMALL_STATE(2546)] = 78112,
  [SMALL_STATE(2547)] = 78131,
  [SMALL_STATE(2548)] = 78150,
  [SMALL_STATE(2549)] = 78173,
  [SMALL_STATE(2550)] = 78196,
  [SMALL_STATE(2551)] = 78219,
  [SMALL_STATE(2552)] = 78242,
  [SMALL_STATE(2553)] = 78265,
  [SMALL_STATE(2554)] = 78284,
  [SMALL_STATE(2555)] = 78301,
  [SMALL_STATE(2556)] = 78324,
  [SMALL_STATE(2557)] = 78347,
  [SMALL_STATE(2558)] = 78370,
  [SMALL_STATE(2559)] = 78389,
  [SMALL_STATE(2560)] = 78412,
  [SMALL_STATE(2561)] = 78431,
  [SMALL_STATE(2562)] = 78454,
  [SMALL_STATE(2563)] = 78477,
  [SMALL_STATE(2564)] = 78500,
  [SMALL_STATE(2565)] = 78523,
  [SMALL_STATE(2566)] = 78540,
  [SMALL_STATE(2567)] = 78563,
  [SMALL_STATE(2568)] = 78586,
  [SMALL_STATE(2569)] = 78609,
  [SMALL_STATE(2570)] = 78626,
  [SMALL_STATE(2571)] = 78647,
  [SMALL_STATE(2572)] = 78670,
  [SMALL_STATE(2573)] = 78693,
  [SMALL_STATE(2574)] = 78710,
  [SMALL_STATE(2575)] = 78731,
  [SMALL_STATE(2576)] = 78754,
  [SMALL_STATE(2577)] = 78777,
  [SMALL_STATE(2578)] = 78800,
  [SMALL_STATE(2579)] = 78823,
  [SMALL_STATE(2580)] = 78842,
  [SMALL_STATE(2581)] = 78865,
  [SMALL_STATE(2582)] = 78888,
  [SMALL_STATE(2583)] = 78911,
  [SMALL_STATE(2584)] = 78932,
  [SMALL_STATE(2585)] = 78955,
  [SMALL_STATE(2586)] = 78978,
  [SMALL_STATE(2587)] = 79001,
  [SMALL_STATE(2588)] = 79024,
  [SMALL_STATE(2589)] = 79047,
  [SMALL_STATE(2590)] = 79070,
  [SMALL_STATE(2591)] = 79093,
  [SMALL_STATE(2592)] = 79116,
  [SMALL_STATE(2593)] = 79137,
  [SMALL_STATE(2594)] = 79160,
  [SMALL_STATE(2595)] = 79179,
  [SMALL_STATE(2596)] = 79200,
  [SMALL_STATE(2597)] = 79223,
  [SMALL_STATE(2598)] = 79242,
  [SMALL_STATE(2599)] = 79265,
  [SMALL_STATE(2600)] = 79288,
  [SMALL_STATE(2601)] = 79311,
  [SMALL_STATE(2602)] = 79332,
  [SMALL_STATE(2603)] = 79355,
  [SMALL_STATE(2604)] = 79378,
  [SMALL_STATE(2605)] = 79401,
  [SMALL_STATE(2606)] = 79424,
  [SMALL_STATE(2607)] = 79447,
  [SMALL_STATE(2608)] = 79470,
  [SMALL_STATE(2609)] = 79493,
  [SMALL_STATE(2610)] = 79516,
  [SMALL_STATE(2611)] = 79539,
  [SMALL_STATE(2612)] = 79560,
  [SMALL_STATE(2613)] = 79581,
  [SMALL_STATE(2614)] = 79604,
  [SMALL_STATE(2615)] = 79627,
  [SMALL_STATE(2616)] = 79650,
  [SMALL_STATE(2617)] = 79673,
  [SMALL_STATE(2618)] = 79696,
  [SMALL_STATE(2619)] = 79719,
  [SMALL_STATE(2620)] = 79742,
  [SMALL_STATE(2621)] = 79765,
  [SMALL_STATE(2622)] = 79786,
  [SMALL_STATE(2623)] = 79809,
  [SMALL_STATE(2624)] = 79832,
  [SMALL_STATE(2625)] = 79853,
  [SMALL_STATE(2626)] = 79876,
  [SMALL_STATE(2627)] = 79899,
  [SMALL_STATE(2628)] = 79922,
  [SMALL_STATE(2629)] = 79941,
  [SMALL_STATE(2630)] = 79964,
  [SMALL_STATE(2631)] = 79987,
  [SMALL_STATE(2632)] = 80010,
  [SMALL_STATE(2633)] = 80033,
  [SMALL_STATE(2634)] = 80056,
  [SMALL_STATE(2635)] = 80079,
  [SMALL_STATE(2636)] = 80098,
  [SMALL_STATE(2637)] = 80121,
  [SMALL_STATE(2638)] = 80144,
  [SMALL_STATE(2639)] = 80167,
  [SMALL_STATE(2640)] = 80190,
  [SMALL_STATE(2641)] = 80213,
  [SMALL_STATE(2642)] = 80236,
  [SMALL_STATE(2643)] = 80259,
  [SMALL_STATE(2644)] = 80278,
  [SMALL_STATE(2645)] = 80301,
  [SMALL_STATE(2646)] = 80320,
  [SMALL_STATE(2647)] = 80341,
  [SMALL_STATE(2648)] = 80364,
  [SMALL_STATE(2649)] = 80385,
  [SMALL_STATE(2650)] = 80404,
  [SMALL_STATE(2651)] = 80423,
  [SMALL_STATE(2652)] = 80446,
  [SMALL_STATE(2653)] = 80469,
  [SMALL_STATE(2654)] = 80490,
  [SMALL_STATE(2655)] = 80511,
  [SMALL_STATE(2656)] = 80532,
  [SMALL_STATE(2657)] = 80555,
  [SMALL_STATE(2658)] = 80578,
  [SMALL_STATE(2659)] = 80601,
  [SMALL_STATE(2660)] = 80624,
  [SMALL_STATE(2661)] = 80643,
  [SMALL_STATE(2662)] = 80666,
  [SMALL_STATE(2663)] = 80689,
  [SMALL_STATE(2664)] = 80708,
  [SMALL_STATE(2665)] = 80729,
  [SMALL_STATE(2666)] = 80748,
  [SMALL_STATE(2667)] = 80771,
  [SMALL_STATE(2668)] = 80794,
  [SMALL_STATE(2669)] = 80817,
  [SMALL_STATE(2670)] = 80840,
  [SMALL_STATE(2671)] = 80863,
  [SMALL_STATE(2672)] = 80886,
  [SMALL_STATE(2673)] = 80909,
  [SMALL_STATE(2674)] = 80928,
  [SMALL_STATE(2675)] = 80951,
  [SMALL_STATE(2676)] = 80968,
  [SMALL_STATE(2677)] = 80989,
  [SMALL_STATE(2678)] = 81010,
  [SMALL_STATE(2679)] = 81033,
  [SMALL_STATE(2680)] = 81056,
  [SMALL_STATE(2681)] = 81075,
  [SMALL_STATE(2682)] = 81098,
  [SMALL_STATE(2683)] = 81121,
  [SMALL_STATE(2684)] = 81144,
  [SMALL_STATE(2685)] = 81167,
  [SMALL_STATE(2686)] = 81190,
  [SMALL_STATE(2687)] = 81211,
  [SMALL_STATE(2688)] = 81230,
  [SMALL_STATE(2689)] = 81251,
  [SMALL_STATE(2690)] = 81274,
  [SMALL_STATE(2691)] = 81297,
  [SMALL_STATE(2692)] = 81318,
  [SMALL_STATE(2693)] = 81341,
  [SMALL_STATE(2694)] = 81364,
  [SMALL_STATE(2695)] = 81385,
  [SMALL_STATE(2696)] = 81406,
  [SMALL_STATE(2697)] = 81429,
  [SMALL_STATE(2698)] = 81452,
  [SMALL_STATE(2699)] = 81471,
  [SMALL_STATE(2700)] = 81494,
  [SMALL_STATE(2701)] = 81517,
  [SMALL_STATE(2702)] = 81540,
  [SMALL_STATE(2703)] = 81563,
  [SMALL_STATE(2704)] = 81586,
  [SMALL_STATE(2705)] = 81609,
  [SMALL_STATE(2706)] = 81632,
  [SMALL_STATE(2707)] = 81655,
  [SMALL_STATE(2708)] = 81678,
  [SMALL_STATE(2709)] = 81701,
  [SMALL_STATE(2710)] = 81724,
  [SMALL_STATE(2711)] = 81747,
  [SMALL_STATE(2712)] = 81770,
  [SMALL_STATE(2713)] = 81793,
  [SMALL_STATE(2714)] = 81816,
  [SMALL_STATE(2715)] = 81839,
  [SMALL_STATE(2716)] = 81862,
  [SMALL_STATE(2717)] = 81879,
  [SMALL_STATE(2718)] = 81902,
  [SMALL_STATE(2719)] = 81925,
  [SMALL_STATE(2720)] = 81948,
  [SMALL_STATE(2721)] = 81971,
  [SMALL_STATE(2722)] = 81992,
  [SMALL_STATE(2723)] = 82015,
  [SMALL_STATE(2724)] = 82038,
  [SMALL_STATE(2725)] = 82061,
  [SMALL_STATE(2726)] = 82084,
  [SMALL_STATE(2727)] = 82105,
  [SMALL_STATE(2728)] = 82128,
  [SMALL_STATE(2729)] = 82151,
  [SMALL_STATE(2730)] = 82174,
  [SMALL_STATE(2731)] = 82197,
  [SMALL_STATE(2732)] = 82217,
  [SMALL_STATE(2733)] = 82237,
  [SMALL_STATE(2734)] = 82253,
  [SMALL_STATE(2735)] = 82271,
  [SMALL_STATE(2736)] = 82291,
  [SMALL_STATE(2737)] = 82307,
  [SMALL_STATE(2738)] = 82323,
  [SMALL_STATE(2739)] = 82343,
  [SMALL_STATE(2740)] = 82359,
  [SMALL_STATE(2741)] = 82375,
  [SMALL_STATE(2742)] = 82395,
  [SMALL_STATE(2743)] = 82411,
  [SMALL_STATE(2744)] = 82431,
  [SMALL_STATE(2745)] = 82451,
  [SMALL_STATE(2746)] = 82471,
  [SMALL_STATE(2747)] = 82491,
  [SMALL_STATE(2748)] = 82507,
  [SMALL_STATE(2749)] = 82527,
  [SMALL_STATE(2750)] = 82543,
  [SMALL_STATE(2751)] = 82563,
  [SMALL_STATE(2752)] = 82583,
  [SMALL_STATE(2753)] = 82603,
  [SMALL_STATE(2754)] = 82619,
  [SMALL_STATE(2755)] = 82635,
  [SMALL_STATE(2756)] = 82655,
  [SMALL_STATE(2757)] = 82673,
  [SMALL_STATE(2758)] = 82693,
  [SMALL_STATE(2759)] = 82709,
  [SMALL_STATE(2760)] = 82725,
  [SMALL_STATE(2761)] = 82741,
  [SMALL_STATE(2762)] = 82757,
  [SMALL_STATE(2763)] = 82773,
  [SMALL_STATE(2764)] = 82789,
  [SMALL_STATE(2765)] = 82807,
  [SMALL_STATE(2766)] = 82823,
  [SMALL_STATE(2767)] = 82839,
  [SMALL_STATE(2768)] = 82859,
  [SMALL_STATE(2769)] = 82879,
  [SMALL_STATE(2770)] = 82899,
  [SMALL_STATE(2771)] = 82919,
  [SMALL_STATE(2772)] = 82939,
  [SMALL_STATE(2773)] = 82959,
  [SMALL_STATE(2774)] = 82979,
  [SMALL_STATE(2775)] = 82995,
  [SMALL_STATE(2776)] = 83011,
  [SMALL_STATE(2777)] = 83029,
  [SMALL_STATE(2778)] = 83045,
  [SMALL_STATE(2779)] = 83063,
  [SMALL_STATE(2780)] = 83079,
  [SMALL_STATE(2781)] = 83099,
  [SMALL_STATE(2782)] = 83115,
  [SMALL_STATE(2783)] = 83135,
  [SMALL_STATE(2784)] = 83151,
  [SMALL_STATE(2785)] = 83171,
  [SMALL_STATE(2786)] = 83187,
  [SMALL_STATE(2787)] = 83207,
  [SMALL_STATE(2788)] = 83227,
  [SMALL_STATE(2789)] = 83247,
  [SMALL_STATE(2790)] = 83263,
  [SMALL_STATE(2791)] = 83283,
  [SMALL_STATE(2792)] = 83303,
  [SMALL_STATE(2793)] = 83319,
  [SMALL_STATE(2794)] = 83335,
  [SMALL_STATE(2795)] = 83355,
  [SMALL_STATE(2796)] = 83371,
  [SMALL_STATE(2797)] = 83387,
  [SMALL_STATE(2798)] = 83407,
  [SMALL_STATE(2799)] = 83423,
  [SMALL_STATE(2800)] = 83439,
  [SMALL_STATE(2801)] = 83459,
  [SMALL_STATE(2802)] = 83477,
  [SMALL_STATE(2803)] = 83493,
  [SMALL_STATE(2804)] = 83513,
  [SMALL_STATE(2805)] = 83529,
  [SMALL_STATE(2806)] = 83549,
  [SMALL_STATE(2807)] = 83565,
  [SMALL_STATE(2808)] = 83585,
  [SMALL_STATE(2809)] = 83601,
  [SMALL_STATE(2810)] = 83621,
  [SMALL_STATE(2811)] = 83641,
  [SMALL_STATE(2812)] = 83657,
  [SMALL_STATE(2813)] = 83677,
  [SMALL_STATE(2814)] = 83697,
  [SMALL_STATE(2815)] = 83717,
  [SMALL_STATE(2816)] = 83737,
  [SMALL_STATE(2817)] = 83757,
  [SMALL_STATE(2818)] = 83777,
  [SMALL_STATE(2819)] = 83797,
  [SMALL_STATE(2820)] = 83815,
  [SMALL_STATE(2821)] = 83833,
  [SMALL_STATE(2822)] = 83849,
  [SMALL_STATE(2823)] = 83869,
  [SMALL_STATE(2824)] = 83889,
  [SMALL_STATE(2825)] = 83909,
  [SMALL_STATE(2826)] = 83929,
  [SMALL_STATE(2827)] = 83949,
  [SMALL_STATE(2828)] = 83969,
  [SMALL_STATE(2829)] = 83989,
  [SMALL_STATE(2830)] = 84007,
  [SMALL_STATE(2831)] = 84025,
  [SMALL_STATE(2832)] = 84043,
  [SMALL_STATE(2833)] = 84063,
  [SMALL_STATE(2834)] = 84083,
  [SMALL_STATE(2835)] = 84101,
  [SMALL_STATE(2836)] = 84121,
  [SMALL_STATE(2837)] = 84141,
  [SMALL_STATE(2838)] = 84161,
  [SMALL_STATE(2839)] = 84181,
  [SMALL_STATE(2840)] = 84197,
  [SMALL_STATE(2841)] = 84217,
  [SMALL_STATE(2842)] = 84237,
  [SMALL_STATE(2843)] = 84255,
  [SMALL_STATE(2844)] = 84273,
  [SMALL_STATE(2845)] = 84289,
  [SMALL_STATE(2846)] = 84309,
  [SMALL_STATE(2847)] = 84325,
  [SMALL_STATE(2848)] = 84345,
  [SMALL_STATE(2849)] = 84361,
  [SMALL_STATE(2850)] = 84379,
  [SMALL_STATE(2851)] = 84397,
  [SMALL_STATE(2852)] = 84415,
  [SMALL_STATE(2853)] = 84435,
  [SMALL_STATE(2854)] = 84455,
  [SMALL_STATE(2855)] = 84473,
  [SMALL_STATE(2856)] = 84493,
  [SMALL_STATE(2857)] = 84509,
  [SMALL_STATE(2858)] = 84529,
  [SMALL_STATE(2859)] = 84549,
  [SMALL_STATE(2860)] = 84569,
  [SMALL_STATE(2861)] = 84589,
  [SMALL_STATE(2862)] = 84609,
  [SMALL_STATE(2863)] = 84629,
  [SMALL_STATE(2864)] = 84649,
  [SMALL_STATE(2865)] = 84667,
  [SMALL_STATE(2866)] = 84687,
  [SMALL_STATE(2867)] = 84707,
  [SMALL_STATE(2868)] = 84727,
  [SMALL_STATE(2869)] = 84747,
  [SMALL_STATE(2870)] = 84765,
  [SMALL_STATE(2871)] = 84785,
  [SMALL_STATE(2872)] = 84805,
  [SMALL_STATE(2873)] = 84825,
  [SMALL_STATE(2874)] = 84843,
  [SMALL_STATE(2875)] = 84861,
  [SMALL_STATE(2876)] = 84879,
  [SMALL_STATE(2877)] = 84899,
  [SMALL_STATE(2878)] = 84915,
  [SMALL_STATE(2879)] = 84935,
  [SMALL_STATE(2880)] = 84953,
  [SMALL_STATE(2881)] = 84971,
  [SMALL_STATE(2882)] = 84991,
  [SMALL_STATE(2883)] = 85009,
  [SMALL_STATE(2884)] = 85027,
  [SMALL_STATE(2885)] = 85045,
  [SMALL_STATE(2886)] = 85065,
  [SMALL_STATE(2887)] = 85085,
  [SMALL_STATE(2888)] = 85103,
  [SMALL_STATE(2889)] = 85123,
  [SMALL_STATE(2890)] = 85143,
  [SMALL_STATE(2891)] = 85163,
  [SMALL_STATE(2892)] = 85181,
  [SMALL_STATE(2893)] = 85201,
  [SMALL_STATE(2894)] = 85221,
  [SMALL_STATE(2895)] = 85241,
  [SMALL_STATE(2896)] = 85261,
  [SMALL_STATE(2897)] = 85281,
  [SMALL_STATE(2898)] = 85301,
  [SMALL_STATE(2899)] = 85321,
  [SMALL_STATE(2900)] = 85341,
  [SMALL_STATE(2901)] = 85361,
  [SMALL_STATE(2902)] = 85381,
  [SMALL_STATE(2903)] = 85401,
  [SMALL_STATE(2904)] = 85421,
  [SMALL_STATE(2905)] = 85441,
  [SMALL_STATE(2906)] = 85461,
  [SMALL_STATE(2907)] = 85481,
  [SMALL_STATE(2908)] = 85501,
  [SMALL_STATE(2909)] = 85521,
  [SMALL_STATE(2910)] = 85541,
  [SMALL_STATE(2911)] = 85559,
  [SMALL_STATE(2912)] = 85579,
  [SMALL_STATE(2913)] = 85597,
  [SMALL_STATE(2914)] = 85613,
  [SMALL_STATE(2915)] = 85633,
  [SMALL_STATE(2916)] = 85653,
  [SMALL_STATE(2917)] = 85673,
  [SMALL_STATE(2918)] = 85691,
  [SMALL_STATE(2919)] = 85711,
  [SMALL_STATE(2920)] = 85731,
  [SMALL_STATE(2921)] = 85751,
  [SMALL_STATE(2922)] = 85771,
  [SMALL_STATE(2923)] = 85791,
  [SMALL_STATE(2924)] = 85811,
  [SMALL_STATE(2925)] = 85831,
  [SMALL_STATE(2926)] = 85851,
  [SMALL_STATE(2927)] = 85871,
  [SMALL_STATE(2928)] = 85891,
  [SMALL_STATE(2929)] = 85911,
  [SMALL_STATE(2930)] = 85931,
  [SMALL_STATE(2931)] = 85951,
  [SMALL_STATE(2932)] = 85971,
  [SMALL_STATE(2933)] = 85991,
  [SMALL_STATE(2934)] = 86011,
  [SMALL_STATE(2935)] = 86031,
  [SMALL_STATE(2936)] = 86051,
  [SMALL_STATE(2937)] = 86071,
  [SMALL_STATE(2938)] = 86091,
  [SMALL_STATE(2939)] = 86111,
  [SMALL_STATE(2940)] = 86131,
  [SMALL_STATE(2941)] = 86151,
  [SMALL_STATE(2942)] = 86167,
  [SMALL_STATE(2943)] = 86187,
  [SMALL_STATE(2944)] = 86207,
  [SMALL_STATE(2945)] = 86227,
  [SMALL_STATE(2946)] = 86247,
  [SMALL_STATE(2947)] = 86267,
  [SMALL_STATE(2948)] = 86287,
  [SMALL_STATE(2949)] = 86305,
  [SMALL_STATE(2950)] = 86323,
  [SMALL_STATE(2951)] = 86343,
  [SMALL_STATE(2952)] = 86359,
  [SMALL_STATE(2953)] = 86379,
  [SMALL_STATE(2954)] = 86399,
  [SMALL_STATE(2955)] = 86419,
  [SMALL_STATE(2956)] = 86439,
  [SMALL_STATE(2957)] = 86459,
  [SMALL_STATE(2958)] = 86475,
  [SMALL_STATE(2959)] = 86495,
  [SMALL_STATE(2960)] = 86513,
  [SMALL_STATE(2961)] = 86531,
  [SMALL_STATE(2962)] = 86551,
  [SMALL_STATE(2963)] = 86571,
  [SMALL_STATE(2964)] = 86591,
  [SMALL_STATE(2965)] = 86611,
  [SMALL_STATE(2966)] = 86629,
  [SMALL_STATE(2967)] = 86649,
  [SMALL_STATE(2968)] = 86669,
  [SMALL_STATE(2969)] = 86689,
  [SMALL_STATE(2970)] = 86709,
  [SMALL_STATE(2971)] = 86729,
  [SMALL_STATE(2972)] = 86749,
  [SMALL_STATE(2973)] = 86769,
  [SMALL_STATE(2974)] = 86789,
  [SMALL_STATE(2975)] = 86809,
  [SMALL_STATE(2976)] = 86829,
  [SMALL_STATE(2977)] = 86849,
  [SMALL_STATE(2978)] = 86869,
  [SMALL_STATE(2979)] = 86889,
  [SMALL_STATE(2980)] = 86909,
  [SMALL_STATE(2981)] = 86929,
  [SMALL_STATE(2982)] = 86947,
  [SMALL_STATE(2983)] = 86965,
  [SMALL_STATE(2984)] = 86985,
  [SMALL_STATE(2985)] = 87005,
  [SMALL_STATE(2986)] = 87025,
  [SMALL_STATE(2987)] = 87045,
  [SMALL_STATE(2988)] = 87065,
  [SMALL_STATE(2989)] = 87083,
  [SMALL_STATE(2990)] = 87103,
  [SMALL_STATE(2991)] = 87123,
  [SMALL_STATE(2992)] = 87143,
  [SMALL_STATE(2993)] = 87163,
  [SMALL_STATE(2994)] = 87183,
  [SMALL_STATE(2995)] = 87203,
  [SMALL_STATE(2996)] = 87223,
  [SMALL_STATE(2997)] = 87241,
  [SMALL_STATE(2998)] = 87261,
  [SMALL_STATE(2999)] = 87279,
  [SMALL_STATE(3000)] = 87299,
  [SMALL_STATE(3001)] = 87319,
  [SMALL_STATE(3002)] = 87339,
  [SMALL_STATE(3003)] = 87359,
  [SMALL_STATE(3004)] = 87379,
  [SMALL_STATE(3005)] = 87399,
  [SMALL_STATE(3006)] = 87419,
  [SMALL_STATE(3007)] = 87439,
  [SMALL_STATE(3008)] = 87459,
  [SMALL_STATE(3009)] = 87477,
  [SMALL_STATE(3010)] = 87497,
  [SMALL_STATE(3011)] = 87513,
  [SMALL_STATE(3012)] = 87529,
  [SMALL_STATE(3013)] = 87549,
  [SMALL_STATE(3014)] = 87569,
  [SMALL_STATE(3015)] = 87589,
  [SMALL_STATE(3016)] = 87605,
  [SMALL_STATE(3017)] = 87621,
  [SMALL_STATE(3018)] = 87641,
  [SMALL_STATE(3019)] = 87657,
  [SMALL_STATE(3020)] = 87677,
  [SMALL_STATE(3021)] = 87697,
  [SMALL_STATE(3022)] = 87713,
  [SMALL_STATE(3023)] = 87733,
  [SMALL_STATE(3024)] = 87749,
  [SMALL_STATE(3025)] = 87769,
  [SMALL_STATE(3026)] = 87789,
  [SMALL_STATE(3027)] = 87809,
  [SMALL_STATE(3028)] = 87829,
  [SMALL_STATE(3029)] = 87845,
  [SMALL_STATE(3030)] = 87861,
  [SMALL_STATE(3031)] = 87881,
  [SMALL_STATE(3032)] = 87901,
  [SMALL_STATE(3033)] = 87921,
  [SMALL_STATE(3034)] = 87938,
  [SMALL_STATE(3035)] = 87955,
  [SMALL_STATE(3036)] = 87972,
  [SMALL_STATE(3037)] = 87989,
  [SMALL_STATE(3038)] = 88006,
  [SMALL_STATE(3039)] = 88023,
  [SMALL_STATE(3040)] = 88040,
  [SMALL_STATE(3041)] = 88057,
  [SMALL_STATE(3042)] = 88074,
  [SMALL_STATE(3043)] = 88089,
  [SMALL_STATE(3044)] = 88106,
  [SMALL_STATE(3045)] = 88123,
  [SMALL_STATE(3046)] = 88140,
  [SMALL_STATE(3047)] = 88157,
  [SMALL_STATE(3048)] = 88174,
  [SMALL_STATE(3049)] = 88191,
  [SMALL_STATE(3050)] = 88208,
  [SMALL_STATE(3051)] = 88225,
  [SMALL_STATE(3052)] = 88242,
  [SMALL_STATE(3053)] = 88259,
  [SMALL_STATE(3054)] = 88276,
  [SMALL_STATE(3055)] = 88293,
  [SMALL_STATE(3056)] = 88310,
  [SMALL_STATE(3057)] = 88327,
  [SMALL_STATE(3058)] = 88344,
  [SMALL_STATE(3059)] = 88361,
  [SMALL_STATE(3060)] = 88378,
  [SMALL_STATE(3061)] = 88393,
  [SMALL_STATE(3062)] = 88410,
  [SMALL_STATE(3063)] = 88427,
  [SMALL_STATE(3064)] = 88444,
  [SMALL_STATE(3065)] = 88461,
  [SMALL_STATE(3066)] = 88478,
  [SMALL_STATE(3067)] = 88495,
  [SMALL_STATE(3068)] = 88512,
  [SMALL_STATE(3069)] = 88529,
  [SMALL_STATE(3070)] = 88546,
  [SMALL_STATE(3071)] = 88561,
  [SMALL_STATE(3072)] = 88578,
  [SMALL_STATE(3073)] = 88595,
  [SMALL_STATE(3074)] = 88612,
  [SMALL_STATE(3075)] = 88629,
  [SMALL_STATE(3076)] = 88646,
  [SMALL_STATE(3077)] = 88663,
  [SMALL_STATE(3078)] = 88680,
  [SMALL_STATE(3079)] = 88697,
  [SMALL_STATE(3080)] = 88712,
  [SMALL_STATE(3081)] = 88729,
  [SMALL_STATE(3082)] = 88746,
  [SMALL_STATE(3083)] = 88763,
  [SMALL_STATE(3084)] = 88780,
  [SMALL_STATE(3085)] = 88797,
  [SMALL_STATE(3086)] = 88812,
  [SMALL_STATE(3087)] = 88829,
  [SMALL_STATE(3088)] = 88846,
  [SMALL_STATE(3089)] = 88861,
  [SMALL_STATE(3090)] = 88878,
  [SMALL_STATE(3091)] = 88895,
  [SMALL_STATE(3092)] = 88912,
  [SMALL_STATE(3093)] = 88929,
  [SMALL_STATE(3094)] = 88944,
  [SMALL_STATE(3095)] = 88961,
  [SMALL_STATE(3096)] = 88978,
  [SMALL_STATE(3097)] = 88993,
  [SMALL_STATE(3098)] = 89010,
  [SMALL_STATE(3099)] = 89025,
  [SMALL_STATE(3100)] = 89042,
  [SMALL_STATE(3101)] = 89059,
  [SMALL_STATE(3102)] = 89076,
  [SMALL_STATE(3103)] = 89093,
  [SMALL_STATE(3104)] = 89110,
  [SMALL_STATE(3105)] = 89127,
  [SMALL_STATE(3106)] = 89142,
  [SMALL_STATE(3107)] = 89157,
  [SMALL_STATE(3108)] = 89172,
  [SMALL_STATE(3109)] = 89189,
  [SMALL_STATE(3110)] = 89206,
  [SMALL_STATE(3111)] = 89223,
  [SMALL_STATE(3112)] = 89240,
  [SMALL_STATE(3113)] = 89257,
  [SMALL_STATE(3114)] = 89274,
  [SMALL_STATE(3115)] = 89291,
  [SMALL_STATE(3116)] = 89306,
  [SMALL_STATE(3117)] = 89323,
  [SMALL_STATE(3118)] = 89340,
  [SMALL_STATE(3119)] = 89355,
  [SMALL_STATE(3120)] = 89370,
  [SMALL_STATE(3121)] = 89387,
  [SMALL_STATE(3122)] = 89402,
  [SMALL_STATE(3123)] = 89419,
  [SMALL_STATE(3124)] = 89436,
  [SMALL_STATE(3125)] = 89453,
  [SMALL_STATE(3126)] = 89468,
  [SMALL_STATE(3127)] = 89483,
  [SMALL_STATE(3128)] = 89498,
  [SMALL_STATE(3129)] = 89515,
  [SMALL_STATE(3130)] = 89532,
  [SMALL_STATE(3131)] = 89549,
  [SMALL_STATE(3132)] = 89566,
  [SMALL_STATE(3133)] = 89583,
  [SMALL_STATE(3134)] = 89600,
  [SMALL_STATE(3135)] = 89617,
  [SMALL_STATE(3136)] = 89634,
  [SMALL_STATE(3137)] = 89651,
  [SMALL_STATE(3138)] = 89668,
  [SMALL_STATE(3139)] = 89685,
  [SMALL_STATE(3140)] = 89702,
  [SMALL_STATE(3141)] = 89717,
  [SMALL_STATE(3142)] = 89734,
  [SMALL_STATE(3143)] = 89749,
  [SMALL_STATE(3144)] = 89766,
  [SMALL_STATE(3145)] = 89783,
  [SMALL_STATE(3146)] = 89800,
  [SMALL_STATE(3147)] = 89817,
  [SMALL_STATE(3148)] = 89834,
  [SMALL_STATE(3149)] = 89851,
  [SMALL_STATE(3150)] = 89868,
  [SMALL_STATE(3151)] = 89883,
  [SMALL_STATE(3152)] = 89900,
  [SMALL_STATE(3153)] = 89917,
  [SMALL_STATE(3154)] = 89934,
  [SMALL_STATE(3155)] = 89949,
  [SMALL_STATE(3156)] = 89966,
  [SMALL_STATE(3157)] = 89983,
  [SMALL_STATE(3158)] = 90000,
  [SMALL_STATE(3159)] = 90017,
  [SMALL_STATE(3160)] = 90034,
  [SMALL_STATE(3161)] = 90051,
  [SMALL_STATE(3162)] = 90068,
  [SMALL_STATE(3163)] = 90083,
  [SMALL_STATE(3164)] = 90098,
  [SMALL_STATE(3165)] = 90115,
  [SMALL_STATE(3166)] = 90132,
  [SMALL_STATE(3167)] = 90149,
  [SMALL_STATE(3168)] = 90166,
  [SMALL_STATE(3169)] = 90183,
  [SMALL_STATE(3170)] = 90200,
  [SMALL_STATE(3171)] = 90217,
  [SMALL_STATE(3172)] = 90232,
  [SMALL_STATE(3173)] = 90249,
  [SMALL_STATE(3174)] = 90266,
  [SMALL_STATE(3175)] = 90281,
  [SMALL_STATE(3176)] = 90298,
  [SMALL_STATE(3177)] = 90315,
  [SMALL_STATE(3178)] = 90332,
  [SMALL_STATE(3179)] = 90349,
  [SMALL_STATE(3180)] = 90366,
  [SMALL_STATE(3181)] = 90383,
  [SMALL_STATE(3182)] = 90400,
  [SMALL_STATE(3183)] = 90417,
  [SMALL_STATE(3184)] = 90434,
  [SMALL_STATE(3185)] = 90451,
  [SMALL_STATE(3186)] = 90468,
  [SMALL_STATE(3187)] = 90483,
  [SMALL_STATE(3188)] = 90500,
  [SMALL_STATE(3189)] = 90517,
  [SMALL_STATE(3190)] = 90534,
  [SMALL_STATE(3191)] = 90551,
  [SMALL_STATE(3192)] = 90568,
  [SMALL_STATE(3193)] = 90585,
  [SMALL_STATE(3194)] = 90602,
  [SMALL_STATE(3195)] = 90619,
  [SMALL_STATE(3196)] = 90636,
  [SMALL_STATE(3197)] = 90653,
  [SMALL_STATE(3198)] = 90670,
  [SMALL_STATE(3199)] = 90687,
  [SMALL_STATE(3200)] = 90704,
  [SMALL_STATE(3201)] = 90721,
  [SMALL_STATE(3202)] = 90736,
  [SMALL_STATE(3203)] = 90753,
  [SMALL_STATE(3204)] = 90770,
  [SMALL_STATE(3205)] = 90787,
  [SMALL_STATE(3206)] = 90804,
  [SMALL_STATE(3207)] = 90821,
  [SMALL_STATE(3208)] = 90836,
  [SMALL_STATE(3209)] = 90853,
  [SMALL_STATE(3210)] = 90870,
  [SMALL_STATE(3211)] = 90887,
  [SMALL_STATE(3212)] = 90904,
  [SMALL_STATE(3213)] = 90921,
  [SMALL_STATE(3214)] = 90936,
  [SMALL_STATE(3215)] = 90953,
  [SMALL_STATE(3216)] = 90968,
  [SMALL_STATE(3217)] = 90985,
  [SMALL_STATE(3218)] = 91002,
  [SMALL_STATE(3219)] = 91019,
  [SMALL_STATE(3220)] = 91036,
  [SMALL_STATE(3221)] = 91053,
  [SMALL_STATE(3222)] = 91070,
  [SMALL_STATE(3223)] = 91087,
  [SMALL_STATE(3224)] = 91104,
  [SMALL_STATE(3225)] = 91119,
  [SMALL_STATE(3226)] = 91134,
  [SMALL_STATE(3227)] = 91151,
  [SMALL_STATE(3228)] = 91168,
  [SMALL_STATE(3229)] = 91185,
  [SMALL_STATE(3230)] = 91202,
  [SMALL_STATE(3231)] = 91219,
  [SMALL_STATE(3232)] = 91236,
  [SMALL_STATE(3233)] = 91253,
  [SMALL_STATE(3234)] = 91270,
  [SMALL_STATE(3235)] = 91287,
  [SMALL_STATE(3236)] = 91304,
  [SMALL_STATE(3237)] = 91321,
  [SMALL_STATE(3238)] = 91338,
  [SMALL_STATE(3239)] = 91355,
  [SMALL_STATE(3240)] = 91372,
  [SMALL_STATE(3241)] = 91389,
  [SMALL_STATE(3242)] = 91404,
  [SMALL_STATE(3243)] = 91421,
  [SMALL_STATE(3244)] = 91438,
  [SMALL_STATE(3245)] = 91455,
  [SMALL_STATE(3246)] = 91472,
  [SMALL_STATE(3247)] = 91489,
  [SMALL_STATE(3248)] = 91506,
  [SMALL_STATE(3249)] = 91523,
  [SMALL_STATE(3250)] = 91538,
  [SMALL_STATE(3251)] = 91555,
  [SMALL_STATE(3252)] = 91572,
  [SMALL_STATE(3253)] = 91589,
  [SMALL_STATE(3254)] = 91606,
  [SMALL_STATE(3255)] = 91623,
  [SMALL_STATE(3256)] = 91640,
  [SMALL_STATE(3257)] = 91657,
  [SMALL_STATE(3258)] = 91674,
  [SMALL_STATE(3259)] = 91691,
  [SMALL_STATE(3260)] = 91706,
  [SMALL_STATE(3261)] = 91721,
  [SMALL_STATE(3262)] = 91736,
  [SMALL_STATE(3263)] = 91751,
  [SMALL_STATE(3264)] = 91768,
  [SMALL_STATE(3265)] = 91785,
  [SMALL_STATE(3266)] = 91802,
  [SMALL_STATE(3267)] = 91819,
  [SMALL_STATE(3268)] = 91834,
  [SMALL_STATE(3269)] = 91851,
  [SMALL_STATE(3270)] = 91868,
  [SMALL_STATE(3271)] = 91885,
  [SMALL_STATE(3272)] = 91902,
  [SMALL_STATE(3273)] = 91917,
  [SMALL_STATE(3274)] = 91934,
  [SMALL_STATE(3275)] = 91951,
  [SMALL_STATE(3276)] = 91966,
  [SMALL_STATE(3277)] = 91983,
  [SMALL_STATE(3278)] = 91998,
  [SMALL_STATE(3279)] = 92015,
  [SMALL_STATE(3280)] = 92032,
  [SMALL_STATE(3281)] = 92049,
  [SMALL_STATE(3282)] = 92066,
  [SMALL_STATE(3283)] = 92081,
  [SMALL_STATE(3284)] = 92098,
  [SMALL_STATE(3285)] = 92115,
  [SMALL_STATE(3286)] = 92130,
  [SMALL_STATE(3287)] = 92147,
  [SMALL_STATE(3288)] = 92164,
  [SMALL_STATE(3289)] = 92181,
  [SMALL_STATE(3290)] = 92198,
  [SMALL_STATE(3291)] = 92215,
  [SMALL_STATE(3292)] = 92232,
  [SMALL_STATE(3293)] = 92249,
  [SMALL_STATE(3294)] = 92266,
  [SMALL_STATE(3295)] = 92283,
  [SMALL_STATE(3296)] = 92300,
  [SMALL_STATE(3297)] = 92317,
  [SMALL_STATE(3298)] = 92334,
  [SMALL_STATE(3299)] = 92351,
  [SMALL_STATE(3300)] = 92368,
  [SMALL_STATE(3301)] = 92385,
  [SMALL_STATE(3302)] = 92402,
  [SMALL_STATE(3303)] = 92417,
  [SMALL_STATE(3304)] = 92434,
  [SMALL_STATE(3305)] = 92449,
  [SMALL_STATE(3306)] = 92466,
  [SMALL_STATE(3307)] = 92483,
  [SMALL_STATE(3308)] = 92498,
  [SMALL_STATE(3309)] = 92515,
  [SMALL_STATE(3310)] = 92532,
  [SMALL_STATE(3311)] = 92547,
  [SMALL_STATE(3312)] = 92564,
  [SMALL_STATE(3313)] = 92578,
  [SMALL_STATE(3314)] = 92592,
  [SMALL_STATE(3315)] = 92606,
  [SMALL_STATE(3316)] = 92620,
  [SMALL_STATE(3317)] = 92634,
  [SMALL_STATE(3318)] = 92648,
  [SMALL_STATE(3319)] = 92662,
  [SMALL_STATE(3320)] = 92676,
  [SMALL_STATE(3321)] = 92690,
  [SMALL_STATE(3322)] = 92704,
  [SMALL_STATE(3323)] = 92718,
  [SMALL_STATE(3324)] = 92732,
  [SMALL_STATE(3325)] = 92746,
  [SMALL_STATE(3326)] = 92760,
  [SMALL_STATE(3327)] = 92774,
  [SMALL_STATE(3328)] = 92788,
  [SMALL_STATE(3329)] = 92802,
  [SMALL_STATE(3330)] = 92816,
  [SMALL_STATE(3331)] = 92830,
  [SMALL_STATE(3332)] = 92844,
  [SMALL_STATE(3333)] = 92858,
  [SMALL_STATE(3334)] = 92872,
  [SMALL_STATE(3335)] = 92886,
  [SMALL_STATE(3336)] = 92900,
  [SMALL_STATE(3337)] = 92914,
  [SMALL_STATE(3338)] = 92928,
  [SMALL_STATE(3339)] = 92942,
  [SMALL_STATE(3340)] = 92956,
  [SMALL_STATE(3341)] = 92970,
  [SMALL_STATE(3342)] = 92984,
  [SMALL_STATE(3343)] = 92998,
  [SMALL_STATE(3344)] = 93012,
  [SMALL_STATE(3345)] = 93026,
  [SMALL_STATE(3346)] = 93040,
  [SMALL_STATE(3347)] = 93054,
  [SMALL_STATE(3348)] = 93068,
  [SMALL_STATE(3349)] = 93082,
  [SMALL_STATE(3350)] = 93096,
  [SMALL_STATE(3351)] = 93110,
  [SMALL_STATE(3352)] = 93124,
  [SMALL_STATE(3353)] = 93138,
  [SMALL_STATE(3354)] = 93152,
  [SMALL_STATE(3355)] = 93166,
  [SMALL_STATE(3356)] = 93180,
  [SMALL_STATE(3357)] = 93194,
  [SMALL_STATE(3358)] = 93208,
  [SMALL_STATE(3359)] = 93222,
  [SMALL_STATE(3360)] = 93236,
  [SMALL_STATE(3361)] = 93250,
  [SMALL_STATE(3362)] = 93264,
  [SMALL_STATE(3363)] = 93278,
  [SMALL_STATE(3364)] = 93292,
  [SMALL_STATE(3365)] = 93306,
  [SMALL_STATE(3366)] = 93320,
  [SMALL_STATE(3367)] = 93334,
  [SMALL_STATE(3368)] = 93348,
  [SMALL_STATE(3369)] = 93362,
  [SMALL_STATE(3370)] = 93376,
  [SMALL_STATE(3371)] = 93390,
  [SMALL_STATE(3372)] = 93404,
  [SMALL_STATE(3373)] = 93418,
  [SMALL_STATE(3374)] = 93432,
  [SMALL_STATE(3375)] = 93446,
  [SMALL_STATE(3376)] = 93460,
  [SMALL_STATE(3377)] = 93474,
  [SMALL_STATE(3378)] = 93488,
  [SMALL_STATE(3379)] = 93502,
  [SMALL_STATE(3380)] = 93516,
  [SMALL_STATE(3381)] = 93530,
  [SMALL_STATE(3382)] = 93544,
  [SMALL_STATE(3383)] = 93558,
  [SMALL_STATE(3384)] = 93572,
  [SMALL_STATE(3385)] = 93586,
  [SMALL_STATE(3386)] = 93600,
  [SMALL_STATE(3387)] = 93614,
  [SMALL_STATE(3388)] = 93628,
  [SMALL_STATE(3389)] = 93642,
  [SMALL_STATE(3390)] = 93656,
  [SMALL_STATE(3391)] = 93670,
  [SMALL_STATE(3392)] = 93684,
  [SMALL_STATE(3393)] = 93698,
  [SMALL_STATE(3394)] = 93712,
  [SMALL_STATE(3395)] = 93726,
  [SMALL_STATE(3396)] = 93740,
  [SMALL_STATE(3397)] = 93754,
  [SMALL_STATE(3398)] = 93768,
  [SMALL_STATE(3399)] = 93782,
  [SMALL_STATE(3400)] = 93796,
  [SMALL_STATE(3401)] = 93810,
  [SMALL_STATE(3402)] = 93824,
  [SMALL_STATE(3403)] = 93838,
  [SMALL_STATE(3404)] = 93852,
  [SMALL_STATE(3405)] = 93866,
  [SMALL_STATE(3406)] = 93880,
  [SMALL_STATE(3407)] = 93894,
  [SMALL_STATE(3408)] = 93908,
  [SMALL_STATE(3409)] = 93922,
  [SMALL_STATE(3410)] = 93936,
  [SMALL_STATE(3411)] = 93950,
  [SMALL_STATE(3412)] = 93964,
  [SMALL_STATE(3413)] = 93978,
  [SMALL_STATE(3414)] = 93992,
  [SMALL_STATE(3415)] = 94006,
  [SMALL_STATE(3416)] = 94020,
  [SMALL_STATE(3417)] = 94034,
  [SMALL_STATE(3418)] = 94048,
  [SMALL_STATE(3419)] = 94062,
  [SMALL_STATE(3420)] = 94076,
  [SMALL_STATE(3421)] = 94090,
  [SMALL_STATE(3422)] = 94104,
  [SMALL_STATE(3423)] = 94118,
  [SMALL_STATE(3424)] = 94132,
  [SMALL_STATE(3425)] = 94146,
  [SMALL_STATE(3426)] = 94160,
  [SMALL_STATE(3427)] = 94174,
  [SMALL_STATE(3428)] = 94188,
  [SMALL_STATE(3429)] = 94202,
  [SMALL_STATE(3430)] = 94216,
  [SMALL_STATE(3431)] = 94230,
  [SMALL_STATE(3432)] = 94244,
  [SMALL_STATE(3433)] = 94258,
  [SMALL_STATE(3434)] = 94272,
  [SMALL_STATE(3435)] = 94286,
  [SMALL_STATE(3436)] = 94300,
  [SMALL_STATE(3437)] = 94314,
  [SMALL_STATE(3438)] = 94328,
  [SMALL_STATE(3439)] = 94342,
  [SMALL_STATE(3440)] = 94356,
  [SMALL_STATE(3441)] = 94370,
  [SMALL_STATE(3442)] = 94384,
  [SMALL_STATE(3443)] = 94398,
  [SMALL_STATE(3444)] = 94412,
  [SMALL_STATE(3445)] = 94426,
  [SMALL_STATE(3446)] = 94440,
  [SMALL_STATE(3447)] = 94454,
  [SMALL_STATE(3448)] = 94468,
  [SMALL_STATE(3449)] = 94482,
  [SMALL_STATE(3450)] = 94496,
  [SMALL_STATE(3451)] = 94510,
  [SMALL_STATE(3452)] = 94524,
  [SMALL_STATE(3453)] = 94538,
  [SMALL_STATE(3454)] = 94552,
  [SMALL_STATE(3455)] = 94566,
  [SMALL_STATE(3456)] = 94580,
  [SMALL_STATE(3457)] = 94594,
  [SMALL_STATE(3458)] = 94608,
  [SMALL_STATE(3459)] = 94622,
  [SMALL_STATE(3460)] = 94636,
  [SMALL_STATE(3461)] = 94650,
  [SMALL_STATE(3462)] = 94664,
  [SMALL_STATE(3463)] = 94678,
  [SMALL_STATE(3464)] = 94692,
  [SMALL_STATE(3465)] = 94706,
  [SMALL_STATE(3466)] = 94720,
  [SMALL_STATE(3467)] = 94734,
  [SMALL_STATE(3468)] = 94748,
  [SMALL_STATE(3469)] = 94762,
  [SMALL_STATE(3470)] = 94776,
  [SMALL_STATE(3471)] = 94790,
  [SMALL_STATE(3472)] = 94804,
  [SMALL_STATE(3473)] = 94818,
  [SMALL_STATE(3474)] = 94832,
  [SMALL_STATE(3475)] = 94846,
  [SMALL_STATE(3476)] = 94860,
  [SMALL_STATE(3477)] = 94874,
  [SMALL_STATE(3478)] = 94888,
  [SMALL_STATE(3479)] = 94902,
  [SMALL_STATE(3480)] = 94916,
  [SMALL_STATE(3481)] = 94930,
  [SMALL_STATE(3482)] = 94944,
  [SMALL_STATE(3483)] = 94958,
  [SMALL_STATE(3484)] = 94972,
  [SMALL_STATE(3485)] = 94986,
  [SMALL_STATE(3486)] = 95000,
  [SMALL_STATE(3487)] = 95014,
  [SMALL_STATE(3488)] = 95028,
  [SMALL_STATE(3489)] = 95042,
  [SMALL_STATE(3490)] = 95056,
  [SMALL_STATE(3491)] = 95070,
  [SMALL_STATE(3492)] = 95084,
  [SMALL_STATE(3493)] = 95098,
  [SMALL_STATE(3494)] = 95112,
  [SMALL_STATE(3495)] = 95126,
  [SMALL_STATE(3496)] = 95140,
  [SMALL_STATE(3497)] = 95154,
  [SMALL_STATE(3498)] = 95168,
  [SMALL_STATE(3499)] = 95182,
  [SMALL_STATE(3500)] = 95196,
  [SMALL_STATE(3501)] = 95210,
  [SMALL_STATE(3502)] = 95224,
  [SMALL_STATE(3503)] = 95238,
  [SMALL_STATE(3504)] = 95252,
  [SMALL_STATE(3505)] = 95266,
  [SMALL_STATE(3506)] = 95280,
  [SMALL_STATE(3507)] = 95294,
  [SMALL_STATE(3508)] = 95308,
  [SMALL_STATE(3509)] = 95322,
  [SMALL_STATE(3510)] = 95336,
  [SMALL_STATE(3511)] = 95350,
  [SMALL_STATE(3512)] = 95364,
  [SMALL_STATE(3513)] = 95378,
  [SMALL_STATE(3514)] = 95392,
  [SMALL_STATE(3515)] = 95406,
  [SMALL_STATE(3516)] = 95420,
  [SMALL_STATE(3517)] = 95434,
  [SMALL_STATE(3518)] = 95448,
  [SMALL_STATE(3519)] = 95462,
  [SMALL_STATE(3520)] = 95476,
  [SMALL_STATE(3521)] = 95490,
  [SMALL_STATE(3522)] = 95504,
  [SMALL_STATE(3523)] = 95518,
  [SMALL_STATE(3524)] = 95532,
  [SMALL_STATE(3525)] = 95546,
  [SMALL_STATE(3526)] = 95560,
  [SMALL_STATE(3527)] = 95574,
  [SMALL_STATE(3528)] = 95588,
  [SMALL_STATE(3529)] = 95602,
  [SMALL_STATE(3530)] = 95616,
  [SMALL_STATE(3531)] = 95630,
  [SMALL_STATE(3532)] = 95644,
  [SMALL_STATE(3533)] = 95658,
  [SMALL_STATE(3534)] = 95672,
  [SMALL_STATE(3535)] = 95686,
  [SMALL_STATE(3536)] = 95700,
  [SMALL_STATE(3537)] = 95714,
  [SMALL_STATE(3538)] = 95728,
  [SMALL_STATE(3539)] = 95742,
  [SMALL_STATE(3540)] = 95756,
  [SMALL_STATE(3541)] = 95770,
  [SMALL_STATE(3542)] = 95784,
  [SMALL_STATE(3543)] = 95798,
  [SMALL_STATE(3544)] = 95812,
  [SMALL_STATE(3545)] = 95826,
  [SMALL_STATE(3546)] = 95840,
  [SMALL_STATE(3547)] = 95854,
  [SMALL_STATE(3548)] = 95868,
  [SMALL_STATE(3549)] = 95882,
  [SMALL_STATE(3550)] = 95896,
  [SMALL_STATE(3551)] = 95910,
  [SMALL_STATE(3552)] = 95924,
  [SMALL_STATE(3553)] = 95938,
  [SMALL_STATE(3554)] = 95952,
  [SMALL_STATE(3555)] = 95966,
  [SMALL_STATE(3556)] = 95980,
  [SMALL_STATE(3557)] = 95994,
  [SMALL_STATE(3558)] = 96008,
  [SMALL_STATE(3559)] = 96022,
  [SMALL_STATE(3560)] = 96036,
  [SMALL_STATE(3561)] = 96050,
  [SMALL_STATE(3562)] = 96064,
  [SMALL_STATE(3563)] = 96078,
  [SMALL_STATE(3564)] = 96092,
  [SMALL_STATE(3565)] = 96106,
  [SMALL_STATE(3566)] = 96120,
  [SMALL_STATE(3567)] = 96134,
  [SMALL_STATE(3568)] = 96148,
  [SMALL_STATE(3569)] = 96162,
  [SMALL_STATE(3570)] = 96176,
  [SMALL_STATE(3571)] = 96190,
  [SMALL_STATE(3572)] = 96204,
  [SMALL_STATE(3573)] = 96218,
  [SMALL_STATE(3574)] = 96232,
  [SMALL_STATE(3575)] = 96246,
  [SMALL_STATE(3576)] = 96260,
  [SMALL_STATE(3577)] = 96274,
  [SMALL_STATE(3578)] = 96288,
  [SMALL_STATE(3579)] = 96302,
  [SMALL_STATE(3580)] = 96316,
  [SMALL_STATE(3581)] = 96330,
  [SMALL_STATE(3582)] = 96344,
  [SMALL_STATE(3583)] = 96358,
  [SMALL_STATE(3584)] = 96372,
  [SMALL_STATE(3585)] = 96386,
  [SMALL_STATE(3586)] = 96400,
  [SMALL_STATE(3587)] = 96414,
  [SMALL_STATE(3588)] = 96428,
  [SMALL_STATE(3589)] = 96442,
  [SMALL_STATE(3590)] = 96456,
  [SMALL_STATE(3591)] = 96470,
  [SMALL_STATE(3592)] = 96484,
  [SMALL_STATE(3593)] = 96498,
  [SMALL_STATE(3594)] = 96512,
  [SMALL_STATE(3595)] = 96526,
  [SMALL_STATE(3596)] = 96540,
  [SMALL_STATE(3597)] = 96554,
  [SMALL_STATE(3598)] = 96568,
  [SMALL_STATE(3599)] = 96582,
  [SMALL_STATE(3600)] = 96596,
  [SMALL_STATE(3601)] = 96610,
  [SMALL_STATE(3602)] = 96624,
  [SMALL_STATE(3603)] = 96638,
  [SMALL_STATE(3604)] = 96652,
  [SMALL_STATE(3605)] = 96666,
  [SMALL_STATE(3606)] = 96680,
  [SMALL_STATE(3607)] = 96694,
  [SMALL_STATE(3608)] = 96708,
  [SMALL_STATE(3609)] = 96722,
  [SMALL_STATE(3610)] = 96736,
  [SMALL_STATE(3611)] = 96750,
  [SMALL_STATE(3612)] = 96754,
  [SMALL_STATE(3613)] = 96758,
  [SMALL_STATE(3614)] = 96762,
  [SMALL_STATE(3615)] = 96766,
  [SMALL_STATE(3616)] = 96770,
  [SMALL_STATE(3617)] = 96774,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2418),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3040),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3609),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2729),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3598),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2314),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3562),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3558),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2668),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3523),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2, 0, 0),
  [155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1501),
  [160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(630),
  [163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2734),
  [166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(206),
  [169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(166),
  [172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(10),
  [175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(276),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1472),
  [181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(243),
  [184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(783),
  [187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(850),
  [190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3036),
  [196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3040),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3498),
  [202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2053),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(36),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2055),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1048),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1041),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3609),
  [220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3042),
  [223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(815),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(178),
  [229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(838),
  [232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(822),
  [235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2729),
  [238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(295),
  [241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3598),
  [244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1950),
  [247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(40),
  [250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2314),
  [253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3562),
  [256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3558),
  [259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3554),
  [262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1509),
  [265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2029),
  [268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1878),
  [271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(171),
  [274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2040),
  [277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(42),
  [280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3103),
  [283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2668),
  [286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1214),
  [289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2648),
  [292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1246),
  [295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1477),
  [298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3523),
  [301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1978),
  [304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1477),
  [307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3340),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 2, 0, 0),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 2, 0, 0),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2794),
  [362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 1, 0, 0),
  [370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 1, 0, 0),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3394),
  [374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 1, 0, 0),
  [376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 1, 0, 0),
  [378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 2, 0, 0),
  [380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 2, 0, 0),
  [382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_expression, 1, 0, 0),
  [384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1, 0, 0),
  [396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1, 0, 0),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2647),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2478),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2908),
  [432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2500),
  [434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3214),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2591),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3469),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3005),
  [480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3057),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3321),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3590),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2896),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(143),
  [517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(157),
  [520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(70),
  [523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0),
  [525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(71),
  [528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(72),
  [531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(157),
  [534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3575),
  [537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(164),
  [540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2653),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(155),
  [546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(144),
  [549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3519),
  [552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(163),
  [555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(157),
  [558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(98),
  [561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0),
  [563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(84),
  [566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(120),
  [569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(157),
  [572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(3379),
  [575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(164),
  [578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(2653),
  [581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(155),
  [584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(163),
  [587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(3519),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3575),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(183),
  [627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(174),
  [630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(90),
  [633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0),
  [635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(95),
  [638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(96),
  [641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(174),
  [644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(183),
  [647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(199),
  [650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(2497),
  [653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(201),
  [656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2, 0, 0), SHIFT_REPEAT(3313),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3379),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__token_pattern, 1, 0, 0),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__token_pattern, 1, 0, 0),
  [735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 1, 0, 0),
  [737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 1, 0, 0),
  [739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__non_special_token_repeat1, 2, 0, 0),
  [741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__non_special_token_repeat1, 2, 0, 0), SHIFT_REPEAT(157),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__non_special_token_repeat1, 2, 0, 0),
  [746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__non_special_token_repeat1, 2, 0, 0), SHIFT_REPEAT(157),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition, 5, 0, 0),
  [761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition, 5, 0, 0),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree_pattern, 3, 0, 0),
  [773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree_pattern, 3, 0, 0),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 3, 0, 0),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 3, 0, 0),
  [781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition, 4, 0, 0),
  [783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition, 4, 0, 0),
  [785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition_pattern, 4, 0, 0),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition_pattern, 4, 0, 0),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree, 3, 0, 0),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree, 3, 0, 0),
  [805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition_pattern, 6, 0, 0),
  [807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition_pattern, 6, 0, 0),
  [809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 1, 0, 0),
  [811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 1, 0, 0),
  [813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__non_delim_token, 1, 0, 0),
  [815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__non_delim_token, 1, 0, 0),
  [817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__non_special_token_repeat1, 2, 0, 0), SHIFT_REPEAT(174),
  [824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__non_special_token_repeat1, 2, 0, 0), SHIFT_REPEAT(174),
  [827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__non_special_token_repeat1, 1, 0, 0),
  [829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__non_special_token_repeat1, 1, 0, 0),
  [831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fragment_specifier, 1, 0, 0),
  [833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fragment_specifier, 1, 0, 0),
  [835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_binding_pattern, 3, 0, 197),
  [837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_binding_pattern, 3, 0, 197),
  [839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1037),
  [842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(206),
  [845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(166),
  [848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0),
  [850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2),
  [853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(276),
  [856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1472),
  [859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(243),
  [862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(783),
  [865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(850),
  [868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(37),
  [871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(3036),
  [874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3471),
  [877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(3498),
  [880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2425),
  [883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(36),
  [886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2617),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1048),
  [892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1349),
  [895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(824),
  [898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(176),
  [901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2598),
  [904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(255),
  [907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(40),
  [910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2794),
  [913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2616),
  [916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(200),
  [919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(42),
  [922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(3103),
  [925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2600),
  [928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1214),
  [931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(2648),
  [934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1246),
  [937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1477),
  [940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(3523),
  [943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(1477),
  [946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT(3340),
  [949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree_pattern, 2, 0, 0),
  [951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree_pattern, 2, 0, 0),
  [953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree, 2, 0, 0),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree, 2, 0, 0),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1, 0, 0),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1, 0, 0),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition_pattern, 5, 0, 0),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition_pattern, 5, 0, 0),
  [969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition, 6, 0, 0),
  [971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition, 6, 0, 0),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delim_token_tree, 3, 0, 0),
  [993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delim_token_tree, 3, 0, 0),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delim_token_tree, 2, 0, 0),
  [999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delim_token_tree, 2, 0, 0),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [1021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_delim_token_tree_repeat1, 1, 0, 0),
  [1023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 1, 0, 0),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [1029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__delim_tokens, 1, 0, 0),
  [1031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delim_tokens, 1, 0, 0),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [1083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1037),
  [1086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(206),
  [1089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0),
  [1091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(166),
  [1094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2),
  [1097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(276),
  [1100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1472),
  [1103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(243),
  [1106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(783),
  [1109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(850),
  [1112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [1115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3036),
  [1118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3498),
  [1121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2425),
  [1124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(36),
  [1127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2617),
  [1130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1048),
  [1133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1349),
  [1136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(824),
  [1139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(176),
  [1142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2598),
  [1145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(255),
  [1148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(40),
  [1151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2794),
  [1154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2616),
  [1157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(200),
  [1160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(42),
  [1163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3103),
  [1166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2600),
  [1169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1214),
  [1172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2648),
  [1175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1246),
  [1178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1477),
  [1181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3523),
  [1184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1477),
  [1187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3340),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [1196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 3, 0, 30),
  [1198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 3, 0, 30),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [1222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2498),
  [1232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4, 0, 0),
  [1234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4, 0, 0),
  [1236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 5, 0, 0),
  [1238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 5, 0, 0),
  [1240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [1242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [1244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 6, 0, 0),
  [1246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 6, 0, 0),
  [1248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_expression, 4, 0, 98),
  [1250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_expression, 4, 0, 98),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [1264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [1274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [1276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [1288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [1290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [1292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [1294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3166),
  [1296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3435),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [1318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 7, 0, 241),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 7, 0, 241),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_invocation, 3, 0, 39),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_invocation, 3, 0, 39),
  [1332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [1338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [1350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [1354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2726),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_block, 2, 0, 0),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_block, 2, 0, 0),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 5, 0, 115),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 5, 0, 115),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 4, 0, 0),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 4, 0, 0),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 3, 0, 38),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 3, 0, 38),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [1380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [1390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_except_range, 1, 0, 0),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_except_range, 1, 0, 0),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_expression, 2, 0, 8),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_expression, 2, 0, 8),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 5, 0, 145),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 5, 0, 145),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [1406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [1410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 3, 0, 33),
  [1412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 3, 0, 33),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_invocation, 3, 0, 28),
  [1416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_invocation, 3, 0, 28),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unsafe_block, 2, 0, 0),
  [1420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unsafe_block, 2, 0, 0),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 0, 0),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 0, 0),
  [1426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, 0, 75),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, 0, 75),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 3, 0, 0),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 3, 0, 0),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 2, 0, 0),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 2, 0, 0),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_async_block, 2, 0, 0),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_async_block, 2, 0, 0),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_async_block, 3, 0, 0),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_async_block, 3, 0, 0),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_block, 2, 0, 8),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_block, 2, 0, 8),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [1480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2931),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [1490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3168),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [1496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2393),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2423),
  [1502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2421),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2322),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [1536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [1546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 2, 0, 0),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 2, 0, 0),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_parameters, 3, 0, 0),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_parameters, 3, 0, 0),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_parameters, 2, 0, 0),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_parameters, 2, 0, 0),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3516),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [1578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2531),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [1602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [1604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2796),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [1628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [1630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [1636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [1640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2350),
  [1642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [1648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 4, 0, 116),
  [1650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 4, 0, 116),
  [1652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 3, 0, 172),
  [1654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 3, 0, 172),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [1662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 129),
  [1664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 129),
  [1666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 224),
  [1668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 224),
  [1670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 166),
  [1672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 166),
  [1674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 3, 0, 7),
  [1676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 3, 0, 7),
  [1678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 5, 0, 110),
  [1680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 5, 0, 110),
  [1682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 7, 0, 180),
  [1684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 7, 0, 180),
  [1686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inner_attribute_item, 5, 0, 0),
  [1688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inner_attribute_item, 5, 0, 0),
  [1690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 222),
  [1692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 222),
  [1694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 3, 0, 29),
  [1696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 3, 0, 29),
  [1698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 213),
  [1700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 213),
  [1702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 164),
  [1704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 164),
  [1706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 212),
  [1708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 212),
  [1710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 211),
  [1712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 211),
  [1714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 210),
  [1716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 210),
  [1718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 209),
  [1720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 209),
  [1722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 208),
  [1724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 208),
  [1726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 120),
  [1728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 120),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 121),
  [1732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 121),
  [1734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 5, 0, 0),
  [1736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 5, 0, 0),
  [1738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 161),
  [1740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 161),
  [1742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 5, 0, 112),
  [1744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 5, 0, 112),
  [1746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 207),
  [1748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 207),
  [1750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 159),
  [1752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 159),
  [1754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, 0, 206),
  [1756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, 0, 206),
  [1758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 3, 0, 37),
  [1760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_declaration, 3, 0, 37),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, 0, 157),
  [1764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, 0, 157),
  [1766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, 0, 205),
  [1768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, 0, 205),
  [1770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 226),
  [1772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 226),
  [1774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 225),
  [1776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 225),
  [1778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, 0, 204),
  [1780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, 0, 204),
  [1782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 79),
  [1784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 79),
  [1786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 3, 0, 22),
  [1788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 3, 0, 22),
  [1790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 3, 0, 31),
  [1792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 3, 0, 31),
  [1794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 5, 0, 111),
  [1796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 5, 0, 111),
  [1798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 3, 0, 6),
  [1800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 3, 0, 6),
  [1802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 254),
  [1804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 254),
  [1806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 122),
  [1808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 122),
  [1810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 5, 0, 0),
  [1812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 5, 0, 0),
  [1814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 3, 0, 34),
  [1816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 3, 0, 34),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 7, 0, 201),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 7, 0, 201),
  [1822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 123),
  [1824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 123),
  [1826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 3, 0, 32),
  [1828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 3, 0, 32),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 124),
  [1832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 124),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [1836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [1838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 228),
  [1840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 228),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, 0, 229),
  [1844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, 0, 229),
  [1846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, 0, 188),
  [1848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, 0, 188),
  [1850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, 0, 230),
  [1852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, 0, 230),
  [1854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, 0, 231),
  [1856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, 0, 231),
  [1858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 5, 0, 113),
  [1860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 5, 0, 113),
  [1862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 7, 0, 6),
  [1864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 7, 0, 6),
  [1866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 7, 0, 54),
  [1868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 7, 0, 54),
  [1870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3205),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3463),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [1884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [1886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3326),
  [1890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3107),
  [1892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [1894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3465),
  [1898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2955),
  [1900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [1902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [1904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [1906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2953),
  [1908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [1910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [1912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [1914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [1916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 225),
  [1922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 225),
  [1924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, 0, 100),
  [1926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, 0, 100),
  [1928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, 0, 232),
  [1930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, 0, 232),
  [1932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 7, 0, 137),
  [1934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 7, 0, 137),
  [1936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 29),
  [1938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 29),
  [1940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 6, 0, 6),
  [1942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 6, 0, 6),
  [1944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 7, 0, 191),
  [1946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 7, 0, 191),
  [1948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 71),
  [1950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 71),
  [1952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 84),
  [1954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 84),
  [1956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 7, 0, 233),
  [1958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 7, 0, 233),
  [1960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 6, 0, 174),
  [1962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 6, 0, 174),
  [1964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 3, 0, 44),
  [1966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 3, 0, 44),
  [1968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, 0, 234),
  [1970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, 0, 234),
  [1972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, 0, 116),
  [1974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, 0, 116),
  [1976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, 0, 235),
  [1978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, 0, 235),
  [1980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, 0, 236),
  [1982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, 0, 236),
  [1984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 7, 0, 237),
  [1986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 7, 0, 237),
  [1988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, 0, 238),
  [1990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, 0, 238),
  [1992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, 0, 239),
  [1994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, 0, 239),
  [1996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, 0, 125),
  [1998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, 0, 125),
  [2000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, 0, 195),
  [2002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, 0, 195),
  [2004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, 0, 196),
  [2006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, 0, 196),
  [2008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2012),
  [2011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(754),
  [2014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(775),
  [2017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2255),
  [2020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3307),
  [2023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(825),
  [2026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(814),
  [2029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(850),
  [2032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2796),
  [2035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2795),
  [2038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3269),
  [2041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3058),
  [2044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2506),
  [2047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2118),
  [2050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(827),
  [2053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(806),
  [2056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2309),
  [2059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2592),
  [2062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2350),
  [2065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2621),
  [2068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2621),
  [2071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3500),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, 0, 195),
  [2076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, 0, 195),
  [2078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 194),
  [2080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 194),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 193),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 193),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 192),
  [2088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 192),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 6, 0, 183),
  [2092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 6, 0, 183),
  [2094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 6, 0, 191),
  [2096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 6, 0, 191),
  [2098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, 0, 183),
  [2100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, 0, 183),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, 0, 137),
  [2104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, 0, 137),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, 0, 88),
  [2108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, 0, 88),
  [2110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 5, 0, 110),
  [2112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 5, 0, 110),
  [2114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 72),
  [2116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 72),
  [2118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, 0, 71),
  [2120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, 0, 71),
  [2122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 6, 0, 183),
  [2124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 6, 0, 183),
  [2126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, 0, 240),
  [2128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, 0, 240),
  [2130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [2132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [2134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 4, 0, 82),
  [2136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 4, 0, 82),
  [2138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 6, 0, 0),
  [2140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 6, 0, 0),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 7, 0, 201),
  [2144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 7, 0, 201),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, 0, 204),
  [2148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, 0, 204),
  [2150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, 0, 244),
  [2152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, 0, 244),
  [2154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, 0, 81),
  [2156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, 0, 81),
  [2158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 6, 0, 174),
  [2160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 6, 0, 174),
  [2162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, 0, 190),
  [2164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, 0, 190),
  [2166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, 0, 22),
  [2168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, 0, 22),
  [2170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 4, 0, 54),
  [2172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 4, 0, 54),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, 0, 140),
  [2176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, 0, 140),
  [2178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, 0, 189),
  [2180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, 0, 189),
  [2182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 3, 0, 29),
  [2184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 3, 0, 29),
  [2186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, 0, 188),
  [2188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, 0, 188),
  [2190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 209),
  [2192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 209),
  [2194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 245),
  [2196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 245),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 211),
  [2200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 211),
  [2202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 4, 0, 6),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 4, 0, 6),
  [2206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 29),
  [2208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 29),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 6, 0, 185),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 6, 0, 185),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 184),
  [2216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 184),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 183),
  [2220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 183),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, 0, 85),
  [2224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, 0, 85),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 72),
  [2228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 72),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 182),
  [2232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 182),
  [2234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 181),
  [2236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 181),
  [2238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 132),
  [2240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 132),
  [2242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 227),
  [2244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 227),
  [2246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 246),
  [2248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 246),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 8, 0, 247),
  [2252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 8, 0, 247),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, 0, 80),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, 0, 80),
  [2258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 111),
  [2260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 111),
  [2262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 3, 0, 29),
  [2264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 3, 0, 29),
  [2266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 8, 0, 248),
  [2268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 8, 0, 248),
  [2270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [2272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, 0, 79),
  [2276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, 0, 79),
  [2278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, 0, 72),
  [2280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, 0, 72),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 10, 0, 278),
  [2284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 10, 0, 278),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 10, 0, 273),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 10, 0, 273),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 128),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 128),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 6, 0, 131),
  [2296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 6, 0, 131),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 6, 0, 180),
  [2300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 6, 0, 180),
  [2302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 6, 0, 130),
  [2304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 6, 0, 130),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, 0, 179),
  [2308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, 0, 179),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, 0, 72),
  [2312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, 0, 72),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 111),
  [2316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 111),
  [2318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 8, 0, 249),
  [2320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 8, 0, 249),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 4, 0, 0),
  [2328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 4, 0, 0),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 8, 0, 250),
  [2332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 8, 0, 250),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 6, 0, 54),
  [2336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 6, 0, 54),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 3, 0, 0),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 3, 0, 0),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 4, 0, 7),
  [2344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 4, 0, 7),
  [2346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 6, 0, 0),
  [2348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 6, 0, 0),
  [2350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 4, 0, 86),
  [2352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 4, 0, 86),
  [2354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 5, 0, 6),
  [2356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 5, 0, 6),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [2362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [2364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 221),
  [2366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 221),
  [2368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 214),
  [2370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 214),
  [2372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 252),
  [2374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 252),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 223),
  [2378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 223),
  [2380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 10, 0, 277),
  [2382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 10, 0, 277),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 253),
  [2386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 253),
  [2388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 3, 0, 0),
  [2390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 3, 0, 0),
  [2392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 223),
  [2394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 223),
  [2396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 88),
  [2398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 88),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 4, 0, 84),
  [2402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 4, 0, 84),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 255),
  [2406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 255),
  [2408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 4, 0, 71),
  [2410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 4, 0, 71),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 5, 0, 130),
  [2414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 5, 0, 130),
  [2416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 5, 0, 86),
  [2418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 5, 0, 86),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 5, 0, 84),
  [2422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 5, 0, 84),
  [2424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 10, 0, 276),
  [2426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 10, 0, 276),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 4, 0, 72),
  [2430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 4, 0, 72),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 7, 0, 215),
  [2434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 7, 0, 215),
  [2436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, 0, 171),
  [2438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, 0, 171),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, 0, 170),
  [2442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, 0, 170),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 256),
  [2446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 256),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 257),
  [2450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 257),
  [2452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 5, 0, 131),
  [2458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 5, 0, 131),
  [2460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 258),
  [2462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 258),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 5, 0, 111),
  [2466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 5, 0, 111),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 227),
  [2470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 227),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, 0, 259),
  [2474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, 0, 259),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, 0, 169),
  [2478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, 0, 169),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 168),
  [2482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 168),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 123),
  [2486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 123),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 132),
  [2490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 132),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, 0, 260),
  [2494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, 0, 260),
  [2496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, 0, 261),
  [2498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, 0, 261),
  [2500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, 0, 231),
  [2502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, 0, 231),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 4, 0, 96),
  [2508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_declaration, 4, 0, 96),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 167),
  [2512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 167),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 166),
  [2516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 166),
  [2518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, 0, 262),
  [2520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, 0, 262),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 165),
  [2524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 165),
  [2526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 164),
  [2528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 164),
  [2530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 5, 0, 144),
  [2532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 5, 0, 144),
  [2534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 133),
  [2536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 133),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 163),
  [2540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 163),
  [2542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 120),
  [2544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 120),
  [2546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 8, 0, 250),
  [2548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 8, 0, 250),
  [2550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 8, 0, 263),
  [2552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 8, 0, 263),
  [2554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 4, 0, 88),
  [2556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 4, 0, 88),
  [2558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 63),
  [2560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 63),
  [2562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 134),
  [2564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 134),
  [2566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 135),
  [2568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 135),
  [2570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 143),
  [2572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 143),
  [2574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 5, 0, 54),
  [2576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 5, 0, 54),
  [2578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 5, 0, 137),
  [2580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 5, 0, 137),
  [2582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 8, 0, 233),
  [2584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 8, 0, 233),
  [2586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 8, 0, 264),
  [2588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 8, 0, 264),
  [2590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 95),
  [2592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 95),
  [2594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 4, 0, 94),
  [2596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 4, 0, 94),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 162),
  [2600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 162),
  [2602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 161),
  [2604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 161),
  [2606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, 0, 238),
  [2608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, 0, 238),
  [2610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, 0, 265),
  [2612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, 0, 265),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 160),
  [2616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 160),
  [2618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, 0, 159),
  [2620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, 0, 159),
  [2622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, 0, 158),
  [2624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, 0, 158),
  [2626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 4, 0, 93),
  [2628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 4, 0, 93),
  [2630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, 0, 266),
  [2632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, 0, 266),
  [2634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 136),
  [2636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 136),
  [2638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, 0, 157),
  [2640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, 0, 157),
  [2642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, 0, 88),
  [2644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, 0, 88),
  [2646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, 0, 156),
  [2648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, 0, 156),
  [2650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, 0, 267),
  [2652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, 0, 267),
  [2654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_item, 4, 0, 0),
  [2656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_item, 4, 0, 0),
  [2658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3205),
  [2661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1418),
  [2664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2764),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0),
  [2669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3463),
  [2672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(850),
  [2675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3162),
  [2678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3108),
  [2681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2351),
  [2684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2258),
  [2687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2208),
  [2690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3326),
  [2693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3107),
  [2696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(840),
  [2699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(798),
  [2702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3465),
  [2705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1950),
  [2708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2955),
  [2711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3314),
  [2714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3315),
  [2717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3316),
  [2720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2953),
  [2723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2214),
  [2726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1877),
  [2729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2046),
  [2732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3323),
  [2735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1969),
  [2738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3323),
  [2741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 2, 0, 8),
  [2743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 2, 0, 8),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [2747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 2, 0, 0),
  [2749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 2, 0, 0),
  [2751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 9, 0, 268),
  [2753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 9, 0, 268),
  [2755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 9, 0, 269),
  [2757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 9, 0, 269),
  [2759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [2761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [2763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 9, 0, 254),
  [2765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 9, 0, 254),
  [2767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 9, 0, 270),
  [2769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 9, 0, 270),
  [2771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 9, 0, 256),
  [2773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 9, 0, 256),
  [2775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 9, 0, 271),
  [2777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 9, 0, 271),
  [2779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 137),
  [2781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 137),
  [2783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 2, 0, 0),
  [2785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 2, 0, 0),
  [2787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 9, 0, 260),
  [2789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 9, 0, 260),
  [2791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, 0, 112),
  [2793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, 0, 112),
  [2795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 3, 0, 29),
  [2797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 3, 0, 29),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 5, 0, 140),
  [2801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 5, 0, 140),
  [2803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 4, 0, 0),
  [2805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 4, 0, 0),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 5, 0, 141),
  [2809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 5, 0, 141),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 4, 0, 93),
  [2813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 4, 0, 93),
  [2815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 9, 0, 272),
  [2817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 9, 0, 272),
  [2819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 7, 0, 216),
  [2821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 7, 0, 216),
  [2823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 5, 0, 135),
  [2825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 5, 0, 135),
  [2827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 5, 0, 137),
  [2829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 5, 0, 137),
  [2831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 9, 0, 273),
  [2833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 9, 0, 273),
  [2835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 7, 0, 218),
  [2837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 7, 0, 218),
  [2839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 3, 0, 7),
  [2841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 3, 0, 7),
  [2843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 88),
  [2845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 88),
  [2847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, 0, 71),
  [2849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, 0, 71),
  [2851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, 0, 72),
  [2853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, 0, 72),
  [2855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 7, 0, 217),
  [2857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 7, 0, 217),
  [2859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 9, 0, 274),
  [2861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 9, 0, 274),
  [2863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 4, 0, 73),
  [2865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 4, 0, 73),
  [2867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 135),
  [2869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 135),
  [2871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 142),
  [2873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 142),
  [2875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 4, 0, 74),
  [2877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 4, 0, 74),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, 0, 137),
  [2881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, 0, 137),
  [2883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 9, 0, 266),
  [2885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 9, 0, 266),
  [2887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 9, 0, 275),
  [2889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 9, 0, 275),
  [2891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, 0, 221),
  [2893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, 0, 221),
  [2895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 5, 0, 114),
  [2897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 5, 0, 114),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, 0, 88),
  [2901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, 0, 88),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, 0, 87),
  [2905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, 0, 87),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, 0, 63),
  [2909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, 0, 63),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 5, 0, 73),
  [2913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 5, 0, 73),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 5, 0, 135),
  [2917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 5, 0, 135),
  [2919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [2935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [2937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [2939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [2953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [2959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [2963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [2971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [2973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [3013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [3037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2248),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [3041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [3043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [3045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2414),
  [3047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [3049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [3063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [3071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [3073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3263),
  [3075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2630),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [3089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [3113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [3115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [3119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2515),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [3123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [3125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3535),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [3129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [3133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3195),
  [3145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [3151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [3165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [3167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [3183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [3191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [3195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2842),
  [3197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [3201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0),
  [3203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 1, 0, 0),
  [3205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 1, 0, 0),
  [3207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_parameters, 4, 0, 0),
  [3209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_parameters, 4, 0, 0),
  [3211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0),
  [3213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lifetime, 2, 0, 0),
  [3215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lifetime, 2, 0, 0),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [3219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 2, 0, 0),
  [3221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 2, 0, 0),
  [3223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [3225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [3229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [3231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 2, 0, 1),
  [3233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 2, 0, 1),
  [3235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [3237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [3239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [3241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, 0, 5),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [3245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, 0, 5),
  [3247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [3249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [3253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_type, 2, 0, 24),
  [3255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_type, 2, 0, 24),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [3259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 2, 0, 24),
  [3261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 2, 0, 24),
  [3263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 4, 0, 104),
  [3265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 4, 0, 104),
  [3267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, 0, 41),
  [3269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, 0, 41),
  [3271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, 0, 40),
  [3273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 40),
  [3275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, 0, 17),
  [3277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, 0, 17),
  [3279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, 0, 16),
  [3281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 16),
  [3283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 4, 0, 105),
  [3285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 4, 0, 105),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_type, 2, 0, 25),
  [3289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_type, 2, 0, 25),
  [3291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, 0, 46),
  [3293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, 0, 46),
  [3295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, 0, 45),
  [3297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 45),
  [3299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 2, 0, 25),
  [3301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 2, 0, 25),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 2, 0, 7),
  [3305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 2, 0, 7),
  [3307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 2, 0, 6),
  [3309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 2, 0, 6),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, 0, 0),
  [3313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, 0, 0),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [3319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_except_range, 1, 0, 1),
  [3321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_except_range, 1, 0, 1),
  [3323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [3327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 1, 0, 0),
  [3329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_arm_repeat1, 2, 0, 0),
  [3331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_arm_repeat1, 2, 0, 0),
  [3333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_arm_repeat1, 2, 0, 0), SHIFT_REPEAT(3058),
  [3336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [3338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 3, 0, 0),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [3344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2925),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [3352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2922),
  [3354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [3356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3474),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [3360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 4, 0, 0),
  [3362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, 0, 0),
  [3364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, 0, 0),
  [3366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 107),
  [3368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 107),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [3372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_expression, 1, 0, 0),
  [3374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_expression, 1, 0, 0),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [3378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [3380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [3384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [3386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 0),
  [3388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [3390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [3392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 67),
  [3394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 67),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [3398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 66),
  [3400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 66),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [3404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 64),
  [3406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 64),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [3410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [3412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 0),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [3416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, 0, 27),
  [3418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, 0, 27),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [3422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, 0, 26),
  [3424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, 0, 26),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [3430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, 0, 23),
  [3432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, 0, 23),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [3436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 21),
  [3438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 21),
  [3440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 20),
  [3442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 20),
  [3444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 19),
  [3446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 19),
  [3448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3542),
  [3451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [3455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [3457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3408),
  [3461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [3463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [3469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 2, 0, 7),
  [3471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [3473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [3475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 5, 0, 0),
  [3477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 5, 0, 0),
  [3479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, 0, 17),
  [3481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [3485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3486),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [3489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [3491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [3493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [3497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3128),
  [3501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, 0, 41),
  [3503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 6, 0, 0),
  [3505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 6, 0, 0),
  [3507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 6, 0, 0),
  [3509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 6, 0, 0),
  [3511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, 0, 46),
  [3513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 49),
  [3515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 49),
  [3517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 50),
  [3519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 50),
  [3521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [3525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3367),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [3529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [3531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2990),
  [3533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3532),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [3537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [3539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3246),
  [3541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [3543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5, 0, 119),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, 0, 119),
  [3547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [3549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [3551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 5, 0, 127),
  [3553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 5, 0, 127),
  [3555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 5, 0, 0),
  [3557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 5, 0, 0),
  [3559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 5, 0, 99),
  [3561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 5, 0, 99),
  [3563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [3565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [3567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 4, 0, 97),
  [3569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 4, 0, 97),
  [3571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, 0, 0),
  [3573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, 0, 0),
  [3575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [3577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3, 0, 0),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 150),
  [3581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 150),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 4, 0, 0),
  [3585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 4, 0, 0),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 108),
  [3589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 108),
  [3591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_higher_ranked_trait_bound, 3, 0, 79),
  [3593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_higher_ranked_trait_bound, 3, 0, 79),
  [3595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 106),
  [3597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 106),
  [3599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, 0, 152),
  [3601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, 0, 152),
  [3603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 103),
  [3605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 103),
  [3607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, 0, 153),
  [3609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, 0, 153),
  [3611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type, 4, 0, 102),
  [3613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type, 4, 0, 102),
  [3615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [3617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [3619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [3621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [3623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, 0, 154),
  [3625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, 0, 154),
  [3627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 0),
  [3629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4, 0, 0),
  [3631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 6, 0, 0),
  [3633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 6, 0, 0),
  [3635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 6, 0, 146),
  [3637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 6, 0, 146),
  [3639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 6, 0, 0),
  [3641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 6, 0, 0),
  [3643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 4, 0, 83),
  [3645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 4, 0, 83),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bounded_type, 3, 0, 0),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bounded_type, 3, 0, 0),
  [3651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, 0, 76),
  [3653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 0, 76),
  [3655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_expression, 2, 0, 0),
  [3657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_expression, 2, 0, 0),
  [3659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 3, 0, 35),
  [3661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 3, 0, 35),
  [3663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type, 3, 0, 63),
  [3665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type, 3, 0, 63),
  [3667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 3, 0, 63),
  [3669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 3, 0, 63),
  [3671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 62),
  [3673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 62),
  [3675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [3677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [3679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [3681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [3683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3, 0, 76),
  [3685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, 0, 76),
  [3687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 4, 0, 172),
  [3689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 4, 0, 172),
  [3691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 4, 0, 172),
  [3693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 6, 0, 0),
  [3695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 6, 0, 0),
  [3697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5, 0, 76),
  [3699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, 0, 76),
  [3701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5, 0, 0),
  [3703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, 0, 0),
  [3705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [3707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [3709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type, 2, 0, 22),
  [3711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type, 2, 0, 22),
  [3713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_removed_trait_bound, 2, 0, 0),
  [3715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_removed_trait_bound, 2, 0, 0),
  [3717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit_type, 2, 0, 0),
  [3719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unit_type, 2, 0, 0),
  [3721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, 0, 119),
  [3723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 0, 119),
  [3725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [3727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2649),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [3731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [3735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [3737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2628),
  [3739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [3743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 6, 0, 0),
  [3745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 6, 0, 0),
  [3747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit_expression, 2, 0, 0),
  [3749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unit_expression, 2, 0, 0),
  [3751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [3753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 6, 0, 175),
  [3755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 6, 0, 175),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 2, 0, 0),
  [3759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 2, 0, 0),
  [3761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 0),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [3765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 0),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [3769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2901),
  [3771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_expression, 2, 0, 4),
  [3773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_expression, 2, 0, 4),
  [3775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 6, 0, 119),
  [3777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 6, 0, 119),
  [3779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 5, 0, 116),
  [3781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 5, 0, 116),
  [3783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 5, 0, 116),
  [3785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_never_type, 1, 0, 0),
  [3787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_never_type, 1, 0, 0),
  [3789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 4, 0, 0),
  [3791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 4, 0, 0),
  [3793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [3795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [3797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 5, 0, 0),
  [3799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 5, 0, 0),
  [3801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 6, 0, 200),
  [3803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 6, 0, 200),
  [3805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_function, 3, 0, 42),
  [3807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_function, 3, 0, 42),
  [3809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_expression, 2, 0, 0),
  [3811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_expression, 2, 0, 0),
  [3813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_with_turbofish, 3, 0, 52),
  [3815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_cast_expression, 3, 0, 51),
  [3817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_cast_expression, 3, 0, 51),
  [3819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [3821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [3823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 3, 0, 0),
  [3825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 3, 0, 0),
  [3827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_expression, 3, 0, 18),
  [3829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_expression, 3, 0, 18),
  [3831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 3, 0, 0),
  [3833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 3, 0, 0),
  [3835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [3837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [3839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5, 0, 0),
  [3841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5, 0, 0),
  [3843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_with_turbofish, 3, 0, 43),
  [3845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 47),
  [3847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 47),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [3851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2, 0, 0),
  [3853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2, 0, 0),
  [3855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 2, 0, 13),
  [3857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 2, 0, 13),
  [3859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 7, 0, 0),
  [3861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 7, 0, 0),
  [3863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 7, 0, 0),
  [3865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 7, 0, 0),
  [3867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 2, 0, 10),
  [3869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 2, 0, 10),
  [3871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [3873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [3877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 2, 0, 11),
  [3879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 2, 0, 11),
  [3881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 12),
  [3883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 12),
  [3885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 1, 0, 0),
  [3887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 1, 0, 0),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [3891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_arm_repeat1, 1, 0, 0),
  [3893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_arm_repeat1, 1, 0, 0),
  [3895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3, 0, 0),
  [3897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [3899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [3901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [3903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [3905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [3913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 0),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [3921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [3923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [3927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_assignment_expr, 3, 0, 47),
  [3929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_assignment_expr, 3, 0, 47),
  [3931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 48),
  [3933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 48),
  [3935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 3, 0, 0),
  [3937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 3, 0, 0),
  [3939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [3941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3109),
  [3943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [3945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2, 0, 0),
  [3947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2, 0, 0),
  [3949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2730),
  [3951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_expression, 2, 0, 0),
  [3953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_expression, 2, 0, 0),
  [3955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [3957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [3961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [3973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [3979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 1, 0, 0),
  [3981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_visibility_modifier, 1, 0, 0), SHIFT(2650),
  [3984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 1, 0, 0),
  [3986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_visibility_modifier, 1, 0, 0), SHIFT(3136),
  [3989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 4, 0, 0),
  [3991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 4, 0, 0),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [3995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 5, 0, 126),
  [3997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 5, 0, 126),
  [3999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 5, 0, 0),
  [4001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 5, 0, 0),
  [4003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [4005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [4007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [4009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [4017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [4049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [4063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [4079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 3, 0, 0),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [4083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2389),
  [4085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3110),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [4099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2, 0, 0),
  [4101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [4103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3187),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [4113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2471),
  [4115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [4125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [4127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [4129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 4, 0, 203),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [4135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 4, 0, 202),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [4141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [4143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [4145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [4149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [4153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [4167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [4169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [4175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [4177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [4181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [4183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [4185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [4191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [4199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [4201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [4203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [4213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_field_initializer, 2, 0, 0),
  [4215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [4223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2398),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [4237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2394),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [4245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__condition, 1, 0, 0),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [4251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 138),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [4255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 139),
  [4257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_condition, 4, 0, 116),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [4261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 4, 0, 187),
  [4263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 4, 0, 186),
  [4265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 4, 0, 116),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [4269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_chain, 3, 0, 0),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [4281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 3, 0, 172),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [4311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 3, 0, 155),
  [4313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 5, 0, 243),
  [4315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 109),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [4319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [4323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [4335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 18),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [4379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [4381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [4385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2767),
  [4387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [4391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [4393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2559),
  [4395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2516),
  [4397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [4399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2723),
  [4401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2674),
  [4403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2701),
  [4405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_lifetimes, 4, 0, 0),
  [4407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_lifetimes, 4, 0, 0),
  [4409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_lifetimes, 6, 0, 0),
  [4411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_lifetimes, 6, 0, 0),
  [4413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_lifetimes, 5, 0, 0),
  [4415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_lifetimes, 5, 0, 0),
  [4417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [4419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [4421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [4425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3120),
  [4427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3122),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [4431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3204),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [4435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3196),
  [4437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [4439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3199),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [4453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 0),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [4459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, 0, 0),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [4463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [4469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 1),
  [4471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, 0, 1),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [4475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [4479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [4485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [4495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [4545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1, 0, 5), REDUCE(sym__pattern, 1, 0, 0),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [4578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [4590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 45), REDUCE(sym_scoped_type_identifier, 3, 0, 46),
  [4593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 16), REDUCE(sym_scoped_type_identifier, 3, 0, 17),
  [4596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 40), REDUCE(sym_scoped_type_identifier, 3, 0, 41),
  [4599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negative_literal, 2, 0, 0),
  [4601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negative_literal, 2, 0, 0),
  [4603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 2, 0, 6), REDUCE(sym_scoped_type_identifier, 2, 0, 7),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [4620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal_pattern, 1, 0, 0),
  [4622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal_pattern, 1, 0, 0),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [4628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3409),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [4678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_modifier, 1, 0, 0),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [4686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, 0, 0),
  [4688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, 0, 0),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [4694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2490),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [4698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [4702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2343),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [4712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3413),
  [4714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_modifiers_repeat1, 1, 0, 0),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [4728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, 0, 55),
  [4730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, 0, 55),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [4734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, 0, 1),
  [4736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, 0, 1),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [4742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [4746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, 0, 59),
  [4748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, 0, 59),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [4752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [4758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [4764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 5, 0, 61),
  [4766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 5, 0, 56),
  [4768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [4778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 3, 0, 57),
  [4780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 2, 0, 0),
  [4782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 3, 0, 56),
  [4784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_captured_pattern, 3, 0, 0),
  [4786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_pattern, 2, 0, 0),
  [4788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4, 0, 0),
  [4790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_pattern, 3, 0, 0),
  [4792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 4, 0, 0),
  [4794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 3, 0, 0),
  [4796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 4, 0, 56),
  [4798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 3, 0, 61),
  [4800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2, 0, 0),
  [4802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 0),
  [4804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 5, 0, 0),
  [4806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 4, 0, 57),
  [4808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 3, 0, 56),
  [4810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 5, 0, 0),
  [4812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 5, 0, 56),
  [4814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_pattern, 2, 0, 0),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [4818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 5, 0, 57),
  [4820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 4, 0, 61),
  [4822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_pattern, 3, 0, 0),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_pattern, 2, 0, 0),
  [4826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 6, 0, 56),
  [4828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 6, 0, 61),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [4832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 4, 0, 56),
  [4834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_remaining_field_pattern, 1, 0, 0),
  [4836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 6, 0, 57),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [4840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [4846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 6, 0, 56),
  [4848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mut_pattern, 2, 0, 0),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [4862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1, 0, 0), REDUCE(sym__pattern, 1, 0, 1),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [4867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_trait_bounds_repeat1, 2, 0, 0),
  [4869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_trait_bounds_repeat1, 2, 0, 0), SHIFT_REPEAT(841),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [4874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(80),
  [4877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2, 0, 0),
  [4879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(76),
  [4882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(75),
  [4885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_bounds, 3, 0, 0),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [4955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_bounds, 2, 0, 0),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [4999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2351),
  [5002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 2, 0, 0),
  [5004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2194),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [5011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2756),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [5017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [5019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [5043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_modifier, 2, 0, 0),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [5081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_modifiers, 1, 0, 0),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [5115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 0),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [5125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 1),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [5129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [5135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [5137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3457),
  [5139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 2, 0, 6),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [5147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 2, 0, 0),
  [5149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [5153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [5157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 1, 0, 0),
  [5159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [5161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [5165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 1, 0, 70),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [5171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3546),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [5189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [5215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3565),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [5253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0), REDUCE(sym_tuple_struct_pattern, 3, 0, 56),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [5258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3381),
  [5260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3239),
  [5262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3384),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3240),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [5278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 3, 0, 0),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [5300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0), REDUCE(sym_tuple_struct_pattern, 4, 0, 56),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [5363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 4, 0, 63),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [5367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__use_clause, 1, 0, 0),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [5373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 2, 0, 0),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [5379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 7, 0, 251),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [5385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_unit_type, 2, 0, 0), REDUCE(sym_tuple_pattern, 2, 0, 0),
  [5388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1, 0, 0), REDUCE(sym__pattern, 1, 0, 0),
  [5391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 76),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [5395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 3, 0, 0),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [5403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 3, 0, 22),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [5407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__use_clause, 1, 0, 1),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [5443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3611),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [5447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3495),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [5467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 4, 0, 22),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [5471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 0), SHIFT(1952),
  [5474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 0), SHIFT(403),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [5481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 6, 0, 251),
  [5483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 6, 0, 102),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [5491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [5499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 4, 0, 176),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [5509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 2, 0, 0),
  [5511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 6, 0, 219),
  [5513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, 0, 63),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [5519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [5527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [5531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [5533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [5547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [5549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, 0, 219),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [5553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, 0, 176),
  [5555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, 0, 102),
  [5557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [5559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [5561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0),
  [5563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1479),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [5572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 3, 0, 119),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [5618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [5620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [5624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [5626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [5628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [5630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [5634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_slice_pattern_repeat1, 2, 0, 0),
  [5636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slice_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(807),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [5643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 100),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [5647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [5649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [5651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2856),
  [5654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 3, 0, 0),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [5662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_binding, 4, 0, 198),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [5666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2821),
  [5668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [5680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_predicate, 2, 0, 78),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [5684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_predicate, 2, 0, 77),
  [5686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [5690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [5694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2781),
  [5696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [5724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 60),
  [5726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [5728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2799),
  [5730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [5740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [5792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0), REDUCE(aux_sym_for_lifetimes_repeat1, 2, 0, 0),
  [5795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [5797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [5805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [5807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [5811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_rule, 3, 0, 48),
  [5813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [5823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(212),
  [5826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [5840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_binding, 3, 0, 147),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [5856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [5858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0),
  [5860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [5874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [5876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [5878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [5880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [5882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 3, 0, 0),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [5890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2790),
  [5892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2787),
  [5894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3561),
  [5896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3041),
  [5898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3608),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [5918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 1, 0, 58),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [5926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [5928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2863),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [5942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_closure_parameters_repeat1, 2, 0, 0),
  [5944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_closure_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(793),
  [5947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [5957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [5961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [5963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [5979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [5983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 220),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [5997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [6001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [6005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [6007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [6011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 4, 0, 102),
  [6013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 5, 0, 242),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [6037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__condition, 1, 0, 9),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [6047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 3, 0, 63),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [6063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 4, 0, 0),
  [6065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 4, 0, 199),
  [6067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_wildcard, 1, 0, 0),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [6071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 5, 0, 0),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [6075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2, 0, 0),
  [6077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2188),
  [6080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 178),
  [6082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2, 0, 177),
  [6084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2, 0, 177), SHIFT_REPEAT(779),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [6093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2, 0, 22),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [6099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 1, 0, 0),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [6121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [6127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [6131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3566),
  [6133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3243),
  [6135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3564),
  [6137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_parameter, 4, 0, 110),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [6145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 3, 0, 34),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [6149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 2, 0, 0),
  [6151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 2, 0, 0), SHIFT_REPEAT(2204),
  [6154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_lifetimes_repeat1, 2, 0, 0),
  [6156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_lifetimes_repeat1, 2, 0, 0), SHIFT_REPEAT(3256),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [6163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(410),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [6168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_pattern_repeat1, 2, 0, 0),
  [6170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2335),
  [6173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, 0, 149),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [6177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, 0, 148),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [6185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(442),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [6202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [6204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [6224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0),
  [6226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2128),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [6231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2, 0, 0),
  [6233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1880),
  [6236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 4, 0, 0),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [6242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [6244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 2, 0, 11),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [6292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type_parameter, 2, 0, 77),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [6304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter, 3, 0, 118),
  [6306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(2049),
  [6309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type_parameter, 2, 0, 78),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [6315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3551),
  [6317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3044),
  [6319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3602),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [6323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter, 3, 0, 117),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [6331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [6335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shorthand_field_initializer, 1, 0, 0),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [6347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 1, 0, 0),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [6351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [6353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [6357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [6361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0),
  [6363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(978),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [6376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 2, 0, 101),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [6398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 0),
  [6400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(762),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [6421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shorthand_field_initializer, 2, 0, 0),
  [6423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [6425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [6427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3, 0, 92),
  [6429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 2, 0, 36),
  [6431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [6435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [6437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [6439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 3, 0, 91),
  [6441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 2, 0, 0),
  [6443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [6445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_wildcard, 3, 0, 0),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [6451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3, 0, 90),
  [6453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [6457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 3, 0, 89),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [6463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [6467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_wildcard, 3, 0, 1),
  [6469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 3, 0, 0),
  [6471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [6473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [6475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [6477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [6481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [6483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3571),
  [6485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3358),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [6489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [6491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [6495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [6497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [6499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [6501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [6503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [6505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [6509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [6511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [6513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [6515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [6517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3543),
  [6519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [6521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [6523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [6525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [6527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [6531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2988),
  [6533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3538),
  [6535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [6541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [6545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [6547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [6549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [6553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [6555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [6557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [6559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [6561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [6563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [6565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [6567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [6569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [6571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [6573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [6577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [6579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [6581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [6585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 2, 0, 0),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [6595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_doc_comment_marker, 1, 0, 3),
  [6597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_doc_comment_marker, 1, 0, 2),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [6601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [6603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [6611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [6613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [6615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [6617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [6621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [6623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [6627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [6629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [6631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 1, 0, 0),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [6637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [6639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [6651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 3, 0, 0),
  [6653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 3, 0, 0),
  [6655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [6657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [6659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 4, 0, 32),
  [6661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [6663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [6667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [6669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 3, 0, 0),
  [6671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [6673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3589),
  [6675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [6677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [6679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [6681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [6685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [6689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [6691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [6693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [6695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [6699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [6701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [6703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, 0, 151),
  [6705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [6707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [6709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [6711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [6713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [6715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [6717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [6719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [6721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [6723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 3, 0, 65),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [6741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [6755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [6757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [6761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [6771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [6777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 3, 0, 173),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [6817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 68),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [6821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 69),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [6859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [6863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [6869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [6873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [6881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [6887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [6891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [6901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [6919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_type, 3, 0, 0),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [6981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [6987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [6995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [7007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [7011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__line_doc_comment_marker, 1, 0, 3),
  [7013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__line_doc_comment_marker, 1, 0, 2),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [7017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3616),
  [7019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [7021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [7045] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [7109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [7137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [7159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [7163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [7165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [7167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [7173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [7177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [7181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [7189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_comment, 2, 0, 0),
  [7191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 2, 0, 0),
  [7193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3, 0, 15),
  [7195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3, 0, 0),
  [7197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_comment, 3, 0, 14),
  [7199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_comment, 3, 0, 0),
  [7201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 4, 0, 53),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_string_content = 0,
  ts_external_token__raw_string_literal_start = 1,
  ts_external_token_raw_string_literal_content = 2,
  ts_external_token__raw_string_literal_end = 3,
  ts_external_token_float_literal = 4,
  ts_external_token__outer_block_doc_comment_marker = 5,
  ts_external_token__inner_block_doc_comment_marker = 6,
  ts_external_token__block_comment_content = 7,
  ts_external_token__line_doc_content = 8,
  ts_external_token__error_sentinel = 9,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_string_content] = sym_string_content,
  [ts_external_token__raw_string_literal_start] = sym__raw_string_literal_start,
  [ts_external_token_raw_string_literal_content] = sym_raw_string_literal_content,
  [ts_external_token__raw_string_literal_end] = sym__raw_string_literal_end,
  [ts_external_token_float_literal] = sym_float_literal,
  [ts_external_token__outer_block_doc_comment_marker] = sym__outer_block_doc_comment_marker,
  [ts_external_token__inner_block_doc_comment_marker] = sym__inner_block_doc_comment_marker,
  [ts_external_token__block_comment_content] = sym__block_comment_content,
  [ts_external_token__line_doc_content] = sym__line_doc_content,
  [ts_external_token__error_sentinel] = sym__error_sentinel,
};

static const bool ts_external_scanner_states[10][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_string_content] = true,
    [ts_external_token__raw_string_literal_start] = true,
    [ts_external_token_raw_string_literal_content] = true,
    [ts_external_token__raw_string_literal_end] = true,
    [ts_external_token_float_literal] = true,
    [ts_external_token__outer_block_doc_comment_marker] = true,
    [ts_external_token__inner_block_doc_comment_marker] = true,
    [ts_external_token__block_comment_content] = true,
    [ts_external_token__line_doc_content] = true,
    [ts_external_token__error_sentinel] = true,
  },
  [2] = {
    [ts_external_token__raw_string_literal_start] = true,
    [ts_external_token_float_literal] = true,
  },
  [3] = {
    [ts_external_token__outer_block_doc_comment_marker] = true,
    [ts_external_token__inner_block_doc_comment_marker] = true,
    [ts_external_token__block_comment_content] = true,
  },
  [4] = {
    [ts_external_token_string_content] = true,
  },
  [5] = {
    [ts_external_token__block_comment_content] = true,
  },
  [6] = {
    [ts_external_token_float_literal] = true,
  },
  [7] = {
    [ts_external_token_raw_string_literal_content] = true,
  },
  [8] = {
    [ts_external_token__raw_string_literal_end] = true,
  },
  [9] = {
    [ts_external_token__line_doc_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_rust_external_scanner_create(void);
void tree_sitter_rust_external_scanner_destroy(void *);
bool tree_sitter_rust_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_rust_external_scanner_serialize(void *, char *);
void tree_sitter_rust_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_rust(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_rust_external_scanner_create,
      tree_sitter_rust_external_scanner_destroy,
      tree_sitter_rust_external_scanner_scan,
      tree_sitter_rust_external_scanner_serialize,
      tree_sitter_rust_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
